var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a2, b2) => {
  for (var prop in b2 || (b2 = {}))
    if (__hasOwnProp.call(b2, prop))
      __defNormalProp(a2, prop, b2[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b2)) {
      if (__propIsEnum.call(b2, prop))
        __defNormalProp(a2, prop, b2[prop]);
    }
  return a2;
};
var __spreadProps = (a2, b2) => __defProps(a2, __getOwnPropDescs(b2));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
const p$2 = function polyfill() {
  const relList = document.createElement("link").relList;
  if (relList && relList.supports && relList.supports("modulepreload")) {
    return;
  }
  for (const link of document.querySelectorAll('link[rel="modulepreload"]')) {
    processPreload(link);
  }
  new MutationObserver((mutations) => {
    for (const mutation of mutations) {
      if (mutation.type !== "childList") {
        continue;
      }
      for (const node of mutation.addedNodes) {
        if (node.tagName === "LINK" && node.rel === "modulepreload")
          processPreload(node);
      }
    }
  }).observe(document, { childList: true, subtree: true });
  function getFetchOpts(script) {
    const fetchOpts = {};
    if (script.integrity)
      fetchOpts.integrity = script.integrity;
    if (script.referrerpolicy)
      fetchOpts.referrerPolicy = script.referrerpolicy;
    if (script.crossorigin === "use-credentials")
      fetchOpts.credentials = "include";
    else if (script.crossorigin === "anonymous")
      fetchOpts.credentials = "omit";
    else
      fetchOpts.credentials = "same-origin";
    return fetchOpts;
  }
  function processPreload(link) {
    if (link.ep)
      return;
    link.ep = true;
    const fetchOpts = getFetchOpts(link);
    fetch(link.href, fetchOpts);
  }
};
p$2();
function makeMap(str, expectsLowerCase) {
  const map = /* @__PURE__ */ Object.create(null);
  const list = str.split(",");
  for (let i = 0; i < list.length; i++) {
    map[list[i]] = true;
  }
  return expectsLowerCase ? (val) => !!map[val.toLowerCase()] : (val) => !!map[val];
}
const specialBooleanAttrs = `itemscope,allowfullscreen,formnovalidate,ismap,nomodule,novalidate,readonly`;
const isSpecialBooleanAttr = /* @__PURE__ */ makeMap(specialBooleanAttrs);
function includeBooleanAttr(value) {
  return !!value || value === "";
}
function normalizeStyle(value) {
  if (isArray(value)) {
    const res = {};
    for (let i = 0; i < value.length; i++) {
      const item = value[i];
      const normalized = isString(item) ? parseStringStyle(item) : normalizeStyle(item);
      if (normalized) {
        for (const key in normalized) {
          res[key] = normalized[key];
        }
      }
    }
    return res;
  } else if (isString(value)) {
    return value;
  } else if (isObject(value)) {
    return value;
  }
}
const listDelimiterRE = /;(?![^(]*\))/g;
const propertyDelimiterRE = /:(.+)/;
function parseStringStyle(cssText) {
  const ret = {};
  cssText.split(listDelimiterRE).forEach((item) => {
    if (item) {
      const tmp = item.split(propertyDelimiterRE);
      tmp.length > 1 && (ret[tmp[0].trim()] = tmp[1].trim());
    }
  });
  return ret;
}
function normalizeClass(value) {
  let res = "";
  if (isString(value)) {
    res = value;
  } else if (isArray(value)) {
    for (let i = 0; i < value.length; i++) {
      const normalized = normalizeClass(value[i]);
      if (normalized) {
        res += normalized + " ";
      }
    }
  } else if (isObject(value)) {
    for (const name in value) {
      if (value[name]) {
        res += name + " ";
      }
    }
  }
  return res.trim();
}
const toDisplayString = (val) => {
  return isString(val) ? val : val == null ? "" : isArray(val) || isObject(val) && (val.toString === objectToString || !isFunction(val.toString)) ? JSON.stringify(val, replacer, 2) : String(val);
};
const replacer = (_key, val) => {
  if (val && val.__v_isRef) {
    return replacer(_key, val.value);
  } else if (isMap(val)) {
    return {
      [`Map(${val.size})`]: [...val.entries()].reduce((entries, [key, val2]) => {
        entries[`${key} =>`] = val2;
        return entries;
      }, {})
    };
  } else if (isSet(val)) {
    return {
      [`Set(${val.size})`]: [...val.values()]
    };
  } else if (isObject(val) && !isArray(val) && !isPlainObject(val)) {
    return String(val);
  }
  return val;
};
const EMPTY_OBJ = {};
const EMPTY_ARR = [];
const NOOP = () => {
};
const NO = () => false;
const onRE = /^on[^a-z]/;
const isOn = (key) => onRE.test(key);
const isModelListener = (key) => key.startsWith("onUpdate:");
const extend = Object.assign;
const remove = (arr, el) => {
  const i = arr.indexOf(el);
  if (i > -1) {
    arr.splice(i, 1);
  }
};
const hasOwnProperty = Object.prototype.hasOwnProperty;
const hasOwn = (val, key) => hasOwnProperty.call(val, key);
const isArray = Array.isArray;
const isMap = (val) => toTypeString(val) === "[object Map]";
const isSet = (val) => toTypeString(val) === "[object Set]";
const isFunction = (val) => typeof val === "function";
const isString = (val) => typeof val === "string";
const isSymbol = (val) => typeof val === "symbol";
const isObject = (val) => val !== null && typeof val === "object";
const isPromise = (val) => {
  return isObject(val) && isFunction(val.then) && isFunction(val.catch);
};
const objectToString = Object.prototype.toString;
const toTypeString = (value) => objectToString.call(value);
const toRawType = (value) => {
  return toTypeString(value).slice(8, -1);
};
const isPlainObject = (val) => toTypeString(val) === "[object Object]";
const isIntegerKey = (key) => isString(key) && key !== "NaN" && key[0] !== "-" && "" + parseInt(key, 10) === key;
const isReservedProp = /* @__PURE__ */ makeMap(",key,ref,ref_for,ref_key,onVnodeBeforeMount,onVnodeMounted,onVnodeBeforeUpdate,onVnodeUpdated,onVnodeBeforeUnmount,onVnodeUnmounted");
const cacheStringFunction = (fn) => {
  const cache = /* @__PURE__ */ Object.create(null);
  return (str) => {
    const hit = cache[str];
    return hit || (cache[str] = fn(str));
  };
};
const camelizeRE = /-(\w)/g;
const camelize = cacheStringFunction((str) => {
  return str.replace(camelizeRE, (_, c) => c ? c.toUpperCase() : "");
});
const hyphenateRE = /\B([A-Z])/g;
const hyphenate = cacheStringFunction((str) => str.replace(hyphenateRE, "-$1").toLowerCase());
const capitalize = cacheStringFunction((str) => str.charAt(0).toUpperCase() + str.slice(1));
const toHandlerKey = cacheStringFunction((str) => str ? `on${capitalize(str)}` : ``);
const hasChanged = (value, oldValue) => !Object.is(value, oldValue);
const invokeArrayFns = (fns, arg) => {
  for (let i = 0; i < fns.length; i++) {
    fns[i](arg);
  }
};
const def = (obj, key, value) => {
  Object.defineProperty(obj, key, {
    configurable: true,
    enumerable: false,
    value
  });
};
const toNumber = (val) => {
  const n2 = parseFloat(val);
  return isNaN(n2) ? val : n2;
};
let _globalThis;
const getGlobalThis = () => {
  return _globalThis || (_globalThis = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {});
};
let activeEffectScope;
class EffectScope {
  constructor(detached = false) {
    this.active = true;
    this.effects = [];
    this.cleanups = [];
    if (!detached && activeEffectScope) {
      this.parent = activeEffectScope;
      this.index = (activeEffectScope.scopes || (activeEffectScope.scopes = [])).push(this) - 1;
    }
  }
  run(fn) {
    if (this.active) {
      const currentEffectScope = activeEffectScope;
      try {
        activeEffectScope = this;
        return fn();
      } finally {
        activeEffectScope = currentEffectScope;
      }
    }
  }
  on() {
    activeEffectScope = this;
  }
  off() {
    activeEffectScope = this.parent;
  }
  stop(fromParent) {
    if (this.active) {
      let i, l2;
      for (i = 0, l2 = this.effects.length; i < l2; i++) {
        this.effects[i].stop();
      }
      for (i = 0, l2 = this.cleanups.length; i < l2; i++) {
        this.cleanups[i]();
      }
      if (this.scopes) {
        for (i = 0, l2 = this.scopes.length; i < l2; i++) {
          this.scopes[i].stop(true);
        }
      }
      if (this.parent && !fromParent) {
        const last = this.parent.scopes.pop();
        if (last && last !== this) {
          this.parent.scopes[this.index] = last;
          last.index = this.index;
        }
      }
      this.active = false;
    }
  }
}
function recordEffectScope(effect, scope = activeEffectScope) {
  if (scope && scope.active) {
    scope.effects.push(effect);
  }
}
const createDep = (effects) => {
  const dep = new Set(effects);
  dep.w = 0;
  dep.n = 0;
  return dep;
};
const wasTracked = (dep) => (dep.w & trackOpBit) > 0;
const newTracked = (dep) => (dep.n & trackOpBit) > 0;
const initDepMarkers = ({ deps }) => {
  if (deps.length) {
    for (let i = 0; i < deps.length; i++) {
      deps[i].w |= trackOpBit;
    }
  }
};
const finalizeDepMarkers = (effect) => {
  const { deps } = effect;
  if (deps.length) {
    let ptr = 0;
    for (let i = 0; i < deps.length; i++) {
      const dep = deps[i];
      if (wasTracked(dep) && !newTracked(dep)) {
        dep.delete(effect);
      } else {
        deps[ptr++] = dep;
      }
      dep.w &= ~trackOpBit;
      dep.n &= ~trackOpBit;
    }
    deps.length = ptr;
  }
};
const targetMap = /* @__PURE__ */ new WeakMap();
let effectTrackDepth = 0;
let trackOpBit = 1;
const maxMarkerBits = 30;
let activeEffect;
const ITERATE_KEY = Symbol("");
const MAP_KEY_ITERATE_KEY = Symbol("");
class ReactiveEffect {
  constructor(fn, scheduler = null, scope) {
    this.fn = fn;
    this.scheduler = scheduler;
    this.active = true;
    this.deps = [];
    this.parent = void 0;
    recordEffectScope(this, scope);
  }
  run() {
    if (!this.active) {
      return this.fn();
    }
    let parent = activeEffect;
    let lastShouldTrack = shouldTrack;
    while (parent) {
      if (parent === this) {
        return;
      }
      parent = parent.parent;
    }
    try {
      this.parent = activeEffect;
      activeEffect = this;
      shouldTrack = true;
      trackOpBit = 1 << ++effectTrackDepth;
      if (effectTrackDepth <= maxMarkerBits) {
        initDepMarkers(this);
      } else {
        cleanupEffect(this);
      }
      return this.fn();
    } finally {
      if (effectTrackDepth <= maxMarkerBits) {
        finalizeDepMarkers(this);
      }
      trackOpBit = 1 << --effectTrackDepth;
      activeEffect = this.parent;
      shouldTrack = lastShouldTrack;
      this.parent = void 0;
      if (this.deferStop) {
        this.stop();
      }
    }
  }
  stop() {
    if (activeEffect === this) {
      this.deferStop = true;
    } else if (this.active) {
      cleanupEffect(this);
      if (this.onStop) {
        this.onStop();
      }
      this.active = false;
    }
  }
}
function cleanupEffect(effect) {
  const { deps } = effect;
  if (deps.length) {
    for (let i = 0; i < deps.length; i++) {
      deps[i].delete(effect);
    }
    deps.length = 0;
  }
}
let shouldTrack = true;
const trackStack = [];
function pauseTracking() {
  trackStack.push(shouldTrack);
  shouldTrack = false;
}
function resetTracking() {
  const last = trackStack.pop();
  shouldTrack = last === void 0 ? true : last;
}
function track(target, type, key) {
  if (shouldTrack && activeEffect) {
    let depsMap = targetMap.get(target);
    if (!depsMap) {
      targetMap.set(target, depsMap = /* @__PURE__ */ new Map());
    }
    let dep = depsMap.get(key);
    if (!dep) {
      depsMap.set(key, dep = createDep());
    }
    trackEffects(dep);
  }
}
function trackEffects(dep, debuggerEventExtraInfo) {
  let shouldTrack2 = false;
  if (effectTrackDepth <= maxMarkerBits) {
    if (!newTracked(dep)) {
      dep.n |= trackOpBit;
      shouldTrack2 = !wasTracked(dep);
    }
  } else {
    shouldTrack2 = !dep.has(activeEffect);
  }
  if (shouldTrack2) {
    dep.add(activeEffect);
    activeEffect.deps.push(dep);
  }
}
function trigger(target, type, key, newValue, oldValue, oldTarget) {
  const depsMap = targetMap.get(target);
  if (!depsMap) {
    return;
  }
  let deps = [];
  if (type === "clear") {
    deps = [...depsMap.values()];
  } else if (key === "length" && isArray(target)) {
    depsMap.forEach((dep, key2) => {
      if (key2 === "length" || key2 >= newValue) {
        deps.push(dep);
      }
    });
  } else {
    if (key !== void 0) {
      deps.push(depsMap.get(key));
    }
    switch (type) {
      case "add":
        if (!isArray(target)) {
          deps.push(depsMap.get(ITERATE_KEY));
          if (isMap(target)) {
            deps.push(depsMap.get(MAP_KEY_ITERATE_KEY));
          }
        } else if (isIntegerKey(key)) {
          deps.push(depsMap.get("length"));
        }
        break;
      case "delete":
        if (!isArray(target)) {
          deps.push(depsMap.get(ITERATE_KEY));
          if (isMap(target)) {
            deps.push(depsMap.get(MAP_KEY_ITERATE_KEY));
          }
        }
        break;
      case "set":
        if (isMap(target)) {
          deps.push(depsMap.get(ITERATE_KEY));
        }
        break;
    }
  }
  if (deps.length === 1) {
    if (deps[0]) {
      {
        triggerEffects(deps[0]);
      }
    }
  } else {
    const effects = [];
    for (const dep of deps) {
      if (dep) {
        effects.push(...dep);
      }
    }
    {
      triggerEffects(createDep(effects));
    }
  }
}
function triggerEffects(dep, debuggerEventExtraInfo) {
  for (const effect of isArray(dep) ? dep : [...dep]) {
    if (effect !== activeEffect || effect.allowRecurse) {
      if (effect.scheduler) {
        effect.scheduler();
      } else {
        effect.run();
      }
    }
  }
}
const isNonTrackableKeys = /* @__PURE__ */ makeMap(`__proto__,__v_isRef,__isVue`);
const builtInSymbols = new Set(/* @__PURE__ */ Object.getOwnPropertyNames(Symbol).map((key) => Symbol[key]).filter(isSymbol));
const get = /* @__PURE__ */ createGetter();
const shallowGet = /* @__PURE__ */ createGetter(false, true);
const readonlyGet = /* @__PURE__ */ createGetter(true);
const arrayInstrumentations = /* @__PURE__ */ createArrayInstrumentations();
function createArrayInstrumentations() {
  const instrumentations = {};
  ["includes", "indexOf", "lastIndexOf"].forEach((key) => {
    instrumentations[key] = function(...args) {
      const arr = toRaw(this);
      for (let i = 0, l2 = this.length; i < l2; i++) {
        track(arr, "get", i + "");
      }
      const res = arr[key](...args);
      if (res === -1 || res === false) {
        return arr[key](...args.map(toRaw));
      } else {
        return res;
      }
    };
  });
  ["push", "pop", "shift", "unshift", "splice"].forEach((key) => {
    instrumentations[key] = function(...args) {
      pauseTracking();
      const res = toRaw(this)[key].apply(this, args);
      resetTracking();
      return res;
    };
  });
  return instrumentations;
}
function createGetter(isReadonly2 = false, shallow = false) {
  return function get2(target, key, receiver) {
    if (key === "__v_isReactive") {
      return !isReadonly2;
    } else if (key === "__v_isReadonly") {
      return isReadonly2;
    } else if (key === "__v_isShallow") {
      return shallow;
    } else if (key === "__v_raw" && receiver === (isReadonly2 ? shallow ? shallowReadonlyMap : readonlyMap : shallow ? shallowReactiveMap : reactiveMap).get(target)) {
      return target;
    }
    const targetIsArray = isArray(target);
    if (!isReadonly2 && targetIsArray && hasOwn(arrayInstrumentations, key)) {
      return Reflect.get(arrayInstrumentations, key, receiver);
    }
    const res = Reflect.get(target, key, receiver);
    if (isSymbol(key) ? builtInSymbols.has(key) : isNonTrackableKeys(key)) {
      return res;
    }
    if (!isReadonly2) {
      track(target, "get", key);
    }
    if (shallow) {
      return res;
    }
    if (isRef(res)) {
      const shouldUnwrap = !targetIsArray || !isIntegerKey(key);
      return shouldUnwrap ? res.value : res;
    }
    if (isObject(res)) {
      return isReadonly2 ? readonly(res) : reactive(res);
    }
    return res;
  };
}
const set = /* @__PURE__ */ createSetter();
const shallowSet = /* @__PURE__ */ createSetter(true);
function createSetter(shallow = false) {
  return function set2(target, key, value, receiver) {
    let oldValue = target[key];
    if (isReadonly(oldValue) && isRef(oldValue) && !isRef(value)) {
      return false;
    }
    if (!shallow && !isReadonly(value)) {
      if (!isShallow(value)) {
        value = toRaw(value);
        oldValue = toRaw(oldValue);
      }
      if (!isArray(target) && isRef(oldValue) && !isRef(value)) {
        oldValue.value = value;
        return true;
      }
    }
    const hadKey = isArray(target) && isIntegerKey(key) ? Number(key) < target.length : hasOwn(target, key);
    const result = Reflect.set(target, key, value, receiver);
    if (target === toRaw(receiver)) {
      if (!hadKey) {
        trigger(target, "add", key, value);
      } else if (hasChanged(value, oldValue)) {
        trigger(target, "set", key, value);
      }
    }
    return result;
  };
}
function deleteProperty(target, key) {
  const hadKey = hasOwn(target, key);
  target[key];
  const result = Reflect.deleteProperty(target, key);
  if (result && hadKey) {
    trigger(target, "delete", key, void 0);
  }
  return result;
}
function has(target, key) {
  const result = Reflect.has(target, key);
  if (!isSymbol(key) || !builtInSymbols.has(key)) {
    track(target, "has", key);
  }
  return result;
}
function ownKeys(target) {
  track(target, "iterate", isArray(target) ? "length" : ITERATE_KEY);
  return Reflect.ownKeys(target);
}
const mutableHandlers = {
  get,
  set,
  deleteProperty,
  has,
  ownKeys
};
const readonlyHandlers = {
  get: readonlyGet,
  set(target, key) {
    return true;
  },
  deleteProperty(target, key) {
    return true;
  }
};
const shallowReactiveHandlers = /* @__PURE__ */ extend({}, mutableHandlers, {
  get: shallowGet,
  set: shallowSet
});
const toShallow = (value) => value;
const getProto = (v) => Reflect.getPrototypeOf(v);
function get$1(target, key, isReadonly2 = false, isShallow2 = false) {
  target = target["__v_raw"];
  const rawTarget = toRaw(target);
  const rawKey = toRaw(key);
  if (key !== rawKey) {
    !isReadonly2 && track(rawTarget, "get", key);
  }
  !isReadonly2 && track(rawTarget, "get", rawKey);
  const { has: has2 } = getProto(rawTarget);
  const wrap = isShallow2 ? toShallow : isReadonly2 ? toReadonly : toReactive;
  if (has2.call(rawTarget, key)) {
    return wrap(target.get(key));
  } else if (has2.call(rawTarget, rawKey)) {
    return wrap(target.get(rawKey));
  } else if (target !== rawTarget) {
    target.get(key);
  }
}
function has$1(key, isReadonly2 = false) {
  const target = this["__v_raw"];
  const rawTarget = toRaw(target);
  const rawKey = toRaw(key);
  if (key !== rawKey) {
    !isReadonly2 && track(rawTarget, "has", key);
  }
  !isReadonly2 && track(rawTarget, "has", rawKey);
  return key === rawKey ? target.has(key) : target.has(key) || target.has(rawKey);
}
function size(target, isReadonly2 = false) {
  target = target["__v_raw"];
  !isReadonly2 && track(toRaw(target), "iterate", ITERATE_KEY);
  return Reflect.get(target, "size", target);
}
function add(value) {
  value = toRaw(value);
  const target = toRaw(this);
  const proto = getProto(target);
  const hadKey = proto.has.call(target, value);
  if (!hadKey) {
    target.add(value);
    trigger(target, "add", value, value);
  }
  return this;
}
function set$1(key, value) {
  value = toRaw(value);
  const target = toRaw(this);
  const { has: has2, get: get2 } = getProto(target);
  let hadKey = has2.call(target, key);
  if (!hadKey) {
    key = toRaw(key);
    hadKey = has2.call(target, key);
  }
  const oldValue = get2.call(target, key);
  target.set(key, value);
  if (!hadKey) {
    trigger(target, "add", key, value);
  } else if (hasChanged(value, oldValue)) {
    trigger(target, "set", key, value);
  }
  return this;
}
function deleteEntry(key) {
  const target = toRaw(this);
  const { has: has2, get: get2 } = getProto(target);
  let hadKey = has2.call(target, key);
  if (!hadKey) {
    key = toRaw(key);
    hadKey = has2.call(target, key);
  }
  get2 ? get2.call(target, key) : void 0;
  const result = target.delete(key);
  if (hadKey) {
    trigger(target, "delete", key, void 0);
  }
  return result;
}
function clear() {
  const target = toRaw(this);
  const hadItems = target.size !== 0;
  const result = target.clear();
  if (hadItems) {
    trigger(target, "clear", void 0, void 0);
  }
  return result;
}
function createForEach(isReadonly2, isShallow2) {
  return function forEach(callback, thisArg) {
    const observed = this;
    const target = observed["__v_raw"];
    const rawTarget = toRaw(target);
    const wrap = isShallow2 ? toShallow : isReadonly2 ? toReadonly : toReactive;
    !isReadonly2 && track(rawTarget, "iterate", ITERATE_KEY);
    return target.forEach((value, key) => {
      return callback.call(thisArg, wrap(value), wrap(key), observed);
    });
  };
}
function createIterableMethod(method, isReadonly2, isShallow2) {
  return function(...args) {
    const target = this["__v_raw"];
    const rawTarget = toRaw(target);
    const targetIsMap = isMap(rawTarget);
    const isPair = method === "entries" || method === Symbol.iterator && targetIsMap;
    const isKeyOnly = method === "keys" && targetIsMap;
    const innerIterator = target[method](...args);
    const wrap = isShallow2 ? toShallow : isReadonly2 ? toReadonly : toReactive;
    !isReadonly2 && track(rawTarget, "iterate", isKeyOnly ? MAP_KEY_ITERATE_KEY : ITERATE_KEY);
    return {
      next() {
        const { value, done } = innerIterator.next();
        return done ? { value, done } : {
          value: isPair ? [wrap(value[0]), wrap(value[1])] : wrap(value),
          done
        };
      },
      [Symbol.iterator]() {
        return this;
      }
    };
  };
}
function createReadonlyMethod(type) {
  return function(...args) {
    return type === "delete" ? false : this;
  };
}
function createInstrumentations() {
  const mutableInstrumentations2 = {
    get(key) {
      return get$1(this, key);
    },
    get size() {
      return size(this);
    },
    has: has$1,
    add,
    set: set$1,
    delete: deleteEntry,
    clear,
    forEach: createForEach(false, false)
  };
  const shallowInstrumentations2 = {
    get(key) {
      return get$1(this, key, false, true);
    },
    get size() {
      return size(this);
    },
    has: has$1,
    add,
    set: set$1,
    delete: deleteEntry,
    clear,
    forEach: createForEach(false, true)
  };
  const readonlyInstrumentations2 = {
    get(key) {
      return get$1(this, key, true);
    },
    get size() {
      return size(this, true);
    },
    has(key) {
      return has$1.call(this, key, true);
    },
    add: createReadonlyMethod("add"),
    set: createReadonlyMethod("set"),
    delete: createReadonlyMethod("delete"),
    clear: createReadonlyMethod("clear"),
    forEach: createForEach(true, false)
  };
  const shallowReadonlyInstrumentations2 = {
    get(key) {
      return get$1(this, key, true, true);
    },
    get size() {
      return size(this, true);
    },
    has(key) {
      return has$1.call(this, key, true);
    },
    add: createReadonlyMethod("add"),
    set: createReadonlyMethod("set"),
    delete: createReadonlyMethod("delete"),
    clear: createReadonlyMethod("clear"),
    forEach: createForEach(true, true)
  };
  const iteratorMethods = ["keys", "values", "entries", Symbol.iterator];
  iteratorMethods.forEach((method) => {
    mutableInstrumentations2[method] = createIterableMethod(method, false, false);
    readonlyInstrumentations2[method] = createIterableMethod(method, true, false);
    shallowInstrumentations2[method] = createIterableMethod(method, false, true);
    shallowReadonlyInstrumentations2[method] = createIterableMethod(method, true, true);
  });
  return [
    mutableInstrumentations2,
    readonlyInstrumentations2,
    shallowInstrumentations2,
    shallowReadonlyInstrumentations2
  ];
}
const [mutableInstrumentations, readonlyInstrumentations, shallowInstrumentations, shallowReadonlyInstrumentations] = /* @__PURE__ */ createInstrumentations();
function createInstrumentationGetter(isReadonly2, shallow) {
  const instrumentations = shallow ? isReadonly2 ? shallowReadonlyInstrumentations : shallowInstrumentations : isReadonly2 ? readonlyInstrumentations : mutableInstrumentations;
  return (target, key, receiver) => {
    if (key === "__v_isReactive") {
      return !isReadonly2;
    } else if (key === "__v_isReadonly") {
      return isReadonly2;
    } else if (key === "__v_raw") {
      return target;
    }
    return Reflect.get(hasOwn(instrumentations, key) && key in target ? instrumentations : target, key, receiver);
  };
}
const mutableCollectionHandlers = {
  get: /* @__PURE__ */ createInstrumentationGetter(false, false)
};
const shallowCollectionHandlers = {
  get: /* @__PURE__ */ createInstrumentationGetter(false, true)
};
const readonlyCollectionHandlers = {
  get: /* @__PURE__ */ createInstrumentationGetter(true, false)
};
const reactiveMap = /* @__PURE__ */ new WeakMap();
const shallowReactiveMap = /* @__PURE__ */ new WeakMap();
const readonlyMap = /* @__PURE__ */ new WeakMap();
const shallowReadonlyMap = /* @__PURE__ */ new WeakMap();
function targetTypeMap(rawType) {
  switch (rawType) {
    case "Object":
    case "Array":
      return 1;
    case "Map":
    case "Set":
    case "WeakMap":
    case "WeakSet":
      return 2;
    default:
      return 0;
  }
}
function getTargetType(value) {
  return value["__v_skip"] || !Object.isExtensible(value) ? 0 : targetTypeMap(toRawType(value));
}
function reactive(target) {
  if (isReadonly(target)) {
    return target;
  }
  return createReactiveObject(target, false, mutableHandlers, mutableCollectionHandlers, reactiveMap);
}
function shallowReactive(target) {
  return createReactiveObject(target, false, shallowReactiveHandlers, shallowCollectionHandlers, shallowReactiveMap);
}
function readonly(target) {
  return createReactiveObject(target, true, readonlyHandlers, readonlyCollectionHandlers, readonlyMap);
}
function createReactiveObject(target, isReadonly2, baseHandlers, collectionHandlers, proxyMap) {
  if (!isObject(target)) {
    return target;
  }
  if (target["__v_raw"] && !(isReadonly2 && target["__v_isReactive"])) {
    return target;
  }
  const existingProxy = proxyMap.get(target);
  if (existingProxy) {
    return existingProxy;
  }
  const targetType = getTargetType(target);
  if (targetType === 0) {
    return target;
  }
  const proxy = new Proxy(target, targetType === 2 ? collectionHandlers : baseHandlers);
  proxyMap.set(target, proxy);
  return proxy;
}
function isReactive(value) {
  if (isReadonly(value)) {
    return isReactive(value["__v_raw"]);
  }
  return !!(value && value["__v_isReactive"]);
}
function isReadonly(value) {
  return !!(value && value["__v_isReadonly"]);
}
function isShallow(value) {
  return !!(value && value["__v_isShallow"]);
}
function isProxy(value) {
  return isReactive(value) || isReadonly(value);
}
function toRaw(observed) {
  const raw = observed && observed["__v_raw"];
  return raw ? toRaw(raw) : observed;
}
function markRaw(value) {
  def(value, "__v_skip", true);
  return value;
}
const toReactive = (value) => isObject(value) ? reactive(value) : value;
const toReadonly = (value) => isObject(value) ? readonly(value) : value;
function trackRefValue(ref2) {
  if (shouldTrack && activeEffect) {
    ref2 = toRaw(ref2);
    {
      trackEffects(ref2.dep || (ref2.dep = createDep()));
    }
  }
}
function triggerRefValue(ref2, newVal) {
  ref2 = toRaw(ref2);
  if (ref2.dep) {
    {
      triggerEffects(ref2.dep);
    }
  }
}
function isRef(r2) {
  return !!(r2 && r2.__v_isRef === true);
}
function ref(value) {
  return createRef(value, false);
}
function createRef(rawValue, shallow) {
  if (isRef(rawValue)) {
    return rawValue;
  }
  return new RefImpl(rawValue, shallow);
}
class RefImpl {
  constructor(value, __v_isShallow) {
    this.__v_isShallow = __v_isShallow;
    this.dep = void 0;
    this.__v_isRef = true;
    this._rawValue = __v_isShallow ? value : toRaw(value);
    this._value = __v_isShallow ? value : toReactive(value);
  }
  get value() {
    trackRefValue(this);
    return this._value;
  }
  set value(newVal) {
    newVal = this.__v_isShallow ? newVal : toRaw(newVal);
    if (hasChanged(newVal, this._rawValue)) {
      this._rawValue = newVal;
      this._value = this.__v_isShallow ? newVal : toReactive(newVal);
      triggerRefValue(this);
    }
  }
}
function unref(ref2) {
  return isRef(ref2) ? ref2.value : ref2;
}
const shallowUnwrapHandlers = {
  get: (target, key, receiver) => unref(Reflect.get(target, key, receiver)),
  set: (target, key, value, receiver) => {
    const oldValue = target[key];
    if (isRef(oldValue) && !isRef(value)) {
      oldValue.value = value;
      return true;
    } else {
      return Reflect.set(target, key, value, receiver);
    }
  }
};
function proxyRefs(objectWithRefs) {
  return isReactive(objectWithRefs) ? objectWithRefs : new Proxy(objectWithRefs, shallowUnwrapHandlers);
}
class ComputedRefImpl {
  constructor(getter, _setter, isReadonly2, isSSR) {
    this._setter = _setter;
    this.dep = void 0;
    this.__v_isRef = true;
    this._dirty = true;
    this.effect = new ReactiveEffect(getter, () => {
      if (!this._dirty) {
        this._dirty = true;
        triggerRefValue(this);
      }
    });
    this.effect.computed = this;
    this.effect.active = this._cacheable = !isSSR;
    this["__v_isReadonly"] = isReadonly2;
  }
  get value() {
    const self2 = toRaw(this);
    trackRefValue(self2);
    if (self2._dirty || !self2._cacheable) {
      self2._dirty = false;
      self2._value = self2.effect.run();
    }
    return self2._value;
  }
  set value(newValue) {
    this._setter(newValue);
  }
}
function computed$1(getterOrOptions, debugOptions, isSSR = false) {
  let getter;
  let setter;
  const onlyGetter = isFunction(getterOrOptions);
  if (onlyGetter) {
    getter = getterOrOptions;
    setter = NOOP;
  } else {
    getter = getterOrOptions.get;
    setter = getterOrOptions.set;
  }
  const cRef = new ComputedRefImpl(getter, setter, onlyGetter || !setter, isSSR);
  return cRef;
}
function callWithErrorHandling(fn, instance, type, args) {
  let res;
  try {
    res = args ? fn(...args) : fn();
  } catch (err) {
    handleError(err, instance, type);
  }
  return res;
}
function callWithAsyncErrorHandling(fn, instance, type, args) {
  if (isFunction(fn)) {
    const res = callWithErrorHandling(fn, instance, type, args);
    if (res && isPromise(res)) {
      res.catch((err) => {
        handleError(err, instance, type);
      });
    }
    return res;
  }
  const values = [];
  for (let i = 0; i < fn.length; i++) {
    values.push(callWithAsyncErrorHandling(fn[i], instance, type, args));
  }
  return values;
}
function handleError(err, instance, type, throwInDev = true) {
  const contextVNode = instance ? instance.vnode : null;
  if (instance) {
    let cur = instance.parent;
    const exposedInstance = instance.proxy;
    const errorInfo = type;
    while (cur) {
      const errorCapturedHooks = cur.ec;
      if (errorCapturedHooks) {
        for (let i = 0; i < errorCapturedHooks.length; i++) {
          if (errorCapturedHooks[i](err, exposedInstance, errorInfo) === false) {
            return;
          }
        }
      }
      cur = cur.parent;
    }
    const appErrorHandler = instance.appContext.config.errorHandler;
    if (appErrorHandler) {
      callWithErrorHandling(appErrorHandler, null, 10, [err, exposedInstance, errorInfo]);
      return;
    }
  }
  logError(err, type, contextVNode, throwInDev);
}
function logError(err, type, contextVNode, throwInDev = true) {
  {
    console.error(err);
  }
}
let isFlushing = false;
let isFlushPending = false;
const queue = [];
let flushIndex = 0;
const pendingPreFlushCbs = [];
let activePreFlushCbs = null;
let preFlushIndex = 0;
const pendingPostFlushCbs = [];
let activePostFlushCbs = null;
let postFlushIndex = 0;
const resolvedPromise = /* @__PURE__ */ Promise.resolve();
let currentFlushPromise = null;
let currentPreFlushParentJob = null;
function nextTick(fn) {
  const p2 = currentFlushPromise || resolvedPromise;
  return fn ? p2.then(this ? fn.bind(this) : fn) : p2;
}
function findInsertionIndex(id) {
  let start = flushIndex + 1;
  let end = queue.length;
  while (start < end) {
    const middle = start + end >>> 1;
    const middleJobId = getId(queue[middle]);
    middleJobId < id ? start = middle + 1 : end = middle;
  }
  return start;
}
function queueJob(job) {
  if ((!queue.length || !queue.includes(job, isFlushing && job.allowRecurse ? flushIndex + 1 : flushIndex)) && job !== currentPreFlushParentJob) {
    if (job.id == null) {
      queue.push(job);
    } else {
      queue.splice(findInsertionIndex(job.id), 0, job);
    }
    queueFlush();
  }
}
function queueFlush() {
  if (!isFlushing && !isFlushPending) {
    isFlushPending = true;
    currentFlushPromise = resolvedPromise.then(flushJobs);
  }
}
function invalidateJob(job) {
  const i = queue.indexOf(job);
  if (i > flushIndex) {
    queue.splice(i, 1);
  }
}
function queueCb(cb, activeQueue, pendingQueue, index2) {
  if (!isArray(cb)) {
    if (!activeQueue || !activeQueue.includes(cb, cb.allowRecurse ? index2 + 1 : index2)) {
      pendingQueue.push(cb);
    }
  } else {
    pendingQueue.push(...cb);
  }
  queueFlush();
}
function queuePreFlushCb(cb) {
  queueCb(cb, activePreFlushCbs, pendingPreFlushCbs, preFlushIndex);
}
function queuePostFlushCb(cb) {
  queueCb(cb, activePostFlushCbs, pendingPostFlushCbs, postFlushIndex);
}
function flushPreFlushCbs(seen, parentJob = null) {
  if (pendingPreFlushCbs.length) {
    currentPreFlushParentJob = parentJob;
    activePreFlushCbs = [...new Set(pendingPreFlushCbs)];
    pendingPreFlushCbs.length = 0;
    for (preFlushIndex = 0; preFlushIndex < activePreFlushCbs.length; preFlushIndex++) {
      activePreFlushCbs[preFlushIndex]();
    }
    activePreFlushCbs = null;
    preFlushIndex = 0;
    currentPreFlushParentJob = null;
    flushPreFlushCbs(seen, parentJob);
  }
}
function flushPostFlushCbs(seen) {
  if (pendingPostFlushCbs.length) {
    const deduped = [...new Set(pendingPostFlushCbs)];
    pendingPostFlushCbs.length = 0;
    if (activePostFlushCbs) {
      activePostFlushCbs.push(...deduped);
      return;
    }
    activePostFlushCbs = deduped;
    activePostFlushCbs.sort((a2, b2) => getId(a2) - getId(b2));
    for (postFlushIndex = 0; postFlushIndex < activePostFlushCbs.length; postFlushIndex++) {
      activePostFlushCbs[postFlushIndex]();
    }
    activePostFlushCbs = null;
    postFlushIndex = 0;
  }
}
const getId = (job) => job.id == null ? Infinity : job.id;
function flushJobs(seen) {
  isFlushPending = false;
  isFlushing = true;
  flushPreFlushCbs(seen);
  queue.sort((a2, b2) => getId(a2) - getId(b2));
  const check = NOOP;
  try {
    for (flushIndex = 0; flushIndex < queue.length; flushIndex++) {
      const job = queue[flushIndex];
      if (job && job.active !== false) {
        if (false)
          ;
        callWithErrorHandling(job, null, 14);
      }
    }
  } finally {
    flushIndex = 0;
    queue.length = 0;
    flushPostFlushCbs();
    isFlushing = false;
    currentFlushPromise = null;
    if (queue.length || pendingPreFlushCbs.length || pendingPostFlushCbs.length) {
      flushJobs(seen);
    }
  }
}
function emit$1(instance, event, ...rawArgs) {
  if (instance.isUnmounted)
    return;
  const props = instance.vnode.props || EMPTY_OBJ;
  let args = rawArgs;
  const isModelListener2 = event.startsWith("update:");
  const modelArg = isModelListener2 && event.slice(7);
  if (modelArg && modelArg in props) {
    const modifiersKey = `${modelArg === "modelValue" ? "model" : modelArg}Modifiers`;
    const { number, trim } = props[modifiersKey] || EMPTY_OBJ;
    if (trim) {
      args = rawArgs.map((a2) => a2.trim());
    } else if (number) {
      args = rawArgs.map(toNumber);
    }
  }
  let handlerName;
  let handler = props[handlerName = toHandlerKey(event)] || props[handlerName = toHandlerKey(camelize(event))];
  if (!handler && isModelListener2) {
    handler = props[handlerName = toHandlerKey(hyphenate(event))];
  }
  if (handler) {
    callWithAsyncErrorHandling(handler, instance, 6, args);
  }
  const onceHandler = props[handlerName + `Once`];
  if (onceHandler) {
    if (!instance.emitted) {
      instance.emitted = {};
    } else if (instance.emitted[handlerName]) {
      return;
    }
    instance.emitted[handlerName] = true;
    callWithAsyncErrorHandling(onceHandler, instance, 6, args);
  }
}
function normalizeEmitsOptions(comp, appContext, asMixin = false) {
  const cache = appContext.emitsCache;
  const cached = cache.get(comp);
  if (cached !== void 0) {
    return cached;
  }
  const raw = comp.emits;
  let normalized = {};
  let hasExtends = false;
  if (!isFunction(comp)) {
    const extendEmits = (raw2) => {
      const normalizedFromExtend = normalizeEmitsOptions(raw2, appContext, true);
      if (normalizedFromExtend) {
        hasExtends = true;
        extend(normalized, normalizedFromExtend);
      }
    };
    if (!asMixin && appContext.mixins.length) {
      appContext.mixins.forEach(extendEmits);
    }
    if (comp.extends) {
      extendEmits(comp.extends);
    }
    if (comp.mixins) {
      comp.mixins.forEach(extendEmits);
    }
  }
  if (!raw && !hasExtends) {
    cache.set(comp, null);
    return null;
  }
  if (isArray(raw)) {
    raw.forEach((key) => normalized[key] = null);
  } else {
    extend(normalized, raw);
  }
  cache.set(comp, normalized);
  return normalized;
}
function isEmitListener(options, key) {
  if (!options || !isOn(key)) {
    return false;
  }
  key = key.slice(2).replace(/Once$/, "");
  return hasOwn(options, key[0].toLowerCase() + key.slice(1)) || hasOwn(options, hyphenate(key)) || hasOwn(options, key);
}
let currentRenderingInstance = null;
let currentScopeId = null;
function setCurrentRenderingInstance(instance) {
  const prev = currentRenderingInstance;
  currentRenderingInstance = instance;
  currentScopeId = instance && instance.type.__scopeId || null;
  return prev;
}
function withCtx(fn, ctx = currentRenderingInstance, isNonScopedSlot) {
  if (!ctx)
    return fn;
  if (fn._n) {
    return fn;
  }
  const renderFnWithContext = (...args) => {
    if (renderFnWithContext._d) {
      setBlockTracking(-1);
    }
    const prevInstance = setCurrentRenderingInstance(ctx);
    const res = fn(...args);
    setCurrentRenderingInstance(prevInstance);
    if (renderFnWithContext._d) {
      setBlockTracking(1);
    }
    return res;
  };
  renderFnWithContext._n = true;
  renderFnWithContext._c = true;
  renderFnWithContext._d = true;
  return renderFnWithContext;
}
function markAttrsAccessed() {
}
function renderComponentRoot(instance) {
  const { type: Component, vnode, proxy, withProxy, props, propsOptions: [propsOptions], slots, attrs, emit, render: render2, renderCache, data, setupState, ctx, inheritAttrs } = instance;
  let result;
  let fallthroughAttrs;
  const prev = setCurrentRenderingInstance(instance);
  try {
    if (vnode.shapeFlag & 4) {
      const proxyToUse = withProxy || proxy;
      result = normalizeVNode(render2.call(proxyToUse, proxyToUse, renderCache, props, setupState, data, ctx));
      fallthroughAttrs = attrs;
    } else {
      const render3 = Component;
      if (false)
        ;
      result = normalizeVNode(render3.length > 1 ? render3(props, false ? {
        get attrs() {
          markAttrsAccessed();
          return attrs;
        },
        slots,
        emit
      } : { attrs, slots, emit }) : render3(props, null));
      fallthroughAttrs = Component.props ? attrs : getFunctionalFallthrough(attrs);
    }
  } catch (err) {
    blockStack.length = 0;
    handleError(err, instance, 1);
    result = createVNode(Comment);
  }
  let root = result;
  if (fallthroughAttrs && inheritAttrs !== false) {
    const keys = Object.keys(fallthroughAttrs);
    const { shapeFlag } = root;
    if (keys.length) {
      if (shapeFlag & (1 | 6)) {
        if (propsOptions && keys.some(isModelListener)) {
          fallthroughAttrs = filterModelListeners(fallthroughAttrs, propsOptions);
        }
        root = cloneVNode(root, fallthroughAttrs);
      }
    }
  }
  if (vnode.dirs) {
    root.dirs = root.dirs ? root.dirs.concat(vnode.dirs) : vnode.dirs;
  }
  if (vnode.transition) {
    root.transition = vnode.transition;
  }
  {
    result = root;
  }
  setCurrentRenderingInstance(prev);
  return result;
}
const getFunctionalFallthrough = (attrs) => {
  let res;
  for (const key in attrs) {
    if (key === "class" || key === "style" || isOn(key)) {
      (res || (res = {}))[key] = attrs[key];
    }
  }
  return res;
};
const filterModelListeners = (attrs, props) => {
  const res = {};
  for (const key in attrs) {
    if (!isModelListener(key) || !(key.slice(9) in props)) {
      res[key] = attrs[key];
    }
  }
  return res;
};
function shouldUpdateComponent(prevVNode, nextVNode, optimized) {
  const { props: prevProps, children: prevChildren, component } = prevVNode;
  const { props: nextProps, children: nextChildren, patchFlag } = nextVNode;
  const emits = component.emitsOptions;
  if (nextVNode.dirs || nextVNode.transition) {
    return true;
  }
  if (optimized && patchFlag >= 0) {
    if (patchFlag & 1024) {
      return true;
    }
    if (patchFlag & 16) {
      if (!prevProps) {
        return !!nextProps;
      }
      return hasPropsChanged(prevProps, nextProps, emits);
    } else if (patchFlag & 8) {
      const dynamicProps = nextVNode.dynamicProps;
      for (let i = 0; i < dynamicProps.length; i++) {
        const key = dynamicProps[i];
        if (nextProps[key] !== prevProps[key] && !isEmitListener(emits, key)) {
          return true;
        }
      }
    }
  } else {
    if (prevChildren || nextChildren) {
      if (!nextChildren || !nextChildren.$stable) {
        return true;
      }
    }
    if (prevProps === nextProps) {
      return false;
    }
    if (!prevProps) {
      return !!nextProps;
    }
    if (!nextProps) {
      return true;
    }
    return hasPropsChanged(prevProps, nextProps, emits);
  }
  return false;
}
function hasPropsChanged(prevProps, nextProps, emitsOptions) {
  const nextKeys = Object.keys(nextProps);
  if (nextKeys.length !== Object.keys(prevProps).length) {
    return true;
  }
  for (let i = 0; i < nextKeys.length; i++) {
    const key = nextKeys[i];
    if (nextProps[key] !== prevProps[key] && !isEmitListener(emitsOptions, key)) {
      return true;
    }
  }
  return false;
}
function updateHOCHostEl({ vnode, parent }, el) {
  while (parent && parent.subTree === vnode) {
    (vnode = parent.vnode).el = el;
    parent = parent.parent;
  }
}
const isSuspense = (type) => type.__isSuspense;
function queueEffectWithSuspense(fn, suspense) {
  if (suspense && suspense.pendingBranch) {
    if (isArray(fn)) {
      suspense.effects.push(...fn);
    } else {
      suspense.effects.push(fn);
    }
  } else {
    queuePostFlushCb(fn);
  }
}
function provide(key, value) {
  if (!currentInstance)
    ;
  else {
    let provides = currentInstance.provides;
    const parentProvides = currentInstance.parent && currentInstance.parent.provides;
    if (parentProvides === provides) {
      provides = currentInstance.provides = Object.create(parentProvides);
    }
    provides[key] = value;
  }
}
function inject(key, defaultValue, treatDefaultAsFactory = false) {
  const instance = currentInstance || currentRenderingInstance;
  if (instance) {
    const provides = instance.parent == null ? instance.vnode.appContext && instance.vnode.appContext.provides : instance.parent.provides;
    if (provides && key in provides) {
      return provides[key];
    } else if (arguments.length > 1) {
      return treatDefaultAsFactory && isFunction(defaultValue) ? defaultValue.call(instance.proxy) : defaultValue;
    } else
      ;
  }
}
function watchEffect(effect, options) {
  return doWatch(effect, null, options);
}
const INITIAL_WATCHER_VALUE = {};
function watch(source, cb, options) {
  return doWatch(source, cb, options);
}
function doWatch(source, cb, { immediate, deep, flush, onTrack, onTrigger } = EMPTY_OBJ) {
  const instance = currentInstance;
  let getter;
  let forceTrigger = false;
  let isMultiSource = false;
  if (isRef(source)) {
    getter = () => source.value;
    forceTrigger = isShallow(source);
  } else if (isReactive(source)) {
    getter = () => source;
    deep = true;
  } else if (isArray(source)) {
    isMultiSource = true;
    forceTrigger = source.some(isReactive);
    getter = () => source.map((s) => {
      if (isRef(s)) {
        return s.value;
      } else if (isReactive(s)) {
        return traverse(s);
      } else if (isFunction(s)) {
        return callWithErrorHandling(s, instance, 2);
      } else
        ;
    });
  } else if (isFunction(source)) {
    if (cb) {
      getter = () => callWithErrorHandling(source, instance, 2);
    } else {
      getter = () => {
        if (instance && instance.isUnmounted) {
          return;
        }
        if (cleanup) {
          cleanup();
        }
        return callWithAsyncErrorHandling(source, instance, 3, [onCleanup]);
      };
    }
  } else {
    getter = NOOP;
  }
  if (cb && deep) {
    const baseGetter = getter;
    getter = () => traverse(baseGetter());
  }
  let cleanup;
  let onCleanup = (fn) => {
    cleanup = effect.onStop = () => {
      callWithErrorHandling(fn, instance, 4);
    };
  };
  if (isInSSRComponentSetup) {
    onCleanup = NOOP;
    if (!cb) {
      getter();
    } else if (immediate) {
      callWithAsyncErrorHandling(cb, instance, 3, [
        getter(),
        isMultiSource ? [] : void 0,
        onCleanup
      ]);
    }
    return NOOP;
  }
  let oldValue = isMultiSource ? [] : INITIAL_WATCHER_VALUE;
  const job = () => {
    if (!effect.active) {
      return;
    }
    if (cb) {
      const newValue = effect.run();
      if (deep || forceTrigger || (isMultiSource ? newValue.some((v, i) => hasChanged(v, oldValue[i])) : hasChanged(newValue, oldValue)) || false) {
        if (cleanup) {
          cleanup();
        }
        callWithAsyncErrorHandling(cb, instance, 3, [
          newValue,
          oldValue === INITIAL_WATCHER_VALUE ? void 0 : oldValue,
          onCleanup
        ]);
        oldValue = newValue;
      }
    } else {
      effect.run();
    }
  };
  job.allowRecurse = !!cb;
  let scheduler;
  if (flush === "sync") {
    scheduler = job;
  } else if (flush === "post") {
    scheduler = () => queuePostRenderEffect(job, instance && instance.suspense);
  } else {
    scheduler = () => {
      if (!instance || instance.isMounted) {
        queuePreFlushCb(job);
      } else {
        job();
      }
    };
  }
  const effect = new ReactiveEffect(getter, scheduler);
  if (cb) {
    if (immediate) {
      job();
    } else {
      oldValue = effect.run();
    }
  } else if (flush === "post") {
    queuePostRenderEffect(effect.run.bind(effect), instance && instance.suspense);
  } else {
    effect.run();
  }
  return () => {
    effect.stop();
    if (instance && instance.scope) {
      remove(instance.scope.effects, effect);
    }
  };
}
function instanceWatch(source, value, options) {
  const publicThis = this.proxy;
  const getter = isString(source) ? source.includes(".") ? createPathGetter(publicThis, source) : () => publicThis[source] : source.bind(publicThis, publicThis);
  let cb;
  if (isFunction(value)) {
    cb = value;
  } else {
    cb = value.handler;
    options = value;
  }
  const cur = currentInstance;
  setCurrentInstance(this);
  const res = doWatch(getter, cb.bind(publicThis), options);
  if (cur) {
    setCurrentInstance(cur);
  } else {
    unsetCurrentInstance();
  }
  return res;
}
function createPathGetter(ctx, path) {
  const segments = path.split(".");
  return () => {
    let cur = ctx;
    for (let i = 0; i < segments.length && cur; i++) {
      cur = cur[segments[i]];
    }
    return cur;
  };
}
function traverse(value, seen) {
  if (!isObject(value) || value["__v_skip"]) {
    return value;
  }
  seen = seen || /* @__PURE__ */ new Set();
  if (seen.has(value)) {
    return value;
  }
  seen.add(value);
  if (isRef(value)) {
    traverse(value.value, seen);
  } else if (isArray(value)) {
    for (let i = 0; i < value.length; i++) {
      traverse(value[i], seen);
    }
  } else if (isSet(value) || isMap(value)) {
    value.forEach((v) => {
      traverse(v, seen);
    });
  } else if (isPlainObject(value)) {
    for (const key in value) {
      traverse(value[key], seen);
    }
  }
  return value;
}
function useTransitionState() {
  const state = {
    isMounted: false,
    isLeaving: false,
    isUnmounting: false,
    leavingVNodes: /* @__PURE__ */ new Map()
  };
  onMounted(() => {
    state.isMounted = true;
  });
  onBeforeUnmount(() => {
    state.isUnmounting = true;
  });
  return state;
}
const TransitionHookValidator = [Function, Array];
const BaseTransitionImpl = {
  name: `BaseTransition`,
  props: {
    mode: String,
    appear: Boolean,
    persisted: Boolean,
    onBeforeEnter: TransitionHookValidator,
    onEnter: TransitionHookValidator,
    onAfterEnter: TransitionHookValidator,
    onEnterCancelled: TransitionHookValidator,
    onBeforeLeave: TransitionHookValidator,
    onLeave: TransitionHookValidator,
    onAfterLeave: TransitionHookValidator,
    onLeaveCancelled: TransitionHookValidator,
    onBeforeAppear: TransitionHookValidator,
    onAppear: TransitionHookValidator,
    onAfterAppear: TransitionHookValidator,
    onAppearCancelled: TransitionHookValidator
  },
  setup(props, { slots }) {
    const instance = getCurrentInstance();
    const state = useTransitionState();
    let prevTransitionKey;
    return () => {
      const children = slots.default && getTransitionRawChildren(slots.default(), true);
      if (!children || !children.length) {
        return;
      }
      let child = children[0];
      if (children.length > 1) {
        for (const c of children) {
          if (c.type !== Comment) {
            child = c;
            break;
          }
        }
      }
      const rawProps = toRaw(props);
      const { mode } = rawProps;
      if (state.isLeaving) {
        return emptyPlaceholder(child);
      }
      const innerChild = getKeepAliveChild(child);
      if (!innerChild) {
        return emptyPlaceholder(child);
      }
      const enterHooks = resolveTransitionHooks(innerChild, rawProps, state, instance);
      setTransitionHooks(innerChild, enterHooks);
      const oldChild = instance.subTree;
      const oldInnerChild = oldChild && getKeepAliveChild(oldChild);
      let transitionKeyChanged = false;
      const { getTransitionKey } = innerChild.type;
      if (getTransitionKey) {
        const key = getTransitionKey();
        if (prevTransitionKey === void 0) {
          prevTransitionKey = key;
        } else if (key !== prevTransitionKey) {
          prevTransitionKey = key;
          transitionKeyChanged = true;
        }
      }
      if (oldInnerChild && oldInnerChild.type !== Comment && (!isSameVNodeType(innerChild, oldInnerChild) || transitionKeyChanged)) {
        const leavingHooks = resolveTransitionHooks(oldInnerChild, rawProps, state, instance);
        setTransitionHooks(oldInnerChild, leavingHooks);
        if (mode === "out-in") {
          state.isLeaving = true;
          leavingHooks.afterLeave = () => {
            state.isLeaving = false;
            instance.update();
          };
          return emptyPlaceholder(child);
        } else if (mode === "in-out" && innerChild.type !== Comment) {
          leavingHooks.delayLeave = (el, earlyRemove, delayedLeave) => {
            const leavingVNodesCache = getLeavingNodesForType(state, oldInnerChild);
            leavingVNodesCache[String(oldInnerChild.key)] = oldInnerChild;
            el._leaveCb = () => {
              earlyRemove();
              el._leaveCb = void 0;
              delete enterHooks.delayedLeave;
            };
            enterHooks.delayedLeave = delayedLeave;
          };
        }
      }
      return child;
    };
  }
};
const BaseTransition = BaseTransitionImpl;
function getLeavingNodesForType(state, vnode) {
  const { leavingVNodes } = state;
  let leavingVNodesCache = leavingVNodes.get(vnode.type);
  if (!leavingVNodesCache) {
    leavingVNodesCache = /* @__PURE__ */ Object.create(null);
    leavingVNodes.set(vnode.type, leavingVNodesCache);
  }
  return leavingVNodesCache;
}
function resolveTransitionHooks(vnode, props, state, instance) {
  const { appear, mode, persisted = false, onBeforeEnter, onEnter, onAfterEnter, onEnterCancelled, onBeforeLeave, onLeave, onAfterLeave, onLeaveCancelled, onBeforeAppear, onAppear, onAfterAppear, onAppearCancelled } = props;
  const key = String(vnode.key);
  const leavingVNodesCache = getLeavingNodesForType(state, vnode);
  const callHook2 = (hook, args) => {
    hook && callWithAsyncErrorHandling(hook, instance, 9, args);
  };
  const hooks = {
    mode,
    persisted,
    beforeEnter(el) {
      let hook = onBeforeEnter;
      if (!state.isMounted) {
        if (appear) {
          hook = onBeforeAppear || onBeforeEnter;
        } else {
          return;
        }
      }
      if (el._leaveCb) {
        el._leaveCb(true);
      }
      const leavingVNode = leavingVNodesCache[key];
      if (leavingVNode && isSameVNodeType(vnode, leavingVNode) && leavingVNode.el._leaveCb) {
        leavingVNode.el._leaveCb();
      }
      callHook2(hook, [el]);
    },
    enter(el) {
      let hook = onEnter;
      let afterHook = onAfterEnter;
      let cancelHook = onEnterCancelled;
      if (!state.isMounted) {
        if (appear) {
          hook = onAppear || onEnter;
          afterHook = onAfterAppear || onAfterEnter;
          cancelHook = onAppearCancelled || onEnterCancelled;
        } else {
          return;
        }
      }
      let called = false;
      const done = el._enterCb = (cancelled) => {
        if (called)
          return;
        called = true;
        if (cancelled) {
          callHook2(cancelHook, [el]);
        } else {
          callHook2(afterHook, [el]);
        }
        if (hooks.delayedLeave) {
          hooks.delayedLeave();
        }
        el._enterCb = void 0;
      };
      if (hook) {
        hook(el, done);
        if (hook.length <= 1) {
          done();
        }
      } else {
        done();
      }
    },
    leave(el, remove2) {
      const key2 = String(vnode.key);
      if (el._enterCb) {
        el._enterCb(true);
      }
      if (state.isUnmounting) {
        return remove2();
      }
      callHook2(onBeforeLeave, [el]);
      let called = false;
      const done = el._leaveCb = (cancelled) => {
        if (called)
          return;
        called = true;
        remove2();
        if (cancelled) {
          callHook2(onLeaveCancelled, [el]);
        } else {
          callHook2(onAfterLeave, [el]);
        }
        el._leaveCb = void 0;
        if (leavingVNodesCache[key2] === vnode) {
          delete leavingVNodesCache[key2];
        }
      };
      leavingVNodesCache[key2] = vnode;
      if (onLeave) {
        onLeave(el, done);
        if (onLeave.length <= 1) {
          done();
        }
      } else {
        done();
      }
    },
    clone(vnode2) {
      return resolveTransitionHooks(vnode2, props, state, instance);
    }
  };
  return hooks;
}
function emptyPlaceholder(vnode) {
  if (isKeepAlive(vnode)) {
    vnode = cloneVNode(vnode);
    vnode.children = null;
    return vnode;
  }
}
function getKeepAliveChild(vnode) {
  return isKeepAlive(vnode) ? vnode.children ? vnode.children[0] : void 0 : vnode;
}
function setTransitionHooks(vnode, hooks) {
  if (vnode.shapeFlag & 6 && vnode.component) {
    setTransitionHooks(vnode.component.subTree, hooks);
  } else if (vnode.shapeFlag & 128) {
    vnode.ssContent.transition = hooks.clone(vnode.ssContent);
    vnode.ssFallback.transition = hooks.clone(vnode.ssFallback);
  } else {
    vnode.transition = hooks;
  }
}
function getTransitionRawChildren(children, keepComment = false, parentKey) {
  let ret = [];
  let keyedFragmentCount = 0;
  for (let i = 0; i < children.length; i++) {
    let child = children[i];
    const key = parentKey == null ? child.key : String(parentKey) + String(child.key != null ? child.key : i);
    if (child.type === Fragment) {
      if (child.patchFlag & 128)
        keyedFragmentCount++;
      ret = ret.concat(getTransitionRawChildren(child.children, keepComment, key));
    } else if (keepComment || child.type !== Comment) {
      ret.push(key != null ? cloneVNode(child, { key }) : child);
    }
  }
  if (keyedFragmentCount > 1) {
    for (let i = 0; i < ret.length; i++) {
      ret[i].patchFlag = -2;
    }
  }
  return ret;
}
function defineComponent(options) {
  return isFunction(options) ? { setup: options, name: options.name } : options;
}
const isAsyncWrapper = (i) => !!i.type.__asyncLoader;
const isKeepAlive = (vnode) => vnode.type.__isKeepAlive;
function onActivated(hook, target) {
  registerKeepAliveHook(hook, "a", target);
}
function onDeactivated(hook, target) {
  registerKeepAliveHook(hook, "da", target);
}
function registerKeepAliveHook(hook, type, target = currentInstance) {
  const wrappedHook = hook.__wdc || (hook.__wdc = () => {
    let current = target;
    while (current) {
      if (current.isDeactivated) {
        return;
      }
      current = current.parent;
    }
    return hook();
  });
  injectHook(type, wrappedHook, target);
  if (target) {
    let current = target.parent;
    while (current && current.parent) {
      if (isKeepAlive(current.parent.vnode)) {
        injectToKeepAliveRoot(wrappedHook, type, target, current);
      }
      current = current.parent;
    }
  }
}
function injectToKeepAliveRoot(hook, type, target, keepAliveRoot) {
  const injected = injectHook(type, hook, keepAliveRoot, true);
  onUnmounted(() => {
    remove(keepAliveRoot[type], injected);
  }, target);
}
function injectHook(type, hook, target = currentInstance, prepend = false) {
  if (target) {
    const hooks = target[type] || (target[type] = []);
    const wrappedHook = hook.__weh || (hook.__weh = (...args) => {
      if (target.isUnmounted) {
        return;
      }
      pauseTracking();
      setCurrentInstance(target);
      const res = callWithAsyncErrorHandling(hook, target, type, args);
      unsetCurrentInstance();
      resetTracking();
      return res;
    });
    if (prepend) {
      hooks.unshift(wrappedHook);
    } else {
      hooks.push(wrappedHook);
    }
    return wrappedHook;
  }
}
const createHook = (lifecycle) => (hook, target = currentInstance) => (!isInSSRComponentSetup || lifecycle === "sp") && injectHook(lifecycle, hook, target);
const onBeforeMount = createHook("bm");
const onMounted = createHook("m");
const onBeforeUpdate = createHook("bu");
const onUpdated = createHook("u");
const onBeforeUnmount = createHook("bum");
const onUnmounted = createHook("um");
const onServerPrefetch = createHook("sp");
const onRenderTriggered = createHook("rtg");
const onRenderTracked = createHook("rtc");
function onErrorCaptured(hook, target = currentInstance) {
  injectHook("ec", hook, target);
}
let shouldCacheAccess = true;
function applyOptions(instance) {
  const options = resolveMergedOptions(instance);
  const publicThis = instance.proxy;
  const ctx = instance.ctx;
  shouldCacheAccess = false;
  if (options.beforeCreate) {
    callHook$1(options.beforeCreate, instance, "bc");
  }
  const {
    data: dataOptions,
    computed: computedOptions,
    methods,
    watch: watchOptions,
    provide: provideOptions,
    inject: injectOptions,
    created,
    beforeMount,
    mounted,
    beforeUpdate,
    updated,
    activated,
    deactivated,
    beforeDestroy,
    beforeUnmount,
    destroyed,
    unmounted,
    render: render2,
    renderTracked,
    renderTriggered,
    errorCaptured,
    serverPrefetch,
    expose,
    inheritAttrs,
    components,
    directives,
    filters
  } = options;
  const checkDuplicateProperties = null;
  if (injectOptions) {
    resolveInjections(injectOptions, ctx, checkDuplicateProperties, instance.appContext.config.unwrapInjectedRef);
  }
  if (methods) {
    for (const key in methods) {
      const methodHandler = methods[key];
      if (isFunction(methodHandler)) {
        {
          ctx[key] = methodHandler.bind(publicThis);
        }
      }
    }
  }
  if (dataOptions) {
    const data = dataOptions.call(publicThis, publicThis);
    if (!isObject(data))
      ;
    else {
      instance.data = reactive(data);
    }
  }
  shouldCacheAccess = true;
  if (computedOptions) {
    for (const key in computedOptions) {
      const opt = computedOptions[key];
      const get2 = isFunction(opt) ? opt.bind(publicThis, publicThis) : isFunction(opt.get) ? opt.get.bind(publicThis, publicThis) : NOOP;
      const set2 = !isFunction(opt) && isFunction(opt.set) ? opt.set.bind(publicThis) : NOOP;
      const c = computed({
        get: get2,
        set: set2
      });
      Object.defineProperty(ctx, key, {
        enumerable: true,
        configurable: true,
        get: () => c.value,
        set: (v) => c.value = v
      });
    }
  }
  if (watchOptions) {
    for (const key in watchOptions) {
      createWatcher(watchOptions[key], ctx, publicThis, key);
    }
  }
  if (provideOptions) {
    const provides = isFunction(provideOptions) ? provideOptions.call(publicThis) : provideOptions;
    Reflect.ownKeys(provides).forEach((key) => {
      provide(key, provides[key]);
    });
  }
  if (created) {
    callHook$1(created, instance, "c");
  }
  function registerLifecycleHook(register, hook) {
    if (isArray(hook)) {
      hook.forEach((_hook) => register(_hook.bind(publicThis)));
    } else if (hook) {
      register(hook.bind(publicThis));
    }
  }
  registerLifecycleHook(onBeforeMount, beforeMount);
  registerLifecycleHook(onMounted, mounted);
  registerLifecycleHook(onBeforeUpdate, beforeUpdate);
  registerLifecycleHook(onUpdated, updated);
  registerLifecycleHook(onActivated, activated);
  registerLifecycleHook(onDeactivated, deactivated);
  registerLifecycleHook(onErrorCaptured, errorCaptured);
  registerLifecycleHook(onRenderTracked, renderTracked);
  registerLifecycleHook(onRenderTriggered, renderTriggered);
  registerLifecycleHook(onBeforeUnmount, beforeUnmount);
  registerLifecycleHook(onUnmounted, unmounted);
  registerLifecycleHook(onServerPrefetch, serverPrefetch);
  if (isArray(expose)) {
    if (expose.length) {
      const exposed = instance.exposed || (instance.exposed = {});
      expose.forEach((key) => {
        Object.defineProperty(exposed, key, {
          get: () => publicThis[key],
          set: (val) => publicThis[key] = val
        });
      });
    } else if (!instance.exposed) {
      instance.exposed = {};
    }
  }
  if (render2 && instance.render === NOOP) {
    instance.render = render2;
  }
  if (inheritAttrs != null) {
    instance.inheritAttrs = inheritAttrs;
  }
  if (components)
    instance.components = components;
  if (directives)
    instance.directives = directives;
}
function resolveInjections(injectOptions, ctx, checkDuplicateProperties = NOOP, unwrapRef = false) {
  if (isArray(injectOptions)) {
    injectOptions = normalizeInject(injectOptions);
  }
  for (const key in injectOptions) {
    const opt = injectOptions[key];
    let injected;
    if (isObject(opt)) {
      if ("default" in opt) {
        injected = inject(opt.from || key, opt.default, true);
      } else {
        injected = inject(opt.from || key);
      }
    } else {
      injected = inject(opt);
    }
    if (isRef(injected)) {
      if (unwrapRef) {
        Object.defineProperty(ctx, key, {
          enumerable: true,
          configurable: true,
          get: () => injected.value,
          set: (v) => injected.value = v
        });
      } else {
        ctx[key] = injected;
      }
    } else {
      ctx[key] = injected;
    }
  }
}
function callHook$1(hook, instance, type) {
  callWithAsyncErrorHandling(isArray(hook) ? hook.map((h2) => h2.bind(instance.proxy)) : hook.bind(instance.proxy), instance, type);
}
function createWatcher(raw, ctx, publicThis, key) {
  const getter = key.includes(".") ? createPathGetter(publicThis, key) : () => publicThis[key];
  if (isString(raw)) {
    const handler = ctx[raw];
    if (isFunction(handler)) {
      watch(getter, handler);
    }
  } else if (isFunction(raw)) {
    watch(getter, raw.bind(publicThis));
  } else if (isObject(raw)) {
    if (isArray(raw)) {
      raw.forEach((r2) => createWatcher(r2, ctx, publicThis, key));
    } else {
      const handler = isFunction(raw.handler) ? raw.handler.bind(publicThis) : ctx[raw.handler];
      if (isFunction(handler)) {
        watch(getter, handler, raw);
      }
    }
  } else
    ;
}
function resolveMergedOptions(instance) {
  const base = instance.type;
  const { mixins, extends: extendsOptions } = base;
  const { mixins: globalMixins, optionsCache: cache, config: { optionMergeStrategies } } = instance.appContext;
  const cached = cache.get(base);
  let resolved;
  if (cached) {
    resolved = cached;
  } else if (!globalMixins.length && !mixins && !extendsOptions) {
    {
      resolved = base;
    }
  } else {
    resolved = {};
    if (globalMixins.length) {
      globalMixins.forEach((m2) => mergeOptions(resolved, m2, optionMergeStrategies, true));
    }
    mergeOptions(resolved, base, optionMergeStrategies);
  }
  cache.set(base, resolved);
  return resolved;
}
function mergeOptions(to, from, strats, asMixin = false) {
  const { mixins, extends: extendsOptions } = from;
  if (extendsOptions) {
    mergeOptions(to, extendsOptions, strats, true);
  }
  if (mixins) {
    mixins.forEach((m2) => mergeOptions(to, m2, strats, true));
  }
  for (const key in from) {
    if (asMixin && key === "expose")
      ;
    else {
      const strat = internalOptionMergeStrats[key] || strats && strats[key];
      to[key] = strat ? strat(to[key], from[key]) : from[key];
    }
  }
  return to;
}
const internalOptionMergeStrats = {
  data: mergeDataFn,
  props: mergeObjectOptions,
  emits: mergeObjectOptions,
  methods: mergeObjectOptions,
  computed: mergeObjectOptions,
  beforeCreate: mergeAsArray,
  created: mergeAsArray,
  beforeMount: mergeAsArray,
  mounted: mergeAsArray,
  beforeUpdate: mergeAsArray,
  updated: mergeAsArray,
  beforeDestroy: mergeAsArray,
  beforeUnmount: mergeAsArray,
  destroyed: mergeAsArray,
  unmounted: mergeAsArray,
  activated: mergeAsArray,
  deactivated: mergeAsArray,
  errorCaptured: mergeAsArray,
  serverPrefetch: mergeAsArray,
  components: mergeObjectOptions,
  directives: mergeObjectOptions,
  watch: mergeWatchOptions,
  provide: mergeDataFn,
  inject: mergeInject
};
function mergeDataFn(to, from) {
  if (!from) {
    return to;
  }
  if (!to) {
    return from;
  }
  return function mergedDataFn() {
    return extend(isFunction(to) ? to.call(this, this) : to, isFunction(from) ? from.call(this, this) : from);
  };
}
function mergeInject(to, from) {
  return mergeObjectOptions(normalizeInject(to), normalizeInject(from));
}
function normalizeInject(raw) {
  if (isArray(raw)) {
    const res = {};
    for (let i = 0; i < raw.length; i++) {
      res[raw[i]] = raw[i];
    }
    return res;
  }
  return raw;
}
function mergeAsArray(to, from) {
  return to ? [...new Set([].concat(to, from))] : from;
}
function mergeObjectOptions(to, from) {
  return to ? extend(extend(/* @__PURE__ */ Object.create(null), to), from) : from;
}
function mergeWatchOptions(to, from) {
  if (!to)
    return from;
  if (!from)
    return to;
  const merged = extend(/* @__PURE__ */ Object.create(null), to);
  for (const key in from) {
    merged[key] = mergeAsArray(to[key], from[key]);
  }
  return merged;
}
function initProps(instance, rawProps, isStateful, isSSR = false) {
  const props = {};
  const attrs = {};
  def(attrs, InternalObjectKey, 1);
  instance.propsDefaults = /* @__PURE__ */ Object.create(null);
  setFullProps(instance, rawProps, props, attrs);
  for (const key in instance.propsOptions[0]) {
    if (!(key in props)) {
      props[key] = void 0;
    }
  }
  if (isStateful) {
    instance.props = isSSR ? props : shallowReactive(props);
  } else {
    if (!instance.type.props) {
      instance.props = attrs;
    } else {
      instance.props = props;
    }
  }
  instance.attrs = attrs;
}
function updateProps(instance, rawProps, rawPrevProps, optimized) {
  const { props, attrs, vnode: { patchFlag } } = instance;
  const rawCurrentProps = toRaw(props);
  const [options] = instance.propsOptions;
  let hasAttrsChanged = false;
  if ((optimized || patchFlag > 0) && !(patchFlag & 16)) {
    if (patchFlag & 8) {
      const propsToUpdate = instance.vnode.dynamicProps;
      for (let i = 0; i < propsToUpdate.length; i++) {
        let key = propsToUpdate[i];
        if (isEmitListener(instance.emitsOptions, key)) {
          continue;
        }
        const value = rawProps[key];
        if (options) {
          if (hasOwn(attrs, key)) {
            if (value !== attrs[key]) {
              attrs[key] = value;
              hasAttrsChanged = true;
            }
          } else {
            const camelizedKey = camelize(key);
            props[camelizedKey] = resolvePropValue(options, rawCurrentProps, camelizedKey, value, instance, false);
          }
        } else {
          if (value !== attrs[key]) {
            attrs[key] = value;
            hasAttrsChanged = true;
          }
        }
      }
    }
  } else {
    if (setFullProps(instance, rawProps, props, attrs)) {
      hasAttrsChanged = true;
    }
    let kebabKey;
    for (const key in rawCurrentProps) {
      if (!rawProps || !hasOwn(rawProps, key) && ((kebabKey = hyphenate(key)) === key || !hasOwn(rawProps, kebabKey))) {
        if (options) {
          if (rawPrevProps && (rawPrevProps[key] !== void 0 || rawPrevProps[kebabKey] !== void 0)) {
            props[key] = resolvePropValue(options, rawCurrentProps, key, void 0, instance, true);
          }
        } else {
          delete props[key];
        }
      }
    }
    if (attrs !== rawCurrentProps) {
      for (const key in attrs) {
        if (!rawProps || !hasOwn(rawProps, key) && true) {
          delete attrs[key];
          hasAttrsChanged = true;
        }
      }
    }
  }
  if (hasAttrsChanged) {
    trigger(instance, "set", "$attrs");
  }
}
function setFullProps(instance, rawProps, props, attrs) {
  const [options, needCastKeys] = instance.propsOptions;
  let hasAttrsChanged = false;
  let rawCastValues;
  if (rawProps) {
    for (let key in rawProps) {
      if (isReservedProp(key)) {
        continue;
      }
      const value = rawProps[key];
      let camelKey;
      if (options && hasOwn(options, camelKey = camelize(key))) {
        if (!needCastKeys || !needCastKeys.includes(camelKey)) {
          props[camelKey] = value;
        } else {
          (rawCastValues || (rawCastValues = {}))[camelKey] = value;
        }
      } else if (!isEmitListener(instance.emitsOptions, key)) {
        if (!(key in attrs) || value !== attrs[key]) {
          attrs[key] = value;
          hasAttrsChanged = true;
        }
      }
    }
  }
  if (needCastKeys) {
    const rawCurrentProps = toRaw(props);
    const castValues = rawCastValues || EMPTY_OBJ;
    for (let i = 0; i < needCastKeys.length; i++) {
      const key = needCastKeys[i];
      props[key] = resolvePropValue(options, rawCurrentProps, key, castValues[key], instance, !hasOwn(castValues, key));
    }
  }
  return hasAttrsChanged;
}
function resolvePropValue(options, props, key, value, instance, isAbsent) {
  const opt = options[key];
  if (opt != null) {
    const hasDefault = hasOwn(opt, "default");
    if (hasDefault && value === void 0) {
      const defaultValue = opt.default;
      if (opt.type !== Function && isFunction(defaultValue)) {
        const { propsDefaults } = instance;
        if (key in propsDefaults) {
          value = propsDefaults[key];
        } else {
          setCurrentInstance(instance);
          value = propsDefaults[key] = defaultValue.call(null, props);
          unsetCurrentInstance();
        }
      } else {
        value = defaultValue;
      }
    }
    if (opt[0]) {
      if (isAbsent && !hasDefault) {
        value = false;
      } else if (opt[1] && (value === "" || value === hyphenate(key))) {
        value = true;
      }
    }
  }
  return value;
}
function normalizePropsOptions(comp, appContext, asMixin = false) {
  const cache = appContext.propsCache;
  const cached = cache.get(comp);
  if (cached) {
    return cached;
  }
  const raw = comp.props;
  const normalized = {};
  const needCastKeys = [];
  let hasExtends = false;
  if (!isFunction(comp)) {
    const extendProps = (raw2) => {
      hasExtends = true;
      const [props, keys] = normalizePropsOptions(raw2, appContext, true);
      extend(normalized, props);
      if (keys)
        needCastKeys.push(...keys);
    };
    if (!asMixin && appContext.mixins.length) {
      appContext.mixins.forEach(extendProps);
    }
    if (comp.extends) {
      extendProps(comp.extends);
    }
    if (comp.mixins) {
      comp.mixins.forEach(extendProps);
    }
  }
  if (!raw && !hasExtends) {
    cache.set(comp, EMPTY_ARR);
    return EMPTY_ARR;
  }
  if (isArray(raw)) {
    for (let i = 0; i < raw.length; i++) {
      const normalizedKey = camelize(raw[i]);
      if (validatePropName(normalizedKey)) {
        normalized[normalizedKey] = EMPTY_OBJ;
      }
    }
  } else if (raw) {
    for (const key in raw) {
      const normalizedKey = camelize(key);
      if (validatePropName(normalizedKey)) {
        const opt = raw[key];
        const prop = normalized[normalizedKey] = isArray(opt) || isFunction(opt) ? { type: opt } : opt;
        if (prop) {
          const booleanIndex = getTypeIndex(Boolean, prop.type);
          const stringIndex = getTypeIndex(String, prop.type);
          prop[0] = booleanIndex > -1;
          prop[1] = stringIndex < 0 || booleanIndex < stringIndex;
          if (booleanIndex > -1 || hasOwn(prop, "default")) {
            needCastKeys.push(normalizedKey);
          }
        }
      }
    }
  }
  const res = [normalized, needCastKeys];
  cache.set(comp, res);
  return res;
}
function validatePropName(key) {
  if (key[0] !== "$") {
    return true;
  }
  return false;
}
function getType(ctor) {
  const match = ctor && ctor.toString().match(/^\s*function (\w+)/);
  return match ? match[1] : ctor === null ? "null" : "";
}
function isSameType(a2, b2) {
  return getType(a2) === getType(b2);
}
function getTypeIndex(type, expectedTypes) {
  if (isArray(expectedTypes)) {
    return expectedTypes.findIndex((t2) => isSameType(t2, type));
  } else if (isFunction(expectedTypes)) {
    return isSameType(expectedTypes, type) ? 0 : -1;
  }
  return -1;
}
const isInternalKey = (key) => key[0] === "_" || key === "$stable";
const normalizeSlotValue = (value) => isArray(value) ? value.map(normalizeVNode) : [normalizeVNode(value)];
const normalizeSlot = (key, rawSlot, ctx) => {
  const normalized = withCtx((...args) => {
    return normalizeSlotValue(rawSlot(...args));
  }, ctx);
  normalized._c = false;
  return normalized;
};
const normalizeObjectSlots = (rawSlots, slots, instance) => {
  const ctx = rawSlots._ctx;
  for (const key in rawSlots) {
    if (isInternalKey(key))
      continue;
    const value = rawSlots[key];
    if (isFunction(value)) {
      slots[key] = normalizeSlot(key, value, ctx);
    } else if (value != null) {
      const normalized = normalizeSlotValue(value);
      slots[key] = () => normalized;
    }
  }
};
const normalizeVNodeSlots = (instance, children) => {
  const normalized = normalizeSlotValue(children);
  instance.slots.default = () => normalized;
};
const initSlots = (instance, children) => {
  if (instance.vnode.shapeFlag & 32) {
    const type = children._;
    if (type) {
      instance.slots = toRaw(children);
      def(children, "_", type);
    } else {
      normalizeObjectSlots(children, instance.slots = {});
    }
  } else {
    instance.slots = {};
    if (children) {
      normalizeVNodeSlots(instance, children);
    }
  }
  def(instance.slots, InternalObjectKey, 1);
};
const updateSlots = (instance, children, optimized) => {
  const { vnode, slots } = instance;
  let needDeletionCheck = true;
  let deletionComparisonTarget = EMPTY_OBJ;
  if (vnode.shapeFlag & 32) {
    const type = children._;
    if (type) {
      if (optimized && type === 1) {
        needDeletionCheck = false;
      } else {
        extend(slots, children);
        if (!optimized && type === 1) {
          delete slots._;
        }
      }
    } else {
      needDeletionCheck = !children.$stable;
      normalizeObjectSlots(children, slots);
    }
    deletionComparisonTarget = children;
  } else if (children) {
    normalizeVNodeSlots(instance, children);
    deletionComparisonTarget = { default: 1 };
  }
  if (needDeletionCheck) {
    for (const key in slots) {
      if (!isInternalKey(key) && !(key in deletionComparisonTarget)) {
        delete slots[key];
      }
    }
  }
};
function invokeDirectiveHook(vnode, prevVNode, instance, name) {
  const bindings = vnode.dirs;
  const oldBindings = prevVNode && prevVNode.dirs;
  for (let i = 0; i < bindings.length; i++) {
    const binding = bindings[i];
    if (oldBindings) {
      binding.oldValue = oldBindings[i].value;
    }
    let hook = binding.dir[name];
    if (hook) {
      pauseTracking();
      callWithAsyncErrorHandling(hook, instance, 8, [
        vnode.el,
        binding,
        vnode,
        prevVNode
      ]);
      resetTracking();
    }
  }
}
function createAppContext() {
  return {
    app: null,
    config: {
      isNativeTag: NO,
      performance: false,
      globalProperties: {},
      optionMergeStrategies: {},
      errorHandler: void 0,
      warnHandler: void 0,
      compilerOptions: {}
    },
    mixins: [],
    components: {},
    directives: {},
    provides: /* @__PURE__ */ Object.create(null),
    optionsCache: /* @__PURE__ */ new WeakMap(),
    propsCache: /* @__PURE__ */ new WeakMap(),
    emitsCache: /* @__PURE__ */ new WeakMap()
  };
}
let uid = 0;
function createAppAPI(render2, hydrate) {
  return function createApp2(rootComponent, rootProps = null) {
    if (!isFunction(rootComponent)) {
      rootComponent = Object.assign({}, rootComponent);
    }
    if (rootProps != null && !isObject(rootProps)) {
      rootProps = null;
    }
    const context = createAppContext();
    const installedPlugins = /* @__PURE__ */ new Set();
    let isMounted = false;
    const app2 = context.app = {
      _uid: uid++,
      _component: rootComponent,
      _props: rootProps,
      _container: null,
      _context: context,
      _instance: null,
      version,
      get config() {
        return context.config;
      },
      set config(v) {
      },
      use(plugin, ...options) {
        if (installedPlugins.has(plugin))
          ;
        else if (plugin && isFunction(plugin.install)) {
          installedPlugins.add(plugin);
          plugin.install(app2, ...options);
        } else if (isFunction(plugin)) {
          installedPlugins.add(plugin);
          plugin(app2, ...options);
        } else
          ;
        return app2;
      },
      mixin(mixin) {
        {
          if (!context.mixins.includes(mixin)) {
            context.mixins.push(mixin);
          }
        }
        return app2;
      },
      component(name, component) {
        if (!component) {
          return context.components[name];
        }
        context.components[name] = component;
        return app2;
      },
      directive(name, directive) {
        if (!directive) {
          return context.directives[name];
        }
        context.directives[name] = directive;
        return app2;
      },
      mount(rootContainer, isHydrate, isSVG) {
        if (!isMounted) {
          const vnode = createVNode(rootComponent, rootProps);
          vnode.appContext = context;
          if (isHydrate && hydrate) {
            hydrate(vnode, rootContainer);
          } else {
            render2(vnode, rootContainer, isSVG);
          }
          isMounted = true;
          app2._container = rootContainer;
          rootContainer.__vue_app__ = app2;
          return getExposeProxy(vnode.component) || vnode.component.proxy;
        }
      },
      unmount() {
        if (isMounted) {
          render2(null, app2._container);
          delete app2._container.__vue_app__;
        }
      },
      provide(key, value) {
        context.provides[key] = value;
        return app2;
      }
    };
    return app2;
  };
}
function setRef(rawRef, oldRawRef, parentSuspense, vnode, isUnmount = false) {
  if (isArray(rawRef)) {
    rawRef.forEach((r2, i) => setRef(r2, oldRawRef && (isArray(oldRawRef) ? oldRawRef[i] : oldRawRef), parentSuspense, vnode, isUnmount));
    return;
  }
  if (isAsyncWrapper(vnode) && !isUnmount) {
    return;
  }
  const refValue = vnode.shapeFlag & 4 ? getExposeProxy(vnode.component) || vnode.component.proxy : vnode.el;
  const value = isUnmount ? null : refValue;
  const { i: owner, r: ref2 } = rawRef;
  const oldRef = oldRawRef && oldRawRef.r;
  const refs = owner.refs === EMPTY_OBJ ? owner.refs = {} : owner.refs;
  const setupState = owner.setupState;
  if (oldRef != null && oldRef !== ref2) {
    if (isString(oldRef)) {
      refs[oldRef] = null;
      if (hasOwn(setupState, oldRef)) {
        setupState[oldRef] = null;
      }
    } else if (isRef(oldRef)) {
      oldRef.value = null;
    }
  }
  if (isFunction(ref2)) {
    callWithErrorHandling(ref2, owner, 12, [value, refs]);
  } else {
    const _isString = isString(ref2);
    const _isRef = isRef(ref2);
    if (_isString || _isRef) {
      const doSet = () => {
        if (rawRef.f) {
          const existing = _isString ? refs[ref2] : ref2.value;
          if (isUnmount) {
            isArray(existing) && remove(existing, refValue);
          } else {
            if (!isArray(existing)) {
              if (_isString) {
                refs[ref2] = [refValue];
                if (hasOwn(setupState, ref2)) {
                  setupState[ref2] = refs[ref2];
                }
              } else {
                ref2.value = [refValue];
                if (rawRef.k)
                  refs[rawRef.k] = ref2.value;
              }
            } else if (!existing.includes(refValue)) {
              existing.push(refValue);
            }
          }
        } else if (_isString) {
          refs[ref2] = value;
          if (hasOwn(setupState, ref2)) {
            setupState[ref2] = value;
          }
        } else if (isRef(ref2)) {
          ref2.value = value;
          if (rawRef.k)
            refs[rawRef.k] = value;
        } else
          ;
      };
      if (value) {
        doSet.id = -1;
        queuePostRenderEffect(doSet, parentSuspense);
      } else {
        doSet();
      }
    }
  }
}
const queuePostRenderEffect = queueEffectWithSuspense;
function createRenderer(options) {
  return baseCreateRenderer(options);
}
function baseCreateRenderer(options, createHydrationFns) {
  const target = getGlobalThis();
  target.__VUE__ = true;
  const { insert: hostInsert, remove: hostRemove, patchProp: hostPatchProp, createElement: hostCreateElement, createText: hostCreateText, createComment: hostCreateComment, setText: hostSetText, setElementText: hostSetElementText, parentNode: hostParentNode, nextSibling: hostNextSibling, setScopeId: hostSetScopeId = NOOP, cloneNode: hostCloneNode, insertStaticContent: hostInsertStaticContent } = options;
  const patch = (n1, n2, container, anchor = null, parentComponent = null, parentSuspense = null, isSVG = false, slotScopeIds = null, optimized = !!n2.dynamicChildren) => {
    if (n1 === n2) {
      return;
    }
    if (n1 && !isSameVNodeType(n1, n2)) {
      anchor = getNextHostNode(n1);
      unmount(n1, parentComponent, parentSuspense, true);
      n1 = null;
    }
    if (n2.patchFlag === -2) {
      optimized = false;
      n2.dynamicChildren = null;
    }
    const { type, ref: ref2, shapeFlag } = n2;
    switch (type) {
      case Text:
        processText(n1, n2, container, anchor);
        break;
      case Comment:
        processCommentNode(n1, n2, container, anchor);
        break;
      case Static:
        if (n1 == null) {
          mountStaticNode(n2, container, anchor, isSVG);
        }
        break;
      case Fragment:
        processFragment(n1, n2, container, anchor, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized);
        break;
      default:
        if (shapeFlag & 1) {
          processElement(n1, n2, container, anchor, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized);
        } else if (shapeFlag & 6) {
          processComponent(n1, n2, container, anchor, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized);
        } else if (shapeFlag & 64) {
          type.process(n1, n2, container, anchor, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized, internals);
        } else if (shapeFlag & 128) {
          type.process(n1, n2, container, anchor, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized, internals);
        } else
          ;
    }
    if (ref2 != null && parentComponent) {
      setRef(ref2, n1 && n1.ref, parentSuspense, n2 || n1, !n2);
    }
  };
  const processText = (n1, n2, container, anchor) => {
    if (n1 == null) {
      hostInsert(n2.el = hostCreateText(n2.children), container, anchor);
    } else {
      const el = n2.el = n1.el;
      if (n2.children !== n1.children) {
        hostSetText(el, n2.children);
      }
    }
  };
  const processCommentNode = (n1, n2, container, anchor) => {
    if (n1 == null) {
      hostInsert(n2.el = hostCreateComment(n2.children || ""), container, anchor);
    } else {
      n2.el = n1.el;
    }
  };
  const mountStaticNode = (n2, container, anchor, isSVG) => {
    [n2.el, n2.anchor] = hostInsertStaticContent(n2.children, container, anchor, isSVG, n2.el, n2.anchor);
  };
  const moveStaticNode = ({ el, anchor }, container, nextSibling) => {
    let next;
    while (el && el !== anchor) {
      next = hostNextSibling(el);
      hostInsert(el, container, nextSibling);
      el = next;
    }
    hostInsert(anchor, container, nextSibling);
  };
  const removeStaticNode = ({ el, anchor }) => {
    let next;
    while (el && el !== anchor) {
      next = hostNextSibling(el);
      hostRemove(el);
      el = next;
    }
    hostRemove(anchor);
  };
  const processElement = (n1, n2, container, anchor, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized) => {
    isSVG = isSVG || n2.type === "svg";
    if (n1 == null) {
      mountElement(n2, container, anchor, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized);
    } else {
      patchElement(n1, n2, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized);
    }
  };
  const mountElement = (vnode, container, anchor, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized) => {
    let el;
    let vnodeHook;
    const { type, props, shapeFlag, transition, patchFlag, dirs } = vnode;
    if (vnode.el && hostCloneNode !== void 0 && patchFlag === -1) {
      el = vnode.el = hostCloneNode(vnode.el);
    } else {
      el = vnode.el = hostCreateElement(vnode.type, isSVG, props && props.is, props);
      if (shapeFlag & 8) {
        hostSetElementText(el, vnode.children);
      } else if (shapeFlag & 16) {
        mountChildren(vnode.children, el, null, parentComponent, parentSuspense, isSVG && type !== "foreignObject", slotScopeIds, optimized);
      }
      if (dirs) {
        invokeDirectiveHook(vnode, null, parentComponent, "created");
      }
      if (props) {
        for (const key in props) {
          if (key !== "value" && !isReservedProp(key)) {
            hostPatchProp(el, key, null, props[key], isSVG, vnode.children, parentComponent, parentSuspense, unmountChildren);
          }
        }
        if ("value" in props) {
          hostPatchProp(el, "value", null, props.value);
        }
        if (vnodeHook = props.onVnodeBeforeMount) {
          invokeVNodeHook(vnodeHook, parentComponent, vnode);
        }
      }
      setScopeId(el, vnode, vnode.scopeId, slotScopeIds, parentComponent);
    }
    if (dirs) {
      invokeDirectiveHook(vnode, null, parentComponent, "beforeMount");
    }
    const needCallTransitionHooks = (!parentSuspense || parentSuspense && !parentSuspense.pendingBranch) && transition && !transition.persisted;
    if (needCallTransitionHooks) {
      transition.beforeEnter(el);
    }
    hostInsert(el, container, anchor);
    if ((vnodeHook = props && props.onVnodeMounted) || needCallTransitionHooks || dirs) {
      queuePostRenderEffect(() => {
        vnodeHook && invokeVNodeHook(vnodeHook, parentComponent, vnode);
        needCallTransitionHooks && transition.enter(el);
        dirs && invokeDirectiveHook(vnode, null, parentComponent, "mounted");
      }, parentSuspense);
    }
  };
  const setScopeId = (el, vnode, scopeId, slotScopeIds, parentComponent) => {
    if (scopeId) {
      hostSetScopeId(el, scopeId);
    }
    if (slotScopeIds) {
      for (let i = 0; i < slotScopeIds.length; i++) {
        hostSetScopeId(el, slotScopeIds[i]);
      }
    }
    if (parentComponent) {
      let subTree = parentComponent.subTree;
      if (vnode === subTree) {
        const parentVNode = parentComponent.vnode;
        setScopeId(el, parentVNode, parentVNode.scopeId, parentVNode.slotScopeIds, parentComponent.parent);
      }
    }
  };
  const mountChildren = (children, container, anchor, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized, start = 0) => {
    for (let i = start; i < children.length; i++) {
      const child = children[i] = optimized ? cloneIfMounted(children[i]) : normalizeVNode(children[i]);
      patch(null, child, container, anchor, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized);
    }
  };
  const patchElement = (n1, n2, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized) => {
    const el = n2.el = n1.el;
    let { patchFlag, dynamicChildren, dirs } = n2;
    patchFlag |= n1.patchFlag & 16;
    const oldProps = n1.props || EMPTY_OBJ;
    const newProps = n2.props || EMPTY_OBJ;
    let vnodeHook;
    parentComponent && toggleRecurse(parentComponent, false);
    if (vnodeHook = newProps.onVnodeBeforeUpdate) {
      invokeVNodeHook(vnodeHook, parentComponent, n2, n1);
    }
    if (dirs) {
      invokeDirectiveHook(n2, n1, parentComponent, "beforeUpdate");
    }
    parentComponent && toggleRecurse(parentComponent, true);
    const areChildrenSVG = isSVG && n2.type !== "foreignObject";
    if (dynamicChildren) {
      patchBlockChildren(n1.dynamicChildren, dynamicChildren, el, parentComponent, parentSuspense, areChildrenSVG, slotScopeIds);
    } else if (!optimized) {
      patchChildren(n1, n2, el, null, parentComponent, parentSuspense, areChildrenSVG, slotScopeIds, false);
    }
    if (patchFlag > 0) {
      if (patchFlag & 16) {
        patchProps(el, n2, oldProps, newProps, parentComponent, parentSuspense, isSVG);
      } else {
        if (patchFlag & 2) {
          if (oldProps.class !== newProps.class) {
            hostPatchProp(el, "class", null, newProps.class, isSVG);
          }
        }
        if (patchFlag & 4) {
          hostPatchProp(el, "style", oldProps.style, newProps.style, isSVG);
        }
        if (patchFlag & 8) {
          const propsToUpdate = n2.dynamicProps;
          for (let i = 0; i < propsToUpdate.length; i++) {
            const key = propsToUpdate[i];
            const prev = oldProps[key];
            const next = newProps[key];
            if (next !== prev || key === "value") {
              hostPatchProp(el, key, prev, next, isSVG, n1.children, parentComponent, parentSuspense, unmountChildren);
            }
          }
        }
      }
      if (patchFlag & 1) {
        if (n1.children !== n2.children) {
          hostSetElementText(el, n2.children);
        }
      }
    } else if (!optimized && dynamicChildren == null) {
      patchProps(el, n2, oldProps, newProps, parentComponent, parentSuspense, isSVG);
    }
    if ((vnodeHook = newProps.onVnodeUpdated) || dirs) {
      queuePostRenderEffect(() => {
        vnodeHook && invokeVNodeHook(vnodeHook, parentComponent, n2, n1);
        dirs && invokeDirectiveHook(n2, n1, parentComponent, "updated");
      }, parentSuspense);
    }
  };
  const patchBlockChildren = (oldChildren, newChildren, fallbackContainer, parentComponent, parentSuspense, isSVG, slotScopeIds) => {
    for (let i = 0; i < newChildren.length; i++) {
      const oldVNode = oldChildren[i];
      const newVNode = newChildren[i];
      const container = oldVNode.el && (oldVNode.type === Fragment || !isSameVNodeType(oldVNode, newVNode) || oldVNode.shapeFlag & (6 | 64)) ? hostParentNode(oldVNode.el) : fallbackContainer;
      patch(oldVNode, newVNode, container, null, parentComponent, parentSuspense, isSVG, slotScopeIds, true);
    }
  };
  const patchProps = (el, vnode, oldProps, newProps, parentComponent, parentSuspense, isSVG) => {
    if (oldProps !== newProps) {
      for (const key in newProps) {
        if (isReservedProp(key))
          continue;
        const next = newProps[key];
        const prev = oldProps[key];
        if (next !== prev && key !== "value") {
          hostPatchProp(el, key, prev, next, isSVG, vnode.children, parentComponent, parentSuspense, unmountChildren);
        }
      }
      if (oldProps !== EMPTY_OBJ) {
        for (const key in oldProps) {
          if (!isReservedProp(key) && !(key in newProps)) {
            hostPatchProp(el, key, oldProps[key], null, isSVG, vnode.children, parentComponent, parentSuspense, unmountChildren);
          }
        }
      }
      if ("value" in newProps) {
        hostPatchProp(el, "value", oldProps.value, newProps.value);
      }
    }
  };
  const processFragment = (n1, n2, container, anchor, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized) => {
    const fragmentStartAnchor = n2.el = n1 ? n1.el : hostCreateText("");
    const fragmentEndAnchor = n2.anchor = n1 ? n1.anchor : hostCreateText("");
    let { patchFlag, dynamicChildren, slotScopeIds: fragmentSlotScopeIds } = n2;
    if (fragmentSlotScopeIds) {
      slotScopeIds = slotScopeIds ? slotScopeIds.concat(fragmentSlotScopeIds) : fragmentSlotScopeIds;
    }
    if (n1 == null) {
      hostInsert(fragmentStartAnchor, container, anchor);
      hostInsert(fragmentEndAnchor, container, anchor);
      mountChildren(n2.children, container, fragmentEndAnchor, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized);
    } else {
      if (patchFlag > 0 && patchFlag & 64 && dynamicChildren && n1.dynamicChildren) {
        patchBlockChildren(n1.dynamicChildren, dynamicChildren, container, parentComponent, parentSuspense, isSVG, slotScopeIds);
        if (n2.key != null || parentComponent && n2 === parentComponent.subTree) {
          traverseStaticChildren(n1, n2, true);
        }
      } else {
        patchChildren(n1, n2, container, fragmentEndAnchor, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized);
      }
    }
  };
  const processComponent = (n1, n2, container, anchor, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized) => {
    n2.slotScopeIds = slotScopeIds;
    if (n1 == null) {
      if (n2.shapeFlag & 512) {
        parentComponent.ctx.activate(n2, container, anchor, isSVG, optimized);
      } else {
        mountComponent(n2, container, anchor, parentComponent, parentSuspense, isSVG, optimized);
      }
    } else {
      updateComponent(n1, n2, optimized);
    }
  };
  const mountComponent = (initialVNode, container, anchor, parentComponent, parentSuspense, isSVG, optimized) => {
    const instance = initialVNode.component = createComponentInstance(initialVNode, parentComponent, parentSuspense);
    if (isKeepAlive(initialVNode)) {
      instance.ctx.renderer = internals;
    }
    {
      setupComponent(instance);
    }
    if (instance.asyncDep) {
      parentSuspense && parentSuspense.registerDep(instance, setupRenderEffect);
      if (!initialVNode.el) {
        const placeholder = instance.subTree = createVNode(Comment);
        processCommentNode(null, placeholder, container, anchor);
      }
      return;
    }
    setupRenderEffect(instance, initialVNode, container, anchor, parentSuspense, isSVG, optimized);
  };
  const updateComponent = (n1, n2, optimized) => {
    const instance = n2.component = n1.component;
    if (shouldUpdateComponent(n1, n2, optimized)) {
      if (instance.asyncDep && !instance.asyncResolved) {
        updateComponentPreRender(instance, n2, optimized);
        return;
      } else {
        instance.next = n2;
        invalidateJob(instance.update);
        instance.update();
      }
    } else {
      n2.component = n1.component;
      n2.el = n1.el;
      instance.vnode = n2;
    }
  };
  const setupRenderEffect = (instance, initialVNode, container, anchor, parentSuspense, isSVG, optimized) => {
    const componentUpdateFn = () => {
      if (!instance.isMounted) {
        let vnodeHook;
        const { el, props } = initialVNode;
        const { bm, m: m2, parent } = instance;
        const isAsyncWrapperVNode = isAsyncWrapper(initialVNode);
        toggleRecurse(instance, false);
        if (bm) {
          invokeArrayFns(bm);
        }
        if (!isAsyncWrapperVNode && (vnodeHook = props && props.onVnodeBeforeMount)) {
          invokeVNodeHook(vnodeHook, parent, initialVNode);
        }
        toggleRecurse(instance, true);
        if (el && hydrateNode) {
          const hydrateSubTree = () => {
            instance.subTree = renderComponentRoot(instance);
            hydrateNode(el, instance.subTree, instance, parentSuspense, null);
          };
          if (isAsyncWrapperVNode) {
            initialVNode.type.__asyncLoader().then(() => !instance.isUnmounted && hydrateSubTree());
          } else {
            hydrateSubTree();
          }
        } else {
          const subTree = instance.subTree = renderComponentRoot(instance);
          patch(null, subTree, container, anchor, instance, parentSuspense, isSVG);
          initialVNode.el = subTree.el;
        }
        if (m2) {
          queuePostRenderEffect(m2, parentSuspense);
        }
        if (!isAsyncWrapperVNode && (vnodeHook = props && props.onVnodeMounted)) {
          const scopedInitialVNode = initialVNode;
          queuePostRenderEffect(() => invokeVNodeHook(vnodeHook, parent, scopedInitialVNode), parentSuspense);
        }
        if (initialVNode.shapeFlag & 256) {
          instance.a && queuePostRenderEffect(instance.a, parentSuspense);
        }
        instance.isMounted = true;
        initialVNode = container = anchor = null;
      } else {
        let { next, bu, u: u2, parent, vnode } = instance;
        let originNext = next;
        let vnodeHook;
        toggleRecurse(instance, false);
        if (next) {
          next.el = vnode.el;
          updateComponentPreRender(instance, next, optimized);
        } else {
          next = vnode;
        }
        if (bu) {
          invokeArrayFns(bu);
        }
        if (vnodeHook = next.props && next.props.onVnodeBeforeUpdate) {
          invokeVNodeHook(vnodeHook, parent, next, vnode);
        }
        toggleRecurse(instance, true);
        const nextTree = renderComponentRoot(instance);
        const prevTree = instance.subTree;
        instance.subTree = nextTree;
        patch(prevTree, nextTree, hostParentNode(prevTree.el), getNextHostNode(prevTree), instance, parentSuspense, isSVG);
        next.el = nextTree.el;
        if (originNext === null) {
          updateHOCHostEl(instance, nextTree.el);
        }
        if (u2) {
          queuePostRenderEffect(u2, parentSuspense);
        }
        if (vnodeHook = next.props && next.props.onVnodeUpdated) {
          queuePostRenderEffect(() => invokeVNodeHook(vnodeHook, parent, next, vnode), parentSuspense);
        }
      }
    };
    const effect = instance.effect = new ReactiveEffect(componentUpdateFn, () => queueJob(instance.update), instance.scope);
    const update = instance.update = effect.run.bind(effect);
    update.id = instance.uid;
    toggleRecurse(instance, true);
    update();
  };
  const updateComponentPreRender = (instance, nextVNode, optimized) => {
    nextVNode.component = instance;
    const prevProps = instance.vnode.props;
    instance.vnode = nextVNode;
    instance.next = null;
    updateProps(instance, nextVNode.props, prevProps, optimized);
    updateSlots(instance, nextVNode.children, optimized);
    pauseTracking();
    flushPreFlushCbs(void 0, instance.update);
    resetTracking();
  };
  const patchChildren = (n1, n2, container, anchor, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized = false) => {
    const c1 = n1 && n1.children;
    const prevShapeFlag = n1 ? n1.shapeFlag : 0;
    const c2 = n2.children;
    const { patchFlag, shapeFlag } = n2;
    if (patchFlag > 0) {
      if (patchFlag & 128) {
        patchKeyedChildren(c1, c2, container, anchor, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized);
        return;
      } else if (patchFlag & 256) {
        patchUnkeyedChildren(c1, c2, container, anchor, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized);
        return;
      }
    }
    if (shapeFlag & 8) {
      if (prevShapeFlag & 16) {
        unmountChildren(c1, parentComponent, parentSuspense);
      }
      if (c2 !== c1) {
        hostSetElementText(container, c2);
      }
    } else {
      if (prevShapeFlag & 16) {
        if (shapeFlag & 16) {
          patchKeyedChildren(c1, c2, container, anchor, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized);
        } else {
          unmountChildren(c1, parentComponent, parentSuspense, true);
        }
      } else {
        if (prevShapeFlag & 8) {
          hostSetElementText(container, "");
        }
        if (shapeFlag & 16) {
          mountChildren(c2, container, anchor, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized);
        }
      }
    }
  };
  const patchUnkeyedChildren = (c1, c2, container, anchor, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized) => {
    c1 = c1 || EMPTY_ARR;
    c2 = c2 || EMPTY_ARR;
    const oldLength = c1.length;
    const newLength = c2.length;
    const commonLength = Math.min(oldLength, newLength);
    let i;
    for (i = 0; i < commonLength; i++) {
      const nextChild = c2[i] = optimized ? cloneIfMounted(c2[i]) : normalizeVNode(c2[i]);
      patch(c1[i], nextChild, container, null, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized);
    }
    if (oldLength > newLength) {
      unmountChildren(c1, parentComponent, parentSuspense, true, false, commonLength);
    } else {
      mountChildren(c2, container, anchor, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized, commonLength);
    }
  };
  const patchKeyedChildren = (c1, c2, container, parentAnchor, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized) => {
    let i = 0;
    const l2 = c2.length;
    let e1 = c1.length - 1;
    let e2 = l2 - 1;
    while (i <= e1 && i <= e2) {
      const n1 = c1[i];
      const n2 = c2[i] = optimized ? cloneIfMounted(c2[i]) : normalizeVNode(c2[i]);
      if (isSameVNodeType(n1, n2)) {
        patch(n1, n2, container, null, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized);
      } else {
        break;
      }
      i++;
    }
    while (i <= e1 && i <= e2) {
      const n1 = c1[e1];
      const n2 = c2[e2] = optimized ? cloneIfMounted(c2[e2]) : normalizeVNode(c2[e2]);
      if (isSameVNodeType(n1, n2)) {
        patch(n1, n2, container, null, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized);
      } else {
        break;
      }
      e1--;
      e2--;
    }
    if (i > e1) {
      if (i <= e2) {
        const nextPos = e2 + 1;
        const anchor = nextPos < l2 ? c2[nextPos].el : parentAnchor;
        while (i <= e2) {
          patch(null, c2[i] = optimized ? cloneIfMounted(c2[i]) : normalizeVNode(c2[i]), container, anchor, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized);
          i++;
        }
      }
    } else if (i > e2) {
      while (i <= e1) {
        unmount(c1[i], parentComponent, parentSuspense, true);
        i++;
      }
    } else {
      const s1 = i;
      const s2 = i;
      const keyToNewIndexMap = /* @__PURE__ */ new Map();
      for (i = s2; i <= e2; i++) {
        const nextChild = c2[i] = optimized ? cloneIfMounted(c2[i]) : normalizeVNode(c2[i]);
        if (nextChild.key != null) {
          keyToNewIndexMap.set(nextChild.key, i);
        }
      }
      let j;
      let patched = 0;
      const toBePatched = e2 - s2 + 1;
      let moved = false;
      let maxNewIndexSoFar = 0;
      const newIndexToOldIndexMap = new Array(toBePatched);
      for (i = 0; i < toBePatched; i++)
        newIndexToOldIndexMap[i] = 0;
      for (i = s1; i <= e1; i++) {
        const prevChild = c1[i];
        if (patched >= toBePatched) {
          unmount(prevChild, parentComponent, parentSuspense, true);
          continue;
        }
        let newIndex;
        if (prevChild.key != null) {
          newIndex = keyToNewIndexMap.get(prevChild.key);
        } else {
          for (j = s2; j <= e2; j++) {
            if (newIndexToOldIndexMap[j - s2] === 0 && isSameVNodeType(prevChild, c2[j])) {
              newIndex = j;
              break;
            }
          }
        }
        if (newIndex === void 0) {
          unmount(prevChild, parentComponent, parentSuspense, true);
        } else {
          newIndexToOldIndexMap[newIndex - s2] = i + 1;
          if (newIndex >= maxNewIndexSoFar) {
            maxNewIndexSoFar = newIndex;
          } else {
            moved = true;
          }
          patch(prevChild, c2[newIndex], container, null, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized);
          patched++;
        }
      }
      const increasingNewIndexSequence = moved ? getSequence(newIndexToOldIndexMap) : EMPTY_ARR;
      j = increasingNewIndexSequence.length - 1;
      for (i = toBePatched - 1; i >= 0; i--) {
        const nextIndex = s2 + i;
        const nextChild = c2[nextIndex];
        const anchor = nextIndex + 1 < l2 ? c2[nextIndex + 1].el : parentAnchor;
        if (newIndexToOldIndexMap[i] === 0) {
          patch(null, nextChild, container, anchor, parentComponent, parentSuspense, isSVG, slotScopeIds, optimized);
        } else if (moved) {
          if (j < 0 || i !== increasingNewIndexSequence[j]) {
            move(nextChild, container, anchor, 2);
          } else {
            j--;
          }
        }
      }
    }
  };
  const move = (vnode, container, anchor, moveType, parentSuspense = null) => {
    const { el, type, transition, children, shapeFlag } = vnode;
    if (shapeFlag & 6) {
      move(vnode.component.subTree, container, anchor, moveType);
      return;
    }
    if (shapeFlag & 128) {
      vnode.suspense.move(container, anchor, moveType);
      return;
    }
    if (shapeFlag & 64) {
      type.move(vnode, container, anchor, internals);
      return;
    }
    if (type === Fragment) {
      hostInsert(el, container, anchor);
      for (let i = 0; i < children.length; i++) {
        move(children[i], container, anchor, moveType);
      }
      hostInsert(vnode.anchor, container, anchor);
      return;
    }
    if (type === Static) {
      moveStaticNode(vnode, container, anchor);
      return;
    }
    const needTransition = moveType !== 2 && shapeFlag & 1 && transition;
    if (needTransition) {
      if (moveType === 0) {
        transition.beforeEnter(el);
        hostInsert(el, container, anchor);
        queuePostRenderEffect(() => transition.enter(el), parentSuspense);
      } else {
        const { leave, delayLeave, afterLeave } = transition;
        const remove3 = () => hostInsert(el, container, anchor);
        const performLeave = () => {
          leave(el, () => {
            remove3();
            afterLeave && afterLeave();
          });
        };
        if (delayLeave) {
          delayLeave(el, remove3, performLeave);
        } else {
          performLeave();
        }
      }
    } else {
      hostInsert(el, container, anchor);
    }
  };
  const unmount = (vnode, parentComponent, parentSuspense, doRemove = false, optimized = false) => {
    const { type, props, ref: ref2, children, dynamicChildren, shapeFlag, patchFlag, dirs } = vnode;
    if (ref2 != null) {
      setRef(ref2, null, parentSuspense, vnode, true);
    }
    if (shapeFlag & 256) {
      parentComponent.ctx.deactivate(vnode);
      return;
    }
    const shouldInvokeDirs = shapeFlag & 1 && dirs;
    const shouldInvokeVnodeHook = !isAsyncWrapper(vnode);
    let vnodeHook;
    if (shouldInvokeVnodeHook && (vnodeHook = props && props.onVnodeBeforeUnmount)) {
      invokeVNodeHook(vnodeHook, parentComponent, vnode);
    }
    if (shapeFlag & 6) {
      unmountComponent(vnode.component, parentSuspense, doRemove);
    } else {
      if (shapeFlag & 128) {
        vnode.suspense.unmount(parentSuspense, doRemove);
        return;
      }
      if (shouldInvokeDirs) {
        invokeDirectiveHook(vnode, null, parentComponent, "beforeUnmount");
      }
      if (shapeFlag & 64) {
        vnode.type.remove(vnode, parentComponent, parentSuspense, optimized, internals, doRemove);
      } else if (dynamicChildren && (type !== Fragment || patchFlag > 0 && patchFlag & 64)) {
        unmountChildren(dynamicChildren, parentComponent, parentSuspense, false, true);
      } else if (type === Fragment && patchFlag & (128 | 256) || !optimized && shapeFlag & 16) {
        unmountChildren(children, parentComponent, parentSuspense);
      }
      if (doRemove) {
        remove2(vnode);
      }
    }
    if (shouldInvokeVnodeHook && (vnodeHook = props && props.onVnodeUnmounted) || shouldInvokeDirs) {
      queuePostRenderEffect(() => {
        vnodeHook && invokeVNodeHook(vnodeHook, parentComponent, vnode);
        shouldInvokeDirs && invokeDirectiveHook(vnode, null, parentComponent, "unmounted");
      }, parentSuspense);
    }
  };
  const remove2 = (vnode) => {
    const { type, el, anchor, transition } = vnode;
    if (type === Fragment) {
      {
        removeFragment(el, anchor);
      }
      return;
    }
    if (type === Static) {
      removeStaticNode(vnode);
      return;
    }
    const performRemove = () => {
      hostRemove(el);
      if (transition && !transition.persisted && transition.afterLeave) {
        transition.afterLeave();
      }
    };
    if (vnode.shapeFlag & 1 && transition && !transition.persisted) {
      const { leave, delayLeave } = transition;
      const performLeave = () => leave(el, performRemove);
      if (delayLeave) {
        delayLeave(vnode.el, performRemove, performLeave);
      } else {
        performLeave();
      }
    } else {
      performRemove();
    }
  };
  const removeFragment = (cur, end) => {
    let next;
    while (cur !== end) {
      next = hostNextSibling(cur);
      hostRemove(cur);
      cur = next;
    }
    hostRemove(end);
  };
  const unmountComponent = (instance, parentSuspense, doRemove) => {
    const { bum, scope, update, subTree, um } = instance;
    if (bum) {
      invokeArrayFns(bum);
    }
    scope.stop();
    if (update) {
      update.active = false;
      unmount(subTree, instance, parentSuspense, doRemove);
    }
    if (um) {
      queuePostRenderEffect(um, parentSuspense);
    }
    queuePostRenderEffect(() => {
      instance.isUnmounted = true;
    }, parentSuspense);
    if (parentSuspense && parentSuspense.pendingBranch && !parentSuspense.isUnmounted && instance.asyncDep && !instance.asyncResolved && instance.suspenseId === parentSuspense.pendingId) {
      parentSuspense.deps--;
      if (parentSuspense.deps === 0) {
        parentSuspense.resolve();
      }
    }
  };
  const unmountChildren = (children, parentComponent, parentSuspense, doRemove = false, optimized = false, start = 0) => {
    for (let i = start; i < children.length; i++) {
      unmount(children[i], parentComponent, parentSuspense, doRemove, optimized);
    }
  };
  const getNextHostNode = (vnode) => {
    if (vnode.shapeFlag & 6) {
      return getNextHostNode(vnode.component.subTree);
    }
    if (vnode.shapeFlag & 128) {
      return vnode.suspense.next();
    }
    return hostNextSibling(vnode.anchor || vnode.el);
  };
  const render2 = (vnode, container, isSVG) => {
    if (vnode == null) {
      if (container._vnode) {
        unmount(container._vnode, null, null, true);
      }
    } else {
      patch(container._vnode || null, vnode, container, null, null, null, isSVG);
    }
    flushPostFlushCbs();
    container._vnode = vnode;
  };
  const internals = {
    p: patch,
    um: unmount,
    m: move,
    r: remove2,
    mt: mountComponent,
    mc: mountChildren,
    pc: patchChildren,
    pbc: patchBlockChildren,
    n: getNextHostNode,
    o: options
  };
  let hydrate;
  let hydrateNode;
  if (createHydrationFns) {
    [hydrate, hydrateNode] = createHydrationFns(internals);
  }
  return {
    render: render2,
    hydrate,
    createApp: createAppAPI(render2, hydrate)
  };
}
function toggleRecurse({ effect, update }, allowed) {
  effect.allowRecurse = update.allowRecurse = allowed;
}
function traverseStaticChildren(n1, n2, shallow = false) {
  const ch1 = n1.children;
  const ch2 = n2.children;
  if (isArray(ch1) && isArray(ch2)) {
    for (let i = 0; i < ch1.length; i++) {
      const c1 = ch1[i];
      let c2 = ch2[i];
      if (c2.shapeFlag & 1 && !c2.dynamicChildren) {
        if (c2.patchFlag <= 0 || c2.patchFlag === 32) {
          c2 = ch2[i] = cloneIfMounted(ch2[i]);
          c2.el = c1.el;
        }
        if (!shallow)
          traverseStaticChildren(c1, c2);
      }
    }
  }
}
function getSequence(arr) {
  const p2 = arr.slice();
  const result = [0];
  let i, j, u2, v, c;
  const len = arr.length;
  for (i = 0; i < len; i++) {
    const arrI = arr[i];
    if (arrI !== 0) {
      j = result[result.length - 1];
      if (arr[j] < arrI) {
        p2[i] = j;
        result.push(i);
        continue;
      }
      u2 = 0;
      v = result.length - 1;
      while (u2 < v) {
        c = u2 + v >> 1;
        if (arr[result[c]] < arrI) {
          u2 = c + 1;
        } else {
          v = c;
        }
      }
      if (arrI < arr[result[u2]]) {
        if (u2 > 0) {
          p2[i] = result[u2 - 1];
        }
        result[u2] = i;
      }
    }
  }
  u2 = result.length;
  v = result[u2 - 1];
  while (u2-- > 0) {
    result[u2] = v;
    v = p2[v];
  }
  return result;
}
const isTeleport = (type) => type.__isTeleport;
const COMPONENTS = "components";
function resolveComponent(name, maybeSelfReference) {
  return resolveAsset(COMPONENTS, name, true, maybeSelfReference) || name;
}
const NULL_DYNAMIC_COMPONENT = Symbol();
function resolveAsset(type, name, warnMissing = true, maybeSelfReference = false) {
  const instance = currentRenderingInstance || currentInstance;
  if (instance) {
    const Component = instance.type;
    if (type === COMPONENTS) {
      const selfName = getComponentName(Component);
      if (selfName && (selfName === name || selfName === camelize(name) || selfName === capitalize(camelize(name)))) {
        return Component;
      }
    }
    const res = resolve(instance[type] || Component[type], name) || resolve(instance.appContext[type], name);
    if (!res && maybeSelfReference) {
      return Component;
    }
    return res;
  }
}
function resolve(registry, name) {
  return registry && (registry[name] || registry[camelize(name)] || registry[capitalize(camelize(name))]);
}
const Fragment = Symbol(void 0);
const Text = Symbol(void 0);
const Comment = Symbol(void 0);
const Static = Symbol(void 0);
const blockStack = [];
let currentBlock = null;
function openBlock(disableTracking = false) {
  blockStack.push(currentBlock = disableTracking ? null : []);
}
function closeBlock() {
  blockStack.pop();
  currentBlock = blockStack[blockStack.length - 1] || null;
}
let isBlockTreeEnabled = 1;
function setBlockTracking(value) {
  isBlockTreeEnabled += value;
}
function setupBlock(vnode) {
  vnode.dynamicChildren = isBlockTreeEnabled > 0 ? currentBlock || EMPTY_ARR : null;
  closeBlock();
  if (isBlockTreeEnabled > 0 && currentBlock) {
    currentBlock.push(vnode);
  }
  return vnode;
}
function createElementBlock(type, props, children, patchFlag, dynamicProps, shapeFlag) {
  return setupBlock(createBaseVNode(type, props, children, patchFlag, dynamicProps, shapeFlag, true));
}
function createBlock(type, props, children, patchFlag, dynamicProps) {
  return setupBlock(createVNode(type, props, children, patchFlag, dynamicProps, true));
}
function isVNode(value) {
  return value ? value.__v_isVNode === true : false;
}
function isSameVNodeType(n1, n2) {
  return n1.type === n2.type && n1.key === n2.key;
}
const InternalObjectKey = `__vInternal`;
const normalizeKey = ({ key }) => key != null ? key : null;
const normalizeRef = ({ ref: ref2, ref_key, ref_for }) => {
  return ref2 != null ? isString(ref2) || isRef(ref2) || isFunction(ref2) ? { i: currentRenderingInstance, r: ref2, k: ref_key, f: !!ref_for } : ref2 : null;
};
function createBaseVNode(type, props = null, children = null, patchFlag = 0, dynamicProps = null, shapeFlag = type === Fragment ? 0 : 1, isBlockNode = false, needFullChildrenNormalization = false) {
  const vnode = {
    __v_isVNode: true,
    __v_skip: true,
    type,
    props,
    key: props && normalizeKey(props),
    ref: props && normalizeRef(props),
    scopeId: currentScopeId,
    slotScopeIds: null,
    children,
    component: null,
    suspense: null,
    ssContent: null,
    ssFallback: null,
    dirs: null,
    transition: null,
    el: null,
    anchor: null,
    target: null,
    targetAnchor: null,
    staticCount: 0,
    shapeFlag,
    patchFlag,
    dynamicProps,
    dynamicChildren: null,
    appContext: null
  };
  if (needFullChildrenNormalization) {
    normalizeChildren(vnode, children);
    if (shapeFlag & 128) {
      type.normalize(vnode);
    }
  } else if (children) {
    vnode.shapeFlag |= isString(children) ? 8 : 16;
  }
  if (isBlockTreeEnabled > 0 && !isBlockNode && currentBlock && (vnode.patchFlag > 0 || shapeFlag & 6) && vnode.patchFlag !== 32) {
    currentBlock.push(vnode);
  }
  return vnode;
}
const createVNode = _createVNode;
function _createVNode(type, props = null, children = null, patchFlag = 0, dynamicProps = null, isBlockNode = false) {
  if (!type || type === NULL_DYNAMIC_COMPONENT) {
    type = Comment;
  }
  if (isVNode(type)) {
    const cloned = cloneVNode(type, props, true);
    if (children) {
      normalizeChildren(cloned, children);
    }
    return cloned;
  }
  if (isClassComponent(type)) {
    type = type.__vccOpts;
  }
  if (props) {
    props = guardReactiveProps(props);
    let { class: klass, style } = props;
    if (klass && !isString(klass)) {
      props.class = normalizeClass(klass);
    }
    if (isObject(style)) {
      if (isProxy(style) && !isArray(style)) {
        style = extend({}, style);
      }
      props.style = normalizeStyle(style);
    }
  }
  const shapeFlag = isString(type) ? 1 : isSuspense(type) ? 128 : isTeleport(type) ? 64 : isObject(type) ? 4 : isFunction(type) ? 2 : 0;
  return createBaseVNode(type, props, children, patchFlag, dynamicProps, shapeFlag, isBlockNode, true);
}
function guardReactiveProps(props) {
  if (!props)
    return null;
  return isProxy(props) || InternalObjectKey in props ? extend({}, props) : props;
}
function cloneVNode(vnode, extraProps, mergeRef = false) {
  const { props, ref: ref2, patchFlag, children } = vnode;
  const mergedProps = extraProps ? mergeProps(props || {}, extraProps) : props;
  const cloned = {
    __v_isVNode: true,
    __v_skip: true,
    type: vnode.type,
    props: mergedProps,
    key: mergedProps && normalizeKey(mergedProps),
    ref: extraProps && extraProps.ref ? mergeRef && ref2 ? isArray(ref2) ? ref2.concat(normalizeRef(extraProps)) : [ref2, normalizeRef(extraProps)] : normalizeRef(extraProps) : ref2,
    scopeId: vnode.scopeId,
    slotScopeIds: vnode.slotScopeIds,
    children,
    target: vnode.target,
    targetAnchor: vnode.targetAnchor,
    staticCount: vnode.staticCount,
    shapeFlag: vnode.shapeFlag,
    patchFlag: extraProps && vnode.type !== Fragment ? patchFlag === -1 ? 16 : patchFlag | 16 : patchFlag,
    dynamicProps: vnode.dynamicProps,
    dynamicChildren: vnode.dynamicChildren,
    appContext: vnode.appContext,
    dirs: vnode.dirs,
    transition: vnode.transition,
    component: vnode.component,
    suspense: vnode.suspense,
    ssContent: vnode.ssContent && cloneVNode(vnode.ssContent),
    ssFallback: vnode.ssFallback && cloneVNode(vnode.ssFallback),
    el: vnode.el,
    anchor: vnode.anchor
  };
  return cloned;
}
function createTextVNode(text = " ", flag = 0) {
  return createVNode(Text, null, text, flag);
}
function createStaticVNode(content, numberOfNodes) {
  const vnode = createVNode(Static, null, content);
  vnode.staticCount = numberOfNodes;
  return vnode;
}
function createCommentVNode(text = "", asBlock = false) {
  return asBlock ? (openBlock(), createBlock(Comment, null, text)) : createVNode(Comment, null, text);
}
function normalizeVNode(child) {
  if (child == null || typeof child === "boolean") {
    return createVNode(Comment);
  } else if (isArray(child)) {
    return createVNode(Fragment, null, child.slice());
  } else if (typeof child === "object") {
    return cloneIfMounted(child);
  } else {
    return createVNode(Text, null, String(child));
  }
}
function cloneIfMounted(child) {
  return child.el === null || child.memo ? child : cloneVNode(child);
}
function normalizeChildren(vnode, children) {
  let type = 0;
  const { shapeFlag } = vnode;
  if (children == null) {
    children = null;
  } else if (isArray(children)) {
    type = 16;
  } else if (typeof children === "object") {
    if (shapeFlag & (1 | 64)) {
      const slot = children.default;
      if (slot) {
        slot._c && (slot._d = false);
        normalizeChildren(vnode, slot());
        slot._c && (slot._d = true);
      }
      return;
    } else {
      type = 32;
      const slotFlag = children._;
      if (!slotFlag && !(InternalObjectKey in children)) {
        children._ctx = currentRenderingInstance;
      } else if (slotFlag === 3 && currentRenderingInstance) {
        if (currentRenderingInstance.slots._ === 1) {
          children._ = 1;
        } else {
          children._ = 2;
          vnode.patchFlag |= 1024;
        }
      }
    }
  } else if (isFunction(children)) {
    children = { default: children, _ctx: currentRenderingInstance };
    type = 32;
  } else {
    children = String(children);
    if (shapeFlag & 64) {
      type = 16;
      children = [createTextVNode(children)];
    } else {
      type = 8;
    }
  }
  vnode.children = children;
  vnode.shapeFlag |= type;
}
function mergeProps(...args) {
  const ret = {};
  for (let i = 0; i < args.length; i++) {
    const toMerge = args[i];
    for (const key in toMerge) {
      if (key === "class") {
        if (ret.class !== toMerge.class) {
          ret.class = normalizeClass([ret.class, toMerge.class]);
        }
      } else if (key === "style") {
        ret.style = normalizeStyle([ret.style, toMerge.style]);
      } else if (isOn(key)) {
        const existing = ret[key];
        const incoming = toMerge[key];
        if (incoming && existing !== incoming && !(isArray(existing) && existing.includes(incoming))) {
          ret[key] = existing ? [].concat(existing, incoming) : incoming;
        }
      } else if (key !== "") {
        ret[key] = toMerge[key];
      }
    }
  }
  return ret;
}
function invokeVNodeHook(hook, instance, vnode, prevVNode = null) {
  callWithAsyncErrorHandling(hook, instance, 7, [
    vnode,
    prevVNode
  ]);
}
function renderList(source, renderItem, cache, index2) {
  let ret;
  const cached = cache && cache[index2];
  if (isArray(source) || isString(source)) {
    ret = new Array(source.length);
    for (let i = 0, l2 = source.length; i < l2; i++) {
      ret[i] = renderItem(source[i], i, void 0, cached && cached[i]);
    }
  } else if (typeof source === "number") {
    ret = new Array(source);
    for (let i = 0; i < source; i++) {
      ret[i] = renderItem(i + 1, i, void 0, cached && cached[i]);
    }
  } else if (isObject(source)) {
    if (source[Symbol.iterator]) {
      ret = Array.from(source, (item, i) => renderItem(item, i, void 0, cached && cached[i]));
    } else {
      const keys = Object.keys(source);
      ret = new Array(keys.length);
      for (let i = 0, l2 = keys.length; i < l2; i++) {
        const key = keys[i];
        ret[i] = renderItem(source[key], key, i, cached && cached[i]);
      }
    }
  } else {
    ret = [];
  }
  if (cache) {
    cache[index2] = ret;
  }
  return ret;
}
const getPublicInstance = (i) => {
  if (!i)
    return null;
  if (isStatefulComponent(i))
    return getExposeProxy(i) || i.proxy;
  return getPublicInstance(i.parent);
};
const publicPropertiesMap = /* @__PURE__ */ extend(/* @__PURE__ */ Object.create(null), {
  $: (i) => i,
  $el: (i) => i.vnode.el,
  $data: (i) => i.data,
  $props: (i) => i.props,
  $attrs: (i) => i.attrs,
  $slots: (i) => i.slots,
  $refs: (i) => i.refs,
  $parent: (i) => getPublicInstance(i.parent),
  $root: (i) => getPublicInstance(i.root),
  $emit: (i) => i.emit,
  $options: (i) => resolveMergedOptions(i),
  $forceUpdate: (i) => () => queueJob(i.update),
  $nextTick: (i) => nextTick.bind(i.proxy),
  $watch: (i) => instanceWatch.bind(i)
});
const PublicInstanceProxyHandlers = {
  get({ _: instance }, key) {
    const { ctx, setupState, data, props, accessCache, type, appContext } = instance;
    let normalizedProps;
    if (key[0] !== "$") {
      const n2 = accessCache[key];
      if (n2 !== void 0) {
        switch (n2) {
          case 1:
            return setupState[key];
          case 2:
            return data[key];
          case 4:
            return ctx[key];
          case 3:
            return props[key];
        }
      } else if (setupState !== EMPTY_OBJ && hasOwn(setupState, key)) {
        accessCache[key] = 1;
        return setupState[key];
      } else if (data !== EMPTY_OBJ && hasOwn(data, key)) {
        accessCache[key] = 2;
        return data[key];
      } else if ((normalizedProps = instance.propsOptions[0]) && hasOwn(normalizedProps, key)) {
        accessCache[key] = 3;
        return props[key];
      } else if (ctx !== EMPTY_OBJ && hasOwn(ctx, key)) {
        accessCache[key] = 4;
        return ctx[key];
      } else if (shouldCacheAccess) {
        accessCache[key] = 0;
      }
    }
    const publicGetter = publicPropertiesMap[key];
    let cssModule, globalProperties;
    if (publicGetter) {
      if (key === "$attrs") {
        track(instance, "get", key);
      }
      return publicGetter(instance);
    } else if ((cssModule = type.__cssModules) && (cssModule = cssModule[key])) {
      return cssModule;
    } else if (ctx !== EMPTY_OBJ && hasOwn(ctx, key)) {
      accessCache[key] = 4;
      return ctx[key];
    } else if (globalProperties = appContext.config.globalProperties, hasOwn(globalProperties, key)) {
      {
        return globalProperties[key];
      }
    } else
      ;
  },
  set({ _: instance }, key, value) {
    const { data, setupState, ctx } = instance;
    if (setupState !== EMPTY_OBJ && hasOwn(setupState, key)) {
      setupState[key] = value;
      return true;
    } else if (data !== EMPTY_OBJ && hasOwn(data, key)) {
      data[key] = value;
      return true;
    } else if (hasOwn(instance.props, key)) {
      return false;
    }
    if (key[0] === "$" && key.slice(1) in instance) {
      return false;
    } else {
      {
        ctx[key] = value;
      }
    }
    return true;
  },
  has({ _: { data, setupState, accessCache, ctx, appContext, propsOptions } }, key) {
    let normalizedProps;
    return !!accessCache[key] || data !== EMPTY_OBJ && hasOwn(data, key) || setupState !== EMPTY_OBJ && hasOwn(setupState, key) || (normalizedProps = propsOptions[0]) && hasOwn(normalizedProps, key) || hasOwn(ctx, key) || hasOwn(publicPropertiesMap, key) || hasOwn(appContext.config.globalProperties, key);
  },
  defineProperty(target, key, descriptor) {
    if (descriptor.get != null) {
      target._.accessCache[key] = 0;
    } else if (hasOwn(descriptor, "value")) {
      this.set(target, key, descriptor.value, null);
    }
    return Reflect.defineProperty(target, key, descriptor);
  }
};
const emptyAppContext = createAppContext();
let uid$1 = 0;
function createComponentInstance(vnode, parent, suspense) {
  const type = vnode.type;
  const appContext = (parent ? parent.appContext : vnode.appContext) || emptyAppContext;
  const instance = {
    uid: uid$1++,
    vnode,
    type,
    parent,
    appContext,
    root: null,
    next: null,
    subTree: null,
    effect: null,
    update: null,
    scope: new EffectScope(true),
    render: null,
    proxy: null,
    exposed: null,
    exposeProxy: null,
    withProxy: null,
    provides: parent ? parent.provides : Object.create(appContext.provides),
    accessCache: null,
    renderCache: [],
    components: null,
    directives: null,
    propsOptions: normalizePropsOptions(type, appContext),
    emitsOptions: normalizeEmitsOptions(type, appContext),
    emit: null,
    emitted: null,
    propsDefaults: EMPTY_OBJ,
    inheritAttrs: type.inheritAttrs,
    ctx: EMPTY_OBJ,
    data: EMPTY_OBJ,
    props: EMPTY_OBJ,
    attrs: EMPTY_OBJ,
    slots: EMPTY_OBJ,
    refs: EMPTY_OBJ,
    setupState: EMPTY_OBJ,
    setupContext: null,
    suspense,
    suspenseId: suspense ? suspense.pendingId : 0,
    asyncDep: null,
    asyncResolved: false,
    isMounted: false,
    isUnmounted: false,
    isDeactivated: false,
    bc: null,
    c: null,
    bm: null,
    m: null,
    bu: null,
    u: null,
    um: null,
    bum: null,
    da: null,
    a: null,
    rtg: null,
    rtc: null,
    ec: null,
    sp: null
  };
  {
    instance.ctx = { _: instance };
  }
  instance.root = parent ? parent.root : instance;
  instance.emit = emit$1.bind(null, instance);
  if (vnode.ce) {
    vnode.ce(instance);
  }
  return instance;
}
let currentInstance = null;
const getCurrentInstance = () => currentInstance || currentRenderingInstance;
const setCurrentInstance = (instance) => {
  currentInstance = instance;
  instance.scope.on();
};
const unsetCurrentInstance = () => {
  currentInstance && currentInstance.scope.off();
  currentInstance = null;
};
function isStatefulComponent(instance) {
  return instance.vnode.shapeFlag & 4;
}
let isInSSRComponentSetup = false;
function setupComponent(instance, isSSR = false) {
  isInSSRComponentSetup = isSSR;
  const { props, children } = instance.vnode;
  const isStateful = isStatefulComponent(instance);
  initProps(instance, props, isStateful, isSSR);
  initSlots(instance, children);
  const setupResult = isStateful ? setupStatefulComponent(instance, isSSR) : void 0;
  isInSSRComponentSetup = false;
  return setupResult;
}
function setupStatefulComponent(instance, isSSR) {
  const Component = instance.type;
  instance.accessCache = /* @__PURE__ */ Object.create(null);
  instance.proxy = markRaw(new Proxy(instance.ctx, PublicInstanceProxyHandlers));
  const { setup } = Component;
  if (setup) {
    const setupContext = instance.setupContext = setup.length > 1 ? createSetupContext(instance) : null;
    setCurrentInstance(instance);
    pauseTracking();
    const setupResult = callWithErrorHandling(setup, instance, 0, [instance.props, setupContext]);
    resetTracking();
    unsetCurrentInstance();
    if (isPromise(setupResult)) {
      setupResult.then(unsetCurrentInstance, unsetCurrentInstance);
      if (isSSR) {
        return setupResult.then((resolvedResult) => {
          handleSetupResult(instance, resolvedResult, isSSR);
        }).catch((e2) => {
          handleError(e2, instance, 0);
        });
      } else {
        instance.asyncDep = setupResult;
      }
    } else {
      handleSetupResult(instance, setupResult, isSSR);
    }
  } else {
    finishComponentSetup(instance, isSSR);
  }
}
function handleSetupResult(instance, setupResult, isSSR) {
  if (isFunction(setupResult)) {
    if (instance.type.__ssrInlineRender) {
      instance.ssrRender = setupResult;
    } else {
      instance.render = setupResult;
    }
  } else if (isObject(setupResult)) {
    instance.setupState = proxyRefs(setupResult);
  } else
    ;
  finishComponentSetup(instance, isSSR);
}
let compile;
function finishComponentSetup(instance, isSSR, skipOptions) {
  const Component = instance.type;
  if (!instance.render) {
    if (!isSSR && compile && !Component.render) {
      const template = Component.template;
      if (template) {
        const { isCustomElement, compilerOptions } = instance.appContext.config;
        const { delimiters, compilerOptions: componentCompilerOptions } = Component;
        const finalCompilerOptions = extend(extend({
          isCustomElement,
          delimiters
        }, compilerOptions), componentCompilerOptions);
        Component.render = compile(template, finalCompilerOptions);
      }
    }
    instance.render = Component.render || NOOP;
  }
  {
    setCurrentInstance(instance);
    pauseTracking();
    applyOptions(instance);
    resetTracking();
    unsetCurrentInstance();
  }
}
function createAttrsProxy(instance) {
  return new Proxy(instance.attrs, {
    get(target, key) {
      track(instance, "get", "$attrs");
      return target[key];
    }
  });
}
function createSetupContext(instance) {
  const expose = (exposed) => {
    instance.exposed = exposed || {};
  };
  let attrs;
  {
    return {
      get attrs() {
        return attrs || (attrs = createAttrsProxy(instance));
      },
      slots: instance.slots,
      emit: instance.emit,
      expose
    };
  }
}
function getExposeProxy(instance) {
  if (instance.exposed) {
    return instance.exposeProxy || (instance.exposeProxy = new Proxy(proxyRefs(markRaw(instance.exposed)), {
      get(target, key) {
        if (key in target) {
          return target[key];
        } else if (key in publicPropertiesMap) {
          return publicPropertiesMap[key](instance);
        }
      }
    }));
  }
}
function getComponentName(Component) {
  return isFunction(Component) ? Component.displayName || Component.name : Component.name;
}
function isClassComponent(value) {
  return isFunction(value) && "__vccOpts" in value;
}
const computed = (getterOrOptions, debugOptions) => {
  return computed$1(getterOrOptions, debugOptions, isInSSRComponentSetup);
};
function h$2(type, propsOrChildren, children) {
  const l2 = arguments.length;
  if (l2 === 2) {
    if (isObject(propsOrChildren) && !isArray(propsOrChildren)) {
      if (isVNode(propsOrChildren)) {
        return createVNode(type, null, [propsOrChildren]);
      }
      return createVNode(type, propsOrChildren);
    } else {
      return createVNode(type, null, propsOrChildren);
    }
  } else {
    if (l2 > 3) {
      children = Array.prototype.slice.call(arguments, 2);
    } else if (l2 === 3 && isVNode(children)) {
      children = [children];
    }
    return createVNode(type, propsOrChildren, children);
  }
}
const version = "3.2.33";
const svgNS = "http://www.w3.org/2000/svg";
const doc = typeof document !== "undefined" ? document : null;
const templateContainer = doc && /* @__PURE__ */ doc.createElement("template");
const nodeOps = {
  insert: (child, parent, anchor) => {
    parent.insertBefore(child, anchor || null);
  },
  remove: (child) => {
    const parent = child.parentNode;
    if (parent) {
      parent.removeChild(child);
    }
  },
  createElement: (tag, isSVG, is, props) => {
    const el = isSVG ? doc.createElementNS(svgNS, tag) : doc.createElement(tag, is ? { is } : void 0);
    if (tag === "select" && props && props.multiple != null) {
      el.setAttribute("multiple", props.multiple);
    }
    return el;
  },
  createText: (text) => doc.createTextNode(text),
  createComment: (text) => doc.createComment(text),
  setText: (node, text) => {
    node.nodeValue = text;
  },
  setElementText: (el, text) => {
    el.textContent = text;
  },
  parentNode: (node) => node.parentNode,
  nextSibling: (node) => node.nextSibling,
  querySelector: (selector) => doc.querySelector(selector),
  setScopeId(el, id) {
    el.setAttribute(id, "");
  },
  cloneNode(el) {
    const cloned = el.cloneNode(true);
    if (`_value` in el) {
      cloned._value = el._value;
    }
    return cloned;
  },
  insertStaticContent(content, parent, anchor, isSVG, start, end) {
    const before = anchor ? anchor.previousSibling : parent.lastChild;
    if (start && (start === end || start.nextSibling)) {
      while (true) {
        parent.insertBefore(start.cloneNode(true), anchor);
        if (start === end || !(start = start.nextSibling))
          break;
      }
    } else {
      templateContainer.innerHTML = isSVG ? `<svg>${content}</svg>` : content;
      const template = templateContainer.content;
      if (isSVG) {
        const wrapper = template.firstChild;
        while (wrapper.firstChild) {
          template.appendChild(wrapper.firstChild);
        }
        template.removeChild(wrapper);
      }
      parent.insertBefore(template, anchor);
    }
    return [
      before ? before.nextSibling : parent.firstChild,
      anchor ? anchor.previousSibling : parent.lastChild
    ];
  }
};
function patchClass(el, value, isSVG) {
  const transitionClasses = el._vtc;
  if (transitionClasses) {
    value = (value ? [value, ...transitionClasses] : [...transitionClasses]).join(" ");
  }
  if (value == null) {
    el.removeAttribute("class");
  } else if (isSVG) {
    el.setAttribute("class", value);
  } else {
    el.className = value;
  }
}
function patchStyle(el, prev, next) {
  const style = el.style;
  const isCssString = isString(next);
  if (next && !isCssString) {
    for (const key in next) {
      setStyle(style, key, next[key]);
    }
    if (prev && !isString(prev)) {
      for (const key in prev) {
        if (next[key] == null) {
          setStyle(style, key, "");
        }
      }
    }
  } else {
    const currentDisplay = style.display;
    if (isCssString) {
      if (prev !== next) {
        style.cssText = next;
      }
    } else if (prev) {
      el.removeAttribute("style");
    }
    if ("_vod" in el) {
      style.display = currentDisplay;
    }
  }
}
const importantRE = /\s*!important$/;
function setStyle(style, name, val) {
  if (isArray(val)) {
    val.forEach((v) => setStyle(style, name, v));
  } else {
    if (val == null)
      val = "";
    if (name.startsWith("--")) {
      style.setProperty(name, val);
    } else {
      const prefixed = autoPrefix(style, name);
      if (importantRE.test(val)) {
        style.setProperty(hyphenate(prefixed), val.replace(importantRE, ""), "important");
      } else {
        style[prefixed] = val;
      }
    }
  }
}
const prefixes = ["Webkit", "Moz", "ms"];
const prefixCache = {};
function autoPrefix(style, rawName) {
  const cached = prefixCache[rawName];
  if (cached) {
    return cached;
  }
  let name = camelize(rawName);
  if (name !== "filter" && name in style) {
    return prefixCache[rawName] = name;
  }
  name = capitalize(name);
  for (let i = 0; i < prefixes.length; i++) {
    const prefixed = prefixes[i] + name;
    if (prefixed in style) {
      return prefixCache[rawName] = prefixed;
    }
  }
  return rawName;
}
const xlinkNS = "http://www.w3.org/1999/xlink";
function patchAttr(el, key, value, isSVG, instance) {
  if (isSVG && key.startsWith("xlink:")) {
    if (value == null) {
      el.removeAttributeNS(xlinkNS, key.slice(6, key.length));
    } else {
      el.setAttributeNS(xlinkNS, key, value);
    }
  } else {
    const isBoolean = isSpecialBooleanAttr(key);
    if (value == null || isBoolean && !includeBooleanAttr(value)) {
      el.removeAttribute(key);
    } else {
      el.setAttribute(key, isBoolean ? "" : value);
    }
  }
}
function patchDOMProp(el, key, value, prevChildren, parentComponent, parentSuspense, unmountChildren) {
  if (key === "innerHTML" || key === "textContent") {
    if (prevChildren) {
      unmountChildren(prevChildren, parentComponent, parentSuspense);
    }
    el[key] = value == null ? "" : value;
    return;
  }
  if (key === "value" && el.tagName !== "PROGRESS" && !el.tagName.includes("-")) {
    el._value = value;
    const newValue = value == null ? "" : value;
    if (el.value !== newValue || el.tagName === "OPTION") {
      el.value = newValue;
    }
    if (value == null) {
      el.removeAttribute(key);
    }
    return;
  }
  let needRemove = false;
  if (value === "" || value == null) {
    const type = typeof el[key];
    if (type === "boolean") {
      value = includeBooleanAttr(value);
    } else if (value == null && type === "string") {
      value = "";
      needRemove = true;
    } else if (type === "number") {
      value = 0;
      needRemove = true;
    }
  }
  try {
    el[key] = value;
  } catch (e2) {
  }
  needRemove && el.removeAttribute(key);
}
const [_getNow, skipTimestampCheck] = /* @__PURE__ */ (() => {
  let _getNow2 = Date.now;
  let skipTimestampCheck2 = false;
  if (typeof window !== "undefined") {
    if (Date.now() > document.createEvent("Event").timeStamp) {
      _getNow2 = () => performance.now();
    }
    const ffMatch = navigator.userAgent.match(/firefox\/(\d+)/i);
    skipTimestampCheck2 = !!(ffMatch && Number(ffMatch[1]) <= 53);
  }
  return [_getNow2, skipTimestampCheck2];
})();
let cachedNow = 0;
const p$1 = /* @__PURE__ */ Promise.resolve();
const reset = () => {
  cachedNow = 0;
};
const getNow = () => cachedNow || (p$1.then(reset), cachedNow = _getNow());
function addEventListener(el, event, handler, options) {
  el.addEventListener(event, handler, options);
}
function removeEventListener(el, event, handler, options) {
  el.removeEventListener(event, handler, options);
}
function patchEvent(el, rawName, prevValue, nextValue, instance = null) {
  const invokers = el._vei || (el._vei = {});
  const existingInvoker = invokers[rawName];
  if (nextValue && existingInvoker) {
    existingInvoker.value = nextValue;
  } else {
    const [name, options] = parseName(rawName);
    if (nextValue) {
      const invoker = invokers[rawName] = createInvoker(nextValue, instance);
      addEventListener(el, name, invoker, options);
    } else if (existingInvoker) {
      removeEventListener(el, name, existingInvoker, options);
      invokers[rawName] = void 0;
    }
  }
}
const optionsModifierRE = /(?:Once|Passive|Capture)$/;
function parseName(name) {
  let options;
  if (optionsModifierRE.test(name)) {
    options = {};
    let m2;
    while (m2 = name.match(optionsModifierRE)) {
      name = name.slice(0, name.length - m2[0].length);
      options[m2[0].toLowerCase()] = true;
    }
  }
  return [hyphenate(name.slice(2)), options];
}
function createInvoker(initialValue, instance) {
  const invoker = (e2) => {
    const timeStamp = e2.timeStamp || _getNow();
    if (skipTimestampCheck || timeStamp >= invoker.attached - 1) {
      callWithAsyncErrorHandling(patchStopImmediatePropagation(e2, invoker.value), instance, 5, [e2]);
    }
  };
  invoker.value = initialValue;
  invoker.attached = getNow();
  return invoker;
}
function patchStopImmediatePropagation(e2, value) {
  if (isArray(value)) {
    const originalStop = e2.stopImmediatePropagation;
    e2.stopImmediatePropagation = () => {
      originalStop.call(e2);
      e2._stopped = true;
    };
    return value.map((fn) => (e3) => !e3._stopped && fn && fn(e3));
  } else {
    return value;
  }
}
const nativeOnRE = /^on[a-z]/;
const patchProp = (el, key, prevValue, nextValue, isSVG = false, prevChildren, parentComponent, parentSuspense, unmountChildren) => {
  if (key === "class") {
    patchClass(el, nextValue, isSVG);
  } else if (key === "style") {
    patchStyle(el, prevValue, nextValue);
  } else if (isOn(key)) {
    if (!isModelListener(key)) {
      patchEvent(el, key, prevValue, nextValue, parentComponent);
    }
  } else if (key[0] === "." ? (key = key.slice(1), true) : key[0] === "^" ? (key = key.slice(1), false) : shouldSetAsProp(el, key, nextValue, isSVG)) {
    patchDOMProp(el, key, nextValue, prevChildren, parentComponent, parentSuspense, unmountChildren);
  } else {
    if (key === "true-value") {
      el._trueValue = nextValue;
    } else if (key === "false-value") {
      el._falseValue = nextValue;
    }
    patchAttr(el, key, nextValue, isSVG);
  }
};
function shouldSetAsProp(el, key, value, isSVG) {
  if (isSVG) {
    if (key === "innerHTML" || key === "textContent") {
      return true;
    }
    if (key in el && nativeOnRE.test(key) && isFunction(value)) {
      return true;
    }
    return false;
  }
  if (key === "spellcheck" || key === "draggable" || key === "translate") {
    return false;
  }
  if (key === "form") {
    return false;
  }
  if (key === "list" && el.tagName === "INPUT") {
    return false;
  }
  if (key === "type" && el.tagName === "TEXTAREA") {
    return false;
  }
  if (nativeOnRE.test(key) && isString(value)) {
    return false;
  }
  return key in el;
}
const TRANSITION = "transition";
const ANIMATION = "animation";
const Transition = (props, { slots }) => h$2(BaseTransition, resolveTransitionProps(props), slots);
Transition.displayName = "Transition";
const DOMTransitionPropsValidators = {
  name: String,
  type: String,
  css: {
    type: Boolean,
    default: true
  },
  duration: [String, Number, Object],
  enterFromClass: String,
  enterActiveClass: String,
  enterToClass: String,
  appearFromClass: String,
  appearActiveClass: String,
  appearToClass: String,
  leaveFromClass: String,
  leaveActiveClass: String,
  leaveToClass: String
};
Transition.props = /* @__PURE__ */ extend({}, BaseTransition.props, DOMTransitionPropsValidators);
const callHook = (hook, args = []) => {
  if (isArray(hook)) {
    hook.forEach((h2) => h2(...args));
  } else if (hook) {
    hook(...args);
  }
};
const hasExplicitCallback = (hook) => {
  return hook ? isArray(hook) ? hook.some((h2) => h2.length > 1) : hook.length > 1 : false;
};
function resolveTransitionProps(rawProps) {
  const baseProps = {};
  for (const key in rawProps) {
    if (!(key in DOMTransitionPropsValidators)) {
      baseProps[key] = rawProps[key];
    }
  }
  if (rawProps.css === false) {
    return baseProps;
  }
  const { name = "v", type, duration, enterFromClass = `${name}-enter-from`, enterActiveClass = `${name}-enter-active`, enterToClass = `${name}-enter-to`, appearFromClass = enterFromClass, appearActiveClass = enterActiveClass, appearToClass = enterToClass, leaveFromClass = `${name}-leave-from`, leaveActiveClass = `${name}-leave-active`, leaveToClass = `${name}-leave-to` } = rawProps;
  const durations = normalizeDuration(duration);
  const enterDuration = durations && durations[0];
  const leaveDuration = durations && durations[1];
  const { onBeforeEnter, onEnter, onEnterCancelled, onLeave, onLeaveCancelled, onBeforeAppear = onBeforeEnter, onAppear = onEnter, onAppearCancelled = onEnterCancelled } = baseProps;
  const finishEnter = (el, isAppear, done) => {
    removeTransitionClass(el, isAppear ? appearToClass : enterToClass);
    removeTransitionClass(el, isAppear ? appearActiveClass : enterActiveClass);
    done && done();
  };
  const finishLeave = (el, done) => {
    removeTransitionClass(el, leaveToClass);
    removeTransitionClass(el, leaveActiveClass);
    done && done();
  };
  const makeEnterHook = (isAppear) => {
    return (el, done) => {
      const hook = isAppear ? onAppear : onEnter;
      const resolve2 = () => finishEnter(el, isAppear, done);
      callHook(hook, [el, resolve2]);
      nextFrame(() => {
        removeTransitionClass(el, isAppear ? appearFromClass : enterFromClass);
        addTransitionClass(el, isAppear ? appearToClass : enterToClass);
        if (!hasExplicitCallback(hook)) {
          whenTransitionEnds(el, type, enterDuration, resolve2);
        }
      });
    };
  };
  return extend(baseProps, {
    onBeforeEnter(el) {
      callHook(onBeforeEnter, [el]);
      addTransitionClass(el, enterFromClass);
      addTransitionClass(el, enterActiveClass);
    },
    onBeforeAppear(el) {
      callHook(onBeforeAppear, [el]);
      addTransitionClass(el, appearFromClass);
      addTransitionClass(el, appearActiveClass);
    },
    onEnter: makeEnterHook(false),
    onAppear: makeEnterHook(true),
    onLeave(el, done) {
      const resolve2 = () => finishLeave(el, done);
      addTransitionClass(el, leaveFromClass);
      forceReflow();
      addTransitionClass(el, leaveActiveClass);
      nextFrame(() => {
        removeTransitionClass(el, leaveFromClass);
        addTransitionClass(el, leaveToClass);
        if (!hasExplicitCallback(onLeave)) {
          whenTransitionEnds(el, type, leaveDuration, resolve2);
        }
      });
      callHook(onLeave, [el, resolve2]);
    },
    onEnterCancelled(el) {
      finishEnter(el, false);
      callHook(onEnterCancelled, [el]);
    },
    onAppearCancelled(el) {
      finishEnter(el, true);
      callHook(onAppearCancelled, [el]);
    },
    onLeaveCancelled(el) {
      finishLeave(el);
      callHook(onLeaveCancelled, [el]);
    }
  });
}
function normalizeDuration(duration) {
  if (duration == null) {
    return null;
  } else if (isObject(duration)) {
    return [NumberOf(duration.enter), NumberOf(duration.leave)];
  } else {
    const n2 = NumberOf(duration);
    return [n2, n2];
  }
}
function NumberOf(val) {
  const res = toNumber(val);
  return res;
}
function addTransitionClass(el, cls) {
  cls.split(/\s+/).forEach((c) => c && el.classList.add(c));
  (el._vtc || (el._vtc = /* @__PURE__ */ new Set())).add(cls);
}
function removeTransitionClass(el, cls) {
  cls.split(/\s+/).forEach((c) => c && el.classList.remove(c));
  const { _vtc } = el;
  if (_vtc) {
    _vtc.delete(cls);
    if (!_vtc.size) {
      el._vtc = void 0;
    }
  }
}
function nextFrame(cb) {
  requestAnimationFrame(() => {
    requestAnimationFrame(cb);
  });
}
let endId = 0;
function whenTransitionEnds(el, expectedType, explicitTimeout, resolve2) {
  const id = el._endId = ++endId;
  const resolveIfNotStale = () => {
    if (id === el._endId) {
      resolve2();
    }
  };
  if (explicitTimeout) {
    return setTimeout(resolveIfNotStale, explicitTimeout);
  }
  const { type, timeout, propCount } = getTransitionInfo(el, expectedType);
  if (!type) {
    return resolve2();
  }
  const endEvent = type + "end";
  let ended = 0;
  const end = () => {
    el.removeEventListener(endEvent, onEnd);
    resolveIfNotStale();
  };
  const onEnd = (e2) => {
    if (e2.target === el && ++ended >= propCount) {
      end();
    }
  };
  setTimeout(() => {
    if (ended < propCount) {
      end();
    }
  }, timeout + 1);
  el.addEventListener(endEvent, onEnd);
}
function getTransitionInfo(el, expectedType) {
  const styles = window.getComputedStyle(el);
  const getStyleProperties = (key) => (styles[key] || "").split(", ");
  const transitionDelays = getStyleProperties(TRANSITION + "Delay");
  const transitionDurations = getStyleProperties(TRANSITION + "Duration");
  const transitionTimeout = getTimeout(transitionDelays, transitionDurations);
  const animationDelays = getStyleProperties(ANIMATION + "Delay");
  const animationDurations = getStyleProperties(ANIMATION + "Duration");
  const animationTimeout = getTimeout(animationDelays, animationDurations);
  let type = null;
  let timeout = 0;
  let propCount = 0;
  if (expectedType === TRANSITION) {
    if (transitionTimeout > 0) {
      type = TRANSITION;
      timeout = transitionTimeout;
      propCount = transitionDurations.length;
    }
  } else if (expectedType === ANIMATION) {
    if (animationTimeout > 0) {
      type = ANIMATION;
      timeout = animationTimeout;
      propCount = animationDurations.length;
    }
  } else {
    timeout = Math.max(transitionTimeout, animationTimeout);
    type = timeout > 0 ? transitionTimeout > animationTimeout ? TRANSITION : ANIMATION : null;
    propCount = type ? type === TRANSITION ? transitionDurations.length : animationDurations.length : 0;
  }
  const hasTransform = type === TRANSITION && /\b(transform|all)(,|$)/.test(styles[TRANSITION + "Property"]);
  return {
    type,
    timeout,
    propCount,
    hasTransform
  };
}
function getTimeout(delays, durations) {
  while (delays.length < durations.length) {
    delays = delays.concat(delays);
  }
  return Math.max(...durations.map((d, i) => toMs(d) + toMs(delays[i])));
}
function toMs(s) {
  return Number(s.slice(0, -1).replace(",", ".")) * 1e3;
}
function forceReflow() {
  return document.body.offsetHeight;
}
const rendererOptions = /* @__PURE__ */ extend({ patchProp }, nodeOps);
let renderer;
function ensureRenderer() {
  return renderer || (renderer = createRenderer(rendererOptions));
}
const createApp = (...args) => {
  const app2 = ensureRenderer().createApp(...args);
  const { mount } = app2;
  app2.mount = (containerOrSelector) => {
    const container = normalizeContainer(containerOrSelector);
    if (!container)
      return;
    const component = app2._component;
    if (!isFunction(component) && !component.render && !component.template) {
      component.template = container.innerHTML;
    }
    container.innerHTML = "";
    const proxy = mount(container, false, container instanceof SVGElement);
    if (container instanceof Element) {
      container.removeAttribute("v-cloak");
      container.setAttribute("data-v-app", "");
    }
    return proxy;
  };
  return app2;
};
function normalizeContainer(container) {
  if (isString(container)) {
    const res = document.querySelector(container);
    return res;
  }
  return container;
}
var _600 = "";
var _400 = "";
var _700 = "";
var sourceSansPro = "";
function render$8(_ctx, _cache) {
  return openBlock(), createBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 20 20",
    fill: "currentColor",
    "aria-hidden": "true"
  }, [
    createVNode("path", { d: "M17.293 13.293A8 8 0 016.707 2.707a8.001 8.001 0 1010.586 10.586z" })
  ]);
}
function render$7(_ctx, _cache) {
  return openBlock(), createBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 20 20",
    fill: "currentColor",
    "aria-hidden": "true"
  }, [
    createVNode("path", {
      "fill-rule": "evenodd",
      d: "M10 2a1 1 0 011 1v1a1 1 0 11-2 0V3a1 1 0 011-1zm4 8a4 4 0 11-8 0 4 4 0 018 0zm-.464 4.95l.707.707a1 1 0 001.414-1.414l-.707-.707a1 1 0 00-1.414 1.414zm2.12-10.607a1 1 0 010 1.414l-.706.707a1 1 0 11-1.414-1.414l.707-.707a1 1 0 011.414 0zM17 11a1 1 0 100-2h-1a1 1 0 100 2h1zm-7 4a1 1 0 011 1v1a1 1 0 11-2 0v-1a1 1 0 011-1zM5.05 6.464A1 1 0 106.465 5.05l-.708-.707a1 1 0 00-1.414 1.414l.707.707zm1.414 8.486l-.707.707a1 1 0 01-1.414-1.414l.707-.707a1 1 0 011.414 1.414zM4 11a1 1 0 100-2H3a1 1 0 000 2h1z",
      "clip-rule": "evenodd"
    })
  ]);
}
function render$6(_ctx, _cache) {
  return openBlock(), createBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 20 20",
    fill: "currentColor",
    "aria-hidden": "true"
  }, [
    createVNode("path", {
      "fill-rule": "evenodd",
      d: "M10 18a8 8 0 100-16 8 8 0 000 16zM8.707 7.293a1 1 0 00-1.414 1.414L8.586 10l-1.293 1.293a1 1 0 101.414 1.414L10 11.414l1.293 1.293a1 1 0 001.414-1.414L11.414 10l1.293-1.293a1 1 0 00-1.414-1.414L10 8.586 8.707 7.293z",
      "clip-rule": "evenodd"
    })
  ]);
}
function render$5(_ctx, _cache) {
  return openBlock(), createBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 20 20",
    fill: "currentColor",
    "aria-hidden": "true"
  }, [
    createVNode("path", {
      "fill-rule": "evenodd",
      d: "M4.293 4.293a1 1 0 011.414 0L10 8.586l4.293-4.293a1 1 0 111.414 1.414L11.414 10l4.293 4.293a1 1 0 01-1.414 1.414L10 11.414l-4.293 4.293a1 1 0 01-1.414-1.414L8.586 10 4.293 5.707a1 1 0 010-1.414z",
      "clip-rule": "evenodd"
    })
  ]);
}
var _export_sfc = (sfc, props) => {
  const target = sfc.__vccOpts || sfc;
  for (const [key, val] of props) {
    target[key] = val;
  }
  return target;
};
const _sfc_main$s = {
  props: {
    moduleName: String,
    darkModeInjectionKey: { type: Symbol, required: false, default: null }
  },
  setup(props) {
    var _a;
    const darkMode = (_a = props.darkModeInjectionKey) != null ? _a : ref(true);
    function getTheme() {
      let prefersDark = window.matchMedia && window.matchMedia("(prefers-color-scheme: dark)").matches;
      let theme = localStorage.getItem("color-theme");
      if (theme === null)
        return prefersDark;
      if (theme === "dark")
        return true;
      return false;
    }
    darkMode.value = getTheme();
    if (darkMode.value) {
      document.documentElement.classList.add("dark");
    } else {
      document.documentElement.classList.remove("dark");
    }
    const home = () => {
      cockpit.location.go("/");
    };
    watch(() => darkMode.value, (darkMode2, oldDarkMode) => {
      localStorage.setItem("color-theme", darkMode2 ? "dark" : "light");
      if (darkMode2) {
        document.documentElement.classList.add("dark");
      } else {
        document.documentElement.classList.remove("dark");
      }
    }, { lazy: false });
    return {
      darkMode,
      home
    };
  },
  components: {
    SunIcon: render$7,
    MoonIcon: render$8
  }
};
const _hoisted_1$s = { class: "p-5 flex items-center bg-plugin-header font-redhat shadow-lg z-10" };
const _hoisted_2$8 = { class: "flex flex-row items-baseline basis-32 grow shrink-0" };
const _hoisted_3$8 = ["src"];
const _hoisted_4$8 = { class: "text-2xl" };
const _hoisted_5$8 = /* @__PURE__ */ createBaseVNode("span", { class: "text-gray-800 dark:text-red-600" }, "Drives", -1);
const _hoisted_6$8 = { class: "flex basis-32 justify-end grow shrink-0" };
function _sfc_render$s(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_SunIcon = resolveComponent("SunIcon");
  const _component_MoonIcon = resolveComponent("MoonIcon");
  return openBlock(), createElementBlock("div", _hoisted_1$s, [
    createBaseVNode("div", _hoisted_2$8, [
      createBaseVNode("img", {
        class: "w-6 h-6 mr-0.5 self-center",
        src: $setup.darkMode ? "./assets/images/45d-fan-dark.svg" : "./assets/images/45d-fan-light.svg"
      }, null, 8, _hoisted_3$8),
      createBaseVNode("h1", _hoisted_4$8, [
        createBaseVNode("span", {
          class: "text-red-800 dark:text-white font-bold font-source-sans-pro",
          style: normalizeStyle({ "font-size": "1.6rem" })
        }, "45", 4),
        _hoisted_5$8
      ])
    ]),
    createBaseVNode("h1", {
      class: "text-red-800 dark:text-white text-2xl cursor-pointer grow-0 text-center",
      onClick: _cache[0] || (_cache[0] = (...args) => $setup.home && $setup.home(...args))
    }, toDisplayString($props.moduleName), 1),
    createBaseVNode("div", _hoisted_6$8, [
      createBaseVNode("button", {
        onClick: _cache[1] || (_cache[1] = ($event) => $setup.darkMode = !$setup.darkMode),
        id: "theme-toggle",
        type: "button",
        class: "text-muted focus:outline-none"
      }, [
        $setup.darkMode ? (openBlock(), createBlock(_component_SunIcon, {
          key: 0,
          class: "size-icon-lg"
        })) : (openBlock(), createBlock(_component_MoonIcon, {
          key: 1,
          class: "size-icon-lg"
        }))
      ])
    ])
  ]);
}
var FfdHeader = /* @__PURE__ */ _export_sfc(_sfc_main$s, [["render", _sfc_render$s]]);
function render$4(_ctx, _cache) {
  return openBlock(), createBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    fill: "none",
    viewBox: "0 0 24 24",
    "stroke-width": "2",
    stroke: "currentColor",
    "aria-hidden": "true"
  }, [
    createVNode("path", {
      "stroke-linecap": "round",
      "stroke-linejoin": "round",
      d: "M9 12l2 2 4-4m6 2a9 9 0 11-18 0 9 9 0 0118 0z"
    })
  ]);
}
function render$3(_ctx, _cache) {
  return openBlock(), createBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    fill: "none",
    viewBox: "0 0 24 24",
    "stroke-width": "2",
    stroke: "currentColor",
    "aria-hidden": "true"
  }, [
    createVNode("path", {
      "stroke-linecap": "round",
      "stroke-linejoin": "round",
      d: "M12 8v4m0 4h.01M21 12a9 9 0 11-18 0 9 9 0 0118 0z"
    })
  ]);
}
function render$2(_ctx, _cache) {
  return openBlock(), createBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    fill: "none",
    viewBox: "0 0 24 24",
    "stroke-width": "2",
    stroke: "currentColor",
    "aria-hidden": "true"
  }, [
    createVNode("path", {
      "stroke-linecap": "round",
      "stroke-linejoin": "round",
      d: "M13 16h-1v-4h-1m1-4h.01M21 12a9 9 0 11-18 0 9 9 0 0118 0z"
    })
  ]);
}
function render$1(_ctx, _cache) {
  return openBlock(), createBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    fill: "none",
    viewBox: "0 0 24 24",
    "stroke-width": "2",
    stroke: "currentColor",
    "aria-hidden": "true"
  }, [
    createVNode("path", {
      "stroke-linecap": "round",
      "stroke-linejoin": "round",
      d: "M15 12H9m12 0a9 9 0 11-18 0 9 9 0 0118 0z"
    })
  ]);
}
function render(_ctx, _cache) {
  return openBlock(), createBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    fill: "none",
    viewBox: "0 0 24 24",
    "stroke-width": "2",
    stroke: "currentColor",
    "aria-hidden": "true"
  }, [
    createVNode("path", {
      "stroke-linecap": "round",
      "stroke-linejoin": "round",
      d: "M4 4v5h.582m15.356 2A8.001 8.001 0 004.582 9m0 0H9m11 11v-5h-.581m0 0a8.003 8.003 0 01-15.357-2m15.357 2H15"
    })
  ]);
}
const _sfc_main$r = {
  components: {
    XCircleIcon: render$6
  },
  props: {
    errorMsg: Array,
    FixButton: Boolean,
    FixButtonHandler: Function
  },
  setup(props) {
    const errorMsg = ref(props.errorMsg);
    const FixButtonHandler = ref(props.FixButtonHandler);
    watch(() => props.FixButtonHandler, (fn) => {
      FixButtonHandler.value = fn;
    });
    return {
      errorMsg,
      FixButtonHandler
    };
  }
};
const _hoisted_1$r = { class: "flex items-center justify-evenly" };
const _hoisted_2$7 = { class: "rounded-md bg-red-50 p-4" };
const _hoisted_3$7 = { class: "flex" };
const _hoisted_4$7 = { class: "flex-shrink-0" };
const _hoisted_5$7 = { class: "ml-3" };
const _hoisted_6$7 = /* @__PURE__ */ createBaseVNode("h3", { class: "text-sm font-medium text-red-800" }, " 45Drives Disks Encountered an Error ", -1);
const _hoisted_7$7 = { class: "mt-2 text-sm text-red-700" };
const _hoisted_8$7 = {
  role: "list",
  class: "list-disc pl-5 space-y-1 whitespace-pre"
};
function _sfc_render$r(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_XCircleIcon = resolveComponent("XCircleIcon");
  return openBlock(), createElementBlock("div", _hoisted_1$r, [
    createBaseVNode("div", _hoisted_2$7, [
      createBaseVNode("div", _hoisted_3$7, [
        createBaseVNode("div", _hoisted_4$7, [
          createVNode(_component_XCircleIcon, {
            class: "h-5 w-5 text-red-400",
            "aria-hidden": "true"
          })
        ]),
        createBaseVNode("div", _hoisted_5$7, [
          _hoisted_6$7,
          createBaseVNode("div", _hoisted_7$7, [
            createBaseVNode("ul", _hoisted_8$7, [
              (openBlock(true), createElementBlock(Fragment, null, renderList($setup.errorMsg, (entry) => {
                return openBlock(), createElementBlock("li", null, toDisplayString(entry), 1);
              }), 256))
            ])
          ])
        ])
      ])
    ]),
    $props.FixButton ? (openBlock(), createElementBlock("button", {
      key: 0,
      onClick: _cache[0] || (_cache[0] = (...args) => $setup.FixButtonHandler && $setup.FixButtonHandler(...args)),
      type: "button",
      class: "inline-flex items-center px-2.5 py-1.5 border border-gray-300 shadow-sm text-xs font-medium rounded text-gray-700 bg-white hover:bg-gray-50 focus:outline-none"
    }, " Fix ")) : createCommentVNode("", true)
  ]);
}
var ErrorMessage = /* @__PURE__ */ _export_sfc(_sfc_main$r, [["render", _sfc_render$r]]);
function useSpawn(argv = [], opts = {}, stderr = "message") {
  const state = reactive({
    loading: true,
    status: 0,
    stdout: "",
    stderr: "",
    argv: [],
    proc: null,
    promise: () => {
      return new Promise((resolve2, reject) => {
        watch(state, () => {
          if (!state.loading) {
            if (state.status === 0)
              resolve2(__spreadValues({}, state));
            else
              reject(__spreadValues({}, state));
          }
        }, { lazy: false, immediate: true });
      });
    },
    argvPretty: () => {
      return argv.map((token) => /\s/.match(token) ? `"${token}"` : token).join(" ");
    },
    errorStringHTML(fullArgv = false) {
      return `<span class="font-mono text-sm whitespace-pre-wrap"><span class="font-semibold">${this.argv[0]}: </span><span>${errorString(this)} </span>` + (fullArgv ? `<span class="text-gray-500 font-mono text-sm">${this.argvPretty()}</span>` : "") + "</span>";
    }
  });
  if (!opts.superuser)
    opts.superuser = "require";
  if (!opts.err)
    opts.err = stderr;
  state.loading = true;
  state.status = 0;
  state.stdout = "";
  state.stderr = "";
  state.argv = [...argv];
  state.proc = cockpit.spawn(argv, opts);
  state.proc.then((_stdout, _stderr) => {
    state.stdout = _stdout;
    state.stderr = _stderr;
  }).catch((ex, _stdout) => {
    var _a;
    state.stdout = _stdout;
    state.stderr = (_a = ex.message) != null ? _a : ex.problem;
    state.status = ex.exit_status;
  }).finally(() => {
    state.loading = false;
  });
  return state;
}
function errorString(state) {
  var _a, _b;
  if (typeof state === "string")
    return state;
  return (_b = (_a = state == null ? void 0 : state.stderr) != null ? _a : state == null ? void 0 : state.message) != null ? _b : JSON.stringify(state);
}
function errorStringHTML(state) {
  var _a, _b, _c, _d;
  if (typeof state === "string")
    return `<span class="text-gray-500 font-mono text-sm whitespace-pre-wrap">${state}</span>`;
  return (_d = (_a = state.errorStringHTML) == null ? void 0 : _a.call(state)) != null ? _d : `<span class="text-gray-500 font-mono text-sm whitespace-pre-wrap">${(_c = (_b = state == null ? void 0 : state.stderr) != null ? _b : state == null ? void 0 : state.message) != null ? _c : JSON.stringify(state)}</span>`;
}
class FIFO {
  constructor() {
    this.arr = [];
    this.len = 0;
  }
  push(obj) {
    this.len++;
    this.arr.push(obj);
  }
  pop() {
    var _a;
    const obj = (_a = this.arr.shift()) != null ? _a : null;
    if (obj)
      this.len--;
    return obj;
  }
  getLen() {
    return this.len;
  }
}
class UniqueIDGenerator {
  constructor(maxIds = Number.MAX_SAFE_INTEGER) {
    this.id = 0;
    this.maxIds = maxIds;
    this.reuptake = [];
  }
  get() {
    if (this.id == this.maxIds && this.reuptake.length === 0)
      throw new Error("Unique ID limit reached");
    return this.reuptake.length ? this.reuptake.shift() : this.id++;
  }
  release(id) {
    if (this.reuptake.includes(id))
      throw new Error("Double release of unique ID");
    if (id >= this.id)
      throw new Error("Released ID was never given");
    this.reuptake.push(id);
  }
}
const _sfc_main$q = {
  setup() {
    const serverInfo = ref();
    const serverInfoError = reactive({
      errorFlag: false,
      errorMessage: [],
      showFixButton: false,
      fixButtonHandler: () => {
        console.log("Default handler was run for the fix button.");
      }
    });
    const lsdevInfo = ref();
    const lsdevError = reactive({
      errorFlag: false,
      errorMessage: [],
      showFixButton: false,
      fixButtonHandler: () => {
        console.log("Default handler was run for the fix button.");
      }
    });
    console.log(serverInfoError);
    console.log(lsdevError);
    const runServerInfo = async () => {
      try {
        const state = await useSpawn(["/usr/share/cockpit/45drives-disks/scripts/server_info"], {
          err: "out",
          superuser: "require"
        }).promise();
        let result = JSON.parse(state.stdout);
        console.log(result);
        serverInfo.value = state.stdout;
        serverInfoError.errorFlag = false;
        serverInfoError.errorMessage.length = 0;
        serverInfoError.showFixButton = false;
      } catch (error) {
        console.log(error);
        serverInfoError.errorFlag = true;
        serverInfoError.errorMessage.length = 0;
        serverInfoError.errorMessage.push(error.stderr);
        serverInfoError.errorMessage.push("An error occurred when trying to run /usr/share/cockpit/45drives-disks/scripts/server_info");
        serverInfoError.showFixButton = false;
      }
    };
    const runLsdev = async () => {
      try {
        const state = await useSpawn(["/opt/45drives/tools/lsdev", "--json"], {
          err: "out",
          superuser: "require"
        }).promise();
        let result = JSON.parse(state.stdout);
        console.log(result);
        lsdevInfo.value = state.stdout;
        lsdevError.errorFlag = false;
        lsdevError.errorMessage.length = 0;
        lsdevError.showFixButton = false;
      } catch (error) {
        console.log(error);
        lsdevError.errorFlag = true;
        lsdevError.errorMessage.length = 0;
        lsdevError.errorMessage.push(error.stderr);
        lsdevError.errorMessage.push("An error occurred when trying to run /opt/45drives/tools/lsdev");
        lsdevError.showFixButton = false;
      }
    };
    return {
      runServerInfo,
      runLsdev,
      serverInfo,
      serverInfoError,
      lsdevInfo,
      lsdevError
    };
  },
  components: {
    RefreshIconOutline: render,
    ErrorMessage
  }
};
const _hoisted_1$q = { class: "card m-3 grow" };
const _hoisted_2$6 = /* @__PURE__ */ createBaseVNode("div", { class: "card-header p-5 border-b border-stone-200 dark:border-stone-500 dark:bg-stone-700 sm:flex sm:items-center sm:justify-between" }, [
  /* @__PURE__ */ createBaseVNode("h3", { class: "text-lg leading-6 font-semibold" }, "Debug Section")
], -1);
const _hoisted_3$6 = { class: "card-body dark:bg-stone-700" };
const _hoisted_4$6 = { class: "mt-3 sm:mt-0 sm:ml-4" };
const _hoisted_5$6 = { key: 0 };
const _hoisted_6$6 = { class: "w-3/4 m-2" };
const _hoisted_7$6 = { class: "whitespace-pre" };
const _hoisted_8$6 = { key: 1 };
const _hoisted_9$5 = { class: "mt-3 sm:mt-0 sm:ml-4" };
const _hoisted_10$5 = {
  key: 2,
  class: "mt-2 flex"
};
const _hoisted_11$5 = { class: "w-3/4 m-2" };
const _hoisted_12$5 = { class: "whitespace-pre" };
const _hoisted_13$5 = { key: 3 };
function _sfc_render$q(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_ErrorMessage = resolveComponent("ErrorMessage");
  return openBlock(), createElementBlock("div", _hoisted_1$q, [
    _hoisted_2$6,
    createBaseVNode("div", _hoisted_3$6, [
      createBaseVNode("div", _hoisted_4$6, [
        createBaseVNode("button", {
          type: "button",
          onClick: _cache[0] || (_cache[0] = ($event) => $setup.runServerInfo()),
          class: "inline-flex items-center px-3 py-2 border border-transparent text-sm leading-4 font-medium rounded-md shadow-sm text-white bg-indigo-600 hover:bg-indigo-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500"
        }, ' run "server_info" ')
      ]),
      !$setup.serverInfoError.errorFlag ? (openBlock(), createElementBlock("div", _hoisted_5$6, [
        createBaseVNode("div", _hoisted_6$6, [
          createBaseVNode("div", _hoisted_7$6, toDisplayString($setup.serverInfo), 1)
        ])
      ])) : createCommentVNode("", true),
      $setup.serverInfoError.errorFlag ? (openBlock(), createElementBlock("div", _hoisted_8$6, [
        createVNode(_component_ErrorMessage, {
          errorMsg: $setup.serverInfoError.errorMessage,
          FixButton: $setup.serverInfoError.showFixButton,
          FixButtonHandler: $setup.serverInfoError.fixButtonHandler
        }, null, 8, ["errorMsg", "FixButton", "FixButtonHandler"])
      ])) : createCommentVNode("", true),
      createBaseVNode("div", _hoisted_9$5, [
        createBaseVNode("button", {
          type: "button",
          onClick: _cache[1] || (_cache[1] = ($event) => $setup.runLsdev()),
          class: "inline-flex items-center px-3 py-2 border border-transparent text-sm leading-4 font-medium rounded-md shadow-sm text-white bg-indigo-600 hover:bg-indigo-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500"
        }, ' run "lsdev" ')
      ]),
      !$setup.lsdevError.errorFlag ? (openBlock(), createElementBlock("div", _hoisted_10$5, [
        createBaseVNode("div", _hoisted_11$5, [
          createBaseVNode("div", _hoisted_12$5, toDisplayString($setup.lsdevInfo), 1)
        ])
      ])) : createCommentVNode("", true),
      $setup.lsdevError.errorFlag ? (openBlock(), createElementBlock("div", _hoisted_13$5, [
        createVNode(_component_ErrorMessage, {
          errorMsg: $setup.lsdevError.errorMessage,
          FixButton: $setup.lsdevError.showFixButton,
          FixButtonHandler: $setup.lsdevError.fixButtonHandler
        }, null, 8, ["errorMsg", "FixButton", "FixButtonHandler"])
      ])) : createCommentVNode("", true)
    ])
  ]);
}
var DebugBox = /* @__PURE__ */ _export_sfc(_sfc_main$q, [["render", _sfc_render$q]]);
const _sfc_main$p = {
  props: {
    notificationFIFO: FIFO
  },
  setup(props) {
    const notificationList = ref([]);
    const uniqueIDGenerator = new UniqueIDGenerator();
    const constructNotification = (title, body, level = "info", timeout = 1e4) => {
      const actions = [];
      const obj = reactive({
        show: true,
        title,
        body,
        level,
        timeout,
        actions
      });
      showNotificationObj(obj);
      obj.addAction = (text, callback) => {
        obj.actions.push({
          text,
          callback: () => {
            obj.show = false;
            callback();
          }
        });
        return obj;
      };
      return obj;
    };
    const showNotificationObj = (notificationObj) => {
      notificationObj.show = true;
      notificationObj.id = uniqueIDGenerator.get();
      notificationObj.setTimeouts = () => {
        if (notificationObj.timeout > 0) {
          notificationObj.timeout1 = setTimeout(() => notificationObj.show = false, notificationObj.timeout);
          notificationObj.timeout2 = setTimeout(() => {
            notificationList.value = notificationList.value.filter((obj) => obj !== notificationObj);
            uniqueIDGenerator.release(notificationObj.id);
          }, notificationObj.timeout + 2e3);
        }
      };
      notificationObj.clearTimeouts = () => {
        if (notificationObj.timeout1 !== void 0)
          clearTimeout(notificationObj.timeout1);
        if (notificationObj.timeout2 !== void 0)
          clearTimeout(notificationObj.timeout2);
      };
      notificationList.value = [notificationObj, ...notificationList.value];
      if (notificationObj.level === "error") {
        console.error(notificationObj.title);
        console.error(notificationObj.body);
      }
      notificationObj.setTimeouts();
    };
    watch(() => props.notificationFIFO.getLen(), (newLen, oldLen) => {
      if (newLen > oldLen) {
        try {
          const notification = props.notificationFIFO.pop();
          if (notification)
            showNotificationObj(notification);
        } catch (error) {
          console.error(error);
          constructNotification("System Error", "An error occured, check the system console (CTRL+SHIFT+J) for more information.", "error");
        }
      }
    });
    let cleanupHandle = setInterval(() => {
      notificationList.value = notificationList.value.filter((n2) => n2.show);
    }, 1e3);
    onUnmounted(() => clearInterval(cleanupHandle));
    return {
      notificationList,
      constructNotification,
      showNotificationObj
    };
  },
  components: {
    InformationCircleIcon: render$2,
    ExclamationCircleIcon: render$3,
    MinusCircleIcon: render$1,
    CheckCircleIcon: render$4,
    XIcon: render$5
  }
};
const _hoisted_1$p = {
  "aria-live": "assertive",
  class: "fixed inset-0 flex items-end px-4 py-6 pointer-events-none sm:p-6 sm:items-start z-20 h-screen overflow-y-auto"
};
const _hoisted_2$5 = { class: "w-full flex flex-col items-center sm:items-end space-y-content" };
const _hoisted_3$5 = ["onMouseenter", "onMouseleave"];
const _hoisted_4$5 = { class: "p-4" };
const _hoisted_5$5 = { class: "flex items-start" };
const _hoisted_6$5 = {
  class: "flex-shrink-0",
  "aria-hidden": "true"
};
const _hoisted_7$5 = { class: "ml-3 w-0 flex-1 pt-0.5" };
const _hoisted_8$5 = { class: "text-sm font-medium" };
const _hoisted_9$4 = ["innerHTML"];
const _hoisted_10$4 = {
  key: 0,
  class: "mt-3 flex space-x-7"
};
const _hoisted_11$4 = ["onClick"];
const _hoisted_12$4 = ["onClick"];
const _hoisted_13$4 = { class: "ml-4 flex-shrink-0 flex" };
const _hoisted_14$4 = ["onClick"];
const _hoisted_15$3 = /* @__PURE__ */ createBaseVNode("span", { class: "sr-only" }, "Close", -1);
function _sfc_render$p(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_ExclamationCircleIcon = resolveComponent("ExclamationCircleIcon");
  const _component_CheckCircleIcon = resolveComponent("CheckCircleIcon");
  const _component_MinusCircleIcon = resolveComponent("MinusCircleIcon");
  const _component_InformationCircleIcon = resolveComponent("InformationCircleIcon");
  const _component_XIcon = resolveComponent("XIcon");
  return openBlock(), createElementBlock("div", _hoisted_1$p, [
    createBaseVNode("div", _hoisted_2$5, [
      (openBlock(true), createElementBlock(Fragment, null, renderList($setup.notificationList, (notification) => {
        return openBlock(), createBlock(Transition, {
          key: notification.id,
          "enter-active-class": "transform ease-out duration-300 transition",
          "enter-from-class": "translate-y-2 opacity-0 sm:translate-y-0 sm:translate-x-2",
          "enter-to-class": "translate-y-0 opacity-100 sm:translate-x-0",
          "leave-active-class": "transition ease-in duration-100",
          "leave-from-class": "opacity-100",
          "leave-to-class": "opacity-0",
          class: "transition-transform"
        }, {
          default: withCtx(() => {
            var _a;
            return [
              notification.show ? (openBlock(), createElementBlock("div", {
                key: 0,
                class: "max-w-sm w-full shadow-lg pointer-events-auto overflow-hidden bg-default text-default",
                onMouseenter: ($event) => {
                  var _a2;
                  return (_a2 = notification.clearTimeouts) == null ? void 0 : _a2.call(notification);
                },
                onMouseleave: ($event) => {
                  var _a2;
                  return (_a2 = notification.setTimeouts) == null ? void 0 : _a2.call(notification);
                }
              }, [
                createBaseVNode("div", _hoisted_4$5, [
                  createBaseVNode("div", _hoisted_5$5, [
                    createBaseVNode("div", _hoisted_6$5, [
                      notification.level === "error" ? (openBlock(), createBlock(_component_ExclamationCircleIcon, {
                        key: 0,
                        class: "icon-error size-icon-lg",
                        "aria-hidden": "true"
                      })) : notification.level === "warning" ? (openBlock(), createBlock(_component_ExclamationCircleIcon, {
                        key: 1,
                        class: "icon-warning size-icon-lg",
                        "aria-hidden": "true"
                      })) : notification.level === "success" ? (openBlock(), createBlock(_component_CheckCircleIcon, {
                        key: 2,
                        class: "icon-success size-icon-lg",
                        "aria-hidden": "true"
                      })) : notification.level === "denied" ? (openBlock(), createBlock(_component_MinusCircleIcon, {
                        key: 3,
                        class: "icon-error size-icon-lg",
                        "aria-hidden": "true"
                      })) : (openBlock(), createBlock(_component_InformationCircleIcon, {
                        key: 4,
                        class: "icon-info size-icon-lg"
                      }))
                    ]),
                    createBaseVNode("div", _hoisted_7$5, [
                      createBaseVNode("p", _hoisted_8$5, toDisplayString(notification.title), 1),
                      createBaseVNode("p", {
                        class: "mt-1 text-sm text-muted whitespace-pre-wrap",
                        innerHTML: notification.body
                      }, null, 8, _hoisted_9$4),
                      ((_a = notification.actions) == null ? void 0 : _a.length) ? (openBlock(), createElementBlock("div", _hoisted_10$4, [
                        (openBlock(true), createElementBlock(Fragment, null, renderList(notification.actions, (action) => {
                          return openBlock(), createElementBlock("button", {
                            onClick: action.callback,
                            class: "rounded-md text-sm font-medium text-primary focus:outline-none focus:ring-0 focus:ring-offset-0"
                          }, toDisplayString(action.text), 9, _hoisted_11$4);
                        }), 256)),
                        createBaseVNode("button", {
                          onClick: ($event) => notification.show = false,
                          type: "button",
                          class: "rounded-md text-sm font-medium text-secondary focus:outline-none focus:ring-0 focus:ring-offset-0"
                        }, "Dismiss", 8, _hoisted_12$4)
                      ])) : createCommentVNode("", true)
                    ]),
                    createBaseVNode("div", _hoisted_13$4, [
                      createBaseVNode("button", {
                        onClick: ($event) => notification.show = false,
                        class: "icon-default focus:outline-none focus:ring-0 focus:ring-offset-0"
                      }, [
                        _hoisted_15$3,
                        createVNode(_component_XIcon, {
                          class: "size-icon",
                          "aria-hidden": "true"
                        })
                      ], 8, _hoisted_14$4)
                    ])
                  ])
                ])
              ], 40, _hoisted_3$5)) : createCommentVNode("", true)
            ];
          }),
          _: 2
        }, 1024);
      }), 128))
    ])
  ]);
}
var Notifications = /* @__PURE__ */ _export_sfc(_sfc_main$p, [["render", _sfc_render$p]]);
const _sfc_main$o = {
  props: {
    serverInfo: Object
  },
  components: {
    Notifications
  },
  setup(props) {
    const lsdevJson = inject("lsdevJson");
    const diskInfo = inject("diskInfo");
    const notifications = inject("Notifications");
    const diskCount = ref(0);
    if (props.serverInfo.HBA) {
      const has_hwraid = props.serverInfo.HBA.filter((card) => ["9361-16i", "9361-24i"].includes(card.Model)).length != 0;
      if (has_hwraid) {
        notifications.value.constructNotification("Warning:", errorStringHTML("Hardware RAID card(s) detected. \nDevice Mapping is subject to change on subsequent reboots. Run 'dmap' and refresh page to ensure reliable device mapping."), "warning", 0);
      }
    }
    const getCapacityGB = (capacityStr) => {
      let coeffLut = {
        TB: 1e3,
        GB: 1
      };
      if (!capacityStr)
        return 0;
      return Number(capacityStr.split(" ")[0]) * coeffLut[capacityStr.split(" ")[1]];
    };
    const storageCapacity = ref(0);
    const storageCapacityStr = ref("Loading ...");
    const avgTemp = ref(0);
    const avgTempStr = ref("Loading...");
    const updateDiskSummary = () => {
      if (lsdevJson.rows) {
        diskCount.value = lsdevJson.rows.flat().filter((slot) => slot.occupied).length;
        storageCapacity.value = diskCount.value > 0 ? lsdevJson.rows.flat().filter((slot) => slot.occupied).map((disk) => getCapacityGB(disk.capacity)).reduce((total, cap) => total + cap).toFixed(2) : 0;
        storageCapacityStr.value = storageCapacity.value > 1e3 ? (storageCapacity.value / 1e3).toFixed(2).toString() + " TB" : storageCapacity.value.toString() + " GB";
        avgTemp.value = diskCount.value > 0 ? (lsdevJson.rows.flat().filter((slot) => slot.occupied).map((disk) => {
          var _a, _b;
          return Number((_b = (_a = disk["temp-c"]) == null ? void 0 : _a.replace(/[^0-9]/g, "")) != null ? _b : 0);
        }).reduce((total, cap) => total + cap) / Number(diskCount.value)).toFixed(2) : 0;
        if (avgTemp.value === 0) {
          avgTempStr.value = "No Disks Present";
        }
      }
    };
    watch(lsdevJson, updateDiskSummary);
    return {
      diskCount,
      storageCapacity,
      storageCapacityStr,
      avgTemp,
      lsdevJson,
      diskInfo,
      avgTempStr,
      notifications
    };
  }
};
const _hoisted_1$o = { class: "card grow flex flex-col" };
const _hoisted_2$4 = /* @__PURE__ */ createBaseVNode("div", { class: "card-header" }, [
  /* @__PURE__ */ createBaseVNode("h3", { class: "text-header text-default" }, "Server")
], -1);
const _hoisted_3$4 = { class: "card-body grow flex" };
const _hoisted_4$4 = { class: "grow flex flex-col items-stretch" };
const _hoisted_5$4 = { class: "mt-0" };
const _hoisted_6$4 = { class: "sm:divide-y divide-default divide-y" };
const _hoisted_7$4 = { class: "py-2 sm:py-2 sm:grid sm:grid-cols-5 sm:gap-4 grid grid-cols-2" };
const _hoisted_8$4 = /* @__PURE__ */ createBaseVNode("dt", { class: "text-sm font-medium text-muted" }, " Model ", -1);
const _hoisted_9$3 = { class: "mt-1 text-sm sm:mt-0 sm:col-span-4 col-span-2" };
const _hoisted_10$3 = { class: "py-2 sm:py-2 sm:grid sm:grid-cols-5 sm:gap-4 grid grid-cols-2" };
const _hoisted_11$3 = /* @__PURE__ */ createBaseVNode("dt", { class: "text-sm font-medium text-muted" }, " Disk Count ", -1);
const _hoisted_12$3 = { class: "mt-1 text-sm sm:mt-0 sm:col-span-4 col-span-2" };
const _hoisted_13$3 = { class: "py-2 sm:py-2 sm:grid sm:grid-cols-5 sm:gap-4 grid grid-cols-2" };
const _hoisted_14$3 = /* @__PURE__ */ createBaseVNode("dt", { class: "text-sm font-medium text-muted" }, " Total Storage ", -1);
const _hoisted_15$2 = { class: "mt-1 text-sm sm:mt-0 sm:col-span-4 col-span-2" };
const _hoisted_16$2 = { class: "py-2 sm:py-2 sm:grid sm:grid-cols-5 sm:gap-4 grid grid-cols-2" };
const _hoisted_17$2 = /* @__PURE__ */ createBaseVNode("dt", { class: "text-sm font-medium text-muted" }, " Disk Temperature (avg) ", -1);
const _hoisted_18$2 = {
  key: 0,
  class: "mt-1 text-sm sm:mt-0 sm:col-span-4 col-span-2"
};
const _hoisted_19$2 = {
  key: 1,
  class: "mt-1 text-sm sm:mt-0 sm:col-span-4 col-span-2"
};
const _hoisted_20$2 = { class: "py-2 sm:py-2 sm:grid sm:grid-cols-5 sm:gap-4 grid grid-cols-2 col-span-2" };
const _hoisted_21$2 = { class: "text-sm font-medium text-muted col-span-2 sm:col-span-5" };
const _hoisted_22$2 = { class: "col-span-1 sm:col-span-1" };
const _hoisted_23$2 = /* @__PURE__ */ createBaseVNode("dt", { class: "text-sm font-medium text-muted" }, " Model ", -1);
const _hoisted_24$2 = { class: "mt-1 text-sm sm:mt-0 sm:col-span-1 col-span-1" };
const _hoisted_25$2 = { class: "col-span-1 sm:col-span-1" };
const _hoisted_26$2 = /* @__PURE__ */ createBaseVNode("dt", { class: "text-sm font-medium text-muted" }, " Controller ID ", -1);
const _hoisted_27$2 = { class: "mt-1 text-sm sm:mt-0 sm:col-span-1" };
const _hoisted_28$2 = { class: "col-span-1 sm:col-span-1" };
const _hoisted_29$2 = /* @__PURE__ */ createBaseVNode("dt", { class: "text-sm font-medium text-muted" }, " PCI Slot ", -1);
const _hoisted_30$2 = { class: "mt-1 text-sm sm:mt-0 sm:col-span-1" };
const _hoisted_31$2 = { class: "col-span-1 sm:col-span-1" };
const _hoisted_32$2 = /* @__PURE__ */ createBaseVNode("dt", { class: "text-sm font-medium text-muted" }, " Bus Address ", -1);
const _hoisted_33$2 = { class: "mt-1 text-sm sm:mt-0 sm:col-span-1" };
const _hoisted_34$2 = { class: "col-span-1 sm:col-span-1" };
const _hoisted_35$2 = /* @__PURE__ */ createBaseVNode("dt", { class: "text-sm font-medium text-muted" }, " Firmware Version ", -1);
const _hoisted_36$2 = { class: "mt-1 text-sm sm:mt-0 sm:col-span-1" };
function _sfc_render$o(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1$o, [
    _hoisted_2$4,
    createBaseVNode("div", _hoisted_3$4, [
      createBaseVNode("div", _hoisted_4$4, [
        createBaseVNode("div", _hoisted_5$4, [
          createBaseVNode("dl", _hoisted_6$4, [
            createBaseVNode("div", _hoisted_7$4, [
              _hoisted_8$4,
              createBaseVNode("dd", _hoisted_9$3, toDisplayString($props.serverInfo.Model), 1)
            ]),
            createBaseVNode("div", _hoisted_10$3, [
              _hoisted_11$3,
              createBaseVNode("dd", _hoisted_12$3, toDisplayString($setup.diskCount), 1)
            ]),
            createBaseVNode("div", _hoisted_13$3, [
              _hoisted_14$3,
              createBaseVNode("dd", _hoisted_15$2, toDisplayString($setup.storageCapacityStr), 1)
            ]),
            createBaseVNode("div", _hoisted_16$2, [
              _hoisted_17$2,
              $setup.avgTemp != 0 ? (openBlock(), createElementBlock("dd", _hoisted_18$2, toDisplayString($setup.avgTemp) + " \xB0C / " + toDisplayString(($setup.avgTemp * (9 / 5) + 32).toFixed(2)) + " \xB0F ", 1)) : (openBlock(), createElementBlock("dd", _hoisted_19$2, toDisplayString($setup.avgTempStr), 1))
            ]),
            (openBlock(true), createElementBlock(Fragment, null, renderList($props.serverInfo.HBA, (card) => {
              return openBlock(), createElementBlock("div", _hoisted_20$2, [
                createBaseVNode("dt", _hoisted_21$2, " HBA" + toDisplayString(card.Ctl + 1), 1),
                createBaseVNode("div", _hoisted_22$2, [
                  _hoisted_23$2,
                  createBaseVNode("dd", _hoisted_24$2, toDisplayString(card.Model), 1)
                ]),
                createBaseVNode("div", _hoisted_25$2, [
                  _hoisted_26$2,
                  createBaseVNode("dd", _hoisted_27$2, toDisplayString(card.Ctl), 1)
                ]),
                createBaseVNode("div", _hoisted_28$2, [
                  _hoisted_29$2,
                  createBaseVNode("dd", _hoisted_30$2, toDisplayString(card["PCI Slot"]), 1)
                ]),
                createBaseVNode("div", _hoisted_31$2, [
                  _hoisted_32$2,
                  createBaseVNode("dd", _hoisted_33$2, toDisplayString(card["Bus Address"]), 1)
                ]),
                createBaseVNode("div", _hoisted_34$2, [
                  _hoisted_35$2,
                  createBaseVNode("dd", _hoisted_36$2, toDisplayString(card["Firmware Version"] || "-"), 1)
                ])
              ]);
            }), 256))
          ])
        ])
      ])
    ])
  ]);
}
var ServerSection = /* @__PURE__ */ _export_sfc(_sfc_main$o, [["render", _sfc_render$o]]);
var LoadingSpinner_vue_vue_type_style_index_0_lang = "";
const _sfc_main$n = {};
const _hoisted_1$n = { class: "loading-spinner border-neutral-200 border-t-neutral-500 dark:border-neutral-500 dark:border-t-neutral-200 rounded-full w-5 h-5" };
function _sfc_render$n(_ctx, _cache) {
  return openBlock(), createElementBlock("div", _hoisted_1$n);
}
var LoadingSpinner = /* @__PURE__ */ _export_sfc(_sfc_main$n, [["render", _sfc_render$n]]);
const _sfc_main$m = {
  components: {
    RefreshIconOutline: render,
    LoadingSpinner
  },
  props: {
    diskInfo: Object
  },
  setup(props) {
    const currentDisk = inject("currentDisk");
    const wMsg = ref("Click on a disk for more detail.");
    const diskObj = reactive({});
    const lsdevJson = inject("lsdevJson");
    const diskInfo = inject("diskInfo");
    const loadingSpinner = ref(true);
    const updateDiskObj = () => {
      if (!currentDisk.value)
        return;
      const tmpObj = lsdevJson.rows ? lsdevJson.rows.flat().find((slot) => slot["bay-id"] === currentDisk.value) : diskInfo.rows.flat().find((slot) => slot["bay-id"] === currentDisk.value);
      if (!tmpObj) {
        console.log(`Unable to find info for disk in slot "${currentDisk.value}"`);
        return;
      }
      loadingSpinner.value = lsdevJson.rows ? false : true;
      Object.assign(diskObj, tmpObj);
    };
    watch(currentDisk, updateDiskObj);
    watch(lsdevJson, updateDiskObj);
    return {
      wMsg,
      currentDisk,
      diskObj,
      lsdevJson,
      diskInfo,
      loadingSpinner
    };
  }
};
const _hoisted_1$m = {
  id: "diskInfoCard",
  class: "card self-stretch flex-auto flex flex-col"
};
const _hoisted_2$3 = /* @__PURE__ */ createBaseVNode("div", { class: "card-header" }, [
  /* @__PURE__ */ createBaseVNode("h3", { class: "text-header text-default" }, "Disk Information")
], -1);
const _hoisted_3$3 = {
  key: 0,
  id: "diskInfoTable",
  class: "grid grid-cols-2 2xl:grid-cols-3 grid-flow-row-dense grow"
};
const _hoisted_4$3 = {
  key: 0,
  class: "grid grid-cols-1 self-start py-1 md:py-2 px-2"
};
const _hoisted_5$3 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, " Drive Slot ", -1);
const _hoisted_6$3 = { class: "text-sm break-words" };
const _hoisted_7$3 = {
  key: 1,
  class: "grid grid-col-1 self-start col-span-2 py-1 md:py-2 px-2"
};
const _hoisted_8$3 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted col-span-2" }, " Device Path (by-path) ", -1);
const _hoisted_9$2 = { class: "text-sm col-span-2 break-words" };
const _hoisted_10$2 = {
  key: 2,
  class: "grid grid-cols-1 self-start py-1 md:py-2 px-2"
};
const _hoisted_11$2 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, " Disk Type ", -1);
const _hoisted_12$2 = { class: "text-sm break-words" };
const _hoisted_13$2 = {
  key: 3,
  class: "grid grid-cols-1 self-start py-1 md:py-2 px-2"
};
const _hoisted_14$2 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, " Device Path (sd) ", -1);
const _hoisted_15$1 = { class: "text-sm break-words" };
const _hoisted_16$1 = {
  key: 4,
  class: "grid grid-cols-1 self-start py-1 md:py-2 px-2"
};
const _hoisted_17$1 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, " Partition Count ", -1);
const _hoisted_18$1 = { class: "text-sm break-words" };
const _hoisted_19$1 = {
  key: 5,
  class: "grid grid-cols-1 self-start py-1 md:py-2 px-2"
};
const _hoisted_20$1 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, " Model Family ", -1);
const _hoisted_21$1 = { class: "text-sm break-words" };
const _hoisted_22$1 = {
  key: 6,
  class: "grid grid-cols-1 self-start py-1 md:py-2 px-2"
};
const _hoisted_23$1 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, " Model Name ", -1);
const _hoisted_24$1 = { class: "text-sm break-words" };
const _hoisted_25$1 = {
  key: 7,
  class: "grid grid-cols-1 self-start py-1 md:py-2 px-2"
};
const _hoisted_26$1 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, "Serial", -1);
const _hoisted_27$1 = { class: "text-sm break-words" };
const _hoisted_28$1 = {
  key: 8,
  class: "grid grid-cols-1 self-start py-1 md:py-2 px-2"
};
const _hoisted_29$1 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, "Capacity", -1);
const _hoisted_30$1 = { class: "text-sm break-words" };
const _hoisted_31$1 = {
  key: 9,
  class: "grid grid-cols-1 self-start py-1 md:py-2 px-2"
};
const _hoisted_32$1 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, " Firmware Version ", -1);
const _hoisted_33$1 = { class: "text-sm break-words" };
const _hoisted_34$1 = {
  key: 10,
  class: "grid grid-cols-1 self-start py-1 md:py-2 px-2"
};
const _hoisted_35$1 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, " Rotation Rate ", -1);
const _hoisted_36$1 = { class: "text-sm break-words" };
const _hoisted_37$1 = {
  key: 11,
  class: "grid grid-cols-1 self-start py-1 md:py-2 px-2"
};
const _hoisted_38$1 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, " Start/Stop Count ", -1);
const _hoisted_39$1 = { class: "text-sm break-words" };
const _hoisted_40$1 = {
  key: 12,
  class: "grid grid-cols-1 self-start py-1 md:py-2 px-2"
};
const _hoisted_41$1 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, " Power Cycle Count ", -1);
const _hoisted_42$1 = { class: "text-sm break-words" };
const _hoisted_43$1 = {
  key: 13,
  class: "grid grid-cols-1 self-start py-1 md:py-2 px-2"
};
const _hoisted_44$1 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, " Temperature ", -1);
const _hoisted_45$1 = {
  key: 0,
  class: "text-sm break-words"
};
const _hoisted_46$1 = {
  key: 14,
  class: "grid grid-cols-1 self-start py-1 md:py-2 px-2"
};
const _hoisted_47$1 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, " Current Pending Sector ", -1);
const _hoisted_48$1 = { class: "text-sm break-words" };
const _hoisted_49$1 = {
  key: 15,
  class: "grid grid-cols-1 self-start py-1 md:py-2 px-2"
};
const _hoisted_50$1 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, " Offline Uncorrectable ", -1);
const _hoisted_51$1 = { class: "text-sm break-words" };
const _hoisted_52$1 = {
  key: 16,
  class: "grid grid-cols-1 self-start py-1 md:py-2 px-2"
};
const _hoisted_53$1 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, " Power On Time ", -1);
const _hoisted_54$1 = { class: "text-sm break-words" };
const _hoisted_55$1 = {
  key: 17,
  class: "grid grid-cols-1 self-start py-1 md:py-2 px-2"
};
const _hoisted_56$1 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, "Health", -1);
const _hoisted_57$1 = { class: "text-sm break-words" };
const _hoisted_58$1 = {
  key: 18,
  class: "grid grid-cols-1 self-center py-1 md:py-2 px-2 row-span-2"
};
const _hoisted_59$1 = {
  key: 1,
  class: "grow flex justify-center items-center"
};
const _hoisted_60$1 = { class: "p-5 bg-accent rounded-lg" };
const _hoisted_61$1 = { class: "text-muted" };
function _sfc_render$m(_ctx, _cache, $props, $setup, $data, $options) {
  var _a, _b;
  const _component_LoadingSpinner = resolveComponent("LoadingSpinner");
  return openBlock(), createElementBlock("div", _hoisted_1$m, [
    _hoisted_2$3,
    createBaseVNode("div", {
      id: "disk-section-card-body",
      class: normalizeClass([$setup.currentDisk ? "" : "grow", "card-body flex flex-wrap justify-start"])
    }, [
      $setup.currentDisk ? (openBlock(), createElementBlock("div", _hoisted_3$3, [
        $setup.diskObj["bay-id"] ? (openBlock(), createElementBlock("div", _hoisted_4$3, [
          _hoisted_5$3,
          createBaseVNode("div", _hoisted_6$3, toDisplayString($setup.diskObj["bay-id"]), 1)
        ])) : createCommentVNode("", true),
        $setup.diskObj["dev-by-path"] ? (openBlock(), createElementBlock("div", _hoisted_7$3, [
          _hoisted_8$3,
          createBaseVNode("div", _hoisted_9$2, toDisplayString($setup.diskObj["dev-by-path"]), 1)
        ])) : createCommentVNode("", true),
        $setup.diskObj["disk_type"] ? (openBlock(), createElementBlock("div", _hoisted_10$2, [
          _hoisted_11$2,
          createBaseVNode("div", _hoisted_12$2, toDisplayString($setup.diskObj["disk_type"]), 1)
        ])) : createCommentVNode("", true),
        $setup.diskObj["dev"] ? (openBlock(), createElementBlock("div", _hoisted_13$2, [
          _hoisted_14$2,
          createBaseVNode("div", _hoisted_15$1, toDisplayString($setup.diskObj["dev"]), 1)
        ])) : createCommentVNode("", true),
        $setup.diskObj["partitions"] ? (openBlock(), createElementBlock("div", _hoisted_16$1, [
          _hoisted_17$1,
          createBaseVNode("div", _hoisted_18$1, toDisplayString($setup.diskObj["partitions"]), 1)
        ])) : createCommentVNode("", true),
        $setup.diskObj["model-family"] && !["?"].includes($setup.diskObj["model-family"]) ? (openBlock(), createElementBlock("div", _hoisted_19$1, [
          _hoisted_20$1,
          createBaseVNode("div", _hoisted_21$1, toDisplayString($setup.diskObj["model-family"]), 1)
        ])) : createCommentVNode("", true),
        $setup.diskObj["model-name"] && !["?"].includes($setup.diskObj["model-name"]) ? (openBlock(), createElementBlock("div", _hoisted_22$1, [
          _hoisted_23$1,
          createBaseVNode("div", _hoisted_24$1, toDisplayString($setup.diskObj["model-name"]), 1)
        ])) : createCommentVNode("", true),
        $setup.diskObj["serial"] ? (openBlock(), createElementBlock("div", _hoisted_25$1, [
          _hoisted_26$1,
          createBaseVNode("div", _hoisted_27$1, toDisplayString($setup.diskObj["serial"]), 1)
        ])) : createCommentVNode("", true),
        $setup.diskObj["capacity"] ? (openBlock(), createElementBlock("div", _hoisted_28$1, [
          _hoisted_29$1,
          createBaseVNode("div", _hoisted_30$1, toDisplayString($setup.diskObj["capacity"]), 1)
        ])) : createCommentVNode("", true),
        $setup.diskObj["firm-ver"] && !["?"].includes($setup.diskObj["start-stop-count"]) ? (openBlock(), createElementBlock("div", _hoisted_31$1, [
          _hoisted_32$1,
          createBaseVNode("div", _hoisted_33$1, toDisplayString($setup.diskObj["firm-ver"]), 1)
        ])) : createCommentVNode("", true),
        $setup.diskObj["rotation-rate"] && $setup.diskObj["rotation-rate"] != 0 ? (openBlock(), createElementBlock("div", _hoisted_34$1, [
          _hoisted_35$1,
          createBaseVNode("div", _hoisted_36$1, toDisplayString($setup.diskObj["rotation-rate"]) + " RPM ", 1)
        ])) : createCommentVNode("", true),
        $setup.diskObj["start-stop-count"] && !["?"].includes($setup.diskObj["start-stop-count"]) ? (openBlock(), createElementBlock("div", _hoisted_37$1, [
          _hoisted_38$1,
          createBaseVNode("div", _hoisted_39$1, toDisplayString($setup.diskObj["start-stop-count"]), 1)
        ])) : createCommentVNode("", true),
        $setup.diskObj["power-cycle-count"] && !["?"].includes($setup.diskObj["power-cycle-count"]) ? (openBlock(), createElementBlock("div", _hoisted_40$1, [
          _hoisted_41$1,
          createBaseVNode("div", _hoisted_42$1, toDisplayString($setup.diskObj["power-cycle-count"]), 1)
        ])) : createCommentVNode("", true),
        $setup.diskObj["temp-c"] ? (openBlock(), createElementBlock("div", _hoisted_43$1, [
          _hoisted_44$1,
          $setup.diskObj["temp-c"] ? (openBlock(), createElementBlock("div", _hoisted_45$1, toDisplayString((_a = $setup.diskObj["temp-c"]) == null ? void 0 : _a.replace(/[^0-9]/g, "")) + " \xB0C / " + toDisplayString((((_b = $setup.diskObj["temp-c"]) == null ? void 0 : _b.replace(/[^0-9]/g, "")) * (9 / 5) + 32).toFixed(1)) + " \xB0F ", 1)) : createCommentVNode("", true)
        ])) : createCommentVNode("", true),
        $setup.diskObj["current-pending-sector"] && !["?", 0, "0"].includes($setup.diskObj["current-pending-sector"]) ? (openBlock(), createElementBlock("div", _hoisted_46$1, [
          _hoisted_47$1,
          createBaseVNode("div", _hoisted_48$1, toDisplayString($setup.diskObj["current-pending-sector"]), 1)
        ])) : createCommentVNode("", true),
        $setup.diskObj["offline-uncorrectable"] && !["?", 0, "0"].includes($setup.diskObj["offline-uncorrectable"]) ? (openBlock(), createElementBlock("div", _hoisted_49$1, [
          _hoisted_50$1,
          createBaseVNode("div", _hoisted_51$1, toDisplayString($setup.diskObj["offline-uncorrectable"]), 1)
        ])) : createCommentVNode("", true),
        $setup.diskObj["power-on-time"] ? (openBlock(), createElementBlock("div", _hoisted_52$1, [
          _hoisted_53$1,
          createBaseVNode("div", _hoisted_54$1, toDisplayString($setup.diskObj["power-on-time"]) + " h ", 1)
        ])) : createCommentVNode("", true),
        $setup.diskObj["health"] ? (openBlock(), createElementBlock("div", _hoisted_55$1, [
          _hoisted_56$1,
          createBaseVNode("div", _hoisted_57$1, toDisplayString($setup.diskObj["health"]), 1)
        ])) : createCommentVNode("", true),
        $setup.loadingSpinner ? (openBlock(), createElementBlock("div", _hoisted_58$1, [
          createVNode(_component_LoadingSpinner)
        ])) : createCommentVNode("", true)
      ])) : (openBlock(), createElementBlock("div", _hoisted_59$1, [
        createBaseVNode("div", _hoisted_60$1, [
          createBaseVNode("span", _hoisted_61$1, toDisplayString($setup.wMsg), 1)
        ])
      ]))
    ], 2)
  ]);
}
var DiskSection = /* @__PURE__ */ _export_sfc(_sfc_main$m, [["render", _sfc_render$m]]);
var commonjsGlobal = typeof globalThis !== "undefined" ? globalThis : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : {};
function getDefaultExportFromCjs(x) {
  return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, "default") ? x["default"] : x;
}
function commonjsRequire(path) {
  throw new Error('Could not dynamically require "' + path + '". Please configure the dynamicRequireTargets or/and ignoreDynamicRequires option of @rollup/plugin-commonjs appropriately for this require call to work.');
}
var p5_min = { exports: {} };
/*! p5.js v1.4.1 February 02, 2022 */
(function(module, exports) {
  !function(e2) {
    module.exports = e2();
  }(function() {
    var i;
    return function i2(a2, s, l2) {
      function u2(t2, e3) {
        if (!s[t2]) {
          if (!a2[t2]) {
            var r2 = typeof commonjsRequire == "function" && commonjsRequire;
            if (!e3 && r2)
              return r2(t2, true);
            if (c)
              return c(t2, true);
            var n2 = new Error("Cannot find module '" + t2 + "'");
            throw n2.code = "MODULE_NOT_FOUND", n2;
          }
          var o2 = s[t2] = { exports: {} };
          a2[t2][0].call(o2.exports, function(e4) {
            return u2(a2[t2][1][e4] || e4);
          }, o2, o2.exports, i2, a2, s, l2);
        }
        return s[t2].exports;
      }
      for (var c = typeof commonjsRequire == "function" && commonjsRequire, e2 = 0; e2 < l2.length; e2++)
        u2(l2[e2]);
      return u2;
    }({ 1: [function(e2, t2, r2) {
      r2.byteLength = function(e3) {
        var t3 = d(e3), r3 = t3[0], n3 = t3[1];
        return 3 * (r3 + n3) / 4 - n3;
      }, r2.toByteArray = function(e3) {
        var t3, r3, n3 = d(e3), o3 = n3[0], i3 = n3[1], a2 = new c(function(e4, t4) {
          return 3 * (e4 + t4) / 4 - t4;
        }(o3, i3)), s2 = 0, l3 = 0 < i3 ? o3 - 4 : o3;
        for (r3 = 0; r3 < l3; r3 += 4)
          t3 = u2[e3.charCodeAt(r3)] << 18 | u2[e3.charCodeAt(r3 + 1)] << 12 | u2[e3.charCodeAt(r3 + 2)] << 6 | u2[e3.charCodeAt(r3 + 3)], a2[s2++] = t3 >> 16 & 255, a2[s2++] = t3 >> 8 & 255, a2[s2++] = 255 & t3;
        i3 === 2 && (t3 = u2[e3.charCodeAt(r3)] << 2 | u2[e3.charCodeAt(r3 + 1)] >> 4, a2[s2++] = 255 & t3);
        i3 === 1 && (t3 = u2[e3.charCodeAt(r3)] << 10 | u2[e3.charCodeAt(r3 + 1)] << 4 | u2[e3.charCodeAt(r3 + 2)] >> 2, a2[s2++] = t3 >> 8 & 255, a2[s2++] = 255 & t3);
        return a2;
      }, r2.fromByteArray = function(e3) {
        for (var t3, r3 = e3.length, n3 = r3 % 3, o3 = [], i3 = 0, a2 = r3 - n3; i3 < a2; i3 += 16383)
          o3.push(l2(e3, i3, a2 < i3 + 16383 ? a2 : i3 + 16383));
        n3 == 1 ? (t3 = e3[r3 - 1], o3.push(s[t3 >> 2] + s[t3 << 4 & 63] + "==")) : n3 == 2 && (t3 = (e3[r3 - 2] << 8) + e3[r3 - 1], o3.push(s[t3 >> 10] + s[t3 >> 4 & 63] + s[t3 << 2 & 63] + "="));
        return o3.join("");
      };
      for (var s = [], u2 = [], c = typeof Uint8Array != "undefined" ? Uint8Array : Array, n2 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/", o2 = 0, i2 = n2.length; o2 < i2; ++o2)
        s[o2] = n2[o2], u2[n2.charCodeAt(o2)] = o2;
      function d(e3) {
        var t3 = e3.length;
        if (0 < t3 % 4)
          throw new Error("Invalid string. Length must be a multiple of 4");
        var r3 = e3.indexOf("=");
        return r3 === -1 && (r3 = t3), [r3, r3 === t3 ? 0 : 4 - r3 % 4];
      }
      function l2(e3, t3, r3) {
        for (var n3, o3, i3 = [], a2 = t3; a2 < r3; a2 += 3)
          n3 = (e3[a2] << 16 & 16711680) + (e3[a2 + 1] << 8 & 65280) + (255 & e3[a2 + 2]), i3.push(s[(o3 = n3) >> 18 & 63] + s[o3 >> 12 & 63] + s[o3 >> 6 & 63] + s[63 & o3]);
        return i3.join("");
      }
      u2["-".charCodeAt(0)] = 62, u2["_".charCodeAt(0)] = 63;
    }, {}], 2: [function(e2, t2, r2) {
    }, {}], 3: [function(e2, t2, r2) {
      arguments[4][2][0].apply(r2, arguments);
    }, { dup: 2 }], 4: [function(U, e2, N) {
      (function(d) {
        var n2 = U("base64-js"), i2 = U("ieee754"), e3 = typeof Symbol == "function" && typeof Symbol.for == "function" ? Symbol.for("nodejs.util.inspect.custom") : null;
        N.Buffer = d, N.SlowBuffer = function(e4) {
          +e4 != e4 && (e4 = 0);
          return d.alloc(+e4);
        }, N.INSPECT_MAX_BYTES = 50;
        var r2 = 2147483647;
        function a2(e4) {
          if (r2 < e4)
            throw new RangeError('The value "' + e4 + '" is invalid for option "size"');
          var t3 = new Uint8Array(e4);
          return Object.setPrototypeOf(t3, d.prototype), t3;
        }
        function d(e4, t3, r3) {
          if (typeof e4 != "number")
            return o2(e4, t3, r3);
          if (typeof t3 == "string")
            throw new TypeError('The "string" argument must be of type string. Received type number');
          return l2(e4);
        }
        function o2(e4, t3, r3) {
          if (typeof e4 == "string")
            return function(e5, t4) {
              typeof t4 == "string" && t4 !== "" || (t4 = "utf8");
              if (!d.isEncoding(t4))
                throw new TypeError("Unknown encoding: " + t4);
              var r4 = 0 | f(e5, t4), n4 = a2(r4), o4 = n4.write(e5, t4);
              o4 !== r4 && (n4 = n4.slice(0, o4));
              return n4;
            }(e4, t3);
          if (ArrayBuffer.isView(e4))
            return u2(e4);
          if (e4 == null)
            throw new TypeError("The first argument must be one of type string, Buffer, ArrayBuffer, Array, or Array-like Object. Received type " + typeof e4);
          if (R2(e4, ArrayBuffer) || e4 && R2(e4.buffer, ArrayBuffer))
            return function(e5, t4, r4) {
              if (t4 < 0 || e5.byteLength < t4)
                throw new RangeError('"offset" is outside of buffer bounds');
              if (e5.byteLength < t4 + (r4 || 0))
                throw new RangeError('"length" is outside of buffer bounds');
              var n4;
              n4 = t4 === void 0 && r4 === void 0 ? new Uint8Array(e5) : r4 === void 0 ? new Uint8Array(e5, t4) : new Uint8Array(e5, t4, r4);
              return Object.setPrototypeOf(n4, d.prototype), n4;
            }(e4, t3, r3);
          if (typeof e4 == "number")
            throw new TypeError('The "value" argument must not be of type number. Received type number');
          var n3 = e4.valueOf && e4.valueOf();
          if (n3 != null && n3 !== e4)
            return d.from(n3, t3, r3);
          var o3 = function(e5) {
            if (d.isBuffer(e5)) {
              var t4 = 0 | c(e5.length), r4 = a2(t4);
              return r4.length === 0 || e5.copy(r4, 0, 0, t4), r4;
            }
            if (e5.length !== void 0)
              return typeof e5.length != "number" || D(e5.length) ? a2(0) : u2(e5);
            if (e5.type === "Buffer" && Array.isArray(e5.data))
              return u2(e5.data);
          }(e4);
          if (o3)
            return o3;
          if (typeof Symbol != "undefined" && Symbol.toPrimitive != null && typeof e4[Symbol.toPrimitive] == "function")
            return d.from(e4[Symbol.toPrimitive]("string"), t3, r3);
          throw new TypeError("The first argument must be one of type string, Buffer, ArrayBuffer, Array, or Array-like Object. Received type " + typeof e4);
        }
        function s(e4) {
          if (typeof e4 != "number")
            throw new TypeError('"size" argument must be of type number');
          if (e4 < 0)
            throw new RangeError('The value "' + e4 + '" is invalid for option "size"');
        }
        function l2(e4) {
          return s(e4), a2(e4 < 0 ? 0 : 0 | c(e4));
        }
        function u2(e4) {
          for (var t3 = e4.length < 0 ? 0 : 0 | c(e4.length), r3 = a2(t3), n3 = 0; n3 < t3; n3 += 1)
            r3[n3] = 255 & e4[n3];
          return r3;
        }
        function c(e4) {
          if (r2 <= e4)
            throw new RangeError("Attempt to allocate Buffer larger than maximum size: 0x" + r2.toString(16) + " bytes");
          return 0 | e4;
        }
        function f(e4, t3) {
          if (d.isBuffer(e4))
            return e4.length;
          if (ArrayBuffer.isView(e4) || R2(e4, ArrayBuffer))
            return e4.byteLength;
          if (typeof e4 != "string")
            throw new TypeError('The "string" argument must be one of type string, Buffer, or ArrayBuffer. Received type ' + typeof e4);
          var r3 = e4.length, n3 = 2 < arguments.length && arguments[2] === true;
          if (!n3 && r3 === 0)
            return 0;
          for (var o3 = false; ; )
            switch (t3) {
              case "ascii":
              case "latin1":
              case "binary":
                return r3;
              case "utf8":
              case "utf-8":
                return P2(e4).length;
              case "ucs2":
              case "ucs-2":
              case "utf16le":
              case "utf-16le":
                return 2 * r3;
              case "hex":
                return r3 >>> 1;
              case "base64":
                return A(e4).length;
              default:
                if (o3)
                  return n3 ? -1 : P2(e4).length;
                t3 = ("" + t3).toLowerCase(), o3 = true;
            }
        }
        function h2(e4, t3, r3) {
          var n3 = e4[t3];
          e4[t3] = e4[r3], e4[r3] = n3;
        }
        function p2(e4, t3, r3, n3, o3) {
          if (e4.length === 0)
            return -1;
          if (typeof r3 == "string" ? (n3 = r3, r3 = 0) : 2147483647 < r3 ? r3 = 2147483647 : r3 < -2147483648 && (r3 = -2147483648), D(r3 = +r3) && (r3 = o3 ? 0 : e4.length - 1), r3 < 0 && (r3 = e4.length + r3), r3 >= e4.length) {
            if (o3)
              return -1;
            r3 = e4.length - 1;
          } else if (r3 < 0) {
            if (!o3)
              return -1;
            r3 = 0;
          }
          if (typeof t3 == "string" && (t3 = d.from(t3, n3)), d.isBuffer(t3))
            return t3.length === 0 ? -1 : y(e4, t3, r3, n3, o3);
          if (typeof t3 == "number")
            return t3 &= 255, typeof Uint8Array.prototype.indexOf == "function" ? o3 ? Uint8Array.prototype.indexOf.call(e4, t3, r3) : Uint8Array.prototype.lastIndexOf.call(e4, t3, r3) : y(e4, [t3], r3, n3, o3);
          throw new TypeError("val must be string, number or Buffer");
        }
        function y(e4, t3, r3, n3, o3) {
          var i3, a3 = 1, s2 = e4.length, l3 = t3.length;
          if (n3 !== void 0 && ((n3 = String(n3).toLowerCase()) === "ucs2" || n3 === "ucs-2" || n3 === "utf16le" || n3 === "utf-16le")) {
            if (e4.length < 2 || t3.length < 2)
              return -1;
            s2 /= a3 = 2, l3 /= 2, r3 /= 2;
          }
          function u3(e5, t4) {
            return a3 === 1 ? e5[t4] : e5.readUInt16BE(t4 * a3);
          }
          if (o3) {
            var c2 = -1;
            for (i3 = r3; i3 < s2; i3++)
              if (u3(e4, i3) === u3(t3, c2 === -1 ? 0 : i3 - c2)) {
                if (c2 === -1 && (c2 = i3), i3 - c2 + 1 === l3)
                  return c2 * a3;
              } else
                c2 !== -1 && (i3 -= i3 - c2), c2 = -1;
          } else
            for (s2 < r3 + l3 && (r3 = s2 - l3), i3 = r3; 0 <= i3; i3--) {
              for (var d2 = true, f2 = 0; f2 < l3; f2++)
                if (u3(e4, i3 + f2) !== u3(t3, f2)) {
                  d2 = false;
                  break;
                }
              if (d2)
                return i3;
            }
          return -1;
        }
        function m2(e4, t3, r3, n3) {
          r3 = Number(r3) || 0;
          var o3 = e4.length - r3;
          n3 ? o3 < (n3 = Number(n3)) && (n3 = o3) : n3 = o3;
          var i3 = t3.length;
          i3 / 2 < n3 && (n3 = i3 / 2);
          for (var a3 = 0; a3 < n3; ++a3) {
            var s2 = parseInt(t3.substr(2 * a3, 2), 16);
            if (D(s2))
              return a3;
            e4[r3 + a3] = s2;
          }
          return a3;
        }
        function g(e4, t3, r3, n3) {
          return k2(function(e5) {
            for (var t4 = [], r4 = 0; r4 < e5.length; ++r4)
              t4.push(255 & e5.charCodeAt(r4));
            return t4;
          }(t3), e4, r3, n3);
        }
        function v(e4, t3, r3, n3) {
          return k2(function(e5, t4) {
            for (var r4, n4, o3, i3 = [], a3 = 0; a3 < e5.length && !((t4 -= 2) < 0); ++a3)
              r4 = e5.charCodeAt(a3), n4 = r4 >> 8, o3 = r4 % 256, i3.push(o3), i3.push(n4);
            return i3;
          }(t3, e4.length - r3), e4, r3, n3);
        }
        function b2(e4, t3, r3) {
          return t3 === 0 && r3 === e4.length ? n2.fromByteArray(e4) : n2.fromByteArray(e4.slice(t3, r3));
        }
        function _(e4, t3, r3) {
          r3 = Math.min(e4.length, r3);
          for (var n3 = [], o3 = t3; o3 < r3; ) {
            var i3, a3, s2, l3, u3 = e4[o3], c2 = null, d2 = 239 < u3 ? 4 : 223 < u3 ? 3 : 191 < u3 ? 2 : 1;
            if (o3 + d2 <= r3)
              switch (d2) {
                case 1:
                  u3 < 128 && (c2 = u3);
                  break;
                case 2:
                  (192 & (i3 = e4[o3 + 1])) == 128 && 127 < (l3 = (31 & u3) << 6 | 63 & i3) && (c2 = l3);
                  break;
                case 3:
                  i3 = e4[o3 + 1], a3 = e4[o3 + 2], (192 & i3) == 128 && (192 & a3) == 128 && 2047 < (l3 = (15 & u3) << 12 | (63 & i3) << 6 | 63 & a3) && (l3 < 55296 || 57343 < l3) && (c2 = l3);
                  break;
                case 4:
                  i3 = e4[o3 + 1], a3 = e4[o3 + 2], s2 = e4[o3 + 3], (192 & i3) == 128 && (192 & a3) == 128 && (192 & s2) == 128 && 65535 < (l3 = (15 & u3) << 18 | (63 & i3) << 12 | (63 & a3) << 6 | 63 & s2) && l3 < 1114112 && (c2 = l3);
              }
            c2 === null ? (c2 = 65533, d2 = 1) : 65535 < c2 && (c2 -= 65536, n3.push(c2 >>> 10 & 1023 | 55296), c2 = 56320 | 1023 & c2), n3.push(c2), o3 += d2;
          }
          return function(e5) {
            var t4 = e5.length;
            if (t4 <= x)
              return String.fromCharCode.apply(String, e5);
            var r4 = "", n4 = 0;
            for (; n4 < t4; )
              r4 += String.fromCharCode.apply(String, e5.slice(n4, n4 += x));
            return r4;
          }(n3);
        }
        N.kMaxLength = r2, (d.TYPED_ARRAY_SUPPORT = function() {
          try {
            var e4 = new Uint8Array(1), t3 = { foo: function() {
              return 42;
            } };
            return Object.setPrototypeOf(t3, Uint8Array.prototype), Object.setPrototypeOf(e4, t3), e4.foo() === 42;
          } catch (e5) {
            return false;
          }
        }()) || typeof console == "undefined" || typeof console.error != "function" || console.error("This browser lacks typed array (Uint8Array) support which is required by `buffer` v5.x. Use `buffer` v4.x if you require old browser support."), Object.defineProperty(d.prototype, "parent", { enumerable: true, get: function() {
          if (d.isBuffer(this))
            return this.buffer;
        } }), Object.defineProperty(d.prototype, "offset", { enumerable: true, get: function() {
          if (d.isBuffer(this))
            return this.byteOffset;
        } }), typeof Symbol != "undefined" && Symbol.species != null && d[Symbol.species] === d && Object.defineProperty(d, Symbol.species, { value: null, configurable: true, enumerable: false, writable: false }), d.poolSize = 8192, d.from = function(e4, t3, r3) {
          return o2(e4, t3, r3);
        }, Object.setPrototypeOf(d.prototype, Uint8Array.prototype), Object.setPrototypeOf(d, Uint8Array), d.alloc = function(e4, t3, r3) {
          return o3 = t3, i3 = r3, s(n3 = e4), n3 <= 0 ? a2(n3) : o3 !== void 0 ? typeof i3 == "string" ? a2(n3).fill(o3, i3) : a2(n3).fill(o3) : a2(n3);
          var n3, o3, i3;
        }, d.allocUnsafe = function(e4) {
          return l2(e4);
        }, d.allocUnsafeSlow = function(e4) {
          return l2(e4);
        }, d.isBuffer = function(e4) {
          return e4 != null && e4._isBuffer === true && e4 !== d.prototype;
        }, d.compare = function(e4, t3) {
          if (R2(e4, Uint8Array) && (e4 = d.from(e4, e4.offset, e4.byteLength)), R2(t3, Uint8Array) && (t3 = d.from(t3, t3.offset, t3.byteLength)), !d.isBuffer(e4) || !d.isBuffer(t3))
            throw new TypeError('The "buf1", "buf2" arguments must be one of type Buffer or Uint8Array');
          if (e4 === t3)
            return 0;
          for (var r3 = e4.length, n3 = t3.length, o3 = 0, i3 = Math.min(r3, n3); o3 < i3; ++o3)
            if (e4[o3] !== t3[o3]) {
              r3 = e4[o3], n3 = t3[o3];
              break;
            }
          return r3 < n3 ? -1 : n3 < r3 ? 1 : 0;
        }, d.isEncoding = function(e4) {
          switch (String(e4).toLowerCase()) {
            case "hex":
            case "utf8":
            case "utf-8":
            case "ascii":
            case "latin1":
            case "binary":
            case "base64":
            case "ucs2":
            case "ucs-2":
            case "utf16le":
            case "utf-16le":
              return true;
            default:
              return false;
          }
        }, d.concat = function(e4, t3) {
          if (!Array.isArray(e4))
            throw new TypeError('"list" argument must be an Array of Buffers');
          if (e4.length === 0)
            return d.alloc(0);
          var r3;
          if (t3 === void 0)
            for (r3 = t3 = 0; r3 < e4.length; ++r3)
              t3 += e4[r3].length;
          var n3 = d.allocUnsafe(t3), o3 = 0;
          for (r3 = 0; r3 < e4.length; ++r3) {
            var i3 = e4[r3];
            if (R2(i3, Uint8Array) && (i3 = d.from(i3)), !d.isBuffer(i3))
              throw new TypeError('"list" argument must be an Array of Buffers');
            i3.copy(n3, o3), o3 += i3.length;
          }
          return n3;
        }, d.byteLength = f, d.prototype._isBuffer = true, d.prototype.swap16 = function() {
          var e4 = this.length;
          if (e4 % 2 != 0)
            throw new RangeError("Buffer size must be a multiple of 16-bits");
          for (var t3 = 0; t3 < e4; t3 += 2)
            h2(this, t3, t3 + 1);
          return this;
        }, d.prototype.swap32 = function() {
          var e4 = this.length;
          if (e4 % 4 != 0)
            throw new RangeError("Buffer size must be a multiple of 32-bits");
          for (var t3 = 0; t3 < e4; t3 += 4)
            h2(this, t3, t3 + 3), h2(this, t3 + 1, t3 + 2);
          return this;
        }, d.prototype.swap64 = function() {
          var e4 = this.length;
          if (e4 % 8 != 0)
            throw new RangeError("Buffer size must be a multiple of 64-bits");
          for (var t3 = 0; t3 < e4; t3 += 8)
            h2(this, t3, t3 + 7), h2(this, t3 + 1, t3 + 6), h2(this, t3 + 2, t3 + 5), h2(this, t3 + 3, t3 + 4);
          return this;
        }, d.prototype.toLocaleString = d.prototype.toString = function() {
          var e4 = this.length;
          return e4 === 0 ? "" : arguments.length === 0 ? _(this, 0, e4) : function(e5, t3, r3) {
            var n3 = false;
            if ((t3 === void 0 || t3 < 0) && (t3 = 0), t3 > this.length)
              return "";
            if ((r3 === void 0 || r3 > this.length) && (r3 = this.length), r3 <= 0)
              return "";
            if ((r3 >>>= 0) <= (t3 >>>= 0))
              return "";
            for (e5 = e5 || "utf8"; ; )
              switch (e5) {
                case "hex":
                  return S2(this, t3, r3);
                case "utf8":
                case "utf-8":
                  return _(this, t3, r3);
                case "ascii":
                  return w(this, t3, r3);
                case "latin1":
                case "binary":
                  return j(this, t3, r3);
                case "base64":
                  return b2(this, t3, r3);
                case "ucs2":
                case "ucs-2":
                case "utf16le":
                case "utf-16le":
                  return M(this, t3, r3);
                default:
                  if (n3)
                    throw new TypeError("Unknown encoding: " + e5);
                  e5 = (e5 + "").toLowerCase(), n3 = true;
              }
          }.apply(this, arguments);
        }, d.prototype.equals = function(e4) {
          if (!d.isBuffer(e4))
            throw new TypeError("Argument must be a Buffer");
          return this === e4 || d.compare(this, e4) === 0;
        }, d.prototype.inspect = function() {
          var e4 = "", t3 = N.INSPECT_MAX_BYTES;
          return e4 = this.toString("hex", 0, t3).replace(/(.{2})/g, "$1 ").trim(), this.length > t3 && (e4 += " ... "), "<Buffer " + e4 + ">";
        }, e3 && (d.prototype[e3] = d.prototype.inspect), d.prototype.compare = function(e4, t3, r3, n3, o3) {
          if (R2(e4, Uint8Array) && (e4 = d.from(e4, e4.offset, e4.byteLength)), !d.isBuffer(e4))
            throw new TypeError('The "target" argument must be one of type Buffer or Uint8Array. Received type ' + typeof e4);
          if (t3 === void 0 && (t3 = 0), r3 === void 0 && (r3 = e4 ? e4.length : 0), n3 === void 0 && (n3 = 0), o3 === void 0 && (o3 = this.length), t3 < 0 || r3 > e4.length || n3 < 0 || o3 > this.length)
            throw new RangeError("out of range index");
          if (o3 <= n3 && r3 <= t3)
            return 0;
          if (o3 <= n3)
            return -1;
          if (r3 <= t3)
            return 1;
          if (this === e4)
            return 0;
          for (var i3 = (o3 >>>= 0) - (n3 >>>= 0), a3 = (r3 >>>= 0) - (t3 >>>= 0), s2 = Math.min(i3, a3), l3 = this.slice(n3, o3), u3 = e4.slice(t3, r3), c2 = 0; c2 < s2; ++c2)
            if (l3[c2] !== u3[c2]) {
              i3 = l3[c2], a3 = u3[c2];
              break;
            }
          return i3 < a3 ? -1 : a3 < i3 ? 1 : 0;
        }, d.prototype.includes = function(e4, t3, r3) {
          return this.indexOf(e4, t3, r3) !== -1;
        }, d.prototype.indexOf = function(e4, t3, r3) {
          return p2(this, e4, t3, r3, true);
        }, d.prototype.lastIndexOf = function(e4, t3, r3) {
          return p2(this, e4, t3, r3, false);
        }, d.prototype.write = function(e4, t3, r3, n3) {
          if (t3 === void 0)
            n3 = "utf8", r3 = this.length, t3 = 0;
          else if (r3 === void 0 && typeof t3 == "string")
            n3 = t3, r3 = this.length, t3 = 0;
          else {
            if (!isFinite(t3))
              throw new Error("Buffer.write(string, encoding, offset[, length]) is no longer supported");
            t3 >>>= 0, isFinite(r3) ? (r3 >>>= 0, n3 === void 0 && (n3 = "utf8")) : (n3 = r3, r3 = void 0);
          }
          var o3 = this.length - t3;
          if ((r3 === void 0 || o3 < r3) && (r3 = o3), 0 < e4.length && (r3 < 0 || t3 < 0) || t3 > this.length)
            throw new RangeError("Attempt to write outside buffer bounds");
          n3 = n3 || "utf8";
          for (var i3, a3, s2, l3, u3, c2, d2 = false; ; )
            switch (n3) {
              case "hex":
                return m2(this, e4, t3, r3);
              case "utf8":
              case "utf-8":
                return u3 = t3, c2 = r3, k2(P2(e4, (l3 = this).length - u3), l3, u3, c2);
              case "ascii":
                return g(this, e4, t3, r3);
              case "latin1":
              case "binary":
                return g(this, e4, t3, r3);
              case "base64":
                return i3 = this, a3 = t3, s2 = r3, k2(A(e4), i3, a3, s2);
              case "ucs2":
              case "ucs-2":
              case "utf16le":
              case "utf-16le":
                return v(this, e4, t3, r3);
              default:
                if (d2)
                  throw new TypeError("Unknown encoding: " + n3);
                n3 = ("" + n3).toLowerCase(), d2 = true;
            }
        }, d.prototype.toJSON = function() {
          return { type: "Buffer", data: Array.prototype.slice.call(this._arr || this, 0) };
        };
        var x = 4096;
        function w(e4, t3, r3) {
          var n3 = "";
          r3 = Math.min(e4.length, r3);
          for (var o3 = t3; o3 < r3; ++o3)
            n3 += String.fromCharCode(127 & e4[o3]);
          return n3;
        }
        function j(e4, t3, r3) {
          var n3 = "";
          r3 = Math.min(e4.length, r3);
          for (var o3 = t3; o3 < r3; ++o3)
            n3 += String.fromCharCode(e4[o3]);
          return n3;
        }
        function S2(e4, t3, r3) {
          var n3 = e4.length;
          (!t3 || t3 < 0) && (t3 = 0), (!r3 || r3 < 0 || n3 < r3) && (r3 = n3);
          for (var o3 = "", i3 = t3; i3 < r3; ++i3)
            o3 += I[e4[i3]];
          return o3;
        }
        function M(e4, t3, r3) {
          for (var n3 = e4.slice(t3, r3), o3 = "", i3 = 0; i3 < n3.length; i3 += 2)
            o3 += String.fromCharCode(n3[i3] + 256 * n3[i3 + 1]);
          return o3;
        }
        function E(e4, t3, r3) {
          if (e4 % 1 != 0 || e4 < 0)
            throw new RangeError("offset is not uint");
          if (r3 < e4 + t3)
            throw new RangeError("Trying to access beyond buffer length");
        }
        function T2(e4, t3, r3, n3, o3, i3) {
          if (!d.isBuffer(e4))
            throw new TypeError('"buffer" argument must be a Buffer instance');
          if (o3 < t3 || t3 < i3)
            throw new RangeError('"value" argument is out of bounds');
          if (r3 + n3 > e4.length)
            throw new RangeError("Index out of range");
        }
        function O2(e4, t3, r3, n3) {
          if (r3 + n3 > e4.length)
            throw new RangeError("Index out of range");
          if (r3 < 0)
            throw new RangeError("Index out of range");
        }
        function C(e4, t3, r3, n3, o3) {
          return t3 = +t3, r3 >>>= 0, o3 || O2(e4, 0, r3, 4), i2.write(e4, t3, r3, n3, 23, 4), r3 + 4;
        }
        function L(e4, t3, r3, n3, o3) {
          return t3 = +t3, r3 >>>= 0, o3 || O2(e4, 0, r3, 8), i2.write(e4, t3, r3, n3, 52, 8), r3 + 8;
        }
        d.prototype.slice = function(e4, t3) {
          var r3 = this.length;
          (e4 = ~~e4) < 0 ? (e4 += r3) < 0 && (e4 = 0) : r3 < e4 && (e4 = r3), (t3 = t3 === void 0 ? r3 : ~~t3) < 0 ? (t3 += r3) < 0 && (t3 = 0) : r3 < t3 && (t3 = r3), t3 < e4 && (t3 = e4);
          var n3 = this.subarray(e4, t3);
          return Object.setPrototypeOf(n3, d.prototype), n3;
        }, d.prototype.readUIntLE = function(e4, t3, r3) {
          e4 >>>= 0, t3 >>>= 0, r3 || E(e4, t3, this.length);
          for (var n3 = this[e4], o3 = 1, i3 = 0; ++i3 < t3 && (o3 *= 256); )
            n3 += this[e4 + i3] * o3;
          return n3;
        }, d.prototype.readUIntBE = function(e4, t3, r3) {
          e4 >>>= 0, t3 >>>= 0, r3 || E(e4, t3, this.length);
          for (var n3 = this[e4 + --t3], o3 = 1; 0 < t3 && (o3 *= 256); )
            n3 += this[e4 + --t3] * o3;
          return n3;
        }, d.prototype.readUInt8 = function(e4, t3) {
          return e4 >>>= 0, t3 || E(e4, 1, this.length), this[e4];
        }, d.prototype.readUInt16LE = function(e4, t3) {
          return e4 >>>= 0, t3 || E(e4, 2, this.length), this[e4] | this[e4 + 1] << 8;
        }, d.prototype.readUInt16BE = function(e4, t3) {
          return e4 >>>= 0, t3 || E(e4, 2, this.length), this[e4] << 8 | this[e4 + 1];
        }, d.prototype.readUInt32LE = function(e4, t3) {
          return e4 >>>= 0, t3 || E(e4, 4, this.length), (this[e4] | this[e4 + 1] << 8 | this[e4 + 2] << 16) + 16777216 * this[e4 + 3];
        }, d.prototype.readUInt32BE = function(e4, t3) {
          return e4 >>>= 0, t3 || E(e4, 4, this.length), 16777216 * this[e4] + (this[e4 + 1] << 16 | this[e4 + 2] << 8 | this[e4 + 3]);
        }, d.prototype.readIntLE = function(e4, t3, r3) {
          e4 >>>= 0, t3 >>>= 0, r3 || E(e4, t3, this.length);
          for (var n3 = this[e4], o3 = 1, i3 = 0; ++i3 < t3 && (o3 *= 256); )
            n3 += this[e4 + i3] * o3;
          return (o3 *= 128) <= n3 && (n3 -= Math.pow(2, 8 * t3)), n3;
        }, d.prototype.readIntBE = function(e4, t3, r3) {
          e4 >>>= 0, t3 >>>= 0, r3 || E(e4, t3, this.length);
          for (var n3 = t3, o3 = 1, i3 = this[e4 + --n3]; 0 < n3 && (o3 *= 256); )
            i3 += this[e4 + --n3] * o3;
          return (o3 *= 128) <= i3 && (i3 -= Math.pow(2, 8 * t3)), i3;
        }, d.prototype.readInt8 = function(e4, t3) {
          return e4 >>>= 0, t3 || E(e4, 1, this.length), 128 & this[e4] ? -1 * (255 - this[e4] + 1) : this[e4];
        }, d.prototype.readInt16LE = function(e4, t3) {
          e4 >>>= 0, t3 || E(e4, 2, this.length);
          var r3 = this[e4] | this[e4 + 1] << 8;
          return 32768 & r3 ? 4294901760 | r3 : r3;
        }, d.prototype.readInt16BE = function(e4, t3) {
          e4 >>>= 0, t3 || E(e4, 2, this.length);
          var r3 = this[e4 + 1] | this[e4] << 8;
          return 32768 & r3 ? 4294901760 | r3 : r3;
        }, d.prototype.readInt32LE = function(e4, t3) {
          return e4 >>>= 0, t3 || E(e4, 4, this.length), this[e4] | this[e4 + 1] << 8 | this[e4 + 2] << 16 | this[e4 + 3] << 24;
        }, d.prototype.readInt32BE = function(e4, t3) {
          return e4 >>>= 0, t3 || E(e4, 4, this.length), this[e4] << 24 | this[e4 + 1] << 16 | this[e4 + 2] << 8 | this[e4 + 3];
        }, d.prototype.readFloatLE = function(e4, t3) {
          return e4 >>>= 0, t3 || E(e4, 4, this.length), i2.read(this, e4, true, 23, 4);
        }, d.prototype.readFloatBE = function(e4, t3) {
          return e4 >>>= 0, t3 || E(e4, 4, this.length), i2.read(this, e4, false, 23, 4);
        }, d.prototype.readDoubleLE = function(e4, t3) {
          return e4 >>>= 0, t3 || E(e4, 8, this.length), i2.read(this, e4, true, 52, 8);
        }, d.prototype.readDoubleBE = function(e4, t3) {
          return e4 >>>= 0, t3 || E(e4, 8, this.length), i2.read(this, e4, false, 52, 8);
        }, d.prototype.writeUIntLE = function(e4, t3, r3, n3) {
          e4 = +e4, t3 >>>= 0, r3 >>>= 0, n3 || T2(this, e4, t3, r3, Math.pow(2, 8 * r3) - 1, 0);
          var o3 = 1, i3 = 0;
          for (this[t3] = 255 & e4; ++i3 < r3 && (o3 *= 256); )
            this[t3 + i3] = e4 / o3 & 255;
          return t3 + r3;
        }, d.prototype.writeUIntBE = function(e4, t3, r3, n3) {
          e4 = +e4, t3 >>>= 0, r3 >>>= 0, n3 || T2(this, e4, t3, r3, Math.pow(2, 8 * r3) - 1, 0);
          var o3 = r3 - 1, i3 = 1;
          for (this[t3 + o3] = 255 & e4; 0 <= --o3 && (i3 *= 256); )
            this[t3 + o3] = e4 / i3 & 255;
          return t3 + r3;
        }, d.prototype.writeUInt8 = function(e4, t3, r3) {
          return e4 = +e4, t3 >>>= 0, r3 || T2(this, e4, t3, 1, 255, 0), this[t3] = 255 & e4, t3 + 1;
        }, d.prototype.writeUInt16LE = function(e4, t3, r3) {
          return e4 = +e4, t3 >>>= 0, r3 || T2(this, e4, t3, 2, 65535, 0), this[t3] = 255 & e4, this[t3 + 1] = e4 >>> 8, t3 + 2;
        }, d.prototype.writeUInt16BE = function(e4, t3, r3) {
          return e4 = +e4, t3 >>>= 0, r3 || T2(this, e4, t3, 2, 65535, 0), this[t3] = e4 >>> 8, this[t3 + 1] = 255 & e4, t3 + 2;
        }, d.prototype.writeUInt32LE = function(e4, t3, r3) {
          return e4 = +e4, t3 >>>= 0, r3 || T2(this, e4, t3, 4, 4294967295, 0), this[t3 + 3] = e4 >>> 24, this[t3 + 2] = e4 >>> 16, this[t3 + 1] = e4 >>> 8, this[t3] = 255 & e4, t3 + 4;
        }, d.prototype.writeUInt32BE = function(e4, t3, r3) {
          return e4 = +e4, t3 >>>= 0, r3 || T2(this, e4, t3, 4, 4294967295, 0), this[t3] = e4 >>> 24, this[t3 + 1] = e4 >>> 16, this[t3 + 2] = e4 >>> 8, this[t3 + 3] = 255 & e4, t3 + 4;
        }, d.prototype.writeIntLE = function(e4, t3, r3, n3) {
          if (e4 = +e4, t3 >>>= 0, !n3) {
            var o3 = Math.pow(2, 8 * r3 - 1);
            T2(this, e4, t3, r3, o3 - 1, -o3);
          }
          var i3 = 0, a3 = 1, s2 = 0;
          for (this[t3] = 255 & e4; ++i3 < r3 && (a3 *= 256); )
            e4 < 0 && s2 === 0 && this[t3 + i3 - 1] !== 0 && (s2 = 1), this[t3 + i3] = (e4 / a3 >> 0) - s2 & 255;
          return t3 + r3;
        }, d.prototype.writeIntBE = function(e4, t3, r3, n3) {
          if (e4 = +e4, t3 >>>= 0, !n3) {
            var o3 = Math.pow(2, 8 * r3 - 1);
            T2(this, e4, t3, r3, o3 - 1, -o3);
          }
          var i3 = r3 - 1, a3 = 1, s2 = 0;
          for (this[t3 + i3] = 255 & e4; 0 <= --i3 && (a3 *= 256); )
            e4 < 0 && s2 === 0 && this[t3 + i3 + 1] !== 0 && (s2 = 1), this[t3 + i3] = (e4 / a3 >> 0) - s2 & 255;
          return t3 + r3;
        }, d.prototype.writeInt8 = function(e4, t3, r3) {
          return e4 = +e4, t3 >>>= 0, r3 || T2(this, e4, t3, 1, 127, -128), e4 < 0 && (e4 = 255 + e4 + 1), this[t3] = 255 & e4, t3 + 1;
        }, d.prototype.writeInt16LE = function(e4, t3, r3) {
          return e4 = +e4, t3 >>>= 0, r3 || T2(this, e4, t3, 2, 32767, -32768), this[t3] = 255 & e4, this[t3 + 1] = e4 >>> 8, t3 + 2;
        }, d.prototype.writeInt16BE = function(e4, t3, r3) {
          return e4 = +e4, t3 >>>= 0, r3 || T2(this, e4, t3, 2, 32767, -32768), this[t3] = e4 >>> 8, this[t3 + 1] = 255 & e4, t3 + 2;
        }, d.prototype.writeInt32LE = function(e4, t3, r3) {
          return e4 = +e4, t3 >>>= 0, r3 || T2(this, e4, t3, 4, 2147483647, -2147483648), this[t3] = 255 & e4, this[t3 + 1] = e4 >>> 8, this[t3 + 2] = e4 >>> 16, this[t3 + 3] = e4 >>> 24, t3 + 4;
        }, d.prototype.writeInt32BE = function(e4, t3, r3) {
          return e4 = +e4, t3 >>>= 0, r3 || T2(this, e4, t3, 4, 2147483647, -2147483648), e4 < 0 && (e4 = 4294967295 + e4 + 1), this[t3] = e4 >>> 24, this[t3 + 1] = e4 >>> 16, this[t3 + 2] = e4 >>> 8, this[t3 + 3] = 255 & e4, t3 + 4;
        }, d.prototype.writeFloatLE = function(e4, t3, r3) {
          return C(this, e4, t3, true, r3);
        }, d.prototype.writeFloatBE = function(e4, t3, r3) {
          return C(this, e4, t3, false, r3);
        }, d.prototype.writeDoubleLE = function(e4, t3, r3) {
          return L(this, e4, t3, true, r3);
        }, d.prototype.writeDoubleBE = function(e4, t3, r3) {
          return L(this, e4, t3, false, r3);
        }, d.prototype.copy = function(e4, t3, r3, n3) {
          if (!d.isBuffer(e4))
            throw new TypeError("argument should be a Buffer");
          if (r3 = r3 || 0, n3 || n3 === 0 || (n3 = this.length), t3 >= e4.length && (t3 = e4.length), t3 = t3 || 0, 0 < n3 && n3 < r3 && (n3 = r3), n3 === r3)
            return 0;
          if (e4.length === 0 || this.length === 0)
            return 0;
          if (t3 < 0)
            throw new RangeError("targetStart out of bounds");
          if (r3 < 0 || r3 >= this.length)
            throw new RangeError("Index out of range");
          if (n3 < 0)
            throw new RangeError("sourceEnd out of bounds");
          n3 > this.length && (n3 = this.length), e4.length - t3 < n3 - r3 && (n3 = e4.length - t3 + r3);
          var o3 = n3 - r3;
          if (this === e4 && typeof Uint8Array.prototype.copyWithin == "function")
            this.copyWithin(t3, r3, n3);
          else if (this === e4 && r3 < t3 && t3 < n3)
            for (var i3 = o3 - 1; 0 <= i3; --i3)
              e4[i3 + t3] = this[i3 + r3];
          else
            Uint8Array.prototype.set.call(e4, this.subarray(r3, n3), t3);
          return o3;
        }, d.prototype.fill = function(e4, t3, r3, n3) {
          if (typeof e4 == "string") {
            if (typeof t3 == "string" ? (n3 = t3, t3 = 0, r3 = this.length) : typeof r3 == "string" && (n3 = r3, r3 = this.length), n3 !== void 0 && typeof n3 != "string")
              throw new TypeError("encoding must be a string");
            if (typeof n3 == "string" && !d.isEncoding(n3))
              throw new TypeError("Unknown encoding: " + n3);
            if (e4.length === 1) {
              var o3 = e4.charCodeAt(0);
              (n3 === "utf8" && o3 < 128 || n3 === "latin1") && (e4 = o3);
            }
          } else
            typeof e4 == "number" ? e4 &= 255 : typeof e4 == "boolean" && (e4 = Number(e4));
          if (t3 < 0 || this.length < t3 || this.length < r3)
            throw new RangeError("Out of range index");
          if (r3 <= t3)
            return this;
          var i3;
          if (t3 >>>= 0, r3 = r3 === void 0 ? this.length : r3 >>> 0, typeof (e4 = e4 || 0) == "number")
            for (i3 = t3; i3 < r3; ++i3)
              this[i3] = e4;
          else {
            var a3 = d.isBuffer(e4) ? e4 : d.from(e4, n3), s2 = a3.length;
            if (s2 === 0)
              throw new TypeError('The value "' + e4 + '" is invalid for argument "value"');
            for (i3 = 0; i3 < r3 - t3; ++i3)
              this[i3 + t3] = a3[i3 % s2];
          }
          return this;
        };
        var t2 = /[^+/0-9A-Za-z-_]/g;
        function P2(e4, t3) {
          var r3;
          t3 = t3 || 1 / 0;
          for (var n3 = e4.length, o3 = null, i3 = [], a3 = 0; a3 < n3; ++a3) {
            if (55295 < (r3 = e4.charCodeAt(a3)) && r3 < 57344) {
              if (!o3) {
                if (56319 < r3) {
                  -1 < (t3 -= 3) && i3.push(239, 191, 189);
                  continue;
                }
                if (a3 + 1 === n3) {
                  -1 < (t3 -= 3) && i3.push(239, 191, 189);
                  continue;
                }
                o3 = r3;
                continue;
              }
              if (r3 < 56320) {
                -1 < (t3 -= 3) && i3.push(239, 191, 189), o3 = r3;
                continue;
              }
              r3 = 65536 + (o3 - 55296 << 10 | r3 - 56320);
            } else
              o3 && -1 < (t3 -= 3) && i3.push(239, 191, 189);
            if (o3 = null, r3 < 128) {
              if (--t3 < 0)
                break;
              i3.push(r3);
            } else if (r3 < 2048) {
              if ((t3 -= 2) < 0)
                break;
              i3.push(r3 >> 6 | 192, 63 & r3 | 128);
            } else if (r3 < 65536) {
              if ((t3 -= 3) < 0)
                break;
              i3.push(r3 >> 12 | 224, r3 >> 6 & 63 | 128, 63 & r3 | 128);
            } else {
              if (!(r3 < 1114112))
                throw new Error("Invalid code point");
              if ((t3 -= 4) < 0)
                break;
              i3.push(r3 >> 18 | 240, r3 >> 12 & 63 | 128, r3 >> 6 & 63 | 128, 63 & r3 | 128);
            }
          }
          return i3;
        }
        function A(e4) {
          return n2.toByteArray(function(e5) {
            if ((e5 = (e5 = e5.split("=")[0]).trim().replace(t2, "")).length < 2)
              return "";
            for (; e5.length % 4 != 0; )
              e5 += "=";
            return e5;
          }(e4));
        }
        function k2(e4, t3, r3, n3) {
          for (var o3 = 0; o3 < n3 && !(o3 + r3 >= t3.length || o3 >= e4.length); ++o3)
            t3[o3 + r3] = e4[o3];
          return o3;
        }
        function R2(e4, t3) {
          return e4 instanceof t3 || e4 != null && e4.constructor != null && e4.constructor.name != null && e4.constructor.name === t3.name;
        }
        function D(e4) {
          return e4 != e4;
        }
        var I = function() {
          for (var e4 = "0123456789abcdef", t3 = new Array(256), r3 = 0; r3 < 16; ++r3)
            for (var n3 = 16 * r3, o3 = 0; o3 < 16; ++o3)
              t3[n3 + o3] = e4[r3] + e4[o3];
          return t3;
        }();
      }).call(this, U("buffer").Buffer);
    }, { "base64-js": 1, buffer: 4, ieee754: 236 }], 5: [function(e2, t2, r2) {
      t2.exports = function(e3) {
        if (typeof e3 != "function")
          throw TypeError(String(e3) + " is not a function");
        return e3;
      };
    }, {}], 6: [function(e2, t2, r2) {
      var n2 = e2("../internals/is-object");
      t2.exports = function(e3) {
        if (!n2(e3) && e3 !== null)
          throw TypeError("Can't set " + String(e3) + " as a prototype");
        return e3;
      };
    }, { "../internals/is-object": 74 }], 7: [function(e2, t2, r2) {
      var n2 = e2("../internals/well-known-symbol"), o2 = e2("../internals/object-create"), i2 = e2("../internals/object-define-property"), a2 = n2("unscopables"), s = Array.prototype;
      s[a2] == null && i2.f(s, a2, { configurable: true, value: o2(null) }), t2.exports = function(e3) {
        s[a2][e3] = true;
      };
    }, { "../internals/object-create": 90, "../internals/object-define-property": 92, "../internals/well-known-symbol": 146 }], 8: [function(e2, t2, r2) {
      var n2 = e2("../internals/string-multibyte").charAt;
      t2.exports = function(e3, t3, r3) {
        return t3 + (r3 ? n2(e3, t3).length : 1);
      };
    }, { "../internals/string-multibyte": 123 }], 9: [function(e2, t2, r2) {
      t2.exports = function(e3, t3, r3) {
        if (!(e3 instanceof t3))
          throw TypeError("Incorrect " + (r3 ? r3 + " " : "") + "invocation");
        return e3;
      };
    }, {}], 10: [function(e2, t2, r2) {
      var n2 = e2("../internals/is-object");
      t2.exports = function(e3) {
        if (!n2(e3))
          throw TypeError(String(e3) + " is not an object");
        return e3;
      };
    }, { "../internals/is-object": 74 }], 11: [function(e2, t2, r2) {
      t2.exports = typeof ArrayBuffer != "undefined" && typeof DataView != "undefined";
    }, {}], 12: [function(e2, t2, r2) {
      function n2(e3) {
        return l2(e3) && u2(L, c(e3));
      }
      var o2, i2 = e2("../internals/array-buffer-native"), a2 = e2("../internals/descriptors"), s = e2("../internals/global"), l2 = e2("../internals/is-object"), u2 = e2("../internals/has"), c = e2("../internals/classof"), d = e2("../internals/create-non-enumerable-property"), f = e2("../internals/redefine"), h2 = e2("../internals/object-define-property").f, p2 = e2("../internals/object-get-prototype-of"), y = e2("../internals/object-set-prototype-of"), m2 = e2("../internals/well-known-symbol"), g = e2("../internals/uid"), v = s.Int8Array, b2 = v && v.prototype, _ = s.Uint8ClampedArray, x = _ && _.prototype, w = v && p2(v), j = b2 && p2(b2), S2 = Object.prototype, M = S2.isPrototypeOf, E = m2("toStringTag"), T2 = g("TYPED_ARRAY_TAG"), O2 = i2 && !!y && c(s.opera) !== "Opera", C = false, L = { Int8Array: 1, Uint8Array: 1, Uint8ClampedArray: 1, Int16Array: 2, Uint16Array: 2, Int32Array: 4, Uint32Array: 4, Float32Array: 4, Float64Array: 8 };
      for (o2 in L)
        s[o2] || (O2 = false);
      if ((!O2 || typeof w != "function" || w === Function.prototype) && (w = function() {
        throw TypeError("Incorrect invocation");
      }, O2))
        for (o2 in L)
          s[o2] && y(s[o2], w);
      if ((!O2 || !j || j === S2) && (j = w.prototype, O2))
        for (o2 in L)
          s[o2] && y(s[o2].prototype, j);
      if (O2 && p2(x) !== j && y(x, j), a2 && !u2(j, E))
        for (o2 in C = true, h2(j, E, { get: function() {
          return l2(this) ? this[T2] : void 0;
        } }), L)
          s[o2] && d(s[o2], T2, o2);
      t2.exports = { NATIVE_ARRAY_BUFFER_VIEWS: O2, TYPED_ARRAY_TAG: C && T2, aTypedArray: function(e3) {
        if (n2(e3))
          return e3;
        throw TypeError("Target is not a typed array");
      }, aTypedArrayConstructor: function(e3) {
        if (y) {
          if (M.call(w, e3))
            return e3;
        } else
          for (var t3 in L)
            if (u2(L, o2)) {
              var r3 = s[t3];
              if (r3 && (e3 === r3 || M.call(r3, e3)))
                return e3;
            }
        throw TypeError("Target is not a typed array constructor");
      }, exportTypedArrayMethod: function(e3, t3, r3) {
        if (a2) {
          if (r3)
            for (var n3 in L) {
              var o3 = s[n3];
              o3 && u2(o3.prototype, e3) && delete o3.prototype[e3];
            }
          j[e3] && !r3 || f(j, e3, r3 ? t3 : O2 && b2[e3] || t3);
        }
      }, exportTypedArrayStaticMethod: function(e3, t3, r3) {
        var n3, o3;
        if (a2) {
          if (y) {
            if (r3)
              for (n3 in L)
                (o3 = s[n3]) && u2(o3, e3) && delete o3[e3];
            if (w[e3] && !r3)
              return;
            try {
              return f(w, e3, r3 ? t3 : O2 && v[e3] || t3);
            } catch (e4) {
            }
          }
          for (n3 in L)
            !(o3 = s[n3]) || o3[e3] && !r3 || f(o3, e3, t3);
        }
      }, isView: function(e3) {
        var t3 = c(e3);
        return t3 === "DataView" || u2(L, t3);
      }, isTypedArray: n2, TypedArray: w, TypedArrayPrototype: j };
    }, { "../internals/array-buffer-native": 11, "../internals/classof": 29, "../internals/create-non-enumerable-property": 37, "../internals/descriptors": 42, "../internals/global": 59, "../internals/has": 60, "../internals/is-object": 74, "../internals/object-define-property": 92, "../internals/object-get-prototype-of": 97, "../internals/object-set-prototype-of": 101, "../internals/redefine": 108, "../internals/uid": 143, "../internals/well-known-symbol": 146 }], 13: [function(e2, t2, r2) {
      function n2(e3) {
        return [255 & e3];
      }
      function o2(e3) {
        return [255 & e3, e3 >> 8 & 255];
      }
      function i2(e3) {
        return [255 & e3, e3 >> 8 & 255, e3 >> 16 & 255, e3 >> 24 & 255];
      }
      function a2(e3) {
        return e3[3] << 24 | e3[2] << 16 | e3[1] << 8 | e3[0];
      }
      function s(e3) {
        return V(e3, 23, 4);
      }
      function l2(e3) {
        return V(e3, 52, 8);
      }
      function u2(e3, t3) {
        E(e3[R2], t3, { get: function() {
          return L(this)[t3];
        } });
      }
      function c(e3, t3, r3, n3) {
        var o3 = x(r3), i3 = L(e3);
        if (o3 + t3 > i3.byteLength)
          throw G(D);
        var a3 = L(i3.buffer).bytes, s2 = o3 + i3.byteOffset, l3 = a3.slice(s2, s2 + t3);
        return n3 ? l3 : l3.reverse();
      }
      function d(e3, t3, r3, n3, o3, i3) {
        var a3 = x(r3), s2 = L(e3);
        if (a3 + t3 > s2.byteLength)
          throw G(D);
        for (var l3 = L(s2.buffer).bytes, u3 = a3 + s2.byteOffset, c2 = n3(+o3), d2 = 0; d2 < t3; d2++)
          l3[u3 + d2] = c2[i3 ? d2 : t3 - d2 - 1];
      }
      var f = e2("../internals/global"), h2 = e2("../internals/descriptors"), p2 = e2("../internals/array-buffer-native"), y = e2("../internals/create-non-enumerable-property"), m2 = e2("../internals/redefine-all"), g = e2("../internals/fails"), v = e2("../internals/an-instance"), b2 = e2("../internals/to-integer"), _ = e2("../internals/to-length"), x = e2("../internals/to-index"), w = e2("../internals/ieee754"), j = e2("../internals/object-get-prototype-of"), S2 = e2("../internals/object-set-prototype-of"), M = e2("../internals/object-get-own-property-names").f, E = e2("../internals/object-define-property").f, T2 = e2("../internals/array-fill"), O2 = e2("../internals/set-to-string-tag"), C = e2("../internals/internal-state"), L = C.get, P2 = C.set, A = "ArrayBuffer", k2 = "DataView", R2 = "prototype", D = "Wrong index", I = f[A], U = I, N = f[k2], F = N && N[R2], B = Object.prototype, G = f.RangeError, V = w.pack, z = w.unpack;
      if (p2) {
        if (!g(function() {
          I(1);
        }) || !g(function() {
          new I(-1);
        }) || g(function() {
          return new I(), new I(1.5), new I(NaN), I.name != A;
        })) {
          for (var H, W2 = (U = function(e3) {
            return v(this, U), new I(x(e3));
          })[R2] = I[R2], q = M(I), X2 = 0; q.length > X2; )
            (H = q[X2++]) in U || y(U, H, I[H]);
          W2.constructor = U;
        }
        S2 && j(F) !== B && S2(F, B);
        var Y2 = new N(new U(2)), Z = F.setInt8;
        Y2.setInt8(0, 2147483648), Y2.setInt8(1, 2147483649), !Y2.getInt8(0) && Y2.getInt8(1) || m2(F, { setInt8: function(e3, t3) {
          Z.call(this, e3, t3 << 24 >> 24);
        }, setUint8: function(e3, t3) {
          Z.call(this, e3, t3 << 24 >> 24);
        } }, { unsafe: true });
      } else
        U = function(e3) {
          v(this, U, A);
          var t3 = x(e3);
          P2(this, { bytes: T2.call(new Array(t3), 0), byteLength: t3 }), h2 || (this.byteLength = t3);
        }, N = function(e3, t3, r3) {
          v(this, N, k2), v(e3, U, k2);
          var n3 = L(e3).byteLength, o3 = b2(t3);
          if (o3 < 0 || n3 < o3)
            throw G("Wrong offset");
          if (n3 < o3 + (r3 = r3 === void 0 ? n3 - o3 : _(r3)))
            throw G("Wrong length");
          P2(this, { buffer: e3, byteLength: r3, byteOffset: o3 }), h2 || (this.buffer = e3, this.byteLength = r3, this.byteOffset = o3);
        }, h2 && (u2(U, "byteLength"), u2(N, "buffer"), u2(N, "byteLength"), u2(N, "byteOffset")), m2(N[R2], { getInt8: function(e3) {
          return c(this, 1, e3)[0] << 24 >> 24;
        }, getUint8: function(e3) {
          return c(this, 1, e3)[0];
        }, getInt16: function(e3, t3) {
          var r3 = c(this, 2, e3, 1 < arguments.length ? t3 : void 0);
          return (r3[1] << 8 | r3[0]) << 16 >> 16;
        }, getUint16: function(e3, t3) {
          var r3 = c(this, 2, e3, 1 < arguments.length ? t3 : void 0);
          return r3[1] << 8 | r3[0];
        }, getInt32: function(e3, t3) {
          return a2(c(this, 4, e3, 1 < arguments.length ? t3 : void 0));
        }, getUint32: function(e3, t3) {
          return a2(c(this, 4, e3, 1 < arguments.length ? t3 : void 0)) >>> 0;
        }, getFloat32: function(e3, t3) {
          return z(c(this, 4, e3, 1 < arguments.length ? t3 : void 0), 23);
        }, getFloat64: function(e3, t3) {
          return z(c(this, 8, e3, 1 < arguments.length ? t3 : void 0), 52);
        }, setInt8: function(e3, t3) {
          d(this, 1, e3, n2, t3);
        }, setUint8: function(e3, t3) {
          d(this, 1, e3, n2, t3);
        }, setInt16: function(e3, t3, r3) {
          d(this, 2, e3, o2, t3, 2 < arguments.length ? r3 : void 0);
        }, setUint16: function(e3, t3, r3) {
          d(this, 2, e3, o2, t3, 2 < arguments.length ? r3 : void 0);
        }, setInt32: function(e3, t3, r3) {
          d(this, 4, e3, i2, t3, 2 < arguments.length ? r3 : void 0);
        }, setUint32: function(e3, t3, r3) {
          d(this, 4, e3, i2, t3, 2 < arguments.length ? r3 : void 0);
        }, setFloat32: function(e3, t3, r3) {
          d(this, 4, e3, s, t3, 2 < arguments.length ? r3 : void 0);
        }, setFloat64: function(e3, t3, r3) {
          d(this, 8, e3, l2, t3, 2 < arguments.length ? r3 : void 0);
        } });
      O2(U, A), O2(N, k2), t2.exports = { ArrayBuffer: U, DataView: N };
    }, { "../internals/an-instance": 9, "../internals/array-buffer-native": 11, "../internals/array-fill": 15, "../internals/create-non-enumerable-property": 37, "../internals/descriptors": 42, "../internals/fails": 50, "../internals/global": 59, "../internals/ieee754": 65, "../internals/internal-state": 70, "../internals/object-define-property": 92, "../internals/object-get-own-property-names": 95, "../internals/object-get-prototype-of": 97, "../internals/object-set-prototype-of": 101, "../internals/redefine-all": 107, "../internals/set-to-string-tag": 117, "../internals/to-index": 131, "../internals/to-integer": 133, "../internals/to-length": 134 }], 14: [function(e2, t2, r2) {
      var c = e2("../internals/to-object"), d = e2("../internals/to-absolute-index"), f = e2("../internals/to-length"), h2 = Math.min;
      t2.exports = [].copyWithin || function(e3, t3, r3) {
        var n2 = c(this), o2 = f(n2.length), i2 = d(e3, o2), a2 = d(t3, o2), s = 2 < arguments.length ? r3 : void 0, l2 = h2((s === void 0 ? o2 : d(s, o2)) - a2, o2 - i2), u2 = 1;
        for (a2 < i2 && i2 < a2 + l2 && (u2 = -1, a2 += l2 - 1, i2 += l2 - 1); 0 < l2--; )
          a2 in n2 ? n2[i2] = n2[a2] : delete n2[i2], i2 += u2, a2 += u2;
        return n2;
      };
    }, { "../internals/to-absolute-index": 130, "../internals/to-length": 134, "../internals/to-object": 135 }], 15: [function(e2, t2, r2) {
      var u2 = e2("../internals/to-object"), c = e2("../internals/to-absolute-index"), d = e2("../internals/to-length");
      t2.exports = function(e3, t3, r3) {
        for (var n2 = u2(this), o2 = d(n2.length), i2 = arguments.length, a2 = c(1 < i2 ? t3 : void 0, o2), s = 2 < i2 ? r3 : void 0, l2 = s === void 0 ? o2 : c(s, o2); a2 < l2; )
          n2[a2++] = e3;
        return n2;
      };
    }, { "../internals/to-absolute-index": 130, "../internals/to-length": 134, "../internals/to-object": 135 }], 16: [function(e2, t2, r2) {
      var n2 = e2("../internals/array-iteration").forEach, o2 = e2("../internals/array-method-is-strict"), i2 = e2("../internals/array-method-uses-to-length"), a2 = o2("forEach"), s = i2("forEach");
      t2.exports = a2 && s ? [].forEach : function(e3, t3) {
        return n2(this, e3, 1 < arguments.length ? t3 : void 0);
      };
    }, { "../internals/array-iteration": 19, "../internals/array-method-is-strict": 22, "../internals/array-method-uses-to-length": 23 }], 17: [function(e2, t2, r2) {
      var m2 = e2("../internals/function-bind-context"), g = e2("../internals/to-object"), v = e2("../internals/call-with-safe-iteration-closing"), b2 = e2("../internals/is-array-iterator-method"), _ = e2("../internals/to-length"), x = e2("../internals/create-property"), w = e2("../internals/get-iterator-method");
      t2.exports = function(e3, t3, r3) {
        var n2, o2, i2, a2, s, l2, u2 = g(e3), c = typeof this == "function" ? this : Array, d = arguments.length, f = 1 < d ? t3 : void 0, h2 = f !== void 0, p2 = w(u2), y = 0;
        if (h2 && (f = m2(f, 2 < d ? r3 : void 0, 2)), p2 == null || c == Array && b2(p2))
          for (o2 = new c(n2 = _(u2.length)); y < n2; y++)
            l2 = h2 ? f(u2[y], y) : u2[y], x(o2, y, l2);
        else
          for (s = (a2 = p2.call(u2)).next, o2 = new c(); !(i2 = s.call(a2)).done; y++)
            l2 = h2 ? v(a2, f, [i2.value, y], true) : i2.value, x(o2, y, l2);
        return o2.length = y, o2;
      };
    }, { "../internals/call-with-safe-iteration-closing": 26, "../internals/create-property": 39, "../internals/function-bind-context": 54, "../internals/get-iterator-method": 57, "../internals/is-array-iterator-method": 71, "../internals/to-length": 134, "../internals/to-object": 135 }], 18: [function(e2, t2, r2) {
      function n2(s) {
        return function(e3, t3, r3) {
          var n3, o2 = l2(e3), i2 = u2(o2.length), a2 = c(r3, i2);
          if (s && t3 != t3) {
            for (; a2 < i2; )
              if ((n3 = o2[a2++]) != n3)
                return true;
          } else
            for (; a2 < i2; a2++)
              if ((s || a2 in o2) && o2[a2] === t3)
                return s || a2 || 0;
          return !s && -1;
        };
      }
      var l2 = e2("../internals/to-indexed-object"), u2 = e2("../internals/to-length"), c = e2("../internals/to-absolute-index");
      t2.exports = { includes: n2(true), indexOf: n2(false) };
    }, { "../internals/to-absolute-index": 130, "../internals/to-indexed-object": 132, "../internals/to-length": 134 }], 19: [function(e2, t2, r2) {
      function n2(h2) {
        var p2 = h2 == 1, y = h2 == 2, m2 = h2 == 3, g = h2 == 4, v = h2 == 6, b2 = h2 == 5 || v;
        return function(e3, t3, r3, n3) {
          for (var o2, i2, a2 = w(e3), s = x(a2), l2 = _(t3, r3, 3), u2 = j(s.length), c = 0, d = n3 || S2, f = p2 ? d(e3, u2) : y ? d(e3, 0) : void 0; c < u2; c++)
            if ((b2 || c in s) && (i2 = l2(o2 = s[c], c, a2), h2)) {
              if (p2)
                f[c] = i2;
              else if (i2)
                switch (h2) {
                  case 3:
                    return true;
                  case 5:
                    return o2;
                  case 6:
                    return c;
                  case 2:
                    M.call(f, o2);
                }
              else if (g)
                return false;
            }
          return v ? -1 : m2 || g ? g : f;
        };
      }
      var _ = e2("../internals/function-bind-context"), x = e2("../internals/indexed-object"), w = e2("../internals/to-object"), j = e2("../internals/to-length"), S2 = e2("../internals/array-species-create"), M = [].push;
      t2.exports = { forEach: n2(0), map: n2(1), filter: n2(2), some: n2(3), every: n2(4), find: n2(5), findIndex: n2(6) };
    }, { "../internals/array-species-create": 25, "../internals/function-bind-context": 54, "../internals/indexed-object": 66, "../internals/to-length": 134, "../internals/to-object": 135 }], 20: [function(e2, t2, r2) {
      var i2 = e2("../internals/to-indexed-object"), a2 = e2("../internals/to-integer"), s = e2("../internals/to-length"), n2 = e2("../internals/array-method-is-strict"), o2 = e2("../internals/array-method-uses-to-length"), l2 = Math.min, u2 = [].lastIndexOf, c = !!u2 && 1 / [1].lastIndexOf(1, -0) < 0, d = n2("lastIndexOf"), f = o2("indexOf", { ACCESSORS: true, 1: 0 }), h2 = c || !d || !f;
      t2.exports = h2 ? function(e3, t3) {
        if (c)
          return u2.apply(this, arguments) || 0;
        var r3 = i2(this), n3 = s(r3.length), o3 = n3 - 1;
        for (1 < arguments.length && (o3 = l2(o3, a2(t3))), o3 < 0 && (o3 = n3 + o3); 0 <= o3; o3--)
          if (o3 in r3 && r3[o3] === e3)
            return o3 || 0;
        return -1;
      } : u2;
    }, { "../internals/array-method-is-strict": 22, "../internals/array-method-uses-to-length": 23, "../internals/to-indexed-object": 132, "../internals/to-integer": 133, "../internals/to-length": 134 }], 21: [function(e2, t2, r2) {
      var n2 = e2("../internals/fails"), o2 = e2("../internals/well-known-symbol"), i2 = e2("../internals/engine-v8-version"), a2 = o2("species");
      t2.exports = function(t3) {
        return 51 <= i2 || !n2(function() {
          var e3 = [];
          return (e3.constructor = {})[a2] = function() {
            return { foo: 1 };
          }, e3[t3](Boolean).foo !== 1;
        });
      };
    }, { "../internals/engine-v8-version": 47, "../internals/fails": 50, "../internals/well-known-symbol": 146 }], 22: [function(e2, t2, r2) {
      var n2 = e2("../internals/fails");
      t2.exports = function(e3, t3) {
        var r3 = [][e3];
        return !!r3 && n2(function() {
          r3.call(null, t3 || function() {
            throw 1;
          }, 1);
        });
      };
    }, { "../internals/fails": 50 }], 23: [function(e2, t2, r2) {
      function a2(e3) {
        throw e3;
      }
      var s = e2("../internals/descriptors"), l2 = e2("../internals/fails"), u2 = e2("../internals/has"), c = Object.defineProperty, d = {};
      t2.exports = function(e3, t3) {
        if (u2(d, e3))
          return d[e3];
        var r3 = [][e3], n2 = !!u2(t3 = t3 || {}, "ACCESSORS") && t3.ACCESSORS, o2 = u2(t3, 0) ? t3[0] : a2, i2 = u2(t3, 1) ? t3[1] : void 0;
        return d[e3] = !!r3 && !l2(function() {
          if (n2 && !s)
            return true;
          var e4 = { length: -1 };
          n2 ? c(e4, 1, { enumerable: true, get: a2 }) : e4[1] = 1, r3.call(e4, o2, i2);
        });
      };
    }, { "../internals/descriptors": 42, "../internals/fails": 50, "../internals/has": 60 }], 24: [function(e2, t2, r2) {
      function n2(u2) {
        return function(e3, t3, r3, n3) {
          c(t3);
          var o2 = d(e3), i2 = f(o2), a2 = h2(o2.length), s = u2 ? a2 - 1 : 0, l2 = u2 ? -1 : 1;
          if (r3 < 2)
            for (; ; ) {
              if (s in i2) {
                n3 = i2[s], s += l2;
                break;
              }
              if (s += l2, u2 ? s < 0 : a2 <= s)
                throw TypeError("Reduce of empty array with no initial value");
            }
          for (; u2 ? 0 <= s : s < a2; s += l2)
            s in i2 && (n3 = t3(n3, i2[s], s, o2));
          return n3;
        };
      }
      var c = e2("../internals/a-function"), d = e2("../internals/to-object"), f = e2("../internals/indexed-object"), h2 = e2("../internals/to-length");
      t2.exports = { left: n2(false), right: n2(true) };
    }, { "../internals/a-function": 5, "../internals/indexed-object": 66, "../internals/to-length": 134, "../internals/to-object": 135 }], 25: [function(e2, t2, r2) {
      var n2 = e2("../internals/is-object"), o2 = e2("../internals/is-array"), i2 = e2("../internals/well-known-symbol")("species");
      t2.exports = function(e3, t3) {
        var r3;
        return o2(e3) && (typeof (r3 = e3.constructor) != "function" || r3 !== Array && !o2(r3.prototype) ? n2(r3) && (r3 = r3[i2]) === null && (r3 = void 0) : r3 = void 0), new (r3 === void 0 ? Array : r3)(t3 === 0 ? 0 : t3);
      };
    }, { "../internals/is-array": 72, "../internals/is-object": 74, "../internals/well-known-symbol": 146 }], 26: [function(e2, t2, r2) {
      var i2 = e2("../internals/an-object");
      t2.exports = function(t3, e3, r3, n2) {
        try {
          return n2 ? e3(i2(r3)[0], r3[1]) : e3(r3);
        } catch (e4) {
          var o2 = t3.return;
          throw o2 !== void 0 && i2(o2.call(t3)), e4;
        }
      };
    }, { "../internals/an-object": 10 }], 27: [function(e2, t2, r2) {
      var o2 = e2("../internals/well-known-symbol")("iterator"), i2 = false;
      try {
        var n2 = 0, a2 = { next: function() {
          return { done: !!n2++ };
        }, return: function() {
          i2 = true;
        } };
        a2[o2] = function() {
          return this;
        }, Array.from(a2, function() {
          throw 2;
        });
      } catch (e3) {
      }
      t2.exports = function(e3, t3) {
        if (!t3 && !i2)
          return false;
        var r3 = false;
        try {
          var n3 = {};
          n3[o2] = function() {
            return { next: function() {
              return { done: r3 = true };
            } };
          }, e3(n3);
        } catch (e4) {
        }
        return r3;
      };
    }, { "../internals/well-known-symbol": 146 }], 28: [function(e2, t2, r2) {
      var n2 = {}.toString;
      t2.exports = function(e3) {
        return n2.call(e3).slice(8, -1);
      };
    }, {}], 29: [function(e2, t2, r2) {
      var n2 = e2("../internals/to-string-tag-support"), o2 = e2("../internals/classof-raw"), i2 = e2("../internals/well-known-symbol")("toStringTag"), a2 = o2(function() {
        return arguments;
      }()) == "Arguments";
      t2.exports = n2 ? o2 : function(e3) {
        var t3, r3, n3;
        return e3 === void 0 ? "Undefined" : e3 === null ? "Null" : typeof (r3 = function(e4, t4) {
          try {
            return e4[t4];
          } catch (e5) {
          }
        }(t3 = Object(e3), i2)) == "string" ? r3 : a2 ? o2(t3) : (n3 = o2(t3)) == "Object" && typeof t3.callee == "function" ? "Arguments" : n3;
      };
    }, { "../internals/classof-raw": 28, "../internals/to-string-tag-support": 139, "../internals/well-known-symbol": 146 }], 30: [function(e2, t2, r2) {
      var u2 = e2("../internals/object-define-property").f, c = e2("../internals/object-create"), d = e2("../internals/redefine-all"), f = e2("../internals/function-bind-context"), h2 = e2("../internals/an-instance"), p2 = e2("../internals/iterate"), a2 = e2("../internals/define-iterator"), s = e2("../internals/set-species"), y = e2("../internals/descriptors"), m2 = e2("../internals/internal-metadata").fastKey, n2 = e2("../internals/internal-state"), g = n2.set, v = n2.getterFor;
      t2.exports = { getConstructor: function(e3, r3, n3, o2) {
        function i2(e4, t3, r4) {
          var n4, o3, i3 = s2(e4), a4 = l2(e4, t3);
          return a4 ? a4.value = r4 : (i3.last = a4 = { index: o3 = m2(t3, true), key: t3, value: r4, previous: n4 = i3.last, next: void 0, removed: false }, i3.first || (i3.first = a4), n4 && (n4.next = a4), y ? i3.size++ : e4.size++, o3 !== "F" && (i3.index[o3] = a4)), e4;
        }
        var a3 = e3(function(e4, t3) {
          h2(e4, a3, r3), g(e4, { type: r3, index: c(null), first: void 0, last: void 0, size: 0 }), y || (e4.size = 0), t3 != null && p2(t3, e4[o2], e4, n3);
        }), s2 = v(r3), l2 = function(e4, t3) {
          var r4, n4 = s2(e4), o3 = m2(t3);
          if (o3 !== "F")
            return n4.index[o3];
          for (r4 = n4.first; r4; r4 = r4.next)
            if (r4.key == t3)
              return r4;
        };
        return d(a3.prototype, { clear: function() {
          for (var e4 = s2(this), t3 = e4.index, r4 = e4.first; r4; )
            r4.removed = true, r4.previous && (r4.previous = r4.previous.next = void 0), delete t3[r4.index], r4 = r4.next;
          e4.first = e4.last = void 0, y ? e4.size = 0 : this.size = 0;
        }, delete: function(e4) {
          var t3 = s2(this), r4 = l2(this, e4);
          if (r4) {
            var n4 = r4.next, o3 = r4.previous;
            delete t3.index[r4.index], r4.removed = true, o3 && (o3.next = n4), n4 && (n4.previous = o3), t3.first == r4 && (t3.first = n4), t3.last == r4 && (t3.last = o3), y ? t3.size-- : this.size--;
          }
          return !!r4;
        }, forEach: function(e4, t3) {
          for (var r4, n4 = s2(this), o3 = f(e4, 1 < arguments.length ? t3 : void 0, 3); r4 = r4 ? r4.next : n4.first; )
            for (o3(r4.value, r4.key, this); r4 && r4.removed; )
              r4 = r4.previous;
        }, has: function(e4) {
          return !!l2(this, e4);
        } }), d(a3.prototype, n3 ? { get: function(e4) {
          var t3 = l2(this, e4);
          return t3 && t3.value;
        }, set: function(e4, t3) {
          return i2(this, e4 === 0 ? 0 : e4, t3);
        } } : { add: function(e4) {
          return i2(this, e4 = e4 === 0 ? 0 : e4, e4);
        } }), y && u2(a3.prototype, "size", { get: function() {
          return s2(this).size;
        } }), a3;
      }, setStrong: function(e3, t3, r3) {
        var n3 = t3 + " Iterator", o2 = v(t3), i2 = v(n3);
        a2(e3, t3, function(e4, t4) {
          g(this, { type: n3, target: e4, state: o2(e4), kind: t4, last: void 0 });
        }, function() {
          for (var e4 = i2(this), t4 = e4.kind, r4 = e4.last; r4 && r4.removed; )
            r4 = r4.previous;
          return e4.target && (e4.last = r4 = r4 ? r4.next : e4.state.first) ? t4 == "keys" ? { value: r4.key, done: false } : t4 == "values" ? { value: r4.value, done: false } : { value: [r4.key, r4.value], done: false } : { value: e4.target = void 0, done: true };
        }, r3 ? "entries" : "values", !r3, true), s(t3);
      } };
    }, { "../internals/an-instance": 9, "../internals/define-iterator": 40, "../internals/descriptors": 42, "../internals/function-bind-context": 54, "../internals/internal-metadata": 69, "../internals/internal-state": 70, "../internals/iterate": 77, "../internals/object-create": 90, "../internals/object-define-property": 92, "../internals/redefine-all": 107, "../internals/set-species": 116 }], 31: [function(e2, t2, r2) {
      var m2 = e2("../internals/export"), g = e2("../internals/global"), v = e2("../internals/is-forced"), b2 = e2("../internals/redefine"), _ = e2("../internals/internal-metadata"), x = e2("../internals/iterate"), w = e2("../internals/an-instance"), j = e2("../internals/is-object"), S2 = e2("../internals/fails"), M = e2("../internals/check-correctness-of-iteration"), E = e2("../internals/set-to-string-tag"), T2 = e2("../internals/inherit-if-required");
      t2.exports = function(n2, e3, t3) {
        function r3(e4) {
          var r4 = l2[e4];
          b2(l2, e4, e4 == "add" ? function(e5) {
            return r4.call(this, e5 === 0 ? 0 : e5), this;
          } : e4 == "delete" ? function(e5) {
            return !(i2 && !j(e5)) && r4.call(this, e5 === 0 ? 0 : e5);
          } : e4 == "get" ? function(e5) {
            return i2 && !j(e5) ? void 0 : r4.call(this, e5 === 0 ? 0 : e5);
          } : e4 == "has" ? function(e5) {
            return !(i2 && !j(e5)) && r4.call(this, e5 === 0 ? 0 : e5);
          } : function(e5, t4) {
            return r4.call(this, e5 === 0 ? 0 : e5, t4), this;
          });
        }
        var o2 = n2.indexOf("Map") !== -1, i2 = n2.indexOf("Weak") !== -1, a2 = o2 ? "set" : "add", s = g[n2], l2 = s && s.prototype, u2 = s, c = {};
        if (v(n2, typeof s != "function" || !(i2 || l2.forEach && !S2(function() {
          new s().entries().next();
        }))))
          u2 = t3.getConstructor(e3, n2, o2, a2), _.REQUIRED = true;
        else if (v(n2, true)) {
          var d = new u2(), f = d[a2](i2 ? {} : -0, 1) != d, h2 = S2(function() {
            d.has(1);
          }), p2 = M(function(e4) {
            new s(e4);
          }), y = !i2 && S2(function() {
            for (var e4 = new s(), t4 = 5; t4--; )
              e4[a2](t4, t4);
            return !e4.has(-0);
          });
          p2 || (((u2 = e3(function(e4, t4) {
            w(e4, u2, n2);
            var r4 = T2(new s(), e4, u2);
            return t4 != null && x(t4, r4[a2], r4, o2), r4;
          })).prototype = l2).constructor = u2), (h2 || y) && (r3("delete"), r3("has"), o2 && r3("get")), (y || f) && r3(a2), i2 && l2.clear && delete l2.clear;
        }
        return c[n2] = u2, m2({ global: true, forced: u2 != s }, c), E(u2, n2), i2 || t3.setStrong(u2, n2, o2), u2;
      };
    }, { "../internals/an-instance": 9, "../internals/check-correctness-of-iteration": 27, "../internals/export": 49, "../internals/fails": 50, "../internals/global": 59, "../internals/inherit-if-required": 67, "../internals/internal-metadata": 69, "../internals/is-forced": 73, "../internals/is-object": 74, "../internals/iterate": 77, "../internals/redefine": 108, "../internals/set-to-string-tag": 117 }], 32: [function(e2, t2, r2) {
      var s = e2("../internals/has"), l2 = e2("../internals/own-keys"), u2 = e2("../internals/object-get-own-property-descriptor"), c = e2("../internals/object-define-property");
      t2.exports = function(e3, t3) {
        for (var r3 = l2(t3), n2 = c.f, o2 = u2.f, i2 = 0; i2 < r3.length; i2++) {
          var a2 = r3[i2];
          s(e3, a2) || n2(e3, a2, o2(t3, a2));
        }
      };
    }, { "../internals/has": 60, "../internals/object-define-property": 92, "../internals/object-get-own-property-descriptor": 93, "../internals/own-keys": 103 }], 33: [function(e2, t2, r2) {
      var n2 = e2("../internals/well-known-symbol")("match");
      t2.exports = function(t3) {
        var r3 = /./;
        try {
          "/./"[t3](r3);
        } catch (e3) {
          try {
            return r3[n2] = false, "/./"[t3](r3);
          } catch (e4) {
          }
        }
        return false;
      };
    }, { "../internals/well-known-symbol": 146 }], 34: [function(e2, t2, r2) {
      var n2 = e2("../internals/fails");
      t2.exports = !n2(function() {
        function e3() {
        }
        return e3.prototype.constructor = null, Object.getPrototypeOf(new e3()) !== e3.prototype;
      });
    }, { "../internals/fails": 50 }], 35: [function(e2, t2, r2) {
      var a2 = e2("../internals/require-object-coercible"), s = /"/g;
      t2.exports = function(e3, t3, r3, n2) {
        var o2 = String(a2(e3)), i2 = "<" + t3;
        return r3 !== "" && (i2 += " " + r3 + '="' + String(n2).replace(s, "&quot;") + '"'), i2 + ">" + o2 + "</" + t3 + ">";
      };
    }, { "../internals/require-object-coercible": 113 }], 36: [function(e2, t2, r2) {
      function o2() {
        return this;
      }
      var i2 = e2("../internals/iterators-core").IteratorPrototype, a2 = e2("../internals/object-create"), s = e2("../internals/create-property-descriptor"), l2 = e2("../internals/set-to-string-tag"), u2 = e2("../internals/iterators");
      t2.exports = function(e3, t3, r3) {
        var n2 = t3 + " Iterator";
        return e3.prototype = a2(i2, { next: s(1, r3) }), l2(e3, n2, false, true), u2[n2] = o2, e3;
      };
    }, { "../internals/create-property-descriptor": 38, "../internals/iterators": 79, "../internals/iterators-core": 78, "../internals/object-create": 90, "../internals/set-to-string-tag": 117 }], 37: [function(e2, t2, r2) {
      var n2 = e2("../internals/descriptors"), o2 = e2("../internals/object-define-property"), i2 = e2("../internals/create-property-descriptor");
      t2.exports = n2 ? function(e3, t3, r3) {
        return o2.f(e3, t3, i2(1, r3));
      } : function(e3, t3, r3) {
        return e3[t3] = r3, e3;
      };
    }, { "../internals/create-property-descriptor": 38, "../internals/descriptors": 42, "../internals/object-define-property": 92 }], 38: [function(e2, t2, r2) {
      t2.exports = function(e3, t3) {
        return { enumerable: !(1 & e3), configurable: !(2 & e3), writable: !(4 & e3), value: t3 };
      };
    }, {}], 39: [function(e2, t2, r2) {
      var o2 = e2("../internals/to-primitive"), i2 = e2("../internals/object-define-property"), a2 = e2("../internals/create-property-descriptor");
      t2.exports = function(e3, t3, r3) {
        var n2 = o2(t3);
        n2 in e3 ? i2.f(e3, n2, a2(0, r3)) : e3[n2] = r3;
      };
    }, { "../internals/create-property-descriptor": 38, "../internals/object-define-property": 92, "../internals/to-primitive": 138 }], 40: [function(e2, t2, r2) {
      function g() {
        return this;
      }
      var v = e2("../internals/export"), b2 = e2("../internals/create-iterator-constructor"), _ = e2("../internals/object-get-prototype-of"), x = e2("../internals/object-set-prototype-of"), w = e2("../internals/set-to-string-tag"), j = e2("../internals/create-non-enumerable-property"), S2 = e2("../internals/redefine"), n2 = e2("../internals/well-known-symbol"), M = e2("../internals/is-pure"), E = e2("../internals/iterators"), o2 = e2("../internals/iterators-core"), T2 = o2.IteratorPrototype, O2 = o2.BUGGY_SAFARI_ITERATORS, C = n2("iterator"), L = "values", P2 = "entries";
      t2.exports = function(e3, t3, r3, n3, o3, i2, a2) {
        b2(r3, t3, n3);
        function s(e4) {
          if (e4 === o3 && y)
            return y;
          if (!O2 && e4 in h2)
            return h2[e4];
          switch (e4) {
            case "keys":
            case L:
            case P2:
              return function() {
                return new r3(this, e4);
              };
          }
          return function() {
            return new r3(this);
          };
        }
        var l2, u2, c, d = t3 + " Iterator", f = false, h2 = e3.prototype, p2 = h2[C] || h2["@@iterator"] || o3 && h2[o3], y = !O2 && p2 || s(o3), m2 = t3 == "Array" && h2.entries || p2;
        if (m2 && (l2 = _(m2.call(new e3())), T2 !== Object.prototype && l2.next && (M || _(l2) === T2 || (x ? x(l2, T2) : typeof l2[C] != "function" && j(l2, C, g)), w(l2, d, true, true), M && (E[d] = g))), o3 == L && p2 && p2.name !== L && (f = true, y = function() {
          return p2.call(this);
        }), M && !a2 || h2[C] === y || j(h2, C, y), E[t3] = y, o3)
          if (u2 = { values: s(L), keys: i2 ? y : s("keys"), entries: s(P2) }, a2)
            for (c in u2)
              !O2 && !f && c in h2 || S2(h2, c, u2[c]);
          else
            v({ target: t3, proto: true, forced: O2 || f }, u2);
        return u2;
      };
    }, { "../internals/create-iterator-constructor": 36, "../internals/create-non-enumerable-property": 37, "../internals/export": 49, "../internals/is-pure": 75, "../internals/iterators": 79, "../internals/iterators-core": 78, "../internals/object-get-prototype-of": 97, "../internals/object-set-prototype-of": 101, "../internals/redefine": 108, "../internals/set-to-string-tag": 117, "../internals/well-known-symbol": 146 }], 41: [function(e2, t2, r2) {
      var n2 = e2("../internals/path"), o2 = e2("../internals/has"), i2 = e2("../internals/well-known-symbol-wrapped"), a2 = e2("../internals/object-define-property").f;
      t2.exports = function(e3) {
        var t3 = n2.Symbol || (n2.Symbol = {});
        o2(t3, e3) || a2(t3, e3, { value: i2.f(e3) });
      };
    }, { "../internals/has": 60, "../internals/object-define-property": 92, "../internals/path": 104, "../internals/well-known-symbol-wrapped": 145 }], 42: [function(e2, t2, r2) {
      var n2 = e2("../internals/fails");
      t2.exports = !n2(function() {
        return Object.defineProperty({}, 1, { get: function() {
          return 7;
        } })[1] != 7;
      });
    }, { "../internals/fails": 50 }], 43: [function(e2, t2, r2) {
      var n2 = e2("../internals/global"), o2 = e2("../internals/is-object"), i2 = n2.document, a2 = o2(i2) && o2(i2.createElement);
      t2.exports = function(e3) {
        return a2 ? i2.createElement(e3) : {};
      };
    }, { "../internals/global": 59, "../internals/is-object": 74 }], 44: [function(e2, t2, r2) {
      t2.exports = { CSSRuleList: 0, CSSStyleDeclaration: 0, CSSValueList: 0, ClientRectList: 0, DOMRectList: 0, DOMStringList: 0, DOMTokenList: 1, DataTransferItemList: 0, FileList: 0, HTMLAllCollection: 0, HTMLCollection: 0, HTMLFormElement: 0, HTMLSelectElement: 0, MediaList: 0, MimeTypeArray: 0, NamedNodeMap: 0, NodeList: 1, PaintRequestList: 0, Plugin: 0, PluginArray: 0, SVGLengthList: 0, SVGNumberList: 0, SVGPathSegList: 0, SVGPointList: 0, SVGStringList: 0, SVGTransformList: 0, SourceBufferList: 0, StyleSheetList: 0, TextTrackCueList: 0, TextTrackList: 0, TouchList: 0 };
    }, {}], 45: [function(e2, t2, r2) {
      var n2 = e2("../internals/engine-user-agent");
      t2.exports = /(iphone|ipod|ipad).*applewebkit/i.test(n2);
    }, { "../internals/engine-user-agent": 46 }], 46: [function(e2, t2, r2) {
      var n2 = e2("../internals/get-built-in");
      t2.exports = n2("navigator", "userAgent") || "";
    }, { "../internals/get-built-in": 56 }], 47: [function(e2, t2, r2) {
      var n2, o2, i2 = e2("../internals/global"), a2 = e2("../internals/engine-user-agent"), s = i2.process, l2 = s && s.versions, u2 = l2 && l2.v8;
      u2 ? o2 = (n2 = u2.split("."))[0] + n2[1] : a2 && (!(n2 = a2.match(/Edge\/(\d+)/)) || 74 <= n2[1]) && (n2 = a2.match(/Chrome\/(\d+)/)) && (o2 = n2[1]), t2.exports = o2 && +o2;
    }, { "../internals/engine-user-agent": 46, "../internals/global": 59 }], 48: [function(e2, t2, r2) {
      t2.exports = ["constructor", "hasOwnProperty", "isPrototypeOf", "propertyIsEnumerable", "toLocaleString", "toString", "valueOf"];
    }, {}], 49: [function(e2, t2, r2) {
      var c = e2("../internals/global"), d = e2("../internals/object-get-own-property-descriptor").f, f = e2("../internals/create-non-enumerable-property"), h2 = e2("../internals/redefine"), p2 = e2("../internals/set-global"), y = e2("../internals/copy-constructor-properties"), m2 = e2("../internals/is-forced");
      t2.exports = function(e3, t3) {
        var r3, n2, o2, i2, a2, s = e3.target, l2 = e3.global, u2 = e3.stat;
        if (r3 = l2 ? c : u2 ? c[s] || p2(s, {}) : (c[s] || {}).prototype)
          for (n2 in t3) {
            if (i2 = t3[n2], o2 = e3.noTargetGet ? (a2 = d(r3, n2)) && a2.value : r3[n2], !m2(l2 ? n2 : s + (u2 ? "." : "#") + n2, e3.forced) && o2 !== void 0) {
              if (typeof i2 == typeof o2)
                continue;
              y(i2, o2);
            }
            (e3.sham || o2 && o2.sham) && f(i2, "sham", true), h2(r3, n2, i2, e3);
          }
      };
    }, { "../internals/copy-constructor-properties": 32, "../internals/create-non-enumerable-property": 37, "../internals/global": 59, "../internals/is-forced": 73, "../internals/object-get-own-property-descriptor": 93, "../internals/redefine": 108, "../internals/set-global": 115 }], 50: [function(e2, t2, r2) {
      t2.exports = function(e3) {
        try {
          return !!e3();
        } catch (e4) {
          return true;
        }
      };
    }, {}], 51: [function(e2, t2, r2) {
      e2("../modules/es.regexp.exec");
      var d = e2("../internals/redefine"), f = e2("../internals/fails"), h2 = e2("../internals/well-known-symbol"), p2 = e2("../internals/regexp-exec"), y = e2("../internals/create-non-enumerable-property"), m2 = h2("species"), g = !f(function() {
        var e3 = /./;
        return e3.exec = function() {
          var e4 = [];
          return e4.groups = { a: "7" }, e4;
        }, "".replace(e3, "$<a>") !== "7";
      }), v = "a".replace(/./, "$0") === "$0", n2 = h2("replace"), b2 = !!/./[n2] && /./[n2]("a", "$0") === "", _ = !f(function() {
        var e3 = /(?:)/, t3 = e3.exec;
        e3.exec = function() {
          return t3.apply(this, arguments);
        };
        var r3 = "ab".split(e3);
        return r3.length !== 2 || r3[0] !== "a" || r3[1] !== "b";
      });
      t2.exports = function(r3, e3, t3, n3) {
        var o2 = h2(r3), i2 = !f(function() {
          var e4 = {};
          return e4[o2] = function() {
            return 7;
          }, ""[r3](e4) != 7;
        }), a2 = i2 && !f(function() {
          var e4 = false, t4 = /a/;
          return r3 === "split" && ((t4 = { constructor: {} }).constructor[m2] = function() {
            return t4;
          }, t4.flags = "", t4[o2] = /./[o2]), t4.exec = function() {
            return e4 = true, null;
          }, t4[o2](""), !e4;
        });
        if (!i2 || !a2 || r3 === "replace" && (!g || !v || b2) || r3 === "split" && !_) {
          var s = /./[o2], l2 = t3(o2, ""[r3], function(e4, t4, r4, n4, o3) {
            return t4.exec === p2 ? i2 && !o3 ? { done: true, value: s.call(t4, r4, n4) } : { done: true, value: e4.call(r4, t4, n4) } : { done: false };
          }, { REPLACE_KEEPS_$0: v, REGEXP_REPLACE_SUBSTITUTES_UNDEFINED_CAPTURE: b2 }), u2 = l2[0], c = l2[1];
          d(String.prototype, r3, u2), d(RegExp.prototype, o2, e3 == 2 ? function(e4, t4) {
            return c.call(e4, this, t4);
          } : function(e4) {
            return c.call(e4, this);
          });
        }
        n3 && y(RegExp.prototype[o2], "sham", true);
      };
    }, { "../internals/create-non-enumerable-property": 37, "../internals/fails": 50, "../internals/redefine": 108, "../internals/regexp-exec": 110, "../internals/well-known-symbol": 146, "../modules/es.regexp.exec": 181 }], 52: [function(e2, t2, r2) {
      var f = e2("../internals/is-array"), h2 = e2("../internals/to-length"), p2 = e2("../internals/function-bind-context"), y = function(e3, t3, r3, n2, o2, i2, a2, s) {
        for (var l2, u2 = o2, c = 0, d = !!a2 && p2(a2, s, 3); c < n2; ) {
          if (c in r3) {
            if (l2 = d ? d(r3[c], c, t3) : r3[c], 0 < i2 && f(l2))
              u2 = y(e3, t3, l2, h2(l2.length), u2, i2 - 1) - 1;
            else {
              if (9007199254740991 <= u2)
                throw TypeError("Exceed the acceptable array length");
              e3[u2] = l2;
            }
            u2++;
          }
          c++;
        }
        return u2;
      };
      t2.exports = y;
    }, { "../internals/function-bind-context": 54, "../internals/is-array": 72, "../internals/to-length": 134 }], 53: [function(e2, t2, r2) {
      var n2 = e2("../internals/fails");
      t2.exports = !n2(function() {
        return Object.isExtensible(Object.preventExtensions({}));
      });
    }, { "../internals/fails": 50 }], 54: [function(e2, t2, r2) {
      var i2 = e2("../internals/a-function");
      t2.exports = function(n2, o2, e3) {
        if (i2(n2), o2 === void 0)
          return n2;
        switch (e3) {
          case 0:
            return function() {
              return n2.call(o2);
            };
          case 1:
            return function(e4) {
              return n2.call(o2, e4);
            };
          case 2:
            return function(e4, t3) {
              return n2.call(o2, e4, t3);
            };
          case 3:
            return function(e4, t3, r3) {
              return n2.call(o2, e4, t3, r3);
            };
        }
        return function() {
          return n2.apply(o2, arguments);
        };
      };
    }, { "../internals/a-function": 5 }], 55: [function(e2, t2, r2) {
      var i2 = e2("../internals/a-function"), a2 = e2("../internals/is-object"), s = [].slice, l2 = {};
      t2.exports = Function.bind || function(t3) {
        var r3 = i2(this), n2 = s.call(arguments, 1), o2 = function() {
          var e3 = n2.concat(s.call(arguments));
          return this instanceof o2 ? function(e4, t4, r4) {
            if (!(t4 in l2)) {
              for (var n3 = [], o3 = 0; o3 < t4; o3++)
                n3[o3] = "a[" + o3 + "]";
              l2[t4] = Function("C,a", "return new C(" + n3.join(",") + ")");
            }
            return l2[t4](e4, r4);
          }(r3, e3.length, e3) : r3.apply(t3, e3);
        };
        return a2(r3.prototype) && (o2.prototype = r3.prototype), o2;
      };
    }, { "../internals/a-function": 5, "../internals/is-object": 74 }], 56: [function(e2, t2, r2) {
      function n2(e3) {
        return typeof e3 == "function" ? e3 : void 0;
      }
      var o2 = e2("../internals/path"), i2 = e2("../internals/global");
      t2.exports = function(e3, t3) {
        return arguments.length < 2 ? n2(o2[e3]) || n2(i2[e3]) : o2[e3] && o2[e3][t3] || i2[e3] && i2[e3][t3];
      };
    }, { "../internals/global": 59, "../internals/path": 104 }], 57: [function(e2, t2, r2) {
      var n2 = e2("../internals/classof"), o2 = e2("../internals/iterators"), i2 = e2("../internals/well-known-symbol")("iterator");
      t2.exports = function(e3) {
        if (e3 != null)
          return e3[i2] || e3["@@iterator"] || o2[n2(e3)];
      };
    }, { "../internals/classof": 29, "../internals/iterators": 79, "../internals/well-known-symbol": 146 }], 58: [function(e2, t2, r2) {
      var n2 = e2("../internals/an-object"), o2 = e2("../internals/get-iterator-method");
      t2.exports = function(e3) {
        var t3 = o2(e3);
        if (typeof t3 != "function")
          throw TypeError(String(e3) + " is not iterable");
        return n2(t3.call(e3));
      };
    }, { "../internals/an-object": 10, "../internals/get-iterator-method": 57 }], 59: [function(e2, r2, t2) {
      (function(e3) {
        function t3(e4) {
          return e4 && e4.Math == Math && e4;
        }
        r2.exports = t3(typeof globalThis == "object" && globalThis) || t3(typeof window == "object" && window) || t3(typeof self == "object" && self) || t3(typeof e3 == "object" && e3) || Function("return this")();
      }).call(this, typeof commonjsGlobal != "undefined" ? commonjsGlobal : typeof self != "undefined" ? self : typeof window != "undefined" ? window : {});
    }, {}], 60: [function(e2, t2, r2) {
      var n2 = {}.hasOwnProperty;
      t2.exports = function(e3, t3) {
        return n2.call(e3, t3);
      };
    }, {}], 61: [function(e2, t2, r2) {
      t2.exports = {};
    }, {}], 62: [function(e2, t2, r2) {
      var n2 = e2("../internals/global");
      t2.exports = function(e3, t3) {
        var r3 = n2.console;
        r3 && r3.error && (arguments.length === 1 ? r3.error(e3) : r3.error(e3, t3));
      };
    }, { "../internals/global": 59 }], 63: [function(e2, t2, r2) {
      var n2 = e2("../internals/get-built-in");
      t2.exports = n2("document", "documentElement");
    }, { "../internals/get-built-in": 56 }], 64: [function(e2, t2, r2) {
      var n2 = e2("../internals/descriptors"), o2 = e2("../internals/fails"), i2 = e2("../internals/document-create-element");
      t2.exports = !n2 && !o2(function() {
        return Object.defineProperty(i2("div"), "a", { get: function() {
          return 7;
        } }).a != 7;
      });
    }, { "../internals/descriptors": 42, "../internals/document-create-element": 43, "../internals/fails": 50 }], 65: [function(e2, t2, r2) {
      var h2 = Math.abs, p2 = Math.pow, y = Math.floor, m2 = Math.log, g = Math.LN2;
      t2.exports = { pack: function(e3, t3, r3) {
        var n2, o2, i2, a2 = new Array(r3), s = 8 * r3 - t3 - 1, l2 = (1 << s) - 1, u2 = l2 >> 1, c = t3 === 23 ? p2(2, -24) - p2(2, -77) : 0, d = e3 < 0 || e3 === 0 && 1 / e3 < 0 ? 1 : 0, f = 0;
        for ((e3 = h2(e3)) != e3 || e3 === 1 / 0 ? (o2 = e3 != e3 ? 1 : 0, n2 = l2) : (n2 = y(m2(e3) / g), e3 * (i2 = p2(2, -n2)) < 1 && (n2--, i2 *= 2), 2 <= (e3 += 1 <= n2 + u2 ? c / i2 : c * p2(2, 1 - u2)) * i2 && (n2++, i2 /= 2), l2 <= n2 + u2 ? (o2 = 0, n2 = l2) : 1 <= n2 + u2 ? (o2 = (e3 * i2 - 1) * p2(2, t3), n2 += u2) : (o2 = e3 * p2(2, u2 - 1) * p2(2, t3), n2 = 0)); 8 <= t3; a2[f++] = 255 & o2, o2 /= 256, t3 -= 8)
          ;
        for (n2 = n2 << t3 | o2, s += t3; 0 < s; a2[f++] = 255 & n2, n2 /= 256, s -= 8)
          ;
        return a2[--f] |= 128 * d, a2;
      }, unpack: function(e3, t3) {
        var r3, n2 = e3.length, o2 = 8 * n2 - t3 - 1, i2 = (1 << o2) - 1, a2 = i2 >> 1, s = o2 - 7, l2 = n2 - 1, u2 = e3[l2--], c = 127 & u2;
        for (u2 >>= 7; 0 < s; c = 256 * c + e3[l2], l2--, s -= 8)
          ;
        for (r3 = c & (1 << -s) - 1, c >>= -s, s += t3; 0 < s; r3 = 256 * r3 + e3[l2], l2--, s -= 8)
          ;
        if (c === 0)
          c = 1 - a2;
        else {
          if (c === i2)
            return r3 ? NaN : u2 ? -1 / 0 : 1 / 0;
          r3 += p2(2, t3), c -= a2;
        }
        return (u2 ? -1 : 1) * r3 * p2(2, c - t3);
      } };
    }, {}], 66: [function(e2, t2, r2) {
      var n2 = e2("../internals/fails"), o2 = e2("../internals/classof-raw"), i2 = "".split;
      t2.exports = n2(function() {
        return !Object("z").propertyIsEnumerable(0);
      }) ? function(e3) {
        return o2(e3) == "String" ? i2.call(e3, "") : Object(e3);
      } : Object;
    }, { "../internals/classof-raw": 28, "../internals/fails": 50 }], 67: [function(e2, t2, r2) {
      var i2 = e2("../internals/is-object"), a2 = e2("../internals/object-set-prototype-of");
      t2.exports = function(e3, t3, r3) {
        var n2, o2;
        return a2 && typeof (n2 = t3.constructor) == "function" && n2 !== r3 && i2(o2 = n2.prototype) && o2 !== r3.prototype && a2(e3, o2), e3;
      };
    }, { "../internals/is-object": 74, "../internals/object-set-prototype-of": 101 }], 68: [function(e2, t2, r2) {
      var n2 = e2("../internals/shared-store"), o2 = Function.toString;
      typeof n2.inspectSource != "function" && (n2.inspectSource = function(e3) {
        return o2.call(e3);
      }), t2.exports = n2.inspectSource;
    }, { "../internals/shared-store": 119 }], 69: [function(e2, t2, r2) {
      function n2(e3) {
        s(e3, c, { value: { objectID: "O" + ++d, weakData: {} } });
      }
      var o2 = e2("../internals/hidden-keys"), i2 = e2("../internals/is-object"), a2 = e2("../internals/has"), s = e2("../internals/object-define-property").f, l2 = e2("../internals/uid"), u2 = e2("../internals/freezing"), c = l2("meta"), d = 0, f = Object.isExtensible || function() {
        return true;
      }, h2 = t2.exports = { REQUIRED: false, fastKey: function(e3, t3) {
        if (!i2(e3))
          return typeof e3 == "symbol" ? e3 : (typeof e3 == "string" ? "S" : "P") + e3;
        if (!a2(e3, c)) {
          if (!f(e3))
            return "F";
          if (!t3)
            return "E";
          n2(e3);
        }
        return e3[c].objectID;
      }, getWeakData: function(e3, t3) {
        if (!a2(e3, c)) {
          if (!f(e3))
            return true;
          if (!t3)
            return false;
          n2(e3);
        }
        return e3[c].weakData;
      }, onFreeze: function(e3) {
        return u2 && h2.REQUIRED && f(e3) && !a2(e3, c) && n2(e3), e3;
      } };
      o2[c] = true;
    }, { "../internals/freezing": 53, "../internals/has": 60, "../internals/hidden-keys": 61, "../internals/is-object": 74, "../internals/object-define-property": 92, "../internals/uid": 143 }], 70: [function(e2, t2, r2) {
      var n2, o2, i2, a2 = e2("../internals/native-weak-map"), s = e2("../internals/global"), l2 = e2("../internals/is-object"), u2 = e2("../internals/create-non-enumerable-property"), c = e2("../internals/has"), d = e2("../internals/shared-key"), f = e2("../internals/hidden-keys"), h2 = s.WeakMap;
      if (a2) {
        var p2 = new h2(), y = p2.get, m2 = p2.has, g = p2.set;
        n2 = function(e3, t3) {
          return g.call(p2, e3, t3), t3;
        }, o2 = function(e3) {
          return y.call(p2, e3) || {};
        }, i2 = function(e3) {
          return m2.call(p2, e3);
        };
      } else {
        var v = d("state");
        f[v] = true, n2 = function(e3, t3) {
          return u2(e3, v, t3), t3;
        }, o2 = function(e3) {
          return c(e3, v) ? e3[v] : {};
        }, i2 = function(e3) {
          return c(e3, v);
        };
      }
      t2.exports = { set: n2, get: o2, has: i2, enforce: function(e3) {
        return i2(e3) ? o2(e3) : n2(e3, {});
      }, getterFor: function(r3) {
        return function(e3) {
          var t3;
          if (!l2(e3) || (t3 = o2(e3)).type !== r3)
            throw TypeError("Incompatible receiver, " + r3 + " required");
          return t3;
        };
      } };
    }, { "../internals/create-non-enumerable-property": 37, "../internals/global": 59, "../internals/has": 60, "../internals/hidden-keys": 61, "../internals/is-object": 74, "../internals/native-weak-map": 85, "../internals/shared-key": 118 }], 71: [function(e2, t2, r2) {
      var n2 = e2("../internals/well-known-symbol"), o2 = e2("../internals/iterators"), i2 = n2("iterator"), a2 = Array.prototype;
      t2.exports = function(e3) {
        return e3 !== void 0 && (o2.Array === e3 || a2[i2] === e3);
      };
    }, { "../internals/iterators": 79, "../internals/well-known-symbol": 146 }], 72: [function(e2, t2, r2) {
      var n2 = e2("../internals/classof-raw");
      t2.exports = Array.isArray || function(e3) {
        return n2(e3) == "Array";
      };
    }, { "../internals/classof-raw": 28 }], 73: [function(e2, t2, r2) {
      function n2(e3, t3) {
        var r3 = s[a2(e3)];
        return r3 == u2 || r3 != l2 && (typeof t3 == "function" ? o2(t3) : !!t3);
      }
      var o2 = e2("../internals/fails"), i2 = /#|\.prototype\./, a2 = n2.normalize = function(e3) {
        return String(e3).replace(i2, ".").toLowerCase();
      }, s = n2.data = {}, l2 = n2.NATIVE = "N", u2 = n2.POLYFILL = "P";
      t2.exports = n2;
    }, { "../internals/fails": 50 }], 74: [function(e2, t2, r2) {
      t2.exports = function(e3) {
        return typeof e3 == "object" ? e3 !== null : typeof e3 == "function";
      };
    }, {}], 75: [function(e2, t2, r2) {
      t2.exports = false;
    }, {}], 76: [function(e2, t2, r2) {
      var n2 = e2("../internals/is-object"), o2 = e2("../internals/classof-raw"), i2 = e2("../internals/well-known-symbol")("match");
      t2.exports = function(e3) {
        var t3;
        return n2(e3) && ((t3 = e3[i2]) !== void 0 ? !!t3 : o2(e3) == "RegExp");
      };
    }, { "../internals/classof-raw": 28, "../internals/is-object": 74, "../internals/well-known-symbol": 146 }], 77: [function(e2, t2, r2) {
      function h2(e3, t3) {
        this.stopped = e3, this.result = t3;
      }
      var p2 = e2("../internals/an-object"), y = e2("../internals/is-array-iterator-method"), m2 = e2("../internals/to-length"), g = e2("../internals/function-bind-context"), v = e2("../internals/get-iterator-method"), b2 = e2("../internals/call-with-safe-iteration-closing");
      (t2.exports = function(e3, t3, r3, n2, o2) {
        var i2, a2, s, l2, u2, c, d, f = g(t3, r3, n2 ? 2 : 1);
        if (o2)
          i2 = e3;
        else {
          if (typeof (a2 = v(e3)) != "function")
            throw TypeError("Target is not iterable");
          if (y(a2)) {
            for (s = 0, l2 = m2(e3.length); s < l2; s++)
              if ((u2 = n2 ? f(p2(d = e3[s])[0], d[1]) : f(e3[s])) && u2 instanceof h2)
                return u2;
            return new h2(false);
          }
          i2 = a2.call(e3);
        }
        for (c = i2.next; !(d = c.call(i2)).done; )
          if (typeof (u2 = b2(i2, f, d.value, n2)) == "object" && u2 && u2 instanceof h2)
            return u2;
        return new h2(false);
      }).stop = function(e3) {
        return new h2(true, e3);
      };
    }, { "../internals/an-object": 10, "../internals/call-with-safe-iteration-closing": 26, "../internals/function-bind-context": 54, "../internals/get-iterator-method": 57, "../internals/is-array-iterator-method": 71, "../internals/to-length": 134 }], 78: [function(e2, t2, r2) {
      var n2, o2, i2, a2 = e2("../internals/object-get-prototype-of"), s = e2("../internals/create-non-enumerable-property"), l2 = e2("../internals/has"), u2 = e2("../internals/well-known-symbol"), c = e2("../internals/is-pure"), d = u2("iterator"), f = false;
      [].keys && ("next" in (i2 = [].keys()) ? (o2 = a2(a2(i2))) !== Object.prototype && (n2 = o2) : f = true), n2 == null && (n2 = {}), c || l2(n2, d) || s(n2, d, function() {
        return this;
      }), t2.exports = { IteratorPrototype: n2, BUGGY_SAFARI_ITERATORS: f };
    }, { "../internals/create-non-enumerable-property": 37, "../internals/has": 60, "../internals/is-pure": 75, "../internals/object-get-prototype-of": 97, "../internals/well-known-symbol": 146 }], 79: [function(e2, t2, r2) {
      arguments[4][61][0].apply(r2, arguments);
    }, { dup: 61 }], 80: [function(e2, t2, r2) {
      t2.exports = Math.sign || function(e3) {
        return (e3 = +e3) == 0 || e3 != e3 ? e3 : e3 < 0 ? -1 : 1;
      };
    }, {}], 81: [function(e2, t2, r2) {
      var n2, o2, i2, a2, s, l2, u2, c, d = e2("../internals/global"), f = e2("../internals/object-get-own-property-descriptor").f, h2 = e2("../internals/classof-raw"), p2 = e2("../internals/task").set, y = e2("../internals/engine-is-ios"), m2 = d.MutationObserver || d.WebKitMutationObserver, g = d.process, v = d.Promise, b2 = h2(g) == "process", _ = f(d, "queueMicrotask"), x = _ && _.value;
      x || (n2 = function() {
        var e3, t3;
        for (b2 && (e3 = g.domain) && e3.exit(); o2; ) {
          t3 = o2.fn, o2 = o2.next;
          try {
            t3();
          } catch (e4) {
            throw o2 ? a2() : i2 = void 0, e4;
          }
        }
        i2 = void 0, e3 && e3.enter();
      }, a2 = b2 ? function() {
        g.nextTick(n2);
      } : m2 && !y ? (s = true, l2 = document.createTextNode(""), new m2(n2).observe(l2, { characterData: true }), function() {
        l2.data = s = !s;
      }) : v && v.resolve ? (u2 = v.resolve(void 0), c = u2.then, function() {
        c.call(u2, n2);
      }) : function() {
        p2.call(d, n2);
      }), t2.exports = x || function(e3) {
        var t3 = { fn: e3, next: void 0 };
        i2 && (i2.next = t3), o2 || (o2 = t3, a2()), i2 = t3;
      };
    }, { "../internals/classof-raw": 28, "../internals/engine-is-ios": 45, "../internals/global": 59, "../internals/object-get-own-property-descriptor": 93, "../internals/task": 128 }], 82: [function(e2, t2, r2) {
      var n2 = e2("../internals/global");
      t2.exports = n2.Promise;
    }, { "../internals/global": 59 }], 83: [function(e2, t2, r2) {
      var n2 = e2("../internals/fails");
      t2.exports = !!Object.getOwnPropertySymbols && !n2(function() {
        return !String(Symbol());
      });
    }, { "../internals/fails": 50 }], 84: [function(e2, t2, r2) {
      var n2 = e2("../internals/fails"), o2 = e2("../internals/well-known-symbol"), i2 = e2("../internals/is-pure"), a2 = o2("iterator");
      t2.exports = !n2(function() {
        var e3 = new URL("b?a=1&b=2&c=3", "http://a"), r3 = e3.searchParams, n3 = "";
        return e3.pathname = "c%20d", r3.forEach(function(e4, t3) {
          r3.delete("b"), n3 += t3 + e4;
        }), i2 && !e3.toJSON || !r3.sort || e3.href !== "http://a/c%20d?a=1&c=3" || r3.get("c") !== "3" || String(new URLSearchParams("?a=1")) !== "a=1" || !r3[a2] || new URL("https://a@b").username !== "a" || new URLSearchParams(new URLSearchParams("a=b")).get("a") !== "b" || new URL("http://\u0442\u0435\u0441\u0442").host !== "xn--e1aybc" || new URL("http://a#\u0431").hash !== "#%D0%B1" || n3 !== "a1c3" || new URL("http://x", void 0).host !== "x";
      });
    }, { "../internals/fails": 50, "../internals/is-pure": 75, "../internals/well-known-symbol": 146 }], 85: [function(e2, t2, r2) {
      var n2 = e2("../internals/global"), o2 = e2("../internals/inspect-source"), i2 = n2.WeakMap;
      t2.exports = typeof i2 == "function" && /native code/.test(o2(i2));
    }, { "../internals/global": 59, "../internals/inspect-source": 68 }], 86: [function(e2, t2, r2) {
      function n2(e3) {
        var r3, n3;
        this.promise = new e3(function(e4, t3) {
          if (r3 !== void 0 || n3 !== void 0)
            throw TypeError("Bad Promise constructor");
          r3 = e4, n3 = t3;
        }), this.resolve = o2(r3), this.reject = o2(n3);
      }
      var o2 = e2("../internals/a-function");
      t2.exports.f = function(e3) {
        return new n2(e3);
      };
    }, { "../internals/a-function": 5 }], 87: [function(e2, t2, r2) {
      var n2 = e2("../internals/is-regexp");
      t2.exports = function(e3) {
        if (n2(e3))
          throw TypeError("The method doesn't accept regular expressions");
        return e3;
      };
    }, { "../internals/is-regexp": 76 }], 88: [function(e2, t2, r2) {
      var n2 = e2("../internals/global").isFinite;
      t2.exports = Number.isFinite || function(e3) {
        return typeof e3 == "number" && n2(e3);
      };
    }, { "../internals/global": 59 }], 89: [function(e2, t2, r2) {
      var f = e2("../internals/descriptors"), n2 = e2("../internals/fails"), h2 = e2("../internals/object-keys"), p2 = e2("../internals/object-get-own-property-symbols"), y = e2("../internals/object-property-is-enumerable"), m2 = e2("../internals/to-object"), g = e2("../internals/indexed-object"), o2 = Object.assign, i2 = Object.defineProperty;
      t2.exports = !o2 || n2(function() {
        if (f && o2({ b: 1 }, o2(i2({}, "a", { enumerable: true, get: function() {
          i2(this, "b", { value: 3, enumerable: false });
        } }), { b: 2 })).b !== 1)
          return true;
        var e3 = {}, t3 = {}, r3 = Symbol(), n3 = "abcdefghijklmnopqrst";
        return e3[r3] = 7, n3.split("").forEach(function(e4) {
          t3[e4] = e4;
        }), o2({}, e3)[r3] != 7 || h2(o2({}, t3)).join("") != n3;
      }) ? function(e3, t3) {
        for (var r3 = m2(e3), n3 = arguments.length, o3 = 1, i3 = p2.f, a2 = y.f; o3 < n3; )
          for (var s, l2 = g(arguments[o3++]), u2 = i3 ? h2(l2).concat(i3(l2)) : h2(l2), c = u2.length, d = 0; d < c; )
            s = u2[d++], f && !a2.call(l2, s) || (r3[s] = l2[s]);
        return r3;
      } : o2;
    }, { "../internals/descriptors": 42, "../internals/fails": 50, "../internals/indexed-object": 66, "../internals/object-get-own-property-symbols": 96, "../internals/object-keys": 99, "../internals/object-property-is-enumerable": 100, "../internals/to-object": 135 }], 90: [function(e2, t2, r2) {
      function n2() {
      }
      function o2(e3) {
        return "<script>" + e3 + "</" + p2 + ">";
      }
      var i2, a2 = e2("../internals/an-object"), s = e2("../internals/object-define-properties"), l2 = e2("../internals/enum-bug-keys"), u2 = e2("../internals/hidden-keys"), c = e2("../internals/html"), d = e2("../internals/document-create-element"), f = e2("../internals/shared-key"), h2 = "prototype", p2 = "script", y = f("IE_PROTO"), m2 = function() {
        try {
          i2 = document.domain && new ActiveXObject("htmlfile");
        } catch (e4) {
        }
        var e3, t3;
        m2 = i2 ? function(e4) {
          e4.write(o2("")), e4.close();
          var t4 = e4.parentWindow.Object;
          return e4 = null, t4;
        }(i2) : ((t3 = d("iframe")).style.display = "none", c.appendChild(t3), t3.src = String("javascript:"), (e3 = t3.contentWindow.document).open(), e3.write(o2("document.F=Object")), e3.close(), e3.F);
        for (var r3 = l2.length; r3--; )
          delete m2[h2][l2[r3]];
        return m2();
      };
      u2[y] = true, t2.exports = Object.create || function(e3, t3) {
        var r3;
        return e3 !== null ? (n2[h2] = a2(e3), r3 = new n2(), n2[h2] = null, r3[y] = e3) : r3 = m2(), t3 === void 0 ? r3 : s(r3, t3);
      };
    }, { "../internals/an-object": 10, "../internals/document-create-element": 43, "../internals/enum-bug-keys": 48, "../internals/hidden-keys": 61, "../internals/html": 63, "../internals/object-define-properties": 91, "../internals/shared-key": 118 }], 91: [function(e2, t2, r2) {
      var n2 = e2("../internals/descriptors"), a2 = e2("../internals/object-define-property"), s = e2("../internals/an-object"), l2 = e2("../internals/object-keys");
      t2.exports = n2 ? Object.defineProperties : function(e3, t3) {
        s(e3);
        for (var r3, n3 = l2(t3), o2 = n3.length, i2 = 0; i2 < o2; )
          a2.f(e3, r3 = n3[i2++], t3[r3]);
        return e3;
      };
    }, { "../internals/an-object": 10, "../internals/descriptors": 42, "../internals/object-define-property": 92, "../internals/object-keys": 99 }], 92: [function(e2, t2, r2) {
      var n2 = e2("../internals/descriptors"), o2 = e2("../internals/ie8-dom-define"), i2 = e2("../internals/an-object"), a2 = e2("../internals/to-primitive"), s = Object.defineProperty;
      r2.f = n2 ? s : function(e3, t3, r3) {
        if (i2(e3), t3 = a2(t3, true), i2(r3), o2)
          try {
            return s(e3, t3, r3);
          } catch (e4) {
          }
        if ("get" in r3 || "set" in r3)
          throw TypeError("Accessors not supported");
        return "value" in r3 && (e3[t3] = r3.value), e3;
      };
    }, { "../internals/an-object": 10, "../internals/descriptors": 42, "../internals/ie8-dom-define": 64, "../internals/to-primitive": 138 }], 93: [function(e2, t2, r2) {
      var n2 = e2("../internals/descriptors"), o2 = e2("../internals/object-property-is-enumerable"), i2 = e2("../internals/create-property-descriptor"), a2 = e2("../internals/to-indexed-object"), s = e2("../internals/to-primitive"), l2 = e2("../internals/has"), u2 = e2("../internals/ie8-dom-define"), c = Object.getOwnPropertyDescriptor;
      r2.f = n2 ? c : function(e3, t3) {
        if (e3 = a2(e3), t3 = s(t3, true), u2)
          try {
            return c(e3, t3);
          } catch (e4) {
          }
        if (l2(e3, t3))
          return i2(!o2.f.call(e3, t3), e3[t3]);
      };
    }, { "../internals/create-property-descriptor": 38, "../internals/descriptors": 42, "../internals/has": 60, "../internals/ie8-dom-define": 64, "../internals/object-property-is-enumerable": 100, "../internals/to-indexed-object": 132, "../internals/to-primitive": 138 }], 94: [function(e2, t2, r2) {
      var n2 = e2("../internals/to-indexed-object"), o2 = e2("../internals/object-get-own-property-names").f, i2 = {}.toString, a2 = typeof window == "object" && window && Object.getOwnPropertyNames ? Object.getOwnPropertyNames(window) : [];
      t2.exports.f = function(e3) {
        return a2 && i2.call(e3) == "[object Window]" ? function(e4) {
          try {
            return o2(e4);
          } catch (e5) {
            return a2.slice();
          }
        }(e3) : o2(n2(e3));
      };
    }, { "../internals/object-get-own-property-names": 95, "../internals/to-indexed-object": 132 }], 95: [function(e2, t2, r2) {
      var n2 = e2("../internals/object-keys-internal"), o2 = e2("../internals/enum-bug-keys").concat("length", "prototype");
      r2.f = Object.getOwnPropertyNames || function(e3) {
        return n2(e3, o2);
      };
    }, { "../internals/enum-bug-keys": 48, "../internals/object-keys-internal": 98 }], 96: [function(e2, t2, r2) {
      r2.f = Object.getOwnPropertySymbols;
    }, {}], 97: [function(e2, t2, r2) {
      var n2 = e2("../internals/has"), o2 = e2("../internals/to-object"), i2 = e2("../internals/shared-key"), a2 = e2("../internals/correct-prototype-getter"), s = i2("IE_PROTO"), l2 = Object.prototype;
      t2.exports = a2 ? Object.getPrototypeOf : function(e3) {
        return e3 = o2(e3), n2(e3, s) ? e3[s] : typeof e3.constructor == "function" && e3 instanceof e3.constructor ? e3.constructor.prototype : e3 instanceof Object ? l2 : null;
      };
    }, { "../internals/correct-prototype-getter": 34, "../internals/has": 60, "../internals/shared-key": 118, "../internals/to-object": 135 }], 98: [function(e2, t2, r2) {
      var a2 = e2("../internals/has"), s = e2("../internals/to-indexed-object"), l2 = e2("../internals/array-includes").indexOf, u2 = e2("../internals/hidden-keys");
      t2.exports = function(e3, t3) {
        var r3, n2 = s(e3), o2 = 0, i2 = [];
        for (r3 in n2)
          !a2(u2, r3) && a2(n2, r3) && i2.push(r3);
        for (; t3.length > o2; )
          a2(n2, r3 = t3[o2++]) && (~l2(i2, r3) || i2.push(r3));
        return i2;
      };
    }, { "../internals/array-includes": 18, "../internals/has": 60, "../internals/hidden-keys": 61, "../internals/to-indexed-object": 132 }], 99: [function(e2, t2, r2) {
      var n2 = e2("../internals/object-keys-internal"), o2 = e2("../internals/enum-bug-keys");
      t2.exports = Object.keys || function(e3) {
        return n2(e3, o2);
      };
    }, { "../internals/enum-bug-keys": 48, "../internals/object-keys-internal": 98 }], 100: [function(e2, t2, r2) {
      var n2 = {}.propertyIsEnumerable, o2 = Object.getOwnPropertyDescriptor, i2 = o2 && !n2.call({ 1: 2 }, 1);
      r2.f = i2 ? function(e3) {
        var t3 = o2(this, e3);
        return !!t3 && t3.enumerable;
      } : n2;
    }, {}], 101: [function(e2, t2, r2) {
      var o2 = e2("../internals/an-object"), i2 = e2("../internals/a-possible-prototype");
      t2.exports = Object.setPrototypeOf || ("__proto__" in {} ? function() {
        var r3, n2 = false, e3 = {};
        try {
          (r3 = Object.getOwnPropertyDescriptor(Object.prototype, "__proto__").set).call(e3, []), n2 = e3 instanceof Array;
        } catch (e4) {
        }
        return function(e4, t3) {
          return o2(e4), i2(t3), n2 ? r3.call(e4, t3) : e4.__proto__ = t3, e4;
        };
      }() : void 0);
    }, { "../internals/a-possible-prototype": 6, "../internals/an-object": 10 }], 102: [function(e2, t2, r2) {
      var n2 = e2("../internals/to-string-tag-support"), o2 = e2("../internals/classof");
      t2.exports = n2 ? {}.toString : function() {
        return "[object " + o2(this) + "]";
      };
    }, { "../internals/classof": 29, "../internals/to-string-tag-support": 139 }], 103: [function(e2, t2, r2) {
      var n2 = e2("../internals/get-built-in"), o2 = e2("../internals/object-get-own-property-names"), i2 = e2("../internals/object-get-own-property-symbols"), a2 = e2("../internals/an-object");
      t2.exports = n2("Reflect", "ownKeys") || function(e3) {
        var t3 = o2.f(a2(e3)), r3 = i2.f;
        return r3 ? t3.concat(r3(e3)) : t3;
      };
    }, { "../internals/an-object": 10, "../internals/get-built-in": 56, "../internals/object-get-own-property-names": 95, "../internals/object-get-own-property-symbols": 96 }], 104: [function(e2, t2, r2) {
      var n2 = e2("../internals/global");
      t2.exports = n2;
    }, { "../internals/global": 59 }], 105: [function(e2, t2, r2) {
      t2.exports = function(e3) {
        try {
          return { error: false, value: e3() };
        } catch (e4) {
          return { error: true, value: e4 };
        }
      };
    }, {}], 106: [function(e2, t2, r2) {
      var n2 = e2("../internals/an-object"), o2 = e2("../internals/is-object"), i2 = e2("../internals/new-promise-capability");
      t2.exports = function(e3, t3) {
        if (n2(e3), o2(t3) && t3.constructor === e3)
          return t3;
        var r3 = i2.f(e3);
        return (0, r3.resolve)(t3), r3.promise;
      };
    }, { "../internals/an-object": 10, "../internals/is-object": 74, "../internals/new-promise-capability": 86 }], 107: [function(e2, t2, r2) {
      var o2 = e2("../internals/redefine");
      t2.exports = function(e3, t3, r3) {
        for (var n2 in t3)
          o2(e3, n2, t3[n2], r3);
        return e3;
      };
    }, { "../internals/redefine": 108 }], 108: [function(e2, t2, r2) {
      var s = e2("../internals/global"), l2 = e2("../internals/create-non-enumerable-property"), u2 = e2("../internals/has"), c = e2("../internals/set-global"), n2 = e2("../internals/inspect-source"), o2 = e2("../internals/internal-state"), i2 = o2.get, d = o2.enforce, f = String(String).split("String");
      (t2.exports = function(e3, t3, r3, n3) {
        var o3 = !!n3 && !!n3.unsafe, i3 = !!n3 && !!n3.enumerable, a2 = !!n3 && !!n3.noTargetGet;
        typeof r3 == "function" && (typeof t3 != "string" || u2(r3, "name") || l2(r3, "name", t3), d(r3).source = f.join(typeof t3 == "string" ? t3 : "")), e3 !== s ? (o3 ? !a2 && e3[t3] && (i3 = true) : delete e3[t3], i3 ? e3[t3] = r3 : l2(e3, t3, r3)) : i3 ? e3[t3] = r3 : c(t3, r3);
      })(Function.prototype, "toString", function() {
        return typeof this == "function" && i2(this).source || n2(this);
      });
    }, { "../internals/create-non-enumerable-property": 37, "../internals/global": 59, "../internals/has": 60, "../internals/inspect-source": 68, "../internals/internal-state": 70, "../internals/set-global": 115 }], 109: [function(e2, t2, r2) {
      var o2 = e2("./classof-raw"), i2 = e2("./regexp-exec");
      t2.exports = function(e3, t3) {
        var r3 = e3.exec;
        if (typeof r3 == "function") {
          var n2 = r3.call(e3, t3);
          if (typeof n2 != "object")
            throw TypeError("RegExp exec method returned something other than an Object or null");
          return n2;
        }
        if (o2(e3) !== "RegExp")
          throw TypeError("RegExp#exec called on incompatible receiver");
        return i2.call(e3, t3);
      };
    }, { "./classof-raw": 28, "./regexp-exec": 110 }], 110: [function(e2, t2, r2) {
      var n2, o2, d = e2("./regexp-flags"), i2 = e2("./regexp-sticky-helpers"), f = RegExp.prototype.exec, h2 = String.prototype.replace, a2 = f, p2 = (n2 = /a/, o2 = /b*/g, f.call(n2, "a"), f.call(o2, "a"), n2.lastIndex !== 0 || o2.lastIndex !== 0), y = i2.UNSUPPORTED_Y || i2.BROKEN_CARET, m2 = /()??/.exec("")[1] !== void 0;
      (p2 || m2 || y) && (a2 = function(e3) {
        var t3, r3, n3, o3, i3 = this, a3 = y && i3.sticky, s = d.call(i3), l2 = i3.source, u2 = 0, c = e3;
        return a3 && ((s = s.replace("y", "")).indexOf("g") === -1 && (s += "g"), c = String(e3).slice(i3.lastIndex), 0 < i3.lastIndex && (!i3.multiline || i3.multiline && e3[i3.lastIndex - 1] !== "\n") && (l2 = "(?: " + l2 + ")", c = " " + c, u2++), r3 = new RegExp("^(?:" + l2 + ")", s)), m2 && (r3 = new RegExp("^" + l2 + "$(?!\\s)", s)), p2 && (t3 = i3.lastIndex), n3 = f.call(a3 ? r3 : i3, c), a3 ? n3 ? (n3.input = n3.input.slice(u2), n3[0] = n3[0].slice(u2), n3.index = i3.lastIndex, i3.lastIndex += n3[0].length) : i3.lastIndex = 0 : p2 && n3 && (i3.lastIndex = i3.global ? n3.index + n3[0].length : t3), m2 && n3 && 1 < n3.length && h2.call(n3[0], r3, function() {
          for (o3 = 1; o3 < arguments.length - 2; o3++)
            arguments[o3] === void 0 && (n3[o3] = void 0);
        }), n3;
      }), t2.exports = a2;
    }, { "./regexp-flags": 111, "./regexp-sticky-helpers": 112 }], 111: [function(e2, t2, r2) {
      var n2 = e2("../internals/an-object");
      t2.exports = function() {
        var e3 = n2(this), t3 = "";
        return e3.global && (t3 += "g"), e3.ignoreCase && (t3 += "i"), e3.multiline && (t3 += "m"), e3.dotAll && (t3 += "s"), e3.unicode && (t3 += "u"), e3.sticky && (t3 += "y"), t3;
      };
    }, { "../internals/an-object": 10 }], 112: [function(e2, t2, r2) {
      var n2 = e2("./fails");
      function o2(e3, t3) {
        return RegExp(e3, t3);
      }
      r2.UNSUPPORTED_Y = n2(function() {
        var e3 = o2("a", "y");
        return e3.lastIndex = 2, e3.exec("abcd") != null;
      }), r2.BROKEN_CARET = n2(function() {
        var e3 = o2("^r", "gy");
        return e3.lastIndex = 2, e3.exec("str") != null;
      });
    }, { "./fails": 50 }], 113: [function(e2, t2, r2) {
      t2.exports = function(e3) {
        if (e3 == null)
          throw TypeError("Can't call method on " + e3);
        return e3;
      };
    }, {}], 114: [function(e2, t2, r2) {
      t2.exports = Object.is || function(e3, t3) {
        return e3 === t3 ? e3 !== 0 || 1 / e3 == 1 / t3 : e3 != e3 && t3 != t3;
      };
    }, {}], 115: [function(e2, t2, r2) {
      var n2 = e2("../internals/global"), o2 = e2("../internals/create-non-enumerable-property");
      t2.exports = function(t3, r3) {
        try {
          o2(n2, t3, r3);
        } catch (e3) {
          n2[t3] = r3;
        }
        return r3;
      };
    }, { "../internals/create-non-enumerable-property": 37, "../internals/global": 59 }], 116: [function(e2, t2, r2) {
      var n2 = e2("../internals/get-built-in"), o2 = e2("../internals/object-define-property"), i2 = e2("../internals/well-known-symbol"), a2 = e2("../internals/descriptors"), s = i2("species");
      t2.exports = function(e3) {
        var t3 = n2(e3), r3 = o2.f;
        a2 && t3 && !t3[s] && r3(t3, s, { configurable: true, get: function() {
          return this;
        } });
      };
    }, { "../internals/descriptors": 42, "../internals/get-built-in": 56, "../internals/object-define-property": 92, "../internals/well-known-symbol": 146 }], 117: [function(e2, t2, r2) {
      var n2 = e2("../internals/object-define-property").f, o2 = e2("../internals/has"), i2 = e2("../internals/well-known-symbol")("toStringTag");
      t2.exports = function(e3, t3, r3) {
        e3 && !o2(e3 = r3 ? e3 : e3.prototype, i2) && n2(e3, i2, { configurable: true, value: t3 });
      };
    }, { "../internals/has": 60, "../internals/object-define-property": 92, "../internals/well-known-symbol": 146 }], 118: [function(e2, t2, r2) {
      var n2 = e2("../internals/shared"), o2 = e2("../internals/uid"), i2 = n2("keys");
      t2.exports = function(e3) {
        return i2[e3] || (i2[e3] = o2(e3));
      };
    }, { "../internals/shared": 120, "../internals/uid": 143 }], 119: [function(e2, t2, r2) {
      var n2 = e2("../internals/global"), o2 = e2("../internals/set-global"), i2 = "__core-js_shared__", a2 = n2[i2] || o2(i2, {});
      t2.exports = a2;
    }, { "../internals/global": 59, "../internals/set-global": 115 }], 120: [function(e2, t2, r2) {
      var n2 = e2("../internals/is-pure"), o2 = e2("../internals/shared-store");
      (t2.exports = function(e3, t3) {
        return o2[e3] || (o2[e3] = t3 !== void 0 ? t3 : {});
      })("versions", []).push({ version: "3.6.5", mode: n2 ? "pure" : "global", copyright: "\xA9 2020 Denis Pushkarev (zloirock.ru)" });
    }, { "../internals/is-pure": 75, "../internals/shared-store": 119 }], 121: [function(e2, t2, r2) {
      var o2 = e2("../internals/an-object"), i2 = e2("../internals/a-function"), a2 = e2("../internals/well-known-symbol")("species");
      t2.exports = function(e3, t3) {
        var r3, n2 = o2(e3).constructor;
        return n2 === void 0 || (r3 = o2(n2)[a2]) == null ? t3 : i2(r3);
      };
    }, { "../internals/a-function": 5, "../internals/an-object": 10, "../internals/well-known-symbol": 146 }], 122: [function(e2, t2, r2) {
      var n2 = e2("../internals/fails");
      t2.exports = function(t3) {
        return n2(function() {
          var e3 = ""[t3]('"');
          return e3 !== e3.toLowerCase() || 3 < e3.split('"').length;
        });
      };
    }, { "../internals/fails": 50 }], 123: [function(e2, t2, r2) {
      function n2(s) {
        return function(e3, t3) {
          var r3, n3, o2 = String(u2(e3)), i2 = l2(t3), a2 = o2.length;
          return i2 < 0 || a2 <= i2 ? s ? "" : void 0 : (r3 = o2.charCodeAt(i2)) < 55296 || 56319 < r3 || i2 + 1 === a2 || (n3 = o2.charCodeAt(i2 + 1)) < 56320 || 57343 < n3 ? s ? o2.charAt(i2) : r3 : s ? o2.slice(i2, i2 + 2) : n3 - 56320 + (r3 - 55296 << 10) + 65536;
        };
      }
      var l2 = e2("../internals/to-integer"), u2 = e2("../internals/require-object-coercible");
      t2.exports = { codeAt: n2(false), charAt: n2(true) };
    }, { "../internals/require-object-coercible": 113, "../internals/to-integer": 133 }], 124: [function(e2, t2, r2) {
      function g(e3) {
        return e3 + 22 + 75 * (e3 < 26);
      }
      function v(e3, t3, r3) {
        var n2 = 0;
        for (e3 = r3 ? x(e3 / 700) : e3 >> 1, e3 += x(e3 / t3); 455 < e3; n2 += 36)
          e3 = x(e3 / 35);
        return x(n2 + 36 * e3 / (e3 + 38));
      }
      function i2(e3) {
        var t3, r3, n2 = [], o2 = (e3 = function(e4) {
          for (var t4 = [], r4 = 0, n3 = e4.length; r4 < n3; ) {
            var o3 = e4.charCodeAt(r4++);
            if (55296 <= o3 && o3 <= 56319 && r4 < n3) {
              var i4 = e4.charCodeAt(r4++);
              (64512 & i4) == 56320 ? t4.push(((1023 & o3) << 10) + (1023 & i4) + 65536) : (t4.push(o3), r4--);
            } else
              t4.push(o3);
          }
          return t4;
        }(e3)).length, i3 = 128, a3 = 0, s2 = 72;
        for (t3 = 0; t3 < e3.length; t3++)
          (r3 = e3[t3]) < 128 && n2.push(w(r3));
        var l2 = n2.length, u2 = l2;
        for (l2 && n2.push("-"); u2 < o2; ) {
          var c = b2;
          for (t3 = 0; t3 < e3.length; t3++)
            i3 <= (r3 = e3[t3]) && r3 < c && (c = r3);
          var d = u2 + 1;
          if (c - i3 > x((b2 - a3) / d))
            throw RangeError(_);
          for (a3 += (c - i3) * d, i3 = c, t3 = 0; t3 < e3.length; t3++) {
            if ((r3 = e3[t3]) < i3 && ++a3 > b2)
              throw RangeError(_);
            if (r3 == i3) {
              for (var f = a3, h2 = 36; ; h2 += 36) {
                var p2 = h2 <= s2 ? 1 : s2 + 26 <= h2 ? 26 : h2 - s2;
                if (f < p2)
                  break;
                var y = f - p2, m2 = 36 - p2;
                n2.push(w(g(p2 + y % m2))), f = x(y / m2);
              }
              n2.push(w(g(f))), s2 = v(a3, d, u2 == l2), a3 = 0, ++u2;
            }
          }
          ++a3, ++i3;
        }
        return n2.join("");
      }
      var b2 = 2147483647, a2 = /[^\0-\u007E]/, s = /[.\u3002\uFF0E\uFF61]/g, _ = "Overflow: input needs wider integers to process", x = Math.floor, w = String.fromCharCode;
      t2.exports = function(e3) {
        var t3, r3, n2 = [], o2 = e3.toLowerCase().replace(s, ".").split(".");
        for (t3 = 0; t3 < o2.length; t3++)
          r3 = o2[t3], n2.push(a2.test(r3) ? "xn--" + i2(r3) : r3);
        return n2.join(".");
      };
    }, {}], 125: [function(e2, t2, r2) {
      var o2 = e2("../internals/to-integer"), i2 = e2("../internals/require-object-coercible");
      t2.exports = "".repeat || function(e3) {
        var t3 = String(i2(this)), r3 = "", n2 = o2(e3);
        if (n2 < 0 || n2 == 1 / 0)
          throw RangeError("Wrong number of repetitions");
        for (; 0 < n2; (n2 >>>= 1) && (t3 += t3))
          1 & n2 && (r3 += t3);
        return r3;
      };
    }, { "../internals/require-object-coercible": 113, "../internals/to-integer": 133 }], 126: [function(e2, t2, r2) {
      var n2 = e2("../internals/fails"), o2 = e2("../internals/whitespaces");
      t2.exports = function(e3) {
        return n2(function() {
          return !!o2[e3]() || "\u200B\x85\u180E"[e3]() != "\u200B\x85\u180E" || o2[e3].name !== e3;
        });
      };
    }, { "../internals/fails": 50, "../internals/whitespaces": 147 }], 127: [function(e2, t2, r2) {
      function n2(r3) {
        return function(e3) {
          var t3 = String(o2(e3));
          return 1 & r3 && (t3 = t3.replace(a2, "")), 2 & r3 && (t3 = t3.replace(s, "")), t3;
        };
      }
      var o2 = e2("../internals/require-object-coercible"), i2 = "[" + e2("../internals/whitespaces") + "]", a2 = RegExp("^" + i2 + i2 + "*"), s = RegExp(i2 + i2 + "*$");
      t2.exports = { start: n2(1), end: n2(2), trim: n2(3) };
    }, { "../internals/require-object-coercible": 113, "../internals/whitespaces": 147 }], 128: [function(e2, t2, r2) {
      function n2(e3) {
        if (S2.hasOwnProperty(e3)) {
          var t3 = S2[e3];
          delete S2[e3], t3();
        }
      }
      function o2(e3) {
        return function() {
          n2(e3);
        };
      }
      function i2(e3) {
        n2(e3.data);
      }
      function a2(e3) {
        c.postMessage(e3 + "", g.protocol + "//" + g.host);
      }
      var s, l2, u2, c = e2("../internals/global"), d = e2("../internals/fails"), f = e2("../internals/classof-raw"), h2 = e2("../internals/function-bind-context"), p2 = e2("../internals/html"), y = e2("../internals/document-create-element"), m2 = e2("../internals/engine-is-ios"), g = c.location, v = c.setImmediate, b2 = c.clearImmediate, _ = c.process, x = c.MessageChannel, w = c.Dispatch, j = 0, S2 = {}, M = "onreadystatechange";
      v && b2 || (v = function(e3) {
        for (var t3 = [], r3 = 1; r3 < arguments.length; )
          t3.push(arguments[r3++]);
        return S2[++j] = function() {
          (typeof e3 == "function" ? e3 : Function(e3)).apply(void 0, t3);
        }, s(j), j;
      }, b2 = function(e3) {
        delete S2[e3];
      }, f(_) == "process" ? s = function(e3) {
        _.nextTick(o2(e3));
      } : w && w.now ? s = function(e3) {
        w.now(o2(e3));
      } : x && !m2 ? (u2 = (l2 = new x()).port2, l2.port1.onmessage = i2, s = h2(u2.postMessage, u2, 1)) : !c.addEventListener || typeof postMessage != "function" || c.importScripts || d(a2) || g.protocol === "file:" ? s = M in y("script") ? function(e3) {
        p2.appendChild(y("script"))[M] = function() {
          p2.removeChild(this), n2(e3);
        };
      } : function(e3) {
        setTimeout(o2(e3), 0);
      } : (s = a2, c.addEventListener("message", i2, false))), t2.exports = { set: v, clear: b2 };
    }, { "../internals/classof-raw": 28, "../internals/document-create-element": 43, "../internals/engine-is-ios": 45, "../internals/fails": 50, "../internals/function-bind-context": 54, "../internals/global": 59, "../internals/html": 63 }], 129: [function(e2, t2, r2) {
      var n2 = e2("../internals/classof-raw");
      t2.exports = function(e3) {
        if (typeof e3 != "number" && n2(e3) != "Number")
          throw TypeError("Incorrect invocation");
        return +e3;
      };
    }, { "../internals/classof-raw": 28 }], 130: [function(e2, t2, r2) {
      var n2 = e2("../internals/to-integer"), o2 = Math.max, i2 = Math.min;
      t2.exports = function(e3, t3) {
        var r3 = n2(e3);
        return r3 < 0 ? o2(r3 + t3, 0) : i2(r3, t3);
      };
    }, { "../internals/to-integer": 133 }], 131: [function(e2, t2, r2) {
      var n2 = e2("../internals/to-integer"), o2 = e2("../internals/to-length");
      t2.exports = function(e3) {
        if (e3 === void 0)
          return 0;
        var t3 = n2(e3), r3 = o2(t3);
        if (t3 !== r3)
          throw RangeError("Wrong length or index");
        return r3;
      };
    }, { "../internals/to-integer": 133, "../internals/to-length": 134 }], 132: [function(e2, t2, r2) {
      var n2 = e2("../internals/indexed-object"), o2 = e2("../internals/require-object-coercible");
      t2.exports = function(e3) {
        return n2(o2(e3));
      };
    }, { "../internals/indexed-object": 66, "../internals/require-object-coercible": 113 }], 133: [function(e2, t2, r2) {
      var n2 = Math.ceil, o2 = Math.floor;
      t2.exports = function(e3) {
        return isNaN(e3 = +e3) ? 0 : (0 < e3 ? o2 : n2)(e3);
      };
    }, {}], 134: [function(e2, t2, r2) {
      var n2 = e2("../internals/to-integer"), o2 = Math.min;
      t2.exports = function(e3) {
        return 0 < e3 ? o2(n2(e3), 9007199254740991) : 0;
      };
    }, { "../internals/to-integer": 133 }], 135: [function(e2, t2, r2) {
      var n2 = e2("../internals/require-object-coercible");
      t2.exports = function(e3) {
        return Object(n2(e3));
      };
    }, { "../internals/require-object-coercible": 113 }], 136: [function(e2, t2, r2) {
      var n2 = e2("../internals/to-positive-integer");
      t2.exports = function(e3, t3) {
        var r3 = n2(e3);
        if (r3 % t3)
          throw RangeError("Wrong offset");
        return r3;
      };
    }, { "../internals/to-positive-integer": 137 }], 137: [function(e2, t2, r2) {
      var n2 = e2("../internals/to-integer");
      t2.exports = function(e3) {
        var t3 = n2(e3);
        if (t3 < 0)
          throw RangeError("The argument can't be less than 0");
        return t3;
      };
    }, { "../internals/to-integer": 133 }], 138: [function(e2, t2, r2) {
      var o2 = e2("../internals/is-object");
      t2.exports = function(e3, t3) {
        if (!o2(e3))
          return e3;
        var r3, n2;
        if (t3 && typeof (r3 = e3.toString) == "function" && !o2(n2 = r3.call(e3)))
          return n2;
        if (typeof (r3 = e3.valueOf) == "function" && !o2(n2 = r3.call(e3)))
          return n2;
        if (!t3 && typeof (r3 = e3.toString) == "function" && !o2(n2 = r3.call(e3)))
          return n2;
        throw TypeError("Can't convert object to primitive value");
      };
    }, { "../internals/is-object": 74 }], 139: [function(e2, t2, r2) {
      var n2 = {};
      n2[e2("../internals/well-known-symbol")("toStringTag")] = "z", t2.exports = String(n2) === "[object z]";
    }, { "../internals/well-known-symbol": 146 }], 140: [function(e2, t2, r2) {
      function p2(e3, t3) {
        for (var r3 = 0, n3 = t3.length, o3 = new (X2(e3))(n3); r3 < n3; )
          o3[r3] = t3[r3++];
        return o3;
      }
      function n2(e3, t3) {
        U(e3, t3, { get: function() {
          return D(this)[t3];
        } });
      }
      function y(e3) {
        var t3;
        return e3 instanceof G || (t3 = j(e3)) == "ArrayBuffer" || t3 == "SharedArrayBuffer";
      }
      function o2(e3, t3) {
        return Y2(e3) && typeof t3 != "symbol" && t3 in e3 && String(+t3) == String(t3);
      }
      function i2(e3, t3) {
        return o2(e3, t3 = h2(t3, true)) ? f(2, e3[t3]) : N(e3, t3);
      }
      function a2(e3, t3, r3) {
        return !(o2(e3, t3 = h2(t3, true)) && S2(r3) && w(r3, "value")) || w(r3, "get") || w(r3, "set") || r3.configurable || w(r3, "writable") && !r3.writable || w(r3, "enumerable") && !r3.enumerable ? U(e3, t3, r3) : (e3[t3] = r3.value, e3);
      }
      var l2 = e2("../internals/export"), u2 = e2("../internals/global"), s = e2("../internals/descriptors"), m2 = e2("../internals/typed-array-constructors-require-wrappers"), c = e2("../internals/array-buffer-view-core"), d = e2("../internals/array-buffer"), g = e2("../internals/an-instance"), f = e2("../internals/create-property-descriptor"), v = e2("../internals/create-non-enumerable-property"), b2 = e2("../internals/to-length"), _ = e2("../internals/to-index"), x = e2("../internals/to-offset"), h2 = e2("../internals/to-primitive"), w = e2("../internals/has"), j = e2("../internals/classof"), S2 = e2("../internals/is-object"), M = e2("../internals/object-create"), E = e2("../internals/object-set-prototype-of"), T2 = e2("../internals/object-get-own-property-names").f, O2 = e2("../internals/typed-array-from"), C = e2("../internals/array-iteration").forEach, L = e2("../internals/set-species"), P2 = e2("../internals/object-define-property"), A = e2("../internals/object-get-own-property-descriptor"), k2 = e2("../internals/internal-state"), R2 = e2("../internals/inherit-if-required"), D = k2.get, I = k2.set, U = P2.f, N = A.f, F = Math.round, B = u2.RangeError, G = d.ArrayBuffer, V = d.DataView, z = c.NATIVE_ARRAY_BUFFER_VIEWS, H = c.TYPED_ARRAY_TAG, W2 = c.TypedArray, q = c.TypedArrayPrototype, X2 = c.aTypedArrayConstructor, Y2 = c.isTypedArray, Z = "BYTES_PER_ELEMENT", Q = "Wrong length";
      s ? (z || (A.f = i2, P2.f = a2, n2(q, "buffer"), n2(q, "byteOffset"), n2(q, "byteLength"), n2(q, "length")), l2({ target: "Object", stat: true, forced: !z }, { getOwnPropertyDescriptor: i2, defineProperty: a2 }), t2.exports = function(e3, t3, i3) {
        function c2(e4, o4) {
          U(e4, o4, { get: function() {
            return e5 = o4, (t4 = D(this)).view[r3](e5 * d2 + t4.byteOffset, true);
            var e5, t4;
          }, set: function(e5) {
            return t4 = o4, r4 = e5, n4 = D(this), i3 && (r4 = (r4 = F(r4)) < 0 ? 0 : 255 < r4 ? 255 : 255 & r4), void n4.view[a3](t4 * d2 + n4.byteOffset, r4, true);
            var t4, r4, n4;
          }, enumerable: true });
        }
        var d2 = e3.match(/\d+$/)[0] / 8, f2 = e3 + (i3 ? "Clamped" : "") + "Array", r3 = "get" + e3, a3 = "set" + e3, o3 = u2[f2], h3 = o3, n3 = h3 && h3.prototype, s2 = {};
        z ? m2 && (h3 = t3(function(e4, t4, r4, n4) {
          return g(e4, h3, f2), R2(S2(t4) ? y(t4) ? n4 !== void 0 ? new o3(t4, x(r4, d2), n4) : r4 !== void 0 ? new o3(t4, x(r4, d2)) : new o3(t4) : Y2(t4) ? p2(h3, t4) : O2.call(h3, t4) : new o3(_(t4)), e4, h3);
        }), E && E(h3, W2), C(T2(o3), function(e4) {
          e4 in h3 || v(h3, e4, o3[e4]);
        }), h3.prototype = n3) : (h3 = t3(function(e4, t4, r4, n4) {
          g(e4, h3, f2);
          var o4, i4, a4, s3 = 0, l3 = 0;
          if (S2(t4)) {
            if (!y(t4))
              return Y2(t4) ? p2(h3, t4) : O2.call(h3, t4);
            o4 = t4, l3 = x(r4, d2);
            var u3 = t4.byteLength;
            if (n4 === void 0) {
              if (u3 % d2)
                throw B(Q);
              if ((i4 = u3 - l3) < 0)
                throw B(Q);
            } else if (u3 < (i4 = b2(n4) * d2) + l3)
              throw B(Q);
            a4 = i4 / d2;
          } else
            a4 = _(t4), o4 = new G(i4 = a4 * d2);
          for (I(e4, { buffer: o4, byteOffset: l3, byteLength: i4, length: a4, view: new V(o4) }); s3 < a4; )
            c2(e4, s3++);
        }), E && E(h3, W2), n3 = h3.prototype = M(q)), n3.constructor !== h3 && v(n3, "constructor", h3), H && v(n3, H, f2), s2[f2] = h3, l2({ global: true, forced: h3 != o3, sham: !z }, s2), Z in h3 || v(h3, Z, d2), Z in n3 || v(n3, Z, d2), L(f2);
      }) : t2.exports = function() {
      };
    }, { "../internals/an-instance": 9, "../internals/array-buffer": 13, "../internals/array-buffer-view-core": 12, "../internals/array-iteration": 19, "../internals/classof": 29, "../internals/create-non-enumerable-property": 37, "../internals/create-property-descriptor": 38, "../internals/descriptors": 42, "../internals/export": 49, "../internals/global": 59, "../internals/has": 60, "../internals/inherit-if-required": 67, "../internals/internal-state": 70, "../internals/is-object": 74, "../internals/object-create": 90, "../internals/object-define-property": 92, "../internals/object-get-own-property-descriptor": 93, "../internals/object-get-own-property-names": 95, "../internals/object-set-prototype-of": 101, "../internals/set-species": 116, "../internals/to-index": 131, "../internals/to-length": 134, "../internals/to-offset": 136, "../internals/to-primitive": 138, "../internals/typed-array-constructors-require-wrappers": 141, "../internals/typed-array-from": 142 }], 141: [function(e2, t2, r2) {
      var n2 = e2("../internals/global"), o2 = e2("../internals/fails"), i2 = e2("../internals/check-correctness-of-iteration"), a2 = e2("../internals/array-buffer-view-core").NATIVE_ARRAY_BUFFER_VIEWS, s = n2.ArrayBuffer, l2 = n2.Int8Array;
      t2.exports = !a2 || !o2(function() {
        l2(1);
      }) || !o2(function() {
        new l2(-1);
      }) || !i2(function(e3) {
        new l2(), new l2(null), new l2(1.5), new l2(e3);
      }, true) || o2(function() {
        return new l2(new s(2), 1, void 0).length !== 1;
      });
    }, { "../internals/array-buffer-view-core": 12, "../internals/check-correctness-of-iteration": 27, "../internals/fails": 50, "../internals/global": 59 }], 142: [function(e2, t2, r2) {
      var p2 = e2("../internals/to-object"), y = e2("../internals/to-length"), m2 = e2("../internals/get-iterator-method"), g = e2("../internals/is-array-iterator-method"), v = e2("../internals/function-bind-context"), b2 = e2("../internals/array-buffer-view-core").aTypedArrayConstructor;
      t2.exports = function(e3, t3, r3) {
        var n2, o2, i2, a2, s, l2, u2 = p2(e3), c = arguments.length, d = 1 < c ? t3 : void 0, f = d !== void 0, h2 = m2(u2);
        if (h2 != null && !g(h2))
          for (l2 = (s = h2.call(u2)).next, u2 = []; !(a2 = l2.call(s)).done; )
            u2.push(a2.value);
        for (f && 2 < c && (d = v(d, r3, 2)), o2 = y(u2.length), i2 = new (b2(this))(o2), n2 = 0; n2 < o2; n2++)
          i2[n2] = f ? d(u2[n2], n2) : u2[n2];
        return i2;
      };
    }, { "../internals/array-buffer-view-core": 12, "../internals/function-bind-context": 54, "../internals/get-iterator-method": 57, "../internals/is-array-iterator-method": 71, "../internals/to-length": 134, "../internals/to-object": 135 }], 143: [function(e2, t2, r2) {
      var n2 = 0, o2 = Math.random();
      t2.exports = function(e3) {
        return "Symbol(" + String(e3 === void 0 ? "" : e3) + ")_" + (++n2 + o2).toString(36);
      };
    }, {}], 144: [function(e2, t2, r2) {
      var n2 = e2("../internals/native-symbol");
      t2.exports = n2 && !Symbol.sham && typeof Symbol.iterator == "symbol";
    }, { "../internals/native-symbol": 83 }], 145: [function(e2, t2, r2) {
      var n2 = e2("../internals/well-known-symbol");
      r2.f = n2;
    }, { "../internals/well-known-symbol": 146 }], 146: [function(e2, t2, r2) {
      var n2 = e2("../internals/global"), o2 = e2("../internals/shared"), i2 = e2("../internals/has"), a2 = e2("../internals/uid"), s = e2("../internals/native-symbol"), l2 = e2("../internals/use-symbol-as-uid"), u2 = o2("wks"), c = n2.Symbol, d = l2 ? c : c && c.withoutSetter || a2;
      t2.exports = function(e3) {
        return i2(u2, e3) || (s && i2(c, e3) ? u2[e3] = c[e3] : u2[e3] = d("Symbol." + e3)), u2[e3];
      };
    }, { "../internals/global": 59, "../internals/has": 60, "../internals/native-symbol": 83, "../internals/shared": 120, "../internals/uid": 143, "../internals/use-symbol-as-uid": 144 }], 147: [function(e2, t2, r2) {
      t2.exports = "	\n\v\f\r \xA0\u1680\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u202F\u205F\u3000\u2028\u2029\uFEFF";
    }, {}], 148: [function(e2, t2, r2) {
      var n2 = e2("../internals/export"), o2 = e2("../internals/global"), i2 = e2("../internals/array-buffer"), a2 = e2("../internals/set-species"), s = "ArrayBuffer", l2 = i2[s];
      n2({ global: true, forced: o2[s] !== l2 }, { ArrayBuffer: l2 }), a2(s);
    }, { "../internals/array-buffer": 13, "../internals/export": 49, "../internals/global": 59, "../internals/set-species": 116 }], 149: [function(e2, t2, r2) {
      function u2(e3) {
        if (!a2(e3))
          return false;
        var t3 = e3[y];
        return t3 !== void 0 ? !!t3 : i2(e3);
      }
      var n2 = e2("../internals/export"), o2 = e2("../internals/fails"), i2 = e2("../internals/is-array"), a2 = e2("../internals/is-object"), c = e2("../internals/to-object"), d = e2("../internals/to-length"), f = e2("../internals/create-property"), h2 = e2("../internals/array-species-create"), s = e2("../internals/array-method-has-species-support"), l2 = e2("../internals/well-known-symbol"), p2 = e2("../internals/engine-v8-version"), y = l2("isConcatSpreadable"), m2 = 9007199254740991, g = "Maximum allowed index exceeded", v = 51 <= p2 || !o2(function() {
        var e3 = [];
        return e3[y] = false, e3.concat()[0] !== e3;
      }), b2 = s("concat");
      n2({ target: "Array", proto: true, forced: !v || !b2 }, { concat: function(e3) {
        var t3, r3, n3, o3, i3, a3 = c(this), s2 = h2(a3, 0), l3 = 0;
        for (t3 = -1, n3 = arguments.length; t3 < n3; t3++)
          if (u2(i3 = t3 === -1 ? a3 : arguments[t3])) {
            if (o3 = d(i3.length), m2 < l3 + o3)
              throw TypeError(g);
            for (r3 = 0; r3 < o3; r3++, l3++)
              r3 in i3 && f(s2, l3, i3[r3]);
          } else {
            if (m2 <= l3)
              throw TypeError(g);
            f(s2, l3++, i3);
          }
        return s2.length = l3, s2;
      } });
    }, { "../internals/array-method-has-species-support": 21, "../internals/array-species-create": 25, "../internals/create-property": 39, "../internals/engine-v8-version": 47, "../internals/export": 49, "../internals/fails": 50, "../internals/is-array": 72, "../internals/is-object": 74, "../internals/to-length": 134, "../internals/to-object": 135, "../internals/well-known-symbol": 146 }], 150: [function(e2, t2, r2) {
      var n2 = e2("../internals/export"), o2 = e2("../internals/array-iteration").every, i2 = e2("../internals/array-method-is-strict"), a2 = e2("../internals/array-method-uses-to-length"), s = i2("every"), l2 = a2("every");
      n2({ target: "Array", proto: true, forced: !s || !l2 }, { every: function(e3, t3) {
        return o2(this, e3, 1 < arguments.length ? t3 : void 0);
      } });
    }, { "../internals/array-iteration": 19, "../internals/array-method-is-strict": 22, "../internals/array-method-uses-to-length": 23, "../internals/export": 49 }], 151: [function(e2, t2, r2) {
      var n2 = e2("../internals/export"), o2 = e2("../internals/array-fill"), i2 = e2("../internals/add-to-unscopables");
      n2({ target: "Array", proto: true }, { fill: o2 }), i2("fill");
    }, { "../internals/add-to-unscopables": 7, "../internals/array-fill": 15, "../internals/export": 49 }], 152: [function(e2, t2, r2) {
      var n2 = e2("../internals/export"), o2 = e2("../internals/array-iteration").filter, i2 = e2("../internals/array-method-has-species-support"), a2 = e2("../internals/array-method-uses-to-length"), s = i2("filter"), l2 = a2("filter");
      n2({ target: "Array", proto: true, forced: !s || !l2 }, { filter: function(e3, t3) {
        return o2(this, e3, 1 < arguments.length ? t3 : void 0);
      } });
    }, { "../internals/array-iteration": 19, "../internals/array-method-has-species-support": 21, "../internals/array-method-uses-to-length": 23, "../internals/export": 49 }], 153: [function(e2, t2, r2) {
      var n2 = e2("../internals/export"), i2 = e2("../internals/flatten-into-array"), a2 = e2("../internals/to-object"), s = e2("../internals/to-length"), l2 = e2("../internals/a-function"), u2 = e2("../internals/array-species-create");
      n2({ target: "Array", proto: true }, { flatMap: function(e3, t3) {
        var r3, n3 = a2(this), o2 = s(n3.length);
        return l2(e3), (r3 = u2(n3, 0)).length = i2(r3, n3, n3, o2, 0, 1, e3, 1 < arguments.length ? t3 : void 0), r3;
      } });
    }, { "../internals/a-function": 5, "../internals/array-species-create": 25, "../internals/export": 49, "../internals/flatten-into-array": 52, "../internals/to-length": 134, "../internals/to-object": 135 }], 154: [function(e2, t2, r2) {
      var n2 = e2("../internals/export"), o2 = e2("../internals/array-for-each");
      n2({ target: "Array", proto: true, forced: [].forEach != o2 }, { forEach: o2 });
    }, { "../internals/array-for-each": 16, "../internals/export": 49 }], 155: [function(e2, t2, r2) {
      var n2 = e2("../internals/export"), o2 = e2("../internals/array-from");
      n2({ target: "Array", stat: true, forced: !e2("../internals/check-correctness-of-iteration")(function(e3) {
        Array.from(e3);
      }) }, { from: o2 });
    }, { "../internals/array-from": 17, "../internals/check-correctness-of-iteration": 27, "../internals/export": 49 }], 156: [function(e2, t2, r2) {
      var n2 = e2("../internals/export"), o2 = e2("../internals/array-includes").includes, i2 = e2("../internals/add-to-unscopables");
      n2({ target: "Array", proto: true, forced: !e2("../internals/array-method-uses-to-length")("indexOf", { ACCESSORS: true, 1: 0 }) }, { includes: function(e3, t3) {
        return o2(this, e3, 1 < arguments.length ? t3 : void 0);
      } }), i2("includes");
    }, { "../internals/add-to-unscopables": 7, "../internals/array-includes": 18, "../internals/array-method-uses-to-length": 23, "../internals/export": 49 }], 157: [function(e2, t2, r2) {
      var n2 = e2("../internals/export"), o2 = e2("../internals/array-includes").indexOf, i2 = e2("../internals/array-method-is-strict"), a2 = e2("../internals/array-method-uses-to-length"), s = [].indexOf, l2 = !!s && 1 / [1].indexOf(1, -0) < 0, u2 = i2("indexOf"), c = a2("indexOf", { ACCESSORS: true, 1: 0 });
      n2({ target: "Array", proto: true, forced: l2 || !u2 || !c }, { indexOf: function(e3, t3) {
        return l2 ? s.apply(this, arguments) || 0 : o2(this, e3, 1 < arguments.length ? t3 : void 0);
      } });
    }, { "../internals/array-includes": 18, "../internals/array-method-is-strict": 22, "../internals/array-method-uses-to-length": 23, "../internals/export": 49 }], 158: [function(e2, t2, r2) {
      var n2 = e2("../internals/to-indexed-object"), o2 = e2("../internals/add-to-unscopables"), i2 = e2("../internals/iterators"), a2 = e2("../internals/internal-state"), s = e2("../internals/define-iterator"), l2 = "Array Iterator", u2 = a2.set, c = a2.getterFor(l2);
      t2.exports = s(Array, "Array", function(e3, t3) {
        u2(this, { type: l2, target: n2(e3), index: 0, kind: t3 });
      }, function() {
        var e3 = c(this), t3 = e3.target, r3 = e3.kind, n3 = e3.index++;
        return !t3 || n3 >= t3.length ? { value: e3.target = void 0, done: true } : r3 == "keys" ? { value: n3, done: false } : r3 == "values" ? { value: t3[n3], done: false } : { value: [n3, t3[n3]], done: false };
      }, "values"), i2.Arguments = i2.Array, o2("keys"), o2("values"), o2("entries");
    }, { "../internals/add-to-unscopables": 7, "../internals/define-iterator": 40, "../internals/internal-state": 70, "../internals/iterators": 79, "../internals/to-indexed-object": 132 }], 159: [function(e2, t2, r2) {
      var n2 = e2("../internals/export"), o2 = e2("../internals/indexed-object"), i2 = e2("../internals/to-indexed-object"), a2 = e2("../internals/array-method-is-strict"), s = [].join, l2 = o2 != Object, u2 = a2("join", ",");
      n2({ target: "Array", proto: true, forced: l2 || !u2 }, { join: function(e3) {
        return s.call(i2(this), e3 === void 0 ? "," : e3);
      } });
    }, { "../internals/array-method-is-strict": 22, "../internals/export": 49, "../internals/indexed-object": 66, "../internals/to-indexed-object": 132 }], 160: [function(e2, t2, r2) {
      var n2 = e2("../internals/export"), o2 = e2("../internals/array-last-index-of");
      n2({ target: "Array", proto: true, forced: o2 !== [].lastIndexOf }, { lastIndexOf: o2 });
    }, { "../internals/array-last-index-of": 20, "../internals/export": 49 }], 161: [function(e2, t2, r2) {
      var n2 = e2("../internals/export"), o2 = e2("../internals/array-iteration").map, i2 = e2("../internals/array-method-has-species-support"), a2 = e2("../internals/array-method-uses-to-length"), s = i2("map"), l2 = a2("map");
      n2({ target: "Array", proto: true, forced: !s || !l2 }, { map: function(e3, t3) {
        return o2(this, e3, 1 < arguments.length ? t3 : void 0);
      } });
    }, { "../internals/array-iteration": 19, "../internals/array-method-has-species-support": 21, "../internals/array-method-uses-to-length": 23, "../internals/export": 49 }], 162: [function(e2, t2, r2) {
      var n2 = e2("../internals/export"), u2 = e2("../internals/is-object"), c = e2("../internals/is-array"), d = e2("../internals/to-absolute-index"), f = e2("../internals/to-length"), h2 = e2("../internals/to-indexed-object"), p2 = e2("../internals/create-property"), o2 = e2("../internals/well-known-symbol"), i2 = e2("../internals/array-method-has-species-support"), a2 = e2("../internals/array-method-uses-to-length"), s = i2("slice"), l2 = a2("slice", { ACCESSORS: true, 0: 0, 1: 2 }), y = o2("species"), m2 = [].slice, g = Math.max;
      n2({ target: "Array", proto: true, forced: !s || !l2 }, { slice: function(e3, t3) {
        var r3, n3, o3, i3 = h2(this), a3 = f(i3.length), s2 = d(e3, a3), l3 = d(t3 === void 0 ? a3 : t3, a3);
        if (c(i3) && (typeof (r3 = i3.constructor) != "function" || r3 !== Array && !c(r3.prototype) ? u2(r3) && (r3 = r3[y]) === null && (r3 = void 0) : r3 = void 0, r3 === Array || r3 === void 0))
          return m2.call(i3, s2, l3);
        for (n3 = new (r3 === void 0 ? Array : r3)(g(l3 - s2, 0)), o3 = 0; s2 < l3; s2++, o3++)
          s2 in i3 && p2(n3, o3, i3[s2]);
        return n3.length = o3, n3;
      } });
    }, { "../internals/array-method-has-species-support": 21, "../internals/array-method-uses-to-length": 23, "../internals/create-property": 39, "../internals/export": 49, "../internals/is-array": 72, "../internals/is-object": 74, "../internals/to-absolute-index": 130, "../internals/to-indexed-object": 132, "../internals/to-length": 134, "../internals/well-known-symbol": 146 }], 163: [function(e2, t2, r2) {
      var n2 = e2("../internals/export"), o2 = e2("../internals/array-iteration").some, i2 = e2("../internals/array-method-is-strict"), a2 = e2("../internals/array-method-uses-to-length"), s = i2("some"), l2 = a2("some");
      n2({ target: "Array", proto: true, forced: !s || !l2 }, { some: function(e3, t3) {
        return o2(this, e3, 1 < arguments.length ? t3 : void 0);
      } });
    }, { "../internals/array-iteration": 19, "../internals/array-method-is-strict": 22, "../internals/array-method-uses-to-length": 23, "../internals/export": 49 }], 164: [function(e2, t2, r2) {
      var n2 = e2("../internals/export"), f = e2("../internals/to-absolute-index"), h2 = e2("../internals/to-integer"), p2 = e2("../internals/to-length"), y = e2("../internals/to-object"), m2 = e2("../internals/array-species-create"), g = e2("../internals/create-property"), o2 = e2("../internals/array-method-has-species-support"), i2 = e2("../internals/array-method-uses-to-length"), a2 = o2("splice"), s = i2("splice", { ACCESSORS: true, 0: 0, 1: 2 }), v = Math.max, b2 = Math.min;
      n2({ target: "Array", proto: true, forced: !a2 || !s }, { splice: function(e3, t3) {
        var r3, n3, o3, i3, a3, s2, l2 = y(this), u2 = p2(l2.length), c = f(e3, u2), d = arguments.length;
        if (d === 0 ? r3 = n3 = 0 : n3 = d === 1 ? (r3 = 0, u2 - c) : (r3 = d - 2, b2(v(h2(t3), 0), u2 - c)), 9007199254740991 < u2 + r3 - n3)
          throw TypeError("Maximum allowed length exceeded");
        for (o3 = m2(l2, n3), i3 = 0; i3 < n3; i3++)
          (a3 = c + i3) in l2 && g(o3, i3, l2[a3]);
        if (r3 < (o3.length = n3)) {
          for (i3 = c; i3 < u2 - n3; i3++)
            s2 = i3 + r3, (a3 = i3 + n3) in l2 ? l2[s2] = l2[a3] : delete l2[s2];
          for (i3 = u2; u2 - n3 + r3 < i3; i3--)
            delete l2[i3 - 1];
        } else if (n3 < r3)
          for (i3 = u2 - n3; c < i3; i3--)
            s2 = i3 + r3 - 1, (a3 = i3 + n3 - 1) in l2 ? l2[s2] = l2[a3] : delete l2[s2];
        for (i3 = 0; i3 < r3; i3++)
          l2[i3 + c] = arguments[i3 + 2];
        return l2.length = u2 - n3 + r3, o3;
      } });
    }, { "../internals/array-method-has-species-support": 21, "../internals/array-method-uses-to-length": 23, "../internals/array-species-create": 25, "../internals/create-property": 39, "../internals/export": 49, "../internals/to-absolute-index": 130, "../internals/to-integer": 133, "../internals/to-length": 134, "../internals/to-object": 135 }], 165: [function(e2, t2, r2) {
      e2("../internals/add-to-unscopables")("flatMap");
    }, { "../internals/add-to-unscopables": 7 }], 166: [function(e2, t2, r2) {
      var n2 = e2("../internals/descriptors"), o2 = e2("../internals/object-define-property").f, i2 = Function.prototype, a2 = i2.toString, s = /^\s*function ([^ (]*)/;
      !n2 || "name" in i2 || o2(i2, "name", { configurable: true, get: function() {
        try {
          return a2.call(this).match(s)[1];
        } catch (e3) {
          return "";
        }
      } });
    }, { "../internals/descriptors": 42, "../internals/object-define-property": 92 }], 167: [function(e2, t2, r2) {
      var n2 = e2("../internals/collection"), o2 = e2("../internals/collection-strong");
      t2.exports = n2("Map", function(t3) {
        return function(e3) {
          return t3(this, arguments.length ? e3 : void 0);
        };
      }, o2);
    }, { "../internals/collection": 31, "../internals/collection-strong": 30 }], 168: [function(e2, t2, r2) {
      var n2 = e2("../internals/export"), o2 = Math.hypot, l2 = Math.abs, u2 = Math.sqrt;
      n2({ target: "Math", stat: true, forced: !!o2 && o2(1 / 0, NaN) !== 1 / 0 }, { hypot: function(e3, t3) {
        for (var r3, n3, o3 = 0, i2 = 0, a2 = arguments.length, s = 0; i2 < a2; )
          s < (r3 = l2(arguments[i2++])) ? (o3 = o3 * (n3 = s / r3) * n3 + 1, s = r3) : o3 += 0 < r3 ? (n3 = r3 / s) * n3 : r3;
        return s === 1 / 0 ? 1 / 0 : s * u2(o3);
      } });
    }, { "../internals/export": 49 }], 169: [function(e2, t2, r2) {
      e2("../internals/export")({ target: "Math", stat: true }, { sign: e2("../internals/math-sign") });
    }, { "../internals/export": 49, "../internals/math-sign": 80 }], 170: [function(e2, t2, r2) {
      function n2(e3) {
        var t3, r3, n3, o3, i3, a3, s2, l3, u3 = d(e3, false);
        if (typeof u3 == "string" && 2 < u3.length) {
          if ((t3 = (u3 = g(u3)).charCodeAt(0)) === 43 || t3 === 45) {
            if ((r3 = u3.charCodeAt(2)) === 88 || r3 === 120)
              return NaN;
          } else if (t3 === 48) {
            switch (u3.charCodeAt(1)) {
              case 66:
              case 98:
                n3 = 2, o3 = 49;
                break;
              case 79:
              case 111:
                n3 = 8, o3 = 55;
                break;
              default:
                return +u3;
            }
            for (a3 = (i3 = u3.slice(2)).length, s2 = 0; s2 < a3; s2++)
              if ((l3 = i3.charCodeAt(s2)) < 48 || o3 < l3)
                return NaN;
            return parseInt(i3, n3);
          }
        }
        return +u3;
      }
      var o2 = e2("../internals/descriptors"), i2 = e2("../internals/global"), a2 = e2("../internals/is-forced"), s = e2("../internals/redefine"), l2 = e2("../internals/has"), u2 = e2("../internals/classof-raw"), c = e2("../internals/inherit-if-required"), d = e2("../internals/to-primitive"), f = e2("../internals/fails"), h2 = e2("../internals/object-create"), p2 = e2("../internals/object-get-own-property-names").f, y = e2("../internals/object-get-own-property-descriptor").f, m2 = e2("../internals/object-define-property").f, g = e2("../internals/string-trim").trim, v = "Number", b2 = i2[v], _ = b2.prototype, x = u2(h2(_)) == v;
      if (a2(v, !b2(" 0o1") || !b2("0b1") || b2("+0x1"))) {
        for (var w, j = function(e3) {
          var t3 = arguments.length < 1 ? 0 : e3, r3 = this;
          return r3 instanceof j && (x ? f(function() {
            _.valueOf.call(r3);
          }) : u2(r3) != v) ? c(new b2(n2(t3)), r3, j) : n2(t3);
        }, S2 = o2 ? p2(b2) : "MAX_VALUE,MIN_VALUE,NaN,NEGATIVE_INFINITY,POSITIVE_INFINITY,EPSILON,isFinite,isInteger,isNaN,isSafeInteger,MAX_SAFE_INTEGER,MIN_SAFE_INTEGER,parseFloat,parseInt,isInteger".split(","), M = 0; S2.length > M; M++)
          l2(b2, w = S2[M]) && !l2(j, w) && m2(j, w, y(b2, w));
        (j.prototype = _).constructor = j, s(i2, v, j);
      }
    }, { "../internals/classof-raw": 28, "../internals/descriptors": 42, "../internals/fails": 50, "../internals/global": 59, "../internals/has": 60, "../internals/inherit-if-required": 67, "../internals/is-forced": 73, "../internals/object-create": 90, "../internals/object-define-property": 92, "../internals/object-get-own-property-descriptor": 93, "../internals/object-get-own-property-names": 95, "../internals/redefine": 108, "../internals/string-trim": 127, "../internals/to-primitive": 138 }], 171: [function(e2, t2, r2) {
      e2("../internals/export")({ target: "Number", stat: true }, { isFinite: e2("../internals/number-is-finite") });
    }, { "../internals/export": 49, "../internals/number-is-finite": 88 }], 172: [function(e2, t2, r2) {
      var n2 = e2("../internals/export"), h2 = e2("../internals/to-integer"), p2 = e2("../internals/this-number-value"), y = e2("../internals/string-repeat"), o2 = e2("../internals/fails"), i2 = 1 .toFixed, m2 = Math.floor, g = function(e3, t3, r3) {
        return t3 === 0 ? r3 : t3 % 2 == 1 ? g(e3, t3 - 1, r3 * e3) : g(e3 * e3, t3 / 2, r3);
      };
      n2({ target: "Number", proto: true, forced: i2 && (8e-5 .toFixed(3) !== "0.000" || 0.9 .toFixed(0) !== "1" || 1.255 .toFixed(2) !== "1.25" || 1000000000000000100 .toFixed(0) !== "1000000000000000128") || !o2(function() {
        i2.call({});
      }) }, { toFixed: function(e3) {
        function t3(e4, t4) {
          for (var r4 = -1, n4 = t4; ++r4 < 6; )
            n4 += e4 * c[r4], c[r4] = n4 % 1e7, n4 = m2(n4 / 1e7);
        }
        function r3(e4) {
          for (var t4 = 6, r4 = 0; 0 <= --t4; )
            r4 += c[t4], c[t4] = m2(r4 / e4), r4 = r4 % e4 * 1e7;
        }
        function n3() {
          for (var e4 = 6, t4 = ""; 0 <= --e4; )
            if (t4 !== "" || e4 === 0 || c[e4] !== 0) {
              var r4 = String(c[e4]);
              t4 = t4 === "" ? r4 : t4 + y.call("0", 7 - r4.length) + r4;
            }
          return t4;
        }
        var o3, i3, a2, s, l2 = p2(this), u2 = h2(e3), c = [0, 0, 0, 0, 0, 0], d = "", f = "0";
        if (u2 < 0 || 20 < u2)
          throw RangeError("Incorrect fraction digits");
        if (l2 != l2)
          return "NaN";
        if (l2 <= -1e21 || 1e21 <= l2)
          return String(l2);
        if (l2 < 0 && (d = "-", l2 = -l2), 1e-21 < l2)
          if (i3 = (o3 = function(e4) {
            for (var t4 = 0, r4 = e4; 4096 <= r4; )
              t4 += 12, r4 /= 4096;
            for (; 2 <= r4; )
              t4 += 1, r4 /= 2;
            return t4;
          }(l2 * g(2, 69, 1)) - 69) < 0 ? l2 * g(2, -o3, 1) : l2 / g(2, o3, 1), i3 *= 4503599627370496, 0 < (o3 = 52 - o3)) {
            for (t3(0, i3), a2 = u2; 7 <= a2; )
              t3(1e7, 0), a2 -= 7;
            for (t3(g(10, a2, 1), 0), a2 = o3 - 1; 23 <= a2; )
              r3(1 << 23), a2 -= 23;
            r3(1 << a2), t3(1, 1), r3(2), f = n3();
          } else
            t3(0, i3), t3(1 << -o3, 0), f = n3() + y.call("0", u2);
        return f = 0 < u2 ? d + ((s = f.length) <= u2 ? "0." + y.call("0", u2 - s) + f : f.slice(0, s - u2) + "." + f.slice(s - u2)) : d + f;
      } });
    }, { "../internals/export": 49, "../internals/fails": 50, "../internals/string-repeat": 125, "../internals/this-number-value": 129, "../internals/to-integer": 133 }], 173: [function(e2, t2, r2) {
      var n2 = e2("../internals/export"), o2 = e2("../internals/object-assign");
      n2({ target: "Object", stat: true, forced: Object.assign !== o2 }, { assign: o2 });
    }, { "../internals/export": 49, "../internals/object-assign": 89 }], 174: [function(e2, t2, r2) {
      var n2 = e2("../internals/export"), o2 = e2("../internals/fails"), i2 = e2("../internals/object-get-own-property-names-external").f;
      n2({ target: "Object", stat: true, forced: o2(function() {
        return !Object.getOwnPropertyNames(1);
      }) }, { getOwnPropertyNames: i2 });
    }, { "../internals/export": 49, "../internals/fails": 50, "../internals/object-get-own-property-names-external": 94 }], 175: [function(e2, t2, r2) {
      var n2 = e2("../internals/export"), o2 = e2("../internals/fails"), i2 = e2("../internals/to-object"), a2 = e2("../internals/object-get-prototype-of"), s = e2("../internals/correct-prototype-getter");
      n2({ target: "Object", stat: true, forced: o2(function() {
        a2(1);
      }), sham: !s }, { getPrototypeOf: function(e3) {
        return a2(i2(e3));
      } });
    }, { "../internals/correct-prototype-getter": 34, "../internals/export": 49, "../internals/fails": 50, "../internals/object-get-prototype-of": 97, "../internals/to-object": 135 }], 176: [function(e2, t2, r2) {
      var n2 = e2("../internals/export"), o2 = e2("../internals/to-object"), i2 = e2("../internals/object-keys");
      n2({ target: "Object", stat: true, forced: e2("../internals/fails")(function() {
        i2(1);
      }) }, { keys: function(e3) {
        return i2(o2(e3));
      } });
    }, { "../internals/export": 49, "../internals/fails": 50, "../internals/object-keys": 99, "../internals/to-object": 135 }], 177: [function(e2, t2, r2) {
      var n2 = e2("../internals/to-string-tag-support"), o2 = e2("../internals/redefine"), i2 = e2("../internals/object-to-string");
      n2 || o2(Object.prototype, "toString", i2, { unsafe: true });
    }, { "../internals/object-to-string": 102, "../internals/redefine": 108, "../internals/to-string-tag-support": 139 }], 178: [function(e2, t2, r2) {
      function y(e3) {
        var t3;
        return !(!x(e3) || typeof (t3 = e3.then) != "function") && t3;
      }
      function i2(d2, f2, h3) {
        if (!f2.notified) {
          f2.notified = true;
          var p3 = f2.reactions;
          L(function() {
            for (var e3 = f2.value, t3 = f2.state == 1, r3 = 0; p3.length > r3; ) {
              var n3, o3, i3, a3 = p3[r3++], s2 = t3 ? a3.ok : a3.fail, l3 = a3.resolve, u3 = a3.reject, c2 = a3.domain;
              try {
                s2 ? (t3 || (f2.rejection === 2 && oe(d2, f2), f2.rejection = 1), s2 === true ? n3 = e3 : (c2 && c2.enter(), n3 = s2(e3), c2 && (c2.exit(), i3 = true)), n3 === a3.promise ? u3(W2("Promise-chain cycle")) : (o3 = y(n3)) ? o3.call(n3, l3, u3) : l3(n3)) : u3(e3);
              } catch (e4) {
                c2 && !i3 && c2.exit(), u3(e4);
              }
            }
            f2.reactions = [], f2.notified = false, h3 && !f2.rejection && re(d2, f2);
          });
        }
      }
      function o2(e3, t3, r3) {
        var n3, o3;
        J ? ((n3 = q.createEvent("Event")).promise = t3, n3.reason = r3, n3.initEvent(e3, false, true), h2.dispatchEvent(n3)) : n3 = { promise: t3, reason: r3 }, (o3 = h2["on" + e3]) ? o3(n3) : e3 === $ && A("Unhandled promise rejection", r3);
      }
      function a2(t3, r3, n3, o3) {
        return function(e3) {
          t3(r3, n3, e3, o3);
        };
      }
      function s(e3, t3, r3, n3) {
        t3.done || (t3.done = true, n3 && (t3 = n3), t3.value = r3, t3.state = 2, i2(e3, t3, true));
      }
      var n2, l2, u2, c, d = e2("../internals/export"), f = e2("../internals/is-pure"), h2 = e2("../internals/global"), p2 = e2("../internals/get-built-in"), m2 = e2("../internals/native-promise-constructor"), g = e2("../internals/redefine"), v = e2("../internals/redefine-all"), b2 = e2("../internals/set-to-string-tag"), _ = e2("../internals/set-species"), x = e2("../internals/is-object"), w = e2("../internals/a-function"), j = e2("../internals/an-instance"), S2 = e2("../internals/classof-raw"), M = e2("../internals/inspect-source"), E = e2("../internals/iterate"), T2 = e2("../internals/check-correctness-of-iteration"), O2 = e2("../internals/species-constructor"), C = e2("../internals/task").set, L = e2("../internals/microtask"), P2 = e2("../internals/promise-resolve"), A = e2("../internals/host-report-errors"), k2 = e2("../internals/new-promise-capability"), R2 = e2("../internals/perform"), D = e2("../internals/internal-state"), I = e2("../internals/is-forced"), U = e2("../internals/well-known-symbol"), N = e2("../internals/engine-v8-version"), F = U("species"), B = "Promise", G = D.get, V = D.set, z = D.getterFor(B), H = m2, W2 = h2.TypeError, q = h2.document, X2 = h2.process, Y2 = p2("fetch"), Z = k2.f, Q = Z, K2 = S2(X2) == "process", J = !!(q && q.createEvent && h2.dispatchEvent), $ = "unhandledrejection", ee = I(B, function() {
        if (!(M(H) !== String(H))) {
          if (N === 66)
            return true;
          if (!K2 && typeof PromiseRejectionEvent != "function")
            return true;
        }
        if (f && !H.prototype.finally)
          return true;
        if (51 <= N && /native code/.test(H))
          return false;
        function e3(e4) {
          e4(function() {
          }, function() {
          });
        }
        var t3 = H.resolve(1);
        return (t3.constructor = {})[F] = e3, !(t3.then(function() {
        }) instanceof e3);
      }), te = ee || !T2(function(e3) {
        H.all(e3).catch(function() {
        });
      }), re = function(r3, n3) {
        C.call(h2, function() {
          var e3, t3 = n3.value;
          if (ne(n3) && (e3 = R2(function() {
            K2 ? X2.emit("unhandledRejection", t3, r3) : o2($, r3, t3);
          }), n3.rejection = K2 || ne(n3) ? 2 : 1, e3.error))
            throw e3.value;
        });
      }, ne = function(e3) {
        return e3.rejection !== 1 && !e3.parent;
      }, oe = function(e3, t3) {
        C.call(h2, function() {
          K2 ? X2.emit("rejectionHandled", e3) : o2("rejectionhandled", e3, t3.value);
        });
      }, ie = function(r3, n3, e3, t3) {
        if (!n3.done) {
          n3.done = true, t3 && (n3 = t3);
          try {
            if (r3 === e3)
              throw W2("Promise can't be resolved itself");
            var o3 = y(e3);
            o3 ? L(function() {
              var t4 = { done: false };
              try {
                o3.call(e3, a2(ie, r3, t4, n3), a2(s, r3, t4, n3));
              } catch (e4) {
                s(r3, t4, e4, n3);
              }
            }) : (n3.value = e3, n3.state = 1, i2(r3, n3, false));
          } catch (e4) {
            s(r3, { done: false }, e4, n3);
          }
        }
      };
      ee && (H = function(e3) {
        j(this, H, B), w(e3), n2.call(this);
        var t3 = G(this);
        try {
          e3(a2(ie, this, t3), a2(s, this, t3));
        } catch (e4) {
          s(this, t3, e4);
        }
      }, (n2 = function() {
        V(this, { type: B, done: false, notified: false, parent: false, reactions: [], rejection: false, state: 0, value: void 0 });
      }).prototype = v(H.prototype, { then: function(e3, t3) {
        var r3 = z(this), n3 = Z(O2(this, H));
        return n3.ok = typeof e3 != "function" || e3, n3.fail = typeof t3 == "function" && t3, n3.domain = K2 ? X2.domain : void 0, r3.parent = true, r3.reactions.push(n3), r3.state != 0 && i2(this, r3, false), n3.promise;
      }, catch: function(e3) {
        return this.then(void 0, e3);
      } }), l2 = function() {
        var e3 = new n2(), t3 = G(e3);
        this.promise = e3, this.resolve = a2(ie, e3, t3), this.reject = a2(s, e3, t3);
      }, k2.f = Z = function(e3) {
        return e3 === H || e3 === u2 ? new l2(e3) : Q(e3);
      }, f || typeof m2 != "function" || (c = m2.prototype.then, g(m2.prototype, "then", function(e3, t3) {
        var r3 = this;
        return new H(function(e4, t4) {
          c.call(r3, e4, t4);
        }).then(e3, t3);
      }, { unsafe: true }), typeof Y2 == "function" && d({ global: true, enumerable: true, forced: true }, { fetch: function(e3) {
        return P2(H, Y2.apply(h2, arguments));
      } }))), d({ global: true, wrap: true, forced: ee }, { Promise: H }), b2(H, B, false, true), _(B), u2 = p2(B), d({ target: B, stat: true, forced: ee }, { reject: function(e3) {
        var t3 = Z(this);
        return t3.reject.call(void 0, e3), t3.promise;
      } }), d({ target: B, stat: true, forced: f || ee }, { resolve: function(e3) {
        return P2(f && this === u2 ? H : this, e3);
      } }), d({ target: B, stat: true, forced: te }, { all: function(e3) {
        var s2 = this, t3 = Z(s2), l3 = t3.resolve, u3 = t3.reject, r3 = R2(function() {
          var n3 = w(s2.resolve), o3 = [], i3 = 0, a3 = 1;
          E(e3, function(e4) {
            var t4 = i3++, r4 = false;
            o3.push(void 0), a3++, n3.call(s2, e4).then(function(e5) {
              r4 || (r4 = true, o3[t4] = e5, --a3 || l3(o3));
            }, u3);
          }), --a3 || l3(o3);
        });
        return r3.error && u3(r3.value), t3.promise;
      }, race: function(e3) {
        var r3 = this, n3 = Z(r3), o3 = n3.reject, t3 = R2(function() {
          var t4 = w(r3.resolve);
          E(e3, function(e4) {
            t4.call(r3, e4).then(n3.resolve, o3);
          });
        });
        return t3.error && o3(t3.value), n3.promise;
      } });
    }, { "../internals/a-function": 5, "../internals/an-instance": 9, "../internals/check-correctness-of-iteration": 27, "../internals/classof-raw": 28, "../internals/engine-v8-version": 47, "../internals/export": 49, "../internals/get-built-in": 56, "../internals/global": 59, "../internals/host-report-errors": 62, "../internals/inspect-source": 68, "../internals/internal-state": 70, "../internals/is-forced": 73, "../internals/is-object": 74, "../internals/is-pure": 75, "../internals/iterate": 77, "../internals/microtask": 81, "../internals/native-promise-constructor": 82, "../internals/new-promise-capability": 86, "../internals/perform": 105, "../internals/promise-resolve": 106, "../internals/redefine": 108, "../internals/redefine-all": 107, "../internals/set-species": 116, "../internals/set-to-string-tag": 117, "../internals/species-constructor": 121, "../internals/task": 128, "../internals/well-known-symbol": 146 }], 179: [function(e2, t2, r2) {
      var n2 = e2("../internals/export"), o2 = e2("../internals/get-built-in"), l2 = e2("../internals/a-function"), u2 = e2("../internals/an-object"), c = e2("../internals/is-object"), d = e2("../internals/object-create"), f = e2("../internals/function-bind"), i2 = e2("../internals/fails"), h2 = o2("Reflect", "construct"), p2 = i2(function() {
        function e3() {
        }
        return !(h2(function() {
        }, [], e3) instanceof e3);
      }), y = !i2(function() {
        h2(function() {
        });
      }), a2 = p2 || y;
      n2({ target: "Reflect", stat: true, forced: a2, sham: a2 }, { construct: function(e3, t3, r3) {
        l2(e3), u2(t3);
        var n3 = arguments.length < 3 ? e3 : l2(r3);
        if (y && !p2)
          return h2(e3, t3, n3);
        if (e3 == n3) {
          switch (t3.length) {
            case 0:
              return new e3();
            case 1:
              return new e3(t3[0]);
            case 2:
              return new e3(t3[0], t3[1]);
            case 3:
              return new e3(t3[0], t3[1], t3[2]);
            case 4:
              return new e3(t3[0], t3[1], t3[2], t3[3]);
          }
          var o3 = [null];
          return o3.push.apply(o3, t3), new (f.apply(e3, o3))();
        }
        var i3 = n3.prototype, a3 = d(c(i3) ? i3 : Object.prototype), s = Function.apply.call(e3, a3, t3);
        return c(s) ? s : a3;
      } });
    }, { "../internals/a-function": 5, "../internals/an-object": 10, "../internals/export": 49, "../internals/fails": 50, "../internals/function-bind": 55, "../internals/get-built-in": 56, "../internals/is-object": 74, "../internals/object-create": 90 }], 180: [function(e2, t2, r2) {
      var n2 = e2("../internals/descriptors"), o2 = e2("../internals/global"), i2 = e2("../internals/is-forced"), s = e2("../internals/inherit-if-required"), a2 = e2("../internals/object-define-property").f, l2 = e2("../internals/object-get-own-property-names").f, u2 = e2("../internals/is-regexp"), c = e2("../internals/regexp-flags"), d = e2("../internals/regexp-sticky-helpers"), f = e2("../internals/redefine"), h2 = e2("../internals/fails"), p2 = e2("../internals/internal-state").set, y = e2("../internals/set-species"), m2 = e2("../internals/well-known-symbol")("match"), g = o2.RegExp, v = g.prototype, b2 = /a/g, _ = /a/g, x = new g(b2) !== b2, w = d.UNSUPPORTED_Y;
      if (n2 && i2("RegExp", !x || w || h2(function() {
        return _[m2] = false, g(b2) != b2 || g(_) == _ || g(b2, "i") != "/a/i";
      }))) {
        let j2 = function(t3) {
          t3 in S2 || a2(S2, t3, { configurable: true, get: function() {
            return g[t3];
          }, set: function(e3) {
            g[t3] = e3;
          } });
        };
        var j = j2;
        for (var S2 = function(e3, t3) {
          var r3, n3 = this instanceof S2, o3 = u2(e3), i3 = t3 === void 0;
          if (!n3 && o3 && e3.constructor === S2 && i3)
            return e3;
          x ? o3 && !i3 && (e3 = e3.source) : e3 instanceof S2 && (i3 && (t3 = c.call(e3)), e3 = e3.source), w && (r3 = !!t3 && -1 < t3.indexOf("y")) && (t3 = t3.replace(/y/g, ""));
          var a3 = s(x ? new g(e3, t3) : g(e3, t3), n3 ? this : v, S2);
          return w && r3 && p2(a3, { sticky: r3 }), a3;
        }, M = l2(g), E = 0; M.length > E; )
          j2(M[E++]);
        (v.constructor = S2).prototype = v, f(o2, "RegExp", S2);
      }
      y("RegExp");
    }, { "../internals/descriptors": 42, "../internals/fails": 50, "../internals/global": 59, "../internals/inherit-if-required": 67, "../internals/internal-state": 70, "../internals/is-forced": 73, "../internals/is-regexp": 76, "../internals/object-define-property": 92, "../internals/object-get-own-property-names": 95, "../internals/redefine": 108, "../internals/regexp-flags": 111, "../internals/regexp-sticky-helpers": 112, "../internals/set-species": 116, "../internals/well-known-symbol": 146 }], 181: [function(e2, t2, r2) {
      var n2 = e2("../internals/export"), o2 = e2("../internals/regexp-exec");
      n2({ target: "RegExp", proto: true, forced: /./.exec !== o2 }, { exec: o2 });
    }, { "../internals/export": 49, "../internals/regexp-exec": 110 }], 182: [function(e2, t2, r2) {
      var n2 = e2("../internals/redefine"), o2 = e2("../internals/an-object"), i2 = e2("../internals/fails"), a2 = e2("../internals/regexp-flags"), s = "toString", l2 = RegExp.prototype, u2 = l2[s], c = i2(function() {
        return u2.call({ source: "a", flags: "b" }) != "/a/b";
      }), d = u2.name != s;
      (c || d) && n2(RegExp.prototype, s, function() {
        var e3 = o2(this), t3 = String(e3.source), r3 = e3.flags;
        return "/" + t3 + "/" + String(r3 === void 0 && e3 instanceof RegExp && !("flags" in l2) ? a2.call(e3) : r3);
      }, { unsafe: true });
    }, { "../internals/an-object": 10, "../internals/fails": 50, "../internals/redefine": 108, "../internals/regexp-flags": 111 }], 183: [function(e2, t2, r2) {
      var n2 = e2("../internals/collection"), o2 = e2("../internals/collection-strong");
      t2.exports = n2("Set", function(t3) {
        return function(e3) {
          return t3(this, arguments.length ? e3 : void 0);
        };
      }, o2);
    }, { "../internals/collection": 31, "../internals/collection-strong": 30 }], 184: [function(e2, t2, r2) {
      var n2, o2 = e2("../internals/export"), i2 = e2("../internals/object-get-own-property-descriptor").f, s = e2("../internals/to-length"), l2 = e2("../internals/not-a-regexp"), u2 = e2("../internals/require-object-coercible"), a2 = e2("../internals/correct-is-regexp-logic"), c = e2("../internals/is-pure"), d = "".endsWith, f = Math.min, h2 = a2("endsWith");
      o2({ target: "String", proto: true, forced: !!(c || h2 || (!(n2 = i2(String.prototype, "endsWith")) || n2.writable)) && !h2 }, { endsWith: function(e3, t3) {
        var r3 = String(u2(this));
        l2(e3);
        var n3 = 1 < arguments.length ? t3 : void 0, o3 = s(r3.length), i3 = n3 === void 0 ? o3 : f(s(n3), o3), a3 = String(e3);
        return d ? d.call(r3, a3, i3) : r3.slice(i3 - a3.length, i3) === a3;
      } });
    }, { "../internals/correct-is-regexp-logic": 33, "../internals/export": 49, "../internals/is-pure": 75, "../internals/not-a-regexp": 87, "../internals/object-get-own-property-descriptor": 93, "../internals/require-object-coercible": 113, "../internals/to-length": 134 }], 185: [function(e2, t2, r2) {
      var n2 = e2("../internals/export"), o2 = e2("../internals/not-a-regexp"), i2 = e2("../internals/require-object-coercible");
      n2({ target: "String", proto: true, forced: !e2("../internals/correct-is-regexp-logic")("includes") }, { includes: function(e3, t3) {
        return !!~String(i2(this)).indexOf(o2(e3), 1 < arguments.length ? t3 : void 0);
      } });
    }, { "../internals/correct-is-regexp-logic": 33, "../internals/export": 49, "../internals/not-a-regexp": 87, "../internals/require-object-coercible": 113 }], 186: [function(e2, t2, r2) {
      var o2 = e2("../internals/string-multibyte").charAt, n2 = e2("../internals/internal-state"), i2 = e2("../internals/define-iterator"), a2 = "String Iterator", s = n2.set, l2 = n2.getterFor(a2);
      i2(String, "String", function(e3) {
        s(this, { type: a2, string: String(e3), index: 0 });
      }, function() {
        var e3, t3 = l2(this), r3 = t3.string, n3 = t3.index;
        return n3 >= r3.length ? { value: void 0, done: true } : (e3 = o2(r3, n3), t3.index += e3.length, { value: e3, done: false });
      });
    }, { "../internals/define-iterator": 40, "../internals/internal-state": 70, "../internals/string-multibyte": 123 }], 187: [function(e2, t2, r2) {
      var n2 = e2("../internals/fix-regexp-well-known-symbol-logic"), d = e2("../internals/an-object"), f = e2("../internals/to-length"), o2 = e2("../internals/require-object-coercible"), h2 = e2("../internals/advance-string-index"), p2 = e2("../internals/regexp-exec-abstract");
      n2("match", 1, function(n3, u2, c) {
        return [function(e3) {
          var t3 = o2(this), r3 = e3 == null ? void 0 : e3[n3];
          return r3 !== void 0 ? r3.call(e3, t3) : new RegExp(e3)[n3](String(t3));
        }, function(e3) {
          var t3 = c(u2, e3, this);
          if (t3.done)
            return t3.value;
          var r3 = d(e3), n4 = String(this);
          if (!r3.global)
            return p2(r3, n4);
          for (var o3, i2 = r3.unicode, a2 = [], s = r3.lastIndex = 0; (o3 = p2(r3, n4)) !== null; ) {
            var l2 = String(o3[0]);
            (a2[s] = l2) === "" && (r3.lastIndex = h2(n4, f(r3.lastIndex), i2)), s++;
          }
          return s === 0 ? null : a2;
        }];
      });
    }, { "../internals/advance-string-index": 8, "../internals/an-object": 10, "../internals/fix-regexp-well-known-symbol-logic": 51, "../internals/regexp-exec-abstract": 109, "../internals/require-object-coercible": 113, "../internals/to-length": 134 }], 188: [function(e2, t2, r2) {
      e2("../internals/export")({ target: "String", proto: true }, { repeat: e2("../internals/string-repeat") });
    }, { "../internals/export": 49, "../internals/string-repeat": 125 }], 189: [function(e2, t2, r2) {
      var n2 = e2("../internals/fix-regexp-well-known-symbol-logic"), T2 = e2("../internals/an-object"), f = e2("../internals/to-object"), O2 = e2("../internals/to-length"), C = e2("../internals/to-integer"), i2 = e2("../internals/require-object-coercible"), L = e2("../internals/advance-string-index"), P2 = e2("../internals/regexp-exec-abstract"), A = Math.max, k2 = Math.min, h2 = Math.floor, p2 = /\$([$&'`]|\d\d?|<[^>]*>)/g, y = /\$([$&'`]|\d\d?)/g;
      n2("replace", 2, function(o2, x, w, e3) {
        var j = e3.REGEXP_REPLACE_SUBSTITUTES_UNDEFINED_CAPTURE, S2 = e3.REPLACE_KEEPS_$0, M = j ? "$" : "$0";
        return [function(e4, t3) {
          var r3 = i2(this), n3 = e4 == null ? void 0 : e4[o2];
          return n3 !== void 0 ? n3.call(e4, r3, t3) : x.call(String(r3), e4, t3);
        }, function(e4, t3) {
          if (!j && S2 || typeof t3 == "string" && t3.indexOf(M) === -1) {
            var r3 = w(x, e4, this, t3);
            if (r3.done)
              return r3.value;
          }
          var n3 = T2(e4), o3 = String(this), i3 = typeof t3 == "function";
          i3 || (t3 = String(t3));
          var a2 = n3.global;
          if (a2) {
            var s = n3.unicode;
            n3.lastIndex = 0;
          }
          for (var l2 = []; ; ) {
            var u2 = P2(n3, o3);
            if (u2 === null)
              break;
            if (l2.push(u2), !a2)
              break;
            String(u2[0]) === "" && (n3.lastIndex = L(o3, O2(n3.lastIndex), s));
          }
          for (var c, d = "", f2 = 0, h3 = 0; h3 < l2.length; h3++) {
            u2 = l2[h3];
            for (var p3 = String(u2[0]), y2 = A(k2(C(u2.index), o3.length), 0), m2 = [], g = 1; g < u2.length; g++)
              m2.push((c = u2[g]) === void 0 ? c : String(c));
            var v = u2.groups;
            if (i3) {
              var b2 = [p3].concat(m2, y2, o3);
              v !== void 0 && b2.push(v);
              var _ = String(t3.apply(void 0, b2));
            } else
              _ = E(p3, o3, y2, m2, v, t3);
            f2 <= y2 && (d += o3.slice(f2, y2) + _, f2 = y2 + p3.length);
          }
          return d + o3.slice(f2);
        }];
        function E(i3, a2, s, l2, u2, e4) {
          var c = s + i3.length, d = l2.length, t3 = y;
          return u2 !== void 0 && (u2 = f(u2), t3 = p2), x.call(e4, t3, function(e5, t4) {
            var r3;
            switch (t4.charAt(0)) {
              case "$":
                return "$";
              case "&":
                return i3;
              case "`":
                return a2.slice(0, s);
              case "'":
                return a2.slice(c);
              case "<":
                r3 = u2[t4.slice(1, -1)];
                break;
              default:
                var n3 = +t4;
                if (n3 == 0)
                  return e5;
                if (d < n3) {
                  var o3 = h2(n3 / 10);
                  return o3 === 0 ? e5 : o3 <= d ? l2[o3 - 1] === void 0 ? t4.charAt(1) : l2[o3 - 1] + t4.charAt(1) : e5;
                }
                r3 = l2[n3 - 1];
            }
            return r3 === void 0 ? "" : r3;
          });
        }
      });
    }, { "../internals/advance-string-index": 8, "../internals/an-object": 10, "../internals/fix-regexp-well-known-symbol-logic": 51, "../internals/regexp-exec-abstract": 109, "../internals/require-object-coercible": 113, "../internals/to-integer": 133, "../internals/to-length": 134, "../internals/to-object": 135 }], 190: [function(e2, t2, r2) {
      var n2 = e2("../internals/fix-regexp-well-known-symbol-logic"), l2 = e2("../internals/an-object"), o2 = e2("../internals/require-object-coercible"), u2 = e2("../internals/same-value"), c = e2("../internals/regexp-exec-abstract");
      n2("search", 1, function(n3, a2, s) {
        return [function(e3) {
          var t3 = o2(this), r3 = e3 == null ? void 0 : e3[n3];
          return r3 !== void 0 ? r3.call(e3, t3) : new RegExp(e3)[n3](String(t3));
        }, function(e3) {
          var t3 = s(a2, e3, this);
          if (t3.done)
            return t3.value;
          var r3 = l2(e3), n4 = String(this), o3 = r3.lastIndex;
          u2(o3, 0) || (r3.lastIndex = 0);
          var i2 = c(r3, n4);
          return u2(r3.lastIndex, o3) || (r3.lastIndex = o3), i2 === null ? -1 : i2.index;
        }];
      });
    }, { "../internals/an-object": 10, "../internals/fix-regexp-well-known-symbol-logic": 51, "../internals/regexp-exec-abstract": 109, "../internals/require-object-coercible": 113, "../internals/same-value": 114 }], 191: [function(e2, t2, r2) {
      var n2 = e2("../internals/fix-regexp-well-known-symbol-logic"), d = e2("../internals/is-regexp"), b2 = e2("../internals/an-object"), f = e2("../internals/require-object-coercible"), _ = e2("../internals/species-constructor"), x = e2("../internals/advance-string-index"), w = e2("../internals/to-length"), j = e2("../internals/regexp-exec-abstract"), h2 = e2("../internals/regexp-exec"), o2 = e2("../internals/fails"), p2 = [].push, S2 = Math.min, M = 4294967295, E = !o2(function() {
        return !RegExp(M, "y");
      });
      n2("split", 2, function(o3, m2, g) {
        var v;
        return v = "abbc".split(/(b)*/)[1] == "c" || "test".split(/(?:)/, -1).length != 4 || "ab".split(/(?:ab)*/).length != 2 || ".".split(/(.?)(.?)/).length != 4 || 1 < ".".split(/()()/).length || "".split(/.?/).length ? function(e3, t3) {
          var r3 = String(f(this)), n3 = t3 === void 0 ? M : t3 >>> 0;
          if (n3 == 0)
            return [];
          if (e3 === void 0)
            return [r3];
          if (!d(e3))
            return m2.call(r3, e3, n3);
          for (var o4, i2, a2, s = [], l2 = (e3.ignoreCase ? "i" : "") + (e3.multiline ? "m" : "") + (e3.unicode ? "u" : "") + (e3.sticky ? "y" : ""), u2 = 0, c = new RegExp(e3.source, l2 + "g"); (o4 = h2.call(c, r3)) && !(u2 < (i2 = c.lastIndex) && (s.push(r3.slice(u2, o4.index)), 1 < o4.length && o4.index < r3.length && p2.apply(s, o4.slice(1)), a2 = o4[0].length, u2 = i2, s.length >= n3)); )
            c.lastIndex === o4.index && c.lastIndex++;
          return u2 === r3.length ? !a2 && c.test("") || s.push("") : s.push(r3.slice(u2)), s.length > n3 ? s.slice(0, n3) : s;
        } : "0".split(void 0, 0).length ? function(e3, t3) {
          return e3 === void 0 && t3 === 0 ? [] : m2.call(this, e3, t3);
        } : m2, [function(e3, t3) {
          var r3 = f(this), n3 = e3 == null ? void 0 : e3[o3];
          return n3 !== void 0 ? n3.call(e3, r3, t3) : v.call(String(r3), e3, t3);
        }, function(e3, t3) {
          var r3 = g(v, e3, this, t3, v !== m2);
          if (r3.done)
            return r3.value;
          var n3 = b2(e3), o4 = String(this), i2 = _(n3, RegExp), a2 = n3.unicode, s = (n3.ignoreCase ? "i" : "") + (n3.multiline ? "m" : "") + (n3.unicode ? "u" : "") + (E ? "y" : "g"), l2 = new i2(E ? n3 : "^(?:" + n3.source + ")", s), u2 = t3 === void 0 ? M : t3 >>> 0;
          if (u2 == 0)
            return [];
          if (o4.length === 0)
            return j(l2, o4) === null ? [o4] : [];
          for (var c = 0, d2 = 0, f2 = []; d2 < o4.length; ) {
            l2.lastIndex = E ? d2 : 0;
            var h3, p3 = j(l2, E ? o4 : o4.slice(d2));
            if (p3 === null || (h3 = S2(w(l2.lastIndex + (E ? 0 : d2)), o4.length)) === c)
              d2 = x(o4, d2, a2);
            else {
              if (f2.push(o4.slice(c, d2)), f2.length === u2)
                return f2;
              for (var y = 1; y <= p3.length - 1; y++)
                if (f2.push(p3[y]), f2.length === u2)
                  return f2;
              d2 = c = h3;
            }
          }
          return f2.push(o4.slice(c)), f2;
        }];
      }, !E);
    }, { "../internals/advance-string-index": 8, "../internals/an-object": 10, "../internals/fails": 50, "../internals/fix-regexp-well-known-symbol-logic": 51, "../internals/is-regexp": 76, "../internals/regexp-exec": 110, "../internals/regexp-exec-abstract": 109, "../internals/require-object-coercible": 113, "../internals/species-constructor": 121, "../internals/to-length": 134 }], 192: [function(e2, t2, r2) {
      var n2 = e2("../internals/export"), o2 = e2("../internals/create-html");
      n2({ target: "String", proto: true, forced: e2("../internals/string-html-forced")("sub") }, { sub: function() {
        return o2(this, "sub", "", "");
      } });
    }, { "../internals/create-html": 35, "../internals/export": 49, "../internals/string-html-forced": 122 }], 193: [function(e2, t2, r2) {
      var n2 = e2("../internals/export"), o2 = e2("../internals/string-trim").trim;
      n2({ target: "String", proto: true, forced: e2("../internals/string-trim-forced")("trim") }, { trim: function() {
        return o2(this);
      } });
    }, { "../internals/export": 49, "../internals/string-trim": 127, "../internals/string-trim-forced": 126 }], 194: [function(e2, t2, r2) {
      var n2 = e2("../internals/export"), o2 = e2("../internals/descriptors"), i2 = e2("../internals/global"), a2 = e2("../internals/has"), s = e2("../internals/is-object"), l2 = e2("../internals/object-define-property").f, u2 = e2("../internals/copy-constructor-properties"), c = i2.Symbol;
      if (o2 && typeof c == "function" && (!("description" in c.prototype) || c().description !== void 0)) {
        var d = {}, f = function(e3) {
          var t3 = arguments.length < 1 || e3 === void 0 ? void 0 : String(e3), r3 = this instanceof f ? new c(t3) : t3 === void 0 ? c() : c(t3);
          return t3 === "" && (d[r3] = true), r3;
        };
        u2(f, c);
        var h2 = f.prototype = c.prototype;
        h2.constructor = f;
        var p2 = h2.toString, y = String(c("test")) == "Symbol(test)", m2 = /^Symbol\((.*)\)[^)]+$/;
        l2(h2, "description", { configurable: true, get: function() {
          var e3 = s(this) ? this.valueOf() : this, t3 = p2.call(e3);
          if (a2(d, e3))
            return "";
          var r3 = y ? t3.slice(7, -1) : t3.replace(m2, "$1");
          return r3 === "" ? void 0 : r3;
        } }), n2({ global: true, forced: true }, { Symbol: f });
      }
    }, { "../internals/copy-constructor-properties": 32, "../internals/descriptors": 42, "../internals/export": 49, "../internals/global": 59, "../internals/has": 60, "../internals/is-object": 74, "../internals/object-define-property": 92 }], 195: [function(e2, t2, r2) {
      e2("../internals/define-well-known-symbol")("iterator");
    }, { "../internals/define-well-known-symbol": 41 }], 196: [function(e2, t2, r2) {
      function o2(e3, t3) {
        var r3 = re[e3] = j(Q[W2]);
        return X2(r3, { type: H, tag: e3, description: t3 }), d || (r3.description = t3), r3;
      }
      function n2(t3, e3) {
        v(t3);
        var r3 = _(e3), n3 = S2(r3).concat(he(r3));
        return V(n3, function(e4) {
          d && !fe.call(r3, e4) || de(t3, e4, r3[e4]);
        }), t3;
      }
      function i2(e3, t3) {
        var r3 = _(e3), n3 = x(t3, true);
        if (r3 !== Z || !y(re, n3) || y(ne, n3)) {
          var o3 = J(r3, n3);
          return !o3 || !y(re, n3) || y(r3, z) && r3[z][n3] || (o3.enumerable = true), o3;
        }
      }
      function a2(e3) {
        var t3 = ee(_(e3)), r3 = [];
        return V(t3, function(e4) {
          y(re, e4) || y(D, e4) || r3.push(e4);
        }), r3;
      }
      var s = e2("../internals/export"), l2 = e2("../internals/global"), u2 = e2("../internals/get-built-in"), c = e2("../internals/is-pure"), d = e2("../internals/descriptors"), f = e2("../internals/native-symbol"), h2 = e2("../internals/use-symbol-as-uid"), p2 = e2("../internals/fails"), y = e2("../internals/has"), m2 = e2("../internals/is-array"), g = e2("../internals/is-object"), v = e2("../internals/an-object"), b2 = e2("../internals/to-object"), _ = e2("../internals/to-indexed-object"), x = e2("../internals/to-primitive"), w = e2("../internals/create-property-descriptor"), j = e2("../internals/object-create"), S2 = e2("../internals/object-keys"), M = e2("../internals/object-get-own-property-names"), E = e2("../internals/object-get-own-property-names-external"), T2 = e2("../internals/object-get-own-property-symbols"), O2 = e2("../internals/object-get-own-property-descriptor"), C = e2("../internals/object-define-property"), L = e2("../internals/object-property-is-enumerable"), P2 = e2("../internals/create-non-enumerable-property"), A = e2("../internals/redefine"), k2 = e2("../internals/shared"), R2 = e2("../internals/shared-key"), D = e2("../internals/hidden-keys"), I = e2("../internals/uid"), U = e2("../internals/well-known-symbol"), N = e2("../internals/well-known-symbol-wrapped"), F = e2("../internals/define-well-known-symbol"), B = e2("../internals/set-to-string-tag"), G = e2("../internals/internal-state"), V = e2("../internals/array-iteration").forEach, z = R2("hidden"), H = "Symbol", W2 = "prototype", q = U("toPrimitive"), X2 = G.set, Y2 = G.getterFor(H), Z = Object[W2], Q = l2.Symbol, K2 = u2("JSON", "stringify"), J = O2.f, $ = C.f, ee = E.f, te = L.f, re = k2("symbols"), ne = k2("op-symbols"), oe = k2("string-to-symbol-registry"), ie = k2("symbol-to-string-registry"), ae = k2("wks"), se = l2.QObject, le = !se || !se[W2] || !se[W2].findChild, ue = d && p2(function() {
        return j($({}, "a", { get: function() {
          return $(this, "a", { value: 7 }).a;
        } })).a != 7;
      }) ? function(e3, t3, r3) {
        var n3 = J(Z, t3);
        n3 && delete Z[t3], $(e3, t3, r3), n3 && e3 !== Z && $(Z, t3, n3);
      } : $, ce = h2 ? function(e3) {
        return typeof e3 == "symbol";
      } : function(e3) {
        return Object(e3) instanceof Q;
      }, de = function(e3, t3, r3) {
        e3 === Z && de(ne, t3, r3), v(e3);
        var n3 = x(t3, true);
        return v(r3), y(re, n3) ? (r3.enumerable ? (y(e3, z) && e3[z][n3] && (e3[z][n3] = false), r3 = j(r3, { enumerable: w(0, false) })) : (y(e3, z) || $(e3, z, w(1, {})), e3[z][n3] = true), ue(e3, n3, r3)) : $(e3, n3, r3);
      }, fe = function(e3) {
        var t3 = x(e3, true), r3 = te.call(this, t3);
        return !(this === Z && y(re, t3) && !y(ne, t3)) && (!(r3 || !y(this, t3) || !y(re, t3) || y(this, z) && this[z][t3]) || r3);
      }, he = function(e3) {
        var t3 = e3 === Z, r3 = ee(t3 ? ne : _(e3)), n3 = [];
        return V(r3, function(e4) {
          !y(re, e4) || t3 && !y(Z, e4) || n3.push(re[e4]);
        }), n3;
      };
      f || (A((Q = function(e3) {
        if (this instanceof Q)
          throw TypeError("Symbol is not a constructor");
        var t3 = arguments.length && e3 !== void 0 ? String(e3) : void 0, r3 = I(t3), n3 = function(e4) {
          this === Z && n3.call(ne, e4), y(this, z) && y(this[z], r3) && (this[z][r3] = false), ue(this, r3, w(1, e4));
        };
        return d && le && ue(Z, r3, { configurable: true, set: n3 }), o2(r3, t3);
      })[W2], "toString", function() {
        return Y2(this).tag;
      }), A(Q, "withoutSetter", function(e3) {
        return o2(I(e3), e3);
      }), L.f = fe, C.f = de, O2.f = i2, M.f = E.f = a2, T2.f = he, N.f = function(e3) {
        return o2(U(e3), e3);
      }, d && ($(Q[W2], "description", { configurable: true, get: function() {
        return Y2(this).description;
      } }), c || A(Z, "propertyIsEnumerable", fe, { unsafe: true }))), s({ global: true, wrap: true, forced: !f, sham: !f }, { Symbol: Q }), V(S2(ae), function(e3) {
        F(e3);
      }), s({ target: H, stat: true, forced: !f }, { for: function(e3) {
        var t3 = String(e3);
        if (y(oe, t3))
          return oe[t3];
        var r3 = Q(t3);
        return oe[t3] = r3, ie[r3] = t3, r3;
      }, keyFor: function(e3) {
        if (!ce(e3))
          throw TypeError(e3 + " is not a symbol");
        if (y(ie, e3))
          return ie[e3];
      }, useSetter: function() {
        le = true;
      }, useSimple: function() {
        le = false;
      } }), s({ target: "Object", stat: true, forced: !f, sham: !d }, { create: function(e3, t3) {
        return t3 === void 0 ? j(e3) : n2(j(e3), t3);
      }, defineProperty: de, defineProperties: n2, getOwnPropertyDescriptor: i2 }), s({ target: "Object", stat: true, forced: !f }, { getOwnPropertyNames: a2, getOwnPropertySymbols: he }), s({ target: "Object", stat: true, forced: p2(function() {
        T2.f(1);
      }) }, { getOwnPropertySymbols: function(e3) {
        return T2.f(b2(e3));
      } }), K2 && s({ target: "JSON", stat: true, forced: !f || p2(function() {
        var e3 = Q();
        return K2([e3]) != "[null]" || K2({ a: e3 }) != "{}" || K2(Object(e3)) != "{}";
      }) }, { stringify: function(e3, t3, r3) {
        for (var n3, o3 = [e3], i3 = 1; i3 < arguments.length; )
          o3.push(arguments[i3++]);
        if ((g(n3 = t3) || e3 !== void 0) && !ce(e3))
          return m2(t3) || (t3 = function(e4, t4) {
            if (typeof n3 == "function" && (t4 = n3.call(this, e4, t4)), !ce(t4))
              return t4;
          }), o3[1] = t3, K2.apply(null, o3);
      } });
      Q[W2][q] || P2(Q[W2], q, Q[W2].valueOf), B(Q, H), D[z] = true;
    }, { "../internals/an-object": 10, "../internals/array-iteration": 19, "../internals/create-non-enumerable-property": 37, "../internals/create-property-descriptor": 38, "../internals/define-well-known-symbol": 41, "../internals/descriptors": 42, "../internals/export": 49, "../internals/fails": 50, "../internals/get-built-in": 56, "../internals/global": 59, "../internals/has": 60, "../internals/hidden-keys": 61, "../internals/internal-state": 70, "../internals/is-array": 72, "../internals/is-object": 74, "../internals/is-pure": 75, "../internals/native-symbol": 83, "../internals/object-create": 90, "../internals/object-define-property": 92, "../internals/object-get-own-property-descriptor": 93, "../internals/object-get-own-property-names": 95, "../internals/object-get-own-property-names-external": 94, "../internals/object-get-own-property-symbols": 96, "../internals/object-keys": 99, "../internals/object-property-is-enumerable": 100, "../internals/redefine": 108, "../internals/set-to-string-tag": 117, "../internals/shared": 120, "../internals/shared-key": 118, "../internals/to-indexed-object": 132, "../internals/to-object": 135, "../internals/to-primitive": 138, "../internals/uid": 143, "../internals/use-symbol-as-uid": 144, "../internals/well-known-symbol": 146, "../internals/well-known-symbol-wrapped": 145 }], 197: [function(e2, t2, r2) {
      var n2 = e2("../internals/array-buffer-view-core"), o2 = e2("../internals/array-copy-within"), i2 = n2.aTypedArray;
      (0, n2.exportTypedArrayMethod)("copyWithin", function(e3, t3, r3) {
        return o2.call(i2(this), e3, t3, 2 < arguments.length ? r3 : void 0);
      });
    }, { "../internals/array-buffer-view-core": 12, "../internals/array-copy-within": 14 }], 198: [function(e2, t2, r2) {
      var n2 = e2("../internals/array-buffer-view-core"), o2 = e2("../internals/array-iteration").every, i2 = n2.aTypedArray;
      (0, n2.exportTypedArrayMethod)("every", function(e3, t3) {
        return o2(i2(this), e3, 1 < arguments.length ? t3 : void 0);
      });
    }, { "../internals/array-buffer-view-core": 12, "../internals/array-iteration": 19 }], 199: [function(e2, t2, r2) {
      var n2 = e2("../internals/array-buffer-view-core"), o2 = e2("../internals/array-fill"), i2 = n2.aTypedArray;
      (0, n2.exportTypedArrayMethod)("fill", function(e3) {
        return o2.apply(i2(this), arguments);
      });
    }, { "../internals/array-buffer-view-core": 12, "../internals/array-fill": 15 }], 200: [function(e2, t2, r2) {
      var n2 = e2("../internals/array-buffer-view-core"), s = e2("../internals/array-iteration").filter, l2 = e2("../internals/species-constructor"), u2 = n2.aTypedArray, c = n2.aTypedArrayConstructor;
      (0, n2.exportTypedArrayMethod)("filter", function(e3, t3) {
        for (var r3 = s(u2(this), e3, 1 < arguments.length ? t3 : void 0), n3 = l2(this, this.constructor), o2 = 0, i2 = r3.length, a2 = new (c(n3))(i2); o2 < i2; )
          a2[o2] = r3[o2++];
        return a2;
      });
    }, { "../internals/array-buffer-view-core": 12, "../internals/array-iteration": 19, "../internals/species-constructor": 121 }], 201: [function(e2, t2, r2) {
      var n2 = e2("../internals/array-buffer-view-core"), o2 = e2("../internals/array-iteration").findIndex, i2 = n2.aTypedArray;
      (0, n2.exportTypedArrayMethod)("findIndex", function(e3, t3) {
        return o2(i2(this), e3, 1 < arguments.length ? t3 : void 0);
      });
    }, { "../internals/array-buffer-view-core": 12, "../internals/array-iteration": 19 }], 202: [function(e2, t2, r2) {
      var n2 = e2("../internals/array-buffer-view-core"), o2 = e2("../internals/array-iteration").find, i2 = n2.aTypedArray;
      (0, n2.exportTypedArrayMethod)("find", function(e3, t3) {
        return o2(i2(this), e3, 1 < arguments.length ? t3 : void 0);
      });
    }, { "../internals/array-buffer-view-core": 12, "../internals/array-iteration": 19 }], 203: [function(e2, t2, r2) {
      e2("../internals/typed-array-constructor")("Float32", function(n2) {
        return function(e3, t3, r3) {
          return n2(this, e3, t3, r3);
        };
      });
    }, { "../internals/typed-array-constructor": 140 }], 204: [function(e2, t2, r2) {
      e2("../internals/typed-array-constructor")("Float64", function(n2) {
        return function(e3, t3, r3) {
          return n2(this, e3, t3, r3);
        };
      });
    }, { "../internals/typed-array-constructor": 140 }], 205: [function(e2, t2, r2) {
      var n2 = e2("../internals/array-buffer-view-core"), o2 = e2("../internals/array-iteration").forEach, i2 = n2.aTypedArray;
      (0, n2.exportTypedArrayMethod)("forEach", function(e3, t3) {
        o2(i2(this), e3, 1 < arguments.length ? t3 : void 0);
      });
    }, { "../internals/array-buffer-view-core": 12, "../internals/array-iteration": 19 }], 206: [function(e2, t2, r2) {
      var n2 = e2("../internals/array-buffer-view-core"), o2 = e2("../internals/array-includes").includes, i2 = n2.aTypedArray;
      (0, n2.exportTypedArrayMethod)("includes", function(e3, t3) {
        return o2(i2(this), e3, 1 < arguments.length ? t3 : void 0);
      });
    }, { "../internals/array-buffer-view-core": 12, "../internals/array-includes": 18 }], 207: [function(e2, t2, r2) {
      var n2 = e2("../internals/array-buffer-view-core"), o2 = e2("../internals/array-includes").indexOf, i2 = n2.aTypedArray;
      (0, n2.exportTypedArrayMethod)("indexOf", function(e3, t3) {
        return o2(i2(this), e3, 1 < arguments.length ? t3 : void 0);
      });
    }, { "../internals/array-buffer-view-core": 12, "../internals/array-includes": 18 }], 208: [function(e2, t2, r2) {
      e2("../internals/typed-array-constructor")("Int16", function(n2) {
        return function(e3, t3, r3) {
          return n2(this, e3, t3, r3);
        };
      });
    }, { "../internals/typed-array-constructor": 140 }], 209: [function(e2, t2, r2) {
      e2("../internals/typed-array-constructor")("Int32", function(n2) {
        return function(e3, t3, r3) {
          return n2(this, e3, t3, r3);
        };
      });
    }, { "../internals/typed-array-constructor": 140 }], 210: [function(e2, t2, r2) {
      function n2() {
        return u2.call(f(this));
      }
      var o2 = e2("../internals/global"), i2 = e2("../internals/array-buffer-view-core"), a2 = e2("../modules/es.array.iterator"), s = e2("../internals/well-known-symbol")("iterator"), l2 = o2.Uint8Array, u2 = a2.values, c = a2.keys, d = a2.entries, f = i2.aTypedArray, h2 = i2.exportTypedArrayMethod, p2 = l2 && l2.prototype[s], y = !!p2 && (p2.name == "values" || p2.name == null);
      h2("entries", function() {
        return d.call(f(this));
      }), h2("keys", function() {
        return c.call(f(this));
      }), h2("values", n2, !y), h2(s, n2, !y);
    }, { "../internals/array-buffer-view-core": 12, "../internals/global": 59, "../internals/well-known-symbol": 146, "../modules/es.array.iterator": 158 }], 211: [function(e2, t2, r2) {
      var n2 = e2("../internals/array-buffer-view-core"), o2 = n2.aTypedArray, i2 = n2.exportTypedArrayMethod, a2 = [].join;
      i2("join", function(e3) {
        return a2.apply(o2(this), arguments);
      });
    }, { "../internals/array-buffer-view-core": 12 }], 212: [function(e2, t2, r2) {
      var n2 = e2("../internals/array-buffer-view-core"), o2 = e2("../internals/array-last-index-of"), i2 = n2.aTypedArray;
      (0, n2.exportTypedArrayMethod)("lastIndexOf", function(e3) {
        return o2.apply(i2(this), arguments);
      });
    }, { "../internals/array-buffer-view-core": 12, "../internals/array-last-index-of": 20 }], 213: [function(e2, t2, r2) {
      var n2 = e2("../internals/array-buffer-view-core"), o2 = e2("../internals/array-iteration").map, i2 = e2("../internals/species-constructor"), a2 = n2.aTypedArray, s = n2.aTypedArrayConstructor;
      (0, n2.exportTypedArrayMethod)("map", function(e3, t3) {
        return o2(a2(this), e3, 1 < arguments.length ? t3 : void 0, function(e4, t4) {
          return new (s(i2(e4, e4.constructor)))(t4);
        });
      });
    }, { "../internals/array-buffer-view-core": 12, "../internals/array-iteration": 19, "../internals/species-constructor": 121 }], 214: [function(e2, t2, r2) {
      var n2 = e2("../internals/array-buffer-view-core"), o2 = e2("../internals/array-reduce").right, i2 = n2.aTypedArray;
      (0, n2.exportTypedArrayMethod)("reduceRight", function(e3, t3) {
        return o2(i2(this), e3, arguments.length, 1 < arguments.length ? t3 : void 0);
      });
    }, { "../internals/array-buffer-view-core": 12, "../internals/array-reduce": 24 }], 215: [function(e2, t2, r2) {
      var n2 = e2("../internals/array-buffer-view-core"), o2 = e2("../internals/array-reduce").left, i2 = n2.aTypedArray;
      (0, n2.exportTypedArrayMethod)("reduce", function(e3, t3) {
        return o2(i2(this), e3, arguments.length, 1 < arguments.length ? t3 : void 0);
      });
    }, { "../internals/array-buffer-view-core": 12, "../internals/array-reduce": 24 }], 216: [function(e2, t2, r2) {
      var n2 = e2("../internals/array-buffer-view-core"), o2 = n2.aTypedArray, i2 = n2.exportTypedArrayMethod, a2 = Math.floor;
      i2("reverse", function() {
        for (var e3, t3 = o2(this).length, r3 = a2(t3 / 2), n3 = 0; n3 < r3; )
          e3 = this[n3], this[n3++] = this[--t3], this[t3] = e3;
        return this;
      });
    }, { "../internals/array-buffer-view-core": 12 }], 217: [function(e2, t2, r2) {
      var n2 = e2("../internals/array-buffer-view-core"), s = e2("../internals/to-length"), l2 = e2("../internals/to-offset"), u2 = e2("../internals/to-object"), o2 = e2("../internals/fails"), c = n2.aTypedArray;
      (0, n2.exportTypedArrayMethod)("set", function(e3, t3) {
        c(this);
        var r3 = l2(1 < arguments.length ? t3 : void 0, 1), n3 = this.length, o3 = u2(e3), i2 = s(o3.length), a2 = 0;
        if (n3 < i2 + r3)
          throw RangeError("Wrong length");
        for (; a2 < i2; )
          this[r3 + a2] = o3[a2++];
      }, o2(function() {
        new Int8Array(1).set({});
      }));
    }, { "../internals/array-buffer-view-core": 12, "../internals/fails": 50, "../internals/to-length": 134, "../internals/to-object": 135, "../internals/to-offset": 136 }], 218: [function(e2, t2, r2) {
      var n2 = e2("../internals/array-buffer-view-core"), s = e2("../internals/species-constructor"), o2 = e2("../internals/fails"), l2 = n2.aTypedArray, u2 = n2.aTypedArrayConstructor, i2 = n2.exportTypedArrayMethod, c = [].slice;
      i2("slice", function(e3, t3) {
        for (var r3 = c.call(l2(this), e3, t3), n3 = s(this, this.constructor), o3 = 0, i3 = r3.length, a2 = new (u2(n3))(i3); o3 < i3; )
          a2[o3] = r3[o3++];
        return a2;
      }, o2(function() {
        new Int8Array(1).slice();
      }));
    }, { "../internals/array-buffer-view-core": 12, "../internals/fails": 50, "../internals/species-constructor": 121 }], 219: [function(e2, t2, r2) {
      var n2 = e2("../internals/array-buffer-view-core"), o2 = e2("../internals/array-iteration").some, i2 = n2.aTypedArray;
      (0, n2.exportTypedArrayMethod)("some", function(e3, t3) {
        return o2(i2(this), e3, 1 < arguments.length ? t3 : void 0);
      });
    }, { "../internals/array-buffer-view-core": 12, "../internals/array-iteration": 19 }], 220: [function(e2, t2, r2) {
      var n2 = e2("../internals/array-buffer-view-core"), o2 = n2.aTypedArray, i2 = n2.exportTypedArrayMethod, a2 = [].sort;
      i2("sort", function(e3) {
        return a2.call(o2(this), e3);
      });
    }, { "../internals/array-buffer-view-core": 12 }], 221: [function(e2, t2, r2) {
      var n2 = e2("../internals/array-buffer-view-core"), i2 = e2("../internals/to-length"), a2 = e2("../internals/to-absolute-index"), s = e2("../internals/species-constructor"), l2 = n2.aTypedArray;
      (0, n2.exportTypedArrayMethod)("subarray", function(e3, t3) {
        var r3 = l2(this), n3 = r3.length, o2 = a2(e3, n3);
        return new (s(r3, r3.constructor))(r3.buffer, r3.byteOffset + o2 * r3.BYTES_PER_ELEMENT, i2((t3 === void 0 ? n3 : a2(t3, n3)) - o2));
      });
    }, { "../internals/array-buffer-view-core": 12, "../internals/species-constructor": 121, "../internals/to-absolute-index": 130, "../internals/to-length": 134 }], 222: [function(e2, t2, r2) {
      var n2 = e2("../internals/global"), o2 = e2("../internals/array-buffer-view-core"), i2 = e2("../internals/fails"), a2 = n2.Int8Array, s = o2.aTypedArray, l2 = o2.exportTypedArrayMethod, u2 = [].toLocaleString, c = [].slice, d = !!a2 && i2(function() {
        u2.call(new a2(1));
      });
      l2("toLocaleString", function() {
        return u2.apply(d ? c.call(s(this)) : s(this), arguments);
      }, i2(function() {
        return [1, 2].toLocaleString() != new a2([1, 2]).toLocaleString();
      }) || !i2(function() {
        a2.prototype.toLocaleString.call([1, 2]);
      }));
    }, { "../internals/array-buffer-view-core": 12, "../internals/fails": 50, "../internals/global": 59 }], 223: [function(e2, t2, r2) {
      var n2 = e2("../internals/array-buffer-view-core").exportTypedArrayMethod, o2 = e2("../internals/fails"), i2 = e2("../internals/global").Uint8Array, a2 = i2 && i2.prototype || {}, s = [].toString, l2 = [].join;
      o2(function() {
        s.call({});
      }) && (s = function() {
        return l2.call(this);
      }), n2("toString", s, a2.toString != s);
    }, { "../internals/array-buffer-view-core": 12, "../internals/fails": 50, "../internals/global": 59 }], 224: [function(e2, t2, r2) {
      e2("../internals/typed-array-constructor")("Uint16", function(n2) {
        return function(e3, t3, r3) {
          return n2(this, e3, t3, r3);
        };
      });
    }, { "../internals/typed-array-constructor": 140 }], 225: [function(e2, t2, r2) {
      e2("../internals/typed-array-constructor")("Uint32", function(n2) {
        return function(e3, t3, r3) {
          return n2(this, e3, t3, r3);
        };
      });
    }, { "../internals/typed-array-constructor": 140 }], 226: [function(e2, t2, r2) {
      e2("../internals/typed-array-constructor")("Uint8", function(n2) {
        return function(e3, t3, r3) {
          return n2(this, e3, t3, r3);
        };
      });
    }, { "../internals/typed-array-constructor": 140 }], 227: [function(e2, t2, r2) {
      e2("../internals/typed-array-constructor")("Uint8", function(n2) {
        return function(e3, t3, r3) {
          return n2(this, e3, t3, r3);
        };
      }, true);
    }, { "../internals/typed-array-constructor": 140 }], 228: [function(e2, t2, r2) {
      var n2 = e2("../internals/global"), o2 = e2("../internals/dom-iterables"), i2 = e2("../internals/array-for-each"), a2 = e2("../internals/create-non-enumerable-property");
      for (var s in o2) {
        var l2 = n2[s], u2 = l2 && l2.prototype;
        if (u2 && u2.forEach !== i2)
          try {
            a2(u2, "forEach", i2);
          } catch (e3) {
            u2.forEach = i2;
          }
      }
    }, { "../internals/array-for-each": 16, "../internals/create-non-enumerable-property": 37, "../internals/dom-iterables": 44, "../internals/global": 59 }], 229: [function(e2, t2, r2) {
      var n2 = e2("../internals/global"), o2 = e2("../internals/dom-iterables"), i2 = e2("../modules/es.array.iterator"), a2 = e2("../internals/create-non-enumerable-property"), s = e2("../internals/well-known-symbol"), l2 = s("iterator"), u2 = s("toStringTag"), c = i2.values;
      for (var d in o2) {
        var f = n2[d], h2 = f && f.prototype;
        if (h2) {
          if (h2[l2] !== c)
            try {
              a2(h2, l2, c);
            } catch (e3) {
              h2[l2] = c;
            }
          if (h2[u2] || a2(h2, u2, d), o2[d]) {
            for (var p2 in i2)
              if (h2[p2] !== i2[p2])
                try {
                  a2(h2, p2, i2[p2]);
                } catch (e3) {
                  h2[p2] = i2[p2];
                }
          }
        }
      }
    }, { "../internals/create-non-enumerable-property": 37, "../internals/dom-iterables": 44, "../internals/global": 59, "../internals/well-known-symbol": 146, "../modules/es.array.iterator": 158 }], 230: [function(e2, t2, r2) {
      e2("../modules/es.array.iterator");
      function o2(t3) {
        try {
          return decodeURIComponent(t3);
        } catch (e3) {
          return t3;
        }
      }
      function a2(e3) {
        var t3, r3 = e3.replace(U, " "), n3 = 4;
        try {
          return decodeURIComponent(r3);
        } catch (e4) {
          for (; n3; )
            r3 = r3.replace((t3 = n3--, N[t3 - 1] || (N[t3 - 1] = RegExp("((?:%[\\da-f]{2}){" + t3 + "})", "gi"))), o2);
          return r3;
        }
      }
      function n2(e3) {
        return B[e3];
      }
      function i2(e3) {
        return encodeURIComponent(e3).replace(F, n2);
      }
      function f(e3, t3) {
        if (t3)
          for (var r3, n3, o3 = t3.split("&"), i3 = 0; i3 < o3.length; )
            (r3 = o3[i3++]).length && (n3 = r3.split("="), e3.push({ key: a2(n3.shift()), value: a2(n3.join("=")) }));
      }
      function h2(e3) {
        this.entries.length = 0, f(this.entries, e3);
      }
      function u2(e3, t3) {
        if (e3 < t3)
          throw TypeError("Not enough arguments");
      }
      var s = e2("../internals/export"), l2 = e2("../internals/get-built-in"), c = e2("../internals/native-url"), d = e2("../internals/redefine"), p2 = e2("../internals/redefine-all"), y = e2("../internals/set-to-string-tag"), m2 = e2("../internals/create-iterator-constructor"), g = e2("../internals/internal-state"), v = e2("../internals/an-instance"), b2 = e2("../internals/has"), _ = e2("../internals/function-bind-context"), x = e2("../internals/classof"), w = e2("../internals/an-object"), j = e2("../internals/is-object"), S2 = e2("../internals/object-create"), M = e2("../internals/create-property-descriptor"), E = e2("../internals/get-iterator"), T2 = e2("../internals/get-iterator-method"), O2 = e2("../internals/well-known-symbol"), C = l2("fetch"), L = l2("Headers"), P2 = O2("iterator"), A = "URLSearchParams", k2 = A + "Iterator", R2 = g.set, D = g.getterFor(A), I = g.getterFor(k2), U = /\+/g, N = Array(4), F = /[!'()~]|%20/g, B = { "!": "%21", "'": "%27", "(": "%28", ")": "%29", "~": "%7E", "%20": "+" }, G = m2(function(e3, t3) {
        R2(this, { type: k2, iterator: E(D(e3).entries), kind: t3 });
      }, "Iterator", function() {
        var e3 = I(this), t3 = e3.kind, r3 = e3.iterator.next(), n3 = r3.value;
        return r3.done || (r3.value = t3 === "keys" ? n3.key : t3 === "values" ? n3.value : [n3.key, n3.value]), r3;
      }), V = function(e3) {
        v(this, V, A);
        var t3, r3, n3, o3, i3, a3, s2, l3, u3, c2 = 0 < arguments.length ? e3 : void 0, d2 = [];
        if (R2(this, { type: A, entries: d2, updateURL: function() {
        }, updateSearchParams: h2 }), c2 !== void 0)
          if (j(c2))
            if (typeof (t3 = T2(c2)) == "function")
              for (n3 = (r3 = t3.call(c2)).next; !(o3 = n3.call(r3)).done; ) {
                if ((s2 = (a3 = (i3 = E(w(o3.value))).next).call(i3)).done || (l3 = a3.call(i3)).done || !a3.call(i3).done)
                  throw TypeError("Expected sequence with length 2");
                d2.push({ key: s2.value + "", value: l3.value + "" });
              }
            else
              for (u3 in c2)
                b2(c2, u3) && d2.push({ key: u3, value: c2[u3] + "" });
          else
            f(d2, typeof c2 == "string" ? c2.charAt(0) === "?" ? c2.slice(1) : c2 : c2 + "");
      }, z = V.prototype;
      p2(z, { append: function(e3, t3) {
        u2(arguments.length, 2);
        var r3 = D(this);
        r3.entries.push({ key: e3 + "", value: t3 + "" }), r3.updateURL();
      }, delete: function(e3) {
        u2(arguments.length, 1);
        for (var t3 = D(this), r3 = t3.entries, n3 = e3 + "", o3 = 0; o3 < r3.length; )
          r3[o3].key === n3 ? r3.splice(o3, 1) : o3++;
        t3.updateURL();
      }, get: function(e3) {
        u2(arguments.length, 1);
        for (var t3 = D(this).entries, r3 = e3 + "", n3 = 0; n3 < t3.length; n3++)
          if (t3[n3].key === r3)
            return t3[n3].value;
        return null;
      }, getAll: function(e3) {
        u2(arguments.length, 1);
        for (var t3 = D(this).entries, r3 = e3 + "", n3 = [], o3 = 0; o3 < t3.length; o3++)
          t3[o3].key === r3 && n3.push(t3[o3].value);
        return n3;
      }, has: function(e3) {
        u2(arguments.length, 1);
        for (var t3 = D(this).entries, r3 = e3 + "", n3 = 0; n3 < t3.length; )
          if (t3[n3++].key === r3)
            return true;
        return false;
      }, set: function(e3, t3) {
        u2(arguments.length, 1);
        for (var r3, n3 = D(this), o3 = n3.entries, i3 = false, a3 = e3 + "", s2 = t3 + "", l3 = 0; l3 < o3.length; l3++)
          (r3 = o3[l3]).key === a3 && (i3 ? o3.splice(l3--, 1) : (i3 = true, r3.value = s2));
        i3 || o3.push({ key: a3, value: s2 }), n3.updateURL();
      }, sort: function() {
        var e3, t3, r3, n3 = D(this), o3 = n3.entries, i3 = o3.slice();
        for (r3 = o3.length = 0; r3 < i3.length; r3++) {
          for (e3 = i3[r3], t3 = 0; t3 < r3; t3++)
            if (o3[t3].key > e3.key) {
              o3.splice(t3, 0, e3);
              break;
            }
          t3 === r3 && o3.push(e3);
        }
        n3.updateURL();
      }, forEach: function(e3, t3) {
        for (var r3, n3 = D(this).entries, o3 = _(e3, 1 < arguments.length ? t3 : void 0, 3), i3 = 0; i3 < n3.length; )
          o3((r3 = n3[i3++]).value, r3.key, this);
      }, keys: function() {
        return new G(this, "keys");
      }, values: function() {
        return new G(this, "values");
      }, entries: function() {
        return new G(this, "entries");
      } }, { enumerable: true }), d(z, P2, z.entries), d(z, "toString", function() {
        for (var e3, t3 = D(this).entries, r3 = [], n3 = 0; n3 < t3.length; )
          e3 = t3[n3++], r3.push(i2(e3.key) + "=" + i2(e3.value));
        return r3.join("&");
      }, { enumerable: true }), y(V, A), s({ global: true, forced: !c }, { URLSearchParams: V }), c || typeof C != "function" || typeof L != "function" || s({ global: true, enumerable: true, forced: true }, { fetch: function(e3, t3) {
        var r3, n3, o3, i3 = [e3];
        return 1 < arguments.length && (j(r3 = t3) && (n3 = r3.body, x(n3) === A && ((o3 = r3.headers ? new L(r3.headers) : new L()).has("content-type") || o3.set("content-type", "application/x-www-form-urlencoded;charset=UTF-8"), r3 = S2(r3, { body: M(0, String(n3)), headers: M(0, o3) }))), i3.push(r3)), C.apply(this, i3);
      } }), t2.exports = { URLSearchParams: V, getState: D };
    }, { "../internals/an-instance": 9, "../internals/an-object": 10, "../internals/classof": 29, "../internals/create-iterator-constructor": 36, "../internals/create-property-descriptor": 38, "../internals/export": 49, "../internals/function-bind-context": 54, "../internals/get-built-in": 56, "../internals/get-iterator": 58, "../internals/get-iterator-method": 57, "../internals/has": 60, "../internals/internal-state": 70, "../internals/is-object": 74, "../internals/native-url": 84, "../internals/object-create": 90, "../internals/redefine": 108, "../internals/redefine-all": 107, "../internals/set-to-string-tag": 117, "../internals/well-known-symbol": 146, "../modules/es.array.iterator": 158 }], 231: [function(e2, t2, r2) {
      e2("../modules/es.string.iterator");
      function _(e3, t3) {
        var r3, n3, o3;
        if (t3.charAt(0) == "[") {
          if (t3.charAt(t3.length - 1) != "]")
            return I;
          if (!(r3 = Q(t3.slice(1, -1))))
            return I;
          e3.host = r3;
        } else if (ne(e3)) {
          if (t3 = m2(t3), W2.test(t3))
            return I;
          if ((r3 = Z(t3)) === null)
            return I;
          e3.host = r3;
        } else {
          if (q.test(t3))
            return I;
          for (r3 = "", n3 = T2(t3), o3 = 0; o3 < n3.length; o3++)
            r3 += te(n3[o3], K2);
          e3.host = r3;
        }
      }
      function c(e3) {
        var t3, r3, n3, o3;
        if (typeof e3 == "number") {
          for (t3 = [], r3 = 0; r3 < 4; r3++)
            t3.unshift(e3 % 256), e3 = k2(e3 / 256);
          return t3.join(".");
        }
        if (typeof e3 != "object")
          return e3;
        for (t3 = "", n3 = function(e4) {
          for (var t4 = null, r4 = 1, n4 = null, o4 = 0, i3 = 0; i3 < 8; i3++)
            e4[i3] !== 0 ? (r4 < o4 && (t4 = n4, r4 = o4), n4 = null, o4 = 0) : (n4 === null && (n4 = i3), ++o4);
          return r4 < o4 && (t4 = n4, r4 = o4), t4;
        }(e3), r3 = 0; r3 < 8; r3++)
          o3 && e3[r3] === 0 || (o3 = o3 && false, n3 === r3 ? (t3 += r3 ? ":" : "::", o3 = true) : (t3 += e3[r3].toString(16), r3 < 7 && (t3 += ":")));
        return "[" + t3 + "]";
      }
      function x(e3) {
        return e3.username != "" || e3.password != "";
      }
      function o2(e3) {
        return !e3.host || e3.cannotBeABaseURL || e3.scheme == "file";
      }
      function w(e3, t3) {
        var r3;
        return e3.length == 2 && N.test(e3.charAt(0)) && ((r3 = e3.charAt(1)) == ":" || !t3 && r3 == "|");
      }
      function j(e3) {
        var t3;
        return 1 < e3.length && w(e3.slice(0, 2)) && (e3.length == 2 || (t3 = e3.charAt(2)) === "/" || t3 === "\\" || t3 === "?" || t3 === "#");
      }
      function S2(e3) {
        var t3 = e3.path, r3 = t3.length;
        !r3 || e3.scheme == "file" && r3 == 1 && w(t3[0], true) || t3.pop();
      }
      function d(e3, t3, r3, n3) {
        var o3, i3, a3, s2, l3, u3, c2 = r3 || oe, d2 = 0, f2 = "", h3 = false, p3 = false, y2 = false;
        for (r3 || (e3.scheme = "", e3.username = "", e3.password = "", e3.host = null, e3.port = null, e3.path = [], e3.query = null, e3.fragment = null, e3.cannotBeABaseURL = false, t3 = t3.replace(X2, "")), t3 = t3.replace(Y2, ""), o3 = T2(t3); d2 <= o3.length; ) {
          switch (i3 = o3[d2], c2) {
            case oe:
              if (!i3 || !N.test(i3)) {
                if (r3)
                  return D;
                c2 = ae;
                continue;
              }
              f2 += i3.toLowerCase(), c2 = ie;
              break;
            case ie:
              if (i3 && (F.test(i3) || i3 == "+" || i3 == "-" || i3 == "."))
                f2 += i3.toLowerCase();
              else {
                if (i3 != ":") {
                  if (r3)
                    return D;
                  f2 = "", c2 = ae, d2 = 0;
                  continue;
                }
                if (r3 && (ne(e3) != E(re, f2) || f2 == "file" && (x(e3) || e3.port !== null) || e3.scheme == "file" && !e3.host))
                  return;
                if (e3.scheme = f2, r3)
                  return void (ne(e3) && re[e3.scheme] == e3.port && (e3.port = null));
                f2 = "", e3.scheme == "file" ? c2 = ge : ne(e3) && n3 && n3.scheme == e3.scheme ? c2 = se : ne(e3) ? c2 = de : o3[d2 + 1] == "/" ? (c2 = le, d2++) : (e3.cannotBeABaseURL = true, e3.path.push(""), c2 = we);
              }
              break;
            case ae:
              if (!n3 || n3.cannotBeABaseURL && i3 != "#")
                return D;
              if (n3.cannotBeABaseURL && i3 == "#") {
                e3.scheme = n3.scheme, e3.path = n3.path.slice(), e3.query = n3.query, e3.fragment = "", e3.cannotBeABaseURL = true, c2 = Se;
                break;
              }
              c2 = n3.scheme == "file" ? ge : ue;
              continue;
            case se:
              if (i3 != "/" || o3[d2 + 1] != "/") {
                c2 = ue;
                continue;
              }
              c2 = fe, d2++;
              break;
            case le:
              if (i3 == "/") {
                c2 = he;
                break;
              }
              c2 = xe;
              continue;
            case ue:
              if (e3.scheme = n3.scheme, i3 == M)
                e3.username = n3.username, e3.password = n3.password, e3.host = n3.host, e3.port = n3.port, e3.path = n3.path.slice(), e3.query = n3.query;
              else if (i3 == "/" || i3 == "\\" && ne(e3))
                c2 = ce;
              else if (i3 == "?")
                e3.username = n3.username, e3.password = n3.password, e3.host = n3.host, e3.port = n3.port, e3.path = n3.path.slice(), e3.query = "", c2 = je;
              else {
                if (i3 != "#") {
                  e3.username = n3.username, e3.password = n3.password, e3.host = n3.host, e3.port = n3.port, e3.path = n3.path.slice(), e3.path.pop(), c2 = xe;
                  continue;
                }
                e3.username = n3.username, e3.password = n3.password, e3.host = n3.host, e3.port = n3.port, e3.path = n3.path.slice(), e3.query = n3.query, e3.fragment = "", c2 = Se;
              }
              break;
            case ce:
              if (!ne(e3) || i3 != "/" && i3 != "\\") {
                if (i3 != "/") {
                  e3.username = n3.username, e3.password = n3.password, e3.host = n3.host, e3.port = n3.port, c2 = xe;
                  continue;
                }
                c2 = he;
              } else
                c2 = fe;
              break;
            case de:
              if (c2 = fe, i3 != "/" || f2.charAt(d2 + 1) != "/")
                continue;
              d2++;
              break;
            case fe:
              if (i3 == "/" || i3 == "\\")
                break;
              c2 = he;
              continue;
            case he:
              if (i3 == "@") {
                h3 && (f2 = "%40" + f2), h3 = true, a3 = T2(f2);
                for (var m3 = 0; m3 < a3.length; m3++) {
                  var g2 = a3[m3];
                  if (g2 != ":" || y2) {
                    var v2 = te(g2, ee);
                    y2 ? e3.password += v2 : e3.username += v2;
                  } else
                    y2 = true;
                }
                f2 = "";
              } else if (i3 == M || i3 == "/" || i3 == "?" || i3 == "#" || i3 == "\\" && ne(e3)) {
                if (h3 && f2 == "")
                  return "Invalid authority";
                d2 -= T2(f2).length + 1, f2 = "", c2 = pe;
              } else
                f2 += i3;
              break;
            case pe:
            case ye:
              if (r3 && e3.scheme == "file") {
                c2 = be;
                continue;
              }
              if (i3 != ":" || p3) {
                if (i3 == M || i3 == "/" || i3 == "?" || i3 == "#" || i3 == "\\" && ne(e3)) {
                  if (ne(e3) && f2 == "")
                    return I;
                  if (r3 && f2 == "" && (x(e3) || e3.port !== null))
                    return;
                  if (s2 = _(e3, f2))
                    return s2;
                  if (f2 = "", c2 = _e, r3)
                    return;
                  continue;
                }
                i3 == "[" ? p3 = true : i3 == "]" && (p3 = false), f2 += i3;
              } else {
                if (f2 == "")
                  return I;
                if (s2 = _(e3, f2))
                  return s2;
                if (f2 = "", c2 = me, r3 == ye)
                  return;
              }
              break;
            case me:
              if (!B.test(i3)) {
                if (i3 == M || i3 == "/" || i3 == "?" || i3 == "#" || i3 == "\\" && ne(e3) || r3) {
                  if (f2 != "") {
                    var b3 = parseInt(f2, 10);
                    if (65535 < b3)
                      return U;
                    e3.port = ne(e3) && b3 === re[e3.scheme] ? null : b3, f2 = "";
                  }
                  if (r3)
                    return;
                  c2 = _e;
                  continue;
                }
                return U;
              }
              f2 += i3;
              break;
            case ge:
              if (e3.scheme = "file", i3 == "/" || i3 == "\\")
                c2 = ve;
              else {
                if (!n3 || n3.scheme != "file") {
                  c2 = xe;
                  continue;
                }
                if (i3 == M)
                  e3.host = n3.host, e3.path = n3.path.slice(), e3.query = n3.query;
                else if (i3 == "?")
                  e3.host = n3.host, e3.path = n3.path.slice(), e3.query = "", c2 = je;
                else {
                  if (i3 != "#") {
                    j(o3.slice(d2).join("")) || (e3.host = n3.host, e3.path = n3.path.slice(), S2(e3)), c2 = xe;
                    continue;
                  }
                  e3.host = n3.host, e3.path = n3.path.slice(), e3.query = n3.query, e3.fragment = "", c2 = Se;
                }
              }
              break;
            case ve:
              if (i3 == "/" || i3 == "\\") {
                c2 = be;
                break;
              }
              n3 && n3.scheme == "file" && !j(o3.slice(d2).join("")) && (w(n3.path[0], true) ? e3.path.push(n3.path[0]) : e3.host = n3.host), c2 = xe;
              continue;
            case be:
              if (i3 == M || i3 == "/" || i3 == "\\" || i3 == "?" || i3 == "#") {
                if (!r3 && w(f2))
                  c2 = xe;
                else if (f2 == "") {
                  if (e3.host = "", r3)
                    return;
                  c2 = _e;
                } else {
                  if (s2 = _(e3, f2))
                    return s2;
                  if (e3.host == "localhost" && (e3.host = ""), r3)
                    return;
                  f2 = "", c2 = _e;
                }
                continue;
              }
              f2 += i3;
              break;
            case _e:
              if (ne(e3)) {
                if (c2 = xe, i3 != "/" && i3 != "\\")
                  continue;
              } else if (r3 || i3 != "?")
                if (r3 || i3 != "#") {
                  if (i3 != M && (c2 = xe, i3 != "/"))
                    continue;
                } else
                  e3.fragment = "", c2 = Se;
              else
                e3.query = "", c2 = je;
              break;
            case xe:
              if (i3 == M || i3 == "/" || i3 == "\\" && ne(e3) || !r3 && (i3 == "?" || i3 == "#")) {
                if ((u3 = (u3 = f2).toLowerCase()) === ".." || u3 === "%2e." || u3 === ".%2e" || u3 === "%2e%2e" ? (S2(e3), i3 == "/" || i3 == "\\" && ne(e3) || e3.path.push("")) : (l3 = f2) === "." || l3.toLowerCase() === "%2e" ? i3 == "/" || i3 == "\\" && ne(e3) || e3.path.push("") : (e3.scheme == "file" && !e3.path.length && w(f2) && (e3.host && (e3.host = ""), f2 = f2.charAt(0) + ":"), e3.path.push(f2)), f2 = "", e3.scheme == "file" && (i3 == M || i3 == "?" || i3 == "#"))
                  for (; 1 < e3.path.length && e3.path[0] === ""; )
                    e3.path.shift();
                i3 == "?" ? (e3.query = "", c2 = je) : i3 == "#" && (e3.fragment = "", c2 = Se);
              } else
                f2 += te(i3, $);
              break;
            case we:
              i3 == "?" ? (e3.query = "", c2 = je) : i3 == "#" ? (e3.fragment = "", c2 = Se) : i3 != M && (e3.path[0] += te(i3, K2));
              break;
            case je:
              r3 || i3 != "#" ? i3 != M && (i3 == "'" && ne(e3) ? e3.query += "%27" : e3.query += i3 == "#" ? "%23" : te(i3, K2)) : (e3.fragment = "", c2 = Se);
              break;
            case Se:
              i3 != M && (e3.fragment += te(i3, J));
          }
          d2++;
        }
      }
      function n2(e3, t3) {
        return { get: e3, set: t3, configurable: true, enumerable: true };
      }
      var M, i2 = e2("../internals/export"), f = e2("../internals/descriptors"), a2 = e2("../internals/native-url"), s = e2("../internals/global"), l2 = e2("../internals/object-define-properties"), u2 = e2("../internals/redefine"), h2 = e2("../internals/an-instance"), E = e2("../internals/has"), p2 = e2("../internals/object-assign"), T2 = e2("../internals/array-from"), y = e2("../internals/string-multibyte").codeAt, m2 = e2("../internals/string-punycode-to-ascii"), g = e2("../internals/set-to-string-tag"), v = e2("../modules/web.url-search-params"), b2 = e2("../internals/internal-state"), O2 = s.URL, C = v.URLSearchParams, L = v.getState, P2 = b2.set, A = b2.getterFor("URL"), k2 = Math.floor, R2 = Math.pow, D = "Invalid scheme", I = "Invalid host", U = "Invalid port", N = /[A-Za-z]/, F = /[\d+-.A-Za-z]/, B = /\d/, G = /^(0x|0X)/, V = /^[0-7]+$/, z = /^\d+$/, H = /^[\dA-Fa-f]+$/, W2 = /[\u0000\u0009\u000A\u000D #%/:?@[\\]]/, q = /[\u0000\u0009\u000A\u000D #/:?@[\\]]/, X2 = /^[\u0000-\u001F ]+|[\u0000-\u001F ]+$/g, Y2 = /[\u0009\u000A\u000D]/g, Z = function(e3) {
        var t3, r3, n3, o3, i3, a3, s2, l3 = e3.split(".");
        if (l3.length && l3[l3.length - 1] == "" && l3.pop(), 4 < (t3 = l3.length))
          return e3;
        for (r3 = [], n3 = 0; n3 < t3; n3++) {
          if ((o3 = l3[n3]) == "")
            return e3;
          if (i3 = 10, 1 < o3.length && o3.charAt(0) == "0" && (i3 = G.test(o3) ? 16 : 8, o3 = o3.slice(i3 == 8 ? 1 : 2)), o3 === "")
            a3 = 0;
          else {
            if (!(i3 == 10 ? z : i3 == 8 ? V : H).test(o3))
              return e3;
            a3 = parseInt(o3, i3);
          }
          r3.push(a3);
        }
        for (n3 = 0; n3 < t3; n3++)
          if (a3 = r3[n3], n3 == t3 - 1) {
            if (a3 >= R2(256, 5 - t3))
              return null;
          } else if (255 < a3)
            return null;
        for (s2 = r3.pop(), n3 = 0; n3 < r3.length; n3++)
          s2 += r3[n3] * R2(256, 3 - n3);
        return s2;
      }, Q = function(e3) {
        function t3() {
          return e3.charAt(f2);
        }
        var r3, n3, o3, i3, a3, s2, l3, u3 = [0, 0, 0, 0, 0, 0, 0, 0], c2 = 0, d2 = null, f2 = 0;
        if (t3() == ":") {
          if (e3.charAt(1) != ":")
            return;
          f2 += 2, d2 = ++c2;
        }
        for (; t3(); ) {
          if (c2 == 8)
            return;
          if (t3() != ":") {
            for (r3 = n3 = 0; n3 < 4 && H.test(t3()); )
              r3 = 16 * r3 + parseInt(t3(), 16), f2++, n3++;
            if (t3() == ".") {
              if (n3 == 0)
                return;
              if (f2 -= n3, 6 < c2)
                return;
              for (o3 = 0; t3(); ) {
                if (i3 = null, 0 < o3) {
                  if (!(t3() == "." && o3 < 4))
                    return;
                  f2++;
                }
                if (!B.test(t3()))
                  return;
                for (; B.test(t3()); ) {
                  if (a3 = parseInt(t3(), 10), i3 === null)
                    i3 = a3;
                  else {
                    if (i3 == 0)
                      return;
                    i3 = 10 * i3 + a3;
                  }
                  if (255 < i3)
                    return;
                  f2++;
                }
                u3[c2] = 256 * u3[c2] + i3, ++o3 != 2 && o3 != 4 || c2++;
              }
              if (o3 != 4)
                return;
              break;
            }
            if (t3() == ":") {
              if (f2++, !t3())
                return;
            } else if (t3())
              return;
            u3[c2++] = r3;
          } else {
            if (d2 !== null)
              return;
            f2++, d2 = ++c2;
          }
        }
        if (d2 !== null)
          for (s2 = c2 - d2, c2 = 7; c2 != 0 && 0 < s2; )
            l3 = u3[c2], u3[c2--] = u3[d2 + s2 - 1], u3[d2 + --s2] = l3;
        else if (c2 != 8)
          return;
        return u3;
      }, K2 = {}, J = p2({}, K2, { " ": 1, '"': 1, "<": 1, ">": 1, "`": 1 }), $ = p2({}, J, { "#": 1, "?": 1, "{": 1, "}": 1 }), ee = p2({}, $, { "/": 1, ":": 1, ";": 1, "=": 1, "@": 1, "[": 1, "\\": 1, "]": 1, "^": 1, "|": 1 }), te = function(e3, t3) {
        var r3 = y(e3, 0);
        return 32 < r3 && r3 < 127 && !E(t3, e3) ? e3 : encodeURIComponent(e3);
      }, re = { ftp: 21, file: null, http: 80, https: 443, ws: 80, wss: 443 }, ne = function(e3) {
        return E(re, e3.scheme);
      }, oe = {}, ie = {}, ae = {}, se = {}, le = {}, ue = {}, ce = {}, de = {}, fe = {}, he = {}, pe = {}, ye = {}, me = {}, ge = {}, ve = {}, be = {}, _e = {}, xe = {}, we = {}, je = {}, Se = {}, Me = function(e3, t3) {
        var r3, n3, o3 = h2(this, Me, "URL"), i3 = 1 < arguments.length ? t3 : void 0, a3 = String(e3), s2 = P2(o3, { type: "URL" });
        if (i3 !== void 0) {
          if (i3 instanceof Me)
            r3 = A(i3);
          else if (n3 = d(r3 = {}, String(i3)))
            throw TypeError(n3);
        }
        if (n3 = d(s2, a3, null, r3))
          throw TypeError(n3);
        var l3 = s2.searchParams = new C(), u3 = L(l3);
        u3.updateSearchParams(s2.query), u3.updateURL = function() {
          s2.query = String(l3) || null;
        }, f || (o3.href = Te.call(o3), o3.origin = Oe.call(o3), o3.protocol = Ce.call(o3), o3.username = Le.call(o3), o3.password = Pe.call(o3), o3.host = Ae.call(o3), o3.hostname = ke.call(o3), o3.port = Re.call(o3), o3.pathname = De.call(o3), o3.search = Ie.call(o3), o3.searchParams = Ue.call(o3), o3.hash = Ne.call(o3));
      }, Ee = Me.prototype, Te = function() {
        var e3 = A(this), t3 = e3.scheme, r3 = e3.username, n3 = e3.password, o3 = e3.host, i3 = e3.port, a3 = e3.path, s2 = e3.query, l3 = e3.fragment, u3 = t3 + ":";
        return o3 !== null ? (u3 += "//", x(e3) && (u3 += r3 + (n3 ? ":" + n3 : "") + "@"), u3 += c(o3), i3 !== null && (u3 += ":" + i3)) : t3 == "file" && (u3 += "//"), u3 += e3.cannotBeABaseURL ? a3[0] : a3.length ? "/" + a3.join("/") : "", s2 !== null && (u3 += "?" + s2), l3 !== null && (u3 += "#" + l3), u3;
      }, Oe = function() {
        var e3 = A(this), t3 = e3.scheme, r3 = e3.port;
        if (t3 == "blob")
          try {
            return new URL(t3.path[0]).origin;
          } catch (e4) {
            return "null";
          }
        return t3 != "file" && ne(e3) ? t3 + "://" + c(e3.host) + (r3 !== null ? ":" + r3 : "") : "null";
      }, Ce = function() {
        return A(this).scheme + ":";
      }, Le = function() {
        return A(this).username;
      }, Pe = function() {
        return A(this).password;
      }, Ae = function() {
        var e3 = A(this), t3 = e3.host, r3 = e3.port;
        return t3 === null ? "" : r3 === null ? c(t3) : c(t3) + ":" + r3;
      }, ke = function() {
        var e3 = A(this).host;
        return e3 === null ? "" : c(e3);
      }, Re = function() {
        var e3 = A(this).port;
        return e3 === null ? "" : String(e3);
      }, De = function() {
        var e3 = A(this), t3 = e3.path;
        return e3.cannotBeABaseURL ? t3[0] : t3.length ? "/" + t3.join("/") : "";
      }, Ie = function() {
        var e3 = A(this).query;
        return e3 ? "?" + e3 : "";
      }, Ue = function() {
        return A(this).searchParams;
      }, Ne = function() {
        var e3 = A(this).fragment;
        return e3 ? "#" + e3 : "";
      };
      if (f && l2(Ee, { href: n2(Te, function(e3) {
        var t3 = A(this), r3 = String(e3), n3 = d(t3, r3);
        if (n3)
          throw TypeError(n3);
        L(t3.searchParams).updateSearchParams(t3.query);
      }), origin: n2(Oe), protocol: n2(Ce, function(e3) {
        var t3 = A(this);
        d(t3, String(e3) + ":", oe);
      }), username: n2(Le, function(e3) {
        var t3 = A(this), r3 = T2(String(e3));
        if (!o2(t3)) {
          t3.username = "";
          for (var n3 = 0; n3 < r3.length; n3++)
            t3.username += te(r3[n3], ee);
        }
      }), password: n2(Pe, function(e3) {
        var t3 = A(this), r3 = T2(String(e3));
        if (!o2(t3)) {
          t3.password = "";
          for (var n3 = 0; n3 < r3.length; n3++)
            t3.password += te(r3[n3], ee);
        }
      }), host: n2(Ae, function(e3) {
        var t3 = A(this);
        t3.cannotBeABaseURL || d(t3, String(e3), pe);
      }), hostname: n2(ke, function(e3) {
        var t3 = A(this);
        t3.cannotBeABaseURL || d(t3, String(e3), ye);
      }), port: n2(Re, function(e3) {
        var t3 = A(this);
        o2(t3) || ((e3 = String(e3)) == "" ? t3.port = null : d(t3, e3, me));
      }), pathname: n2(De, function(e3) {
        var t3 = A(this);
        t3.cannotBeABaseURL || (t3.path = [], d(t3, e3 + "", _e));
      }), search: n2(Ie, function(e3) {
        var t3 = A(this);
        (e3 = String(e3)) == "" ? t3.query = null : (e3.charAt(0) == "?" && (e3 = e3.slice(1)), t3.query = "", d(t3, e3, je)), L(t3.searchParams).updateSearchParams(t3.query);
      }), searchParams: n2(Ue), hash: n2(Ne, function(e3) {
        var t3 = A(this);
        (e3 = String(e3)) != "" ? (e3.charAt(0) == "#" && (e3 = e3.slice(1)), t3.fragment = "", d(t3, e3, Se)) : t3.fragment = null;
      }) }), u2(Ee, "toJSON", function() {
        return Te.call(this);
      }, { enumerable: true }), u2(Ee, "toString", function() {
        return Te.call(this);
      }, { enumerable: true }), O2) {
        var Fe = O2.createObjectURL, Be = O2.revokeObjectURL;
        Fe && u2(Me, "createObjectURL", function(e3) {
          return Fe.apply(O2, arguments);
        }), Be && u2(Me, "revokeObjectURL", function(e3) {
          return Be.apply(O2, arguments);
        });
      }
      g(Me, "URL"), i2({ global: true, forced: !a2, sham: !f }, { URL: Me });
    }, { "../internals/an-instance": 9, "../internals/array-from": 17, "../internals/descriptors": 42, "../internals/export": 49, "../internals/global": 59, "../internals/has": 60, "../internals/internal-state": 70, "../internals/native-url": 84, "../internals/object-assign": 89, "../internals/object-define-properties": 91, "../internals/redefine": 108, "../internals/set-to-string-tag": 117, "../internals/string-multibyte": 123, "../internals/string-punycode-to-ascii": 124, "../modules/es.string.iterator": 186, "../modules/web.url-search-params": 230 }], 232: [function(e2, t2, r2) {
      t2.exports = e2("./").polyfill();
    }, { "./": 233 }], 233: [function(z, r2, n2) {
      (function(G, V) {
        var e2, t2;
        e2 = this, t2 = function() {
          function l2(e4) {
            return typeof e4 == "function";
          }
          var r3 = Array.isArray ? Array.isArray : function(e4) {
            return Object.prototype.toString.call(e4) === "[object Array]";
          }, n3 = 0, t3 = void 0, o2 = void 0, a2 = function(e4, t4) {
            f[n3] = e4, f[n3 + 1] = t4, (n3 += 2) === 2 && (o2 ? o2(h2) : v());
          };
          var e3 = typeof window != "undefined" ? window : void 0, i2 = e3 || {}, s = i2.MutationObserver || i2.WebKitMutationObserver, u2 = typeof self == "undefined" && G !== void 0 && {}.toString.call(G) === "[object process]", c = typeof Uint8ClampedArray != "undefined" && typeof importScripts != "undefined" && typeof MessageChannel != "undefined";
          function d() {
            var e4 = setTimeout;
            return function() {
              return e4(h2, 1);
            };
          }
          var f = new Array(1e3);
          function h2() {
            for (var e4 = 0; e4 < n3; e4 += 2) {
              (0, f[e4])(f[e4 + 1]), f[e4] = void 0, f[e4 + 1] = void 0;
            }
            n3 = 0;
          }
          var p2, y, m2, g, v = void 0;
          function b2(e4, t4) {
            var r4 = this, n4 = new this.constructor(w);
            n4[x] === void 0 && I(n4);
            var o3 = r4._state;
            if (o3) {
              var i3 = arguments[o3 - 1];
              a2(function() {
                return R2(o3, n4, i3, r4._result);
              });
            } else
              A(r4, n4, e4, t4);
            return n4;
          }
          function _(e4) {
            if (e4 && typeof e4 == "object" && e4.constructor === this)
              return e4;
            var t4 = new this(w);
            return O2(t4, e4), t4;
          }
          v = u2 ? function() {
            return G.nextTick(h2);
          } : s ? (y = 0, m2 = new s(h2), g = document.createTextNode(""), m2.observe(g, { characterData: true }), function() {
            g.data = y = ++y % 2;
          }) : c ? ((p2 = new MessageChannel()).port1.onmessage = h2, function() {
            return p2.port2.postMessage(0);
          }) : e3 === void 0 && typeof z == "function" ? function() {
            try {
              var e4 = Function("return this")().require("vertx");
              return (t3 = e4.runOnLoop || e4.runOnContext) !== void 0 ? function() {
                t3(h2);
              } : d();
            } catch (e5) {
              return d();
            }
          }() : d();
          var x = Math.random().toString(36).substring(2);
          function w() {
          }
          var j = void 0, S2 = 1, M = 2;
          function E(e4, n4, o3) {
            a2(function(t4) {
              var r4 = false, e5 = function(e6, t5, r5, n5) {
                try {
                  e6.call(t5, r5, n5);
                } catch (e7) {
                  return e7;
                }
              }(o3, n4, function(e6) {
                r4 || (r4 = true, n4 !== e6 ? O2(t4, e6) : L(t4, e6));
              }, function(e6) {
                r4 || (r4 = true, P2(t4, e6));
              }, t4._label);
              !r4 && e5 && (r4 = true, P2(t4, e5));
            }, e4);
          }
          function T2(e4, t4, r4) {
            var n4, o3;
            t4.constructor === e4.constructor && r4 === b2 && t4.constructor.resolve === _ ? (n4 = e4, (o3 = t4)._state === S2 ? L(n4, o3._result) : o3._state === M ? P2(n4, o3._result) : A(o3, void 0, function(e5) {
              return O2(n4, e5);
            }, function(e5) {
              return P2(n4, e5);
            })) : r4 === void 0 ? L(e4, t4) : l2(r4) ? E(e4, t4, r4) : L(e4, t4);
          }
          function O2(t4, e4) {
            if (t4 === e4)
              P2(t4, new TypeError("You cannot resolve a promise with itself"));
            else if (o3 = typeof (n4 = e4), n4 === null || o3 != "object" && o3 != "function")
              L(t4, e4);
            else {
              var r4 = void 0;
              try {
                r4 = e4.then;
              } catch (e5) {
                return void P2(t4, e5);
              }
              T2(t4, e4, r4);
            }
            var n4, o3;
          }
          function C(e4) {
            e4._onerror && e4._onerror(e4._result), k2(e4);
          }
          function L(e4, t4) {
            e4._state === j && (e4._result = t4, e4._state = S2, e4._subscribers.length !== 0 && a2(k2, e4));
          }
          function P2(e4, t4) {
            e4._state === j && (e4._state = M, e4._result = t4, a2(C, e4));
          }
          function A(e4, t4, r4, n4) {
            var o3 = e4._subscribers, i3 = o3.length;
            e4._onerror = null, o3[i3] = t4, o3[i3 + S2] = r4, o3[i3 + M] = n4, i3 === 0 && e4._state && a2(k2, e4);
          }
          function k2(e4) {
            var t4 = e4._subscribers, r4 = e4._state;
            if (t4.length !== 0) {
              for (var n4 = void 0, o3 = void 0, i3 = e4._result, a3 = 0; a3 < t4.length; a3 += 3)
                n4 = t4[a3], o3 = t4[a3 + r4], n4 ? R2(r4, n4, o3, i3) : o3(i3);
              e4._subscribers.length = 0;
            }
          }
          function R2(e4, t4, r4, n4) {
            var o3 = l2(r4), i3 = void 0, a3 = void 0, s2 = true;
            if (o3) {
              try {
                i3 = r4(n4);
              } catch (e5) {
                s2 = false, a3 = e5;
              }
              if (t4 === i3)
                return void P2(t4, new TypeError("A promises callback cannot return that same promise."));
            } else
              i3 = n4;
            t4._state !== j || (o3 && s2 ? O2(t4, i3) : s2 === false ? P2(t4, a3) : e4 === S2 ? L(t4, i3) : e4 === M && P2(t4, i3));
          }
          var D = 0;
          function I(e4) {
            e4[x] = D++, e4._state = void 0, e4._result = void 0, e4._subscribers = [];
          }
          var U = (N.prototype._enumerate = function(e4) {
            for (var t4 = 0; this._state === j && t4 < e4.length; t4++)
              this._eachEntry(e4[t4], t4);
          }, N.prototype._eachEntry = function(t4, e4) {
            var r4 = this._instanceConstructor, n4 = r4.resolve;
            if (n4 === _) {
              var o3 = void 0, i3 = void 0, a3 = false;
              try {
                o3 = t4.then;
              } catch (e5) {
                a3 = true, i3 = e5;
              }
              if (o3 === b2 && t4._state !== j)
                this._settledAt(t4._state, e4, t4._result);
              else if (typeof o3 != "function")
                this._remaining--, this._result[e4] = t4;
              else if (r4 === F) {
                var s2 = new r4(w);
                a3 ? P2(s2, i3) : T2(s2, t4, o3), this._willSettleAt(s2, e4);
              } else
                this._willSettleAt(new r4(function(e5) {
                  return e5(t4);
                }), e4);
            } else
              this._willSettleAt(n4(t4), e4);
          }, N.prototype._settledAt = function(e4, t4, r4) {
            var n4 = this.promise;
            n4._state === j && (this._remaining--, e4 === M ? P2(n4, r4) : this._result[t4] = r4), this._remaining === 0 && L(n4, this._result);
          }, N.prototype._willSettleAt = function(e4, t4) {
            var r4 = this;
            A(e4, void 0, function(e5) {
              return r4._settledAt(S2, t4, e5);
            }, function(e5) {
              return r4._settledAt(M, t4, e5);
            });
          }, N);
          function N(e4, t4) {
            this._instanceConstructor = e4, this.promise = new e4(w), this.promise[x] || I(this.promise), r3(t4) ? (this.length = t4.length, this._remaining = t4.length, this._result = new Array(this.length), this.length === 0 ? L(this.promise, this._result) : (this.length = this.length || 0, this._enumerate(t4), this._remaining === 0 && L(this.promise, this._result))) : P2(this.promise, new Error("Array Methods must be provided an Array"));
          }
          var F = (B.prototype.catch = function(e4) {
            return this.then(null, e4);
          }, B.prototype.finally = function(t4) {
            var r4 = this.constructor;
            return l2(t4) ? this.then(function(e4) {
              return r4.resolve(t4()).then(function() {
                return e4;
              });
            }, function(e4) {
              return r4.resolve(t4()).then(function() {
                throw e4;
              });
            }) : this.then(t4, t4);
          }, B);
          function B(e4) {
            this[x] = D++, this._result = this._state = void 0, this._subscribers = [], w !== e4 && (typeof e4 != "function" && function() {
              throw new TypeError("You must pass a resolver function as the first argument to the promise constructor");
            }(), this instanceof B ? function(t4, e5) {
              try {
                e5(function(e6) {
                  O2(t4, e6);
                }, function(e6) {
                  P2(t4, e6);
                });
              } catch (e6) {
                P2(t4, e6);
              }
            }(this, e4) : function() {
              throw new TypeError("Failed to construct 'Promise': Please use the 'new' operator, this object constructor cannot be called as a function.");
            }());
          }
          return F.prototype.then = b2, F.all = function(e4) {
            return new U(this, e4).promise;
          }, F.race = function(o3) {
            var i3 = this;
            return r3(o3) ? new i3(function(e4, t4) {
              for (var r4 = o3.length, n4 = 0; n4 < r4; n4++)
                i3.resolve(o3[n4]).then(e4, t4);
            }) : new i3(function(e4, t4) {
              return t4(new TypeError("You must pass an array to race."));
            });
          }, F.resolve = _, F.reject = function(e4) {
            var t4 = new this(w);
            return P2(t4, e4), t4;
          }, F._setScheduler = function(e4) {
            o2 = e4;
          }, F._setAsap = function(e4) {
            a2 = e4;
          }, F._asap = a2, F.polyfill = function() {
            var e4 = void 0;
            if (V !== void 0)
              e4 = V;
            else if (typeof self != "undefined")
              e4 = self;
            else
              try {
                e4 = Function("return this")();
              } catch (e5) {
                throw new Error("polyfill failed because global object is unavailable in this environment");
              }
            var t4 = e4.Promise;
            if (t4) {
              var r4 = null;
              try {
                r4 = Object.prototype.toString.call(t4.resolve());
              } catch (e5) {
              }
              if (r4 === "[object Promise]" && !t4.cast)
                return;
            }
            e4.Promise = F;
          }, F.Promise = F;
        }, typeof n2 == "object" && r2 !== void 0 ? r2.exports = t2() : e2.ES6Promise = t2();
      }).call(this, z("_process"), typeof commonjsGlobal != "undefined" ? commonjsGlobal : typeof self != "undefined" ? self : typeof window != "undefined" ? window : {});
    }, { _process: 241 }], 234: [function(e2, n2, o2) {
      !function(e3, t2) {
        if (o2 !== void 0 && n2 !== void 0)
          t2(o2, n2);
        else {
          var r2 = { exports: {} };
          t2(r2.exports, r2), e3.fetchJsonp = r2.exports;
        }
      }(this, function(e3, t2) {
        var r2 = 5e3, n3 = "callback";
        function d(t3) {
          try {
            delete window[t3];
          } catch (e4) {
            window[t3] = void 0;
          }
        }
        function f(e4) {
          var t3 = document.getElementById(e4);
          t3 && document.getElementsByTagName("head")[0].removeChild(t3);
        }
        t2.exports = function(i2) {
          var a2 = arguments.length <= 1 || arguments[1] === void 0 ? {} : arguments[1], s = i2, l2 = a2.timeout || r2, u2 = a2.jsonpCallback || n3, c = void 0;
          return new Promise(function(t3, e4) {
            var r3 = a2.jsonpCallbackFunction || "jsonp_" + Date.now() + "_" + Math.ceil(1e5 * Math.random()), n4 = u2 + "_" + r3;
            window[r3] = function(e5) {
              t3({ ok: true, json: function() {
                return Promise.resolve(e5);
              } }), c && clearTimeout(c), f(n4), d(r3);
            }, s += s.indexOf("?") === -1 ? "?" : "&";
            var o3 = document.createElement("script");
            o3.setAttribute("src", "" + s + u2 + "=" + r3), a2.charset && o3.setAttribute("charset", a2.charset), o3.id = n4, document.getElementsByTagName("head")[0].appendChild(o3), c = setTimeout(function() {
              e4(new Error("JSONP request to " + i2 + " timed out")), d(r3), f(n4), window[r3] = function() {
                d(r3);
              };
            }, l2), o3.onerror = function() {
              e4(new Error("JSONP request to " + i2 + " failed")), d(r3), f(n4), c && clearTimeout(c);
            };
          });
        };
      });
    }, {}], 235: [function(e2, t2, r2) {
      var n2 = n2 || function(s) {
        if (!(s === void 0 || typeof navigator != "undefined" && /MSIE [1-9]\./.test(navigator.userAgent))) {
          var e3 = s.document, l2 = function() {
            return s.URL || s.webkitURL || s;
          }, u2 = e3.createElementNS("http://www.w3.org/1999/xhtml", "a"), c = "download" in u2, d = /constructor/i.test(s.HTMLElement) || s.safari, f = /CriOS\/[\d]+/.test(navigator.userAgent), h2 = function(e4) {
            (s.setImmediate || s.setTimeout)(function() {
              throw e4;
            }, 0);
          }, p2 = function(e4) {
            setTimeout(function() {
              typeof e4 == "string" ? l2().revokeObjectURL(e4) : e4.remove();
            }, 4e4);
          }, y = function(e4) {
            return /^\s*(?:text\/\S*|application\/xml|\S*\/\S*\+xml)\s*;.*charset\s*=\s*utf-8/i.test(e4.type) ? new Blob([String.fromCharCode(65279), e4], { type: e4.type }) : e4;
          }, n3 = function(e4, r3, t4) {
            t4 || (e4 = y(e4));
            function n4() {
              !function(e5, t5, r4) {
                for (var n5 = (t5 = [].concat(t5)).length; n5--; ) {
                  var o3 = e5["on" + t5[n5]];
                  if (typeof o3 == "function")
                    try {
                      o3.call(e5, r4 || e5);
                    } catch (e6) {
                      h2(e6);
                    }
                }
              }(i2, "writestart progress write writeend".split(" "));
            }
            var o2, i2 = this, a2 = e4.type === "application/octet-stream";
            if (i2.readyState = i2.INIT, c)
              return o2 = l2().createObjectURL(e4), void setTimeout(function() {
                var e5, t5;
                u2.href = o2, u2.download = r3, e5 = u2, t5 = new MouseEvent("click"), e5.dispatchEvent(t5), n4(), p2(o2), i2.readyState = i2.DONE;
              });
            !function() {
              if ((f || a2 && d) && s.FileReader) {
                var t5 = new FileReader();
                return t5.onloadend = function() {
                  var e5 = f ? t5.result : t5.result.replace(/^data:[^;]*;/, "data:attachment/file;");
                  s.open(e5, "_blank") || (s.location.href = e5), e5 = void 0, i2.readyState = i2.DONE, n4();
                }, t5.readAsDataURL(e4), i2.readyState = i2.INIT;
              }
              (o2 = o2 || l2().createObjectURL(e4), a2) ? s.location.href = o2 : s.open(o2, "_blank") || (s.location.href = o2);
              i2.readyState = i2.DONE, n4(), p2(o2);
            }();
          }, t3 = n3.prototype;
          return typeof navigator != "undefined" && navigator.msSaveOrOpenBlob ? function(e4, t4, r3) {
            return t4 = t4 || e4.name || "download", r3 || (e4 = y(e4)), navigator.msSaveOrOpenBlob(e4, t4);
          } : (t3.abort = function() {
          }, t3.readyState = t3.INIT = 0, t3.WRITING = 1, t3.DONE = 2, t3.error = t3.onwritestart = t3.onprogress = t3.onwrite = t3.onabort = t3.onerror = t3.onwriteend = null, function(e4, t4, r3) {
            return new n3(e4, t4 || e4.name || "download", r3);
          });
        }
      }(typeof self != "undefined" && self || typeof window != "undefined" && window || this.content);
      t2 !== void 0 && t2.exports ? t2.exports.saveAs = n2 : i != null;
    }, {}], 236: [function(e2, t2, r2) {
      r2.read = function(e3, t3, r3, n2, o2) {
        var i2, a2, s = 8 * o2 - n2 - 1, l2 = (1 << s) - 1, u2 = l2 >> 1, c = -7, d = r3 ? o2 - 1 : 0, f = r3 ? -1 : 1, h2 = e3[t3 + d];
        for (d += f, i2 = h2 & (1 << -c) - 1, h2 >>= -c, c += s; 0 < c; i2 = 256 * i2 + e3[t3 + d], d += f, c -= 8)
          ;
        for (a2 = i2 & (1 << -c) - 1, i2 >>= -c, c += n2; 0 < c; a2 = 256 * a2 + e3[t3 + d], d += f, c -= 8)
          ;
        if (i2 === 0)
          i2 = 1 - u2;
        else {
          if (i2 === l2)
            return a2 ? NaN : 1 / 0 * (h2 ? -1 : 1);
          a2 += Math.pow(2, n2), i2 -= u2;
        }
        return (h2 ? -1 : 1) * a2 * Math.pow(2, i2 - n2);
      }, r2.write = function(e3, t3, r3, n2, o2, i2) {
        var a2, s, l2, u2 = 8 * i2 - o2 - 1, c = (1 << u2) - 1, d = c >> 1, f = o2 === 23 ? Math.pow(2, -24) - Math.pow(2, -77) : 0, h2 = n2 ? 0 : i2 - 1, p2 = n2 ? 1 : -1, y = t3 < 0 || t3 === 0 && 1 / t3 < 0 ? 1 : 0;
        for (t3 = Math.abs(t3), isNaN(t3) || t3 === 1 / 0 ? (s = isNaN(t3) ? 1 : 0, a2 = c) : (a2 = Math.floor(Math.log(t3) / Math.LN2), t3 * (l2 = Math.pow(2, -a2)) < 1 && (a2--, l2 *= 2), 2 <= (t3 += 1 <= a2 + d ? f / l2 : f * Math.pow(2, 1 - d)) * l2 && (a2++, l2 /= 2), c <= a2 + d ? (s = 0, a2 = c) : 1 <= a2 + d ? (s = (t3 * l2 - 1) * Math.pow(2, o2), a2 += d) : (s = t3 * Math.pow(2, d - 1) * Math.pow(2, o2), a2 = 0)); 8 <= o2; e3[r3 + h2] = 255 & s, h2 += p2, s /= 256, o2 -= 8)
          ;
        for (a2 = a2 << o2 | s, u2 += o2; 0 < u2; e3[r3 + h2] = 255 & a2, h2 += p2, a2 /= 256, u2 -= 8)
          ;
        e3[r3 + h2 - p2] |= 128 * y;
      };
    }, {}], 237: [function(e2, t2, r2) {
      var n2;
      function m2(e3, t3) {
        return e3.b === t3.b && e3.a === t3.a;
      }
      function g(e3, t3) {
        return e3.b < t3.b || e3.b === t3.b && e3.a <= t3.a;
      }
      function v(e3, t3, r3) {
        var n3 = t3.b - e3.b, o3 = r3.b - t3.b;
        return 0 < n3 + o3 ? n3 < o3 ? t3.a - e3.a + n3 / (n3 + o3) * (e3.a - r3.a) : t3.a - r3.a + o3 / (n3 + o3) * (r3.a - e3.a) : 0;
      }
      function b2(e3, t3, r3) {
        var n3 = t3.b - e3.b, o3 = r3.b - t3.b;
        return 0 < n3 + o3 ? (t3.a - r3.a) * n3 + (t3.a - e3.a) * o3 : 0;
      }
      function _(e3, t3) {
        return e3.a < t3.a || e3.a === t3.a && e3.b <= t3.b;
      }
      function x(e3, t3, r3) {
        var n3 = t3.a - e3.a, o3 = r3.a - t3.a;
        return 0 < n3 + o3 ? n3 < o3 ? t3.b - e3.b + n3 / (n3 + o3) * (e3.b - r3.b) : t3.b - r3.b + o3 / (n3 + o3) * (r3.b - e3.b) : 0;
      }
      function w(e3, t3, r3) {
        var n3 = t3.a - e3.a, o3 = r3.a - t3.a;
        return 0 < n3 + o3 ? (t3.b - r3.b) * n3 + (t3.b - e3.b) * o3 : 0;
      }
      function j(e3, t3, r3, n3) {
        return (e3 = e3 < 0 ? 0 : e3) <= (r3 = r3 < 0 ? 0 : r3) ? r3 === 0 ? (t3 + n3) / 2 : t3 + e3 / (e3 + r3) * (n3 - t3) : n3 + r3 / (e3 + r3) * (t3 - n3);
      }
      function a2(e3) {
        var t3 = i2(e3.b);
        return o2(t3, e3.c), o2(t3.b, e3.c), s(t3, e3.a), t3;
      }
      function S2(e3, t3) {
        var r3 = false, n3 = false;
        e3 !== t3 && (t3.a !== e3.a && (n3 = true, y(t3.a, e3.a)), t3.d !== e3.d && (r3 = true, l2(t3.d, e3.d)), h2(t3, e3), n3 || (o2(t3, e3.a), e3.a.c = e3), r3 || (s(t3, e3.d), e3.d.a = e3));
      }
      function d(e3) {
        var t3 = e3.b, r3 = false;
        e3.d !== e3.b.d && (r3 = true, l2(e3.d, e3.b.d)), e3.c === e3 ? y(e3.a, null) : (e3.b.d.a = K2(e3), e3.a.c = e3.c, h2(e3, K2(e3)), r3 || s(e3, e3.d)), t3.c === t3 ? (y(t3.a, null), l2(t3.d, null)) : (e3.d.a = K2(t3), t3.a.c = t3.c, h2(t3, K2(t3))), p2(e3);
      }
      function M(e3) {
        var t3 = i2(e3), r3 = t3.b;
        return h2(t3, e3.e), t3.a = e3.b.a, o2(r3, t3.a), t3.d = r3.d = e3.d, t3 = t3.b, h2(e3.b, K2(e3.b)), h2(e3.b, t3), e3.b.a = t3.a, t3.b.a.c = t3.b, t3.b.d = e3.b.d, t3.f = e3.f, t3.b.f = e3.b.f, t3;
      }
      function f(e3, t3) {
        var r3 = false, n3 = i2(e3), o3 = n3.b;
        return t3.d !== e3.d && (r3 = true, l2(t3.d, e3.d)), h2(n3, e3.e), h2(o3, t3), n3.a = e3.b.a, o3.a = t3.a, n3.d = o3.d = e3.d, e3.d.a = o3, r3 || s(n3, e3.d), n3;
      }
      function i2(e3) {
        var t3 = new Q(), r3 = new Q(), n3 = e3.b.h;
        return (((r3.h = n3).b.h = t3).h = e3).b.h = r3, t3.b = r3, ((t3.c = t3).e = r3).b = t3, (r3.c = r3).e = t3;
      }
      function h2(e3, t3) {
        var r3 = e3.c, n3 = t3.c;
        r3.b.e = t3, (n3.b.e = e3).c = n3, t3.c = r3;
      }
      function o2(e3, t3) {
        var r3 = t3.f, n3 = new $(t3, r3);
        for (r3.e = n3, r3 = (t3.f = n3).c = e3; r3.a = n3, (r3 = r3.c) !== e3; )
          ;
      }
      function s(e3, t3) {
        var r3 = t3.d, n3 = new Z(t3, r3);
        for (r3.b = n3, (t3.d = n3).a = e3, n3.c = t3.c, r3 = e3; r3.d = n3, (r3 = r3.e) !== e3; )
          ;
      }
      function p2(e3) {
        var t3 = e3.h;
        e3 = e3.b.h, (t3.b.h = e3).b.h = t3;
      }
      function y(e3, t3) {
        for (var r3 = e3.c, n3 = r3; n3.a = t3, (n3 = n3.c) !== r3; )
          ;
        r3 = e3.f, ((n3 = e3.e).f = r3).e = n3;
      }
      function l2(e3, t3) {
        for (var r3 = e3.a, n3 = r3; n3.d = t3, (n3 = n3.e) !== r3; )
          ;
        r3 = e3.d, ((n3 = e3.b).d = r3).b = n3;
      }
      function E(e3) {
        var t3 = 0;
        return Math.abs(e3[1]) > Math.abs(e3[0]) && (t3 = 1), Math.abs(e3[2]) > Math.abs(e3[t3]) && (t3 = 2), t3;
      }
      function T2(e3, t3) {
        e3.f += t3.f, e3.b.f += t3.b.f;
      }
      function u2(e3, t3, r3) {
        return e3 = e3.a, t3 = t3.a, r3 = r3.a, t3.b.a === e3 ? r3.b.a === e3 ? g(t3.a, r3.a) ? b2(r3.b.a, t3.a, r3.a) <= 0 : 0 <= b2(t3.b.a, r3.a, t3.a) : b2(r3.b.a, e3, r3.a) <= 0 : r3.b.a === e3 ? 0 <= b2(t3.b.a, e3, t3.a) : (t3 = v(t3.b.a, e3, t3.a), (e3 = v(r3.b.a, e3, r3.a)) <= t3);
      }
      function O2(e3) {
        e3.a.i = null;
        var t3 = e3.e;
        t3.a.c = t3.c, t3.c.a = t3.a, e3.e = null;
      }
      function c(e3, t3) {
        d(e3.a), e3.c = false, (e3.a = t3).i = e3;
      }
      function C(e3) {
        for (var t3 = e3.a.a; (e3 = de(e3)).a.a === t3; )
          ;
        return e3.c && (c(e3, t3 = f(ce(e3).a.b, e3.a.e)), e3 = de(e3)), e3;
      }
      function L(e3, t3, r3) {
        var n3 = new ue();
        return n3.a = r3, n3.e = H(e3.f, t3.e, n3), r3.i = n3;
      }
      function P2(e3, t3) {
        switch (e3.s) {
          case 100130:
            return (1 & t3) != 0;
          case 100131:
            return t3 !== 0;
          case 100132:
            return 0 < t3;
          case 100133:
            return t3 < 0;
          case 100134:
            return 2 <= t3 || t3 <= -2;
        }
        return false;
      }
      function A(e3) {
        var t3 = e3.a, r3 = t3.d;
        r3.c = e3.d, r3.a = t3, O2(e3);
      }
      function k2(e3, t3, r3) {
        for (t3 = (e3 = t3).a; e3 !== r3; ) {
          e3.c = false;
          var n3 = ce(e3), o3 = n3.a;
          if (o3.a !== t3.a) {
            if (!n3.c) {
              A(e3);
              break;
            }
            c(n3, o3 = f(t3.c.b, o3.b));
          }
          t3.c !== o3 && (S2(K2(o3), o3), S2(t3, o3)), A(e3), t3 = n3.a, e3 = n3;
        }
        return t3;
      }
      function R2(e3, t3, r3, n3, o3, i3) {
        for (var a3 = true; L(e3, t3, r3.b), (r3 = r3.c) !== n3; )
          ;
        for (o3 === null && (o3 = ce(t3).a.b.c); (r3 = (n3 = ce(t3)).a.b).a === o3.a; )
          r3.c !== o3 && (S2(K2(r3), r3), S2(K2(o3), r3)), n3.f = t3.f - r3.f, n3.d = P2(e3, n3.f), t3.b = true, !a3 && N(e3, t3) && (T2(r3, o3), O2(t3), d(o3)), a3 = false, t3 = n3, o3 = r3;
        t3.b = true, i3 && B(e3, t3);
      }
      function D(e3, t3, r3, n3, o3) {
        var i3 = [t3.g[0], t3.g[1], t3.g[2]];
        t3.d = null, t3.d = e3.o && e3.o(i3, r3, n3, e3.c) || null, t3.d === null && (o3 ? e3.n || (Y2(e3, 100156), e3.n = true) : t3.d = r3[0]);
      }
      function I(e3, t3, r3) {
        var n3 = [null, null, null, null];
        n3[0] = t3.a.d, n3[1] = r3.a.d, D(e3, t3.a, n3, [0.5, 0.5, 0, 0], false), S2(t3, r3);
      }
      function U(e3, t3, r3, n3, o3) {
        var i3 = Math.abs(t3.b - e3.b) + Math.abs(t3.a - e3.a), a3 = Math.abs(r3.b - e3.b) + Math.abs(r3.a - e3.a), s2 = o3 + 1;
        n3[o3] = 0.5 * a3 / (i3 + a3), n3[s2] = 0.5 * i3 / (i3 + a3), e3.g[0] += n3[o3] * t3.g[0] + n3[s2] * r3.g[0], e3.g[1] += n3[o3] * t3.g[1] + n3[s2] * r3.g[1], e3.g[2] += n3[o3] * t3.g[2] + n3[s2] * r3.g[2];
      }
      function N(e3, t3) {
        var r3 = ce(t3), n3 = t3.a, o3 = r3.a;
        if (g(n3.a, o3.a)) {
          if (0 < b2(o3.b.a, n3.a, o3.a))
            return false;
          if (m2(n3.a, o3.a)) {
            if (n3.a !== o3.a) {
              r3 = e3.e;
              var i3 = n3.a.h;
              if (0 <= i3) {
                var a3 = (r3 = r3.b).d, s2 = r3.e, l3 = r3.c, u3 = l3[i3];
                a3[u3] = a3[r3.a], (l3[a3[u3]] = u3) <= --r3.a && (u3 <= 1 ? se(r3, u3) : g(s2[a3[u3 >> 1]], s2[a3[u3]]) ? se(r3, u3) : le(r3, u3)), s2[i3] = null, l3[i3] = r3.b, r3.b = i3;
              } else
                for (r3.c[-(i3 + 1)] = null; 0 < r3.a && r3.c[r3.d[r3.a - 1]] === null; )
                  --r3.a;
              I(e3, K2(o3), n3);
            }
          } else
            M(o3.b), S2(n3, K2(o3)), t3.b = r3.b = true;
        } else {
          if (b2(n3.b.a, o3.a, n3.a) < 0)
            return false;
          de(t3).b = t3.b = true, M(n3.b), S2(K2(o3), n3);
        }
        return true;
      }
      function F(e3, t3) {
        var r3 = ce(t3), n3 = t3.a, o3 = r3.a, i3 = n3.a, a3 = o3.a, s2 = n3.b.a, l3 = o3.b.a, u3 = new $();
        if (b2(s2, e3.a, i3), b2(l3, e3.a, a3), i3 === a3 || Math.min(i3.a, s2.a) > Math.max(a3.a, l3.a))
          return false;
        if (g(i3, a3)) {
          if (0 < b2(l3, i3, a3))
            return false;
        } else if (b2(s2, a3, i3) < 0)
          return false;
        var c2, d2, f2 = s2, h3 = i3, p3 = l3, y2 = a3;
        if (g(f2, h3) || (c2 = f2, f2 = h3, h3 = c2), g(p3, y2) || (c2 = p3, p3 = y2, y2 = c2), g(f2, p3) || (c2 = f2, f2 = p3, p3 = c2, c2 = h3, h3 = y2, y2 = c2), g(p3, h3) ? g(h3, y2) ? ((c2 = v(f2, p3, h3)) + (d2 = v(p3, h3, y2)) < 0 && (c2 = -c2, d2 = -d2), u3.b = j(c2, p3.b, d2, h3.b)) : ((c2 = b2(f2, p3, h3)) + (d2 = -b2(f2, y2, h3)) < 0 && (c2 = -c2, d2 = -d2), u3.b = j(c2, p3.b, d2, y2.b)) : u3.b = (p3.b + h3.b) / 2, _(f2, h3) || (c2 = f2, f2 = h3, h3 = c2), _(p3, y2) || (c2 = p3, p3 = y2, y2 = c2), _(f2, p3) || (c2 = f2, f2 = p3, p3 = c2, c2 = h3, h3 = y2, y2 = c2), _(p3, h3) ? _(h3, y2) ? ((c2 = x(f2, p3, h3)) + (d2 = x(p3, h3, y2)) < 0 && (c2 = -c2, d2 = -d2), u3.a = j(c2, p3.a, d2, h3.a)) : ((c2 = w(f2, p3, h3)) + (d2 = -w(f2, y2, h3)) < 0 && (c2 = -c2, d2 = -d2), u3.a = j(c2, p3.a, d2, y2.a)) : u3.a = (p3.a + h3.a) / 2, g(u3, e3.a) && (u3.b = e3.a.b, u3.a = e3.a.a), f2 = g(i3, a3) ? i3 : a3, g(f2, u3) && (u3.b = f2.b, u3.a = f2.a), m2(u3, i3) || m2(u3, a3))
          return N(e3, t3), false;
        if (!m2(s2, e3.a) && 0 <= b2(s2, e3.a, u3) || !m2(l3, e3.a) && b2(l3, e3.a, u3) <= 0) {
          if (l3 === e3.a)
            return M(n3.b), S2(o3.b, n3), n3 = ce(t3 = C(t3)).a, k2(e3, ce(t3), r3), R2(e3, t3, K2(n3), n3, n3, true), true;
          if (s2 !== e3.a)
            return 0 <= b2(s2, e3.a, u3) && (de(t3).b = t3.b = true, M(n3.b), n3.a.b = e3.a.b, n3.a.a = e3.a.a), b2(l3, e3.a, u3) <= 0 && (t3.b = r3.b = true, M(o3.b), o3.a.b = e3.a.b, o3.a.a = e3.a.a), false;
          for (M(o3.b), S2(n3.e, K2(o3)), a3 = (i3 = r3 = t3).a.b.a; (i3 = de(i3)).a.b.a === a3; )
            ;
          return i3 = ce(t3 = i3).a.b.c, r3.a = K2(o3), R2(e3, t3, (o3 = k2(e3, r3, null)).c, n3.b.c, i3, true), true;
        }
        return M(n3.b), M(o3.b), S2(K2(o3), n3), n3.a.b = u3.b, n3.a.a = u3.a, n3.a.h = te(e3.e, n3.a), n3 = n3.a, o3 = [0, 0, 0, 0], u3 = [i3.d, s2.d, a3.d, l3.d], n3.g[0] = n3.g[1] = n3.g[2] = 0, U(n3, i3, s2, o3, 0), U(n3, a3, l3, o3, 2), D(e3, n3, u3, o3, true), de(t3).b = t3.b = r3.b = true, false;
      }
      function B(e3, t3) {
        for (var r3 = ce(t3); ; ) {
          for (; r3.b; )
            r3 = ce(t3 = r3);
          if (!t3.b && ((t3 = de(r3 = t3)) === null || !t3.b))
            break;
          t3.b = false;
          var n3, o3 = t3.a, i3 = r3.a;
          if (n3 = o3.b.a !== i3.b.a)
            e: {
              var a3 = ce(n3 = t3), s2 = n3.a, l3 = a3.a, u3 = void 0;
              if (g(s2.b.a, l3.b.a)) {
                if (b2(s2.b.a, l3.b.a, s2.a) < 0) {
                  n3 = false;
                  break e;
                }
                de(n3).b = n3.b = true, u3 = M(s2), S2(l3.b, u3), u3.d.c = n3.d;
              } else {
                if (0 < b2(l3.b.a, s2.b.a, l3.a)) {
                  n3 = false;
                  break e;
                }
                n3.b = a3.b = true, u3 = M(l3), S2(s2.e, l3.b), u3.b.d.c = n3.d;
              }
              n3 = true;
            }
          if (n3 && (r3.c ? (O2(r3), d(i3), i3 = (r3 = ce(t3)).a) : t3.c && (O2(t3), d(o3), o3 = (t3 = de(r3)).a)), o3.a !== i3.a) {
            if (o3.b.a === i3.b.a || t3.c || r3.c || o3.b.a !== e3.a && i3.b.a !== e3.a)
              N(e3, t3);
            else if (F(e3, t3))
              break;
          }
          o3.a === i3.a && o3.b.a === i3.b.a && (T2(i3, o3), O2(t3), d(o3), t3 = de(r3));
        }
      }
      function G(e3, t3) {
        for (var r3 = (e3.a = t3).c; r3.i === null; )
          if ((r3 = r3.c) === t3.c) {
            r3 = e3;
            var n3 = t3;
            (a3 = new ue()).a = n3.c.b;
            for (var o3 = (l3 = r3.f).a; (o3 = o3.a).b !== null && !l3.c(l3.b, a3, o3.b); )
              ;
            var i3 = ce(l3 = o3.b), a3 = l3.a;
            o3 = i3.a;
            if (b2(a3.b.a, n3, a3.a) === 0)
              m2((a3 = l3.a).a, n3) || m2(a3.b.a, n3) || (M(a3.b), l3.c && (d(a3.c), l3.c = false), S2(n3.c, a3), G(r3, n3));
            else {
              var s2 = g(o3.b.a, a3.b.a) ? l3 : i3;
              i3 = void 0;
              l3.d || s2.c ? (i3 = s2 === l3 ? f(n3.c.b, a3.e) : f(o3.b.c.b, n3.c).b, s2.c ? c(s2, i3) : ((l3 = L(a3 = r3, l3, i3)).f = de(l3).f + l3.a.f, l3.d = P2(a3, l3.f)), G(r3, n3)) : R2(r3, l3, n3.c, n3.c, null, true);
            }
            return;
          }
        if (l3 = (a3 = ce(r3 = C(r3.i))).a, (a3 = k2(e3, a3, null)).c === l3) {
          a3 = (l3 = a3).c, o3 = ce(r3), i3 = r3.a, s2 = o3.a;
          var l3, u3 = false;
          i3.b.a !== s2.b.a && F(e3, r3), m2(i3.a, e3.a) && (S2(K2(a3), i3), a3 = ce(r3 = C(r3)).a, k2(e3, ce(r3), o3), u3 = true), m2(s2.a, e3.a) && (S2(l3, K2(s2)), l3 = k2(e3, o3, null), u3 = true), u3 ? R2(e3, r3, l3.c, a3, a3, true) : (n3 = g(s2.a, i3.a) ? K2(s2) : i3, R2(e3, r3, n3 = f(l3.c.b, n3), n3.c, n3.c, false), n3.b.i.c = true, B(e3, r3));
        } else
          R2(e3, r3, a3.c, l3, l3, true);
      }
      function V(e3, t3) {
        var r3 = new ue(), n3 = a2(e3.b);
        n3.a.b = 4e150, n3.a.a = t3, n3.b.a.b = -4e150, n3.b.a.a = t3, e3.a = n3.b.a, r3.a = n3, r3.f = 0, r3.d = false, r3.c = false, r3.h = true, r3.b = false, n3 = H(n3 = e3.f, n3.a, r3), r3.e = n3;
      }
      function z(e3) {
        this.a = new W2(), this.b = e3, this.c = u2;
      }
      function H(e3, t3, r3) {
        for (; (t3 = t3.c).b !== null && !e3.c(e3.b, t3.b, r3); )
          ;
        return e3 = new W2(r3, t3.a, t3), t3.a.c = e3, t3.a = e3;
      }
      function W2(e3, t3, r3) {
        this.b = e3 || null, this.a = t3 || this, this.c = r3 || this;
      }
      function q() {
        this.d = 0, this.p = this.b = this.q = null, this.j = [0, 0, 0], this.s = 100130, this.n = false, this.o = this.a = this.e = this.f = null, this.m = false, this.c = this.r = this.i = this.k = this.l = this.h = null;
      }
      function X2(e3, t3) {
        if (e3.d !== t3)
          for (; e3.d !== t3; )
            if (e3.d < t3)
              switch (e3.d) {
                case 0:
                  Y2(e3, 100151), e3.u(null);
                  break;
                case 1:
                  Y2(e3, 100152), e3.t();
              }
            else
              switch (e3.d) {
                case 2:
                  Y2(e3, 100154), e3.v();
                  break;
                case 1:
                  Y2(e3, 100153), e3.w();
              }
      }
      function Y2(e3, t3) {
        e3.p && e3.p(t3, e3.c);
      }
      function Z(e3, t3) {
        this.b = e3 || this, this.d = t3 || this, this.a = null, this.c = false;
      }
      function Q() {
        (this.h = this).i = this.d = this.a = this.e = this.c = this.b = null, this.f = 0;
      }
      function K2(e3) {
        return e3.b.e;
      }
      function J() {
        this.c = new $(), this.a = new Z(), this.b = new Q(), this.d = new Q(), this.b.b = this.d, this.d.b = this.b;
      }
      function $(e3, t3) {
        this.e = e3 || this, this.f = t3 || this, this.d = this.c = null, this.g = [0, 0, 0], this.h = this.a = this.b = 0;
      }
      function ee() {
        this.c = [], this.d = null, this.a = 0, this.e = false, this.b = new ne();
      }
      function te(e3, t3) {
        if (e3.e) {
          var r3, n3 = e3.b, o3 = ++n3.a;
          return 2 * o3 > n3.f && (n3.f *= 2, n3.c = oe(n3.c, n3.f + 1)), n3.b === 0 ? r3 = o3 : (r3 = n3.b, n3.b = n3.c[n3.b]), n3.e[r3] = t3, n3.c[r3] = o3, n3.d[o3] = r3, n3.h && le(n3, o3), r3;
        }
        return n3 = e3.a++, e3.c[n3] = t3, -(n3 + 1);
      }
      function re(e3) {
        if (e3.a === 0)
          return ae(e3.b);
        var t3 = e3.c[e3.d[e3.a - 1]];
        if (e3.b.a !== 0 && g(ie(e3.b), t3))
          return ae(e3.b);
        for (; --e3.a, 0 < e3.a && e3.c[e3.d[e3.a - 1]] === null; )
          ;
        return t3;
      }
      function ne() {
        this.d = oe([0], 33), this.e = [null, null], this.c = [0, 0], this.a = 0, this.f = 32, this.b = 0, this.h = false, this.d[1] = 1;
      }
      function oe(e3, t3) {
        for (var r3 = Array(t3), n3 = 0; n3 < e3.length; n3++)
          r3[n3] = e3[n3];
        for (; n3 < t3; n3++)
          r3[n3] = 0;
        return r3;
      }
      function ie(e3) {
        return e3.e[e3.d[1]];
      }
      function ae(e3) {
        var t3 = e3.d, r3 = e3.e, n3 = e3.c, o3 = t3[1], i3 = r3[o3];
        return 0 < e3.a && (t3[1] = t3[e3.a], n3[t3[1]] = 1, r3[o3] = null, n3[o3] = e3.b, e3.b = o3, 0 < --e3.a && se(e3, 1)), i3;
      }
      function se(e3, t3) {
        for (var r3 = e3.d, n3 = e3.e, o3 = e3.c, i3 = t3, a3 = r3[i3]; ; ) {
          var s2 = i3 << 1;
          s2 < e3.a && g(n3[r3[s2 + 1]], n3[r3[s2]]) && (s2 += 1);
          var l3 = r3[s2];
          if (s2 > e3.a || g(n3[a3], n3[l3])) {
            o3[r3[i3] = a3] = i3;
            break;
          }
          o3[r3[i3] = l3] = i3, i3 = s2;
        }
      }
      function le(e3, t3) {
        for (var r3 = e3.d, n3 = e3.e, o3 = e3.c, i3 = t3, a3 = r3[i3]; ; ) {
          var s2 = i3 >> 1, l3 = r3[s2];
          if (s2 == 0 || g(n3[l3], n3[a3])) {
            o3[r3[i3] = a3] = i3;
            break;
          }
          o3[r3[i3] = l3] = i3, i3 = s2;
        }
      }
      function ue() {
        this.e = this.a = null, this.f = 0, this.c = this.b = this.h = this.d = false;
      }
      function ce(e3) {
        return e3.e.c.b;
      }
      function de(e3) {
        return e3.e.a.b;
      }
      (n2 = q.prototype).x = function() {
        X2(this, 0);
      }, n2.B = function(e3, t3) {
        switch (e3) {
          case 100142:
            return;
          case 100140:
            switch (t3) {
              case 100130:
              case 100131:
              case 100132:
              case 100133:
              case 100134:
                return void (this.s = t3);
            }
            break;
          case 100141:
            return void (this.m = !!t3);
          default:
            return void Y2(this, 100900);
        }
        Y2(this, 100901);
      }, n2.y = function(e3) {
        switch (e3) {
          case 100142:
            return 0;
          case 100140:
            return this.s;
          case 100141:
            return this.m;
          default:
            Y2(this, 100900);
        }
        return false;
      }, n2.A = function(e3, t3, r3) {
        this.j[0] = e3, this.j[1] = t3, this.j[2] = r3;
      }, n2.z = function(e3, t3) {
        var r3 = t3 || null;
        switch (e3) {
          case 100100:
          case 100106:
            this.h = r3;
            break;
          case 100104:
          case 100110:
            this.l = r3;
            break;
          case 100101:
          case 100107:
            this.k = r3;
            break;
          case 100102:
          case 100108:
            this.i = r3;
            break;
          case 100103:
          case 100109:
            this.p = r3;
            break;
          case 100105:
          case 100111:
            this.o = r3;
            break;
          case 100112:
            this.r = r3;
            break;
          default:
            Y2(this, 100900);
        }
      }, n2.C = function(e3, t3) {
        var r3 = false, n3 = [0, 0, 0];
        X2(this, 2);
        for (var o3 = 0; o3 < 3; ++o3) {
          var i3 = e3[o3];
          i3 < -1e150 && (i3 = -1e150, r3 = true), 1e150 < i3 && (i3 = 1e150, r3 = true), n3[o3] = i3;
        }
        r3 && Y2(this, 100155), (r3 = this.q) === null ? S2(r3 = a2(this.b), r3.b) : (M(r3), r3 = r3.e), r3.a.d = t3, r3.a.g[0] = n3[0], r3.a.g[1] = n3[1], r3.a.g[2] = n3[2], r3.f = 1, r3.b.f = -1, this.q = r3;
      }, n2.u = function(e3) {
        X2(this, 0), this.d = 1, this.b = new J(), this.c = e3;
      }, n2.t = function() {
        X2(this, 1), this.d = 2, this.q = null;
      }, n2.v = function() {
        X2(this, 2), this.d = 1;
      }, n2.w = function() {
        X2(this, 1), this.d = 0;
        var e3, t3, r3 = false, n3 = [l3 = this.j[0], o3 = this.j[1], a3 = this.j[2]];
        if (l3 === 0 && o3 === 0 && a3 === 0) {
          for (var o3 = [-2e150, -2e150, -2e150], i3 = [2e150, 2e150, 2e150], a3 = [], s2 = [], l3 = (r3 = this.b.c).e; l3 !== r3; l3 = l3.e)
            for (var u3 = 0; u3 < 3; ++u3) {
              var c2 = l3.g[u3];
              c2 < i3[u3] && (i3[u3] = c2, s2[u3] = l3), c2 > o3[u3] && (o3[u3] = c2, a3[u3] = l3);
            }
          if (l3 = 0, o3[1] - i3[1] > o3[0] - i3[0] && (l3 = 1), o3[2] - i3[2] > o3[l3] - i3[l3] && (l3 = 2), i3[l3] >= o3[l3])
            n3[0] = 0, n3[1] = 0, n3[2] = 1;
          else {
            for (o3 = 0, i3 = s2[l3], a3 = a3[l3], s2 = [0, 0, 0], i3 = [i3.g[0] - a3.g[0], i3.g[1] - a3.g[1], i3.g[2] - a3.g[2]], u3 = [0, 0, 0], l3 = r3.e; l3 !== r3; l3 = l3.e)
              u3[0] = l3.g[0] - a3.g[0], u3[1] = l3.g[1] - a3.g[1], u3[2] = l3.g[2] - a3.g[2], s2[0] = i3[1] * u3[2] - i3[2] * u3[1], s2[1] = i3[2] * u3[0] - i3[0] * u3[2], s2[2] = i3[0] * u3[1] - i3[1] * u3[0], o3 < (c2 = s2[0] * s2[0] + s2[1] * s2[1] + s2[2] * s2[2]) && (o3 = c2, n3[0] = s2[0], n3[1] = s2[1], n3[2] = s2[2]);
            o3 <= 0 && (n3[0] = n3[1] = n3[2] = 0, n3[E(i3)] = 1);
          }
          r3 = true;
        }
        for (s2 = E(n3), l3 = this.b.c, o3 = (s2 + 1) % 3, a3 = (s2 + 2) % 3, s2 = 0 < n3[s2] ? 1 : -1, n3 = l3.e; n3 !== l3; n3 = n3.e)
          n3.b = n3.g[o3], n3.a = s2 * n3.g[a3];
        if (r3) {
          for (n3 = 0, l3 = (r3 = this.b.a).b; l3 !== r3; l3 = l3.b)
            if (!((o3 = l3.a).f <= 0))
              for (; n3 += (o3.a.b - o3.b.a.b) * (o3.a.a + o3.b.a.a), (o3 = o3.e) !== l3.a; )
                ;
          if (n3 < 0)
            for (r3 = (n3 = this.b.c).e; r3 !== n3; r3 = r3.e)
              r3.a = -r3.a;
        }
        for (this.n = false, l3 = (n3 = this.b.b).h; l3 !== n3; l3 = r3)
          r3 = l3.h, o3 = l3.e, m2(l3.a, l3.b.a) && l3.e.e !== l3 && (I(this, o3, l3), d(l3), o3 = (l3 = o3).e), o3.e === l3 && (o3 !== l3 && (o3 !== r3 && o3 !== r3.b || (r3 = r3.h), d(o3)), l3 !== r3 && l3 !== r3.b || (r3 = r3.h), d(l3));
        for (this.e = n3 = new ee(), l3 = (r3 = this.b.c).e; l3 !== r3; l3 = l3.e)
          l3.h = te(n3, l3);
        for (!function(e4) {
          e4.d = [];
          for (var t4 = 0; t4 < e4.a; t4++)
            e4.d[t4] = t4;
          e4.d.sort(function(r4) {
            return function(e5, t5) {
              return g(r4[e5], r4[t5]) ? 1 : -1;
            };
          }(e4.c)), e4.e = true, function(e5) {
            for (var t5 = e5.a; 1 <= t5; --t5)
              se(e5, t5);
            e5.h = true;
          }(e4.b);
        }(n3), this.f = new z(this), V(this, -4e150), V(this, 4e150); (n3 = re(this.e)) !== null; ) {
          for (; ; ) {
            e:
              if (l3 = this.e, l3.a === 0)
                r3 = ie(l3.b);
              else if (r3 = l3.c[l3.d[l3.a - 1]], l3.b.a !== 0 && (l3 = ie(l3.b), g(l3, r3))) {
                r3 = l3;
                break e;
              }
            if (r3 === null || !m2(r3, n3))
              break;
            r3 = re(this.e), I(this, n3.c, r3.c);
          }
          G(this, n3);
        }
        for (this.a = this.f.a.a.b.a.a, n3 = 0; (r3 = this.f.a.a.b) !== null; )
          r3.h || ++n3, O2(r3);
        for (this.f = null, (n3 = this.e).b = null, n3.d = null, this.e = n3.c = null, l3 = (n3 = this.b).a.b; l3 !== n3.a; l3 = r3)
          r3 = l3.b, (l3 = l3.a).e.e === l3 && (T2(l3.c, l3), d(l3));
        if (!this.n) {
          if (n3 = this.b, this.m)
            for (l3 = n3.b.h; l3 !== n3.b; l3 = r3)
              r3 = l3.h, l3.b.d.c !== l3.d.c ? l3.f = l3.d.c ? 1 : -1 : d(l3);
          else
            for (l3 = n3.a.b; l3 !== n3.a; l3 = r3)
              if (r3 = l3.b, l3.c) {
                for (l3 = l3.a; g(l3.b.a, l3.a); l3 = l3.c.b)
                  ;
                for (; g(l3.a, l3.b.a); l3 = l3.e)
                  ;
                for (o3 = l3.c.b, a3 = void 0; l3.e !== o3; )
                  if (g(l3.b.a, o3.a)) {
                    for (; o3.e !== l3 && (g((t3 = o3.e).b.a, t3.a) || b2(o3.a, o3.b.a, o3.e.b.a) <= 0); )
                      o3 = (a3 = f(o3.e, o3)).b;
                    o3 = o3.c.b;
                  } else {
                    for (; o3.e !== l3 && (g((e3 = l3.c.b).a, e3.b.a) || 0 <= b2(l3.b.a, l3.a, l3.c.b.a)); )
                      l3 = (a3 = f(l3, l3.c.b)).b;
                    l3 = l3.e;
                  }
                for (; o3.e.e !== l3; )
                  o3 = (a3 = f(o3.e, o3)).b;
              }
          if (this.h || this.i || this.k || this.l)
            if (this.m) {
              for (r3 = (n3 = this.b).a.b; r3 !== n3.a; r3 = r3.b)
                if (r3.c) {
                  for (this.h && this.h(2, this.c), l3 = r3.a; this.k && this.k(l3.a.d, this.c), (l3 = l3.e) !== r3.a; )
                    ;
                  this.i && this.i(this.c);
                }
            } else {
              for (n3 = this.b, r3 = !!this.l, l3 = false, o3 = -1, a3 = n3.a.d; a3 !== n3.a; a3 = a3.d)
                if (a3.c)
                  for (l3 || (this.h && this.h(4, this.c), l3 = true), s2 = a3.a; r3 && (o3 !== (i3 = s2.b.d.c ? 0 : 1) && (o3 = i3, this.l && this.l(!!o3, this.c))), this.k && this.k(s2.a.d, this.c), (s2 = s2.e) !== a3.a; )
                    ;
              l3 && this.i && this.i(this.c);
            }
          if (this.r) {
            for (l3 = (n3 = this.b).a.b; l3 !== n3.a; l3 = r3)
              if (r3 = l3.b, !l3.c) {
                for (a3 = (o3 = l3.a).e, s2 = void 0; a3 = (s2 = a3).e, (s2.d = null) === s2.b.d && (s2.c === s2 ? y(s2.a, null) : (s2.a.c = s2.c, h2(s2, K2(s2))), (i3 = s2.b).c === i3 ? y(i3.a, null) : (i3.a.c = i3.c, h2(i3, K2(i3))), p2(s2)), s2 !== o3; )
                  ;
                o3 = l3.d, ((l3 = l3.b).d = o3).b = l3;
              }
            return this.r(this.b), void (this.c = this.b = null);
          }
        }
        this.b = this.c = null;
      }, this.libtess = { GluTesselator: q, windingRule: { GLU_TESS_WINDING_ODD: 100130, GLU_TESS_WINDING_NONZERO: 100131, GLU_TESS_WINDING_POSITIVE: 100132, GLU_TESS_WINDING_NEGATIVE: 100133, GLU_TESS_WINDING_ABS_GEQ_TWO: 100134 }, primitiveType: { GL_LINE_LOOP: 2, GL_TRIANGLES: 4, GL_TRIANGLE_STRIP: 5, GL_TRIANGLE_FAN: 6 }, errorType: { GLU_TESS_MISSING_BEGIN_POLYGON: 100151, GLU_TESS_MISSING_END_POLYGON: 100153, GLU_TESS_MISSING_BEGIN_CONTOUR: 100152, GLU_TESS_MISSING_END_CONTOUR: 100154, GLU_TESS_COORD_TOO_LARGE: 100155, GLU_TESS_NEED_COMBINE_CALLBACK: 100156 }, gluEnum: { GLU_TESS_MESH: 100112, GLU_TESS_TOLERANCE: 100142, GLU_TESS_WINDING_RULE: 100140, GLU_TESS_BOUNDARY_ONLY: 100141, GLU_INVALID_ENUM: 100900, GLU_INVALID_VALUE: 100901, GLU_TESS_BEGIN: 100100, GLU_TESS_VERTEX: 100101, GLU_TESS_END: 100102, GLU_TESS_ERROR: 100103, GLU_TESS_EDGE_FLAG: 100104, GLU_TESS_COMBINE: 100105, GLU_TESS_BEGIN_DATA: 100106, GLU_TESS_VERTEX_DATA: 100107, GLU_TESS_END_DATA: 100108, GLU_TESS_ERROR_DATA: 100109, GLU_TESS_EDGE_FLAG_DATA: 100110, GLU_TESS_COMBINE_DATA: 100111 } }, q.prototype.gluDeleteTess = q.prototype.x, q.prototype.gluTessProperty = q.prototype.B, q.prototype.gluGetTessProperty = q.prototype.y, q.prototype.gluTessNormal = q.prototype.A, q.prototype.gluTessCallback = q.prototype.z, q.prototype.gluTessVertex = q.prototype.C, q.prototype.gluTessBeginPolygon = q.prototype.u, q.prototype.gluTessBeginContour = q.prototype.t, q.prototype.gluTessEndContour = q.prototype.v, q.prototype.gluTessEndPolygon = q.prototype.w, t2 !== void 0 && (t2.exports = this.libtess);
    }, {}], 238: [function(e2, t2, r2) {
      function O2(e3, t3, r3, n2) {
        for (var o2 = e3[t3++], i2 = 1 << o2, a2 = 1 + i2, s = 1 + a2, l2 = o2 + 1, u2 = (1 << l2) - 1, c = 0, d = 0, f = 0, h2 = e3[t3++], p2 = new Int32Array(4096), y = null; ; ) {
          for (; c < 16 && h2 !== 0; )
            d |= e3[t3++] << c, c += 8, h2 === 1 ? h2 = e3[t3++] : --h2;
          if (c < l2)
            break;
          var m2 = d & u2;
          if (d >>= l2, c -= l2, m2 != i2) {
            if (m2 == a2)
              break;
            for (var g = m2 < s ? m2 : y, v = 0, b2 = g; i2 < b2; )
              b2 = p2[b2] >> 8, ++v;
            var _ = b2;
            if (n2 < f + v + (g !== m2 ? 1 : 0))
              return void console.log("Warning, gif stream longer than expected.");
            r3[f++] = _;
            var x = f += v;
            for (g !== m2 && (r3[f++] = _), b2 = g; v--; )
              b2 = p2[b2], r3[--x] = 255 & b2, b2 >>= 8;
            y !== null && s < 4096 && (p2[s++] = y << 8 | _, u2 + 1 <= s && l2 < 12 && (++l2, u2 = u2 << 1 | 1)), y = m2;
          } else
            s = 1 + a2, u2 = (1 << (l2 = o2 + 1)) - 1, y = null;
        }
        return f !== n2 && console.log("Warning, gif stream shorter than expected."), r3;
      }
      try {
        r2.GifWriter = function(g, e3, t3, r3) {
          var v = 0, n2 = (r3 = r3 === void 0 ? {} : r3).loop === void 0 ? null : r3.loop, b2 = r3.palette === void 0 ? null : r3.palette;
          if (e3 <= 0 || t3 <= 0 || 65535 < e3 || 65535 < t3)
            throw new Error("Width/Height invalid.");
          function _(e4) {
            var t4 = e4.length;
            if (t4 < 2 || 256 < t4 || t4 & t4 - 1)
              throw new Error("Invalid code/color length, must be power of 2 and 2 .. 256.");
            return t4;
          }
          g[v++] = 71, g[v++] = 73, g[v++] = 70, g[v++] = 56, g[v++] = 57, g[v++] = 97;
          var o2 = 0, i2 = 0;
          if (b2 !== null) {
            for (var a2 = _(b2); a2 >>= 1; )
              ++o2;
            if (a2 = 1 << o2, --o2, r3.background !== void 0) {
              if (a2 <= (i2 = r3.background))
                throw new Error("Background index out of range.");
              if (i2 === 0)
                throw new Error("Background index explicitly passed as 0.");
            }
          }
          if (g[v++] = 255 & e3, g[v++] = e3 >> 8 & 255, g[v++] = 255 & t3, g[v++] = t3 >> 8 & 255, g[v++] = (b2 !== null ? 128 : 0) | o2, g[v++] = i2, g[v++] = 0, b2 !== null)
            for (var s = 0, l2 = b2.length; s < l2; ++s) {
              var u2 = b2[s];
              g[v++] = u2 >> 16 & 255, g[v++] = u2 >> 8 & 255, g[v++] = 255 & u2;
            }
          if (n2 !== null) {
            if (n2 < 0 || 65535 < n2)
              throw new Error("Loop count invalid.");
            g[v++] = 33, g[v++] = 255, g[v++] = 11, g[v++] = 78, g[v++] = 69, g[v++] = 84, g[v++] = 83, g[v++] = 67, g[v++] = 65, g[v++] = 80, g[v++] = 69, g[v++] = 50, g[v++] = 46, g[v++] = 48, g[v++] = 3, g[v++] = 1, g[v++] = 255 & n2, g[v++] = n2 >> 8 & 255, g[v++] = 0;
          }
          var x = false;
          this.addFrame = function(e4, t4, r4, n3, o3, i3) {
            if (x === true && (--v, x = false), i3 = i3 === void 0 ? {} : i3, e4 < 0 || t4 < 0 || 65535 < e4 || 65535 < t4)
              throw new Error("x/y invalid.");
            if (r4 <= 0 || n3 <= 0 || 65535 < r4 || 65535 < n3)
              throw new Error("Width/Height invalid.");
            if (o3.length < r4 * n3)
              throw new Error("Not enough pixels for the frame size.");
            var a3 = true, s2 = i3.palette;
            if (s2 == null && (a3 = false, s2 = b2), s2 == null)
              throw new Error("Must supply either a local or global palette.");
            for (var l3 = _(s2), u3 = 0; l3 >>= 1; )
              ++u3;
            l3 = 1 << u3;
            var c = i3.delay === void 0 ? 0 : i3.delay, d = i3.disposal === void 0 ? 0 : i3.disposal;
            if (d < 0 || 3 < d)
              throw new Error("Disposal out of range.");
            var f = false, h2 = 0;
            if (i3.transparent !== void 0 && i3.transparent !== null && (f = true, (h2 = i3.transparent) < 0 || l3 <= h2))
              throw new Error("Transparent color index.");
            if (d === 0 && !f && c === 0 || (g[v++] = 33, g[v++] = 249, g[v++] = 4, g[v++] = d << 2 | (f === true ? 1 : 0), g[v++] = 255 & c, g[v++] = c >> 8 & 255, g[v++] = h2, g[v++] = 0), g[v++] = 44, g[v++] = 255 & e4, g[v++] = e4 >> 8 & 255, g[v++] = 255 & t4, g[v++] = t4 >> 8 & 255, g[v++] = 255 & r4, g[v++] = r4 >> 8 & 255, g[v++] = 255 & n3, g[v++] = n3 >> 8 & 255, g[v++] = a3 === true ? 128 | u3 - 1 : 0, a3 === true)
              for (var p2 = 0, y = s2.length; p2 < y; ++p2) {
                var m2 = s2[p2];
                g[v++] = m2 >> 16 & 255, g[v++] = m2 >> 8 & 255, g[v++] = 255 & m2;
              }
            return v = function(t5, r5, e5, n4) {
              t5[r5++] = e5;
              var o4 = r5++, i4 = 1 << e5, a4 = i4 - 1, s3 = 1 + i4, l4 = 1 + s3, u4 = e5 + 1, c2 = 0, d2 = 0;
              function f2(e6) {
                for (; e6 <= c2; )
                  t5[r5++] = 255 & d2, d2 >>= 8, c2 -= 8, r5 === o4 + 256 && (t5[o4] = 255, o4 = r5++);
              }
              function h3(e6) {
                d2 |= e6 << c2, c2 += u4, f2(8);
              }
              var p3 = n4[0] & a4, y2 = {};
              h3(i4);
              for (var m3 = 1, g2 = n4.length; m3 < g2; ++m3) {
                var v2 = n4[m3] & a4, b3 = p3 << 8 | v2, _2 = y2[b3];
                if (_2 === void 0) {
                  for (d2 |= p3 << c2, c2 += u4; 8 <= c2; )
                    t5[r5++] = 255 & d2, d2 >>= 8, c2 -= 8, r5 === o4 + 256 && (t5[o4] = 255, o4 = r5++);
                  l4 === 4096 ? (h3(i4), l4 = 1 + s3, u4 = e5 + 1, y2 = {}) : (1 << u4 <= l4 && ++u4, y2[b3] = l4++), p3 = v2;
                } else
                  p3 = _2;
              }
              h3(p3), h3(s3), f2(1), o4 + 1 === r5 ? t5[o4] = 0 : (t5[o4] = r5 - o4 - 1, t5[r5++] = 0);
              return r5;
            }(g, v, u3 < 2 ? 2 : u3, o3);
          }, this.end = function() {
            return x === false && (g[v++] = 59, x = true), v;
          }, this.getOutputBuffer = function() {
            return g;
          }, this.setOutputBuffer = function(e4) {
            g = e4;
          }, this.getOutputBufferPosition = function() {
            return v;
          }, this.setOutputBufferPosition = function(e4) {
            v = e4;
          };
        }, r2.GifReader = function(x) {
          var e3 = 0;
          if (x[e3++] !== 71 || x[e3++] !== 73 || x[e3++] !== 70 || x[e3++] !== 56 || (x[e3++] + 1 & 253) != 56 || x[e3++] !== 97)
            throw new Error("Invalid GIF 87a/89a header.");
          var w = x[e3++] | x[e3++] << 8, t3 = x[e3++] | x[e3++] << 8, r3 = x[e3++], n2 = r3 >> 7, o2 = 1 << 1 + (7 & r3);
          x[e3++], x[e3++];
          var i2 = null, a2 = null;
          n2 && (i2 = e3, e3 += 3 * (a2 = o2));
          var s = true, l2 = [], u2 = 0, c = null, d = 0, f = null;
          for (this.width = w, this.height = t3; s && e3 < x.length; )
            switch (x[e3++]) {
              case 33:
                switch (x[e3++]) {
                  case 255:
                    if (x[e3] !== 11 || x[e3 + 1] == 78 && x[e3 + 2] == 69 && x[e3 + 3] == 84 && x[e3 + 4] == 83 && x[e3 + 5] == 67 && x[e3 + 6] == 65 && x[e3 + 7] == 80 && x[e3 + 8] == 69 && x[e3 + 9] == 50 && x[e3 + 10] == 46 && x[e3 + 11] == 48 && x[e3 + 12] == 3 && x[e3 + 13] == 1 && x[e3 + 16] == 0)
                      e3 += 14, f = x[e3++] | x[e3++] << 8, e3++;
                    else
                      for (e3 += 12; ; ) {
                        if (!(0 <= (T2 = x[e3++])))
                          throw Error("Invalid block size");
                        if (T2 === 0)
                          break;
                        e3 += T2;
                      }
                    break;
                  case 249:
                    if (x[e3++] !== 4 || x[e3 + 4] !== 0)
                      throw new Error("Invalid graphics extension block.");
                    var h2 = x[e3++];
                    u2 = x[e3++] | x[e3++] << 8, c = x[e3++], (1 & h2) == 0 && (c = null), d = h2 >> 2 & 7, e3++;
                    break;
                  case 254:
                    for (; ; ) {
                      if (!(0 <= (T2 = x[e3++])))
                        throw Error("Invalid block size");
                      if (T2 === 0)
                        break;
                      e3 += T2;
                    }
                    break;
                  default:
                    throw new Error("Unknown graphic control label: 0x" + x[e3 - 1].toString(16));
                }
                break;
              case 44:
                var p2 = x[e3++] | x[e3++] << 8, y = x[e3++] | x[e3++] << 8, m2 = x[e3++] | x[e3++] << 8, g = x[e3++] | x[e3++] << 8, v = x[e3++], b2 = v >> 6 & 1, _ = 1 << 1 + (7 & v), j = i2, S2 = a2, M = false;
                if (v >> 7) {
                  M = true;
                  j = e3, e3 += 3 * (S2 = _);
                }
                var E = e3;
                for (e3++; ; ) {
                  var T2;
                  if (!(0 <= (T2 = x[e3++])))
                    throw Error("Invalid block size");
                  if (T2 === 0)
                    break;
                  e3 += T2;
                }
                l2.push({ x: p2, y, width: m2, height: g, has_local_palette: M, palette_offset: j, palette_size: S2, data_offset: E, data_length: e3 - E, transparent_index: c, interlaced: !!b2, delay: u2, disposal: d });
                break;
              case 59:
                s = false;
                break;
              default:
                throw new Error("Unknown gif block: 0x" + x[e3 - 1].toString(16));
            }
          this.numFrames = function() {
            return l2.length;
          }, this.loopCount = function() {
            return f;
          }, this.frameInfo = function(e4) {
            if (e4 < 0 || e4 >= l2.length)
              throw new Error("Frame index out of range.");
            return l2[e4];
          }, this.decodeAndBlitFrameBGRA = function(e4, t4) {
            var r4 = this.frameInfo(e4), n3 = r4.width * r4.height, o3 = new Uint8Array(n3);
            O2(x, r4.data_offset, o3, n3);
            var i3 = r4.palette_offset, a3 = r4.transparent_index;
            a3 === null && (a3 = 256);
            var s2 = r4.width, l3 = w - s2, u3 = s2, c2 = 4 * (r4.y * w + r4.x), d2 = 4 * ((r4.y + r4.height) * w + r4.x), f2 = c2, h3 = 4 * l3;
            r4.interlaced === true && (h3 += 4 * w * 7);
            for (var p3 = 8, y2 = 0, m3 = o3.length; y2 < m3; ++y2) {
              var g2 = o3[y2];
              if (u3 === 0 && (u3 = s2, d2 <= (f2 += h3) && (h3 = 4 * l3 + 4 * w * (p3 - 1), f2 = c2 + (s2 + l3) * (p3 << 1), p3 >>= 1)), g2 === a3)
                f2 += 4;
              else {
                var v2 = x[i3 + 3 * g2], b3 = x[i3 + 3 * g2 + 1], _2 = x[i3 + 3 * g2 + 2];
                t4[f2++] = _2, t4[f2++] = b3, t4[f2++] = v2, t4[f2++] = 255;
              }
              --u3;
            }
          }, this.decodeAndBlitFrameRGBA = function(e4, t4) {
            var r4 = this.frameInfo(e4), n3 = r4.width * r4.height, o3 = new Uint8Array(n3);
            O2(x, r4.data_offset, o3, n3);
            var i3 = r4.palette_offset, a3 = r4.transparent_index;
            a3 === null && (a3 = 256);
            var s2 = r4.width, l3 = w - s2, u3 = s2, c2 = 4 * (r4.y * w + r4.x), d2 = 4 * ((r4.y + r4.height) * w + r4.x), f2 = c2, h3 = 4 * l3;
            r4.interlaced === true && (h3 += 4 * w * 7);
            for (var p3 = 8, y2 = 0, m3 = o3.length; y2 < m3; ++y2) {
              var g2 = o3[y2];
              if (u3 === 0 && (u3 = s2, d2 <= (f2 += h3) && (h3 = 4 * l3 + 4 * w * (p3 - 1), f2 = c2 + (s2 + l3) * (p3 << 1), p3 >>= 1)), g2 === a3)
                f2 += 4;
              else {
                var v2 = x[i3 + 3 * g2], b3 = x[i3 + 3 * g2 + 1], _2 = x[i3 + 3 * g2 + 2];
                t4[f2++] = v2, t4[f2++] = b3, t4[f2++] = _2, t4[f2++] = 255;
              }
              --u3;
            }
          };
        };
      } catch (e3) {
      }
    }, {}], 239: [function(Br, r2, n2) {
      (function(Fr) {
        var e2, t2;
        e2 = this, t2 = function(M) {
          function e3(e4) {
            if (this == null)
              throw TypeError();
            var t4 = String(this), r4 = t4.length, n4 = e4 ? Number(e4) : 0;
            if (n4 != n4 && (n4 = 0), !(n4 < 0 || r4 <= n4)) {
              var o3, i3 = t4.charCodeAt(n4);
              return 55296 <= i3 && i3 <= 56319 && n4 + 1 < r4 && 56320 <= (o3 = t4.charCodeAt(n4 + 1)) && o3 <= 57343 ? 1024 * (i3 - 55296) + o3 - 56320 + 65536 : i3;
            }
          }
          var t3;
          String.prototype.codePointAt || ((t3 = function() {
            try {
              var e4 = {}, t4 = Object.defineProperty, r4 = t4(e4, e4, e4) && t4;
            } catch (e5) {
            }
            return r4;
          }()) ? t3(String.prototype, "codePointAt", { value: e3, configurable: true, writable: true }) : String.prototype.codePointAt = e3);
          var l2 = 0, i2 = -3;
          function r3() {
            this.table = new Uint16Array(16), this.trans = new Uint16Array(288);
          }
          function a2(e4, t4) {
            this.source = e4, this.sourceIndex = 0, this.tag = 0, this.bitcount = 0, this.dest = t4, this.destLen = 0, this.ltree = new r3(), this.dtree = new r3();
          }
          var s = new r3(), u2 = new r3(), c = new Uint8Array(30), d = new Uint16Array(30), f = new Uint8Array(30), h2 = new Uint16Array(30), p2 = new Uint8Array([16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15]), y = new r3(), m2 = new Uint8Array(320);
          function n3(e4, t4, r4, n4) {
            var o3, i3;
            for (o3 = 0; o3 < r4; ++o3)
              e4[o3] = 0;
            for (o3 = 0; o3 < 30 - r4; ++o3)
              e4[o3 + r4] = o3 / r4 | 0;
            for (i3 = n4, o3 = 0; o3 < 30; ++o3)
              t4[o3] = i3, i3 += 1 << e4[o3];
          }
          var g = new Uint16Array(16);
          function v(e4, t4, r4, n4) {
            var o3, i3;
            for (o3 = 0; o3 < 16; ++o3)
              e4.table[o3] = 0;
            for (o3 = 0; o3 < n4; ++o3)
              e4.table[t4[r4 + o3]]++;
            for (o3 = i3 = e4.table[0] = 0; o3 < 16; ++o3)
              g[o3] = i3, i3 += e4.table[o3];
            for (o3 = 0; o3 < n4; ++o3)
              t4[r4 + o3] && (e4.trans[g[t4[r4 + o3]]++] = o3);
          }
          function b2(e4) {
            e4.bitcount-- || (e4.tag = e4.source[e4.sourceIndex++], e4.bitcount = 7);
            var t4 = 1 & e4.tag;
            return e4.tag >>>= 1, t4;
          }
          function _(e4, t4, r4) {
            if (!t4)
              return r4;
            for (; e4.bitcount < 24; )
              e4.tag |= e4.source[e4.sourceIndex++] << e4.bitcount, e4.bitcount += 8;
            var n4 = e4.tag & 65535 >>> 16 - t4;
            return e4.tag >>>= t4, e4.bitcount -= t4, n4 + r4;
          }
          function x(e4, t4) {
            for (; e4.bitcount < 24; )
              e4.tag |= e4.source[e4.sourceIndex++] << e4.bitcount, e4.bitcount += 8;
            for (var r4 = 0, n4 = 0, o3 = 0, i3 = e4.tag; n4 = 2 * n4 + (1 & i3), i3 >>>= 1, ++o3, r4 += t4.table[o3], 0 <= (n4 -= t4.table[o3]); )
              ;
            return e4.tag = i3, e4.bitcount -= o3, t4.trans[r4 + n4];
          }
          function w(e4, t4, r4) {
            var n4, o3, i3, a3, s2, l3;
            for (n4 = _(e4, 5, 257), o3 = _(e4, 5, 1), i3 = _(e4, 4, 4), a3 = 0; a3 < 19; ++a3)
              m2[a3] = 0;
            for (a3 = 0; a3 < i3; ++a3) {
              var u3 = _(e4, 3, 0);
              m2[p2[a3]] = u3;
            }
            for (v(y, m2, 0, 19), s2 = 0; s2 < n4 + o3; ) {
              var c2 = x(e4, y);
              switch (c2) {
                case 16:
                  var d2 = m2[s2 - 1];
                  for (l3 = _(e4, 2, 3); l3; --l3)
                    m2[s2++] = d2;
                  break;
                case 17:
                  for (l3 = _(e4, 3, 3); l3; --l3)
                    m2[s2++] = 0;
                  break;
                case 18:
                  for (l3 = _(e4, 7, 11); l3; --l3)
                    m2[s2++] = 0;
                  break;
                default:
                  m2[s2++] = c2;
              }
            }
            v(t4, m2, 0, n4), v(r4, m2, n4, o3);
          }
          function j(e4, t4, r4) {
            for (; ; ) {
              var n4, o3, i3, a3, s2 = x(e4, t4);
              if (s2 === 256)
                return l2;
              if (s2 < 256)
                e4.dest[e4.destLen++] = s2;
              else
                for (n4 = _(e4, c[s2 -= 257], d[s2]), o3 = x(e4, r4), a3 = i3 = e4.destLen - _(e4, f[o3], h2[o3]); a3 < i3 + n4; ++a3)
                  e4.dest[e4.destLen++] = e4.dest[a3];
            }
          }
          function S2(e4) {
            for (var t4, r4; 8 < e4.bitcount; )
              e4.sourceIndex--, e4.bitcount -= 8;
            if ((t4 = 256 * (t4 = e4.source[e4.sourceIndex + 1]) + e4.source[e4.sourceIndex]) !== (65535 & ~(256 * e4.source[e4.sourceIndex + 3] + e4.source[e4.sourceIndex + 2])))
              return i2;
            for (e4.sourceIndex += 4, r4 = t4; r4; --r4)
              e4.dest[e4.destLen++] = e4.source[e4.sourceIndex++];
            return e4.bitcount = 0, l2;
          }
          !function(e4, t4) {
            var r4;
            for (r4 = 0; r4 < 7; ++r4)
              e4.table[r4] = 0;
            for (e4.table[7] = 24, e4.table[8] = 152, e4.table[9] = 112, r4 = 0; r4 < 24; ++r4)
              e4.trans[r4] = 256 + r4;
            for (r4 = 0; r4 < 144; ++r4)
              e4.trans[24 + r4] = r4;
            for (r4 = 0; r4 < 8; ++r4)
              e4.trans[168 + r4] = 280 + r4;
            for (r4 = 0; r4 < 112; ++r4)
              e4.trans[176 + r4] = 144 + r4;
            for (r4 = 0; r4 < 5; ++r4)
              t4.table[r4] = 0;
            for (t4.table[5] = 32, r4 = 0; r4 < 32; ++r4)
              t4.trans[r4] = r4;
          }(s, u2), n3(c, d, 4, 3), n3(f, h2, 2, 1), c[28] = 0, d[28] = 258;
          var o2 = function(e4, t4) {
            var r4, n4, o3 = new a2(e4, t4);
            do {
              switch (r4 = b2(o3), _(o3, 2, 0)) {
                case 0:
                  n4 = S2(o3);
                  break;
                case 1:
                  n4 = j(o3, s, u2);
                  break;
                case 2:
                  w(o3, o3.ltree, o3.dtree), n4 = j(o3, o3.ltree, o3.dtree);
                  break;
                default:
                  n4 = i2;
              }
              if (n4 !== l2)
                throw new Error("Data error");
            } while (!r4);
            return o3.destLen < o3.dest.length ? typeof o3.dest.slice == "function" ? o3.dest.slice(0, o3.destLen) : o3.dest.subarray(0, o3.destLen) : o3.dest;
          };
          function E(e4, t4, r4, n4, o3) {
            return Math.pow(1 - o3, 3) * e4 + 3 * Math.pow(1 - o3, 2) * o3 * t4 + 3 * (1 - o3) * Math.pow(o3, 2) * r4 + Math.pow(o3, 3) * n4;
          }
          function T2() {
            this.x1 = Number.NaN, this.y1 = Number.NaN, this.x2 = Number.NaN, this.y2 = Number.NaN;
          }
          function D() {
            this.commands = [], this.fill = "black", this.stroke = null, this.strokeWidth = 1;
          }
          function O2(e4) {
            throw new Error(e4);
          }
          function C(e4, t4) {
            e4 || O2(t4);
          }
          T2.prototype.isEmpty = function() {
            return isNaN(this.x1) || isNaN(this.y1) || isNaN(this.x2) || isNaN(this.y2);
          }, T2.prototype.addPoint = function(e4, t4) {
            typeof e4 == "number" && ((isNaN(this.x1) || isNaN(this.x2)) && (this.x1 = e4, this.x2 = e4), e4 < this.x1 && (this.x1 = e4), e4 > this.x2 && (this.x2 = e4)), typeof t4 == "number" && ((isNaN(this.y1) || isNaN(this.y2)) && (this.y1 = t4, this.y2 = t4), t4 < this.y1 && (this.y1 = t4), t4 > this.y2 && (this.y2 = t4));
          }, T2.prototype.addX = function(e4) {
            this.addPoint(e4, null);
          }, T2.prototype.addY = function(e4) {
            this.addPoint(null, e4);
          }, T2.prototype.addBezier = function(e4, t4, r4, n4, o3, i3, a3, s2) {
            var l3 = [e4, t4], u3 = [r4, n4], c2 = [o3, i3], d2 = [a3, s2];
            this.addPoint(e4, t4), this.addPoint(a3, s2);
            for (var f2 = 0; f2 <= 1; f2++) {
              var h3 = 6 * l3[f2] - 12 * u3[f2] + 6 * c2[f2], p3 = -3 * l3[f2] + 9 * u3[f2] - 9 * c2[f2] + 3 * d2[f2], y2 = 3 * u3[f2] - 3 * l3[f2];
              if (p3 != 0) {
                var m3 = Math.pow(h3, 2) - 4 * y2 * p3;
                if (!(m3 < 0)) {
                  var g2 = (-h3 + Math.sqrt(m3)) / (2 * p3);
                  0 < g2 && g2 < 1 && (f2 === 0 && this.addX(E(l3[f2], u3[f2], c2[f2], d2[f2], g2)), f2 === 1 && this.addY(E(l3[f2], u3[f2], c2[f2], d2[f2], g2)));
                  var v2 = (-h3 - Math.sqrt(m3)) / (2 * p3);
                  0 < v2 && v2 < 1 && (f2 === 0 && this.addX(E(l3[f2], u3[f2], c2[f2], d2[f2], v2)), f2 === 1 && this.addY(E(l3[f2], u3[f2], c2[f2], d2[f2], v2)));
                }
              } else {
                if (h3 == 0)
                  continue;
                var b3 = -y2 / h3;
                0 < b3 && b3 < 1 && (f2 === 0 && this.addX(E(l3[f2], u3[f2], c2[f2], d2[f2], b3)), f2 === 1 && this.addY(E(l3[f2], u3[f2], c2[f2], d2[f2], b3)));
              }
            }
          }, T2.prototype.addQuad = function(e4, t4, r4, n4, o3, i3) {
            var a3 = e4 + 2 / 3 * (r4 - e4), s2 = t4 + 2 / 3 * (n4 - t4), l3 = a3 + 1 / 3 * (o3 - e4), u3 = s2 + 1 / 3 * (i3 - t4);
            this.addBezier(e4, t4, a3, s2, l3, u3, o3, i3);
          }, D.prototype.moveTo = function(e4, t4) {
            this.commands.push({ type: "M", x: e4, y: t4 });
          }, D.prototype.lineTo = function(e4, t4) {
            this.commands.push({ type: "L", x: e4, y: t4 });
          }, D.prototype.curveTo = D.prototype.bezierCurveTo = function(e4, t4, r4, n4, o3, i3) {
            this.commands.push({ type: "C", x1: e4, y1: t4, x2: r4, y2: n4, x: o3, y: i3 });
          }, D.prototype.quadTo = D.prototype.quadraticCurveTo = function(e4, t4, r4, n4) {
            this.commands.push({ type: "Q", x1: e4, y1: t4, x: r4, y: n4 });
          }, D.prototype.close = D.prototype.closePath = function() {
            this.commands.push({ type: "Z" });
          }, D.prototype.extend = function(e4) {
            if (e4.commands)
              e4 = e4.commands;
            else if (e4 instanceof T2) {
              var t4 = e4;
              return this.moveTo(t4.x1, t4.y1), this.lineTo(t4.x2, t4.y1), this.lineTo(t4.x2, t4.y2), this.lineTo(t4.x1, t4.y2), void this.close();
            }
            Array.prototype.push.apply(this.commands, e4);
          }, D.prototype.getBoundingBox = function() {
            for (var e4 = new T2(), t4 = 0, r4 = 0, n4 = 0, o3 = 0, i3 = 0; i3 < this.commands.length; i3++) {
              var a3 = this.commands[i3];
              switch (a3.type) {
                case "M":
                  e4.addPoint(a3.x, a3.y), t4 = n4 = a3.x, r4 = o3 = a3.y;
                  break;
                case "L":
                  e4.addPoint(a3.x, a3.y), n4 = a3.x, o3 = a3.y;
                  break;
                case "Q":
                  e4.addQuad(n4, o3, a3.x1, a3.y1, a3.x, a3.y), n4 = a3.x, o3 = a3.y;
                  break;
                case "C":
                  e4.addBezier(n4, o3, a3.x1, a3.y1, a3.x2, a3.y2, a3.x, a3.y), n4 = a3.x, o3 = a3.y;
                  break;
                case "Z":
                  n4 = t4, o3 = r4;
                  break;
                default:
                  throw new Error("Unexpected path command " + a3.type);
              }
            }
            return e4.isEmpty() && e4.addPoint(0, 0), e4;
          }, D.prototype.draw = function(e4) {
            e4.beginPath();
            for (var t4 = 0; t4 < this.commands.length; t4 += 1) {
              var r4 = this.commands[t4];
              r4.type === "M" ? e4.moveTo(r4.x, r4.y) : r4.type === "L" ? e4.lineTo(r4.x, r4.y) : r4.type === "C" ? e4.bezierCurveTo(r4.x1, r4.y1, r4.x2, r4.y2, r4.x, r4.y) : r4.type === "Q" ? e4.quadraticCurveTo(r4.x1, r4.y1, r4.x, r4.y) : r4.type === "Z" && e4.closePath();
            }
            this.fill && (e4.fillStyle = this.fill, e4.fill()), this.stroke && (e4.strokeStyle = this.stroke, e4.lineWidth = this.strokeWidth, e4.stroke());
          }, D.prototype.toPathData = function(i3) {
            function e4() {
              for (var e5, t5 = arguments, r5 = "", n5 = 0; n5 < arguments.length; n5 += 1) {
                var o3 = t5[n5];
                0 <= o3 && 0 < n5 && (r5 += " "), r5 += (e5 = o3, Math.round(e5) === e5 ? "" + Math.round(e5) : e5.toFixed(i3));
              }
              return r5;
            }
            i3 = i3 !== void 0 ? i3 : 2;
            for (var t4 = "", r4 = 0; r4 < this.commands.length; r4 += 1) {
              var n4 = this.commands[r4];
              n4.type === "M" ? t4 += "M" + e4(n4.x, n4.y) : n4.type === "L" ? t4 += "L" + e4(n4.x, n4.y) : n4.type === "C" ? t4 += "C" + e4(n4.x1, n4.y1, n4.x2, n4.y2, n4.x, n4.y) : n4.type === "Q" ? t4 += "Q" + e4(n4.x1, n4.y1, n4.x, n4.y) : n4.type === "Z" && (t4 += "Z");
            }
            return t4;
          }, D.prototype.toSVG = function(e4) {
            var t4 = '<path d="';
            return t4 += this.toPathData(e4), t4 += '"', this.fill && this.fill !== "black" && (this.fill === null ? t4 += ' fill="none"' : t4 += ' fill="' + this.fill + '"'), this.stroke && (t4 += ' stroke="' + this.stroke + '" stroke-width="' + this.strokeWidth + '"'), t4 += "/>";
          }, D.prototype.toDOMElement = function(e4) {
            var t4 = this.toPathData(e4), r4 = document.createElementNS("http://www.w3.org/2000/svg", "path");
            return r4.setAttribute("d", t4), r4;
          };
          var L = { fail: O2, argument: C, assert: C }, P2 = {}, A = {}, k2 = {};
          function R2(e4) {
            return function() {
              return e4;
            };
          }
          A.BYTE = function(e4) {
            return L.argument(0 <= e4 && e4 <= 255, "Byte value should be between 0 and 255."), [e4];
          }, k2.BYTE = R2(1), A.CHAR = function(e4) {
            return [e4.charCodeAt(0)];
          }, k2.CHAR = R2(1), A.CHARARRAY = function(e4) {
            for (var t4 = [], r4 = 0; r4 < e4.length; r4 += 1)
              t4[r4] = e4.charCodeAt(r4);
            return t4;
          }, k2.CHARARRAY = function(e4) {
            return e4.length;
          }, A.USHORT = function(e4) {
            return [e4 >> 8 & 255, 255 & e4];
          }, k2.USHORT = R2(2), A.SHORT = function(e4) {
            return 32768 <= e4 && (e4 = -(65536 - e4)), [e4 >> 8 & 255, 255 & e4];
          }, k2.SHORT = R2(2), A.UINT24 = function(e4) {
            return [e4 >> 16 & 255, e4 >> 8 & 255, 255 & e4];
          }, k2.UINT24 = R2(3), A.ULONG = function(e4) {
            return [e4 >> 24 & 255, e4 >> 16 & 255, e4 >> 8 & 255, 255 & e4];
          }, k2.ULONG = R2(4), A.LONG = function(e4) {
            return 2147483648 <= e4 && (e4 = -(4294967296 - e4)), [e4 >> 24 & 255, e4 >> 16 & 255, e4 >> 8 & 255, 255 & e4];
          }, k2.LONG = R2(4), A.FIXED = A.ULONG, k2.FIXED = k2.ULONG, A.FWORD = A.SHORT, k2.FWORD = k2.SHORT, A.UFWORD = A.USHORT, k2.UFWORD = k2.USHORT, A.LONGDATETIME = function(e4) {
            return [0, 0, 0, 0, e4 >> 24 & 255, e4 >> 16 & 255, e4 >> 8 & 255, 255 & e4];
          }, k2.LONGDATETIME = R2(8), A.TAG = function(e4) {
            return L.argument(e4.length === 4, "Tag should be exactly 4 ASCII characters."), [e4.charCodeAt(0), e4.charCodeAt(1), e4.charCodeAt(2), e4.charCodeAt(3)];
          }, k2.TAG = R2(4), A.Card8 = A.BYTE, k2.Card8 = k2.BYTE, A.Card16 = A.USHORT, k2.Card16 = k2.USHORT, A.OffSize = A.BYTE, k2.OffSize = k2.BYTE, A.SID = A.USHORT, k2.SID = k2.USHORT, A.NUMBER = function(e4) {
            return -107 <= e4 && e4 <= 107 ? [e4 + 139] : 108 <= e4 && e4 <= 1131 ? [247 + ((e4 -= 108) >> 8), 255 & e4] : -1131 <= e4 && e4 <= -108 ? [251 + ((e4 = -e4 - 108) >> 8), 255 & e4] : -32768 <= e4 && e4 <= 32767 ? A.NUMBER16(e4) : A.NUMBER32(e4);
          }, k2.NUMBER = function(e4) {
            return A.NUMBER(e4).length;
          }, A.NUMBER16 = function(e4) {
            return [28, e4 >> 8 & 255, 255 & e4];
          }, k2.NUMBER16 = R2(3), A.NUMBER32 = function(e4) {
            return [29, e4 >> 24 & 255, e4 >> 16 & 255, e4 >> 8 & 255, 255 & e4];
          }, k2.NUMBER32 = R2(5), A.REAL = function(e4) {
            var t4 = e4.toString(), r4 = /\.(\d*?)(?:9{5,20}|0{5,20})\d{0,2}(?:e(.+)|$)/.exec(t4);
            if (r4) {
              var n4 = parseFloat("1e" + ((r4[2] ? +r4[2] : 0) + r4[1].length));
              t4 = (Math.round(e4 * n4) / n4).toString();
            }
            for (var o3 = "", i3 = 0, a3 = t4.length; i3 < a3; i3 += 1) {
              var s2 = t4[i3];
              o3 += s2 === "e" ? t4[++i3] === "-" ? "c" : "b" : s2 === "." ? "a" : s2 === "-" ? "e" : s2;
            }
            for (var l3 = [30], u3 = 0, c2 = (o3 += 1 & o3.length ? "f" : "ff").length; u3 < c2; u3 += 2)
              l3.push(parseInt(o3.substr(u3, 2), 16));
            return l3;
          }, k2.REAL = function(e4) {
            return A.REAL(e4).length;
          }, A.NAME = A.CHARARRAY, k2.NAME = k2.CHARARRAY, A.STRING = A.CHARARRAY, k2.STRING = k2.CHARARRAY, P2.UTF8 = function(e4, t4, r4) {
            for (var n4 = [], o3 = r4, i3 = 0; i3 < o3; i3++, t4 += 1)
              n4[i3] = e4.getUint8(t4);
            return String.fromCharCode.apply(null, n4);
          }, P2.UTF16 = function(e4, t4, r4) {
            for (var n4 = [], o3 = r4 / 2, i3 = 0; i3 < o3; i3++, t4 += 2)
              n4[i3] = e4.getUint16(t4);
            return String.fromCharCode.apply(null, n4);
          }, A.UTF16 = function(e4) {
            for (var t4 = [], r4 = 0; r4 < e4.length; r4 += 1) {
              var n4 = e4.charCodeAt(r4);
              t4[t4.length] = n4 >> 8 & 255, t4[t4.length] = 255 & n4;
            }
            return t4;
          }, k2.UTF16 = function(e4) {
            return 2 * e4.length;
          };
          var I = { "x-mac-croatian": "\xC4\xC5\xC7\xC9\xD1\xD6\xDC\xE1\xE0\xE2\xE4\xE3\xE5\xE7\xE9\xE8\xEA\xEB\xED\xEC\xEE\xEF\xF1\xF3\xF2\xF4\xF6\xF5\xFA\xF9\xFB\xFC\u2020\xB0\xA2\xA3\xA7\u2022\xB6\xDF\xAE\u0160\u2122\xB4\xA8\u2260\u017D\xD8\u221E\xB1\u2264\u2265\u2206\xB5\u2202\u2211\u220F\u0161\u222B\xAA\xBA\u03A9\u017E\xF8\xBF\xA1\xAC\u221A\u0192\u2248\u0106\xAB\u010C\u2026\xA0\xC0\xC3\xD5\u0152\u0153\u0110\u2014\u201C\u201D\u2018\u2019\xF7\u25CA\uF8FF\xA9\u2044\u20AC\u2039\u203A\xC6\xBB\u2013\xB7\u201A\u201E\u2030\xC2\u0107\xC1\u010D\xC8\xCD\xCE\xCF\xCC\xD3\xD4\u0111\xD2\xDA\xDB\xD9\u0131\u02C6\u02DC\xAF\u03C0\xCB\u02DA\xB8\xCA\xE6\u02C7", "x-mac-cyrillic": "\u0410\u0411\u0412\u0413\u0414\u0415\u0416\u0417\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u0420\u0421\u0422\u0423\u0424\u0425\u0426\u0427\u0428\u0429\u042A\u042B\u042C\u042D\u042E\u042F\u2020\xB0\u0490\xA3\xA7\u2022\xB6\u0406\xAE\xA9\u2122\u0402\u0452\u2260\u0403\u0453\u221E\xB1\u2264\u2265\u0456\xB5\u0491\u0408\u0404\u0454\u0407\u0457\u0409\u0459\u040A\u045A\u0458\u0405\xAC\u221A\u0192\u2248\u2206\xAB\xBB\u2026\xA0\u040B\u045B\u040C\u045C\u0455\u2013\u2014\u201C\u201D\u2018\u2019\xF7\u201E\u040E\u045E\u040F\u045F\u2116\u0401\u0451\u044F\u0430\u0431\u0432\u0433\u0434\u0435\u0436\u0437\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u0440\u0441\u0442\u0443\u0444\u0445\u0446\u0447\u0448\u0449\u044A\u044B\u044C\u044D\u044E", "x-mac-gaelic": "\xC4\xC5\xC7\xC9\xD1\xD6\xDC\xE1\xE0\xE2\xE4\xE3\xE5\xE7\xE9\xE8\xEA\xEB\xED\xEC\xEE\xEF\xF1\xF3\xF2\xF4\xF6\xF5\xFA\xF9\xFB\xFC\u2020\xB0\xA2\xA3\xA7\u2022\xB6\xDF\xAE\xA9\u2122\xB4\xA8\u2260\xC6\xD8\u1E02\xB1\u2264\u2265\u1E03\u010A\u010B\u1E0A\u1E0B\u1E1E\u1E1F\u0120\u0121\u1E40\xE6\xF8\u1E41\u1E56\u1E57\u027C\u0192\u017F\u1E60\xAB\xBB\u2026\xA0\xC0\xC3\xD5\u0152\u0153\u2013\u2014\u201C\u201D\u2018\u2019\u1E61\u1E9B\xFF\u0178\u1E6A\u20AC\u2039\u203A\u0176\u0177\u1E6B\xB7\u1EF2\u1EF3\u204A\xC2\xCA\xC1\xCB\xC8\xCD\xCE\xCF\xCC\xD3\xD4\u2663\xD2\xDA\xDB\xD9\u0131\xDD\xFD\u0174\u0175\u1E84\u1E85\u1E80\u1E81\u1E82\u1E83", "x-mac-greek": "\xC4\xB9\xB2\xC9\xB3\xD6\xDC\u0385\xE0\xE2\xE4\u0384\xA8\xE7\xE9\xE8\xEA\xEB\xA3\u2122\xEE\xEF\u2022\xBD\u2030\xF4\xF6\xA6\u20AC\xF9\xFB\xFC\u2020\u0393\u0394\u0398\u039B\u039E\u03A0\xDF\xAE\xA9\u03A3\u03AA\xA7\u2260\xB0\xB7\u0391\xB1\u2264\u2265\xA5\u0392\u0395\u0396\u0397\u0399\u039A\u039C\u03A6\u03AB\u03A8\u03A9\u03AC\u039D\xAC\u039F\u03A1\u2248\u03A4\xAB\xBB\u2026\xA0\u03A5\u03A7\u0386\u0388\u0153\u2013\u2015\u201C\u201D\u2018\u2019\xF7\u0389\u038A\u038C\u038E\u03AD\u03AE\u03AF\u03CC\u038F\u03CD\u03B1\u03B2\u03C8\u03B4\u03B5\u03C6\u03B3\u03B7\u03B9\u03BE\u03BA\u03BB\u03BC\u03BD\u03BF\u03C0\u03CE\u03C1\u03C3\u03C4\u03B8\u03C9\u03C2\u03C7\u03C5\u03B6\u03CA\u03CB\u0390\u03B0\xAD", "x-mac-icelandic": "\xC4\xC5\xC7\xC9\xD1\xD6\xDC\xE1\xE0\xE2\xE4\xE3\xE5\xE7\xE9\xE8\xEA\xEB\xED\xEC\xEE\xEF\xF1\xF3\xF2\xF4\xF6\xF5\xFA\xF9\xFB\xFC\xDD\xB0\xA2\xA3\xA7\u2022\xB6\xDF\xAE\xA9\u2122\xB4\xA8\u2260\xC6\xD8\u221E\xB1\u2264\u2265\xA5\xB5\u2202\u2211\u220F\u03C0\u222B\xAA\xBA\u03A9\xE6\xF8\xBF\xA1\xAC\u221A\u0192\u2248\u2206\xAB\xBB\u2026\xA0\xC0\xC3\xD5\u0152\u0153\u2013\u2014\u201C\u201D\u2018\u2019\xF7\u25CA\xFF\u0178\u2044\u20AC\xD0\xF0\xDE\xFE\xFD\xB7\u201A\u201E\u2030\xC2\xCA\xC1\xCB\xC8\xCD\xCE\xCF\xCC\xD3\xD4\uF8FF\xD2\xDA\xDB\xD9\u0131\u02C6\u02DC\xAF\u02D8\u02D9\u02DA\xB8\u02DD\u02DB\u02C7", "x-mac-inuit": "\u1403\u1404\u1405\u1406\u140A\u140B\u1431\u1432\u1433\u1434\u1438\u1439\u1449\u144E\u144F\u1450\u1451\u1455\u1456\u1466\u146D\u146E\u146F\u1470\u1472\u1473\u1483\u148B\u148C\u148D\u148E\u1490\u1491\xB0\u14A1\u14A5\u14A6\u2022\xB6\u14A7\xAE\xA9\u2122\u14A8\u14AA\u14AB\u14BB\u14C2\u14C3\u14C4\u14C5\u14C7\u14C8\u14D0\u14EF\u14F0\u14F1\u14F2\u14F4\u14F5\u1505\u14D5\u14D6\u14D7\u14D8\u14DA\u14DB\u14EA\u1528\u1529\u152A\u152B\u152D\u2026\xA0\u152E\u153E\u1555\u1556\u1557\u2013\u2014\u201C\u201D\u2018\u2019\u1558\u1559\u155A\u155D\u1546\u1547\u1548\u1549\u154B\u154C\u1550\u157F\u1580\u1581\u1582\u1583\u1584\u1585\u158F\u1590\u1591\u1592\u1593\u1594\u1595\u1671\u1672\u1673\u1674\u1675\u1676\u1596\u15A0\u15A1\u15A2\u15A3\u15A4\u15A5\u15A6\u157C\u0141\u0142", "x-mac-ce": "\xC4\u0100\u0101\xC9\u0104\xD6\xDC\xE1\u0105\u010C\xE4\u010D\u0106\u0107\xE9\u0179\u017A\u010E\xED\u010F\u0112\u0113\u0116\xF3\u0117\xF4\xF6\xF5\xFA\u011A\u011B\xFC\u2020\xB0\u0118\xA3\xA7\u2022\xB6\xDF\xAE\xA9\u2122\u0119\xA8\u2260\u0123\u012E\u012F\u012A\u2264\u2265\u012B\u0136\u2202\u2211\u0142\u013B\u013C\u013D\u013E\u0139\u013A\u0145\u0146\u0143\xAC\u221A\u0144\u0147\u2206\xAB\xBB\u2026\xA0\u0148\u0150\xD5\u0151\u014C\u2013\u2014\u201C\u201D\u2018\u2019\xF7\u25CA\u014D\u0154\u0155\u0158\u2039\u203A\u0159\u0156\u0157\u0160\u201A\u201E\u0161\u015A\u015B\xC1\u0164\u0165\xCD\u017D\u017E\u016A\xD3\xD4\u016B\u016E\xDA\u016F\u0170\u0171\u0172\u0173\xDD\xFD\u0137\u017B\u0141\u017C\u0122\u02C7", macintosh: "\xC4\xC5\xC7\xC9\xD1\xD6\xDC\xE1\xE0\xE2\xE4\xE3\xE5\xE7\xE9\xE8\xEA\xEB\xED\xEC\xEE\xEF\xF1\xF3\xF2\xF4\xF6\xF5\xFA\xF9\xFB\xFC\u2020\xB0\xA2\xA3\xA7\u2022\xB6\xDF\xAE\xA9\u2122\xB4\xA8\u2260\xC6\xD8\u221E\xB1\u2264\u2265\xA5\xB5\u2202\u2211\u220F\u03C0\u222B\xAA\xBA\u03A9\xE6\xF8\xBF\xA1\xAC\u221A\u0192\u2248\u2206\xAB\xBB\u2026\xA0\xC0\xC3\xD5\u0152\u0153\u2013\u2014\u201C\u201D\u2018\u2019\xF7\u25CA\xFF\u0178\u2044\u20AC\u2039\u203A\uFB01\uFB02\u2021\xB7\u201A\u201E\u2030\xC2\xCA\xC1\xCB\xC8\xCD\xCE\xCF\xCC\xD3\xD4\uF8FF\xD2\xDA\xDB\xD9\u0131\u02C6\u02DC\xAF\u02D8\u02D9\u02DA\xB8\u02DD\u02DB\u02C7", "x-mac-romanian": "\xC4\xC5\xC7\xC9\xD1\xD6\xDC\xE1\xE0\xE2\xE4\xE3\xE5\xE7\xE9\xE8\xEA\xEB\xED\xEC\xEE\xEF\xF1\xF3\xF2\xF4\xF6\xF5\xFA\xF9\xFB\xFC\u2020\xB0\xA2\xA3\xA7\u2022\xB6\xDF\xAE\xA9\u2122\xB4\xA8\u2260\u0102\u0218\u221E\xB1\u2264\u2265\xA5\xB5\u2202\u2211\u220F\u03C0\u222B\xAA\xBA\u03A9\u0103\u0219\xBF\xA1\xAC\u221A\u0192\u2248\u2206\xAB\xBB\u2026\xA0\xC0\xC3\xD5\u0152\u0153\u2013\u2014\u201C\u201D\u2018\u2019\xF7\u25CA\xFF\u0178\u2044\u20AC\u2039\u203A\u021A\u021B\u2021\xB7\u201A\u201E\u2030\xC2\xCA\xC1\xCB\xC8\xCD\xCE\xCF\xCC\xD3\xD4\uF8FF\xD2\xDA\xDB\xD9\u0131\u02C6\u02DC\xAF\u02D8\u02D9\u02DA\xB8\u02DD\u02DB\u02C7", "x-mac-turkish": "\xC4\xC5\xC7\xC9\xD1\xD6\xDC\xE1\xE0\xE2\xE4\xE3\xE5\xE7\xE9\xE8\xEA\xEB\xED\xEC\xEE\xEF\xF1\xF3\xF2\xF4\xF6\xF5\xFA\xF9\xFB\xFC\u2020\xB0\xA2\xA3\xA7\u2022\xB6\xDF\xAE\xA9\u2122\xB4\xA8\u2260\xC6\xD8\u221E\xB1\u2264\u2265\xA5\xB5\u2202\u2211\u220F\u03C0\u222B\xAA\xBA\u03A9\xE6\xF8\xBF\xA1\xAC\u221A\u0192\u2248\u2206\xAB\xBB\u2026\xA0\xC0\xC3\xD5\u0152\u0153\u2013\u2014\u201C\u201D\u2018\u2019\xF7\u25CA\xFF\u0178\u011E\u011F\u0130\u0131\u015E\u015F\u2021\xB7\u201A\u201E\u2030\xC2\xCA\xC1\xCB\xC8\xCD\xCE\xCF\xCC\xD3\xD4\uF8FF\xD2\xDA\xDB\xD9\uF8A0\u02C6\u02DC\xAF\u02D8\u02D9\u02DA\xB8\u02DD\u02DB\u02C7" };
          P2.MACSTRING = function(e4, t4, r4, n4) {
            var o3 = I[n4];
            if (o3 !== void 0) {
              for (var i3 = "", a3 = 0; a3 < r4; a3++) {
                var s2 = e4.getUint8(t4 + a3);
                i3 += s2 <= 127 ? String.fromCharCode(s2) : o3[127 & s2];
              }
              return i3;
            }
          };
          var U, N = typeof WeakMap == "function" && /* @__PURE__ */ new WeakMap();
          function F(e4) {
            return -128 <= e4 && e4 <= 127;
          }
          function B(e4, t4, r4) {
            for (var n4 = 0, o3 = e4.length; t4 < o3 && n4 < 64 && e4[t4] === 0; )
              ++t4, ++n4;
            return r4.push(128 | n4 - 1), t4;
          }
          function G(e4, t4, r4) {
            for (var n4 = 0, o3 = e4.length, i3 = t4; i3 < o3 && n4 < 64; ) {
              var a3 = e4[i3];
              if (!F(a3))
                break;
              if (a3 === 0 && i3 + 1 < o3 && e4[i3 + 1] === 0)
                break;
              ++i3, ++n4;
            }
            r4.push(n4 - 1);
            for (var s2 = t4; s2 < i3; ++s2)
              r4.push(e4[s2] + 256 & 255);
            return i3;
          }
          function V(e4, t4, r4) {
            for (var n4 = 0, o3 = e4.length, i3 = t4; i3 < o3 && n4 < 64; ) {
              var a3 = e4[i3];
              if (a3 === 0)
                break;
              if (F(a3) && i3 + 1 < o3 && F(e4[i3 + 1]))
                break;
              ++i3, ++n4;
            }
            r4.push(64 | n4 - 1);
            for (var s2 = t4; s2 < i3; ++s2) {
              var l3 = e4[s2];
              r4.push(l3 + 65536 >> 8 & 255, l3 + 256 & 255);
            }
            return i3;
          }
          A.MACSTRING = function(e4, t4) {
            var r4 = function(e5) {
              if (!U)
                for (var t5 in U = {}, I)
                  U[t5] = new String(t5);
              var r5 = U[e5];
              if (r5 !== void 0) {
                if (N) {
                  var n5 = N.get(r5);
                  if (n5 !== void 0)
                    return n5;
                }
                var o4 = I[e5];
                if (o4 !== void 0) {
                  for (var i4 = {}, a3 = 0; a3 < o4.length; a3++)
                    i4[o4.charCodeAt(a3)] = a3 + 128;
                  return N && N.set(r5, i4), i4;
                }
              }
            }(t4);
            if (r4 !== void 0) {
              for (var n4 = [], o3 = 0; o3 < e4.length; o3++) {
                var i3 = e4.charCodeAt(o3);
                if (128 <= i3 && (i3 = r4[i3]) === void 0)
                  return;
                n4[o3] = i3;
              }
              return n4;
            }
          }, k2.MACSTRING = function(e4, t4) {
            var r4 = A.MACSTRING(e4, t4);
            return r4 !== void 0 ? r4.length : 0;
          }, A.VARDELTAS = function(e4) {
            for (var t4 = 0, r4 = []; t4 < e4.length; ) {
              var n4 = e4[t4];
              t4 = n4 === 0 ? B(e4, t4, r4) : -128 <= n4 && n4 <= 127 ? G(e4, t4, r4) : V(e4, t4, r4);
            }
            return r4;
          }, A.INDEX = function(e4) {
            for (var t4 = 1, r4 = [t4], n4 = [], o3 = 0; o3 < e4.length; o3 += 1) {
              var i3 = A.OBJECT(e4[o3]);
              Array.prototype.push.apply(n4, i3), t4 += i3.length, r4.push(t4);
            }
            if (n4.length === 0)
              return [0, 0];
            for (var a3 = [], s2 = 1 + Math.floor(Math.log(t4) / Math.log(2)) / 8 | 0, l3 = [void 0, A.BYTE, A.USHORT, A.UINT24, A.ULONG][s2], u3 = 0; u3 < r4.length; u3 += 1) {
              var c2 = l3(r4[u3]);
              Array.prototype.push.apply(a3, c2);
            }
            return Array.prototype.concat(A.Card16(e4.length), A.OffSize(s2), a3, n4);
          }, k2.INDEX = function(e4) {
            return A.INDEX(e4).length;
          }, A.DICT = function(e4) {
            for (var t4 = [], r4 = Object.keys(e4), n4 = r4.length, o3 = 0; o3 < n4; o3 += 1) {
              var i3 = parseInt(r4[o3], 0), a3 = e4[i3];
              t4 = (t4 = t4.concat(A.OPERAND(a3.value, a3.type))).concat(A.OPERATOR(i3));
            }
            return t4;
          }, k2.DICT = function(e4) {
            return A.DICT(e4).length;
          }, A.OPERATOR = function(e4) {
            return e4 < 1200 ? [e4] : [12, e4 - 1200];
          }, A.OPERAND = function(e4, t4) {
            var r4 = [];
            if (Array.isArray(t4))
              for (var n4 = 0; n4 < t4.length; n4 += 1)
                L.argument(e4.length === t4.length, "Not enough arguments given for type" + t4), r4 = r4.concat(A.OPERAND(e4[n4], t4[n4]));
            else if (t4 === "SID")
              r4 = r4.concat(A.NUMBER(e4));
            else if (t4 === "offset")
              r4 = r4.concat(A.NUMBER32(e4));
            else if (t4 === "number")
              r4 = r4.concat(A.NUMBER(e4));
            else {
              if (t4 !== "real")
                throw new Error("Unknown operand type " + t4);
              r4 = r4.concat(A.REAL(e4));
            }
            return r4;
          }, A.OP = A.BYTE, k2.OP = k2.BYTE;
          var z = typeof WeakMap == "function" && /* @__PURE__ */ new WeakMap();
          function H(e4, t4, r4) {
            for (var n4 = 0; n4 < t4.length; n4 += 1) {
              var o3 = t4[n4];
              this[o3.name] = o3.value;
            }
            if (this.tableName = e4, this.fields = t4, r4)
              for (var i3 = Object.keys(r4), a3 = 0; a3 < i3.length; a3 += 1) {
                var s2 = i3[a3], l3 = r4[s2];
                this[s2] !== void 0 && (this[s2] = l3);
              }
          }
          function W2(e4, t4, r4) {
            r4 === void 0 && (r4 = t4.length);
            var n4 = new Array(t4.length + 1);
            n4[0] = { name: e4 + "Count", type: "USHORT", value: r4 };
            for (var o3 = 0; o3 < t4.length; o3++)
              n4[o3 + 1] = { name: e4 + o3, type: "USHORT", value: t4[o3] };
            return n4;
          }
          function q(e4, t4, r4) {
            var n4 = t4.length, o3 = new Array(n4 + 1);
            o3[0] = { name: e4 + "Count", type: "USHORT", value: n4 };
            for (var i3 = 0; i3 < n4; i3++)
              o3[i3 + 1] = { name: e4 + i3, type: "TABLE", value: r4(t4[i3], i3) };
            return o3;
          }
          function X2(e4, t4, r4) {
            var n4 = t4.length, o3 = [];
            o3[0] = { name: e4 + "Count", type: "USHORT", value: n4 };
            for (var i3 = 0; i3 < n4; i3++)
              o3 = o3.concat(r4(t4[i3], i3));
            return o3;
          }
          function Y2(e4) {
            e4.format === 1 ? H.call(this, "coverageTable", [{ name: "coverageFormat", type: "USHORT", value: 1 }].concat(W2("glyph", e4.glyphs))) : L.assert(false, "Can't create coverage table format 2 yet.");
          }
          function Z(e4) {
            H.call(this, "scriptListTable", X2("scriptRecord", e4, function(e5, t4) {
              var r4 = e5.script, n4 = r4.defaultLangSys;
              return L.assert(!!n4, "Unable to write GSUB: script " + e5.tag + " has no default language system."), [{ name: "scriptTag" + t4, type: "TAG", value: e5.tag }, { name: "script" + t4, type: "TABLE", value: new H("scriptTable", [{ name: "defaultLangSys", type: "TABLE", value: new H("defaultLangSys", [{ name: "lookupOrder", type: "USHORT", value: 0 }, { name: "reqFeatureIndex", type: "USHORT", value: n4.reqFeatureIndex }].concat(W2("featureIndex", n4.featureIndexes))) }].concat(X2("langSys", r4.langSysRecords, function(e6, t5) {
                var r5 = e6.langSys;
                return [{ name: "langSysTag" + t5, type: "TAG", value: e6.tag }, { name: "langSys" + t5, type: "TABLE", value: new H("langSys", [{ name: "lookupOrder", type: "USHORT", value: 0 }, { name: "reqFeatureIndex", type: "USHORT", value: r5.reqFeatureIndex }].concat(W2("featureIndex", r5.featureIndexes))) }];
              }))) }];
            }));
          }
          function Q(e4) {
            H.call(this, "featureListTable", X2("featureRecord", e4, function(e5, t4) {
              var r4 = e5.feature;
              return [{ name: "featureTag" + t4, type: "TAG", value: e5.tag }, { name: "feature" + t4, type: "TABLE", value: new H("featureTable", [{ name: "featureParams", type: "USHORT", value: r4.featureParams }].concat(W2("lookupListIndex", r4.lookupListIndexes))) }];
            }));
          }
          function K2(e4, r4) {
            H.call(this, "lookupListTable", q("lookup", e4, function(e5) {
              var t4 = r4[e5.lookupType];
              return L.assert(!!t4, "Unable to write GSUB lookup type " + e5.lookupType + " tables."), new H("lookupTable", [{ name: "lookupType", type: "USHORT", value: e5.lookupType }, { name: "lookupFlag", type: "USHORT", value: e5.lookupFlag }].concat(q("subtable", e5.subtables, t4)));
            }));
          }
          A.CHARSTRING = function(e4) {
            if (z) {
              var t4 = z.get(e4);
              if (t4 !== void 0)
                return t4;
            }
            for (var r4 = [], n4 = e4.length, o3 = 0; o3 < n4; o3 += 1) {
              var i3 = e4[o3];
              r4 = r4.concat(A[i3.type](i3.value));
            }
            return z && z.set(e4, r4), r4;
          }, k2.CHARSTRING = function(e4) {
            return A.CHARSTRING(e4).length;
          }, A.OBJECT = function(e4) {
            var t4 = A[e4.type];
            return L.argument(t4 !== void 0, "No encoding function for type " + e4.type), t4(e4.value);
          }, k2.OBJECT = function(e4) {
            var t4 = k2[e4.type];
            return L.argument(t4 !== void 0, "No sizeOf function for type " + e4.type), t4(e4.value);
          }, A.TABLE = function(e4) {
            for (var t4 = [], r4 = e4.fields.length, n4 = [], o3 = [], i3 = 0; i3 < r4; i3 += 1) {
              var a3 = e4.fields[i3], s2 = A[a3.type];
              L.argument(s2 !== void 0, "No encoding function for field type " + a3.type + " (" + a3.name + ")");
              var l3 = e4[a3.name];
              l3 === void 0 && (l3 = a3.value);
              var u3 = s2(l3);
              a3.type === "TABLE" ? (o3.push(t4.length), t4 = t4.concat([0, 0]), n4.push(u3)) : t4 = t4.concat(u3);
            }
            for (var c2 = 0; c2 < n4.length; c2 += 1) {
              var d2 = o3[c2], f2 = t4.length;
              L.argument(f2 < 65536, "Table " + e4.tableName + " too big."), t4[d2] = f2 >> 8, t4[d2 + 1] = 255 & f2, t4 = t4.concat(n4[c2]);
            }
            return t4;
          }, k2.TABLE = function(e4) {
            for (var t4 = 0, r4 = e4.fields.length, n4 = 0; n4 < r4; n4 += 1) {
              var o3 = e4.fields[n4], i3 = k2[o3.type];
              L.argument(i3 !== void 0, "No sizeOf function for field type " + o3.type + " (" + o3.name + ")");
              var a3 = e4[o3.name];
              a3 === void 0 && (a3 = o3.value), t4 += i3(a3), o3.type === "TABLE" && (t4 += 2);
            }
            return t4;
          }, A.RECORD = A.TABLE, k2.RECORD = k2.TABLE, A.LITERAL = function(e4) {
            return e4;
          }, k2.LITERAL = function(e4) {
            return e4.length;
          }, H.prototype.encode = function() {
            return A.TABLE(this);
          }, H.prototype.sizeOf = function() {
            return k2.TABLE(this);
          };
          var J = { Table: H, Record: H, Coverage: (Y2.prototype = Object.create(H.prototype)).constructor = Y2, ScriptList: (Z.prototype = Object.create(H.prototype)).constructor = Z, FeatureList: (Q.prototype = Object.create(H.prototype)).constructor = Q, LookupList: (K2.prototype = Object.create(H.prototype)).constructor = K2, ushortList: W2, tableList: q, recordList: X2 };
          function $(e4, t4) {
            return e4.getUint8(t4);
          }
          function ee(e4, t4) {
            return e4.getUint16(t4, false);
          }
          function te(e4, t4) {
            return e4.getUint32(t4, false);
          }
          function re(e4, t4) {
            return e4.getInt16(t4, false) + e4.getUint16(t4 + 2, false) / 65535;
          }
          var ne = { byte: 1, uShort: 2, short: 2, uLong: 4, fixed: 4, longDateTime: 8, tag: 4 };
          function oe(e4, t4) {
            this.data = e4, this.offset = t4, this.relativeOffset = 0;
          }
          oe.prototype.parseByte = function() {
            var e4 = this.data.getUint8(this.offset + this.relativeOffset);
            return this.relativeOffset += 1, e4;
          }, oe.prototype.parseChar = function() {
            var e4 = this.data.getInt8(this.offset + this.relativeOffset);
            return this.relativeOffset += 1, e4;
          }, oe.prototype.parseCard8 = oe.prototype.parseByte, oe.prototype.parseCard16 = oe.prototype.parseUShort = function() {
            var e4 = this.data.getUint16(this.offset + this.relativeOffset);
            return this.relativeOffset += 2, e4;
          }, oe.prototype.parseSID = oe.prototype.parseUShort, oe.prototype.parseOffset16 = oe.prototype.parseUShort, oe.prototype.parseShort = function() {
            var e4 = this.data.getInt16(this.offset + this.relativeOffset);
            return this.relativeOffset += 2, e4;
          }, oe.prototype.parseF2Dot14 = function() {
            var e4 = this.data.getInt16(this.offset + this.relativeOffset) / 16384;
            return this.relativeOffset += 2, e4;
          }, oe.prototype.parseOffset32 = oe.prototype.parseULong = function() {
            var e4 = te(this.data, this.offset + this.relativeOffset);
            return this.relativeOffset += 4, e4;
          }, oe.prototype.parseFixed = function() {
            var e4 = re(this.data, this.offset + this.relativeOffset);
            return this.relativeOffset += 4, e4;
          }, oe.prototype.parseString = function(e4) {
            var t4 = this.data, r4 = this.offset + this.relativeOffset, n4 = "";
            this.relativeOffset += e4;
            for (var o3 = 0; o3 < e4; o3++)
              n4 += String.fromCharCode(t4.getUint8(r4 + o3));
            return n4;
          }, oe.prototype.parseTag = function() {
            return this.parseString(4);
          }, oe.prototype.parseLongDateTime = function() {
            var e4 = te(this.data, this.offset + this.relativeOffset + 4);
            return e4 -= 2082844800, this.relativeOffset += 8, e4;
          }, oe.prototype.parseVersion = function(e4) {
            var t4 = ee(this.data, this.offset + this.relativeOffset), r4 = ee(this.data, this.offset + this.relativeOffset + 2);
            return this.relativeOffset += 4, e4 === void 0 && (e4 = 4096), t4 + r4 / e4 / 10;
          }, oe.prototype.skip = function(e4, t4) {
            t4 === void 0 && (t4 = 1), this.relativeOffset += ne[e4] * t4;
          }, oe.prototype.parseULongList = function(e4) {
            e4 === void 0 && (e4 = this.parseULong());
            for (var t4 = new Array(e4), r4 = this.data, n4 = this.offset + this.relativeOffset, o3 = 0; o3 < e4; o3++)
              t4[o3] = r4.getUint32(n4), n4 += 4;
            return this.relativeOffset += 4 * e4, t4;
          }, oe.prototype.parseOffset16List = oe.prototype.parseUShortList = function(e4) {
            e4 === void 0 && (e4 = this.parseUShort());
            for (var t4 = new Array(e4), r4 = this.data, n4 = this.offset + this.relativeOffset, o3 = 0; o3 < e4; o3++)
              t4[o3] = r4.getUint16(n4), n4 += 2;
            return this.relativeOffset += 2 * e4, t4;
          }, oe.prototype.parseShortList = function(e4) {
            for (var t4 = new Array(e4), r4 = this.data, n4 = this.offset + this.relativeOffset, o3 = 0; o3 < e4; o3++)
              t4[o3] = r4.getInt16(n4), n4 += 2;
            return this.relativeOffset += 2 * e4, t4;
          }, oe.prototype.parseByteList = function(e4) {
            for (var t4 = new Array(e4), r4 = this.data, n4 = this.offset + this.relativeOffset, o3 = 0; o3 < e4; o3++)
              t4[o3] = r4.getUint8(n4++);
            return this.relativeOffset += e4, t4;
          }, oe.prototype.parseList = function(e4, t4) {
            t4 || (t4 = e4, e4 = this.parseUShort());
            for (var r4 = new Array(e4), n4 = 0; n4 < e4; n4++)
              r4[n4] = t4.call(this);
            return r4;
          }, oe.prototype.parseList32 = function(e4, t4) {
            t4 || (t4 = e4, e4 = this.parseULong());
            for (var r4 = new Array(e4), n4 = 0; n4 < e4; n4++)
              r4[n4] = t4.call(this);
            return r4;
          }, oe.prototype.parseRecordList = function(e4, t4) {
            t4 || (t4 = e4, e4 = this.parseUShort());
            for (var r4 = new Array(e4), n4 = Object.keys(t4), o3 = 0; o3 < e4; o3++) {
              for (var i3 = {}, a3 = 0; a3 < n4.length; a3++) {
                var s2 = n4[a3], l3 = t4[s2];
                i3[s2] = l3.call(this);
              }
              r4[o3] = i3;
            }
            return r4;
          }, oe.prototype.parseRecordList32 = function(e4, t4) {
            t4 || (t4 = e4, e4 = this.parseULong());
            for (var r4 = new Array(e4), n4 = Object.keys(t4), o3 = 0; o3 < e4; o3++) {
              for (var i3 = {}, a3 = 0; a3 < n4.length; a3++) {
                var s2 = n4[a3], l3 = t4[s2];
                i3[s2] = l3.call(this);
              }
              r4[o3] = i3;
            }
            return r4;
          }, oe.prototype.parseStruct = function(e4) {
            if (typeof e4 == "function")
              return e4.call(this);
            for (var t4 = Object.keys(e4), r4 = {}, n4 = 0; n4 < t4.length; n4++) {
              var o3 = t4[n4], i3 = e4[o3];
              r4[o3] = i3.call(this);
            }
            return r4;
          }, oe.prototype.parseValueRecord = function(e4) {
            if (e4 === void 0 && (e4 = this.parseUShort()), e4 !== 0) {
              var t4 = {};
              return 1 & e4 && (t4.xPlacement = this.parseShort()), 2 & e4 && (t4.yPlacement = this.parseShort()), 4 & e4 && (t4.xAdvance = this.parseShort()), 8 & e4 && (t4.yAdvance = this.parseShort()), 16 & e4 && (t4.xPlaDevice = void 0, this.parseShort()), 32 & e4 && (t4.yPlaDevice = void 0, this.parseShort()), 64 & e4 && (t4.xAdvDevice = void 0, this.parseShort()), 128 & e4 && (t4.yAdvDevice = void 0, this.parseShort()), t4;
            }
          }, oe.prototype.parseValueRecordList = function() {
            for (var e4 = this.parseUShort(), t4 = this.parseUShort(), r4 = new Array(t4), n4 = 0; n4 < t4; n4++)
              r4[n4] = this.parseValueRecord(e4);
            return r4;
          }, oe.prototype.parsePointer = function(e4) {
            var t4 = this.parseOffset16();
            if (0 < t4)
              return new oe(this.data, this.offset + t4).parseStruct(e4);
          }, oe.prototype.parsePointer32 = function(e4) {
            var t4 = this.parseOffset32();
            if (0 < t4)
              return new oe(this.data, this.offset + t4).parseStruct(e4);
          }, oe.prototype.parseListOfLists = function(e4) {
            for (var t4 = this.parseOffset16List(), r4 = t4.length, n4 = this.relativeOffset, o3 = new Array(r4), i3 = 0; i3 < r4; i3++) {
              var a3 = t4[i3];
              if (a3 !== 0)
                if (this.relativeOffset = a3, e4) {
                  for (var s2 = this.parseOffset16List(), l3 = new Array(s2.length), u3 = 0; u3 < s2.length; u3++)
                    this.relativeOffset = a3 + s2[u3], l3[u3] = e4.call(this);
                  o3[i3] = l3;
                } else
                  o3[i3] = this.parseUShortList();
              else
                o3[i3] = void 0;
            }
            return this.relativeOffset = n4, o3;
          }, oe.prototype.parseCoverage = function() {
            var e4 = this.offset + this.relativeOffset, t4 = this.parseUShort(), r4 = this.parseUShort();
            if (t4 === 1)
              return { format: 1, glyphs: this.parseUShortList(r4) };
            if (t4 !== 2)
              throw new Error("0x" + e4.toString(16) + ": Coverage format must be 1 or 2.");
            for (var n4 = new Array(r4), o3 = 0; o3 < r4; o3++)
              n4[o3] = { start: this.parseUShort(), end: this.parseUShort(), index: this.parseUShort() };
            return { format: 2, ranges: n4 };
          }, oe.prototype.parseClassDef = function() {
            var e4 = this.offset + this.relativeOffset, t4 = this.parseUShort();
            if (t4 === 1)
              return { format: 1, startGlyph: this.parseUShort(), classes: this.parseUShortList() };
            if (t4 === 2)
              return { format: 2, ranges: this.parseRecordList({ start: oe.uShort, end: oe.uShort, classId: oe.uShort }) };
            throw new Error("0x" + e4.toString(16) + ": ClassDef format must be 1 or 2.");
          }, oe.list = function(e4, t4) {
            return function() {
              return this.parseList(e4, t4);
            };
          }, oe.list32 = function(e4, t4) {
            return function() {
              return this.parseList32(e4, t4);
            };
          }, oe.recordList = function(e4, t4) {
            return function() {
              return this.parseRecordList(e4, t4);
            };
          }, oe.recordList32 = function(e4, t4) {
            return function() {
              return this.parseRecordList32(e4, t4);
            };
          }, oe.pointer = function(e4) {
            return function() {
              return this.parsePointer(e4);
            };
          }, oe.pointer32 = function(e4) {
            return function() {
              return this.parsePointer32(e4);
            };
          }, oe.tag = oe.prototype.parseTag, oe.byte = oe.prototype.parseByte, oe.uShort = oe.offset16 = oe.prototype.parseUShort, oe.uShortList = oe.prototype.parseUShortList, oe.uLong = oe.offset32 = oe.prototype.parseULong, oe.uLongList = oe.prototype.parseULongList, oe.struct = oe.prototype.parseStruct, oe.coverage = oe.prototype.parseCoverage, oe.classDef = oe.prototype.parseClassDef;
          var ie = { reserved: oe.uShort, reqFeatureIndex: oe.uShort, featureIndexes: oe.uShortList };
          oe.prototype.parseScriptList = function() {
            return this.parsePointer(oe.recordList({ tag: oe.tag, script: oe.pointer({ defaultLangSys: oe.pointer(ie), langSysRecords: oe.recordList({ tag: oe.tag, langSys: oe.pointer(ie) }) }) })) || [];
          }, oe.prototype.parseFeatureList = function() {
            return this.parsePointer(oe.recordList({ tag: oe.tag, feature: oe.pointer({ featureParams: oe.offset16, lookupListIndexes: oe.uShortList }) })) || [];
          }, oe.prototype.parseLookupList = function(n4) {
            return this.parsePointer(oe.list(oe.pointer(function() {
              var e4 = this.parseUShort();
              L.argument(1 <= e4 && e4 <= 9, "GPOS/GSUB lookup type " + e4 + " unknown.");
              var t4 = this.parseUShort(), r4 = 16 & t4;
              return { lookupType: e4, lookupFlag: t4, subtables: this.parseList(oe.pointer(n4[e4])), markFilteringSet: r4 ? this.parseUShort() : void 0 };
            }))) || [];
          }, oe.prototype.parseFeatureVariationsList = function() {
            return this.parsePointer32(function() {
              var e4 = this.parseUShort(), t4 = this.parseUShort();
              return L.argument(e4 === 1 && t4 < 1, "GPOS/GSUB feature variations table unknown."), this.parseRecordList32({ conditionSetOffset: oe.offset32, featureTableSubstitutionOffset: oe.offset32 });
            }) || [];
          };
          var ae = { getByte: $, getCard8: $, getUShort: ee, getCard16: ee, getShort: function(e4, t4) {
            return e4.getInt16(t4, false);
          }, getULong: te, getFixed: re, getTag: function(e4, t4) {
            for (var r4 = "", n4 = t4; n4 < t4 + 4; n4 += 1)
              r4 += String.fromCharCode(e4.getInt8(n4));
            return r4;
          }, getOffset: function(e4, t4, r4) {
            for (var n4 = 0, o3 = 0; o3 < r4; o3 += 1)
              n4 <<= 8, n4 += e4.getUint8(t4 + o3);
            return n4;
          }, getBytes: function(e4, t4, r4) {
            for (var n4 = [], o3 = t4; o3 < r4; o3 += 1)
              n4.push(e4.getUint8(o3));
            return n4;
          }, bytesToString: function(e4) {
            for (var t4 = "", r4 = 0; r4 < e4.length; r4 += 1)
              t4 += String.fromCharCode(e4[r4]);
            return t4;
          }, Parser: oe };
          var se = { parse: function(e4, t4) {
            var r4 = {};
            r4.version = ae.getUShort(e4, t4), L.argument(r4.version === 0, "cmap table version should be 0."), r4.numTables = ae.getUShort(e4, t4 + 2);
            for (var n4 = -1, o3 = r4.numTables - 1; 0 <= o3; --o3) {
              var i3 = ae.getUShort(e4, t4 + 4 + 8 * o3), a3 = ae.getUShort(e4, t4 + 4 + 8 * o3 + 2);
              if (i3 === 3 && (a3 === 0 || a3 === 1 || a3 === 10) || i3 === 0 && (a3 === 0 || a3 === 1 || a3 === 2 || a3 === 3 || a3 === 4)) {
                n4 = ae.getULong(e4, t4 + 4 + 8 * o3 + 4);
                break;
              }
            }
            if (n4 === -1)
              throw new Error("No valid cmap sub-tables found.");
            var s2 = new ae.Parser(e4, t4 + n4);
            if (r4.format = s2.parseUShort(), r4.format === 12)
              !function(e5, t5) {
                var r5;
                t5.parseUShort(), e5.length = t5.parseULong(), e5.language = t5.parseULong(), e5.groupCount = r5 = t5.parseULong(), e5.glyphIndexMap = {};
                for (var n5 = 0; n5 < r5; n5 += 1)
                  for (var o4 = t5.parseULong(), i4 = t5.parseULong(), a4 = t5.parseULong(), s3 = o4; s3 <= i4; s3 += 1)
                    e5.glyphIndexMap[s3] = a4, a4++;
              }(r4, s2);
            else {
              if (r4.format !== 4)
                throw new Error("Only format 4 and 12 cmap tables are supported (found format " + r4.format + ").");
              !function(e5, t5, r5, n5, o4) {
                var i4;
                e5.length = t5.parseUShort(), e5.language = t5.parseUShort(), e5.segCount = i4 = t5.parseUShort() >> 1, t5.skip("uShort", 3), e5.glyphIndexMap = {};
                for (var a4 = new ae.Parser(r5, n5 + o4 + 14), s3 = new ae.Parser(r5, n5 + o4 + 16 + 2 * i4), l3 = new ae.Parser(r5, n5 + o4 + 16 + 4 * i4), u3 = new ae.Parser(r5, n5 + o4 + 16 + 6 * i4), c2 = n5 + o4 + 16 + 8 * i4, d2 = 0; d2 < i4 - 1; d2 += 1)
                  for (var f2 = void 0, h3 = a4.parseUShort(), p3 = s3.parseUShort(), y2 = l3.parseShort(), m3 = u3.parseUShort(), g2 = p3; g2 <= h3; g2 += 1)
                    m3 !== 0 ? (c2 = u3.offset + u3.relativeOffset - 2, c2 += m3, c2 += 2 * (g2 - p3), (f2 = ae.getUShort(r5, c2)) !== 0 && (f2 = f2 + y2 & 65535)) : f2 = g2 + y2 & 65535, e5.glyphIndexMap[g2] = f2;
              }(r4, s2, e4, t4, n4);
            }
            return r4;
          }, make: function(e4) {
            var t4, r4 = true;
            for (t4 = e4.length - 1; 0 < t4; --t4) {
              if (65535 < e4.get(t4).unicode) {
                console.log("Adding CMAP format 12 (needed!)"), r4 = false;
                break;
              }
            }
            var n4 = [{ name: "version", type: "USHORT", value: 0 }, { name: "numTables", type: "USHORT", value: r4 ? 1 : 2 }, { name: "platformID", type: "USHORT", value: 3 }, { name: "encodingID", type: "USHORT", value: 1 }, { name: "offset", type: "ULONG", value: r4 ? 12 : 20 }];
            r4 || (n4 = n4.concat([{ name: "cmap12PlatformID", type: "USHORT", value: 3 }, { name: "cmap12EncodingID", type: "USHORT", value: 10 }, { name: "cmap12Offset", type: "ULONG", value: 0 }])), n4 = n4.concat([{ name: "format", type: "USHORT", value: 4 }, { name: "cmap4Length", type: "USHORT", value: 0 }, { name: "language", type: "USHORT", value: 0 }, { name: "segCountX2", type: "USHORT", value: 0 }, { name: "searchRange", type: "USHORT", value: 0 }, { name: "entrySelector", type: "USHORT", value: 0 }, { name: "rangeShift", type: "USHORT", value: 0 }]);
            var o3, i3, a3, s2 = new J.Table("cmap", n4);
            for (s2.segments = [], t4 = 0; t4 < e4.length; t4 += 1) {
              for (var l3 = e4.get(t4), u3 = 0; u3 < l3.unicodes.length; u3 += 1)
                o3 = s2, i3 = l3.unicodes[u3], a3 = t4, o3.segments.push({ end: i3, start: i3, delta: -(i3 - a3), offset: 0, glyphIndex: a3 });
              s2.segments = s2.segments.sort(function(e5, t5) {
                return e5.start - t5.start;
              });
            }
            s2.segments.push({ end: 65535, start: 65535, delta: 1, offset: 0 });
            var c2 = s2.segments.length, d2 = 0, f2 = [], h3 = [], p3 = [], y2 = [], m3 = [], g2 = [];
            for (t4 = 0; t4 < c2; t4 += 1) {
              var v2 = s2.segments[t4];
              v2.end <= 65535 && v2.start <= 65535 ? (f2 = f2.concat({ name: "end_" + t4, type: "USHORT", value: v2.end }), h3 = h3.concat({ name: "start_" + t4, type: "USHORT", value: v2.start }), p3 = p3.concat({ name: "idDelta_" + t4, type: "SHORT", value: v2.delta }), y2 = y2.concat({ name: "idRangeOffset_" + t4, type: "USHORT", value: v2.offset }), v2.glyphId !== void 0 && (m3 = m3.concat({ name: "glyph_" + t4, type: "USHORT", value: v2.glyphId }))) : d2 += 1, r4 || v2.glyphIndex === void 0 || (g2 = (g2 = (g2 = g2.concat({ name: "cmap12Start_" + t4, type: "ULONG", value: v2.start })).concat({ name: "cmap12End_" + t4, type: "ULONG", value: v2.end })).concat({ name: "cmap12Glyph_" + t4, type: "ULONG", value: v2.glyphIndex }));
            }
            if (s2.segCountX2 = 2 * (c2 - d2), s2.searchRange = 2 * Math.pow(2, Math.floor(Math.log(c2 - d2) / Math.log(2))), s2.entrySelector = Math.log(s2.searchRange / 2) / Math.log(2), s2.rangeShift = s2.segCountX2 - s2.searchRange, s2.fields = s2.fields.concat(f2), s2.fields.push({ name: "reservedPad", type: "USHORT", value: 0 }), s2.fields = s2.fields.concat(h3), s2.fields = s2.fields.concat(p3), s2.fields = s2.fields.concat(y2), s2.fields = s2.fields.concat(m3), s2.cmap4Length = 14 + 2 * f2.length + 2 + 2 * h3.length + 2 * p3.length + 2 * y2.length + 2 * m3.length, !r4) {
              var b3 = 16 + 4 * g2.length;
              s2.cmap12Offset = 20 + s2.cmap4Length, s2.fields = s2.fields.concat([{ name: "cmap12Format", type: "USHORT", value: 12 }, { name: "cmap12Reserved", type: "USHORT", value: 0 }, { name: "cmap12Length", type: "ULONG", value: b3 }, { name: "cmap12Language", type: "ULONG", value: 0 }, { name: "cmap12nGroups", type: "ULONG", value: g2.length / 3 }]), s2.fields = s2.fields.concat(g2);
            }
            return s2;
          } }, le = [".notdef", "space", "exclam", "quotedbl", "numbersign", "dollar", "percent", "ampersand", "quoteright", "parenleft", "parenright", "asterisk", "plus", "comma", "hyphen", "period", "slash", "zero", "one", "two", "three", "four", "five", "six", "seven", "eight", "nine", "colon", "semicolon", "less", "equal", "greater", "question", "at", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "bracketleft", "backslash", "bracketright", "asciicircum", "underscore", "quoteleft", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "braceleft", "bar", "braceright", "asciitilde", "exclamdown", "cent", "sterling", "fraction", "yen", "florin", "section", "currency", "quotesingle", "quotedblleft", "guillemotleft", "guilsinglleft", "guilsinglright", "fi", "fl", "endash", "dagger", "daggerdbl", "periodcentered", "paragraph", "bullet", "quotesinglbase", "quotedblbase", "quotedblright", "guillemotright", "ellipsis", "perthousand", "questiondown", "grave", "acute", "circumflex", "tilde", "macron", "breve", "dotaccent", "dieresis", "ring", "cedilla", "hungarumlaut", "ogonek", "caron", "emdash", "AE", "ordfeminine", "Lslash", "Oslash", "OE", "ordmasculine", "ae", "dotlessi", "lslash", "oslash", "oe", "germandbls", "onesuperior", "logicalnot", "mu", "trademark", "Eth", "onehalf", "plusminus", "Thorn", "onequarter", "divide", "brokenbar", "degree", "thorn", "threequarters", "twosuperior", "registered", "minus", "eth", "multiply", "threesuperior", "copyright", "Aacute", "Acircumflex", "Adieresis", "Agrave", "Aring", "Atilde", "Ccedilla", "Eacute", "Ecircumflex", "Edieresis", "Egrave", "Iacute", "Icircumflex", "Idieresis", "Igrave", "Ntilde", "Oacute", "Ocircumflex", "Odieresis", "Ograve", "Otilde", "Scaron", "Uacute", "Ucircumflex", "Udieresis", "Ugrave", "Yacute", "Ydieresis", "Zcaron", "aacute", "acircumflex", "adieresis", "agrave", "aring", "atilde", "ccedilla", "eacute", "ecircumflex", "edieresis", "egrave", "iacute", "icircumflex", "idieresis", "igrave", "ntilde", "oacute", "ocircumflex", "odieresis", "ograve", "otilde", "scaron", "uacute", "ucircumflex", "udieresis", "ugrave", "yacute", "ydieresis", "zcaron", "exclamsmall", "Hungarumlautsmall", "dollaroldstyle", "dollarsuperior", "ampersandsmall", "Acutesmall", "parenleftsuperior", "parenrightsuperior", "266 ff", "onedotenleader", "zerooldstyle", "oneoldstyle", "twooldstyle", "threeoldstyle", "fouroldstyle", "fiveoldstyle", "sixoldstyle", "sevenoldstyle", "eightoldstyle", "nineoldstyle", "commasuperior", "threequartersemdash", "periodsuperior", "questionsmall", "asuperior", "bsuperior", "centsuperior", "dsuperior", "esuperior", "isuperior", "lsuperior", "msuperior", "nsuperior", "osuperior", "rsuperior", "ssuperior", "tsuperior", "ff", "ffi", "ffl", "parenleftinferior", "parenrightinferior", "Circumflexsmall", "hyphensuperior", "Gravesmall", "Asmall", "Bsmall", "Csmall", "Dsmall", "Esmall", "Fsmall", "Gsmall", "Hsmall", "Ismall", "Jsmall", "Ksmall", "Lsmall", "Msmall", "Nsmall", "Osmall", "Psmall", "Qsmall", "Rsmall", "Ssmall", "Tsmall", "Usmall", "Vsmall", "Wsmall", "Xsmall", "Ysmall", "Zsmall", "colonmonetary", "onefitted", "rupiah", "Tildesmall", "exclamdownsmall", "centoldstyle", "Lslashsmall", "Scaronsmall", "Zcaronsmall", "Dieresissmall", "Brevesmall", "Caronsmall", "Dotaccentsmall", "Macronsmall", "figuredash", "hypheninferior", "Ogoneksmall", "Ringsmall", "Cedillasmall", "questiondownsmall", "oneeighth", "threeeighths", "fiveeighths", "seveneighths", "onethird", "twothirds", "zerosuperior", "foursuperior", "fivesuperior", "sixsuperior", "sevensuperior", "eightsuperior", "ninesuperior", "zeroinferior", "oneinferior", "twoinferior", "threeinferior", "fourinferior", "fiveinferior", "sixinferior", "seveninferior", "eightinferior", "nineinferior", "centinferior", "dollarinferior", "periodinferior", "commainferior", "Agravesmall", "Aacutesmall", "Acircumflexsmall", "Atildesmall", "Adieresissmall", "Aringsmall", "AEsmall", "Ccedillasmall", "Egravesmall", "Eacutesmall", "Ecircumflexsmall", "Edieresissmall", "Igravesmall", "Iacutesmall", "Icircumflexsmall", "Idieresissmall", "Ethsmall", "Ntildesmall", "Ogravesmall", "Oacutesmall", "Ocircumflexsmall", "Otildesmall", "Odieresissmall", "OEsmall", "Oslashsmall", "Ugravesmall", "Uacutesmall", "Ucircumflexsmall", "Udieresissmall", "Yacutesmall", "Thornsmall", "Ydieresissmall", "001.000", "001.001", "001.002", "001.003", "Black", "Bold", "Book", "Light", "Medium", "Regular", "Roman", "Semibold"], ue = ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "space", "exclam", "quotedbl", "numbersign", "dollar", "percent", "ampersand", "quoteright", "parenleft", "parenright", "asterisk", "plus", "comma", "hyphen", "period", "slash", "zero", "one", "two", "three", "four", "five", "six", "seven", "eight", "nine", "colon", "semicolon", "less", "equal", "greater", "question", "at", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "bracketleft", "backslash", "bracketright", "asciicircum", "underscore", "quoteleft", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "braceleft", "bar", "braceright", "asciitilde", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "exclamdown", "cent", "sterling", "fraction", "yen", "florin", "section", "currency", "quotesingle", "quotedblleft", "guillemotleft", "guilsinglleft", "guilsinglright", "fi", "fl", "", "endash", "dagger", "daggerdbl", "periodcentered", "", "paragraph", "bullet", "quotesinglbase", "quotedblbase", "quotedblright", "guillemotright", "ellipsis", "perthousand", "", "questiondown", "", "grave", "acute", "circumflex", "tilde", "macron", "breve", "dotaccent", "dieresis", "", "ring", "cedilla", "", "hungarumlaut", "ogonek", "caron", "emdash", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "AE", "", "ordfeminine", "", "", "", "", "Lslash", "Oslash", "OE", "ordmasculine", "", "", "", "", "", "ae", "", "", "", "dotlessi", "", "", "lslash", "oslash", "oe", "germandbls"], ce = ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "space", "exclamsmall", "Hungarumlautsmall", "", "dollaroldstyle", "dollarsuperior", "ampersandsmall", "Acutesmall", "parenleftsuperior", "parenrightsuperior", "twodotenleader", "onedotenleader", "comma", "hyphen", "period", "fraction", "zerooldstyle", "oneoldstyle", "twooldstyle", "threeoldstyle", "fouroldstyle", "fiveoldstyle", "sixoldstyle", "sevenoldstyle", "eightoldstyle", "nineoldstyle", "colon", "semicolon", "commasuperior", "threequartersemdash", "periodsuperior", "questionsmall", "", "asuperior", "bsuperior", "centsuperior", "dsuperior", "esuperior", "", "", "isuperior", "", "", "lsuperior", "msuperior", "nsuperior", "osuperior", "", "", "rsuperior", "ssuperior", "tsuperior", "", "ff", "fi", "fl", "ffi", "ffl", "parenleftinferior", "", "parenrightinferior", "Circumflexsmall", "hyphensuperior", "Gravesmall", "Asmall", "Bsmall", "Csmall", "Dsmall", "Esmall", "Fsmall", "Gsmall", "Hsmall", "Ismall", "Jsmall", "Ksmall", "Lsmall", "Msmall", "Nsmall", "Osmall", "Psmall", "Qsmall", "Rsmall", "Ssmall", "Tsmall", "Usmall", "Vsmall", "Wsmall", "Xsmall", "Ysmall", "Zsmall", "colonmonetary", "onefitted", "rupiah", "Tildesmall", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "exclamdownsmall", "centoldstyle", "Lslashsmall", "", "", "Scaronsmall", "Zcaronsmall", "Dieresissmall", "Brevesmall", "Caronsmall", "", "Dotaccentsmall", "", "", "Macronsmall", "", "", "figuredash", "hypheninferior", "", "", "Ogoneksmall", "Ringsmall", "Cedillasmall", "", "", "", "onequarter", "onehalf", "threequarters", "questiondownsmall", "oneeighth", "threeeighths", "fiveeighths", "seveneighths", "onethird", "twothirds", "", "", "zerosuperior", "onesuperior", "twosuperior", "threesuperior", "foursuperior", "fivesuperior", "sixsuperior", "sevensuperior", "eightsuperior", "ninesuperior", "zeroinferior", "oneinferior", "twoinferior", "threeinferior", "fourinferior", "fiveinferior", "sixinferior", "seveninferior", "eightinferior", "nineinferior", "centinferior", "dollarinferior", "periodinferior", "commainferior", "Agravesmall", "Aacutesmall", "Acircumflexsmall", "Atildesmall", "Adieresissmall", "Aringsmall", "AEsmall", "Ccedillasmall", "Egravesmall", "Eacutesmall", "Ecircumflexsmall", "Edieresissmall", "Igravesmall", "Iacutesmall", "Icircumflexsmall", "Idieresissmall", "Ethsmall", "Ntildesmall", "Ogravesmall", "Oacutesmall", "Ocircumflexsmall", "Otildesmall", "Odieresissmall", "OEsmall", "Oslashsmall", "Ugravesmall", "Uacutesmall", "Ucircumflexsmall", "Udieresissmall", "Yacutesmall", "Thornsmall", "Ydieresissmall"], de = [".notdef", ".null", "nonmarkingreturn", "space", "exclam", "quotedbl", "numbersign", "dollar", "percent", "ampersand", "quotesingle", "parenleft", "parenright", "asterisk", "plus", "comma", "hyphen", "period", "slash", "zero", "one", "two", "three", "four", "five", "six", "seven", "eight", "nine", "colon", "semicolon", "less", "equal", "greater", "question", "at", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "bracketleft", "backslash", "bracketright", "asciicircum", "underscore", "grave", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "braceleft", "bar", "braceright", "asciitilde", "Adieresis", "Aring", "Ccedilla", "Eacute", "Ntilde", "Odieresis", "Udieresis", "aacute", "agrave", "acircumflex", "adieresis", "atilde", "aring", "ccedilla", "eacute", "egrave", "ecircumflex", "edieresis", "iacute", "igrave", "icircumflex", "idieresis", "ntilde", "oacute", "ograve", "ocircumflex", "odieresis", "otilde", "uacute", "ugrave", "ucircumflex", "udieresis", "dagger", "degree", "cent", "sterling", "section", "bullet", "paragraph", "germandbls", "registered", "copyright", "trademark", "acute", "dieresis", "notequal", "AE", "Oslash", "infinity", "plusminus", "lessequal", "greaterequal", "yen", "mu", "partialdiff", "summation", "product", "pi", "integral", "ordfeminine", "ordmasculine", "Omega", "ae", "oslash", "questiondown", "exclamdown", "logicalnot", "radical", "florin", "approxequal", "Delta", "guillemotleft", "guillemotright", "ellipsis", "nonbreakingspace", "Agrave", "Atilde", "Otilde", "OE", "oe", "endash", "emdash", "quotedblleft", "quotedblright", "quoteleft", "quoteright", "divide", "lozenge", "ydieresis", "Ydieresis", "fraction", "currency", "guilsinglleft", "guilsinglright", "fi", "fl", "daggerdbl", "periodcentered", "quotesinglbase", "quotedblbase", "perthousand", "Acircumflex", "Ecircumflex", "Aacute", "Edieresis", "Egrave", "Iacute", "Icircumflex", "Idieresis", "Igrave", "Oacute", "Ocircumflex", "apple", "Ograve", "Uacute", "Ucircumflex", "Ugrave", "dotlessi", "circumflex", "tilde", "macron", "breve", "dotaccent", "ring", "cedilla", "hungarumlaut", "ogonek", "caron", "Lslash", "lslash", "Scaron", "scaron", "Zcaron", "zcaron", "brokenbar", "Eth", "eth", "Yacute", "yacute", "Thorn", "thorn", "minus", "multiply", "onesuperior", "twosuperior", "threesuperior", "onehalf", "onequarter", "threequarters", "franc", "Gbreve", "gbreve", "Idotaccent", "Scedilla", "scedilla", "Cacute", "cacute", "Ccaron", "ccaron", "dcroat"];
          function fe(e4) {
            this.font = e4;
          }
          function he(e4) {
            this.cmap = e4;
          }
          function pe(e4, t4) {
            this.encoding = e4, this.charset = t4;
          }
          function ye(e4) {
            switch (e4.version) {
              case 1:
                this.names = de.slice();
                break;
              case 2:
                this.names = new Array(e4.numberOfGlyphs);
                for (var t4 = 0; t4 < e4.numberOfGlyphs; t4++)
                  e4.glyphNameIndex[t4] < de.length ? this.names[t4] = de[e4.glyphNameIndex[t4]] : this.names[t4] = e4.names[e4.glyphNameIndex[t4] - de.length];
                break;
              case 2.5:
                this.names = new Array(e4.numberOfGlyphs);
                for (var r4 = 0; r4 < e4.numberOfGlyphs; r4++)
                  this.names[r4] = de[r4 + e4.glyphNameIndex[r4]];
                break;
              case 3:
              default:
                this.names = [];
            }
          }
          fe.prototype.charToGlyphIndex = function(e4) {
            var t4 = e4.codePointAt(0), r4 = this.font.glyphs;
            if (r4) {
              for (var n4 = 0; n4 < r4.length; n4 += 1)
                for (var o3 = r4.get(n4), i3 = 0; i3 < o3.unicodes.length; i3 += 1)
                  if (o3.unicodes[i3] === t4)
                    return n4;
            }
            return null;
          }, he.prototype.charToGlyphIndex = function(e4) {
            return this.cmap.glyphIndexMap[e4.codePointAt(0)] || 0;
          }, pe.prototype.charToGlyphIndex = function(e4) {
            var t4 = e4.codePointAt(0), r4 = this.encoding[t4];
            return this.charset.indexOf(r4);
          }, ye.prototype.nameToGlyphIndex = function(e4) {
            return this.names.indexOf(e4);
          }, ye.prototype.glyphIndexToName = function(e4) {
            return this.names[e4];
          };
          var me = { line: function(e4, t4, r4, n4, o3) {
            e4.beginPath(), e4.moveTo(t4, r4), e4.lineTo(n4, o3), e4.stroke();
          } };
          function ge(e4) {
            this.bindConstructorValues(e4);
          }
          function ve(t4, e4, r4) {
            Object.defineProperty(t4, e4, { get: function() {
              return t4.path, t4[r4];
            }, set: function(e5) {
              t4[r4] = e5;
            }, enumerable: true, configurable: true });
          }
          function be(e4, t4) {
            if (this.font = e4, this.glyphs = {}, Array.isArray(t4))
              for (var r4 = 0; r4 < t4.length; r4++)
                this.glyphs[r4] = t4[r4];
            this.length = t4 && t4.length || 0;
          }
          ge.prototype.bindConstructorValues = function(e4) {
            var t4, r4;
            this.index = e4.index || 0, this.name = e4.name || null, this.unicode = e4.unicode || void 0, this.unicodes = e4.unicodes || e4.unicode !== void 0 ? [e4.unicode] : [], e4.xMin && (this.xMin = e4.xMin), e4.yMin && (this.yMin = e4.yMin), e4.xMax && (this.xMax = e4.xMax), e4.yMax && (this.yMax = e4.yMax), e4.advanceWidth && (this.advanceWidth = e4.advanceWidth), Object.defineProperty(this, "path", (t4 = e4.path, r4 = t4 || new D(), { configurable: true, get: function() {
              return typeof r4 == "function" && (r4 = r4()), r4;
            }, set: function(e5) {
              r4 = e5;
            } }));
          }, ge.prototype.addUnicode = function(e4) {
            this.unicodes.length === 0 && (this.unicode = e4), this.unicodes.push(e4);
          }, ge.prototype.getBoundingBox = function() {
            return this.path.getBoundingBox();
          }, ge.prototype.getPath = function(e4, t4, r4, n4, o3) {
            var i3, a3;
            e4 = e4 !== void 0 ? e4 : 0, t4 = t4 !== void 0 ? t4 : 0, r4 = r4 !== void 0 ? r4 : 72;
            var s2 = (n4 = n4 || {}).xScale, l3 = n4.yScale;
            if (n4.hinting && o3 && o3.hinting && (a3 = this.path && o3.hinting.exec(this, r4)), a3)
              i3 = o3.hinting.getCommands(a3), e4 = Math.round(e4), t4 = Math.round(t4), s2 = l3 = 1;
            else {
              i3 = this.path.commands;
              var u3 = 1 / this.path.unitsPerEm * r4;
              s2 === void 0 && (s2 = u3), l3 === void 0 && (l3 = u3);
            }
            for (var c2 = new D(), d2 = 0; d2 < i3.length; d2 += 1) {
              var f2 = i3[d2];
              f2.type === "M" ? c2.moveTo(e4 + f2.x * s2, t4 + -f2.y * l3) : f2.type === "L" ? c2.lineTo(e4 + f2.x * s2, t4 + -f2.y * l3) : f2.type === "Q" ? c2.quadraticCurveTo(e4 + f2.x1 * s2, t4 + -f2.y1 * l3, e4 + f2.x * s2, t4 + -f2.y * l3) : f2.type === "C" ? c2.curveTo(e4 + f2.x1 * s2, t4 + -f2.y1 * l3, e4 + f2.x2 * s2, t4 + -f2.y2 * l3, e4 + f2.x * s2, t4 + -f2.y * l3) : f2.type === "Z" && c2.closePath();
            }
            return c2;
          }, ge.prototype.getContours = function() {
            if (this.points === void 0)
              return [];
            for (var e4 = [], t4 = [], r4 = 0; r4 < this.points.length; r4 += 1) {
              var n4 = this.points[r4];
              t4.push(n4), n4.lastPointOfContour && (e4.push(t4), t4 = []);
            }
            return L.argument(t4.length === 0, "There are still points left in the current contour."), e4;
          }, ge.prototype.getMetrics = function() {
            for (var e4 = this.path.commands, t4 = [], r4 = [], n4 = 0; n4 < e4.length; n4 += 1) {
              var o3 = e4[n4];
              o3.type !== "Z" && (t4.push(o3.x), r4.push(o3.y)), o3.type !== "Q" && o3.type !== "C" || (t4.push(o3.x1), r4.push(o3.y1)), o3.type === "C" && (t4.push(o3.x2), r4.push(o3.y2));
            }
            var i3 = { xMin: Math.min.apply(null, t4), yMin: Math.min.apply(null, r4), xMax: Math.max.apply(null, t4), yMax: Math.max.apply(null, r4), leftSideBearing: this.leftSideBearing };
            return isFinite(i3.xMin) || (i3.xMin = 0), isFinite(i3.xMax) || (i3.xMax = this.advanceWidth), isFinite(i3.yMin) || (i3.yMin = 0), isFinite(i3.yMax) || (i3.yMax = 0), i3.rightSideBearing = this.advanceWidth - i3.leftSideBearing - (i3.xMax - i3.xMin), i3;
          }, ge.prototype.draw = function(e4, t4, r4, n4, o3) {
            this.getPath(t4, r4, n4, o3).draw(e4);
          }, ge.prototype.drawPoints = function(a3, e4, t4, r4) {
            function n4(e5, t5, r5, n5) {
              var o4 = 2 * Math.PI;
              a3.beginPath();
              for (var i4 = 0; i4 < e5.length; i4 += 1)
                a3.moveTo(t5 + e5[i4].x * n5, r5 + e5[i4].y * n5), a3.arc(t5 + e5[i4].x * n5, r5 + e5[i4].y * n5, 2, 0, o4, false);
              a3.closePath(), a3.fill();
            }
            e4 = e4 !== void 0 ? e4 : 0, t4 = t4 !== void 0 ? t4 : 0, r4 = r4 !== void 0 ? r4 : 24;
            for (var o3 = 1 / this.path.unitsPerEm * r4, i3 = [], s2 = [], l3 = this.path, u3 = 0; u3 < l3.commands.length; u3 += 1) {
              var c2 = l3.commands[u3];
              c2.x !== void 0 && i3.push({ x: c2.x, y: -c2.y }), c2.x1 !== void 0 && s2.push({ x: c2.x1, y: -c2.y1 }), c2.x2 !== void 0 && s2.push({ x: c2.x2, y: -c2.y2 });
            }
            a3.fillStyle = "blue", n4(i3, e4, t4, o3), a3.fillStyle = "red", n4(s2, e4, t4, o3);
          }, ge.prototype.drawMetrics = function(e4, t4, r4, n4) {
            var o3;
            t4 = t4 !== void 0 ? t4 : 0, r4 = r4 !== void 0 ? r4 : 0, n4 = n4 !== void 0 ? n4 : 24, o3 = 1 / this.path.unitsPerEm * n4, e4.lineWidth = 1, e4.strokeStyle = "black", me.line(e4, t4, -1e4, t4, 1e4), me.line(e4, -1e4, r4, 1e4, r4);
            var i3 = this.xMin || 0, a3 = this.yMin || 0, s2 = this.xMax || 0, l3 = this.yMax || 0, u3 = this.advanceWidth || 0;
            e4.strokeStyle = "blue", me.line(e4, t4 + i3 * o3, -1e4, t4 + i3 * o3, 1e4), me.line(e4, t4 + s2 * o3, -1e4, t4 + s2 * o3, 1e4), me.line(e4, -1e4, r4 + -a3 * o3, 1e4, r4 + -a3 * o3), me.line(e4, -1e4, r4 + -l3 * o3, 1e4, r4 + -l3 * o3), e4.strokeStyle = "green", me.line(e4, t4 + u3 * o3, -1e4, t4 + u3 * o3, 1e4);
          }, be.prototype.get = function(e4) {
            return typeof this.glyphs[e4] == "function" && (this.glyphs[e4] = this.glyphs[e4]()), this.glyphs[e4];
          }, be.prototype.push = function(e4, t4) {
            this.glyphs[e4] = t4, this.length++;
          };
          var _e = { GlyphSet: be, glyphLoader: function(e4, t4) {
            return new ge({ index: t4, font: e4 });
          }, ttfGlyphLoader: function(r4, e4, n4, o3, i3, a3) {
            return function() {
              var t4 = new ge({ index: e4, font: r4 });
              return t4.path = function() {
                n4(t4, o3, i3);
                var e5 = a3(r4.glyphs, t4);
                return e5.unitsPerEm = r4.unitsPerEm, e5;
              }, ve(t4, "xMin", "_xMin"), ve(t4, "xMax", "_xMax"), ve(t4, "yMin", "_yMin"), ve(t4, "yMax", "_yMax"), t4;
            };
          }, cffGlyphLoader: function(r4, e4, n4, o3) {
            return function() {
              var t4 = new ge({ index: e4, font: r4 });
              return t4.path = function() {
                var e5 = n4(r4, t4, o3);
                return e5.unitsPerEm = r4.unitsPerEm, e5;
              }, t4;
            };
          } };
          function xe(e4, t4) {
            if (e4 === t4)
              return true;
            if (Array.isArray(e4) && Array.isArray(t4)) {
              if (e4.length !== t4.length)
                return false;
              for (var r4 = 0; r4 < e4.length; r4 += 1)
                if (!xe(e4[r4], t4[r4]))
                  return false;
              return true;
            }
            return false;
          }
          function we(e4) {
            return e4.length < 1240 ? 107 : e4.length < 33900 ? 1131 : 32768;
          }
          function je(e4, t4, r4) {
            var n4, o3, i3 = [], a3 = [], s2 = ae.getCard16(e4, t4);
            if (s2 !== 0) {
              var l3 = ae.getByte(e4, t4 + 2);
              n4 = t4 + (s2 + 1) * l3 + 2;
              for (var u3 = t4 + 3, c2 = 0; c2 < s2 + 1; c2 += 1)
                i3.push(ae.getOffset(e4, u3, l3)), u3 += l3;
              o3 = n4 + i3[s2];
            } else
              o3 = t4 + 2;
            for (var d2 = 0; d2 < i3.length - 1; d2 += 1) {
              var f2 = ae.getBytes(e4, n4 + i3[d2], n4 + i3[d2 + 1]);
              r4 && (f2 = r4(f2)), a3.push(f2);
            }
            return { objects: a3, startOffset: t4, endOffset: o3 };
          }
          function Se(e4, t4) {
            if (t4 === 28)
              return e4.parseByte() << 8 | e4.parseByte();
            if (t4 === 29)
              return e4.parseByte() << 24 | e4.parseByte() << 16 | e4.parseByte() << 8 | e4.parseByte();
            if (t4 === 30)
              return function(e5) {
                for (var t5 = "", r4 = ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9", ".", "E", "E-", null, "-"]; ; ) {
                  var n4 = e5.parseByte(), o3 = n4 >> 4, i3 = 15 & n4;
                  if (o3 == 15)
                    break;
                  if (t5 += r4[o3], i3 == 15)
                    break;
                  t5 += r4[i3];
                }
                return parseFloat(t5);
              }(e4);
            if (32 <= t4 && t4 <= 246)
              return t4 - 139;
            if (247 <= t4 && t4 <= 250)
              return 256 * (t4 - 247) + e4.parseByte() + 108;
            if (251 <= t4 && t4 <= 254)
              return 256 * -(t4 - 251) - e4.parseByte() - 108;
            throw new Error("Invalid b0 " + t4);
          }
          function Me(e4, t4, r4) {
            t4 = t4 !== void 0 ? t4 : 0;
            var n4 = new ae.Parser(e4, t4), o3 = [], i3 = [];
            for (r4 = r4 !== void 0 ? r4 : e4.length; n4.relativeOffset < r4; ) {
              var a3 = n4.parseByte();
              a3 <= 21 ? (a3 === 12 && (a3 = 1200 + n4.parseByte()), o3.push([a3, i3]), i3 = []) : i3.push(Se(n4, a3));
            }
            return function(e5) {
              for (var t5 = {}, r5 = 0; r5 < e5.length; r5 += 1) {
                var n5 = e5[r5][0], o4 = e5[r5][1], i4 = void 0;
                if (i4 = o4.length === 1 ? o4[0] : o4, t5.hasOwnProperty(n5) && !isNaN(t5[n5]))
                  throw new Error("Object " + t5 + " already has key " + n5);
                t5[n5] = i4;
              }
              return t5;
            }(o3);
          }
          function Ee(e4, t4) {
            return t4 = t4 <= 390 ? le[t4] : e4[t4 - 391];
          }
          function Te(e4, t4, r4) {
            for (var n4, o3 = {}, i3 = 0; i3 < t4.length; i3 += 1) {
              var a3 = t4[i3];
              if (Array.isArray(a3.type)) {
                var s2 = [];
                s2.length = a3.type.length;
                for (var l3 = 0; l3 < a3.type.length; l3++)
                  (n4 = e4[a3.op] !== void 0 ? e4[a3.op][l3] : void 0) === void 0 && (n4 = a3.value !== void 0 && a3.value[l3] !== void 0 ? a3.value[l3] : null), a3.type[l3] === "SID" && (n4 = Ee(r4, n4)), s2[l3] = n4;
                o3[a3.name] = s2;
              } else
                (n4 = e4[a3.op]) === void 0 && (n4 = a3.value !== void 0 ? a3.value : null), a3.type === "SID" && (n4 = Ee(r4, n4)), o3[a3.name] = n4;
            }
            return o3;
          }
          var Oe = [{ name: "version", op: 0, type: "SID" }, { name: "notice", op: 1, type: "SID" }, { name: "copyright", op: 1200, type: "SID" }, { name: "fullName", op: 2, type: "SID" }, { name: "familyName", op: 3, type: "SID" }, { name: "weight", op: 4, type: "SID" }, { name: "isFixedPitch", op: 1201, type: "number", value: 0 }, { name: "italicAngle", op: 1202, type: "number", value: 0 }, { name: "underlinePosition", op: 1203, type: "number", value: -100 }, { name: "underlineThickness", op: 1204, type: "number", value: 50 }, { name: "paintType", op: 1205, type: "number", value: 0 }, { name: "charstringType", op: 1206, type: "number", value: 2 }, { name: "fontMatrix", op: 1207, type: ["real", "real", "real", "real", "real", "real"], value: [1e-3, 0, 0, 1e-3, 0, 0] }, { name: "uniqueId", op: 13, type: "number" }, { name: "fontBBox", op: 5, type: ["number", "number", "number", "number"], value: [0, 0, 0, 0] }, { name: "strokeWidth", op: 1208, type: "number", value: 0 }, { name: "xuid", op: 14, type: [], value: null }, { name: "charset", op: 15, type: "offset", value: 0 }, { name: "encoding", op: 16, type: "offset", value: 0 }, { name: "charStrings", op: 17, type: "offset", value: 0 }, { name: "private", op: 18, type: ["number", "offset"], value: [0, 0] }, { name: "ros", op: 1230, type: ["SID", "SID", "number"] }, { name: "cidFontVersion", op: 1231, type: "number", value: 0 }, { name: "cidFontRevision", op: 1232, type: "number", value: 0 }, { name: "cidFontType", op: 1233, type: "number", value: 0 }, { name: "cidCount", op: 1234, type: "number", value: 8720 }, { name: "uidBase", op: 1235, type: "number" }, { name: "fdArray", op: 1236, type: "offset" }, { name: "fdSelect", op: 1237, type: "offset" }, { name: "fontName", op: 1238, type: "SID" }], Ce = [{ name: "subrs", op: 19, type: "offset", value: 0 }, { name: "defaultWidthX", op: 20, type: "number", value: 0 }, { name: "nominalWidthX", op: 21, type: "number", value: 0 }];
          function Le(e4, t4, r4, n4) {
            return Te(Me(e4, t4, r4), Ce, n4);
          }
          function Pe(e4, t4, r4, n4) {
            for (var o3, i3, a3 = [], s2 = 0; s2 < r4.length; s2 += 1) {
              var l3 = new DataView(new Uint8Array(r4[s2]).buffer), u3 = (i3 = n4, Te(Me(o3 = l3, 0, o3.byteLength), Oe, i3));
              u3._subrs = [], u3._subrsBias = 0;
              var c2 = u3.private[0], d2 = u3.private[1];
              if (c2 !== 0 && d2 !== 0) {
                var f2 = Le(e4, d2 + t4, c2, n4);
                if (u3._defaultWidthX = f2.defaultWidthX, u3._nominalWidthX = f2.nominalWidthX, f2.subrs !== 0) {
                  var h3 = je(e4, d2 + f2.subrs + t4);
                  u3._subrs = h3.objects, u3._subrsBias = we(u3._subrs);
                }
                u3._privateDict = f2;
              }
              a3.push(u3);
            }
            return a3;
          }
          function Ae(m3, g2, e4) {
            var v2, b3, _2, x2, w2, j2, t4, S3, M2 = new D(), E2 = [], T3 = 0, O3 = false, C2 = false, L2 = 0, P3 = 0;
            if (m3.isCIDFont) {
              var r4 = m3.tables.cff.topDict._fdSelect[g2.index], n4 = m3.tables.cff.topDict._fdArray[r4];
              w2 = n4._subrs, j2 = n4._subrsBias, t4 = n4._defaultWidthX, S3 = n4._nominalWidthX;
            } else
              w2 = m3.tables.cff.topDict._subrs, j2 = m3.tables.cff.topDict._subrsBias, t4 = m3.tables.cff.topDict._defaultWidthX, S3 = m3.tables.cff.topDict._nominalWidthX;
            var A2 = t4;
            function k3(e5, t5) {
              C2 && M2.closePath(), M2.moveTo(e5, t5), C2 = true;
            }
            function R3() {
              E2.length % 2 == 0 || O3 || (A2 = E2.shift() + S3), T3 += E2.length >> 1, E2.length = 0, O3 = true;
            }
            return function e5(t5) {
              for (var r5, n5, o3, i3, a3, s2, l3, u3, c2, d2, f2, h3, p3 = 0; p3 < t5.length; ) {
                var y2 = t5[p3];
                switch (p3 += 1, y2) {
                  case 1:
                  case 3:
                    R3();
                    break;
                  case 4:
                    1 < E2.length && !O3 && (A2 = E2.shift() + S3, O3 = true), P3 += E2.pop(), k3(L2, P3);
                    break;
                  case 5:
                    for (; 0 < E2.length; )
                      L2 += E2.shift(), P3 += E2.shift(), M2.lineTo(L2, P3);
                    break;
                  case 6:
                    for (; 0 < E2.length && (L2 += E2.shift(), M2.lineTo(L2, P3), E2.length !== 0); )
                      P3 += E2.shift(), M2.lineTo(L2, P3);
                    break;
                  case 7:
                    for (; 0 < E2.length && (P3 += E2.shift(), M2.lineTo(L2, P3), E2.length !== 0); )
                      L2 += E2.shift(), M2.lineTo(L2, P3);
                    break;
                  case 8:
                    for (; 0 < E2.length; )
                      v2 = L2 + E2.shift(), b3 = P3 + E2.shift(), _2 = v2 + E2.shift(), x2 = b3 + E2.shift(), L2 = _2 + E2.shift(), P3 = x2 + E2.shift(), M2.curveTo(v2, b3, _2, x2, L2, P3);
                    break;
                  case 10:
                    a3 = E2.pop() + j2, (s2 = w2[a3]) && e5(s2);
                    break;
                  case 11:
                    return;
                  case 12:
                    switch (y2 = t5[p3], p3 += 1, y2) {
                      case 35:
                        v2 = L2 + E2.shift(), b3 = P3 + E2.shift(), _2 = v2 + E2.shift(), x2 = b3 + E2.shift(), l3 = _2 + E2.shift(), u3 = x2 + E2.shift(), c2 = l3 + E2.shift(), d2 = u3 + E2.shift(), f2 = c2 + E2.shift(), h3 = d2 + E2.shift(), L2 = f2 + E2.shift(), P3 = h3 + E2.shift(), E2.shift(), M2.curveTo(v2, b3, _2, x2, l3, u3), M2.curveTo(c2, d2, f2, h3, L2, P3);
                        break;
                      case 34:
                        v2 = L2 + E2.shift(), b3 = P3, _2 = v2 + E2.shift(), x2 = b3 + E2.shift(), l3 = _2 + E2.shift(), u3 = x2, c2 = l3 + E2.shift(), d2 = x2, f2 = c2 + E2.shift(), h3 = P3, L2 = f2 + E2.shift(), M2.curveTo(v2, b3, _2, x2, l3, u3), M2.curveTo(c2, d2, f2, h3, L2, P3);
                        break;
                      case 36:
                        v2 = L2 + E2.shift(), b3 = P3 + E2.shift(), _2 = v2 + E2.shift(), x2 = b3 + E2.shift(), l3 = _2 + E2.shift(), u3 = x2, c2 = l3 + E2.shift(), d2 = x2, f2 = c2 + E2.shift(), h3 = d2 + E2.shift(), L2 = f2 + E2.shift(), M2.curveTo(v2, b3, _2, x2, l3, u3), M2.curveTo(c2, d2, f2, h3, L2, P3);
                        break;
                      case 37:
                        v2 = L2 + E2.shift(), b3 = P3 + E2.shift(), _2 = v2 + E2.shift(), x2 = b3 + E2.shift(), l3 = _2 + E2.shift(), u3 = x2 + E2.shift(), c2 = l3 + E2.shift(), d2 = u3 + E2.shift(), f2 = c2 + E2.shift(), h3 = d2 + E2.shift(), Math.abs(f2 - L2) > Math.abs(h3 - P3) ? L2 = f2 + E2.shift() : P3 = h3 + E2.shift(), M2.curveTo(v2, b3, _2, x2, l3, u3), M2.curveTo(c2, d2, f2, h3, L2, P3);
                        break;
                      default:
                        console.log("Glyph " + g2.index + ": unknown operator 1200" + y2), E2.length = 0;
                    }
                    break;
                  case 14:
                    0 < E2.length && !O3 && (A2 = E2.shift() + S3, O3 = true), C2 && (M2.closePath(), C2 = false);
                    break;
                  case 18:
                    R3();
                    break;
                  case 19:
                  case 20:
                    R3(), p3 += T3 + 7 >> 3;
                    break;
                  case 21:
                    2 < E2.length && !O3 && (A2 = E2.shift() + S3, O3 = true), P3 += E2.pop(), k3(L2 += E2.pop(), P3);
                    break;
                  case 22:
                    1 < E2.length && !O3 && (A2 = E2.shift() + S3, O3 = true), k3(L2 += E2.pop(), P3);
                    break;
                  case 23:
                    R3();
                    break;
                  case 24:
                    for (; 2 < E2.length; )
                      v2 = L2 + E2.shift(), b3 = P3 + E2.shift(), _2 = v2 + E2.shift(), x2 = b3 + E2.shift(), L2 = _2 + E2.shift(), P3 = x2 + E2.shift(), M2.curveTo(v2, b3, _2, x2, L2, P3);
                    L2 += E2.shift(), P3 += E2.shift(), M2.lineTo(L2, P3);
                    break;
                  case 25:
                    for (; 6 < E2.length; )
                      L2 += E2.shift(), P3 += E2.shift(), M2.lineTo(L2, P3);
                    v2 = L2 + E2.shift(), b3 = P3 + E2.shift(), _2 = v2 + E2.shift(), x2 = b3 + E2.shift(), L2 = _2 + E2.shift(), P3 = x2 + E2.shift(), M2.curveTo(v2, b3, _2, x2, L2, P3);
                    break;
                  case 26:
                    for (E2.length % 2 && (L2 += E2.shift()); 0 < E2.length; )
                      v2 = L2, b3 = P3 + E2.shift(), _2 = v2 + E2.shift(), x2 = b3 + E2.shift(), L2 = _2, P3 = x2 + E2.shift(), M2.curveTo(v2, b3, _2, x2, L2, P3);
                    break;
                  case 27:
                    for (E2.length % 2 && (P3 += E2.shift()); 0 < E2.length; )
                      v2 = L2 + E2.shift(), b3 = P3, _2 = v2 + E2.shift(), x2 = b3 + E2.shift(), L2 = _2 + E2.shift(), P3 = x2, M2.curveTo(v2, b3, _2, x2, L2, P3);
                    break;
                  case 28:
                    r5 = t5[p3], n5 = t5[p3 + 1], E2.push((r5 << 24 | n5 << 16) >> 16), p3 += 2;
                    break;
                  case 29:
                    a3 = E2.pop() + m3.gsubrsBias, (s2 = m3.gsubrs[a3]) && e5(s2);
                    break;
                  case 30:
                    for (; 0 < E2.length && (v2 = L2, b3 = P3 + E2.shift(), _2 = v2 + E2.shift(), x2 = b3 + E2.shift(), L2 = _2 + E2.shift(), P3 = x2 + (E2.length === 1 ? E2.shift() : 0), M2.curveTo(v2, b3, _2, x2, L2, P3), E2.length !== 0); )
                      v2 = L2 + E2.shift(), b3 = P3, _2 = v2 + E2.shift(), x2 = b3 + E2.shift(), P3 = x2 + E2.shift(), L2 = _2 + (E2.length === 1 ? E2.shift() : 0), M2.curveTo(v2, b3, _2, x2, L2, P3);
                    break;
                  case 31:
                    for (; 0 < E2.length && (v2 = L2 + E2.shift(), b3 = P3, _2 = v2 + E2.shift(), x2 = b3 + E2.shift(), P3 = x2 + E2.shift(), L2 = _2 + (E2.length === 1 ? E2.shift() : 0), M2.curveTo(v2, b3, _2, x2, L2, P3), E2.length !== 0); )
                      v2 = L2, b3 = P3 + E2.shift(), _2 = v2 + E2.shift(), x2 = b3 + E2.shift(), L2 = _2 + E2.shift(), P3 = x2 + (E2.length === 1 ? E2.shift() : 0), M2.curveTo(v2, b3, _2, x2, L2, P3);
                    break;
                  default:
                    y2 < 32 ? console.log("Glyph " + g2.index + ": unknown operator " + y2) : y2 < 247 ? E2.push(y2 - 139) : y2 < 251 ? (r5 = t5[p3], p3 += 1, E2.push(256 * (y2 - 247) + r5 + 108)) : y2 < 255 ? (r5 = t5[p3], p3 += 1, E2.push(256 * -(y2 - 251) - r5 - 108)) : (r5 = t5[p3], n5 = t5[p3 + 1], o3 = t5[p3 + 2], i3 = t5[p3 + 3], p3 += 4, E2.push((r5 << 24 | n5 << 16 | o3 << 8 | i3) / 65536));
                }
              }
            }(e4), g2.advanceWidth = A2, M2;
          }
          function ke(e4, t4) {
            var r4, n4 = le.indexOf(e4);
            return 0 <= n4 && (r4 = n4), 0 <= (n4 = t4.indexOf(e4)) ? r4 = n4 + le.length : (r4 = le.length + t4.length, t4.push(e4)), r4;
          }
          function Re(e4, t4, r4) {
            for (var n4 = {}, o3 = 0; o3 < e4.length; o3 += 1) {
              var i3 = e4[o3], a3 = t4[i3.name];
              a3 === void 0 || xe(a3, i3.value) || (i3.type === "SID" && (a3 = ke(a3, r4)), n4[i3.op] = { name: i3.name, type: i3.type, value: a3 });
            }
            return n4;
          }
          function De(e4, t4) {
            var r4 = new J.Record("Top DICT", [{ name: "dict", type: "DICT", value: {} }]);
            return r4.dict = Re(Oe, e4, t4), r4;
          }
          function Ie(e4) {
            var t4 = new J.Record("Top DICT INDEX", [{ name: "topDicts", type: "INDEX", value: [] }]);
            return t4.topDicts = [{ name: "topDict_0", type: "TABLE", value: e4 }], t4;
          }
          function Ue(e4) {
            var t4 = [], r4 = e4.path;
            t4.push({ name: "width", type: "NUMBER", value: e4.advanceWidth });
            for (var n4 = 0, o3 = 0, i3 = 0; i3 < r4.commands.length; i3 += 1) {
              var a3 = void 0, s2 = void 0, l3 = r4.commands[i3];
              if (l3.type === "Q") {
                l3 = { type: "C", x: l3.x, y: l3.y, x1: 1 / 3 * n4 + 2 / 3 * l3.x1, y1: 1 / 3 * o3 + 2 / 3 * l3.y1, x2: 1 / 3 * l3.x + 2 / 3 * l3.x1, y2: 1 / 3 * l3.y + 2 / 3 * l3.y1 };
              }
              if (l3.type === "M")
                a3 = Math.round(l3.x - n4), s2 = Math.round(l3.y - o3), t4.push({ name: "dx", type: "NUMBER", value: a3 }), t4.push({ name: "dy", type: "NUMBER", value: s2 }), t4.push({ name: "rmoveto", type: "OP", value: 21 }), n4 = Math.round(l3.x), o3 = Math.round(l3.y);
              else if (l3.type === "L")
                a3 = Math.round(l3.x - n4), s2 = Math.round(l3.y - o3), t4.push({ name: "dx", type: "NUMBER", value: a3 }), t4.push({ name: "dy", type: "NUMBER", value: s2 }), t4.push({ name: "rlineto", type: "OP", value: 5 }), n4 = Math.round(l3.x), o3 = Math.round(l3.y);
              else if (l3.type === "C") {
                var u3 = Math.round(l3.x1 - n4), c2 = Math.round(l3.y1 - o3), d2 = Math.round(l3.x2 - l3.x1), f2 = Math.round(l3.y2 - l3.y1);
                a3 = Math.round(l3.x - l3.x2), s2 = Math.round(l3.y - l3.y2), t4.push({ name: "dx1", type: "NUMBER", value: u3 }), t4.push({ name: "dy1", type: "NUMBER", value: c2 }), t4.push({ name: "dx2", type: "NUMBER", value: d2 }), t4.push({ name: "dy2", type: "NUMBER", value: f2 }), t4.push({ name: "dx", type: "NUMBER", value: a3 }), t4.push({ name: "dy", type: "NUMBER", value: s2 }), t4.push({ name: "rrcurveto", type: "OP", value: 8 }), n4 = Math.round(l3.x), o3 = Math.round(l3.y);
              }
            }
            return t4.push({ name: "endchar", type: "OP", value: 14 }), t4;
          }
          var Ne = { parse: function(e4, t4, r4) {
            r4.tables.cff = {};
            var n4, o3, i3, a3 = je(e4, (n4 = e4, o3 = t4, (i3 = {}).formatMajor = ae.getCard8(n4, o3), i3.formatMinor = ae.getCard8(n4, o3 + 1), i3.size = ae.getCard8(n4, o3 + 2), i3.offsetSize = ae.getCard8(n4, o3 + 3), i3.startOffset = o3, i3.endOffset = o3 + 4, i3).endOffset, ae.bytesToString), s2 = je(e4, a3.endOffset), l3 = je(e4, s2.endOffset, ae.bytesToString), u3 = je(e4, l3.endOffset);
            r4.gsubrs = u3.objects, r4.gsubrsBias = we(r4.gsubrs);
            var c2 = Pe(e4, t4, s2.objects, l3.objects);
            if (c2.length !== 1)
              throw new Error("CFF table has too many fonts in 'FontSet' - count of fonts NameIndex.length = " + c2.length);
            var d2 = c2[0];
            if ((r4.tables.cff.topDict = d2)._privateDict && (r4.defaultWidthX = d2._privateDict.defaultWidthX, r4.nominalWidthX = d2._privateDict.nominalWidthX), d2.ros[0] !== void 0 && d2.ros[1] !== void 0 && (r4.isCIDFont = true), r4.isCIDFont) {
              var f2 = d2.fdArray, h3 = d2.fdSelect;
              if (f2 === 0 || h3 === 0)
                throw new Error("Font is marked as a CID font, but FDArray and/or FDSelect information is missing");
              var p3 = Pe(e4, t4, je(e4, f2 += t4).objects, l3.objects);
              d2._fdArray = p3, h3 += t4, d2._fdSelect = function(e5, t5, r5, n5) {
                var o4, i4 = [], a4 = new ae.Parser(e5, t5), s3 = a4.parseCard8();
                if (s3 === 0)
                  for (var l4 = 0; l4 < r5; l4++) {
                    if (n5 <= (o4 = a4.parseCard8()))
                      throw new Error("CFF table CID Font FDSelect has bad FD index value " + o4 + " (FD count " + n5 + ")");
                    i4.push(o4);
                  }
                else {
                  if (s3 !== 3)
                    throw new Error("CFF Table CID Font FDSelect table has unsupported format " + s3);
                  var u4, c3 = a4.parseCard16(), d3 = a4.parseCard16();
                  if (d3 !== 0)
                    throw new Error("CFF Table CID Font FDSelect format 3 range has bad initial GID " + d3);
                  for (var f3 = 0; f3 < c3; f3++) {
                    if (o4 = a4.parseCard8(), u4 = a4.parseCard16(), n5 <= o4)
                      throw new Error("CFF table CID Font FDSelect has bad FD index value " + o4 + " (FD count " + n5 + ")");
                    if (r5 < u4)
                      throw new Error("CFF Table CID Font FDSelect format 3 range has bad GID " + u4);
                    for (; d3 < u4; d3++)
                      i4.push(o4);
                    d3 = u4;
                  }
                  if (u4 !== r5)
                    throw new Error("CFF Table CID Font FDSelect format 3 range has bad final GID " + u4);
                }
                return i4;
              }(e4, h3, r4.numGlyphs, p3.length);
            }
            var y2 = t4 + d2.private[1], m3 = Le(e4, y2, d2.private[0], l3.objects);
            if (r4.defaultWidthX = m3.defaultWidthX, r4.nominalWidthX = m3.nominalWidthX, m3.subrs !== 0) {
              var g2 = je(e4, y2 + m3.subrs);
              r4.subrs = g2.objects, r4.subrsBias = we(r4.subrs);
            } else
              r4.subrs = [], r4.subrsBias = 0;
            var v2 = je(e4, t4 + d2.charStrings);
            r4.nGlyphs = v2.objects.length;
            var b3 = function(e5, t5, r5, n5) {
              var o4, i4, a4 = new ae.Parser(e5, t5);
              --r5;
              var s3 = [".notdef"], l4 = a4.parseCard8();
              if (l4 === 0)
                for (var u4 = 0; u4 < r5; u4 += 1)
                  o4 = a4.parseSID(), s3.push(Ee(n5, o4));
              else if (l4 === 1)
                for (; s3.length <= r5; ) {
                  o4 = a4.parseSID(), i4 = a4.parseCard8();
                  for (var c3 = 0; c3 <= i4; c3 += 1)
                    s3.push(Ee(n5, o4)), o4 += 1;
                }
              else {
                if (l4 !== 2)
                  throw new Error("Unknown charset format " + l4);
                for (; s3.length <= r5; ) {
                  o4 = a4.parseSID(), i4 = a4.parseCard16();
                  for (var d3 = 0; d3 <= i4; d3 += 1)
                    s3.push(Ee(n5, o4)), o4 += 1;
                }
              }
              return s3;
            }(e4, t4 + d2.charset, r4.nGlyphs, l3.objects);
            d2.encoding === 0 ? r4.cffEncoding = new pe(ue, b3) : d2.encoding === 1 ? r4.cffEncoding = new pe(ce, b3) : r4.cffEncoding = function(e5, t5, r5) {
              var n5, o4 = {}, i4 = new ae.Parser(e5, t5), a4 = i4.parseCard8();
              if (a4 === 0)
                for (var s3 = i4.parseCard8(), l4 = 0; l4 < s3; l4 += 1)
                  o4[n5 = i4.parseCard8()] = l4;
              else {
                if (a4 !== 1)
                  throw new Error("Unknown encoding format " + a4);
                var u4 = i4.parseCard8();
                n5 = 1;
                for (var c3 = 0; c3 < u4; c3 += 1)
                  for (var d3 = i4.parseCard8(), f3 = i4.parseCard8(), h4 = d3; h4 <= d3 + f3; h4 += 1)
                    o4[h4] = n5, n5 += 1;
              }
              return new pe(o4, r5);
            }(e4, t4 + d2.encoding, b3), r4.encoding = r4.encoding || r4.cffEncoding, r4.glyphs = new _e.GlyphSet(r4);
            for (var _2 = 0; _2 < r4.nGlyphs; _2 += 1) {
              var x2 = v2.objects[_2];
              r4.glyphs.push(_2, _e.cffGlyphLoader(r4, _2, Ae, x2));
            }
          }, make: function(e4, t4) {
            for (var r4, n4 = new J.Table("CFF ", [{ name: "header", type: "RECORD" }, { name: "nameIndex", type: "RECORD" }, { name: "topDictIndex", type: "RECORD" }, { name: "stringIndex", type: "RECORD" }, { name: "globalSubrIndex", type: "RECORD" }, { name: "charsets", type: "RECORD" }, { name: "charStringsIndex", type: "RECORD" }, { name: "privateDict", type: "RECORD" }]), o3 = 1 / t4.unitsPerEm, i3 = { version: t4.version, fullName: t4.fullName, familyName: t4.familyName, weight: t4.weightName, fontBBox: t4.fontBBox || [0, 0, 0, 0], fontMatrix: [o3, 0, 0, o3, 0, 0], charset: 999, encoding: 0, charStrings: 999, private: [0, 999] }, a3 = [], s2 = 1; s2 < e4.length; s2 += 1)
              r4 = e4.get(s2), a3.push(r4.name);
            var l3 = [];
            n4.header = new J.Record("Header", [{ name: "major", type: "Card8", value: 1 }, { name: "minor", type: "Card8", value: 0 }, { name: "hdrSize", type: "Card8", value: 4 }, { name: "major", type: "Card8", value: 1 }]), n4.nameIndex = function(e5) {
              var t5 = new J.Record("Name INDEX", [{ name: "names", type: "INDEX", value: [] }]);
              t5.names = [];
              for (var r5 = 0; r5 < e5.length; r5 += 1)
                t5.names.push({ name: "name_" + r5, type: "NAME", value: e5[r5] });
              return t5;
            }([t4.postScriptName]);
            var u3, c2, d2, f2 = De(i3, l3);
            n4.topDictIndex = Ie(f2), n4.globalSubrIndex = new J.Record("Global Subr INDEX", [{ name: "subrs", type: "INDEX", value: [] }]), n4.charsets = function(e5, t5) {
              for (var r5 = new J.Record("Charsets", [{ name: "format", type: "Card8", value: 0 }]), n5 = 0; n5 < e5.length; n5 += 1) {
                var o4 = ke(e5[n5], t5);
                r5.fields.push({ name: "glyph_" + n5, type: "SID", value: o4 });
              }
              return r5;
            }(a3, l3), n4.charStringsIndex = function(e5) {
              for (var t5 = new J.Record("CharStrings INDEX", [{ name: "charStrings", type: "INDEX", value: [] }]), r5 = 0; r5 < e5.length; r5 += 1) {
                var n5 = e5.get(r5), o4 = Ue(n5);
                t5.charStrings.push({ name: n5.name, type: "CHARSTRING", value: o4 });
              }
              return t5;
            }(e4), n4.privateDict = (u3 = {}, c2 = l3, (d2 = new J.Record("Private DICT", [{ name: "dict", type: "DICT", value: {} }])).dict = Re(Ce, u3, c2), d2), n4.stringIndex = function(e5) {
              var t5 = new J.Record("String INDEX", [{ name: "strings", type: "INDEX", value: [] }]);
              t5.strings = [];
              for (var r5 = 0; r5 < e5.length; r5 += 1)
                t5.strings.push({ name: "string_" + r5, type: "STRING", value: e5[r5] });
              return t5;
            }(l3);
            var h3 = n4.header.sizeOf() + n4.nameIndex.sizeOf() + n4.topDictIndex.sizeOf() + n4.stringIndex.sizeOf() + n4.globalSubrIndex.sizeOf();
            return i3.charset = h3, i3.encoding = 0, i3.charStrings = i3.charset + n4.charsets.sizeOf(), i3.private[1] = i3.charStrings + n4.charStringsIndex.sizeOf(), f2 = De(i3, l3), n4.topDictIndex = Ie(f2), n4;
          } };
          var Fe = { parse: function(e4, t4) {
            var r4 = {}, n4 = new ae.Parser(e4, t4);
            return r4.version = n4.parseVersion(), r4.fontRevision = Math.round(1e3 * n4.parseFixed()) / 1e3, r4.checkSumAdjustment = n4.parseULong(), r4.magicNumber = n4.parseULong(), L.argument(r4.magicNumber === 1594834165, "Font header has wrong magic number."), r4.flags = n4.parseUShort(), r4.unitsPerEm = n4.parseUShort(), r4.created = n4.parseLongDateTime(), r4.modified = n4.parseLongDateTime(), r4.xMin = n4.parseShort(), r4.yMin = n4.parseShort(), r4.xMax = n4.parseShort(), r4.yMax = n4.parseShort(), r4.macStyle = n4.parseUShort(), r4.lowestRecPPEM = n4.parseUShort(), r4.fontDirectionHint = n4.parseShort(), r4.indexToLocFormat = n4.parseShort(), r4.glyphDataFormat = n4.parseShort(), r4;
          }, make: function(e4) {
            var t4 = Math.round(new Date().getTime() / 1e3) + 2082844800, r4 = t4;
            return e4.createdTimestamp && (r4 = e4.createdTimestamp + 2082844800), new J.Table("head", [{ name: "version", type: "FIXED", value: 65536 }, { name: "fontRevision", type: "FIXED", value: 65536 }, { name: "checkSumAdjustment", type: "ULONG", value: 0 }, { name: "magicNumber", type: "ULONG", value: 1594834165 }, { name: "flags", type: "USHORT", value: 0 }, { name: "unitsPerEm", type: "USHORT", value: 1e3 }, { name: "created", type: "LONGDATETIME", value: r4 }, { name: "modified", type: "LONGDATETIME", value: t4 }, { name: "xMin", type: "SHORT", value: 0 }, { name: "yMin", type: "SHORT", value: 0 }, { name: "xMax", type: "SHORT", value: 0 }, { name: "yMax", type: "SHORT", value: 0 }, { name: "macStyle", type: "USHORT", value: 0 }, { name: "lowestRecPPEM", type: "USHORT", value: 0 }, { name: "fontDirectionHint", type: "SHORT", value: 2 }, { name: "indexToLocFormat", type: "SHORT", value: 0 }, { name: "glyphDataFormat", type: "SHORT", value: 0 }], e4);
          } };
          var Be = { parse: function(e4, t4) {
            var r4 = {}, n4 = new ae.Parser(e4, t4);
            return r4.version = n4.parseVersion(), r4.ascender = n4.parseShort(), r4.descender = n4.parseShort(), r4.lineGap = n4.parseShort(), r4.advanceWidthMax = n4.parseUShort(), r4.minLeftSideBearing = n4.parseShort(), r4.minRightSideBearing = n4.parseShort(), r4.xMaxExtent = n4.parseShort(), r4.caretSlopeRise = n4.parseShort(), r4.caretSlopeRun = n4.parseShort(), r4.caretOffset = n4.parseShort(), n4.relativeOffset += 8, r4.metricDataFormat = n4.parseShort(), r4.numberOfHMetrics = n4.parseUShort(), r4;
          }, make: function(e4) {
            return new J.Table("hhea", [{ name: "version", type: "FIXED", value: 65536 }, { name: "ascender", type: "FWORD", value: 0 }, { name: "descender", type: "FWORD", value: 0 }, { name: "lineGap", type: "FWORD", value: 0 }, { name: "advanceWidthMax", type: "UFWORD", value: 0 }, { name: "minLeftSideBearing", type: "FWORD", value: 0 }, { name: "minRightSideBearing", type: "FWORD", value: 0 }, { name: "xMaxExtent", type: "FWORD", value: 0 }, { name: "caretSlopeRise", type: "SHORT", value: 1 }, { name: "caretSlopeRun", type: "SHORT", value: 0 }, { name: "caretOffset", type: "SHORT", value: 0 }, { name: "reserved1", type: "SHORT", value: 0 }, { name: "reserved2", type: "SHORT", value: 0 }, { name: "reserved3", type: "SHORT", value: 0 }, { name: "reserved4", type: "SHORT", value: 0 }, { name: "metricDataFormat", type: "SHORT", value: 0 }, { name: "numberOfHMetrics", type: "USHORT", value: 0 }], e4);
          } };
          var Ge = { parse: function(e4, t4, r4, n4, o3) {
            for (var i3, a3, s2 = new ae.Parser(e4, t4), l3 = 0; l3 < n4; l3 += 1) {
              l3 < r4 && (i3 = s2.parseUShort(), a3 = s2.parseShort());
              var u3 = o3.get(l3);
              u3.advanceWidth = i3, u3.leftSideBearing = a3;
            }
          }, make: function(e4) {
            for (var t4 = new J.Table("hmtx", []), r4 = 0; r4 < e4.length; r4 += 1) {
              var n4 = e4.get(r4), o3 = n4.advanceWidth || 0, i3 = n4.leftSideBearing || 0;
              t4.fields.push({ name: "advanceWidth_" + r4, type: "USHORT", value: o3 }), t4.fields.push({ name: "leftSideBearing_" + r4, type: "SHORT", value: i3 });
            }
            return t4;
          } };
          var Ve = { make: function(e4) {
            for (var t4 = new J.Table("ltag", [{ name: "version", type: "ULONG", value: 1 }, { name: "flags", type: "ULONG", value: 0 }, { name: "numTags", type: "ULONG", value: e4.length }]), r4 = "", n4 = 12 + 4 * e4.length, o3 = 0; o3 < e4.length; ++o3) {
              var i3 = r4.indexOf(e4[o3]);
              i3 < 0 && (i3 = r4.length, r4 += e4[o3]), t4.fields.push({ name: "offset " + o3, type: "USHORT", value: n4 + i3 }), t4.fields.push({ name: "length " + o3, type: "USHORT", value: e4[o3].length });
            }
            return t4.fields.push({ name: "stringPool", type: "CHARARRAY", value: r4 }), t4;
          }, parse: function(e4, t4) {
            var r4 = new ae.Parser(e4, t4), n4 = r4.parseULong();
            L.argument(n4 === 1, "Unsupported ltag table version."), r4.skip("uLong", 1);
            for (var o3 = r4.parseULong(), i3 = [], a3 = 0; a3 < o3; a3++) {
              for (var s2 = "", l3 = t4 + r4.parseUShort(), u3 = r4.parseUShort(), c2 = l3; c2 < l3 + u3; ++c2)
                s2 += String.fromCharCode(e4.getInt8(c2));
              i3.push(s2);
            }
            return i3;
          } };
          var ze = { parse: function(e4, t4) {
            var r4 = {}, n4 = new ae.Parser(e4, t4);
            return r4.version = n4.parseVersion(), r4.numGlyphs = n4.parseUShort(), r4.version === 1 && (r4.maxPoints = n4.parseUShort(), r4.maxContours = n4.parseUShort(), r4.maxCompositePoints = n4.parseUShort(), r4.maxCompositeContours = n4.parseUShort(), r4.maxZones = n4.parseUShort(), r4.maxTwilightPoints = n4.parseUShort(), r4.maxStorage = n4.parseUShort(), r4.maxFunctionDefs = n4.parseUShort(), r4.maxInstructionDefs = n4.parseUShort(), r4.maxStackElements = n4.parseUShort(), r4.maxSizeOfInstructions = n4.parseUShort(), r4.maxComponentElements = n4.parseUShort(), r4.maxComponentDepth = n4.parseUShort()), r4;
          }, make: function(e4) {
            return new J.Table("maxp", [{ name: "version", type: "FIXED", value: 20480 }, { name: "numGlyphs", type: "USHORT", value: e4 }]);
          } }, He = ["copyright", "fontFamily", "fontSubfamily", "uniqueID", "fullName", "version", "postScriptName", "trademark", "manufacturer", "designer", "description", "manufacturerURL", "designerURL", "license", "licenseURL", "reserved", "preferredFamily", "preferredSubfamily", "compatibleFullName", "sampleText", "postScriptFindFontName", "wwsFamily", "wwsSubfamily"], We = { 0: "en", 1: "fr", 2: "de", 3: "it", 4: "nl", 5: "sv", 6: "es", 7: "da", 8: "pt", 9: "no", 10: "he", 11: "ja", 12: "ar", 13: "fi", 14: "el", 15: "is", 16: "mt", 17: "tr", 18: "hr", 19: "zh-Hant", 20: "ur", 21: "hi", 22: "th", 23: "ko", 24: "lt", 25: "pl", 26: "hu", 27: "es", 28: "lv", 29: "se", 30: "fo", 31: "fa", 32: "ru", 33: "zh", 34: "nl-BE", 35: "ga", 36: "sq", 37: "ro", 38: "cz", 39: "sk", 40: "si", 41: "yi", 42: "sr", 43: "mk", 44: "bg", 45: "uk", 46: "be", 47: "uz", 48: "kk", 49: "az-Cyrl", 50: "az-Arab", 51: "hy", 52: "ka", 53: "mo", 54: "ky", 55: "tg", 56: "tk", 57: "mn-CN", 58: "mn", 59: "ps", 60: "ks", 61: "ku", 62: "sd", 63: "bo", 64: "ne", 65: "sa", 66: "mr", 67: "bn", 68: "as", 69: "gu", 70: "pa", 71: "or", 72: "ml", 73: "kn", 74: "ta", 75: "te", 76: "si", 77: "my", 78: "km", 79: "lo", 80: "vi", 81: "id", 82: "tl", 83: "ms", 84: "ms-Arab", 85: "am", 86: "ti", 87: "om", 88: "so", 89: "sw", 90: "rw", 91: "rn", 92: "ny", 93: "mg", 94: "eo", 128: "cy", 129: "eu", 130: "ca", 131: "la", 132: "qu", 133: "gn", 134: "ay", 135: "tt", 136: "ug", 137: "dz", 138: "jv", 139: "su", 140: "gl", 141: "af", 142: "br", 143: "iu", 144: "gd", 145: "gv", 146: "ga", 147: "to", 148: "el-polyton", 149: "kl", 150: "az", 151: "nn" }, qe = { 0: 0, 1: 0, 2: 0, 3: 0, 4: 0, 5: 0, 6: 0, 7: 0, 8: 0, 9: 0, 10: 5, 11: 1, 12: 4, 13: 0, 14: 6, 15: 0, 16: 0, 17: 0, 18: 0, 19: 2, 20: 4, 21: 9, 22: 21, 23: 3, 24: 29, 25: 29, 26: 29, 27: 29, 28: 29, 29: 0, 30: 0, 31: 4, 32: 7, 33: 25, 34: 0, 35: 0, 36: 0, 37: 0, 38: 29, 39: 29, 40: 0, 41: 5, 42: 7, 43: 7, 44: 7, 45: 7, 46: 7, 47: 7, 48: 7, 49: 7, 50: 4, 51: 24, 52: 23, 53: 7, 54: 7, 55: 7, 56: 7, 57: 27, 58: 7, 59: 4, 60: 4, 61: 4, 62: 4, 63: 26, 64: 9, 65: 9, 66: 9, 67: 13, 68: 13, 69: 11, 70: 10, 71: 12, 72: 17, 73: 16, 74: 14, 75: 15, 76: 18, 77: 19, 78: 20, 79: 22, 80: 30, 81: 0, 82: 0, 83: 0, 84: 4, 85: 28, 86: 28, 87: 28, 88: 0, 89: 0, 90: 0, 91: 0, 92: 0, 93: 0, 94: 0, 128: 0, 129: 0, 130: 0, 131: 0, 132: 0, 133: 0, 134: 0, 135: 7, 136: 4, 137: 26, 138: 0, 139: 0, 140: 0, 141: 0, 142: 0, 143: 28, 144: 0, 145: 0, 146: 0, 147: 0, 148: 6, 149: 0, 150: 0, 151: 0 }, Xe = { 1078: "af", 1052: "sq", 1156: "gsw", 1118: "am", 5121: "ar-DZ", 15361: "ar-BH", 3073: "ar", 2049: "ar-IQ", 11265: "ar-JO", 13313: "ar-KW", 12289: "ar-LB", 4097: "ar-LY", 6145: "ary", 8193: "ar-OM", 16385: "ar-QA", 1025: "ar-SA", 10241: "ar-SY", 7169: "aeb", 14337: "ar-AE", 9217: "ar-YE", 1067: "hy", 1101: "as", 2092: "az-Cyrl", 1068: "az", 1133: "ba", 1069: "eu", 1059: "be", 2117: "bn", 1093: "bn-IN", 8218: "bs-Cyrl", 5146: "bs", 1150: "br", 1026: "bg", 1027: "ca", 3076: "zh-HK", 5124: "zh-MO", 2052: "zh", 4100: "zh-SG", 1028: "zh-TW", 1155: "co", 1050: "hr", 4122: "hr-BA", 1029: "cs", 1030: "da", 1164: "prs", 1125: "dv", 2067: "nl-BE", 1043: "nl", 3081: "en-AU", 10249: "en-BZ", 4105: "en-CA", 9225: "en-029", 16393: "en-IN", 6153: "en-IE", 8201: "en-JM", 17417: "en-MY", 5129: "en-NZ", 13321: "en-PH", 18441: "en-SG", 7177: "en-ZA", 11273: "en-TT", 2057: "en-GB", 1033: "en", 12297: "en-ZW", 1061: "et", 1080: "fo", 1124: "fil", 1035: "fi", 2060: "fr-BE", 3084: "fr-CA", 1036: "fr", 5132: "fr-LU", 6156: "fr-MC", 4108: "fr-CH", 1122: "fy", 1110: "gl", 1079: "ka", 3079: "de-AT", 1031: "de", 5127: "de-LI", 4103: "de-LU", 2055: "de-CH", 1032: "el", 1135: "kl", 1095: "gu", 1128: "ha", 1037: "he", 1081: "hi", 1038: "hu", 1039: "is", 1136: "ig", 1057: "id", 1117: "iu", 2141: "iu-Latn", 2108: "ga", 1076: "xh", 1077: "zu", 1040: "it", 2064: "it-CH", 1041: "ja", 1099: "kn", 1087: "kk", 1107: "km", 1158: "quc", 1159: "rw", 1089: "sw", 1111: "kok", 1042: "ko", 1088: "ky", 1108: "lo", 1062: "lv", 1063: "lt", 2094: "dsb", 1134: "lb", 1071: "mk", 2110: "ms-BN", 1086: "ms", 1100: "ml", 1082: "mt", 1153: "mi", 1146: "arn", 1102: "mr", 1148: "moh", 1104: "mn", 2128: "mn-CN", 1121: "ne", 1044: "nb", 2068: "nn", 1154: "oc", 1096: "or", 1123: "ps", 1045: "pl", 1046: "pt", 2070: "pt-PT", 1094: "pa", 1131: "qu-BO", 2155: "qu-EC", 3179: "qu", 1048: "ro", 1047: "rm", 1049: "ru", 9275: "smn", 4155: "smj-NO", 5179: "smj", 3131: "se-FI", 1083: "se", 2107: "se-SE", 8251: "sms", 6203: "sma-NO", 7227: "sms", 1103: "sa", 7194: "sr-Cyrl-BA", 3098: "sr", 6170: "sr-Latn-BA", 2074: "sr-Latn", 1132: "nso", 1074: "tn", 1115: "si", 1051: "sk", 1060: "sl", 11274: "es-AR", 16394: "es-BO", 13322: "es-CL", 9226: "es-CO", 5130: "es-CR", 7178: "es-DO", 12298: "es-EC", 17418: "es-SV", 4106: "es-GT", 18442: "es-HN", 2058: "es-MX", 19466: "es-NI", 6154: "es-PA", 15370: "es-PY", 10250: "es-PE", 20490: "es-PR", 3082: "es", 1034: "es", 21514: "es-US", 14346: "es-UY", 8202: "es-VE", 2077: "sv-FI", 1053: "sv", 1114: "syr", 1064: "tg", 2143: "tzm", 1097: "ta", 1092: "tt", 1098: "te", 1054: "th", 1105: "bo", 1055: "tr", 1090: "tk", 1152: "ug", 1058: "uk", 1070: "hsb", 1056: "ur", 2115: "uz-Cyrl", 1091: "uz", 1066: "vi", 1106: "cy", 1160: "wo", 1157: "sah", 1144: "ii", 1130: "yo" };
          function Ye(e4, t4, r4) {
            switch (e4) {
              case 0:
                if (t4 === 65535)
                  return "und";
                if (r4)
                  return r4[t4];
                break;
              case 1:
                return We[t4];
              case 3:
                return Xe[t4];
            }
          }
          var Ze = "utf-16", Qe = { 0: "macintosh", 1: "x-mac-japanese", 2: "x-mac-chinesetrad", 3: "x-mac-korean", 6: "x-mac-greek", 7: "x-mac-cyrillic", 9: "x-mac-devanagai", 10: "x-mac-gurmukhi", 11: "x-mac-gujarati", 12: "x-mac-oriya", 13: "x-mac-bengali", 14: "x-mac-tamil", 15: "x-mac-telugu", 16: "x-mac-kannada", 17: "x-mac-malayalam", 18: "x-mac-sinhalese", 19: "x-mac-burmese", 20: "x-mac-khmer", 21: "x-mac-thai", 22: "x-mac-lao", 23: "x-mac-georgian", 24: "x-mac-armenian", 25: "x-mac-chinesesimp", 26: "x-mac-tibetan", 27: "x-mac-mongolian", 28: "x-mac-ethiopic", 29: "x-mac-ce", 30: "x-mac-vietnamese", 31: "x-mac-extarabic" }, Ke = { 15: "x-mac-icelandic", 17: "x-mac-turkish", 18: "x-mac-croatian", 24: "x-mac-ce", 25: "x-mac-ce", 26: "x-mac-ce", 27: "x-mac-ce", 28: "x-mac-ce", 30: "x-mac-icelandic", 37: "x-mac-romanian", 38: "x-mac-ce", 39: "x-mac-ce", 40: "x-mac-ce", 143: "x-mac-inuit", 146: "x-mac-gaelic" };
          function Je(e4, t4, r4) {
            switch (e4) {
              case 0:
                return Ze;
              case 1:
                return Ke[r4] || Qe[t4];
              case 3:
                if (t4 === 1 || t4 === 10)
                  return Ze;
            }
          }
          function $e(e4) {
            var t4 = {};
            for (var r4 in e4)
              t4[e4[r4]] = parseInt(r4);
            return t4;
          }
          function et(e4, t4, r4, n4, o3, i3) {
            return new J.Record("NameRecord", [{ name: "platformID", type: "USHORT", value: e4 }, { name: "encodingID", type: "USHORT", value: t4 }, { name: "languageID", type: "USHORT", value: r4 }, { name: "nameID", type: "USHORT", value: n4 }, { name: "length", type: "USHORT", value: o3 }, { name: "offset", type: "USHORT", value: i3 }]);
          }
          function tt(e4, t4) {
            var r4 = function(e5, t5) {
              var r5 = e5.length, n5 = t5.length - r5 + 1;
              e:
                for (var o4 = 0; o4 < n5; o4++)
                  for (; o4 < n5; o4++) {
                    for (var i3 = 0; i3 < r5; i3++)
                      if (t5[o4 + i3] !== e5[i3])
                        continue e;
                    return o4;
                  }
              return -1;
            }(e4, t4);
            if (r4 < 0) {
              r4 = t4.length;
              for (var n4 = 0, o3 = e4.length; n4 < o3; ++n4)
                t4.push(e4[n4]);
            }
            return r4;
          }
          var rt = { parse: function(e4, t4, r4) {
            for (var n4 = {}, o3 = new ae.Parser(e4, t4), i3 = o3.parseUShort(), a3 = o3.parseUShort(), s2 = o3.offset + o3.parseUShort(), l3 = 0; l3 < a3; l3++) {
              var u3 = o3.parseUShort(), c2 = o3.parseUShort(), d2 = o3.parseUShort(), f2 = o3.parseUShort(), h3 = He[f2] || f2, p3 = o3.parseUShort(), y2 = o3.parseUShort(), m3 = Ye(u3, d2, r4), g2 = Je(u3, c2, d2);
              if (g2 !== void 0 && m3 !== void 0) {
                var v2 = void 0;
                if (v2 = g2 === Ze ? P2.UTF16(e4, s2 + y2, p3) : P2.MACSTRING(e4, s2 + y2, p3, g2)) {
                  var b3 = n4[h3];
                  b3 === void 0 && (b3 = n4[h3] = {}), b3[m3] = v2;
                }
              }
            }
            return i3 === 1 && o3.parseUShort(), n4;
          }, make: function(e4, t4) {
            var r4, n4 = [], o3 = {}, i3 = $e(He);
            for (var a3 in e4) {
              var s2 = i3[a3];
              if (s2 === void 0 && (s2 = a3), r4 = parseInt(s2), isNaN(r4))
                throw new Error('Name table entry "' + a3 + '" does not exist, see nameTableNames for complete list.');
              o3[r4] = e4[a3], n4.push(r4);
            }
            for (var l3 = $e(We), u3 = $e(Xe), c2 = [], d2 = [], f2 = 0; f2 < n4.length; f2++) {
              var h3 = o3[r4 = n4[f2]];
              for (var p3 in h3) {
                var y2 = h3[p3], m3 = 1, g2 = l3[p3], v2 = qe[g2], b3 = Je(m3, v2, g2), _2 = A.MACSTRING(y2, b3);
                _2 === void 0 && (m3 = 0, (g2 = t4.indexOf(p3)) < 0 && (g2 = t4.length, t4.push(p3)), v2 = 4, _2 = A.UTF16(y2));
                var x2 = tt(_2, d2);
                c2.push(et(m3, v2, g2, r4, _2.length, x2));
                var w2 = u3[p3];
                if (w2 !== void 0) {
                  var j2 = A.UTF16(y2), S3 = tt(j2, d2);
                  c2.push(et(3, 1, w2, r4, j2.length, S3));
                }
              }
            }
            c2.sort(function(e5, t5) {
              return e5.platformID - t5.platformID || e5.encodingID - t5.encodingID || e5.languageID - t5.languageID || e5.nameID - t5.nameID;
            });
            for (var M2 = new J.Table("name", [{ name: "format", type: "USHORT", value: 0 }, { name: "count", type: "USHORT", value: c2.length }, { name: "stringOffset", type: "USHORT", value: 6 + 12 * c2.length }]), E2 = 0; E2 < c2.length; E2++)
              M2.fields.push({ name: "record_" + E2, type: "RECORD", value: c2[E2] });
            return M2.fields.push({ name: "strings", type: "LITERAL", value: d2 }), M2;
          } }, nt = [{ begin: 0, end: 127 }, { begin: 128, end: 255 }, { begin: 256, end: 383 }, { begin: 384, end: 591 }, { begin: 592, end: 687 }, { begin: 688, end: 767 }, { begin: 768, end: 879 }, { begin: 880, end: 1023 }, { begin: 11392, end: 11519 }, { begin: 1024, end: 1279 }, { begin: 1328, end: 1423 }, { begin: 1424, end: 1535 }, { begin: 42240, end: 42559 }, { begin: 1536, end: 1791 }, { begin: 1984, end: 2047 }, { begin: 2304, end: 2431 }, { begin: 2432, end: 2559 }, { begin: 2560, end: 2687 }, { begin: 2688, end: 2815 }, { begin: 2816, end: 2943 }, { begin: 2944, end: 3071 }, { begin: 3072, end: 3199 }, { begin: 3200, end: 3327 }, { begin: 3328, end: 3455 }, { begin: 3584, end: 3711 }, { begin: 3712, end: 3839 }, { begin: 4256, end: 4351 }, { begin: 6912, end: 7039 }, { begin: 4352, end: 4607 }, { begin: 7680, end: 7935 }, { begin: 7936, end: 8191 }, { begin: 8192, end: 8303 }, { begin: 8304, end: 8351 }, { begin: 8352, end: 8399 }, { begin: 8400, end: 8447 }, { begin: 8448, end: 8527 }, { begin: 8528, end: 8591 }, { begin: 8592, end: 8703 }, { begin: 8704, end: 8959 }, { begin: 8960, end: 9215 }, { begin: 9216, end: 9279 }, { begin: 9280, end: 9311 }, { begin: 9312, end: 9471 }, { begin: 9472, end: 9599 }, { begin: 9600, end: 9631 }, { begin: 9632, end: 9727 }, { begin: 9728, end: 9983 }, { begin: 9984, end: 10175 }, { begin: 12288, end: 12351 }, { begin: 12352, end: 12447 }, { begin: 12448, end: 12543 }, { begin: 12544, end: 12591 }, { begin: 12592, end: 12687 }, { begin: 43072, end: 43135 }, { begin: 12800, end: 13055 }, { begin: 13056, end: 13311 }, { begin: 44032, end: 55215 }, { begin: 55296, end: 57343 }, { begin: 67840, end: 67871 }, { begin: 19968, end: 40959 }, { begin: 57344, end: 63743 }, { begin: 12736, end: 12783 }, { begin: 64256, end: 64335 }, { begin: 64336, end: 65023 }, { begin: 65056, end: 65071 }, { begin: 65040, end: 65055 }, { begin: 65104, end: 65135 }, { begin: 65136, end: 65279 }, { begin: 65280, end: 65519 }, { begin: 65520, end: 65535 }, { begin: 3840, end: 4095 }, { begin: 1792, end: 1871 }, { begin: 1920, end: 1983 }, { begin: 3456, end: 3583 }, { begin: 4096, end: 4255 }, { begin: 4608, end: 4991 }, { begin: 5024, end: 5119 }, { begin: 5120, end: 5759 }, { begin: 5760, end: 5791 }, { begin: 5792, end: 5887 }, { begin: 6016, end: 6143 }, { begin: 6144, end: 6319 }, { begin: 10240, end: 10495 }, { begin: 40960, end: 42127 }, { begin: 5888, end: 5919 }, { begin: 66304, end: 66351 }, { begin: 66352, end: 66383 }, { begin: 66560, end: 66639 }, { begin: 118784, end: 119039 }, { begin: 119808, end: 120831 }, { begin: 1044480, end: 1048573 }, { begin: 65024, end: 65039 }, { begin: 917504, end: 917631 }, { begin: 6400, end: 6479 }, { begin: 6480, end: 6527 }, { begin: 6528, end: 6623 }, { begin: 6656, end: 6687 }, { begin: 11264, end: 11359 }, { begin: 11568, end: 11647 }, { begin: 19904, end: 19967 }, { begin: 43008, end: 43055 }, { begin: 65536, end: 65663 }, { begin: 65856, end: 65935 }, { begin: 66432, end: 66463 }, { begin: 66464, end: 66527 }, { begin: 66640, end: 66687 }, { begin: 66688, end: 66735 }, { begin: 67584, end: 67647 }, { begin: 68096, end: 68191 }, { begin: 119552, end: 119647 }, { begin: 73728, end: 74751 }, { begin: 119648, end: 119679 }, { begin: 7040, end: 7103 }, { begin: 7168, end: 7247 }, { begin: 7248, end: 7295 }, { begin: 43136, end: 43231 }, { begin: 43264, end: 43311 }, { begin: 43312, end: 43359 }, { begin: 43520, end: 43615 }, { begin: 65936, end: 65999 }, { begin: 66e3, end: 66047 }, { begin: 66208, end: 66271 }, { begin: 127024, end: 127135 }];
          var ot = { parse: function(e4, t4) {
            var r4 = {}, n4 = new ae.Parser(e4, t4);
            r4.version = n4.parseUShort(), r4.xAvgCharWidth = n4.parseShort(), r4.usWeightClass = n4.parseUShort(), r4.usWidthClass = n4.parseUShort(), r4.fsType = n4.parseUShort(), r4.ySubscriptXSize = n4.parseShort(), r4.ySubscriptYSize = n4.parseShort(), r4.ySubscriptXOffset = n4.parseShort(), r4.ySubscriptYOffset = n4.parseShort(), r4.ySuperscriptXSize = n4.parseShort(), r4.ySuperscriptYSize = n4.parseShort(), r4.ySuperscriptXOffset = n4.parseShort(), r4.ySuperscriptYOffset = n4.parseShort(), r4.yStrikeoutSize = n4.parseShort(), r4.yStrikeoutPosition = n4.parseShort(), r4.sFamilyClass = n4.parseShort(), r4.panose = [];
            for (var o3 = 0; o3 < 10; o3++)
              r4.panose[o3] = n4.parseByte();
            return r4.ulUnicodeRange1 = n4.parseULong(), r4.ulUnicodeRange2 = n4.parseULong(), r4.ulUnicodeRange3 = n4.parseULong(), r4.ulUnicodeRange4 = n4.parseULong(), r4.achVendID = String.fromCharCode(n4.parseByte(), n4.parseByte(), n4.parseByte(), n4.parseByte()), r4.fsSelection = n4.parseUShort(), r4.usFirstCharIndex = n4.parseUShort(), r4.usLastCharIndex = n4.parseUShort(), r4.sTypoAscender = n4.parseShort(), r4.sTypoDescender = n4.parseShort(), r4.sTypoLineGap = n4.parseShort(), r4.usWinAscent = n4.parseUShort(), r4.usWinDescent = n4.parseUShort(), 1 <= r4.version && (r4.ulCodePageRange1 = n4.parseULong(), r4.ulCodePageRange2 = n4.parseULong()), 2 <= r4.version && (r4.sxHeight = n4.parseShort(), r4.sCapHeight = n4.parseShort(), r4.usDefaultChar = n4.parseUShort(), r4.usBreakChar = n4.parseUShort(), r4.usMaxContent = n4.parseUShort()), r4;
          }, make: function(e4) {
            return new J.Table("OS/2", [{ name: "version", type: "USHORT", value: 3 }, { name: "xAvgCharWidth", type: "SHORT", value: 0 }, { name: "usWeightClass", type: "USHORT", value: 0 }, { name: "usWidthClass", type: "USHORT", value: 0 }, { name: "fsType", type: "USHORT", value: 0 }, { name: "ySubscriptXSize", type: "SHORT", value: 650 }, { name: "ySubscriptYSize", type: "SHORT", value: 699 }, { name: "ySubscriptXOffset", type: "SHORT", value: 0 }, { name: "ySubscriptYOffset", type: "SHORT", value: 140 }, { name: "ySuperscriptXSize", type: "SHORT", value: 650 }, { name: "ySuperscriptYSize", type: "SHORT", value: 699 }, { name: "ySuperscriptXOffset", type: "SHORT", value: 0 }, { name: "ySuperscriptYOffset", type: "SHORT", value: 479 }, { name: "yStrikeoutSize", type: "SHORT", value: 49 }, { name: "yStrikeoutPosition", type: "SHORT", value: 258 }, { name: "sFamilyClass", type: "SHORT", value: 0 }, { name: "bFamilyType", type: "BYTE", value: 0 }, { name: "bSerifStyle", type: "BYTE", value: 0 }, { name: "bWeight", type: "BYTE", value: 0 }, { name: "bProportion", type: "BYTE", value: 0 }, { name: "bContrast", type: "BYTE", value: 0 }, { name: "bStrokeVariation", type: "BYTE", value: 0 }, { name: "bArmStyle", type: "BYTE", value: 0 }, { name: "bLetterform", type: "BYTE", value: 0 }, { name: "bMidline", type: "BYTE", value: 0 }, { name: "bXHeight", type: "BYTE", value: 0 }, { name: "ulUnicodeRange1", type: "ULONG", value: 0 }, { name: "ulUnicodeRange2", type: "ULONG", value: 0 }, { name: "ulUnicodeRange3", type: "ULONG", value: 0 }, { name: "ulUnicodeRange4", type: "ULONG", value: 0 }, { name: "achVendID", type: "CHARARRAY", value: "XXXX" }, { name: "fsSelection", type: "USHORT", value: 0 }, { name: "usFirstCharIndex", type: "USHORT", value: 0 }, { name: "usLastCharIndex", type: "USHORT", value: 0 }, { name: "sTypoAscender", type: "SHORT", value: 0 }, { name: "sTypoDescender", type: "SHORT", value: 0 }, { name: "sTypoLineGap", type: "SHORT", value: 0 }, { name: "usWinAscent", type: "USHORT", value: 0 }, { name: "usWinDescent", type: "USHORT", value: 0 }, { name: "ulCodePageRange1", type: "ULONG", value: 0 }, { name: "ulCodePageRange2", type: "ULONG", value: 0 }, { name: "sxHeight", type: "SHORT", value: 0 }, { name: "sCapHeight", type: "SHORT", value: 0 }, { name: "usDefaultChar", type: "USHORT", value: 0 }, { name: "usBreakChar", type: "USHORT", value: 0 }, { name: "usMaxContext", type: "USHORT", value: 0 }], e4);
          }, unicodeRanges: nt, getUnicodeRange: function(e4) {
            for (var t4 = 0; t4 < nt.length; t4 += 1) {
              var r4 = nt[t4];
              if (e4 >= r4.begin && e4 < r4.end)
                return t4;
            }
            return -1;
          } };
          var it = { parse: function(e4, t4) {
            var r4 = {}, n4 = new ae.Parser(e4, t4);
            switch (r4.version = n4.parseVersion(), r4.italicAngle = n4.parseFixed(), r4.underlinePosition = n4.parseShort(), r4.underlineThickness = n4.parseShort(), r4.isFixedPitch = n4.parseULong(), r4.minMemType42 = n4.parseULong(), r4.maxMemType42 = n4.parseULong(), r4.minMemType1 = n4.parseULong(), r4.maxMemType1 = n4.parseULong(), r4.version) {
              case 1:
                r4.names = de.slice();
                break;
              case 2:
                r4.numberOfGlyphs = n4.parseUShort(), r4.glyphNameIndex = new Array(r4.numberOfGlyphs);
                for (var o3 = 0; o3 < r4.numberOfGlyphs; o3++)
                  r4.glyphNameIndex[o3] = n4.parseUShort();
                r4.names = [];
                for (var i3 = 0; i3 < r4.numberOfGlyphs; i3++)
                  if (r4.glyphNameIndex[i3] >= de.length) {
                    var a3 = n4.parseChar();
                    r4.names.push(n4.parseString(a3));
                  }
                break;
              case 2.5:
                r4.numberOfGlyphs = n4.parseUShort(), r4.offset = new Array(r4.numberOfGlyphs);
                for (var s2 = 0; s2 < r4.numberOfGlyphs; s2++)
                  r4.offset[s2] = n4.parseChar();
            }
            return r4;
          }, make: function() {
            return new J.Table("post", [{ name: "version", type: "FIXED", value: 196608 }, { name: "italicAngle", type: "FIXED", value: 0 }, { name: "underlinePosition", type: "FWORD", value: 0 }, { name: "underlineThickness", type: "FWORD", value: 0 }, { name: "isFixedPitch", type: "ULONG", value: 0 }, { name: "minMemType42", type: "ULONG", value: 0 }, { name: "maxMemType42", type: "ULONG", value: 0 }, { name: "minMemType1", type: "ULONG", value: 0 }, { name: "maxMemType1", type: "ULONG", value: 0 }]);
          } }, at = new Array(9);
          at[1] = function() {
            var e4 = this.offset + this.relativeOffset, t4 = this.parseUShort();
            return t4 === 1 ? { substFormat: 1, coverage: this.parsePointer(oe.coverage), deltaGlyphId: this.parseUShort() } : t4 === 2 ? { substFormat: 2, coverage: this.parsePointer(oe.coverage), substitute: this.parseOffset16List() } : void L.assert(false, "0x" + e4.toString(16) + ": lookup type 1 format must be 1 or 2.");
          }, at[2] = function() {
            var e4 = this.parseUShort();
            return L.argument(e4 === 1, "GSUB Multiple Substitution Subtable identifier-format must be 1"), { substFormat: e4, coverage: this.parsePointer(oe.coverage), sequences: this.parseListOfLists() };
          }, at[3] = function() {
            var e4 = this.parseUShort();
            return L.argument(e4 === 1, "GSUB Alternate Substitution Subtable identifier-format must be 1"), { substFormat: e4, coverage: this.parsePointer(oe.coverage), alternateSets: this.parseListOfLists() };
          }, at[4] = function() {
            var e4 = this.parseUShort();
            return L.argument(e4 === 1, "GSUB ligature table identifier-format must be 1"), { substFormat: e4, coverage: this.parsePointer(oe.coverage), ligatureSets: this.parseListOfLists(function() {
              return { ligGlyph: this.parseUShort(), components: this.parseUShortList(this.parseUShort() - 1) };
            }) };
          };
          var st = { sequenceIndex: oe.uShort, lookupListIndex: oe.uShort };
          at[5] = function() {
            var e4 = this.offset + this.relativeOffset, t4 = this.parseUShort();
            if (t4 === 1)
              return { substFormat: t4, coverage: this.parsePointer(oe.coverage), ruleSets: this.parseListOfLists(function() {
                var e5 = this.parseUShort(), t5 = this.parseUShort();
                return { input: this.parseUShortList(e5 - 1), lookupRecords: this.parseRecordList(t5, st) };
              }) };
            if (t4 === 2)
              return { substFormat: t4, coverage: this.parsePointer(oe.coverage), classDef: this.parsePointer(oe.classDef), classSets: this.parseListOfLists(function() {
                var e5 = this.parseUShort(), t5 = this.parseUShort();
                return { classes: this.parseUShortList(e5 - 1), lookupRecords: this.parseRecordList(t5, st) };
              }) };
            if (t4 === 3) {
              var r4 = this.parseUShort(), n4 = this.parseUShort();
              return { substFormat: t4, coverages: this.parseList(r4, oe.pointer(oe.coverage)), lookupRecords: this.parseRecordList(n4, st) };
            }
            L.assert(false, "0x" + e4.toString(16) + ": lookup type 5 format must be 1, 2 or 3.");
          }, at[6] = function() {
            var e4 = this.offset + this.relativeOffset, t4 = this.parseUShort();
            return t4 === 1 ? { substFormat: 1, coverage: this.parsePointer(oe.coverage), chainRuleSets: this.parseListOfLists(function() {
              return { backtrack: this.parseUShortList(), input: this.parseUShortList(this.parseShort() - 1), lookahead: this.parseUShortList(), lookupRecords: this.parseRecordList(st) };
            }) } : t4 === 2 ? { substFormat: 2, coverage: this.parsePointer(oe.coverage), backtrackClassDef: this.parsePointer(oe.classDef), inputClassDef: this.parsePointer(oe.classDef), lookaheadClassDef: this.parsePointer(oe.classDef), chainClassSet: this.parseListOfLists(function() {
              return { backtrack: this.parseUShortList(), input: this.parseUShortList(this.parseShort() - 1), lookahead: this.parseUShortList(), lookupRecords: this.parseRecordList(st) };
            }) } : t4 === 3 ? { substFormat: 3, backtrackCoverage: this.parseList(oe.pointer(oe.coverage)), inputCoverage: this.parseList(oe.pointer(oe.coverage)), lookaheadCoverage: this.parseList(oe.pointer(oe.coverage)), lookupRecords: this.parseRecordList(st) } : void L.assert(false, "0x" + e4.toString(16) + ": lookup type 6 format must be 1, 2 or 3.");
          }, at[7] = function() {
            var e4 = this.parseUShort();
            L.argument(e4 === 1, "GSUB Extension Substitution subtable identifier-format must be 1");
            var t4 = this.parseUShort(), r4 = new oe(this.data, this.offset + this.parseULong());
            return { substFormat: 1, lookupType: t4, extension: at[t4].call(r4) };
          }, at[8] = function() {
            var e4 = this.parseUShort();
            return L.argument(e4 === 1, "GSUB Reverse Chaining Contextual Single Substitution Subtable identifier-format must be 1"), { substFormat: e4, coverage: this.parsePointer(oe.coverage), backtrackCoverage: this.parseList(oe.pointer(oe.coverage)), lookaheadCoverage: this.parseList(oe.pointer(oe.coverage)), substitutes: this.parseUShortList() };
          };
          var lt = new Array(9);
          lt[1] = function(e4) {
            return e4.substFormat === 1 ? new J.Table("substitutionTable", [{ name: "substFormat", type: "USHORT", value: 1 }, { name: "coverage", type: "TABLE", value: new J.Coverage(e4.coverage) }, { name: "deltaGlyphID", type: "USHORT", value: e4.deltaGlyphId }]) : new J.Table("substitutionTable", [{ name: "substFormat", type: "USHORT", value: 2 }, { name: "coverage", type: "TABLE", value: new J.Coverage(e4.coverage) }].concat(J.ushortList("substitute", e4.substitute)));
          }, lt[3] = function(e4) {
            return L.assert(e4.substFormat === 1, "Lookup type 3 substFormat must be 1."), new J.Table("substitutionTable", [{ name: "substFormat", type: "USHORT", value: 1 }, { name: "coverage", type: "TABLE", value: new J.Coverage(e4.coverage) }].concat(J.tableList("altSet", e4.alternateSets, function(e5) {
              return new J.Table("alternateSetTable", J.ushortList("alternate", e5));
            })));
          }, lt[4] = function(e4) {
            return L.assert(e4.substFormat === 1, "Lookup type 4 substFormat must be 1."), new J.Table("substitutionTable", [{ name: "substFormat", type: "USHORT", value: 1 }, { name: "coverage", type: "TABLE", value: new J.Coverage(e4.coverage) }].concat(J.tableList("ligSet", e4.ligatureSets, function(e5) {
              return new J.Table("ligatureSetTable", J.tableList("ligature", e5, function(e6) {
                return new J.Table("ligatureTable", [{ name: "ligGlyph", type: "USHORT", value: e6.ligGlyph }].concat(J.ushortList("component", e6.components, e6.components.length + 1)));
              }));
            })));
          };
          var ut = { parse: function(e4, t4) {
            var r4 = new oe(e4, t4 = t4 || 0), n4 = r4.parseVersion(1);
            return L.argument(n4 === 1 || n4 === 1.1, "Unsupported GSUB table version."), n4 === 1 ? { version: n4, scripts: r4.parseScriptList(), features: r4.parseFeatureList(), lookups: r4.parseLookupList(at) } : { version: n4, scripts: r4.parseScriptList(), features: r4.parseFeatureList(), lookups: r4.parseLookupList(at), variations: r4.parseFeatureVariationsList() };
          }, make: function(e4) {
            return new J.Table("GSUB", [{ name: "version", type: "ULONG", value: 65536 }, { name: "scripts", type: "TABLE", value: new J.ScriptList(e4.scripts) }, { name: "features", type: "TABLE", value: new J.FeatureList(e4.features) }, { name: "lookups", type: "TABLE", value: new J.LookupList(e4.lookups, lt) }]);
          } };
          var ct = { parse: function(e4, t4) {
            var r4 = new ae.Parser(e4, t4), n4 = r4.parseULong();
            L.argument(n4 === 1, "Unsupported META table version."), r4.parseULong(), r4.parseULong();
            for (var o3 = r4.parseULong(), i3 = {}, a3 = 0; a3 < o3; a3++) {
              var s2 = r4.parseTag(), l3 = r4.parseULong(), u3 = r4.parseULong(), c2 = P2.UTF8(e4, t4 + l3, u3);
              i3[s2] = c2;
            }
            return i3;
          }, make: function(e4) {
            var t4 = Object.keys(e4).length, r4 = "", n4 = 16 + 12 * t4, o3 = new J.Table("meta", [{ name: "version", type: "ULONG", value: 1 }, { name: "flags", type: "ULONG", value: 0 }, { name: "offset", type: "ULONG", value: n4 }, { name: "numTags", type: "ULONG", value: t4 }]);
            for (var i3 in e4) {
              var a3 = r4.length;
              r4 += e4[i3], o3.fields.push({ name: "tag " + i3, type: "TAG", value: i3 }), o3.fields.push({ name: "offset " + i3, type: "ULONG", value: n4 + a3 }), o3.fields.push({ name: "length " + i3, type: "ULONG", value: e4[i3].length });
            }
            return o3.fields.push({ name: "stringPool", type: "CHARARRAY", value: r4 }), o3;
          } };
          function dt(e4) {
            return Math.log(e4) / Math.log(2) | 0;
          }
          function ft(e4) {
            for (; e4.length % 4 != 0; )
              e4.push(0);
            for (var t4 = 0, r4 = 0; r4 < e4.length; r4 += 4)
              t4 += (e4[r4] << 24) + (e4[r4 + 1] << 16) + (e4[r4 + 2] << 8) + e4[r4 + 3];
            return t4 %= Math.pow(2, 32);
          }
          function ht(e4, t4, r4, n4) {
            return new J.Record("Table Record", [{ name: "tag", type: "TAG", value: e4 !== void 0 ? e4 : "" }, { name: "checkSum", type: "ULONG", value: t4 !== void 0 ? t4 : 0 }, { name: "offset", type: "ULONG", value: r4 !== void 0 ? r4 : 0 }, { name: "length", type: "ULONG", value: n4 !== void 0 ? n4 : 0 }]);
          }
          function pt(e4) {
            var t4 = new J.Table("sfnt", [{ name: "version", type: "TAG", value: "OTTO" }, { name: "numTables", type: "USHORT", value: 0 }, { name: "searchRange", type: "USHORT", value: 0 }, { name: "entrySelector", type: "USHORT", value: 0 }, { name: "rangeShift", type: "USHORT", value: 0 }]);
            t4.tables = e4, t4.numTables = e4.length;
            var r4 = Math.pow(2, dt(t4.numTables));
            t4.searchRange = 16 * r4, t4.entrySelector = dt(r4), t4.rangeShift = 16 * t4.numTables - t4.searchRange;
            for (var n4 = [], o3 = [], i3 = t4.sizeOf() + ht().sizeOf() * t4.numTables; i3 % 4 != 0; )
              i3 += 1, o3.push({ name: "padding", type: "BYTE", value: 0 });
            for (var a3 = 0; a3 < e4.length; a3 += 1) {
              var s2 = e4[a3];
              L.argument(s2.tableName.length === 4, "Table name" + s2.tableName + " is invalid.");
              var l3 = s2.sizeOf(), u3 = ht(s2.tableName, ft(s2.encode()), i3, l3);
              for (n4.push({ name: u3.tag + " Table Record", type: "RECORD", value: u3 }), o3.push({ name: s2.tableName + " table", type: "RECORD", value: s2 }), i3 += l3, L.argument(!isNaN(i3), "Something went wrong calculating the offset."); i3 % 4 != 0; )
                i3 += 1, o3.push({ name: "padding", type: "BYTE", value: 0 });
            }
            return n4.sort(function(e5, t5) {
              return e5.value.tag > t5.value.tag ? 1 : -1;
            }), t4.fields = t4.fields.concat(n4), t4.fields = t4.fields.concat(o3), t4;
          }
          function yt(e4, t4, r4) {
            for (var n4 = 0; n4 < t4.length; n4 += 1) {
              var o3 = e4.charToGlyphIndex(t4[n4]);
              if (0 < o3)
                return e4.glyphs.get(o3).getMetrics();
            }
            return r4;
          }
          var mt = { make: pt, fontToTable: function(e4) {
            for (var t4, r4 = [], n4 = [], o3 = [], i3 = [], a3 = [], s2 = [], l3 = [], u3 = 0, c2 = 0, d2 = 0, f2 = 0, h3 = 0, p3 = 0; p3 < e4.glyphs.length; p3 += 1) {
              var y2 = e4.glyphs.get(p3), m3 = 0 | y2.unicode;
              if (isNaN(y2.advanceWidth))
                throw new Error("Glyph " + y2.name + " (" + p3 + "): advanceWidth is not a number.");
              (m3 < t4 || t4 === void 0) && 0 < m3 && (t4 = m3), u3 < m3 && (u3 = m3);
              var g2 = ot.getUnicodeRange(m3);
              if (g2 < 32)
                c2 |= 1 << g2;
              else if (g2 < 64)
                d2 |= 1 << g2 - 32;
              else if (g2 < 96)
                f2 |= 1 << g2 - 64;
              else {
                if (!(g2 < 123))
                  throw new Error("Unicode ranges bits > 123 are reserved for internal usage");
                h3 |= 1 << g2 - 96;
              }
              if (y2.name !== ".notdef") {
                var v2 = y2.getMetrics();
                r4.push(v2.xMin), n4.push(v2.yMin), o3.push(v2.xMax), i3.push(v2.yMax), s2.push(v2.leftSideBearing), l3.push(v2.rightSideBearing), a3.push(y2.advanceWidth);
              }
            }
            var b3 = { xMin: Math.min.apply(null, r4), yMin: Math.min.apply(null, n4), xMax: Math.max.apply(null, o3), yMax: Math.max.apply(null, i3), advanceWidthMax: Math.max.apply(null, a3), advanceWidthAvg: function(e5) {
              for (var t5 = 0, r5 = 0; r5 < e5.length; r5 += 1)
                t5 += e5[r5];
              return t5 / e5.length;
            }(a3), minLeftSideBearing: Math.min.apply(null, s2), maxLeftSideBearing: Math.max.apply(null, s2), minRightSideBearing: Math.min.apply(null, l3) };
            b3.ascender = e4.ascender, b3.descender = e4.descender;
            var _2 = Fe.make({ flags: 3, unitsPerEm: e4.unitsPerEm, xMin: b3.xMin, yMin: b3.yMin, xMax: b3.xMax, yMax: b3.yMax, lowestRecPPEM: 3, createdTimestamp: e4.createdTimestamp }), x2 = Be.make({ ascender: b3.ascender, descender: b3.descender, advanceWidthMax: b3.advanceWidthMax, minLeftSideBearing: b3.minLeftSideBearing, minRightSideBearing: b3.minRightSideBearing, xMaxExtent: b3.maxLeftSideBearing + (b3.xMax - b3.xMin), numberOfHMetrics: e4.glyphs.length }), w2 = ze.make(e4.glyphs.length), j2 = ot.make({ xAvgCharWidth: Math.round(b3.advanceWidthAvg), usWeightClass: e4.tables.os2.usWeightClass, usWidthClass: e4.tables.os2.usWidthClass, usFirstCharIndex: t4, usLastCharIndex: u3, ulUnicodeRange1: c2, ulUnicodeRange2: d2, ulUnicodeRange3: f2, ulUnicodeRange4: h3, fsSelection: e4.tables.os2.fsSelection, sTypoAscender: b3.ascender, sTypoDescender: b3.descender, sTypoLineGap: 0, usWinAscent: b3.yMax, usWinDescent: Math.abs(b3.yMin), ulCodePageRange1: 1, sxHeight: yt(e4, "xyvw", { yMax: Math.round(b3.ascender / 2) }).yMax, sCapHeight: yt(e4, "HIKLEFJMNTZBDPRAGOQSUVWXY", b3).yMax, usDefaultChar: e4.hasChar(" ") ? 32 : 0, usBreakChar: e4.hasChar(" ") ? 32 : 0 }), S3 = Ge.make(e4.glyphs), M2 = se.make(e4.glyphs), E2 = e4.getEnglishName("fontFamily"), T3 = e4.getEnglishName("fontSubfamily"), O3 = E2 + " " + T3, C2 = e4.getEnglishName("postScriptName");
            C2 = C2 || E2.replace(/\s/g, "") + "-" + T3;
            var L2 = {};
            for (var P3 in e4.names)
              L2[P3] = e4.names[P3];
            L2.uniqueID || (L2.uniqueID = { en: e4.getEnglishName("manufacturer") + ":" + O3 }), L2.postScriptName || (L2.postScriptName = { en: C2 }), L2.preferredFamily || (L2.preferredFamily = e4.names.fontFamily), L2.preferredSubfamily || (L2.preferredSubfamily = e4.names.fontSubfamily);
            var A2 = [], k3 = rt.make(L2, A2), R3 = 0 < A2.length ? Ve.make(A2) : void 0, D2 = it.make(), I2 = Ne.make(e4.glyphs, { version: e4.getEnglishName("version"), fullName: O3, familyName: E2, weightName: T3, postScriptName: C2, unitsPerEm: e4.unitsPerEm, fontBBox: [0, b3.yMin, b3.ascender, b3.advanceWidthMax] }), U2 = e4.metas && 0 < Object.keys(e4.metas).length ? ct.make(e4.metas) : void 0, N2 = [_2, x2, w2, j2, k3, M2, D2, I2, S3];
            R3 && N2.push(R3), e4.tables.gsub && N2.push(ut.make(e4.tables.gsub)), U2 && N2.push(U2);
            for (var F2 = pt(N2), B2 = ft(F2.encode()), G2 = F2.fields, V2 = false, z2 = 0; z2 < G2.length; z2 += 1)
              if (G2[z2].name === "head table") {
                G2[z2].value.checkSumAdjustment = 2981146554 - B2, V2 = true;
                break;
              }
            if (!V2)
              throw new Error("Could not find head table with checkSum to adjust.");
            return F2;
          }, computeCheckSum: ft };
          function gt(e4, t4) {
            for (var r4 = 0, n4 = e4.length - 1; r4 <= n4; ) {
              var o3 = r4 + n4 >>> 1, i3 = e4[o3].tag;
              if (i3 === t4)
                return o3;
              i3 < t4 ? r4 = 1 + o3 : n4 = o3 - 1;
            }
            return -r4 - 1;
          }
          function vt(e4, t4) {
            for (var r4 = 0, n4 = e4.length - 1; r4 <= n4; ) {
              var o3 = r4 + n4 >>> 1, i3 = e4[o3];
              if (i3 === t4)
                return o3;
              i3 < t4 ? r4 = 1 + o3 : n4 = o3 - 1;
            }
            return -r4 - 1;
          }
          function bt(e4, t4) {
            for (var r4, n4 = 0, o3 = e4.length - 1; n4 <= o3; ) {
              var i3 = n4 + o3 >>> 1, a3 = (r4 = e4[i3]).start;
              if (a3 === t4)
                return r4;
              a3 < t4 ? n4 = 1 + i3 : o3 = i3 - 1;
            }
            if (0 < n4)
              return t4 > (r4 = e4[n4 - 1]).end ? 0 : r4;
          }
          function _t(e4, t4) {
            this.font = e4, this.tableName = t4;
          }
          function xt(e4) {
            _t.call(this, e4, "gpos");
          }
          function wt(e4) {
            _t.call(this, e4, "gsub");
          }
          function jt(e4, t4) {
            var r4 = e4.length;
            if (r4 !== t4.length)
              return false;
            for (var n4 = 0; n4 < r4; n4++)
              if (e4[n4] !== t4[n4])
                return false;
            return true;
          }
          function St(e4, t4, r4) {
            for (var n4 = e4.subtables, o3 = 0; o3 < n4.length; o3++) {
              var i3 = n4[o3];
              if (i3.substFormat === t4)
                return i3;
            }
            if (r4)
              return n4.push(r4), r4;
          }
          function Mt(e4) {
            for (var t4 = new ArrayBuffer(e4.length), r4 = new Uint8Array(t4), n4 = 0; n4 < e4.length; ++n4)
              r4[n4] = e4[n4];
            return t4;
          }
          function Et(e4, t4) {
            if (!e4)
              throw t4;
          }
          function Tt(e4, t4, r4, n4, o3) {
            var i3;
            return i3 = 0 < (t4 & n4) ? (i3 = e4.parseByte(), (t4 & o3) == 0 && (i3 = -i3), r4 + i3) : 0 < (t4 & o3) ? r4 : r4 + e4.parseShort();
          }
          function Ot(e4, t4, r4) {
            var n4, o3, i3 = new ae.Parser(t4, r4);
            if (e4.numberOfContours = i3.parseShort(), e4._xMin = i3.parseShort(), e4._yMin = i3.parseShort(), e4._xMax = i3.parseShort(), e4._yMax = i3.parseShort(), 0 < e4.numberOfContours) {
              for (var a3 = e4.endPointIndices = [], s2 = 0; s2 < e4.numberOfContours; s2 += 1)
                a3.push(i3.parseUShort());
              e4.instructionLength = i3.parseUShort(), e4.instructions = [];
              for (var l3 = 0; l3 < e4.instructionLength; l3 += 1)
                e4.instructions.push(i3.parseByte());
              var u3 = a3[a3.length - 1] + 1;
              n4 = [];
              for (var c2 = 0; c2 < u3; c2 += 1)
                if (o3 = i3.parseByte(), n4.push(o3), 0 < (8 & o3))
                  for (var d2 = i3.parseByte(), f2 = 0; f2 < d2; f2 += 1)
                    n4.push(o3), c2 += 1;
              if (L.argument(n4.length === u3, "Bad flags."), 0 < a3.length) {
                var h3, p3 = [];
                if (0 < u3) {
                  for (var y2 = 0; y2 < u3; y2 += 1)
                    o3 = n4[y2], (h3 = {}).onCurve = !!(1 & o3), h3.lastPointOfContour = 0 <= a3.indexOf(y2), p3.push(h3);
                  for (var m3 = 0, g2 = 0; g2 < u3; g2 += 1)
                    o3 = n4[g2], (h3 = p3[g2]).x = Tt(i3, o3, m3, 2, 16), m3 = h3.x;
                  for (var v2 = 0, b3 = 0; b3 < u3; b3 += 1)
                    o3 = n4[b3], (h3 = p3[b3]).y = Tt(i3, o3, v2, 4, 32), v2 = h3.y;
                }
                e4.points = p3;
              } else
                e4.points = [];
            } else if (e4.numberOfContours === 0)
              e4.points = [];
            else {
              e4.isComposite = true, e4.points = [], e4.components = [];
              for (var _2 = true; _2; ) {
                n4 = i3.parseUShort();
                var x2 = { glyphIndex: i3.parseUShort(), xScale: 1, scale01: 0, scale10: 0, yScale: 1, dx: 0, dy: 0 };
                0 < (1 & n4) ? 0 < (2 & n4) ? (x2.dx = i3.parseShort(), x2.dy = i3.parseShort()) : x2.matchedPoints = [i3.parseUShort(), i3.parseUShort()] : 0 < (2 & n4) ? (x2.dx = i3.parseChar(), x2.dy = i3.parseChar()) : x2.matchedPoints = [i3.parseByte(), i3.parseByte()], 0 < (8 & n4) ? x2.xScale = x2.yScale = i3.parseF2Dot14() : 0 < (64 & n4) ? (x2.xScale = i3.parseF2Dot14(), x2.yScale = i3.parseF2Dot14()) : 0 < (128 & n4) && (x2.xScale = i3.parseF2Dot14(), x2.scale01 = i3.parseF2Dot14(), x2.scale10 = i3.parseF2Dot14(), x2.yScale = i3.parseF2Dot14()), e4.components.push(x2), _2 = !!(32 & n4);
              }
              if (256 & n4) {
                e4.instructionLength = i3.parseUShort(), e4.instructions = [];
                for (var w2 = 0; w2 < e4.instructionLength; w2 += 1)
                  e4.instructions.push(i3.parseByte());
              }
            }
          }
          function Ct(e4, t4) {
            for (var r4 = [], n4 = 0; n4 < e4.length; n4 += 1) {
              var o3 = e4[n4], i3 = { x: t4.xScale * o3.x + t4.scale01 * o3.y + t4.dx, y: t4.scale10 * o3.x + t4.yScale * o3.y + t4.dy, onCurve: o3.onCurve, lastPointOfContour: o3.lastPointOfContour };
              r4.push(i3);
            }
            return r4;
          }
          function Lt(e4) {
            var t4 = new D();
            if (!e4)
              return t4;
            for (var r4 = function(e5) {
              for (var t5 = [], r5 = [], n5 = 0; n5 < e5.length; n5 += 1) {
                var o4 = e5[n5];
                r5.push(o4), o4.lastPointOfContour && (t5.push(r5), r5 = []);
              }
              return L.argument(r5.length === 0, "There are still points left in the current contour."), t5;
            }(e4), n4 = 0; n4 < r4.length; ++n4) {
              var o3 = r4[n4], i3 = null, a3 = o3[o3.length - 1], s2 = o3[0];
              if (a3.onCurve)
                t4.moveTo(a3.x, a3.y);
              else if (s2.onCurve)
                t4.moveTo(s2.x, s2.y);
              else {
                var l3 = { x: 0.5 * (a3.x + s2.x), y: 0.5 * (a3.y + s2.y) };
                t4.moveTo(l3.x, l3.y);
              }
              for (var u3 = 0; u3 < o3.length; ++u3)
                if (i3 = a3, a3 = s2, s2 = o3[(u3 + 1) % o3.length], a3.onCurve)
                  t4.lineTo(a3.x, a3.y);
                else {
                  var c2 = s2;
                  i3.onCurve || { x: 0.5 * (a3.x + i3.x), y: 0.5 * (a3.y + i3.y) }, s2.onCurve || (c2 = { x: 0.5 * (a3.x + s2.x), y: 0.5 * (a3.y + s2.y) }), t4.quadraticCurveTo(a3.x, a3.y, c2.x, c2.y);
                }
              t4.closePath();
            }
            return t4;
          }
          function Pt(e4, t4) {
            if (t4.isComposite)
              for (var r4 = 0; r4 < t4.components.length; r4 += 1) {
                var n4 = t4.components[r4], o3 = e4.get(n4.glyphIndex);
                if (o3.getPath(), o3.points) {
                  var i3 = void 0;
                  if (n4.matchedPoints === void 0)
                    i3 = Ct(o3.points, n4);
                  else {
                    if (n4.matchedPoints[0] > t4.points.length - 1 || n4.matchedPoints[1] > o3.points.length - 1)
                      throw Error("Matched points out of range in " + t4.name);
                    var a3 = t4.points[n4.matchedPoints[0]], s2 = o3.points[n4.matchedPoints[1]], l3 = { xScale: n4.xScale, scale01: n4.scale01, scale10: n4.scale10, yScale: n4.yScale, dx: 0, dy: 0 };
                    s2 = Ct([s2], l3)[0], l3.dx = a3.x - s2.x, l3.dy = a3.y - s2.y, i3 = Ct(o3.points, l3);
                  }
                  t4.points = t4.points.concat(i3);
                }
              }
            return Lt(t4.points);
          }
          (xt.prototype = _t.prototype = { searchTag: gt, binSearch: vt, getTable: function(e4) {
            var t4 = this.font.tables[this.tableName];
            return !t4 && e4 && (t4 = this.font.tables[this.tableName] = this.createDefaultTable()), t4;
          }, getScriptNames: function() {
            var e4 = this.getTable();
            return e4 ? e4.scripts.map(function(e5) {
              return e5.tag;
            }) : [];
          }, getDefaultScriptName: function() {
            var e4 = this.getTable();
            if (e4) {
              for (var t4 = false, r4 = 0; r4 < e4.scripts.length; r4++) {
                var n4 = e4.scripts[r4].tag;
                if (n4 === "DFLT")
                  return n4;
                n4 === "latn" && (t4 = true);
              }
              return t4 ? "latn" : void 0;
            }
          }, getScriptTable: function(e4, t4) {
            var r4 = this.getTable(t4);
            if (r4) {
              e4 = e4 || "DFLT";
              var n4 = r4.scripts, o3 = gt(r4.scripts, e4);
              if (0 <= o3)
                return n4[o3].script;
              if (t4) {
                var i3 = { tag: e4, script: { defaultLangSys: { reserved: 0, reqFeatureIndex: 65535, featureIndexes: [] }, langSysRecords: [] } };
                return n4.splice(-1 - o3, 0, i3), i3.script;
              }
            }
          }, getLangSysTable: function(e4, t4, r4) {
            var n4 = this.getScriptTable(e4, r4);
            if (n4) {
              if (!t4 || t4 === "dflt" || t4 === "DFLT")
                return n4.defaultLangSys;
              var o3 = gt(n4.langSysRecords, t4);
              if (0 <= o3)
                return n4.langSysRecords[o3].langSys;
              if (r4) {
                var i3 = { tag: t4, langSys: { reserved: 0, reqFeatureIndex: 65535, featureIndexes: [] } };
                return n4.langSysRecords.splice(-1 - o3, 0, i3), i3.langSys;
              }
            }
          }, getFeatureTable: function(e4, t4, r4, n4) {
            var o3 = this.getLangSysTable(e4, t4, n4);
            if (o3) {
              for (var i3, a3 = o3.featureIndexes, s2 = this.font.tables[this.tableName].features, l3 = 0; l3 < a3.length; l3++)
                if ((i3 = s2[a3[l3]]).tag === r4)
                  return i3.feature;
              if (n4) {
                var u3 = s2.length;
                return L.assert(u3 === 0 || r4 >= s2[u3 - 1].tag, "Features must be added in alphabetical order."), i3 = { tag: r4, feature: { params: 0, lookupListIndexes: [] } }, s2.push(i3), a3.push(u3), i3.feature;
              }
            }
          }, getLookupTables: function(e4, t4, r4, n4, o3) {
            var i3 = this.getFeatureTable(e4, t4, r4, o3), a3 = [];
            if (i3) {
              for (var s2, l3 = i3.lookupListIndexes, u3 = this.font.tables[this.tableName].lookups, c2 = 0; c2 < l3.length; c2++)
                (s2 = u3[l3[c2]]).lookupType === n4 && a3.push(s2);
              if (a3.length === 0 && o3) {
                s2 = { lookupType: n4, lookupFlag: 0, subtables: [], markFilteringSet: void 0 };
                var d2 = u3.length;
                return u3.push(s2), l3.push(d2), [s2];
              }
            }
            return a3;
          }, getGlyphClass: function(e4, t4) {
            switch (e4.format) {
              case 1:
                return e4.startGlyph <= t4 && t4 < e4.startGlyph + e4.classes.length ? e4.classes[t4 - e4.startGlyph] : 0;
              case 2:
                var r4 = bt(e4.ranges, t4);
                return r4 ? r4.classId : 0;
            }
          }, getCoverageIndex: function(e4, t4) {
            switch (e4.format) {
              case 1:
                var r4 = vt(e4.glyphs, t4);
                return 0 <= r4 ? r4 : -1;
              case 2:
                var n4 = bt(e4.ranges, t4);
                return n4 ? n4.index + t4 - n4.start : -1;
            }
          }, expandCoverage: function(e4) {
            if (e4.format === 1)
              return e4.glyphs;
            for (var t4 = [], r4 = e4.ranges, n4 = 0; n4 < r4.length; n4++)
              for (var o3 = r4[n4], i3 = o3.start, a3 = o3.end, s2 = i3; s2 <= a3; s2++)
                t4.push(s2);
            return t4;
          } }).init = function() {
            var e4 = this.getDefaultScriptName();
            this.defaultKerningTables = this.getKerningTables(e4);
          }, xt.prototype.getKerningValue = function(e4, t4, r4) {
            for (var n4 = 0; n4 < e4.length; n4++)
              for (var o3 = e4[n4].subtables, i3 = 0; i3 < o3.length; i3++) {
                var a3 = o3[i3], s2 = this.getCoverageIndex(a3.coverage, t4);
                if (!(s2 < 0))
                  switch (a3.posFormat) {
                    case 1:
                      for (var l3 = a3.pairSets[s2], u3 = 0; u3 < l3.length; u3++) {
                        var c2 = l3[u3];
                        if (c2.secondGlyph === r4)
                          return c2.value1 && c2.value1.xAdvance || 0;
                      }
                      break;
                    case 2:
                      var d2 = this.getGlyphClass(a3.classDef1, t4), f2 = this.getGlyphClass(a3.classDef2, r4), h3 = a3.classRecords[d2][f2];
                      return h3.value1 && h3.value1.xAdvance || 0;
                  }
              }
            return 0;
          }, xt.prototype.getKerningTables = function(e4, t4) {
            if (this.font.tables.gpos)
              return this.getLookupTables(e4, t4, "kern", 2);
          }, (wt.prototype = _t.prototype).createDefaultTable = function() {
            return { version: 1, scripts: [{ tag: "DFLT", script: { defaultLangSys: { reserved: 0, reqFeatureIndex: 65535, featureIndexes: [] }, langSysRecords: [] } }], features: [], lookups: [] };
          }, wt.prototype.getSingle = function(e4, t4, r4) {
            for (var n4 = [], o3 = this.getLookupTables(t4, r4, e4, 1), i3 = 0; i3 < o3.length; i3++)
              for (var a3 = o3[i3].subtables, s2 = 0; s2 < a3.length; s2++) {
                var l3 = a3[s2], u3 = this.expandCoverage(l3.coverage), c2 = void 0;
                if (l3.substFormat === 1) {
                  var d2 = l3.deltaGlyphId;
                  for (c2 = 0; c2 < u3.length; c2++) {
                    var f2 = u3[c2];
                    n4.push({ sub: f2, by: f2 + d2 });
                  }
                } else {
                  var h3 = l3.substitute;
                  for (c2 = 0; c2 < u3.length; c2++)
                    n4.push({ sub: u3[c2], by: h3[c2] });
                }
              }
            return n4;
          }, wt.prototype.getAlternates = function(e4, t4, r4) {
            for (var n4 = [], o3 = this.getLookupTables(t4, r4, e4, 3), i3 = 0; i3 < o3.length; i3++)
              for (var a3 = o3[i3].subtables, s2 = 0; s2 < a3.length; s2++)
                for (var l3 = a3[s2], u3 = this.expandCoverage(l3.coverage), c2 = l3.alternateSets, d2 = 0; d2 < u3.length; d2++)
                  n4.push({ sub: u3[d2], by: c2[d2] });
            return n4;
          }, wt.prototype.getLigatures = function(e4, t4, r4) {
            for (var n4 = [], o3 = this.getLookupTables(t4, r4, e4, 4), i3 = 0; i3 < o3.length; i3++)
              for (var a3 = o3[i3].subtables, s2 = 0; s2 < a3.length; s2++)
                for (var l3 = a3[s2], u3 = this.expandCoverage(l3.coverage), c2 = l3.ligatureSets, d2 = 0; d2 < u3.length; d2++)
                  for (var f2 = u3[d2], h3 = c2[d2], p3 = 0; p3 < h3.length; p3++) {
                    var y2 = h3[p3];
                    n4.push({ sub: [f2].concat(y2.components), by: y2.ligGlyph });
                  }
            return n4;
          }, wt.prototype.addSingle = function(e4, t4, r4, n4) {
            var o3 = St(this.getLookupTables(r4, n4, e4, 1, true)[0], 2, { substFormat: 2, coverage: { format: 1, glyphs: [] }, substitute: [] });
            L.assert(o3.coverage.format === 1, "Ligature: unable to modify coverage table format " + o3.coverage.format);
            var i3 = t4.sub, a3 = this.binSearch(o3.coverage.glyphs, i3);
            a3 < 0 && (a3 = -1 - a3, o3.coverage.glyphs.splice(a3, 0, i3), o3.substitute.splice(a3, 0, 0)), o3.substitute[a3] = t4.by;
          }, wt.prototype.addAlternate = function(e4, t4, r4, n4) {
            var o3 = St(this.getLookupTables(r4, n4, e4, 3, true)[0], 1, { substFormat: 1, coverage: { format: 1, glyphs: [] }, alternateSets: [] });
            L.assert(o3.coverage.format === 1, "Ligature: unable to modify coverage table format " + o3.coverage.format);
            var i3 = t4.sub, a3 = this.binSearch(o3.coverage.glyphs, i3);
            a3 < 0 && (a3 = -1 - a3, o3.coverage.glyphs.splice(a3, 0, i3), o3.alternateSets.splice(a3, 0, 0)), o3.alternateSets[a3] = t4.by;
          }, wt.prototype.addLigature = function(e4, t4, r4, n4) {
            var o3 = this.getLookupTables(r4, n4, e4, 4, true)[0], i3 = o3.subtables[0];
            i3 || (i3 = { substFormat: 1, coverage: { format: 1, glyphs: [] }, ligatureSets: [] }, o3.subtables[0] = i3), L.assert(i3.coverage.format === 1, "Ligature: unable to modify coverage table format " + i3.coverage.format);
            var a3 = t4.sub[0], s2 = t4.sub.slice(1), l3 = { ligGlyph: t4.by, components: s2 }, u3 = this.binSearch(i3.coverage.glyphs, a3);
            if (0 <= u3) {
              for (var c2 = i3.ligatureSets[u3], d2 = 0; d2 < c2.length; d2++)
                if (jt(c2[d2].components, s2))
                  return;
              c2.push(l3);
            } else
              u3 = -1 - u3, i3.coverage.glyphs.splice(u3, 0, a3), i3.ligatureSets.splice(u3, 0, [l3]);
          }, wt.prototype.getFeature = function(e4, t4, r4) {
            if (/ss\d\d/.test(e4))
              return this.getSingle(e4, t4, r4);
            switch (e4) {
              case "aalt":
              case "salt":
                return this.getSingle(e4, t4, r4).concat(this.getAlternates(e4, t4, r4));
              case "dlig":
              case "liga":
              case "rlig":
                return this.getLigatures(e4, t4, r4);
            }
          }, wt.prototype.add = function(e4, t4, r4, n4) {
            if (/ss\d\d/.test(e4))
              return this.addSingle(e4, t4, r4, n4);
            switch (e4) {
              case "aalt":
              case "salt":
                return typeof t4.by == "number" ? this.addSingle(e4, t4, r4, n4) : this.addAlternate(e4, t4, r4, n4);
              case "dlig":
              case "liga":
              case "rlig":
                return this.addLigature(e4, t4, r4, n4);
            }
          };
          var At, kt, Rt, Dt, It = { getPath: Lt, parse: function(e4, t4, r4, n4) {
            for (var o3 = new _e.GlyphSet(n4), i3 = 0; i3 < r4.length - 1; i3 += 1) {
              var a3 = r4[i3];
              a3 !== r4[i3 + 1] ? o3.push(i3, _e.ttfGlyphLoader(n4, i3, Ot, e4, t4 + a3, Pt)) : o3.push(i3, _e.glyphLoader(n4, i3));
            }
            return o3;
          } };
          function Ut(e4) {
            this.font = e4, this.getCommands = function(e5) {
              return It.getPath(e5).commands;
            }, this._fpgmState = this._prepState = void 0, this._errorState = 0;
          }
          function Nt(e4) {
            return e4;
          }
          function Ft(e4) {
            return Math.sign(e4) * Math.round(Math.abs(e4));
          }
          function Bt(e4) {
            return Math.sign(e4) * Math.round(Math.abs(2 * e4)) / 2;
          }
          function Gt(e4) {
            return Math.sign(e4) * (Math.round(Math.abs(e4) + 0.5) - 0.5);
          }
          function Vt(e4) {
            return Math.sign(e4) * Math.ceil(Math.abs(e4));
          }
          function zt(e4) {
            return Math.sign(e4) * Math.floor(Math.abs(e4));
          }
          function Ht(e4) {
            var t4 = this.srPeriod, r4 = this.srPhase, n4 = 1;
            return e4 < 0 && (e4 = -e4, n4 = -1), e4 += this.srThreshold - r4, e4 = Math.trunc(e4 / t4) * t4, (e4 += r4) < 0 ? r4 * n4 : e4 * n4;
          }
          var Wt = { x: 1, y: 0, axis: "x", distance: function(e4, t4, r4, n4) {
            return (r4 ? e4.xo : e4.x) - (n4 ? t4.xo : t4.x);
          }, interpolate: function(e4, t4, r4, n4) {
            var o3, i3, a3, s2, l3, u3, c2;
            if (!n4 || n4 === this)
              return o3 = e4.xo - t4.xo, i3 = e4.xo - r4.xo, l3 = t4.x - t4.xo, u3 = r4.x - r4.xo, (c2 = (a3 = Math.abs(o3)) + (s2 = Math.abs(i3))) === 0 ? void (e4.x = e4.xo + (l3 + u3) / 2) : void (e4.x = e4.xo + (l3 * s2 + u3 * a3) / c2);
            o3 = n4.distance(e4, t4, true, true), i3 = n4.distance(e4, r4, true, true), l3 = n4.distance(t4, t4, false, true), u3 = n4.distance(r4, r4, false, true), (c2 = (a3 = Math.abs(o3)) + (s2 = Math.abs(i3))) !== 0 ? Wt.setRelative(e4, e4, (l3 * s2 + u3 * a3) / c2, n4, true) : Wt.setRelative(e4, e4, (l3 + u3) / 2, n4, true);
          }, normalSlope: Number.NEGATIVE_INFINITY, setRelative: function(e4, t4, r4, n4, o3) {
            if (n4 && n4 !== this) {
              var i3 = o3 ? t4.xo : t4.x, a3 = o3 ? t4.yo : t4.y, s2 = i3 + r4 * n4.x, l3 = a3 + r4 * n4.y;
              e4.x = s2 + (e4.y - l3) / n4.normalSlope;
            } else
              e4.x = (o3 ? t4.xo : t4.x) + r4;
          }, slope: 0, touch: function(e4) {
            e4.xTouched = true;
          }, touched: function(e4) {
            return e4.xTouched;
          }, untouch: function(e4) {
            e4.xTouched = false;
          } }, qt = { x: 0, y: 1, axis: "y", distance: function(e4, t4, r4, n4) {
            return (r4 ? e4.yo : e4.y) - (n4 ? t4.yo : t4.y);
          }, interpolate: function(e4, t4, r4, n4) {
            var o3, i3, a3, s2, l3, u3, c2;
            if (!n4 || n4 === this)
              return o3 = e4.yo - t4.yo, i3 = e4.yo - r4.yo, l3 = t4.y - t4.yo, u3 = r4.y - r4.yo, (c2 = (a3 = Math.abs(o3)) + (s2 = Math.abs(i3))) === 0 ? void (e4.y = e4.yo + (l3 + u3) / 2) : void (e4.y = e4.yo + (l3 * s2 + u3 * a3) / c2);
            o3 = n4.distance(e4, t4, true, true), i3 = n4.distance(e4, r4, true, true), l3 = n4.distance(t4, t4, false, true), u3 = n4.distance(r4, r4, false, true), (c2 = (a3 = Math.abs(o3)) + (s2 = Math.abs(i3))) !== 0 ? qt.setRelative(e4, e4, (l3 * s2 + u3 * a3) / c2, n4, true) : qt.setRelative(e4, e4, (l3 + u3) / 2, n4, true);
          }, normalSlope: 0, setRelative: function(e4, t4, r4, n4, o3) {
            if (n4 && n4 !== this) {
              var i3 = o3 ? t4.xo : t4.x, a3 = o3 ? t4.yo : t4.y, s2 = i3 + r4 * n4.x, l3 = a3 + r4 * n4.y;
              e4.y = l3 + n4.normalSlope * (e4.x - s2);
            } else
              e4.y = (o3 ? t4.yo : t4.y) + r4;
          }, slope: Number.POSITIVE_INFINITY, touch: function(e4) {
            e4.yTouched = true;
          }, touched: function(e4) {
            return e4.yTouched;
          }, untouch: function(e4) {
            e4.yTouched = false;
          } };
          function Xt(e4, t4) {
            this.x = e4, this.y = t4, this.axis = void 0, this.slope = t4 / e4, this.normalSlope = -e4 / t4, Object.freeze(this);
          }
          function Yt(e4, t4) {
            var r4 = Math.sqrt(e4 * e4 + t4 * t4);
            return t4 /= r4, (e4 /= r4) === 1 && t4 === 0 ? Wt : e4 === 0 && t4 === 1 ? qt : new Xt(e4, t4);
          }
          function Zt(e4, t4, r4, n4) {
            this.x = this.xo = Math.round(64 * e4) / 64, this.y = this.yo = Math.round(64 * t4) / 64, this.lastPointOfContour = r4, this.onCurve = n4, this.prevPointOnContour = void 0, this.nextPointOnContour = void 0, this.xTouched = false, this.yTouched = false, Object.preventExtensions(this);
          }
          Object.freeze(Wt), Object.freeze(qt), Xt.prototype.distance = function(e4, t4, r4, n4) {
            return this.x * Wt.distance(e4, t4, r4, n4) + this.y * qt.distance(e4, t4, r4, n4);
          }, Xt.prototype.interpolate = function(e4, t4, r4, n4) {
            var o3, i3, a3, s2, l3, u3, c2;
            a3 = n4.distance(e4, t4, true, true), s2 = n4.distance(e4, r4, true, true), o3 = n4.distance(t4, t4, false, true), i3 = n4.distance(r4, r4, false, true), (c2 = (l3 = Math.abs(a3)) + (u3 = Math.abs(s2))) !== 0 ? this.setRelative(e4, e4, (o3 * u3 + i3 * l3) / c2, n4, true) : this.setRelative(e4, e4, (o3 + i3) / 2, n4, true);
          }, Xt.prototype.setRelative = function(e4, t4, r4, n4, o3) {
            n4 = n4 || this;
            var i3 = o3 ? t4.xo : t4.x, a3 = o3 ? t4.yo : t4.y, s2 = i3 + r4 * n4.x, l3 = a3 + r4 * n4.y, u3 = n4.normalSlope, c2 = this.slope, d2 = e4.x, f2 = e4.y;
            e4.x = (c2 * d2 - u3 * s2 + l3 - f2) / (c2 - u3), e4.y = c2 * (e4.x - d2) + f2;
          }, Xt.prototype.touch = function(e4) {
            e4.xTouched = true, e4.yTouched = true;
          }, Zt.prototype.nextTouched = function(e4) {
            for (var t4 = this.nextPointOnContour; !e4.touched(t4) && t4 !== this; )
              t4 = t4.nextPointOnContour;
            return t4;
          }, Zt.prototype.prevTouched = function(e4) {
            for (var t4 = this.prevPointOnContour; !e4.touched(t4) && t4 !== this; )
              t4 = t4.prevPointOnContour;
            return t4;
          };
          var Qt = Object.freeze(new Zt(0, 0)), Kt = { cvCutIn: 17 / 16, deltaBase: 9, deltaShift: 0.125, loop: 1, minDis: 1, autoFlip: true };
          function Jt(e4, t4) {
            switch (this.env = e4, this.stack = [], this.prog = t4, e4) {
              case "glyf":
                this.zp0 = this.zp1 = this.zp2 = 1, this.rp0 = this.rp1 = this.rp2 = 0;
              case "prep":
                this.fv = this.pv = this.dpv = Wt, this.round = Ft;
            }
          }
          function $t(e4) {
            for (var t4 = e4.tZone = new Array(e4.gZone.length), r4 = 0; r4 < t4.length; r4++)
              t4[r4] = new Zt(0, 0);
          }
          function er(e4, t4) {
            var r4, n4 = e4.prog, o3 = e4.ip, i3 = 1;
            do {
              if ((r4 = n4[++o3]) === 88)
                i3++;
              else if (r4 === 89)
                i3--;
              else if (r4 === 64)
                o3 += n4[o3 + 1] + 1;
              else if (r4 === 65)
                o3 += 2 * n4[o3 + 1] + 1;
              else if (176 <= r4 && r4 <= 183)
                o3 += r4 - 176 + 1;
              else if (184 <= r4 && r4 <= 191)
                o3 += 2 * (r4 - 184 + 1);
              else if (t4 && i3 === 1 && r4 === 27)
                break;
            } while (0 < i3);
            e4.ip = o3;
          }
          function tr(e4, t4) {
            M.DEBUG && console.log(t4.step, "SVTCA[" + e4.axis + "]"), t4.fv = t4.pv = t4.dpv = e4;
          }
          function rr(e4, t4) {
            M.DEBUG && console.log(t4.step, "SPVTCA[" + e4.axis + "]"), t4.pv = t4.dpv = e4;
          }
          function nr(e4, t4) {
            M.DEBUG && console.log(t4.step, "SFVTCA[" + e4.axis + "]"), t4.fv = e4;
          }
          function or(e4, t4) {
            var r4, n4, o3 = t4.stack, i3 = o3.pop(), a3 = o3.pop(), s2 = t4.z2[i3], l3 = t4.z1[a3];
            M.DEBUG && console.log("SPVTL[" + e4 + "]", i3, a3), n4 = e4 ? (r4 = s2.y - l3.y, l3.x - s2.x) : (r4 = l3.x - s2.x, l3.y - s2.y), t4.pv = t4.dpv = Yt(r4, n4);
          }
          function ir(e4, t4) {
            var r4, n4, o3 = t4.stack, i3 = o3.pop(), a3 = o3.pop(), s2 = t4.z2[i3], l3 = t4.z1[a3];
            M.DEBUG && console.log("SFVTL[" + e4 + "]", i3, a3), n4 = e4 ? (r4 = s2.y - l3.y, l3.x - s2.x) : (r4 = l3.x - s2.x, l3.y - s2.y), t4.fv = Yt(r4, n4);
          }
          function ar(e4) {
            M.DEBUG && console.log(e4.step, "POP[]"), e4.stack.pop();
          }
          function sr(e4, t4) {
            var r4 = t4.stack.pop(), n4 = t4.z0[r4], o3 = t4.fv, i3 = t4.pv;
            M.DEBUG && console.log(t4.step, "MDAP[" + e4 + "]", r4);
            var a3 = i3.distance(n4, Qt);
            e4 && (a3 = t4.round(a3)), o3.setRelative(n4, Qt, a3, i3), o3.touch(n4), t4.rp0 = t4.rp1 = r4;
          }
          function lr(e4, t4) {
            var r4, n4, o3, i3 = t4.z2, a3 = i3.length - 2;
            M.DEBUG && console.log(t4.step, "IUP[" + e4.axis + "]");
            for (var s2 = 0; s2 < a3; s2++)
              r4 = i3[s2], e4.touched(r4) || (n4 = r4.prevTouched(e4)) !== r4 && (n4 === (o3 = r4.nextTouched(e4)) && e4.setRelative(r4, r4, e4.distance(n4, n4, false, true), e4, true), e4.interpolate(r4, n4, o3, e4));
          }
          function ur(e4, t4) {
            for (var r4 = t4.stack, n4 = e4 ? t4.rp1 : t4.rp2, o3 = (e4 ? t4.z0 : t4.z1)[n4], i3 = t4.fv, a3 = t4.pv, s2 = t4.loop, l3 = t4.z2; s2--; ) {
              var u3 = r4.pop(), c2 = l3[u3], d2 = a3.distance(o3, o3, false, true);
              i3.setRelative(c2, c2, d2, a3), i3.touch(c2), M.DEBUG && console.log(t4.step, (1 < t4.loop ? "loop " + (t4.loop - s2) + ": " : "") + "SHP[" + (e4 ? "rp1" : "rp2") + "]", u3);
            }
            t4.loop = 1;
          }
          function cr(e4, t4) {
            var r4 = t4.stack, n4 = e4 ? t4.rp1 : t4.rp2, o3 = (e4 ? t4.z0 : t4.z1)[n4], i3 = t4.fv, a3 = t4.pv, s2 = r4.pop(), l3 = t4.z2[t4.contours[s2]], u3 = l3;
            M.DEBUG && console.log(t4.step, "SHC[" + e4 + "]", s2);
            for (var c2 = a3.distance(o3, o3, false, true); u3 !== o3 && i3.setRelative(u3, u3, c2, a3), (u3 = u3.nextPointOnContour) !== l3; )
              ;
          }
          function dr(e4, t4) {
            var r4, n4, o3 = t4.stack, i3 = e4 ? t4.rp1 : t4.rp2, a3 = (e4 ? t4.z0 : t4.z1)[i3], s2 = t4.fv, l3 = t4.pv, u3 = o3.pop();
            switch (M.DEBUG && console.log(t4.step, "SHZ[" + e4 + "]", u3), u3) {
              case 0:
                r4 = t4.tZone;
                break;
              case 1:
                r4 = t4.gZone;
                break;
              default:
                throw new Error("Invalid zone");
            }
            for (var c2 = l3.distance(a3, a3, false, true), d2 = r4.length - 2, f2 = 0; f2 < d2; f2++)
              n4 = r4[f2], s2.setRelative(n4, n4, c2, l3);
          }
          function fr(e4, t4) {
            var r4 = t4.stack, n4 = r4.pop() / 64, o3 = r4.pop(), i3 = t4.z1[o3], a3 = t4.z0[t4.rp0], s2 = t4.fv, l3 = t4.pv;
            s2.setRelative(i3, a3, n4, l3), s2.touch(i3), M.DEBUG && console.log(t4.step, "MSIRP[" + e4 + "]", n4, o3), t4.rp1 = t4.rp0, t4.rp2 = o3, e4 && (t4.rp0 = o3);
          }
          function hr(e4, t4) {
            var r4 = t4.stack, n4 = r4.pop(), o3 = r4.pop(), i3 = t4.z0[o3], a3 = t4.fv, s2 = t4.pv, l3 = t4.cvt[n4];
            M.DEBUG && console.log(t4.step, "MIAP[" + e4 + "]", n4, "(", l3, ")", o3);
            var u3 = s2.distance(i3, Qt);
            e4 && (Math.abs(u3 - l3) < t4.cvCutIn && (u3 = l3), u3 = t4.round(u3)), a3.setRelative(i3, Qt, u3, s2), t4.zp0 === 0 && (i3.xo = i3.x, i3.yo = i3.y), a3.touch(i3), t4.rp0 = t4.rp1 = o3;
          }
          function pr(e4, t4) {
            var r4 = t4.stack, n4 = r4.pop(), o3 = t4.z2[n4];
            M.DEBUG && console.log(t4.step, "GC[" + e4 + "]", n4), r4.push(64 * t4.dpv.distance(o3, Qt, e4, false));
          }
          function yr(e4, t4) {
            var r4 = t4.stack, n4 = r4.pop(), o3 = r4.pop(), i3 = t4.z1[n4], a3 = t4.z0[o3], s2 = t4.dpv.distance(a3, i3, e4, e4);
            M.DEBUG && console.log(t4.step, "MD[" + e4 + "]", n4, o3, "->", s2), t4.stack.push(Math.round(64 * s2));
          }
          function mr(e4, t4) {
            var r4 = t4.stack, n4 = r4.pop(), o3 = t4.fv, i3 = t4.pv, a3 = t4.ppem, s2 = t4.deltaBase + 16 * (e4 - 1), l3 = t4.deltaShift, u3 = t4.z0;
            M.DEBUG && console.log(t4.step, "DELTAP[" + e4 + "]", n4, r4);
            for (var c2 = 0; c2 < n4; c2++) {
              var d2 = r4.pop(), f2 = r4.pop();
              if (s2 + ((240 & f2) >> 4) === a3) {
                var h3 = (15 & f2) - 8;
                0 <= h3 && h3++, M.DEBUG && console.log(t4.step, "DELTAPFIX", d2, "by", h3 * l3);
                var p3 = u3[d2];
                o3.setRelative(p3, p3, h3 * l3, i3);
              }
            }
          }
          function gr(e4, t4) {
            var r4 = t4.stack, n4 = r4.pop();
            M.DEBUG && console.log(t4.step, "ROUND[]"), r4.push(64 * t4.round(n4 / 64));
          }
          function vr(e4, t4) {
            var r4 = t4.stack, n4 = r4.pop(), o3 = t4.ppem, i3 = t4.deltaBase + 16 * (e4 - 1), a3 = t4.deltaShift;
            M.DEBUG && console.log(t4.step, "DELTAC[" + e4 + "]", n4, r4);
            for (var s2 = 0; s2 < n4; s2++) {
              var l3 = r4.pop(), u3 = r4.pop();
              if (i3 + ((240 & u3) >> 4) === o3) {
                var c2 = (15 & u3) - 8;
                0 <= c2 && c2++;
                var d2 = c2 * a3;
                M.DEBUG && console.log(t4.step, "DELTACFIX", l3, "by", d2), t4.cvt[l3] += d2;
              }
            }
          }
          function br(e4, t4) {
            var r4, n4, o3 = t4.stack, i3 = o3.pop(), a3 = o3.pop(), s2 = t4.z2[i3], l3 = t4.z1[a3];
            M.DEBUG && console.log(t4.step, "SDPVTL[" + e4 + "]", i3, a3), n4 = e4 ? (r4 = s2.y - l3.y, l3.x - s2.x) : (r4 = l3.x - s2.x, l3.y - s2.y), t4.dpv = Yt(r4, n4);
          }
          function _r(e4, t4) {
            var r4 = t4.stack, n4 = t4.prog, o3 = t4.ip;
            M.DEBUG && console.log(t4.step, "PUSHB[" + e4 + "]");
            for (var i3 = 0; i3 < e4; i3++)
              r4.push(n4[++o3]);
            t4.ip = o3;
          }
          function xr(e4, t4) {
            var r4 = t4.ip, n4 = t4.prog, o3 = t4.stack;
            M.DEBUG && console.log(t4.ip, "PUSHW[" + e4 + "]");
            for (var i3 = 0; i3 < e4; i3++) {
              var a3 = n4[++r4] << 8 | n4[++r4];
              32768 & a3 && (a3 = -(1 + (65535 ^ a3))), o3.push(a3);
            }
            t4.ip = r4;
          }
          function wr(e4, t4, r4, n4, o3, i3) {
            var a3, s2, l3, u3, c2 = i3.stack, d2 = e4 && c2.pop(), f2 = c2.pop(), h3 = i3.rp0, p3 = i3.z0[h3], y2 = i3.z1[f2], m3 = i3.minDis, g2 = i3.fv, v2 = i3.dpv;
            l3 = 0 <= (s2 = a3 = v2.distance(y2, p3, true, true)) ? 1 : -1, s2 = Math.abs(s2), e4 && (u3 = i3.cvt[d2], n4 && Math.abs(s2 - u3) < i3.cvCutIn && (s2 = u3)), r4 && s2 < m3 && (s2 = m3), n4 && (s2 = i3.round(s2)), g2.setRelative(y2, p3, l3 * s2, v2), g2.touch(y2), M.DEBUG && console.log(i3.step, (e4 ? "MIRP[" : "MDRP[") + (t4 ? "M" : "m") + (r4 ? ">" : "_") + (n4 ? "R" : "_") + (o3 === 0 ? "Gr" : o3 === 1 ? "Bl" : o3 === 2 ? "Wh" : "") + "]", e4 ? d2 + "(" + i3.cvt[d2] + "," + u3 + ")" : "", f2, "(d =", a3, "->", l3 * s2, ")"), i3.rp1 = i3.rp0, i3.rp2 = f2, t4 && (i3.rp0 = f2);
          }
          Ut.prototype.exec = function(e4, t4) {
            if (typeof t4 != "number")
              throw new Error("Point size is not a number!");
            if (!(2 < this._errorState)) {
              var r4 = this.font, n4 = this._prepState;
              if (!n4 || n4.ppem !== t4) {
                var o3 = this._fpgmState;
                if (!o3) {
                  Jt.prototype = Kt, (o3 = this._fpgmState = new Jt("fpgm", r4.tables.fpgm)).funcs = [], o3.font = r4, M.DEBUG && (console.log("---EXEC FPGM---"), o3.step = -1);
                  try {
                    kt(o3);
                  } catch (e5) {
                    return console.log("Hinting error in FPGM:" + e5), void (this._errorState = 3);
                  }
                }
                Jt.prototype = o3, (n4 = this._prepState = new Jt("prep", r4.tables.prep)).ppem = t4;
                var i3 = r4.tables.cvt;
                if (i3)
                  for (var a3 = n4.cvt = new Array(i3.length), s2 = t4 / r4.unitsPerEm, l3 = 0; l3 < i3.length; l3++)
                    a3[l3] = i3[l3] * s2;
                else
                  n4.cvt = [];
                M.DEBUG && (console.log("---EXEC PREP---"), n4.step = -1);
                try {
                  kt(n4);
                } catch (e5) {
                  this._errorState < 2 && console.log("Hinting error in PREP:" + e5), this._errorState = 2;
                }
              }
              if (!(1 < this._errorState))
                try {
                  return Rt(e4, n4);
                } catch (e5) {
                  return this._errorState < 1 && (console.log("Hinting error:" + e5), console.log("Note: further hinting errors are silenced")), void (this._errorState = 1);
                }
            }
          }, Rt = function(e4, t4) {
            var r4, n4, o3, i3 = t4.ppem / t4.font.unitsPerEm, a3 = i3, s2 = e4.components;
            if (Jt.prototype = t4, s2) {
              var l3 = t4.font;
              n4 = [], r4 = [];
              for (var u3 = 0; u3 < s2.length; u3++) {
                var c2 = s2[u3], d2 = l3.glyphs.get(c2.glyphIndex);
                o3 = new Jt("glyf", d2.instructions), M.DEBUG && (console.log("---EXEC COMP " + u3 + "---"), o3.step = -1), Dt(d2, o3, i3, a3);
                for (var f2 = Math.round(c2.dx * i3), h3 = Math.round(c2.dy * a3), p3 = o3.gZone, y2 = o3.contours, m3 = 0; m3 < p3.length; m3++) {
                  var g2 = p3[m3];
                  g2.xTouched = g2.yTouched = false, g2.xo = g2.x = g2.x + f2, g2.yo = g2.y = g2.y + h3;
                }
                var v2 = n4.length;
                n4.push.apply(n4, p3);
                for (var b3 = 0; b3 < y2.length; b3++)
                  r4.push(y2[b3] + v2);
              }
              e4.instructions && !o3.inhibitGridFit && ((o3 = new Jt("glyf", e4.instructions)).gZone = o3.z0 = o3.z1 = o3.z2 = n4, o3.contours = r4, n4.push(new Zt(0, 0), new Zt(Math.round(e4.advanceWidth * i3), 0)), M.DEBUG && (console.log("---EXEC COMPOSITE---"), o3.step = -1), kt(o3), n4.length -= 2);
            } else
              o3 = new Jt("glyf", e4.instructions), M.DEBUG && (console.log("---EXEC GLYPH---"), o3.step = -1), Dt(e4, o3, i3, a3), n4 = o3.gZone;
            return n4;
          }, Dt = function(e4, t4, r4, n4) {
            for (var o3, i3, a3, s2 = e4.points || [], l3 = s2.length, u3 = t4.gZone = t4.z0 = t4.z1 = t4.z2 = [], c2 = t4.contours = [], d2 = 0; d2 < l3; d2++)
              o3 = s2[d2], u3[d2] = new Zt(o3.x * r4, o3.y * n4, o3.lastPointOfContour, o3.onCurve);
            for (var f2 = 0; f2 < l3; f2++)
              o3 = u3[f2], i3 || (i3 = o3, c2.push(f2)), o3.lastPointOfContour ? ((o3.nextPointOnContour = i3).prevPointOnContour = o3, i3 = void 0) : (a3 = u3[f2 + 1], (o3.nextPointOnContour = a3).prevPointOnContour = o3);
            if (!t4.inhibitGridFit) {
              if (M.DEBUG) {
                console.log("PROCESSING GLYPH", t4.stack);
                for (var h3 = 0; h3 < l3; h3++)
                  console.log(h3, u3[h3].x, u3[h3].y);
              }
              if (u3.push(new Zt(0, 0), new Zt(Math.round(e4.advanceWidth * r4), 0)), kt(t4), u3.length -= 2, M.DEBUG) {
                console.log("FINISHED GLYPH", t4.stack);
                for (var p3 = 0; p3 < l3; p3++)
                  console.log(p3, u3[p3].x, u3[p3].y);
              }
            }
          }, kt = function(e4) {
            var t4 = e4.prog;
            if (t4) {
              var r4, n4 = t4.length;
              for (e4.ip = 0; e4.ip < n4; e4.ip++) {
                if (M.DEBUG && e4.step++, !(r4 = At[t4[e4.ip]]))
                  throw new Error("unknown instruction: 0x" + Number(t4[e4.ip]).toString(16));
                r4(e4);
              }
            }
          }, At = [tr.bind(void 0, qt), tr.bind(void 0, Wt), rr.bind(void 0, qt), rr.bind(void 0, Wt), nr.bind(void 0, qt), nr.bind(void 0, Wt), or.bind(void 0, 0), or.bind(void 0, 1), ir.bind(void 0, 0), ir.bind(void 0, 1), function(e4) {
            var t4 = e4.stack, r4 = t4.pop(), n4 = t4.pop();
            M.DEBUG && console.log(e4.step, "SPVFS[]", r4, n4), e4.pv = e4.dpv = Yt(n4, r4);
          }, function(e4) {
            var t4 = e4.stack, r4 = t4.pop(), n4 = t4.pop();
            M.DEBUG && console.log(e4.step, "SPVFS[]", r4, n4), e4.fv = Yt(n4, r4);
          }, function(e4) {
            var t4 = e4.stack, r4 = e4.pv;
            M.DEBUG && console.log(e4.step, "GPV[]"), t4.push(16384 * r4.x), t4.push(16384 * r4.y);
          }, function(e4) {
            var t4 = e4.stack, r4 = e4.fv;
            M.DEBUG && console.log(e4.step, "GFV[]"), t4.push(16384 * r4.x), t4.push(16384 * r4.y);
          }, function(e4) {
            e4.fv = e4.pv, M.DEBUG && console.log(e4.step, "SFVTPV[]");
          }, function(e4) {
            var t4 = e4.stack, r4 = t4.pop(), n4 = t4.pop(), o3 = t4.pop(), i3 = t4.pop(), a3 = t4.pop(), s2 = e4.z0, l3 = e4.z1, u3 = s2[r4], c2 = s2[n4], d2 = l3[o3], f2 = l3[i3], h3 = e4.z2[a3];
            M.DEBUG && console.log("ISECT[], ", r4, n4, o3, i3, a3);
            var p3 = u3.x, y2 = u3.y, m3 = c2.x, g2 = c2.y, v2 = d2.x, b3 = d2.y, _2 = f2.x, x2 = f2.y, w2 = (p3 - m3) * (b3 - x2) - (y2 - g2) * (v2 - _2), j2 = p3 * g2 - y2 * m3, S3 = v2 * x2 - b3 * _2;
            h3.x = (j2 * (v2 - _2) - S3 * (p3 - m3)) / w2, h3.y = (j2 * (b3 - x2) - S3 * (y2 - g2)) / w2;
          }, function(e4) {
            e4.rp0 = e4.stack.pop(), M.DEBUG && console.log(e4.step, "SRP0[]", e4.rp0);
          }, function(e4) {
            e4.rp1 = e4.stack.pop(), M.DEBUG && console.log(e4.step, "SRP1[]", e4.rp1);
          }, function(e4) {
            e4.rp2 = e4.stack.pop(), M.DEBUG && console.log(e4.step, "SRP2[]", e4.rp2);
          }, function(e4) {
            var t4 = e4.stack.pop();
            switch (M.DEBUG && console.log(e4.step, "SZP0[]", t4), e4.zp0 = t4) {
              case 0:
                e4.tZone || $t(e4), e4.z0 = e4.tZone;
                break;
              case 1:
                e4.z0 = e4.gZone;
                break;
              default:
                throw new Error("Invalid zone pointer");
            }
          }, function(e4) {
            var t4 = e4.stack.pop();
            switch (M.DEBUG && console.log(e4.step, "SZP1[]", t4), e4.zp1 = t4) {
              case 0:
                e4.tZone || $t(e4), e4.z1 = e4.tZone;
                break;
              case 1:
                e4.z1 = e4.gZone;
                break;
              default:
                throw new Error("Invalid zone pointer");
            }
          }, function(e4) {
            var t4 = e4.stack.pop();
            switch (M.DEBUG && console.log(e4.step, "SZP2[]", t4), e4.zp2 = t4) {
              case 0:
                e4.tZone || $t(e4), e4.z2 = e4.tZone;
                break;
              case 1:
                e4.z2 = e4.gZone;
                break;
              default:
                throw new Error("Invalid zone pointer");
            }
          }, function(e4) {
            var t4 = e4.stack.pop();
            switch (M.DEBUG && console.log(e4.step, "SZPS[]", t4), e4.zp0 = e4.zp1 = e4.zp2 = t4, t4) {
              case 0:
                e4.tZone || $t(e4), e4.z0 = e4.z1 = e4.z2 = e4.tZone;
                break;
              case 1:
                e4.z0 = e4.z1 = e4.z2 = e4.gZone;
                break;
              default:
                throw new Error("Invalid zone pointer");
            }
          }, function(e4) {
            e4.loop = e4.stack.pop(), M.DEBUG && console.log(e4.step, "SLOOP[]", e4.loop);
          }, function(e4) {
            M.DEBUG && console.log(e4.step, "RTG[]"), e4.round = Ft;
          }, function(e4) {
            M.DEBUG && console.log(e4.step, "RTHG[]"), e4.round = Gt;
          }, function(e4) {
            var t4 = e4.stack.pop();
            M.DEBUG && console.log(e4.step, "SMD[]", t4), e4.minDis = t4 / 64;
          }, function(e4) {
            M.DEBUG && console.log(e4.step, "ELSE[]"), er(e4, false);
          }, function(e4) {
            var t4 = e4.stack.pop();
            M.DEBUG && console.log(e4.step, "JMPR[]", t4), e4.ip += t4 - 1;
          }, function(e4) {
            var t4 = e4.stack.pop();
            M.DEBUG && console.log(e4.step, "SCVTCI[]", t4), e4.cvCutIn = t4 / 64;
          }, void 0, void 0, function(e4) {
            var t4 = e4.stack;
            M.DEBUG && console.log(e4.step, "DUP[]"), t4.push(t4[t4.length - 1]);
          }, ar, function(e4) {
            M.DEBUG && console.log(e4.step, "CLEAR[]"), e4.stack.length = 0;
          }, function(e4) {
            var t4 = e4.stack, r4 = t4.pop(), n4 = t4.pop();
            M.DEBUG && console.log(e4.step, "SWAP[]"), t4.push(r4), t4.push(n4);
          }, function(e4) {
            var t4 = e4.stack;
            M.DEBUG && console.log(e4.step, "DEPTH[]"), t4.push(t4.length);
          }, function(e4) {
            var t4 = e4.stack, r4 = t4.pop();
            M.DEBUG && console.log(e4.step, "CINDEX[]", r4), t4.push(t4[t4.length - r4]);
          }, function(e4) {
            var t4 = e4.stack, r4 = t4.pop();
            M.DEBUG && console.log(e4.step, "MINDEX[]", r4), t4.push(t4.splice(t4.length - r4, 1)[0]);
          }, void 0, void 0, void 0, function(e4) {
            var t4 = e4.stack, r4 = t4.pop(), n4 = t4.pop();
            M.DEBUG && console.log(e4.step, "LOOPCALL[]", r4, n4);
            var o3 = e4.ip, i3 = e4.prog;
            e4.prog = e4.funcs[r4];
            for (var a3 = 0; a3 < n4; a3++)
              kt(e4), M.DEBUG && console.log(++e4.step, a3 + 1 < n4 ? "next loopcall" : "done loopcall", a3);
            e4.ip = o3, e4.prog = i3;
          }, function(e4) {
            var t4 = e4.stack.pop();
            M.DEBUG && console.log(e4.step, "CALL[]", t4);
            var r4 = e4.ip, n4 = e4.prog;
            e4.prog = e4.funcs[t4], kt(e4), e4.ip = r4, e4.prog = n4, M.DEBUG && console.log(++e4.step, "returning from", t4);
          }, function(e4) {
            if (e4.env !== "fpgm")
              throw new Error("FDEF not allowed here");
            var t4 = e4.stack, r4 = e4.prog, n4 = e4.ip, o3 = t4.pop(), i3 = n4;
            for (M.DEBUG && console.log(e4.step, "FDEF[]", o3); r4[++n4] !== 45; )
              ;
            e4.ip = n4, e4.funcs[o3] = r4.slice(i3 + 1, n4);
          }, void 0, sr.bind(void 0, 0), sr.bind(void 0, 1), lr.bind(void 0, qt), lr.bind(void 0, Wt), ur.bind(void 0, 0), ur.bind(void 0, 1), cr.bind(void 0, 0), cr.bind(void 0, 1), dr.bind(void 0, 0), dr.bind(void 0, 1), function(e4) {
            for (var t4 = e4.stack, r4 = e4.loop, n4 = e4.fv, o3 = t4.pop() / 64, i3 = e4.z2; r4--; ) {
              var a3 = t4.pop(), s2 = i3[a3];
              M.DEBUG && console.log(e4.step, (1 < e4.loop ? "loop " + (e4.loop - r4) + ": " : "") + "SHPIX[]", a3, o3), n4.setRelative(s2, s2, o3), n4.touch(s2);
            }
            e4.loop = 1;
          }, function(e4) {
            for (var t4 = e4.stack, r4 = e4.rp1, n4 = e4.rp2, o3 = e4.loop, i3 = e4.z0[r4], a3 = e4.z1[n4], s2 = e4.fv, l3 = e4.dpv, u3 = e4.z2; o3--; ) {
              var c2 = t4.pop(), d2 = u3[c2];
              M.DEBUG && console.log(e4.step, (1 < e4.loop ? "loop " + (e4.loop - o3) + ": " : "") + "IP[]", c2, r4, "<->", n4), s2.interpolate(d2, i3, a3, l3), s2.touch(d2);
            }
            e4.loop = 1;
          }, fr.bind(void 0, 0), fr.bind(void 0, 1), function(e4) {
            for (var t4 = e4.stack, r4 = e4.rp0, n4 = e4.z0[r4], o3 = e4.loop, i3 = e4.fv, a3 = e4.pv, s2 = e4.z1; o3--; ) {
              var l3 = t4.pop(), u3 = s2[l3];
              M.DEBUG && console.log(e4.step, (1 < e4.loop ? "loop " + (e4.loop - o3) + ": " : "") + "ALIGNRP[]", l3), i3.setRelative(u3, n4, 0, a3), i3.touch(u3);
            }
            e4.loop = 1;
          }, function(e4) {
            M.DEBUG && console.log(e4.step, "RTDG[]"), e4.round = Bt;
          }, hr.bind(void 0, 0), hr.bind(void 0, 1), function(e4) {
            var t4 = e4.prog, r4 = e4.ip, n4 = e4.stack, o3 = t4[++r4];
            M.DEBUG && console.log(e4.step, "NPUSHB[]", o3);
            for (var i3 = 0; i3 < o3; i3++)
              n4.push(t4[++r4]);
            e4.ip = r4;
          }, function(e4) {
            var t4 = e4.ip, r4 = e4.prog, n4 = e4.stack, o3 = r4[++t4];
            M.DEBUG && console.log(e4.step, "NPUSHW[]", o3);
            for (var i3 = 0; i3 < o3; i3++) {
              var a3 = r4[++t4] << 8 | r4[++t4];
              32768 & a3 && (a3 = -(1 + (65535 ^ a3))), n4.push(a3);
            }
            e4.ip = t4;
          }, function(e4) {
            var t4 = e4.stack, r4 = e4.store;
            r4 = r4 || (e4.store = []);
            var n4 = t4.pop(), o3 = t4.pop();
            M.DEBUG && console.log(e4.step, "WS", n4, o3), r4[o3] = n4;
          }, function(e4) {
            var t4 = e4.stack, r4 = e4.store, n4 = t4.pop();
            M.DEBUG && console.log(e4.step, "RS", n4);
            var o3 = r4 && r4[n4] || 0;
            t4.push(o3);
          }, function(e4) {
            var t4 = e4.stack, r4 = t4.pop(), n4 = t4.pop();
            M.DEBUG && console.log(e4.step, "WCVTP", r4, n4), e4.cvt[n4] = r4 / 64;
          }, function(e4) {
            var t4 = e4.stack, r4 = t4.pop();
            M.DEBUG && console.log(e4.step, "RCVT", r4), t4.push(64 * e4.cvt[r4]);
          }, pr.bind(void 0, 0), pr.bind(void 0, 1), void 0, yr.bind(void 0, 0), yr.bind(void 0, 1), function(e4) {
            M.DEBUG && console.log(e4.step, "MPPEM[]"), e4.stack.push(e4.ppem);
          }, void 0, function(e4) {
            M.DEBUG && console.log(e4.step, "FLIPON[]"), e4.autoFlip = true;
          }, void 0, void 0, function(e4) {
            var t4 = e4.stack, r4 = t4.pop(), n4 = t4.pop();
            M.DEBUG && console.log(e4.step, "LT[]", r4, n4), t4.push(n4 < r4 ? 1 : 0);
          }, function(e4) {
            var t4 = e4.stack, r4 = t4.pop(), n4 = t4.pop();
            M.DEBUG && console.log(e4.step, "LTEQ[]", r4, n4), t4.push(n4 <= r4 ? 1 : 0);
          }, function(e4) {
            var t4 = e4.stack, r4 = t4.pop(), n4 = t4.pop();
            M.DEBUG && console.log(e4.step, "GT[]", r4, n4), t4.push(r4 < n4 ? 1 : 0);
          }, function(e4) {
            var t4 = e4.stack, r4 = t4.pop(), n4 = t4.pop();
            M.DEBUG && console.log(e4.step, "GTEQ[]", r4, n4), t4.push(r4 <= n4 ? 1 : 0);
          }, function(e4) {
            var t4 = e4.stack, r4 = t4.pop(), n4 = t4.pop();
            M.DEBUG && console.log(e4.step, "EQ[]", r4, n4), t4.push(r4 === n4 ? 1 : 0);
          }, function(e4) {
            var t4 = e4.stack, r4 = t4.pop(), n4 = t4.pop();
            M.DEBUG && console.log(e4.step, "NEQ[]", r4, n4), t4.push(r4 !== n4 ? 1 : 0);
          }, function(e4) {
            var t4 = e4.stack, r4 = t4.pop();
            M.DEBUG && console.log(e4.step, "ODD[]", r4), t4.push(Math.trunc(r4) % 2 ? 1 : 0);
          }, function(e4) {
            var t4 = e4.stack, r4 = t4.pop();
            M.DEBUG && console.log(e4.step, "EVEN[]", r4), t4.push(Math.trunc(r4) % 2 ? 0 : 1);
          }, function(e4) {
            var t4 = e4.stack.pop();
            M.DEBUG && console.log(e4.step, "IF[]", t4), t4 || (er(e4, true), M.DEBUG && console.log(e4.step, "EIF[]"));
          }, function(e4) {
            M.DEBUG && console.log(e4.step, "EIF[]");
          }, function(e4) {
            var t4 = e4.stack, r4 = t4.pop(), n4 = t4.pop();
            M.DEBUG && console.log(e4.step, "AND[]", r4, n4), t4.push(r4 && n4 ? 1 : 0);
          }, function(e4) {
            var t4 = e4.stack, r4 = t4.pop(), n4 = t4.pop();
            M.DEBUG && console.log(e4.step, "OR[]", r4, n4), t4.push(r4 || n4 ? 1 : 0);
          }, function(e4) {
            var t4 = e4.stack, r4 = t4.pop();
            M.DEBUG && console.log(e4.step, "NOT[]", r4), t4.push(r4 ? 0 : 1);
          }, mr.bind(void 0, 1), function(e4) {
            var t4 = e4.stack.pop();
            M.DEBUG && console.log(e4.step, "SDB[]", t4), e4.deltaBase = t4;
          }, function(e4) {
            var t4 = e4.stack.pop();
            M.DEBUG && console.log(e4.step, "SDS[]", t4), e4.deltaShift = Math.pow(0.5, t4);
          }, function(e4) {
            var t4 = e4.stack, r4 = t4.pop(), n4 = t4.pop();
            M.DEBUG && console.log(e4.step, "ADD[]", r4, n4), t4.push(n4 + r4);
          }, function(e4) {
            var t4 = e4.stack, r4 = t4.pop(), n4 = t4.pop();
            M.DEBUG && console.log(e4.step, "SUB[]", r4, n4), t4.push(n4 - r4);
          }, function(e4) {
            var t4 = e4.stack, r4 = t4.pop(), n4 = t4.pop();
            M.DEBUG && console.log(e4.step, "DIV[]", r4, n4), t4.push(64 * n4 / r4);
          }, function(e4) {
            var t4 = e4.stack, r4 = t4.pop(), n4 = t4.pop();
            M.DEBUG && console.log(e4.step, "MUL[]", r4, n4), t4.push(n4 * r4 / 64);
          }, function(e4) {
            var t4 = e4.stack, r4 = t4.pop();
            M.DEBUG && console.log(e4.step, "ABS[]", r4), t4.push(Math.abs(r4));
          }, function(e4) {
            var t4 = e4.stack, r4 = t4.pop();
            M.DEBUG && console.log(e4.step, "NEG[]", r4), t4.push(-r4);
          }, function(e4) {
            var t4 = e4.stack, r4 = t4.pop();
            M.DEBUG && console.log(e4.step, "FLOOR[]", r4), t4.push(64 * Math.floor(r4 / 64));
          }, function(e4) {
            var t4 = e4.stack, r4 = t4.pop();
            M.DEBUG && console.log(e4.step, "CEILING[]", r4), t4.push(64 * Math.ceil(r4 / 64));
          }, gr.bind(void 0, 0), gr.bind(void 0, 1), gr.bind(void 0, 2), gr.bind(void 0, 3), void 0, void 0, void 0, void 0, function(e4) {
            var t4 = e4.stack, r4 = t4.pop(), n4 = t4.pop();
            M.DEBUG && console.log(e4.step, "WCVTF[]", r4, n4), e4.cvt[n4] = r4 * e4.ppem / e4.font.unitsPerEm;
          }, mr.bind(void 0, 2), mr.bind(void 0, 3), vr.bind(void 0, 1), vr.bind(void 0, 2), vr.bind(void 0, 3), function(e4) {
            var t4, r4 = e4.stack.pop();
            switch (M.DEBUG && console.log(e4.step, "SROUND[]", r4), e4.round = Ht, 192 & r4) {
              case 0:
                t4 = 0.5;
                break;
              case 64:
                t4 = 1;
                break;
              case 128:
                t4 = 2;
                break;
              default:
                throw new Error("invalid SROUND value");
            }
            switch (e4.srPeriod = t4, 48 & r4) {
              case 0:
                e4.srPhase = 0;
                break;
              case 16:
                e4.srPhase = 0.25 * t4;
                break;
              case 32:
                e4.srPhase = 0.5 * t4;
                break;
              case 48:
                e4.srPhase = 0.75 * t4;
                break;
              default:
                throw new Error("invalid SROUND value");
            }
            r4 &= 15, e4.srThreshold = r4 === 0 ? 0 : (r4 / 8 - 0.5) * t4;
          }, function(e4) {
            var t4, r4 = e4.stack.pop();
            switch (M.DEBUG && console.log(e4.step, "S45ROUND[]", r4), e4.round = Ht, 192 & r4) {
              case 0:
                t4 = Math.sqrt(2) / 2;
                break;
              case 64:
                t4 = Math.sqrt(2);
                break;
              case 128:
                t4 = 2 * Math.sqrt(2);
                break;
              default:
                throw new Error("invalid S45ROUND value");
            }
            switch (e4.srPeriod = t4, 48 & r4) {
              case 0:
                e4.srPhase = 0;
                break;
              case 16:
                e4.srPhase = 0.25 * t4;
                break;
              case 32:
                e4.srPhase = 0.5 * t4;
                break;
              case 48:
                e4.srPhase = 0.75 * t4;
                break;
              default:
                throw new Error("invalid S45ROUND value");
            }
            r4 &= 15, e4.srThreshold = r4 === 0 ? 0 : (r4 / 8 - 0.5) * t4;
          }, void 0, void 0, function(e4) {
            M.DEBUG && console.log(e4.step, "ROFF[]"), e4.round = Nt;
          }, void 0, function(e4) {
            M.DEBUG && console.log(e4.step, "RUTG[]"), e4.round = Vt;
          }, function(e4) {
            M.DEBUG && console.log(e4.step, "RDTG[]"), e4.round = zt;
          }, ar, ar, void 0, void 0, void 0, void 0, void 0, function(e4) {
            var t4 = e4.stack.pop();
            M.DEBUG && console.log(e4.step, "SCANCTRL[]", t4);
          }, br.bind(void 0, 0), br.bind(void 0, 1), function(e4) {
            var t4 = e4.stack, r4 = t4.pop(), n4 = 0;
            M.DEBUG && console.log(e4.step, "GETINFO[]", r4), 1 & r4 && (n4 = 35), 32 & r4 && (n4 |= 4096), t4.push(n4);
          }, void 0, function(e4) {
            var t4 = e4.stack, r4 = t4.pop(), n4 = t4.pop(), o3 = t4.pop();
            M.DEBUG && console.log(e4.step, "ROLL[]"), t4.push(n4), t4.push(r4), t4.push(o3);
          }, function(e4) {
            var t4 = e4.stack, r4 = t4.pop(), n4 = t4.pop();
            M.DEBUG && console.log(e4.step, "MAX[]", r4, n4), t4.push(Math.max(n4, r4));
          }, function(e4) {
            var t4 = e4.stack, r4 = t4.pop(), n4 = t4.pop();
            M.DEBUG && console.log(e4.step, "MIN[]", r4, n4), t4.push(Math.min(n4, r4));
          }, function(e4) {
            var t4 = e4.stack.pop();
            M.DEBUG && console.log(e4.step, "SCANTYPE[]", t4);
          }, function(e4) {
            var t4 = e4.stack.pop(), r4 = e4.stack.pop();
            switch (M.DEBUG && console.log(e4.step, "INSTCTRL[]", t4, r4), t4) {
              case 1:
                return void (e4.inhibitGridFit = !!r4);
              case 2:
                return void (e4.ignoreCvt = !!r4);
              default:
                throw new Error("invalid INSTCTRL[] selector");
            }
          }, void 0, void 0, void 0, void 0, void 0, void 0, void 0, void 0, void 0, void 0, void 0, void 0, void 0, void 0, void 0, void 0, void 0, void 0, void 0, void 0, void 0, void 0, void 0, void 0, void 0, void 0, void 0, void 0, void 0, void 0, void 0, void 0, void 0, _r.bind(void 0, 1), _r.bind(void 0, 2), _r.bind(void 0, 3), _r.bind(void 0, 4), _r.bind(void 0, 5), _r.bind(void 0, 6), _r.bind(void 0, 7), _r.bind(void 0, 8), xr.bind(void 0, 1), xr.bind(void 0, 2), xr.bind(void 0, 3), xr.bind(void 0, 4), xr.bind(void 0, 5), xr.bind(void 0, 6), xr.bind(void 0, 7), xr.bind(void 0, 8), wr.bind(void 0, 0, 0, 0, 0, 0), wr.bind(void 0, 0, 0, 0, 0, 1), wr.bind(void 0, 0, 0, 0, 0, 2), wr.bind(void 0, 0, 0, 0, 0, 3), wr.bind(void 0, 0, 0, 0, 1, 0), wr.bind(void 0, 0, 0, 0, 1, 1), wr.bind(void 0, 0, 0, 0, 1, 2), wr.bind(void 0, 0, 0, 0, 1, 3), wr.bind(void 0, 0, 0, 1, 0, 0), wr.bind(void 0, 0, 0, 1, 0, 1), wr.bind(void 0, 0, 0, 1, 0, 2), wr.bind(void 0, 0, 0, 1, 0, 3), wr.bind(void 0, 0, 0, 1, 1, 0), wr.bind(void 0, 0, 0, 1, 1, 1), wr.bind(void 0, 0, 0, 1, 1, 2), wr.bind(void 0, 0, 0, 1, 1, 3), wr.bind(void 0, 0, 1, 0, 0, 0), wr.bind(void 0, 0, 1, 0, 0, 1), wr.bind(void 0, 0, 1, 0, 0, 2), wr.bind(void 0, 0, 1, 0, 0, 3), wr.bind(void 0, 0, 1, 0, 1, 0), wr.bind(void 0, 0, 1, 0, 1, 1), wr.bind(void 0, 0, 1, 0, 1, 2), wr.bind(void 0, 0, 1, 0, 1, 3), wr.bind(void 0, 0, 1, 1, 0, 0), wr.bind(void 0, 0, 1, 1, 0, 1), wr.bind(void 0, 0, 1, 1, 0, 2), wr.bind(void 0, 0, 1, 1, 0, 3), wr.bind(void 0, 0, 1, 1, 1, 0), wr.bind(void 0, 0, 1, 1, 1, 1), wr.bind(void 0, 0, 1, 1, 1, 2), wr.bind(void 0, 0, 1, 1, 1, 3), wr.bind(void 0, 1, 0, 0, 0, 0), wr.bind(void 0, 1, 0, 0, 0, 1), wr.bind(void 0, 1, 0, 0, 0, 2), wr.bind(void 0, 1, 0, 0, 0, 3), wr.bind(void 0, 1, 0, 0, 1, 0), wr.bind(void 0, 1, 0, 0, 1, 1), wr.bind(void 0, 1, 0, 0, 1, 2), wr.bind(void 0, 1, 0, 0, 1, 3), wr.bind(void 0, 1, 0, 1, 0, 0), wr.bind(void 0, 1, 0, 1, 0, 1), wr.bind(void 0, 1, 0, 1, 0, 2), wr.bind(void 0, 1, 0, 1, 0, 3), wr.bind(void 0, 1, 0, 1, 1, 0), wr.bind(void 0, 1, 0, 1, 1, 1), wr.bind(void 0, 1, 0, 1, 1, 2), wr.bind(void 0, 1, 0, 1, 1, 3), wr.bind(void 0, 1, 1, 0, 0, 0), wr.bind(void 0, 1, 1, 0, 0, 1), wr.bind(void 0, 1, 1, 0, 0, 2), wr.bind(void 0, 1, 1, 0, 0, 3), wr.bind(void 0, 1, 1, 0, 1, 0), wr.bind(void 0, 1, 1, 0, 1, 1), wr.bind(void 0, 1, 1, 0, 1, 2), wr.bind(void 0, 1, 1, 0, 1, 3), wr.bind(void 0, 1, 1, 1, 0, 0), wr.bind(void 0, 1, 1, 1, 0, 1), wr.bind(void 0, 1, 1, 1, 0, 2), wr.bind(void 0, 1, 1, 1, 0, 3), wr.bind(void 0, 1, 1, 1, 1, 0), wr.bind(void 0, 1, 1, 1, 1, 1), wr.bind(void 0, 1, 1, 1, 1, 2), wr.bind(void 0, 1, 1, 1, 1, 3)];
          var jr = Array.from || function(e4) {
            return e4.match(/[\uD800-\uDBFF][\uDC00-\uDFFF]?|[^\uD800-\uDFFF]|./g) || [];
          };
          function Sr(e4) {
            (e4 = e4 || {}).empty || (Et(e4.familyName, "When creating a new Font object, familyName is required."), Et(e4.styleName, "When creating a new Font object, styleName is required."), Et(e4.unitsPerEm, "When creating a new Font object, unitsPerEm is required."), Et(e4.ascender, "When creating a new Font object, ascender is required."), Et(e4.descender, "When creating a new Font object, descender is required."), Et(e4.descender < 0, "Descender should be negative (e.g. -512)."), this.names = { fontFamily: { en: e4.familyName || " " }, fontSubfamily: { en: e4.styleName || " " }, fullName: { en: e4.fullName || e4.familyName + " " + e4.styleName }, postScriptName: { en: e4.postScriptName || (e4.familyName + e4.styleName).replace(/\s/g, "") }, designer: { en: e4.designer || " " }, designerURL: { en: e4.designerURL || " " }, manufacturer: { en: e4.manufacturer || " " }, manufacturerURL: { en: e4.manufacturerURL || " " }, license: { en: e4.license || " " }, licenseURL: { en: e4.licenseURL || " " }, version: { en: e4.version || "Version 0.1" }, description: { en: e4.description || " " }, copyright: { en: e4.copyright || " " }, trademark: { en: e4.trademark || " " } }, this.unitsPerEm = e4.unitsPerEm || 1e3, this.ascender = e4.ascender, this.descender = e4.descender, this.createdTimestamp = e4.createdTimestamp, this.tables = { os2: { usWeightClass: e4.weightClass || this.usWeightClasses.MEDIUM, usWidthClass: e4.widthClass || this.usWidthClasses.MEDIUM, fsSelection: e4.fsSelection || this.fsSelectionValues.REGULAR } }), this.supported = true, this.glyphs = new _e.GlyphSet(this, e4.glyphs || []), this.encoding = new fe(this), this.position = new xt(this), this.substitution = new wt(this), this.tables = this.tables || {}, Object.defineProperty(this, "hinting", { get: function() {
              return this._hinting ? this._hinting : this.outlinesFormat === "truetype" ? this._hinting = new Ut(this) : void 0;
            } });
          }
          function Mr(e4, t4) {
            var r4 = JSON.stringify(e4), n4 = 256;
            for (var o3 in t4) {
              var i3 = parseInt(o3);
              if (i3 && !(i3 < 256)) {
                if (JSON.stringify(t4[o3]) === r4)
                  return i3;
                n4 <= i3 && (n4 = i3 + 1);
              }
            }
            return t4[n4] = e4, n4;
          }
          function Er(e4, t4, r4, n4) {
            for (var o3 = [{ name: "nameID_" + e4, type: "USHORT", value: Mr(t4.name, n4) }, { name: "flags_" + e4, type: "USHORT", value: 0 }], i3 = 0; i3 < r4.length; ++i3) {
              var a3 = r4[i3].tag;
              o3.push({ name: "axis_" + e4 + " " + a3, type: "FIXED", value: t4.coordinates[a3] << 16 });
            }
            return o3;
          }
          function Tr(e4, t4, r4, n4) {
            var o3 = {}, i3 = new ae.Parser(e4, t4);
            o3.name = n4[i3.parseUShort()] || {}, i3.skip("uShort", 1), o3.coordinates = {};
            for (var a3 = 0; a3 < r4.length; ++a3)
              o3.coordinates[r4[a3].tag] = i3.parseFixed();
            return o3;
          }
          Sr.prototype.hasChar = function(e4) {
            return this.encoding.charToGlyphIndex(e4) !== null;
          }, Sr.prototype.charToGlyphIndex = function(e4) {
            return this.encoding.charToGlyphIndex(e4);
          }, Sr.prototype.charToGlyph = function(e4) {
            var t4 = this.charToGlyphIndex(e4), r4 = this.glyphs.get(t4);
            return r4 = r4 || this.glyphs.get(0);
          }, Sr.prototype.stringToGlyphs = function(e4, t4) {
            t4 = t4 || this.defaultRenderOptions;
            for (var r4 = jr(e4), n4 = [], o3 = 0; o3 < r4.length; o3 += 1) {
              var i3 = r4[o3];
              n4.push(this.charToGlyphIndex(i3));
            }
            var a3 = n4.length;
            if (t4.features) {
              var s2 = t4.script || this.substitution.getDefaultScriptName(), l3 = [];
              t4.features.liga && (l3 = l3.concat(this.substitution.getFeature("liga", s2, t4.language))), t4.features.rlig && (l3 = l3.concat(this.substitution.getFeature("rlig", s2, t4.language)));
              for (var u3 = 0; u3 < a3; u3 += 1)
                for (var c2 = 0; c2 < l3.length; c2++) {
                  for (var d2 = l3[c2], f2 = d2.sub, h3 = f2.length, p3 = 0; p3 < h3 && f2[p3] === n4[u3 + p3]; )
                    p3++;
                  p3 === h3 && (n4.splice(u3, h3, d2.by), a3 = a3 - h3 + 1);
                }
            }
            for (var y2 = new Array(a3), m3 = this.glyphs.get(0), g2 = 0; g2 < a3; g2 += 1)
              y2[g2] = this.glyphs.get(n4[g2]) || m3;
            return y2;
          }, Sr.prototype.nameToGlyphIndex = function(e4) {
            return this.glyphNames.nameToGlyphIndex(e4);
          }, Sr.prototype.nameToGlyph = function(e4) {
            var t4 = this.nameToGlyphIndex(e4), r4 = this.glyphs.get(t4);
            return r4 = r4 || this.glyphs.get(0);
          }, Sr.prototype.glyphIndexToName = function(e4) {
            return this.glyphNames.glyphIndexToName ? this.glyphNames.glyphIndexToName(e4) : "";
          }, Sr.prototype.getKerningValue = function(e4, t4) {
            e4 = e4.index || e4, t4 = t4.index || t4;
            var r4 = this.position.defaultKerningTables;
            return r4 ? this.position.getKerningValue(r4, e4, t4) : this.kerningPairs[e4 + "," + t4] || 0;
          }, Sr.prototype.defaultRenderOptions = { kerning: true, features: { liga: true, rlig: true } }, Sr.prototype.forEachGlyph = function(e4, t4, r4, n4, o3, i3) {
            t4 = t4 !== void 0 ? t4 : 0, r4 = r4 !== void 0 ? r4 : 0, n4 = n4 !== void 0 ? n4 : 72, o3 = o3 || this.defaultRenderOptions;
            var a3, s2 = 1 / this.unitsPerEm * n4, l3 = this.stringToGlyphs(e4, o3);
            if (o3.kerning) {
              var u3 = o3.script || this.position.getDefaultScriptName();
              a3 = this.position.getKerningTables(u3, o3.language);
            }
            for (var c2 = 0; c2 < l3.length; c2 += 1) {
              var d2 = l3[c2];
              if (i3.call(this, d2, t4, r4, n4, o3), d2.advanceWidth && (t4 += d2.advanceWidth * s2), o3.kerning && c2 < l3.length - 1)
                t4 += (a3 ? this.position.getKerningValue(a3, d2.index, l3[c2 + 1].index) : this.getKerningValue(d2, l3[c2 + 1])) * s2;
              o3.letterSpacing ? t4 += o3.letterSpacing * n4 : o3.tracking && (t4 += o3.tracking / 1e3 * n4);
            }
            return t4;
          }, Sr.prototype.getPath = function(e4, t4, r4, n4, i3) {
            var a3 = new D();
            return this.forEachGlyph(e4, t4, r4, n4, i3, function(e5, t5, r5, n5) {
              var o3 = e5.getPath(t5, r5, n5, i3, this);
              a3.extend(o3);
            }), a3;
          }, Sr.prototype.getPaths = function(e4, t4, r4, n4, i3) {
            var a3 = [];
            return this.forEachGlyph(e4, t4, r4, n4, i3, function(e5, t5, r5, n5) {
              var o3 = e5.getPath(t5, r5, n5, i3, this);
              a3.push(o3);
            }), a3;
          }, Sr.prototype.getAdvanceWidth = function(e4, t4, r4) {
            return this.forEachGlyph(e4, 0, 0, t4, r4, function() {
            });
          }, Sr.prototype.draw = function(e4, t4, r4, n4, o3, i3) {
            this.getPath(t4, r4, n4, o3, i3).draw(e4);
          }, Sr.prototype.drawPoints = function(o3, e4, t4, r4, n4, i3) {
            this.forEachGlyph(e4, t4, r4, n4, i3, function(e5, t5, r5, n5) {
              e5.drawPoints(o3, t5, r5, n5);
            });
          }, Sr.prototype.drawMetrics = function(o3, e4, t4, r4, n4, i3) {
            this.forEachGlyph(e4, t4, r4, n4, i3, function(e5, t5, r5, n5) {
              e5.drawMetrics(o3, t5, r5, n5);
            });
          }, Sr.prototype.getEnglishName = function(e4) {
            var t4 = this.names[e4];
            if (t4)
              return t4.en;
          }, Sr.prototype.validate = function() {
            var r4 = this;
            function e4(e5) {
              var t4 = r4.getEnglishName(e5);
              t4 && t4.trim().length;
            }
            e4("fontFamily"), e4("weightName"), e4("manufacturer"), e4("copyright"), e4("version"), this.unitsPerEm;
          }, Sr.prototype.toTables = function() {
            return mt.fontToTable(this);
          }, Sr.prototype.toBuffer = function() {
            return console.warn("Font.toBuffer is deprecated. Use Font.toArrayBuffer instead."), this.toArrayBuffer();
          }, Sr.prototype.toArrayBuffer = function() {
            for (var e4 = this.toTables().encode(), t4 = new ArrayBuffer(e4.length), r4 = new Uint8Array(t4), n4 = 0; n4 < e4.length; n4++)
              r4[n4] = e4[n4];
            return t4;
          }, Sr.prototype.download = function(t4) {
            var e4 = this.getEnglishName("fontFamily"), r4 = this.getEnglishName("fontSubfamily");
            t4 = t4 || e4.replace(/\s/g, "") + "-" + r4 + ".otf";
            var o3 = this.toArrayBuffer();
            if (typeof window != "undefined")
              window.requestFileSystem = window.requestFileSystem || window.webkitRequestFileSystem, window.requestFileSystem(window.TEMPORARY, o3.byteLength, function(e5) {
                e5.root.getFile(t4, { create: true }, function(n5) {
                  n5.createWriter(function(e6) {
                    var t5 = new DataView(o3), r5 = new Blob([t5], { type: "font/opentype" });
                    e6.write(r5), e6.addEventListener("writeend", function() {
                      location.href = n5.toURL();
                    }, false);
                  });
                });
              }, function(e5) {
                throw new Error(e5.name + ": " + e5.message);
              });
            else {
              var n4 = Br("fs"), i3 = function(e5) {
                for (var t5 = new Fr(e5.byteLength), r5 = new Uint8Array(e5), n5 = 0; n5 < t5.length; ++n5)
                  t5[n5] = r5[n5];
                return t5;
              }(o3);
              n4.writeFileSync(t4, i3);
            }
          }, Sr.prototype.fsSelectionValues = { ITALIC: 1, UNDERSCORE: 2, NEGATIVE: 4, OUTLINED: 8, STRIKEOUT: 16, BOLD: 32, REGULAR: 64, USER_TYPO_METRICS: 128, WWS: 256, OBLIQUE: 512 }, Sr.prototype.usWidthClasses = { ULTRA_CONDENSED: 1, EXTRA_CONDENSED: 2, CONDENSED: 3, SEMI_CONDENSED: 4, MEDIUM: 5, SEMI_EXPANDED: 6, EXPANDED: 7, EXTRA_EXPANDED: 8, ULTRA_EXPANDED: 9 }, Sr.prototype.usWeightClasses = { THIN: 100, EXTRA_LIGHT: 200, LIGHT: 300, NORMAL: 400, MEDIUM: 500, SEMI_BOLD: 600, BOLD: 700, EXTRA_BOLD: 800, BLACK: 900 };
          var Or = { make: function(e4, t4) {
            var r4, n4, o3, i3, a3 = new J.Table("fvar", [{ name: "version", type: "ULONG", value: 65536 }, { name: "offsetToData", type: "USHORT", value: 0 }, { name: "countSizePairs", type: "USHORT", value: 2 }, { name: "axisCount", type: "USHORT", value: e4.axes.length }, { name: "axisSize", type: "USHORT", value: 20 }, { name: "instanceCount", type: "USHORT", value: e4.instances.length }, { name: "instanceSize", type: "USHORT", value: 4 + 4 * e4.axes.length }]);
            a3.offsetToData = a3.sizeOf();
            for (var s2 = 0; s2 < e4.axes.length; s2++)
              a3.fields = a3.fields.concat((r4 = s2, n4 = e4.axes[s2], o3 = t4, i3 = Mr(n4.name, o3), [{ name: "tag_" + r4, type: "TAG", value: n4.tag }, { name: "minValue_" + r4, type: "FIXED", value: n4.minValue << 16 }, { name: "defaultValue_" + r4, type: "FIXED", value: n4.defaultValue << 16 }, { name: "maxValue_" + r4, type: "FIXED", value: n4.maxValue << 16 }, { name: "flags_" + r4, type: "USHORT", value: 0 }, { name: "nameID_" + r4, type: "USHORT", value: i3 }]));
            for (var l3 = 0; l3 < e4.instances.length; l3++)
              a3.fields = a3.fields.concat(Er(l3, e4.instances[l3], e4.axes, t4));
            return a3;
          }, parse: function(e4, t4, r4) {
            var n4 = new ae.Parser(e4, t4), o3 = n4.parseULong();
            L.argument(o3 === 65536, "Unsupported fvar table version.");
            var i3 = n4.parseOffset16();
            n4.skip("uShort", 1);
            for (var a3, s2, l3, u3, c2, d2 = n4.parseUShort(), f2 = n4.parseUShort(), h3 = n4.parseUShort(), p3 = n4.parseUShort(), y2 = [], m3 = 0; m3 < d2; m3++)
              y2.push((a3 = e4, s2 = t4 + i3 + m3 * f2, l3 = r4, c2 = u3 = void 0, u3 = {}, c2 = new ae.Parser(a3, s2), u3.tag = c2.parseTag(), u3.minValue = c2.parseFixed(), u3.defaultValue = c2.parseFixed(), u3.maxValue = c2.parseFixed(), c2.skip("uShort", 1), u3.name = l3[c2.parseUShort()] || {}, u3));
            for (var g2 = [], v2 = t4 + i3 + d2 * f2, b3 = 0; b3 < h3; b3++)
              g2.push(Tr(e4, v2 + b3 * p3, y2, r4));
            return { axes: y2, instances: g2 };
          } }, Cr = new Array(10);
          Cr[1] = function() {
            var e4 = this.offset + this.relativeOffset, t4 = this.parseUShort();
            return t4 === 1 ? { posFormat: 1, coverage: this.parsePointer(oe.coverage), value: this.parseValueRecord() } : t4 === 2 ? { posFormat: 2, coverage: this.parsePointer(oe.coverage), values: this.parseValueRecordList() } : void L.assert(false, "0x" + e4.toString(16) + ": GPOS lookup type 1 format must be 1 or 2.");
          }, Cr[2] = function() {
            var e4 = this.offset + this.relativeOffset, t4 = this.parseUShort();
            L.assert(t4 === 1 || t4 === 2, "0x" + e4.toString(16) + ": GPOS lookup type 2 format must be 1 or 2.");
            var r4 = this.parsePointer(oe.coverage), n4 = this.parseUShort(), o3 = this.parseUShort();
            if (t4 === 1)
              return { posFormat: t4, coverage: r4, valueFormat1: n4, valueFormat2: o3, pairSets: this.parseList(oe.pointer(oe.list(function() {
                return { secondGlyph: this.parseUShort(), value1: this.parseValueRecord(n4), value2: this.parseValueRecord(o3) };
              }))) };
            if (t4 === 2) {
              var i3 = this.parsePointer(oe.classDef), a3 = this.parsePointer(oe.classDef), s2 = this.parseUShort(), l3 = this.parseUShort();
              return { posFormat: t4, coverage: r4, valueFormat1: n4, valueFormat2: o3, classDef1: i3, classDef2: a3, class1Count: s2, class2Count: l3, classRecords: this.parseList(s2, oe.list(l3, function() {
                return { value1: this.parseValueRecord(n4), value2: this.parseValueRecord(o3) };
              })) };
            }
          }, Cr[3] = function() {
            return { error: "GPOS Lookup 3 not supported" };
          }, Cr[4] = function() {
            return { error: "GPOS Lookup 4 not supported" };
          }, Cr[5] = function() {
            return { error: "GPOS Lookup 5 not supported" };
          }, Cr[6] = function() {
            return { error: "GPOS Lookup 6 not supported" };
          }, Cr[7] = function() {
            return { error: "GPOS Lookup 7 not supported" };
          }, Cr[8] = function() {
            return { error: "GPOS Lookup 8 not supported" };
          }, Cr[9] = function() {
            return { error: "GPOS Lookup 9 not supported" };
          };
          var Lr = new Array(10);
          var Pr = { parse: function(e4, t4) {
            var r4 = new oe(e4, t4 = t4 || 0), n4 = r4.parseVersion(1);
            return L.argument(n4 === 1 || n4 === 1.1, "Unsupported GPOS table version " + n4), n4 === 1 ? { version: n4, scripts: r4.parseScriptList(), features: r4.parseFeatureList(), lookups: r4.parseLookupList(Cr) } : { version: n4, scripts: r4.parseScriptList(), features: r4.parseFeatureList(), lookups: r4.parseLookupList(Cr), variations: r4.parseFeatureVariationsList() };
          }, make: function(e4) {
            return new J.Table("GPOS", [{ name: "version", type: "ULONG", value: 65536 }, { name: "scripts", type: "TABLE", value: new J.ScriptList(e4.scripts) }, { name: "features", type: "TABLE", value: new J.FeatureList(e4.features) }, { name: "lookups", type: "TABLE", value: new J.LookupList(e4.lookups, Lr) }]);
          } };
          var Ar = { parse: function(e4, t4) {
            var r4 = new ae.Parser(e4, t4), n4 = r4.parseUShort();
            if (n4 === 0)
              return function(e5) {
                var t5 = {};
                e5.skip("uShort");
                var r5 = e5.parseUShort();
                L.argument(r5 === 0, "Unsupported kern sub-table version."), e5.skip("uShort", 2);
                var n5 = e5.parseUShort();
                e5.skip("uShort", 3);
                for (var o3 = 0; o3 < n5; o3 += 1) {
                  var i3 = e5.parseUShort(), a3 = e5.parseUShort(), s2 = e5.parseShort();
                  t5[i3 + "," + a3] = s2;
                }
                return t5;
              }(r4);
            if (n4 === 1)
              return function(e5) {
                var t5 = {};
                e5.skip("uShort"), 1 < e5.parseULong() && console.warn("Only the first kern subtable is supported."), e5.skip("uLong");
                var r5 = 255 & e5.parseUShort();
                if (e5.skip("uShort"), r5 == 0) {
                  var n5 = e5.parseUShort();
                  e5.skip("uShort", 3);
                  for (var o3 = 0; o3 < n5; o3 += 1) {
                    var i3 = e5.parseUShort(), a3 = e5.parseUShort(), s2 = e5.parseShort();
                    t5[i3 + "," + a3] = s2;
                  }
                }
                return t5;
              }(r4);
            throw new Error("Unsupported kern table version (" + n4 + ").");
          } };
          var kr = { parse: function(e4, t4, r4, n4) {
            for (var o3 = new ae.Parser(e4, t4), i3 = n4 ? o3.parseUShort : o3.parseULong, a3 = [], s2 = 0; s2 < r4 + 1; s2 += 1) {
              var l3 = i3.call(o3);
              n4 && (l3 *= 2), a3.push(l3);
            }
            return a3;
          } };
          function Rr(e4, r4) {
            Br("fs").readFile(e4, function(e5, t4) {
              if (e5)
                return r4(e5.message);
              r4(null, Mt(t4));
            });
          }
          function Dr(e4, t4) {
            var r4 = new XMLHttpRequest();
            r4.open("get", e4, true), r4.responseType = "arraybuffer", r4.onload = function() {
              return r4.response ? t4(null, r4.response) : t4("Font could not be loaded: " + r4.statusText);
            }, r4.onerror = function() {
              t4("Font could not be loaded");
            }, r4.send();
          }
          function Ir(e4, t4) {
            for (var r4 = [], n4 = 12, o3 = 0; o3 < t4; o3 += 1) {
              var i3 = ae.getTag(e4, n4), a3 = ae.getULong(e4, n4 + 4), s2 = ae.getULong(e4, n4 + 8), l3 = ae.getULong(e4, n4 + 12);
              r4.push({ tag: i3, checksum: a3, offset: s2, length: l3, compression: false }), n4 += 16;
            }
            return r4;
          }
          function Ur(e4, t4) {
            if (t4.compression !== "WOFF")
              return { data: e4, offset: t4.offset };
            var r4 = new Uint8Array(e4.buffer, t4.offset + 2, t4.compressedLength - 2), n4 = new Uint8Array(t4.length);
            if (o2(r4, n4), n4.byteLength !== t4.length)
              throw new Error("Decompression error: " + t4.tag + " decompressed length doesn't match recorded length");
            return { data: new DataView(n4.buffer, 0), offset: 0 };
          }
          function Nr(e4) {
            var t4, r4, n4, o3, i3, a3, s2, l3, u3, c2, d2, f2, h3, p3, y2 = new Sr({ empty: true }), m3 = new DataView(e4, 0), g2 = [], v2 = ae.getTag(m3, 0);
            if (v2 === String.fromCharCode(0, 1, 0, 0) || v2 === "true" || v2 === "typ1")
              y2.outlinesFormat = "truetype", g2 = Ir(m3, n4 = ae.getUShort(m3, 4));
            else if (v2 === "OTTO")
              y2.outlinesFormat = "cff", g2 = Ir(m3, n4 = ae.getUShort(m3, 4));
            else {
              if (v2 !== "wOFF")
                throw new Error("Unsupported OpenType signature " + v2);
              var b3 = ae.getTag(m3, 4);
              if (b3 === String.fromCharCode(0, 1, 0, 0))
                y2.outlinesFormat = "truetype";
              else {
                if (b3 !== "OTTO")
                  throw new Error("Unsupported OpenType flavor " + v2);
                y2.outlinesFormat = "cff";
              }
              g2 = function(e5, t5) {
                for (var r5 = [], n5 = 44, o4 = 0; o4 < t5; o4 += 1) {
                  var i4 = ae.getTag(e5, n5), a4 = ae.getULong(e5, n5 + 4), s3 = ae.getULong(e5, n5 + 8), l4 = ae.getULong(e5, n5 + 12), u4 = void 0;
                  u4 = s3 < l4 && "WOFF", r5.push({ tag: i4, offset: a4, compression: u4, compressedLength: s3, length: l4 }), n5 += 20;
                }
                return r5;
              }(m3, n4 = ae.getUShort(m3, 12));
            }
            for (var _2 = 0; _2 < n4; _2 += 1) {
              var x2 = g2[_2], w2 = void 0;
              switch (x2.tag) {
                case "cmap":
                  w2 = Ur(m3, x2), y2.tables.cmap = se.parse(w2.data, w2.offset), y2.encoding = new he(y2.tables.cmap);
                  break;
                case "cvt ":
                  w2 = Ur(m3, x2), p3 = new ae.Parser(w2.data, w2.offset), y2.tables.cvt = p3.parseShortList(x2.length / 2);
                  break;
                case "fvar":
                  i3 = x2;
                  break;
                case "fpgm":
                  w2 = Ur(m3, x2), p3 = new ae.Parser(w2.data, w2.offset), y2.tables.fpgm = p3.parseByteList(x2.length);
                  break;
                case "head":
                  w2 = Ur(m3, x2), y2.tables.head = Fe.parse(w2.data, w2.offset), y2.unitsPerEm = y2.tables.head.unitsPerEm, t4 = y2.tables.head.indexToLocFormat;
                  break;
                case "hhea":
                  w2 = Ur(m3, x2), y2.tables.hhea = Be.parse(w2.data, w2.offset), y2.ascender = y2.tables.hhea.ascender, y2.descender = y2.tables.hhea.descender, y2.numberOfHMetrics = y2.tables.hhea.numberOfHMetrics;
                  break;
                case "hmtx":
                  u3 = x2;
                  break;
                case "ltag":
                  w2 = Ur(m3, x2), r4 = Ve.parse(w2.data, w2.offset);
                  break;
                case "maxp":
                  w2 = Ur(m3, x2), y2.tables.maxp = ze.parse(w2.data, w2.offset), y2.numGlyphs = y2.tables.maxp.numGlyphs;
                  break;
                case "name":
                  f2 = x2;
                  break;
                case "OS/2":
                  w2 = Ur(m3, x2), y2.tables.os2 = ot.parse(w2.data, w2.offset);
                  break;
                case "post":
                  w2 = Ur(m3, x2), y2.tables.post = it.parse(w2.data, w2.offset), y2.glyphNames = new ye(y2.tables.post);
                  break;
                case "prep":
                  w2 = Ur(m3, x2), p3 = new ae.Parser(w2.data, w2.offset), y2.tables.prep = p3.parseByteList(x2.length);
                  break;
                case "glyf":
                  a3 = x2;
                  break;
                case "loca":
                  d2 = x2;
                  break;
                case "CFF ":
                  o3 = x2;
                  break;
                case "kern":
                  c2 = x2;
                  break;
                case "GPOS":
                  s2 = x2;
                  break;
                case "GSUB":
                  l3 = x2;
                  break;
                case "meta":
                  h3 = x2;
              }
            }
            var j2 = Ur(m3, f2);
            if (y2.tables.name = rt.parse(j2.data, j2.offset, r4), y2.names = y2.tables.name, a3 && d2) {
              var S3 = t4 === 0, M2 = Ur(m3, d2), E2 = kr.parse(M2.data, M2.offset, y2.numGlyphs, S3), T3 = Ur(m3, a3);
              y2.glyphs = It.parse(T3.data, T3.offset, E2, y2);
            } else {
              if (!o3)
                throw new Error("Font doesn't contain TrueType or CFF outlines.");
              var O3 = Ur(m3, o3);
              Ne.parse(O3.data, O3.offset, y2);
            }
            var C2 = Ur(m3, u3);
            if (Ge.parse(C2.data, C2.offset, y2.numberOfHMetrics, y2.numGlyphs, y2.glyphs), function(e5) {
              for (var t5, r5 = e5.tables.cmap.glyphIndexMap, n5 = Object.keys(r5), o4 = 0; o4 < n5.length; o4 += 1) {
                var i4 = n5[o4], a4 = r5[i4];
                (t5 = e5.glyphs.get(a4)).addUnicode(parseInt(i4));
              }
              for (var s3 = 0; s3 < e5.glyphs.length; s3 += 1)
                t5 = e5.glyphs.get(s3), e5.cffEncoding ? e5.isCIDFont ? t5.name = "gid" + s3 : t5.name = e5.cffEncoding.charset[s3] : e5.glyphNames.names && (t5.name = e5.glyphNames.glyphIndexToName(s3));
            }(y2), c2) {
              var L2 = Ur(m3, c2);
              y2.kerningPairs = Ar.parse(L2.data, L2.offset);
            } else
              y2.kerningPairs = {};
            if (s2) {
              var P3 = Ur(m3, s2);
              y2.tables.gpos = Pr.parse(P3.data, P3.offset), y2.position.init();
            }
            if (l3) {
              var A2 = Ur(m3, l3);
              y2.tables.gsub = ut.parse(A2.data, A2.offset);
            }
            if (i3) {
              var k3 = Ur(m3, i3);
              y2.tables.fvar = Or.parse(k3.data, k3.offset, y2.names);
            }
            if (h3) {
              var R3 = Ur(m3, h3);
              y2.tables.meta = ct.parse(R3.data, R3.offset), y2.metas = y2.tables.meta;
            }
            return y2;
          }
          M.Font = Sr, M.Glyph = ge, M.Path = D, M.BoundingBox = T2, M._parse = ae, M.parse = Nr, M.load = function(e4, n4) {
            (typeof window == "undefined" ? Rr : Dr)(e4, function(e5, t4) {
              if (e5)
                return n4(e5);
              var r4;
              try {
                r4 = Nr(t4);
              } catch (e6) {
                return n4(e6, null);
              }
              return n4(null, r4);
            });
          }, M.loadSync = function(e4) {
            return Nr(Mt(Br("fs").readFileSync(e4)));
          }, Object.defineProperty(M, "__esModule", { value: true });
        }, typeof n2 == "object" && r2 !== void 0 ? t2(n2) : t2(e2.opentype = {});
      }).call(this, Br("buffer").Buffer);
    }, { buffer: 4, fs: 2 }], 240: [function(e2, t2, u2) {
      (function(o2) {
        function i2(e3, t3) {
          for (var r2 = 0, n3 = e3.length - 1; 0 <= n3; n3--) {
            var o3 = e3[n3];
            o3 === "." ? e3.splice(n3, 1) : o3 === ".." ? (e3.splice(n3, 1), r2++) : r2 && (e3.splice(n3, 1), r2--);
          }
          if (t3)
            for (; r2--; )
              e3.unshift("..");
          return e3;
        }
        function a2(e3, t3) {
          if (e3.filter)
            return e3.filter(t3);
          for (var r2 = [], n3 = 0; n3 < e3.length; n3++)
            t3(e3[n3], n3, e3) && r2.push(e3[n3]);
          return r2;
        }
        u2.resolve = function() {
          for (var e3 = "", t3 = false, r2 = arguments.length - 1; -1 <= r2 && !t3; r2--) {
            var n3 = 0 <= r2 ? arguments[r2] : o2.cwd();
            if (typeof n3 != "string")
              throw new TypeError("Arguments to path.resolve must be strings");
            n3 && (e3 = n3 + "/" + e3, t3 = n3.charAt(0) === "/");
          }
          return (t3 ? "/" : "") + (e3 = i2(a2(e3.split("/"), function(e4) {
            return !!e4;
          }), !t3).join("/")) || ".";
        }, u2.normalize = function(e3) {
          var t3 = u2.isAbsolute(e3), r2 = n2(e3, -1) === "/";
          return (e3 = i2(a2(e3.split("/"), function(e4) {
            return !!e4;
          }), !t3).join("/")) || t3 || (e3 = "."), e3 && r2 && (e3 += "/"), (t3 ? "/" : "") + e3;
        }, u2.isAbsolute = function(e3) {
          return e3.charAt(0) === "/";
        }, u2.join = function() {
          var e3 = Array.prototype.slice.call(arguments, 0);
          return u2.normalize(a2(e3, function(e4, t3) {
            if (typeof e4 != "string")
              throw new TypeError("Arguments to path.join must be strings");
            return e4;
          }).join("/"));
        }, u2.relative = function(e3, t3) {
          function r2(e4) {
            for (var t4 = 0; t4 < e4.length && e4[t4] === ""; t4++)
              ;
            for (var r3 = e4.length - 1; 0 <= r3 && e4[r3] === ""; r3--)
              ;
            return r3 < t4 ? [] : e4.slice(t4, r3 - t4 + 1);
          }
          e3 = u2.resolve(e3).substr(1), t3 = u2.resolve(t3).substr(1);
          for (var n3 = r2(e3.split("/")), o3 = r2(t3.split("/")), i3 = Math.min(n3.length, o3.length), a3 = i3, s = 0; s < i3; s++)
            if (n3[s] !== o3[s]) {
              a3 = s;
              break;
            }
          var l2 = [];
          for (s = a3; s < n3.length; s++)
            l2.push("..");
          return (l2 = l2.concat(o3.slice(a3))).join("/");
        }, u2.sep = "/", u2.delimiter = ":", u2.dirname = function(e3) {
          if (typeof e3 != "string" && (e3 += ""), e3.length === 0)
            return ".";
          for (var t3 = e3.charCodeAt(0), r2 = t3 === 47, n3 = -1, o3 = true, i3 = e3.length - 1; 1 <= i3; --i3)
            if ((t3 = e3.charCodeAt(i3)) === 47) {
              if (!o3) {
                n3 = i3;
                break;
              }
            } else
              o3 = false;
          return n3 === -1 ? r2 ? "/" : "." : r2 && n3 === 1 ? "/" : e3.slice(0, n3);
        }, u2.basename = function(e3, t3) {
          var r2 = function(e4) {
            typeof e4 != "string" && (e4 += "");
            var t4, r3 = 0, n3 = -1, o3 = true;
            for (t4 = e4.length - 1; 0 <= t4; --t4)
              if (e4.charCodeAt(t4) === 47) {
                if (!o3) {
                  r3 = t4 + 1;
                  break;
                }
              } else
                n3 === -1 && (o3 = false, n3 = t4 + 1);
            return n3 === -1 ? "" : e4.slice(r3, n3);
          }(e3);
          return t3 && r2.substr(-1 * t3.length) === t3 && (r2 = r2.substr(0, r2.length - t3.length)), r2;
        }, u2.extname = function(e3) {
          typeof e3 != "string" && (e3 += "");
          for (var t3 = -1, r2 = 0, n3 = -1, o3 = true, i3 = 0, a3 = e3.length - 1; 0 <= a3; --a3) {
            var s = e3.charCodeAt(a3);
            if (s === 47) {
              if (o3)
                continue;
              r2 = a3 + 1;
              break;
            }
            n3 === -1 && (o3 = false, n3 = a3 + 1), s === 46 ? t3 === -1 ? t3 = a3 : i3 !== 1 && (i3 = 1) : t3 !== -1 && (i3 = -1);
          }
          return t3 === -1 || n3 === -1 || i3 === 0 || i3 === 1 && t3 === n3 - 1 && t3 === r2 + 1 ? "" : e3.slice(t3, n3);
        };
        var n2 = "ab".substr(-1) === "b" ? function(e3, t3, r2) {
          return e3.substr(t3, r2);
        } : function(e3, t3, r2) {
          return t3 < 0 && (t3 = e3.length + t3), e3.substr(t3, r2);
        };
      }).call(this, e2("_process"));
    }, { _process: 241 }], 241: [function(e2, t2, r2) {
      var n2, o2, i2 = t2.exports = {};
      function a2() {
        throw new Error("setTimeout has not been defined");
      }
      function s() {
        throw new Error("clearTimeout has not been defined");
      }
      function l2(t3) {
        if (n2 === setTimeout)
          return setTimeout(t3, 0);
        if ((n2 === a2 || !n2) && setTimeout)
          return n2 = setTimeout, setTimeout(t3, 0);
        try {
          return n2(t3, 0);
        } catch (e3) {
          try {
            return n2.call(null, t3, 0);
          } catch (e4) {
            return n2.call(this, t3, 0);
          }
        }
      }
      !function() {
        try {
          n2 = typeof setTimeout == "function" ? setTimeout : a2;
        } catch (e3) {
          n2 = a2;
        }
        try {
          o2 = typeof clearTimeout == "function" ? clearTimeout : s;
        } catch (e3) {
          o2 = s;
        }
      }();
      var u2, c = [], d = false, f = -1;
      function h2() {
        d && u2 && (d = false, u2.length ? c = u2.concat(c) : f = -1, c.length && p2());
      }
      function p2() {
        if (!d) {
          var e3 = l2(h2);
          d = true;
          for (var t3 = c.length; t3; ) {
            for (u2 = c, c = []; ++f < t3; )
              u2 && u2[f].run();
            f = -1, t3 = c.length;
          }
          u2 = null, d = false, function(t4) {
            if (o2 === clearTimeout)
              return clearTimeout(t4);
            if ((o2 === s || !o2) && clearTimeout)
              return o2 = clearTimeout, clearTimeout(t4);
            try {
              o2(t4);
            } catch (e4) {
              try {
                return o2.call(null, t4);
              } catch (e5) {
                return o2.call(this, t4);
              }
            }
          }(e3);
        }
      }
      function y(e3, t3) {
        this.fun = e3, this.array = t3;
      }
      function m2() {
      }
      i2.nextTick = function(e3) {
        var t3 = new Array(arguments.length - 1);
        if (1 < arguments.length)
          for (var r3 = 1; r3 < arguments.length; r3++)
            t3[r3 - 1] = arguments[r3];
        c.push(new y(e3, t3)), c.length !== 1 || d || l2(p2);
      }, y.prototype.run = function() {
        this.fun.apply(null, this.array);
      }, i2.title = "browser", i2.browser = true, i2.env = {}, i2.argv = [], i2.version = "", i2.versions = {}, i2.on = m2, i2.addListener = m2, i2.once = m2, i2.off = m2, i2.removeListener = m2, i2.removeAllListeners = m2, i2.emit = m2, i2.prependListener = m2, i2.prependOnceListener = m2, i2.listeners = function(e3) {
        return [];
      }, i2.binding = function(e3) {
        throw new Error("process.binding is not supported");
      }, i2.cwd = function() {
        return "/";
      }, i2.chdir = function(e3) {
        throw new Error("process.chdir is not supported");
      }, i2.umask = function() {
        return 0;
      };
    }, {}], 242: [function(e2, t2, r2) {
      !function(e3) {
        if (!e3.fetch) {
          var t3 = "URLSearchParams" in e3, r3 = "Symbol" in e3 && "iterator" in Symbol, a2 = "FileReader" in e3 && "Blob" in e3 && function() {
            try {
              return new Blob(), true;
            } catch (e4) {
              return false;
            }
          }(), n2 = "FormData" in e3, o2 = "ArrayBuffer" in e3;
          if (o2)
            var i2 = ["[object Int8Array]", "[object Uint8Array]", "[object Uint8ClampedArray]", "[object Int16Array]", "[object Uint16Array]", "[object Int32Array]", "[object Uint32Array]", "[object Float32Array]", "[object Float64Array]"], s = function(e4) {
              return e4 && DataView.prototype.isPrototypeOf(e4);
            }, l2 = ArrayBuffer.isView || function(e4) {
              return e4 && -1 < i2.indexOf(Object.prototype.toString.call(e4));
            };
          p2.prototype.append = function(e4, t4) {
            e4 = d(e4), t4 = f(t4);
            var r4 = this.map[e4];
            this.map[e4] = r4 ? r4 + "," + t4 : t4;
          }, p2.prototype.delete = function(e4) {
            delete this.map[d(e4)];
          }, p2.prototype.get = function(e4) {
            return e4 = d(e4), this.has(e4) ? this.map[e4] : null;
          }, p2.prototype.has = function(e4) {
            return this.map.hasOwnProperty(d(e4));
          }, p2.prototype.set = function(e4, t4) {
            this.map[d(e4)] = f(t4);
          }, p2.prototype.forEach = function(e4, t4) {
            for (var r4 in this.map)
              this.map.hasOwnProperty(r4) && e4.call(t4, this.map[r4], r4, this);
          }, p2.prototype.keys = function() {
            var r4 = [];
            return this.forEach(function(e4, t4) {
              r4.push(t4);
            }), h2(r4);
          }, p2.prototype.values = function() {
            var t4 = [];
            return this.forEach(function(e4) {
              t4.push(e4);
            }), h2(t4);
          }, p2.prototype.entries = function() {
            var r4 = [];
            return this.forEach(function(e4, t4) {
              r4.push([t4, e4]);
            }), h2(r4);
          }, r3 && (p2.prototype[Symbol.iterator] = p2.prototype.entries);
          var u2 = ["DELETE", "GET", "HEAD", "OPTIONS", "POST", "PUT"];
          _.prototype.clone = function() {
            return new _(this, { body: this._bodyInit });
          }, b2.call(_.prototype), b2.call(w.prototype), w.prototype.clone = function() {
            return new w(this._bodyInit, { status: this.status, statusText: this.statusText, headers: new p2(this.headers), url: this.url });
          }, w.error = function() {
            var e4 = new w(null, { status: 0, statusText: "" });
            return e4.type = "error", e4;
          };
          var c = [301, 302, 303, 307, 308];
          w.redirect = function(e4, t4) {
            if (c.indexOf(t4) === -1)
              throw new RangeError("Invalid status code");
            return new w(null, { status: t4, headers: { location: e4 } });
          }, e3.Headers = p2, e3.Request = _, e3.Response = w, e3.fetch = function(r4, o3) {
            return new Promise(function(n3, e4) {
              var t4 = new _(r4, o3), i3 = new XMLHttpRequest();
              i3.onload = function() {
                var e5, o4, t5 = { status: i3.status, statusText: i3.statusText, headers: (e5 = i3.getAllResponseHeaders() || "", o4 = new p2(), e5.replace(/\r?\n[\t ]+/g, " ").split(/\r?\n/).forEach(function(e6) {
                  var t6 = e6.split(":"), r6 = t6.shift().trim();
                  if (r6) {
                    var n4 = t6.join(":").trim();
                    o4.append(r6, n4);
                  }
                }), o4) };
                t5.url = "responseURL" in i3 ? i3.responseURL : t5.headers.get("X-Request-URL");
                var r5 = "response" in i3 ? i3.response : i3.responseText;
                n3(new w(r5, t5));
              }, i3.onerror = function() {
                e4(new TypeError("Network request failed"));
              }, i3.ontimeout = function() {
                e4(new TypeError("Network request failed"));
              }, i3.open(t4.method, t4.url, true), t4.credentials === "include" ? i3.withCredentials = true : t4.credentials === "omit" && (i3.withCredentials = false), "responseType" in i3 && a2 && (i3.responseType = "blob"), t4.headers.forEach(function(e5, t5) {
                i3.setRequestHeader(t5, e5);
              }), i3.send(t4._bodyInit === void 0 ? null : t4._bodyInit);
            });
          }, e3.fetch.polyfill = true;
        }
        function d(e4) {
          if (typeof e4 != "string" && (e4 = String(e4)), /[^a-z0-9\-#$%&'*+.\^_`|~]/i.test(e4))
            throw new TypeError("Invalid character in header field name");
          return e4.toLowerCase();
        }
        function f(e4) {
          return typeof e4 != "string" && (e4 = String(e4)), e4;
        }
        function h2(t4) {
          var e4 = { next: function() {
            var e5 = t4.shift();
            return { done: e5 === void 0, value: e5 };
          } };
          return r3 && (e4[Symbol.iterator] = function() {
            return e4;
          }), e4;
        }
        function p2(t4) {
          this.map = {}, t4 instanceof p2 ? t4.forEach(function(e4, t5) {
            this.append(t5, e4);
          }, this) : Array.isArray(t4) ? t4.forEach(function(e4) {
            this.append(e4[0], e4[1]);
          }, this) : t4 && Object.getOwnPropertyNames(t4).forEach(function(e4) {
            this.append(e4, t4[e4]);
          }, this);
        }
        function y(e4) {
          if (e4.bodyUsed)
            return Promise.reject(new TypeError("Already read"));
          e4.bodyUsed = true;
        }
        function m2(r4) {
          return new Promise(function(e4, t4) {
            r4.onload = function() {
              e4(r4.result);
            }, r4.onerror = function() {
              t4(r4.error);
            };
          });
        }
        function g(e4) {
          var t4 = new FileReader(), r4 = m2(t4);
          return t4.readAsArrayBuffer(e4), r4;
        }
        function v(e4) {
          if (e4.slice)
            return e4.slice(0);
          var t4 = new Uint8Array(e4.byteLength);
          return t4.set(new Uint8Array(e4)), t4.buffer;
        }
        function b2() {
          return this.bodyUsed = false, this._initBody = function(e4) {
            if (this._bodyInit = e4)
              if (typeof e4 == "string")
                this._bodyText = e4;
              else if (a2 && Blob.prototype.isPrototypeOf(e4))
                this._bodyBlob = e4;
              else if (n2 && FormData.prototype.isPrototypeOf(e4))
                this._bodyFormData = e4;
              else if (t3 && URLSearchParams.prototype.isPrototypeOf(e4))
                this._bodyText = e4.toString();
              else if (o2 && a2 && s(e4))
                this._bodyArrayBuffer = v(e4.buffer), this._bodyInit = new Blob([this._bodyArrayBuffer]);
              else {
                if (!o2 || !ArrayBuffer.prototype.isPrototypeOf(e4) && !l2(e4))
                  throw new Error("unsupported BodyInit type");
                this._bodyArrayBuffer = v(e4);
              }
            else
              this._bodyText = "";
            this.headers.get("content-type") || (typeof e4 == "string" ? this.headers.set("content-type", "text/plain;charset=UTF-8") : this._bodyBlob && this._bodyBlob.type ? this.headers.set("content-type", this._bodyBlob.type) : t3 && URLSearchParams.prototype.isPrototypeOf(e4) && this.headers.set("content-type", "application/x-www-form-urlencoded;charset=UTF-8"));
          }, a2 && (this.blob = function() {
            var e4 = y(this);
            if (e4)
              return e4;
            if (this._bodyBlob)
              return Promise.resolve(this._bodyBlob);
            if (this._bodyArrayBuffer)
              return Promise.resolve(new Blob([this._bodyArrayBuffer]));
            if (this._bodyFormData)
              throw new Error("could not read FormData body as blob");
            return Promise.resolve(new Blob([this._bodyText]));
          }, this.arrayBuffer = function() {
            return this._bodyArrayBuffer ? y(this) || Promise.resolve(this._bodyArrayBuffer) : this.blob().then(g);
          }), this.text = function() {
            var e4, t4, r4, n3 = y(this);
            if (n3)
              return n3;
            if (this._bodyBlob)
              return e4 = this._bodyBlob, t4 = new FileReader(), r4 = m2(t4), t4.readAsText(e4), r4;
            if (this._bodyArrayBuffer)
              return Promise.resolve(function(e5) {
                for (var t5 = new Uint8Array(e5), r5 = new Array(t5.length), n4 = 0; n4 < t5.length; n4++)
                  r5[n4] = String.fromCharCode(t5[n4]);
                return r5.join("");
              }(this._bodyArrayBuffer));
            if (this._bodyFormData)
              throw new Error("could not read FormData body as text");
            return Promise.resolve(this._bodyText);
          }, n2 && (this.formData = function() {
            return this.text().then(x);
          }), this.json = function() {
            return this.text().then(JSON.parse);
          }, this;
        }
        function _(e4, t4) {
          var r4, n3, o3 = (t4 = t4 || {}).body;
          if (e4 instanceof _) {
            if (e4.bodyUsed)
              throw new TypeError("Already read");
            this.url = e4.url, this.credentials = e4.credentials, t4.headers || (this.headers = new p2(e4.headers)), this.method = e4.method, this.mode = e4.mode, o3 || e4._bodyInit == null || (o3 = e4._bodyInit, e4.bodyUsed = true);
          } else
            this.url = String(e4);
          if (this.credentials = t4.credentials || this.credentials || "omit", !t4.headers && this.headers || (this.headers = new p2(t4.headers)), this.method = (r4 = t4.method || this.method || "GET", n3 = r4.toUpperCase(), -1 < u2.indexOf(n3) ? n3 : r4), this.mode = t4.mode || this.mode || null, this.referrer = null, (this.method === "GET" || this.method === "HEAD") && o3)
            throw new TypeError("Body not allowed for GET or HEAD requests");
          this._initBody(o3);
        }
        function x(e4) {
          var o3 = new FormData();
          return e4.trim().split("&").forEach(function(e5) {
            if (e5) {
              var t4 = e5.split("="), r4 = t4.shift().replace(/\+/g, " "), n3 = t4.join("=").replace(/\+/g, " ");
              o3.append(decodeURIComponent(r4), decodeURIComponent(n3));
            }
          }), o3;
        }
        function w(e4, t4) {
          t4 = t4 || {}, this.type = "default", this.status = t4.status === void 0 ? 200 : t4.status, this.ok = 200 <= this.status && this.status < 300, this.statusText = "statusText" in t4 ? t4.statusText : "OK", this.headers = new p2(t4.headers), this.url = t4.url || "", this._initBody(e4);
        }
      }(typeof self != "undefined" ? self : this);
    }, {}], 243: [function(e2, t2, r2) {
      e2("core-js/modules/es.function.name"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.regexp.exec"), e2("core-js/modules/es.regexp.to-string"), e2("core-js/modules/es.string.split"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var l2, n2 = i2(e2("../core/main")), o2 = i2(e2("../color/color_conversion"));
      function i2(e3) {
        return e3 && e3.__esModule ? e3 : { default: e3 };
      }
      var u2 = [{ h: 0, s: 0, b: 0.8275, name: "gray" }, { h: 0, s: 0, b: 0.8627, name: "gray" }, { h: 0, s: 0, b: 0.7529, name: "gray" }, { h: 0.0167, s: 0.1176, b: 1, name: "light pink" }], c = [{ h: 0, s: 0, b: 0, name: "black" }, { h: 0, s: 0, b: 0.5, name: "gray" }, { h: 0, s: 0, b: 1, name: "white" }, { h: 0, s: 0.5, b: 0.5, name: "dark maroon" }, { h: 0, s: 0.5, b: 1, name: "salmon pink" }, { h: 0, s: 1, b: 0, name: "black" }, { h: 0, s: 1, b: 0.5, name: "dark red" }, { h: 0, s: 1, b: 1, name: "red" }, { h: 5, s: 0, b: 1, name: "very light peach" }, { h: 5, s: 0.5, b: 0.5, name: "brown" }, { h: 5, s: 0.5, b: 1, name: "peach" }, { h: 5, s: 1, b: 0.5, name: "brick red" }, { h: 5, s: 1, b: 1, name: "crimson" }, { h: 10, s: 0, b: 1, name: "light peach" }, { h: 10, s: 0.5, b: 0.5, name: "brown" }, { h: 10, s: 0.5, b: 1, name: "light orange" }, { h: 10, s: 1, b: 0.5, name: "brown" }, { h: 10, s: 1, b: 1, name: "orange" }, { h: 15, s: 0, b: 1, name: "very light yellow" }, { h: 15, s: 0.5, b: 0.5, name: "olive green" }, { h: 15, s: 0.5, b: 1, name: "light yellow" }, { h: 15, s: 1, b: 0, name: "dark olive green" }, { h: 15, s: 1, b: 0.5, name: "olive green" }, { h: 15, s: 1, b: 1, name: "yellow" }, { h: 20, s: 0, b: 1, name: "very light yellow" }, { h: 20, s: 0.5, b: 0.5, name: "olive green" }, { h: 20, s: 0.5, b: 1, name: "light yellow green" }, { h: 20, s: 1, b: 0, name: "dark olive green" }, { h: 20, s: 1, b: 0.5, name: "dark yellow green" }, { h: 20, s: 1, b: 1, name: "yellow green" }, { h: 25, s: 0.5, b: 0.5, name: "dark yellow green" }, { h: 25, s: 0.5, b: 1, name: "light green" }, { h: 25, s: 1, b: 0.5, name: "dark green" }, { h: 25, s: 1, b: 1, name: "green" }, { h: 30, s: 0.5, b: 1, name: "light green" }, { h: 30, s: 1, b: 0.5, name: "dark green" }, { h: 30, s: 1, b: 1, name: "green" }, { h: 35, s: 0, b: 0.5, name: "light green" }, { h: 35, s: 0, b: 1, name: "very light green" }, { h: 35, s: 0.5, b: 0.5, name: "dark green" }, { h: 35, s: 0.5, b: 1, name: "light green" }, { h: 35, s: 1, b: 0, name: "very dark green" }, { h: 35, s: 1, b: 0.5, name: "dark green" }, { h: 35, s: 1, b: 1, name: "green" }, { h: 40, s: 0, b: 1, name: "very light green" }, { h: 40, s: 0.5, b: 0.5, name: "dark green" }, { h: 40, s: 0.5, b: 1, name: "light green" }, { h: 40, s: 1, b: 0.5, name: "dark green" }, { h: 40, s: 1, b: 1, name: "green" }, { h: 45, s: 0.5, b: 1, name: "light turquoise" }, { h: 45, s: 1, b: 0.5, name: "dark turquoise" }, { h: 45, s: 1, b: 1, name: "turquoise" }, { h: 50, s: 0, b: 1, name: "light sky blue" }, { h: 50, s: 0.5, b: 0.5, name: "dark cyan" }, { h: 50, s: 0.5, b: 1, name: "light cyan" }, { h: 50, s: 1, b: 0.5, name: "dark cyan" }, { h: 50, s: 1, b: 1, name: "cyan" }, { h: 55, s: 0, b: 1, name: "light sky blue" }, { h: 55, s: 0.5, b: 1, name: "light sky blue" }, { h: 55, s: 1, b: 0.5, name: "dark blue" }, { h: 55, s: 1, b: 1, name: "sky blue" }, { h: 60, s: 0, b: 0.5, name: "gray" }, { h: 60, s: 0, b: 1, name: "very light blue" }, { h: 60, s: 0.5, b: 0.5, name: "blue" }, { h: 60, s: 0.5, b: 1, name: "light blue" }, { h: 60, s: 1, b: 0.5, name: "navy blue" }, { h: 60, s: 1, b: 1, name: "blue" }, { h: 65, s: 0, b: 1, name: "lavender" }, { h: 65, s: 0.5, b: 0.5, name: "navy blue" }, { h: 65, s: 0.5, b: 1, name: "light purple" }, { h: 65, s: 1, b: 0.5, name: "dark navy blue" }, { h: 65, s: 1, b: 1, name: "blue" }, { h: 70, s: 0, b: 1, name: "lavender" }, { h: 70, s: 0.5, b: 0.5, name: "navy blue" }, { h: 70, s: 0.5, b: 1, name: "lavender blue" }, { h: 70, s: 1, b: 0.5, name: "dark navy blue" }, { h: 70, s: 1, b: 1, name: "blue" }, { h: 75, s: 0.5, b: 1, name: "lavender" }, { h: 75, s: 1, b: 0.5, name: "dark purple" }, { h: 75, s: 1, b: 1, name: "purple" }, { h: 80, s: 0.5, b: 1, name: "pinkish purple" }, { h: 80, s: 1, b: 0.5, name: "dark purple" }, { h: 80, s: 1, b: 1, name: "purple" }, { h: 85, s: 0, b: 1, name: "light pink" }, { h: 85, s: 0.5, b: 0.5, name: "purple" }, { h: 85, s: 0.5, b: 1, name: "light fuchsia" }, { h: 85, s: 1, b: 0.5, name: "dark fuchsia" }, { h: 85, s: 1, b: 1, name: "fuchsia" }, { h: 90, s: 0.5, b: 0.5, name: "dark fuchsia" }, { h: 90, s: 0.5, b: 1, name: "hot pink" }, { h: 90, s: 1, b: 0.5, name: "dark fuchsia" }, { h: 90, s: 1, b: 1, name: "fuchsia" }, { h: 95, s: 0, b: 1, name: "pink" }, { h: 95, s: 0.5, b: 1, name: "light pink" }, { h: 95, s: 1, b: 0.5, name: "dark magenta" }, { h: 95, s: 1, b: 1, name: "magenta" }];
      n2.default.prototype._rgbColorName = function(e3) {
        var t3 = o2.default._rgbaToHSBA(e3);
        return function(e4) {
          var t4;
          if (e4[0] !== 0) {
            e4[0] = Math.round(100 * e4[0]);
            var r3 = e4[0].toString().split(""), n3 = r3.length - 1;
            r3[n3] = parseInt(r3[n3]), r3[n3] < 2.5 ? r3[n3] = 0 : 2.5 <= r3[n3] && r3[n3] < 7.5 && (r3[n3] = 5), r3.length === 2 ? (r3[0] = parseInt(r3[0]), 7.5 <= r3[n3] && (r3[n3] = 0, r3[0] = r3[0] + 1), e4[0] = 10 * r3[0] + r3[1]) : 7.5 <= r3[n3] ? e4[0] = 10 : e4[0] = r3[n3];
          }
          e4[2] = e4[2] / 255;
          for (var o3 = e4.length - 1; 1 <= o3; o3--)
            e4[o3] <= 0.25 ? e4[o3] = 0 : 0.25 < e4[o3] && e4[o3] < 0.75 ? e4[o3] = 0.5 : e4[o3] = 1;
          if (e4[0] === 0 && e4[1] === 0 && e4[2] === 1) {
            for (var i3 = 2; 0 <= i3; i3--)
              l2[i3] = Math.round(1e4 * l2[i3]) / 1e4;
            for (var a3 = 0; a3 < u2.length; a3++) {
              if (u2[a3].h === l2[0] && u2[a3].s === l2[1] && u2[a3].b === l2[2]) {
                t4 = u2[a3].name;
                break;
              }
              t4 = "white";
            }
          } else
            for (var s = 0; s < c.length; s++)
              if (c[s].h === e4[0] && c[s].s === e4[1] && c[s].b === e4[2]) {
                t4 = c[s].name;
                break;
              }
          return t4;
        }([(l2 = t3)[0], t3[1], t3[2]]);
      };
      var a2 = n2.default;
      r2.default = a2;
    }, { "../color/color_conversion": 249, "../core/main": 264, "core-js/modules/es.function.name": 166, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.regexp.exec": 181, "core-js/modules/es.regexp.to-string": 182, "core-js/modules/es.string.split": 191 }], 244: [function(e2, t2, r2) {
      e2("core-js/modules/es.array.concat"), e2("core-js/modules/es.regexp.exec"), e2("core-js/modules/es.string.ends-with"), e2("core-js/modules/es.string.replace"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, a2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      var l2 = "_Description", u2 = "_fallbackDesc", c = "_fallbackTable", d = "_Label", f = "_labelDesc", h2 = "_labelTable";
      function s(e3) {
        if (e3 === "label" || e3 === "fallback")
          throw new Error("description should not be LABEL or FALLBACK");
        return e3.endsWith(".") || e3.endsWith(";") || e3.endsWith(",") || e3.endsWith("?") || e3.endsWith("!") || (e3 += "."), e3;
      }
      a2.default.prototype.describe = function(e3, t3) {
        if (a2.default._validateParameters("describe", arguments), typeof e3 == "string") {
          var r3 = this.canvas.id;
          e3 = s(e3), this.dummyDOM || (this.dummyDOM = document.getElementById(r3).parentNode), this.descriptions || (this.descriptions = {}), this.descriptions.fallback ? this.descriptions.fallback.innerHTML !== e3 && (this.descriptions.fallback.innerHTML = e3) : this._describeHTML("fallback", e3), t3 === this.LABEL && (this.descriptions.label ? this.descriptions.label.innerHTML !== e3 && (this.descriptions.label.innerHTML = e3) : this._describeHTML("label", e3));
        }
      }, a2.default.prototype.describeElement = function(e3, t3, r3) {
        if (a2.default._validateParameters("describeElement", arguments), typeof t3 == "string" && typeof e3 == "string") {
          var n3 = this.canvas.id;
          t3 = s(t3);
          var o3 = function(e4) {
            if (e4 === "label" || e4 === "fallback")
              throw new Error("element name should not be LABEL or FALLBACK");
            e4.endsWith(".") || e4.endsWith(";") || e4.endsWith(",") ? e4 = e4.replace(/.$/, ":") : e4.endsWith(":") || (e4 += ":");
            return e4;
          }(e3);
          e3 = e3.replace(/[^a-zA-Z0-9]/g, "");
          var i2 = '<th scope="row">'.concat(o3, "</th><td>").concat(t3, "</td>");
          this.dummyDOM || (this.dummyDOM = document.getElementById(n3).parentNode), this.descriptions ? this.descriptions.fallbackElements || (this.descriptions.fallbackElements = {}) : this.descriptions = { fallbackElements: {} }, this.descriptions.fallbackElements[e3] ? this.descriptions.fallbackElements[e3].innerHTML !== i2 && (this.descriptions.fallbackElements[e3].innerHTML = i2) : this._describeElementHTML("fallback", e3, i2), r3 === this.LABEL && (this.descriptions.labelElements || (this.descriptions.labelElements = {}), this.descriptions.labelElements[e3] ? this.descriptions.labelElements[e3].innerHTML !== i2 && (this.descriptions.labelElements[e3].innerHTML = i2) : this._describeElementHTML("label", e3, i2));
        }
      }, a2.default.prototype._describeHTML = function(e3, t3) {
        var r3 = this.canvas.id;
        if (e3 === "fallback") {
          if (this.dummyDOM.querySelector("#".concat(r3 + l2)))
            this.dummyDOM.querySelector("#" + r3 + c).insertAdjacentHTML("beforebegin", '<p id="'.concat(r3 + u2, '"></p>'));
          else {
            var n3 = '<div id="'.concat(r3).concat(l2, '" role="region" aria-label="Canvas Description"><p id="').concat(r3).concat(u2, '"></p></div>');
            this.dummyDOM.querySelector("#".concat(r3, "accessibleOutput")) ? this.dummyDOM.querySelector("#".concat(r3, "accessibleOutput")).insertAdjacentHTML("beforebegin", n3) : this.dummyDOM.querySelector("#".concat(r3)).innerHTML = n3;
          }
          return this.descriptions.fallback = this.dummyDOM.querySelector("#".concat(r3).concat(u2)), void (this.descriptions.fallback.innerHTML = t3);
        }
        if (e3 === "label") {
          if (this.dummyDOM.querySelector("#".concat(r3 + d)))
            this.dummyDOM.querySelector("#".concat(r3 + h2)) && this.dummyDOM.querySelector("#".concat(r3 + h2)).insertAdjacentHTML("beforebegin", '<p id="'.concat(r3).concat(f, '"></p>'));
          else {
            var o3 = '<div id="'.concat(r3).concat(d, '" class="p5Label"><p id="').concat(r3).concat(f, '"></p></div>');
            this.dummyDOM.querySelector("#".concat(r3, "accessibleOutputLabel")) ? this.dummyDOM.querySelector("#".concat(r3, "accessibleOutputLabel")).insertAdjacentHTML("beforebegin", o3) : this.dummyDOM.querySelector("#" + r3).insertAdjacentHTML("afterend", o3);
          }
          return this.descriptions.label = this.dummyDOM.querySelector("#" + r3 + f), void (this.descriptions.label.innerHTML = t3);
        }
      }, a2.default.prototype._describeElementHTML = function(e3, t3, r3) {
        var n3 = this.canvas.id;
        if (e3 === "fallback") {
          if (this.dummyDOM.querySelector("#".concat(n3 + l2)))
            this.dummyDOM.querySelector("#" + n3 + c) || this.dummyDOM.querySelector("#" + n3 + u2).insertAdjacentHTML("afterend", '<table id="'.concat(n3).concat(c, '"><caption>Canvas elements and their descriptions</caption></table>'));
          else {
            var o3 = '<div id="'.concat(n3).concat(l2, '" role="region" aria-label="Canvas Description"><table id="').concat(n3).concat(c, '"><caption>Canvas elements and their descriptions</caption></table></div>');
            this.dummyDOM.querySelector("#".concat(n3, "accessibleOutput")) ? this.dummyDOM.querySelector("#".concat(n3, "accessibleOutput")).insertAdjacentHTML("beforebegin", o3) : this.dummyDOM.querySelector("#" + n3).innerHTML = o3;
          }
          var i2 = document.createElement("tr");
          return i2.id = n3 + "_fte_" + t3, this.dummyDOM.querySelector("#" + n3 + c).appendChild(i2), this.descriptions.fallbackElements[t3] = this.dummyDOM.querySelector("#".concat(n3).concat("_fte_").concat(t3)), void (this.descriptions.fallbackElements[t3].innerHTML = r3);
        }
        if (e3 === "label") {
          if (this.dummyDOM.querySelector("#".concat(n3 + d)))
            this.dummyDOM.querySelector("#".concat(n3 + h2)) || this.dummyDOM.querySelector("#" + n3 + f).insertAdjacentHTML("afterend", '<table id="'.concat(n3 + h2, '"></table>'));
          else {
            var a3 = '<div id="'.concat(n3).concat(d, '" class="p5Label"><table id="').concat(n3).concat(h2, '"></table></div>');
            this.dummyDOM.querySelector("#".concat(n3, "accessibleOutputLabel")) ? this.dummyDOM.querySelector("#".concat(n3, "accessibleOutputLabel")).insertAdjacentHTML("beforebegin", a3) : this.dummyDOM.querySelector("#" + n3).insertAdjacentHTML("afterend", a3);
          }
          var s2 = document.createElement("tr");
          s2.id = n3 + "_lte_" + t3, this.dummyDOM.querySelector("#" + n3 + h2).appendChild(s2), this.descriptions.labelElements[t3] = this.dummyDOM.querySelector("#".concat(n3).concat("_lte_").concat(t3)), this.descriptions.labelElements[t3].innerHTML = r3;
        }
      };
      var o2 = a2.default;
      r2.default = o2;
    }, { "../core/main": 264, "core-js/modules/es.array.concat": 149, "core-js/modules/es.regexp.exec": 181, "core-js/modules/es.string.ends-with": 184, "core-js/modules/es.string.replace": 189 }], 245: [function(e2, t2, r2) {
      e2("core-js/modules/es.array.concat"), e2("core-js/modules/es.array.map"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, o2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      o2.default.prototype._updateGridOutput = function(e3) {
        if (this.dummyDOM.querySelector("#".concat(e3, "_summary"))) {
          var t3 = this._accessibleOutputs[e3], r3 = function(e4, t4) {
            var r4 = "", n4 = "", o4 = 0;
            for (var i3 in t4) {
              var a2 = 0;
              for (var s in t4[i3]) {
                var l2 = '<li id="'.concat(e4, "shape").concat(o4, '">').concat(t4[i3][s].color, " ").concat(i3, ",");
                i3 === "line" ? l2 += " location = ".concat(t4[i3][s].pos, ", length = ").concat(t4[i3][s].length, " pixels") : (l2 += " location = ".concat(t4[i3][s].pos), i3 !== "point" && (l2 += ", area = ".concat(t4[i3][s].area, " %")), l2 += "</li>"), r4 += l2, a2++, o4++;
              }
              n4 = 1 < a2 ? "".concat(n4, " ").concat(a2, " ").concat(i3, "s") : "".concat(n4, " ").concat(a2, " ").concat(i3);
            }
            return { numShapes: [o4, n4], details: r4 };
          }(e3, this.ingredients.shapes), n3 = function(e4, t4, r4, n4) {
            var o4 = "".concat(t4, " canvas, ").concat(r4, " by ").concat(n4, " pixels, contains ").concat(e4[0]);
            o4 = e4[0] === 1 ? "".concat(o4, " shape: ").concat(e4[1]) : "".concat(o4, " shapes: ").concat(e4[1]);
            return o4;
          }(r3.numShapes, this.ingredients.colors.background, this.width, this.height), o3 = function(e4, t4) {
            var r4 = 0, n4 = "", o4 = Array.apply(null, Array(10)).map(function() {
            });
            for (var i3 in o4)
              o4[i3] = Array.apply(null, Array(10)).map(function() {
              });
            for (var a2 in t4)
              for (var s in t4[a2]) {
                var l2 = void 0;
                l2 = a2 !== "line" ? '<a href="#'.concat(e4, "shape").concat(r4, '">').concat(t4[a2][s].color, " ").concat(a2, "</a>") : '<a href="#'.concat(e4, "shape").concat(r4, '">').concat(t4[a2][s].color, " ").concat(a2, " midpoint</a>"), o4[t4[a2][s].loc.locY][t4[a2][s].loc.locX] ? o4[t4[a2][s].loc.locY][t4[a2][s].loc.locX] = o4[t4[a2][s].loc.locY][t4[a2][s].loc.locX] + "  " + l2 : o4[t4[a2][s].loc.locY][t4[a2][s].loc.locX] = l2, r4++;
              }
            for (var u2 in o4) {
              var c = "<tr>";
              for (var d in o4[u2])
                c += "<td>", o4[u2][d] !== void 0 && (c += o4[u2][d]), c += "</td>";
              n4 = n4 + c + "</tr>";
            }
            return n4;
          }(e3, this.ingredients.shapes);
          n3 !== t3.summary.innerHTML && (t3.summary.innerHTML = n3), o3 !== t3.map.innerHTML && (t3.map.innerHTML = o3), r3.details !== t3.shapeDetails.innerHTML && (t3.shapeDetails.innerHTML = r3.details), this._accessibleOutputs[e3] = t3;
        }
      };
      var i2 = o2.default;
      r2.default = i2;
    }, { "../core/main": 264, "core-js/modules/es.array.concat": 149, "core-js/modules/es.array.map": 161 }], 246: [function(e2, t2, r2) {
      e2("core-js/modules/es.array.concat"), e2("core-js/modules/es.array.fill"), e2("core-js/modules/es.array.map"), e2("core-js/modules/es.number.to-fixed"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, o2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      function l2(e3, t3, r3) {
        return e3[0] < 0.4 * t3 ? e3[1] < 0.4 * r3 ? "top left" : e3[1] > 0.6 * r3 ? "bottom left" : "mid left" : e3[0] > 0.6 * t3 ? e3[1] < 0.4 * r3 ? "top right" : e3[1] > 0.6 * r3 ? "bottom right" : "mid right" : e3[1] < 0.4 * r3 ? "top middle" : e3[1] > 0.6 * r3 ? "bottom middle" : "middle";
      }
      function u2(e3, t3, r3) {
        var n3 = Math.floor(e3[0] / t3 * 10), o3 = Math.floor(e3[1] / r3 * 10);
        return n3 === 10 && --n3, o3 === 10 && --o3, { locX: n3, locY: o3 };
      }
      o2.default.prototype.textOutput = function(e3) {
        o2.default._validateParameters("textOutput", arguments), this._accessibleOutputs.text || (this._accessibleOutputs.text = true, this._createOutput("textOutput", "Fallback"), e3 === this.LABEL && (this._accessibleOutputs.textLabel = true, this._createOutput("textOutput", "Label")));
      }, o2.default.prototype.gridOutput = function(e3) {
        o2.default._validateParameters("gridOutput", arguments), this._accessibleOutputs.grid || (this._accessibleOutputs.grid = true, this._createOutput("gridOutput", "Fallback"), e3 === this.LABEL && (this._accessibleOutputs.gridLabel = true, this._createOutput("gridOutput", "Label")));
      }, o2.default.prototype._addAccsOutput = function() {
        return this._accessibleOutputs || (this._accessibleOutputs = { text: false, grid: false, textLabel: false, gridLabel: false }), this._accessibleOutputs.grid || this._accessibleOutputs.text;
      }, o2.default.prototype._createOutput = function(e3, t3) {
        var r3, n3, o3, i3 = this.canvas.id;
        this.ingredients || (this.ingredients = { shapes: {}, colors: { background: "white", fill: "white", stroke: "black" }, pShapes: "" }), this.dummyDOM || (this.dummyDOM = document.getElementById(i3).parentNode);
        var a2 = "";
        t3 === "Fallback" ? (r3 = i3 + e3, n3 = i3 + "accessibleOutput", this.dummyDOM.querySelector("#".concat(n3)) || (this.dummyDOM.querySelector("#".concat(i3, "_Description")) ? this.dummyDOM.querySelector("#".concat(i3, "_Description")).insertAdjacentHTML("afterend", '<div id="'.concat(n3, '" role="region" aria-label="Canvas Outputs"></div>')) : this.dummyDOM.querySelector("#".concat(i3)).innerHTML = '<div id="'.concat(n3, '" role="region" aria-label="Canvas Outputs"></div>'))) : t3 === "Label" && (r3 = i3 + e3 + (a2 = t3), n3 = i3 + "accessibleOutput" + t3, this.dummyDOM.querySelector("#".concat(n3)) || (this.dummyDOM.querySelector("#".concat(i3, "_Label")) ? this.dummyDOM.querySelector("#".concat(i3, "_Label")).insertAdjacentHTML("afterend", '<div id="'.concat(n3, '"></div>')) : this.dummyDOM.querySelector("#".concat(i3)).insertAdjacentHTML("afterend", '<div id="'.concat(n3, '"></div>')))), this._accessibleOutputs[r3] = {}, e3 === "textOutput" ? (a2 = "#".concat(i3, "gridOutput").concat(a2), o3 = '<div id="'.concat(r3, '">Text Output<div id="').concat(r3, 'Summary" aria-label="text output summary"><p id="').concat(r3, '_summary"></p><ul id="').concat(r3, '_list"></ul></div><table id="').concat(r3, '_shapeDetails" summary="text output shape details"></table></div>'), this.dummyDOM.querySelector(a2) ? this.dummyDOM.querySelector(a2).insertAdjacentHTML("beforebegin", o3) : this.dummyDOM.querySelector("#".concat(n3)).innerHTML = o3, this._accessibleOutputs[r3].list = this.dummyDOM.querySelector("#".concat(r3, "_list"))) : e3 === "gridOutput" && (a2 = "#".concat(i3, "textOutput").concat(a2), o3 = '<div id="'.concat(r3, '">Grid Output<p id="').concat(r3, '_summary" aria-label="grid output summary"><table id="').concat(r3, '_map" summary="grid output content"></table><ul id="').concat(r3, '_shapeDetails" aria-label="grid output shape details"></ul></div>'), this.dummyDOM.querySelector(a2) ? this.dummyDOM.querySelector(a2).insertAdjacentHTML("afterend", o3) : this.dummyDOM.querySelector("#".concat(n3)).innerHTML = o3, this._accessibleOutputs[r3].map = this.dummyDOM.querySelector("#".concat(r3, "_map"))), this._accessibleOutputs[r3].shapeDetails = this.dummyDOM.querySelector("#".concat(r3, "_shapeDetails")), this._accessibleOutputs[r3].summary = this.dummyDOM.querySelector("#".concat(r3, "_summary"));
      }, o2.default.prototype._updateAccsOutput = function() {
        var e3 = this.canvas.id;
        JSON.stringify(this.ingredients.shapes) !== this.ingredients.pShapes && (this.ingredients.pShapes = JSON.stringify(this.ingredients.shapes), this._accessibleOutputs.text && this._updateTextOutput(e3 + "textOutput"), this._accessibleOutputs.grid && this._updateGridOutput(e3 + "gridOutput"), this._accessibleOutputs.textLabel && this._updateTextOutput(e3 + "textOutputLabel"), this._accessibleOutputs.gridLabel && this._updateGridOutput(e3 + "gridOutputLabel"));
      }, o2.default.prototype._accsBackground = function(e3) {
        this.ingredients.pShapes = JSON.stringify(this.ingredients.shapes), this.ingredients.shapes = {}, this.ingredients.colors.backgroundRGBA !== e3 && (this.ingredients.colors.backgroundRGBA = e3, this.ingredients.colors.background = this._rgbColorName(e3));
      }, o2.default.prototype._accsCanvasColors = function(e3, t3) {
        e3 === "fill" ? this.ingredients.colors.fillRGBA !== t3 && (this.ingredients.colors.fillRGBA = t3, this.ingredients.colors.fill = this._rgbColorName(t3)) : e3 === "stroke" && this.ingredients.colors.strokeRGBA !== t3 && (this.ingredients.colors.strokeRGBA = t3, this.ingredients.colors.stroke = this._rgbColorName(t3));
      }, o2.default.prototype._accsOutput = function(e3, t3) {
        e3 === "ellipse" && t3[2] === t3[3] ? e3 = "circle" : e3 === "rectangle" && t3[2] === t3[3] && (e3 = "square");
        var r3 = {}, n3 = true, o3 = function(e4, t4) {
          var r4, n4;
          n4 = e4 === "rectangle" || e4 === "ellipse" || e4 === "arc" || e4 === "circle" || e4 === "square" ? (r4 = Math.round(t4[0] + t4[2] / 2), Math.round(t4[1] + t4[3] / 2)) : e4 === "triangle" ? (r4 = (t4[0] + t4[2] + t4[4]) / 3, (t4[1] + t4[3] + t4[5]) / 3) : e4 === "quadrilateral" ? (r4 = (t4[0] + t4[2] + t4[4] + t4[6]) / 4, (t4[1] + t4[3] + t4[5] + t4[7]) / 4) : e4 === "line" ? (r4 = (t4[0] + t4[2]) / 2, (t4[1] + t4[3]) / 2) : (r4 = t4[0], t4[1]);
          return [r4, n4];
        }(e3, t3);
        if (e3 === "line") {
          r3.color = this.ingredients.colors.stroke, r3.length = Math.round(this.dist(t3[0], t3[1], t3[2], t3[3]));
          var i3 = l2([t3[0], [1]], this.width, this.height), a2 = l2([t3[2], [3]], this.width, this.height);
          r3.loc = u2(o3, this.width, this.height), r3.pos = i3 === a2 ? "at ".concat(i3) : "from ".concat(i3, " to ").concat(a2);
        } else
          e3 === "point" ? r3.color = this.ingredients.colors.stroke : (r3.color = this.ingredients.colors.fill, r3.area = function(e4, t4, r4, n4) {
            var o4 = 0;
            if (e4 === "arc") {
              var i4 = ((t4[5] - t4[4]) % (2 * Math.PI) + 2 * Math.PI) % (2 * Math.PI);
              if (o4 = i4 * t4[2] * t4[3] / 8, t4[6] === "open" || t4[6] === "chord") {
                var a3 = t4[0], s2 = t4[1], l3 = t4[0] + t4[2] / 2 * Math.cos(t4[4]).toFixed(2), u3 = t4[1] + t4[3] / 2 * Math.sin(t4[4]).toFixed(2), c = t4[0] + t4[2] / 2 * Math.cos(t4[5]).toFixed(2), d = t4[1] + t4[3] / 2 * Math.sin(t4[5]).toFixed(2), f = Math.abs(a3 * (u3 - d) + l3 * (d - s2) + c * (s2 - u3)) / 2;
                i4 > Math.PI ? o4 += f : o4 -= f;
              }
            } else
              e4 === "ellipse" || e4 === "circle" ? o4 = 3.14 * t4[2] / 2 * t4[3] / 2 : e4 === "line" ? o4 = 0 : e4 === "point" ? o4 = 0 : e4 === "quadrilateral" ? o4 = Math.abs((t4[6] + t4[0]) * (t4[7] - t4[1]) + (t4[0] + t4[2]) * (t4[1] - t4[3]) + (t4[2] + t4[4]) * (t4[3] - t4[5]) + (t4[4] + t4[6]) * (t4[5] - t4[7])) / 2 : e4 === "rectangle" || e4 === "square" ? o4 = t4[2] * t4[3] : e4 === "triangle" && (o4 = Math.abs(t4[0] * (t4[3] - t4[5]) + t4[2] * (t4[5] - t4[1]) + t4[4] * (t4[1] - t4[3])) / 2);
            return Math.round(100 * o4 / (r4 * n4));
          }(e3, t3, this.width, this.height)), r3.pos = l2(o3, this.width, this.height), r3.loc = u2(o3, this.width, this.height);
        if (this.ingredients.shapes[e3]) {
          if (this.ingredients.shapes[e3] !== [r3]) {
            for (var s in this.ingredients.shapes[e3])
              JSON.stringify(this.ingredients.shapes[e3][s]) === JSON.stringify(r3) && (n3 = false);
            n3 === true && this.ingredients.shapes[e3].push(r3);
          }
        } else
          this.ingredients.shapes[e3] = [r3];
      };
      var i2 = o2.default;
      r2.default = i2;
    }, { "../core/main": 264, "core-js/modules/es.array.concat": 149, "core-js/modules/es.array.fill": 151, "core-js/modules/es.array.map": 161, "core-js/modules/es.number.to-fixed": 172 }], 247: [function(e2, t2, r2) {
      e2("core-js/modules/es.array.concat"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, o2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      o2.default.prototype._updateTextOutput = function(e3) {
        if (this.dummyDOM.querySelector("#".concat(e3, "_summary"))) {
          var t3 = this._accessibleOutputs[e3], r3 = function(e4, t4) {
            var r4 = "", n4 = 0;
            for (var o4 in t4)
              for (var i3 in t4[o4]) {
                var a2 = '<li><a href="#'.concat(e4, "shape").concat(n4, '">').concat(t4[o4][i3].color, " ").concat(o4, "</a>");
                o4 === "line" ? a2 += ", ".concat(t4[o4][i3].pos, ", ").concat(t4[o4][i3].length, " pixels long.</li>") : (a2 += ", at ".concat(t4[o4][i3].pos), o4 !== "point" && (a2 += ", covering ".concat(t4[o4][i3].area, "% of the canvas")), a2 += ".</li>"), r4 += a2, n4++;
              }
            return { numShapes: n4, listShapes: r4 };
          }(e3, this.ingredients.shapes), n3 = function(e4, t4, r4, n4) {
            var o4 = "Your output is a, ".concat(r4, " by ").concat(n4, " pixels, ").concat(t4, " canvas containing the following");
            o4 = e4 === 1 ? "".concat(o4, " shape:") : "".concat(o4, " ").concat(e4, " shapes:");
            return o4;
          }(r3.numShapes, this.ingredients.colors.background, this.width, this.height), o3 = function(e4, t4) {
            var r4 = "", n4 = 0;
            for (var o4 in t4)
              for (var i3 in t4[o4]) {
                var a2 = '<tr id="'.concat(e4, "shape").concat(n4, '"><th>').concat(t4[o4][i3].color, " ").concat(o4, "</th>");
                o4 === "line" ? a2 += "<td>location = ".concat(t4[o4][i3].pos, "</td><td>length = ").concat(t4[o4][i3].length, " pixels</td></tr>") : (a2 += "<td>location = ".concat(t4[o4][i3].pos, "</td>"), o4 !== "point" && (a2 += "<td> area = ".concat(t4[o4][i3].area, "%</td>")), a2 += "</tr>"), r4 += a2, n4++;
              }
            return r4;
          }(e3, this.ingredients.shapes);
          n3 !== t3.summary.innerHTML && (t3.summary.innerHTML = n3), r3.listShapes !== t3.list.innerHTML && (t3.list.innerHTML = r3.listShapes), o3 !== t3.shapeDetails.innerHTML && (t3.shapeDetails.innerHTML = o3), this._accessibleOutputs[e3] = t3;
        }
      };
      var i2 = o2.default;
      r2.default = i2;
    }, { "../core/main": 264, "core-js/modules/es.array.concat": 149 }], 248: [function(e2, t2, r2) {
      var n2, o2 = (n2 = e2("./core/main")) && n2.__esModule ? n2 : { default: n2 };
      e2("./core/constants"), e2("./core/environment"), e2("./core/friendly_errors/stacktrace"), e2("./core/friendly_errors/validate_params"), e2("./core/friendly_errors/file_errors"), e2("./core/friendly_errors/fes_core"), e2("./core/friendly_errors/sketch_reader"), e2("./core/helpers"), e2("./core/legacy"), e2("./core/preload"), e2("./core/p5.Element"), e2("./core/p5.Graphics"), e2("./core/p5.Renderer"), e2("./core/p5.Renderer2D"), e2("./core/rendering"), e2("./core/shim"), e2("./core/structure"), e2("./core/transform"), e2("./core/shape/2d_primitives"), e2("./core/shape/attributes"), e2("./core/shape/curves"), e2("./core/shape/vertex"), e2("./accessibility/outputs"), e2("./accessibility/textOutput"), e2("./accessibility/gridOutput"), e2("./accessibility/color_namer"), e2("./color/color_conversion"), e2("./color/creating_reading"), e2("./color/p5.Color"), e2("./color/setting"), e2("./data/p5.TypedDict"), e2("./data/local_storage.js"), e2("./dom/dom"), e2("./accessibility/describe"), e2("./events/acceleration"), e2("./events/keyboard"), e2("./events/mouse"), e2("./events/touch"), e2("./image/filters"), e2("./image/image"), e2("./image/loading_displaying"), e2("./image/p5.Image"), e2("./image/pixels"), e2("./io/files"), e2("./io/p5.Table"), e2("./io/p5.TableRow"), e2("./io/p5.XML"), e2("./math/calculation"), e2("./math/math"), e2("./math/noise"), e2("./math/p5.Vector"), e2("./math/random"), e2("./math/trigonometry"), e2("./typography/attributes"), e2("./typography/loading_displaying"), e2("./typography/p5.Font"), e2("./utilities/array_functions"), e2("./utilities/conversion"), e2("./utilities/string_functions"), e2("./utilities/time_date"), e2("./webgl/3d_primitives"), e2("./webgl/interaction"), e2("./webgl/light"), e2("./webgl/loading"), e2("./webgl/material"), e2("./webgl/p5.Camera"), e2("./webgl/p5.Geometry"), e2("./webgl/p5.Matrix"), e2("./webgl/p5.RendererGL.Immediate"), e2("./webgl/p5.RendererGL"), e2("./webgl/p5.RendererGL.Retained"), e2("./webgl/p5.Shader"), e2("./webgl/p5.RenderBuffer"), e2("./webgl/p5.Texture"), e2("./webgl/text"), e2("./core/init"), t2.exports = o2.default;
    }, { "./accessibility/color_namer": 243, "./accessibility/describe": 244, "./accessibility/gridOutput": 245, "./accessibility/outputs": 246, "./accessibility/textOutput": 247, "./color/color_conversion": 249, "./color/creating_reading": 250, "./color/p5.Color": 251, "./color/setting": 252, "./core/constants": 253, "./core/environment": 254, "./core/friendly_errors/fes_core": 255, "./core/friendly_errors/file_errors": 256, "./core/friendly_errors/sketch_reader": 257, "./core/friendly_errors/stacktrace": 258, "./core/friendly_errors/validate_params": 259, "./core/helpers": 260, "./core/init": 261, "./core/legacy": 263, "./core/main": 264, "./core/p5.Element": 265, "./core/p5.Graphics": 266, "./core/p5.Renderer": 267, "./core/p5.Renderer2D": 268, "./core/preload": 269, "./core/rendering": 270, "./core/shape/2d_primitives": 271, "./core/shape/attributes": 272, "./core/shape/curves": 273, "./core/shape/vertex": 274, "./core/shim": 275, "./core/structure": 276, "./core/transform": 277, "./data/local_storage.js": 278, "./data/p5.TypedDict": 279, "./dom/dom": 280, "./events/acceleration": 281, "./events/keyboard": 282, "./events/mouse": 283, "./events/touch": 284, "./image/filters": 285, "./image/image": 286, "./image/loading_displaying": 287, "./image/p5.Image": 288, "./image/pixels": 289, "./io/files": 290, "./io/p5.Table": 291, "./io/p5.TableRow": 292, "./io/p5.XML": 293, "./math/calculation": 294, "./math/math": 295, "./math/noise": 296, "./math/p5.Vector": 297, "./math/random": 298, "./math/trigonometry": 299, "./typography/attributes": 300, "./typography/loading_displaying": 301, "./typography/p5.Font": 302, "./utilities/array_functions": 303, "./utilities/conversion": 304, "./utilities/string_functions": 305, "./utilities/time_date": 306, "./webgl/3d_primitives": 307, "./webgl/interaction": 308, "./webgl/light": 309, "./webgl/loading": 310, "./webgl/material": 311, "./webgl/p5.Camera": 312, "./webgl/p5.Geometry": 313, "./webgl/p5.Matrix": 314, "./webgl/p5.RenderBuffer": 315, "./webgl/p5.RendererGL": 318, "./webgl/p5.RendererGL.Immediate": 316, "./webgl/p5.RendererGL.Retained": 317, "./webgl/p5.Shader": 319, "./webgl/p5.Texture": 320, "./webgl/text": 321 }], 249: [function(e2, t2, r2) {
      Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, o2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      o2.default.ColorConversion = {}, o2.default.ColorConversion._hsbaToHSLA = function(e3) {
        var t3 = e3[0], r3 = e3[1], n3 = e3[2], o3 = (2 - r3) * n3 / 2;
        return o3 != 0 && (o3 == 1 ? r3 = 0 : o3 < 0.5 ? r3 /= 2 - r3 : r3 = r3 * n3 / (2 - 2 * o3)), [t3, r3, o3, e3[3]];
      }, o2.default.ColorConversion._hsbaToRGBA = function(e3) {
        var t3 = 6 * e3[0], r3 = e3[1], n3 = e3[2], o3 = [];
        if (r3 === 0)
          o3 = [n3, n3, n3, e3[3]];
        else {
          var i3, a2, s, l2 = Math.floor(t3), u2 = n3 * (1 - r3), c = n3 * (1 - r3 * (t3 - l2)), d = n3 * (1 - r3 * (1 + l2 - t3));
          s = l2 === 1 ? (i3 = c, a2 = n3, u2) : l2 === 2 ? (i3 = u2, a2 = n3, d) : l2 === 3 ? (i3 = u2, a2 = c, n3) : l2 === 4 ? (i3 = d, a2 = u2, n3) : l2 === 5 ? (i3 = n3, a2 = u2, c) : (i3 = n3, a2 = d, u2), o3 = [i3, a2, s, e3[3]];
        }
        return o3;
      }, o2.default.ColorConversion._hslaToHSBA = function(e3) {
        var t3, r3 = e3[0], n3 = e3[1], o3 = e3[2];
        return [r3, n3 = 2 * ((t3 = o3 < 0.5 ? (1 + n3) * o3 : o3 + n3 - o3 * n3) - o3) / t3, t3, e3[3]];
      }, o2.default.ColorConversion._hslaToRGBA = function(e3) {
        var t3 = 6 * e3[0], r3 = e3[1], n3 = e3[2], o3 = [];
        if (r3 === 0)
          o3 = [n3, n3, n3, e3[3]];
        else {
          var i3, a2 = 2 * n3 - (i3 = n3 < 0.5 ? (1 + r3) * n3 : n3 + r3 - n3 * r3), s = function(e4, t4, r4) {
            return e4 < 0 ? e4 += 6 : 6 <= e4 && (e4 -= 6), e4 < 1 ? t4 + (r4 - t4) * e4 : e4 < 3 ? r4 : e4 < 4 ? t4 + (r4 - t4) * (4 - e4) : t4;
          };
          o3 = [s(2 + t3, a2, i3), s(t3, a2, i3), s(t3 - 2, a2, i3), e3[3]];
        }
        return o3;
      }, o2.default.ColorConversion._rgbaToHSBA = function(e3) {
        var t3, r3, n3 = e3[0], o3 = e3[1], i3 = e3[2], a2 = Math.max(n3, o3, i3), s = a2 - Math.min(n3, o3, i3);
        return s == 0 ? r3 = t3 = 0 : (r3 = s / a2, n3 === a2 ? t3 = (o3 - i3) / s : o3 === a2 ? t3 = 2 + (i3 - n3) / s : i3 === a2 && (t3 = 4 + (n3 - o3) / s), t3 < 0 ? t3 += 6 : 6 <= t3 && (t3 -= 6)), [t3 / 6, r3, a2, e3[3]];
      }, o2.default.ColorConversion._rgbaToHSLA = function(e3) {
        var t3, r3, n3 = e3[0], o3 = e3[1], i3 = e3[2], a2 = Math.max(n3, o3, i3), s = Math.min(n3, o3, i3), l2 = a2 + s, u2 = a2 - s;
        return u2 == 0 ? r3 = t3 = 0 : (r3 = l2 < 1 ? u2 / l2 : u2 / (2 - l2), n3 === a2 ? t3 = (o3 - i3) / u2 : o3 === a2 ? t3 = 2 + (i3 - n3) / u2 : i3 === a2 && (t3 = 4 + (n3 - o3) / u2), t3 < 0 ? t3 += 6 : 6 <= t3 && (t3 -= 6)), [t3 / 6, r3, l2 / 2, e3[3]];
      };
      var i2 = o2.default.ColorConversion;
      r2.default = i2;
    }, { "../core/main": 264 }], 250: [function(e2, t2, r2) {
      function a2(e3) {
        return (a2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      e2("core-js/modules/es.array.map"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, d = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 }, f = function(e3) {
        if (e3 && e3.__esModule)
          return e3;
        if (e3 === null || a2(e3) !== "object" && typeof e3 != "function")
          return { default: e3 };
        var t3 = s();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o3 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o3)) {
            var i2 = n3 ? Object.getOwnPropertyDescriptor(e3, o3) : null;
            i2 && (i2.get || i2.set) ? Object.defineProperty(r3, o3, i2) : r3[o3] = e3[o3];
          }
        r3.default = e3, t3 && t3.set(e3, r3);
        return r3;
      }(e2("../core/constants"));
      function s() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return s = function() {
          return e3;
        }, e3;
      }
      e2("./p5.Color"), e2("../core/friendly_errors/validate_params"), e2("../core/friendly_errors/file_errors"), e2("../core/friendly_errors/fes_core"), d.default.prototype.alpha = function(e3) {
        return d.default._validateParameters("alpha", arguments), this.color(e3)._getAlpha();
      }, d.default.prototype.blue = function(e3) {
        return d.default._validateParameters("blue", arguments), this.color(e3)._getBlue();
      }, d.default.prototype.brightness = function(e3) {
        return d.default._validateParameters("brightness", arguments), this.color(e3)._getBrightness();
      }, d.default.prototype.color = function() {
        if (d.default._validateParameters("color", arguments), arguments[0] instanceof d.default.Color)
          return arguments[0];
        var e3 = arguments[0] instanceof Array ? arguments[0] : arguments;
        return new d.default.Color(this, e3);
      }, d.default.prototype.green = function(e3) {
        return d.default._validateParameters("green", arguments), this.color(e3)._getGreen();
      }, d.default.prototype.hue = function(e3) {
        return d.default._validateParameters("hue", arguments), this.color(e3)._getHue();
      }, d.default.prototype.lerpColor = function(e3, t3, r3) {
        d.default._validateParameters("lerpColor", arguments);
        var n3, o3, i2, a3, s2, l2, u2 = this._colorMode, c = this._colorMaxes;
        if (u2 === f.RGB)
          s2 = e3.levels.map(function(e4) {
            return e4 / 255;
          }), l2 = t3.levels.map(function(e4) {
            return e4 / 255;
          });
        else if (u2 === f.HSB)
          e3._getBrightness(), t3._getBrightness(), s2 = e3.hsba, l2 = t3.hsba;
        else {
          if (u2 !== f.HSL)
            throw new Error("".concat(u2, "cannot be used for interpolation."));
          e3._getLightness(), t3._getLightness(), s2 = e3.hsla, l2 = t3.hsla;
        }
        return r3 = Math.max(Math.min(r3, 1), 0), this.lerp === void 0 && (this.lerp = function(e4, t4, r4) {
          return r4 * (t4 - e4) + e4;
        }), n3 = this.lerp(s2[0], l2[0], r3), o3 = this.lerp(s2[1], l2[1], r3), i2 = this.lerp(s2[2], l2[2], r3), a3 = this.lerp(s2[3], l2[3], r3), n3 *= c[u2][0], o3 *= c[u2][1], i2 *= c[u2][2], a3 *= c[u2][3], this.color(n3, o3, i2, a3);
      }, d.default.prototype.lightness = function(e3) {
        return d.default._validateParameters("lightness", arguments), this.color(e3)._getLightness();
      }, d.default.prototype.red = function(e3) {
        return d.default._validateParameters("red", arguments), this.color(e3)._getRed();
      }, d.default.prototype.saturation = function(e3) {
        return d.default._validateParameters("saturation", arguments), this.color(e3)._getSaturation();
      };
      var o2 = d.default;
      r2.default = o2;
    }, { "../core/constants": 253, "../core/friendly_errors/fes_core": 255, "../core/friendly_errors/file_errors": 256, "../core/friendly_errors/validate_params": 259, "../core/main": 264, "./p5.Color": 251, "core-js/modules/es.array.map": 161 }], 251: [function(e2, t2, r2) {
      function a2(e3) {
        return (a2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      e2("core-js/modules/es.array.join"), e2("core-js/modules/es.array.map"), e2("core-js/modules/es.array.slice"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.regexp.constructor"), e2("core-js/modules/es.regexp.exec"), e2("core-js/modules/es.regexp.to-string"), e2("core-js/modules/es.string.trim"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var d = n2(e2("../core/main")), f = function(e3) {
        if (e3 && e3.__esModule)
          return e3;
        if (e3 === null || a2(e3) !== "object" && typeof e3 != "function")
          return { default: e3 };
        var t3 = s();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o3 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o3)) {
            var i3 = n3 ? Object.getOwnPropertyDescriptor(e3, o3) : null;
            i3 && (i3.get || i3.set) ? Object.defineProperty(r3, o3, i3) : r3[o3] = e3[o3];
          }
        r3.default = e3, t3 && t3.set(e3, r3);
        return r3;
      }(e2("../core/constants")), h2 = n2(e2("./color_conversion"));
      function s() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return s = function() {
          return e3;
        }, e3;
      }
      function n2(e3) {
        return e3 && e3.__esModule ? e3 : { default: e3 };
      }
      d.default.Color = function(e3, t3) {
        if (this._storeModeAndMaxes(e3._colorMode, e3._colorMaxes), this.mode !== f.RGB && this.mode !== f.HSL && this.mode !== f.HSB)
          throw new Error("".concat(this.mode, " is an invalid colorMode."));
        return this._array = d.default.Color._parseInputs.apply(this, t3), this._calculateLevels(), this;
      }, d.default.Color.prototype.toString = function(e3) {
        var t3 = this.levels, r3 = this._array, n3 = r3[3];
        switch (e3) {
          case "#rrggbb":
            return "#".concat(t3[0] < 16 ? "0".concat(t3[0].toString(16)) : t3[0].toString(16), t3[1] < 16 ? "0".concat(t3[1].toString(16)) : t3[1].toString(16), t3[2] < 16 ? "0".concat(t3[2].toString(16)) : t3[2].toString(16));
          case "#rrggbbaa":
            return "#".concat(t3[0] < 16 ? "0".concat(t3[0].toString(16)) : t3[0].toString(16), t3[1] < 16 ? "0".concat(t3[1].toString(16)) : t3[1].toString(16), t3[2] < 16 ? "0".concat(t3[2].toString(16)) : t3[2].toString(16), t3[3] < 16 ? "0".concat(t3[3].toString(16)) : t3[3].toString(16));
          case "#rgb":
            return "#".concat(Math.round(15 * r3[0]).toString(16), Math.round(15 * r3[1]).toString(16), Math.round(15 * r3[2]).toString(16));
          case "#rgba":
            return "#".concat(Math.round(15 * r3[0]).toString(16), Math.round(15 * r3[1]).toString(16), Math.round(15 * r3[2]).toString(16), Math.round(15 * r3[3]).toString(16));
          case "rgb":
            return "rgb(".concat(t3[0], ", ", t3[1], ", ", t3[2], ")");
          case "rgb%":
            return "rgb(".concat((100 * r3[0]).toPrecision(3), "%, ", (100 * r3[1]).toPrecision(3), "%, ", (100 * r3[2]).toPrecision(3), "%)");
          case "rgba%":
            return "rgba(".concat((100 * r3[0]).toPrecision(3), "%, ", (100 * r3[1]).toPrecision(3), "%, ", (100 * r3[2]).toPrecision(3), "%, ", (100 * r3[3]).toPrecision(3), "%)");
          case "hsb":
          case "hsv":
            return this.hsba || (this.hsba = h2.default._rgbaToHSBA(this._array)), "hsb(".concat(this.hsba[0] * this.maxes[f.HSB][0], ", ", this.hsba[1] * this.maxes[f.HSB][1], ", ", this.hsba[2] * this.maxes[f.HSB][2], ")");
          case "hsb%":
          case "hsv%":
            return this.hsba || (this.hsba = h2.default._rgbaToHSBA(this._array)), "hsb(".concat((100 * this.hsba[0]).toPrecision(3), "%, ", (100 * this.hsba[1]).toPrecision(3), "%, ", (100 * this.hsba[2]).toPrecision(3), "%)");
          case "hsba":
          case "hsva":
            return this.hsba || (this.hsba = h2.default._rgbaToHSBA(this._array)), "hsba(".concat(this.hsba[0] * this.maxes[f.HSB][0], ", ", this.hsba[1] * this.maxes[f.HSB][1], ", ", this.hsba[2] * this.maxes[f.HSB][2], ", ", n3, ")");
          case "hsba%":
          case "hsva%":
            return this.hsba || (this.hsba = h2.default._rgbaToHSBA(this._array)), "hsba(".concat((100 * this.hsba[0]).toPrecision(3), "%, ", (100 * this.hsba[1]).toPrecision(3), "%, ", (100 * this.hsba[2]).toPrecision(3), "%, ", (100 * n3).toPrecision(3), "%)");
          case "hsl":
            return this.hsla || (this.hsla = h2.default._rgbaToHSLA(this._array)), "hsl(".concat(this.hsla[0] * this.maxes[f.HSL][0], ", ", this.hsla[1] * this.maxes[f.HSL][1], ", ", this.hsla[2] * this.maxes[f.HSL][2], ")");
          case "hsl%":
            return this.hsla || (this.hsla = h2.default._rgbaToHSLA(this._array)), "hsl(".concat((100 * this.hsla[0]).toPrecision(3), "%, ", (100 * this.hsla[1]).toPrecision(3), "%, ", (100 * this.hsla[2]).toPrecision(3), "%)");
          case "hsla":
            return this.hsla || (this.hsla = h2.default._rgbaToHSLA(this._array)), "hsla(".concat(this.hsla[0] * this.maxes[f.HSL][0], ", ", this.hsla[1] * this.maxes[f.HSL][1], ", ", this.hsla[2] * this.maxes[f.HSL][2], ", ", n3, ")");
          case "hsla%":
            return this.hsla || (this.hsla = h2.default._rgbaToHSLA(this._array)), "hsl(".concat((100 * this.hsla[0]).toPrecision(3), "%, ", (100 * this.hsla[1]).toPrecision(3), "%, ", (100 * this.hsla[2]).toPrecision(3), "%, ", (100 * n3).toPrecision(3), "%)");
          case "rgba":
          default:
            return "rgba(".concat(t3[0], ",", t3[1], ",", t3[2], ",", n3, ")");
        }
      }, d.default.Color.prototype.setRed = function(e3) {
        this._array[0] = e3 / this.maxes[f.RGB][0], this._calculateLevels();
      }, d.default.Color.prototype.setGreen = function(e3) {
        this._array[1] = e3 / this.maxes[f.RGB][1], this._calculateLevels();
      }, d.default.Color.prototype.setBlue = function(e3) {
        this._array[2] = e3 / this.maxes[f.RGB][2], this._calculateLevels();
      }, d.default.Color.prototype.setAlpha = function(e3) {
        this._array[3] = e3 / this.maxes[this.mode][3], this._calculateLevels();
      }, d.default.Color.prototype._calculateLevels = function() {
        for (var e3 = this._array, t3 = this.levels = new Array(e3.length), r3 = e3.length - 1; 0 <= r3; --r3)
          t3[r3] = Math.round(255 * e3[r3]);
      }, d.default.Color.prototype._getAlpha = function() {
        return this._array[3] * this.maxes[this.mode][3];
      }, d.default.Color.prototype._storeModeAndMaxes = function(e3, t3) {
        this.mode = e3, this.maxes = t3;
      }, d.default.Color.prototype._getMode = function() {
        return this.mode;
      }, d.default.Color.prototype._getMaxes = function() {
        return this.maxes;
      }, d.default.Color.prototype._getBlue = function() {
        return this._array[2] * this.maxes[f.RGB][2];
      }, d.default.Color.prototype._getBrightness = function() {
        return this.hsba || (this.hsba = h2.default._rgbaToHSBA(this._array)), this.hsba[2] * this.maxes[f.HSB][2];
      }, d.default.Color.prototype._getGreen = function() {
        return this._array[1] * this.maxes[f.RGB][1];
      }, d.default.Color.prototype._getHue = function() {
        return this.mode === f.HSB ? (this.hsba || (this.hsba = h2.default._rgbaToHSBA(this._array)), this.hsba[0] * this.maxes[f.HSB][0]) : (this.hsla || (this.hsla = h2.default._rgbaToHSLA(this._array)), this.hsla[0] * this.maxes[f.HSL][0]);
      }, d.default.Color.prototype._getLightness = function() {
        return this.hsla || (this.hsla = h2.default._rgbaToHSLA(this._array)), this.hsla[2] * this.maxes[f.HSL][2];
      }, d.default.Color.prototype._getRed = function() {
        return this._array[0] * this.maxes[f.RGB][0];
      }, d.default.Color.prototype._getSaturation = function() {
        return this.mode === f.HSB ? (this.hsba || (this.hsba = h2.default._rgbaToHSBA(this._array)), this.hsba[1] * this.maxes[f.HSB][1]) : (this.hsla || (this.hsla = h2.default._rgbaToHSLA(this._array)), this.hsla[1] * this.maxes[f.HSL][1]);
      };
      var p2 = { aliceblue: "#f0f8ff", antiquewhite: "#faebd7", aqua: "#00ffff", aquamarine: "#7fffd4", azure: "#f0ffff", beige: "#f5f5dc", bisque: "#ffe4c4", black: "#000000", blanchedalmond: "#ffebcd", blue: "#0000ff", blueviolet: "#8a2be2", brown: "#a52a2a", burlywood: "#deb887", cadetblue: "#5f9ea0", chartreuse: "#7fff00", chocolate: "#d2691e", coral: "#ff7f50", cornflowerblue: "#6495ed", cornsilk: "#fff8dc", crimson: "#dc143c", cyan: "#00ffff", darkblue: "#00008b", darkcyan: "#008b8b", darkgoldenrod: "#b8860b", darkgray: "#a9a9a9", darkgreen: "#006400", darkgrey: "#a9a9a9", darkkhaki: "#bdb76b", darkmagenta: "#8b008b", darkolivegreen: "#556b2f", darkorange: "#ff8c00", darkorchid: "#9932cc", darkred: "#8b0000", darksalmon: "#e9967a", darkseagreen: "#8fbc8f", darkslateblue: "#483d8b", darkslategray: "#2f4f4f", darkslategrey: "#2f4f4f", darkturquoise: "#00ced1", darkviolet: "#9400d3", deeppink: "#ff1493", deepskyblue: "#00bfff", dimgray: "#696969", dimgrey: "#696969", dodgerblue: "#1e90ff", firebrick: "#b22222", floralwhite: "#fffaf0", forestgreen: "#228b22", fuchsia: "#ff00ff", gainsboro: "#dcdcdc", ghostwhite: "#f8f8ff", gold: "#ffd700", goldenrod: "#daa520", gray: "#808080", green: "#008000", greenyellow: "#adff2f", grey: "#808080", honeydew: "#f0fff0", hotpink: "#ff69b4", indianred: "#cd5c5c", indigo: "#4b0082", ivory: "#fffff0", khaki: "#f0e68c", lavender: "#e6e6fa", lavenderblush: "#fff0f5", lawngreen: "#7cfc00", lemonchiffon: "#fffacd", lightblue: "#add8e6", lightcoral: "#f08080", lightcyan: "#e0ffff", lightgoldenrodyellow: "#fafad2", lightgray: "#d3d3d3", lightgreen: "#90ee90", lightgrey: "#d3d3d3", lightpink: "#ffb6c1", lightsalmon: "#ffa07a", lightseagreen: "#20b2aa", lightskyblue: "#87cefa", lightslategray: "#778899", lightslategrey: "#778899", lightsteelblue: "#b0c4de", lightyellow: "#ffffe0", lime: "#00ff00", limegreen: "#32cd32", linen: "#faf0e6", magenta: "#ff00ff", maroon: "#800000", mediumaquamarine: "#66cdaa", mediumblue: "#0000cd", mediumorchid: "#ba55d3", mediumpurple: "#9370db", mediumseagreen: "#3cb371", mediumslateblue: "#7b68ee", mediumspringgreen: "#00fa9a", mediumturquoise: "#48d1cc", mediumvioletred: "#c71585", midnightblue: "#191970", mintcream: "#f5fffa", mistyrose: "#ffe4e1", moccasin: "#ffe4b5", navajowhite: "#ffdead", navy: "#000080", oldlace: "#fdf5e6", olive: "#808000", olivedrab: "#6b8e23", orange: "#ffa500", orangered: "#ff4500", orchid: "#da70d6", palegoldenrod: "#eee8aa", palegreen: "#98fb98", paleturquoise: "#afeeee", palevioletred: "#db7093", papayawhip: "#ffefd5", peachpuff: "#ffdab9", peru: "#cd853f", pink: "#ffc0cb", plum: "#dda0dd", powderblue: "#b0e0e6", purple: "#800080", rebeccapurple: "#663399", red: "#ff0000", rosybrown: "#bc8f8f", royalblue: "#4169e1", saddlebrown: "#8b4513", salmon: "#fa8072", sandybrown: "#f4a460", seagreen: "#2e8b57", seashell: "#fff5ee", sienna: "#a0522d", silver: "#c0c0c0", skyblue: "#87ceeb", slateblue: "#6a5acd", slategray: "#708090", slategrey: "#708090", snow: "#fffafa", springgreen: "#00ff7f", steelblue: "#4682b4", tan: "#d2b48c", teal: "#008080", thistle: "#d8bfd8", tomato: "#ff6347", turquoise: "#40e0d0", violet: "#ee82ee", wheat: "#f5deb3", white: "#ffffff", whitesmoke: "#f5f5f5", yellow: "#ffff00", yellowgreen: "#9acd32" }, o2 = /\s*/, i2 = /(\d{1,3})/, l2 = /((?:\d+(?:\.\d+)?)|(?:\.\d+))/, u2 = new RegExp("".concat(l2.source, "%")), y = { HEX3: /^#([a-f0-9])([a-f0-9])([a-f0-9])$/i, HEX4: /^#([a-f0-9])([a-f0-9])([a-f0-9])([a-f0-9])$/i, HEX6: /^#([a-f0-9]{2})([a-f0-9]{2})([a-f0-9]{2})$/i, HEX8: /^#([a-f0-9]{2})([a-f0-9]{2})([a-f0-9]{2})([a-f0-9]{2})$/i, RGB: new RegExp(["^rgb\\(", i2.source, ",", i2.source, ",", i2.source, "\\)$"].join(o2.source), "i"), RGB_PERCENT: new RegExp(["^rgb\\(", u2.source, ",", u2.source, ",", u2.source, "\\)$"].join(o2.source), "i"), RGBA: new RegExp(["^rgba\\(", i2.source, ",", i2.source, ",", i2.source, ",", l2.source, "\\)$"].join(o2.source), "i"), RGBA_PERCENT: new RegExp(["^rgba\\(", u2.source, ",", u2.source, ",", u2.source, ",", l2.source, "\\)$"].join(o2.source), "i"), HSL: new RegExp(["^hsl\\(", i2.source, ",", u2.source, ",", u2.source, "\\)$"].join(o2.source), "i"), HSLA: new RegExp(["^hsla\\(", i2.source, ",", u2.source, ",", u2.source, ",", l2.source, "\\)$"].join(o2.source), "i"), HSB: new RegExp(["^hsb\\(", i2.source, ",", u2.source, ",", u2.source, "\\)$"].join(o2.source), "i"), HSBA: new RegExp(["^hsba\\(", i2.source, ",", u2.source, ",", u2.source, ",", l2.source, "\\)$"].join(o2.source), "i") };
      d.default.Color._parseInputs = function(e3, t3, r3, n3) {
        var o3, i3 = arguments.length, a3 = this.mode, s2 = this.maxes[a3], l3 = [];
        if (3 <= i3) {
          for (l3[0] = e3 / s2[0], l3[1] = t3 / s2[1], l3[2] = r3 / s2[2], l3[3] = typeof n3 == "number" ? n3 / s2[3] : 1, o3 = l3.length - 1; 0 <= o3; --o3) {
            var u3 = l3[o3];
            u3 < 0 ? l3[o3] = 0 : 1 < u3 && (l3[o3] = 1);
          }
          return a3 === f.HSL ? h2.default._hslaToRGBA(l3) : a3 === f.HSB ? h2.default._hsbaToRGBA(l3) : l3;
        }
        if (i3 === 1 && typeof e3 == "string") {
          var c2 = e3.trim().toLowerCase();
          if (p2[c2])
            return d.default.Color._parseInputs.call(this, p2[c2]);
          if (y.HEX3.test(c2))
            return (l3 = y.HEX3.exec(c2).slice(1).map(function(e4) {
              return parseInt(e4 + e4, 16) / 255;
            }))[3] = 1, l3;
          if (y.HEX6.test(c2))
            return (l3 = y.HEX6.exec(c2).slice(1).map(function(e4) {
              return parseInt(e4, 16) / 255;
            }))[3] = 1, l3;
          if (y.HEX4.test(c2))
            return l3 = y.HEX4.exec(c2).slice(1).map(function(e4) {
              return parseInt(e4 + e4, 16) / 255;
            });
          if (y.HEX8.test(c2))
            return l3 = y.HEX8.exec(c2).slice(1).map(function(e4) {
              return parseInt(e4, 16) / 255;
            });
          if (y.RGB.test(c2))
            return (l3 = y.RGB.exec(c2).slice(1).map(function(e4) {
              return e4 / 255;
            }))[3] = 1, l3;
          if (y.RGB_PERCENT.test(c2))
            return (l3 = y.RGB_PERCENT.exec(c2).slice(1).map(function(e4) {
              return parseFloat(e4) / 100;
            }))[3] = 1, l3;
          if (y.RGBA.test(c2))
            return l3 = y.RGBA.exec(c2).slice(1).map(function(e4, t4) {
              return t4 === 3 ? parseFloat(e4) : e4 / 255;
            });
          if (y.RGBA_PERCENT.test(c2))
            return l3 = y.RGBA_PERCENT.exec(c2).slice(1).map(function(e4, t4) {
              return t4 === 3 ? parseFloat(e4) : parseFloat(e4) / 100;
            });
          if (y.HSL.test(c2) ? (l3 = y.HSL.exec(c2).slice(1).map(function(e4, t4) {
            return t4 === 0 ? parseInt(e4, 10) / 360 : parseInt(e4, 10) / 100;
          }))[3] = 1 : y.HSLA.test(c2) && (l3 = y.HSLA.exec(c2).slice(1).map(function(e4, t4) {
            return t4 === 0 ? parseInt(e4, 10) / 360 : t4 === 3 ? parseFloat(e4) : parseInt(e4, 10) / 100;
          })), (l3 = l3.map(function(e4) {
            return Math.max(Math.min(e4, 1), 0);
          })).length)
            return h2.default._hslaToRGBA(l3);
          if (y.HSB.test(c2) ? (l3 = y.HSB.exec(c2).slice(1).map(function(e4, t4) {
            return t4 === 0 ? parseInt(e4, 10) / 360 : parseInt(e4, 10) / 100;
          }))[3] = 1 : y.HSBA.test(c2) && (l3 = y.HSBA.exec(c2).slice(1).map(function(e4, t4) {
            return t4 === 0 ? parseInt(e4, 10) / 360 : t4 === 3 ? parseFloat(e4) : parseInt(e4, 10) / 100;
          })), l3.length) {
            for (o3 = l3.length - 1; 0 <= o3; --o3)
              l3[o3] = Math.max(Math.min(l3[o3], 1), 0);
            return h2.default._hsbaToRGBA(l3);
          }
          l3 = [1, 1, 1, 1];
        } else {
          if (i3 !== 1 && i3 !== 2 || typeof e3 != "number")
            throw new Error("".concat(arguments, "is not a valid color representation."));
          l3[0] = e3 / s2[2], l3[1] = e3 / s2[2], l3[2] = e3 / s2[2], l3[3] = typeof t3 == "number" ? t3 / s2[3] : 1, l3 = l3.map(function(e4) {
            return Math.max(Math.min(e4, 1), 0);
          });
        }
        return l3;
      };
      var c = d.default.Color;
      r2.default = c;
    }, { "../core/constants": 253, "../core/main": 264, "./color_conversion": 249, "core-js/modules/es.array.join": 159, "core-js/modules/es.array.map": 161, "core-js/modules/es.array.slice": 162, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.regexp.constructor": 180, "core-js/modules/es.regexp.exec": 181, "core-js/modules/es.regexp.to-string": 182, "core-js/modules/es.string.trim": 193 }], 252: [function(e2, t2, r2) {
      function a2(e3) {
        return (a2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      e2("core-js/modules/es.array.fill"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, s = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 }, l2 = function(e3) {
        if (e3 && e3.__esModule)
          return e3;
        if (e3 === null || a2(e3) !== "object" && typeof e3 != "function")
          return { default: e3 };
        var t3 = u2();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o3 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o3)) {
            var i2 = n3 ? Object.getOwnPropertyDescriptor(e3, o3) : null;
            i2 && (i2.get || i2.set) ? Object.defineProperty(r3, o3, i2) : r3[o3] = e3[o3];
          }
        r3.default = e3, t3 && t3.set(e3, r3);
        return r3;
      }(e2("../core/constants"));
      function u2() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return u2 = function() {
          return e3;
        }, e3;
      }
      e2("./p5.Color"), s.default.prototype.background = function() {
        var e3;
        return (e3 = this._renderer).background.apply(e3, arguments), this;
      }, s.default.prototype.clear = function() {
        var e3 = (arguments.length <= 0 ? void 0 : arguments[0]) || 0, t3 = (arguments.length <= 1 ? void 0 : arguments[1]) || 0, r3 = (arguments.length <= 2 ? void 0 : arguments[2]) || 0, n3 = (arguments.length <= 3 ? void 0 : arguments[3]) || 0;
        return this._renderer.clear(e3, t3, r3, n3), this;
      }, s.default.prototype.colorMode = function(e3, t3, r3, n3, o3) {
        if (s.default._validateParameters("colorMode", arguments), e3 === l2.RGB || e3 === l2.HSB || e3 === l2.HSL) {
          this._colorMode = e3;
          var i2 = this._colorMaxes[e3];
          arguments.length === 2 ? (i2[0] = t3, i2[1] = t3, i2[2] = t3, i2[3] = t3) : arguments.length === 4 ? (i2[0] = t3, i2[1] = r3, i2[2] = n3) : arguments.length === 5 && (i2[0] = t3, i2[1] = r3, i2[2] = n3, i2[3] = o3);
        }
        return this;
      }, s.default.prototype.fill = function() {
        var e3;
        return this._renderer._setProperty("_fillSet", true), this._renderer._setProperty("_doFill", true), (e3 = this._renderer).fill.apply(e3, arguments), this;
      }, s.default.prototype.noFill = function() {
        return this._renderer._setProperty("_doFill", false), this;
      }, s.default.prototype.noStroke = function() {
        return this._renderer._setProperty("_doStroke", false), this;
      }, s.default.prototype.stroke = function() {
        var e3;
        return this._renderer._setProperty("_strokeSet", true), this._renderer._setProperty("_doStroke", true), (e3 = this._renderer).stroke.apply(e3, arguments), this;
      }, s.default.prototype.erase = function() {
        var e3 = 0 < arguments.length && arguments[0] !== void 0 ? arguments[0] : 255, t3 = 1 < arguments.length && arguments[1] !== void 0 ? arguments[1] : 255;
        return this._renderer.erase(e3, t3), this;
      }, s.default.prototype.noErase = function() {
        return this._renderer.noErase(), this;
      };
      var o2 = s.default;
      r2.default = o2;
    }, { "../core/constants": 253, "../core/main": 264, "./p5.Color": 251, "core-js/modules/es.array.fill": 151 }], 253: [function(e2, t2, r2) {
      Object.defineProperty(r2, "__esModule", { value: true }), r2.BEZIER = r2.QUADRATIC = r2.LINEAR = r2._CTX_MIDDLE = r2._DEFAULT_LEADMULT = r2._DEFAULT_TEXT_FILL = r2.WORD = r2.CHAR = r2.BOLDITALIC = r2.BOLD = r2.ITALIC = r2.NORMAL = r2.BLUR = r2.ERODE = r2.DILATE = r2.POSTERIZE = r2.INVERT = r2.OPAQUE = r2.GRAY = r2.THRESHOLD = r2.BURN = r2.DODGE = r2.SOFT_LIGHT = r2.HARD_LIGHT = r2.OVERLAY = r2.REPLACE = r2.SCREEN = r2.MULTIPLY = r2.EXCLUSION = r2.SUBTRACT = r2.DIFFERENCE = r2.LIGHTEST = r2.DARKEST = r2.ADD = r2.REMOVE = r2.BLEND = r2.UP_ARROW = r2.TAB = r2.SHIFT = r2.RIGHT_ARROW = r2.RETURN = r2.OPTION = r2.LEFT_ARROW = r2.ESCAPE = r2.ENTER = r2.DOWN_ARROW = r2.DELETE = r2.CONTROL = r2.BACKSPACE = r2.ALT = r2.AUTO = r2.HSL = r2.HSB = r2.RGB = r2.MITER = r2.BEVEL = r2.ROUND = r2.SQUARE = r2.PROJECT = r2.PIE = r2.CHORD = r2.OPEN = r2.CLOSE = r2.TESS = r2.QUAD_STRIP = r2.QUADS = r2.TRIANGLE_STRIP = r2.TRIANGLE_FAN = r2.TRIANGLES = r2.LINE_LOOP = r2.LINE_STRIP = r2.LINES = r2.POINTS = r2.BASELINE = r2.BOTTOM = r2.TOP = r2.CENTER = r2.LEFT = r2.RIGHT = r2.RADIUS = r2.CORNERS = r2.CORNER = r2.RAD_TO_DEG = r2.DEG_TO_RAD = r2.RADIANS = r2.DEGREES = r2.TWO_PI = r2.TAU = r2.QUARTER_PI = r2.PI = r2.HALF_PI = r2.WAIT = r2.TEXT = r2.MOVE = r2.HAND = r2.CROSS = r2.ARROW = r2.WEBGL = r2.P2D = r2.VERSION = void 0, r2.FALLBACK = r2.LABEL = r2.AXES = r2.GRID = r2._DEFAULT_FILL = r2._DEFAULT_STROKE = r2.PORTRAIT = r2.LANDSCAPE = r2.MIRROR = r2.CLAMP = r2.REPEAT = r2.NEAREST = r2.IMAGE = r2.IMMEDIATE = r2.TEXTURE = r2.FILL = r2.STROKE = r2.CURVE = void 0;
      var n2 = Math.PI;
      r2.VERSION = "1.4.1";
      r2.P2D = "p2d";
      r2.WEBGL = "webgl";
      r2.ARROW = "default";
      r2.CROSS = "crosshair";
      r2.HAND = "pointer";
      r2.MOVE = "move";
      r2.TEXT = "text";
      r2.WAIT = "wait";
      var o2 = n2 / 2;
      r2.HALF_PI = o2;
      var i2 = n2;
      r2.PI = i2;
      var a2 = n2 / 4;
      r2.QUARTER_PI = a2;
      var s = 2 * n2;
      r2.TAU = s;
      var l2 = 2 * n2;
      r2.TWO_PI = l2;
      r2.DEGREES = "degrees";
      r2.RADIANS = "radians";
      var u2 = n2 / 180;
      r2.DEG_TO_RAD = u2;
      var c = 180 / n2;
      r2.RAD_TO_DEG = c;
      r2.CORNER = "corner";
      r2.CORNERS = "corners";
      r2.RADIUS = "radius";
      r2.RIGHT = "right";
      r2.LEFT = "left";
      r2.CENTER = "center";
      r2.TOP = "top";
      r2.BOTTOM = "bottom";
      r2.BASELINE = "alphabetic";
      r2.POINTS = 0;
      r2.LINES = 1;
      r2.LINE_STRIP = 3;
      r2.LINE_LOOP = 2;
      r2.TRIANGLES = 4;
      r2.TRIANGLE_FAN = 6;
      r2.TRIANGLE_STRIP = 5;
      r2.QUADS = "quads";
      r2.QUAD_STRIP = "quad_strip";
      r2.TESS = "tess";
      r2.CLOSE = "close";
      r2.OPEN = "open";
      r2.CHORD = "chord";
      r2.PIE = "pie";
      r2.PROJECT = "square";
      r2.SQUARE = "butt";
      r2.ROUND = "round";
      r2.BEVEL = "bevel";
      r2.MITER = "miter";
      r2.RGB = "rgb";
      r2.HSB = "hsb";
      r2.HSL = "hsl";
      r2.AUTO = "auto";
      r2.ALT = 18;
      r2.BACKSPACE = 8;
      r2.CONTROL = 17;
      r2.DELETE = 46;
      r2.DOWN_ARROW = 40;
      r2.ENTER = 13;
      r2.ESCAPE = 27;
      r2.LEFT_ARROW = 37;
      r2.OPTION = 18;
      r2.RETURN = 13;
      r2.RIGHT_ARROW = 39;
      r2.SHIFT = 16;
      r2.TAB = 9;
      r2.UP_ARROW = 38;
      r2.BLEND = "source-over";
      r2.REMOVE = "destination-out";
      r2.ADD = "lighter";
      r2.DARKEST = "darken";
      r2.LIGHTEST = "lighten";
      r2.DIFFERENCE = "difference";
      r2.SUBTRACT = "subtract";
      r2.EXCLUSION = "exclusion";
      r2.MULTIPLY = "multiply";
      r2.SCREEN = "screen";
      r2.REPLACE = "copy";
      r2.OVERLAY = "overlay";
      r2.HARD_LIGHT = "hard-light";
      r2.SOFT_LIGHT = "soft-light";
      r2.DODGE = "color-dodge";
      r2.BURN = "color-burn";
      r2.THRESHOLD = "threshold";
      r2.GRAY = "gray";
      r2.OPAQUE = "opaque";
      r2.INVERT = "invert";
      r2.POSTERIZE = "posterize";
      r2.DILATE = "dilate";
      r2.ERODE = "erode";
      r2.BLUR = "blur";
      r2.NORMAL = "normal";
      r2.ITALIC = "italic";
      r2.BOLD = "bold";
      r2.BOLDITALIC = "bold italic";
      r2.CHAR = "CHAR";
      r2.WORD = "WORD";
      r2._DEFAULT_TEXT_FILL = "#000000";
      r2._DEFAULT_LEADMULT = 1.25;
      r2._CTX_MIDDLE = "middle";
      r2.LINEAR = "linear";
      r2.QUADRATIC = "quadratic";
      r2.BEZIER = "bezier";
      r2.CURVE = "curve";
      r2.STROKE = "stroke";
      r2.FILL = "fill";
      r2.TEXTURE = "texture";
      r2.IMMEDIATE = "immediate";
      r2.IMAGE = "image";
      r2.NEAREST = "nearest";
      r2.REPEAT = "repeat";
      r2.CLAMP = "clamp";
      r2.MIRROR = "mirror";
      r2.LANDSCAPE = "landscape";
      r2.PORTRAIT = "portrait";
      r2._DEFAULT_STROKE = "#000000";
      r2._DEFAULT_FILL = "#FFFFFF";
      r2.GRID = "grid";
      r2.AXES = "axes";
      r2.LABEL = "label";
      r2.FALLBACK = "fallback";
    }, {}], 254: [function(e2, t2, r2) {
      function a2(e3) {
        return (a2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      e2("core-js/modules/es.array.concat"), e2("core-js/modules/es.array.filter"), e2("core-js/modules/es.array.includes"), e2("core-js/modules/es.regexp.exec"), e2("core-js/modules/es.string.includes"), e2("core-js/modules/es.string.search"), e2("core-js/modules/es.string.split"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, o2 = (n2 = e2("./main")) && n2.__esModule ? n2 : { default: n2 }, i2 = function(e3) {
        if (e3 && e3.__esModule)
          return e3;
        if (e3 === null || a2(e3) !== "object" && typeof e3 != "function")
          return { default: e3 };
        var t3 = s();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o3 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o3)) {
            var i3 = n3 ? Object.getOwnPropertyDescriptor(e3, o3) : null;
            i3 && (i3.get || i3.set) ? Object.defineProperty(r3, o3, i3) : r3[o3] = e3[o3];
          }
        r3.default = e3, t3 && t3.set(e3, r3);
        return r3;
      }(e2("./constants"));
      function s() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return s = function() {
          return e3;
        }, e3;
      }
      var l2 = [i2.ARROW, i2.CROSS, i2.HAND, i2.MOVE, i2.TEXT, i2.WAIT];
      o2.default.prototype._frameRate = 0, o2.default.prototype._lastFrameTime = window.performance.now(), o2.default.prototype._targetFrameRate = 60;
      var u2 = window.print;
      function c() {
        return window.innerWidth || document.documentElement && document.documentElement.clientWidth || document.body && document.body.clientWidth || 0;
      }
      function d() {
        return window.innerHeight || document.documentElement && document.documentElement.clientHeight || document.body && document.body.clientHeight || 0;
      }
      o2.default.prototype.print = function() {
        var e3;
        arguments.length ? (e3 = console).log.apply(e3, arguments) : u2();
      }, o2.default.prototype.frameCount = 0, o2.default.prototype.deltaTime = 0, o2.default.prototype.focused = document.hasFocus(), o2.default.prototype.cursor = function(e3, t3, r3) {
        var n3 = "auto", o3 = this._curElement.elt;
        if (l2.includes(e3))
          n3 = e3;
        else if (typeof e3 == "string") {
          var i3 = "";
          t3 && r3 && typeof t3 == "number" && typeof r3 == "number" && (i3 = "".concat(t3, " ").concat(r3)), n3 = e3.substring(0, 7) === "http://" || e3.substring(0, 8) === "https://" ? "url(".concat(e3, ") ").concat(i3, ", auto") : /\.(cur|jpg|jpeg|gif|png|CUR|JPG|JPEG|GIF|PNG)$/.test(e3) ? "url(".concat(e3, ") ").concat(i3, ", auto") : e3;
        }
        o3.style.cursor = n3;
      }, o2.default.prototype.frameRate = function(e3) {
        return o2.default._validateParameters("frameRate", arguments), typeof e3 != "number" || e3 < 0 ? this._frameRate : (this._setProperty("_targetFrameRate", e3), e3 === 0 && this._setProperty("_frameRate", e3), this);
      }, o2.default.prototype.getFrameRate = function() {
        return this.frameRate();
      }, o2.default.prototype.setFrameRate = function(e3) {
        return this.frameRate(e3);
      }, o2.default.prototype.noCursor = function() {
        this._curElement.elt.style.cursor = "none";
      }, o2.default.prototype.displayWidth = screen.width, o2.default.prototype.displayHeight = screen.height, o2.default.prototype.windowWidth = c(), o2.default.prototype.windowHeight = d(), o2.default.prototype._onresize = function(e3) {
        this._setProperty("windowWidth", c()), this._setProperty("windowHeight", d());
        var t3, r3 = this._isGlobal ? window : this;
        typeof r3.windowResized == "function" && ((t3 = r3.windowResized(e3)) === void 0 || t3 || e3.preventDefault());
      }, o2.default.prototype.width = 0, o2.default.prototype.height = 0, o2.default.prototype.fullscreen = function(e3) {
        if (o2.default._validateParameters("fullscreen", arguments), e3 === void 0)
          return document.fullscreenElement || document.webkitFullscreenElement || document.mozFullScreenElement || document.msFullscreenElement;
        e3 ? function(e4) {
          if (!(document.fullscreenEnabled || document.webkitFullscreenEnabled || document.mozFullScreenEnabled || document.msFullscreenEnabled))
            throw new Error("Fullscreen not enabled in this browser.");
          e4.requestFullscreen ? e4.requestFullscreen() : e4.mozRequestFullScreen ? e4.mozRequestFullScreen() : e4.webkitRequestFullscreen ? e4.webkitRequestFullscreen() : e4.msRequestFullscreen && e4.msRequestFullscreen();
        }(document.documentElement) : document.exitFullscreen ? document.exitFullscreen() : document.mozCancelFullScreen ? document.mozCancelFullScreen() : document.webkitExitFullscreen ? document.webkitExitFullscreen() : document.msExitFullscreen && document.msExitFullscreen();
      }, o2.default.prototype.pixelDensity = function(e3) {
        var t3;
        return o2.default._validateParameters("pixelDensity", arguments), typeof e3 == "number" ? (e3 !== this._pixelDensity && (this._pixelDensity = e3), (t3 = this).resizeCanvas(this.width, this.height, true)) : t3 = this._pixelDensity, t3;
      }, o2.default.prototype.displayDensity = function() {
        return window.devicePixelRatio;
      }, o2.default.prototype.getURL = function() {
        return location.href;
      }, o2.default.prototype.getURLPath = function() {
        return location.pathname.split("/").filter(function(e3) {
          return e3 !== "";
        });
      }, o2.default.prototype.getURLParams = function() {
        for (var e3, t3 = /[?&]([^&=]+)(?:[&=])([^&=]+)/gim, r3 = {}; (e3 = t3.exec(location.search)) != null; )
          e3.index === t3.lastIndex && t3.lastIndex++, r3[e3[1]] = e3[2];
        return r3;
      };
      var f = o2.default;
      r2.default = f;
    }, { "./constants": 253, "./main": 264, "core-js/modules/es.array.concat": 149, "core-js/modules/es.array.filter": 152, "core-js/modules/es.array.includes": 156, "core-js/modules/es.regexp.exec": 181, "core-js/modules/es.string.includes": 185, "core-js/modules/es.string.search": 190, "core-js/modules/es.string.split": 191 }], 255: [function(r2, e2, t2) {
      r2("core-js/modules/es.symbol"), r2("core-js/modules/es.symbol.description"), r2("core-js/modules/es.symbol.iterator"), r2("core-js/modules/es.array.concat"), r2("core-js/modules/es.array.filter"), r2("core-js/modules/es.array.for-each"), r2("core-js/modules/es.array.includes"), r2("core-js/modules/es.array.iterator"), r2("core-js/modules/es.array.join"), r2("core-js/modules/es.array.map"), r2("core-js/modules/es.array.slice"), r2("core-js/modules/es.array.some"), r2("core-js/modules/es.function.name"), r2("core-js/modules/es.object.assign"), r2("core-js/modules/es.object.get-own-property-names"), r2("core-js/modules/es.object.keys"), r2("core-js/modules/es.object.to-string"), r2("core-js/modules/es.regexp.constructor"), r2("core-js/modules/es.regexp.exec"), r2("core-js/modules/es.regexp.to-string"), r2("core-js/modules/es.string.iterator"), r2("core-js/modules/es.string.match"), r2("core-js/modules/es.string.replace"), r2("core-js/modules/es.string.search"), r2("core-js/modules/es.string.split"), r2("core-js/modules/web.dom-collections.for-each"), r2("core-js/modules/web.dom-collections.iterator"), Object.defineProperty(t2, "__esModule", { value: true }), t2.default = void 0;
      var n2, o2 = (n2 = r2("../main")) && n2.__esModule ? n2 : { default: n2 };
      r2("../internationalization");
      var i2 = null, a2 = null;
      o2.default._friendlyError = o2.default._checkForUserDefinedFunctions = o2.default._fesErrorMonitor = function() {
      }, i2 = null;
      var s = "https://github.com/processing/p5.js/wiki/p5.js-overview#why-cant-i-assign-variables-using-p5-functions-and-variables-before-setup";
      a2 = function() {
        function e3(r3) {
          return Object.getOwnPropertyNames(r3).filter(function(e4) {
            return e4[0] !== "_" && (!(e4 in t3) && (t3[e4] = true));
          }).map(function(e4) {
            var t4;
            return t4 = typeof r3[e4] == "function" ? "function" : e4 === e4.toUpperCase() ? "constant" : "variable", { name: e4, type: t4 };
          });
        }
        var t3 = {};
        (i2 = [].concat(e3(o2.default.prototype), e3(r2("../constants")))).sort(function(e4, t4) {
          return t4.name.length - e4.name.length;
        });
      };
      function l2(r3, n3) {
        n3 = n3 || console.log.bind(console), i2 || a2(), i2.some(function(e3) {
          if (r3.message && r3.message.match("\\W?".concat(e3.name, "\\W")) !== null) {
            var t3 = e3.type === "function" ? "".concat(e3.name, "()") : e3.name;
            return n3("Did you just try to use p5.js's ".concat(t3, " ").concat(e3.type, "? If so, you may want to move it into your sketch's setup() function.\n\nFor more details, see: ").concat(s)), true;
          }
        });
      }
      o2.default.prototype._helpForMisusedAtTopLevelCode = l2, document.readyState !== "complete" && (window.addEventListener("error", l2, false), window.addEventListener("load", function() {
        window.removeEventListener("error", l2, false);
      }));
      var u2 = o2.default;
      t2.default = u2;
    }, { "../constants": 253, "../internationalization": 262, "../main": 264, "./browser_errors": void 0, "core-js/modules/es.array.concat": 149, "core-js/modules/es.array.filter": 152, "core-js/modules/es.array.for-each": 154, "core-js/modules/es.array.includes": 156, "core-js/modules/es.array.iterator": 158, "core-js/modules/es.array.join": 159, "core-js/modules/es.array.map": 161, "core-js/modules/es.array.slice": 162, "core-js/modules/es.array.some": 163, "core-js/modules/es.function.name": 166, "core-js/modules/es.object.assign": 173, "core-js/modules/es.object.get-own-property-names": 174, "core-js/modules/es.object.keys": 176, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.regexp.constructor": 180, "core-js/modules/es.regexp.exec": 181, "core-js/modules/es.regexp.to-string": 182, "core-js/modules/es.string.iterator": 186, "core-js/modules/es.string.match": 187, "core-js/modules/es.string.replace": 189, "core-js/modules/es.string.search": 190, "core-js/modules/es.string.split": 191, "core-js/modules/es.symbol": 196, "core-js/modules/es.symbol.description": 194, "core-js/modules/es.symbol.iterator": 195, "core-js/modules/web.dom-collections.for-each": 228, "core-js/modules/web.dom-collections.iterator": 229 }], 256: [function(e2, t2, r2) {
      Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, o2 = (n2 = e2("../main")) && n2.__esModule ? n2 : { default: n2 };
      e2("../internationalization");
      o2.default._friendlyFileLoadError = function() {
      };
      var i2 = o2.default;
      r2.default = i2;
    }, { "../internationalization": 262, "../main": 264 }], 257: [function(e2, t2, r2) {
      function a2(e3) {
        return (a2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      e2("core-js/modules/es.symbol"), e2("core-js/modules/es.symbol.description"), e2("core-js/modules/es.symbol.iterator"), e2("core-js/modules/es.array.filter"), e2("core-js/modules/es.array.flat-map"), e2("core-js/modules/es.array.for-each"), e2("core-js/modules/es.array.from"), e2("core-js/modules/es.array.includes"), e2("core-js/modules/es.array.index-of"), e2("core-js/modules/es.array.iterator"), e2("core-js/modules/es.array.map"), e2("core-js/modules/es.array.unscopables.flat-map"), e2("core-js/modules/es.object.keys"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.regexp.constructor"), e2("core-js/modules/es.regexp.exec"), e2("core-js/modules/es.regexp.to-string"), e2("core-js/modules/es.string.includes"), e2("core-js/modules/es.string.iterator"), e2("core-js/modules/es.string.match"), e2("core-js/modules/es.string.split"), e2("core-js/modules/es.string.trim"), e2("core-js/modules/web.dom-collections.for-each"), e2("core-js/modules/web.dom-collections.iterator"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2 = _(e2("../main"));
      e2("../internationalization");
      b2(e2("../constants"));
      function v() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return v = function() {
          return e3;
        }, e3;
      }
      function b2(e3) {
        if (e3 && e3.__esModule)
          return e3;
        if (e3 === null || a2(e3) !== "object" && typeof e3 != "function")
          return { default: e3 };
        var t3 = v();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o2 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o2)) {
            var i2 = n3 ? Object.getOwnPropertyDescriptor(e3, o2) : null;
            i2 && (i2.get || i2.set) ? Object.defineProperty(r3, o2, i2) : r3[o2] = e3[o2];
          }
        return r3.default = e3, t3 && t3.set(e3, r3), r3;
      }
      function _(e3) {
        return e3 && e3.__esModule ? e3 : { default: e3 };
      }
      n2.default._fesCodeReader = function() {
      };
      var M = n2.default;
      r2.default = M;
    }, { "../constants": 253, "../internationalization": 262, "../main": 264, "core-js/modules/es.array.filter": 152, "core-js/modules/es.array.flat-map": 153, "core-js/modules/es.array.for-each": 154, "core-js/modules/es.array.from": 155, "core-js/modules/es.array.includes": 156, "core-js/modules/es.array.index-of": 157, "core-js/modules/es.array.iterator": 158, "core-js/modules/es.array.map": 161, "core-js/modules/es.array.unscopables.flat-map": 165, "core-js/modules/es.object.keys": 176, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.regexp.constructor": 180, "core-js/modules/es.regexp.exec": 181, "core-js/modules/es.regexp.to-string": 182, "core-js/modules/es.string.includes": 185, "core-js/modules/es.string.iterator": 186, "core-js/modules/es.string.match": 187, "core-js/modules/es.string.split": 191, "core-js/modules/es.string.trim": 193, "core-js/modules/es.symbol": 196, "core-js/modules/es.symbol.description": 194, "core-js/modules/es.symbol.iterator": 195, "core-js/modules/web.dom-collections.for-each": 228, "core-js/modules/web.dom-collections.iterator": 229 }], 258: [function(e2, t2, r2) {
      e2("core-js/modules/es.array.filter"), e2("core-js/modules/es.array.index-of"), e2("core-js/modules/es.array.join"), e2("core-js/modules/es.array.map"), e2("core-js/modules/es.array.slice"), e2("core-js/modules/es.regexp.exec"), e2("core-js/modules/es.string.match"), e2("core-js/modules/es.string.replace"), e2("core-js/modules/es.string.split"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, o2 = (n2 = e2("../main")) && n2.__esModule ? n2 : { default: n2 };
      function i2() {
        var t3 = /(^|@)\S+:\d+/, r3 = /^\s*at .*(\S+:\d+|\(native\))/m, n3 = /^(eval@)?(\[native code])?$/;
        return { parse: function(e3) {
          return e3.stacktrace !== void 0 || e3["opera#sourceloc"] !== void 0 ? this.parseOpera(e3) : e3.stack && e3.stack.match(r3) ? this.parseV8OrIE(e3) : e3.stack ? this.parseFFOrSafari(e3) : void 0;
        }, extractLocation: function(e3) {
          if (e3.indexOf(":") === -1)
            return [e3];
          var t4 = /(.+?)(?::(\d+))?(?::(\d+))?$/.exec(e3.replace(/[()]/g, ""));
          return [t4[1], t4[2] || void 0, t4[3] || void 0];
        }, parseV8OrIE: function(e3) {
          return e3.stack.split("\n").filter(function(e4) {
            return !!e4.match(r3);
          }, this).map(function(e4) {
            -1 < e4.indexOf("(eval ") && (e4 = e4.replace(/eval code/g, "eval").replace(/(\(eval at [^()]*)|(\),.*$)/g, ""));
            var t4 = e4.replace(/^\s+/, "").replace(/\(eval code/g, "("), r4 = t4.match(/ (\((.+):(\d+):(\d+)\)$)/), n4 = (t4 = r4 ? t4.replace(r4[0], "") : t4).split(/\s+/).slice(1), o3 = this.extractLocation(r4 ? r4[1] : n4.pop());
            return { functionName: n4.join(" ") || void 0, fileName: -1 < ["eval", "<anonymous>"].indexOf(o3[0]) ? void 0 : o3[0], lineNumber: o3[1], columnNumber: o3[2], source: e4 };
          }, this);
        }, parseFFOrSafari: function(e3) {
          return e3.stack.split("\n").filter(function(e4) {
            return !e4.match(n3);
          }, this).map(function(e4) {
            if (-1 < e4.indexOf(" > eval") && (e4 = e4.replace(/ line (\d+)(?: > eval line \d+)* > eval:\d+:\d+/g, ":$1")), e4.indexOf("@") === -1 && e4.indexOf(":") === -1)
              return { functionName: e4 };
            var t4 = /((.*".+"[^@]*)?[^@]*)(?:@)/, r4 = e4.match(t4), n4 = r4 && r4[1] ? r4[1] : void 0, o3 = this.extractLocation(e4.replace(t4, ""));
            return { functionName: n4, fileName: o3[0], lineNumber: o3[1], columnNumber: o3[2], source: e4 };
          }, this);
        }, parseOpera: function(e3) {
          return !e3.stacktrace || -1 < e3.message.indexOf("\n") && e3.message.split("\n").length > e3.stacktrace.split("\n").length ? this.parseOpera9(e3) : e3.stack ? this.parseOpera11(e3) : this.parseOpera10(e3);
        }, parseOpera9: function(e3) {
          for (var t4 = /Line (\d+).*script (?:in )?(\S+)/i, r4 = e3.message.split("\n"), n4 = [], o3 = 2, i3 = r4.length; o3 < i3; o3 += 2) {
            var a3 = t4.exec(r4[o3]);
            a3 && n4.push({ fileName: a3[2], lineNumber: a3[1], source: r4[o3] });
          }
          return n4;
        }, parseOpera10: function(e3) {
          for (var t4 = /Line (\d+).*script (?:in )?(\S+)(?:: In function (\S+))?$/i, r4 = e3.stacktrace.split("\n"), n4 = [], o3 = 0, i3 = r4.length; o3 < i3; o3 += 2) {
            var a3 = t4.exec(r4[o3]);
            a3 && n4.push({ functionName: a3[3] || void 0, fileName: a3[2], lineNumber: a3[1], source: r4[o3] });
          }
          return n4;
        }, parseOpera11: function(e3) {
          return e3.stack.split("\n").filter(function(e4) {
            return !!e4.match(t3) && !e4.match(/^Error created at/);
          }, this).map(function(e4) {
            var t4, r4 = e4.split("@"), n4 = this.extractLocation(r4.pop()), o3 = r4.shift() || "", i3 = o3.replace(/<anonymous function(: (\w+))?>/, "$2").replace(/\([^)]*\)/g, "") || void 0;
            return o3.match(/\(([^)]*)\)/) && (t4 = o3.replace(/^[^(]+\(([^)]*)\)$/, "$1")), { functionName: i3, args: t4 === void 0 || t4 === "[arguments not available]" ? void 0 : t4.split(","), fileName: n4[0], lineNumber: n4[1], columnNumber: n4[2], source: e4 };
          }, this);
        } };
      }
      o2.default._getErrorStackParser = function() {
        return new i2();
      };
      var a2 = o2.default;
      r2.default = a2;
    }, { "../main": 264, "core-js/modules/es.array.filter": 152, "core-js/modules/es.array.index-of": 157, "core-js/modules/es.array.join": 159, "core-js/modules/es.array.map": 161, "core-js/modules/es.array.slice": 162, "core-js/modules/es.regexp.exec": 181, "core-js/modules/es.string.match": 187, "core-js/modules/es.string.replace": 189, "core-js/modules/es.string.split": 191 }], 259: [function(e2, t2, r2) {
      e2("core-js/modules/es.symbol"), e2("core-js/modules/es.symbol.description"), e2("core-js/modules/es.symbol.iterator"), e2("core-js/modules/es.array.concat"), e2("core-js/modules/es.array.for-each"), e2("core-js/modules/es.array.includes"), e2("core-js/modules/es.array.index-of"), e2("core-js/modules/es.array.iterator"), e2("core-js/modules/es.array.join"), e2("core-js/modules/es.array.last-index-of"), e2("core-js/modules/es.array.map"), e2("core-js/modules/es.array.slice"), e2("core-js/modules/es.function.name"), e2("core-js/modules/es.map"), e2("core-js/modules/es.number.constructor"), e2("core-js/modules/es.object.get-prototype-of"), e2("core-js/modules/es.object.keys"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.reflect.construct"), e2("core-js/modules/es.regexp.exec"), e2("core-js/modules/es.regexp.to-string"), e2("core-js/modules/es.set"), e2("core-js/modules/es.string.includes"), e2("core-js/modules/es.string.iterator"), e2("core-js/modules/es.string.split"), e2("core-js/modules/web.dom-collections.for-each"), e2("core-js/modules/web.dom-collections.iterator"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, o2 = (n2 = e2("../main")) && n2.__esModule ? n2 : { default: n2 };
      (function(e3) {
        if (e3 && e3.__esModule)
          return;
        if (e3 === null || s(e3) !== "object" && typeof e3 != "function")
          return;
        var t3 = a2();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o3 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o3)) {
            var i3 = n3 ? Object.getOwnPropertyDescriptor(e3, o3) : null;
            i3 && (i3.get || i3.set) ? Object.defineProperty(r3, o3, i3) : r3[o3] = e3[o3];
          }
        r3.default = e3, t3 && t3.set(e3, r3);
      })(e2("../constants")), e2("../internationalization");
      function a2() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return a2 = function() {
          return e3;
        }, e3;
      }
      function s(e3) {
        return (s = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      o2.default._validateParameters = o2.default._clearValidateParamsCache = function() {
      };
      var i2 = o2.default;
      r2.default = i2;
    }, { "../../../docs/parameterData.json": void 0, "../constants": 253, "../internationalization": 262, "../main": 264, "core-js/modules/es.array.concat": 149, "core-js/modules/es.array.for-each": 154, "core-js/modules/es.array.includes": 156, "core-js/modules/es.array.index-of": 157, "core-js/modules/es.array.iterator": 158, "core-js/modules/es.array.join": 159, "core-js/modules/es.array.last-index-of": 160, "core-js/modules/es.array.map": 161, "core-js/modules/es.array.slice": 162, "core-js/modules/es.function.name": 166, "core-js/modules/es.map": 167, "core-js/modules/es.number.constructor": 170, "core-js/modules/es.object.get-prototype-of": 175, "core-js/modules/es.object.keys": 176, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.reflect.construct": 179, "core-js/modules/es.regexp.exec": 181, "core-js/modules/es.regexp.to-string": 182, "core-js/modules/es.set": 183, "core-js/modules/es.string.includes": 185, "core-js/modules/es.string.iterator": 186, "core-js/modules/es.string.split": 191, "core-js/modules/es.symbol": 196, "core-js/modules/es.symbol.description": 194, "core-js/modules/es.symbol.iterator": 195, "core-js/modules/web.dom-collections.for-each": 228, "core-js/modules/web.dom-collections.iterator": 229 }], 260: [function(e2, t2, r2) {
      function a2(e3) {
        return (a2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var i2 = function(e3) {
        if (e3 && e3.__esModule)
          return e3;
        if (e3 === null || a2(e3) !== "object" && typeof e3 != "function")
          return { default: e3 };
        var t3 = s();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o2 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o2)) {
            var i3 = n3 ? Object.getOwnPropertyDescriptor(e3, o2) : null;
            i3 && (i3.get || i3.set) ? Object.defineProperty(r3, o2, i3) : r3[o2] = e3[o2];
          }
        r3.default = e3, t3 && t3.set(e3, r3);
        return r3;
      }(e2("./constants"));
      function s() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return s = function() {
          return e3;
        }, e3;
      }
      var n2 = { modeAdjust: function(e3, t3, r3, n3, o2) {
        return o2 === i2.CORNER ? { x: e3, y: t3, w: r3, h: n3 } : o2 === i2.CORNERS ? { x: e3, y: t3, w: r3 - e3, h: n3 - t3 } : o2 === i2.RADIUS ? { x: e3 - r3, y: t3 - n3, w: 2 * r3, h: 2 * n3 } : o2 === i2.CENTER ? { x: e3 - 0.5 * r3, y: t3 - 0.5 * n3, w: r3, h: n3 } : void 0;
      } };
      r2.default = n2;
    }, { "./constants": 253 }], 261: [function(e2, t2, r2) {
      e2("core-js/modules/es.array.iterator"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.promise"), e2("core-js/modules/es.string.iterator"), e2("core-js/modules/web.dom-collections.iterator");
      var n2, o2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      e2("./internationalization");
      var i2 = Promise.resolve();
      Promise.all([new Promise(function(e3, t3) {
        document.readyState === "complete" ? e3() : window.addEventListener("load", e3, false);
      }), i2]).then(function() {
        window._setupDone === void 0 ? window.mocha || (window.setup && typeof window.setup == "function" || window.draw && typeof window.draw == "function") && !o2.default.instance && new o2.default() : console.warn("p5.js seems to have been imported multiple times. Please remove the duplicate import");
      });
    }, { "../core/main": 264, "./internationalization": 262, "core-js/modules/es.array.iterator": 158, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.promise": 178, "core-js/modules/es.string.iterator": 186, "core-js/modules/web.dom-collections.iterator": 229 }], 262: [function(e2, t2, r2) {
      e2("core-js/modules/es.array.includes"), e2("core-js/modules/es.array.iterator"), e2("core-js/modules/es.array.join"), e2("core-js/modules/es.array.slice"), e2("core-js/modules/es.object.keys"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.promise"), e2("core-js/modules/es.regexp.exec"), e2("core-js/modules/es.string.includes"), e2("core-js/modules/es.string.iterator"), e2("core-js/modules/es.string.split"), e2("core-js/modules/web.dom-collections.iterator"), Object.defineProperty(r2, "__esModule", { value: true }), r2.setTranslatorLanguage = r2.currentTranslatorLanguage = r2.availableTranslatorLanguages = r2.initialize = r2.translator = void 0;
      var i2, a2, n2 = s(e2("i18next")), o2 = s(e2("i18next-browser-languagedetector"));
      function s(e3) {
        return e3 && e3.__esModule ? e3 : { default: e3 };
      }
      function l2(e3, t3) {
        for (var r3 = 0; r3 < t3.length; r3++) {
          var n3 = t3[r3];
          n3.enumerable = n3.enumerable || false, n3.configurable = true, "value" in n3 && (n3.writable = true), Object.defineProperty(e3, n3.key, n3);
        }
      }
      var u2 = function() {
        function r3(e4, t4) {
          !function(e5, t5) {
            if (!(e5 instanceof t5))
              throw new TypeError("Cannot call a class as a function");
          }(this, r3), this.init(e4, t4);
        }
        var e3, t3;
        return e3 = r3, (t3 = [{ key: "fetchWithTimeout", value: function(e4, t4, r4) {
          var n3 = 2 < arguments.length && r4 !== void 0 ? r4 : 2e3;
          return Promise.race([fetch(e4, t4), new Promise(function(e5, t5) {
            return setTimeout(function() {
              return t5(new Error("timeout"));
            }, n3);
          })]);
        } }, { key: "init", value: function(e4, t4) {
          var r4 = 1 < arguments.length && t4 !== void 0 ? t4 : {};
          this.services = e4, this.options = r4;
        } }, { key: "read", value: function(e4, t4, r4) {
          var n3 = this.options.loadPath;
          if (e4 === this.options.fallback)
            r4(null, i2[e4][t4]);
          else if (a2.includes(e4)) {
            var o3 = this.services.interpolator.interpolate(n3, { lng: e4, ns: t4 });
            this.loadUrl(o3, r4);
          } else
            r4("Not found", false);
        } }, { key: "loadUrl", value: function(t4, r4) {
          this.fetchWithTimeout(t4).then(function(e4) {
            if (!e4.ok)
              throw new Error("failed loading ".concat(t4));
            return e4.json();
          }, function() {
            throw new Error("failed loading ".concat(t4));
          }).then(function(e4) {
            return r4(null, e4);
          }).catch(r4);
        } }]) && l2(e3.prototype, t3), r3;
      }();
      u2.type = "backend";
      var c = function(e3, t3) {
        console.debug("p5.js translator called before translations were loaded"), n2.default.t(e3, t3);
      };
      r2.translator = c;
      r2.initialize = function() {
        return n2.default.use(o2.default).use(u2).init({ fallbackLng: "en", nestingPrefix: "$tr(", nestingSuffix: ")", defaultNS: "translation", returnEmptyString: false, interpolation: { escapeValue: false }, detection: { checkWhitelist: false, order: ["querystring", "navigator", "htmlTag", "path", "subdomain"], caches: [] }, backend: { fallback: "en", loadPath: "https://cdn.jsdelivr.net/npm/p5/translations/{{lng}}/{{ns}}.json" }, partialBundledLanguages: true, resources: i2 }).then(function(e3) {
          r2.translator = c = e3;
        }, function(e3) {
          return console.debug("Translations failed to load (".concat(e3, ")"));
        });
      };
      r2.availableTranslatorLanguages = function() {
        return n2.default.languages;
      };
      r2.currentTranslatorLanguage = function() {
        return n2.default.language;
      };
      r2.setTranslatorLanguage = function(e3) {
        return n2.default.changeLanguage(e3 || void 0, function(e4) {
          return console.debug("Translations failed to load (".concat(e4, ")"));
        });
      };
    }, { "../../translations": void 0, "../../translations/dev": void 0, "core-js/modules/es.array.includes": 156, "core-js/modules/es.array.iterator": 158, "core-js/modules/es.array.join": 159, "core-js/modules/es.array.slice": 162, "core-js/modules/es.object.keys": 176, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.promise": 178, "core-js/modules/es.regexp.exec": 181, "core-js/modules/es.string.includes": 185, "core-js/modules/es.string.iterator": 186, "core-js/modules/es.string.split": 191, "core-js/modules/web.dom-collections.iterator": 229, i18next: 3, "i18next-browser-languagedetector": 3 }], 263: [function(e2, t2, r2) {
      Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, o2 = (n2 = e2("./main")) && n2.__esModule ? n2 : { default: n2 };
      o2.default.prototype.pushStyle = function() {
        throw new Error("pushStyle() not used, see push()");
      }, o2.default.prototype.popStyle = function() {
        throw new Error("popStyle() not used, see pop()");
      }, o2.default.prototype.popMatrix = function() {
        throw new Error("popMatrix() not used, see pop()");
      }, o2.default.prototype.pushMatrix = function() {
        throw new Error("pushMatrix() not used, see push()");
      };
      var i2 = o2.default;
      r2.default = i2;
    }, { "./main": 264 }], 264: [function(e2, t2, r2) {
      function a2(e3) {
        return (a2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      e2("core-js/modules/es.symbol"), e2("core-js/modules/es.symbol.description"), e2("core-js/modules/es.symbol.iterator"), e2("core-js/modules/es.array.for-each"), e2("core-js/modules/es.array.iterator"), e2("core-js/modules/es.array.slice"), e2("core-js/modules/es.object.get-own-property-names"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.string.iterator"), e2("core-js/modules/web.dom-collections.for-each"), e2("core-js/modules/web.dom-collections.iterator"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0, e2("./shim");
      var n2 = function(e3) {
        if (e3 && e3.__esModule)
          return e3;
        if (e3 === null || a2(e3) !== "object" && typeof e3 != "function")
          return { default: e3 };
        var t3 = s();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o3 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o3)) {
            var i3 = n3 ? Object.getOwnPropertyDescriptor(e3, o3) : null;
            i3 && (i3.get || i3.set) ? Object.defineProperty(r3, o3, i3) : r3[o3] = e3[o3];
          }
        r3.default = e3, t3 && t3.set(e3, r3);
        return r3;
      }(e2("./constants"));
      function s() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return s = function() {
          return e3;
        }, e3;
      }
      function o2(e3, t3) {
        for (var r3 = 0; r3 < t3.length; r3++) {
          var n3 = t3[r3];
          n3.enumerable = n3.enumerable || false, n3.configurable = true, "value" in n3 && (n3.writable = true), Object.defineProperty(e3, n3.key, n3);
        }
      }
      var i2 = function() {
        function _(e4, t4, r3) {
          var f = this;
          !function(e5, t5) {
            if (!(e5 instanceof t5))
              throw new TypeError("Cannot call a class as a function");
          }(this, _), this._setupDone = false, this._pixelDensity = Math.ceil(window.devicePixelRatio) || 1, this._userNode = t4, this._curElement = null, this._elements = [], this._glAttributes = null, this._requestAnimId = 0, this._preloadCount = 0, this._isGlobal = false, this._loop = true, this._initializeInstanceVariables(), this._defaultCanvasSize = { width: 100, height: 100 }, this._events = { mousemove: null, mousedown: null, mouseup: null, dragend: null, dragover: null, click: null, dblclick: null, mouseover: null, mouseout: null, keydown: null, keyup: null, keypress: null, touchstart: null, touchmove: null, touchend: null, resize: null, blur: null }, this._millisStart = -1, this._lcg_random_state = null, this._gaussian_previous = false, this._events.wheel = null, this._loadingScreenId = "p5_loading", this._registeredMethods = {};
          var n3 = Object.getOwnPropertyNames(_.prototype._registeredMethods), o3 = true, i3 = false, a3 = void 0;
          try {
            for (var s2, l3 = n3[Symbol.iterator](); !(o3 = (s2 = l3.next()).done); o3 = true) {
              var u3 = s2.value;
              this._registeredMethods[u3] = _.prototype._registeredMethods[u3].slice();
            }
          } catch (e5) {
            i3 = true, a3 = e5;
          } finally {
            try {
              o3 || l3.return == null || l3.return();
            } finally {
              if (i3)
                throw a3;
            }
          }
          window.DeviceOrientationEvent && (this._events.deviceorientation = null), window.DeviceMotionEvent && !window._isNodeWebkit && (this._events.devicemotion = null), this._start = function() {
            f._userNode && typeof f._userNode == "string" && (f._userNode = document.getElementById(f._userNode));
            var e5 = f._isGlobal ? window : f;
            if (e5.preload) {
              var t5 = document.getElementById(f._loadingScreenId);
              if (!t5)
                (t5 = document.createElement("div")).innerHTML = "Loading...", t5.style.position = "absolute", t5.id = f._loadingScreenId, (f._userNode || document.body).appendChild(t5);
              var r4 = f._preloadMethods;
              for (var n4 in r4) {
                r4[n4] = r4[n4] || _;
                var o4 = r4[n4];
                o4 !== _.prototype && o4 !== _ || (f._isGlobal && (window[n4] = f._wrapPreload(f, n4)), o4 = f), f._registeredPreloadMethods[n4] = o4[n4], o4[n4] = f._wrapPreload(o4, n4);
              }
              e5.preload(), f._runIfPreloadsAreDone();
            } else
              f._setup(), f._draw();
          }, this._runIfPreloadsAreDone = function() {
            var e5 = this._isGlobal ? window : this;
            if (e5._preloadCount === 0) {
              var t5 = document.getElementById(e5._loadingScreenId);
              t5 && t5.parentNode.removeChild(t5), this._setupDone || (this._lastFrameTime = window.performance.now(), e5._setup(), e5._draw());
            }
          }, this._decrementPreload = function() {
            var e5 = this._isGlobal ? window : this;
            typeof e5.preload == "function" && (e5._setProperty("_preloadCount", e5._preloadCount - 1), e5._runIfPreloadsAreDone());
          }, this._wrapPreload = function(n4, o4) {
            var i4 = this;
            return function() {
              i4._incrementPreload();
              for (var e5 = arguments.length, t5 = new Array(e5), r4 = 0; r4 < e5; r4++)
                t5[r4] = arguments[r4];
              return i4._registeredPreloadMethods[o4].apply(n4, t5);
            };
          }, this._incrementPreload = function() {
            var e5 = this._isGlobal ? window : this;
            e5._setProperty("_preloadCount", e5._preloadCount + 1);
          }, this._setup = function() {
            f.createCanvas(f._defaultCanvasSize.width, f._defaultCanvasSize.height, "p2d");
            var e5 = f._isGlobal ? window : f;
            if (typeof e5.preload == "function")
              for (var t5 in f._preloadMethods)
                e5[t5] = f._preloadMethods[t5][t5], e5[t5] && f && (e5[t5] = e5[t5].bind(f));
            f._millisStart = window.performance.now(), typeof e5.setup == "function" && e5.setup();
            var r4 = document.getElementsByTagName("canvas"), n4 = true, o4 = false, i4 = void 0;
            try {
              for (var a4, s3 = r4[Symbol.iterator](); !(n4 = (a4 = s3.next()).done); n4 = true) {
                var l4 = a4.value;
                l4.dataset.hidden === "true" && (l4.style.visibility = "", delete l4.dataset.hidden);
              }
            } catch (e6) {
              o4 = true, i4 = e6;
            } finally {
              try {
                n4 || s3.return == null || s3.return();
              } finally {
                if (o4)
                  throw i4;
              }
            }
            f._lastFrameTime = window.performance.now(), f._setupDone = true, (f._accessibleOutputs.grid || f._accessibleOutputs.text) && f._updateAccsOutput();
          }, this._draw = function() {
            var e5 = window.performance.now(), t5 = e5 - f._lastFrameTime, r4 = 1e3 / f._targetFrameRate;
            (!f._loop || r4 - 5 <= t5) && (f.redraw(), f._frameRate = 1e3 / (e5 - f._lastFrameTime), f.deltaTime = e5 - f._lastFrameTime, f._setProperty("deltaTime", f.deltaTime), f._lastFrameTime = e5, f._updateMouseCoords !== void 0 && (f._updateMouseCoords(), f._setProperty("movedX", 0), f._setProperty("movedY", 0))), f._loop && (f._requestAnimId = window.requestAnimationFrame(f._draw));
          }, this._setProperty = function(e5, t5) {
            f[e5] = t5, f._isGlobal && (window[e5] = t5);
          }, this.remove = function() {
            var e5 = document.getElementById(f._loadingScreenId);
            if (e5 && (e5.parentNode.removeChild(e5), f._incrementPreload()), f._curElement) {
              for (var t5 in f._loop = false, f._requestAnimId && window.cancelAnimationFrame(f._requestAnimId), f._events)
                window.removeEventListener(t5, f._events[t5]);
              var r4 = true, n4 = false, o4 = void 0;
              try {
                for (var i4, a4 = f._elements[Symbol.iterator](); !(r4 = (i4 = a4.next()).done); r4 = true) {
                  var s3 = i4.value;
                  for (var l4 in s3.elt && s3.elt.parentNode && s3.elt.parentNode.removeChild(s3.elt), s3._events)
                    s3.elt.removeEventListener(l4, s3._events[l4]);
                }
              } catch (e6) {
                n4 = true, o4 = e6;
              } finally {
                try {
                  r4 || a4.return == null || a4.return();
                } finally {
                  if (n4)
                    throw o4;
                }
              }
              var u4 = f;
              f._registeredMethods.remove.forEach(function(e6) {
                e6 !== void 0 && e6.call(u4);
              });
            }
            if (f._isGlobal) {
              for (var c2 in _.prototype)
                try {
                  delete window[c2];
                } catch (e6) {
                  window[c2] = void 0;
                }
              for (var d2 in f)
                if (f.hasOwnProperty(d2))
                  try {
                    delete window[d2];
                  } catch (e6) {
                    window[d2] = void 0;
                  }
              _.instance = null;
            }
          }, this._registeredMethods.init.forEach(function(e5) {
            e5 !== void 0 && e5.call(this);
          }, this), this._setupPromisePreloads();
          var c = this._createFriendlyGlobalFunctionBinder();
          if (e4)
            e4(this), _._checkForUserDefinedFunctions(this);
          else {
            for (var d in this._isGlobal = true, _.instance = this, _.prototype)
              if (typeof _.prototype[d] == "function") {
                var h2 = d.substring(2);
                this._events.hasOwnProperty(h2) || (Math.hasOwnProperty(d) && Math[d] === _.prototype[d] ? c(d, _.prototype[d]) : c(d, _.prototype[d].bind(this)));
              } else
                c(d, _.prototype[d]);
            for (var p2 in this)
              this.hasOwnProperty(p2) && c(p2, this[p2]);
          }
          for (var y in this._events) {
            var m2 = this["_on".concat(y)];
            if (m2) {
              var g = m2.bind(this);
              window.addEventListener(y, g, { passive: false }), this._events[y] = g;
            }
          }
          function v() {
            f._setProperty("focused", true);
          }
          function b2() {
            f._setProperty("focused", false);
          }
          window.addEventListener("focus", v), window.addEventListener("blur", b2), this.registerMethod("remove", function() {
            window.removeEventListener("focus", v), window.removeEventListener("blur", b2);
          }), document.readyState === "complete" ? this._start() : window.addEventListener("load", this._start.bind(this), false);
        }
        var e3, t3;
        return e3 = _, (t3 = [{ key: "_initializeInstanceVariables", value: function() {
          this._accessibleOutputs = { text: false, grid: false, textLabel: false, gridLabel: false }, this._styles = [], this._bezierDetail = 20, this._curveDetail = 20, this._colorMode = n2.RGB, this._colorMaxes = { rgb: [255, 255, 255, 255], hsb: [360, 100, 100, 1], hsl: [360, 100, 100, 1] }, this._downKeys = {};
        } }, { key: "registerPreloadMethod", value: function(e4, t4) {
          _.prototype._preloadMethods.hasOwnProperty(e4) || (_.prototype._preloadMethods[e4] = t4);
        } }, { key: "registerMethod", value: function(e4, t4) {
          var r3 = this || _.prototype;
          r3._registeredMethods.hasOwnProperty(e4) || (r3._registeredMethods[e4] = []), r3._registeredMethods[e4].push(t4);
        } }, { key: "_createFriendlyGlobalFunctionBinder", value: function(e4) {
          var t4 = 0 < arguments.length && e4 !== void 0 ? e4 : {}, r3 = t4.globalObject || window;
          t4.log || console.log.bind(console);
          return function(e5, t5) {
            r3[e5] = t5;
          };
        } }]) && o2(e3.prototype, t3), _;
      }();
      for (var l2 in i2.instance = null, i2.disableFriendlyErrors = false, n2)
        i2.prototype[l2] = n2[l2];
      i2.VERSION = n2.VERSION, i2.prototype._preloadMethods = { loadJSON: i2.prototype, loadImage: i2.prototype, loadStrings: i2.prototype, loadXML: i2.prototype, loadBytes: i2.prototype, loadTable: i2.prototype, loadFont: i2.prototype, loadModel: i2.prototype, loadShader: i2.prototype }, i2.prototype._registeredMethods = { init: [], pre: [], post: [], remove: [] }, i2.prototype._registeredPreloadMethods = {};
      var u2 = i2;
      r2.default = u2;
    }, { "./constants": 253, "./shim": 275, "core-js/modules/es.array.for-each": 154, "core-js/modules/es.array.iterator": 158, "core-js/modules/es.array.slice": 162, "core-js/modules/es.object.get-own-property-names": 174, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.string.iterator": 186, "core-js/modules/es.symbol": 196, "core-js/modules/es.symbol.description": 194, "core-js/modules/es.symbol.iterator": 195, "core-js/modules/web.dom-collections.for-each": 228, "core-js/modules/web.dom-collections.iterator": 229 }], 265: [function(e2, t2, r2) {
      Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, o2 = (n2 = e2("./main")) && n2.__esModule ? n2 : { default: n2 };
      o2.default.Element = function(e3, t3) {
        this.elt = e3, this._pInst = this._pixelsState = t3, this._events = {}, this.width = this.elt.offsetWidth, this.height = this.elt.offsetHeight;
      }, o2.default.Element.prototype.parent = function(e3) {
        return e3 === void 0 ? this.elt.parentNode : (typeof e3 == "string" ? (e3[0] === "#" && (e3 = e3.substring(1)), e3 = document.getElementById(e3)) : e3 instanceof o2.default.Element && (e3 = e3.elt), e3.appendChild(this.elt), this);
      }, o2.default.Element.prototype.id = function(e3) {
        return e3 === void 0 ? this.elt.id : (this.elt.id = e3, this.width = this.elt.offsetWidth, this.height = this.elt.offsetHeight, this);
      }, o2.default.Element.prototype.class = function(e3) {
        return e3 === void 0 ? this.elt.className : (this.elt.className = e3, this);
      }, o2.default.Element.prototype.mousePressed = function(t3) {
        return o2.default.Element._adjustListener("mousedown", function(e3) {
          return this._pInst._setProperty("mouseIsPressed", true), this._pInst._setMouseButton(e3), t3.call(this);
        }, this), this;
      }, o2.default.Element.prototype.doubleClicked = function(e3) {
        return o2.default.Element._adjustListener("dblclick", e3, this), this;
      }, o2.default.Element.prototype.mouseWheel = function(e3) {
        return o2.default.Element._adjustListener("wheel", e3, this), this;
      }, o2.default.Element.prototype.mouseReleased = function(e3) {
        return o2.default.Element._adjustListener("mouseup", e3, this), this;
      }, o2.default.Element.prototype.mouseClicked = function(e3) {
        return o2.default.Element._adjustListener("click", e3, this), this;
      }, o2.default.Element.prototype.mouseMoved = function(e3) {
        return o2.default.Element._adjustListener("mousemove", e3, this), this;
      }, o2.default.Element.prototype.mouseOver = function(e3) {
        return o2.default.Element._adjustListener("mouseover", e3, this), this;
      }, o2.default.Element.prototype.mouseOut = function(e3) {
        return o2.default.Element._adjustListener("mouseout", e3, this), this;
      }, o2.default.Element.prototype.touchStarted = function(e3) {
        return o2.default.Element._adjustListener("touchstart", e3, this), this;
      }, o2.default.Element.prototype.touchMoved = function(e3) {
        return o2.default.Element._adjustListener("touchmove", e3, this), this;
      }, o2.default.Element.prototype.touchEnded = function(e3) {
        return o2.default.Element._adjustListener("touchend", e3, this), this;
      }, o2.default.Element.prototype.dragOver = function(e3) {
        return o2.default.Element._adjustListener("dragover", e3, this), this;
      }, o2.default.Element.prototype.dragLeave = function(e3) {
        return o2.default.Element._adjustListener("dragleave", e3, this), this;
      }, o2.default.Element._adjustListener = function(e3, t3, r3) {
        return t3 === false ? o2.default.Element._detachListener(e3, r3) : o2.default.Element._attachListener(e3, t3, r3), this;
      }, o2.default.Element._attachListener = function(e3, t3, r3) {
        r3._events[e3] && o2.default.Element._detachListener(e3, r3);
        var n3 = t3.bind(r3);
        r3.elt.addEventListener(e3, n3, false), r3._events[e3] = n3;
      }, o2.default.Element._detachListener = function(e3, t3) {
        var r3 = t3._events[e3];
        t3.elt.removeEventListener(e3, r3, false), t3._events[e3] = null;
      }, o2.default.Element.prototype._setProperty = function(e3, t3) {
        this[e3] = t3;
      };
      var i2 = o2.default.Element;
      r2.default = i2;
    }, { "./main": 264 }], 266: [function(e2, t2, r2) {
      function a2(e3) {
        return (a2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      e2("core-js/modules/es.array.index-of"), e2("core-js/modules/es.array.splice"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, s = (n2 = e2("./main")) && n2.__esModule ? n2 : { default: n2 }, l2 = function(e3) {
        if (e3 && e3.__esModule)
          return e3;
        if (e3 === null || a2(e3) !== "object" && typeof e3 != "function")
          return { default: e3 };
        var t3 = u2();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o3 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o3)) {
            var i2 = n3 ? Object.getOwnPropertyDescriptor(e3, o3) : null;
            i2 && (i2.get || i2.set) ? Object.defineProperty(r3, o3, i2) : r3[o3] = e3[o3];
          }
        r3.default = e3, t3 && t3.set(e3, r3);
        return r3;
      }(e2("./constants"));
      function u2() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return u2 = function() {
          return e3;
        }, e3;
      }
      s.default.Graphics = function(e3, t3, r3, n3) {
        var o3 = r3 || l2.P2D;
        this.canvas = document.createElement("canvas");
        var i2 = n3._userNode || document.body;
        for (var a3 in i2.appendChild(this.canvas), s.default.Element.call(this, this.canvas, n3), s.default.prototype)
          this[a3] || (typeof s.default.prototype[a3] == "function" ? this[a3] = s.default.prototype[a3].bind(this) : this[a3] = s.default.prototype[a3]);
        return s.default.prototype._initializeInstanceVariables.apply(this), this.width = e3, this.height = t3, this._pixelDensity = n3._pixelDensity, o3 === l2.WEBGL ? this._renderer = new s.default.RendererGL(this.canvas, this, false) : this._renderer = new s.default.Renderer2D(this.canvas, this, false), n3._elements.push(this), Object.defineProperty(this, "deltaTime", { get: function() {
          return this._pInst.deltaTime;
        } }), this._renderer.resize(e3, t3), this._renderer._applyDefaults(), this;
      }, s.default.Graphics.prototype = Object.create(s.default.Element.prototype), s.default.Graphics.prototype.reset = function() {
        this._renderer.resetMatrix(), this._renderer.isP3D && this._renderer._update();
      }, s.default.Graphics.prototype.remove = function() {
        this.elt.parentNode && this.elt.parentNode.removeChild(this.elt);
        var e3 = this._pInst._elements.indexOf(this);
        for (var t3 in e3 !== -1 && this._pInst._elements.splice(e3, 1), this._events)
          this.elt.removeEventListener(t3, this._events[t3]);
      };
      var o2 = s.default.Graphics;
      r2.default = o2;
    }, { "./constants": 253, "./main": 264, "core-js/modules/es.array.index-of": 157, "core-js/modules/es.array.splice": 164 }], 267: [function(e2, t2, r2) {
      e2("core-js/modules/es.symbol"), e2("core-js/modules/es.symbol.description"), e2("core-js/modules/es.symbol.iterator"), e2("core-js/modules/es.array.iterator"), e2("core-js/modules/es.number.constructor"), e2("core-js/modules/es.object.assign"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.regexp.exec"), e2("core-js/modules/es.regexp.to-string"), e2("core-js/modules/es.string.iterator"), e2("core-js/modules/es.string.replace"), e2("core-js/modules/es.string.split"), e2("core-js/modules/es.string.trim"), e2("core-js/modules/web.dom-collections.iterator"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, l2 = (n2 = e2("./main")) && n2.__esModule ? n2 : { default: n2 }, k2 = function(e3) {
        if (e3 && e3.__esModule)
          return e3;
        if (e3 === null || s(e3) !== "object" && typeof e3 != "function")
          return { default: e3 };
        var t3 = a2();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o3 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o3)) {
            var i2 = n3 ? Object.getOwnPropertyDescriptor(e3, o3) : null;
            i2 && (i2.get || i2.set) ? Object.defineProperty(r3, o3, i2) : r3[o3] = e3[o3];
          }
        r3.default = e3, t3 && t3.set(e3, r3);
        return r3;
      }(e2("../core/constants"));
      function a2() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return a2 = function() {
          return e3;
        }, e3;
      }
      function s(e3) {
        return (s = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      function u2(e3) {
        var t3 = 0, r3 = 0;
        if (e3.offsetParent)
          for (; t3 += e3.offsetLeft, r3 += e3.offsetTop, e3 = e3.offsetParent; )
            ;
        else
          t3 += e3.offsetLeft, r3 += e3.offsetTop;
        return [t3, r3];
      }
      l2.default.Renderer = function(e3, t3, r3) {
        l2.default.Element.call(this, e3, t3), this.canvas = e3, this._pixelsState = t3, r3 ? (this._isMainCanvas = true, this._pInst._setProperty("_curElement", this), this._pInst._setProperty("canvas", this.canvas), this._pInst._setProperty("width", this.width), this._pInst._setProperty("height", this.height)) : (this.canvas.style.display = "none", this._styles = []), this._textSize = 12, this._textLeading = 15, this._textFont = "sans-serif", this._textStyle = k2.NORMAL, this._textAscent = null, this._textDescent = null, this._textAlign = k2.LEFT, this._textBaseline = k2.BASELINE, this._textWrap = k2.WORD, this._rectMode = k2.CORNER, this._ellipseMode = k2.CENTER, this._curveTightness = 0, this._imageMode = k2.CORNER, this._tint = null, this._doStroke = true, this._doFill = true, this._strokeSet = false, this._fillSet = false, this._leadingSet = false;
      }, l2.default.Renderer.prototype = Object.create(l2.default.Element.prototype), l2.default.Renderer.prototype.push = function() {
        return { properties: { _doStroke: this._doStroke, _strokeSet: this._strokeSet, _doFill: this._doFill, _fillSet: this._fillSet, _tint: this._tint, _imageMode: this._imageMode, _rectMode: this._rectMode, _ellipseMode: this._ellipseMode, _textFont: this._textFont, _textLeading: this._textLeading, _leadingSet: this._leadingSet, _textSize: this._textSize, _textAlign: this._textAlign, _textBaseline: this._textBaseline, _textStyle: this._textStyle, _textWrap: this._textWrap } };
      }, l2.default.Renderer.prototype.pop = function(e3) {
        e3.properties && Object.assign(this, e3.properties);
      }, l2.default.Renderer.prototype.resize = function(e3, t3) {
        this.width = e3, this.height = t3, this.elt.width = e3 * this._pInst._pixelDensity, this.elt.height = t3 * this._pInst._pixelDensity, this.elt.style.width = "".concat(e3, "px"), this.elt.style.height = "".concat(t3, "px"), this._isMainCanvas && (this._pInst._setProperty("width", this.width), this._pInst._setProperty("height", this.height));
      }, l2.default.Renderer.prototype.get = function(e3, t3, r3, n3) {
        var o3 = this._pixelsState, i2 = o3._pixelDensity, a3 = this.canvas;
        if (e3 === void 0 && t3 === void 0)
          e3 = t3 = 0, r3 = o3.width, n3 = o3.height;
        else if (e3 *= i2, t3 *= i2, r3 === void 0 && n3 === void 0)
          return e3 < 0 || t3 < 0 || e3 >= a3.width || t3 >= a3.height ? [0, 0, 0, 0] : this._getPixel(e3, t3);
        var s2 = new l2.default.Image(r3, n3);
        return s2.canvas.getContext("2d").drawImage(a3, e3, t3, r3 * i2, n3 * i2, 0, 0, r3, n3), s2;
      }, l2.default.Renderer.prototype.textLeading = function(e3) {
        return typeof e3 == "number" ? (this._setProperty("_leadingSet", true), this._setProperty("_textLeading", e3), this._pInst) : this._textLeading;
      }, l2.default.Renderer.prototype.textSize = function(e3) {
        return typeof e3 == "number" ? (this._setProperty("_textSize", e3), this._leadingSet || this._setProperty("_textLeading", e3 * k2._DEFAULT_LEADMULT), this._applyTextProperties()) : this._textSize;
      }, l2.default.Renderer.prototype.textStyle = function(e3) {
        return e3 ? (e3 !== k2.NORMAL && e3 !== k2.ITALIC && e3 !== k2.BOLD && e3 !== k2.BOLDITALIC || this._setProperty("_textStyle", e3), this._applyTextProperties()) : this._textStyle;
      }, l2.default.Renderer.prototype.textAscent = function() {
        return this._textAscent === null && this._updateTextMetrics(), this._textAscent;
      }, l2.default.Renderer.prototype.textDescent = function() {
        return this._textDescent === null && this._updateTextMetrics(), this._textDescent;
      }, l2.default.Renderer.prototype.textAlign = function(e3, t3) {
        return e3 !== void 0 ? (this._setProperty("_textAlign", e3), t3 !== void 0 && this._setProperty("_textBaseline", t3), this._applyTextProperties()) : { horizontal: this._textAlign, vertical: this._textBaseline };
      }, l2.default.Renderer.prototype.textWrap = function(e3) {
        return this._setProperty("_textWrap", e3), this._textWrap;
      }, l2.default.Renderer.prototype.text = function(e3, t3, r3, n3, o3) {
        var i2, a3, s2, l3, u3, c, d, f = this._pInst, h2 = this._textWrap, p2 = Number.MAX_VALUE;
        if ((this._doFill || this._doStroke) && e3 !== void 0) {
          if (typeof e3 != "string" && (e3 = e3.toString()), i2 = (e3 = e3.replace(/(\t)/g, "  ")).split("\n"), n3 !== void 0) {
            switch (this._rectMode === k2.CENTER && (t3 -= n3 / 2), this._textAlign) {
              case k2.CENTER:
                t3 += n3 / 2;
                break;
              case k2.RIGHT:
                t3 += n3;
            }
            var y = false;
            if (o3 !== void 0) {
              switch (this._rectMode === k2.CENTER && (r3 -= o3 / 2), this._textBaseline) {
                case k2.BOTTOM:
                  d = r3 + o3, r3 = Math.max(d, r3);
                  break;
                case k2.CENTER:
                  d = r3 + o3 / 2, r3 = Math.max(d, r3);
                  break;
                case k2.BASELINE:
                  y = true, this._textBaseline = k2.TOP;
              }
              p2 = r3 + o3 - f.textAscent();
            }
            if (h2 === k2.WORD) {
              for (var m2 = [], g = 0; g < i2.length; g++) {
                a3 = "", u3 = i2[g].split(" ");
                for (var v = 0; v < u3.length; v++)
                  s2 = "".concat(a3 + u3[v]) + " ", a3 = n3 < (l3 = this.textWidth(s2)) && 0 < a3.length ? (m2.push(a3), "".concat(u3[v]) + " ") : s2;
                m2.push(a3);
              }
              var b2 = 0, _ = f.textAlign().vertical;
              _ === k2.CENTER ? b2 = (m2.length - 1) * f.textLeading() / 2 : _ === k2.BOTTOM && (b2 = (m2.length - 1) * f.textLeading());
              for (var x = 0; x < i2.length; x++) {
                a3 = "", u3 = i2[x].split(" ");
                for (var w = 0; w < u3.length; w++)
                  s2 = "".concat(a3 + u3[w]) + " ", n3 < (l3 = this.textWidth(s2)) && 0 < a3.length ? (this._renderText(f, a3.trim(), t3, r3 - b2, p2), a3 = "".concat(u3[w]) + " ", r3 += f.textLeading()) : a3 = s2;
                this._renderText(f, a3.trim(), t3, r3 - b2, p2), r3 += f.textLeading(), y && (this._textBaseline = k2.BASELINE);
              }
            } else {
              for (var j = [], S2 = 0; S2 < i2.length; S2++) {
                a3 = "", c = i2[S2].split("");
                for (var M = 0; M < c.length; M++)
                  s2 = "".concat(a3 + c[M]), (l3 = this.textWidth(s2)) <= n3 ? a3 += c[M] : n3 < l3 && 0 < a3.length && (j.push(a3), a3 = "".concat(c[M]));
              }
              j.push(a3);
              var E = 0, T2 = f.textAlign().vertical;
              T2 === k2.CENTER ? E = (j.length - 1) * f.textLeading() / 2 : T2 === k2.BOTTOM && (E = (j.length - 1) * f.textLeading());
              for (var O2 = 0; O2 < i2.length; O2++) {
                a3 = "", c = i2[O2].split("");
                for (var C = 0; C < c.length; C++)
                  s2 = "".concat(a3 + c[C]), (l3 = this.textWidth(s2)) <= n3 ? a3 += c[C] : n3 < l3 && 0 < a3.length && (this._renderText(f, a3.trim(), t3, r3 - E, p2), r3 += f.textLeading(), a3 = "".concat(c[C]));
              }
              this._renderText(f, a3.trim(), t3, r3 - E, p2), r3 += f.textLeading(), y && (this._textBaseline = k2.BASELINE);
            }
          } else {
            var L = 0, P2 = f.textAlign().vertical;
            P2 === k2.CENTER ? L = (i2.length - 1) * f.textLeading() / 2 : P2 === k2.BOTTOM && (L = (i2.length - 1) * f.textLeading());
            for (var A = 0; A < i2.length; A++)
              this._renderText(f, i2[A], t3, r3 - L, p2), r3 += f.textLeading();
          }
          return f;
        }
      }, l2.default.Renderer.prototype._applyDefaults = function() {
        return this;
      }, l2.default.Renderer.prototype._isOpenType = function() {
        var e3 = 0 < arguments.length && arguments[0] !== void 0 ? arguments[0] : this._textFont;
        return s(e3) === "object" && e3.font && e3.font.supported;
      }, l2.default.Renderer.prototype._updateTextMetrics = function() {
        if (this._isOpenType())
          return this._setProperty("_textAscent", this._textFont._textAscent()), this._setProperty("_textDescent", this._textFont._textDescent()), this;
        var e3 = document.createElement("span");
        e3.style.fontFamily = this._textFont, e3.style.fontSize = "".concat(this._textSize, "px"), e3.innerHTML = "ABCjgq|";
        var t3 = document.createElement("div");
        t3.style.display = "inline-block", t3.style.width = "1px", t3.style.height = "0px";
        var r3 = document.createElement("div");
        r3.appendChild(e3), r3.appendChild(t3), r3.style.height = "0px", r3.style.overflow = "hidden", document.body.appendChild(r3), t3.style.verticalAlign = "baseline";
        var n3 = u2(t3), o3 = u2(e3), i2 = n3[1] - o3[1];
        t3.style.verticalAlign = "bottom", n3 = u2(t3), o3 = u2(e3);
        var a3 = n3[1] - o3[1] - i2;
        return document.body.removeChild(r3), this._setProperty("_textAscent", i2), this._setProperty("_textDescent", a3), this;
      };
      var o2 = l2.default.Renderer;
      r2.default = o2;
    }, { "../core/constants": 253, "./main": 264, "core-js/modules/es.array.iterator": 158, "core-js/modules/es.number.constructor": 170, "core-js/modules/es.object.assign": 173, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.regexp.exec": 181, "core-js/modules/es.regexp.to-string": 182, "core-js/modules/es.string.iterator": 186, "core-js/modules/es.string.replace": 189, "core-js/modules/es.string.split": 191, "core-js/modules/es.string.trim": 193, "core-js/modules/es.symbol": 196, "core-js/modules/es.symbol.description": 194, "core-js/modules/es.symbol.iterator": 195, "core-js/modules/web.dom-collections.iterator": 229 }], 268: [function(e2, t2, r2) {
      function a2(e3) {
        return (a2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      e2("core-js/modules/es.array.concat"), e2("core-js/modules/es.array.fill"), e2("core-js/modules/es.array.for-each"), e2("core-js/modules/es.array.slice"), e2("core-js/modules/es.function.name"), e2("core-js/modules/es.number.to-fixed"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.regexp.to-string"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var d = n2(e2("./main")), p2 = function(e3) {
        if (e3 && e3.__esModule)
          return e3;
        if (e3 === null || a2(e3) !== "object" && typeof e3 != "function")
          return { default: e3 };
        var t3 = s();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o3 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o3)) {
            var i2 = n3 ? Object.getOwnPropertyDescriptor(e3, o3) : null;
            i2 && (i2.get || i2.set) ? Object.defineProperty(r3, o3, i2) : r3[o3] = e3[o3];
          }
        r3.default = e3, t3 && t3.set(e3, r3);
        return r3;
      }(e2("./constants")), f = n2(e2("../image/filters"));
      function s() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return s = function() {
          return e3;
        }, e3;
      }
      function n2(e3) {
        return e3 && e3.__esModule ? e3 : { default: e3 };
      }
      e2("./p5.Renderer");
      var m2 = "rgba(0,0,0,0)";
      d.default.Renderer2D = function(e3, t3, r3) {
        return d.default.Renderer.call(this, e3, t3, r3), this.drawingContext = this.canvas.getContext("2d"), this._pInst._setProperty("drawingContext", this.drawingContext), this;
      }, d.default.Renderer2D.prototype = Object.create(d.default.Renderer.prototype), d.default.Renderer2D.prototype._applyDefaults = function() {
        this._cachedFillStyle = this._cachedStrokeStyle = void 0, this._cachedBlendMode = p2.BLEND, this._setFill(p2._DEFAULT_FILL), this._setStroke(p2._DEFAULT_STROKE), this.drawingContext.lineCap = p2.ROUND, this.drawingContext.font = "normal 12px sans-serif";
      }, d.default.Renderer2D.prototype.resize = function(e3, t3) {
        d.default.Renderer.prototype.resize.call(this, e3, t3), this.drawingContext.scale(this._pInst._pixelDensity, this._pInst._pixelDensity);
      }, d.default.Renderer2D.prototype.background = function() {
        if (this.drawingContext.save(), this.resetMatrix(), (arguments.length <= 0 ? void 0 : arguments[0]) instanceof d.default.Image)
          this._pInst.image(arguments.length <= 0 ? void 0 : arguments[0], 0, 0, this.width, this.height);
        else {
          var e3, t3 = this._getFill(), r3 = (e3 = this._pInst).color.apply(e3, arguments);
          this._pInst._addAccsOutput() && this._pInst._accsBackground(r3.levels);
          var n3 = r3.toString();
          this._setFill(n3), this._isErasing && this.blendMode(this._cachedBlendMode), this.drawingContext.fillRect(0, 0, this.width, this.height), this._setFill(t3), this._isErasing && this._pInst.erase();
        }
        this.drawingContext.restore();
      }, d.default.Renderer2D.prototype.clear = function() {
        this.drawingContext.save(), this.resetMatrix(), this.drawingContext.clearRect(0, 0, this.width, this.height), this.drawingContext.restore();
      }, d.default.Renderer2D.prototype.fill = function() {
        var e3, t3 = (e3 = this._pInst).color.apply(e3, arguments);
        this._setFill(t3.toString()), this._pInst._addAccsOutput() && this._pInst._accsCanvasColors("fill", t3.levels);
      }, d.default.Renderer2D.prototype.stroke = function() {
        var e3, t3 = (e3 = this._pInst).color.apply(e3, arguments);
        this._setStroke(t3.toString()), this._pInst._addAccsOutput() && this._pInst._accsCanvasColors("stroke", t3.levels);
      }, d.default.Renderer2D.prototype.erase = function(e3, t3) {
        if (!this._isErasing) {
          this._cachedFillStyle = this.drawingContext.fillStyle;
          var r3 = this._pInst.color(255, e3).toString();
          this.drawingContext.fillStyle = r3, this._cachedStrokeStyle = this.drawingContext.strokeStyle;
          var n3 = this._pInst.color(255, t3).toString();
          this.drawingContext.strokeStyle = n3;
          var o3 = this._cachedBlendMode;
          this.blendMode(p2.REMOVE), this._cachedBlendMode = o3, this._isErasing = true;
        }
      }, d.default.Renderer2D.prototype.noErase = function() {
        this._isErasing && (this.drawingContext.fillStyle = this._cachedFillStyle, this.drawingContext.strokeStyle = this._cachedStrokeStyle, this.blendMode(this._cachedBlendMode), this._isErasing = false);
      }, d.default.Renderer2D.prototype.image = function(e3, t3, r3, n3, o3, i2, a3, s2, l2) {
        var u2;
        e3.gifProperties && e3._animateGif(this._pInst);
        try {
          this._tint && (d.default.MediaElement && e3 instanceof d.default.MediaElement && e3.loadPixels(), e3.canvas && (u2 = this._getTintedImageCanvas(e3))), u2 = u2 || (e3.canvas || e3.elt);
          var c = 1;
          e3.width && 0 < e3.width && (c = u2.width / e3.width), this._isErasing && this.blendMode(this._cachedBlendMode), this.drawingContext.drawImage(u2, c * t3, c * r3, c * n3, c * o3, i2, a3, s2, l2), this._isErasing && this._pInst.erase();
        } catch (e4) {
          if (e4.name !== "NS_ERROR_NOT_AVAILABLE")
            throw e4;
        }
      }, d.default.Renderer2D.prototype._getTintedImageCanvas = function(e3) {
        if (!e3.canvas)
          return e3;
        var t3 = f.default._toPixels(e3.canvas), r3 = document.createElement("canvas");
        r3.width = e3.canvas.width, r3.height = e3.canvas.height;
        for (var n3 = r3.getContext("2d"), o3 = n3.createImageData(e3.canvas.width, e3.canvas.height), i2 = o3.data, a3 = 0; a3 < t3.length; a3 += 4) {
          var s2 = t3[a3], l2 = t3[a3 + 1], u2 = t3[a3 + 2], c = t3[a3 + 3];
          i2[a3] = s2 * this._tint[0] / 255, i2[a3 + 1] = l2 * this._tint[1] / 255, i2[a3 + 2] = u2 * this._tint[2] / 255, i2[a3 + 3] = c * this._tint[3] / 255;
        }
        return n3.putImageData(o3, 0, 0), r3;
      }, d.default.Renderer2D.prototype.blendMode = function(e3) {
        if (e3 === p2.SUBTRACT)
          console.warn("blendMode(SUBTRACT) only works in WEBGL mode.");
        else {
          if (e3 !== p2.BLEND && e3 !== p2.REMOVE && e3 !== p2.DARKEST && e3 !== p2.LIGHTEST && e3 !== p2.DIFFERENCE && e3 !== p2.MULTIPLY && e3 !== p2.EXCLUSION && e3 !== p2.SCREEN && e3 !== p2.REPLACE && e3 !== p2.OVERLAY && e3 !== p2.HARD_LIGHT && e3 !== p2.SOFT_LIGHT && e3 !== p2.DODGE && e3 !== p2.BURN && e3 !== p2.ADD)
            throw new Error("Mode ".concat(e3, " not recognized."));
          this._cachedBlendMode = e3, this.drawingContext.globalCompositeOperation = e3;
        }
      }, d.default.Renderer2D.prototype.blend = function() {
        for (var e3 = this.drawingContext.globalCompositeOperation, t3 = arguments.length, r3 = new Array(t3), n3 = 0; n3 < t3; n3++)
          r3[n3] = arguments[n3];
        var o3 = r3[r3.length - 1], i2 = Array.prototype.slice.call(r3, 0, r3.length - 1);
        this.drawingContext.globalCompositeOperation = o3, d.default.prototype.copy.apply(this, i2), this.drawingContext.globalCompositeOperation = e3;
      }, d.default.Renderer2D.prototype._getPixel = function(e3, t3) {
        var r3;
        return [(r3 = this.drawingContext.getImageData(e3, t3, 1, 1).data)[0], r3[1], r3[2], r3[3]];
      }, d.default.Renderer2D.prototype.loadPixels = function() {
        var e3 = this._pixelsState, t3 = e3._pixelDensity, r3 = this.width * t3, n3 = this.height * t3, o3 = this.drawingContext.getImageData(0, 0, r3, n3);
        e3._setProperty("imageData", o3), e3._setProperty("pixels", o3.data);
      }, d.default.Renderer2D.prototype.set = function(e3, t3, r3) {
        e3 = Math.floor(e3), t3 = Math.floor(t3);
        var n3 = this._pixelsState;
        if (r3 instanceof d.default.Image)
          this.drawingContext.save(), this.drawingContext.setTransform(1, 0, 0, 1, 0, 0), this.drawingContext.scale(n3._pixelDensity, n3._pixelDensity), this.drawingContext.clearRect(e3, t3, r3.width, r3.height), this.drawingContext.drawImage(r3.canvas, e3, t3), this.drawingContext.restore();
        else {
          var o3 = 0, i2 = 0, a3 = 0, s2 = 0, l2 = 4 * (t3 * n3._pixelDensity * (this.width * n3._pixelDensity) + e3 * n3._pixelDensity);
          if (n3.imageData || n3.loadPixels.call(n3), typeof r3 == "number")
            l2 < n3.pixels.length && (a3 = i2 = o3 = r3, s2 = 255);
          else if (r3 instanceof Array) {
            if (r3.length < 4)
              throw new Error("pixel array must be of the form [R, G, B, A]");
            l2 < n3.pixels.length && (o3 = r3[0], i2 = r3[1], a3 = r3[2], s2 = r3[3]);
          } else
            r3 instanceof d.default.Color && l2 < n3.pixels.length && (o3 = r3.levels[0], i2 = r3.levels[1], a3 = r3.levels[2], s2 = r3.levels[3]);
          for (var u2 = 0; u2 < n3._pixelDensity; u2++)
            for (var c = 0; c < n3._pixelDensity; c++)
              l2 = 4 * ((t3 * n3._pixelDensity + c) * this.width * n3._pixelDensity + (e3 * n3._pixelDensity + u2)), n3.pixels[l2] = o3, n3.pixels[l2 + 1] = i2, n3.pixels[l2 + 2] = a3, n3.pixels[l2 + 3] = s2;
        }
      }, d.default.Renderer2D.prototype.updatePixels = function(e3, t3, r3, n3) {
        var o3 = this._pixelsState, i2 = o3._pixelDensity;
        e3 === void 0 && t3 === void 0 && r3 === void 0 && n3 === void 0 && (t3 = e3 = 0, r3 = this.width, n3 = this.height), e3 *= i2, t3 *= i2, r3 *= i2, n3 *= i2, this.gifProperties && (this.gifProperties.frames[this.gifProperties.displayIndex].image = o3.imageData), this.drawingContext.putImageData(o3.imageData, e3, t3, 0, 0, r3, n3);
      }, d.default.Renderer2D.prototype._acuteArcToBezier = function(e3, t3) {
        var r3 = t3 / 2, n3 = Math.cos(r3), o3 = Math.sin(r3), i2 = 1 / Math.tan(r3), a3 = e3 + r3, s2 = Math.cos(a3), l2 = Math.sin(a3), u2 = (4 - n3) / 3, c = o3 + (n3 - u2) * i2;
        return { ax: Math.cos(e3).toFixed(7), ay: Math.sin(e3).toFixed(7), bx: (u2 * s2 + c * l2).toFixed(7), by: (u2 * l2 - c * s2).toFixed(7), cx: (u2 * s2 - c * l2).toFixed(7), cy: (u2 * l2 + c * s2).toFixed(7), dx: Math.cos(e3 + t3).toFixed(7), dy: Math.sin(e3 + t3).toFixed(7) };
      }, d.default.Renderer2D.prototype.arc = function(r3, n3, e3, t3, o3, i2, a3) {
        var s2 = this.drawingContext, l2 = e3 / 2, u2 = t3 / 2, c = 0, d2 = [];
        for (r3 += l2, n3 += u2; 1e-5 <= i2 - o3; )
          c = Math.min(i2 - o3, p2.HALF_PI), d2.push(this._acuteArcToBezier(o3, c)), o3 += c;
        return this._doFill && (s2.beginPath(), d2.forEach(function(e4, t4) {
          t4 === 0 && s2.moveTo(r3 + e4.ax * l2, n3 + e4.ay * u2), s2.bezierCurveTo(r3 + e4.bx * l2, n3 + e4.by * u2, r3 + e4.cx * l2, n3 + e4.cy * u2, r3 + e4.dx * l2, n3 + e4.dy * u2);
        }), a3 !== p2.PIE && a3 != null || s2.lineTo(r3, n3), s2.closePath(), s2.fill()), this._doStroke && (s2.beginPath(), d2.forEach(function(e4, t4) {
          t4 === 0 && s2.moveTo(r3 + e4.ax * l2, n3 + e4.ay * u2), s2.bezierCurveTo(r3 + e4.bx * l2, n3 + e4.by * u2, r3 + e4.cx * l2, n3 + e4.cy * u2, r3 + e4.dx * l2, n3 + e4.dy * u2);
        }), a3 === p2.PIE ? (s2.lineTo(r3, n3), s2.closePath()) : a3 === p2.CHORD && s2.closePath(), s2.stroke()), this;
      }, d.default.Renderer2D.prototype.ellipse = function(e3) {
        var t3 = this.drawingContext, r3 = this._doFill, n3 = this._doStroke, o3 = parseFloat(e3[0]), i2 = parseFloat(e3[1]), a3 = parseFloat(e3[2]), s2 = parseFloat(e3[3]);
        if (r3 && !n3) {
          if (this._getFill() === m2)
            return this;
        } else if (!r3 && n3 && this._getStroke() === m2)
          return this;
        var l2 = a3 / 2 * 0.5522847498, u2 = s2 / 2 * 0.5522847498, c = o3 + a3, d2 = i2 + s2, f2 = o3 + a3 / 2, h2 = i2 + s2 / 2;
        t3.beginPath(), t3.moveTo(o3, h2), t3.bezierCurveTo(o3, h2 - u2, f2 - l2, i2, f2, i2), t3.bezierCurveTo(f2 + l2, i2, c, h2 - u2, c, h2), t3.bezierCurveTo(c, h2 + u2, f2 + l2, d2, f2, d2), t3.bezierCurveTo(f2 - l2, d2, o3, h2 + u2, o3, h2), r3 && t3.fill(), n3 && t3.stroke();
      }, d.default.Renderer2D.prototype.line = function(e3, t3, r3, n3) {
        var o3 = this.drawingContext;
        return this._doStroke && (this._getStroke() === m2 || (o3.beginPath(), o3.moveTo(e3, t3), o3.lineTo(r3, n3), o3.stroke())), this;
      }, d.default.Renderer2D.prototype.point = function(e3, t3) {
        var r3 = this.drawingContext;
        if (!this._doStroke)
          return this;
        if (this._getStroke() === m2)
          return this;
        var n3 = this._getStroke(), o3 = this._getFill();
        this._setFill(n3), r3.beginPath(), r3.arc(e3, t3, r3.lineWidth / 2, 0, p2.TWO_PI, false), r3.fill(), this._setFill(o3);
      }, d.default.Renderer2D.prototype.quad = function(e3, t3, r3, n3, o3, i2, a3, s2) {
        var l2 = this.drawingContext, u2 = this._doFill, c = this._doStroke;
        if (u2 && !c) {
          if (this._getFill() === m2)
            return this;
        } else if (!u2 && c && this._getStroke() === m2)
          return this;
        return l2.beginPath(), l2.moveTo(e3, t3), l2.lineTo(r3, n3), l2.lineTo(o3, i2), l2.lineTo(a3, s2), l2.closePath(), u2 && l2.fill(), c && l2.stroke(), this;
      }, d.default.Renderer2D.prototype.rect = function(e3) {
        var t3 = e3[0], r3 = e3[1], n3 = e3[2], o3 = e3[3], i2 = e3[4], a3 = e3[5], s2 = e3[6], l2 = e3[7], u2 = this.drawingContext, c = this._doFill, d2 = this._doStroke;
        if (c && !d2) {
          if (this._getFill() === m2)
            return this;
        } else if (!c && d2 && this._getStroke() === m2)
          return this;
        if (u2.beginPath(), i2 === void 0)
          u2.rect(t3, r3, n3, o3);
        else {
          a3 === void 0 && (a3 = i2), s2 === void 0 && (s2 = a3), l2 === void 0 && (l2 = s2);
          var f2 = Math.abs(n3), h2 = Math.abs(o3), p3 = f2 / 2, y = h2 / 2;
          f2 < 2 * i2 && (i2 = p3), h2 < 2 * i2 && (i2 = y), f2 < 2 * a3 && (a3 = p3), h2 < 2 * a3 && (a3 = y), f2 < 2 * s2 && (s2 = p3), h2 < 2 * s2 && (s2 = y), f2 < 2 * l2 && (l2 = p3), h2 < 2 * l2 && (l2 = y), u2.beginPath(), u2.moveTo(t3 + i2, r3), u2.arcTo(t3 + n3, r3, t3 + n3, r3 + o3, a3), u2.arcTo(t3 + n3, r3 + o3, t3, r3 + o3, s2), u2.arcTo(t3, r3 + o3, t3, r3, l2), u2.arcTo(t3, r3, t3 + n3, r3, i2), u2.closePath();
        }
        return this._doFill && u2.fill(), this._doStroke && u2.stroke(), this;
      }, d.default.Renderer2D.prototype.triangle = function(e3) {
        var t3 = this.drawingContext, r3 = this._doFill, n3 = this._doStroke, o3 = e3[0], i2 = e3[1], a3 = e3[2], s2 = e3[3], l2 = e3[4], u2 = e3[5];
        if (r3 && !n3) {
          if (this._getFill() === m2)
            return this;
        } else if (!r3 && n3 && this._getStroke() === m2)
          return this;
        t3.beginPath(), t3.moveTo(o3, i2), t3.lineTo(a3, s2), t3.lineTo(l2, u2), t3.closePath(), r3 && t3.fill(), n3 && t3.stroke();
      }, d.default.Renderer2D.prototype.endShape = function(e3, t3, r3, n3, o3, i2, a3) {
        if (t3.length === 0)
          return this;
        if (!this._doStroke && !this._doFill)
          return this;
        var s2, l2, u2, c = e3 === p2.CLOSE;
        c && !i2 && t3.push(t3[0]);
        var d2 = t3.length;
        if (!r3 || a3 !== p2.POLYGON && a3 !== null)
          if (!n3 || a3 !== p2.POLYGON && a3 !== null)
            if (!o3 || a3 !== p2.POLYGON && a3 !== null)
              if (a3 === p2.POINTS)
                for (l2 = 0; l2 < d2; l2++)
                  s2 = t3[l2], this._doStroke && this._pInst.stroke(s2[6]), this._pInst.point(s2[0], s2[1]);
              else if (a3 === p2.LINES)
                for (l2 = 0; l2 + 1 < d2; l2 += 2)
                  s2 = t3[l2], this._doStroke && this._pInst.stroke(t3[l2 + 1][6]), this._pInst.line(s2[0], s2[1], t3[l2 + 1][0], t3[l2 + 1][1]);
              else if (a3 === p2.TRIANGLES)
                for (l2 = 0; l2 + 2 < d2; l2 += 3)
                  s2 = t3[l2], this.drawingContext.beginPath(), this.drawingContext.moveTo(s2[0], s2[1]), this.drawingContext.lineTo(t3[l2 + 1][0], t3[l2 + 1][1]), this.drawingContext.lineTo(t3[l2 + 2][0], t3[l2 + 2][1]), this.drawingContext.closePath(), this._doFill && (this._pInst.fill(t3[l2 + 2][5]), this.drawingContext.fill()), this._doStroke && (this._pInst.stroke(t3[l2 + 2][6]), this.drawingContext.stroke());
              else if (a3 === p2.TRIANGLE_STRIP)
                for (l2 = 0; l2 + 1 < d2; l2++)
                  s2 = t3[l2], this.drawingContext.beginPath(), this.drawingContext.moveTo(t3[l2 + 1][0], t3[l2 + 1][1]), this.drawingContext.lineTo(s2[0], s2[1]), this._doStroke && this._pInst.stroke(t3[l2 + 1][6]), this._doFill && this._pInst.fill(t3[l2 + 1][5]), l2 + 2 < d2 && (this.drawingContext.lineTo(t3[l2 + 2][0], t3[l2 + 2][1]), this._doStroke && this._pInst.stroke(t3[l2 + 2][6]), this._doFill && this._pInst.fill(t3[l2 + 2][5])), this._doFillStrokeClose(c);
              else if (a3 === p2.TRIANGLE_FAN) {
                if (2 < d2) {
                  for (this.drawingContext.beginPath(), l2 = 2; l2 < d2; l2++)
                    s2 = t3[l2], this.drawingContext.moveTo(t3[0][0], t3[0][1]), this.drawingContext.lineTo(t3[l2 - 1][0], t3[l2 - 1][1]), this.drawingContext.lineTo(s2[0], s2[1]), this.drawingContext.lineTo(t3[0][0], t3[0][1]), l2 < d2 - 1 && (this._doFill && s2[5] !== t3[l2 + 1][5] || this._doStroke && s2[6] !== t3[l2 + 1][6]) && (this._doFill && (this._pInst.fill(s2[5]), this.drawingContext.fill(), this._pInst.fill(t3[l2 + 1][5])), this._doStroke && (this._pInst.stroke(s2[6]), this.drawingContext.stroke(), this._pInst.stroke(t3[l2 + 1][6])), this.drawingContext.closePath(), this.drawingContext.beginPath());
                  this._doFillStrokeClose(c);
                }
              } else if (a3 === p2.QUADS)
                for (l2 = 0; l2 + 3 < d2; l2 += 4) {
                  for (s2 = t3[l2], this.drawingContext.beginPath(), this.drawingContext.moveTo(s2[0], s2[1]), u2 = 1; u2 < 4; u2++)
                    this.drawingContext.lineTo(t3[l2 + u2][0], t3[l2 + u2][1]);
                  this.drawingContext.lineTo(s2[0], s2[1]), this._doFill && this._pInst.fill(t3[l2 + 3][5]), this._doStroke && this._pInst.stroke(t3[l2 + 3][6]), this._doFillStrokeClose(c);
                }
              else if (a3 === p2.QUAD_STRIP) {
                if (3 < d2)
                  for (l2 = 0; l2 + 1 < d2; l2 += 2)
                    s2 = t3[l2], this.drawingContext.beginPath(), l2 + 3 < d2 ? (this.drawingContext.moveTo(t3[l2 + 2][0], t3[l2 + 2][1]), this.drawingContext.lineTo(s2[0], s2[1]), this.drawingContext.lineTo(t3[l2 + 1][0], t3[l2 + 1][1]), this.drawingContext.lineTo(t3[l2 + 3][0], t3[l2 + 3][1]), this._doFill && this._pInst.fill(t3[l2 + 3][5]), this._doStroke && this._pInst.stroke(t3[l2 + 3][6])) : (this.drawingContext.moveTo(s2[0], s2[1]), this.drawingContext.lineTo(t3[l2 + 1][0], t3[l2 + 1][1])), this._doFillStrokeClose(c);
              } else {
                for (this.drawingContext.beginPath(), this.drawingContext.moveTo(t3[0][0], t3[0][1]), l2 = 1; l2 < d2; l2++)
                  (s2 = t3[l2]).isVert && (s2.moveTo ? this.drawingContext.moveTo(s2[0], s2[1]) : this.drawingContext.lineTo(s2[0], s2[1]));
                this._doFillStrokeClose(c);
              }
            else {
              for (this.drawingContext.beginPath(), l2 = 0; l2 < d2; l2++)
                t3[l2].isVert ? t3[l2].moveTo ? this.drawingContext.moveTo(t3[l2][0], t3[l2][1]) : this.drawingContext.lineTo(t3[l2][0], t3[l2][1]) : this.drawingContext.quadraticCurveTo(t3[l2][0], t3[l2][1], t3[l2][2], t3[l2][3]);
              this._doFillStrokeClose(c);
            }
          else {
            for (this.drawingContext.beginPath(), l2 = 0; l2 < d2; l2++)
              t3[l2].isVert ? t3[l2].moveTo ? this.drawingContext.moveTo(t3[l2][0], t3[l2][1]) : this.drawingContext.lineTo(t3[l2][0], t3[l2][1]) : this.drawingContext.bezierCurveTo(t3[l2][0], t3[l2][1], t3[l2][2], t3[l2][3], t3[l2][4], t3[l2][5]);
            this._doFillStrokeClose(c);
          }
        else if (3 < d2) {
          var f2 = [], h2 = 1 - this._curveTightness;
          for (this.drawingContext.beginPath(), this.drawingContext.moveTo(t3[1][0], t3[1][1]), l2 = 1; l2 + 2 < d2; l2++)
            s2 = t3[l2], f2[0] = [s2[0], s2[1]], f2[1] = [s2[0] + (h2 * t3[l2 + 1][0] - h2 * t3[l2 - 1][0]) / 6, s2[1] + (h2 * t3[l2 + 1][1] - h2 * t3[l2 - 1][1]) / 6], f2[2] = [t3[l2 + 1][0] + (h2 * t3[l2][0] - h2 * t3[l2 + 2][0]) / 6, t3[l2 + 1][1] + (h2 * t3[l2][1] - h2 * t3[l2 + 2][1]) / 6], f2[3] = [t3[l2 + 1][0], t3[l2 + 1][1]], this.drawingContext.bezierCurveTo(f2[1][0], f2[1][1], f2[2][0], f2[2][1], f2[3][0], f2[3][1]);
          c && this.drawingContext.lineTo(t3[l2 + 1][0], t3[l2 + 1][1]), this._doFillStrokeClose(c);
        }
        return i2 = o3 = n3 = r3 = false, c && t3.pop(), this;
      }, d.default.Renderer2D.prototype.strokeCap = function(e3) {
        return e3 !== p2.ROUND && e3 !== p2.SQUARE && e3 !== p2.PROJECT || (this.drawingContext.lineCap = e3), this;
      }, d.default.Renderer2D.prototype.strokeJoin = function(e3) {
        return e3 !== p2.ROUND && e3 !== p2.BEVEL && e3 !== p2.MITER || (this.drawingContext.lineJoin = e3), this;
      }, d.default.Renderer2D.prototype.strokeWeight = function(e3) {
        return this.drawingContext.lineWidth = e3 === void 0 || e3 === 0 ? 1e-4 : e3, this;
      }, d.default.Renderer2D.prototype._getFill = function() {
        return this._cachedFillStyle || (this._cachedFillStyle = this.drawingContext.fillStyle), this._cachedFillStyle;
      }, d.default.Renderer2D.prototype._setFill = function(e3) {
        e3 !== this._cachedFillStyle && (this.drawingContext.fillStyle = e3, this._cachedFillStyle = e3);
      }, d.default.Renderer2D.prototype._getStroke = function() {
        return this._cachedStrokeStyle || (this._cachedStrokeStyle = this.drawingContext.strokeStyle), this._cachedStrokeStyle;
      }, d.default.Renderer2D.prototype._setStroke = function(e3) {
        e3 !== this._cachedStrokeStyle && (this.drawingContext.strokeStyle = e3, this._cachedStrokeStyle = e3);
      }, d.default.Renderer2D.prototype.bezier = function(e3, t3, r3, n3, o3, i2, a3, s2) {
        return this._pInst.beginShape(), this._pInst.vertex(e3, t3), this._pInst.bezierVertex(r3, n3, o3, i2, a3, s2), this._pInst.endShape(), this;
      }, d.default.Renderer2D.prototype.curve = function(e3, t3, r3, n3, o3, i2, a3, s2) {
        return this._pInst.beginShape(), this._pInst.curveVertex(e3, t3), this._pInst.curveVertex(r3, n3), this._pInst.curveVertex(o3, i2), this._pInst.curveVertex(a3, s2), this._pInst.endShape(), this;
      }, d.default.Renderer2D.prototype._doFillStrokeClose = function(e3) {
        e3 && this.drawingContext.closePath(), this._doFill && this.drawingContext.fill(), this._doStroke && this.drawingContext.stroke();
      }, d.default.Renderer2D.prototype.applyMatrix = function(e3, t3, r3, n3, o3, i2) {
        this.drawingContext.transform(e3, t3, r3, n3, o3, i2);
      }, d.default.Renderer2D.prototype.resetMatrix = function() {
        return this.drawingContext.setTransform(1, 0, 0, 1, 0, 0), this.drawingContext.scale(this._pInst._pixelDensity, this._pInst._pixelDensity), this;
      }, d.default.Renderer2D.prototype.rotate = function(e3) {
        this.drawingContext.rotate(e3);
      }, d.default.Renderer2D.prototype.scale = function(e3, t3) {
        return this.drawingContext.scale(e3, t3), this;
      }, d.default.Renderer2D.prototype.translate = function(e3, t3) {
        return e3 instanceof d.default.Vector && (t3 = e3.y, e3 = e3.x), this.drawingContext.translate(e3, t3), this;
      }, d.default.Renderer2D.prototype.text = function(e3, t3, r3, n3, o3) {
        var i2;
        n3 !== void 0 && this.drawingContext.textBaseline === p2.BASELINE && (i2 = true, this.drawingContext.textBaseline = p2.TOP);
        var a3 = d.default.Renderer.prototype.text.apply(this, arguments);
        return i2 && (this.drawingContext.textBaseline = p2.BASELINE), a3;
      }, d.default.Renderer2D.prototype._renderText = function(e3, t3, r3, n3, o3) {
        if (!(o3 <= n3))
          return e3.push(), this._isOpenType() ? this._textFont._renderPath(t3, r3, n3, { renderer: this }) : (this._doStroke && this._strokeSet && this.drawingContext.strokeText(t3, r3, n3), this._doFill && (this._fillSet || this._setFill(p2._DEFAULT_TEXT_FILL), this.drawingContext.fillText(t3, r3, n3))), e3.pop(), e3;
      }, d.default.Renderer2D.prototype.textWidth = function(e3) {
        return this._isOpenType() ? this._textFont._textWidth(e3, this._textSize) : this.drawingContext.measureText(e3).width;
      }, d.default.Renderer2D.prototype._applyTextProperties = function() {
        var e3, t3 = this._pInst;
        return this._setProperty("_textAscent", null), this._setProperty("_textDescent", null), e3 = this._textFont, this._isOpenType() && (e3 = this._textFont.font.familyName, this._setProperty("_textStyle", this._textFont.font.styleName)), this.drawingContext.font = "".concat(this._textStyle || "normal", " ").concat(this._textSize || 12, "px ").concat(e3 || "sans-serif"), this.drawingContext.textAlign = this._textAlign, this._textBaseline === p2.CENTER ? this.drawingContext.textBaseline = p2._CTX_MIDDLE : this.drawingContext.textBaseline = this._textBaseline, t3;
      }, d.default.Renderer2D.prototype.push = function() {
        return this.drawingContext.save(), d.default.Renderer.prototype.push.apply(this);
      }, d.default.Renderer2D.prototype.pop = function(e3) {
        this.drawingContext.restore(), this._cachedFillStyle = this.drawingContext.fillStyle, this._cachedStrokeStyle = this.drawingContext.strokeStyle, d.default.Renderer.prototype.pop.call(this, e3);
      };
      var o2 = d.default.Renderer2D;
      r2.default = o2;
    }, { "../image/filters": 285, "./constants": 253, "./main": 264, "./p5.Renderer": 267, "core-js/modules/es.array.concat": 149, "core-js/modules/es.array.fill": 151, "core-js/modules/es.array.for-each": 154, "core-js/modules/es.array.slice": 162, "core-js/modules/es.function.name": 166, "core-js/modules/es.number.to-fixed": 172, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.regexp.to-string": 182 }], 269: [function(e2, t2, r2) {
      e2("core-js/modules/es.symbol"), e2("core-js/modules/es.symbol.description"), e2("core-js/modules/es.symbol.iterator"), e2("core-js/modules/es.array.iterator"), e2("core-js/modules/es.object.assign"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.promise"), e2("core-js/modules/es.string.iterator"), e2("core-js/modules/web.dom-collections.iterator");
      var n2, f = (n2 = e2("./main")) && n2.__esModule ? n2 : { default: n2 };
      f.default.prototype._promisePreloads = [];
      var h2 = !(f.default.prototype.registerPromisePreload = function(e3) {
        f.default.prototype._promisePreloads.push(e3);
      });
      f.default.prototype._setupPromisePreloads = function() {
        var e3 = true, t3 = false, r3 = void 0;
        try {
          for (var n3, o2 = this._promisePreloads[Symbol.iterator](); !(e3 = (n3 = o2.next()).done); e3 = true) {
            var i3 = n3.value, a2 = this, s = i3.method, l2 = i3.addCallbacks, u2 = i3.legacyPreloadSetup, c = i3.target || this, d = c[s].bind(c);
            if (c === f.default.prototype) {
              if (h2)
                continue;
              a2 = null, d = c[s];
            }
            if (c[s] = this._wrapPromisePreload(a2, d, l2), u2)
              c[u2.method] = this._legacyPreloadGenerator(a2, u2, c[s]);
          }
        } catch (e4) {
          t3 = true, r3 = e4;
        } finally {
          try {
            e3 || o2.return == null || o2.return();
          } finally {
            if (t3)
              throw r3;
          }
        }
        h2 = true;
      }, f.default.prototype._wrapPromisePreload = function(e3, l2, u2) {
        var t3 = function() {
          var e4 = this;
          this._incrementPreload();
          for (var t4 = null, r3 = null, n3 = arguments.length, o2 = new Array(n3), i3 = 0; i3 < n3; i3++)
            o2[i3] = arguments[i3];
          if (u2)
            for (var a2 = o2.length - 1; 0 <= a2 && !r3 && typeof o2[a2] == "function"; a2--)
              r3 = t4, t4 = o2.pop();
          var s = Promise.resolve(l2.apply(this, o2));
          return t4 && s.then(t4), r3 && s.catch(r3), s.then(function() {
            return e4._decrementPreload();
          }), s;
        };
        return e3 && (t3 = t3.bind(e3)), t3;
      };
      function i2() {
        return {};
      }
      f.default.prototype._legacyPreloadGenerator = function(e3, t3, n3) {
        var o2 = t3.createBaseObject || i2, r3 = function() {
          var t4 = this;
          this._incrementPreload();
          var r4 = o2.apply(this, arguments);
          return n3.apply(this, arguments).then(function(e4) {
            Object.assign(r4, e4), t4._decrementPreload();
          }), r4;
        };
        return e3 && (r3 = r3.bind(e3)), r3;
      };
    }, { "./main": 264, "core-js/modules/es.array.iterator": 158, "core-js/modules/es.object.assign": 173, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.promise": 178, "core-js/modules/es.string.iterator": 186, "core-js/modules/es.symbol": 196, "core-js/modules/es.symbol.description": 194, "core-js/modules/es.symbol.iterator": 195, "core-js/modules/web.dom-collections.iterator": 229 }], 270: [function(e2, t2, r2) {
      e2("core-js/modules/es.symbol"), e2("core-js/modules/es.symbol.description"), e2("core-js/modules/es.symbol.iterator"), e2("core-js/modules/es.array.filter"), e2("core-js/modules/es.array.iterator"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.string.iterator"), e2("core-js/modules/web.dom-collections.iterator"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, l2 = (n2 = e2("./main")) && n2.__esModule ? n2 : { default: n2 }, u2 = function(e3) {
        if (e3 && e3.__esModule)
          return e3;
        if (e3 === null || s(e3) !== "object" && typeof e3 != "function")
          return { default: e3 };
        var t3 = a2();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o3 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o3)) {
            var i2 = n3 ? Object.getOwnPropertyDescriptor(e3, o3) : null;
            i2 && (i2.get || i2.set) ? Object.defineProperty(r3, o3, i2) : r3[o3] = e3[o3];
          }
        r3.default = e3, t3 && t3.set(e3, r3);
        return r3;
      }(e2("./constants"));
      function a2() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return a2 = function() {
          return e3;
        }, e3;
      }
      function s(e3) {
        return (s = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      e2("./p5.Graphics"), e2("./p5.Renderer2D"), e2("../webgl/p5.RendererGL");
      var c = "defaultCanvas0";
      l2.default.prototype.createCanvas = function(e3, t3, r3) {
        l2.default._validateParameters("createCanvas", arguments);
        var n3, o3 = r3 || u2.P2D;
        if (o3 === u2.WEBGL) {
          if (n3 = document.getElementById(c)) {
            n3.parentNode.removeChild(n3);
            var i2 = this._renderer;
            this._elements = this._elements.filter(function(e4) {
              return e4 !== i2;
            });
          }
          (n3 = document.createElement("canvas")).id = c, n3.classList.add("p5Canvas");
        } else if (this._defaultGraphicsCreated)
          n3 = this.canvas;
        else {
          n3 = document.createElement("canvas");
          for (var a3 = 0; document.getElementById("defaultCanvas".concat(a3)); )
            a3++;
          c = "defaultCanvas".concat(a3), n3.id = c, n3.classList.add("p5Canvas");
        }
        if (this._setupDone || (n3.dataset.hidden = true, n3.style.visibility = "hidden"), this._userNode)
          this._userNode.appendChild(n3);
        else {
          if (document.getElementsByTagName("main").length === 0) {
            var s2 = document.createElement("main");
            document.body.appendChild(s2);
          }
          document.getElementsByTagName("main")[0].appendChild(n3);
        }
        return o3 === u2.WEBGL ? (this._setProperty("_renderer", new l2.default.RendererGL(n3, this, true)), this._elements.push(this._renderer)) : this._defaultGraphicsCreated || (this._setProperty("_renderer", new l2.default.Renderer2D(n3, this, true)), this._defaultGraphicsCreated = true, this._elements.push(this._renderer)), this._renderer.resize(e3, t3), this._renderer._applyDefaults(), this._renderer;
      }, l2.default.prototype.resizeCanvas = function(e3, t3, r3) {
        if (l2.default._validateParameters("resizeCanvas", arguments), this._renderer) {
          var n3 = {};
          for (var o3 in this.drawingContext) {
            var i2 = this.drawingContext[o3];
            s(i2) !== "object" && typeof i2 != "function" && (n3[o3] = i2);
          }
          for (var a3 in this._renderer.resize(e3, t3), this.width = e3, this.height = t3, n3)
            try {
              this.drawingContext[a3] = n3[a3];
            } catch (e4) {
            }
          r3 || this.redraw();
        }
        this._addAccsOutput() && this._updateAccsOutput();
      }, l2.default.prototype.noCanvas = function() {
        this.canvas && this.canvas.parentNode.removeChild(this.canvas);
      }, l2.default.prototype.createGraphics = function(e3, t3, r3) {
        return l2.default._validateParameters("createGraphics", arguments), new l2.default.Graphics(e3, t3, r3, this);
      }, l2.default.prototype.blendMode = function(e3) {
        l2.default._validateParameters("blendMode", arguments), e3 === u2.NORMAL && (console.warn("NORMAL has been deprecated for use in blendMode. defaulting to BLEND instead."), e3 = u2.BLEND), this._renderer.blendMode(e3);
      };
      var o2 = l2.default;
      r2.default = o2;
    }, { "../webgl/p5.RendererGL": 318, "./constants": 253, "./main": 264, "./p5.Graphics": 266, "./p5.Renderer2D": 268, "core-js/modules/es.array.filter": 152, "core-js/modules/es.array.iterator": 158, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.string.iterator": 186, "core-js/modules/es.symbol": 196, "core-js/modules/es.symbol.description": 194, "core-js/modules/es.symbol.iterator": 195, "core-js/modules/web.dom-collections.iterator": 229 }], 271: [function(e2, t2, r2) {
      function a2(e3) {
        return (a2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      e2("core-js/modules/es.array.slice"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var c = n2(e2("../main")), s = function(e3) {
        if (e3 && e3.__esModule)
          return e3;
        if (e3 === null || a2(e3) !== "object" && typeof e3 != "function")
          return { default: e3 };
        var t3 = l2();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o3 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o3)) {
            var i2 = n3 ? Object.getOwnPropertyDescriptor(e3, o3) : null;
            i2 && (i2.get || i2.set) ? Object.defineProperty(r3, o3, i2) : r3[o3] = e3[o3];
          }
        r3.default = e3, t3 && t3.set(e3, r3);
        return r3;
      }(e2("../constants")), d = n2(e2("../helpers"));
      function l2() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return l2 = function() {
          return e3;
        }, e3;
      }
      function n2(e3) {
        return e3 && e3.__esModule ? e3 : { default: e3 };
      }
      e2("../friendly_errors/fes_core"), e2("../friendly_errors/file_errors"), e2("../friendly_errors/validate_params"), c.default.prototype._normalizeArcAngles = function(e3, t3, r3, n3, o3) {
        var i2;
        return e3 -= s.TWO_PI * Math.floor(e3 / s.TWO_PI), t3 -= s.TWO_PI * Math.floor(t3 / s.TWO_PI), i2 = Math.min(Math.abs(e3 - t3), s.TWO_PI - Math.abs(e3 - t3)), o3 && (e3 = e3 <= s.HALF_PI ? Math.atan(r3 / n3 * Math.tan(e3)) : e3 > s.HALF_PI && e3 <= 3 * s.HALF_PI ? Math.atan(r3 / n3 * Math.tan(e3)) + s.PI : Math.atan(r3 / n3 * Math.tan(e3)) + s.TWO_PI, t3 = t3 <= s.HALF_PI ? Math.atan(r3 / n3 * Math.tan(t3)) : t3 > s.HALF_PI && t3 <= 3 * s.HALF_PI ? Math.atan(r3 / n3 * Math.tan(t3)) + s.PI : Math.atan(r3 / n3 * Math.tan(t3)) + s.TWO_PI), t3 < e3 && (t3 += s.TWO_PI), { start: e3, stop: t3, correspondToSamePoint: i2 < 1e-5 };
      }, c.default.prototype.arc = function(e3, t3, r3, n3, o3, i2, a3, s2) {
        if (c.default._validateParameters("arc", arguments), !this._renderer._doStroke && !this._renderer._doFill)
          return this;
        if (o3 === i2)
          return this;
        o3 = this._toRadians(o3), i2 = this._toRadians(i2), r3 = Math.abs(r3), n3 = Math.abs(n3);
        var l3 = d.default.modeAdjust(e3, t3, r3, n3, this._renderer._ellipseMode), u2 = this._normalizeArcAngles(o3, i2, l3.w, l3.h, true);
        return u2.correspondToSamePoint ? this._renderer.ellipse([l3.x, l3.y, l3.w, l3.h, s2]) : (this._renderer.arc(l3.x, l3.y, l3.w, l3.h, u2.start, u2.stop, a3, s2), (this._accessibleOutputs.grid || this._accessibleOutputs.text) && this._accsOutput("arc", [l3.x, l3.y, l3.w, l3.h, u2.start, u2.stop, a3])), this;
      }, c.default.prototype.ellipse = function(e3, t3, r3, n3, o3) {
        return c.default._validateParameters("ellipse", arguments), this._renderEllipse.apply(this, arguments);
      }, c.default.prototype.circle = function() {
        c.default._validateParameters("circle", arguments);
        var e3 = Array.prototype.slice.call(arguments, 0, 2);
        return e3.push(arguments[2]), e3.push(arguments[2]), this._renderEllipse.apply(this, e3);
      }, c.default.prototype._renderEllipse = function(e3, t3, r3, n3, o3) {
        if (!this._renderer._doStroke && !this._renderer._doFill)
          return this;
        r3 < 0 && (r3 = Math.abs(r3)), n3 === void 0 ? n3 = r3 : n3 < 0 && (n3 = Math.abs(n3));
        var i2 = d.default.modeAdjust(e3, t3, r3, n3, this._renderer._ellipseMode);
        return this._renderer.ellipse([i2.x, i2.y, i2.w, i2.h, o3]), (this._accessibleOutputs.grid || this._accessibleOutputs.text) && this._accsOutput("ellipse", [i2.x, i2.y, i2.w, i2.h]), this;
      }, c.default.prototype.line = function() {
        for (var e3 = arguments.length, t3 = new Array(e3), r3 = 0; r3 < e3; r3++)
          t3[r3] = arguments[r3];
        var n3;
        c.default._validateParameters("line", t3), this._renderer._doStroke && (n3 = this._renderer).line.apply(n3, t3);
        return (this._accessibleOutputs.grid || this._accessibleOutputs.text) && this._accsOutput("line", t3), this;
      }, c.default.prototype.point = function() {
        for (var e3 = arguments.length, t3 = new Array(e3), r3 = 0; r3 < e3; r3++)
          t3[r3] = arguments[r3];
        var n3;
        c.default._validateParameters("point", t3), this._renderer._doStroke && (t3.length === 1 && t3[0] instanceof c.default.Vector ? this._renderer.point.call(this._renderer, t3[0].x, t3[0].y, t3[0].z) : ((n3 = this._renderer).point.apply(n3, t3), (this._accessibleOutputs.grid || this._accessibleOutputs.text) && this._accsOutput("point", t3)));
        return this;
      }, c.default.prototype.quad = function() {
        for (var e3 = arguments.length, t3 = new Array(e3), r3 = 0; r3 < e3; r3++)
          t3[r3] = arguments[r3];
        var n3;
        c.default._validateParameters("quad", t3), (this._renderer._doStroke || this._renderer._doFill) && (this._renderer.isP3D && t3.length <= 12 ? this._renderer.quad.call(this._renderer, t3[0], t3[1], 0, t3[2], t3[3], 0, t3[4], t3[5], 0, t3[6], t3[7], 0, t3[8], t3[9]) : ((n3 = this._renderer).quad.apply(n3, t3), (this._accessibleOutputs.grid || this._accessibleOutputs.text) && this._accsOutput("quadrilateral", t3)));
        return this;
      }, c.default.prototype.rect = function() {
        return c.default._validateParameters("rect", arguments), this._renderRect.apply(this, arguments);
      }, c.default.prototype.square = function(e3, t3, r3, n3, o3, i2, a3) {
        return c.default._validateParameters("square", arguments), this._renderRect.call(this, e3, t3, r3, r3, n3, o3, i2, a3);
      }, c.default.prototype._renderRect = function() {
        if (this._renderer._doStroke || this._renderer._doFill) {
          arguments.length === 3 && (arguments[3] = arguments[2]);
          for (var e3 = d.default.modeAdjust(arguments[0], arguments[1], arguments[2], arguments[3], this._renderer._rectMode), t3 = [e3.x, e3.y, e3.w, e3.h], r3 = 4; r3 < arguments.length; r3++)
            t3[r3] = arguments[r3];
          this._renderer.rect(t3), (this._accessibleOutputs.grid || this._accessibleOutputs.text) && this._accsOutput("rectangle", [e3.x, e3.y, e3.w, e3.h]);
        }
        return this;
      }, c.default.prototype.triangle = function() {
        for (var e3 = arguments.length, t3 = new Array(e3), r3 = 0; r3 < e3; r3++)
          t3[r3] = arguments[r3];
        return c.default._validateParameters("triangle", t3), (this._renderer._doStroke || this._renderer._doFill) && this._renderer.triangle(t3), (this._accessibleOutputs.grid || this._accessibleOutputs.text) && this._accsOutput("triangle", t3), this;
      };
      var o2 = c.default;
      r2.default = o2;
    }, { "../constants": 253, "../friendly_errors/fes_core": 255, "../friendly_errors/file_errors": 256, "../friendly_errors/validate_params": 259, "../helpers": 260, "../main": 264, "core-js/modules/es.array.slice": 162 }], 272: [function(e2, t2, r2) {
      function a2(e3) {
        return (a2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, o2 = (n2 = e2("../main")) && n2.__esModule ? n2 : { default: n2 }, i2 = function(e3) {
        if (e3 && e3.__esModule)
          return e3;
        if (e3 === null || a2(e3) !== "object" && typeof e3 != "function")
          return { default: e3 };
        var t3 = s();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o3 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o3)) {
            var i3 = n3 ? Object.getOwnPropertyDescriptor(e3, o3) : null;
            i3 && (i3.get || i3.set) ? Object.defineProperty(r3, o3, i3) : r3[o3] = e3[o3];
          }
        r3.default = e3, t3 && t3.set(e3, r3);
        return r3;
      }(e2("../constants"));
      function s() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return s = function() {
          return e3;
        }, e3;
      }
      o2.default.prototype.ellipseMode = function(e3) {
        return o2.default._validateParameters("ellipseMode", arguments), e3 !== i2.CORNER && e3 !== i2.CORNERS && e3 !== i2.RADIUS && e3 !== i2.CENTER || (this._renderer._ellipseMode = e3), this;
      }, o2.default.prototype.noSmooth = function() {
        return this.setAttributes("antialias", false), this._renderer.isP3D || "imageSmoothingEnabled" in this.drawingContext && (this.drawingContext.imageSmoothingEnabled = false), this;
      }, o2.default.prototype.rectMode = function(e3) {
        return o2.default._validateParameters("rectMode", arguments), e3 !== i2.CORNER && e3 !== i2.CORNERS && e3 !== i2.RADIUS && e3 !== i2.CENTER || (this._renderer._rectMode = e3), this;
      }, o2.default.prototype.smooth = function() {
        return this.setAttributes("antialias", true), this._renderer.isP3D || "imageSmoothingEnabled" in this.drawingContext && (this.drawingContext.imageSmoothingEnabled = true), this;
      }, o2.default.prototype.strokeCap = function(e3) {
        return o2.default._validateParameters("strokeCap", arguments), e3 !== i2.ROUND && e3 !== i2.SQUARE && e3 !== i2.PROJECT || this._renderer.strokeCap(e3), this;
      }, o2.default.prototype.strokeJoin = function(e3) {
        return o2.default._validateParameters("strokeJoin", arguments), e3 !== i2.ROUND && e3 !== i2.BEVEL && e3 !== i2.MITER || this._renderer.strokeJoin(e3), this;
      }, o2.default.prototype.strokeWeight = function(e3) {
        return o2.default._validateParameters("strokeWeight", arguments), this._renderer.strokeWeight(e3), this;
      };
      var l2 = o2.default;
      r2.default = l2;
    }, { "../constants": 253, "../main": 264 }], 273: [function(e2, t2, r2) {
      Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, s = (n2 = e2("../main")) && n2.__esModule ? n2 : { default: n2 };
      e2("../friendly_errors/fes_core"), e2("../friendly_errors/file_errors"), e2("../friendly_errors/validate_params"), s.default.prototype.bezier = function() {
        for (var e3, t3 = arguments.length, r3 = new Array(t3), n3 = 0; n3 < t3; n3++)
          r3[n3] = arguments[n3];
        return s.default._validateParameters("bezier", r3), (this._renderer._doStroke || this._renderer._doFill) && (e3 = this._renderer).bezier.apply(e3, r3), this;
      }, s.default.prototype.bezierDetail = function(e3) {
        return s.default._validateParameters("bezierDetail", arguments), this._bezierDetail = e3, this;
      }, s.default.prototype.bezierPoint = function(e3, t3, r3, n3, o3) {
        s.default._validateParameters("bezierPoint", arguments);
        var i2 = 1 - o3;
        return Math.pow(i2, 3) * e3 + 3 * Math.pow(i2, 2) * o3 * t3 + 3 * i2 * Math.pow(o3, 2) * r3 + Math.pow(o3, 3) * n3;
      }, s.default.prototype.bezierTangent = function(e3, t3, r3, n3, o3) {
        s.default._validateParameters("bezierTangent", arguments);
        var i2 = 1 - o3;
        return 3 * n3 * Math.pow(o3, 2) - 3 * r3 * Math.pow(o3, 2) + 6 * r3 * i2 * o3 - 6 * t3 * i2 * o3 + 3 * t3 * Math.pow(i2, 2) - 3 * e3 * Math.pow(i2, 2);
      }, s.default.prototype.curve = function() {
        for (var e3 = arguments.length, t3 = new Array(e3), r3 = 0; r3 < e3; r3++)
          t3[r3] = arguments[r3];
        var n3;
        s.default._validateParameters("curve", t3), this._renderer._doStroke && (n3 = this._renderer).curve.apply(n3, t3);
        return this;
      }, s.default.prototype.curveDetail = function(e3) {
        return s.default._validateParameters("curveDetail", arguments), this._curveDetail = e3 < 3 ? 3 : e3, this;
      }, s.default.prototype.curveTightness = function(e3) {
        return s.default._validateParameters("curveTightness", arguments), this._renderer._curveTightness = e3, this;
      }, s.default.prototype.curvePoint = function(e3, t3, r3, n3, o3) {
        s.default._validateParameters("curvePoint", arguments);
        var i2 = o3 * o3 * o3, a2 = o3 * o3;
        return e3 * (-0.5 * i2 + a2 - 0.5 * o3) + t3 * (1.5 * i2 - 2.5 * a2 + 1) + r3 * (-1.5 * i2 + 2 * a2 + 0.5 * o3) + n3 * (0.5 * i2 - 0.5 * a2);
      }, s.default.prototype.curveTangent = function(e3, t3, r3, n3, o3) {
        s.default._validateParameters("curveTangent", arguments);
        var i2 = o3 * o3;
        return e3 * (-3 * i2 / 2 + 2 * o3 - 0.5) + t3 * (9 * i2 / 2 - 5 * o3) + r3 * (-9 * i2 / 2 + 4 * o3 + 0.5) + n3 * (3 * i2 / 2 - o3);
      };
      var o2 = s.default;
      r2.default = o2;
    }, { "../friendly_errors/fes_core": 255, "../friendly_errors/file_errors": 256, "../friendly_errors/validate_params": 259, "../main": 264 }], 274: [function(e2, t2, r2) {
      function a2(e3) {
        return (a2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      e2("core-js/modules/es.array.slice"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, s = (n2 = e2("../main")) && n2.__esModule ? n2 : { default: n2 }, l2 = function(e3) {
        if (e3 && e3.__esModule)
          return e3;
        if (e3 === null || a2(e3) !== "object" && typeof e3 != "function")
          return { default: e3 };
        var t3 = u2();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o3 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o3)) {
            var i3 = n3 ? Object.getOwnPropertyDescriptor(e3, o3) : null;
            i3 && (i3.get || i3.set) ? Object.defineProperty(r3, o3, i3) : r3[o3] = e3[o3];
          }
        r3.default = e3, t3 && t3.set(e3, r3);
        return r3;
      }(e2("../constants"));
      function u2() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return u2 = function() {
          return e3;
        }, e3;
      }
      var o2 = null, c = [], d = [], f = false, i2 = false, h2 = false, p2 = false, y = true;
      s.default.prototype.beginContour = function() {
        return d = [], p2 = true, this;
      }, s.default.prototype.beginShape = function(e3) {
        var t3;
        (s.default._validateParameters("beginShape", arguments), this._renderer.isP3D) ? (t3 = this._renderer).beginShape.apply(t3, arguments) : (o2 = e3 === l2.POINTS || e3 === l2.LINES || e3 === l2.TRIANGLES || e3 === l2.TRIANGLE_FAN || e3 === l2.TRIANGLE_STRIP || e3 === l2.QUADS || e3 === l2.QUAD_STRIP ? e3 : null, c = [], d = []);
        return this;
      }, s.default.prototype.bezierVertex = function() {
        for (var e3 = arguments.length, t3 = new Array(e3), r3 = 0; r3 < e3; r3++)
          t3[r3] = arguments[r3];
        var n3;
        if (s.default._validateParameters("bezierVertex", t3), this._renderer.isP3D)
          (n3 = this._renderer).bezierVertex.apply(n3, t3);
        else if (c.length === 0)
          s.default._friendlyError("vertex() must be used once before calling bezierVertex()", "bezierVertex");
        else {
          f = true;
          for (var o3 = [], i3 = 0; i3 < t3.length; i3++)
            o3[i3] = t3[i3];
          o3.isVert = false, p2 ? d.push(o3) : c.push(o3);
        }
        return this;
      }, s.default.prototype.curveVertex = function() {
        for (var e3 = arguments.length, t3 = new Array(e3), r3 = 0; r3 < e3; r3++)
          t3[r3] = arguments[r3];
        var n3;
        (s.default._validateParameters("curveVertex", t3), this._renderer.isP3D) ? (n3 = this._renderer).curveVertex.apply(n3, t3) : (i2 = true, this.vertex(t3[0], t3[1]));
        return this;
      }, s.default.prototype.endContour = function() {
        var e3 = d[0].slice();
        e3.isVert = d[0].isVert, e3.moveTo = false, d.push(e3), y && (c.push(c[0]), y = false);
        for (var t3 = 0; t3 < d.length; t3++)
          c.push(d[t3]);
        return this;
      }, s.default.prototype.endShape = function(e3) {
        if (s.default._validateParameters("endShape", arguments), this._renderer.isP3D)
          this._renderer.endShape(e3, i2, f, h2, p2, o2);
        else {
          if (c.length === 0)
            return this;
          if (!this._renderer._doStroke && !this._renderer._doFill)
            return this;
          var t3 = e3 === l2.CLOSE;
          t3 && !p2 && c.push(c[0]), this._renderer.endShape(e3, c, i2, f, h2, p2, o2), y = !(p2 = h2 = f = i2 = false), t3 && c.pop();
        }
        return this;
      }, s.default.prototype.quadraticVertex = function() {
        for (var e3 = arguments.length, t3 = new Array(e3), r3 = 0; r3 < e3; r3++)
          t3[r3] = arguments[r3];
        if (s.default._validateParameters("quadraticVertex", t3), this._renderer.isP3D) {
          var n3;
          (n3 = this._renderer).quadraticVertex.apply(n3, t3);
        } else {
          if (this._contourInited) {
            var o3 = {};
            return o3.x = t3[0], o3.y = t3[1], o3.x3 = t3[2], o3.y3 = t3[3], o3.type = l2.QUADRATIC, this._contourVertices.push(o3), this;
          }
          if (0 < c.length) {
            h2 = true;
            for (var i3 = [], a3 = 0; a3 < t3.length; a3++)
              i3[a3] = t3[a3];
            i3.isVert = false, p2 ? d.push(i3) : c.push(i3);
          } else
            s.default._friendlyError("vertex() must be used once before calling quadraticVertex()", "quadraticVertex");
        }
        return this;
      }, s.default.prototype.vertex = function(e3, t3, r3, n3, o3) {
        if (this._renderer.isP3D) {
          var i3;
          (i3 = this._renderer).vertex.apply(i3, arguments);
        } else {
          var a3 = [];
          a3.isVert = true, a3[0] = e3, a3[1] = t3, a3[2] = 0, a3[3] = 0, a3[4] = 0, a3[5] = this._renderer._getFill(), a3[6] = this._renderer._getStroke(), r3 && (a3.moveTo = r3), p2 ? (d.length === 0 && (a3.moveTo = true), d.push(a3)) : c.push(a3);
        }
        return this;
      }, s.default.prototype.normal = function(e3, t3, r3) {
        var n3;
        return this._assert3d("normal"), s.default._validateParameters("normal", arguments), (n3 = this._renderer).normal.apply(n3, arguments), this;
      };
      var m2 = s.default;
      r2.default = m2;
    }, { "../constants": 253, "../main": 264, "core-js/modules/es.array.slice": 162 }], 275: [function(e2, t2, r2) {
      function n2(e3) {
        return (n2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      e2("core-js/modules/es.symbol"), e2("core-js/modules/es.symbol.description"), e2("core-js/modules/es.symbol.iterator"), e2("core-js/modules/es.array.filter"), e2("core-js/modules/es.array.iterator"), e2("core-js/modules/es.array.slice"), e2("core-js/modules/es.object.assign"), e2("core-js/modules/es.object.keys"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.string.iterator"), e2("core-js/modules/es.typed-array.uint8-clamped-array"), e2("core-js/modules/es.typed-array.copy-within"), e2("core-js/modules/es.typed-array.every"), e2("core-js/modules/es.typed-array.fill"), e2("core-js/modules/es.typed-array.filter"), e2("core-js/modules/es.typed-array.find"), e2("core-js/modules/es.typed-array.find-index"), e2("core-js/modules/es.typed-array.for-each"), e2("core-js/modules/es.typed-array.includes"), e2("core-js/modules/es.typed-array.index-of"), e2("core-js/modules/es.typed-array.iterator"), e2("core-js/modules/es.typed-array.join"), e2("core-js/modules/es.typed-array.last-index-of"), e2("core-js/modules/es.typed-array.map"), e2("core-js/modules/es.typed-array.reduce"), e2("core-js/modules/es.typed-array.reduce-right"), e2("core-js/modules/es.typed-array.reverse"), e2("core-js/modules/es.typed-array.set"), e2("core-js/modules/es.typed-array.slice"), e2("core-js/modules/es.typed-array.some"), e2("core-js/modules/es.typed-array.sort"), e2("core-js/modules/es.typed-array.subarray"), e2("core-js/modules/es.typed-array.to-locale-string"), e2("core-js/modules/es.typed-array.to-string"), e2("core-js/modules/web.dom-collections.iterator"), window.requestAnimationFrame = window.requestAnimationFrame || window.webkitRequestAnimationFrame || window.mozRequestAnimationFrame || window.oRequestAnimationFrame || window.msRequestAnimationFrame || function(e3, t3) {
        window.setTimeout(e3, 1e3 / 60);
      }, typeof Uint8ClampedArray == "undefined" || Uint8ClampedArray.prototype.slice || Object.defineProperty(Uint8ClampedArray.prototype, "slice", { value: Array.prototype.slice, writable: true, configurable: true, enumerable: false }), function() {
        if (!Object.assign) {
          var s = Object.keys, e3 = Object.defineProperty, l2 = typeof Symbol == "function" && n2(Symbol()) === "symbol", r3 = Object.prototype.propertyIsEnumerable, u2 = function(t3) {
            return function(e4) {
              return r3.call(t3, e4);
            };
          };
          e3(Object, "assign", { value: function(e4, t3) {
            if (e4 == null)
              throw new TypeError("target must be an object");
            var r4, n3, o2, i2, a2 = Object(e4);
            for (r4 = 1; r4 < arguments.length; ++r4)
              for (n3 = Object(arguments[r4]), i2 = s(n3), l2 && Object.getOwnPropertySymbols && i2.push.apply(i2, Object.getOwnPropertySymbols(n3).filter(u2(n3))), o2 = 0; o2 < i2.length; ++o2)
                a2[i2[o2]] = n3[i2[o2]];
            return a2;
          }, configurable: true, enumerable: false, writable: true });
        }
      }();
    }, { "core-js/modules/es.array.filter": 152, "core-js/modules/es.array.iterator": 158, "core-js/modules/es.array.slice": 162, "core-js/modules/es.object.assign": 173, "core-js/modules/es.object.keys": 176, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.string.iterator": 186, "core-js/modules/es.symbol": 196, "core-js/modules/es.symbol.description": 194, "core-js/modules/es.symbol.iterator": 195, "core-js/modules/es.typed-array.copy-within": 197, "core-js/modules/es.typed-array.every": 198, "core-js/modules/es.typed-array.fill": 199, "core-js/modules/es.typed-array.filter": 200, "core-js/modules/es.typed-array.find": 202, "core-js/modules/es.typed-array.find-index": 201, "core-js/modules/es.typed-array.for-each": 205, "core-js/modules/es.typed-array.includes": 206, "core-js/modules/es.typed-array.index-of": 207, "core-js/modules/es.typed-array.iterator": 210, "core-js/modules/es.typed-array.join": 211, "core-js/modules/es.typed-array.last-index-of": 212, "core-js/modules/es.typed-array.map": 213, "core-js/modules/es.typed-array.reduce": 215, "core-js/modules/es.typed-array.reduce-right": 214, "core-js/modules/es.typed-array.reverse": 216, "core-js/modules/es.typed-array.set": 217, "core-js/modules/es.typed-array.slice": 218, "core-js/modules/es.typed-array.some": 219, "core-js/modules/es.typed-array.sort": 220, "core-js/modules/es.typed-array.subarray": 221, "core-js/modules/es.typed-array.to-locale-string": 222, "core-js/modules/es.typed-array.to-string": 223, "core-js/modules/es.typed-array.uint8-clamped-array": 227, "core-js/modules/web.dom-collections.iterator": 229 }], 276: [function(e2, t2, r2) {
      e2("core-js/modules/es.array.for-each"), e2("core-js/modules/es.object.assign"), e2("core-js/modules/web.dom-collections.for-each"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, o2 = (n2 = e2("./main")) && n2.__esModule ? n2 : { default: n2 };
      o2.default.prototype.noLoop = function() {
        this._loop = false;
      }, o2.default.prototype.loop = function() {
        this._loop || (this._loop = true, this._setupDone && this._draw());
      }, o2.default.prototype.isLooping = function() {
        return this._loop;
      }, o2.default.prototype.push = function() {
        this._styles.push({ props: { _colorMode: this._colorMode }, renderer: this._renderer.push() });
      }, o2.default.prototype.pop = function() {
        var e3 = this._styles.pop();
        e3 ? (this._renderer.pop(e3.renderer), Object.assign(this, e3.props)) : console.warn("pop() was called without matching push()");
      }, o2.default.prototype.redraw = function(e3) {
        if (!this._inUserDraw && this._setupDone) {
          var t3 = parseInt(e3);
          (isNaN(t3) || t3 < 1) && (t3 = 1);
          var r3 = this._isGlobal ? window : this;
          if (typeof r3.draw == "function") {
            r3.setup === void 0 && r3.scale(r3._pixelDensity, r3._pixelDensity);
            for (var n3 = function(e4) {
              e4.call(r3);
            }, o3 = 0; o3 < t3; o3++) {
              r3.resetMatrix(), (this._accessibleOutputs.grid || this._accessibleOutputs.text) && this._updateAccsOutput(), r3._renderer.isP3D && r3._renderer._update(), r3._setProperty("frameCount", r3.frameCount + 1), r3._registeredMethods.pre.forEach(n3), this._inUserDraw = true;
              try {
                r3.draw();
              } finally {
                this._inUserDraw = false;
              }
              r3._registeredMethods.post.forEach(n3);
            }
          }
        }
      };
      var i2 = o2.default;
      r2.default = i2;
    }, { "./main": 264, "core-js/modules/es.array.for-each": 154, "core-js/modules/es.object.assign": 173, "core-js/modules/web.dom-collections.for-each": 228 }], 277: [function(e2, t2, r2) {
      e2("core-js/modules/es.symbol"), e2("core-js/modules/es.symbol.description"), e2("core-js/modules/es.symbol.iterator"), e2("core-js/modules/es.array.from"), e2("core-js/modules/es.array.iterator"), e2("core-js/modules/es.object.get-prototype-of"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.regexp.to-string"), e2("core-js/modules/es.string.iterator"), e2("core-js/modules/es.typed-array.uint8-array"), e2("core-js/modules/es.typed-array.copy-within"), e2("core-js/modules/es.typed-array.every"), e2("core-js/modules/es.typed-array.fill"), e2("core-js/modules/es.typed-array.filter"), e2("core-js/modules/es.typed-array.find"), e2("core-js/modules/es.typed-array.find-index"), e2("core-js/modules/es.typed-array.for-each"), e2("core-js/modules/es.typed-array.includes"), e2("core-js/modules/es.typed-array.index-of"), e2("core-js/modules/es.typed-array.iterator"), e2("core-js/modules/es.typed-array.join"), e2("core-js/modules/es.typed-array.last-index-of"), e2("core-js/modules/es.typed-array.map"), e2("core-js/modules/es.typed-array.reduce"), e2("core-js/modules/es.typed-array.reduce-right"), e2("core-js/modules/es.typed-array.reverse"), e2("core-js/modules/es.typed-array.set"), e2("core-js/modules/es.typed-array.slice"), e2("core-js/modules/es.typed-array.some"), e2("core-js/modules/es.typed-array.sort"), e2("core-js/modules/es.typed-array.subarray"), e2("core-js/modules/es.typed-array.to-locale-string"), e2("core-js/modules/es.typed-array.to-string"), e2("core-js/modules/web.dom-collections.iterator"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, i2 = (n2 = e2("./main")) && n2.__esModule ? n2 : { default: n2 };
      function o2(e3) {
        return function(e4) {
          if (Array.isArray(e4)) {
            for (var t3 = 0, r3 = new Array(e4.length); t3 < e4.length; t3++)
              r3[t3] = e4[t3];
            return r3;
          }
        }(e3) || function(e4) {
          if (Symbol.iterator in Object(e4) || Object.prototype.toString.call(e4) === "[object Arguments]")
            return Array.from(e4);
        }(e3) || function() {
          throw new TypeError("Invalid attempt to spread non-iterable instance");
        }();
      }
      i2.default.prototype.applyMatrix = function() {
        var e3, t3, r3 = arguments[0] instanceof Object.getPrototypeOf(Uint8Array);
        Array.isArray(arguments[0]) || r3 ? (e3 = this._renderer).applyMatrix.apply(e3, o2(arguments[0])) : (t3 = this._renderer).applyMatrix.apply(t3, arguments);
        return this;
      }, i2.default.prototype.resetMatrix = function() {
        return this._renderer.resetMatrix(), this;
      }, i2.default.prototype.rotate = function(e3, t3) {
        return i2.default._validateParameters("rotate", arguments), this._renderer.rotate(this._toRadians(e3), t3), this;
      }, i2.default.prototype.rotateX = function(e3) {
        return this._assert3d("rotateX"), i2.default._validateParameters("rotateX", arguments), this._renderer.rotateX(this._toRadians(e3)), this;
      }, i2.default.prototype.rotateY = function(e3) {
        return this._assert3d("rotateY"), i2.default._validateParameters("rotateY", arguments), this._renderer.rotateY(this._toRadians(e3)), this;
      }, i2.default.prototype.rotateZ = function(e3) {
        return this._assert3d("rotateZ"), i2.default._validateParameters("rotateZ", arguments), this._renderer.rotateZ(this._toRadians(e3)), this;
      }, i2.default.prototype.scale = function(e3, t3, r3) {
        if (i2.default._validateParameters("scale", arguments), e3 instanceof i2.default.Vector) {
          var n3 = e3;
          e3 = n3.x, t3 = n3.y, r3 = n3.z;
        } else if (e3 instanceof Array) {
          var o3 = e3;
          e3 = o3[0], t3 = o3[1], r3 = o3[2] || 1;
        }
        return isNaN(t3) ? t3 = r3 = e3 : isNaN(r3) && (r3 = 1), this._renderer.scale.call(this._renderer, e3, t3, r3), this;
      }, i2.default.prototype.shearX = function(e3) {
        i2.default._validateParameters("shearX", arguments);
        var t3 = this._toRadians(e3);
        return this._renderer.applyMatrix(1, 0, Math.tan(t3), 1, 0, 0), this;
      }, i2.default.prototype.shearY = function(e3) {
        i2.default._validateParameters("shearY", arguments);
        var t3 = this._toRadians(e3);
        return this._renderer.applyMatrix(1, Math.tan(t3), 0, 1, 0, 0), this;
      }, i2.default.prototype.translate = function(e3, t3, r3) {
        return i2.default._validateParameters("translate", arguments), this._renderer.isP3D ? this._renderer.translate(e3, t3, r3) : this._renderer.translate(e3, t3), this;
      };
      var a2 = i2.default;
      r2.default = a2;
    }, { "./main": 264, "core-js/modules/es.array.from": 155, "core-js/modules/es.array.iterator": 158, "core-js/modules/es.object.get-prototype-of": 175, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.regexp.to-string": 182, "core-js/modules/es.string.iterator": 186, "core-js/modules/es.symbol": 196, "core-js/modules/es.symbol.description": 194, "core-js/modules/es.symbol.iterator": 195, "core-js/modules/es.typed-array.copy-within": 197, "core-js/modules/es.typed-array.every": 198, "core-js/modules/es.typed-array.fill": 199, "core-js/modules/es.typed-array.filter": 200, "core-js/modules/es.typed-array.find": 202, "core-js/modules/es.typed-array.find-index": 201, "core-js/modules/es.typed-array.for-each": 205, "core-js/modules/es.typed-array.includes": 206, "core-js/modules/es.typed-array.index-of": 207, "core-js/modules/es.typed-array.iterator": 210, "core-js/modules/es.typed-array.join": 211, "core-js/modules/es.typed-array.last-index-of": 212, "core-js/modules/es.typed-array.map": 213, "core-js/modules/es.typed-array.reduce": 215, "core-js/modules/es.typed-array.reduce-right": 214, "core-js/modules/es.typed-array.reverse": 216, "core-js/modules/es.typed-array.set": 217, "core-js/modules/es.typed-array.slice": 218, "core-js/modules/es.typed-array.some": 219, "core-js/modules/es.typed-array.sort": 220, "core-js/modules/es.typed-array.subarray": 221, "core-js/modules/es.typed-array.to-locale-string": 222, "core-js/modules/es.typed-array.to-string": 223, "core-js/modules/es.typed-array.uint8-array": 226, "core-js/modules/web.dom-collections.iterator": 229 }], 278: [function(e2, t2, r2) {
      e2("core-js/modules/es.symbol"), e2("core-js/modules/es.symbol.description"), e2("core-js/modules/es.symbol.iterator"), e2("core-js/modules/es.array.from"), e2("core-js/modules/es.array.iterator"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.regexp.to-string"), e2("core-js/modules/es.string.ends-with"), e2("core-js/modules/es.string.iterator"), e2("core-js/modules/web.dom-collections.iterator");
      var n2, o2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      function i2(e3) {
        return function(e4) {
          if (Array.isArray(e4)) {
            for (var t3 = 0, r3 = new Array(e4.length); t3 < e4.length; t3++)
              r3[t3] = e4[t3];
            return r3;
          }
        }(e3) || function(e4) {
          if (Symbol.iterator in Object(e4) || Object.prototype.toString.call(e4) === "[object Arguments]")
            return Array.from(e4);
        }(e3) || function() {
          throw new TypeError("Invalid attempt to spread non-iterable instance");
        }();
      }
      function a2(e3) {
        return (a2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      o2.default.prototype.storeItem = function(e3, t3) {
        typeof e3 != "string" && console.log("The argument that you passed to storeItem() - ".concat(e3, " is not a string.")), e3.endsWith("p5TypeID") && console.log("The argument that you passed to storeItem() - ".concat(e3, " must not end with 'p5TypeID'.")), t3 === void 0 && console.log("You cannot store undefined variables using storeItem().");
        var r3 = a2(t3);
        switch (r3) {
          case "number":
          case "boolean":
            t3 = t3.toString();
            break;
          case "object":
            if (t3 instanceof o2.default.Color)
              r3 = "p5.Color";
            else if (t3 instanceof o2.default.Vector) {
              r3 = "p5.Vector", t3 = [t3.x, t3.y, t3.z];
            }
            t3 = JSON.stringify(t3);
        }
        localStorage.setItem(e3, t3);
        var n3 = "".concat(e3, "p5TypeID");
        localStorage.setItem(n3, r3);
      }, o2.default.prototype.getItem = function(e3) {
        var t3 = localStorage.getItem(e3), r3 = localStorage.getItem("".concat(e3, "p5TypeID"));
        if (r3 === void 0)
          console.log("Unable to determine type of item stored under ".concat(e3, "in local storage. Did you save the item with something other than setItem()?"));
        else if (t3 !== null)
          switch (r3) {
            case "number":
              t3 = parseFloat(t3);
              break;
            case "boolean":
              t3 = t3 === "true";
              break;
            case "object":
              t3 = JSON.parse(t3);
              break;
            case "p5.Color":
              t3 = JSON.parse(t3), t3 = this.color.apply(this, i2(t3.levels));
              break;
            case "p5.Vector":
              t3 = JSON.parse(t3), t3 = this.createVector.apply(this, i2(t3));
          }
        return t3;
      }, o2.default.prototype.clearStorage = function() {
        localStorage.clear();
      }, o2.default.prototype.removeItem = function(e3) {
        typeof e3 != "string" && console.log("The argument that you passed to removeItem() - ".concat(e3, " is not a string.")), localStorage.removeItem(e3), localStorage.removeItem("".concat(e3, "p5TypeID"));
      };
    }, { "../core/main": 264, "core-js/modules/es.array.from": 155, "core-js/modules/es.array.iterator": 158, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.regexp.to-string": 182, "core-js/modules/es.string.ends-with": 184, "core-js/modules/es.string.iterator": 186, "core-js/modules/es.symbol": 196, "core-js/modules/es.symbol.description": 194, "core-js/modules/es.symbol.iterator": 195, "core-js/modules/web.dom-collections.iterator": 229 }], 279: [function(e2, t2, r2) {
      e2("core-js/modules/es.array.concat"), e2("core-js/modules/es.object.keys"), e2("core-js/modules/es.string.sub"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, o2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      o2.default.prototype.createStringDict = function(e3, t3) {
        return o2.default._validateParameters("createStringDict", arguments), new o2.default.StringDict(e3, t3);
      }, o2.default.prototype.createNumberDict = function(e3, t3) {
        return o2.default._validateParameters("createNumberDict", arguments), new o2.default.NumberDict(e3, t3);
      }, o2.default.TypedDict = function(e3, t3) {
        return e3 instanceof Object ? this.data = e3 : (this.data = {}, this.data[e3] = t3), this;
      }, o2.default.TypedDict.prototype.size = function() {
        return Object.keys(this.data).length;
      }, o2.default.TypedDict.prototype.hasKey = function(e3) {
        return this.data.hasOwnProperty(e3);
      }, o2.default.TypedDict.prototype.get = function(e3) {
        if (this.data.hasOwnProperty(e3))
          return this.data[e3];
        console.log("".concat(e3, " does not exist in this Dictionary"));
      }, o2.default.TypedDict.prototype.set = function(e3, t3) {
        this._validate(t3) ? this.data[e3] = t3 : console.log("Those values dont work for this dictionary type.");
      }, o2.default.TypedDict.prototype._addObj = function(e3) {
        for (var t3 in e3)
          this.set(t3, e3[t3]);
      }, o2.default.TypedDict.prototype.create = function(e3, t3) {
        e3 instanceof Object && t3 === void 0 ? this._addObj(e3) : e3 !== void 0 ? this.set(e3, t3) : console.log("In order to create a new Dictionary entry you must pass an object or a key, value pair");
      }, o2.default.TypedDict.prototype.clear = function() {
        this.data = {};
      }, o2.default.TypedDict.prototype.remove = function(e3) {
        if (!this.data.hasOwnProperty(e3))
          throw new Error("".concat(e3, " does not exist in this Dictionary"));
        delete this.data[e3];
      }, o2.default.TypedDict.prototype.print = function() {
        for (var e3 in this.data)
          console.log("key:".concat(e3, " value:").concat(this.data[e3]));
      }, o2.default.TypedDict.prototype.saveTable = function(e3) {
        var t3 = "";
        for (var r3 in this.data)
          t3 += "".concat(r3, ",").concat(this.data[r3], "\n");
        var n3 = new Blob([t3], { type: "text/csv" });
        o2.default.prototype.downloadFile(n3, e3 || "mycsv", "csv");
      }, o2.default.TypedDict.prototype.saveJSON = function(e3, t3) {
        o2.default.prototype.saveJSON(this.data, e3, t3);
      }, o2.default.TypedDict.prototype._validate = function(e3) {
        return true;
      }, o2.default.StringDict = function() {
        for (var e3 = arguments.length, t3 = new Array(e3), r3 = 0; r3 < e3; r3++)
          t3[r3] = arguments[r3];
        o2.default.TypedDict.apply(this, t3);
      }, o2.default.StringDict.prototype = Object.create(o2.default.TypedDict.prototype), o2.default.StringDict.prototype._validate = function(e3) {
        return typeof e3 == "string";
      }, o2.default.NumberDict = function() {
        for (var e3 = arguments.length, t3 = new Array(e3), r3 = 0; r3 < e3; r3++)
          t3[r3] = arguments[r3];
        o2.default.TypedDict.apply(this, t3);
      }, o2.default.NumberDict.prototype = Object.create(o2.default.TypedDict.prototype), o2.default.NumberDict.prototype._validate = function(e3) {
        return typeof e3 == "number";
      }, o2.default.NumberDict.prototype.add = function(e3, t3) {
        this.data.hasOwnProperty(e3) ? this.data[e3] += t3 : console.log("The key - ".concat(e3, " does not exist in this dictionary."));
      }, o2.default.NumberDict.prototype.sub = function(e3, t3) {
        this.add(e3, -t3);
      }, o2.default.NumberDict.prototype.mult = function(e3, t3) {
        this.data.hasOwnProperty(e3) ? this.data[e3] *= t3 : console.log("The key - ".concat(e3, " does not exist in this dictionary."));
      }, o2.default.NumberDict.prototype.div = function(e3, t3) {
        this.data.hasOwnProperty(e3) ? this.data[e3] /= t3 : console.log("The key - ".concat(e3, " does not exist in this dictionary."));
      }, o2.default.NumberDict.prototype._valueTest = function(e3) {
        if (Object.keys(this.data).length === 0)
          throw new Error("Unable to search for a minimum or maximum value on an empty NumberDict");
        if (Object.keys(this.data).length === 1)
          return this.data[Object.keys(this.data)[0]];
        var t3 = this.data[Object.keys(this.data)[0]];
        for (var r3 in this.data)
          this.data[r3] * e3 < t3 * e3 && (t3 = this.data[r3]);
        return t3;
      }, o2.default.NumberDict.prototype.minValue = function() {
        return this._valueTest(1);
      }, o2.default.NumberDict.prototype.maxValue = function() {
        return this._valueTest(-1);
      }, o2.default.NumberDict.prototype._keyTest = function(e3) {
        if (Object.keys(this.data).length === 0)
          throw new Error("Unable to use minValue on an empty NumberDict");
        if (Object.keys(this.data).length === 1)
          return Object.keys(this.data)[0];
        for (var t3 = Object.keys(this.data)[0], r3 = 1; r3 < Object.keys(this.data).length; r3++)
          Object.keys(this.data)[r3] * e3 < t3 * e3 && (t3 = Object.keys(this.data)[r3]);
        return t3;
      }, o2.default.NumberDict.prototype.minKey = function() {
        return this._keyTest(1);
      }, o2.default.NumberDict.prototype.maxKey = function() {
        return this._keyTest(-1);
      };
      var i2 = o2.default.TypedDict;
      r2.default = i2;
    }, { "../core/main": 264, "core-js/modules/es.array.concat": 149, "core-js/modules/es.object.keys": 176, "core-js/modules/es.string.sub": 192 }], 280: [function(e2, t2, r2) {
      e2("core-js/modules/es.symbol"), e2("core-js/modules/es.symbol.description"), e2("core-js/modules/es.symbol.iterator"), e2("core-js/modules/es.array.every"), e2("core-js/modules/es.array.filter"), e2("core-js/modules/es.array.for-each"), e2("core-js/modules/es.array.from"), e2("core-js/modules/es.array.index-of"), e2("core-js/modules/es.array.iterator"), e2("core-js/modules/es.array.map"), e2("core-js/modules/es.array.slice"), e2("core-js/modules/es.array.splice"), e2("core-js/modules/es.function.name"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.promise"), e2("core-js/modules/es.regexp.exec"), e2("core-js/modules/es.regexp.to-string"), e2("core-js/modules/es.string.iterator"), e2("core-js/modules/es.string.replace"), e2("core-js/modules/es.string.split"), e2("core-js/modules/es.string.trim"), e2("core-js/modules/web.dom-collections.for-each"), e2("core-js/modules/web.dom-collections.iterator"), e2("core-js/modules/web.url"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, f = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      function h2(e3) {
        return (h2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      function y(e3, t3, r3) {
        (t3._userNode ? t3._userNode : document.body).appendChild(e3);
        var n3 = r3 ? new f.default.MediaElement(e3, t3) : new f.default.Element(e3, t3);
        return t3._elements.push(n3), n3;
      }
      function o2(e3, t3, r3, n3) {
        var o3 = document.createElement(t3);
        typeof (r3 = r3 || "") == "string" && (r3 = [r3]);
        var i3 = true, a3 = false, s = void 0;
        try {
          for (var l2, u2 = r3[Symbol.iterator](); !(i3 = (l2 = u2.next()).done); i3 = true) {
            var c = l2.value, d = document.createElement("source");
            d.setAttribute("src", c), o3.appendChild(d);
          }
        } catch (e4) {
          a3 = true, s = e4;
        } finally {
          try {
            i3 || u2.return == null || u2.return();
          } finally {
            if (a3)
              throw s;
          }
        }
        if (typeof n3 == "function") {
          o3.addEventListener("canplaythrough", function e4() {
            n3(), o3.removeEventListener("canplaythrough", e4);
          });
        }
        var f2 = y(o3, e3, true);
        return f2.loadedmetadata = false, o3.addEventListener("loadedmetadata", function() {
          f2.width = o3.videoWidth, f2.height = o3.videoHeight, f2.elt.width === 0 && (f2.elt.width = o3.videoWidth), f2.elt.height === 0 && (f2.elt.height = o3.videoHeight), f2.presetPlaybackRate && (f2.elt.playbackRate = f2.presetPlaybackRate, delete f2.presetPlaybackRate), f2.loadedmetadata = true;
        }), f2;
      }
      f.default.prototype.select = function(e3, t3) {
        f.default._validateParameters("select", arguments);
        var r3 = this._getContainer(t3).querySelector(e3);
        return r3 ? this._wrapElement(r3) : null;
      }, f.default.prototype.selectAll = function(e3, t3) {
        f.default._validateParameters("selectAll", arguments);
        var r3 = [], n3 = this._getContainer(t3).querySelectorAll(e3);
        if (n3)
          for (var o3 = 0; o3 < n3.length; o3++) {
            var i3 = this._wrapElement(n3[o3]);
            r3.push(i3);
          }
        return r3;
      }, f.default.prototype._getContainer = function(e3) {
        var t3 = document;
        return typeof e3 == "string" ? t3 = document.querySelector(e3) || document : e3 instanceof f.default.Element ? t3 = e3.elt : e3 instanceof HTMLElement && (t3 = e3), t3;
      }, f.default.prototype._wrapElement = function(e3) {
        var t3 = Array.prototype.slice.call(e3.children);
        if (e3.tagName !== "INPUT" || e3.type !== "checkbox")
          return e3.tagName === "VIDEO" || e3.tagName === "AUDIO" ? new f.default.MediaElement(e3, this) : e3.tagName === "SELECT" ? this.createSelect(new f.default.Element(e3, this)) : 0 < t3.length && t3.every(function(e4) {
            return e4.tagName === "INPUT" || e4.tagName === "LABEL";
          }) ? this.createRadio(new f.default.Element(e3, this)) : new f.default.Element(e3, this);
        var r3 = new f.default.Element(e3, this);
        return r3.checked = function() {
          return arguments.length === 0 ? this.elt.checked : (this.elt.checked = !!arguments[0], this);
        }, r3;
      }, f.default.prototype.removeElements = function(e3) {
        f.default._validateParameters("removeElements", arguments);
        this._elements.filter(function(e4) {
          return !(e4.elt instanceof HTMLCanvasElement);
        }).map(function(e4) {
          return e4.remove();
        });
      }, f.default.Element.prototype.changed = function(e3) {
        return f.default.Element._adjustListener("change", e3, this), this;
      }, f.default.Element.prototype.input = function(e3) {
        return f.default.Element._adjustListener("input", e3, this), this;
      }, f.default.prototype.createDiv = function() {
        var e3 = 0 < arguments.length && arguments[0] !== void 0 ? arguments[0] : "", t3 = document.createElement("div");
        return t3.innerHTML = e3, y(t3, this);
      }, f.default.prototype.createP = function() {
        var e3 = 0 < arguments.length && arguments[0] !== void 0 ? arguments[0] : "", t3 = document.createElement("p");
        return t3.innerHTML = e3, y(t3, this);
      }, f.default.prototype.createSpan = function() {
        var e3 = 0 < arguments.length && arguments[0] !== void 0 ? arguments[0] : "", t3 = document.createElement("span");
        return t3.innerHTML = e3, y(t3, this);
      }, f.default.prototype.createImg = function() {
        f.default._validateParameters("createImg", arguments);
        var t3, r3 = document.createElement("img"), n3 = arguments;
        return 1 < n3.length && typeof n3[1] == "string" && (r3.alt = n3[1]), 2 < n3.length && typeof n3[2] == "string" && (r3.crossOrigin = n3[2]), r3.src = n3[0], t3 = y(r3, this), r3.addEventListener("load", function() {
          t3.width = r3.offsetWidth || r3.width, t3.height = r3.offsetHeight || r3.height;
          var e3 = n3[n3.length - 1];
          typeof e3 == "function" && e3(t3);
        }), t3;
      }, f.default.prototype.createA = function(e3, t3, r3) {
        f.default._validateParameters("createA", arguments);
        var n3 = document.createElement("a");
        return n3.href = e3, n3.innerHTML = t3, r3 && (n3.target = r3), y(n3, this);
      }, f.default.prototype.createSlider = function(e3, t3, r3, n3) {
        f.default._validateParameters("createSlider", arguments);
        var o3 = document.createElement("input");
        return o3.type = "range", o3.min = e3, o3.max = t3, n3 === 0 ? o3.step = 1e-18 : n3 && (o3.step = n3), typeof r3 == "number" && (o3.value = r3), y(o3, this);
      }, f.default.prototype.createButton = function(e3, t3) {
        f.default._validateParameters("createButton", arguments);
        var r3 = document.createElement("button");
        return r3.innerHTML = e3, t3 && (r3.value = t3), y(r3, this);
      }, f.default.prototype.createCheckbox = function() {
        f.default._validateParameters("createCheckbox", arguments);
        var e3 = document.createElement("div"), t3 = document.createElement("input");
        t3.type = "checkbox";
        var r3 = document.createElement("label");
        r3.appendChild(t3), e3.appendChild(r3);
        var n3 = y(e3, this);
        if (n3.checked = function() {
          var e4 = n3.elt.firstElementChild.getElementsByTagName("input")[0];
          if (e4) {
            if (arguments.length === 0)
              return e4.checked;
            e4.checked = !!arguments[0];
          }
          return n3;
        }, this.value = function(e4) {
          return n3.value = e4, this;
        }, arguments[0]) {
          n3.value(arguments[0]);
          var o3 = document.createElement("span");
          o3.innerHTML = arguments[0], r3.appendChild(o3);
        }
        return arguments[1] && (t3.checked = true), n3;
      }, f.default.prototype.createSelect = function() {
        var e3;
        f.default._validateParameters("createSelect", arguments);
        var t3 = arguments[0];
        if (t3 instanceof f.default.Element && t3.elt instanceof HTMLSelectElement)
          e3 = t3, this.elt = t3.elt;
        else if (t3 instanceof HTMLSelectElement)
          e3 = y(t3, this), this.elt = t3;
        else {
          var r3 = document.createElement("select");
          t3 && typeof t3 == "boolean" && r3.setAttribute("multiple", "true"), e3 = y(r3, this), this.elt = r3;
        }
        return e3.option = function(e4, t4) {
          var r4;
          if (e4 !== void 0) {
            for (var n3 = 0; n3 < this.elt.length; n3 += 1)
              if (this.elt[n3].innerHTML === e4) {
                r4 = n3;
                break;
              }
            if (r4 !== void 0)
              t4 === false ? this.elt.remove(r4) : this.elt[r4].value = t4;
            else {
              var o3 = document.createElement("option");
              o3.innerHTML = e4, o3.value = t4 === void 0 ? e4 : t4, this.elt.appendChild(o3), this._pInst._elements.push(o3);
            }
          }
        }, e3.selected = function(e4) {
          if (e4 !== void 0) {
            for (var t4 = 0; t4 < this.elt.length; t4 += 1)
              this.elt[t4].value.toString() === e4.toString() && (this.elt.selectedIndex = t4);
            return this;
          }
          if (this.elt.getAttribute("multiple")) {
            var r4 = [], n3 = true, o3 = false, i3 = void 0;
            try {
              for (var a3, s = this.elt.selectedOptions[Symbol.iterator](); !(n3 = (a3 = s.next()).done); n3 = true) {
                var l2 = a3.value;
                r4.push(l2.value);
              }
            } catch (e5) {
              o3 = true, i3 = e5;
            } finally {
              try {
                n3 || s.return == null || s.return();
              } finally {
                if (o3)
                  throw i3;
              }
            }
            return r4;
          }
          return this.elt.value;
        }, e3.disable = function(e4) {
          if (typeof e4 == "string")
            for (var t4 = 0; t4 < this.elt.length; t4++)
              this.elt[t4].value.toString() === e4 && (this.elt[t4].disabled = true, this.elt[t4].selected = false);
          else
            this.elt.disabled = true;
          return this;
        }, e3;
      }, f.default.prototype.createRadio = function() {
        var e3, t3, r3 = arguments[0];
        r3 instanceof HTMLDivElement || r3 instanceof HTMLSpanElement ? (e3 = r3, typeof arguments[1] == "string" && (t3 = arguments[1])) : (typeof r3 == "string" && (t3 = r3), e3 = document.createElement("div"));
        var p2 = y(this.elt = e3, this);
        p2._name = t3 || "radioOption";
        function n3(e4) {
          return e4 instanceof HTMLInputElement && e4.type === "radio";
        }
        function d(e4) {
          return e4 instanceof HTMLLabelElement;
        }
        return p2._getOptionsArray = function() {
          return Array.from(this.elt.children).filter(function(e4) {
            return n3(e4) || d(e4) && n3(e4.firstElementChild);
          }).map(function(e4) {
            return n3(e4) ? e4 : e4.firstElementChild;
          });
        }, p2.option = function(e4, t4) {
          var r4, n4, o3, i3 = true, a3 = false, s = void 0;
          try {
            for (var l2, u2 = p2._getOptionsArray()[Symbol.iterator](); !(i3 = (l2 = u2.next()).done); i3 = true) {
              var c = l2.value;
              if (c.value === e4) {
                r4 = c;
                break;
              }
            }
          } catch (e5) {
            a3 = true, s = e5;
          } finally {
            try {
              i3 || u2.return == null || u2.return();
            } finally {
              if (a3)
                throw s;
            }
          }
          return r4 === void 0 && ((r4 = document.createElement("input")).setAttribute("type", "radio"), r4.setAttribute("value", e4)), r4.setAttribute("name", p2._name), d(r4.parentElement) ? n4 = r4.parentElement : (n4 = document.createElement("label")).insertAdjacentElement("afterbegin", r4), n4.lastElementChild instanceof HTMLSpanElement ? o3 = n4.lastElementChild : (o3 = document.createElement("span"), r4.insertAdjacentElement("afterend", o3)), o3.innerHTML = t4 === void 0 ? e4 : t4, this.elt.appendChild(n4), r4;
        }, p2.remove = function(e4) {
          var t4 = true, r4 = false, n4 = void 0;
          try {
            for (var o3, i3 = p2._getOptionsArray()[Symbol.iterator](); !(t4 = (o3 = i3.next()).done); t4 = true) {
              var a3 = o3.value;
              if (a3.value === e4)
                return void (d(a3.parentElement) ? a3.parentElement.remove() : a3.remove());
            }
          } catch (e5) {
            r4 = true, n4 = e5;
          } finally {
            try {
              t4 || i3.return == null || i3.return();
            } finally {
              if (r4)
                throw n4;
            }
          }
        }, p2.value = function() {
          var e4 = "", t4 = true, r4 = false, n4 = void 0;
          try {
            for (var o3, i3 = p2._getOptionsArray()[Symbol.iterator](); !(t4 = (o3 = i3.next()).done); t4 = true) {
              var a3 = o3.value;
              if (a3.checked) {
                e4 = a3.value;
                break;
              }
            }
          } catch (e5) {
            r4 = true, n4 = e5;
          } finally {
            try {
              t4 || i3.return == null || i3.return();
            } finally {
              if (r4)
                throw n4;
            }
          }
          return e4;
        }, p2.selected = function(e4) {
          var t4 = null;
          if (e4 === void 0) {
            var r4 = true, n4 = false, o3 = void 0;
            try {
              for (var i3, a3 = p2._getOptionsArray()[Symbol.iterator](); !(r4 = (i3 = a3.next()).done); r4 = true) {
                var s = i3.value;
                if (s.checked) {
                  t4 = s;
                  break;
                }
              }
            } catch (e5) {
              n4 = true, o3 = e5;
            } finally {
              try {
                r4 || a3.return == null || a3.return();
              } finally {
                if (n4)
                  throw o3;
              }
            }
          } else {
            var l2 = true, u2 = false, c = void 0;
            try {
              for (var d2, f2 = p2._getOptionsArray()[Symbol.iterator](); !(l2 = (d2 = f2.next()).done); l2 = true) {
                var h3 = d2.value;
                h3.value === e4 && (h3.setAttribute("checked", true), t4 = h3);
              }
            } catch (e5) {
              u2 = true, c = e5;
            } finally {
              try {
                l2 || f2.return == null || f2.return();
              } finally {
                if (u2)
                  throw c;
              }
            }
          }
          return t4;
        }, p2.disable = function() {
          var e4 = !(0 < arguments.length && arguments[0] !== void 0) || arguments[0], t4 = true, r4 = false, n4 = void 0;
          try {
            for (var o3, i3 = p2._getOptionsArray()[Symbol.iterator](); !(t4 = (o3 = i3.next()).done); t4 = true) {
              o3.value.setAttribute("disabled", e4);
            }
          } catch (e5) {
            r4 = true, n4 = e5;
          } finally {
            try {
              t4 || i3.return == null || i3.return();
            } finally {
              if (r4)
                throw n4;
            }
          }
        }, p2;
      }, f.default.prototype.createColorPicker = function(e3) {
        f.default._validateParameters("createColorPicker", arguments);
        var t3, r3 = document.createElement("input");
        return r3.type = "color", e3 ? e3 instanceof f.default.Color ? r3.value = e3.toString("#rrggbb") : (f.default.prototype._colorMode = "rgb", f.default.prototype._colorMaxes = { rgb: [255, 255, 255, 255], hsb: [360, 100, 100, 1], hsl: [360, 100, 100, 1] }, r3.value = f.default.prototype.color(e3).toString("#rrggbb")) : r3.value = "#000000", (t3 = y(r3, this)).color = function() {
          return e3 && (e3.mode && (f.default.prototype._colorMode = e3.mode), e3.maxes && (f.default.prototype._colorMaxes = e3.maxes)), f.default.prototype.color(this.elt.value);
        }, t3;
      }, f.default.prototype.createInput = function() {
        var e3 = 0 < arguments.length && arguments[0] !== void 0 ? arguments[0] : "", t3 = 1 < arguments.length && arguments[1] !== void 0 ? arguments[1] : "text";
        f.default._validateParameters("createInput", arguments);
        var r3 = document.createElement("input");
        return r3.setAttribute("value", e3), r3.setAttribute("type", t3), y(r3, this);
      }, f.default.prototype.createFileInput = function(s) {
        var e3 = 1 < arguments.length && arguments[1] !== void 0 && arguments[1];
        f.default._validateParameters("createFileInput", arguments);
        if (window.File && window.FileReader && window.FileList && window.Blob) {
          var t3 = document.createElement("input");
          return t3.setAttribute("type", "file"), e3 && t3.setAttribute("multiple", true), t3.addEventListener("change", function(e4) {
            var t4 = true, r3 = false, n3 = void 0;
            try {
              for (var o3, i3 = e4.target.files[Symbol.iterator](); !(t4 = (o3 = i3.next()).done); t4 = true) {
                var a3 = o3.value;
                f.default.File._load(a3, s);
              }
            } catch (e5) {
              r3 = true, n3 = e5;
            } finally {
              try {
                t4 || i3.return == null || i3.return();
              } finally {
                if (r3)
                  throw n3;
              }
            }
          }, false), y(t3, this);
        }
        console.log("The File APIs are not fully supported in this browser. Cannot create element.");
      }, f.default.prototype.createVideo = function(e3, t3) {
        return f.default._validateParameters("createVideo", arguments), o2(this, "video", e3, t3);
      }, f.default.prototype.createAudio = function(e3, t3) {
        return f.default._validateParameters("createAudio", arguments), o2(this, "audio", e3, t3);
      }, f.default.prototype.VIDEO = "video", f.default.prototype.AUDIO = "audio", navigator.mediaDevices === void 0 && (navigator.mediaDevices = {}), navigator.mediaDevices.getUserMedia === void 0 && (navigator.mediaDevices.getUserMedia = function(r3) {
        var n3 = navigator.webkitGetUserMedia || navigator.mozGetUserMedia;
        return n3 ? new Promise(function(e3, t3) {
          n3.call(navigator, r3, e3, t3);
        }) : Promise.reject(new Error("getUserMedia is not implemented in this browser"));
      }), f.default.prototype.createCapture = function() {
        if (f.default._validateParameters("createCapture", arguments), !navigator.mediaDevices || !navigator.mediaDevices.getUserMedia)
          throw new DOMException("getUserMedia not supported in this browser");
        var e3, t3, r3 = true, n3 = true, o3 = true, i3 = false, a3 = void 0;
        try {
          for (var s, l2 = arguments[Symbol.iterator](); !(o3 = (s = l2.next()).done); o3 = true) {
            var u2 = s.value;
            u2 === f.default.prototype.VIDEO ? n3 = false : u2 === f.default.prototype.AUDIO ? r3 = false : h2(u2) === "object" ? e3 = u2 : typeof u2 == "function" && (t3 = u2);
          }
        } catch (e4) {
          i3 = true, a3 = e4;
        } finally {
          try {
            o3 || l2.return == null || l2.return();
          } finally {
            if (i3)
              throw a3;
          }
        }
        e3 = e3 || { video: r3, audio: n3 };
        var c = document.createElement("video");
        c.setAttribute("playsinline", ""), navigator.mediaDevices.getUserMedia(e3).then(function(t4) {
          try {
            "srcObject" in c ? c.srcObject = t4 : c.src = window.URL.createObjectURL(t4);
          } catch (e4) {
            c.src = t4;
          }
        }, console.log);
        var d = y(c, this, true);
        return d.loadedmetadata = false, c.addEventListener("loadedmetadata", function() {
          c.play(), c.width ? (d.width = c.width, d.height = c.height) : (d.width = d.elt.width = c.videoWidth, d.height = d.elt.height = c.videoHeight), d.loadedmetadata = true, t3 && t3(c.srcObject);
        }), d;
      }, f.default.prototype.createElement = function(e3, t3) {
        f.default._validateParameters("createElement", arguments);
        var r3 = document.createElement(e3);
        return t3 !== void 0 && (r3.innerHTML = t3), y(r3, this);
      }, f.default.Element.prototype.addClass = function(e3) {
        return this.elt.className ? this.hasClass(e3) || (this.elt.className = this.elt.className + " " + e3) : this.elt.className = e3, this;
      }, f.default.Element.prototype.removeClass = function(e3) {
        return this.elt.classList.remove(e3), this;
      }, f.default.Element.prototype.hasClass = function(e3) {
        return this.elt.classList.contains(e3);
      }, f.default.Element.prototype.toggleClass = function(e3) {
        return this.elt.classList.contains(e3) ? this.elt.classList.remove(e3) : this.elt.classList.add(e3), this;
      }, f.default.Element.prototype.child = function(e3) {
        return e3 === void 0 ? this.elt.childNodes : (typeof e3 == "string" ? (e3[0] === "#" && (e3 = e3.substring(1)), e3 = document.getElementById(e3)) : e3 instanceof f.default.Element && (e3 = e3.elt), e3 instanceof HTMLElement && this.elt.appendChild(e3), this);
      }, f.default.Element.prototype.center = function(e3) {
        var t3 = this.elt.style.display, r3 = this.elt.style.display === "none", n3 = this.parent().style.display === "none", o3 = { x: this.elt.offsetLeft, y: this.elt.offsetTop };
        r3 && this.show(), n3 && this.parent().show(), this.elt.style.display = "block", this.position(0, 0);
        var i3 = Math.abs(this.parent().offsetWidth - this.elt.offsetWidth), a3 = Math.abs(this.parent().offsetHeight - this.elt.offsetHeight);
        return e3 === "both" || e3 === void 0 ? this.position(i3 / 2 + this.parent().offsetLeft, a3 / 2 + this.parent().offsetTop) : e3 === "horizontal" ? this.position(i3 / 2 + this.parent().offsetLeft, o3.y) : e3 === "vertical" && this.position(o3.x, a3 / 2 + this.parent().offsetTop), this.style("display", t3), r3 && this.hide(), n3 && this.parent().hide(), this;
      }, f.default.Element.prototype.html = function() {
        return arguments.length === 0 ? this.elt.innerHTML : (arguments[1] ? this.elt.insertAdjacentHTML("beforeend", arguments[0]) : this.elt.innerHTML = arguments[0], this);
      }, f.default.Element.prototype.position = function() {
        if (arguments.length === 0)
          return { x: this.elt.offsetLeft, y: this.elt.offsetTop };
        var e3 = "absolute";
        return arguments[2] !== "static" && arguments[2] !== "fixed" && arguments[2] !== "relative" && arguments[2] !== "sticky" && arguments[2] !== "initial" && arguments[2] !== "inherit" || (e3 = arguments[2]), this.elt.style.position = e3, this.elt.style.left = arguments[0] + "px", this.elt.style.top = arguments[1] + "px", this.x = arguments[0], this.y = arguments[1], this;
      }, f.default.Element.prototype._translate = function() {
        this.elt.style.position = "absolute";
        var e3 = "";
        return this.elt.style.transform && (e3 = (e3 = this.elt.style.transform.replace(/translate3d\(.*\)/g, "")).replace(/translate[X-Z]?\(.*\)/g, "")), arguments.length === 2 ? this.elt.style.transform = "translate(" + arguments[0] + "px, " + arguments[1] + "px)" : 2 < arguments.length && (this.elt.style.transform = "translate3d(" + arguments[0] + "px," + arguments[1] + "px," + arguments[2] + "px)", this.elt.parentElement.style.perspective = arguments.length === 3 ? "1000px" : arguments[3] + "px"), this.elt.style.transform += e3, this;
      }, f.default.Element.prototype._rotate = function() {
        var e3 = "";
        return this.elt.style.transform && (e3 = (e3 = this.elt.style.transform.replace(/rotate3d\(.*\)/g, "")).replace(/rotate[X-Z]?\(.*\)/g, "")), arguments.length === 1 ? this.elt.style.transform = "rotate(" + arguments[0] + "deg)" : arguments.length === 2 ? this.elt.style.transform = "rotate(" + arguments[0] + "deg, " + arguments[1] + "deg)" : arguments.length === 3 && (this.elt.style.transform = "rotateX(" + arguments[0] + "deg)", this.elt.style.transform += "rotateY(" + arguments[1] + "deg)", this.elt.style.transform += "rotateZ(" + arguments[2] + "deg)"), this.elt.style.transform += e3, this;
      }, f.default.Element.prototype.style = function(e3, t3) {
        if (t3 instanceof f.default.Color && (t3 = "rgba(" + t3.levels[0] + "," + t3.levels[1] + "," + t3.levels[2] + "," + t3.levels[3] / 255 + ")"), t3 === void 0) {
          if (e3.indexOf(":") === -1)
            return window.getComputedStyle(this.elt).getPropertyValue(e3);
          for (var r3 = e3.split(";"), n3 = 0; n3 < r3.length; n3++) {
            var o3 = r3[n3].split(":");
            o3[0] && o3[1] && (this.elt.style[o3[0].trim()] = o3[1].trim());
          }
        } else if (this.elt.style[e3] = t3, e3 === "width" || e3 === "height" || e3 === "left" || e3 === "top") {
          var i3 = window.getComputedStyle(this.elt).getPropertyValue(e3).replace(/\D+/g, "");
          this[e3] = parseInt(i3, 10);
        }
        return this;
      }, f.default.Element.prototype.attribute = function(e3, t3) {
        if (this.elt.firstChild == null || this.elt.firstChild.type !== "checkbox" && this.elt.firstChild.type !== "radio")
          return t3 === void 0 ? this.elt.getAttribute(e3) : (this.elt.setAttribute(e3, t3), this);
        if (t3 === void 0)
          return this.elt.firstChild.getAttribute(e3);
        for (var r3 = 0; r3 < this.elt.childNodes.length; r3++)
          this.elt.childNodes[r3].setAttribute(e3, t3);
      }, f.default.Element.prototype.removeAttribute = function(e3) {
        if (this.elt.firstChild != null && (this.elt.firstChild.type === "checkbox" || this.elt.firstChild.type === "radio"))
          for (var t3 = 0; t3 < this.elt.childNodes.length; t3++)
            this.elt.childNodes[t3].removeAttribute(e3);
        return this.elt.removeAttribute(e3), this;
      }, f.default.Element.prototype.value = function() {
        return 0 < arguments.length ? (this.elt.value = arguments[0], this) : this.elt.type === "range" ? parseFloat(this.elt.value) : this.elt.value;
      }, f.default.Element.prototype.show = function() {
        return this.elt.style.display = "block", this;
      }, f.default.Element.prototype.hide = function() {
        return this.elt.style.display = "none", this;
      }, f.default.Element.prototype.size = function(e3, t3) {
        if (arguments.length === 0)
          return { width: this.elt.offsetWidth, height: this.elt.offsetHeight };
        var r3 = e3, n3 = t3, o3 = f.default.prototype.AUTO;
        if (r3 !== o3 || n3 !== o3) {
          if (r3 === o3 ? r3 = t3 * this.width / this.height : n3 === o3 && (n3 = e3 * this.height / this.width), this.elt instanceof HTMLCanvasElement) {
            var i3, a3 = {}, s = this.elt.getContext("2d");
            for (i3 in s)
              a3[i3] = s[i3];
            for (i3 in this.elt.setAttribute("width", r3 * this._pInst._pixelDensity), this.elt.setAttribute("height", n3 * this._pInst._pixelDensity), this.elt.style.width = r3 + "px", this.elt.style.height = n3 + "px", this._pInst.scale(this._pInst._pixelDensity, this._pInst._pixelDensity), a3)
              this.elt.getContext("2d")[i3] = a3[i3];
          } else
            this.elt.style.width = r3 + "px", this.elt.style.height = n3 + "px", this.elt.width = r3, this.elt.height = n3;
          this.width = this.elt.offsetWidth, this.height = this.elt.offsetHeight, this._pInst && this._pInst._curElement && this._pInst._curElement.elt === this.elt && (this._pInst._setProperty("width", this.elt.offsetWidth), this._pInst._setProperty("height", this.elt.offsetHeight));
        }
        return this;
      }, f.default.Element.prototype.remove = function() {
        if (this instanceof f.default.MediaElement) {
          this.stop();
          var e3 = this.elt.srcObject;
          if (e3 !== null)
            e3.getTracks().forEach(function(e4) {
              e4.stop();
            });
        }
        var t3 = this._pInst._elements.indexOf(this);
        for (var r3 in t3 !== -1 && this._pInst._elements.splice(t3, 1), this._events)
          this.elt.removeEventListener(r3, this._events[r3]);
        this.elt && this.elt.parentNode && this.elt.parentNode.removeChild(this.elt);
      }, f.default.Element.prototype.drop = function(o3, i3) {
        if (window.File && window.FileReader && window.FileList && window.Blob) {
          if (!this._dragDisabled) {
            this._dragDisabled = true;
            var e3 = function(e4) {
              e4.preventDefault();
            };
            this.elt.addEventListener("dragover", e3), this.elt.addEventListener("dragleave", e3);
          }
          f.default.Element._attachListener("drop", function(e4) {
            e4.preventDefault(), typeof i3 == "function" && i3.call(this, e4);
            for (var t3 = e4.dataTransfer.files, r3 = 0; r3 < t3.length; r3++) {
              var n3 = t3[r3];
              f.default.File._load(n3, o3);
            }
          }, this);
        } else
          console.log("The File APIs are not fully supported in this browser.");
        return this;
      }, f.default.MediaElement = function(n3, e3) {
        f.default.Element.call(this, n3, e3);
        var o3 = this;
        this.elt.crossOrigin = "anonymous", this._prevTime = 0, this._cueIDCounter = 0, this._cues = [], (this._pixelsState = this)._pixelDensity = 1, this._modified = false, Object.defineProperty(o3, "src", { get: function() {
          var e4 = o3.elt.children[0].src, t3 = o3.elt.src === window.location.href ? "" : o3.elt.src;
          return e4 === window.location.href ? t3 : e4;
        }, set: function(e4) {
          for (var t3 = 0; t3 < o3.elt.children.length; t3++)
            o3.elt.removeChild(o3.elt.children[t3]);
          var r3 = document.createElement("source");
          r3.src = e4, n3.appendChild(r3), o3.elt.src = e4, o3.modified = true;
        } }), o3._onended = function() {
        }, o3.elt.onended = function() {
          o3._onended(o3);
        };
      }, f.default.MediaElement.prototype = Object.create(f.default.Element.prototype), f.default.MediaElement.prototype.play = function() {
        var e3, t3 = this;
        return this.elt.currentTime === this.elt.duration && (this.elt.currentTime = 0), (e3 = (1 < this.elt.readyState || this.elt.load(), this.elt.play())) && e3.catch && e3.catch(function(e4) {
          e4.name === "NotAllowedError" ? f.default._friendlyAutoplayError(t3.src) : console.error("Media play method encountered an unexpected error", e4);
        }), this;
      }, f.default.MediaElement.prototype.stop = function() {
        return this.elt.pause(), this.elt.currentTime = 0, this;
      }, f.default.MediaElement.prototype.pause = function() {
        return this.elt.pause(), this;
      }, f.default.MediaElement.prototype.loop = function() {
        return this.elt.setAttribute("loop", true), this.play(), this;
      }, f.default.MediaElement.prototype.noLoop = function() {
        return this.elt.removeAttribute("loop"), this;
      }, f.default.MediaElement.prototype._setupAutoplayFailDetection = function() {
        var e3 = this, t3 = setTimeout(function() {
          return f.default._friendlyAutoplayError(e3.src);
        }, 500);
        this.elt.addEventListener("play", function() {
          return clearTimeout(t3);
        }, { passive: true, once: true });
      }, f.default.MediaElement.prototype.autoplay = function(e3) {
        var t3 = this, r3 = this.elt.getAttribute("autoplay");
        if (this.elt.setAttribute("autoplay", e3), e3 && !r3) {
          var n3 = function() {
            return t3._setupAutoplayFailDetection();
          };
          this.elt.readyState === 4 ? n3() : this.elt.addEventListener("canplay", n3, { passive: true, once: true });
        }
        return this;
      }, f.default.MediaElement.prototype.volume = function(e3) {
        if (e3 === void 0)
          return this.elt.volume;
        this.elt.volume = e3;
      }, f.default.MediaElement.prototype.speed = function(e3) {
        if (e3 === void 0)
          return this.presetPlaybackRate || this.elt.playbackRate;
        this.loadedmetadata ? this.elt.playbackRate = e3 : this.presetPlaybackRate = e3;
      }, f.default.MediaElement.prototype.time = function(e3) {
        return e3 === void 0 ? this.elt.currentTime : (this.elt.currentTime = e3, this);
      }, f.default.MediaElement.prototype.duration = function() {
        return this.elt.duration;
      }, f.default.MediaElement.prototype.pixels = [], f.default.MediaElement.prototype._ensureCanvas = function() {
        this.canvas || (this.canvas = document.createElement("canvas"), this.drawingContext = this.canvas.getContext("2d"), this.setModified(true)), this.loadedmetadata && (this.canvas.width !== this.elt.width && (this.canvas.width = this.elt.width, this.canvas.height = this.elt.height, this.width = this.canvas.width, this.height = this.canvas.height), this.drawingContext.drawImage(this.elt, 0, 0, this.canvas.width, this.canvas.height), this.setModified(true));
      }, f.default.MediaElement.prototype.loadPixels = function() {
        return this._ensureCanvas(), f.default.Renderer2D.prototype.loadPixels.apply(this, arguments);
      }, f.default.MediaElement.prototype.updatePixels = function(e3, t3, r3, n3) {
        return this.loadedmetadata && (this._ensureCanvas(), f.default.Renderer2D.prototype.updatePixels.call(this, e3, t3, r3, n3)), this.setModified(true), this;
      }, f.default.MediaElement.prototype.get = function() {
        return this._ensureCanvas(), f.default.Renderer2D.prototype.get.apply(this, arguments);
      }, f.default.MediaElement.prototype._getPixel = function() {
        return this.loadPixels(), f.default.Renderer2D.prototype._getPixel.apply(this, arguments);
      }, f.default.MediaElement.prototype.set = function(e3, t3, r3) {
        this.loadedmetadata && (this._ensureCanvas(), f.default.Renderer2D.prototype.set.call(this, e3, t3, r3), this.setModified(true));
      }, f.default.MediaElement.prototype.copy = function() {
        this._ensureCanvas(), f.default.prototype.copy.apply(this, arguments);
      }, f.default.MediaElement.prototype.mask = function() {
        this.loadPixels(), this.setModified(true), f.default.Image.prototype.mask.apply(this, arguments);
      }, f.default.MediaElement.prototype.isModified = function() {
        return this._modified;
      }, f.default.MediaElement.prototype.setModified = function(e3) {
        this._modified = e3;
      }, f.default.MediaElement.prototype.onended = function(e3) {
        return this._onended = e3, this;
      }, f.default.MediaElement.prototype.connect = function(e3) {
        var t3, r3;
        if (typeof f.default.prototype.getAudioContext == "function")
          t3 = f.default.prototype.getAudioContext(), r3 = f.default.soundOut.input;
        else
          try {
            r3 = (t3 = e3.context).destination;
          } catch (e4) {
            throw "connect() is meant to be used with Web Audio API or p5.sound.js";
          }
        this.audioSourceNode || (this.audioSourceNode = t3.createMediaElementSource(this.elt), this.audioSourceNode.connect(r3)), e3 ? e3.input ? this.audioSourceNode.connect(e3.input) : this.audioSourceNode.connect(e3) : this.audioSourceNode.connect(r3);
      }, f.default.MediaElement.prototype.disconnect = function() {
        if (!this.audioSourceNode)
          throw "nothing to disconnect";
        this.audioSourceNode.disconnect();
      }, f.default.MediaElement.prototype.showControls = function() {
        this.elt.style["text-align"] = "inherit", this.elt.controls = true;
      }, f.default.MediaElement.prototype.hideControls = function() {
        this.elt.controls = false;
      };
      function i2(e3, t3, r3, n3) {
        this.callback = e3, this.time = t3, this.id = r3, this.val = n3;
      }
      f.default.MediaElement.prototype.addCue = function(e3, t3, r3) {
        var n3 = this._cueIDCounter++, o3 = new i2(t3, e3, n3, r3);
        return this._cues.push(o3), this.elt.ontimeupdate || (this.elt.ontimeupdate = this._onTimeUpdate.bind(this)), n3;
      }, f.default.MediaElement.prototype.removeCue = function(e3) {
        for (var t3 = 0; t3 < this._cues.length; t3++)
          this._cues[t3].id === e3 && (console.log(e3), this._cues.splice(t3, 1));
        this._cues.length === 0 && (this.elt.ontimeupdate = null);
      }, f.default.MediaElement.prototype.clearCues = function() {
        this._cues = [], this.elt.ontimeupdate = null;
      }, f.default.MediaElement.prototype._onTimeUpdate = function() {
        for (var e3 = this.time(), t3 = 0; t3 < this._cues.length; t3++) {
          var r3 = this._cues[t3].time, n3 = this._cues[t3].val;
          this._prevTime < r3 && r3 <= e3 && this._cues[t3].callback(n3);
        }
        this._prevTime = e3;
      }, f.default.File = function(e3, t3) {
        this.file = e3, this._pInst = t3;
        var r3 = e3.type.split("/");
        this.type = r3[0], this.subtype = r3[1], this.name = e3.name, this.size = e3.size, this.data = void 0;
      }, f.default.File._createLoader = function(n3, o3) {
        var e3 = new FileReader();
        return e3.onload = function(e4) {
          var t3 = new f.default.File(n3);
          if (t3.file.type === "application/json")
            t3.data = JSON.parse(e4.target.result);
          else if (t3.file.type === "text/xml") {
            var r3 = new DOMParser().parseFromString(e4.target.result, "text/xml");
            t3.data = new f.default.XML(r3.documentElement);
          } else
            t3.data = e4.target.result;
          o3(t3);
        }, e3;
      }, f.default.File._load = function(e3, t3) {
        if (/^text\//.test(e3.type) || e3.type === "application/json")
          f.default.File._createLoader(e3, t3).readAsText(e3);
        else if (/^(video|audio)\//.test(e3.type)) {
          var r3 = new f.default.File(e3);
          r3.data = URL.createObjectURL(e3), t3(r3);
        } else
          f.default.File._createLoader(e3, t3).readAsDataURL(e3);
      };
      var a2 = f.default;
      r2.default = a2;
    }, { "../core/main": 264, "core-js/modules/es.array.every": 150, "core-js/modules/es.array.filter": 152, "core-js/modules/es.array.for-each": 154, "core-js/modules/es.array.from": 155, "core-js/modules/es.array.index-of": 157, "core-js/modules/es.array.iterator": 158, "core-js/modules/es.array.map": 161, "core-js/modules/es.array.slice": 162, "core-js/modules/es.array.splice": 164, "core-js/modules/es.function.name": 166, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.promise": 178, "core-js/modules/es.regexp.exec": 181, "core-js/modules/es.regexp.to-string": 182, "core-js/modules/es.string.iterator": 186, "core-js/modules/es.string.replace": 189, "core-js/modules/es.string.split": 191, "core-js/modules/es.string.trim": 193, "core-js/modules/es.symbol": 196, "core-js/modules/es.symbol.description": 194, "core-js/modules/es.symbol.iterator": 195, "core-js/modules/web.dom-collections.for-each": 228, "core-js/modules/web.dom-collections.iterator": 229, "core-js/modules/web.url": 231 }], 281: [function(e2, t2, r2) {
      function a2(e3) {
        return (a2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, o2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 }, i2 = function(e3) {
        if (e3 && e3.__esModule)
          return e3;
        if (e3 === null || a2(e3) !== "object" && typeof e3 != "function")
          return { default: e3 };
        var t3 = s();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o3 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o3)) {
            var i3 = n3 ? Object.getOwnPropertyDescriptor(e3, o3) : null;
            i3 && (i3.get || i3.set) ? Object.defineProperty(r3, o3, i3) : r3[o3] = e3[o3];
          }
        r3.default = e3, t3 && t3.set(e3, r3);
        return r3;
      }(e2("../core/constants"));
      function s() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return s = function() {
          return e3;
        }, e3;
      }
      o2.default.prototype.deviceOrientation = 1 < window.innerWidth / window.innerHeight ? "landscape" : "portrait", o2.default.prototype.accelerationX = 0, o2.default.prototype.accelerationY = 0, o2.default.prototype.accelerationZ = 0, o2.default.prototype.pAccelerationX = 0, o2.default.prototype.pAccelerationY = 0, o2.default.prototype.pAccelerationZ = 0, o2.default.prototype._updatePAccelerations = function() {
        this._setProperty("pAccelerationX", this.accelerationX), this._setProperty("pAccelerationY", this.accelerationY), this._setProperty("pAccelerationZ", this.accelerationZ);
      }, o2.default.prototype.rotationX = 0, o2.default.prototype.rotationY = 0, o2.default.prototype.rotationZ = 0, o2.default.prototype.pRotationX = 0, o2.default.prototype.pRotationY = 0;
      var u2 = o2.default.prototype.pRotationZ = 0, c = 0, d = 0, f = "clockwise", h2 = "clockwise", p2 = "clockwise";
      o2.default.prototype.pRotateDirectionX = void 0, o2.default.prototype.pRotateDirectionY = void 0, o2.default.prototype.pRotateDirectionZ = void 0, o2.default.prototype._updatePRotations = function() {
        this._setProperty("pRotationX", this.rotationX), this._setProperty("pRotationY", this.rotationY), this._setProperty("pRotationZ", this.rotationZ);
      }, o2.default.prototype.turnAxis = void 0;
      var y = 0.5, m2 = 30;
      o2.default.prototype.setMoveThreshold = function(e3) {
        o2.default._validateParameters("setMoveThreshold", arguments), y = e3;
      }, o2.default.prototype.setShakeThreshold = function(e3) {
        o2.default._validateParameters("setShakeThreshold", arguments), m2 = e3;
      }, o2.default.prototype._ondeviceorientation = function(e3) {
        this._updatePRotations(), this._angleMode === i2.radians && (e3.beta = e3.beta * (_PI / 180), e3.gamma = e3.gamma * (_PI / 180), e3.alpha = e3.alpha * (_PI / 180)), this._setProperty("rotationX", e3.beta), this._setProperty("rotationY", e3.gamma), this._setProperty("rotationZ", e3.alpha), this._handleMotion();
      }, o2.default.prototype._ondevicemotion = function(e3) {
        this._updatePAccelerations(), this._setProperty("accelerationX", 2 * e3.acceleration.x), this._setProperty("accelerationY", 2 * e3.acceleration.y), this._setProperty("accelerationZ", 2 * e3.acceleration.z), this._handleMotion();
      }, o2.default.prototype._handleMotion = function() {
        window.orientation === 90 || window.orientation === -90 ? this._setProperty("deviceOrientation", "landscape") : window.orientation === 0 ? this._setProperty("deviceOrientation", "portrait") : window.orientation === void 0 && this._setProperty("deviceOrientation", "undefined");
        var e3, t3, r3 = this._isGlobal ? window : this;
        if (typeof r3.deviceMoved == "function" && (Math.abs(this.accelerationX - this.pAccelerationX) > y || Math.abs(this.accelerationY - this.pAccelerationY) > y || Math.abs(this.accelerationZ - this.pAccelerationZ) > y) && r3.deviceMoved(), typeof r3.deviceTurned == "function") {
          var n3 = this.rotationX + 180, o3 = this.pRotationX + 180, i3 = u2 + 180;
          0 < n3 - o3 && n3 - o3 < 270 || n3 - o3 < -270 ? f = "clockwise" : (n3 - o3 < 0 || 270 < n3 - o3) && (f = "counter-clockwise"), f !== this.pRotateDirectionX && (i3 = n3), 90 < Math.abs(n3 - i3) && Math.abs(n3 - i3) < 270 && (i3 = n3, this._setProperty("turnAxis", "X"), r3.deviceTurned()), this.pRotateDirectionX = f, u2 = i3 - 180;
          var a3 = this.rotationY + 180, s2 = this.pRotationY + 180, l3 = c + 180;
          0 < a3 - s2 && a3 - s2 < 270 || a3 - s2 < -270 ? h2 = "clockwise" : (a3 - s2 < 0 || 270 < a3 - this.pRotationY) && (h2 = "counter-clockwise"), h2 !== this.pRotateDirectionY && (l3 = a3), 90 < Math.abs(a3 - l3) && Math.abs(a3 - l3) < 270 && (l3 = a3, this._setProperty("turnAxis", "Y"), r3.deviceTurned()), this.pRotateDirectionY = h2, c = l3 - 180, 0 < this.rotationZ - this.pRotationZ && this.rotationZ - this.pRotationZ < 270 || this.rotationZ - this.pRotationZ < -270 ? p2 = "clockwise" : (this.rotationZ - this.pRotationZ < 0 || 270 < this.rotationZ - this.pRotationZ) && (p2 = "counter-clockwise"), p2 !== this.pRotateDirectionZ && (d = this.rotationZ), 90 < Math.abs(this.rotationZ - d) && Math.abs(this.rotationZ - d) < 270 && (d = this.rotationZ, this._setProperty("turnAxis", "Z"), r3.deviceTurned()), this.pRotateDirectionZ = p2, this._setProperty("turnAxis", void 0);
        }
        typeof r3.deviceShaken == "function" && (this.pAccelerationX !== null && (e3 = Math.abs(this.accelerationX - this.pAccelerationX), t3 = Math.abs(this.accelerationY - this.pAccelerationY)), m2 < e3 + t3 && r3.deviceShaken());
      };
      var l2 = o2.default;
      r2.default = l2;
    }, { "../core/constants": 253, "../core/main": 264 }], 282: [function(e2, t2, r2) {
      Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, o2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      o2.default.prototype.isKeyPressed = false, o2.default.prototype.keyIsPressed = false, o2.default.prototype.key = "", o2.default.prototype.keyCode = 0, o2.default.prototype._onkeydown = function(e3) {
        if (!this._downKeys[e3.which]) {
          this._setProperty("isKeyPressed", true), this._setProperty("keyIsPressed", true), this._setProperty("keyCode", e3.which), this._downKeys[e3.which] = true, this._setProperty("key", e3.key || String.fromCharCode(e3.which) || e3.which);
          var t3 = this._isGlobal ? window : this;
          if (typeof t3.keyPressed == "function" && !e3.charCode)
            t3.keyPressed(e3) === false && e3.preventDefault();
        }
      }, o2.default.prototype._onkeyup = function(e3) {
        this._downKeys[e3.which] = false, this._areDownKeys() || (this._setProperty("isKeyPressed", false), this._setProperty("keyIsPressed", false)), this._setProperty("_lastKeyCodeTyped", null), this._setProperty("key", e3.key || String.fromCharCode(e3.which) || e3.which), this._setProperty("keyCode", e3.which);
        var t3 = this._isGlobal ? window : this;
        typeof t3.keyReleased == "function" && t3.keyReleased(e3) === false && e3.preventDefault();
      }, o2.default.prototype._onkeypress = function(e3) {
        if (e3.which !== this._lastKeyCodeTyped) {
          this._setProperty("_lastKeyCodeTyped", e3.which), this._setProperty("key", e3.key || String.fromCharCode(e3.which) || e3.which);
          var t3 = this._isGlobal ? window : this;
          if (typeof t3.keyTyped == "function")
            t3.keyTyped(e3) === false && e3.preventDefault();
        }
      }, o2.default.prototype._onblur = function(e3) {
        this._downKeys = {};
      }, o2.default.prototype.keyIsDown = function(e3) {
        return o2.default._validateParameters("keyIsDown", arguments), this._downKeys[e3] || false;
      }, o2.default.prototype._areDownKeys = function() {
        for (var e3 in this._downKeys)
          if (this._downKeys.hasOwnProperty(e3) && this._downKeys[e3] === true)
            return true;
        return false;
      };
      var i2 = o2.default;
      r2.default = i2;
    }, { "../core/main": 264 }], 283: [function(e2, t2, r2) {
      function a2(e3) {
        return (a2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      e2("core-js/modules/es.array.includes"), e2("core-js/modules/es.string.includes"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, o2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 }, i2 = function(e3) {
        if (e3 && e3.__esModule)
          return e3;
        if (e3 === null || a2(e3) !== "object" && typeof e3 != "function")
          return { default: e3 };
        var t3 = s();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o3 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o3)) {
            var i3 = n3 ? Object.getOwnPropertyDescriptor(e3, o3) : null;
            i3 && (i3.get || i3.set) ? Object.defineProperty(r3, o3, i3) : r3[o3] = e3[o3];
          }
        r3.default = e3, t3 && t3.set(e3, r3);
        return r3;
      }(e2("../core/constants"));
      function s() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return s = function() {
          return e3;
        }, e3;
      }
      o2.default.prototype.movedX = 0, o2.default.prototype.movedY = 0, o2.default.prototype._hasMouseInteracted = false, o2.default.prototype.mouseX = 0, o2.default.prototype.mouseY = 0, o2.default.prototype.pmouseX = 0, o2.default.prototype.pmouseY = 0, o2.default.prototype.winMouseX = 0, o2.default.prototype.winMouseY = 0, o2.default.prototype.pwinMouseX = 0, o2.default.prototype.pwinMouseY = 0, o2.default.prototype.mouseButton = 0, o2.default.prototype.mouseIsPressed = false, o2.default.prototype._updateNextMouseCoords = function(e3) {
        if (this._curElement !== null && (!e3.touches || 0 < e3.touches.length)) {
          var t3 = function(e4, t4, r3, n3) {
            n3 && !n3.clientX && (n3.touches ? n3 = n3.touches[0] : n3.changedTouches && (n3 = n3.changedTouches[0]));
            var o3 = e4.getBoundingClientRect(), i3 = e4.scrollWidth / t4 || 1, a3 = e4.scrollHeight / r3 || 1;
            return { x: (n3.clientX - o3.left) / i3, y: (n3.clientY - o3.top) / a3, winX: n3.clientX, winY: n3.clientY, id: n3.identifier };
          }(this._curElement.elt, this.width, this.height, e3);
          this._setProperty("movedX", e3.movementX), this._setProperty("movedY", e3.movementY), this._setProperty("mouseX", t3.x), this._setProperty("mouseY", t3.y), this._setProperty("winMouseX", t3.winX), this._setProperty("winMouseY", t3.winY);
        }
        this._hasMouseInteracted || (this._updateMouseCoords(), this._setProperty("_hasMouseInteracted", true));
      }, o2.default.prototype._updateMouseCoords = function() {
        this._setProperty("pmouseX", this.mouseX), this._setProperty("pmouseY", this.mouseY), this._setProperty("pwinMouseX", this.winMouseX), this._setProperty("pwinMouseY", this.winMouseY), this._setProperty("_pmouseWheelDeltaY", this._mouseWheelDeltaY);
      }, o2.default.prototype._setMouseButton = function(e3) {
        e3.button === 1 ? this._setProperty("mouseButton", i2.CENTER) : e3.button === 2 ? this._setProperty("mouseButton", i2.RIGHT) : this._setProperty("mouseButton", i2.LEFT);
      }, o2.default.prototype._onmousemove = function(e3) {
        var t3 = this._isGlobal ? window : this;
        this._updateNextMouseCoords(e3), this.mouseIsPressed ? typeof t3.mouseDragged == "function" ? t3.mouseDragged(e3) === false && e3.preventDefault() : typeof t3.touchMoved == "function" && t3.touchMoved(e3) === false && e3.preventDefault() : typeof t3.mouseMoved == "function" && t3.mouseMoved(e3) === false && e3.preventDefault();
      }, o2.default.prototype._onmousedown = function(e3) {
        var t3 = this._isGlobal ? window : this;
        this._setProperty("mouseIsPressed", true), this._setMouseButton(e3), this._updateNextMouseCoords(e3), typeof t3.mousePressed == "function" ? t3.mousePressed(e3) === false && e3.preventDefault() : navigator.userAgent.toLowerCase().includes("safari") && typeof t3.touchStarted == "function" && t3.touchStarted(e3) === false && e3.preventDefault();
      }, o2.default.prototype._onmouseup = function(e3) {
        var t3 = this._isGlobal ? window : this;
        this._setProperty("mouseIsPressed", false), typeof t3.mouseReleased == "function" ? t3.mouseReleased(e3) === false && e3.preventDefault() : typeof t3.touchEnded == "function" && t3.touchEnded(e3) === false && e3.preventDefault();
      }, o2.default.prototype._ondragend = o2.default.prototype._onmouseup, o2.default.prototype._ondragover = o2.default.prototype._onmousemove, o2.default.prototype._onclick = function(e3) {
        var t3 = this._isGlobal ? window : this;
        typeof t3.mouseClicked == "function" && t3.mouseClicked(e3) === false && e3.preventDefault();
      }, o2.default.prototype._ondblclick = function(e3) {
        var t3 = this._isGlobal ? window : this;
        typeof t3.doubleClicked == "function" && t3.doubleClicked(e3) === false && e3.preventDefault();
      }, o2.default.prototype._mouseWheelDeltaY = 0, o2.default.prototype._pmouseWheelDeltaY = 0, o2.default.prototype._onwheel = function(e3) {
        var t3 = this._isGlobal ? window : this;
        this._setProperty("_mouseWheelDeltaY", e3.deltaY), typeof t3.mouseWheel == "function" && (e3.delta = e3.deltaY, t3.mouseWheel(e3) === false && e3.preventDefault());
      }, o2.default.prototype.requestPointerLock = function() {
        var e3 = this._curElement.elt;
        return e3.requestPointerLock = e3.requestPointerLock || e3.mozRequestPointerLock, e3.requestPointerLock ? (e3.requestPointerLock(), true) : (console.log("requestPointerLock is not implemented in this browser"), false);
      }, o2.default.prototype.exitPointerLock = function() {
        document.exitPointerLock();
      };
      var l2 = o2.default;
      r2.default = l2;
    }, { "../core/constants": 253, "../core/main": 264, "core-js/modules/es.array.includes": 156, "core-js/modules/es.string.includes": 185 }], 284: [function(e2, t2, r2) {
      e2("core-js/modules/es.array.includes"), e2("core-js/modules/es.string.includes"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, o2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      function i2(e3, t3, r3, n3, o3) {
        var i3 = 4 < arguments.length && o3 !== void 0 ? o3 : 0, a3 = e3.getBoundingClientRect(), s = e3.scrollWidth / t3 || 1, l2 = e3.scrollHeight / r3 || 1, u2 = n3.touches[i3] || n3.changedTouches[i3];
        return { x: (u2.clientX - a3.left) / s, y: (u2.clientY - a3.top) / l2, winX: u2.clientX, winY: u2.clientY, id: u2.identifier };
      }
      o2.default.prototype.touches = [], o2.default.prototype._updateTouchCoords = function(e3) {
        if (this._curElement !== null) {
          for (var t3 = [], r3 = 0; r3 < e3.touches.length; r3++)
            t3[r3] = i2(this._curElement.elt, this.width, this.height, e3, r3);
          this._setProperty("touches", t3);
        }
      }, o2.default.prototype._ontouchstart = function(e3) {
        var t3 = this._isGlobal ? window : this;
        this._setProperty("mouseIsPressed", true), this._updateTouchCoords(e3), this._updateNextMouseCoords(e3), this._updateMouseCoords(), typeof t3.touchStarted == "function" ? t3.touchStarted(e3) === false && e3.preventDefault() : navigator.userAgent.toLowerCase().includes("safari") && typeof t3.mousePressed == "function" && t3.mousePressed(e3) === false && e3.preventDefault();
      }, o2.default.prototype._ontouchmove = function(e3) {
        var t3 = this._isGlobal ? window : this;
        this._updateTouchCoords(e3), this._updateNextMouseCoords(e3), typeof t3.touchMoved == "function" ? t3.touchMoved(e3) === false && e3.preventDefault() : typeof t3.mouseDragged == "function" && t3.mouseDragged(e3) === false && e3.preventDefault();
      }, o2.default.prototype._ontouchend = function(e3) {
        this._setProperty("mouseIsPressed", false), this._updateTouchCoords(e3), this._updateNextMouseCoords(e3);
        var t3 = this._isGlobal ? window : this;
        typeof t3.touchEnded == "function" ? t3.touchEnded(e3) === false && e3.preventDefault() : typeof t3.mouseReleased == "function" && t3.mouseReleased(e3) === false && e3.preventDefault();
      };
      var a2 = o2.default;
      r2.default = a2;
    }, { "../core/main": 264, "core-js/modules/es.array.includes": 156, "core-js/modules/es.string.includes": 185 }], 285: [function(e2, t2, r2) {
      e2("core-js/modules/es.array.iterator"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.typed-array.int32-array"), e2("core-js/modules/es.typed-array.uint8-array"), e2("core-js/modules/es.typed-array.copy-within"), e2("core-js/modules/es.typed-array.every"), e2("core-js/modules/es.typed-array.fill"), e2("core-js/modules/es.typed-array.filter"), e2("core-js/modules/es.typed-array.find"), e2("core-js/modules/es.typed-array.find-index"), e2("core-js/modules/es.typed-array.for-each"), e2("core-js/modules/es.typed-array.includes"), e2("core-js/modules/es.typed-array.index-of"), e2("core-js/modules/es.typed-array.iterator"), e2("core-js/modules/es.typed-array.join"), e2("core-js/modules/es.typed-array.last-index-of"), e2("core-js/modules/es.typed-array.map"), e2("core-js/modules/es.typed-array.reduce"), e2("core-js/modules/es.typed-array.reduce-right"), e2("core-js/modules/es.typed-array.reverse"), e2("core-js/modules/es.typed-array.set"), e2("core-js/modules/es.typed-array.slice"), e2("core-js/modules/es.typed-array.some"), e2("core-js/modules/es.typed-array.sort"), e2("core-js/modules/es.typed-array.subarray"), e2("core-js/modules/es.typed-array.to-locale-string"), e2("core-js/modules/es.typed-array.to-string"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var O2, C, L, P2, A = {};
      function n2(e3, t3) {
        for (var r3, n3, o3, i2, a2, s, l2, u2, c, d, f = A._toPixels(e3), h2 = e3.width, p2 = e3.height, y = h2 * p2, m2 = new Int32Array(y), g = 0; g < y; g++)
          m2[g] = A._getARGB(f, g);
        var v, b2, _, x, w = new Int32Array(y), j = new Int32Array(y), S2 = new Int32Array(y), M = new Int32Array(y), E = 0;
        for (!function(e4) {
          var t4 = 3.5 * e4 | 0;
          if (O2 !== (t4 = t4 < 1 ? 1 : t4 < 248 ? t4 : 248)) {
            C = 1 + (O2 = t4) << 1, L = new Int32Array(C), P2 = new Array(C);
            for (var r4 = 0; r4 < C; r4++)
              P2[r4] = new Int32Array(256);
            for (var n4, o4, i3, a3, s2 = 1, l3 = t4 - 1; s2 < t4; s2++) {
              L[t4 + s2] = L[l3] = o4 = l3 * l3, i3 = P2[t4 + s2], a3 = P2[l3--];
              for (var u3 = 0; u3 < 256; u3++)
                i3[u3] = a3[u3] = o4 * u3;
            }
            n4 = L[t4] = t4 * t4, i3 = P2[t4];
            for (var c2 = 0; c2 < 256; c2++)
              i3[c2] = n4 * c2;
          }
        }(t3), b2 = 0; b2 < p2; b2++) {
          for (v = 0; v < h2; v++) {
            if (i2 = o3 = n3 = a2 = r3 = 0, (s = v - O2) < 0)
              d = -s, s = 0;
            else {
              if (h2 <= s)
                break;
              d = 0;
            }
            for (_ = d; _ < C && !(h2 <= s); _++) {
              var T2 = m2[s + E];
              a2 += (x = P2[_])[(-16777216 & T2) >>> 24], n3 += x[(16711680 & T2) >> 16], o3 += x[(65280 & T2) >> 8], i2 += x[255 & T2], r3 += L[_], s++;
            }
            w[l2 = E + v] = a2 / r3, j[l2] = n3 / r3, S2[l2] = o3 / r3, M[l2] = i2 / r3;
          }
          E += h2;
        }
        for (c = (u2 = -O2) * h2, b2 = E = 0; b2 < p2; b2++) {
          for (v = 0; v < h2; v++) {
            if (i2 = o3 = n3 = a2 = r3 = 0, u2 < 0)
              d = l2 = -u2, s = v;
            else {
              if (p2 <= u2)
                break;
              d = 0, l2 = u2, s = v + c;
            }
            for (_ = d; _ < C && !(p2 <= l2); _++)
              a2 += (x = P2[_])[w[s]], n3 += x[j[s]], o3 += x[S2[s]], i2 += x[M[s]], r3 += L[_], l2++, s += h2;
            m2[v + E] = a2 / r3 << 24 | n3 / r3 << 16 | o3 / r3 << 8 | i2 / r3;
          }
          E += h2, c += h2, u2++;
        }
        A._setPixels(f, m2);
      }
      A._toPixels = function(e3) {
        if (e3 instanceof ImageData)
          return e3.data;
        if (e3.getContext("2d"))
          return e3.getContext("2d").getImageData(0, 0, e3.width, e3.height).data;
        if (e3.getContext("webgl")) {
          var t3 = e3.getContext("webgl"), r3 = t3.drawingBufferWidth * t3.drawingBufferHeight * 4, n3 = new Uint8Array(r3);
          return t3.readPixels(0, 0, e3.width, e3.height, t3.RGBA, t3.UNSIGNED_BYTE, n3), n3;
        }
      }, A._getARGB = function(e3, t3) {
        var r3 = 4 * t3;
        return e3[3 + r3] << 24 & 4278190080 | e3[r3] << 16 & 16711680 | e3[1 + r3] << 8 & 65280 | 255 & e3[2 + r3];
      }, A._setPixels = function(e3, t3) {
        for (var r3 = 0, n3 = 0, o3 = e3.length; n3 < o3; n3++)
          e3[(r3 = 4 * n3) + 0] = (16711680 & t3[n3]) >>> 16, e3[r3 + 1] = (65280 & t3[n3]) >>> 8, e3[r3 + 2] = 255 & t3[n3], e3[r3 + 3] = (4278190080 & t3[n3]) >>> 24;
      }, A._toImageData = function(e3) {
        return e3 instanceof ImageData ? e3 : e3.getContext("2d").getImageData(0, 0, e3.width, e3.height);
      }, A._createImageData = function(e3, t3) {
        return A._tmpCanvas = document.createElement("canvas"), A._tmpCtx = A._tmpCanvas.getContext("2d"), this._tmpCtx.createImageData(e3, t3);
      }, A.apply = function(e3, t3, r3) {
        var n3 = e3.getContext("2d"), o3 = n3.getImageData(0, 0, e3.width, e3.height), i2 = t3(o3, r3);
        i2 instanceof ImageData ? n3.putImageData(i2, 0, 0, 0, 0, e3.width, e3.height) : n3.putImageData(o3, 0, 0, 0, 0, e3.width, e3.height);
      }, A.threshold = function(e3, t3) {
        var r3 = A._toPixels(e3);
        t3 === void 0 && (t3 = 0.5);
        for (var n3 = Math.floor(255 * t3), o3 = 0; o3 < r3.length; o3 += 4) {
          var i2 = void 0;
          i2 = n3 <= 0.2126 * r3[o3] + 0.7152 * r3[o3 + 1] + 0.0722 * r3[o3 + 2] ? 255 : 0, r3[o3] = r3[o3 + 1] = r3[o3 + 2] = i2;
        }
      }, A.gray = function(e3) {
        for (var t3 = A._toPixels(e3), r3 = 0; r3 < t3.length; r3 += 4) {
          var n3 = 0.2126 * t3[r3] + 0.7152 * t3[r3 + 1] + 0.0722 * t3[r3 + 2];
          t3[r3] = t3[r3 + 1] = t3[r3 + 2] = n3;
        }
      }, A.opaque = function(e3) {
        for (var t3 = A._toPixels(e3), r3 = 0; r3 < t3.length; r3 += 4)
          t3[r3 + 3] = 255;
        return t3;
      }, A.invert = function(e3) {
        for (var t3 = A._toPixels(e3), r3 = 0; r3 < t3.length; r3 += 4)
          t3[r3] = 255 - t3[r3], t3[r3 + 1] = 255 - t3[r3 + 1], t3[r3 + 2] = 255 - t3[r3 + 2];
      }, A.posterize = function(e3, t3) {
        var r3 = A._toPixels(e3);
        if (t3 < 2 || 255 < t3)
          throw new Error("Level must be greater than 2 and less than 255 for posterize");
        for (var n3 = t3 - 1, o3 = 0; o3 < r3.length; o3 += 4) {
          var i2 = r3[o3], a2 = r3[o3 + 1], s = r3[o3 + 2];
          r3[o3] = 255 * (i2 * t3 >> 8) / n3, r3[o3 + 1] = 255 * (a2 * t3 >> 8) / n3, r3[o3 + 2] = 255 * (s * t3 >> 8) / n3;
        }
      }, A.dilate = function(e3) {
        for (var t3, r3, n3, o3, i2, a2, s, l2, u2, c, d, f, h2, p2, y, m2, g, v = A._toPixels(e3), b2 = 0, _ = v.length ? v.length / 4 : 0, x = new Int32Array(_); b2 < _; )
          for (r3 = (t3 = b2) + e3.width; b2 < r3; )
            n3 = o3 = A._getARGB(v, b2), (s = b2 - 1) < t3 && (s = b2), r3 <= (a2 = b2 + 1) && (a2 = b2), (l2 = b2 - e3.width) < 0 && (l2 = 0), _ <= (u2 = b2 + e3.width) && (u2 = b2), f = A._getARGB(v, l2), d = A._getARGB(v, s), h2 = A._getARGB(v, u2), (i2 = 77 * (n3 >> 16 & 255) + 151 * (n3 >> 8 & 255) + 28 * (255 & n3)) < (y = 77 * (d >> 16 & 255) + 151 * (d >> 8 & 255) + 28 * (255 & d)) && (o3 = d, i2 = y), i2 < (p2 = 77 * ((c = A._getARGB(v, a2)) >> 16 & 255) + 151 * (c >> 8 & 255) + 28 * (255 & c)) && (o3 = c, i2 = p2), i2 < (m2 = 77 * (f >> 16 & 255) + 151 * (f >> 8 & 255) + 28 * (255 & f)) && (o3 = f, i2 = m2), i2 < (g = 77 * (h2 >> 16 & 255) + 151 * (h2 >> 8 & 255) + 28 * (255 & h2)) && (o3 = h2, i2 = g), x[b2++] = o3;
        A._setPixels(v, x);
      }, A.erode = function(e3) {
        for (var t3, r3, n3, o3, i2, a2, s, l2, u2, c, d, f, h2, p2, y, m2, g, v = A._toPixels(e3), b2 = 0, _ = v.length ? v.length / 4 : 0, x = new Int32Array(_); b2 < _; )
          for (r3 = (t3 = b2) + e3.width; b2 < r3; )
            n3 = o3 = A._getARGB(v, b2), (s = b2 - 1) < t3 && (s = b2), r3 <= (a2 = b2 + 1) && (a2 = b2), (l2 = b2 - e3.width) < 0 && (l2 = 0), _ <= (u2 = b2 + e3.width) && (u2 = b2), f = A._getARGB(v, l2), d = A._getARGB(v, s), h2 = A._getARGB(v, u2), (y = 77 * (d >> 16 & 255) + 151 * (d >> 8 & 255) + 28 * (255 & d)) < (i2 = 77 * (n3 >> 16 & 255) + 151 * (n3 >> 8 & 255) + 28 * (255 & n3)) && (o3 = d, i2 = y), (p2 = 77 * ((c = A._getARGB(v, a2)) >> 16 & 255) + 151 * (c >> 8 & 255) + 28 * (255 & c)) < i2 && (o3 = c, i2 = p2), (m2 = 77 * (f >> 16 & 255) + 151 * (f >> 8 & 255) + 28 * (255 & f)) < i2 && (o3 = f, i2 = m2), (g = 77 * (h2 >> 16 & 255) + 151 * (h2 >> 8 & 255) + 28 * (255 & h2)) < i2 && (o3 = h2, i2 = g), x[b2++] = o3;
        A._setPixels(v, x);
      }, A.blur = function(e3, t3) {
        n2(e3, t3);
      };
      var o2 = A;
      r2.default = o2;
    }, { "core-js/modules/es.array.iterator": 158, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.typed-array.copy-within": 197, "core-js/modules/es.typed-array.every": 198, "core-js/modules/es.typed-array.fill": 199, "core-js/modules/es.typed-array.filter": 200, "core-js/modules/es.typed-array.find": 202, "core-js/modules/es.typed-array.find-index": 201, "core-js/modules/es.typed-array.for-each": 205, "core-js/modules/es.typed-array.includes": 206, "core-js/modules/es.typed-array.index-of": 207, "core-js/modules/es.typed-array.int32-array": 209, "core-js/modules/es.typed-array.iterator": 210, "core-js/modules/es.typed-array.join": 211, "core-js/modules/es.typed-array.last-index-of": 212, "core-js/modules/es.typed-array.map": 213, "core-js/modules/es.typed-array.reduce": 215, "core-js/modules/es.typed-array.reduce-right": 214, "core-js/modules/es.typed-array.reverse": 216, "core-js/modules/es.typed-array.set": 217, "core-js/modules/es.typed-array.slice": 218, "core-js/modules/es.typed-array.some": 219, "core-js/modules/es.typed-array.sort": 220, "core-js/modules/es.typed-array.subarray": 221, "core-js/modules/es.typed-array.to-locale-string": 222, "core-js/modules/es.typed-array.to-string": 223, "core-js/modules/es.typed-array.uint8-array": 226 }], 286: [function(e2, t2, r2) {
      e2("core-js/modules/es.symbol"), e2("core-js/modules/es.symbol.description"), e2("core-js/modules/es.symbol.iterator"), e2("core-js/modules/es.array.concat"), e2("core-js/modules/es.array.filter"), e2("core-js/modules/es.array.from"), e2("core-js/modules/es.array.iterator"), e2("core-js/modules/es.array.map"), e2("core-js/modules/es.array.slice"), e2("core-js/modules/es.object.keys"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.regexp.exec"), e2("core-js/modules/es.regexp.to-string"), e2("core-js/modules/es.set"), e2("core-js/modules/es.string.iterator"), e2("core-js/modules/es.string.replace"), e2("core-js/modules/es.string.split"), e2("core-js/modules/es.typed-array.uint8-array"), e2("core-js/modules/es.typed-array.uint32-array"), e2("core-js/modules/es.typed-array.copy-within"), e2("core-js/modules/es.typed-array.every"), e2("core-js/modules/es.typed-array.fill"), e2("core-js/modules/es.typed-array.filter"), e2("core-js/modules/es.typed-array.find"), e2("core-js/modules/es.typed-array.find-index"), e2("core-js/modules/es.typed-array.for-each"), e2("core-js/modules/es.typed-array.includes"), e2("core-js/modules/es.typed-array.index-of"), e2("core-js/modules/es.typed-array.iterator"), e2("core-js/modules/es.typed-array.join"), e2("core-js/modules/es.typed-array.last-index-of"), e2("core-js/modules/es.typed-array.map"), e2("core-js/modules/es.typed-array.reduce"), e2("core-js/modules/es.typed-array.reduce-right"), e2("core-js/modules/es.typed-array.reverse"), e2("core-js/modules/es.typed-array.set"), e2("core-js/modules/es.typed-array.slice"), e2("core-js/modules/es.typed-array.some"), e2("core-js/modules/es.typed-array.sort"), e2("core-js/modules/es.typed-array.subarray"), e2("core-js/modules/es.typed-array.to-locale-string"), e2("core-js/modules/es.typed-array.to-string"), e2("core-js/modules/web.dom-collections.iterator"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var A = n2(e2("../core/main")), k2 = n2(e2("omggif"));
      function n2(e3) {
        return e3 && e3.__esModule ? e3 : { default: e3 };
      }
      function R2(e3) {
        return function(e4) {
          if (Array.isArray(e4)) {
            for (var t3 = 0, r3 = new Array(e4.length); t3 < e4.length; t3++)
              r3[t3] = e4[t3];
            return r3;
          }
        }(e3) || function(e4) {
          if (Symbol.iterator in Object(e4) || Object.prototype.toString.call(e4) === "[object Arguments]")
            return Array.from(e4);
        }(e3) || function() {
          throw new TypeError("Invalid attempt to spread non-iterable instance");
        }();
      }
      A.default.prototype.createImage = function(e3, t3) {
        return A.default._validateParameters("createImage", arguments), new A.default.Image(e3, t3);
      }, A.default.prototype.saveCanvas = function() {
        A.default._validateParameters("saveCanvas", arguments);
        var e3, t3, r3, n3, o3 = [].slice.call(arguments);
        switch (arguments[0] instanceof HTMLCanvasElement ? (e3 = arguments[0], o3.shift()) : arguments[0] instanceof A.default.Element ? (e3 = arguments[0].elt, o3.shift()) : e3 = this._curElement && this._curElement.elt, 1 <= o3.length && (t3 = o3[0]), 2 <= o3.length && (r3 = o3[1]), r3 = r3 || A.default.prototype._checkFileExtension(t3, r3)[1] || "png") {
          default:
            n3 = "image/png";
            break;
          case "jpeg":
          case "jpg":
            n3 = "image/jpeg";
        }
        e3.toBlob(function(e4) {
          A.default.prototype.downloadFile(e4, t3, r3);
        }, n3);
      }, A.default.prototype.saveGif = function(p2, e3) {
        var y = p2.gifProperties, t3 = y.loopLimit;
        t3 === 1 ? t3 = null : t3 === null && (t3 = 0);
        for (var r3 = new Uint8Array(p2.width * p2.height * y.numFrames), m2 = [], n3 = {}, o3 = 0; o3 < y.numFrames; o3++) {
          for (var i2 = /* @__PURE__ */ new Set(), a2 = y.frames[o3].image.data, s = a2.length, l2 = new Uint32Array(p2.width * p2.height), u2 = 0, c = 0; u2 < s; u2 += 4, c++) {
            var d = a2[u2 + 0] << 16 | a2[u2 + 1] << 8 | a2[u2 + 2] << 0;
            i2.add(d), l2[c] = d;
          }
          var f = R2(i2).sort().toString();
          n3[f] === void 0 ? n3[f] = { freq: 1, frames: [o3] } : (n3[f].freq += 1, n3[f].frames.push(o3)), m2.push(l2);
        }
        var g = [], h2 = Object.keys(n3).sort(function(e4, t4) {
          return n3[t4].freq - n3[e4].freq;
        }), v = h2[0].split(",").map(function(e4) {
          return parseInt(e4);
        });
        g = g.concat(n3[v].frames);
        for (var b2 = new Set(v), _ = 1; _ < h2.length; _++) {
          var x = h2[_].split(",").map(function(e4) {
            return parseInt(e4);
          }).filter(function(e4) {
            return !b2.has(e4);
          });
          if (v.length + x.length <= 256) {
            for (var w = 0; w < x.length; w++)
              v.push(x[w]), b2.add(x[w]);
            g = g.concat(n3[h2[_]].frames);
          }
        }
        g = new Set(g);
        for (var j = {}, S2 = 0; S2 < v.length; S2++)
          j[v[S2]] || (j[v[S2]] = S2);
        for (var M = 1; M < v.length; )
          M <<= 1;
        v.length = M;
        for (var E = { loop: t3, palette: new Uint32Array(v) }, T2 = new k2.default.GifWriter(r3, p2.width, p2.height, E), O2 = {}, C = function(e4) {
          for (var t4 = !g.has(e4), r4 = t4 ? [] : v, n4 = new Uint8Array(p2.width * p2.height), o4 = {}, i3 = /* @__PURE__ */ new Set(), a3 = 0; a3 < m2[e4].length; a3++) {
            var s2 = m2[e4][a3];
            t4 ? (o4[s2] === void 0 && (o4[s2] = r4.length, r4.push(s2)), n4[a3] = o4[s2]) : n4[a3] = j[s2], 0 < e4 && m2[e4 - 1][a3] !== s2 && i3.add(s2);
          }
          var l3 = {}, u3 = r4.filter(function(e5) {
            return !i3.has(e5);
          });
          if (0 < u3.length) {
            var c2 = u3[0], d2 = t4 ? o4[c2] : j[c2];
            if (0 < e4) {
              for (var f2 = 0; f2 < m2[e4].length; f2++)
                m2[e4 - 1][f2] === m2[e4][f2] && (n4[f2] = d2);
              l3.transparent = d2, O2.frameOpts.disposal = 1;
            }
          }
          if (l3.delay = y.frames[e4].delay / 10, t4) {
            for (var h3 = 1; h3 < r4.length; )
              h3 <<= 1;
            r4.length = h3, l3.palette = new Uint32Array(r4);
          }
          0 < e4 && T2.addFrame(0, 0, p2.width, p2.height, O2.pixelPaletteIndex, O2.frameOpts), O2 = { pixelPaletteIndex: n4, frameOpts: l3 };
        }, L = 0; L < y.numFrames; L++)
          C(L);
        O2.frameOpts.disposal = 1, T2.addFrame(0, 0, p2.width, p2.height, O2.pixelPaletteIndex, O2.frameOpts);
        var P2 = new Blob([r3.slice(0, T2.end())], { type: "image/gif" });
        A.default.prototype.downloadFile(P2, e3, "gif");
      }, A.default.prototype.saveFrames = function(e3, t3, r3, n3, a2) {
        A.default._validateParameters("saveFrames", arguments);
        var o3 = r3 || 3;
        o3 = A.default.prototype.constrain(o3, 0, 15), o3 *= 1e3;
        var i2 = n3 || 15;
        i2 = A.default.prototype.constrain(i2, 0, 22);
        var s = 0, l2 = A.default.prototype._makeFrame, u2 = this._curElement.elt, c = [], d = setInterval(function() {
          c.push(l2(e3 + s, t3, u2)), s++;
        }, 1e3 / i2);
        setTimeout(function() {
          if (clearInterval(d), a2)
            a2(c);
          else {
            var e4 = true, t4 = false, r4 = void 0;
            try {
              for (var n4, o4 = c[Symbol.iterator](); !(e4 = (n4 = o4.next()).done); e4 = true) {
                var i3 = n4.value;
                A.default.prototype.downloadFile(i3.imageData, i3.filename, i3.ext);
              }
            } catch (e5) {
              t4 = true, r4 = e5;
            } finally {
              try {
                e4 || o4.return == null || o4.return();
              } finally {
                if (t4)
                  throw r4;
              }
            }
          }
          c = [];
        }, o3 + 0.01);
      }, A.default.prototype._makeFrame = function(e3, t3, r3) {
        var n3, o3;
        if (n3 = this ? this._curElement.elt : r3, t3)
          switch (t3.toLowerCase()) {
            case "png":
              o3 = "image/png";
              break;
            case "jpeg":
            case "jpg":
              o3 = "image/jpeg";
              break;
            default:
              o3 = "image/png";
          }
        else
          t3 = "png", o3 = "image/png";
        var i2 = n3.toDataURL(o3);
        i2 = i2.replace(o3, "image/octet-stream");
        var a2 = {};
        return a2.imageData = i2, a2.filename = e3, a2.ext = t3, a2;
      };
      var o2 = A.default;
      r2.default = o2;
    }, { "../core/main": 264, "core-js/modules/es.array.concat": 149, "core-js/modules/es.array.filter": 152, "core-js/modules/es.array.from": 155, "core-js/modules/es.array.iterator": 158, "core-js/modules/es.array.map": 161, "core-js/modules/es.array.slice": 162, "core-js/modules/es.object.keys": 176, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.regexp.exec": 181, "core-js/modules/es.regexp.to-string": 182, "core-js/modules/es.set": 183, "core-js/modules/es.string.iterator": 186, "core-js/modules/es.string.replace": 189, "core-js/modules/es.string.split": 191, "core-js/modules/es.symbol": 196, "core-js/modules/es.symbol.description": 194, "core-js/modules/es.symbol.iterator": 195, "core-js/modules/es.typed-array.copy-within": 197, "core-js/modules/es.typed-array.every": 198, "core-js/modules/es.typed-array.fill": 199, "core-js/modules/es.typed-array.filter": 200, "core-js/modules/es.typed-array.find": 202, "core-js/modules/es.typed-array.find-index": 201, "core-js/modules/es.typed-array.for-each": 205, "core-js/modules/es.typed-array.includes": 206, "core-js/modules/es.typed-array.index-of": 207, "core-js/modules/es.typed-array.iterator": 210, "core-js/modules/es.typed-array.join": 211, "core-js/modules/es.typed-array.last-index-of": 212, "core-js/modules/es.typed-array.map": 213, "core-js/modules/es.typed-array.reduce": 215, "core-js/modules/es.typed-array.reduce-right": 214, "core-js/modules/es.typed-array.reverse": 216, "core-js/modules/es.typed-array.set": 217, "core-js/modules/es.typed-array.slice": 218, "core-js/modules/es.typed-array.some": 219, "core-js/modules/es.typed-array.sort": 220, "core-js/modules/es.typed-array.subarray": 221, "core-js/modules/es.typed-array.to-locale-string": 222, "core-js/modules/es.typed-array.to-string": 223, "core-js/modules/es.typed-array.uint32-array": 225, "core-js/modules/es.typed-array.uint8-array": 226, "core-js/modules/web.dom-collections.iterator": 229, omggif: 238 }], 287: [function(e2, t2, r2) {
      function a2(e3) {
        return (a2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      e2("core-js/modules/es.array.includes"), e2("core-js/modules/es.array.index-of"), e2("core-js/modules/es.array.iterator"), e2("core-js/modules/es.array.slice"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.promise"), e2("core-js/modules/es.string.includes"), e2("core-js/modules/es.typed-array.uint8-array"), e2("core-js/modules/es.typed-array.uint8-clamped-array"), e2("core-js/modules/es.typed-array.copy-within"), e2("core-js/modules/es.typed-array.every"), e2("core-js/modules/es.typed-array.fill"), e2("core-js/modules/es.typed-array.filter"), e2("core-js/modules/es.typed-array.find"), e2("core-js/modules/es.typed-array.find-index"), e2("core-js/modules/es.typed-array.for-each"), e2("core-js/modules/es.typed-array.includes"), e2("core-js/modules/es.typed-array.index-of"), e2("core-js/modules/es.typed-array.iterator"), e2("core-js/modules/es.typed-array.join"), e2("core-js/modules/es.typed-array.last-index-of"), e2("core-js/modules/es.typed-array.map"), e2("core-js/modules/es.typed-array.reduce"), e2("core-js/modules/es.typed-array.reduce-right"), e2("core-js/modules/es.typed-array.reverse"), e2("core-js/modules/es.typed-array.set"), e2("core-js/modules/es.typed-array.slice"), e2("core-js/modules/es.typed-array.some"), e2("core-js/modules/es.typed-array.sort"), e2("core-js/modules/es.typed-array.subarray"), e2("core-js/modules/es.typed-array.to-locale-string"), e2("core-js/modules/es.typed-array.to-string"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var x = o2(e2("../core/main")), d = o2(e2("./filters")), w = o2(e2("../core/helpers")), n2 = function(e3) {
        if (e3 && e3.__esModule)
          return e3;
        if (e3 === null || a2(e3) !== "object" && typeof e3 != "function")
          return { default: e3 };
        var t3 = s();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o3 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o3)) {
            var i3 = n3 ? Object.getOwnPropertyDescriptor(e3, o3) : null;
            i3 && (i3.get || i3.set) ? Object.defineProperty(r3, o3, i3) : r3[o3] = e3[o3];
          }
        r3.default = e3, t3 && t3.set(e3, r3);
        return r3;
      }(e2("../core/constants")), m2 = o2(e2("omggif"));
      function s() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return s = function() {
          return e3;
        }, e3;
      }
      function o2(e3) {
        return e3 && e3.__esModule ? e3 : { default: e3 };
      }
      function j(e3, t3) {
        return 0 < e3 && e3 < t3 ? e3 : t3;
      }
      e2("../core/friendly_errors/validate_params"), e2("../core/friendly_errors/file_errors"), e2("../core/friendly_errors/fes_core"), x.default.prototype.loadImage = function(n3, o3, i3) {
        x.default._validateParameters("loadImage", arguments);
        var a3 = new x.default.Image(1, 1, this), s2 = this, e3 = new Request(n3, { method: "GET", mode: "cors" });
        return fetch(n3, e3).then(function(e4) {
          var t3 = e4.headers.get("content-type");
          if (t3 === null && console.warn("The image you loaded does not have a Content-Type header. If you are using the online editor consider reuploading the asset."), t3 && t3.includes("image/gif"))
            e4.arrayBuffer().then(function(e5) {
              e5 && function(e6, r4, t4, n4, o4) {
                var i4 = new m2.default.GifReader(e6);
                r4.width = r4.canvas.width = i4.width, r4.height = r4.canvas.height = i4.height;
                var a4 = [], s3 = i4.numFrames(), l2 = new Uint8ClampedArray(r4.width * r4.height * 4);
                if (1 < s3) {
                  for (var u2 = function(e7, t5) {
                    try {
                      t5.decodeAndBlitFrameRGBA(e7, l2);
                    } catch (e8) {
                      x.default._friendlyFileLoadError(8, r4.src), typeof n4 == "function" ? n4(e8) : console.error(e8);
                    }
                  }, c = 0; c < s3; c++) {
                    var d2 = i4.frameInfo(c), f = r4.drawingContext.getImageData(0, 0, r4.width, r4.height);
                    l2 = f.data.slice(), u2(c, i4);
                    var h2 = new ImageData(l2, r4.width, r4.height);
                    r4.drawingContext.putImageData(h2, 0, 0);
                    var p2 = d2.delay;
                    p2 === 0 && (p2 = 10), a4.push({ image: r4.drawingContext.getImageData(0, 0, r4.width, r4.height), delay: 10 * p2 }), d2.disposal === 2 ? r4.drawingContext.clearRect(d2.x, d2.y, d2.width, d2.height) : d2.disposal === 3 && r4.drawingContext.putImageData(f, 0, 0, d2.x, d2.y, d2.width, d2.height);
                  }
                  var y = i4.loopCount();
                  y === null ? y = 1 : y === 0 && (y = null), r4.drawingContext.putImageData(a4[0].image, 0, 0), r4.gifProperties = { displayIndex: 0, loopLimit: y, loopCount: 0, frames: a4, numFrames: s3, playing: true, timeDisplayed: 0, lastChangeTime: 0 };
                }
                typeof t4 == "function" && t4(r4);
                o4();
              }(new Uint8Array(e5), a3, o3, i3, function(e6) {
                s2._decrementPreload();
              }.bind(s2));
            }, function(e5) {
              typeof i3 == "function" ? i3(e5) : console.error(e5);
            });
          else {
            var r3 = new Image();
            r3.onload = function() {
              a3.width = a3.canvas.width = r3.width, a3.height = a3.canvas.height = r3.height, a3.drawingContext.drawImage(r3, 0, 0), a3.modified = true, typeof o3 == "function" && o3(a3), s2._decrementPreload();
            }, r3.onerror = function(e5) {
              x.default._friendlyFileLoadError(0, r3.src), typeof i3 == "function" ? i3(e5) : console.error(e5);
            }, n3.indexOf("data:image/") !== 0 && (r3.crossOrigin = "Anonymous"), r3.src = n3;
          }
          a3.modified = true;
        }).catch(function(e4) {
          x.default._friendlyFileLoadError(0, n3), typeof i3 == "function" ? i3(e4) : console.error(e4);
        }), a3;
      }, x.default.prototype.image = function(e3, t3, r3, n3, o3, i3, a3, s2, l2) {
        x.default._validateParameters("image", arguments);
        var u2 = e3.width, c = e3.height;
        e3.elt && e3.elt.videoWidth && !e3.canvas && (u2 = e3.elt.videoWidth, c = e3.elt.videoHeight);
        var d2 = t3, f = r3, h2 = n3 || u2, p2 = o3 || c, y = i3 || 0, m3 = a3 || 0, g = s2 || u2, v = l2 || c;
        g = j(g, u2), v = j(v, c);
        var b2 = 1;
        e3.elt && !e3.canvas && e3.elt.style.width && (b2 = e3.elt.videoWidth && !n3 ? e3.elt.videoWidth : e3.elt.width, b2 /= parseInt(e3.elt.style.width, 10)), y *= b2, m3 *= b2, v *= b2, g *= b2;
        var _ = w.default.modeAdjust(d2, f, h2, p2, this._renderer._imageMode);
        this._renderer.image(e3, y, m3, g, v, _.x, _.y, _.w, _.h);
      }, x.default.prototype.tint = function() {
        for (var e3 = arguments.length, t3 = new Array(e3), r3 = 0; r3 < e3; r3++)
          t3[r3] = arguments[r3];
        x.default._validateParameters("tint", t3);
        var n3 = this.color.apply(this, t3);
        this._renderer._tint = n3.levels;
      }, x.default.prototype.noTint = function() {
        this._renderer._tint = null;
      }, x.default.prototype._getTintedImageCanvas = function(e3) {
        if (!e3.canvas)
          return e3;
        var t3 = d.default._toPixels(e3.canvas), r3 = document.createElement("canvas");
        r3.width = e3.canvas.width, r3.height = e3.canvas.height;
        for (var n3 = r3.getContext("2d"), o3 = n3.createImageData(e3.canvas.width, e3.canvas.height), i3 = o3.data, a3 = 0; a3 < t3.length; a3 += 4) {
          var s2 = t3[a3], l2 = t3[a3 + 1], u2 = t3[a3 + 2], c = t3[a3 + 3];
          i3[a3] = s2 * this._renderer._tint[0] / 255, i3[a3 + 1] = l2 * this._renderer._tint[1] / 255, i3[a3 + 2] = u2 * this._renderer._tint[2] / 255, i3[a3 + 3] = c * this._renderer._tint[3] / 255;
        }
        return n3.putImageData(o3, 0, 0), r3;
      }, x.default.prototype.imageMode = function(e3) {
        x.default._validateParameters("imageMode", arguments), e3 !== n2.CORNER && e3 !== n2.CORNERS && e3 !== n2.CENTER || (this._renderer._imageMode = e3);
      };
      var i2 = x.default;
      r2.default = i2;
    }, { "../core/constants": 253, "../core/friendly_errors/fes_core": 255, "../core/friendly_errors/file_errors": 256, "../core/friendly_errors/validate_params": 259, "../core/helpers": 260, "../core/main": 264, "./filters": 285, "core-js/modules/es.array.includes": 156, "core-js/modules/es.array.index-of": 157, "core-js/modules/es.array.iterator": 158, "core-js/modules/es.array.slice": 162, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.promise": 178, "core-js/modules/es.string.includes": 185, "core-js/modules/es.typed-array.copy-within": 197, "core-js/modules/es.typed-array.every": 198, "core-js/modules/es.typed-array.fill": 199, "core-js/modules/es.typed-array.filter": 200, "core-js/modules/es.typed-array.find": 202, "core-js/modules/es.typed-array.find-index": 201, "core-js/modules/es.typed-array.for-each": 205, "core-js/modules/es.typed-array.includes": 206, "core-js/modules/es.typed-array.index-of": 207, "core-js/modules/es.typed-array.iterator": 210, "core-js/modules/es.typed-array.join": 211, "core-js/modules/es.typed-array.last-index-of": 212, "core-js/modules/es.typed-array.map": 213, "core-js/modules/es.typed-array.reduce": 215, "core-js/modules/es.typed-array.reduce-right": 214, "core-js/modules/es.typed-array.reverse": 216, "core-js/modules/es.typed-array.set": 217, "core-js/modules/es.typed-array.slice": 218, "core-js/modules/es.typed-array.some": 219, "core-js/modules/es.typed-array.sort": 220, "core-js/modules/es.typed-array.subarray": 221, "core-js/modules/es.typed-array.to-locale-string": 222, "core-js/modules/es.typed-array.to-string": 223, "core-js/modules/es.typed-array.uint8-array": 226, "core-js/modules/es.typed-array.uint8-clamped-array": 227, omggif: 238 }], 288: [function(e2, t2, r2) {
      e2("core-js/modules/es.symbol"), e2("core-js/modules/es.symbol.description"), e2("core-js/modules/es.symbol.iterator"), e2("core-js/modules/es.array.filter"), e2("core-js/modules/es.array.iterator"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.string.iterator"), e2("core-js/modules/web.dom-collections.iterator"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var o2 = i2(e2("../core/main")), n2 = i2(e2("./filters"));
      function i2(e3) {
        return e3 && e3.__esModule ? e3 : { default: e3 };
      }
      o2.default.Image = function(e3, t3) {
        this.width = e3, this.height = t3, this.canvas = document.createElement("canvas"), this.canvas.width = this.width, this.canvas.height = this.height, this.drawingContext = this.canvas.getContext("2d"), (this._pixelsState = this)._pixelDensity = 1, this.gifProperties = null, this._modified = false, this.pixels = [];
      }, o2.default.Image.prototype._animateGif = function(e3) {
        var t3 = this.gifProperties, r3 = e3._lastFrameTime;
        if (t3.lastChangeTime === 0 && (t3.lastChangeTime = r3), t3.playing) {
          t3.timeDisplayed = r3 - t3.lastChangeTime;
          var n3 = t3.frames[t3.displayIndex].delay;
          if (t3.timeDisplayed >= n3) {
            var o3 = Math.floor(t3.timeDisplayed / n3);
            if (t3.timeDisplayed = 0, t3.lastChangeTime = r3, t3.displayIndex += o3, t3.loopCount = Math.floor(t3.displayIndex / t3.numFrames), t3.loopLimit !== null && t3.loopCount >= t3.loopLimit)
              t3.playing = false;
            else {
              var i3 = t3.displayIndex % t3.numFrames;
              this.drawingContext.putImageData(t3.frames[i3].image, 0, 0), t3.displayIndex = i3, this.setModified(true);
            }
          }
        }
      }, o2.default.Image.prototype._setProperty = function(e3, t3) {
        this[e3] = t3, this.setModified(true);
      }, o2.default.Image.prototype.loadPixels = function() {
        o2.default.Renderer2D.prototype.loadPixels.call(this), this.setModified(true);
      }, o2.default.Image.prototype.updatePixels = function(e3, t3, r3, n3) {
        o2.default.Renderer2D.prototype.updatePixels.call(this, e3, t3, r3, n3), this.setModified(true);
      }, o2.default.Image.prototype.get = function(e3, t3, r3, n3) {
        return o2.default._validateParameters("p5.Image.get", arguments), o2.default.Renderer2D.prototype.get.apply(this, arguments);
      }, o2.default.Image.prototype._getPixel = o2.default.Renderer2D.prototype._getPixel, o2.default.Image.prototype.set = function(e3, t3, r3) {
        o2.default.Renderer2D.prototype.set.call(this, e3, t3, r3), this.setModified(true);
      }, o2.default.Image.prototype.resize = function(e3, t3) {
        e3 === 0 && t3 === 0 ? (e3 = this.canvas.width, t3 = this.canvas.height) : e3 === 0 ? e3 = this.canvas.width * t3 / this.canvas.height : t3 === 0 && (t3 = this.canvas.height * e3 / this.canvas.width), e3 = Math.floor(e3), t3 = Math.floor(t3);
        var r3 = document.createElement("canvas");
        if (r3.width = e3, r3.height = t3, this.gifProperties)
          for (var n3 = this.gifProperties, o3 = function(e4, t4) {
            for (var r4 = 0, n4 = 0; n4 < t4.height; n4++)
              for (var o4 = 0; o4 < t4.width; o4++) {
                var i4 = Math.floor(o4 * e4.width / t4.width), a4 = 4 * (Math.floor(n4 * e4.height / t4.height) * e4.width + i4);
                t4.data[r4++] = e4.data[a4++], t4.data[r4++] = e4.data[a4++], t4.data[r4++] = e4.data[a4++], t4.data[r4++] = e4.data[a4++];
              }
          }, i3 = 0; i3 < n3.numFrames; i3++) {
            var a3 = this.drawingContext.createImageData(e3, t3);
            o3(n3.frames[i3].image, a3), n3.frames[i3].image = a3;
          }
        r3.getContext("2d").drawImage(this.canvas, 0, 0, this.canvas.width, this.canvas.height, 0, 0, r3.width, r3.height), this.canvas.width = this.width = e3, this.canvas.height = this.height = t3, this.drawingContext.drawImage(r3, 0, 0, e3, t3, 0, 0, e3, t3), 0 < this.pixels.length && this.loadPixels(), this.setModified(true);
      }, o2.default.Image.prototype.copy = function() {
        for (var e3 = arguments.length, t3 = new Array(e3), r3 = 0; r3 < e3; r3++)
          t3[r3] = arguments[r3];
        o2.default.prototype.copy.apply(this, t3);
      }, o2.default.Image.prototype.mask = function(e3) {
        e3 === void 0 && (e3 = this);
        var t3 = this.drawingContext.globalCompositeOperation, r3 = 1;
        e3 instanceof o2.default.Renderer && (r3 = e3._pInst._pixelDensity);
        var n3 = [e3, 0, 0, r3 * e3.width, r3 * e3.height, 0, 0, this.width, this.height];
        this.drawingContext.globalCompositeOperation = "destination-in", o2.default.Image.prototype.copy.apply(this, n3), this.drawingContext.globalCompositeOperation = t3, this.setModified(true);
      }, o2.default.Image.prototype.filter = function(e3, t3) {
        n2.default.apply(this.canvas, n2.default[e3], t3), this.setModified(true);
      }, o2.default.Image.prototype.blend = function() {
        for (var e3 = arguments.length, t3 = new Array(e3), r3 = 0; r3 < e3; r3++)
          t3[r3] = arguments[r3];
        o2.default._validateParameters("p5.Image.blend", arguments), o2.default.prototype.blend.apply(this, t3), this.setModified(true);
      }, o2.default.Image.prototype.setModified = function(e3) {
        this._modified = e3;
      }, o2.default.Image.prototype.isModified = function() {
        return this._modified;
      }, o2.default.Image.prototype.save = function(e3, t3) {
        this.gifProperties ? o2.default.prototype.saveGif(this, e3) : o2.default.prototype.saveCanvas(this.canvas, e3, t3);
      }, o2.default.Image.prototype.reset = function() {
        if (this.gifProperties) {
          var e3 = this.gifProperties;
          e3.playing = true, e3.timeSinceStart = 0, e3.timeDisplayed = 0, e3.lastChangeTime = 0, e3.loopCount = 0, e3.displayIndex = 0, this.drawingContext.putImageData(e3.frames[0].image, 0, 0);
        }
      }, o2.default.Image.prototype.getCurrentFrame = function() {
        if (this.gifProperties) {
          var e3 = this.gifProperties;
          return e3.displayIndex % e3.numFrames;
        }
      }, o2.default.Image.prototype.setFrame = function(e3) {
        if (this.gifProperties) {
          var t3 = this.gifProperties;
          e3 < t3.numFrames && 0 <= e3 ? (t3.timeDisplayed = 0, t3.lastChangeTime = 0, t3.displayIndex = e3, this.drawingContext.putImageData(t3.frames[e3].image, 0, 0)) : console.log("Cannot set GIF to a frame number that is higher than total number of frames or below zero.");
        }
      }, o2.default.Image.prototype.numFrames = function() {
        if (this.gifProperties)
          return this.gifProperties.numFrames;
      }, o2.default.Image.prototype.play = function() {
        this.gifProperties && (this.gifProperties.playing = true);
      }, o2.default.Image.prototype.pause = function() {
        this.gifProperties && (this.gifProperties.playing = false);
      }, o2.default.Image.prototype.delay = function(e3, t3) {
        if (this.gifProperties) {
          var r3 = this.gifProperties;
          if (t3 < r3.numFrames && 0 <= t3)
            r3.frames[t3].delay = e3;
          else {
            var n3 = true, o3 = false, i3 = void 0;
            try {
              for (var a3, s = r3.frames[Symbol.iterator](); !(n3 = (a3 = s.next()).done); n3 = true) {
                a3.value.delay = e3;
              }
            } catch (e4) {
              o3 = true, i3 = e4;
            } finally {
              try {
                n3 || s.return == null || s.return();
              } finally {
                if (o3)
                  throw i3;
              }
            }
          }
        }
      };
      var a2 = o2.default.Image;
      r2.default = a2;
    }, { "../core/main": 264, "./filters": 285, "core-js/modules/es.array.filter": 152, "core-js/modules/es.array.iterator": 158, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.string.iterator": 186, "core-js/modules/es.symbol": 196, "core-js/modules/es.symbol.description": 194, "core-js/modules/es.symbol.iterator": 195, "core-js/modules/web.dom-collections.iterator": 229 }], 289: [function(e2, t2, r2) {
      e2("core-js/modules/es.array.filter"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var h2 = o2(e2("../core/main")), n2 = o2(e2("./filters"));
      function o2(e3) {
        return e3 && e3.__esModule ? e3 : { default: e3 };
      }
      e2("../color/p5.Color"), h2.default.prototype.pixels = [], h2.default.prototype.blend = function() {
        for (var e3 = arguments.length, t3 = new Array(e3), r3 = 0; r3 < e3; r3++)
          t3[r3] = arguments[r3];
        var n3;
        (h2.default._validateParameters("blend", t3), this._renderer) ? (n3 = this._renderer).blend.apply(n3, t3) : h2.default.Renderer2D.prototype.blend.apply(this, t3);
      }, h2.default.prototype.copy = function() {
        for (var e3 = arguments.length, t3 = new Array(e3), r3 = 0; r3 < e3; r3++)
          t3[r3] = arguments[r3];
        var n3, o3, i3, a2, s, l2, u2, c, d;
        if (h2.default._validateParameters("copy", t3), t3.length === 9)
          n3 = t3[0], o3 = t3[1], i3 = t3[2], a2 = t3[3], s = t3[4], l2 = t3[5], u2 = t3[6], c = t3[7], d = t3[8];
        else {
          if (t3.length !== 8)
            throw new Error("Signature not supported");
          n3 = this, o3 = t3[0], i3 = t3[1], a2 = t3[2], s = t3[3], l2 = t3[4], u2 = t3[5], c = t3[6], d = t3[7];
        }
        h2.default.prototype._copyHelper(this, n3, o3, i3, a2, s, l2, u2, c, d);
      }, h2.default.prototype._copyHelper = function(e3, t3, r3, n3, o3, i3, a2, s, l2, u2) {
        t3.loadPixels();
        var c = t3.canvas.width / t3.width, d = 0, f = 0;
        t3._renderer && t3._renderer.isP3D && (d = t3.width / 2, f = t3.height / 2), e3._renderer && e3._renderer.isP3D ? h2.default.RendererGL.prototype.image.call(e3._renderer, t3, r3 + d, n3 + f, o3, i3, a2, s, l2, u2) : e3.drawingContext.drawImage(t3.canvas, c * (r3 + d), c * (n3 + f), c * o3, c * i3, a2, s, l2, u2);
      }, h2.default.prototype.filter = function(e3, t3) {
        h2.default._validateParameters("filter", arguments), this.canvas !== void 0 ? n2.default.apply(this.canvas, n2.default[e3], t3) : n2.default.apply(this.elt, n2.default[e3], t3);
      }, h2.default.prototype.get = function(e3, t3, r3, n3) {
        var o3;
        return h2.default._validateParameters("get", arguments), (o3 = this._renderer).get.apply(o3, arguments);
      }, h2.default.prototype.loadPixels = function() {
        for (var e3 = arguments.length, t3 = new Array(e3), r3 = 0; r3 < e3; r3++)
          t3[r3] = arguments[r3];
        h2.default._validateParameters("loadPixels", t3), this._renderer.loadPixels();
      }, h2.default.prototype.set = function(e3, t3, r3) {
        this._renderer.set(e3, t3, r3);
      }, h2.default.prototype.updatePixels = function(e3, t3, r3, n3) {
        h2.default._validateParameters("updatePixels", arguments), this.pixels.length !== 0 && this._renderer.updatePixels(e3, t3, r3, n3);
      };
      var i2 = h2.default;
      r2.default = i2;
    }, { "../color/p5.Color": 251, "../core/main": 264, "./filters": 285, "core-js/modules/es.array.filter": 152 }], 290: [function(e2, t2, r2) {
      e2("core-js/modules/es.symbol"), e2("core-js/modules/es.symbol.description"), e2("core-js/modules/es.symbol.iterator"), e2("core-js/modules/es.array.concat"), e2("core-js/modules/es.array.includes"), e2("core-js/modules/es.array.index-of"), e2("core-js/modules/es.array.iterator"), e2("core-js/modules/es.array.last-index-of"), e2("core-js/modules/es.array.slice"), e2("core-js/modules/es.array.splice"), e2("core-js/modules/es.function.name"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.promise"), e2("core-js/modules/es.regexp.exec"), e2("core-js/modules/es.regexp.to-string"), e2("core-js/modules/es.string.includes"), e2("core-js/modules/es.string.iterator"), e2("core-js/modules/es.string.replace"), e2("core-js/modules/es.string.split"), e2("core-js/modules/es.typed-array.uint8-array"), e2("core-js/modules/es.typed-array.copy-within"), e2("core-js/modules/es.typed-array.every"), e2("core-js/modules/es.typed-array.fill"), e2("core-js/modules/es.typed-array.filter"), e2("core-js/modules/es.typed-array.find"), e2("core-js/modules/es.typed-array.find-index"), e2("core-js/modules/es.typed-array.for-each"), e2("core-js/modules/es.typed-array.includes"), e2("core-js/modules/es.typed-array.index-of"), e2("core-js/modules/es.typed-array.iterator"), e2("core-js/modules/es.typed-array.join"), e2("core-js/modules/es.typed-array.last-index-of"), e2("core-js/modules/es.typed-array.map"), e2("core-js/modules/es.typed-array.reduce"), e2("core-js/modules/es.typed-array.reduce-right"), e2("core-js/modules/es.typed-array.reverse"), e2("core-js/modules/es.typed-array.set"), e2("core-js/modules/es.typed-array.slice"), e2("core-js/modules/es.typed-array.some"), e2("core-js/modules/es.typed-array.sort"), e2("core-js/modules/es.typed-array.subarray"), e2("core-js/modules/es.typed-array.to-locale-string"), e2("core-js/modules/es.typed-array.to-string"), e2("core-js/modules/web.dom-collections.iterator"), e2("core-js/modules/web.url"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var g = n2(e2("../core/main"));
      e2("whatwg-fetch"), e2("es6-promise/auto");
      var m2 = n2(e2("fetch-jsonp")), s = n2(e2("file-saver"));
      function n2(e3) {
        return e3 && e3.__esModule ? e3 : { default: e3 };
      }
      function v(e3) {
        return (v = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      function b2(e3, t3) {
        var r3 = {};
        if ((t3 = t3 || []) === void 0)
          for (var n3 = 0; n3 < e3.length; n3++)
            t3[n3.toString()] = n3;
        for (var o3 = 0; o3 < t3.length; o3++) {
          var i2 = t3[o3], a2 = e3[o3];
          r3[i2] = a2;
        }
        return r3;
      }
      function y(e3) {
        return e3.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/"/g, "&quot;").replace(/'/g, "&#039;");
      }
      function l2(e3, t3) {
        t3 && t3 !== true && t3 !== "true" || (t3 = "");
        var r3 = "";
        return (e3 = e3 || "untitled") && e3.includes(".") && (r3 = e3.split(".").pop()), t3 && r3 !== t3 && (r3 = t3, e3 = "".concat(e3, ".").concat(r3)), [e3, r3];
      }
      e2("../core/friendly_errors/validate_params"), e2("../core/friendly_errors/file_errors"), e2("../core/friendly_errors/fes_core"), g.default.prototype.loadJSON = function() {
        for (var e3 = arguments.length, t3 = new Array(e3), r3 = 0; r3 < e3; r3++)
          t3[r3] = arguments[r3];
        g.default._validateParameters("loadJSON", t3);
        for (var n3, o3, i2, a2 = t3[0], s2 = {}, l3 = "json", u2 = 1; u2 < t3.length; u2++) {
          var c = t3[u2];
          typeof c == "string" ? c !== "jsonp" && c !== "json" || (l3 = c) : typeof c == "function" ? n3 ? o3 = c : n3 = c : v(c) === "object" && (c.hasOwnProperty("jsonpCallback") || c.hasOwnProperty("jsonpCallbackFunction")) && (l3 = "jsonp", i2 = c);
        }
        var d = this;
        return this.httpDo(a2, "GET", i2, l3, function(e4) {
          for (var t4 in e4)
            s2[t4] = e4[t4];
          n3 !== void 0 && n3(e4), d._decrementPreload();
        }, function(e4) {
          if (g.default._friendlyFileLoadError(5, a2), !o3)
            throw e4;
          o3(e4);
        }), s2;
      }, g.default.prototype.loadStrings = function() {
        for (var e3 = arguments.length, t3 = new Array(e3), r3 = 0; r3 < e3; r3++)
          t3[r3] = arguments[r3];
        g.default._validateParameters("loadStrings", t3);
        for (var o3, n3, i2 = [], a2 = 1; a2 < t3.length; a2++) {
          var s2 = t3[a2];
          typeof s2 == "function" && (o3 === void 0 ? o3 = s2 : n3 === void 0 && (n3 = s2));
        }
        var l3 = this;
        return g.default.prototype.httpDo.call(this, t3[0], "GET", "text", function(e4) {
          for (var t4 = e4.replace(/\r\n/g, "\r").replace(/\n/g, "\r").split(/\r/), r4 = 0, n4 = t4.length; r4 < n4; r4 += 32768)
            Array.prototype.push.apply(i2, t4.slice(r4, Math.min(r4 + 32768, n4)));
          o3 !== void 0 && o3(i2), l3._decrementPreload();
        }, function(e4) {
          if (g.default._friendlyFileLoadError(3, e4), !n3)
            throw e4;
          n3(e4);
        }), i2;
      }, g.default.prototype.loadTable = function(t3) {
        var f, r3, h2, p2 = false, n3 = t3.substring(t3.lastIndexOf(".") + 1, t3.length);
        n3 === "csv" ? h2 = "," : n3 === "ssv" ? h2 = ";" : n3 === "tsv" && (h2 = "	");
        for (var o3 = 1; o3 < arguments.length; o3++)
          typeof arguments[o3] == "function" ? f === void 0 ? f = arguments[o3] : r3 === void 0 && (r3 = arguments[o3]) : typeof arguments[o3] == "string" && (arguments[o3] === "header" && (p2 = true), arguments[o3] === "csv" ? h2 = "," : arguments[o3] === "ssv" ? h2 = ";" : arguments[o3] === "tsv" && (h2 = "	"));
        var y2 = new g.default.Table(), m3 = this;
        return this.httpDo(t3, "GET", "table", function(e3) {
          for (var t4, r4, n4 = {}, o4 = [], i2 = 0, a2 = null, s2 = function() {
            n4.currentState = 0, n4.token = "";
          }, l3 = function() {
            a2.push(n4.token), s2();
          }, u2 = function() {
            n4.currentState = 4, o4.push(a2), a2 = null;
          }; ; ) {
            if ((t4 = e3[i2++]) == null) {
              if (n4.escaped)
                throw new Error("Unclosed quote in file.");
              if (a2) {
                l3(), u2();
                break;
              }
            }
            if (a2 === null && (n4.escaped = false, a2 = [], s2()), n4.currentState === 0) {
              if (t4 === '"') {
                n4.escaped = true, n4.currentState = 1;
                continue;
              }
              n4.currentState = 1;
            }
            if (n4.currentState === 1 && n4.escaped)
              if (t4 === '"')
                e3[i2] === '"' ? (n4.token += '"', i2++) : (n4.escaped = false, n4.currentState = 2);
              else {
                if (t4 === "\r")
                  continue;
                n4.token += t4;
              }
            else
              t4 === "\r" ? (e3[i2] === "\n" && i2++, l3(), u2()) : t4 === "\n" ? (l3(), u2()) : t4 === h2 ? l3() : n4.currentState === 1 && (n4.token += t4);
          }
          if (p2)
            y2.columns = o4.shift();
          else
            for (var c = 0; c < o4[0].length; c++)
              y2.columns[c] = "null";
          for (var d = 0; d < o4.length; d++)
            (o4[d].length !== 1 || o4[d][0] !== "undefined" && o4[d][0] !== "") && ((r4 = new g.default.TableRow()).arr = o4[d], r4.obj = b2(o4[d], y2.columns), y2.addRow(r4));
          typeof f == "function" && f(y2), m3._decrementPreload();
        }, function(e3) {
          g.default._friendlyFileLoadError(2, t3), r3 ? r3(e3) : console.error(e3);
        }), y2;
      }, g.default.prototype.loadXML = function() {
        for (var e3 = arguments.length, t3 = new Array(e3), r3 = 0; r3 < e3; r3++)
          t3[r3] = arguments[r3];
        for (var n3, o3, i2 = new g.default.XML(), a2 = 1; a2 < t3.length; a2++) {
          var s2 = t3[a2];
          typeof s2 == "function" && (n3 === void 0 ? n3 = s2 : o3 === void 0 && (o3 = s2));
        }
        var l3 = this;
        return this.httpDo(t3[0], "GET", "xml", function(e4) {
          for (var t4 in e4)
            i2[t4] = e4[t4];
          n3 !== void 0 && n3(i2), l3._decrementPreload();
        }, function(e4) {
          if (g.default._friendlyFileLoadError(1, e4), !o3)
            throw e4;
          o3(e4);
        }), i2;
      }, g.default.prototype.loadBytes = function(t3, r3, n3) {
        var o3 = {}, i2 = this;
        return this.httpDo(t3, "GET", "arrayBuffer", function(e3) {
          o3.bytes = new Uint8Array(e3), typeof r3 == "function" && r3(o3), i2._decrementPreload();
        }, function(e3) {
          if (g.default._friendlyFileLoadError(6, t3), !n3)
            throw e3;
          n3(e3);
        }), o3;
      }, g.default.prototype.httpGet = function() {
        g.default._validateParameters("httpGet", arguments);
        var e3 = Array.prototype.slice.call(arguments);
        return e3.splice(1, 0, "GET"), g.default.prototype.httpDo.apply(this, e3);
      }, g.default.prototype.httpPost = function() {
        g.default._validateParameters("httpPost", arguments);
        var e3 = Array.prototype.slice.call(arguments);
        return e3.splice(1, 0, "POST"), g.default.prototype.httpDo.apply(this, e3);
      }, g.default.prototype.httpDo = function() {
        for (var n3, e3, t3, r3, o3, i2 = {}, a2 = 0, s2 = "text/plain", l3 = arguments.length - 1; 0 < l3 && typeof (l3 < 0 || arguments.length <= l3 ? void 0 : arguments[l3]) == "function"; l3--)
          a2++;
        var u2 = arguments.length <= 0 ? void 0 : arguments[0];
        if (arguments.length - a2 == 2 && typeof u2 == "string" && v(arguments.length <= 1 ? void 0 : arguments[1]) === "object")
          r3 = new Request(u2, arguments.length <= 1 ? void 0 : arguments[1]), e3 = arguments.length <= 2 ? void 0 : arguments[2], t3 = arguments.length <= 3 ? void 0 : arguments[3];
        else {
          for (var c, d = "GET", f = 1; f < arguments.length; f++) {
            var h2 = f < 0 || arguments.length <= f ? void 0 : arguments[f];
            if (typeof h2 == "string")
              h2 === "GET" || h2 === "POST" || h2 === "PUT" || h2 === "DELETE" ? d = h2 : h2 === "json" || h2 === "jsonp" || h2 === "binary" || h2 === "arrayBuffer" || h2 === "xml" || h2 === "text" || h2 === "table" ? n3 = h2 : c = h2;
            else if (typeof h2 == "number")
              c = h2.toString();
            else if (v(h2) === "object")
              if (h2.hasOwnProperty("jsonpCallback") || h2.hasOwnProperty("jsonpCallbackFunction"))
                for (var p2 in h2)
                  i2[p2] = h2[p2];
              else
                s2 = h2 instanceof g.default.XML ? (c = h2.serialize(), "application/xml") : (c = JSON.stringify(h2), "application/json");
            else
              typeof h2 == "function" && (e3 ? t3 = h2 : e3 = h2);
          }
          var y2 = d === "GET" ? new Headers() : new Headers({ "Content-Type": s2 });
          r3 = new Request(u2, { method: d, mode: "cors", body: c, headers: y2 });
        }
        return (o3 = (o3 = (n3 = n3 || (u2.includes("json") ? "json" : u2.includes("xml") ? "xml" : "text")) === "jsonp" ? (0, m2.default)(u2, i2) : fetch(r3)).then(function(e4) {
          if (!e4.ok) {
            var t4 = new Error(e4.body);
            throw t4.status = e4.status, t4.ok = false, t4;
          }
          var r4 = 0;
          switch (n3 !== "jsonp" && (r4 = e4.headers.get("content-length")), r4 && 64e6 < r4 && g.default._friendlyFileLoadError(7, u2), n3) {
            case "json":
            case "jsonp":
              return e4.json();
            case "binary":
              return e4.blob();
            case "arrayBuffer":
              return e4.arrayBuffer();
            case "xml":
              return e4.text().then(function(e5) {
                var t5 = new DOMParser().parseFromString(e5, "text/xml");
                return new g.default.XML(t5.documentElement);
              });
            default:
              return e4.text();
          }
        })).then(e3 || function() {
        }), o3.catch(t3 || console.error), o3;
      }, window.URL = window.URL || window.webkitURL, g.default.prototype._pWriters = [], g.default.prototype.createWriter = function(e3, t3) {
        var r3;
        for (var n3 in g.default.prototype._pWriters)
          if (g.default.prototype._pWriters[n3].name === e3)
            return r3 = new g.default.PrintWriter(e3 + this.millis(), t3), g.default.prototype._pWriters.push(r3), r3;
        return r3 = new g.default.PrintWriter(e3, t3), g.default.prototype._pWriters.push(r3), r3;
      }, g.default.PrintWriter = function(r3, n3) {
        var o3 = this;
        this.name = r3, this.content = "", this.write = function(e3) {
          this.content += e3;
        }, this.print = function(e3) {
          this.content += "".concat(e3, "\n");
        }, this.clear = function() {
          this.content = "";
        }, this.close = function() {
          var e3 = [];
          for (var t3 in e3.push(this.content), g.default.prototype.writeFile(e3, r3, n3), g.default.prototype._pWriters)
            g.default.prototype._pWriters[t3].name === this.name && g.default.prototype._pWriters.splice(t3, 1);
          o3.clear(), o3 = {};
        };
      }, g.default.prototype.save = function(e3, t3, r3) {
        var n3 = arguments, o3 = this._curElement ? this._curElement.elt : this.elt;
        if (n3.length !== 0)
          if (n3[0] instanceof g.default.Renderer || n3[0] instanceof g.default.Graphics)
            g.default.prototype.saveCanvas(n3[0].elt, n3[1], n3[2]);
          else if (n3.length === 1 && typeof n3[0] == "string")
            g.default.prototype.saveCanvas(o3, n3[0]);
          else
            switch (l2(n3[1], n3[2])[1]) {
              case "json":
                return void g.default.prototype.saveJSON(n3[0], n3[1], n3[2]);
              case "txt":
                return void g.default.prototype.saveStrings(n3[0], n3[1], n3[2]);
              default:
                n3[0] instanceof Array ? g.default.prototype.saveStrings(n3[0], n3[1], n3[2]) : n3[0] instanceof g.default.Table ? g.default.prototype.saveTable(n3[0], n3[1], n3[2]) : n3[0] instanceof g.default.Image ? g.default.prototype.saveCanvas(n3[0].canvas, n3[1]) : n3[0] instanceof g.default.SoundFile && g.default.prototype.saveSound(n3[0], n3[1], n3[2], n3[3]);
            }
        else
          g.default.prototype.saveCanvas(o3);
      }, g.default.prototype.saveJSON = function(e3, t3, r3) {
        var n3;
        g.default._validateParameters("saveJSON", arguments), n3 = r3 ? JSON.stringify(e3) : JSON.stringify(e3, void 0, 2), this.saveStrings(n3.split("\n"), t3, "json");
      }, g.default.prototype.saveJSONObject = g.default.prototype.saveJSON, g.default.prototype.saveJSONArray = g.default.prototype.saveJSON, g.default.prototype.saveStrings = function(e3, t3, r3, n3) {
        g.default._validateParameters("saveStrings", arguments);
        for (var o3 = r3 || "txt", i2 = this.createWriter(t3, o3), a2 = 0; a2 < e3.length; a2++)
          n3 ? i2.write(e3[a2] + "\r\n") : i2.write(e3[a2] + "\n");
        i2.close(), i2.clear();
      }, g.default.prototype.saveTable = function(e3, t3, r3) {
        var n3;
        g.default._validateParameters("saveTable", arguments), n3 = r3 === void 0 ? t3.substring(t3.lastIndexOf(".") + 1, t3.length) : r3;
        var o3 = this.createWriter(t3, n3), i2 = e3.columns, a2 = ",";
        if (n3 === "tsv" && (a2 = "	"), n3 !== "html") {
          if (i2[0] !== "0") {
            for (var s2 = 0; s2 < i2.length; s2++)
              s2 < i2.length - 1 ? o3.write(i2[s2] + a2) : o3.write(i2[s2]);
            o3.write("\n");
          }
          for (var l3 = 0; l3 < e3.rows.length; l3++) {
            var u2 = void 0;
            for (u2 = 0; u2 < e3.rows[l3].arr.length; u2++)
              u2 < e3.rows[l3].arr.length - 1 ? n3 === "csv" && String(e3.rows[l3].arr[u2]).includes(",") ? o3.write('"' + e3.rows[l3].arr[u2] + '"' + a2) : o3.write(e3.rows[l3].arr[u2] + a2) : n3 === "csv" && String(e3.rows[l3].arr[u2]).includes(",") ? o3.write('"' + e3.rows[l3].arr[u2] + '"') : o3.write(e3.rows[l3].arr[u2]);
            o3.write("\n");
          }
        } else {
          o3.print("<html>"), o3.print("<head>");
          if (o3.print('  <meta http-equiv="content-type" content="text/html;charset=utf-8" />'), o3.print("</head>"), o3.print("<body>"), o3.print("  <table>"), i2[0] !== "0") {
            o3.print("    <tr>");
            for (var c = 0; c < i2.length; c++) {
              var d = y(i2[c]);
              o3.print("      <td>".concat(d)), o3.print("      </td>");
            }
            o3.print("    </tr>");
          }
          for (var f = 0; f < e3.rows.length; f++) {
            o3.print("    <tr>");
            for (var h2 = 0; h2 < e3.columns.length; h2++) {
              var p2 = y(e3.rows[f].getString(h2));
              o3.print("      <td>".concat(p2)), o3.print("      </td>");
            }
            o3.print("    </tr>");
          }
          o3.print("  </table>"), o3.print("</body>"), o3.print("</html>");
        }
        o3.close(), o3.clear();
      }, g.default.prototype.writeFile = function(e3, t3, r3) {
        var n3 = "application/octet-stream";
        g.default.prototype._isSafari() && (n3 = "text/plain");
        var o3 = new Blob(e3, { type: n3 });
        g.default.prototype.downloadFile(o3, t3, r3);
      }, g.default.prototype.downloadFile = function(e3, t3, r3) {
        var n3 = l2(t3, r3), o3 = n3[0];
        if (e3 instanceof Blob)
          s.default.saveAs(e3, o3);
        else {
          var i2 = document.createElement("a");
          if (i2.href = e3, i2.download = o3, i2.onclick = function(e4) {
            var t4;
            t4 = e4, document.body.removeChild(t4.target), e4.stopPropagation();
          }, i2.style.display = "none", document.body.appendChild(i2), g.default.prototype._isSafari()) {
            var a2 = "Hello, Safari user! To download this file...\n";
            a2 += "1. Go to File --> Save As.\n", a2 += '2. Choose "Page Source" as the Format.\n', a2 += '3. Name it with this extension: ."'.concat(n3[1], '"'), alert(a2);
          }
          i2.click();
        }
      }, g.default.prototype._checkFileExtension = l2, g.default.prototype._isSafari = function() {
        return 0 < Object.prototype.toString.call(window.HTMLElement).indexOf("Constructor");
      };
      var o2 = g.default;
      r2.default = o2;
    }, { "../core/friendly_errors/fes_core": 255, "../core/friendly_errors/file_errors": 256, "../core/friendly_errors/validate_params": 259, "../core/main": 264, "core-js/modules/es.array.concat": 149, "core-js/modules/es.array.includes": 156, "core-js/modules/es.array.index-of": 157, "core-js/modules/es.array.iterator": 158, "core-js/modules/es.array.last-index-of": 160, "core-js/modules/es.array.slice": 162, "core-js/modules/es.array.splice": 164, "core-js/modules/es.function.name": 166, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.promise": 178, "core-js/modules/es.regexp.exec": 181, "core-js/modules/es.regexp.to-string": 182, "core-js/modules/es.string.includes": 185, "core-js/modules/es.string.iterator": 186, "core-js/modules/es.string.replace": 189, "core-js/modules/es.string.split": 191, "core-js/modules/es.symbol": 196, "core-js/modules/es.symbol.description": 194, "core-js/modules/es.symbol.iterator": 195, "core-js/modules/es.typed-array.copy-within": 197, "core-js/modules/es.typed-array.every": 198, "core-js/modules/es.typed-array.fill": 199, "core-js/modules/es.typed-array.filter": 200, "core-js/modules/es.typed-array.find": 202, "core-js/modules/es.typed-array.find-index": 201, "core-js/modules/es.typed-array.for-each": 205, "core-js/modules/es.typed-array.includes": 206, "core-js/modules/es.typed-array.index-of": 207, "core-js/modules/es.typed-array.iterator": 210, "core-js/modules/es.typed-array.join": 211, "core-js/modules/es.typed-array.last-index-of": 212, "core-js/modules/es.typed-array.map": 213, "core-js/modules/es.typed-array.reduce": 215, "core-js/modules/es.typed-array.reduce-right": 214, "core-js/modules/es.typed-array.reverse": 216, "core-js/modules/es.typed-array.set": 217, "core-js/modules/es.typed-array.slice": 218, "core-js/modules/es.typed-array.some": 219, "core-js/modules/es.typed-array.sort": 220, "core-js/modules/es.typed-array.subarray": 221, "core-js/modules/es.typed-array.to-locale-string": 222, "core-js/modules/es.typed-array.to-string": 223, "core-js/modules/es.typed-array.uint8-array": 226, "core-js/modules/web.dom-collections.iterator": 229, "core-js/modules/web.url": 231, "es6-promise/auto": 232, "fetch-jsonp": 234, "file-saver": 235, "whatwg-fetch": 242 }], 291: [function(e2, t2, r2) {
      e2("core-js/modules/es.array.concat"), e2("core-js/modules/es.array.index-of"), e2("core-js/modules/es.array.join"), e2("core-js/modules/es.array.splice"), e2("core-js/modules/es.regexp.constructor"), e2("core-js/modules/es.regexp.exec"), e2("core-js/modules/es.regexp.to-string"), e2("core-js/modules/es.string.match"), e2("core-js/modules/es.string.replace"), e2("core-js/modules/es.string.trim"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, o2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      o2.default.Table = function(e3) {
        this.columns = [], this.rows = [];
      }, o2.default.Table.prototype.addRow = function(e3) {
        var t3 = e3 || new o2.default.TableRow();
        if (t3.arr === void 0 || t3.obj === void 0)
          throw new Error("invalid TableRow: ".concat(t3));
        return (t3.table = this).rows.push(t3), t3;
      }, o2.default.Table.prototype.removeRow = function(e3) {
        this.rows[e3].table = null;
        var t3 = this.rows.splice(e3 + 1, this.rows.length);
        this.rows.pop(), this.rows = this.rows.concat(t3);
      }, o2.default.Table.prototype.getRow = function(e3) {
        return this.rows[e3];
      }, o2.default.Table.prototype.getRows = function() {
        return this.rows;
      }, o2.default.Table.prototype.findRow = function(e3, t3) {
        if (typeof t3 == "string") {
          for (var r3 = 0; r3 < this.rows.length; r3++)
            if (this.rows[r3].obj[t3] === e3)
              return this.rows[r3];
        } else
          for (var n3 = 0; n3 < this.rows.length; n3++)
            if (this.rows[n3].arr[t3] === e3)
              return this.rows[n3];
        return null;
      }, o2.default.Table.prototype.findRows = function(e3, t3) {
        var r3 = [];
        if (typeof t3 == "string")
          for (var n3 = 0; n3 < this.rows.length; n3++)
            this.rows[n3].obj[t3] === e3 && r3.push(this.rows[n3]);
        else
          for (var o3 = 0; o3 < this.rows.length; o3++)
            this.rows[o3].arr[t3] === e3 && r3.push(this.rows[o3]);
        return r3;
      }, o2.default.Table.prototype.matchRow = function(e3, t3) {
        if (typeof t3 == "number") {
          for (var r3 = 0; r3 < this.rows.length; r3++)
            if (this.rows[r3].arr[t3].match(e3))
              return this.rows[r3];
        } else
          for (var n3 = 0; n3 < this.rows.length; n3++)
            if (this.rows[n3].obj[t3].match(e3))
              return this.rows[n3];
        return null;
      }, o2.default.Table.prototype.matchRows = function(e3, t3) {
        var r3 = [];
        if (typeof t3 == "number")
          for (var n3 = 0; n3 < this.rows.length; n3++)
            this.rows[n3].arr[t3].match(e3) && r3.push(this.rows[n3]);
        else
          for (var o3 = 0; o3 < this.rows.length; o3++)
            this.rows[o3].obj[t3].match(e3) && r3.push(this.rows[o3]);
        return r3;
      }, o2.default.Table.prototype.getColumn = function(e3) {
        var t3 = [];
        if (typeof e3 == "string")
          for (var r3 = 0; r3 < this.rows.length; r3++)
            t3.push(this.rows[r3].obj[e3]);
        else
          for (var n3 = 0; n3 < this.rows.length; n3++)
            t3.push(this.rows[n3].arr[e3]);
        return t3;
      }, o2.default.Table.prototype.clearRows = function() {
        delete this.rows, this.rows = [];
      }, o2.default.Table.prototype.addColumn = function(e3) {
        var t3 = e3 || null;
        this.columns.push(t3);
      }, o2.default.Table.prototype.getColumnCount = function() {
        return this.columns.length;
      }, o2.default.Table.prototype.getRowCount = function() {
        return this.rows.length;
      }, o2.default.Table.prototype.removeTokens = function(e3, t3) {
        for (var r3 = [], n3 = 0; n3 < e3.length; n3++)
          r3.push(e3.charAt(n3).replace(/[-/\\^$*+?.()|[\]{}]/g, "\\$&"));
        var o3 = new RegExp(r3.join("|"), "g");
        if (t3 === void 0)
          for (var i3 = 0; i3 < this.columns.length; i3++)
            for (var a2 = 0; a2 < this.rows.length; a2++) {
              var s = this.rows[a2].arr[i3];
              s = s.replace(o3, ""), this.rows[a2].arr[i3] = s, this.rows[a2].obj[this.columns[i3]] = s;
            }
        else if (typeof t3 == "string")
          for (var l2 = 0; l2 < this.rows.length; l2++) {
            var u2 = this.rows[l2].obj[t3];
            u2 = u2.replace(o3, ""), this.rows[l2].obj[t3] = u2;
            var c = this.columns.indexOf(t3);
            this.rows[l2].arr[c] = u2;
          }
        else
          for (var d = 0; d < this.rows.length; d++) {
            var f = this.rows[d].arr[t3];
            f = f.replace(o3, ""), this.rows[d].arr[t3] = f, this.rows[d].obj[this.columns[t3]] = f;
          }
      }, o2.default.Table.prototype.trim = function(e3) {
        var t3 = new RegExp(" ", "g");
        if (e3 === void 0)
          for (var r3 = 0; r3 < this.columns.length; r3++)
            for (var n3 = 0; n3 < this.rows.length; n3++) {
              var o3 = this.rows[n3].arr[r3];
              o3 = o3.replace(t3, ""), this.rows[n3].arr[r3] = o3, this.rows[n3].obj[this.columns[r3]] = o3;
            }
        else if (typeof e3 == "string")
          for (var i3 = 0; i3 < this.rows.length; i3++) {
            var a2 = this.rows[i3].obj[e3];
            a2 = a2.replace(t3, ""), this.rows[i3].obj[e3] = a2;
            var s = this.columns.indexOf(e3);
            this.rows[i3].arr[s] = a2;
          }
        else
          for (var l2 = 0; l2 < this.rows.length; l2++) {
            var u2 = this.rows[l2].arr[e3];
            u2 = u2.replace(t3, ""), this.rows[l2].arr[e3] = u2, this.rows[l2].obj[this.columns[e3]] = u2;
          }
      }, o2.default.Table.prototype.removeColumn = function(e3) {
        var t3, r3;
        typeof e3 == "string" ? (t3 = e3, r3 = this.columns.indexOf(e3)) : (r3 = e3, t3 = this.columns[e3]);
        var n3 = this.columns.splice(r3 + 1, this.columns.length);
        this.columns.pop(), this.columns = this.columns.concat(n3);
        for (var o3 = 0; o3 < this.rows.length; o3++) {
          var i3 = this.rows[o3].arr, a2 = i3.splice(r3 + 1, i3.length);
          i3.pop(), this.rows[o3].arr = i3.concat(a2), delete this.rows[o3].obj[t3];
        }
      }, o2.default.Table.prototype.set = function(e3, t3, r3) {
        this.rows[e3].set(t3, r3);
      }, o2.default.Table.prototype.setNum = function(e3, t3, r3) {
        this.rows[e3].setNum(t3, r3);
      }, o2.default.Table.prototype.setString = function(e3, t3, r3) {
        this.rows[e3].setString(t3, r3);
      }, o2.default.Table.prototype.get = function(e3, t3) {
        return this.rows[e3].get(t3);
      }, o2.default.Table.prototype.getNum = function(e3, t3) {
        return this.rows[e3].getNum(t3);
      }, o2.default.Table.prototype.getString = function(e3, t3) {
        return this.rows[e3].getString(t3);
      }, o2.default.Table.prototype.getObject = function(e3) {
        for (var t3, r3 = {}, n3 = 0; n3 < this.rows.length; n3++)
          if (t3 = this.rows[n3].obj, typeof e3 == "string") {
            if (!(0 <= this.columns.indexOf(e3)))
              throw new Error('This table has no column named "'.concat(e3, '"'));
            r3[t3[e3]] = t3;
          } else
            r3[n3] = this.rows[n3].obj;
        return r3;
      }, o2.default.Table.prototype.getArray = function() {
        for (var e3 = [], t3 = 0; t3 < this.rows.length; t3++)
          e3.push(this.rows[t3].arr);
        return e3;
      };
      var i2 = o2.default;
      r2.default = i2;
    }, { "../core/main": 264, "core-js/modules/es.array.concat": 149, "core-js/modules/es.array.index-of": 157, "core-js/modules/es.array.join": 159, "core-js/modules/es.array.splice": 164, "core-js/modules/es.regexp.constructor": 180, "core-js/modules/es.regexp.exec": 181, "core-js/modules/es.regexp.to-string": 182, "core-js/modules/es.string.match": 187, "core-js/modules/es.string.replace": 189, "core-js/modules/es.string.trim": 193 }], 292: [function(e2, t2, r2) {
      e2("core-js/modules/es.array.index-of"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.regexp.exec"), e2("core-js/modules/es.regexp.to-string"), e2("core-js/modules/es.string.split"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, o2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      o2.default.TableRow = function(e3, t3) {
        var r3 = [], n3 = {};
        e3 && (t3 = t3 || ",", r3 = e3.split(t3));
        for (var o3 = 0; o3 < r3.length; o3++) {
          var i3 = o3, a2 = r3[o3];
          n3[i3] = a2;
        }
        this.arr = r3, this.obj = n3, this.table = null;
      }, o2.default.TableRow.prototype.set = function(e3, t3) {
        if (typeof e3 == "string") {
          var r3 = this.table.columns.indexOf(e3);
          if (!(0 <= r3))
            throw new Error('This table has no column named "'.concat(e3, '"'));
          this.obj[e3] = t3, this.arr[r3] = t3;
        } else {
          if (!(e3 < this.table.columns.length))
            throw new Error("Column #".concat(e3, " is out of the range of this table"));
          this.arr[e3] = t3;
          var n3 = this.table.columns[e3];
          this.obj[n3] = t3;
        }
      }, o2.default.TableRow.prototype.setNum = function(e3, t3) {
        var r3 = parseFloat(t3);
        this.set(e3, r3);
      }, o2.default.TableRow.prototype.setString = function(e3, t3) {
        var r3 = t3.toString();
        this.set(e3, r3);
      }, o2.default.TableRow.prototype.get = function(e3) {
        return typeof e3 == "string" ? this.obj[e3] : this.arr[e3];
      }, o2.default.TableRow.prototype.getNum = function(e3) {
        var t3;
        if ((t3 = typeof e3 == "string" ? parseFloat(this.obj[e3]) : parseFloat(this.arr[e3])).toString() === "NaN")
          throw "Error: ".concat(this.obj[e3], " is NaN (Not a Number)");
        return t3;
      }, o2.default.TableRow.prototype.getString = function(e3) {
        return typeof e3 == "string" ? this.obj[e3].toString() : this.arr[e3].toString();
      };
      var i2 = o2.default;
      r2.default = i2;
    }, { "../core/main": 264, "core-js/modules/es.array.index-of": 157, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.regexp.exec": 181, "core-js/modules/es.regexp.to-string": 182, "core-js/modules/es.string.split": 191 }], 293: [function(e2, t2, r2) {
      e2("core-js/modules/es.symbol"), e2("core-js/modules/es.symbol.description"), e2("core-js/modules/es.symbol.iterator"), e2("core-js/modules/es.array.iterator"), e2("core-js/modules/es.number.constructor"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.regexp.exec"), e2("core-js/modules/es.string.iterator"), e2("core-js/modules/es.string.replace"), e2("core-js/modules/web.dom-collections.iterator"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, s = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      function o2(e3) {
        for (var t3 = [], r3 = 0; r3 < e3.length; r3++)
          t3.push(new s.default.XML(e3[r3]));
        return t3;
      }
      s.default.XML = function(e3) {
        if (e3)
          this.DOM = e3;
        else {
          var t3 = document.implementation.createDocument(null, "doc");
          this.DOM = t3.createElement("root");
        }
      }, s.default.XML.prototype.getParent = function() {
        return new s.default.XML(this.DOM.parentElement);
      }, s.default.XML.prototype.getName = function() {
        return this.DOM.tagName;
      }, s.default.XML.prototype.setName = function(e3) {
        var t3 = this.DOM.innerHTML, r3 = this.DOM.attributes, n3 = document.implementation.createDocument(null, "default").createElement(e3);
        n3.innerHTML = t3;
        for (var o3 = 0; o3 < r3.length; o3++)
          n3.setAttribute(r3[o3].nodeName, r3.nodeValue);
        this.DOM = n3;
      }, s.default.XML.prototype.hasChildren = function() {
        return 0 < this.DOM.children.length;
      }, s.default.XML.prototype.listChildren = function() {
        for (var e3 = [], t3 = 0; t3 < this.DOM.childNodes.length; t3++)
          e3.push(this.DOM.childNodes[t3].nodeName);
        return e3;
      }, s.default.XML.prototype.getChildren = function(e3) {
        return o2(e3 ? this.DOM.getElementsByTagName(e3) : this.DOM.children);
      }, s.default.XML.prototype.getChild = function(e3) {
        if (typeof e3 != "string")
          return new s.default.XML(this.DOM.children[e3]);
        var t3 = true, r3 = false, n3 = void 0;
        try {
          for (var o3, i3 = this.DOM.children[Symbol.iterator](); !(t3 = (o3 = i3.next()).done); t3 = true) {
            var a2 = o3.value;
            if (a2.tagName === e3)
              return new s.default.XML(a2);
          }
        } catch (e4) {
          r3 = true, n3 = e4;
        } finally {
          try {
            t3 || i3.return == null || i3.return();
          } finally {
            if (r3)
              throw n3;
          }
        }
      }, s.default.XML.prototype.addChild = function(e3) {
        e3 instanceof s.default.XML && this.DOM.appendChild(e3.DOM);
      }, s.default.XML.prototype.removeChild = function(e3) {
        var t3 = -1;
        if (typeof e3 == "string") {
          for (var r3 = 0; r3 < this.DOM.children.length; r3++)
            if (this.DOM.children[r3].tagName === e3) {
              t3 = r3;
              break;
            }
        } else
          t3 = e3;
        t3 !== -1 && this.DOM.removeChild(this.DOM.children[t3]);
      }, s.default.XML.prototype.getAttributeCount = function() {
        return this.DOM.attributes.length;
      }, s.default.XML.prototype.listAttributes = function() {
        var e3 = [], t3 = true, r3 = false, n3 = void 0;
        try {
          for (var o3, i3 = this.DOM.attributes[Symbol.iterator](); !(t3 = (o3 = i3.next()).done); t3 = true) {
            var a2 = o3.value;
            e3.push(a2.nodeName);
          }
        } catch (e4) {
          r3 = true, n3 = e4;
        } finally {
          try {
            t3 || i3.return == null || i3.return();
          } finally {
            if (r3)
              throw n3;
          }
        }
        return e3;
      }, s.default.XML.prototype.hasAttribute = function(e3) {
        var t3 = {}, r3 = true, n3 = false, o3 = void 0;
        try {
          for (var i3, a2 = this.DOM.attributes[Symbol.iterator](); !(r3 = (i3 = a2.next()).done); r3 = true) {
            var s2 = i3.value;
            t3[s2.nodeName] = s2.nodeValue;
          }
        } catch (e4) {
          n3 = true, o3 = e4;
        } finally {
          try {
            r3 || a2.return == null || a2.return();
          } finally {
            if (n3)
              throw o3;
          }
        }
        return !!t3[e3];
      }, s.default.XML.prototype.getNum = function(e3, t3) {
        var r3 = {}, n3 = true, o3 = false, i3 = void 0;
        try {
          for (var a2, s2 = this.DOM.attributes[Symbol.iterator](); !(n3 = (a2 = s2.next()).done); n3 = true) {
            var l2 = a2.value;
            r3[l2.nodeName] = l2.nodeValue;
          }
        } catch (e4) {
          o3 = true, i3 = e4;
        } finally {
          try {
            n3 || s2.return == null || s2.return();
          } finally {
            if (o3)
              throw i3;
          }
        }
        return Number(r3[e3]) || t3 || 0;
      }, s.default.XML.prototype.getString = function(e3, t3) {
        var r3 = {}, n3 = true, o3 = false, i3 = void 0;
        try {
          for (var a2, s2 = this.DOM.attributes[Symbol.iterator](); !(n3 = (a2 = s2.next()).done); n3 = true) {
            var l2 = a2.value;
            r3[l2.nodeName] = l2.nodeValue;
          }
        } catch (e4) {
          o3 = true, i3 = e4;
        } finally {
          try {
            n3 || s2.return == null || s2.return();
          } finally {
            if (o3)
              throw i3;
          }
        }
        return r3[e3] ? String(r3[e3]) : t3 || null;
      }, s.default.XML.prototype.setAttribute = function(e3, t3) {
        this.DOM.setAttribute(e3, t3);
      }, s.default.XML.prototype.getContent = function(e3) {
        return this.DOM.textContent.replace(/\s\s+/g, ",") || e3 || null;
      }, s.default.XML.prototype.setContent = function(e3) {
        this.DOM.children.length || (this.DOM.textContent = e3);
      }, s.default.XML.prototype.serialize = function() {
        return new XMLSerializer().serializeToString(this.DOM);
      };
      var i2 = s.default;
      r2.default = i2;
    }, { "../core/main": 264, "core-js/modules/es.array.iterator": 158, "core-js/modules/es.number.constructor": 170, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.regexp.exec": 181, "core-js/modules/es.string.iterator": 186, "core-js/modules/es.string.replace": 189, "core-js/modules/es.symbol": 196, "core-js/modules/es.symbol.description": 194, "core-js/modules/es.symbol.iterator": 195, "core-js/modules/web.dom-collections.iterator": 229 }], 294: [function(e2, t2, r2) {
      e2("core-js/modules/es.array.includes"), e2("core-js/modules/es.array.index-of"), e2("core-js/modules/es.array.map"), e2("core-js/modules/es.array.slice"), e2("core-js/modules/es.math.hypot"), e2("core-js/modules/es.number.constructor"), e2("core-js/modules/es.string.includes"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, s = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      function o2() {
        if (typeof Math.hypot == "function")
          return Math.hypot.apply(null, arguments);
        for (var e3 = arguments.length, t3 = [], r3 = 0, n3 = 0; n3 < e3; n3++) {
          var o3 = arguments[n3];
          if ((o3 = +o3) === 1 / 0 || o3 === -1 / 0)
            return 1 / 0;
          r3 < (o3 = Math.abs(o3)) && (r3 = o3), t3[n3] = o3;
        }
        r3 === 0 && (r3 = 1);
        for (var i3 = 0, a2 = 0, s2 = 0; s2 < e3; s2++) {
          var l2 = t3[s2] / r3, u2 = l2 * l2 - a2, c = i3 + u2;
          a2 = c - i3 - u2, i3 = c;
        }
        return Math.sqrt(i3) * r3;
      }
      s.default.prototype.abs = Math.abs, s.default.prototype.ceil = Math.ceil, s.default.prototype.constrain = function(e3, t3, r3) {
        return s.default._validateParameters("constrain", arguments), Math.max(Math.min(e3, r3), t3);
      }, s.default.prototype.dist = function() {
        for (var e3 = arguments.length, t3 = new Array(e3), r3 = 0; r3 < e3; r3++)
          t3[r3] = arguments[r3];
        return s.default._validateParameters("dist", t3), t3.length === 4 ? o2(t3[2] - t3[0], t3[3] - t3[1]) : t3.length === 6 ? o2(t3[3] - t3[0], t3[4] - t3[1], t3[5] - t3[2]) : void 0;
      }, s.default.prototype.exp = Math.exp, s.default.prototype.floor = Math.floor, s.default.prototype.lerp = function(e3, t3, r3) {
        return s.default._validateParameters("lerp", arguments), r3 * (t3 - e3) + e3;
      }, s.default.prototype.log = Math.log, s.default.prototype.mag = function(e3, t3) {
        return s.default._validateParameters("mag", arguments), o2(e3, t3);
      }, s.default.prototype.map = function(e3, t3, r3, n3, o3, i3) {
        s.default._validateParameters("map", arguments);
        var a2 = (e3 - t3) / (r3 - t3) * (o3 - n3) + n3;
        return i3 ? n3 < o3 ? this.constrain(a2, n3, o3) : this.constrain(a2, o3, n3) : a2;
      }, s.default.prototype.max = function() {
        for (var e3 = arguments.length, t3 = new Array(e3), r3 = 0; r3 < e3; r3++)
          t3[r3] = arguments[r3];
        return t3[0] instanceof Array ? Math.max.apply(null, t3[0]) : Math.max.apply(null, t3);
      }, s.default.prototype.min = function() {
        for (var e3 = arguments.length, t3 = new Array(e3), r3 = 0; r3 < e3; r3++)
          t3[r3] = arguments[r3];
        return t3[0] instanceof Array ? Math.min.apply(null, t3[0]) : Math.min.apply(null, t3);
      }, s.default.prototype.norm = function(e3, t3, r3) {
        return s.default._validateParameters("norm", arguments), this.map(e3, t3, r3, 0, 1);
      }, s.default.prototype.pow = Math.pow, s.default.prototype.round = function(e3, t3) {
        if (!t3)
          return Math.round(e3);
        var r3 = Math.pow(10, t3);
        return Math.round(e3 * r3) / r3;
      }, s.default.prototype.sq = function(e3) {
        return e3 * e3;
      }, s.default.prototype.sqrt = Math.sqrt, s.default.prototype.fract = function(e3) {
        s.default._validateParameters("fract", arguments);
        var t3 = 0, r3 = Number(e3);
        if (isNaN(r3) || Math.abs(r3) === 1 / 0)
          return r3;
        if (r3 < 0 && (r3 = -r3, t3 = 1), !String(r3).includes(".") || String(r3).includes("e"))
          return r3 < 1 ? Math.abs(t3 - r3) : 0;
        var n3 = String(r3);
        return n3 = Number("0" + n3.slice(n3.indexOf("."))), Math.abs(t3 - n3);
      };
      var i2 = s.default;
      r2.default = i2;
    }, { "../core/main": 264, "core-js/modules/es.array.includes": 156, "core-js/modules/es.array.index-of": 157, "core-js/modules/es.array.map": 161, "core-js/modules/es.array.slice": 162, "core-js/modules/es.math.hypot": 168, "core-js/modules/es.number.constructor": 170, "core-js/modules/es.string.includes": 185 }], 295: [function(e2, t2, r2) {
      e2("core-js/modules/es.array.concat"), e2("core-js/modules/es.array.slice"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.reflect.construct"), e2("core-js/modules/es.regexp.to-string"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, o2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      function i2(e3, t3, r3) {
        return (i2 = function() {
          if (typeof Reflect == "undefined" || !Reflect.construct)
            return false;
          if (Reflect.construct.sham)
            return false;
          if (typeof Proxy == "function")
            return true;
          try {
            return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
            })), true;
          } catch (e4) {
            return false;
          }
        }() ? Reflect.construct : function(e4, t4, r4) {
          var n3 = [null];
          n3.push.apply(n3, t4);
          var o3 = new (Function.bind.apply(e4, n3))();
          return r4 && a2(o3, r4.prototype), o3;
        }).apply(null, arguments);
      }
      function a2(e3, t3) {
        return (a2 = Object.setPrototypeOf || function(e4, t4) {
          return e4.__proto__ = t4, e4;
        })(e3, t3);
      }
      o2.default.prototype.createVector = function(e3, t3, r3) {
        return this instanceof o2.default ? i2(o2.default.Vector, [this._fromRadians.bind(this), this._toRadians.bind(this)].concat(Array.prototype.slice.call(arguments))) : new o2.default.Vector(e3, t3, r3);
      };
      var s = o2.default;
      r2.default = s;
    }, { "../core/main": 264, "core-js/modules/es.array.concat": 149, "core-js/modules/es.array.slice": 162, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.reflect.construct": 179, "core-js/modules/es.regexp.to-string": 182 }], 296: [function(e2, t2, r2) {
      Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, o2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      function b2(e3) {
        return 0.5 * (1 - Math.cos(e3 * Math.PI));
      }
      var _, x = 4095, w = 4, j = 0.5;
      o2.default.prototype.noise = function(e3) {
        var t3 = 1 < arguments.length && arguments[1] !== void 0 ? arguments[1] : 0, r3 = 2 < arguments.length && arguments[2] !== void 0 ? arguments[2] : 0;
        if (_ == null) {
          _ = new Array(4096);
          for (var n3 = 0; n3 < 4096; n3++)
            _[n3] = Math.random();
        }
        e3 < 0 && (e3 = -e3), t3 < 0 && (t3 = -t3), r3 < 0 && (r3 = -r3);
        for (var o3, i3, a2, s, l2, u2 = Math.floor(e3), c = Math.floor(t3), d = Math.floor(r3), f = e3 - u2, h2 = t3 - c, p2 = r3 - d, y = 0, m2 = 0.5, g = 0; g < w; g++) {
          var v = u2 + (c << 4) + (d << 8);
          o3 = b2(f), i3 = b2(h2), a2 = _[v & x], a2 += o3 * (_[v + 1 & x] - a2), s = _[v + 16 & x], a2 += i3 * ((s += o3 * (_[v + 16 + 1 & x] - s)) - a2), s = _[(v += 256) & x], s += o3 * (_[v + 1 & x] - s), l2 = _[v + 16 & x], s += i3 * ((l2 += o3 * (_[v + 16 + 1 & x] - l2)) - s), y += (a2 += b2(p2) * (s - a2)) * m2, m2 *= j, u2 <<= 1, c <<= 1, d <<= 1, 1 <= (f *= 2) && (u2++, f--), 1 <= (h2 *= 2) && (c++, h2--), 1 <= (p2 *= 2) && (d++, p2--);
        }
        return y;
      }, o2.default.prototype.noiseDetail = function(e3, t3) {
        0 < e3 && (w = e3), 0 < t3 && (j = t3);
      }, o2.default.prototype.noiseSeed = function(e3) {
        var t3, r3, n3, o3 = (n3 = 4294967296, { setSeed: function(e4) {
          r3 = t3 = (e4 == null ? Math.random() * n3 : e4) >>> 0;
        }, getSeed: function() {
          return t3;
        }, rand: function() {
          return (r3 = (1664525 * r3 + 1013904223) % n3) / n3;
        } });
        o3.setSeed(e3), _ = new Array(4096);
        for (var i3 = 0; i3 < 4096; i3++)
          _[i3] = o3.rand();
      };
      var i2 = o2.default;
      r2.default = i2;
    }, { "../core/main": 264 }], 297: [function(e2, t2, r2) {
      function a2(e3) {
        return (a2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      e2("core-js/modules/es.array.concat"), e2("core-js/modules/es.array.every"), e2("core-js/modules/es.array.slice"), e2("core-js/modules/es.array.some"), e2("core-js/modules/es.math.sign"), e2("core-js/modules/es.number.constructor"), e2("core-js/modules/es.number.is-finite"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.regexp.to-string"), e2("core-js/modules/es.string.sub"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, l2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 }, i2 = function(e3) {
        if (e3 && e3.__esModule)
          return e3;
        if (e3 === null || a2(e3) !== "object" && typeof e3 != "function")
          return { default: e3 };
        var t3 = s();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o3 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o3)) {
            var i3 = n3 ? Object.getOwnPropertyDescriptor(e3, o3) : null;
            i3 && (i3.get || i3.set) ? Object.defineProperty(r3, o3, i3) : r3[o3] = e3[o3];
          }
        r3.default = e3, t3 && t3.set(e3, r3);
        return r3;
      }(e2("../core/constants"));
      function s() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return s = function() {
          return e3;
        }, e3;
      }
      l2.default.Vector = function(e3, t3, r3, n3, o3) {
        var i3, a3, s2;
        s2 = {}.toString.call(e3) === "[object Function]" ? (this.isPInst = true, this._fromRadians = e3, this._toRadians = t3, i3 = r3 || 0, a3 = n3 || 0, o3 || 0) : (i3 = e3 || 0, a3 = t3 || 0, r3 || 0), this.x = i3, this.y = a3, this.z = s2;
      }, l2.default.Vector.prototype.toString = function() {
        return "p5.Vector Object : [".concat(this.x, ", ").concat(this.y, ", ").concat(this.z, "]");
      }, l2.default.Vector.prototype.set = function(e3, t3, r3) {
        return e3 instanceof l2.default.Vector ? (this.x = e3.x || 0, this.y = e3.y || 0, this.z = e3.z || 0) : e3 instanceof Array ? (this.x = e3[0] || 0, this.y = e3[1] || 0, this.z = e3[2] || 0) : (this.x = e3 || 0, this.y = t3 || 0, this.z = r3 || 0), this;
      }, l2.default.Vector.prototype.copy = function() {
        return this.isPInst ? new l2.default.Vector(this._fromRadians, this._toRadians, this.x, this.y, this.z) : new l2.default.Vector(this.x, this.y, this.z);
      }, l2.default.Vector.prototype.add = function(e3, t3, r3) {
        return e3 instanceof l2.default.Vector ? (this.x += e3.x || 0, this.y += e3.y || 0, this.z += e3.z || 0) : e3 instanceof Array ? (this.x += e3[0] || 0, this.y += e3[1] || 0, this.z += e3[2] || 0) : (this.x += e3 || 0, this.y += t3 || 0, this.z += r3 || 0), this;
      };
      function u2(e3, t3) {
        return e3 !== 0 && (this.x = this.x % e3), t3 !== 0 && (this.y = this.y % t3), this;
      }
      function c(e3, t3, r3) {
        return e3 !== 0 && (this.x = this.x % e3), t3 !== 0 && (this.y = this.y % t3), r3 !== 0 && (this.z = this.z % r3), this;
      }
      l2.default.Vector.prototype.rem = function(e3, t3, r3) {
        if (e3 instanceof l2.default.Vector) {
          if (Number.isFinite(e3.x) && Number.isFinite(e3.y) && Number.isFinite(e3.z)) {
            var n3 = parseFloat(e3.x), o3 = parseFloat(e3.y), i3 = parseFloat(e3.z);
            return c.call(this, n3, o3, i3);
          }
        } else if (e3 instanceof Array) {
          if (e3.every(function(e4) {
            return Number.isFinite(e4);
          })) {
            if (e3.length === 2)
              return u2.call(this, e3[0], e3[1]);
            if (e3.length === 3)
              return c.call(this, e3[0], e3[1], e3[2]);
          }
        } else if (arguments.length === 1) {
          if (Number.isFinite(e3) && e3 !== 0)
            return this.x = this.x % e3, this.y = this.y % e3, this.z = this.z % e3, this;
        } else if (arguments.length === 2) {
          var a3 = Array.prototype.slice.call(arguments);
          if (a3.every(function(e4) {
            return Number.isFinite(e4);
          }) && a3.length === 2)
            return u2.call(this, a3[0], a3[1]);
        } else if (arguments.length === 3) {
          var s2 = Array.prototype.slice.call(arguments);
          if (s2.every(function(e4) {
            return Number.isFinite(e4);
          }) && s2.length === 3)
            return c.call(this, s2[0], s2[1], s2[2]);
        }
      }, l2.default.Vector.prototype.sub = function(e3, t3, r3) {
        return e3 instanceof l2.default.Vector ? (this.x -= e3.x || 0, this.y -= e3.y || 0, this.z -= e3.z || 0) : e3 instanceof Array ? (this.x -= e3[0] || 0, this.y -= e3[1] || 0, this.z -= e3[2] || 0) : (this.x -= e3 || 0, this.y -= t3 || 0, this.z -= r3 || 0), this;
      }, l2.default.Vector.prototype.mult = function(e3, t3, r3) {
        if (e3 instanceof l2.default.Vector)
          return Number.isFinite(e3.x) && Number.isFinite(e3.y) && Number.isFinite(e3.z) && typeof e3.x == "number" && typeof e3.y == "number" && typeof e3.z == "number" ? (this.x *= e3.x, this.y *= e3.y, this.z *= e3.z) : console.warn("p5.Vector.prototype.mult:", "x contains components that are either undefined or not finite numbers"), this;
        if (e3 instanceof Array)
          return e3.every(function(e4) {
            return Number.isFinite(e4);
          }) && e3.every(function(e4) {
            return typeof e4 == "number";
          }) ? e3.length === 1 ? (this.x *= e3[0], this.y *= e3[0], this.z *= e3[0]) : e3.length === 2 ? (this.x *= e3[0], this.y *= e3[1]) : e3.length === 3 && (this.x *= e3[0], this.y *= e3[1], this.z *= e3[2]) : console.warn("p5.Vector.prototype.mult:", "x contains elements that are either undefined or not finite numbers"), this;
        var n3 = Array.prototype.slice.call(arguments);
        return n3.every(function(e4) {
          return Number.isFinite(e4);
        }) && n3.every(function(e4) {
          return typeof e4 == "number";
        }) ? (arguments.length === 1 && (this.x *= e3, this.y *= e3, this.z *= e3), arguments.length === 2 && (this.x *= e3, this.y *= t3), arguments.length === 3 && (this.x *= e3, this.y *= t3, this.z *= r3)) : console.warn("p5.Vector.prototype.mult:", "x, y, or z arguments are either undefined or not a finite number"), this;
      }, l2.default.Vector.prototype.div = function(e3, t3, r3) {
        if (e3 instanceof l2.default.Vector) {
          if (Number.isFinite(e3.x) && Number.isFinite(e3.y) && Number.isFinite(e3.z) && typeof e3.x == "number" && typeof e3.y == "number" && typeof e3.z == "number") {
            if (e3.x === 0 || e3.y === 0 || e3.z === 0)
              return console.warn("p5.Vector.prototype.div:", "divide by 0"), this;
            this.x /= e3.x, this.y /= e3.y, this.z /= e3.z;
          } else
            console.warn("p5.Vector.prototype.div:", "x contains components that are either undefined or not finite numbers");
          return this;
        }
        if (e3 instanceof Array) {
          if (e3.every(function(e4) {
            return Number.isFinite(e4);
          }) && e3.every(function(e4) {
            return typeof e4 == "number";
          })) {
            if (e3.some(function(e4) {
              return e4 === 0;
            }))
              return console.warn("p5.Vector.prototype.div:", "divide by 0"), this;
            e3.length === 1 ? (this.x /= e3[0], this.y /= e3[0], this.z /= e3[0]) : e3.length === 2 ? (this.x /= e3[0], this.y /= e3[1]) : e3.length === 3 && (this.x /= e3[0], this.y /= e3[1], this.z /= e3[2]);
          } else
            console.warn("p5.Vector.prototype.div:", "x contains components that are either undefined or not finite numbers");
          return this;
        }
        var n3 = Array.prototype.slice.call(arguments);
        if (n3.every(function(e4) {
          return Number.isFinite(e4);
        }) && n3.every(function(e4) {
          return typeof e4 == "number";
        })) {
          if (n3.some(function(e4) {
            return e4 === 0;
          }))
            return console.warn("p5.Vector.prototype.div:", "divide by 0"), this;
          arguments.length === 1 && (this.x /= e3, this.y /= e3, this.z /= e3), arguments.length === 2 && (this.x /= e3, this.y /= t3), arguments.length === 3 && (this.x /= e3, this.y /= t3, this.z /= r3);
        } else
          console.warn("p5.Vector.prototype.div:", "x, y, or z arguments are either undefined or not a finite number");
        return this;
      }, l2.default.Vector.prototype.mag = function() {
        return Math.sqrt(this.magSq());
      }, l2.default.Vector.prototype.magSq = function() {
        var e3 = this.x, t3 = this.y, r3 = this.z;
        return e3 * e3 + t3 * t3 + r3 * r3;
      }, l2.default.Vector.prototype.dot = function(e3, t3, r3) {
        return e3 instanceof l2.default.Vector ? this.dot(e3.x, e3.y, e3.z) : this.x * (e3 || 0) + this.y * (t3 || 0) + this.z * (r3 || 0);
      }, l2.default.Vector.prototype.cross = function(e3) {
        var t3 = this.y * e3.z - this.z * e3.y, r3 = this.z * e3.x - this.x * e3.z, n3 = this.x * e3.y - this.y * e3.x;
        return this.isPInst ? new l2.default.Vector(this._fromRadians, this._toRadians, t3, r3, n3) : new l2.default.Vector(t3, r3, n3);
      }, l2.default.Vector.prototype.dist = function(e3) {
        return e3.copy().sub(this).mag();
      }, l2.default.Vector.prototype.normalize = function() {
        var e3 = this.mag();
        return e3 !== 0 && this.mult(1 / e3), this;
      }, l2.default.Vector.prototype.limit = function(e3) {
        var t3 = this.magSq();
        return e3 * e3 < t3 && this.div(Math.sqrt(t3)).mult(e3), this;
      }, l2.default.Vector.prototype.setMag = function(e3) {
        return this.normalize().mult(e3);
      }, l2.default.Vector.prototype.heading = function() {
        var e3 = Math.atan2(this.y, this.x);
        return this.isPInst ? this._fromRadians(e3) : e3;
      }, l2.default.Vector.prototype.setHeading = function(e3) {
        var t3 = this.mag();
        return this.x = t3 * Math.cos(e3), this.y = t3 * Math.sin(e3), this;
      }, l2.default.Vector.prototype.rotate = function(e3) {
        var t3 = this.heading() + e3;
        this.isPInst && (t3 = this._toRadians(t3));
        var r3 = this.mag();
        return this.x = Math.cos(t3) * r3, this.y = Math.sin(t3) * r3, this;
      }, l2.default.Vector.prototype.angleBetween = function(e3) {
        var t3, r3 = this.dot(e3) / (this.mag() * e3.mag());
        return t3 = Math.acos(Math.min(1, Math.max(-1, r3))), t3 *= Math.sign(this.cross(e3).z || 1), this.isPInst && (t3 = this._fromRadians(t3)), t3;
      }, l2.default.Vector.prototype.lerp = function(e3, t3, r3, n3) {
        return e3 instanceof l2.default.Vector ? this.lerp(e3.x, e3.y, e3.z, t3) : (this.x += (e3 - this.x) * n3 || 0, this.y += (t3 - this.y) * n3 || 0, this.z += (r3 - this.z) * n3 || 0, this);
      }, l2.default.Vector.prototype.reflect = function(e3) {
        return e3.normalize(), this.sub(e3.mult(2 * this.dot(e3)));
      }, l2.default.Vector.prototype.array = function() {
        return [this.x || 0, this.y || 0, this.z || 0];
      }, l2.default.Vector.prototype.equals = function(e3, t3, r3) {
        var n3, o3, i3;
        return i3 = e3 instanceof l2.default.Vector ? (n3 = e3.x || 0, o3 = e3.y || 0, e3.z || 0) : e3 instanceof Array ? (n3 = e3[0] || 0, o3 = e3[1] || 0, e3[2] || 0) : (n3 = e3 || 0, o3 = t3 || 0, r3 || 0), this.x === n3 && this.y === o3 && this.z === i3;
      }, l2.default.Vector.fromAngle = function(e3, t3) {
        return t3 === void 0 && (t3 = 1), new l2.default.Vector(t3 * Math.cos(e3), t3 * Math.sin(e3), 0);
      }, l2.default.Vector.fromAngles = function(e3, t3, r3) {
        r3 === void 0 && (r3 = 1);
        var n3 = Math.cos(t3), o3 = Math.sin(t3), i3 = Math.cos(e3), a3 = Math.sin(e3);
        return new l2.default.Vector(r3 * a3 * o3, -r3 * i3, r3 * a3 * n3);
      }, l2.default.Vector.random2D = function() {
        return this.fromAngle(Math.random() * i2.TWO_PI);
      }, l2.default.Vector.random3D = function() {
        var e3 = Math.random() * i2.TWO_PI, t3 = 2 * Math.random() - 1, r3 = Math.sqrt(1 - t3 * t3), n3 = r3 * Math.cos(e3), o3 = r3 * Math.sin(e3);
        return new l2.default.Vector(n3, o3, t3);
      }, l2.default.Vector.add = function(e3, t3, r3) {
        return r3 ? r3.set(e3) : (r3 = e3.copy(), arguments.length === 3 && l2.default._friendlyError("The target parameter is undefined, it should be of type p5.Vector", "p5.Vector.add")), r3.add(t3), r3;
      }, l2.default.Vector.rem = function(e3, t3) {
        if (e3 instanceof l2.default.Vector && t3 instanceof l2.default.Vector) {
          var r3 = e3.copy();
          return r3.rem(t3), r3;
        }
      }, l2.default.Vector.sub = function(e3, t3, r3) {
        return r3 ? r3.set(e3) : (r3 = e3.copy(), arguments.length === 3 && l2.default._friendlyError("The target parameter is undefined, it should be of type p5.Vector", "p5.Vector.sub")), r3.sub(t3), r3;
      }, l2.default.Vector.mult = function(e3, t3, r3) {
        return r3 ? r3.set(e3) : (r3 = e3.copy(), arguments.length === 3 && l2.default._friendlyError("The target parameter is undefined, it should be of type p5.Vector", "p5.Vector.mult")), r3.mult(t3), r3;
      }, l2.default.Vector.rotate = function(e3, t3, r3) {
        return arguments.length === 2 ? r3 = e3.copy() : (r3 instanceof l2.default.Vector || l2.default._friendlyError("The target parameter should be of type p5.Vector", "p5.Vector.rotate"), r3.set(e3)), r3.rotate(t3), r3;
      }, l2.default.Vector.div = function(e3, t3, r3) {
        return r3 ? r3.set(e3) : (r3 = e3.copy(), arguments.length === 3 && l2.default._friendlyError("The target parameter is undefined, it should be of type p5.Vector", "p5.Vector.div")), r3.div(t3), r3;
      }, l2.default.Vector.dot = function(e3, t3) {
        return e3.dot(t3);
      }, l2.default.Vector.cross = function(e3, t3) {
        return e3.cross(t3);
      }, l2.default.Vector.dist = function(e3, t3) {
        return e3.dist(t3);
      }, l2.default.Vector.lerp = function(e3, t3, r3, n3) {
        return n3 ? n3.set(e3) : (n3 = e3.copy(), arguments.length === 4 && l2.default._friendlyError("The target parameter is undefined, it should be of type p5.Vector", "p5.Vector.lerp")), n3.lerp(t3, r3), n3;
      }, l2.default.Vector.mag = function(e3) {
        var t3 = e3.x, r3 = e3.y, n3 = e3.z, o3 = t3 * t3 + r3 * r3 + n3 * n3;
        return Math.sqrt(o3);
      }, l2.default.Vector.normalize = function(e3, t3) {
        return arguments.length < 2 ? t3 = e3.copy() : (t3 instanceof l2.default.Vector || l2.default._friendlyError("The target parameter should be of type p5.Vector", "p5.Vector.normalize"), t3.set(e3)), t3.normalize();
      };
      var o2 = l2.default.Vector;
      r2.default = o2;
    }, { "../core/constants": 253, "../core/main": 264, "core-js/modules/es.array.concat": 149, "core-js/modules/es.array.every": 150, "core-js/modules/es.array.slice": 162, "core-js/modules/es.array.some": 163, "core-js/modules/es.math.sign": 169, "core-js/modules/es.number.constructor": 170, "core-js/modules/es.number.is-finite": 171, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.regexp.to-string": 182, "core-js/modules/es.string.sub": 192 }], 298: [function(e2, t2, r2) {
      Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, o2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      var i2 = "_lcg_random_state", a2 = 4294967296, s = 0;
      o2.default.prototype._lcg = function(e3) {
        return this[e3] = (1664525 * this[e3] + 1013904223) % a2, this[e3] / a2;
      }, o2.default.prototype._lcgSetSeed = function(e3, t3) {
        this[e3] = (t3 == null ? Math.random() * a2 : t3) >>> 0;
      }, o2.default.prototype.randomSeed = function(e3) {
        this._lcgSetSeed(i2, e3), this._gaussian_previous = false;
      }, o2.default.prototype.random = function(e3, t3) {
        var r3;
        if (o2.default._validateParameters("random", arguments), r3 = this[i2] != null ? this._lcg(i2) : Math.random(), e3 === void 0)
          return r3;
        if (t3 === void 0)
          return e3 instanceof Array ? e3[Math.floor(r3 * e3.length)] : r3 * e3;
        if (t3 < e3) {
          var n3 = e3;
          e3 = t3, t3 = n3;
        }
        return r3 * (t3 - e3) + e3;
      }, o2.default.prototype.randomGaussian = function(e3) {
        var t3, r3, n3, o3, i3 = 1 < arguments.length && arguments[1] !== void 0 ? arguments[1] : 1;
        if (this._gaussian_previous)
          t3 = s, this._gaussian_previous = false;
        else {
          for (; 1 <= (o3 = (r3 = this.random(2) - 1) * r3 + (n3 = this.random(2) - 1) * n3); )
            ;
          t3 = r3 * (o3 = Math.sqrt(-2 * Math.log(o3) / o3)), s = n3 * o3, this._gaussian_previous = true;
        }
        return t3 * i3 + (e3 || 0);
      };
      var l2 = o2.default;
      r2.default = l2;
    }, { "../core/main": 264 }], 299: [function(e2, t2, r2) {
      function a2(e3) {
        return (a2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, o2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 }, i2 = function(e3) {
        if (e3 && e3.__esModule)
          return e3;
        if (e3 === null || a2(e3) !== "object" && typeof e3 != "function")
          return { default: e3 };
        var t3 = s();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o3 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o3)) {
            var i3 = n3 ? Object.getOwnPropertyDescriptor(e3, o3) : null;
            i3 && (i3.get || i3.set) ? Object.defineProperty(r3, o3, i3) : r3[o3] = e3[o3];
          }
        r3.default = e3, t3 && t3.set(e3, r3);
        return r3;
      }(e2("../core/constants"));
      function s() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return s = function() {
          return e3;
        }, e3;
      }
      o2.default.prototype._angleMode = i2.RADIANS, o2.default.prototype.acos = function(e3) {
        return this._fromRadians(Math.acos(e3));
      }, o2.default.prototype.asin = function(e3) {
        return this._fromRadians(Math.asin(e3));
      }, o2.default.prototype.atan = function(e3) {
        return this._fromRadians(Math.atan(e3));
      }, o2.default.prototype.atan2 = function(e3, t3) {
        return this._fromRadians(Math.atan2(e3, t3));
      }, o2.default.prototype.cos = function(e3) {
        return Math.cos(this._toRadians(e3));
      }, o2.default.prototype.sin = function(e3) {
        return Math.sin(this._toRadians(e3));
      }, o2.default.prototype.tan = function(e3) {
        return Math.tan(this._toRadians(e3));
      }, o2.default.prototype.degrees = function(e3) {
        return e3 * i2.RAD_TO_DEG;
      }, o2.default.prototype.radians = function(e3) {
        return e3 * i2.DEG_TO_RAD;
      }, o2.default.prototype.angleMode = function(e3) {
        e3 !== i2.DEGREES && e3 !== i2.RADIANS || (this._angleMode = e3);
      }, o2.default.prototype._toRadians = function(e3) {
        return this._angleMode === i2.DEGREES ? e3 * i2.DEG_TO_RAD : e3;
      }, o2.default.prototype._toDegrees = function(e3) {
        return this._angleMode === i2.RADIANS ? e3 * i2.RAD_TO_DEG : e3;
      }, o2.default.prototype._fromRadians = function(e3) {
        return this._angleMode === i2.DEGREES ? e3 * i2.RAD_TO_DEG : e3;
      };
      var l2 = o2.default;
      r2.default = l2;
    }, { "../core/constants": 253, "../core/main": 264 }], 300: [function(e2, t2, r2) {
      Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, o2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      o2.default.prototype.textAlign = function(e3, t3) {
        var r3;
        return o2.default._validateParameters("textAlign", arguments), (r3 = this._renderer).textAlign.apply(r3, arguments);
      }, o2.default.prototype.textLeading = function(e3) {
        var t3;
        return o2.default._validateParameters("textLeading", arguments), (t3 = this._renderer).textLeading.apply(t3, arguments);
      }, o2.default.prototype.textSize = function(e3) {
        var t3;
        return o2.default._validateParameters("textSize", arguments), (t3 = this._renderer).textSize.apply(t3, arguments);
      }, o2.default.prototype.textStyle = function(e3) {
        var t3;
        return o2.default._validateParameters("textStyle", arguments), (t3 = this._renderer).textStyle.apply(t3, arguments);
      }, o2.default.prototype.textWidth = function() {
        for (var e3, t3 = arguments.length, r3 = new Array(t3), n3 = 0; n3 < t3; n3++)
          r3[n3] = arguments[n3];
        return r3[0] += "", o2.default._validateParameters("textWidth", r3), r3[0].length === 0 ? 0 : (e3 = this._renderer).textWidth.apply(e3, r3);
      }, o2.default.prototype.textAscent = function() {
        for (var e3 = arguments.length, t3 = new Array(e3), r3 = 0; r3 < e3; r3++)
          t3[r3] = arguments[r3];
        return o2.default._validateParameters("textAscent", t3), this._renderer.textAscent();
      }, o2.default.prototype.textDescent = function() {
        for (var e3 = arguments.length, t3 = new Array(e3), r3 = 0; r3 < e3; r3++)
          t3[r3] = arguments[r3];
        return o2.default._validateParameters("textDescent", t3), this._renderer.textDescent();
      }, o2.default.prototype._updateTextMetrics = function() {
        return this._renderer._updateTextMetrics();
      }, o2.default.prototype.textWrap = function(e3) {
        if (e3 !== "WORD" && e3 !== "CHAR")
          throw "Error: textWrap accepts only WORD or CHAR";
        return this._renderer.textWrap(e3);
      };
      var i2 = o2.default;
      r2.default = i2;
    }, { "../core/main": 264 }], 301: [function(e2, t2, r2) {
      function a2(e3) {
        return (a2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      e2("core-js/modules/es.array.concat"), e2("core-js/modules/es.array.includes"), e2("core-js/modules/es.array.last-index-of"), e2("core-js/modules/es.regexp.exec"), e2("core-js/modules/es.string.split"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, f = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 }, o2 = l2(e2("../core/constants")), i2 = l2(e2("opentype.js"));
      function s() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return s = function() {
          return e3;
        }, e3;
      }
      function l2(e3) {
        if (e3 && e3.__esModule)
          return e3;
        if (e3 === null || a2(e3) !== "object" && typeof e3 != "function")
          return { default: e3 };
        var t3 = s();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o3 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o3)) {
            var i3 = n3 ? Object.getOwnPropertyDescriptor(e3, o3) : null;
            i3 && (i3.get || i3.set) ? Object.defineProperty(r3, o3, i3) : r3[o3] = e3[o3];
          }
        return r3.default = e3, t3 && t3.set(e3, r3), r3;
      }
      e2("../core/friendly_errors/validate_params"), e2("../core/friendly_errors/file_errors"), e2("../core/friendly_errors/fes_core"), f.default.prototype.loadFont = function(s2, l3, u3) {
        f.default._validateParameters("loadFont", arguments);
        var c = new f.default.Font(this), d = this;
        return i2.load(s2, function(e3, t3) {
          if (e3)
            return f.default._friendlyFileLoadError(4, s2), u3 !== void 0 ? u3(e3) : void console.error(e3, s2);
          c.font = t3, l3 !== void 0 && l3(c), d._decrementPreload();
          var r3, n3, o3 = s2.split("\\").pop().split("/").pop(), i3 = o3.lastIndexOf("."), a3 = i3 < 1 ? null : o3.substr(i3 + 1);
          ["ttf", "otf", "woff", "woff2"].includes(a3) && (r3 = o3.substr(0, i3), (n3 = document.createElement("style")).appendChild(document.createTextNode("\n@font-face {\nfont-family: ".concat(r3, ";\nsrc: url(").concat(s2, ");\n}\n"))), document.head.appendChild(n3));
        }), c;
      }, f.default.prototype.text = function(e3, t3, r3, n3, o3) {
        var i3;
        return f.default._validateParameters("text", arguments), this._renderer._doFill || this._renderer._doStroke ? (i3 = this._renderer).text.apply(i3, arguments) : this;
      }, f.default.prototype.textFont = function(e3, t3) {
        if (f.default._validateParameters("textFont", arguments), arguments.length) {
          if (!e3)
            throw new Error("null font passed to textFont");
          return this._renderer._setProperty("_textFont", e3), t3 && (this._renderer._setProperty("_textSize", t3), this._renderer._leadingSet || this._renderer._setProperty("_textLeading", t3 * o2._DEFAULT_LEADMULT)), this._renderer._applyTextProperties();
        }
        return this._renderer._textFont;
      };
      var u2 = f.default;
      r2.default = u2;
    }, { "../core/constants": 253, "../core/friendly_errors/fes_core": 255, "../core/friendly_errors/file_errors": 256, "../core/friendly_errors/validate_params": 259, "../core/main": 264, "core-js/modules/es.array.concat": 149, "core-js/modules/es.array.includes": 156, "core-js/modules/es.array.last-index-of": 160, "core-js/modules/es.regexp.exec": 181, "core-js/modules/es.string.split": 191, "opentype.js": 239 }], 302: [function(e2, t2, r2) {
      e2("core-js/modules/es.symbol"), e2("core-js/modules/es.symbol.description"), e2("core-js/modules/es.symbol.iterator"), e2("core-js/modules/es.array.concat"), e2("core-js/modules/es.array.fill"), e2("core-js/modules/es.array.iterator"), e2("core-js/modules/es.array.join"), e2("core-js/modules/es.array.slice"), e2("core-js/modules/es.array.splice"), e2("core-js/modules/es.function.name"), e2("core-js/modules/es.number.to-fixed"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.regexp.exec"), e2("core-js/modules/es.string.iterator"), e2("core-js/modules/es.string.split"), e2("core-js/modules/web.dom-collections.iterator"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, o2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 }, x = function(e3) {
        if (e3 && e3.__esModule)
          return e3;
        if (e3 === null || h2(e3) !== "object" && typeof e3 != "function")
          return { default: e3 };
        var t3 = a2();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o3 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o3)) {
            var i3 = n3 ? Object.getOwnPropertyDescriptor(e3, o3) : null;
            i3 && (i3.get || i3.set) ? Object.defineProperty(r3, o3, i3) : r3[o3] = e3[o3];
          }
        r3.default = e3, t3 && t3.set(e3, r3);
        return r3;
      }(e2("../core/constants"));
      function a2() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return a2 = function() {
          return e3;
        }, e3;
      }
      function h2(e3) {
        return (h2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      function p2(e3, t3) {
        for (var r3 = function(e4, t4) {
          if (h2(e4) !== "object")
            e4 = t4;
          else
            for (var r4 in t4)
              e4[r4] === void 0 && (e4[r4] = t4[r4]);
          return e4;
        }(t3, { sampleFactor: 0.1, simplifyThreshold: 0 }), n3 = l2(e3, 0, 1), o3 = n3 / (n3 * r3.sampleFactor), i3 = [], a3 = 0; a3 < n3; a3 += o3)
          i3.push(l2(e3, a3));
        return r3.simplifyThreshold && function(e4) {
          for (var t4 = 1 < arguments.length && arguments[1] !== void 0 ? arguments[1] : 0, r4 = 0, n4 = e4.length - 1; 3 < e4.length && 0 <= n4; --n4)
            f(s(e4, n4 - 1), s(e4, n4), s(e4, n4 + 1), t4) && (e4.splice(n4 % e4.length, 1), r4++);
        }(i3, r3.simplifyThreshold), i3;
      }
      function y(e3) {
        for (var t3, r3 = [], n3 = 0; n3 < e3.length; n3++)
          e3[n3].type === "M" && (t3 && r3.push(t3), t3 = []), t3.push(i2(e3[n3]));
        return r3.push(t3), r3;
      }
      function i2(e3) {
        var t3 = [e3.type];
        return e3.type === "M" || e3.type === "L" ? t3.push(e3.x, e3.y) : e3.type === "C" ? t3.push(e3.x1, e3.y1, e3.x2, e3.y2, e3.x, e3.y) : e3.type === "Q" && t3.push(e3.x1, e3.y1, e3.x, e3.y), t3;
      }
      function s(e3, t3) {
        var r3 = e3.length;
        return e3[t3 < 0 ? t3 % r3 + r3 : t3 % r3];
      }
      function f(e3, t3, r3, n3) {
        if (!n3)
          return (o3 = e3, a3 = r3, ((i3 = t3)[0] - o3[0]) * (a3[1] - o3[1]) - (a3[0] - o3[0]) * (i3[1] - o3[1])) == 0;
        var o3, i3, a3;
        f.tmpPoint1 === void 0 && (f.tmpPoint1 = [], f.tmpPoint2 = []);
        var s2 = f.tmpPoint1, l3 = f.tmpPoint2;
        s2.x = t3.x - e3.x, s2.y = t3.y - e3.y, l3.x = r3.x - t3.x, l3.y = r3.y - t3.y;
        var u3 = s2.x * l3.x + s2.y * l3.y, c = Math.sqrt(s2.x * s2.x + s2.y * s2.y), d2 = Math.sqrt(l3.x * l3.x + l3.y * l3.y);
        return Math.acos(u3 / (c * d2)) < n3;
      }
      function d(e3, t3, r3, n3, o3, i3, a3, s2, l3) {
        var u3 = 1 - l3, c = Math.pow(u3, 3), d2 = Math.pow(u3, 2), f2 = l3 * l3, h3 = f2 * l3, p3 = c * e3 + 3 * d2 * l3 * r3 + 3 * u3 * l3 * l3 * o3 + h3 * a3, y2 = c * t3 + 3 * d2 * l3 * n3 + 3 * u3 * l3 * l3 * i3 + h3 * s2, m3 = e3 + 2 * l3 * (r3 - e3) + f2 * (o3 - 2 * r3 + e3), g2 = t3 + 2 * l3 * (n3 - t3) + f2 * (i3 - 2 * n3 + t3), v2 = r3 + 2 * l3 * (o3 - r3) + f2 * (a3 - 2 * o3 + r3), b3 = n3 + 2 * l3 * (i3 - n3) + f2 * (s2 - 2 * i3 + n3), _2 = u3 * e3 + l3 * r3, x2 = u3 * t3 + l3 * n3, w2 = u3 * o3 + l3 * a3, j2 = u3 * i3 + l3 * s2, S2 = 90 - 180 * Math.atan2(m3 - v2, g2 - b3) / Math.PI;
        return (v2 < m3 || g2 < b3) && (S2 += 180), { x: p3, y: y2, m: { x: m3, y: g2 }, n: { x: v2, y: b3 }, start: { x: _2, y: x2 }, end: { x: w2, y: j2 }, alpha: S2 };
      }
      function m2(e3, t3, r3, n3, o3, i3, a3, s2, l3) {
        return l3 == null ? g(e3, t3, r3, n3, o3, i3, a3, s2) : d(e3, t3, r3, n3, o3, i3, a3, s2, function(e4, t4, r4, n4, o4, i4, a4, s3, l4) {
          if (l4 < 0 || g(e4, t4, r4, n4, o4, i4, a4, s3) < l4)
            return;
          var u3, c = 0.5, d2 = 1 - c;
          u3 = g(e4, t4, r4, n4, o4, i4, a4, s3, d2);
          for (; 0.01 < Math.abs(u3 - l4); )
            u3 = g(e4, t4, r4, n4, o4, i4, a4, s3, d2 += (u3 < l4 ? 1 : -1) * (c /= 2));
          return d2;
        }(e3, t3, r3, n3, o3, i3, a3, s2, l3));
      }
      function l2(e3, t3, r3) {
        for (var n3, o3, i3, a3, s2, l3 = 0, u3 = 0, c = (e3 = function(e4, t4) {
          function r4(e5, t5, r5) {
            var n5, o5;
            if (!e5)
              return ["C", t5.x, t5.y, t5.x, t5.y, t5.x, t5.y];
            switch (e5[0] in { T: 1, Q: 1 } || (t5.qx = t5.qy = null), e5[0]) {
              case "M":
                t5.X = e5[1], t5.Y = e5[2];
                break;
              case "A":
                e5 = ["C"].concat(function e6(t6, r6, n6, o6, i5, a5, s4, l5, u5, c3) {
                  var d3 = Math.PI;
                  var f3 = 120 * d3 / 180;
                  var h4;
                  var p4;
                  var y3;
                  var m4;
                  var g3 = d3 / 180 * (+i5 || 0);
                  var v3 = [];
                  var b3;
                  var _2 = function(e7, t7, r7) {
                    var n7 = e7 * Math.cos(r7) - t7 * Math.sin(r7), o7 = e7 * Math.sin(r7) + t7 * Math.cos(r7);
                    return { x: n7, y: o7 };
                  };
                  if (c3)
                    h4 = c3[0], p4 = c3[1], y3 = c3[2], m4 = c3[3];
                  else {
                    b3 = _2(t6, r6, -g3), t6 = b3.x, r6 = b3.y, b3 = _2(l5, u5, -g3), l5 = b3.x, u5 = b3.y;
                    var x2 = (t6 - l5) / 2, w2 = (r6 - u5) / 2, j2 = x2 * x2 / (n6 * n6) + w2 * w2 / (o6 * o6);
                    1 < j2 && (j2 = Math.sqrt(j2), n6 *= j2, o6 *= j2);
                    var S2 = n6 * n6, M = o6 * o6, E = (a5 === s4 ? -1 : 1) * Math.sqrt(Math.abs((S2 * M - S2 * w2 * w2 - M * x2 * x2) / (S2 * w2 * w2 + M * x2 * x2)));
                    y3 = E * n6 * w2 / o6 + (t6 + l5) / 2, m4 = E * -o6 * x2 / n6 + (r6 + u5) / 2, h4 = Math.asin(((r6 - m4) / o6).toFixed(9)), p4 = Math.asin(((u5 - m4) / o6).toFixed(9)), (h4 = t6 < y3 ? d3 - h4 : h4) < 0 && (h4 = 2 * d3 + h4), (p4 = l5 < y3 ? d3 - p4 : p4) < 0 && (p4 = 2 * d3 + p4), s4 && p4 < h4 && (h4 -= 2 * d3), !s4 && h4 < p4 && (p4 -= 2 * d3);
                  }
                  var T2 = p4 - h4;
                  if (Math.abs(T2) > f3) {
                    var O2 = p4, C = l5, L = u5;
                    p4 = h4 + f3 * (s4 && h4 < p4 ? 1 : -1), l5 = y3 + n6 * Math.cos(p4), u5 = m4 + o6 * Math.sin(p4), v3 = e6(l5, u5, n6, o6, i5, 0, s4, C, L, [p4, O2, y3, m4]);
                  }
                  T2 = p4 - h4;
                  var P2 = Math.cos(h4), A = Math.sin(h4), k2 = Math.cos(p4), R2 = Math.sin(p4), D = Math.tan(T2 / 4), I = 4 / 3 * n6 * D, U = 4 / 3 * o6 * D, N = [t6, r6], F = [t6 + I * A, r6 - U * P2], B = [l5 + I * R2, u5 - U * k2], G = [l5, u5];
                  F[0] = 2 * N[0] - F[0];
                  F[1] = 2 * N[1] - F[1];
                  {
                    if (c3)
                      return [F, B, G].concat(v3);
                    v3 = [F, B, G].concat(v3).join().split(",");
                    for (var V = [], z = 0, H = v3.length; z < H; z++)
                      V[z] = z % 2 ? _2(v3[z - 1], v3[z], g3).y : _2(v3[z], v3[z + 1], g3).x;
                    return V;
                  }
                }.apply(0, [t5.x, t5.y].concat(e5.slice(1))));
                break;
              case "S":
                o5 = r5 === "C" || r5 === "S" ? (n5 = 2 * t5.x - t5.bx, 2 * t5.y - t5.by) : (n5 = t5.x, t5.y), e5 = ["C", n5, o5].concat(e5.slice(1));
                break;
              case "T":
                r5 === "Q" || r5 === "T" ? (t5.qx = 2 * t5.x - t5.qx, t5.qy = 2 * t5.y - t5.qy) : (t5.qx = t5.x, t5.qy = t5.y), e5 = ["C"].concat(j(t5.x, t5.y, t5.qx, t5.qy, e5[1], e5[2]));
                break;
              case "Q":
                t5.qx = e5[1], t5.qy = e5[2], e5 = ["C"].concat(j(t5.x, t5.y, e5[1], e5[2], e5[3], e5[4]));
                break;
              case "L":
                e5 = ["C"].concat(w(t5.x, t5.y, e5[1], e5[2]));
                break;
              case "H":
                e5 = ["C"].concat(w(t5.x, t5.y, e5[1], t5.y));
                break;
              case "V":
                e5 = ["C"].concat(w(t5.x, t5.y, t5.x, e5[1]));
                break;
              case "Z":
                e5 = ["C"].concat(w(t5.x, t5.y, t5.X, t5.Y));
            }
            return e5;
          }
          function n4(e5, t5) {
            if (7 < e5[t5].length) {
              e5[t5].shift();
              for (var r5 = e5[t5]; r5.length; )
                c2[t5] = "A", s3 && (d2[t5] = "A"), e5.splice(t5++, 0, ["C"].concat(r5.splice(0, 6)));
              e5.splice(t5, 1), i4 = Math.max(a4.length, s3 && s3.length || 0);
            }
          }
          function o4(e5, t5, r5, n5, o5) {
            e5 && t5 && e5[o5][0] === "M" && t5[o5][0] !== "M" && (t5.splice(o5, 0, ["M", n5.x, n5.y]), r5.bx = 0, r5.by = 0, r5.x = e5[o5][1], r5.y = e5[o5][2], i4 = Math.max(a4.length, s3 && s3.length || 0));
          }
          var i4, a4 = b2(e4), s3 = t4 && b2(t4), l4 = { x: 0, y: 0, bx: 0, by: 0, X: 0, Y: 0, qx: null, qy: null }, u4 = { x: 0, y: 0, bx: 0, by: 0, X: 0, Y: 0, qx: null, qy: null }, c2 = [], d2 = [], f2 = "", h3 = "";
          i4 = Math.max(a4.length, s3 && s3.length || 0);
          for (var p3 = 0; p3 < i4; p3++) {
            a4[p3] && (f2 = a4[p3][0]), f2 !== "C" && (c2[p3] = f2, p3 && (h3 = c2[p3 - 1])), a4[p3] = r4(a4[p3], l4, h3), c2[p3] !== "A" && f2 === "C" && (c2[p3] = "C"), n4(a4, p3), s3 && (s3[p3] && (f2 = s3[p3][0]), f2 !== "C" && (d2[p3] = f2, p3 && (h3 = d2[p3 - 1])), s3[p3] = r4(s3[p3], u4, h3), d2[p3] !== "A" && f2 === "C" && (d2[p3] = "C"), n4(s3, p3)), o4(a4, s3, l4, u4, p3), o4(s3, a4, u4, l4, p3);
            var y2 = a4[p3], m3 = s3 && s3[p3], g2 = y2.length, v2 = s3 && m3.length;
            l4.x = y2[g2 - 2], l4.y = y2[g2 - 1], l4.bx = parseFloat(y2[g2 - 4]) || l4.x, l4.by = parseFloat(y2[g2 - 3]) || l4.y, u4.bx = s3 && (parseFloat(m3[v2 - 4]) || u4.x), u4.by = s3 && (parseFloat(m3[v2 - 3]) || u4.y), u4.x = s3 && m3[v2 - 2], u4.y = s3 && m3[v2 - 1];
          }
          return s3 ? [a4, s3] : a4;
        }(e3)).length; u3 < c; u3++) {
          if ((i3 = e3[u3])[0] === "M")
            n3 = +i3[1], o3 = +i3[2];
          else {
            if (t3 < l3 + (a3 = m2(n3, o3, i3[1], i3[2], i3[3], i3[4], i3[5], i3[6])) && !r3)
              return { x: (s2 = m2(n3, o3, i3[1], i3[2], i3[3], i3[4], i3[5], i3[6], t3 - l3)).x, y: s2.y, alpha: s2.alpha };
            l3 += a3, n3 = +i3[5], o3 = +i3[6];
          }
          i3.shift() + i3;
        }
        return (s2 = r3 ? l3 : d(n3, o3, i3[0], i3[1], i3[2], i3[3], i3[4], i3[5], 1)).alpha && (s2 = { x: s2.x, y: s2.y, alpha: s2.alpha }), s2;
      }
      function b2(e3) {
        var t3, r3 = [], n3 = 0, o3 = 0, i3 = 0, a3 = 0, s2 = 0;
        if (!e3)
          return r3;
        e3[0][0] === "M" && (i3 = n3 = +e3[0][1], a3 = o3 = +e3[0][2], s2++, r3[0] = ["M", n3, o3]);
        for (var l3, u3, c = e3.length === 3 && e3[0][0] === "M" && e3[1][0].toUpperCase() === "R" && e3[2][0].toUpperCase() === "Z", d2 = s2, f2 = e3.length; d2 < f2; d2++) {
          if (r3.push(l3 = []), (u3 = e3[d2])[0] !== String.prototype.toUpperCase.call(u3[0]))
            switch (l3[0] = String.prototype.toUpperCase.call(u3[0]), l3[0]) {
              case "A":
                l3[1] = u3[1], l3[2] = u3[2], l3[3] = u3[3], l3[4] = u3[4], l3[5] = u3[5], l3[6] = +(u3[6] + n3), l3[7] = +(u3[7] + o3);
                break;
              case "V":
                l3[1] = +u3[1] + o3;
                break;
              case "H":
                l3[1] = +u3[1] + n3;
                break;
              case "R":
                for (var h3 = 2, p3 = (t3 = [n3, o3].concat(u3.slice(1))).length; h3 < p3; h3++)
                  t3[h3] = +t3[h3] + n3, t3[++h3] = +t3[h3] + o3;
                r3.pop(), r3 = r3.concat(_(t3, c));
                break;
              case "M":
                i3 = +u3[1] + n3, a3 = +u3[2] + o3;
                break;
              default:
                for (var y2 = 1, m3 = u3.length; y2 < m3; y2++)
                  l3[y2] = +u3[y2] + (y2 % 2 ? n3 : o3);
            }
          else if (u3[0] === "R")
            t3 = [n3, o3].concat(u3.slice(1)), r3.pop(), r3 = r3.concat(_(t3, c)), l3 = ["R"].concat(u3.slice(-2));
          else
            for (var g2 = 0, v2 = u3.length; g2 < v2; g2++)
              l3[g2] = u3[g2];
          switch (l3[0]) {
            case "Z":
              n3 = i3, o3 = a3;
              break;
            case "H":
              n3 = l3[1];
              break;
            case "V":
              o3 = l3[1];
              break;
            case "M":
              i3 = l3[l3.length - 2], a3 = l3[l3.length - 1];
              break;
            default:
              n3 = l3[l3.length - 2], o3 = l3[l3.length - 1];
          }
        }
        return r3;
      }
      function _(e3, t3) {
        for (var r3 = [], n3 = 0, o3 = e3.length; n3 < o3 - 2 * !t3; n3 += 2) {
          var i3 = [{ x: +e3[n3 - 2], y: +e3[n3 - 1] }, { x: +e3[n3], y: +e3[n3 + 1] }, { x: +e3[n3 + 2], y: +e3[n3 + 3] }, { x: +e3[n3 + 4], y: +e3[n3 + 5] }];
          t3 ? n3 ? o3 - 4 === n3 ? i3[3] = { x: +e3[0], y: +e3[1] } : o3 - 2 === n3 && (i3[2] = { x: +e3[0], y: +e3[1] }, i3[3] = { x: +e3[2], y: +e3[3] }) : i3[0] = { x: +e3[o3 - 2], y: +e3[o3 - 1] } : o3 - 4 === n3 ? i3[3] = i3[2] : n3 || (i3[0] = { x: +e3[n3], y: +e3[n3 + 1] }), r3.push(["C", (-i3[0].x + 6 * i3[1].x + i3[2].x) / 6, (-i3[0].y + 6 * i3[1].y + i3[2].y) / 6, (i3[1].x + 6 * i3[2].x - i3[3].x) / 6, (i3[1].y + 6 * i3[2].y - i3[3].y) / 6, i3[2].x, i3[2].y]);
        }
        return r3;
      }
      function w(e3, t3, r3, n3) {
        return [e3, t3, r3, n3, r3, n3];
      }
      function j(e3, t3, r3, n3, o3, i3) {
        return [1 / 3 * e3 + 2 / 3 * r3, 1 / 3 * t3 + 2 / 3 * n3, 1 / 3 * o3 + 2 / 3 * r3, 1 / 3 * i3 + 2 / 3 * n3, o3, i3];
      }
      function g(e3, t3, r3, n3, o3, i3, a3, s2, l3) {
        l3 == null && (l3 = 1);
        for (var u3 = (l3 = 1 < l3 ? 1 : l3 < 0 ? 0 : l3) / 2, c = [-0.1252, 0.1252, -0.3678, 0.3678, -0.5873, 0.5873, -0.7699, 0.7699, -0.9041, 0.9041, -0.9816, 0.9816], d2 = 0, f2 = [0.2491, 0.2491, 0.2335, 0.2335, 0.2032, 0.2032, 0.1601, 0.1601, 0.1069, 0.1069, 0.0472, 0.0472], h3 = 0; h3 < 12; h3++) {
          var p3 = u3 * c[h3] + u3, y2 = v(p3, e3, r3, o3, a3), m3 = v(p3, t3, n3, i3, s2), g2 = y2 * y2 + m3 * m3;
          d2 += f2[h3] * Math.sqrt(g2);
        }
        return u3 * d2;
      }
      function v(e3, t3, r3, n3, o3) {
        return e3 * (e3 * (-3 * t3 + 9 * r3 - 9 * n3 + 3 * o3) + 6 * t3 - 12 * r3 + 6 * n3) - 3 * t3 + 3 * r3;
      }
      o2.default.Font = function(e3) {
        this.parent = e3, this.cache = {}, this.font = void 0;
      }, o2.default.Font.prototype.textBounds = function(e3) {
        var t3, r3 = 1 < arguments.length && arguments[1] !== void 0 ? arguments[1] : 0, n3 = 2 < arguments.length && arguments[2] !== void 0 ? arguments[2] : 0, o3 = 3 < arguments.length ? arguments[3] : void 0, i3 = 4 < arguments.length ? arguments[4] : void 0, a3 = i3 && i3.renderer && i3.renderer._pInst || this.parent, s2 = a3._renderer.drawingContext;
        s2.textAlign || x.LEFT, s2.textBaseline || x.BASELINE;
        if (o3 = o3 || a3._renderer._textSize, !t3) {
          var l3, u3, c = [], d2 = [], f2 = [];
          f2[0] = [];
          var h3 = [], p3 = this._scale(o3), y2 = a3._renderer.textLeading(), m3 = 0;
          this.font.forEachGlyph(e3, r3, n3, o3, i3, function(e4, t4, r4, n4) {
            var o4 = e4.getMetrics();
            e4.index === 0 || e4.index === 10 ? f2[m3 += 1] = [] : (f2[m3].push(t4 + o4.xMin * p3), f2[m3].push(t4 + o4.xMax * p3), h3.push(r4 + m3 * y2 + -o4.yMin * p3), h3.push(r4 + m3 * y2 + -o4.yMax * p3));
          }), 0 < f2[m3].length && (c[m3] = Math.min.apply(null, f2[m3]), d2[m3] = Math.max.apply(null, f2[m3]));
          for (var g2 = 0, v2 = 0; v2 <= m3; v2++) {
            c[v2] = Math.min.apply(null, f2[v2]), d2[v2] = Math.max.apply(null, f2[v2]);
            var b3 = d2[v2] - c[v2];
            g2 < b3 && (g2 = b3);
          }
          var _2 = Math.min.apply(null, c);
          t3 = { x: _2, y: l3 = Math.min.apply(null, h3), h: Math.max.apply(null, h3) - l3, w: g2, advance: _2 - r3 }, u3 = this._handleAlignment(a3._renderer, e3, t3.x, t3.y, t3.w + t3.advance), t3.x = u3.x, t3.y = u3.y;
        }
        return t3;
      }, o2.default.Font.prototype.textToPoints = function(e3, t3, r3, n3, o3) {
        var i3, a3 = 0, s2 = [], l3 = this._getGlyphs(e3);
        n3 = n3 || this.parent._renderer._textSize;
        for (var u3 = 0; u3 < l3.length; u3++) {
          if (!(l3[i3 = u3].name && l3[i3].name === "space" || e3.length === l3.length && e3[i3] === " "))
            for (var c = y(l3[u3].getPath(t3, r3, n3).commands), d2 = 0; d2 < c.length; d2++)
              for (var f2 = p2(c[d2], o3), h3 = 0; h3 < f2.length; h3++)
                f2[h3].x += a3, s2.push(f2[h3]);
          a3 += l3[u3].advanceWidth * this._scale(n3);
        }
        return s2;
      }, o2.default.Font.prototype._getGlyphs = function(e3) {
        return this.font.stringToGlyphs(e3);
      }, o2.default.Font.prototype._getPath = function(e3, t3, r3, n3) {
        var o3 = (n3 && n3.renderer && n3.renderer._pInst || this.parent)._renderer, i3 = this._handleAlignment(o3, e3, t3, r3);
        return this.font.getPath(e3, i3.x, i3.y, o3._textSize, n3);
      }, o2.default.Font.prototype._getPathData = function(e3, t3, r3, n3) {
        var o3 = 3;
        return typeof e3 == "string" && 2 < arguments.length ? e3 = this._getPath(e3, t3, r3, n3) : h2(t3) === "object" && (n3 = t3), n3 && typeof n3.decimals == "number" && (o3 = n3.decimals), e3.toPathData(o3);
      }, o2.default.Font.prototype._getSVG = function(e3, t3, r3, n3) {
        var o3 = 3;
        return typeof e3 == "string" && 2 < arguments.length ? e3 = this._getPath(e3, t3, r3, n3) : h2(t3) === "object" && (n3 = t3), n3 && (typeof n3.decimals == "number" && (o3 = n3.decimals), typeof n3.strokeWidth == "number" && (e3.strokeWidth = n3.strokeWidth), n3.fill !== void 0 && (e3.fill = n3.fill), n3.stroke !== void 0 && (e3.stroke = n3.stroke)), e3.toSVG(o3);
      }, o2.default.Font.prototype._renderPath = function(e3, t3, r3, n3) {
        var o3, i3 = n3 && n3.renderer || this.parent._renderer, a3 = i3.drawingContext;
        o3 = h2(e3) === "object" && e3.commands ? e3.commands : this._getPath(e3, t3, r3, n3).commands, a3.beginPath();
        var s2 = true, l3 = false, u3 = void 0;
        try {
          for (var c, d2 = o3[Symbol.iterator](); !(s2 = (c = d2.next()).done); s2 = true) {
            var f2 = c.value;
            f2.type === "M" ? a3.moveTo(f2.x, f2.y) : f2.type === "L" ? a3.lineTo(f2.x, f2.y) : f2.type === "C" ? a3.bezierCurveTo(f2.x1, f2.y1, f2.x2, f2.y2, f2.x, f2.y) : f2.type === "Q" ? a3.quadraticCurveTo(f2.x1, f2.y1, f2.x, f2.y) : f2.type === "Z" && a3.closePath();
          }
        } catch (e4) {
          l3 = true, u3 = e4;
        } finally {
          try {
            s2 || d2.return == null || d2.return();
          } finally {
            if (l3)
              throw u3;
          }
        }
        return i3._doStroke && i3._strokeSet && a3.stroke(), i3._doFill && (i3._fillSet || i3._setFill(x._DEFAULT_TEXT_FILL), a3.fill()), this;
      }, o2.default.Font.prototype._textWidth = function(e3, t3) {
        return this.font.getAdvanceWidth(e3, t3);
      }, o2.default.Font.prototype._textAscent = function(e3) {
        return this.font.ascender * this._scale(e3);
      }, o2.default.Font.prototype._textDescent = function(e3) {
        return -this.font.descender * this._scale(e3);
      }, o2.default.Font.prototype._scale = function(e3) {
        return 1 / this.font.unitsPerEm * (e3 || this.parent._renderer._textSize);
      }, o2.default.Font.prototype._handleAlignment = function(e3, t3, r3, n3, o3) {
        var i3 = e3._textSize;
        switch (o3 === void 0 && (o3 = this._textWidth(t3, i3)), e3._textAlign) {
          case x.CENTER:
            r3 -= o3 / 2;
            break;
          case x.RIGHT:
            r3 -= o3;
        }
        switch (e3._textBaseline) {
          case x.TOP:
            n3 += this._textAscent(i3);
            break;
          case x.CENTER:
            n3 += this._textAscent(i3) / 2;
            break;
          case x.BOTTOM:
            n3 -= this._textDescent(i3);
        }
        return { x: r3, y: n3 };
      };
      var u2 = o2.default;
      r2.default = u2;
    }, { "../core/constants": 253, "../core/main": 264, "core-js/modules/es.array.concat": 149, "core-js/modules/es.array.fill": 151, "core-js/modules/es.array.iterator": 158, "core-js/modules/es.array.join": 159, "core-js/modules/es.array.slice": 162, "core-js/modules/es.array.splice": 164, "core-js/modules/es.function.name": 166, "core-js/modules/es.number.to-fixed": 172, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.regexp.exec": 181, "core-js/modules/es.string.iterator": 186, "core-js/modules/es.string.split": 191, "core-js/modules/es.symbol": 196, "core-js/modules/es.symbol.description": 194, "core-js/modules/es.symbol.iterator": 195, "core-js/modules/web.dom-collections.iterator": 229 }], 303: [function(e2, t2, r2) {
      e2("core-js/modules/es.array.concat"), e2("core-js/modules/es.array.slice"), e2("core-js/modules/es.array.splice"), e2("core-js/modules/es.array-buffer.constructor"), e2("core-js/modules/es.object.to-string"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, o2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      o2.default.prototype.append = function(e3, t3) {
        return e3.push(t3), e3;
      }, o2.default.prototype.arrayCopy = function(e3, t3, r3, n3, o3) {
        var i3, a2;
        e3 = o3 !== void 0 ? (a2 = Math.min(o3, e3.length), i3 = n3, e3.slice(t3, a2 + t3)) : (a2 = r3 !== void 0 ? (a2 = r3, Math.min(a2, e3.length)) : e3.length, i3 = 0, r3 = t3, e3.slice(0, a2)), Array.prototype.splice.apply(r3, [i3, a2].concat(e3));
      }, o2.default.prototype.concat = function(e3, t3) {
        return e3.concat(t3);
      }, o2.default.prototype.reverse = function(e3) {
        return e3.reverse();
      }, o2.default.prototype.shorten = function(e3) {
        return e3.pop(), e3;
      }, o2.default.prototype.shuffle = function(e3, t3) {
        for (var r3, n3, o3 = ArrayBuffer && ArrayBuffer.isView && ArrayBuffer.isView(e3), i3 = (e3 = t3 || o3 ? e3 : e3.slice()).length; 1 < i3; )
          r3 = this.random(0, 1) * i3 | 0, n3 = e3[--i3], e3[i3] = e3[r3], e3[r3] = n3;
        return e3;
      }, o2.default.prototype.sort = function(e3, t3) {
        var r3 = t3 ? e3.slice(0, Math.min(t3, e3.length)) : e3, n3 = t3 ? e3.slice(Math.min(t3, e3.length)) : [];
        return (r3 = typeof r3[0] == "string" ? r3.sort() : r3.sort(function(e4, t4) {
          return e4 - t4;
        })).concat(n3);
      }, o2.default.prototype.splice = function(e3, t3, r3) {
        return Array.prototype.splice.apply(e3, [r3, 0].concat(t3)), e3;
      }, o2.default.prototype.subset = function(e3, t3, r3) {
        return r3 !== void 0 ? e3.slice(t3, t3 + r3) : e3.slice(t3, e3.length);
      };
      var i2 = o2.default;
      r2.default = i2;
    }, { "../core/main": 264, "core-js/modules/es.array-buffer.constructor": 148, "core-js/modules/es.array.concat": 149, "core-js/modules/es.array.slice": 162, "core-js/modules/es.array.splice": 164, "core-js/modules/es.object.to-string": 177 }], 304: [function(e2, t2, r2) {
      e2("core-js/modules/es.array.map"), e2("core-js/modules/es.number.constructor"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.regexp.to-string"), e2("core-js/modules/es.string.repeat"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, o2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      o2.default.prototype.float = function(e3) {
        return e3 instanceof Array ? e3.map(parseFloat) : parseFloat(e3);
      }, o2.default.prototype.int = function(e3) {
        var t3 = 1 < arguments.length && arguments[1] !== void 0 ? arguments[1] : 10;
        return e3 === 1 / 0 || e3 === "Infinity" ? 1 / 0 : e3 === -1 / 0 || e3 === "-Infinity" ? -1 / 0 : typeof e3 == "string" ? parseInt(e3, t3) : typeof e3 == "number" ? 0 | e3 : typeof e3 == "boolean" ? e3 ? 1 : 0 : e3 instanceof Array ? e3.map(function(e4) {
          return o2.default.prototype.int(e4, t3);
        }) : void 0;
      }, o2.default.prototype.str = function(e3) {
        return e3 instanceof Array ? e3.map(o2.default.prototype.str) : String(e3);
      }, o2.default.prototype.boolean = function(e3) {
        return typeof e3 == "number" ? e3 !== 0 : typeof e3 == "string" ? e3.toLowerCase() === "true" : typeof e3 == "boolean" ? e3 : e3 instanceof Array ? e3.map(o2.default.prototype.boolean) : void 0;
      }, o2.default.prototype.byte = function(e3) {
        var t3 = o2.default.prototype.int(e3, 10);
        return typeof t3 == "number" ? (t3 + 128) % 256 - 128 : t3 instanceof Array ? t3.map(o2.default.prototype.byte) : void 0;
      }, o2.default.prototype.char = function(e3) {
        return typeof e3 != "number" || isNaN(e3) ? e3 instanceof Array ? e3.map(o2.default.prototype.char) : typeof e3 == "string" ? o2.default.prototype.char(parseInt(e3, 10)) : void 0 : String.fromCharCode(e3);
      }, o2.default.prototype.unchar = function(e3) {
        return typeof e3 == "string" && e3.length === 1 ? e3.charCodeAt(0) : e3 instanceof Array ? e3.map(o2.default.prototype.unchar) : void 0;
      }, o2.default.prototype.hex = function(e3, t3) {
        if (t3 = t3 == null ? t3 = 8 : t3, e3 instanceof Array)
          return e3.map(function(e4) {
            return o2.default.prototype.hex(e4, t3);
          });
        if (e3 === 1 / 0 || e3 === -1 / 0)
          return (e3 === 1 / 0 ? "F" : "0").repeat(t3);
        if (typeof e3 == "number") {
          e3 < 0 && (e3 = 4294967295 + e3 + 1);
          for (var r3 = Number(e3).toString(16).toUpperCase(); r3.length < t3; )
            r3 = "0".concat(r3);
          return r3.length >= t3 && (r3 = r3.substring(r3.length - t3, r3.length)), r3;
        }
      }, o2.default.prototype.unhex = function(e3) {
        return e3 instanceof Array ? e3.map(o2.default.prototype.unhex) : parseInt("0x".concat(e3), 16);
      };
      var i2 = o2.default;
      r2.default = i2;
    }, { "../core/main": 264, "core-js/modules/es.array.map": 161, "core-js/modules/es.number.constructor": 170, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.regexp.to-string": 182, "core-js/modules/es.string.repeat": 188 }], 305: [function(e2, t2, r2) {
      e2("core-js/modules/es.array.filter"), e2("core-js/modules/es.array.index-of"), e2("core-js/modules/es.array.join"), e2("core-js/modules/es.array.map"), e2("core-js/modules/es.array.slice"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.regexp.constructor"), e2("core-js/modules/es.regexp.exec"), e2("core-js/modules/es.regexp.to-string"), e2("core-js/modules/es.string.match"), e2("core-js/modules/es.string.replace"), e2("core-js/modules/es.string.split"), e2("core-js/modules/es.string.trim"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, a2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      function o2(e3, t3, r3) {
        var n3 = e3 < 0, o3 = n3 ? e3.toString().substring(1) : e3.toString(), i3 = o3.indexOf("."), a3 = i3 !== -1 ? o3.substring(0, i3) : o3, s2 = i3 !== -1 ? o3.substring(i3 + 1) : "", l3 = n3 ? "-" : "";
        if (r3 !== void 0) {
          var u3 = "";
          (i3 !== -1 || 0 < r3 - s2.length) && (u3 = "."), s2.length > r3 && (s2 = s2.substring(0, r3));
          for (var c = 0; c < t3 - a3.length; c++)
            l3 += "0";
          l3 += a3, l3 += u3, l3 += s2;
          for (var d = 0; d < r3 - s2.length; d++)
            l3 += "0";
          return l3;
        }
        for (var f = 0; f < Math.max(t3 - a3.length, 0); f++)
          l3 += "0";
        return l3 += o3;
      }
      function i2(e3, t3) {
        var r3 = (e3 = e3.toString()).indexOf("."), n3 = r3 !== -1 ? e3.substring(r3) : "", o3 = r3 !== -1 ? e3.substring(0, r3) : e3;
        if (o3 = o3.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ","), t3 === 0)
          n3 = "";
        else if (t3 !== void 0)
          if (t3 > n3.length)
            for (var i3 = t3 - (n3 += r3 === -1 ? "." : "").length + 1, a3 = 0; a3 < i3; a3++)
              n3 += "0";
          else
            n3 = n3.substring(0, t3 + 1);
        return o3 + n3;
      }
      function s(e3) {
        return 0 < parseFloat(e3) ? "+".concat(e3.toString()) : e3.toString();
      }
      function l2(e3) {
        return 0 <= parseFloat(e3) ? " ".concat(e3.toString()) : e3.toString();
      }
      e2("../core/friendly_errors/validate_params"), e2("../core/friendly_errors/file_errors"), e2("../core/friendly_errors/fes_core"), a2.default.prototype.join = function(e3, t3) {
        return a2.default._validateParameters("join", arguments), e3.join(t3);
      }, a2.default.prototype.match = function(e3, t3) {
        return a2.default._validateParameters("match", arguments), e3.match(t3);
      }, a2.default.prototype.matchAll = function(e3, t3) {
        a2.default._validateParameters("matchAll", arguments);
        for (var r3 = new RegExp(t3, "g"), n3 = r3.exec(e3), o3 = []; n3 !== null; )
          o3.push(n3), n3 = r3.exec(e3);
        return o3;
      }, a2.default.prototype.nf = function(e3, t3, r3) {
        return a2.default._validateParameters("nf", arguments), e3 instanceof Array ? e3.map(function(e4) {
          return o2(e4, t3, r3);
        }) : Object.prototype.toString.call(e3) === "[object Arguments]" ? e3.length === 3 ? this.nf(e3[0], e3[1], e3[2]) : e3.length === 2 ? this.nf(e3[0], e3[1]) : this.nf(e3[0]) : o2(e3, t3, r3);
      }, a2.default.prototype.nfc = function(e3, t3) {
        return a2.default._validateParameters("nfc", arguments), e3 instanceof Array ? e3.map(function(e4) {
          return i2(e4, t3);
        }) : i2(e3, t3);
      }, a2.default.prototype.nfp = function() {
        for (var e3 = arguments.length, t3 = new Array(e3), r3 = 0; r3 < e3; r3++)
          t3[r3] = arguments[r3];
        a2.default._validateParameters("nfp", t3);
        var n3 = a2.default.prototype.nf.apply(this, t3);
        return n3 instanceof Array ? n3.map(s) : s(n3);
      }, a2.default.prototype.nfs = function() {
        for (var e3 = arguments.length, t3 = new Array(e3), r3 = 0; r3 < e3; r3++)
          t3[r3] = arguments[r3];
        a2.default._validateParameters("nfs", t3);
        var n3 = a2.default.prototype.nf.apply(this, t3);
        return n3 instanceof Array ? n3.map(l2) : l2(n3);
      }, a2.default.prototype.split = function(e3, t3) {
        return a2.default._validateParameters("split", arguments), e3.split(t3);
      }, a2.default.prototype.splitTokens = function(e3, t3) {
        var r3;
        if (a2.default._validateParameters("splitTokens", arguments), t3 !== void 0) {
          var n3 = t3, o3 = /\]/g.exec(n3), i3 = /\[/g.exec(n3);
          r3 = i3 && o3 ? (n3 = n3.slice(0, o3.index) + n3.slice(o3.index + 1), i3 = /\[/g.exec(n3), n3 = n3.slice(0, i3.index) + n3.slice(i3.index + 1), new RegExp("[\\[".concat(n3, "\\]]"), "g")) : o3 ? (n3 = n3.slice(0, o3.index) + n3.slice(o3.index + 1), new RegExp("[".concat(n3, "\\]]"), "g")) : i3 ? (n3 = n3.slice(0, i3.index) + n3.slice(i3.index + 1), new RegExp("[".concat(n3, "\\[]"), "g")) : new RegExp("[".concat(n3, "]"), "g");
        } else
          r3 = /\s/g;
        return e3.split(r3).filter(function(e4) {
          return e4;
        });
      }, a2.default.prototype.trim = function(e3) {
        return a2.default._validateParameters("trim", arguments), e3 instanceof Array ? e3.map(this.trim) : e3.trim();
      };
      var u2 = a2.default;
      r2.default = u2;
    }, { "../core/friendly_errors/fes_core": 255, "../core/friendly_errors/file_errors": 256, "../core/friendly_errors/validate_params": 259, "../core/main": 264, "core-js/modules/es.array.filter": 152, "core-js/modules/es.array.index-of": 157, "core-js/modules/es.array.join": 159, "core-js/modules/es.array.map": 161, "core-js/modules/es.array.slice": 162, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.regexp.constructor": 180, "core-js/modules/es.regexp.exec": 181, "core-js/modules/es.regexp.to-string": 182, "core-js/modules/es.string.match": 187, "core-js/modules/es.string.replace": 189, "core-js/modules/es.string.split": 191, "core-js/modules/es.string.trim": 193 }], 306: [function(e2, t2, r2) {
      Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, o2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      o2.default.prototype.day = function() {
        return new Date().getDate();
      }, o2.default.prototype.hour = function() {
        return new Date().getHours();
      }, o2.default.prototype.minute = function() {
        return new Date().getMinutes();
      }, o2.default.prototype.millis = function() {
        return this._millisStart === -1 ? 0 : window.performance.now() - this._millisStart;
      }, o2.default.prototype.month = function() {
        return new Date().getMonth() + 1;
      }, o2.default.prototype.second = function() {
        return new Date().getSeconds();
      }, o2.default.prototype.year = function() {
        return new Date().getFullYear();
      };
      var i2 = o2.default;
      r2.default = i2;
    }, { "../core/main": 264 }], 307: [function(e2, t2, r2) {
      function a2(e3) {
        return (a2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      e2("core-js/modules/es.array.concat"), e2("core-js/modules/es.number.to-fixed"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, E = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      e2("./p5.Geometry");
      var h2 = function(e3) {
        if (e3 && e3.__esModule)
          return e3;
        if (e3 === null || a2(e3) !== "object" && typeof e3 != "function")
          return { default: e3 };
        var t3 = s();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o3 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o3)) {
            var i2 = n3 ? Object.getOwnPropertyDescriptor(e3, o3) : null;
            i2 && (i2.get || i2.set) ? Object.defineProperty(r3, o3, i2) : r3[o3] = e3[o3];
          }
        r3.default = e3, t3 && t3.set(e3, r3);
        return r3;
      }(e2("../core/constants"));
      function s() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return s = function() {
          return e3;
        }, e3;
      }
      E.default.prototype.plane = function(e3, t3, r3, n3) {
        this._assert3d("plane"), E.default._validateParameters("plane", arguments), e3 === void 0 && (e3 = 50), t3 === void 0 && (t3 = e3), r3 === void 0 && (r3 = 1), n3 === void 0 && (n3 = 1);
        var o3 = "plane|".concat(r3, "|").concat(n3);
        if (!this._renderer.geometryInHash(o3)) {
          var i2 = new E.default.Geometry(r3, n3, function() {
            for (var e4, t4, r4, n4 = 0; n4 <= this.detailY; n4++) {
              t4 = n4 / this.detailY;
              for (var o4 = 0; o4 <= this.detailX; o4++)
                e4 = o4 / this.detailX, r4 = new E.default.Vector(e4 - 0.5, t4 - 0.5, 0), this.vertices.push(r4), this.uvs.push(e4, t4);
            }
          });
          i2.computeFaces().computeNormals(), r3 <= 1 && n3 <= 1 ? i2._makeTriangleEdges()._edgesToVertices() : this._renderer._doStroke && console.log("Cannot draw stroke on plane objects with more than 1 detailX or 1 detailY"), this._renderer.createBuffers(o3, i2);
        }
        return this._renderer.drawBuffersScaled(o3, e3, t3, 1), this;
      }, E.default.prototype.box = function(e3, t3, r3, n3, o3) {
        this._assert3d("box"), E.default._validateParameters("box", arguments), e3 === void 0 && (e3 = 50), t3 === void 0 && (t3 = e3), r3 === void 0 && (r3 = t3);
        var i2 = this._renderer.attributes && this._renderer.attributes.perPixelLighting;
        n3 === void 0 && (n3 = i2 ? 1 : 4), o3 === void 0 && (o3 = i2 ? 1 : 4);
        var a3 = "box|".concat(n3, "|").concat(o3);
        if (!this._renderer.geometryInHash(a3)) {
          var s2 = new E.default.Geometry(n3, o3, function() {
            var e4 = [[0, 4, 2, 6], [1, 3, 5, 7], [0, 1, 4, 5], [2, 6, 3, 7], [0, 2, 1, 3], [4, 5, 6, 7]];
            this.strokeIndices = [[0, 1], [1, 3], [3, 2], [6, 7], [8, 9], [9, 11], [14, 15], [16, 17], [17, 19], [18, 19], [20, 21], [22, 23]];
            for (var t4 = 0; t4 < e4.length; t4++) {
              for (var r4 = e4[t4], n4 = 4 * t4, o4 = 0; o4 < 4; o4++) {
                var i3 = r4[o4], a4 = new E.default.Vector((2 * (1 & i3) - 1) / 2, ((2 & i3) - 1) / 2, ((4 & i3) / 2 - 1) / 2);
                this.vertices.push(a4), this.uvs.push(1 & o4, (2 & o4) / 2);
              }
              this.faces.push([n4, 1 + n4, 2 + n4]), this.faces.push([2 + n4, 1 + n4, 3 + n4]);
            }
          });
          s2.computeNormals(), n3 <= 4 && o3 <= 4 ? s2._makeTriangleEdges()._edgesToVertices() : this._renderer._doStroke && console.log("Cannot draw stroke on box objects with more than 4 detailX or 4 detailY"), this._renderer.createBuffers(a3, s2);
        }
        return this._renderer.drawBuffersScaled(a3, e3, t3, r3), this;
      }, E.default.prototype.sphere = function(e3, t3, r3) {
        return this._assert3d("sphere"), E.default._validateParameters("sphere", arguments), e3 === void 0 && (e3 = 50), t3 === void 0 && (t3 = 24), r3 === void 0 && (r3 = 16), this.ellipsoid(e3, e3, e3, t3, r3), this;
      };
      function l2(e3, t3, r3, n3, o3, i2, a3) {
        e3 = e3 <= 0 ? 1 : e3, t3 = t3 < 0 ? 0 : t3, r3 = r3 <= 0 ? e3 : r3, n3 = n3 < 3 ? 3 : n3;
        var s2, l3, u2, c = (i2 = i2 === void 0 || i2) ? -2 : 0, d = (o3 = o3 < 1 ? 1 : o3) + ((a3 = a3 === void 0 ? t3 !== 0 : a3) ? 2 : 0), f = Math.atan2(e3 - t3, r3), h3 = Math.sin(f), p2 = Math.cos(f);
        for (s2 = c; s2 <= d; ++s2) {
          var y = s2 / o3, m2 = r3 * y, g = void 0;
          for (g = s2 < 0 ? (y = m2 = 0, e3) : o3 < s2 ? (m2 = r3, y = 1, t3) : e3 + (t3 - e3) * y, s2 !== -2 && s2 !== o3 + 2 || (g = 0), m2 -= r3 / 2, l3 = 0; l3 < n3; ++l3) {
            var v = l3 / (n3 - 1), b2 = 2 * Math.PI * v, _ = Math.sin(b2), x = Math.cos(b2);
            this.vertices.push(new E.default.Vector(_ * g, m2, x * g));
            var w = void 0;
            w = s2 < 0 ? new E.default.Vector(0, -1, 0) : o3 < s2 && t3 ? new E.default.Vector(0, 1, 0) : new E.default.Vector(_ * p2, h3, x * p2), this.vertexNormals.push(w), this.uvs.push(v, y);
          }
        }
        var j = 0;
        if (i2) {
          for (u2 = 0; u2 < n3; ++u2) {
            var S2 = (u2 + 1) % n3;
            this.faces.push([j + u2, j + n3 + S2, j + n3 + u2]);
          }
          j += 2 * n3;
        }
        for (s2 = 0; s2 < o3; ++s2) {
          for (l3 = 0; l3 < n3; ++l3) {
            var M = (l3 + 1) % n3;
            this.faces.push([j + l3, j + M, j + n3 + M]), this.faces.push([j + l3, j + n3 + M, j + n3 + l3]);
          }
          j += n3;
        }
        if (a3)
          for (j += n3, l3 = 0; l3 < n3; ++l3)
            this.faces.push([j + l3, j + (l3 + 1) % n3, j + n3]);
      }
      E.default.prototype.cylinder = function(e3, t3, r3, n3, o3, i2) {
        this._assert3d("cylinder"), E.default._validateParameters("cylinder", arguments), e3 === void 0 && (e3 = 50), t3 === void 0 && (t3 = e3), r3 === void 0 && (r3 = 24), n3 === void 0 && (n3 = 1), i2 === void 0 && (i2 = true), o3 === void 0 && (o3 = true);
        var a3 = "cylinder|".concat(r3, "|").concat(n3, "|").concat(o3, "|").concat(i2);
        if (!this._renderer.geometryInHash(a3)) {
          var s2 = new E.default.Geometry(r3, n3);
          l2.call(s2, 1, 1, 1, r3, n3, o3, i2), r3 <= 24 && n3 <= 16 ? s2._makeTriangleEdges()._edgesToVertices() : this._renderer._doStroke && console.log("Cannot draw stroke on cylinder objects with more than 24 detailX or 16 detailY"), this._renderer.createBuffers(a3, s2);
        }
        return this._renderer.drawBuffersScaled(a3, e3, t3, e3), this;
      }, E.default.prototype.cone = function(e3, t3, r3, n3, o3) {
        this._assert3d("cone"), E.default._validateParameters("cone", arguments), e3 === void 0 && (e3 = 50), t3 === void 0 && (t3 = e3), r3 === void 0 && (r3 = 24), n3 === void 0 && (n3 = 1), o3 === void 0 && (o3 = true);
        var i2 = "cone|".concat(r3, "|").concat(n3, "|").concat(o3);
        if (!this._renderer.geometryInHash(i2)) {
          var a3 = new E.default.Geometry(r3, n3);
          l2.call(a3, 1, 0, 1, r3, n3, o3, false), r3 <= 24 && n3 <= 16 ? a3._makeTriangleEdges()._edgesToVertices() : this._renderer._doStroke && console.log("Cannot draw stroke on cone objects with more than 24 detailX or 16 detailY"), this._renderer.createBuffers(i2, a3);
        }
        return this._renderer.drawBuffersScaled(i2, e3, t3, e3), this;
      }, E.default.prototype.ellipsoid = function(e3, t3, r3, n3, o3) {
        this._assert3d("ellipsoid"), E.default._validateParameters("ellipsoid", arguments), e3 === void 0 && (e3 = 50), t3 === void 0 && (t3 = e3), r3 === void 0 && (r3 = e3), n3 === void 0 && (n3 = 24), o3 === void 0 && (o3 = 16);
        var i2 = "ellipsoid|".concat(n3, "|").concat(o3);
        if (!this._renderer.geometryInHash(i2)) {
          var a3 = new E.default.Geometry(n3, o3, function() {
            for (var e4 = 0; e4 <= this.detailY; e4++)
              for (var t4 = e4 / this.detailY, r4 = Math.PI * t4 - Math.PI / 2, n4 = Math.cos(r4), o4 = Math.sin(r4), i3 = 0; i3 <= this.detailX; i3++) {
                var a4 = i3 / this.detailX, s2 = 2 * Math.PI * a4, l3 = Math.cos(s2), u2 = Math.sin(s2), c = new E.default.Vector(n4 * u2, o4, n4 * l3);
                this.vertices.push(c), this.vertexNormals.push(c), this.uvs.push(a4, t4);
              }
          });
          a3.computeFaces(), n3 <= 24 && o3 <= 24 ? a3._makeTriangleEdges()._edgesToVertices() : this._renderer._doStroke && console.log("Cannot draw stroke on ellipsoids with more than 24 detailX or 24 detailY"), this._renderer.createBuffers(i2, a3);
        }
        return this._renderer.drawBuffersScaled(i2, e3, t3, r3), this;
      }, E.default.prototype.torus = function(e3, t3, r3, n3) {
        if (this._assert3d("torus"), E.default._validateParameters("torus", arguments), e3 === void 0)
          e3 = 50;
        else if (!e3)
          return;
        if (t3 === void 0)
          t3 = 10;
        else if (!t3)
          return;
        r3 === void 0 && (r3 = 24), n3 === void 0 && (n3 = 16);
        var h3 = (t3 / e3).toPrecision(4), o3 = "torus|".concat(h3, "|").concat(r3, "|").concat(n3);
        if (!this._renderer.geometryInHash(o3)) {
          var i2 = new E.default.Geometry(r3, n3, function() {
            for (var e4 = 0; e4 <= this.detailY; e4++)
              for (var t4 = e4 / this.detailY, r4 = 2 * Math.PI * t4, n4 = Math.cos(r4), o4 = Math.sin(r4), i3 = 1 + h3 * n4, a3 = 0; a3 <= this.detailX; a3++) {
                var s2 = a3 / this.detailX, l3 = 2 * Math.PI * s2, u2 = Math.cos(l3), c = Math.sin(l3), d = new E.default.Vector(i3 * u2, i3 * c, h3 * o4), f = new E.default.Vector(n4 * u2, n4 * c, o4);
                this.vertices.push(d), this.vertexNormals.push(f), this.uvs.push(s2, t4);
              }
          });
          i2.computeFaces(), r3 <= 24 && n3 <= 16 ? i2._makeTriangleEdges()._edgesToVertices() : this._renderer._doStroke && console.log("Cannot draw strokes on torus object with more than 24 detailX or 16 detailY"), this._renderer.createBuffers(o3, i2);
        }
        return this._renderer.drawBuffersScaled(o3, e3, e3, e3), this;
      }, E.default.RendererGL.prototype.point = function(e3, t3, r3) {
        r3 === void 0 && (r3 = 0);
        var n3 = [];
        return n3.push(new E.default.Vector(e3, t3, r3)), this._drawPoints(n3, this.immediateMode.buffers.point), this;
      }, E.default.RendererGL.prototype.triangle = function(e3) {
        var t3 = e3[0], r3 = e3[1], n3 = e3[2], o3 = e3[3], i2 = e3[4], a3 = e3[5];
        if (!this.geometryInHash("tri")) {
          var s2 = new E.default.Geometry(1, 1, function() {
            var e4 = [];
            e4.push(new E.default.Vector(0, 0, 0)), e4.push(new E.default.Vector(0, 1, 0)), e4.push(new E.default.Vector(1, 0, 0)), this.strokeIndices = [[0, 1], [1, 2], [2, 0]], this.vertices = e4, this.faces = [[0, 1, 2]], this.uvs = [0, 0, 0, 1, 1, 1];
          });
          s2._makeTriangleEdges()._edgesToVertices(), s2.computeNormals(), this.createBuffers("tri", s2);
        }
        var l3 = this.uMVMatrix.copy();
        try {
          var u2 = new E.default.Matrix([n3 - t3, o3 - r3, 0, 0, i2 - t3, a3 - r3, 0, 0, 0, 0, 1, 0, t3, r3, 0, 1]).mult(this.uMVMatrix);
          this.uMVMatrix = u2, this.drawBuffers("tri");
        } finally {
          this.uMVMatrix = l3;
        }
        return this;
      }, E.default.RendererGL.prototype.ellipse = function(e3) {
        this.arc(e3[0], e3[1], e3[2], e3[3], 0, h2.TWO_PI, h2.OPEN, e3[4]);
      }, E.default.RendererGL.prototype.arc = function(e3) {
        var t3, r3, n3 = e3, o3 = arguments[1], i2 = arguments[2], a3 = arguments[3], s2 = arguments[4], l3 = arguments[5], u2 = arguments[6], c = arguments[7] || 25;
        if (r3 = Math.abs(l3 - s2) >= h2.TWO_PI ? "".concat(t3 = "ellipse", "|").concat(c, "|") : "".concat(t3 = "arc", "|").concat(s2, "|").concat(l3, "|").concat(u2, "|").concat(c, "|"), !this.geometryInHash(r3)) {
          var d = new E.default.Geometry(c, 1, function() {
            if (this.strokeIndices = [], s2.toFixed(10) !== l3.toFixed(10)) {
              u2 !== h2.PIE && u2 !== void 0 || (this.vertices.push(new E.default.Vector(0.5, 0.5, 0)), this.uvs.push([0.5, 0.5]));
              for (var e4 = 0; e4 <= c; e4++) {
                var t4 = (l3 - s2) * (e4 / c) + s2, r4 = 0.5 + Math.cos(t4) / 2, n4 = 0.5 + Math.sin(t4) / 2;
                this.vertices.push(new E.default.Vector(r4, n4, 0)), this.uvs.push([r4, n4]), e4 < c - 1 && (this.faces.push([0, e4 + 1, e4 + 2]), this.strokeIndices.push([e4 + 1, e4 + 2]));
              }
              switch (u2) {
                case h2.PIE:
                  this.faces.push([0, this.vertices.length - 2, this.vertices.length - 1]), this.strokeIndices.push([0, 1]), this.strokeIndices.push([this.vertices.length - 2, this.vertices.length - 1]), this.strokeIndices.push([0, this.vertices.length - 1]);
                  break;
                case h2.CHORD:
                  this.strokeIndices.push([0, 1]), this.strokeIndices.push([0, this.vertices.length - 1]);
                  break;
                case h2.OPEN:
                  this.strokeIndices.push([0, 1]);
                  break;
                default:
                  this.faces.push([0, this.vertices.length - 2, this.vertices.length - 1]), this.strokeIndices.push([this.vertices.length - 2, this.vertices.length - 1]);
              }
            }
          });
          d.computeNormals(), c <= 50 ? d._makeTriangleEdges()._edgesToVertices(d) : this._doStroke && console.log("Cannot apply a stroke to an ".concat(t3, " with more than 50 detail")), this.createBuffers(r3, d);
        }
        var f = this.uMVMatrix.copy();
        try {
          this.uMVMatrix.translate([n3, o3, 0]), this.uMVMatrix.scale(i2, a3, 1), this.drawBuffers(r3);
        } finally {
          this.uMVMatrix = f;
        }
        return this;
      }, E.default.RendererGL.prototype.rect = function(e3) {
        var t3 = this._pInst._glAttributes.perPixelLighting, r3 = e3[0], n3 = e3[1], o3 = e3[2], i2 = e3[3], a3 = e3[4] || (t3 ? 1 : 24), s2 = e3[5] || (t3 ? 1 : 16), l3 = "rect|".concat(a3, "|").concat(s2);
        if (!this.geometryInHash(l3)) {
          var u2 = new E.default.Geometry(a3, s2, function() {
            for (var e4 = 0; e4 <= this.detailY; e4++)
              for (var t4 = e4 / this.detailY, r4 = 0; r4 <= this.detailX; r4++) {
                var n4 = r4 / this.detailX, o4 = new E.default.Vector(n4, t4, 0);
                this.vertices.push(o4), this.uvs.push(n4, t4);
              }
            0 < a3 && 0 < s2 && (this.strokeIndices = [[0, a3], [a3, (a3 + 1) * (s2 + 1) - 1], [(a3 + 1) * (s2 + 1) - 1, (a3 + 1) * s2], [(a3 + 1) * s2, 0]]);
          });
          u2.computeFaces().computeNormals()._makeTriangleEdges()._edgesToVertices(), this.createBuffers(l3, u2);
        }
        var c = this.uMVMatrix.copy();
        try {
          this.uMVMatrix.translate([r3, n3, 0]), this.uMVMatrix.scale(o3, i2, 1), this.drawBuffers(l3);
        } finally {
          this.uMVMatrix = c;
        }
        return this;
      }, E.default.RendererGL.prototype.quad = function(u2, c, d, f, h3, p2, y, m2, g, v, b2, _, e3, t3) {
        e3 === void 0 && (e3 = 2), t3 === void 0 && (t3 = 2);
        var r3 = "quad|".concat(u2, "|").concat(c, "|").concat(d, "|").concat(f, "|").concat(h3, "|").concat(p2, "|").concat(y, "|").concat(m2, "|").concat(g, "|").concat(v, "|").concat(b2, "|").concat(_, "|").concat(e3, "|").concat(t3);
        if (!this.geometryInHash(r3)) {
          var n3 = new E.default.Geometry(e3, t3, function() {
            for (var e4 = 1 / (this.detailX - 1), t4 = 1 / (this.detailY - 1), r4 = 0; r4 < this.detailY; r4++)
              for (var n4 = 0; n4 < this.detailX; n4++) {
                var o4 = n4 * e4, i3 = r4 * t4, a4 = (1 - o4) * ((1 - i3) * u2 + i3 * v) + o4 * ((1 - i3) * f + i3 * y), s3 = (1 - o4) * ((1 - i3) * c + i3 * b2) + o4 * ((1 - i3) * h3 + i3 * m2), l4 = (1 - o4) * ((1 - i3) * d + i3 * _) + o4 * ((1 - i3) * p2 + i3 * g);
                this.vertices.push(new E.default.Vector(a4, s3, l4)), this.uvs.push([o4, i3]);
              }
          });
          n3.faces = [];
          for (var o3 = 0; o3 < t3 - 1; o3++)
            for (var i2 = 0; i2 < e3 - 1; i2++) {
              var a3 = i2 + o3 * e3, s2 = i2 + 1 + o3 * e3, l3 = i2 + 1 + (o3 + 1) * e3, x = i2 + (o3 + 1) * e3;
              n3.faces.push([a3, s2, l3]), n3.faces.push([a3, l3, x]);
            }
          n3.computeNormals()._makeTriangleEdges()._edgesToVertices(), this.createBuffers(r3, n3);
        }
        return this.drawBuffers(r3), this;
      }, E.default.RendererGL.prototype.bezier = function(e3, t3, r3, n3, o3, i2, a3, s2, l3, u2, c, d) {
        arguments.length === 8 && (c = s2, u2 = a3, s2 = i2, a3 = o3, o3 = n3, n3 = r3, r3 = i2 = l3 = d = 0);
        var f = this._pInst._bezierDetail || 20;
        this.beginShape();
        for (var h3 = 0; h3 <= f; h3++) {
          var p2 = Math.pow(1 - h3 / f, 3), y = h3 / f * 3 * Math.pow(1 - h3 / f, 2), m2 = 3 * Math.pow(h3 / f, 2) * (1 - h3 / f), g = Math.pow(h3 / f, 3);
          this.vertex(e3 * p2 + n3 * y + a3 * m2 + u2 * g, t3 * p2 + o3 * y + s2 * m2 + c * g, r3 * p2 + i2 * y + l3 * m2 + d * g);
        }
        return this.endShape(), this;
      }, E.default.RendererGL.prototype.curve = function(e3, t3, r3, n3, o3, i2, a3, s2, l3, u2, c, d) {
        arguments.length === 8 && (u2 = a3, c = s2, a3 = o3, s2 = n3, o3 = n3 = r3, r3 = i2 = l3 = d = 0);
        var f = this._pInst._curveDetail;
        this.beginShape();
        for (var h3 = 0; h3 <= f; h3++) {
          var p2 = 0.5 * Math.pow(h3 / f, 3), y = 0.5 * Math.pow(h3 / f, 2), m2 = h3 / f * 0.5, g = p2 * (3 * n3 - e3 - 3 * a3 + u2) + y * (2 * e3 - 5 * n3 + 4 * a3 - u2) + m2 * (-e3 + a3) + 2 * n3 * 0.5, v = p2 * (3 * o3 - t3 - 3 * s2 + c) + y * (2 * t3 - 5 * o3 + 4 * s2 - c) + m2 * (-t3 + s2) + 2 * o3 * 0.5, b2 = p2 * (3 * i2 - r3 - 3 * l3 + d) + y * (2 * r3 - 5 * i2 + 4 * l3 - d) + m2 * (-r3 + l3) + 2 * i2 * 0.5;
          this.vertex(g, v, b2);
        }
        return this.endShape(), this;
      }, E.default.RendererGL.prototype.line = function() {
        return arguments.length === 6 ? (this.beginShape(h2.LINES), this.vertex(arguments.length <= 0 ? void 0 : arguments[0], arguments.length <= 1 ? void 0 : arguments[1], arguments.length <= 2 ? void 0 : arguments[2]), this.vertex(arguments.length <= 3 ? void 0 : arguments[3], arguments.length <= 4 ? void 0 : arguments[4], arguments.length <= 5 ? void 0 : arguments[5]), this.endShape()) : arguments.length === 4 && (this.beginShape(h2.LINES), this.vertex(arguments.length <= 0 ? void 0 : arguments[0], arguments.length <= 1 ? void 0 : arguments[1], 0), this.vertex(arguments.length <= 2 ? void 0 : arguments[2], arguments.length <= 3 ? void 0 : arguments[3], 0), this.endShape()), this;
      }, E.default.RendererGL.prototype.bezierVertex = function() {
        if (this.immediateMode._bezierVertex.length === 0)
          throw Error("vertex() must be used once before calling bezierVertex()");
        var e3, t3, r3, n3, o3, i2 = [], a3 = [], s2 = [], l3 = arguments.length;
        if ((e3 = 0) === this._lookUpTableBezier.length || this._lutBezierDetail !== this._pInst._curveDetail) {
          this._lookUpTableBezier = [], this._lutBezierDetail = this._pInst._curveDetail;
          for (var u2 = 1 / this._lutBezierDetail, c = 0, d = 1, f = 0; c < 1; ) {
            if (e3 = parseFloat(c.toFixed(6)), this._lookUpTableBezier[f] = this._bezierCoefficients(e3), d.toFixed(6) === u2.toFixed(6)) {
              e3 = parseFloat(d.toFixed(6)) + parseFloat(c.toFixed(6)), ++f, this._lookUpTableBezier[f] = this._bezierCoefficients(e3);
              break;
            }
            c += u2, d -= u2, ++f;
          }
        }
        var h3 = this._lookUpTableBezier.length;
        if (l3 === 6) {
          for (this.isBezier = true, i2 = [this.immediateMode._bezierVertex[0], arguments.length <= 0 ? void 0 : arguments[0], arguments.length <= 2 ? void 0 : arguments[2], arguments.length <= 4 ? void 0 : arguments[4]], a3 = [this.immediateMode._bezierVertex[1], arguments.length <= 1 ? void 0 : arguments[1], arguments.length <= 3 ? void 0 : arguments[3], arguments.length <= 5 ? void 0 : arguments[5]], o3 = 0; o3 < h3; o3++)
            t3 = i2[0] * this._lookUpTableBezier[o3][0] + i2[1] * this._lookUpTableBezier[o3][1] + i2[2] * this._lookUpTableBezier[o3][2] + i2[3] * this._lookUpTableBezier[o3][3], r3 = a3[0] * this._lookUpTableBezier[o3][0] + a3[1] * this._lookUpTableBezier[o3][1] + a3[2] * this._lookUpTableBezier[o3][2] + a3[3] * this._lookUpTableBezier[o3][3], this.vertex(t3, r3);
          this.immediateMode._bezierVertex[0] = arguments.length <= 4 ? void 0 : arguments[4], this.immediateMode._bezierVertex[1] = arguments.length <= 5 ? void 0 : arguments[5];
        } else if (l3 === 9) {
          for (this.isBezier = true, i2 = [this.immediateMode._bezierVertex[0], arguments.length <= 0 ? void 0 : arguments[0], arguments.length <= 3 ? void 0 : arguments[3], arguments.length <= 6 ? void 0 : arguments[6]], a3 = [this.immediateMode._bezierVertex[1], arguments.length <= 1 ? void 0 : arguments[1], arguments.length <= 4 ? void 0 : arguments[4], arguments.length <= 7 ? void 0 : arguments[7]], s2 = [this.immediateMode._bezierVertex[2], arguments.length <= 2 ? void 0 : arguments[2], arguments.length <= 5 ? void 0 : arguments[5], arguments.length <= 8 ? void 0 : arguments[8]], o3 = 0; o3 < h3; o3++)
            t3 = i2[0] * this._lookUpTableBezier[o3][0] + i2[1] * this._lookUpTableBezier[o3][1] + i2[2] * this._lookUpTableBezier[o3][2] + i2[3] * this._lookUpTableBezier[o3][3], r3 = a3[0] * this._lookUpTableBezier[o3][0] + a3[1] * this._lookUpTableBezier[o3][1] + a3[2] * this._lookUpTableBezier[o3][2] + a3[3] * this._lookUpTableBezier[o3][3], n3 = s2[0] * this._lookUpTableBezier[o3][0] + s2[1] * this._lookUpTableBezier[o3][1] + s2[2] * this._lookUpTableBezier[o3][2] + s2[3] * this._lookUpTableBezier[o3][3], this.vertex(t3, r3, n3);
          this.immediateMode._bezierVertex[0] = arguments.length <= 6 ? void 0 : arguments[6], this.immediateMode._bezierVertex[1] = arguments.length <= 7 ? void 0 : arguments[7], this.immediateMode._bezierVertex[2] = arguments.length <= 8 ? void 0 : arguments[8];
        }
      }, E.default.RendererGL.prototype.quadraticVertex = function() {
        if (this.immediateMode._quadraticVertex.length === 0)
          throw Error("vertex() must be used once before calling quadraticVertex()");
        var e3, t3, r3, n3, o3, i2 = [], a3 = [], s2 = [], l3 = arguments.length;
        if ((e3 = 0) === this._lookUpTableQuadratic.length || this._lutQuadraticDetail !== this._pInst._curveDetail) {
          this._lookUpTableQuadratic = [], this._lutQuadraticDetail = this._pInst._curveDetail;
          for (var u2 = 1 / this._lutQuadraticDetail, c = 0, d = 1, f = 0; c < 1; ) {
            if (e3 = parseFloat(c.toFixed(6)), this._lookUpTableQuadratic[f] = this._quadraticCoefficients(e3), d.toFixed(6) === u2.toFixed(6)) {
              e3 = parseFloat(d.toFixed(6)) + parseFloat(c.toFixed(6)), ++f, this._lookUpTableQuadratic[f] = this._quadraticCoefficients(e3);
              break;
            }
            c += u2, d -= u2, ++f;
          }
        }
        var h3 = this._lookUpTableQuadratic.length;
        if (l3 === 4) {
          for (this.isQuadratic = true, i2 = [this.immediateMode._quadraticVertex[0], arguments.length <= 0 ? void 0 : arguments[0], arguments.length <= 2 ? void 0 : arguments[2]], a3 = [this.immediateMode._quadraticVertex[1], arguments.length <= 1 ? void 0 : arguments[1], arguments.length <= 3 ? void 0 : arguments[3]], o3 = 0; o3 < h3; o3++)
            t3 = i2[0] * this._lookUpTableQuadratic[o3][0] + i2[1] * this._lookUpTableQuadratic[o3][1] + i2[2] * this._lookUpTableQuadratic[o3][2], r3 = a3[0] * this._lookUpTableQuadratic[o3][0] + a3[1] * this._lookUpTableQuadratic[o3][1] + a3[2] * this._lookUpTableQuadratic[o3][2], this.vertex(t3, r3);
          this.immediateMode._quadraticVertex[0] = arguments.length <= 2 ? void 0 : arguments[2], this.immediateMode._quadraticVertex[1] = arguments.length <= 3 ? void 0 : arguments[3];
        } else if (l3 === 6) {
          for (this.isQuadratic = true, i2 = [this.immediateMode._quadraticVertex[0], arguments.length <= 0 ? void 0 : arguments[0], arguments.length <= 3 ? void 0 : arguments[3]], a3 = [this.immediateMode._quadraticVertex[1], arguments.length <= 1 ? void 0 : arguments[1], arguments.length <= 4 ? void 0 : arguments[4]], s2 = [this.immediateMode._quadraticVertex[2], arguments.length <= 2 ? void 0 : arguments[2], arguments.length <= 5 ? void 0 : arguments[5]], o3 = 0; o3 < h3; o3++)
            t3 = i2[0] * this._lookUpTableQuadratic[o3][0] + i2[1] * this._lookUpTableQuadratic[o3][1] + i2[2] * this._lookUpTableQuadratic[o3][2], r3 = a3[0] * this._lookUpTableQuadratic[o3][0] + a3[1] * this._lookUpTableQuadratic[o3][1] + a3[2] * this._lookUpTableQuadratic[o3][2], n3 = s2[0] * this._lookUpTableQuadratic[o3][0] + s2[1] * this._lookUpTableQuadratic[o3][1] + s2[2] * this._lookUpTableQuadratic[o3][2], this.vertex(t3, r3, n3);
          this.immediateMode._quadraticVertex[0] = arguments.length <= 3 ? void 0 : arguments[3], this.immediateMode._quadraticVertex[1] = arguments.length <= 4 ? void 0 : arguments[4], this.immediateMode._quadraticVertex[2] = arguments.length <= 5 ? void 0 : arguments[5];
        }
      }, E.default.RendererGL.prototype.curveVertex = function() {
        var e3, t3, r3, n3, o3, i2 = [], a3 = [], s2 = [], l3 = arguments.length;
        if ((e3 = 0) === this._lookUpTableBezier.length || this._lutBezierDetail !== this._pInst._curveDetail) {
          this._lookUpTableBezier = [], this._lutBezierDetail = this._pInst._curveDetail;
          for (var u2 = 1 / this._lutBezierDetail, c = 0, d = 1, f = 0; c < 1; ) {
            if (e3 = parseFloat(c.toFixed(6)), this._lookUpTableBezier[f] = this._bezierCoefficients(e3), d.toFixed(6) === u2.toFixed(6)) {
              e3 = parseFloat(d.toFixed(6)) + parseFloat(c.toFixed(6)), ++f, this._lookUpTableBezier[f] = this._bezierCoefficients(e3);
              break;
            }
            c += u2, d -= u2, ++f;
          }
        }
        var h3 = this._lookUpTableBezier.length;
        if (l3 === 2) {
          if (this.immediateMode._curveVertex.push(arguments.length <= 0 ? void 0 : arguments[0]), this.immediateMode._curveVertex.push(arguments.length <= 1 ? void 0 : arguments[1]), this.immediateMode._curveVertex.length === 8) {
            for (this.isCurve = true, i2 = this._bezierToCatmull([this.immediateMode._curveVertex[0], this.immediateMode._curveVertex[2], this.immediateMode._curveVertex[4], this.immediateMode._curveVertex[6]]), a3 = this._bezierToCatmull([this.immediateMode._curveVertex[1], this.immediateMode._curveVertex[3], this.immediateMode._curveVertex[5], this.immediateMode._curveVertex[7]]), o3 = 0; o3 < h3; o3++)
              t3 = i2[0] * this._lookUpTableBezier[o3][0] + i2[1] * this._lookUpTableBezier[o3][1] + i2[2] * this._lookUpTableBezier[o3][2] + i2[3] * this._lookUpTableBezier[o3][3], r3 = a3[0] * this._lookUpTableBezier[o3][0] + a3[1] * this._lookUpTableBezier[o3][1] + a3[2] * this._lookUpTableBezier[o3][2] + a3[3] * this._lookUpTableBezier[o3][3], this.vertex(t3, r3);
            for (o3 = 0; o3 < l3; o3++)
              this.immediateMode._curveVertex.shift();
          }
        } else if (l3 === 3 && (this.immediateMode._curveVertex.push(arguments.length <= 0 ? void 0 : arguments[0]), this.immediateMode._curveVertex.push(arguments.length <= 1 ? void 0 : arguments[1]), this.immediateMode._curveVertex.push(arguments.length <= 2 ? void 0 : arguments[2]), this.immediateMode._curveVertex.length === 12)) {
          for (this.isCurve = true, i2 = this._bezierToCatmull([this.immediateMode._curveVertex[0], this.immediateMode._curveVertex[3], this.immediateMode._curveVertex[6], this.immediateMode._curveVertex[9]]), a3 = this._bezierToCatmull([this.immediateMode._curveVertex[1], this.immediateMode._curveVertex[4], this.immediateMode._curveVertex[7], this.immediateMode._curveVertex[10]]), s2 = this._bezierToCatmull([this.immediateMode._curveVertex[2], this.immediateMode._curveVertex[5], this.immediateMode._curveVertex[8], this.immediateMode._curveVertex[11]]), o3 = 0; o3 < h3; o3++)
            t3 = i2[0] * this._lookUpTableBezier[o3][0] + i2[1] * this._lookUpTableBezier[o3][1] + i2[2] * this._lookUpTableBezier[o3][2] + i2[3] * this._lookUpTableBezier[o3][3], r3 = a3[0] * this._lookUpTableBezier[o3][0] + a3[1] * this._lookUpTableBezier[o3][1] + a3[2] * this._lookUpTableBezier[o3][2] + a3[3] * this._lookUpTableBezier[o3][3], n3 = s2[0] * this._lookUpTableBezier[o3][0] + s2[1] * this._lookUpTableBezier[o3][1] + s2[2] * this._lookUpTableBezier[o3][2] + s2[3] * this._lookUpTableBezier[o3][3], this.vertex(t3, r3, n3);
          for (o3 = 0; o3 < l3; o3++)
            this.immediateMode._curveVertex.shift();
        }
      }, E.default.RendererGL.prototype.image = function(e3, t3, r3, n3, o3, i2, a3, s2, l3) {
        this._isErasing && this.blendMode(this._cachedBlendMode), this._pInst.push(), this._pInst.noLights(), this._pInst.texture(e3), this._pInst.textureMode(h2.NORMAL);
        var u2 = 0;
        t3 <= e3.width && (u2 = t3 / e3.width);
        var c = 1;
        t3 + n3 <= e3.width && (c = (t3 + n3) / e3.width);
        var d = 0;
        r3 <= e3.height && (d = r3 / e3.height);
        var f = 1;
        r3 + o3 <= e3.height && (f = (r3 + o3) / e3.height), this.beginShape(), this.vertex(i2, a3, 0, u2, d), this.vertex(i2 + s2, a3, 0, c, d), this.vertex(i2 + s2, a3 + l3, 0, c, f), this.vertex(i2, a3 + l3, 0, u2, f), this.endShape(h2.CLOSE), this._pInst.pop(), this._isErasing && this.blendMode(h2.REMOVE);
      };
      var o2 = E.default;
      r2.default = o2;
    }, { "../core/constants": 253, "../core/main": 264, "./p5.Geometry": 313, "core-js/modules/es.array.concat": 149, "core-js/modules/es.number.to-fixed": 172 }], 308: [function(e2, t2, r2) {
      function a2(e3) {
        return (a2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      e2("core-js/modules/es.array.splice"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.regexp.to-string"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, f = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 }, o2 = function(e3) {
        if (e3 && e3.__esModule)
          return e3;
        if (e3 === null || a2(e3) !== "object" && typeof e3 != "function")
          return { default: e3 };
        var t3 = s();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o3 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o3)) {
            var i3 = n3 ? Object.getOwnPropertyDescriptor(e3, o3) : null;
            i3 && (i3.get || i3.set) ? Object.defineProperty(r3, o3, i3) : r3[o3] = e3[o3];
          }
        r3.default = e3, t3 && t3.set(e3, r3);
        return r3;
      }(e2("../core/constants"));
      function s() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return s = function() {
          return e3;
        }, e3;
      }
      f.default.prototype.orbitControl = function(e3, t3, r3) {
        if (this._assert3d("orbitControl"), f.default._validateParameters("orbitControl", arguments), this.mouseX < this.width && 0 < this.mouseX && this.mouseY < this.height && 0 < this.mouseY) {
          var n3 = this._renderer._curCamera;
          e3 === void 0 && (e3 = 1), t3 === void 0 && (t3 = e3), r3 === void 0 && (r3 = 0.5), this.contextMenuDisabled !== true && (this.canvas.oncontextmenu = function() {
            return false;
          }, this._setProperty("contextMenuDisabled", true)), this.wheelDefaultDisabled !== true && (this.canvas.onwheel = function() {
            return false;
          }, this._setProperty("wheelDefaultDisabled", true));
          var o3 = this.height < this.width ? this.height : this.width;
          if (this._mouseWheelDeltaY !== this._pmouseWheelDeltaY && (0 < this._mouseWheelDeltaY ? this._renderer._curCamera._orbit(0, 0, r3 * o3) : this._renderer._curCamera._orbit(0, 0, -r3 * o3)), this.mouseIsPressed) {
            if (this.mouseButton === this.LEFT) {
              var i3 = -e3 * (this.mouseX - this.pmouseX) / o3, a3 = t3 * (this.mouseY - this.pmouseY) / o3;
              this._renderer._curCamera._orbit(i3, a3, 0);
            } else if (this.mouseButton === this.RIGHT) {
              var s2 = n3._getLocalAxes(), l2 = Math.sqrt(s2.x[0] * s2.x[0] + s2.x[2] * s2.x[2]);
              l2 !== 0 && (s2.x[0] /= l2, s2.x[2] /= l2);
              var u2 = Math.sqrt(s2.y[0] * s2.y[0] + s2.y[2] * s2.y[2]);
              u2 !== 0 && (s2.y[0] /= u2, s2.y[2] /= u2);
              var c = -1 * e3 * (this.mouseX - this.pmouseX), d = -1 * t3 * (this.mouseY - this.pmouseY);
              n3.setPosition(n3.eyeX + c * s2.x[0] + d * s2.z[0], n3.eyeY, n3.eyeZ + c * s2.x[2] + d * s2.z[2]);
            }
          }
          return this;
        }
      }, f.default.prototype.debugMode = function() {
        this._assert3d("debugMode");
        for (var e3 = arguments.length, t3 = new Array(e3), r3 = 0; r3 < e3; r3++)
          t3[r3] = arguments[r3];
        f.default._validateParameters("debugMode", t3);
        for (var n3 = this._registeredMethods.post.length - 1; 0 <= n3; n3--)
          this._registeredMethods.post[n3].toString() !== this._grid().toString() && this._registeredMethods.post[n3].toString() !== this._axesIcon().toString() || this._registeredMethods.post.splice(n3, 1);
        t3[0] === o2.GRID ? this.registerMethod("post", this._grid.call(this, t3[1], t3[2], t3[3], t3[4], t3[5])) : t3[0] === o2.AXES ? this.registerMethod("post", this._axesIcon.call(this, t3[1], t3[2], t3[3], t3[4])) : (this.registerMethod("post", this._grid.call(this, t3[0], t3[1], t3[2], t3[3], t3[4])), this.registerMethod("post", this._axesIcon.call(this, t3[5], t3[6], t3[7], t3[8])));
      }, f.default.prototype.noDebugMode = function() {
        this._assert3d("noDebugMode");
        for (var e3 = this._registeredMethods.post.length - 1; 0 <= e3; e3--)
          this._registeredMethods.post[e3].toString() !== this._grid().toString() && this._registeredMethods.post[e3].toString() !== this._axesIcon().toString() || this._registeredMethods.post.splice(e3, 1);
      }, f.default.prototype._grid = function(e3, r3, n3, o3, i3) {
        e3 === void 0 && (e3 = this.width / 2), r3 === void 0 && (r3 = Math.round(e3 / 30) < 4 ? 4 : Math.round(e3 / 30)), n3 === void 0 && (n3 = 0), o3 === void 0 && (o3 = 0), i3 === void 0 && (i3 = 0);
        var a3 = e3 / r3, s2 = e3 / 2;
        return function() {
          this.push(), this.stroke(255 * this._renderer.curStrokeColor[0], 255 * this._renderer.curStrokeColor[1], 255 * this._renderer.curStrokeColor[2]), this._renderer.uMVMatrix.set(this._renderer._curCamera.cameraMatrix.mat4[0], this._renderer._curCamera.cameraMatrix.mat4[1], this._renderer._curCamera.cameraMatrix.mat4[2], this._renderer._curCamera.cameraMatrix.mat4[3], this._renderer._curCamera.cameraMatrix.mat4[4], this._renderer._curCamera.cameraMatrix.mat4[5], this._renderer._curCamera.cameraMatrix.mat4[6], this._renderer._curCamera.cameraMatrix.mat4[7], this._renderer._curCamera.cameraMatrix.mat4[8], this._renderer._curCamera.cameraMatrix.mat4[9], this._renderer._curCamera.cameraMatrix.mat4[10], this._renderer._curCamera.cameraMatrix.mat4[11], this._renderer._curCamera.cameraMatrix.mat4[12], this._renderer._curCamera.cameraMatrix.mat4[13], this._renderer._curCamera.cameraMatrix.mat4[14], this._renderer._curCamera.cameraMatrix.mat4[15]);
          for (var e4 = 0; e4 <= r3; e4++)
            this.beginShape(this.LINES), this.vertex(-s2 + n3, o3, e4 * a3 - s2 + i3), this.vertex(+s2 + n3, o3, e4 * a3 - s2 + i3), this.endShape();
          for (var t3 = 0; t3 <= r3; t3++)
            this.beginShape(this.LINES), this.vertex(t3 * a3 - s2 + n3, o3, -s2 + i3), this.vertex(t3 * a3 - s2 + n3, o3, +s2 + i3), this.endShape();
          this.pop();
        };
      }, f.default.prototype._axesIcon = function(e3, t3, r3, n3) {
        return e3 === void 0 && (e3 = 40 < this.width / 20 ? this.width / 20 : 40), t3 === void 0 && (t3 = -this.width / 4), r3 === void 0 && (r3 = t3), n3 === void 0 && (n3 = t3), function() {
          this.push(), this._renderer.uMVMatrix.set(this._renderer._curCamera.cameraMatrix.mat4[0], this._renderer._curCamera.cameraMatrix.mat4[1], this._renderer._curCamera.cameraMatrix.mat4[2], this._renderer._curCamera.cameraMatrix.mat4[3], this._renderer._curCamera.cameraMatrix.mat4[4], this._renderer._curCamera.cameraMatrix.mat4[5], this._renderer._curCamera.cameraMatrix.mat4[6], this._renderer._curCamera.cameraMatrix.mat4[7], this._renderer._curCamera.cameraMatrix.mat4[8], this._renderer._curCamera.cameraMatrix.mat4[9], this._renderer._curCamera.cameraMatrix.mat4[10], this._renderer._curCamera.cameraMatrix.mat4[11], this._renderer._curCamera.cameraMatrix.mat4[12], this._renderer._curCamera.cameraMatrix.mat4[13], this._renderer._curCamera.cameraMatrix.mat4[14], this._renderer._curCamera.cameraMatrix.mat4[15]), this.strokeWeight(2), this.stroke(255, 0, 0), this.beginShape(this.LINES), this.vertex(t3, r3, n3), this.vertex(t3 + e3, r3, n3), this.endShape(), this.stroke(0, 255, 0), this.beginShape(this.LINES), this.vertex(t3, r3, n3), this.vertex(t3, r3 + e3, n3), this.endShape(), this.stroke(0, 0, 255), this.beginShape(this.LINES), this.vertex(t3, r3, n3), this.vertex(t3, r3, n3 + e3), this.endShape(), this.pop();
        };
      };
      var i2 = f.default;
      r2.default = i2;
    }, { "../core/constants": 253, "../core/main": 264, "core-js/modules/es.array.splice": 164, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.regexp.to-string": 182 }], 309: [function(e2, t2, r2) {
      function a2(e3) {
        return (a2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, y = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 }, o2 = function(e3) {
        if (e3 && e3.__esModule)
          return e3;
        if (e3 === null || a2(e3) !== "object" && typeof e3 != "function")
          return { default: e3 };
        var t3 = s();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o3 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o3)) {
            var i3 = n3 ? Object.getOwnPropertyDescriptor(e3, o3) : null;
            i3 && (i3.get || i3.set) ? Object.defineProperty(r3, o3, i3) : r3[o3] = e3[o3];
          }
        r3.default = e3, t3 && t3.set(e3, r3);
        return r3;
      }(e2("../core/constants"));
      function s() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return s = function() {
          return e3;
        }, e3;
      }
      y.default.prototype.ambientLight = function(e3, t3, r3, n3) {
        this._assert3d("ambientLight"), y.default._validateParameters("ambientLight", arguments);
        var o3 = this.color.apply(this, arguments);
        return this._renderer.ambientLightColors.push(o3._array[0], o3._array[1], o3._array[2]), this._renderer._enableLighting = true, this;
      }, y.default.prototype.specularColor = function(e3, t3, r3) {
        this._assert3d("specularColor"), y.default._validateParameters("specularColor", arguments);
        var n3 = this.color.apply(this, arguments);
        return this._renderer.specularColors = [n3._array[0], n3._array[1], n3._array[2]], this;
      }, y.default.prototype.directionalLight = function(e3, t3, r3, n3, o3, i3) {
        var a3, s2, l2, u2;
        this._assert3d("directionalLight"), y.default._validateParameters("directionalLight", arguments), a3 = e3 instanceof y.default.Color ? e3 : this.color(e3, t3, r3);
        var c = arguments[arguments.length - 1];
        u2 = typeof c == "number" ? (s2 = arguments[arguments.length - 3], l2 = arguments[arguments.length - 2], arguments[arguments.length - 1]) : (s2 = c.x, l2 = c.y, c.z);
        var d = Math.sqrt(s2 * s2 + l2 * l2 + u2 * u2);
        return this._renderer.directionalLightDirections.push(s2 / d, l2 / d, u2 / d), this._renderer.directionalLightDiffuseColors.push(a3._array[0], a3._array[1], a3._array[2]), Array.prototype.push.apply(this._renderer.directionalLightSpecularColors, this._renderer.specularColors), this._renderer._enableLighting = true, this;
      }, y.default.prototype.pointLight = function(e3, t3, r3, n3, o3, i3) {
        var a3, s2, l2, u2;
        this._assert3d("pointLight"), y.default._validateParameters("pointLight", arguments), a3 = e3 instanceof y.default.Color ? e3 : this.color(e3, t3, r3);
        var c = arguments[arguments.length - 1];
        return u2 = typeof c == "number" ? (s2 = arguments[arguments.length - 3], l2 = arguments[arguments.length - 2], arguments[arguments.length - 1]) : (s2 = c.x, l2 = c.y, c.z), this._renderer.pointLightPositions.push(s2, l2, u2), this._renderer.pointLightDiffuseColors.push(a3._array[0], a3._array[1], a3._array[2]), Array.prototype.push.apply(this._renderer.pointLightSpecularColors, this._renderer.specularColors), this._renderer._enableLighting = true, this;
      }, y.default.prototype.lights = function() {
        if (this._assert3d("lights"), this._colorMode === o2.RGB)
          this.ambientLight(128, 128, 128), this.directionalLight(128, 128, 128, 0, 0, -1);
        else {
          var e3 = this._colorMaxes[this._colorMode][2];
          this.ambientLight(0, 0, e3), this.directionalLight(0, 0, e3, 0, 0, -1);
        }
        return this;
      }, y.default.prototype.lightFalloff = function(e3, t3, r3) {
        return this._assert3d("lightFalloff"), y.default._validateParameters("lightFalloff", arguments), e3 < 0 && (e3 = 0, console.warn("Value of constant argument in lightFalloff() should be never be negative. Set to 0.")), t3 < 0 && (t3 = 0, console.warn("Value of linear argument in lightFalloff() should be never be negative. Set to 0.")), r3 < 0 && (r3 = 0, console.warn("Value of quadratic argument in lightFalloff() should be never be negative. Set to 0.")), e3 === 0 && t3 === 0 && r3 === 0 && (e3 = 1, console.warn("Either one of the three arguments in lightFalloff() should be greater than zero. Set constant argument to 1.")), this._renderer.constantAttenuation = e3, this._renderer.linearAttenuation = t3, this._renderer.quadraticAttenuation = r3, this;
      }, y.default.prototype.spotLight = function(e3, t3, r3, n3, o3, i3, a3, s2, l2, u2, c) {
        var d, f, h2;
        this._assert3d("spotLight"), y.default._validateParameters("spotLight", arguments);
        var p2 = arguments.length;
        switch (p2) {
          case 11:
          case 10:
            d = this.color(e3, t3, r3), f = new y.default.Vector(n3, o3, i3), h2 = new y.default.Vector(a3, s2, l2);
            break;
          case 9:
            e3 instanceof y.default.Color ? (d = e3, f = new y.default.Vector(t3, r3, n3), h2 = new y.default.Vector(o3, i3, a3), u2 = s2, c = l2) : n3 instanceof y.default.Vector ? (d = this.color(e3, t3, r3), f = n3, h2 = new y.default.Vector(o3, i3, a3), u2 = s2, c = l2) : a3 instanceof y.default.Vector ? (d = this.color(e3, t3, r3), f = new y.default.Vector(n3, o3, i3), h2 = a3, u2 = s2, c = l2) : (d = this.color(e3, t3, r3), f = new y.default.Vector(n3, o3, i3), h2 = new y.default.Vector(a3, s2, l2));
            break;
          case 8:
            u2 = (h2 = e3 instanceof y.default.Color ? (d = e3, f = new y.default.Vector(t3, r3, n3), new y.default.Vector(o3, i3, a3)) : n3 instanceof y.default.Vector ? (d = this.color(e3, t3, r3), f = n3, new y.default.Vector(o3, i3, a3)) : (d = this.color(e3, t3, r3), f = new y.default.Vector(n3, o3, i3), a3), s2);
            break;
          case 7:
            e3 instanceof y.default.Color && t3 instanceof y.default.Vector ? (d = e3, f = t3, h2 = new y.default.Vector(r3, n3, o3), u2 = i3, c = a3) : e3 instanceof y.default.Color && o3 instanceof y.default.Vector ? (d = e3, f = new y.default.Vector(t3, r3, n3), h2 = o3, u2 = i3, c = a3) : n3 instanceof y.default.Vector && o3 instanceof y.default.Vector ? (d = this.color(e3, t3, r3), f = n3, h2 = o3, u2 = i3, c = a3) : h2 = e3 instanceof y.default.Color ? (d = e3, f = new y.default.Vector(t3, r3, n3), new y.default.Vector(o3, i3, a3)) : n3 instanceof y.default.Vector ? (d = this.color(e3, t3, r3), f = n3, new y.default.Vector(o3, i3, a3)) : (d = this.color(e3, t3, r3), f = new y.default.Vector(n3, o3, i3), a3);
            break;
          case 6:
            n3 instanceof y.default.Vector && o3 instanceof y.default.Vector ? (d = this.color(e3, t3, r3), f = n3, h2 = o3, u2 = i3) : e3 instanceof y.default.Color && o3 instanceof y.default.Vector ? (d = e3, f = new y.default.Vector(t3, r3, n3), h2 = o3, u2 = i3) : e3 instanceof y.default.Color && t3 instanceof y.default.Vector && (d = e3, f = t3, h2 = new y.default.Vector(r3, n3, o3), u2 = i3);
            break;
          case 5:
            e3 instanceof y.default.Color && t3 instanceof y.default.Vector && r3 instanceof y.default.Vector ? (d = e3, f = t3, h2 = r3, u2 = n3, c = o3) : n3 instanceof y.default.Vector && o3 instanceof y.default.Vector ? (d = this.color(e3, t3, r3), f = n3, h2 = o3) : e3 instanceof y.default.Color && o3 instanceof y.default.Vector ? (d = e3, f = new y.default.Vector(t3, r3, n3), h2 = o3) : e3 instanceof y.default.Color && t3 instanceof y.default.Vector && (d = e3, f = t3, h2 = new y.default.Vector(r3, n3, o3));
            break;
          case 4:
            d = e3, f = t3, h2 = r3, u2 = n3;
            break;
          case 3:
            d = e3, f = t3, h2 = r3;
            break;
          default:
            return console.warn("Sorry, input for spotlight() is not in prescribed format. Too ".concat(p2 < 3 ? "few" : "many", " arguments were provided")), this;
        }
        return this._renderer.spotLightDiffuseColors.push(d._array[0], d._array[1], d._array[2]), Array.prototype.push.apply(this._renderer.spotLightSpecularColors, this._renderer.specularColors), this._renderer.spotLightPositions.push(f.x, f.y, f.z), h2.normalize(), this._renderer.spotLightDirections.push(h2.x, h2.y, h2.z), u2 === void 0 && (u2 = Math.PI / 3), c !== void 0 && c < 1 ? (c = 1, console.warn("Value of concentration needs to be greater than 1. Setting it to 1")) : c === void 0 && (c = 100), u2 = this._renderer._pInst._toRadians(u2), this._renderer.spotLightAngle.push(Math.cos(u2)), this._renderer.spotLightConc.push(c), this._renderer._enableLighting = true, this;
      }, y.default.prototype.noLights = function() {
        return this._assert3d("noLights"), y.default._validateParameters("noLights", arguments), this._renderer._enableLighting = false, this._renderer.ambientLightColors.length = 0, this._renderer.specularColors = [1, 1, 1], this._renderer.directionalLightDirections.length = 0, this._renderer.directionalLightDiffuseColors.length = 0, this._renderer.directionalLightSpecularColors.length = 0, this._renderer.pointLightPositions.length = 0, this._renderer.pointLightDiffuseColors.length = 0, this._renderer.pointLightSpecularColors.length = 0, this._renderer.spotLightPositions.length = 0, this._renderer.spotLightDirections.length = 0, this._renderer.spotLightDiffuseColors.length = 0, this._renderer.spotLightSpecularColors.length = 0, this._renderer.spotLightAngle.length = 0, this._renderer.spotLightConc.length = 0, this._renderer.constantAttenuation = 1, this._renderer.linearAttenuation = 0, this._renderer.quadraticAttenuation = 0, this._renderer._useShininess = 1, this;
      };
      var i2 = y.default;
      r2.default = i2;
    }, { "../core/constants": 253, "../core/main": 264 }], 310: [function(e2, t2, r2) {
      e2("core-js/modules/es.array.concat"), e2("core-js/modules/es.array.index-of"), e2("core-js/modules/es.array.slice"), e2("core-js/modules/es.array.splice"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.regexp.exec"), e2("core-js/modules/es.string.match"), e2("core-js/modules/es.string.split"), e2("core-js/modules/es.string.trim"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, j = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      function s(e3, t3, r3) {
        for (var n3 = 0, o3 = e3.length; n3 < o3; n3++)
          if (e3[n3] !== t3.getUint8(r3 + n3, false))
            return false;
        return true;
      }
      e2("./p5.Geometry"), j.default.prototype.loadModel = function(e3) {
        var t3, r3, n3;
        j.default._validateParameters("loadModel", arguments);
        var o3 = e3.slice(-4);
        typeof arguments[1] == "boolean" ? (t3 = arguments[1], r3 = arguments[2], n3 = arguments[3], arguments[4] !== void 0 && (o3 = arguments[4])) : (t3 = false, r3 = arguments[1], n3 = arguments[2], arguments[3] !== void 0 && (o3 = arguments[3]));
        var i2 = new j.default.Geometry();
        i2.gid = "".concat(e3, "|").concat(t3);
        var a2 = this;
        return o3.match(/\.stl$/i) ? this.httpDo(e3, "GET", "arrayBuffer", function(e4) {
          !function(e5, t4) {
            if (function(e6) {
              for (var t5 = new DataView(e6), r5 = [115, 111, 108, 105, 100], n5 = 0; n5 < 5; n5++)
                if (s(r5, t5, n5))
                  return false;
              return true;
            }(t4))
              !function(e6, t5) {
                for (var r5, n5, o4, i3, a3, s2, l2, u2 = new DataView(t5), c = u2.getUint32(80, true), d = false, f = 0; f < 70; f++)
                  u2.getUint32(f, false) === 1129270351 && u2.getUint8(f + 4) === 82 && u2.getUint8(f + 5) === 61 && (d = true, i3 = [], a3 = u2.getUint8(f + 6) / 255, s2 = u2.getUint8(f + 7) / 255, l2 = u2.getUint8(f + 8) / 255);
                for (var h2 = 0; h2 < c; h2++) {
                  var p2 = 84 + 50 * h2, y = u2.getFloat32(p2, true), m2 = u2.getFloat32(4 + p2, true), g = u2.getFloat32(8 + p2, true);
                  if (d) {
                    var v = u2.getUint16(48 + p2, true);
                    o4 = (32768 & v) == 0 ? (r5 = (31 & v) / 31, n5 = (v >> 5 & 31) / 31, (v >> 10 & 31) / 31) : (r5 = a3, n5 = s2, l2);
                  }
                  for (var b2 = new j.default.Vector(y, m2, g), _ = 1; _ <= 3; _++) {
                    var x = p2 + 12 * _, w = new j.default.Vector(u2.getFloat32(x, true), u2.getFloat32(4 + x, true), u2.getFloat32(8 + x, true));
                    e6.vertices.push(w), e6.vertexNormals.push(b2), d && i3.push(r5, n5, o4);
                  }
                  e6.faces.push([3 * h2, 3 * h2 + 1, 3 * h2 + 2]), e6.uvs.push([0, 0], [0, 0], [0, 0]);
                }
              }(e5, t4);
            else {
              var r4 = new DataView(t4);
              if (!("TextDecoder" in window))
                return console.warn("Sorry, ASCII STL loading only works in browsers that support TextDecoder (https://caniuse.com/#feat=textencoder)");
              var n4 = new TextDecoder("utf-8").decode(r4).split("\n");
              !function(e6, t5) {
                for (var r5, n5, o4 = "", i3 = [], a3 = 0; a3 < t5.length; ++a3) {
                  for (var s2 = t5[a3].trim(), l2 = s2.split(" "), u2 = 0; u2 < l2.length; ++u2)
                    l2[u2] === "" && l2.splice(u2, 1);
                  if (l2.length !== 0)
                    switch (o4) {
                      case "":
                        if (l2[0] !== "solid")
                          return console.error(s2), console.error('Invalid state "'.concat(l2[0], '", should be "solid"'));
                        o4 = "solid";
                        break;
                      case "solid":
                        if (l2[0] !== "facet" || l2[1] !== "normal")
                          return console.error(s2), console.error('Invalid state "'.concat(l2[0], '", should be "facet normal"'));
                        r5 = new j.default.Vector(parseFloat(l2[2]), parseFloat(l2[3]), parseFloat(l2[4])), e6.vertexNormals.push(r5, r5, r5), o4 = "facet normal";
                        break;
                      case "facet normal":
                        if (l2[0] !== "outer" || l2[1] !== "loop")
                          return console.error(s2), console.error('Invalid state "'.concat(l2[0], '", should be "outer loop"'));
                        o4 = "vertex";
                        break;
                      case "vertex":
                        if (l2[0] === "vertex")
                          n5 = new j.default.Vector(parseFloat(l2[1]), parseFloat(l2[2]), parseFloat(l2[3])), e6.vertices.push(n5), e6.uvs.push([0, 0]), i3.push(e6.vertices.indexOf(n5));
                        else {
                          if (l2[0] !== "endloop")
                            return console.error(s2), console.error('Invalid state "'.concat(l2[0], '", should be "vertex" or "endloop"'));
                          e6.faces.push(i3), i3 = [], o4 = "endloop";
                        }
                        break;
                      case "endloop":
                        if (l2[0] !== "endfacet")
                          return console.error(s2), console.error('Invalid state "'.concat(l2[0], '", should be "endfacet"'));
                        o4 = "endfacet";
                        break;
                      case "endfacet":
                        if (l2[0] !== "endsolid") {
                          if (l2[0] !== "facet" || l2[1] !== "normal")
                            return console.error(s2), console.error('Invalid state "'.concat(l2[0], '", should be "endsolid" or "facet normal"'));
                          r5 = new j.default.Vector(parseFloat(l2[2]), parseFloat(l2[3]), parseFloat(l2[4])), e6.vertexNormals.push(r5, r5, r5), o4 = "facet normal";
                        }
                        break;
                      default:
                        console.error('Invalid state "'.concat(o4, '"'));
                    }
                }
              }(e5, n4);
            }
          }(i2, e4), t3 && i2.normalize(), a2._decrementPreload(), typeof r3 == "function" && r3(i2);
        }, n3) : o3.match(/\.obj$/i) ? this.loadStrings(e3, function(e4) {
          !function(e5, t4) {
            for (var r4 = { v: [], vt: [], vn: [] }, n4 = {}, o4 = 0; o4 < t4.length; ++o4) {
              var i3 = t4[o4].trim().split(/\b\s+/);
              if (0 < i3.length) {
                if (i3[0] === "v" || i3[0] === "vn") {
                  var a3 = new j.default.Vector(parseFloat(i3[1]), parseFloat(i3[2]), parseFloat(i3[3]));
                  r4[i3[0]].push(a3);
                } else if (i3[0] === "vt") {
                  var s2 = [parseFloat(i3[1]), 1 - parseFloat(i3[2])];
                  r4[i3[0]].push(s2);
                } else if (i3[0] === "f")
                  for (var l2 = 3; l2 < i3.length; ++l2) {
                    for (var u2 = [], c = [1, l2 - 1, l2], d = 0; d < c.length; ++d) {
                      var f = i3[c[d]], h2 = 0;
                      if (n4[f] !== void 0)
                        h2 = n4[f];
                      else {
                        for (var p2 = f.split("/"), y = 0; y < p2.length; y++)
                          p2[y] = parseInt(p2[y]) - 1;
                        h2 = n4[f] = e5.vertices.length, e5.vertices.push(r4.v[p2[0]].copy()), r4.vt[p2[1]] ? e5.uvs.push(r4.vt[p2[1]].slice()) : e5.uvs.push([0, 0]), r4.vn[p2[2]] && e5.vertexNormals.push(r4.vn[p2[2]].copy());
                      }
                      u2.push(h2);
                    }
                    u2[0] !== u2[1] && u2[0] !== u2[2] && u2[1] !== u2[2] && e5.faces.push(u2);
                  }
              }
            }
            e5.vertexNormals.length === 0 && e5.computeNormals();
          }(i2, e4), t3 && i2.normalize(), a2._decrementPreload(), typeof r3 == "function" && r3(i2);
        }, n3) : (j.default._friendlyFileLoadError(3, e3), n3 ? n3() : console.error("Sorry, the file type is invalid. Only OBJ and STL files are supported.")), i2;
      }, j.default.prototype.model = function(e3) {
        this._assert3d("model"), j.default._validateParameters("model", arguments), 0 < e3.vertices.length && (this._renderer.geometryInHash(e3.gid) || (e3._makeTriangleEdges()._edgesToVertices(), this._renderer.createBuffers(e3.gid, e3)), this._renderer.drawBuffers(e3.gid));
      };
      var o2 = j.default;
      r2.default = o2;
    }, { "../core/main": 264, "./p5.Geometry": 313, "core-js/modules/es.array.concat": 149, "core-js/modules/es.array.index-of": 157, "core-js/modules/es.array.slice": 162, "core-js/modules/es.array.splice": 164, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.regexp.exec": 181, "core-js/modules/es.string.match": 187, "core-js/modules/es.string.split": 191, "core-js/modules/es.string.trim": 193 }], 311: [function(e2, t2, r2) {
      function a2(e3) {
        return (a2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      e2("core-js/modules/es.array.join"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, u2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 }, o2 = function(e3) {
        if (e3 && e3.__esModule)
          return e3;
        if (e3 === null || a2(e3) !== "object" && typeof e3 != "function")
          return { default: e3 };
        var t3 = s();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o3 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o3)) {
            var i3 = n3 ? Object.getOwnPropertyDescriptor(e3, o3) : null;
            i3 && (i3.get || i3.set) ? Object.defineProperty(r3, o3, i3) : r3[o3] = e3[o3];
          }
        r3.default = e3, t3 && t3.set(e3, r3);
        return r3;
      }(e2("../core/constants"));
      function s() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return s = function() {
          return e3;
        }, e3;
      }
      e2("./p5.Texture"), u2.default.prototype.loadShader = function(e3, t3, r3, n3) {
        u2.default._validateParameters("loadShader", arguments), n3 = n3 || console.error;
        function o3() {
          a3._decrementPreload(), r3 && r3(i3);
        }
        var i3 = new u2.default.Shader(), a3 = this, s2 = false, l2 = false;
        return this.loadStrings(e3, function(e4) {
          i3._vertSrc = e4.join("\n"), l2 = true, s2 && o3();
        }, n3), this.loadStrings(t3, function(e4) {
          i3._fragSrc = e4.join("\n"), s2 = true, l2 && o3();
        }, n3), i3;
      }, u2.default.prototype.createShader = function(e3, t3) {
        return this._assert3d("createShader"), u2.default._validateParameters("createShader", arguments), new u2.default.Shader(this._renderer, e3, t3);
      }, u2.default.prototype.shader = function(e3) {
        return this._assert3d("shader"), u2.default._validateParameters("shader", arguments), e3._renderer === void 0 && (e3._renderer = this._renderer), e3.init(), e3.isStrokeShader() ? this._renderer.userStrokeShader = e3 : (this._renderer.userFillShader = e3, this._renderer._useNormalMaterial = false), this;
      }, u2.default.prototype.resetShader = function() {
        return this._renderer.userFillShader = this._renderer.userStrokeShader = null, this;
      }, u2.default.prototype.texture = function(e3) {
        return this._assert3d("texture"), u2.default._validateParameters("texture", arguments), e3.gifProperties && e3._animateGif(this), this._renderer.drawMode = o2.TEXTURE, this._renderer._useSpecularMaterial = false, this._renderer._useEmissiveMaterial = false, this._renderer._useNormalMaterial = false, this._renderer._tex = e3, this._renderer._setProperty("_doFill", true), this;
      }, u2.default.prototype.textureMode = function(e3) {
        e3 !== o2.IMAGE && e3 !== o2.NORMAL ? console.warn("You tried to set ".concat(e3, " textureMode only supports IMAGE & NORMAL ")) : this._renderer.textureMode = e3;
      }, u2.default.prototype.textureWrap = function(e3) {
        var t3 = 1 < arguments.length && arguments[1] !== void 0 ? arguments[1] : e3;
        this._renderer.textureWrapX = e3, this._renderer.textureWrapY = t3;
        for (var r3 = this._renderer.textures, n3 = 0; n3 < r3.length; n3++)
          r3[n3].setWrapMode(e3, t3);
      }, u2.default.prototype.normalMaterial = function() {
        this._assert3d("normalMaterial");
        for (var e3 = arguments.length, t3 = new Array(e3), r3 = 0; r3 < e3; r3++)
          t3[r3] = arguments[r3];
        return u2.default._validateParameters("normalMaterial", t3), this._renderer.drawMode = o2.FILL, this._renderer._useSpecularMaterial = false, this._renderer._useEmissiveMaterial = false, this._renderer._useNormalMaterial = true, this._renderer.curFillColor = [1, 1, 1, 1], this._renderer._setProperty("_doFill", true), this.noStroke(), this;
      }, u2.default.prototype.ambientMaterial = function(e3, t3, r3) {
        this._assert3d("ambientMaterial"), u2.default._validateParameters("ambientMaterial", arguments);
        var n3 = u2.default.prototype.color.apply(this, arguments);
        return this._renderer.curFillColor = n3._array, this._renderer._useSpecularMaterial = false, this._renderer._useEmissiveMaterial = false, this._renderer._useNormalMaterial = false, this._renderer._enableLighting = true, this._renderer._tex = null, this._renderer._setProperty("_doFill", true), this;
      }, u2.default.prototype.emissiveMaterial = function(e3, t3, r3, n3) {
        this._assert3d("emissiveMaterial"), u2.default._validateParameters("emissiveMaterial", arguments);
        var o3 = u2.default.prototype.color.apply(this, arguments);
        return this._renderer.curFillColor = o3._array, this._renderer._useSpecularMaterial = false, this._renderer._useEmissiveMaterial = true, this._renderer._useNormalMaterial = false, this._renderer._enableLighting = true, this._renderer._tex = null, this;
      }, u2.default.prototype.specularMaterial = function(e3, t3, r3, n3) {
        this._assert3d("specularMaterial"), u2.default._validateParameters("specularMaterial", arguments);
        var o3 = u2.default.prototype.color.apply(this, arguments);
        return this._renderer.curFillColor = o3._array, this._renderer._useSpecularMaterial = true, this._renderer._useEmissiveMaterial = false, this._renderer._useNormalMaterial = false, this._renderer._enableLighting = true, this._renderer._tex = null, this;
      }, u2.default.prototype.shininess = function(e3) {
        return this._assert3d("shininess"), u2.default._validateParameters("shininess", arguments), e3 < 1 && (e3 = 1), this._renderer._useShininess = e3, this;
      }, u2.default.RendererGL.prototype._applyColorBlend = function(e3) {
        var t3 = this.GL, r3 = this.drawMode === o2.TEXTURE || e3[e3.length - 1] < 1 || this._isErasing;
        return r3 !== this._isBlending && (r3 || this.curBlendMode !== o2.BLEND && this.curBlendMode !== o2.ADD ? t3.enable(t3.BLEND) : t3.disable(t3.BLEND), t3.depthMask(true), this._isBlending = r3), this._applyBlendMode(), e3;
      }, u2.default.RendererGL.prototype._applyBlendMode = function() {
        if (this._cachedBlendMode !== this.curBlendMode) {
          var e3 = this.GL;
          switch (this.curBlendMode) {
            case o2.BLEND:
            case o2.ADD:
              e3.blendEquation(e3.FUNC_ADD), e3.blendFunc(e3.SRC_ALPHA, e3.ONE_MINUS_SRC_ALPHA);
              break;
            case o2.REMOVE:
              e3.blendEquation(e3.FUNC_REVERSE_SUBTRACT), e3.blendFunc(e3.SRC_ALPHA, e3.DST_ALPHA);
              break;
            case o2.MULTIPLY:
              e3.blendEquationSeparate(e3.FUNC_ADD, e3.FUNC_ADD), e3.blendFuncSeparate(e3.ZERO, e3.SRC_COLOR, e3.ONE, e3.ONE);
              break;
            case o2.SCREEN:
              e3.blendEquationSeparate(e3.FUNC_ADD, e3.FUNC_ADD), e3.blendFuncSeparate(e3.ONE_MINUS_DST_COLOR, e3.ONE, e3.ONE, e3.ONE);
              break;
            case o2.EXCLUSION:
              e3.blendEquationSeparate(e3.FUNC_ADD, e3.FUNC_ADD), e3.blendFuncSeparate(e3.ONE_MINUS_DST_COLOR, e3.ONE_MINUS_SRC_COLOR, e3.ONE, e3.ONE);
              break;
            case o2.REPLACE:
              e3.blendEquation(e3.FUNC_ADD), e3.blendFunc(e3.ONE, e3.ZERO);
              break;
            case o2.SUBTRACT:
              e3.blendEquationSeparate(e3.FUNC_REVERSE_SUBTRACT, e3.FUNC_ADD), e3.blendFuncSeparate(e3.SRC_ALPHA, e3.ONE, e3.ONE, e3.ONE);
              break;
            case o2.DARKEST:
              this.blendExt ? (e3.blendEquationSeparate(this.blendExt.MIN_EXT, e3.FUNC_ADD), e3.blendFuncSeparate(e3.ONE, e3.ONE, e3.ONE, e3.ONE)) : console.warn("blendMode(DARKEST) does not work in your browser in WEBGL mode.");
              break;
            case o2.LIGHTEST:
              this.blendExt ? (e3.blendEquationSeparate(this.blendExt.MAX_EXT, e3.FUNC_ADD), e3.blendFuncSeparate(e3.ONE, e3.ONE, e3.ONE, e3.ONE)) : console.warn("blendMode(LIGHTEST) does not work in your browser in WEBGL mode.");
              break;
            default:
              console.error("Oops! Somehow RendererGL set curBlendMode to an unsupported mode.");
          }
          this._isErasing || (this._cachedBlendMode = this.curBlendMode);
        }
      };
      var i2 = u2.default;
      r2.default = i2;
    }, { "../core/constants": 253, "../core/main": 264, "./p5.Texture": 320, "core-js/modules/es.array.join": 159 }], 312: [function(e2, t2, r2) {
      Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, y = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      y.default.prototype.camera = function() {
        var e3;
        this._assert3d("camera");
        for (var t3 = arguments.length, r3 = new Array(t3), n3 = 0; n3 < t3; n3++)
          r3[n3] = arguments[n3];
        return y.default._validateParameters("camera", r3), (e3 = this._renderer._curCamera).camera.apply(e3, r3), this;
      }, y.default.prototype.perspective = function() {
        var e3;
        this._assert3d("perspective");
        for (var t3 = arguments.length, r3 = new Array(t3), n3 = 0; n3 < t3; n3++)
          r3[n3] = arguments[n3];
        return y.default._validateParameters("perspective", r3), (e3 = this._renderer._curCamera).perspective.apply(e3, r3), this;
      }, y.default.prototype.ortho = function() {
        var e3;
        this._assert3d("ortho");
        for (var t3 = arguments.length, r3 = new Array(t3), n3 = 0; n3 < t3; n3++)
          r3[n3] = arguments[n3];
        return y.default._validateParameters("ortho", r3), (e3 = this._renderer._curCamera).ortho.apply(e3, r3), this;
      }, y.default.prototype.frustum = function() {
        var e3;
        this._assert3d("frustum");
        for (var t3 = arguments.length, r3 = new Array(t3), n3 = 0; n3 < t3; n3++)
          r3[n3] = arguments[n3];
        return y.default._validateParameters("frustum", r3), (e3 = this._renderer._curCamera).frustum.apply(e3, r3), this;
      }, y.default.prototype.createCamera = function() {
        this._assert3d("createCamera");
        var e3 = new y.default.Camera(this._renderer);
        return e3._computeCameraDefaultSettings(), e3._setDefaultCamera(), this._renderer._curCamera = e3;
      }, y.default.Camera = function(e3) {
        this._renderer = e3, this.cameraType = "default", this.cameraMatrix = new y.default.Matrix(), this.projMatrix = new y.default.Matrix();
      }, y.default.Camera.prototype.perspective = function(e3, t3, r3, n3) {
        this.cameraType = 0 < arguments.length ? "custom" : "default", e3 === void 0 ? (e3 = this.defaultCameraFOV, this.cameraFOV = e3) : this.cameraFOV = this._renderer._pInst._toRadians(e3), t3 === void 0 && (t3 = this.defaultAspectRatio), r3 === void 0 && (r3 = this.defaultCameraNear), n3 === void 0 && (n3 = this.defaultCameraFar), r3 <= 1e-4 && (r3 = 0.01, console.log("Avoid perspective near plane values close to or below 0. Setting value to 0.01.")), n3 < r3 && console.log("Perspective far plane value is less than near plane value. Nothing will be shown."), this.aspectRatio = t3, this.cameraNear = r3, this.cameraFar = n3, this.projMatrix = y.default.Matrix.identity();
        var o3 = 1 / Math.tan(this.cameraFOV / 2), i2 = 1 / (this.cameraNear - this.cameraFar);
        this.projMatrix.set(o3 / t3, 0, 0, 0, 0, -o3, 0, 0, 0, 0, (n3 + r3) * i2, -1, 0, 0, 2 * n3 * r3 * i2, 0), this._isActive() && this._renderer.uPMatrix.set(this.projMatrix.mat4[0], this.projMatrix.mat4[1], this.projMatrix.mat4[2], this.projMatrix.mat4[3], this.projMatrix.mat4[4], this.projMatrix.mat4[5], this.projMatrix.mat4[6], this.projMatrix.mat4[7], this.projMatrix.mat4[8], this.projMatrix.mat4[9], this.projMatrix.mat4[10], this.projMatrix.mat4[11], this.projMatrix.mat4[12], this.projMatrix.mat4[13], this.projMatrix.mat4[14], this.projMatrix.mat4[15]);
      }, y.default.Camera.prototype.ortho = function(e3, t3, r3, n3, o3, i2) {
        e3 === void 0 && (e3 = -this._renderer.width / 2), t3 === void 0 && (t3 = this._renderer.width / 2), r3 === void 0 && (r3 = -this._renderer.height / 2), n3 === void 0 && (n3 = this._renderer.height / 2), o3 === void 0 && (o3 = 0), i2 === void 0 && (i2 = Math.max(this._renderer.width, this._renderer.height));
        var a2 = t3 - e3, s = n3 - r3, l2 = i2 - o3, u2 = 2 / a2, c = 2 / s, d = -2 / l2, f = -(t3 + e3) / a2, h2 = -(n3 + r3) / s, p2 = -(i2 + o3) / l2;
        this.projMatrix = y.default.Matrix.identity(), this.projMatrix.set(u2, 0, 0, 0, 0, -c, 0, 0, 0, 0, d, 0, f, h2, p2, 1), this._isActive() && this._renderer.uPMatrix.set(this.projMatrix.mat4[0], this.projMatrix.mat4[1], this.projMatrix.mat4[2], this.projMatrix.mat4[3], this.projMatrix.mat4[4], this.projMatrix.mat4[5], this.projMatrix.mat4[6], this.projMatrix.mat4[7], this.projMatrix.mat4[8], this.projMatrix.mat4[9], this.projMatrix.mat4[10], this.projMatrix.mat4[11], this.projMatrix.mat4[12], this.projMatrix.mat4[13], this.projMatrix.mat4[14], this.projMatrix.mat4[15]), this.cameraType = "custom";
      }, y.default.Camera.prototype.frustum = function(e3, t3, r3, n3, o3, i2) {
        e3 === void 0 && (e3 = -this._renderer.width / 2), t3 === void 0 && (t3 = this._renderer.width / 2), r3 === void 0 && (r3 = -this._renderer.height / 2), n3 === void 0 && (n3 = this._renderer.height / 2), o3 === void 0 && (o3 = 0), i2 === void 0 && (i2 = Math.max(this._renderer.width, this._renderer.height));
        var a2 = t3 - e3, s = n3 - r3, l2 = i2 - o3, u2 = 2 * o3 / a2, c = 2 * o3 / s, d = -2 * i2 * o3 / l2, f = (t3 + e3) / a2, h2 = (n3 + r3) / s, p2 = -(i2 + o3) / l2;
        this.projMatrix = y.default.Matrix.identity(), this.projMatrix.set(u2, 0, 0, 0, 0, c, 0, 0, f, h2, p2, -1, 0, 0, d, 0), this._isActive() && this._renderer.uPMatrix.set(this.projMatrix.mat4[0], this.projMatrix.mat4[1], this.projMatrix.mat4[2], this.projMatrix.mat4[3], this.projMatrix.mat4[4], this.projMatrix.mat4[5], this.projMatrix.mat4[6], this.projMatrix.mat4[7], this.projMatrix.mat4[8], this.projMatrix.mat4[9], this.projMatrix.mat4[10], this.projMatrix.mat4[11], this.projMatrix.mat4[12], this.projMatrix.mat4[13], this.projMatrix.mat4[14], this.projMatrix.mat4[15]), this.cameraType = "custom";
      }, y.default.Camera.prototype._rotateView = function(e3, t3, r3, n3) {
        var o3 = this.centerX, i2 = this.centerY, a2 = this.centerZ;
        o3 -= this.eyeX, i2 -= this.eyeY, a2 -= this.eyeZ;
        var s = y.default.Matrix.identity(this._renderer._pInst);
        s.rotate(this._renderer._pInst._toRadians(e3), t3, r3, n3);
        var l2 = [o3 * s.mat4[0] + i2 * s.mat4[4] + a2 * s.mat4[8], o3 * s.mat4[1] + i2 * s.mat4[5] + a2 * s.mat4[9], o3 * s.mat4[2] + i2 * s.mat4[6] + a2 * s.mat4[10]];
        l2[0] += this.eyeX, l2[1] += this.eyeY, l2[2] += this.eyeZ, this.camera(this.eyeX, this.eyeY, this.eyeZ, l2[0], l2[1], l2[2], this.upX, this.upY, this.upZ);
      }, y.default.Camera.prototype.pan = function(e3) {
        var t3 = this._getLocalAxes();
        this._rotateView(e3, t3.y[0], t3.y[1], t3.y[2]);
      }, y.default.Camera.prototype.tilt = function(e3) {
        var t3 = this._getLocalAxes();
        this._rotateView(e3, t3.x[0], t3.x[1], t3.x[2]);
      }, y.default.Camera.prototype.lookAt = function(e3, t3, r3) {
        this.camera(this.eyeX, this.eyeY, this.eyeZ, e3, t3, r3, this.upX, this.upY, this.upZ);
      }, y.default.Camera.prototype.camera = function(e3, t3, r3, n3, o3, i2, a2, s, l2) {
        e3 === void 0 && (e3 = this.defaultEyeX, t3 = this.defaultEyeY, r3 = this.defaultEyeZ, n3 = e3, o3 = t3, s = 1, l2 = a2 = i2 = 0), this.eyeX = e3, this.eyeY = t3, this.eyeZ = r3, n3 !== void 0 && (this.centerX = n3, this.centerY = o3, this.centerZ = i2), a2 !== void 0 && (this.upX = a2, this.upY = s, this.upZ = l2);
        var u2 = this._getLocalAxes();
        this.cameraMatrix.set(u2.x[0], u2.y[0], u2.z[0], 0, u2.x[1], u2.y[1], u2.z[1], 0, u2.x[2], u2.y[2], u2.z[2], 0, 0, 0, 0, 1);
        var c = -e3, d = -t3, f = -r3;
        return this.cameraMatrix.translate([c, d, f]), this._isActive() && this._renderer.uMVMatrix.set(this.cameraMatrix.mat4[0], this.cameraMatrix.mat4[1], this.cameraMatrix.mat4[2], this.cameraMatrix.mat4[3], this.cameraMatrix.mat4[4], this.cameraMatrix.mat4[5], this.cameraMatrix.mat4[6], this.cameraMatrix.mat4[7], this.cameraMatrix.mat4[8], this.cameraMatrix.mat4[9], this.cameraMatrix.mat4[10], this.cameraMatrix.mat4[11], this.cameraMatrix.mat4[12], this.cameraMatrix.mat4[13], this.cameraMatrix.mat4[14], this.cameraMatrix.mat4[15]), this;
      }, y.default.Camera.prototype.move = function(e3, t3, r3) {
        var n3 = this._getLocalAxes(), o3 = [n3.x[0] * e3, n3.x[1] * e3, n3.x[2] * e3], i2 = [n3.y[0] * t3, n3.y[1] * t3, n3.y[2] * t3], a2 = [n3.z[0] * r3, n3.z[1] * r3, n3.z[2] * r3];
        this.camera(this.eyeX + o3[0] + i2[0] + a2[0], this.eyeY + o3[1] + i2[1] + a2[1], this.eyeZ + o3[2] + i2[2] + a2[2], this.centerX + o3[0] + i2[0] + a2[0], this.centerY + o3[1] + i2[1] + a2[1], this.centerZ + o3[2] + i2[2] + a2[2], 0, 1, 0);
      }, y.default.Camera.prototype.setPosition = function(e3, t3, r3) {
        var n3 = e3 - this.eyeX, o3 = t3 - this.eyeY, i2 = r3 - this.eyeZ;
        this.camera(e3, t3, r3, this.centerX + n3, this.centerY + o3, this.centerZ + i2, 0, 1, 0);
      }, y.default.Camera.prototype._computeCameraDefaultSettings = function() {
        this.defaultCameraFOV = 60 / 180 * Math.PI, this.defaultAspectRatio = this._renderer.width / this._renderer.height, this.defaultEyeX = 0, this.defaultEyeY = 0, this.defaultEyeZ = this._renderer.height / 2 / Math.tan(this.defaultCameraFOV / 2), this.defaultCenterX = 0, this.defaultCenterY = 0, this.defaultCenterZ = 0, this.defaultCameraNear = 0.1 * this.defaultEyeZ, this.defaultCameraFar = 10 * this.defaultEyeZ;
      }, y.default.Camera.prototype._setDefaultCamera = function() {
        this.cameraFOV = this.defaultCameraFOV, this.aspectRatio = this.defaultAspectRatio, this.eyeX = this.defaultEyeX, this.eyeY = this.defaultEyeY, this.eyeZ = this.defaultEyeZ, this.centerX = this.defaultCenterX, this.centerY = this.defaultCenterY, this.centerZ = this.defaultCenterZ, this.upX = 0, this.upY = 1, this.upZ = 0, this.cameraNear = this.defaultCameraNear, this.cameraFar = this.defaultCameraFar, this.perspective(), this.camera(), this.cameraType = "default";
      }, y.default.Camera.prototype._resize = function() {
        this.cameraType === "default" ? (this._computeCameraDefaultSettings(), this._setDefaultCamera()) : this.perspective(this.cameraFOV, this._renderer.width / this._renderer.height);
      }, y.default.Camera.prototype.copy = function() {
        var e3 = new y.default.Camera(this._renderer);
        return e3.cameraFOV = this.cameraFOV, e3.aspectRatio = this.aspectRatio, e3.eyeX = this.eyeX, e3.eyeY = this.eyeY, e3.eyeZ = this.eyeZ, e3.centerX = this.centerX, e3.centerY = this.centerY, e3.centerZ = this.centerZ, e3.cameraNear = this.cameraNear, e3.cameraFar = this.cameraFar, e3.cameraType = this.cameraType, e3.cameraMatrix = this.cameraMatrix.copy(), e3.projMatrix = this.projMatrix.copy(), e3;
      }, y.default.Camera.prototype._getLocalAxes = function() {
        var e3 = this.eyeX - this.centerX, t3 = this.eyeY - this.centerY, r3 = this.eyeZ - this.centerZ, n3 = Math.sqrt(e3 * e3 + t3 * t3 + r3 * r3);
        n3 !== 0 && (e3 /= n3, t3 /= n3, r3 /= n3);
        var o3 = this.upX, i2 = this.upY, a2 = this.upZ, s = i2 * r3 - a2 * t3, l2 = -o3 * r3 + a2 * e3, u2 = o3 * t3 - i2 * e3;
        o3 = t3 * u2 - r3 * l2, i2 = -e3 * u2 + r3 * s, a2 = e3 * l2 - t3 * s;
        var c = Math.sqrt(s * s + l2 * l2 + u2 * u2);
        c !== 0 && (s /= c, l2 /= c, u2 /= c);
        var d = Math.sqrt(o3 * o3 + i2 * i2 + a2 * a2);
        return d !== 0 && (o3 /= d, i2 /= d, a2 /= d), { x: [s, l2, u2], y: [o3, i2, a2], z: [e3, t3, r3] };
      }, y.default.Camera.prototype._orbit = function(e3, t3, r3) {
        var n3 = this.eyeX - this.centerX, o3 = this.eyeY - this.centerY, i2 = this.eyeZ - this.centerZ, a2 = Math.sqrt(n3 * n3 + o3 * o3 + i2 * i2), s = Math.atan2(n3, i2), l2 = Math.acos(Math.max(-1, Math.min(1, o3 / a2)));
        s += e3, (a2 += r3) < 0 && (a2 = 0.1), (l2 += t3) > Math.PI ? l2 = Math.PI : l2 <= 0 && (l2 = 1e-3);
        var u2 = Math.sin(l2) * a2 * Math.sin(s), c = Math.cos(l2) * a2, d = Math.sin(l2) * a2 * Math.cos(s);
        this.camera(u2 + this.centerX, c + this.centerY, d + this.centerZ, this.centerX, this.centerY, this.centerZ, 0, 1, 0);
      }, y.default.Camera.prototype._isActive = function() {
        return this === this._renderer._curCamera;
      }, y.default.prototype.setCamera = function(e3) {
        this._renderer._curCamera = e3, this._renderer.uPMatrix.set(e3.projMatrix.mat4[0], e3.projMatrix.mat4[1], e3.projMatrix.mat4[2], e3.projMatrix.mat4[3], e3.projMatrix.mat4[4], e3.projMatrix.mat4[5], e3.projMatrix.mat4[6], e3.projMatrix.mat4[7], e3.projMatrix.mat4[8], e3.projMatrix.mat4[9], e3.projMatrix.mat4[10], e3.projMatrix.mat4[11], e3.projMatrix.mat4[12], e3.projMatrix.mat4[13], e3.projMatrix.mat4[14], e3.projMatrix.mat4[15]);
      };
      var o2 = y.default.Camera;
      r2.default = o2;
    }, { "../core/main": 264 }], 313: [function(e2, t2, r2) {
      e2("core-js/modules/es.string.sub"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, c = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      c.default.Geometry = function(e3, t3, r3) {
        return this.vertices = [], this.lineVertices = [], this.lineNormals = [], this.vertexNormals = [], this.faces = [], this.uvs = [], this.edges = [], this.vertexColors = [], this.detailX = e3 !== void 0 ? e3 : 1, this.detailY = t3 !== void 0 ? t3 : 1, this.dirtyFlags = {}, r3 instanceof Function && r3.call(this), this;
      }, c.default.Geometry.prototype.reset = function() {
        this.lineVertices.length = 0, this.lineNormals.length = 0, this.vertices.length = 0, this.edges.length = 0, this.vertexColors.length = 0, this.vertexNormals.length = 0, this.uvs.length = 0, this.dirtyFlags = {};
      }, c.default.Geometry.prototype.computeFaces = function() {
        this.faces.length = 0;
        for (var e3, t3, r3, n3, o3 = this.detailX + 1, i2 = 0; i2 < this.detailY; i2++)
          for (var a2 = 0; a2 < this.detailX; a2++)
            t3 = (e3 = i2 * o3 + a2) + 1, r3 = (i2 + 1) * o3 + a2 + 1, n3 = (i2 + 1) * o3 + a2, this.faces.push([e3, t3, n3]), this.faces.push([n3, t3, r3]);
        return this;
      }, c.default.Geometry.prototype._getFaceNormal = function(e3) {
        var t3 = this.faces[e3], r3 = this.vertices[t3[0]], n3 = this.vertices[t3[1]], o3 = this.vertices[t3[2]], i2 = c.default.Vector.sub(n3, r3), a2 = c.default.Vector.sub(o3, r3), s = c.default.Vector.cross(i2, a2), l2 = c.default.Vector.mag(s), u2 = l2 / (c.default.Vector.mag(i2) * c.default.Vector.mag(a2));
        return u2 === 0 || isNaN(u2) ? (console.warn("p5.Geometry.prototype._getFaceNormal:", "face has colinear sides or a repeated vertex"), s) : (1 < u2 && (u2 = 1), s.mult(Math.asin(u2) / l2));
      }, c.default.Geometry.prototype.computeNormals = function() {
        var e3, t3 = this.vertexNormals, r3 = this.vertices, n3 = this.faces;
        for (e3 = t3.length = 0; e3 < r3.length; ++e3)
          t3.push(new c.default.Vector());
        for (var o3 = 0; o3 < n3.length; ++o3)
          for (var i2 = n3[o3], a2 = this._getFaceNormal(o3), s = 0; s < 3; ++s) {
            t3[i2[s]].add(a2);
          }
        for (e3 = 0; e3 < r3.length; ++e3)
          t3[e3].normalize();
        return this;
      }, c.default.Geometry.prototype.averageNormals = function() {
        for (var e3 = 0; e3 <= this.detailY; e3++) {
          var t3 = this.detailX + 1, r3 = c.default.Vector.add(this.vertexNormals[e3 * t3], this.vertexNormals[e3 * t3 + this.detailX]);
          r3 = c.default.Vector.div(r3, 2), this.vertexNormals[e3 * t3] = r3, this.vertexNormals[e3 * t3 + this.detailX] = r3;
        }
        return this;
      }, c.default.Geometry.prototype.averagePoleNormals = function() {
        for (var e3 = new c.default.Vector(0, 0, 0), t3 = 0; t3 < this.detailX; t3++)
          e3.add(this.vertexNormals[t3]);
        e3 = c.default.Vector.div(e3, this.detailX);
        for (var r3 = 0; r3 < this.detailX; r3++)
          this.vertexNormals[r3] = e3;
        e3 = new c.default.Vector(0, 0, 0);
        for (var n3 = this.vertices.length - 1; n3 > this.vertices.length - 1 - this.detailX; n3--)
          e3.add(this.vertexNormals[n3]);
        e3 = c.default.Vector.div(e3, this.detailX);
        for (var o3 = this.vertices.length - 1; o3 > this.vertices.length - 1 - this.detailX; o3--)
          this.vertexNormals[o3] = e3;
        return this;
      }, c.default.Geometry.prototype._makeTriangleEdges = function() {
        if (this.edges.length = 0, Array.isArray(this.strokeIndices))
          for (var e3 = 0, t3 = this.strokeIndices.length; e3 < t3; e3++)
            this.edges.push(this.strokeIndices[e3]);
        else
          for (var r3 = 0; r3 < this.faces.length; r3++)
            this.edges.push([this.faces[r3][0], this.faces[r3][1]]), this.edges.push([this.faces[r3][1], this.faces[r3][2]]), this.edges.push([this.faces[r3][2], this.faces[r3][0]]);
        return this;
      }, c.default.Geometry.prototype._edgesToVertices = function() {
        this.lineVertices.length = 0;
        for (var e3 = this.lineNormals.length = 0; e3 < this.edges.length; e3++) {
          var t3 = this.vertices[this.edges[e3][0]], r3 = this.vertices[this.edges[e3][1]], n3 = r3.copy().sub(t3).normalize(), o3 = t3.array(), i2 = t3.array(), a2 = r3.array(), s = r3.array(), l2 = n3.array(), u2 = n3.array();
          l2.push(1), u2.push(-1), this.lineNormals.push(l2, u2, l2, l2, u2, u2), this.lineVertices.push(o3, i2, a2, a2, i2, s);
        }
        return this;
      }, c.default.Geometry.prototype.normalize = function() {
        if (0 < this.vertices.length) {
          for (var e3 = this.vertices[0].copy(), t3 = this.vertices[0].copy(), r3 = 0; r3 < this.vertices.length; r3++)
            e3.x = Math.max(e3.x, this.vertices[r3].x), t3.x = Math.min(t3.x, this.vertices[r3].x), e3.y = Math.max(e3.y, this.vertices[r3].y), t3.y = Math.min(t3.y, this.vertices[r3].y), e3.z = Math.max(e3.z, this.vertices[r3].z), t3.z = Math.min(t3.z, this.vertices[r3].z);
          for (var n3 = c.default.Vector.lerp(e3, t3, 0.5), o3 = c.default.Vector.sub(e3, t3), i2 = 200 / Math.max(Math.max(o3.x, o3.y), o3.z), a2 = 0; a2 < this.vertices.length; a2++)
            this.vertices[a2].sub(n3), this.vertices[a2].mult(i2);
        }
        return this;
      };
      var o2 = c.default.Geometry;
      r2.default = o2;
    }, { "../core/main": 264, "core-js/modules/es.string.sub": 192 }], 314: [function(e2, t2, r2) {
      e2("core-js/modules/es.array.iterator"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.typed-array.float32-array"), e2("core-js/modules/es.typed-array.copy-within"), e2("core-js/modules/es.typed-array.every"), e2("core-js/modules/es.typed-array.fill"), e2("core-js/modules/es.typed-array.filter"), e2("core-js/modules/es.typed-array.find"), e2("core-js/modules/es.typed-array.find-index"), e2("core-js/modules/es.typed-array.for-each"), e2("core-js/modules/es.typed-array.includes"), e2("core-js/modules/es.typed-array.index-of"), e2("core-js/modules/es.typed-array.iterator"), e2("core-js/modules/es.typed-array.join"), e2("core-js/modules/es.typed-array.last-index-of"), e2("core-js/modules/es.typed-array.map"), e2("core-js/modules/es.typed-array.reduce"), e2("core-js/modules/es.typed-array.reduce-right"), e2("core-js/modules/es.typed-array.reverse"), e2("core-js/modules/es.typed-array.set"), e2("core-js/modules/es.typed-array.slice"), e2("core-js/modules/es.typed-array.some"), e2("core-js/modules/es.typed-array.sort"), e2("core-js/modules/es.typed-array.subarray"), e2("core-js/modules/es.typed-array.to-locale-string"), e2("core-js/modules/es.typed-array.to-string"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, L = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      var o2 = Array, P2 = function(e3) {
        return e3 instanceof Array;
      };
      typeof Float32Array != "undefined" && (o2 = Float32Array, P2 = function(e3) {
        return e3 instanceof Array || e3 instanceof Float32Array;
      }), L.default.Matrix = function() {
        for (var e3 = new Array(arguments.length), t3 = 0; t3 < e3.length; ++t3)
          e3[t3] = arguments[t3];
        return e3.length && e3[e3.length - 1] instanceof L.default && (this.p5 = e3[e3.length - 1]), e3[0] === "mat3" ? this.mat3 = Array.isArray(e3[1]) ? e3[1] : new o2([1, 0, 0, 0, 1, 0, 0, 0, 1]) : this.mat4 = Array.isArray(e3[0]) ? e3[0] : new o2([1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1]), this;
      }, L.default.Matrix.prototype.set = function(e3) {
        return e3 instanceof L.default.Matrix ? this.mat4 = e3.mat4 : P2(e3) ? this.mat4 = e3 : arguments.length === 16 && (this.mat4[0] = e3, this.mat4[1] = arguments[1], this.mat4[2] = arguments[2], this.mat4[3] = arguments[3], this.mat4[4] = arguments[4], this.mat4[5] = arguments[5], this.mat4[6] = arguments[6], this.mat4[7] = arguments[7], this.mat4[8] = arguments[8], this.mat4[9] = arguments[9], this.mat4[10] = arguments[10], this.mat4[11] = arguments[11], this.mat4[12] = arguments[12], this.mat4[13] = arguments[13], this.mat4[14] = arguments[14], this.mat4[15] = arguments[15]), this;
      }, L.default.Matrix.prototype.get = function() {
        return new L.default.Matrix(this.mat4, this.p5);
      }, L.default.Matrix.prototype.copy = function() {
        var e3 = new L.default.Matrix(this.p5);
        return e3.mat4[0] = this.mat4[0], e3.mat4[1] = this.mat4[1], e3.mat4[2] = this.mat4[2], e3.mat4[3] = this.mat4[3], e3.mat4[4] = this.mat4[4], e3.mat4[5] = this.mat4[5], e3.mat4[6] = this.mat4[6], e3.mat4[7] = this.mat4[7], e3.mat4[8] = this.mat4[8], e3.mat4[9] = this.mat4[9], e3.mat4[10] = this.mat4[10], e3.mat4[11] = this.mat4[11], e3.mat4[12] = this.mat4[12], e3.mat4[13] = this.mat4[13], e3.mat4[14] = this.mat4[14], e3.mat4[15] = this.mat4[15], e3;
      }, L.default.Matrix.identity = function(e3) {
        return new L.default.Matrix(e3);
      }, L.default.Matrix.prototype.transpose = function(e3) {
        var t3, r3, n3, o3, i3, a2;
        return e3 instanceof L.default.Matrix ? (t3 = e3.mat4[1], r3 = e3.mat4[2], n3 = e3.mat4[3], o3 = e3.mat4[6], i3 = e3.mat4[7], a2 = e3.mat4[11], this.mat4[0] = e3.mat4[0], this.mat4[1] = e3.mat4[4], this.mat4[2] = e3.mat4[8], this.mat4[3] = e3.mat4[12], this.mat4[4] = t3, this.mat4[5] = e3.mat4[5], this.mat4[6] = e3.mat4[9], this.mat4[7] = e3.mat4[13], this.mat4[8] = r3, this.mat4[9] = o3, this.mat4[10] = e3.mat4[10], this.mat4[11] = e3.mat4[14], this.mat4[12] = n3, this.mat4[13] = i3, this.mat4[14] = a2, this.mat4[15] = e3.mat4[15]) : P2(e3) && (t3 = e3[1], r3 = e3[2], n3 = e3[3], o3 = e3[6], i3 = e3[7], a2 = e3[11], this.mat4[0] = e3[0], this.mat4[1] = e3[4], this.mat4[2] = e3[8], this.mat4[3] = e3[12], this.mat4[4] = t3, this.mat4[5] = e3[5], this.mat4[6] = e3[9], this.mat4[7] = e3[13], this.mat4[8] = r3, this.mat4[9] = o3, this.mat4[10] = e3[10], this.mat4[11] = e3[14], this.mat4[12] = n3, this.mat4[13] = i3, this.mat4[14] = a2, this.mat4[15] = e3[15]), this;
      }, L.default.Matrix.prototype.invert = function(e3) {
        var t3, r3, n3, o3, i3, a2, s, l2, u2, c, d, f, h2, p2, y, m2;
        e3 instanceof L.default.Matrix ? (t3 = e3.mat4[0], r3 = e3.mat4[1], n3 = e3.mat4[2], o3 = e3.mat4[3], i3 = e3.mat4[4], a2 = e3.mat4[5], s = e3.mat4[6], l2 = e3.mat4[7], u2 = e3.mat4[8], c = e3.mat4[9], d = e3.mat4[10], f = e3.mat4[11], h2 = e3.mat4[12], p2 = e3.mat4[13], y = e3.mat4[14], m2 = e3.mat4[15]) : P2(e3) && (t3 = e3[0], r3 = e3[1], n3 = e3[2], o3 = e3[3], i3 = e3[4], a2 = e3[5], s = e3[6], l2 = e3[7], u2 = e3[8], c = e3[9], d = e3[10], f = e3[11], h2 = e3[12], p2 = e3[13], y = e3[14], m2 = e3[15]);
        var g = t3 * a2 - r3 * i3, v = t3 * s - n3 * i3, b2 = t3 * l2 - o3 * i3, _ = r3 * s - n3 * a2, x = r3 * l2 - o3 * a2, w = n3 * l2 - o3 * s, j = u2 * p2 - c * h2, S2 = u2 * y - d * h2, M = u2 * m2 - f * h2, E = c * y - d * p2, T2 = c * m2 - f * p2, O2 = d * m2 - f * y, C = g * O2 - v * T2 + b2 * E + _ * M - x * S2 + w * j;
        return C ? (C = 1 / C, this.mat4[0] = (a2 * O2 - s * T2 + l2 * E) * C, this.mat4[1] = (n3 * T2 - r3 * O2 - o3 * E) * C, this.mat4[2] = (p2 * w - y * x + m2 * _) * C, this.mat4[3] = (d * x - c * w - f * _) * C, this.mat4[4] = (s * M - i3 * O2 - l2 * S2) * C, this.mat4[5] = (t3 * O2 - n3 * M + o3 * S2) * C, this.mat4[6] = (y * b2 - h2 * w - m2 * v) * C, this.mat4[7] = (u2 * w - d * b2 + f * v) * C, this.mat4[8] = (i3 * T2 - a2 * M + l2 * j) * C, this.mat4[9] = (r3 * M - t3 * T2 - o3 * j) * C, this.mat4[10] = (h2 * x - p2 * b2 + m2 * g) * C, this.mat4[11] = (c * b2 - u2 * x - f * g) * C, this.mat4[12] = (a2 * S2 - i3 * E - s * j) * C, this.mat4[13] = (t3 * E - r3 * S2 + n3 * j) * C, this.mat4[14] = (p2 * v - h2 * _ - y * g) * C, this.mat4[15] = (u2 * _ - c * v + d * g) * C, this) : null;
      }, L.default.Matrix.prototype.invert3x3 = function() {
        var e3 = this.mat3[0], t3 = this.mat3[1], r3 = this.mat3[2], n3 = this.mat3[3], o3 = this.mat3[4], i3 = this.mat3[5], a2 = this.mat3[6], s = this.mat3[7], l2 = this.mat3[8], u2 = l2 * o3 - i3 * s, c = -l2 * n3 + i3 * a2, d = s * n3 - o3 * a2, f = e3 * u2 + t3 * c + r3 * d;
        return f ? (f = 1 / f, this.mat3[0] = u2 * f, this.mat3[1] = (-l2 * t3 + r3 * s) * f, this.mat3[2] = (i3 * t3 - r3 * o3) * f, this.mat3[3] = c * f, this.mat3[4] = (l2 * e3 - r3 * a2) * f, this.mat3[5] = (-i3 * e3 + r3 * n3) * f, this.mat3[6] = d * f, this.mat3[7] = (-s * e3 + t3 * a2) * f, this.mat3[8] = (o3 * e3 - t3 * n3) * f, this) : null;
      }, L.default.Matrix.prototype.transpose3x3 = function(e3) {
        var t3 = e3[1], r3 = e3[2], n3 = e3[5];
        return this.mat3[1] = e3[3], this.mat3[2] = e3[6], this.mat3[3] = t3, this.mat3[5] = e3[7], this.mat3[6] = r3, this.mat3[7] = n3, this;
      }, L.default.Matrix.prototype.inverseTranspose = function(e3) {
        this.mat3 === void 0 ? console.error("sorry, this function only works with mat3") : (this.mat3[0] = e3.mat4[0], this.mat3[1] = e3.mat4[1], this.mat3[2] = e3.mat4[2], this.mat3[3] = e3.mat4[4], this.mat3[4] = e3.mat4[5], this.mat3[5] = e3.mat4[6], this.mat3[6] = e3.mat4[8], this.mat3[7] = e3.mat4[9], this.mat3[8] = e3.mat4[10]);
        var t3 = this.invert3x3();
        if (t3)
          t3.transpose3x3(this.mat3);
        else
          for (var r3 = 0; r3 < 9; r3++)
            this.mat3[r3] = 0;
        return this;
      }, L.default.Matrix.prototype.determinant = function() {
        var e3 = this.mat4[0] * this.mat4[5] - this.mat4[1] * this.mat4[4], t3 = this.mat4[0] * this.mat4[6] - this.mat4[2] * this.mat4[4], r3 = this.mat4[0] * this.mat4[7] - this.mat4[3] * this.mat4[4], n3 = this.mat4[1] * this.mat4[6] - this.mat4[2] * this.mat4[5], o3 = this.mat4[1] * this.mat4[7] - this.mat4[3] * this.mat4[5], i3 = this.mat4[2] * this.mat4[7] - this.mat4[3] * this.mat4[6], a2 = this.mat4[8] * this.mat4[13] - this.mat4[9] * this.mat4[12], s = this.mat4[8] * this.mat4[14] - this.mat4[10] * this.mat4[12], l2 = this.mat4[8] * this.mat4[15] - this.mat4[11] * this.mat4[12], u2 = this.mat4[9] * this.mat4[14] - this.mat4[10] * this.mat4[13], c = this.mat4[9] * this.mat4[15] - this.mat4[11] * this.mat4[13];
        return e3 * (this.mat4[10] * this.mat4[15] - this.mat4[11] * this.mat4[14]) - t3 * c + r3 * u2 + n3 * l2 - o3 * s + i3 * a2;
      }, L.default.Matrix.prototype.mult = function(e3) {
        var t3;
        if (e3 === this || e3 === this.mat4)
          t3 = this.copy().mat4;
        else if (e3 instanceof L.default.Matrix)
          t3 = e3.mat4;
        else if (P2(e3))
          t3 = e3;
        else {
          if (arguments.length !== 16)
            return;
          t3 = arguments;
        }
        var r3 = this.mat4[0], n3 = this.mat4[1], o3 = this.mat4[2], i3 = this.mat4[3];
        return this.mat4[0] = r3 * t3[0] + n3 * t3[4] + o3 * t3[8] + i3 * t3[12], this.mat4[1] = r3 * t3[1] + n3 * t3[5] + o3 * t3[9] + i3 * t3[13], this.mat4[2] = r3 * t3[2] + n3 * t3[6] + o3 * t3[10] + i3 * t3[14], this.mat4[3] = r3 * t3[3] + n3 * t3[7] + o3 * t3[11] + i3 * t3[15], r3 = this.mat4[4], n3 = this.mat4[5], o3 = this.mat4[6], i3 = this.mat4[7], this.mat4[4] = r3 * t3[0] + n3 * t3[4] + o3 * t3[8] + i3 * t3[12], this.mat4[5] = r3 * t3[1] + n3 * t3[5] + o3 * t3[9] + i3 * t3[13], this.mat4[6] = r3 * t3[2] + n3 * t3[6] + o3 * t3[10] + i3 * t3[14], this.mat4[7] = r3 * t3[3] + n3 * t3[7] + o3 * t3[11] + i3 * t3[15], r3 = this.mat4[8], n3 = this.mat4[9], o3 = this.mat4[10], i3 = this.mat4[11], this.mat4[8] = r3 * t3[0] + n3 * t3[4] + o3 * t3[8] + i3 * t3[12], this.mat4[9] = r3 * t3[1] + n3 * t3[5] + o3 * t3[9] + i3 * t3[13], this.mat4[10] = r3 * t3[2] + n3 * t3[6] + o3 * t3[10] + i3 * t3[14], this.mat4[11] = r3 * t3[3] + n3 * t3[7] + o3 * t3[11] + i3 * t3[15], r3 = this.mat4[12], n3 = this.mat4[13], o3 = this.mat4[14], i3 = this.mat4[15], this.mat4[12] = r3 * t3[0] + n3 * t3[4] + o3 * t3[8] + i3 * t3[12], this.mat4[13] = r3 * t3[1] + n3 * t3[5] + o3 * t3[9] + i3 * t3[13], this.mat4[14] = r3 * t3[2] + n3 * t3[6] + o3 * t3[10] + i3 * t3[14], this.mat4[15] = r3 * t3[3] + n3 * t3[7] + o3 * t3[11] + i3 * t3[15], this;
      }, L.default.Matrix.prototype.apply = function(e3) {
        var t3;
        if (e3 === this || e3 === this.mat4)
          t3 = this.copy().mat4;
        else if (e3 instanceof L.default.Matrix)
          t3 = e3.mat4;
        else if (P2(e3))
          t3 = e3;
        else {
          if (arguments.length !== 16)
            return;
          t3 = arguments;
        }
        var r3 = this.mat4, n3 = r3[0], o3 = r3[4], i3 = r3[8], a2 = r3[12];
        r3[0] = t3[0] * n3 + t3[1] * o3 + t3[2] * i3 + t3[3] * a2, r3[4] = t3[4] * n3 + t3[5] * o3 + t3[6] * i3 + t3[7] * a2, r3[8] = t3[8] * n3 + t3[9] * o3 + t3[10] * i3 + t3[11] * a2, r3[12] = t3[12] * n3 + t3[13] * o3 + t3[14] * i3 + t3[15] * a2;
        var s = r3[1], l2 = r3[5], u2 = r3[9], c = r3[13];
        r3[1] = t3[0] * s + t3[1] * l2 + t3[2] * u2 + t3[3] * c, r3[5] = t3[4] * s + t3[5] * l2 + t3[6] * u2 + t3[7] * c, r3[9] = t3[8] * s + t3[9] * l2 + t3[10] * u2 + t3[11] * c, r3[13] = t3[12] * s + t3[13] * l2 + t3[14] * u2 + t3[15] * c;
        var d = r3[2], f = r3[6], h2 = r3[10], p2 = r3[14];
        r3[2] = t3[0] * d + t3[1] * f + t3[2] * h2 + t3[3] * p2, r3[6] = t3[4] * d + t3[5] * f + t3[6] * h2 + t3[7] * p2, r3[10] = t3[8] * d + t3[9] * f + t3[10] * h2 + t3[11] * p2, r3[14] = t3[12] * d + t3[13] * f + t3[14] * h2 + t3[15] * p2;
        var y = r3[3], m2 = r3[7], g = r3[11], v = r3[15];
        return r3[3] = t3[0] * y + t3[1] * m2 + t3[2] * g + t3[3] * v, r3[7] = t3[4] * y + t3[5] * m2 + t3[6] * g + t3[7] * v, r3[11] = t3[8] * y + t3[9] * m2 + t3[10] * g + t3[11] * v, r3[15] = t3[12] * y + t3[13] * m2 + t3[14] * g + t3[15] * v, this;
      }, L.default.Matrix.prototype.scale = function(e3, t3, r3) {
        return e3 instanceof L.default.Vector ? (t3 = e3.y, r3 = e3.z, e3 = e3.x) : e3 instanceof Array && (t3 = e3[1], r3 = e3[2], e3 = e3[0]), this.mat4[0] *= e3, this.mat4[1] *= e3, this.mat4[2] *= e3, this.mat4[3] *= e3, this.mat4[4] *= t3, this.mat4[5] *= t3, this.mat4[6] *= t3, this.mat4[7] *= t3, this.mat4[8] *= r3, this.mat4[9] *= r3, this.mat4[10] *= r3, this.mat4[11] *= r3, this;
      }, L.default.Matrix.prototype.rotate = function(e3, t3, r3, n3) {
        t3 instanceof L.default.Vector ? (r3 = t3.y, n3 = t3.z, t3 = t3.x) : t3 instanceof Array && (r3 = t3[1], n3 = t3[2], t3 = t3[0]);
        var o3 = Math.sqrt(t3 * t3 + r3 * r3 + n3 * n3);
        t3 *= 1 / o3, r3 *= 1 / o3, n3 *= 1 / o3;
        var i3 = this.mat4[0], a2 = this.mat4[1], s = this.mat4[2], l2 = this.mat4[3], u2 = this.mat4[4], c = this.mat4[5], d = this.mat4[6], f = this.mat4[7], h2 = this.mat4[8], p2 = this.mat4[9], y = this.mat4[10], m2 = this.mat4[11], g = Math.sin(e3), v = Math.cos(e3), b2 = 1 - v, _ = t3 * t3 * b2 + v, x = r3 * t3 * b2 + n3 * g, w = n3 * t3 * b2 - r3 * g, j = t3 * r3 * b2 - n3 * g, S2 = r3 * r3 * b2 + v, M = n3 * r3 * b2 + t3 * g, E = t3 * n3 * b2 + r3 * g, T2 = r3 * n3 * b2 - t3 * g, O2 = n3 * n3 * b2 + v;
        return this.mat4[0] = i3 * _ + u2 * x + h2 * w, this.mat4[1] = a2 * _ + c * x + p2 * w, this.mat4[2] = s * _ + d * x + y * w, this.mat4[3] = l2 * _ + f * x + m2 * w, this.mat4[4] = i3 * j + u2 * S2 + h2 * M, this.mat4[5] = a2 * j + c * S2 + p2 * M, this.mat4[6] = s * j + d * S2 + y * M, this.mat4[7] = l2 * j + f * S2 + m2 * M, this.mat4[8] = i3 * E + u2 * T2 + h2 * O2, this.mat4[9] = a2 * E + c * T2 + p2 * O2, this.mat4[10] = s * E + d * T2 + y * O2, this.mat4[11] = l2 * E + f * T2 + m2 * O2, this;
      }, L.default.Matrix.prototype.translate = function(e3) {
        var t3 = e3[0], r3 = e3[1], n3 = e3[2] || 0;
        this.mat4[12] += this.mat4[0] * t3 + this.mat4[4] * r3 + this.mat4[8] * n3, this.mat4[13] += this.mat4[1] * t3 + this.mat4[5] * r3 + this.mat4[9] * n3, this.mat4[14] += this.mat4[2] * t3 + this.mat4[6] * r3 + this.mat4[10] * n3, this.mat4[15] += this.mat4[3] * t3 + this.mat4[7] * r3 + this.mat4[11] * n3;
      }, L.default.Matrix.prototype.rotateX = function(e3) {
        this.rotate(e3, 1, 0, 0);
      }, L.default.Matrix.prototype.rotateY = function(e3) {
        this.rotate(e3, 0, 1, 0);
      }, L.default.Matrix.prototype.rotateZ = function(e3) {
        this.rotate(e3, 0, 0, 1);
      }, L.default.Matrix.prototype.perspective = function(e3, t3, r3, n3) {
        var o3 = 1 / Math.tan(e3 / 2), i3 = 1 / (r3 - n3);
        return this.mat4[0] = o3 / t3, this.mat4[1] = 0, this.mat4[2] = 0, this.mat4[3] = 0, this.mat4[4] = 0, this.mat4[5] = o3, this.mat4[6] = 0, this.mat4[7] = 0, this.mat4[8] = 0, this.mat4[9] = 0, this.mat4[10] = (n3 + r3) * i3, this.mat4[11] = -1, this.mat4[12] = 0, this.mat4[13] = 0, this.mat4[14] = 2 * n3 * r3 * i3, this.mat4[15] = 0, this;
      }, L.default.Matrix.prototype.ortho = function(e3, t3, r3, n3, o3, i3) {
        var a2 = 1 / (e3 - t3), s = 1 / (r3 - n3), l2 = 1 / (o3 - i3);
        return this.mat4[0] = -2 * a2, this.mat4[1] = 0, this.mat4[2] = 0, this.mat4[3] = 0, this.mat4[4] = 0, this.mat4[5] = -2 * s, this.mat4[6] = 0, this.mat4[7] = 0, this.mat4[8] = 0, this.mat4[9] = 0, this.mat4[10] = 2 * l2, this.mat4[11] = 0, this.mat4[12] = (e3 + t3) * a2, this.mat4[13] = (n3 + r3) * s, this.mat4[14] = (i3 + o3) * l2, this.mat4[15] = 1, this;
      };
      var i2 = L.default.Matrix;
      r2.default = i2;
    }, { "../core/main": 264, "core-js/modules/es.array.iterator": 158, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.typed-array.copy-within": 197, "core-js/modules/es.typed-array.every": 198, "core-js/modules/es.typed-array.fill": 199, "core-js/modules/es.typed-array.filter": 200, "core-js/modules/es.typed-array.find": 202, "core-js/modules/es.typed-array.find-index": 201, "core-js/modules/es.typed-array.float32-array": 203, "core-js/modules/es.typed-array.for-each": 205, "core-js/modules/es.typed-array.includes": 206, "core-js/modules/es.typed-array.index-of": 207, "core-js/modules/es.typed-array.iterator": 210, "core-js/modules/es.typed-array.join": 211, "core-js/modules/es.typed-array.last-index-of": 212, "core-js/modules/es.typed-array.map": 213, "core-js/modules/es.typed-array.reduce": 215, "core-js/modules/es.typed-array.reduce-right": 214, "core-js/modules/es.typed-array.reverse": 216, "core-js/modules/es.typed-array.set": 217, "core-js/modules/es.typed-array.slice": 218, "core-js/modules/es.typed-array.some": 219, "core-js/modules/es.typed-array.sort": 220, "core-js/modules/es.typed-array.subarray": 221, "core-js/modules/es.typed-array.to-locale-string": 222, "core-js/modules/es.typed-array.to-string": 223 }], 315: [function(e2, t2, r2) {
      e2("core-js/modules/es.array.map"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, o2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      o2.default.RenderBuffer = function(e3, t3, r3, n3, o3, i3) {
        this.size = e3, this.src = t3, this.dst = r3, this.attr = n3, this._renderer = o3, this.map = i3;
      }, o2.default.RenderBuffer.prototype._prepareBuffer = function(e3, t3) {
        var r3, n3 = t3.attributes, o3 = this._renderer.GL;
        r3 = e3.model ? e3.model : e3;
        var i3 = n3[this.attr];
        if (i3) {
          var a2 = e3[this.dst], s = r3[this.src];
          if (0 < s.length) {
            var l2 = !a2;
            if (l2 && (e3[this.dst] = a2 = o3.createBuffer()), o3.bindBuffer(o3.ARRAY_BUFFER, a2), l2 || r3.dirtyFlags[this.src] !== false) {
              var u2 = this.map, c = u2 ? u2(s) : s;
              this._renderer._bindBuffer(a2, o3.ARRAY_BUFFER, c), r3.dirtyFlags[this.src] = false;
            }
            t3.enableAttrib(i3, this.size);
          }
        }
      };
      var i2 = o2.default.RenderBuffer;
      r2.default = i2;
    }, { "../core/main": 264, "core-js/modules/es.array.map": 161 }], 316: [function(e2, t2, r2) {
      function a2(e3) {
        return (a2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      e2("core-js/modules/es.symbol"), e2("core-js/modules/es.symbol.description"), e2("core-js/modules/es.symbol.iterator"), e2("core-js/modules/es.array.fill"), e2("core-js/modules/es.array.iterator"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.string.iterator"), e2("core-js/modules/es.typed-array.float32-array"), e2("core-js/modules/es.typed-array.copy-within"), e2("core-js/modules/es.typed-array.every"), e2("core-js/modules/es.typed-array.fill"), e2("core-js/modules/es.typed-array.filter"), e2("core-js/modules/es.typed-array.find"), e2("core-js/modules/es.typed-array.find-index"), e2("core-js/modules/es.typed-array.for-each"), e2("core-js/modules/es.typed-array.includes"), e2("core-js/modules/es.typed-array.index-of"), e2("core-js/modules/es.typed-array.iterator"), e2("core-js/modules/es.typed-array.join"), e2("core-js/modules/es.typed-array.last-index-of"), e2("core-js/modules/es.typed-array.map"), e2("core-js/modules/es.typed-array.reduce"), e2("core-js/modules/es.typed-array.reduce-right"), e2("core-js/modules/es.typed-array.reverse"), e2("core-js/modules/es.typed-array.set"), e2("core-js/modules/es.typed-array.slice"), e2("core-js/modules/es.typed-array.some"), e2("core-js/modules/es.typed-array.sort"), e2("core-js/modules/es.typed-array.subarray"), e2("core-js/modules/es.typed-array.to-locale-string"), e2("core-js/modules/es.typed-array.to-string"), e2("core-js/modules/web.dom-collections.iterator"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, s = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 }, l2 = function(e3) {
        if (e3 && e3.__esModule)
          return e3;
        if (e3 === null || a2(e3) !== "object" && typeof e3 != "function")
          return { default: e3 };
        var t3 = u2();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o3 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o3)) {
            var i2 = n3 ? Object.getOwnPropertyDescriptor(e3, o3) : null;
            i2 && (i2.get || i2.set) ? Object.defineProperty(r3, o3, i2) : r3[o3] = e3[o3];
          }
        r3.default = e3, t3 && t3.set(e3, r3);
        return r3;
      }(e2("../core/constants"));
      function u2() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return u2 = function() {
          return e3;
        }, e3;
      }
      e2("./p5.RenderBuffer"), s.default.RendererGL.prototype.beginShape = function(e3) {
        return this.immediateMode.shapeMode = e3 !== void 0 ? e3 : l2.TRIANGLE_FAN, this.immediateMode.geometry.reset(), this;
      }, s.default.RendererGL.prototype.vertex = function(e3, t3) {
        var r3, n3, o3;
        r3 = n3 = o3 = 0, arguments.length === 3 ? r3 = arguments[2] : arguments.length === 4 ? (n3 = arguments[2], o3 = arguments[3]) : arguments.length === 5 && (r3 = arguments[2], n3 = arguments[3], o3 = arguments[4]);
        var i2 = new s.default.Vector(e3, t3, r3);
        this.immediateMode.geometry.vertices.push(i2), this.immediateMode.geometry.vertexNormals.push(this._currentNormal);
        var a3 = this.curFillColor || [0.5, 0.5, 0.5, 1];
        return this.immediateMode.geometry.vertexColors.push(a3[0], a3[1], a3[2], a3[3]), this.textureMode === l2.IMAGE && (this._tex !== null ? 0 < this._tex.width && 0 < this._tex.height && (n3 /= this._tex.width, o3 /= this._tex.height) : this._tex === null && 4 <= arguments.length && console.warn("You must first call texture() before using vertex() with image based u and v coordinates")), this.immediateMode.geometry.uvs.push(n3, o3), this.immediateMode._bezierVertex[0] = e3, this.immediateMode._bezierVertex[1] = t3, this.immediateMode._bezierVertex[2] = r3, this.immediateMode._quadraticVertex[0] = e3, this.immediateMode._quadraticVertex[1] = t3, this.immediateMode._quadraticVertex[2] = r3, this;
      }, s.default.RendererGL.prototype.normal = function(e3, t3, r3) {
        return e3 instanceof s.default.Vector ? this._currentNormal = e3 : this._currentNormal = new s.default.Vector(e3, t3, r3), this;
      }, s.default.RendererGL.prototype.endShape = function(e3, t3, r3, n3, o3, i2) {
        return this.immediateMode.shapeMode === l2.POINTS ? this._drawPoints(this.immediateMode.geometry.vertices, this.immediateMode.buffers.point) : (this._processVertices.apply(this, arguments), this._doFill && 1 < this.immediateMode.geometry.vertices.length && this._drawImmediateFill(), this._doStroke && 1 < this.immediateMode.geometry.lineVertices.length && this._drawImmediateStroke(), this.isBezier = false, this.isQuadratic = false, this.isCurve = false, this.immediateMode._bezierVertex.length = 0, this.immediateMode._quadraticVertex.length = 0, this.immediateMode._curveVertex.length = 0), this;
      }, s.default.RendererGL.prototype._processVertices = function(e3) {
        if (this.immediateMode.geometry.vertices.length !== 0) {
          var t3 = this._doStroke && this.drawMode !== l2.TEXTURE, r3 = e3 === l2.CLOSE;
          t3 && (this.immediateMode.geometry.edges = this._calculateEdges(this.immediateMode.shapeMode, this.immediateMode.geometry.vertices, r3), this.immediateMode.geometry._edgesToVertices());
          var n3 = this.immediateMode.shapeMode === l2.TESS;
          (this.isBezier || this.isQuadratic || this.isCurve || n3) && this.immediateMode.shapeMode !== l2.LINES && this._tesselateShape();
        }
      }, s.default.RendererGL.prototype._calculateEdges = function(e3, t3, r3) {
        var n3 = [], o3 = 0;
        switch (e3) {
          case l2.TRIANGLE_STRIP:
            for (o3 = 0; o3 < t3.length - 2; o3++)
              n3.push([o3, o3 + 1]), n3.push([o3, o3 + 2]);
            n3.push([o3, o3 + 1]);
            break;
          case l2.TRIANGLES:
            for (o3 = 0; o3 < t3.length - 2; o3 += 3)
              n3.push([o3, o3 + 1]), n3.push([o3 + 1, o3 + 2]), n3.push([o3 + 2, o3]);
            break;
          case l2.LINES:
            for (o3 = 0; o3 < t3.length - 1; o3 += 2)
              n3.push([o3, o3 + 1]);
            break;
          default:
            for (o3 = 0; o3 < t3.length - 1; o3++)
              n3.push([o3, o3 + 1]);
        }
        return r3 && n3.push([t3.length - 1, 0]), n3;
      }, s.default.RendererGL.prototype._tesselateShape = function() {
        this.immediateMode.shapeMode = l2.TRIANGLES;
        var e3 = [new Float32Array(this._vToNArray(this.immediateMode.geometry.vertices))], t3 = this._triangulate(e3);
        this.immediateMode.geometry.vertices = [];
        for (var r3 = 0, n3 = t3.length; r3 < n3; r3 += 3)
          this.vertex(t3[r3], t3[r3 + 1], t3[r3 + 2]);
      }, s.default.RendererGL.prototype._drawImmediateFill = function() {
        var e3 = this.GL, t3 = this._getImmediateFillShader();
        this._setFillUniforms(t3);
        var r3 = true, n3 = false, o3 = void 0;
        try {
          for (var i2, a3 = this.immediateMode.buffers.fill[Symbol.iterator](); !(r3 = (i2 = a3.next()).done); r3 = true) {
            i2.value._prepareBuffer(this.immediateMode.geometry, t3);
          }
        } catch (e4) {
          n3 = true, o3 = e4;
        } finally {
          try {
            r3 || a3.return == null || a3.return();
          } finally {
            if (n3)
              throw o3;
          }
        }
        this.immediateMode.shapeMode !== l2.LINE_STRIP && this.immediateMode.shapeMode !== l2.LINES || (this.immediateMode.shapeMode = l2.TRIANGLE_FAN), this._applyColorBlend(this.curFillColor), e3.drawArrays(this.immediateMode.shapeMode, 0, this.immediateMode.geometry.vertices.length), t3.unbindShader();
      }, s.default.RendererGL.prototype._drawImmediateStroke = function() {
        var e3 = this.GL, t3 = this._getImmediateStrokeShader();
        this._setStrokeUniforms(t3);
        var r3 = true, n3 = false, o3 = void 0;
        try {
          for (var i2, a3 = this.immediateMode.buffers.stroke[Symbol.iterator](); !(r3 = (i2 = a3.next()).done); r3 = true) {
            i2.value._prepareBuffer(this.immediateMode.geometry, t3);
          }
        } catch (e4) {
          n3 = true, o3 = e4;
        } finally {
          try {
            r3 || a3.return == null || a3.return();
          } finally {
            if (n3)
              throw o3;
          }
        }
        this._applyColorBlend(this.curStrokeColor), e3.drawArrays(e3.TRIANGLES, 0, this.immediateMode.geometry.lineVertices.length), t3.unbindShader();
      };
      var o2 = s.default.RendererGL;
      r2.default = o2;
    }, { "../core/constants": 253, "../core/main": 264, "./p5.RenderBuffer": 315, "core-js/modules/es.array.fill": 151, "core-js/modules/es.array.iterator": 158, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.string.iterator": 186, "core-js/modules/es.symbol": 196, "core-js/modules/es.symbol.description": 194, "core-js/modules/es.symbol.iterator": 195, "core-js/modules/es.typed-array.copy-within": 197, "core-js/modules/es.typed-array.every": 198, "core-js/modules/es.typed-array.fill": 199, "core-js/modules/es.typed-array.filter": 200, "core-js/modules/es.typed-array.find": 202, "core-js/modules/es.typed-array.find-index": 201, "core-js/modules/es.typed-array.float32-array": 203, "core-js/modules/es.typed-array.for-each": 205, "core-js/modules/es.typed-array.includes": 206, "core-js/modules/es.typed-array.index-of": 207, "core-js/modules/es.typed-array.iterator": 210, "core-js/modules/es.typed-array.join": 211, "core-js/modules/es.typed-array.last-index-of": 212, "core-js/modules/es.typed-array.map": 213, "core-js/modules/es.typed-array.reduce": 215, "core-js/modules/es.typed-array.reduce-right": 214, "core-js/modules/es.typed-array.reverse": 216, "core-js/modules/es.typed-array.set": 217, "core-js/modules/es.typed-array.slice": 218, "core-js/modules/es.typed-array.some": 219, "core-js/modules/es.typed-array.sort": 220, "core-js/modules/es.typed-array.subarray": 221, "core-js/modules/es.typed-array.to-locale-string": 222, "core-js/modules/es.typed-array.to-string": 223, "core-js/modules/web.dom-collections.iterator": 229 }], 317: [function(e2, t2, r2) {
      e2("core-js/modules/es.symbol"), e2("core-js/modules/es.symbol.description"), e2("core-js/modules/es.symbol.iterator"), e2("core-js/modules/es.array.fill"), e2("core-js/modules/es.array.iterator"), e2("core-js/modules/es.array.some"), e2("core-js/modules/es.object.keys"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.string.iterator"), e2("core-js/modules/es.typed-array.float32-array"), e2("core-js/modules/es.typed-array.uint16-array"), e2("core-js/modules/es.typed-array.uint32-array"), e2("core-js/modules/es.typed-array.copy-within"), e2("core-js/modules/es.typed-array.every"), e2("core-js/modules/es.typed-array.fill"), e2("core-js/modules/es.typed-array.filter"), e2("core-js/modules/es.typed-array.find"), e2("core-js/modules/es.typed-array.find-index"), e2("core-js/modules/es.typed-array.for-each"), e2("core-js/modules/es.typed-array.includes"), e2("core-js/modules/es.typed-array.index-of"), e2("core-js/modules/es.typed-array.iterator"), e2("core-js/modules/es.typed-array.join"), e2("core-js/modules/es.typed-array.last-index-of"), e2("core-js/modules/es.typed-array.map"), e2("core-js/modules/es.typed-array.reduce"), e2("core-js/modules/es.typed-array.reduce-right"), e2("core-js/modules/es.typed-array.reverse"), e2("core-js/modules/es.typed-array.set"), e2("core-js/modules/es.typed-array.slice"), e2("core-js/modules/es.typed-array.some"), e2("core-js/modules/es.typed-array.sort"), e2("core-js/modules/es.typed-array.subarray"), e2("core-js/modules/es.typed-array.to-locale-string"), e2("core-js/modules/es.typed-array.to-string"), e2("core-js/modules/web.dom-collections.iterator"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, l2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      e2("./p5.RendererGL"), e2("./p5.RenderBuffer");
      var o2 = 0;
      l2.default.RendererGL.prototype._initBufferDefaults = function(e3) {
        if (this._freeBuffers(e3), 1e3 < ++o2) {
          var t3 = Object.keys(this.retainedMode.geometry)[0];
          delete this.retainedMode.geometry[t3], o2--;
        }
        return this.retainedMode.geometry[e3] = {};
      }, l2.default.RendererGL.prototype._freeBuffers = function(e3) {
        var s = this.retainedMode.geometry[e3];
        if (s) {
          delete this.retainedMode.geometry[e3], o2--;
          var l3 = this.GL;
          s.indexBuffer && l3.deleteBuffer(s.indexBuffer), t3(this.retainedMode.buffers.stroke), t3(this.retainedMode.buffers.fill);
        }
        function t3(e4) {
          var t4 = true, r3 = false, n3 = void 0;
          try {
            for (var o3, i3 = e4[Symbol.iterator](); !(t4 = (o3 = i3.next()).done); t4 = true) {
              var a2 = o3.value;
              s[a2.dst] && (l3.deleteBuffer(s[a2.dst]), s[a2.dst] = null);
            }
          } catch (e5) {
            r3 = true, n3 = e5;
          } finally {
            try {
              t4 || i3.return == null || i3.return();
            } finally {
              if (r3)
                throw n3;
            }
          }
        }
      }, l2.default.RendererGL.prototype.createBuffers = function(e3, t3) {
        var r3 = this.GL, n3 = this._initBufferDefaults(e3);
        n3.model = t3;
        var o3 = n3.indexBuffer;
        if (t3.faces.length) {
          o3 = o3 || (n3.indexBuffer = r3.createBuffer());
          var i3 = l2.default.RendererGL.prototype._flatten(t3.faces), a2 = i3.some(function(e4) {
            return 65535 < e4;
          }), s = a2 ? Uint32Array : Uint16Array;
          this._bindBuffer(o3, r3.ELEMENT_ARRAY_BUFFER, i3, s), n3.indexBufferType = a2 ? r3.UNSIGNED_INT : r3.UNSIGNED_SHORT, n3.vertexCount = 3 * t3.faces.length;
        } else
          o3 && (r3.deleteBuffer(o3), n3.indexBuffer = null), n3.vertexCount = t3.vertices ? t3.vertices.length : 0;
        return n3.lineVertexCount = t3.lineVertices ? t3.lineVertices.length : 0, n3;
      }, l2.default.RendererGL.prototype.drawBuffers = function(e3) {
        var t3 = this.GL, r3 = this.retainedMode.geometry[e3];
        if (this._doStroke && 0 < r3.lineVertexCount) {
          var n3 = this._getRetainedStrokeShader();
          this._setStrokeUniforms(n3);
          var o3 = true, i3 = false, a2 = void 0;
          try {
            for (var s, l3 = this.retainedMode.buffers.stroke[Symbol.iterator](); !(o3 = (s = l3.next()).done); o3 = true) {
              s.value._prepareBuffer(r3, n3);
            }
          } catch (e4) {
            i3 = true, a2 = e4;
          } finally {
            try {
              o3 || l3.return == null || l3.return();
            } finally {
              if (i3)
                throw a2;
            }
          }
          this._applyColorBlend(this.curStrokeColor), this._drawArrays(t3.TRIANGLES, e3), n3.unbindShader();
        }
        if (this._doFill) {
          var u2 = this._getRetainedFillShader();
          this._setFillUniforms(u2);
          var c = true, d = false, f = void 0;
          try {
            for (var h2, p2 = this.retainedMode.buffers.fill[Symbol.iterator](); !(c = (h2 = p2.next()).done); c = true) {
              h2.value._prepareBuffer(r3, u2);
            }
          } catch (e4) {
            d = true, f = e4;
          } finally {
            try {
              c || p2.return == null || p2.return();
            } finally {
              if (d)
                throw f;
            }
          }
          r3.indexBuffer && this._bindBuffer(r3.indexBuffer, t3.ELEMENT_ARRAY_BUFFER), this._applyColorBlend(this.curFillColor), this._drawElements(t3.TRIANGLES, e3), u2.unbindShader();
        }
        return this;
      }, l2.default.RendererGL.prototype.drawBuffersScaled = function(e3, t3, r3, n3) {
        var o3 = this.uMVMatrix.copy();
        try {
          this.uMVMatrix.scale(t3, r3, n3), this.drawBuffers(e3);
        } finally {
          this.uMVMatrix = o3;
        }
      }, l2.default.RendererGL.prototype._drawArrays = function(e3, t3) {
        return this.GL.drawArrays(e3, 0, this.retainedMode.geometry[t3].lineVertexCount), this;
      }, l2.default.RendererGL.prototype._drawElements = function(e3, t3) {
        var r3 = this.retainedMode.geometry[t3], n3 = this.GL;
        if (r3.indexBuffer) {
          if (r3.indexBufferType === n3.UNSIGNED_INT && !n3.getExtension("OES_element_index_uint"))
            throw new Error("Unable to render a 3d model with > 65535 triangles. Your web browser does not support the WebGL Extension OES_element_index_uint.");
          n3.drawElements(n3.TRIANGLES, r3.vertexCount, r3.indexBufferType, 0);
        } else
          n3.drawArrays(e3 || n3.TRIANGLES, 0, r3.vertexCount);
      }, l2.default.RendererGL.prototype._drawPoints = function(e3, t3) {
        var r3 = this.GL, n3 = this._getImmediatePointShader();
        this._setPointUniforms(n3), this._bindBuffer(t3, r3.ARRAY_BUFFER, this._vToNArray(e3), Float32Array, r3.STATIC_DRAW), n3.enableAttrib(n3.attributes.aPosition, 3), r3.drawArrays(r3.Points, 0, e3.length), n3.unbindShader();
      };
      var i2 = l2.default.RendererGL;
      r2.default = i2;
    }, { "../core/main": 264, "./p5.RenderBuffer": 315, "./p5.RendererGL": 318, "core-js/modules/es.array.fill": 151, "core-js/modules/es.array.iterator": 158, "core-js/modules/es.array.some": 163, "core-js/modules/es.object.keys": 176, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.string.iterator": 186, "core-js/modules/es.symbol": 196, "core-js/modules/es.symbol.description": 194, "core-js/modules/es.symbol.iterator": 195, "core-js/modules/es.typed-array.copy-within": 197, "core-js/modules/es.typed-array.every": 198, "core-js/modules/es.typed-array.fill": 199, "core-js/modules/es.typed-array.filter": 200, "core-js/modules/es.typed-array.find": 202, "core-js/modules/es.typed-array.find-index": 201, "core-js/modules/es.typed-array.float32-array": 203, "core-js/modules/es.typed-array.for-each": 205, "core-js/modules/es.typed-array.includes": 206, "core-js/modules/es.typed-array.index-of": 207, "core-js/modules/es.typed-array.iterator": 210, "core-js/modules/es.typed-array.join": 211, "core-js/modules/es.typed-array.last-index-of": 212, "core-js/modules/es.typed-array.map": 213, "core-js/modules/es.typed-array.reduce": 215, "core-js/modules/es.typed-array.reduce-right": 214, "core-js/modules/es.typed-array.reverse": 216, "core-js/modules/es.typed-array.set": 217, "core-js/modules/es.typed-array.slice": 218, "core-js/modules/es.typed-array.some": 219, "core-js/modules/es.typed-array.sort": 220, "core-js/modules/es.typed-array.subarray": 221, "core-js/modules/es.typed-array.to-locale-string": 222, "core-js/modules/es.typed-array.to-string": 223, "core-js/modules/es.typed-array.uint16-array": 224, "core-js/modules/es.typed-array.uint32-array": 225, "core-js/modules/web.dom-collections.iterator": 229 }], 318: [function(e2, t2, r2) {
      function a2(e3) {
        return (a2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      e2("core-js/modules/es.symbol"), e2("core-js/modules/es.symbol.description"), e2("core-js/modules/es.symbol.iterator"), e2("core-js/modules/es.array.concat"), e2("core-js/modules/es.array.fill"), e2("core-js/modules/es.array.filter"), e2("core-js/modules/es.array.from"), e2("core-js/modules/es.array.includes"), e2("core-js/modules/es.array.iterator"), e2("core-js/modules/es.array.slice"), e2("core-js/modules/es.object.assign"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.regexp.to-string"), e2("core-js/modules/es.string.includes"), e2("core-js/modules/es.string.iterator"), e2("core-js/modules/es.typed-array.float32-array"), e2("core-js/modules/es.typed-array.float64-array"), e2("core-js/modules/es.typed-array.int16-array"), e2("core-js/modules/es.typed-array.uint8-array"), e2("core-js/modules/es.typed-array.uint16-array"), e2("core-js/modules/es.typed-array.uint32-array"), e2("core-js/modules/es.typed-array.copy-within"), e2("core-js/modules/es.typed-array.every"), e2("core-js/modules/es.typed-array.fill"), e2("core-js/modules/es.typed-array.filter"), e2("core-js/modules/es.typed-array.find"), e2("core-js/modules/es.typed-array.find-index"), e2("core-js/modules/es.typed-array.for-each"), e2("core-js/modules/es.typed-array.includes"), e2("core-js/modules/es.typed-array.index-of"), e2("core-js/modules/es.typed-array.iterator"), e2("core-js/modules/es.typed-array.join"), e2("core-js/modules/es.typed-array.last-index-of"), e2("core-js/modules/es.typed-array.map"), e2("core-js/modules/es.typed-array.reduce"), e2("core-js/modules/es.typed-array.reduce-right"), e2("core-js/modules/es.typed-array.reverse"), e2("core-js/modules/es.typed-array.set"), e2("core-js/modules/es.typed-array.slice"), e2("core-js/modules/es.typed-array.some"), e2("core-js/modules/es.typed-array.sort"), e2("core-js/modules/es.typed-array.subarray"), e2("core-js/modules/es.typed-array.to-locale-string"), e2("core-js/modules/es.typed-array.to-string"), e2("core-js/modules/web.dom-collections.iterator"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var u2 = o2(e2("../core/main")), i2 = function(e3) {
        if (e3 && e3.__esModule)
          return e3;
        if (e3 === null || a2(e3) !== "object" && typeof e3 != "function")
          return { default: e3 };
        var t3 = s();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o3 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o3)) {
            var i3 = n3 ? Object.getOwnPropertyDescriptor(e3, o3) : null;
            i3 && (i3.get || i3.set) ? Object.defineProperty(r3, o3, i3) : r3[o3] = e3[o3];
          }
        r3.default = e3, t3 && t3.set(e3, r3);
        return r3;
      }(e2("../core/constants")), n2 = o2(e2("libtess"));
      e2("./p5.Shader"), e2("./p5.Camera"), e2("../core/p5.Renderer"), e2("./p5.Matrix");
      e2("path");
      function s() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return s = function() {
          return e3;
        }, e3;
      }
      function o2(e3) {
        return e3 && e3.__esModule ? e3 : { default: e3 };
      }
      function l2(e3) {
        return function(e4) {
          if (Array.isArray(e4)) {
            for (var t3 = 0, r3 = new Array(e4.length); t3 < e4.length; t3++)
              r3[t3] = e4[t3];
            return r3;
          }
        }(e3) || function(e4) {
          if (Symbol.iterator in Object(e4) || Object.prototype.toString.call(e4) === "[object Arguments]")
            return Array.from(e4);
        }(e3) || function() {
          throw new TypeError("Invalid attempt to spread non-iterable instance");
        }();
      }
      var c = "precision highp float;\nprecision highp int;\n\nuniform mat4 uViewMatrix;\n\nuniform bool uUseLighting;\n\nuniform int uAmbientLightCount;\nuniform vec3 uAmbientColor[5];\n\nuniform int uDirectionalLightCount;\nuniform vec3 uLightingDirection[5];\nuniform vec3 uDirectionalDiffuseColors[5];\nuniform vec3 uDirectionalSpecularColors[5];\n\nuniform int uPointLightCount;\nuniform vec3 uPointLightLocation[5];\nuniform vec3 uPointLightDiffuseColors[5];	\nuniform vec3 uPointLightSpecularColors[5];\n\nuniform int uSpotLightCount;\nuniform float uSpotLightAngle[5];\nuniform float uSpotLightConc[5];\nuniform vec3 uSpotLightDiffuseColors[5];\nuniform vec3 uSpotLightSpecularColors[5];\nuniform vec3 uSpotLightLocation[5];\nuniform vec3 uSpotLightDirection[5];\n\nuniform bool uSpecular;\nuniform float uShininess;\n\nuniform float uConstantAttenuation;\nuniform float uLinearAttenuation;\nuniform float uQuadraticAttenuation;\n\nconst float specularFactor = 2.0;\nconst float diffuseFactor = 0.73;\n\nstruct LightResult {\n  float specular;\n  float diffuse;\n};\n\nfloat _phongSpecular(\n  vec3 lightDirection,\n  vec3 viewDirection,\n  vec3 surfaceNormal,\n  float shininess) {\n\n  vec3 R = reflect(lightDirection, surfaceNormal);\n  return pow(max(0.0, dot(R, viewDirection)), shininess);\n}\n\nfloat _lambertDiffuse(vec3 lightDirection, vec3 surfaceNormal) {\n  return max(0.0, dot(-lightDirection, surfaceNormal));\n}\n\nLightResult _light(vec3 viewDirection, vec3 normal, vec3 lightVector) {\n\n  vec3 lightDir = normalize(lightVector);\n\n  //compute our diffuse & specular terms\n  LightResult lr;\n  if (uSpecular)\n    lr.specular = _phongSpecular(lightDir, viewDirection, normal, uShininess);\n  lr.diffuse = _lambertDiffuse(lightDir, normal);\n  return lr;\n}\n\nvoid totalLight(\n  vec3 modelPosition,\n  vec3 normal,\n  out vec3 totalDiffuse,\n  out vec3 totalSpecular\n) {\n\n  totalSpecular = vec3(0.0);\n\n  if (!uUseLighting) {\n    totalDiffuse = vec3(1.0);\n    return;\n  }\n\n  totalDiffuse = vec3(0.0);\n\n  vec3 viewDirection = normalize(-modelPosition);\n\n  for (int j = 0; j < 5; j++) {\n    if (j < uDirectionalLightCount) {\n      vec3 lightVector = (uViewMatrix * vec4(uLightingDirection[j], 0.0)).xyz;\n      vec3 lightColor = uDirectionalDiffuseColors[j];\n      vec3 specularColor = uDirectionalSpecularColors[j];\n      LightResult result = _light(viewDirection, normal, lightVector);\n      totalDiffuse += result.diffuse * lightColor;\n      totalSpecular += result.specular * lightColor * specularColor;\n    }\n\n    if (j < uPointLightCount) {\n      vec3 lightPosition = (uViewMatrix * vec4(uPointLightLocation[j], 1.0)).xyz;\n      vec3 lightVector = modelPosition - lightPosition;\n    \n      //calculate attenuation\n      float lightDistance = length(lightVector);\n      float lightFalloff = 1.0 / (uConstantAttenuation + lightDistance * uLinearAttenuation + (lightDistance * lightDistance) * uQuadraticAttenuation);\n      vec3 lightColor = lightFalloff * uPointLightDiffuseColors[j];\n      vec3 specularColor = lightFalloff * uPointLightSpecularColors[j];\n\n      LightResult result = _light(viewDirection, normal, lightVector);\n      totalDiffuse += result.diffuse * lightColor;\n      totalSpecular += result.specular * lightColor * specularColor;\n    }\n\n    if(j < uSpotLightCount) {\n      vec3 lightPosition = (uViewMatrix * vec4(uSpotLightLocation[j], 1.0)).xyz;\n      vec3 lightVector = modelPosition - lightPosition;\n    \n      float lightDistance = length(lightVector);\n      float lightFalloff = 1.0 / (uConstantAttenuation + lightDistance * uLinearAttenuation + (lightDistance * lightDistance) * uQuadraticAttenuation);\n\n      vec3 lightDirection = (uViewMatrix * vec4(uSpotLightDirection[j], 0.0)).xyz;\n      float spotDot = dot(normalize(lightVector), normalize(lightDirection));\n      float spotFalloff;\n      if(spotDot < uSpotLightAngle[j]) {\n        spotFalloff = 0.0;\n      }\n      else {\n        spotFalloff = pow(spotDot, uSpotLightConc[j]);\n      }\n      lightFalloff *= spotFalloff;\n\n      vec3 lightColor = uSpotLightDiffuseColors[j];\n      vec3 specularColor = uSpotLightSpecularColors[j];\n     \n      LightResult result = _light(viewDirection, normal, lightVector);\n      \n      totalDiffuse += result.diffuse * lightColor * lightFalloff;\n      totalSpecular += result.specular * lightColor * specularColor * lightFalloff;\n    }\n  }\n\n  totalDiffuse *= diffuseFactor;\n  totalSpecular *= specularFactor;\n}\n", d = { immediateVert: "attribute vec3 aPosition;\nattribute vec4 aVertexColor;\n\nuniform mat4 uModelViewMatrix;\nuniform mat4 uProjectionMatrix;\nuniform float uResolution;\nuniform float uPointSize;\n\nvarying vec4 vColor;\nvoid main(void) {\n  vec4 positionVec4 = vec4(aPosition, 1.0);\n  gl_Position = uProjectionMatrix * uModelViewMatrix * positionVec4;\n  vColor = aVertexColor;\n  gl_PointSize = uPointSize;\n}\n", vertexColorVert: "attribute vec3 aPosition;\nattribute vec4 aVertexColor;\n\nuniform mat4 uModelViewMatrix;\nuniform mat4 uProjectionMatrix;\n\nvarying vec4 vColor;\n\nvoid main(void) {\n  vec4 positionVec4 = vec4(aPosition, 1.0);\n  gl_Position = uProjectionMatrix * uModelViewMatrix * positionVec4;\n  vColor = aVertexColor;\n}\n", vertexColorFrag: "precision mediump float;\nvarying vec4 vColor;\nvoid main(void) {\n  gl_FragColor = vColor;\n}", normalVert: "attribute vec3 aPosition;\nattribute vec3 aNormal;\nattribute vec2 aTexCoord;\n\nuniform mat4 uModelViewMatrix;\nuniform mat4 uProjectionMatrix;\nuniform mat3 uNormalMatrix;\n\nvarying vec3 vVertexNormal;\nvarying highp vec2 vVertTexCoord;\n\nvoid main(void) {\n  vec4 positionVec4 = vec4(aPosition, 1.0);\n  gl_Position = uProjectionMatrix * uModelViewMatrix * positionVec4;\n  vVertexNormal = normalize(vec3( uNormalMatrix * aNormal ));\n  vVertTexCoord = aTexCoord;\n}\n", normalFrag: "precision mediump float;\nvarying vec3 vVertexNormal;\nvoid main(void) {\n  gl_FragColor = vec4(vVertexNormal, 1.0);\n}", basicFrag: "precision mediump float;\nuniform vec4 uMaterialColor;\nvoid main(void) {\n  gl_FragColor = uMaterialColor;\n}", lightVert: c + "// include lighting.glgl\n\nattribute vec3 aPosition;\nattribute vec3 aNormal;\nattribute vec2 aTexCoord;\n\nuniform mat4 uModelViewMatrix;\nuniform mat4 uProjectionMatrix;\nuniform mat3 uNormalMatrix;\n\nvarying highp vec2 vVertTexCoord;\nvarying vec3 vDiffuseColor;\nvarying vec3 vSpecularColor;\n\nvoid main(void) {\n\n  vec4 viewModelPosition = uModelViewMatrix * vec4(aPosition, 1.0);\n  gl_Position = uProjectionMatrix * viewModelPosition;\n\n  vec3 vertexNormal = normalize(uNormalMatrix * aNormal);\n  vVertTexCoord = aTexCoord;\n\n  totalLight(viewModelPosition.xyz, vertexNormal, vDiffuseColor, vSpecularColor);\n\n  for (int i = 0; i < 8; i++) {\n    if (i < uAmbientLightCount) {\n      vDiffuseColor += uAmbientColor[i];\n    }\n  }\n}\n", lightTextureFrag: "precision highp float;\n\nuniform vec4 uMaterialColor;\nuniform vec4 uTint;\nuniform sampler2D uSampler;\nuniform bool isTexture;\nuniform bool uEmissive;\n\nvarying highp vec2 vVertTexCoord;\nvarying vec3 vDiffuseColor;\nvarying vec3 vSpecularColor;\n\nvoid main(void) {\n  if(uEmissive && !isTexture) {\n    gl_FragColor = uMaterialColor;\n  }\n  else {\n    gl_FragColor = isTexture ? texture2D(uSampler, vVertTexCoord) * (uTint / vec4(255, 255, 255, 255)) : uMaterialColor;\n    gl_FragColor.rgb = gl_FragColor.rgb * vDiffuseColor + vSpecularColor;\n  }\n}", phongVert: "precision highp float;\nprecision highp int;\n\nattribute vec3 aPosition;\nattribute vec3 aNormal;\nattribute vec2 aTexCoord;\n\nuniform vec3 uAmbientColor[5];\n\nuniform mat4 uModelViewMatrix;\nuniform mat4 uProjectionMatrix;\nuniform mat3 uNormalMatrix;\nuniform int uAmbientLightCount;\n\nvarying vec3 vNormal;\nvarying vec2 vTexCoord;\nvarying vec3 vViewPosition;\nvarying vec3 vAmbientColor;\n\nvoid main(void) {\n\n  vec4 viewModelPosition = uModelViewMatrix * vec4(aPosition, 1.0);\n\n  // Pass varyings to fragment shader\n  vViewPosition = viewModelPosition.xyz;\n  gl_Position = uProjectionMatrix * viewModelPosition;  \n\n  vNormal = uNormalMatrix * aNormal;\n  vTexCoord = aTexCoord;\n\n  // TODO: this should be a uniform\n  vAmbientColor = vec3(0.0);\n  for (int i = 0; i < 5; i++) {\n    if (i < uAmbientLightCount) {\n      vAmbientColor += uAmbientColor[i];\n    }\n  }\n}\n", phongFrag: c + "// include lighting.glsl\nprecision highp float;\nprecision highp int;\n\nuniform vec4 uMaterialColor;\nuniform vec4 uTint;\nuniform sampler2D uSampler;\nuniform bool isTexture;\nuniform bool uEmissive;\n\nvarying vec3 vNormal;\nvarying vec2 vTexCoord;\nvarying vec3 vViewPosition;\nvarying vec3 vAmbientColor;\n\nvoid main(void) {\n\n  vec3 diffuse;\n  vec3 specular;\n  totalLight(vViewPosition, normalize(vNormal), diffuse, specular);\n\n  if(uEmissive && !isTexture) {\n    gl_FragColor = uMaterialColor;\n  }\n  else {\n    gl_FragColor = isTexture ? texture2D(uSampler, vTexCoord) * (uTint / vec4(255, 255, 255, 255)) : uMaterialColor;\n    gl_FragColor.rgb = gl_FragColor.rgb * (diffuse + vAmbientColor) + specular;\n  }\n}", fontVert: "precision mediump float;\n\nattribute vec3 aPosition;\nattribute vec2 aTexCoord;\nuniform mat4 uModelViewMatrix;\nuniform mat4 uProjectionMatrix;\n\nuniform vec4 uGlyphRect;\nuniform float uGlyphOffset;\n\nvarying vec2 vTexCoord;\nvarying float w;\n\nvoid main() {\n  vec4 positionVec4 = vec4(aPosition, 1.0);\n\n  // scale by the size of the glyph's rectangle\n  positionVec4.xy *= uGlyphRect.zw - uGlyphRect.xy;\n\n  // move to the corner of the glyph\n  positionVec4.xy += uGlyphRect.xy;\n\n  // move to the letter's line offset\n  positionVec4.x += uGlyphOffset;\n  \n  gl_Position = uProjectionMatrix * uModelViewMatrix * positionVec4;\n  vTexCoord = aTexCoord;\n  w = gl_Position.w;\n}\n", fontFrag: "#extension GL_OES_standard_derivatives : enable\nprecision mediump float;\n\n#if 0\n  // simulate integer math using floats\n	#define int float\n	#define ivec2 vec2\n	#define INT(x) float(x)\n\n	int ifloor(float v) { return floor(v); }\n	ivec2 ifloor(vec2 v) { return floor(v); }\n\n#else\n  // use native integer math\n	precision highp int;\n	#define INT(x) x\n\n	int ifloor(float v) { return int(v); }\n	int ifloor(int v) { return v; }\n	ivec2 ifloor(vec2 v) { return ivec2(v); }\n\n#endif\n\nuniform sampler2D uSamplerStrokes;\nuniform sampler2D uSamplerRowStrokes;\nuniform sampler2D uSamplerRows;\nuniform sampler2D uSamplerColStrokes;\nuniform sampler2D uSamplerCols;\n\nuniform ivec2 uStrokeImageSize;\nuniform ivec2 uCellsImageSize;\nuniform ivec2 uGridImageSize;\n\nuniform ivec2 uGridOffset;\nuniform ivec2 uGridSize;\nuniform vec4 uMaterialColor;\n\nvarying vec2 vTexCoord;\n\n// some helper functions\nint round(float v) { return ifloor(v + 0.5); }\nivec2 round(vec2 v) { return ifloor(v + 0.5); }\nfloat saturate(float v) { return clamp(v, 0.0, 1.0); }\nvec2 saturate(vec2 v) { return clamp(v, 0.0, 1.0); }\n\nint mul(float v1, int v2) {\n  return ifloor(v1 * float(v2));\n}\n\nivec2 mul(vec2 v1, ivec2 v2) {\n  return ifloor(v1 * vec2(v2) + 0.5);\n}\n\n// unpack a 16-bit integer from a float vec2\nint getInt16(vec2 v) {\n  ivec2 iv = round(v * 255.0);\n  return iv.x * INT(128) + iv.y;\n}\n\nvec2 pixelScale;\nvec2 coverage = vec2(0.0);\nvec2 weight = vec2(0.5);\nconst float minDistance = 1.0/8192.0;\nconst float hardness = 1.05; // amount of antialias\n\n// the maximum number of curves in a glyph\nconst int N = INT(250);\n\n// retrieves an indexed pixel from a sampler\nvec4 getTexel(sampler2D sampler, int pos, ivec2 size) {\n  int width = size.x;\n  int y = ifloor(pos / width);\n  int x = pos - y * width;  // pos % width\n\n  return texture2D(sampler, (vec2(x, y) + 0.5) / vec2(size));\n}\n\nvoid calulateCrossings(vec2 p0, vec2 p1, vec2 p2, out vec2 C1, out vec2 C2) {\n\n  // get the coefficients of the quadratic in t\n  vec2 a = p0 - p1 * 2.0 + p2;\n  vec2 b = p0 - p1;\n  vec2 c = p0 - vTexCoord;\n\n  // found out which values of 't' it crosses the axes\n  vec2 surd = sqrt(max(vec2(0.0), b * b - a * c));\n  vec2 t1 = ((b - surd) / a).yx;\n  vec2 t2 = ((b + surd) / a).yx;\n\n  // approximate straight lines to avoid rounding errors\n  if (abs(a.y) < 0.001)\n    t1.x = t2.x = c.y / (2.0 * b.y);\n\n  if (abs(a.x) < 0.001)\n    t1.y = t2.y = c.x / (2.0 * b.x);\n\n  // plug into quadratic formula to find the corrdinates of the crossings\n  C1 = ((a * t1 - b * 2.0) * t1 + c) * pixelScale;\n  C2 = ((a * t2 - b * 2.0) * t2 + c) * pixelScale;\n}\n\nvoid coverageX(vec2 p0, vec2 p1, vec2 p2) {\n\n  vec2 C1, C2;\n  calulateCrossings(p0, p1, p2, C1, C2);\n\n  // determine on which side of the x-axis the points lie\n  bool y0 = p0.y > vTexCoord.y;\n  bool y1 = p1.y > vTexCoord.y;\n  bool y2 = p2.y > vTexCoord.y;\n\n  // could web be under the curve (after t1)?\n  if (y1 ? !y2 : y0) {\n    // add the coverage for t1\n    coverage.x += saturate(C1.x + 0.5);\n    // calculate the anti-aliasing for t1\n    weight.x = min(weight.x, abs(C1.x));\n  }\n\n  // are we outside the curve (after t2)?\n  if (y1 ? !y0 : y2) {\n    // subtract the coverage for t2\n    coverage.x -= saturate(C2.x + 0.5);\n    // calculate the anti-aliasing for t2\n    weight.x = min(weight.x, abs(C2.x));\n  }\n}\n\n// this is essentially the same as coverageX, but with the axes swapped\nvoid coverageY(vec2 p0, vec2 p1, vec2 p2) {\n\n  vec2 C1, C2;\n  calulateCrossings(p0, p1, p2, C1, C2);\n\n  bool x0 = p0.x > vTexCoord.x;\n  bool x1 = p1.x > vTexCoord.x;\n  bool x2 = p2.x > vTexCoord.x;\n\n  if (x1 ? !x2 : x0) {\n    coverage.y -= saturate(C1.y + 0.5);\n    weight.y = min(weight.y, abs(C1.y));\n  }\n\n  if (x1 ? !x0 : x2) {\n    coverage.y += saturate(C2.y + 0.5);\n    weight.y = min(weight.y, abs(C2.y));\n  }\n}\n\nvoid main() {\n\n  // calculate the pixel scale based on screen-coordinates\n  pixelScale = hardness / fwidth(vTexCoord);\n\n  // which grid cell is this pixel in?\n  ivec2 gridCoord = ifloor(vTexCoord * vec2(uGridSize));\n\n  // intersect curves in this row\n  {\n    // the index into the row info bitmap\n    int rowIndex = gridCoord.y + uGridOffset.y;\n    // fetch the info texel\n    vec4 rowInfo = getTexel(uSamplerRows, rowIndex, uGridImageSize);\n    // unpack the rowInfo\n    int rowStrokeIndex = getInt16(rowInfo.xy);\n    int rowStrokeCount = getInt16(rowInfo.zw);\n\n    for (int iRowStroke = INT(0); iRowStroke < N; iRowStroke++) {\n      if (iRowStroke >= rowStrokeCount)\n        break;\n\n      // each stroke is made up of 3 points: the start and control point\n      // and the start of the next curve.\n      // fetch the indices of this pair of strokes:\n      vec4 strokeIndices = getTexel(uSamplerRowStrokes, rowStrokeIndex++, uCellsImageSize);\n\n      // unpack the stroke index\n      int strokePos = getInt16(strokeIndices.xy);\n\n      // fetch the two strokes\n      vec4 stroke0 = getTexel(uSamplerStrokes, strokePos + INT(0), uStrokeImageSize);\n      vec4 stroke1 = getTexel(uSamplerStrokes, strokePos + INT(1), uStrokeImageSize);\n\n      // calculate the coverage\n      coverageX(stroke0.xy, stroke0.zw, stroke1.xy);\n    }\n  }\n\n  // intersect curves in this column\n  {\n    int colIndex = gridCoord.x + uGridOffset.x;\n    vec4 colInfo = getTexel(uSamplerCols, colIndex, uGridImageSize);\n    int colStrokeIndex = getInt16(colInfo.xy);\n    int colStrokeCount = getInt16(colInfo.zw);\n    \n    for (int iColStroke = INT(0); iColStroke < N; iColStroke++) {\n      if (iColStroke >= colStrokeCount)\n        break;\n\n      vec4 strokeIndices = getTexel(uSamplerColStrokes, colStrokeIndex++, uCellsImageSize);\n\n      int strokePos = getInt16(strokeIndices.xy);\n      vec4 stroke0 = getTexel(uSamplerStrokes, strokePos + INT(0), uStrokeImageSize);\n      vec4 stroke1 = getTexel(uSamplerStrokes, strokePos + INT(1), uStrokeImageSize);\n      coverageY(stroke0.xy, stroke0.zw, stroke1.xy);\n    }\n  }\n\n  weight = saturate(1.0 - weight * 2.0);\n  float distance = max(weight.x + weight.y, minDistance); // manhattan approx.\n  float antialias = abs(dot(coverage, weight) / distance);\n  float cover = min(abs(coverage.x), abs(coverage.y));\n  gl_FragColor = uMaterialColor;\n  gl_FragColor.a *= saturate(max(antialias, cover));\n}", lineVert: "/*\n  Part of the Processing project - http://processing.org\n  Copyright (c) 2012-15 The Processing Foundation\n  Copyright (c) 2004-12 Ben Fry and Casey Reas\n  Copyright (c) 2001-04 Massachusetts Institute of Technology\n  This library is free software; you can redistribute it and/or\n  modify it under the terms of the GNU Lesser General Public\n  License as published by the Free Software Foundation, version 2.1.\n  This library is distributed in the hope that it will be useful,\n  but WITHOUT ANY WARRANTY; without even the implied warranty of\n  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU\n  Lesser General Public License for more details.\n  You should have received a copy of the GNU Lesser General\n  Public License along with this library; if not, write to the\n  Free Software Foundation, Inc., 59 Temple Place, Suite 330,\n  Boston, MA  02111-1307  USA\n*/\n\n#define PROCESSING_LINE_SHADER\n\nuniform mat4 uModelViewMatrix;\nuniform mat4 uProjectionMatrix;\nuniform float uStrokeWeight;\n\nuniform vec4 uViewport;\nuniform int uPerspective;\n\nattribute vec4 aPosition;\nattribute vec4 aDirection;\n  \nvoid main() {\n  // using a scale <1 moves the lines towards the camera\n  // in order to prevent popping effects due to half of\n  // the line disappearing behind the geometry faces.\n  vec3 scale = vec3(0.9995);\n\n  vec4 posp = uModelViewMatrix * aPosition;\n  vec4 posq = uModelViewMatrix * (aPosition + vec4(aDirection.xyz, 0));\n\n  // Moving vertices slightly toward the camera\n  // to avoid depth-fighting with the fill triangles.\n  // Discussed here:\n  // http://www.opengl.org/discussion_boards/ubbthreads.php?ubb=showflat&Number=252848  \n  posp.xyz = posp.xyz * scale;\n  posq.xyz = posq.xyz * scale;\n\n  vec4 p = uProjectionMatrix * posp;\n  vec4 q = uProjectionMatrix * posq;\n\n  // formula to convert from clip space (range -1..1) to screen space (range 0..[width or height])\n  // screen_p = (p.xy/p.w + <1,1>) * 0.5 * uViewport.zw\n\n  // prevent division by W by transforming the tangent formula (div by 0 causes\n  // the line to disappear, see https://github.com/processing/processing/issues/5183)\n  // t = screen_q - screen_p\n  //\n  // tangent is normalized and we don't care which aDirection it points to (+-)\n  // t = +- normalize( screen_q - screen_p )\n  // t = +- normalize( (q.xy/q.w+<1,1>)*0.5*uViewport.zw - (p.xy/p.w+<1,1>)*0.5*uViewport.zw )\n  //\n  // extract common factor, <1,1> - <1,1> cancels out\n  // t = +- normalize( (q.xy/q.w - p.xy/p.w) * 0.5 * uViewport.zw )\n  //\n  // convert to common divisor\n  // t = +- normalize( ((q.xy*p.w - p.xy*q.w) / (p.w*q.w)) * 0.5 * uViewport.zw )\n  //\n  // remove the common scalar divisor/factor, not needed due to normalize and +-\n  // (keep uViewport - can't remove because it has different components for x and y\n  //  and corrects for aspect ratio, see https://github.com/processing/processing/issues/5181)\n  // t = +- normalize( (q.xy*p.w - p.xy*q.w) * uViewport.zw )\n\n  vec2 tangent = normalize((q.xy*p.w - p.xy*q.w) * uViewport.zw);\n\n  // flip tangent to normal (it's already normalized)\n  vec2 normal = vec2(-tangent.y, tangent.x);\n\n  float thickness = aDirection.w * uStrokeWeight;\n  vec2 offset = normal * thickness / 2.0;\n\n  vec2 curPerspScale;\n\n  if(uPerspective == 1) {\n    // Perspective ---\n    // convert from world to clip by multiplying with projection scaling factor\n    // to get the right thickness (see https://github.com/processing/processing/issues/5182)\n    // invert Y, projections in Processing invert Y\n    curPerspScale = (uProjectionMatrix * vec4(1, -1, 0, 0)).xy;\n  } else {\n    // No Perspective ---\n    // multiply by W (to cancel out division by W later in the pipeline) and\n    // convert from screen to clip (derived from clip to screen above)\n    curPerspScale = p.w / (0.5 * uViewport.zw);\n  }\n\n  gl_Position.xy = p.xy + offset.xy * curPerspScale;\n  gl_Position.zw = p.zw;\n}\n", lineFrag: "precision mediump float;\nprecision mediump int;\n\nuniform vec4 uMaterialColor;\n\nvoid main() {\n  gl_FragColor = uMaterialColor;\n}", pointVert: "attribute vec3 aPosition;\nuniform float uPointSize;\nvarying float vStrokeWeight;\nuniform mat4 uModelViewMatrix;\nuniform mat4 uProjectionMatrix;\nvoid main() {\n	vec4 positionVec4 =  vec4(aPosition, 1.0);\n	gl_Position = uProjectionMatrix * uModelViewMatrix * positionVec4;\n	gl_PointSize = uPointSize;\n	vStrokeWeight = uPointSize;\n}", pointFrag: "precision mediump float;\nprecision mediump int;\nuniform vec4 uMaterialColor;\nvarying float vStrokeWeight;\n\nvoid main(){\n	float mask = 0.0;\n\n	// make a circular mask using the gl_PointCoord (goes from 0 - 1 on a point)\n    // might be able to get a nicer edge on big strokeweights with smoothstep but slightly less performant\n\n	mask = step(0.98, length(gl_PointCoord * 2.0 - 1.0));\n\n	// if strokeWeight is 1 or less lets just draw a square\n	// this prevents weird artifacting from carving circles when our points are really small\n	// if strokeWeight is larger than 1, we just use it as is\n\n	mask = mix(0.0, mask, clamp(floor(vStrokeWeight - 0.5),0.0,1.0));\n\n	// throw away the borders of the mask\n    // otherwise we get weird alpha blending issues\n\n	if(mask > 0.98){\n      discard;\n  	}\n\n  	gl_FragColor = vec4(uMaterialColor.rgb * (1.0 - mask), uMaterialColor.a) ;\n}" };
      u2.default.RendererGL = function(e3, t3, r3, n3) {
        return u2.default.Renderer.call(this, e3, t3, r3), this._setAttributeDefaults(t3), this._initContext(), this.isP3D = true, this.GL = this.drawingContext, this._pInst._setProperty("drawingContext", this.drawingContext), this._isErasing = false, this._enableLighting = false, this.ambientLightColors = [], this.specularColors = [1, 1, 1], this.directionalLightDirections = [], this.directionalLightDiffuseColors = [], this.directionalLightSpecularColors = [], this.pointLightPositions = [], this.pointLightDiffuseColors = [], this.pointLightSpecularColors = [], this.spotLightPositions = [], this.spotLightDirections = [], this.spotLightDiffuseColors = [], this.spotLightSpecularColors = [], this.spotLightAngle = [], this.spotLightConc = [], this.drawMode = i2.FILL, this.curFillColor = this._cachedFillStyle = [1, 1, 1, 1], this.curStrokeColor = this._cachedStrokeStyle = [0, 0, 0, 1], this.curBlendMode = i2.BLEND, this._cachedBlendMode = void 0, this.blendExt = this.GL.getExtension("EXT_blend_minmax"), this._isBlending = false, this._useSpecularMaterial = false, this._useEmissiveMaterial = false, this._useNormalMaterial = false, this._useShininess = 1, this._tint = [255, 255, 255, 255], this.constantAttenuation = 1, this.linearAttenuation = 0, this.quadraticAttenuation = 0, this.uMVMatrix = new u2.default.Matrix(), this.uPMatrix = new u2.default.Matrix(), this.uNMatrix = new u2.default.Matrix("mat3"), this._currentNormal = new u2.default.Vector(0, 0, 1), this._curCamera = new u2.default.Camera(this), this._curCamera._computeCameraDefaultSettings(), this._curCamera._setDefaultCamera(), this._defaultLightShader = void 0, this._defaultImmediateModeShader = void 0, this._defaultNormalShader = void 0, this._defaultColorShader = void 0, this._defaultPointShader = void 0, this.userFillShader = void 0, this.userStrokeShader = void 0, this.userPointShader = void 0, this.retainedMode = { geometry: {}, buffers: { stroke: [new u2.default.RenderBuffer(3, "lineVertices", "lineVertexBuffer", "aPosition", this, this._flatten), new u2.default.RenderBuffer(4, "lineNormals", "lineNormalBuffer", "aDirection", this, this._flatten)], fill: [new u2.default.RenderBuffer(3, "vertices", "vertexBuffer", "aPosition", this, this._vToNArray), new u2.default.RenderBuffer(3, "vertexNormals", "normalBuffer", "aNormal", this, this._vToNArray), new u2.default.RenderBuffer(4, "vertexColors", "colorBuffer", "aVertexColor", this), new u2.default.RenderBuffer(3, "vertexAmbients", "ambientBuffer", "aAmbientColor", this), new u2.default.RenderBuffer(2, "uvs", "uvBuffer", "aTexCoord", this, this._flatten)], text: [new u2.default.RenderBuffer(3, "vertices", "vertexBuffer", "aPosition", this, this._vToNArray), new u2.default.RenderBuffer(2, "uvs", "uvBuffer", "aTexCoord", this, this._flatten)] } }, this.immediateMode = { geometry: new u2.default.Geometry(), shapeMode: i2.TRIANGLE_FAN, _bezierVertex: [], _quadraticVertex: [], _curveVertex: [], buffers: { fill: [new u2.default.RenderBuffer(3, "vertices", "vertexBuffer", "aPosition", this, this._vToNArray), new u2.default.RenderBuffer(3, "vertexNormals", "normalBuffer", "aNormal", this, this._vToNArray), new u2.default.RenderBuffer(4, "vertexColors", "colorBuffer", "aVertexColor", this), new u2.default.RenderBuffer(3, "vertexAmbients", "ambientBuffer", "aAmbientColor", this), new u2.default.RenderBuffer(2, "uvs", "uvBuffer", "aTexCoord", this, this._flatten)], stroke: [new u2.default.RenderBuffer(3, "lineVertices", "lineVertexBuffer", "aPosition", this, this._flatten), new u2.default.RenderBuffer(4, "lineNormals", "lineNormalBuffer", "aDirection", this, this._flatten)], point: this.GL.createBuffer() } }, this.pointSize = 5, this.curStrokeWeight = 1, this.textures = [], this.textureMode = i2.IMAGE, this.textureWrapX = i2.CLAMP, this.textureWrapY = i2.CLAMP, this._tex = null, this._curveTightness = 6, this._lookUpTableBezier = [], this._lookUpTableQuadratic = [], this._lutBezierDetail = 0, this._lutQuadraticDetail = 0, this._tessy = this._initTessy(), this.fontInfos = {}, this._curShader = void 0, this;
      }, u2.default.RendererGL.prototype = Object.create(u2.default.Renderer.prototype), u2.default.RendererGL.prototype._setAttributeDefaults = function(e3) {
        var t3 = { alpha: false, depth: true, stencil: true, antialias: navigator.userAgent.toLowerCase().includes("safari"), premultipliedAlpha: false, preserveDrawingBuffer: true, perPixelLighting: true };
        e3._glAttributes === null ? e3._glAttributes = t3 : e3._glAttributes = Object.assign(t3, e3._glAttributes);
      }, u2.default.RendererGL.prototype._initContext = function() {
        try {
          if (this.drawingContext = this.canvas.getContext("webgl", this._pInst._glAttributes) || this.canvas.getContext("experimental-webgl", this._pInst._glAttributes), this.drawingContext === null)
            throw new Error("Error creating webgl context");
          var e3 = this.drawingContext;
          e3.enable(e3.DEPTH_TEST), e3.depthFunc(e3.LEQUAL), e3.viewport(0, 0, e3.drawingBufferWidth, e3.drawingBufferHeight), this._viewport = this.drawingContext.getParameter(this.drawingContext.VIEWPORT);
        } catch (e4) {
          throw e4;
        }
      }, u2.default.RendererGL.prototype._resetContext = function(e3, t3) {
        var r3 = this.width, n3 = this.height, o3 = this.canvas.id, i3 = this._pInst instanceof u2.default.Graphics;
        if (i3) {
          var a3 = this._pInst;
          a3.canvas.parentNode.removeChild(a3.canvas), a3.canvas = document.createElement("canvas"), (a3._pInst._userNode || document.body).appendChild(a3.canvas), u2.default.Element.call(a3, a3.canvas, a3._pInst), a3.width = r3, a3.height = n3;
        } else {
          var s2 = this.canvas;
          s2 && s2.parentNode.removeChild(s2), (s2 = document.createElement("canvas")).id = o3, this._pInst._userNode ? this._pInst._userNode.appendChild(s2) : document.body.appendChild(s2), this._pInst.canvas = s2;
        }
        var l3 = new u2.default.RendererGL(this._pInst.canvas, this._pInst, !i3);
        this._pInst._setProperty("_renderer", l3), l3.resize(r3, n3), l3._applyDefaults(), i3 || this._pInst._elements.push(l3), typeof t3 == "function" && setTimeout(function() {
          t3.apply(window._renderer, e3);
        }, 0);
      }, u2.default.prototype.setAttributes = function(e3, t3) {
        if (this._glAttributes !== void 0) {
          var r3 = true;
          if (t3 !== void 0 ? (this._glAttributes === null && (this._glAttributes = {}), this._glAttributes[e3] !== t3 && (this._glAttributes[e3] = t3, r3 = false)) : e3 instanceof Object && this._glAttributes !== e3 && (this._glAttributes = e3, r3 = false), this._renderer.isP3D && !r3) {
            if (!this._setupDone) {
              for (var n3 in this._renderer.retainedMode.geometry)
                if (this._renderer.retainedMode.geometry.hasOwnProperty(n3))
                  return void console.error("Sorry, Could not set the attributes, you need to call setAttributes() before calling the other drawing methods in setup()");
            }
            this.push(), this._renderer._resetContext(), this.pop(), this._renderer._curCamera && (this._renderer._curCamera._renderer = this._renderer);
          }
        } else
          console.log("You are trying to use setAttributes on a p5.Graphics object that does not use a WEBGL renderer.");
      }, u2.default.RendererGL.prototype._update = function() {
        this.uMVMatrix.set(this._curCamera.cameraMatrix.mat4[0], this._curCamera.cameraMatrix.mat4[1], this._curCamera.cameraMatrix.mat4[2], this._curCamera.cameraMatrix.mat4[3], this._curCamera.cameraMatrix.mat4[4], this._curCamera.cameraMatrix.mat4[5], this._curCamera.cameraMatrix.mat4[6], this._curCamera.cameraMatrix.mat4[7], this._curCamera.cameraMatrix.mat4[8], this._curCamera.cameraMatrix.mat4[9], this._curCamera.cameraMatrix.mat4[10], this._curCamera.cameraMatrix.mat4[11], this._curCamera.cameraMatrix.mat4[12], this._curCamera.cameraMatrix.mat4[13], this._curCamera.cameraMatrix.mat4[14], this._curCamera.cameraMatrix.mat4[15]), this.ambientLightColors.length = 0, this.specularColors = [1, 1, 1], this.directionalLightDirections.length = 0, this.directionalLightDiffuseColors.length = 0, this.directionalLightSpecularColors.length = 0, this.pointLightPositions.length = 0, this.pointLightDiffuseColors.length = 0, this.pointLightSpecularColors.length = 0, this.spotLightPositions.length = 0, this.spotLightDirections.length = 0, this.spotLightDiffuseColors.length = 0, this.spotLightSpecularColors.length = 0, this.spotLightAngle.length = 0, this.spotLightConc.length = 0, this._enableLighting = false, this._tint = [255, 255, 255, 255], this.GL.clear(this.GL.DEPTH_BUFFER_BIT);
      }, u2.default.RendererGL.prototype.background = function() {
        var e3, t3 = (e3 = this._pInst).color.apply(e3, arguments), r3 = t3.levels[0] / 255, n3 = t3.levels[1] / 255, o3 = t3.levels[2] / 255, i3 = t3.levels[3] / 255;
        this.GL.clearColor(r3, n3, o3, i3), this.GL.clear(this.GL.COLOR_BUFFER_BIT);
      }, u2.default.RendererGL.prototype.fill = function(e3, t3, r3, n3) {
        var o3 = u2.default.prototype.color.apply(this._pInst, arguments);
        this.curFillColor = o3._array, this.drawMode = i2.FILL, this._useNormalMaterial = false, this._tex = null;
      }, u2.default.RendererGL.prototype.stroke = function(e3, t3, r3, n3) {
        arguments[3] = 255;
        var o3 = u2.default.prototype.color.apply(this._pInst, arguments);
        this.curStrokeColor = o3._array;
      }, u2.default.RendererGL.prototype.strokeCap = function(e3) {
        console.error("Sorry, strokeCap() is not yet implemented in WEBGL mode");
      }, u2.default.RendererGL.prototype.strokeJoin = function(e3) {
        console.error("Sorry, strokeJoin() is not yet implemented in WEBGL mode");
      }, u2.default.RendererGL.prototype.filter = function(e3) {
        console.error("filter() does not work in WEBGL mode");
      }, u2.default.RendererGL.prototype.blendMode = function(e3) {
        e3 === i2.DARKEST || e3 === i2.LIGHTEST || e3 === i2.ADD || e3 === i2.BLEND || e3 === i2.SUBTRACT || e3 === i2.SCREEN || e3 === i2.EXCLUSION || e3 === i2.REPLACE || e3 === i2.MULTIPLY || e3 === i2.REMOVE ? this.curBlendMode = e3 : e3 !== i2.BURN && e3 !== i2.OVERLAY && e3 !== i2.HARD_LIGHT && e3 !== i2.SOFT_LIGHT && e3 !== i2.DODGE || console.warn("BURN, OVERLAY, HARD_LIGHT, SOFT_LIGHT, and DODGE only work for blendMode in 2D mode.");
      }, u2.default.RendererGL.prototype.erase = function(e3, t3) {
        this._isErasing || (this._applyBlendMode(i2.REMOVE), this._isErasing = true, this._cachedFillStyle = this.curFillColor.slice(), this.curFillColor = [1, 1, 1, e3 / 255], this._cachedStrokeStyle = this.curStrokeColor.slice(), this.curStrokeColor = [1, 1, 1, t3 / 255]);
      }, u2.default.RendererGL.prototype.noErase = function() {
        this._isErasing && (this._isErasing = false, this.curFillColor = this._cachedFillStyle.slice(), this.curStrokeColor = this._cachedStrokeStyle.slice(), this.blendMode(this._cachedBlendMode));
      }, u2.default.RendererGL.prototype.strokeWeight = function(e3) {
        this.curStrokeWeight !== e3 && (this.pointSize = e3, this.curStrokeWeight = e3);
      }, u2.default.RendererGL.prototype._getPixel = function(e3, t3) {
        var r3;
        return r3 = new Uint8Array(4), this.drawingContext.readPixels(e3, t3, 1, 1, this.drawingContext.RGBA, this.drawingContext.UNSIGNED_BYTE, r3), [r3[0], r3[1], r3[2], r3[3]];
      }, u2.default.RendererGL.prototype.loadPixels = function() {
        var e3 = this._pixelsState;
        if (this._pInst._glAttributes.preserveDrawingBuffer === true) {
          var t3 = e3.pixels, r3 = this.GL.drawingBufferWidth * this.GL.drawingBufferHeight * 4;
          t3 instanceof Uint8Array && t3.length === r3 || (t3 = new Uint8Array(r3), this._pixelsState._setProperty("pixels", t3));
          var n3 = this._pInst._pixelDensity;
          this.GL.readPixels(0, 0, this.width * n3, this.height * n3, this.GL.RGBA, this.GL.UNSIGNED_BYTE, t3);
        } else
          console.log("loadPixels only works in WebGL when preserveDrawingBuffer is true.");
      }, u2.default.RendererGL.prototype.geometryInHash = function(e3) {
        return this.retainedMode.geometry[e3] !== void 0;
      }, u2.default.RendererGL.prototype.resize = function(e3, t3) {
        u2.default.Renderer.prototype.resize.call(this, e3, t3), this.GL.viewport(0, 0, this.GL.drawingBufferWidth, this.GL.drawingBufferHeight), this._viewport = this.GL.getParameter(this.GL.VIEWPORT), this._curCamera._resize();
        var r3 = this._pixelsState;
        r3.pixels !== void 0 && r3._setProperty("pixels", new Uint8Array(this.GL.drawingBufferWidth * this.GL.drawingBufferHeight * 4));
      }, u2.default.RendererGL.prototype.clear = function() {
        var e3 = (arguments.length <= 0 ? void 0 : arguments[0]) || 0, t3 = (arguments.length <= 1 ? void 0 : arguments[1]) || 0, r3 = (arguments.length <= 2 ? void 0 : arguments[2]) || 0, n3 = (arguments.length <= 3 ? void 0 : arguments[3]) || 0;
        this.GL.clearColor(e3, t3, r3, n3), this.GL.clearDepth(1), this.GL.clear(this.GL.COLOR_BUFFER_BIT | this.GL.DEPTH_BUFFER_BIT);
      }, u2.default.RendererGL.prototype.applyMatrix = function(e3, t3, r3, n3, o3, i3) {
        arguments.length === 16 ? u2.default.Matrix.prototype.apply.apply(this.uMVMatrix, arguments) : this.uMVMatrix.apply([e3, t3, 0, 0, r3, n3, 0, 0, 0, 0, 1, 0, o3, i3, 0, 1]);
      }, u2.default.RendererGL.prototype.translate = function(e3, t3, r3) {
        return e3 instanceof u2.default.Vector && (r3 = e3.z, t3 = e3.y, e3 = e3.x), this.uMVMatrix.translate([e3, t3, r3]), this;
      }, u2.default.RendererGL.prototype.scale = function(e3, t3, r3) {
        return this.uMVMatrix.scale(e3, t3, r3), this;
      }, u2.default.RendererGL.prototype.rotate = function(e3, t3) {
        return t3 === void 0 ? this.rotateZ(e3) : (u2.default.Matrix.prototype.rotate.apply(this.uMVMatrix, arguments), this);
      }, u2.default.RendererGL.prototype.rotateX = function(e3) {
        return this.rotate(e3, 1, 0, 0), this;
      }, u2.default.RendererGL.prototype.rotateY = function(e3) {
        return this.rotate(e3, 0, 1, 0), this;
      }, u2.default.RendererGL.prototype.rotateZ = function(e3) {
        return this.rotate(e3, 0, 0, 1), this;
      }, u2.default.RendererGL.prototype.push = function() {
        var e3 = u2.default.Renderer.prototype.push.apply(this), t3 = e3.properties;
        return t3.uMVMatrix = this.uMVMatrix.copy(), t3.uPMatrix = this.uPMatrix.copy(), t3._curCamera = this._curCamera, this._curCamera = this._curCamera.copy(), t3.ambientLightColors = this.ambientLightColors.slice(), t3.specularColors = this.specularColors.slice(), t3.directionalLightDirections = this.directionalLightDirections.slice(), t3.directionalLightDiffuseColors = this.directionalLightDiffuseColors.slice(), t3.directionalLightSpecularColors = this.directionalLightSpecularColors.slice(), t3.pointLightPositions = this.pointLightPositions.slice(), t3.pointLightDiffuseColors = this.pointLightDiffuseColors.slice(), t3.pointLightSpecularColors = this.pointLightSpecularColors.slice(), t3.spotLightPositions = this.spotLightPositions.slice(), t3.spotLightDirections = this.spotLightDirections.slice(), t3.spotLightDiffuseColors = this.spotLightDiffuseColors.slice(), t3.spotLightSpecularColors = this.spotLightSpecularColors.slice(), t3.spotLightAngle = this.spotLightAngle.slice(), t3.spotLightConc = this.spotLightConc.slice(), t3.userFillShader = this.userFillShader, t3.userStrokeShader = this.userStrokeShader, t3.userPointShader = this.userPointShader, t3.pointSize = this.pointSize, t3.curStrokeWeight = this.curStrokeWeight, t3.curStrokeColor = this.curStrokeColor, t3.curFillColor = this.curFillColor, t3._useSpecularMaterial = this._useSpecularMaterial, t3._useEmissiveMaterial = this._useEmissiveMaterial, t3._useShininess = this._useShininess, t3.constantAttenuation = this.constantAttenuation, t3.linearAttenuation = this.linearAttenuation, t3.quadraticAttenuation = this.quadraticAttenuation, t3._enableLighting = this._enableLighting, t3._useNormalMaterial = this._useNormalMaterial, t3._tex = this._tex, t3.drawMode = this.drawMode, t3._currentNormal = this._currentNormal, e3;
      }, u2.default.RendererGL.prototype.resetMatrix = function() {
        return this.uMVMatrix = u2.default.Matrix.identity(this._pInst), this;
      }, u2.default.RendererGL.prototype._getImmediateStrokeShader = function() {
        var e3 = this.userStrokeShader;
        return e3 && e3.isStrokeShader() ? e3 : this._getLineShader();
      }, u2.default.RendererGL.prototype._getRetainedStrokeShader = u2.default.RendererGL.prototype._getImmediateStrokeShader, u2.default.RendererGL.prototype._getImmediateFillShader = function() {
        var e3 = this.userFillShader;
        if (this._useNormalMaterial && (!e3 || !e3.isNormalShader()))
          return this._getNormalShader();
        if (this._enableLighting) {
          if (!e3 || !e3.isLightShader())
            return this._getLightShader();
        } else if (this._tex) {
          if (!e3 || !e3.isTextureShader())
            return this._getLightShader();
        } else if (!e3)
          return this._getImmediateModeShader();
        return e3;
      }, u2.default.RendererGL.prototype._getRetainedFillShader = function() {
        if (this._useNormalMaterial)
          return this._getNormalShader();
        var e3 = this.userFillShader;
        if (this._enableLighting) {
          if (!e3 || !e3.isLightShader())
            return this._getLightShader();
        } else if (this._tex) {
          if (!e3 || !e3.isTextureShader())
            return this._getLightShader();
        } else if (!e3)
          return this._getColorShader();
        return e3;
      }, u2.default.RendererGL.prototype._getImmediatePointShader = function() {
        var e3 = this.userPointShader;
        return e3 && e3.isPointShader() ? e3 : this._getPointShader();
      }, u2.default.RendererGL.prototype._getRetainedLineShader = u2.default.RendererGL.prototype._getImmediateLineShader, u2.default.RendererGL.prototype._getLightShader = function() {
        return this._defaultLightShader || (this._pInst._glAttributes.perPixelLighting ? this._defaultLightShader = new u2.default.Shader(this, d.phongVert, d.phongFrag) : this._defaultLightShader = new u2.default.Shader(this, d.lightVert, d.lightTextureFrag)), this._defaultLightShader;
      }, u2.default.RendererGL.prototype._getImmediateModeShader = function() {
        return this._defaultImmediateModeShader || (this._defaultImmediateModeShader = new u2.default.Shader(this, d.immediateVert, d.vertexColorFrag)), this._defaultImmediateModeShader;
      }, u2.default.RendererGL.prototype._getNormalShader = function() {
        return this._defaultNormalShader || (this._defaultNormalShader = new u2.default.Shader(this, d.normalVert, d.normalFrag)), this._defaultNormalShader;
      }, u2.default.RendererGL.prototype._getColorShader = function() {
        return this._defaultColorShader || (this._defaultColorShader = new u2.default.Shader(this, d.normalVert, d.basicFrag)), this._defaultColorShader;
      }, u2.default.RendererGL.prototype._getPointShader = function() {
        return this._defaultPointShader || (this._defaultPointShader = new u2.default.Shader(this, d.pointVert, d.pointFrag)), this._defaultPointShader;
      }, u2.default.RendererGL.prototype._getLineShader = function() {
        return this._defaultLineShader || (this._defaultLineShader = new u2.default.Shader(this, d.lineVert, d.lineFrag)), this._defaultLineShader;
      }, u2.default.RendererGL.prototype._getFontShader = function() {
        return this._defaultFontShader || (this.GL.getExtension("OES_standard_derivatives"), this._defaultFontShader = new u2.default.Shader(this, d.fontVert, d.fontFrag)), this._defaultFontShader;
      }, u2.default.RendererGL.prototype._getEmptyTexture = function() {
        if (!this._emptyTexture) {
          var e3 = new u2.default.Image(1, 1);
          e3.set(0, 0, 255), this._emptyTexture = new u2.default.Texture(this, e3);
        }
        return this._emptyTexture;
      }, u2.default.RendererGL.prototype.getTexture = function(e3) {
        var t3 = this.textures, r3 = true, n3 = false, o3 = void 0;
        try {
          for (var i3, a3 = t3[Symbol.iterator](); !(r3 = (i3 = a3.next()).done); r3 = true) {
            var s2 = i3.value;
            if (s2.src === e3)
              return s2;
          }
        } catch (e4) {
          n3 = true, o3 = e4;
        } finally {
          try {
            r3 || a3.return == null || a3.return();
          } finally {
            if (n3)
              throw o3;
          }
        }
        var l3 = new u2.default.Texture(this, e3);
        return t3.push(l3), l3;
      }, u2.default.RendererGL.prototype._setStrokeUniforms = function(e3) {
        e3.bindShader(), e3.setUniform("uMaterialColor", this.curStrokeColor), e3.setUniform("uStrokeWeight", this.curStrokeWeight);
      }, u2.default.RendererGL.prototype._setFillUniforms = function(e3) {
        e3.bindShader(), e3.setUniform("uMaterialColor", this.curFillColor), e3.setUniform("isTexture", !!this._tex), this._tex && e3.setUniform("uSampler", this._tex), e3.setUniform("uTint", this._tint), e3.setUniform("uSpecular", this._useSpecularMaterial), e3.setUniform("uEmissive", this._useEmissiveMaterial), e3.setUniform("uShininess", this._useShininess), e3.setUniform("uUseLighting", this._enableLighting);
        var t3 = this.pointLightDiffuseColors.length / 3;
        e3.setUniform("uPointLightCount", t3), e3.setUniform("uPointLightLocation", this.pointLightPositions), e3.setUniform("uPointLightDiffuseColors", this.pointLightDiffuseColors), e3.setUniform("uPointLightSpecularColors", this.pointLightSpecularColors);
        var r3 = this.directionalLightDiffuseColors.length / 3;
        e3.setUniform("uDirectionalLightCount", r3), e3.setUniform("uLightingDirection", this.directionalLightDirections), e3.setUniform("uDirectionalDiffuseColors", this.directionalLightDiffuseColors), e3.setUniform("uDirectionalSpecularColors", this.directionalLightSpecularColors);
        var n3 = this.ambientLightColors.length / 3;
        e3.setUniform("uAmbientLightCount", n3), e3.setUniform("uAmbientColor", this.ambientLightColors);
        var o3 = this.spotLightDiffuseColors.length / 3;
        e3.setUniform("uSpotLightCount", o3), e3.setUniform("uSpotLightAngle", this.spotLightAngle), e3.setUniform("uSpotLightConc", this.spotLightConc), e3.setUniform("uSpotLightDiffuseColors", this.spotLightDiffuseColors), e3.setUniform("uSpotLightSpecularColors", this.spotLightSpecularColors), e3.setUniform("uSpotLightLocation", this.spotLightPositions), e3.setUniform("uSpotLightDirection", this.spotLightDirections), e3.setUniform("uConstantAttenuation", this.constantAttenuation), e3.setUniform("uLinearAttenuation", this.linearAttenuation), e3.setUniform("uQuadraticAttenuation", this.quadraticAttenuation), e3.bindTextures();
      }, u2.default.RendererGL.prototype._setPointUniforms = function(e3) {
        e3.bindShader(), e3.setUniform("uMaterialColor", this.curStrokeColor), e3.setUniform("uPointSize", this.pointSize * this._pInst._pixelDensity);
      }, u2.default.RendererGL.prototype._bindBuffer = function(e3, t3, r3, n3, o3) {
        if (t3 = t3 || this.GL.ARRAY_BUFFER, this.GL.bindBuffer(t3, e3), r3 !== void 0) {
          var i3 = new (n3 || Float32Array)(r3);
          this.GL.bufferData(t3, i3, o3 || this.GL.STATIC_DRAW);
        }
      }, u2.default.RendererGL.prototype._arraysEqual = function(e3, t3) {
        var r3 = e3.length;
        if (r3 !== t3.length)
          return false;
        for (var n3 = 0; n3 < r3; n3++)
          if (e3[n3] !== t3[n3])
            return false;
        return true;
      }, u2.default.RendererGL.prototype._isTypedArray = function(e3) {
        return e3 instanceof Uint32Array;
      }, u2.default.RendererGL.prototype._flatten = function(e3) {
        if (e3.length === 0)
          return [];
        if (2e4 < e3.length) {
          var t3, r3 = Object.prototype.toString, n3 = [], o3 = e3.slice();
          for (t3 = o3.pop(); r3.call(t3) === "[object Array]" ? o3.push.apply(o3, l2(t3)) : n3.push(t3), o3.length && (t3 = o3.pop()) !== void 0; )
            ;
          return n3.reverse(), n3;
        }
        var i3;
        return (i3 = []).concat.apply(i3, l2(e3));
      }, u2.default.RendererGL.prototype._vToNArray = function(e3) {
        var t3 = [], r3 = true, n3 = false, o3 = void 0;
        try {
          for (var i3, a3 = e3[Symbol.iterator](); !(r3 = (i3 = a3.next()).done); r3 = true) {
            var s2 = i3.value;
            t3.push(s2.x, s2.y, s2.z);
          }
        } catch (e4) {
          n3 = true, o3 = e4;
        } finally {
          try {
            r3 || a3.return == null || a3.return();
          } finally {
            if (n3)
              throw o3;
          }
        }
        return t3;
      }, u2.default.prototype._assert3d = function(e3) {
        if (!this._renderer.isP3D)
          throw new Error("".concat(e3, "() is only supported in WEBGL mode. If you'd like to use 3D graphics and WebGL, see  https://p5js.org/examples/form-3d-primitives.html for more information."));
      }, u2.default.RendererGL.prototype._initTessy = function() {
        var e3 = new n2.default.GluTesselator();
        return e3.gluTessCallback(n2.default.gluEnum.GLU_TESS_VERTEX_DATA, function(e4, t3) {
          t3[t3.length] = e4[0], t3[t3.length] = e4[1], t3[t3.length] = e4[2];
        }), e3.gluTessCallback(n2.default.gluEnum.GLU_TESS_BEGIN, function(e4) {
          e4 !== n2.default.primitiveType.GL_TRIANGLES && console.log("expected TRIANGLES but got type: ".concat(e4));
        }), e3.gluTessCallback(n2.default.gluEnum.GLU_TESS_ERROR, function(e4) {
          console.log("error callback"), console.log("error number: ".concat(e4));
        }), e3.gluTessCallback(n2.default.gluEnum.GLU_TESS_COMBINE, function(e4, t3, r3) {
          return [e4[0], e4[1], e4[2]];
        }), e3.gluTessCallback(n2.default.gluEnum.GLU_TESS_EDGE_FLAG, function(e4) {
        }), e3;
      }, u2.default.RendererGL.prototype._triangulate = function(e3) {
        this._tessy.gluTessNormal(0, 0, 1);
        var t3 = [];
        this._tessy.gluTessBeginPolygon(t3);
        for (var r3 = 0; r3 < e3.length; r3++) {
          this._tessy.gluTessBeginContour();
          for (var n3 = e3[r3], o3 = 0; o3 < n3.length; o3 += 3) {
            var i3 = [n3[o3], n3[o3 + 1], n3[o3 + 2]];
            this._tessy.gluTessVertex(i3, i3);
          }
          this._tessy.gluTessEndContour();
        }
        return this._tessy.gluTessEndPolygon(), t3;
      }, u2.default.RendererGL.prototype._bezierCoefficients = function(e3) {
        var t3 = e3 * e3, r3 = 1 - e3, n3 = r3 * r3;
        return [n3 * r3, 3 * n3 * e3, 3 * r3 * t3, t3 * e3];
      }, u2.default.RendererGL.prototype._quadraticCoefficients = function(e3) {
        var t3 = 1 - e3;
        return [t3 * t3, 2 * t3 * e3, e3 * e3];
      }, u2.default.RendererGL.prototype._bezierToCatmull = function(e3) {
        return [e3[1], e3[1] + (e3[2] - e3[0]) / this._curveTightness, e3[2] - (e3[3] - e3[1]) / this._curveTightness, e3[2]];
      };
      var f = u2.default.RendererGL;
      r2.default = f;
    }, { "../core/constants": 253, "../core/main": 264, "../core/p5.Renderer": 267, "./p5.Camera": 312, "./p5.Matrix": 314, "./p5.Shader": 319, "core-js/modules/es.array.concat": 149, "core-js/modules/es.array.fill": 151, "core-js/modules/es.array.filter": 152, "core-js/modules/es.array.from": 155, "core-js/modules/es.array.includes": 156, "core-js/modules/es.array.iterator": 158, "core-js/modules/es.array.slice": 162, "core-js/modules/es.object.assign": 173, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.regexp.to-string": 182, "core-js/modules/es.string.includes": 185, "core-js/modules/es.string.iterator": 186, "core-js/modules/es.symbol": 196, "core-js/modules/es.symbol.description": 194, "core-js/modules/es.symbol.iterator": 195, "core-js/modules/es.typed-array.copy-within": 197, "core-js/modules/es.typed-array.every": 198, "core-js/modules/es.typed-array.fill": 199, "core-js/modules/es.typed-array.filter": 200, "core-js/modules/es.typed-array.find": 202, "core-js/modules/es.typed-array.find-index": 201, "core-js/modules/es.typed-array.float32-array": 203, "core-js/modules/es.typed-array.float64-array": 204, "core-js/modules/es.typed-array.for-each": 205, "core-js/modules/es.typed-array.includes": 206, "core-js/modules/es.typed-array.index-of": 207, "core-js/modules/es.typed-array.int16-array": 208, "core-js/modules/es.typed-array.iterator": 210, "core-js/modules/es.typed-array.join": 211, "core-js/modules/es.typed-array.last-index-of": 212, "core-js/modules/es.typed-array.map": 213, "core-js/modules/es.typed-array.reduce": 215, "core-js/modules/es.typed-array.reduce-right": 214, "core-js/modules/es.typed-array.reverse": 216, "core-js/modules/es.typed-array.set": 217, "core-js/modules/es.typed-array.slice": 218, "core-js/modules/es.typed-array.some": 219, "core-js/modules/es.typed-array.sort": 220, "core-js/modules/es.typed-array.subarray": 221, "core-js/modules/es.typed-array.to-locale-string": 222, "core-js/modules/es.typed-array.to-string": 223, "core-js/modules/es.typed-array.uint16-array": 224, "core-js/modules/es.typed-array.uint32-array": 225, "core-js/modules/es.typed-array.uint8-array": 226, "core-js/modules/web.dom-collections.iterator": 229, libtess: 237, path: 240 }], 319: [function(e2, t2, r2) {
      e2("core-js/modules/es.symbol"), e2("core-js/modules/es.symbol.description"), e2("core-js/modules/es.symbol.iterator"), e2("core-js/modules/es.array.index-of"), e2("core-js/modules/es.array.iterator"), e2("core-js/modules/es.array.slice"), e2("core-js/modules/es.function.name"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.string.iterator"), e2("core-js/modules/web.dom-collections.iterator"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, i2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 };
      i2.default.Shader = function(e3, t3, r3) {
        this._renderer = e3, this._vertSrc = t3, this._fragSrc = r3, this._vertShader = -1, this._fragShader = -1, this._glProgram = 0, this._loadedAttributes = false, this.attributes = {}, this._loadedUniforms = false, this.uniforms = {}, this._bound = false, this.samplers = [];
      }, i2.default.Shader.prototype.init = function() {
        if (this._glProgram === 0) {
          var e3 = this._renderer.GL;
          if (this._vertShader = e3.createShader(e3.VERTEX_SHADER), e3.shaderSource(this._vertShader, this._vertSrc), e3.compileShader(this._vertShader), !e3.getShaderParameter(this._vertShader, e3.COMPILE_STATUS))
            return console.error("Yikes! An error occurred compiling the vertex shader:".concat(e3.getShaderInfoLog(this._vertShader))), null;
          if (this._fragShader = e3.createShader(e3.FRAGMENT_SHADER), e3.shaderSource(this._fragShader, this._fragSrc), e3.compileShader(this._fragShader), !e3.getShaderParameter(this._fragShader, e3.COMPILE_STATUS))
            return console.error("Darn! An error occurred compiling the fragment shader:".concat(e3.getShaderInfoLog(this._fragShader))), null;
          this._glProgram = e3.createProgram(), e3.attachShader(this._glProgram, this._vertShader), e3.attachShader(this._glProgram, this._fragShader), e3.linkProgram(this._glProgram), e3.getProgramParameter(this._glProgram, e3.LINK_STATUS) || console.error("Snap! Error linking shader program: ".concat(e3.getProgramInfoLog(this._glProgram))), this._loadAttributes(), this._loadUniforms();
        }
        return this;
      }, i2.default.Shader.prototype._loadAttributes = function() {
        if (!this._loadedAttributes) {
          this.attributes = {};
          for (var e3 = this._renderer.GL, t3 = e3.getProgramParameter(this._glProgram, e3.ACTIVE_ATTRIBUTES), r3 = 0; r3 < t3; ++r3) {
            var n3 = e3.getActiveAttrib(this._glProgram, r3), o3 = n3.name, i3 = e3.getAttribLocation(this._glProgram, o3), a2 = {};
            a2.name = o3, a2.location = i3, a2.index = r3, a2.type = n3.type, a2.size = n3.size, this.attributes[o3] = a2;
          }
          this._loadedAttributes = true;
        }
      }, i2.default.Shader.prototype._loadUniforms = function() {
        if (!this._loadedUniforms) {
          for (var e3 = this._renderer.GL, t3 = e3.getProgramParameter(this._glProgram, e3.ACTIVE_UNIFORMS), r3 = 0, n3 = 0; n3 < t3; ++n3) {
            var o3 = e3.getActiveUniform(this._glProgram, n3), i3 = {};
            i3.location = e3.getUniformLocation(this._glProgram, o3.name), i3.size = o3.size;
            var a2 = o3.name;
            1 < o3.size && (a2 = a2.substring(0, a2.indexOf("[0]"))), i3.name = a2, i3.type = o3.type, i3._cachedData = void 0, i3.type === e3.SAMPLER_2D && (i3.samplerIndex = r3, r3++, this.samplers.push(i3)), i3.isArray = 1 < o3.size || i3.type === e3.FLOAT_MAT3 || i3.type === e3.FLOAT_MAT4 || i3.type === e3.FLOAT_VEC2 || i3.type === e3.FLOAT_VEC3 || i3.type === e3.FLOAT_VEC4 || i3.type === e3.INT_VEC2 || i3.type === e3.INT_VEC4 || i3.type === e3.INT_VEC3, this.uniforms[a2] = i3;
          }
          this._loadedUniforms = true;
        }
      }, i2.default.Shader.prototype.compile = function() {
      }, i2.default.Shader.prototype.bindShader = function() {
        this.init(), this._bound || (this.useProgram(), this._bound = true, this._setMatrixUniforms(), this.setUniform("uViewport", this._renderer._viewport));
      }, i2.default.Shader.prototype.unbindShader = function() {
        return this._bound && (this.unbindTextures(), this._bound = false), this;
      }, i2.default.Shader.prototype.bindTextures = function() {
        var e3 = this._renderer.GL, t3 = true, r3 = false, n3 = void 0;
        try {
          for (var o3, i3 = this.samplers[Symbol.iterator](); !(t3 = (o3 = i3.next()).done); t3 = true) {
            var a2 = o3.value, s = a2.texture;
            s === void 0 && (s = this._renderer._getEmptyTexture()), e3.activeTexture(e3.TEXTURE0 + a2.samplerIndex), s.bindTexture(), s.update(), e3.uniform1i(a2.location, a2.samplerIndex);
          }
        } catch (e4) {
          r3 = true, n3 = e4;
        } finally {
          try {
            t3 || i3.return == null || i3.return();
          } finally {
            if (r3)
              throw n3;
          }
        }
      }, i2.default.Shader.prototype.updateTextures = function() {
        var e3 = true, t3 = false, r3 = void 0;
        try {
          for (var n3, o3 = this.samplers[Symbol.iterator](); !(e3 = (n3 = o3.next()).done); e3 = true) {
            var i3 = n3.value.texture;
            i3 && i3.update();
          }
        } catch (e4) {
          t3 = true, r3 = e4;
        } finally {
          try {
            e3 || o3.return == null || o3.return();
          } finally {
            if (t3)
              throw r3;
          }
        }
      }, i2.default.Shader.prototype.unbindTextures = function() {
      }, i2.default.Shader.prototype._setMatrixUniforms = function() {
        var e3 = this._renderer._curCamera.cameraMatrix, t3 = this._renderer.uPMatrix, r3 = this._renderer.uMVMatrix, n3 = r3.copy();
        n3.mult(t3), this.isStrokeShader() && (this._renderer._curCamera.cameraType === "default" ? this.setUniform("uPerspective", 1) : this.setUniform("uPerspective", 0)), this.setUniform("uViewMatrix", e3.mat4), this.setUniform("uProjectionMatrix", t3.mat4), this.setUniform("uModelViewMatrix", r3.mat4), this.setUniform("uModelViewProjectionMatrix", n3.mat4), this.uniforms.uNormalMatrix && (this._renderer.uNMatrix.inverseTranspose(this._renderer.uMVMatrix), this.setUniform("uNormalMatrix", this._renderer.uNMatrix.mat3));
      }, i2.default.Shader.prototype.useProgram = function() {
        var e3 = this._renderer.GL;
        return this._renderer._curShader !== this && (e3.useProgram(this._glProgram), this._renderer._curShader = this), this;
      }, i2.default.Shader.prototype.setUniform = function(e3, t3) {
        var r3 = this.uniforms[e3];
        if (r3) {
          var n3 = this._renderer.GL;
          if (r3.isArray) {
            if (r3._cachedData && this._renderer._arraysEqual(r3._cachedData, t3))
              return;
            r3._cachedData = t3.slice(0);
          } else {
            if (r3._cachedData && r3._cachedData === t3)
              return;
            Array.isArray(t3) ? r3._cachedData = t3.slice(0) : r3._cachedData = t3;
          }
          var o3 = r3.location;
          switch (this.useProgram(), r3.type) {
            case n3.BOOL:
              t3 === true ? n3.uniform1i(o3, 1) : n3.uniform1i(o3, 0);
              break;
            case n3.INT:
              1 < r3.size ? t3.length && n3.uniform1iv(o3, t3) : n3.uniform1i(o3, t3);
              break;
            case n3.FLOAT:
              1 < r3.size ? t3.length && n3.uniform1fv(o3, t3) : n3.uniform1f(o3, t3);
              break;
            case n3.FLOAT_MAT3:
              n3.uniformMatrix3fv(o3, false, t3);
              break;
            case n3.FLOAT_MAT4:
              n3.uniformMatrix4fv(o3, false, t3);
              break;
            case n3.FLOAT_VEC2:
              1 < r3.size ? t3.length && n3.uniform2fv(o3, t3) : n3.uniform2f(o3, t3[0], t3[1]);
              break;
            case n3.FLOAT_VEC3:
              1 < r3.size ? t3.length && n3.uniform3fv(o3, t3) : n3.uniform3f(o3, t3[0], t3[1], t3[2]);
              break;
            case n3.FLOAT_VEC4:
              1 < r3.size ? t3.length && n3.uniform4fv(o3, t3) : n3.uniform4f(o3, t3[0], t3[1], t3[2], t3[3]);
              break;
            case n3.INT_VEC2:
              1 < r3.size ? t3.length && n3.uniform2iv(o3, t3) : n3.uniform2i(o3, t3[0], t3[1]);
              break;
            case n3.INT_VEC3:
              1 < r3.size ? t3.length && n3.uniform3iv(o3, t3) : n3.uniform3i(o3, t3[0], t3[1], t3[2]);
              break;
            case n3.INT_VEC4:
              1 < r3.size ? t3.length && n3.uniform4iv(o3, t3) : n3.uniform4i(o3, t3[0], t3[1], t3[2], t3[3]);
              break;
            case n3.SAMPLER_2D:
              n3.activeTexture(n3.TEXTURE0 + r3.samplerIndex), r3.texture = t3 instanceof i2.default.Texture ? t3 : this._renderer.getTexture(t3), n3.uniform1i(o3, r3.samplerIndex);
          }
          return this;
        }
      }, i2.default.Shader.prototype.isLightShader = function() {
        return this.attributes.aNormal !== void 0 || this.uniforms.uUseLighting !== void 0 || this.uniforms.uAmbientLightCount !== void 0 || this.uniforms.uDirectionalLightCount !== void 0 || this.uniforms.uPointLightCount !== void 0 || this.uniforms.uAmbientColor !== void 0 || this.uniforms.uDirectionalDiffuseColors !== void 0 || this.uniforms.uDirectionalSpecularColors !== void 0 || this.uniforms.uPointLightLocation !== void 0 || this.uniforms.uPointLightDiffuseColors !== void 0 || this.uniforms.uPointLightSpecularColors !== void 0 || this.uniforms.uLightingDirection !== void 0 || this.uniforms.uSpecular !== void 0;
      }, i2.default.Shader.prototype.isNormalShader = function() {
        return this.attributes.aNormal !== void 0;
      }, i2.default.Shader.prototype.isTextureShader = function() {
        return 0 < this.samplers.length;
      }, i2.default.Shader.prototype.isColorShader = function() {
        return this.attributes.aVertexColor !== void 0 || this.uniforms.uMaterialColor !== void 0;
      }, i2.default.Shader.prototype.isTexLightShader = function() {
        return this.isLightShader() && this.isTextureShader();
      }, i2.default.Shader.prototype.isStrokeShader = function() {
        return this.uniforms.uStrokeWeight !== void 0;
      }, i2.default.Shader.prototype.enableAttrib = function(e3, t3, r3, n3, o3, i3) {
        if (e3) {
          var a2 = e3.location;
          if (a2 !== -1) {
            var s = this._renderer.GL;
            e3.enabled || (s.enableVertexAttribArray(a2), e3.enabled = true), this._renderer.GL.vertexAttribPointer(a2, t3, r3 || s.FLOAT, n3 || false, o3 || 0, i3 || 0);
          }
        }
        return this;
      };
      var o2 = i2.default.Shader;
      r2.default = o2;
    }, { "../core/main": 264, "core-js/modules/es.array.index-of": 157, "core-js/modules/es.array.iterator": 158, "core-js/modules/es.array.slice": 162, "core-js/modules/es.function.name": 166, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.string.iterator": 186, "core-js/modules/es.symbol": 196, "core-js/modules/es.symbol.description": 194, "core-js/modules/es.symbol.iterator": 195, "core-js/modules/web.dom-collections.iterator": 229 }], 320: [function(e2, t2, r2) {
      function a2(e3) {
        return (a2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      e2("core-js/modules/es.array.iterator"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.typed-array.uint8-array"), e2("core-js/modules/es.typed-array.copy-within"), e2("core-js/modules/es.typed-array.every"), e2("core-js/modules/es.typed-array.fill"), e2("core-js/modules/es.typed-array.filter"), e2("core-js/modules/es.typed-array.find"), e2("core-js/modules/es.typed-array.find-index"), e2("core-js/modules/es.typed-array.for-each"), e2("core-js/modules/es.typed-array.includes"), e2("core-js/modules/es.typed-array.index-of"), e2("core-js/modules/es.typed-array.iterator"), e2("core-js/modules/es.typed-array.join"), e2("core-js/modules/es.typed-array.last-index-of"), e2("core-js/modules/es.typed-array.map"), e2("core-js/modules/es.typed-array.reduce"), e2("core-js/modules/es.typed-array.reduce-right"), e2("core-js/modules/es.typed-array.reverse"), e2("core-js/modules/es.typed-array.set"), e2("core-js/modules/es.typed-array.slice"), e2("core-js/modules/es.typed-array.some"), e2("core-js/modules/es.typed-array.sort"), e2("core-js/modules/es.typed-array.subarray"), e2("core-js/modules/es.typed-array.to-locale-string"), e2("core-js/modules/es.typed-array.to-string"), Object.defineProperty(r2, "__esModule", { value: true }), r2.default = void 0;
      var n2, i2 = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 }, s = function(e3) {
        if (e3 && e3.__esModule)
          return e3;
        if (e3 === null || a2(e3) !== "object" && typeof e3 != "function")
          return { default: e3 };
        var t3 = l2();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o3 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o3)) {
            var i3 = n3 ? Object.getOwnPropertyDescriptor(e3, o3) : null;
            i3 && (i3.get || i3.set) ? Object.defineProperty(r3, o3, i3) : r3[o3] = e3[o3];
          }
        r3.default = e3, t3 && t3.set(e3, r3);
        return r3;
      }(e2("../core/constants"));
      function l2() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return l2 = function() {
          return e3;
        }, e3;
      }
      i2.default.Texture = function(e3, t3, r3) {
        this._renderer = e3;
        var n3 = this._renderer.GL;
        (r3 = r3 || {}).dataType === n3.FLOAT && (n3.getExtension("OES_texture_float") || console.log("Oh no, your device doesn't support floating point textures!"), n3.getExtension("OES_texture_float_linear") || console.log("Ack! Your device doesn't support linear filtering for floating point textures"));
        this.src = t3, this.glTex = void 0, this.glTarget = n3.TEXTURE_2D, this.glFormat = r3.format || n3.RGBA, this.mipmaps = false, this.glMinFilter = r3.minFilter || n3.LINEAR, this.glMagFilter = r3.magFilter || n3.LINEAR, this.glWrapS = r3.wrapS || n3.CLAMP_TO_EDGE, this.glWrapT = r3.wrapT || n3.CLAMP_TO_EDGE, this.glDataType = r3.dataType || n3.UNSIGNED_BYTE, this.isSrcMediaElement = i2.default.MediaElement !== void 0 && t3 instanceof i2.default.MediaElement, this._videoPrevUpdateTime = 0, this.isSrcHTMLElement = i2.default.Element !== void 0 && t3 instanceof i2.default.Element && !(t3 instanceof i2.default.Graphics), this.isSrcP5Image = t3 instanceof i2.default.Image, this.isSrcP5Graphics = t3 instanceof i2.default.Graphics, this.isImageData = typeof ImageData != "undefined" && t3 instanceof ImageData;
        var o3 = this._getTextureDataFromSource();
        return this.width = o3.width, this.height = o3.height, this.init(o3), this;
      }, i2.default.Texture.prototype._getTextureDataFromSource = function() {
        var e3;
        return this.isSrcP5Image ? e3 = this.src.canvas : this.isSrcMediaElement || this.isSrcP5Graphics || this.isSrcHTMLElement ? e3 = this.src.elt : this.isImageData && (e3 = this.src), e3;
      }, i2.default.Texture.prototype.init = function(e3) {
        var t3 = this._renderer.GL;
        if (this.glTex = t3.createTexture(), this.glWrapS = this._renderer.textureWrapX, this.glWrapT = this._renderer.textureWrapY, this.setWrapMode(this.glWrapS, this.glWrapT), this.bindTexture(), t3.texParameteri(t3.TEXTURE_2D, t3.TEXTURE_MAG_FILTER, this.glMagFilter), t3.texParameteri(t3.TEXTURE_2D, t3.TEXTURE_MIN_FILTER, this.glMinFilter), this.width === 0 || this.height === 0 || this.isSrcMediaElement && !this.src.loadedmetadata) {
          var r3 = new Uint8Array([1, 1, 1, 1]);
          t3.texImage2D(this.glTarget, 0, t3.RGBA, 1, 1, 0, this.glFormat, this.glDataType, r3);
        } else
          t3.texImage2D(this.glTarget, 0, this.glFormat, this.glFormat, this.glDataType, e3);
      }, i2.default.Texture.prototype.update = function() {
        var e3 = this.src;
        if (e3.width === 0 || e3.height === 0)
          return false;
        var t3 = this._getTextureDataFromSource(), r3 = false, n3 = this._renderer.GL;
        return t3.width !== this.width || t3.height !== this.height ? (r3 = true, this.width = t3.width, this.height = t3.height, this.isSrcP5Image ? e3.setModified(false) : (this.isSrcMediaElement || this.isSrcHTMLElement) && e3.setModified(true)) : this.isSrcP5Image ? e3.isModified() && (r3 = true, e3.setModified(false)) : this.isSrcMediaElement ? e3.isModified() ? (r3 = true, e3.setModified(false)) : e3.loadedmetadata && this._videoPrevUpdateTime !== e3.time() && (this._videoPrevUpdateTime = e3.time(), r3 = true) : this.isImageData ? e3._dirty && (r3 = !(e3._dirty = false)) : r3 = true, r3 && (this.bindTexture(), n3.texImage2D(this.glTarget, 0, this.glFormat, this.glFormat, this.glDataType, t3)), r3;
      }, i2.default.Texture.prototype.bindTexture = function() {
        return this._renderer.GL.bindTexture(this.glTarget, this.glTex), this;
      }, i2.default.Texture.prototype.unbindTexture = function() {
        this._renderer.GL.bindTexture(this.glTarget, null);
      }, i2.default.Texture.prototype.setInterpolation = function(e3, t3) {
        var r3 = this._renderer.GL;
        e3 === s.NEAREST ? this.glMinFilter = r3.NEAREST : this.glMinFilter = r3.LINEAR, t3 === s.NEAREST ? this.glMagFilter = r3.NEAREST : this.glMagFilter = r3.LINEAR, this.bindTexture(), r3.texParameteri(r3.TEXTURE_2D, r3.TEXTURE_MIN_FILTER, this.glMinFilter), r3.texParameteri(r3.TEXTURE_2D, r3.TEXTURE_MAG_FILTER, this.glMagFilter), this.unbindTexture();
      }, i2.default.Texture.prototype.setWrapMode = function(e3, t3) {
        function r3(e4) {
          return (e4 & e4 - 1) == 0;
        }
        var n3 = this._renderer.GL, o3 = r3(this.width), i3 = r3(this.height);
        e3 === s.REPEAT ? o3 && i3 ? this.glWrapS = n3.REPEAT : (console.warn("You tried to set the wrap mode to REPEAT but the texture size is not a power of two. Setting to CLAMP instead"), this.glWrapS = n3.CLAMP_TO_EDGE) : e3 === s.MIRROR ? o3 && i3 ? this.glWrapS = n3.MIRRORED_REPEAT : (console.warn("You tried to set the wrap mode to MIRROR but the texture size is not a power of two. Setting to CLAMP instead"), this.glWrapS = n3.CLAMP_TO_EDGE) : this.glWrapS = n3.CLAMP_TO_EDGE, t3 === s.REPEAT ? o3 && i3 ? this.glWrapT = n3.REPEAT : (console.warn("You tried to set the wrap mode to REPEAT but the texture size is not a power of two. Setting to CLAMP instead"), this.glWrapT = n3.CLAMP_TO_EDGE) : t3 === s.MIRROR ? o3 && i3 ? this.glWrapT = n3.MIRRORED_REPEAT : (console.warn("You tried to set the wrap mode to MIRROR but the texture size is not a power of two. Setting to CLAMP instead"), this.glWrapT = n3.CLAMP_TO_EDGE) : this.glWrapT = n3.CLAMP_TO_EDGE, this.bindTexture(), n3.texParameteri(n3.TEXTURE_2D, n3.TEXTURE_WRAP_S, this.glWrapS), n3.texParameteri(n3.TEXTURE_2D, n3.TEXTURE_WRAP_T, this.glWrapT), this.unbindTexture();
      };
      var o2 = i2.default.Texture;
      r2.default = o2;
    }, { "../core/constants": 253, "../core/main": 264, "core-js/modules/es.array.iterator": 158, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.typed-array.copy-within": 197, "core-js/modules/es.typed-array.every": 198, "core-js/modules/es.typed-array.fill": 199, "core-js/modules/es.typed-array.filter": 200, "core-js/modules/es.typed-array.find": 202, "core-js/modules/es.typed-array.find-index": 201, "core-js/modules/es.typed-array.for-each": 205, "core-js/modules/es.typed-array.includes": 206, "core-js/modules/es.typed-array.index-of": 207, "core-js/modules/es.typed-array.iterator": 210, "core-js/modules/es.typed-array.join": 211, "core-js/modules/es.typed-array.last-index-of": 212, "core-js/modules/es.typed-array.map": 213, "core-js/modules/es.typed-array.reduce": 215, "core-js/modules/es.typed-array.reduce-right": 214, "core-js/modules/es.typed-array.reverse": 216, "core-js/modules/es.typed-array.set": 217, "core-js/modules/es.typed-array.slice": 218, "core-js/modules/es.typed-array.some": 219, "core-js/modules/es.typed-array.sort": 220, "core-js/modules/es.typed-array.subarray": 221, "core-js/modules/es.typed-array.to-locale-string": 222, "core-js/modules/es.typed-array.to-string": 223, "core-js/modules/es.typed-array.uint8-array": 226 }], 321: [function(e2, t2, r2) {
      function a2(e3) {
        return (a2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e4) {
          return typeof e4;
        } : function(e4) {
          return e4 && typeof Symbol == "function" && e4.constructor === Symbol && e4 !== Symbol.prototype ? "symbol" : typeof e4;
        })(e3);
      }
      e2("core-js/modules/es.symbol"), e2("core-js/modules/es.symbol.description"), e2("core-js/modules/es.symbol.iterator"), e2("core-js/modules/es.array.iterator"), e2("core-js/modules/es.object.to-string"), e2("core-js/modules/es.regexp.exec"), e2("core-js/modules/es.string.iterator"), e2("core-js/modules/es.string.split"), e2("core-js/modules/es.string.sub"), e2("core-js/modules/web.dom-collections.iterator");
      var n2, G = (n2 = e2("../core/main")) && n2.__esModule ? n2 : { default: n2 }, k2 = function(e3) {
        if (e3 && e3.__esModule)
          return e3;
        if (e3 === null || a2(e3) !== "object" && typeof e3 != "function")
          return { default: e3 };
        var t3 = s();
        if (t3 && t3.has(e3))
          return t3.get(e3);
        var r3 = {}, n3 = Object.defineProperty && Object.getOwnPropertyDescriptor;
        for (var o3 in e3)
          if (Object.prototype.hasOwnProperty.call(e3, o3)) {
            var i2 = n3 ? Object.getOwnPropertyDescriptor(e3, o3) : null;
            i2 && (i2.get || i2.set) ? Object.defineProperty(r3, o3, i2) : r3[o3] = e3[o3];
          }
        r3.default = e3, t3 && t3.set(e3, r3);
        return r3;
      }(e2("../core/constants"));
      function s() {
        if (typeof WeakMap != "function")
          return null;
        var e3 = /* @__PURE__ */ new WeakMap();
        return s = function() {
          return e3;
        }, e3;
      }
      e2("./p5.Shader"), e2("./p5.RendererGL.Retained"), G.default.RendererGL.prototype._applyTextProperties = function() {
      }, G.default.RendererGL.prototype.textWidth = function(e3) {
        return this._isOpenType() ? this._textFont._textWidth(e3, this._textSize) : 0;
      };
      function o2(e3, t3) {
        this.width = e3, this.height = t3, this.infos = [], this.findImage = function(e4) {
          var t4, r3, n3 = this.width * this.height;
          if (n3 < e4)
            throw new Error("font is too complex to render in 3D");
          for (var o3 = this.infos.length - 1; 0 <= o3; --o3) {
            var i2 = this.infos[o3];
            if (i2.index + e4 < n3) {
              r3 = (t4 = i2).imageData;
              break;
            }
          }
          if (!t4) {
            try {
              r3 = new ImageData(this.width, this.height);
            } catch (e5) {
              var a3 = document.getElementsByTagName("canvas")[0], s2 = !a3;
              a3 || ((a3 = document.createElement("canvas")).style.display = "none", document.body.appendChild(a3));
              var l2 = a3.getContext("2d");
              l2 && (r3 = l2.createImageData(this.width, this.height)), s2 && document.body.removeChild(a3);
            }
            t4 = { index: 0, imageData: r3 }, this.infos.push(t4);
          }
          var u2 = t4.index;
          return t4.index += e4, r3._dirty = true, { imageData: r3, index: u2 };
        };
      }
      function V(e3, t3, r3, n3, o3) {
        var i2 = e3.imageData.data, a3 = 4 * e3.index++;
        i2[a3++] = t3, i2[a3++] = r3, i2[a3++] = n3, i2[a3++] = o3;
      }
      function R2(e3) {
        this.font = e3, this.strokeImageInfos = new o2(64, 64), this.colDimImageInfos = new o2(64, 64), this.rowDimImageInfos = new o2(64, 64), this.colCellImageInfos = new o2(64, 64), this.rowCellImageInfos = new o2(64, 64), this.glyphInfos = {}, this.getGlyphInfo = function(e4) {
          var t3 = this.glyphInfos[e4.index];
          if (t3)
            return t3;
          var r3, n3 = e4.getBoundingBox(), o3 = n3.x1, i2 = n3.y1, a3 = n3.x2 - o3, s2 = n3.y2 - i2, l2 = e4.path.commands;
          if (a3 == 0 || s2 == 0 || !l2.length)
            return this.glyphInfos[e4.index] = {};
          var u2, c, d, f, h2 = [], p2 = [], y = [];
          for (r3 = 8; 0 <= r3; --r3)
            y.push([]);
          for (r3 = 8; 0 <= r3; --r3)
            p2.push([]);
          function m2(e5, t4, r4) {
            var n4 = h2.length;
            function o4(e6, t5, r5) {
              for (var n5 = e6.length; 0 < n5--; ) {
                var o5 = e6[n5];
                o5 < t5 && (t5 = o5), r5 < o5 && (r5 = o5);
              }
              return { min: t5, max: r5 };
            }
            h2.push(r4);
            for (var i3 = o4(e5, 1, 0), a4 = Math.max(Math.floor(9 * i3.min), 0), s3 = Math.min(Math.ceil(9 * i3.max), 9), l3 = a4; l3 < s3; ++l3)
              y[l3].push(n4);
            for (var u3 = o4(t4, 1, 0), c2 = Math.max(Math.floor(9 * u3.min), 0), d2 = Math.min(Math.ceil(9 * u3.max), 9), f2 = c2; f2 < d2; ++f2)
              p2[f2].push(n4);
          }
          function g(e5) {
            return (t4 = (n4 = 255) * e5) < (r4 = 0) ? r4 : n4 < t4 ? n4 : t4;
            var t4, r4, n4;
          }
          function w(e5, t4, r4, n4) {
            this.p0 = e5, this.c0 = t4, this.c1 = r4, this.p1 = n4, this.toQuadratic = function() {
              return { x: this.p0.x, y: this.p0.y, x1: this.p1.x, y1: this.p1.y, cx: (3 * (this.c0.x + this.c1.x) - (this.p0.x + this.p1.x)) / 4, cy: (3 * (this.c0.y + this.c1.y) - (this.p0.y + this.p1.y)) / 4 };
            }, this.quadError = function() {
              return G.default.Vector.sub(G.default.Vector.sub(this.p1, this.p0), G.default.Vector.mult(G.default.Vector.sub(this.c1, this.c0), 3)).mag() / 2;
            }, this.split = function(e6) {
              var t5 = G.default.Vector.lerp(this.p0, this.c0, e6), r5 = G.default.Vector.lerp(this.c0, this.c1, e6), n5 = G.default.Vector.lerp(t5, r5, e6);
              this.c1 = G.default.Vector.lerp(this.c1, this.p1, e6), this.c0 = G.default.Vector.lerp(r5, this.c1, e6);
              var o4 = G.default.Vector.lerp(n5, this.c0, e6), i3 = new w(this.p0, t5, n5, o4);
              return this.p0 = o4, i3;
            }, this.splitInflections = function() {
              var e6 = G.default.Vector.sub(this.c0, this.p0), t5 = G.default.Vector.sub(G.default.Vector.sub(this.c1, this.c0), e6), r5 = G.default.Vector.sub(G.default.Vector.sub(G.default.Vector.sub(this.p1, this.c1), e6), G.default.Vector.mult(t5, 2)), n5 = [], o4 = t5.x * r5.y - t5.y * r5.x;
              if (o4 !== 0) {
                var i3 = e6.x * r5.y - e6.y * r5.x, a4 = e6.x * t5.y - e6.y * t5.x, s3 = i3 * i3 - 4 * o4 * a4;
                if (0 <= s3) {
                  o4 < 0 && (o4 = -o4, i3 = -i3, a4 = -a4);
                  var l3 = Math.sqrt(s3), u3 = (-i3 - l3) / (2 * o4), c2 = (-i3 + l3) / (2 * o4);
                  0 < u3 && u3 < 1 && (n5.push(this.split(u3)), c2 = 1 - (1 - c2) / (1 - u3)), 0 < c2 && c2 < 1 && n5.push(this.split(c2));
                }
              }
              return n5.push(this), n5;
            };
          }
          function v(e5, t4, r4, n4, o4, i3, a4, s3) {
            var l3 = new w(new G.default.Vector(e5, t4), new G.default.Vector(r4, n4), new G.default.Vector(o4, i3), new G.default.Vector(a4, s3)).splitInflections(), u3 = [], c2 = 30 / z, d2 = true, f2 = false, h3 = void 0;
            try {
              for (var p3, y2 = l3[Symbol.iterator](); !(d2 = (p3 = y2.next()).done); d2 = true) {
                for (var m3 = p3.value, g2 = [], v2 = void 0; !(0.125 <= (v2 = c2 / m3.quadError())); ) {
                  var b3 = Math.pow(v2, 1 / 3), _2 = m3.split(b3), x2 = m3.split(1 - b3 / (1 - b3));
                  u3.push(_2), g2.push(m3), m3 = x2;
                }
                v2 < 1 && u3.push(m3.split(0.5)), u3.push(m3), Array.prototype.push.apply(u3, g2.reverse());
              }
            } catch (e6) {
              f2 = true, h3 = e6;
            } finally {
              try {
                d2 || y2.return == null || y2.return();
              } finally {
                if (f2)
                  throw h3;
              }
            }
            return u3;
          }
          function b2(e5, t4, r4, n4) {
            m2([e5, r4], [t4, n4], { x: e5, y: t4, cx: (e5 + r4) / 2, cy: (t4 + n4) / 2 });
          }
          function _(e5, t4, r4, n4) {
            return Math.abs(r4 - e5) < 1e-5 && Math.abs(n4 - t4) < 1e-5;
          }
          var x = true, j = false, S2 = void 0;
          try {
            for (var M, E = l2[Symbol.iterator](); !(x = (M = E.next()).done); x = true) {
              var T2 = M.value, O2 = (T2.x - o3) / a3, C = (T2.y - i2) / s2;
              if (!_(u2, c, O2, C)) {
                switch (T2.type) {
                  case "M":
                    d = O2, f = C;
                    break;
                  case "L":
                    b2(u2, c, O2, C);
                    break;
                  case "Q":
                    var L = (T2.x1 - o3) / a3, P2 = (T2.y1 - i2) / s2;
                    m2([u2, O2, L], [c, C, P2], { x: u2, y: c, cx: L, cy: P2 });
                    break;
                  case "Z":
                    _(u2, c, d, f) ? h2.push({ x: u2, y: c }) : (b2(u2, c, d, f), h2.push({ x: d, y: f }));
                    break;
                  case "C":
                    for (var A = v(u2, c, (T2.x1 - o3) / a3, (T2.y1 - i2) / s2, (T2.x2 - o3) / a3, (T2.y2 - i2) / s2, O2, C), k3 = 0; k3 < A.length; k3++) {
                      var R3 = A[k3].toQuadratic();
                      m2([R3.x, R3.x1, R3.cx], [R3.y, R3.y1, R3.cy], R3);
                    }
                    break;
                  default:
                    throw new Error("unknown command type: ".concat(T2.type));
                }
                u2 = O2, c = C;
              }
            }
          } catch (e5) {
            j = true, S2 = e5;
          } finally {
            try {
              x || E.return == null || E.return();
            } finally {
              if (j)
                throw S2;
            }
          }
          for (var D = h2.length, I = this.strokeImageInfos.findImage(D), U = I.index, N = 0; N < D; ++N) {
            var F = h2[N];
            V(I, g(F.x), g(F.y), g(F.cx), g(F.cy));
          }
          function B(e5, t4, r4) {
            for (var n4 = e5.length, o4 = t4.findImage(n4), i3 = o4.index, a4 = 0, s3 = 0; s3 < n4; ++s3)
              a4 += e5[s3].length;
            for (var l3 = r4.findImage(a4), u3 = 0; u3 < n4; ++u3) {
              var c2 = e5[u3], d2 = c2.length, f2 = l3.index;
              V(o4, f2 >> 7, 127 & f2, d2 >> 7, 127 & d2);
              for (var h3 = 0; h3 < d2; ++h3) {
                var p3 = c2[h3] + U;
                V(l3, p3 >> 7, 127 & p3, 0, 0);
              }
            }
            return { cellImageInfo: l3, dimOffset: i3, dimImageInfo: o4 };
          }
          return (t3 = this.glyphInfos[e4.index] = { glyph: e4, uGlyphRect: [n3.x1, -n3.y1, n3.x2, -n3.y2], strokeImageInfo: I, strokes: h2, colInfo: B(y, this.colDimImageInfos, this.colCellImageInfos), rowInfo: B(p2, this.rowDimImageInfos, this.rowCellImageInfos) }).uGridOffset = [t3.colInfo.dimOffset, t3.rowInfo.dimOffset], t3;
        };
      }
      var z = Math.sqrt(3);
      G.default.RendererGL.prototype._renderText = function(e3, t3, r3, n3, o3) {
        if (this._textFont && typeof this._textFont != "string") {
          if (!(o3 <= n3) && this._doFill) {
            if (!this._isOpenType())
              return console.log("WEBGL: only Opentype (.otf) and Truetype (.ttf) fonts are supported"), e3;
            e3.push();
            var i2 = this._doStroke, a3 = this.drawMode;
            this._doStroke = false, this.drawMode = k2.TEXTURE;
            var s2 = this._textFont.font, l2 = this._textFont._fontInfo;
            l2 = l2 || (this._textFont._fontInfo = new R2(s2));
            var u2 = this._textFont._handleAlignment(this, t3, r3, n3), c = this._textSize / s2.unitsPerEm;
            this.translate(u2.x, u2.y, 0), this.scale(c, c, 1);
            var d = this.GL, f = !this._defaultFontShader, h2 = this._getFontShader();
            h2.init(), h2.bindShader(), f && (h2.setUniform("uGridImageSize", [64, 64]), h2.setUniform("uCellsImageSize", [64, 64]), h2.setUniform("uStrokeImageSize", [64, 64]), h2.setUniform("uGridSize", [9, 9])), this._applyColorBlend(this.curFillColor);
            var p2 = this.retainedMode.geometry.glyph;
            if (!p2) {
              var y = this._textGeom = new G.default.Geometry(1, 1, function() {
                for (var e4 = 0; e4 <= 1; e4++)
                  for (var t4 = 0; t4 <= 1; t4++)
                    this.vertices.push(new G.default.Vector(t4, e4, 0)), this.uvs.push(t4, e4);
              });
              y.computeFaces().computeNormals(), p2 = this.createBuffers("glyph", y);
            }
            var m2 = true, g = false, v = void 0;
            try {
              for (var b2, _ = this.retainedMode.buffers.text[Symbol.iterator](); !(m2 = (b2 = _.next()).done); m2 = true) {
                b2.value._prepareBuffer(p2, h2);
              }
            } catch (e4) {
              g = true, v = e4;
            } finally {
              try {
                m2 || _.return == null || _.return();
              } finally {
                if (g)
                  throw v;
              }
            }
            this._bindBuffer(p2.indexBuffer, d.ELEMENT_ARRAY_BUFFER), h2.setUniform("uMaterialColor", this.curFillColor);
            try {
              var x = 0, w = null, j = s2.stringToGlyphs(t3), S2 = true, M = false, E = void 0;
              try {
                for (var T2, O2 = j[Symbol.iterator](); !(S2 = (T2 = O2.next()).done); S2 = true) {
                  var C = T2.value;
                  w && (x += s2.getKerningValue(w, C));
                  var L = l2.getGlyphInfo(C);
                  if (L.uGlyphRect) {
                    var P2 = L.rowInfo, A = L.colInfo;
                    h2.setUniform("uSamplerStrokes", L.strokeImageInfo.imageData), h2.setUniform("uSamplerRowStrokes", P2.cellImageInfo.imageData), h2.setUniform("uSamplerRows", P2.dimImageInfo.imageData), h2.setUniform("uSamplerColStrokes", A.cellImageInfo.imageData), h2.setUniform("uSamplerCols", A.dimImageInfo.imageData), h2.setUniform("uGridOffset", L.uGridOffset), h2.setUniform("uGlyphRect", L.uGlyphRect), h2.setUniform("uGlyphOffset", x), h2.bindTextures(), d.drawElements(d.TRIANGLES, 6, this.GL.UNSIGNED_SHORT, 0);
                  }
                  x += C.advanceWidth, w = C;
                }
              } catch (e4) {
                M = true, E = e4;
              } finally {
                try {
                  S2 || O2.return == null || O2.return();
                } finally {
                  if (M)
                    throw E;
                }
              }
            } finally {
              h2.unbindShader(), this._doStroke = i2, this.drawMode = a3, e3.pop();
            }
            return e3;
          }
        } else
          console.log("WEBGL: you must load and set a font before drawing text. See `loadFont` and `textFont` for more details.");
      };
    }, { "../core/constants": 253, "../core/main": 264, "./p5.RendererGL.Retained": 317, "./p5.Shader": 319, "core-js/modules/es.array.iterator": 158, "core-js/modules/es.object.to-string": 177, "core-js/modules/es.regexp.exec": 181, "core-js/modules/es.string.iterator": 186, "core-js/modules/es.string.split": 191, "core-js/modules/es.string.sub": 192, "core-js/modules/es.symbol": 196, "core-js/modules/es.symbol.description": 194, "core-js/modules/es.symbol.iterator": 195, "core-js/modules/web.dom-collections.iterator": 229 }] }, {}, [248])(248);
  });
})(p5_min);
var P5 = /* @__PURE__ */ getDefaultExportFromCjs(p5_min.exports);
function zfsAnimation(p5) {
  p5.zfsAnimationSteps = 24;
  p5.zfsAnimationIndex = 0;
  p5.zfsAnimationDir = 1;
  p5.zfsAnimationColors = {
    vdev_faulted: {
      start: p5.color(244, 63, 94, 100),
      end: p5.color(239, 68, 68, 200)
    },
    vdev_degraded: {
      start: p5.color(249, 115, 22, 100),
      end: p5.color(252, 211, 77, 200)
    },
    vdev_online: {
      start: p5.color(34, 197, 94, 100),
      end: p5.color(74, 222, 128, 200)
    },
    dev_offline: {
      start: p5.color(249, 115, 22, 192),
      end: p5.color(249, 115, 22, 0)
    },
    dev_online: {
      start: p5.color(74, 222, 128, 192),
      end: p5.color(34, 197, 94, 0)
    },
    dev_removed: {
      start: p5.color(239, 68, 68, 192),
      end: p5.color(244, 63, 94, 0)
    },
    dev_unavail: {
      start: p5.color(239, 68, 68, 192),
      end: p5.color(244, 63, 94, 0)
    }
  };
  p5.animateZpools = (x, y, w, h2, steps, index2, from, to, zfsAnimationDir) => {
    p5.push();
    p5.colorMode(p5.RGB);
    p5.noFill();
    p5.strokeWeight(3);
    let dashValue = zfsAnimationDir === 1 ? 4 : 6;
    p5.setLineDash([dashValue, dashValue]);
    p5.stroke(p5.lerpColor(from, to, index2 / steps));
    p5.rect(x, y, w, h2);
    p5.pop();
  };
  p5.updateZfsAnimationState = () => {
    if (p5.zfsAnimationIndex > p5.zfsAnimationSteps) {
      p5.zfsAnimationDir = -1;
    } else if (p5.zfsAnimationIndex <= 0) {
      p5.zfsAnimationDir = 1;
    }
    p5.zfsAnimationIndex = p5.int(p5.zfsAnimationIndex + p5.zfsAnimationDir);
  };
  p5.setLineDash = (list) => {
    p5.drawingContext.setLineDash(list);
  };
  p5.animateVdevs = (x, y, w, h2, steps, index2, from, to) => {
    p5.push();
    p5.colorMode(p5.RGB);
    p5.noStroke();
    p5.fill(p5.lerpColor(from, to, index2 / steps));
    p5.rect(x, y, w, h2);
    p5.pop();
  };
  p5.showZfs = (cd, zfsInfo, diskLocations2, y_offset = 0) => {
    if (zfsInfo.zfs_installed) {
      if (zfsInfo.zfs_disks && zfsInfo.zfs_disks[cd]) {
        let pool_idx = zfsInfo.zpools.findIndex((pool) => pool.name === zfsInfo.zfs_disks[cd].zpool_name);
        if (typeof pool_idx != "undefined") {
          p5.updateZfsAnimationState();
          zfsInfo.zpools[pool_idx].vdevs[zfsInfo.zfs_disks[cd].vdev_idx].disks.forEach((dsk) => {
            let dsk_idx = diskLocations2.findIndex((loc) => loc.BAY === dsk.name);
            if (typeof dsk_idx != "undefined" && diskLocations2[dsk_idx]) {
              let from = p5.color(255, 255, 255, 100);
              let to = p5.color(0, 0, 0, 0);
              if (dsk.state === "ONLINE") {
                from = p5.zfsAnimationColors.dev_online.start;
                to = p5.zfsAnimationColors.dev_online.end;
              } else if (dsk.state === "OFFLINE") {
                from = p5.zfsAnimationColors.dev_offline.start;
                to = p5.zfsAnimationColors.dev_offline.end;
              } else if (dsk.state === "REMOVED") {
                from = p5.zfsAnimationColors.dev_removed.start;
                to = p5.zfsAnimationColors.dev_removed.end;
              } else if (dsk.state === "UNAVAIL") {
                from = p5.zfsAnimationColors.dev_unavail.start;
                to = p5.zfsAnimationColors.dev_unavail.end;
              }
              p5.animateVdevs(diskLocations2[dsk_idx].x, diskLocations2[dsk_idx].y, diskLocations2[dsk_idx].image.width, diskLocations2[dsk_idx].image.height + y_offset, p5.zfsAnimationSteps, p5.zfsAnimationIndex, from, to);
            }
          });
          zfsInfo.zpools[pool_idx].vdevs.forEach((vdev) => {
            vdev.disks.forEach((dsk) => {
              let dsk_idx = diskLocations2.findIndex((loc) => loc.BAY === dsk.name);
              if (typeof dsk_idx != "undefined" && diskLocations2[dsk_idx]) {
                let from = p5.color(255, 255, 255, 100);
                let to = p5.color(0, 0, 0, 0);
                if (vdev.state === "ONLINE") {
                  from = p5.zfsAnimationColors.vdev_online.start;
                  to = p5.zfsAnimationColors.vdev_online.end;
                } else if (vdev.state === "DEGRADED") {
                  from = p5.zfsAnimationColors.vdev_degraded.start;
                  to = p5.zfsAnimationColors.vdev_degraded.end;
                } else if (vdev.state === "FAULTED") {
                  from = p5.zfsAnimationColors.vdev_faulted.start;
                  to = p5.zfsAnimationColors.vdev_faulted.end;
                } else if (vdev.state === "UNAVAIL") {
                  from = p5.zfsAnimationColors.vdev_faulted.start;
                  to = p5.zfsAnimationColors.vdev_faulted.end;
                }
                p5.animateZpools(diskLocations2[dsk_idx].x, diskLocations2[dsk_idx].y, diskLocations2[dsk_idx].image.width, diskLocations2[dsk_idx].image.height + y_offset, p5.zfsAnimationSteps, p5.zfsAnimationIndex, from, to, p5.zfsAnimationDir);
              }
            });
          });
        }
      }
    }
  };
}
function loadingAnimation(p5) {
  p5.loadingAnimationSteps = 20;
  p5.loadingAnimationIndex = 0;
  p5.animateLoading = (x, y, w, h2) => {
    p5.push();
    p5.colorMode(p5.RGB);
    p5.noStroke();
    let from = p5.color(100, 100, 110, 100);
    let to = p5.color(0, 0, 0, 100);
    p5.colorMode(p5.RGB);
    let stepPx = h2 / p5.loadingAnimationSteps;
    let stepPercent = 1 / p5.loadingAnimationSteps;
    for (let i = 0; i < p5.loadingAnimationSteps; i++) {
      p5.fill(p5.lerpColor(from, to, stepPercent * i));
      p5.rect(x, y + stepPx * ((p5.loadingAnimationIndex + i) % p5.loadingAnimationSteps), w, stepPx);
    }
    p5.pop();
  };
}
function resizeHook(p5, cnv_id, max_w) {
  p5.canvas_id = cnv_id;
  p5.max_w = max_w;
  p5.windowResized = (_) => {
    let cnv = document.getElementById(p5.canvas_id);
    let app2 = document.getElementById("App");
    if (cnv) {
      cnv.style.width = `${Math.min(p5.int(app2.clientWidth - 60), p5.int(p5.max_w))}px`;
      cnv.style.height = `auto`;
    }
  };
  p5.isOverflown = (cnv, app2) => {
    return cnv.clientWidth > app2.clientWidth;
  };
  p5.setInitSize = () => {
    let cnv = document.getElementById(p5.canvas_id);
    let app2 = document.getElementById("App");
    if (cnv) {
      cnv.style.width = `${p5.int(p5.max_w)}px`;
      cnv.style.height = `auto`;
      if (p5.isOverflown(cnv, app2)) {
        cnv.style.width = `${Math.min(p5.int(app2.clientWidth - 60), p5.int(p5.max_w))}px`;
        cnv.style.height = `auto`;
      }
    }
  };
  p5.setInitSize();
}
const assets$i = {
  chassis: {
    path: "img/chassis/f2-stornado-chassis.png",
    image: null
  },
  disks: {
    caddy: {
      loading: {
        path: "img/disks/trimode/ssd_loading.png",
        image: null
      },
      default: {
        path: "img/disks/trimode/ssd_loading.png",
        image: null
      }
    },
    ssd: {
      default: {
        path: "img/disks/trimode/ssd_generic.png",
        image: null
      },
      micronNvme: {
        path: "img/disks/trimode/nvme_micron.png",
        image: null
      },
      seagateNvme: {
        path: "img/disks/trimode/nvme_seagate.png",
        image: null
      },
      micron5200: {
        path: "img/disks/trimode/sata_micron_5200.png",
        image: null
      },
      micron5300: {
        path: "img/disks/trimode/sata_micron_5300.png",
        image: null
      },
      seagate: {
        path: "img/disks/trimode/sata_seagate.png",
        image: null
      },
      seagateSas: {
        path: "img/disks/trimode/sas_seagate.png",
        image: null
      },
      loading: {
        path: "img/disks/trimode/ssd_loading.png",
        image: null
      },
      hdd25: {
        path: "img/disks/trimode/hdd_25.png",
        image: null
      },
      empty: {
        path: "img/disks/trimode/ssd_loading.png",
        image: null
      }
    },
    hdd: {
      loading: {
        path: "img/disks/trimode/ssd_loading.png",
        image: null
      },
      default: {
        path: "img/disks/trimode/ssd_loading.png",
        image: null
      }
    }
  },
  loadingFlag: true
};
const diskLocations$i = [
  {
    x: 181,
    y: 36,
    BAY: "1-1",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 235,
    y: 36,
    BAY: "1-2",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 288,
    y: 36,
    BAY: "1-3",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 342,
    y: 36,
    BAY: "1-4",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 395,
    y: 36,
    BAY: "1-5",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 449,
    y: 36,
    BAY: "1-6",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 502,
    y: 36,
    BAY: "1-7",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 556,
    y: 36,
    BAY: "1-8",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 609,
    y: 36,
    BAY: "2-1",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 663,
    y: 36,
    BAY: "2-2",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 716,
    y: 36,
    BAY: "2-3",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 770,
    y: 36,
    BAY: "2-4",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 823,
    y: 36,
    BAY: "2-5",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 877,
    y: 36,
    BAY: "2-6",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 930,
    y: 36,
    BAY: "2-7",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 984,
    y: 36,
    BAY: "2-8",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 1037,
    y: 36,
    BAY: "3-1",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 1091,
    y: 36,
    BAY: "3-2",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 1144,
    y: 36,
    BAY: "3-3",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 1198,
    y: 36,
    BAY: "3-4",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 1251,
    y: 36,
    BAY: "3-5",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 1305,
    y: 36,
    BAY: "3-6",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 1358,
    y: 36,
    BAY: "3-7",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 1412,
    y: 36,
    BAY: "3-8",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 1465,
    y: 36,
    BAY: "4-1",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 1519,
    y: 36,
    BAY: "4-2",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 1572,
    y: 36,
    BAY: "4-3",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 1626,
    y: 36,
    BAY: "4-4",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 1679,
    y: 36,
    BAY: "4-5",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 1733,
    y: 36,
    BAY: "4-6",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 1786,
    y: 36,
    BAY: "4-7",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 1840,
    y: 36,
    BAY: "4-8",
    HDD: false,
    occupied: false,
    image: null
  }
];
const _sfc_main$l = {
  name: "P5StornadoF2",
  setup() {
    const diskInfoObj = ref({});
    const currentDisk = inject("currentDisk");
    const lsdevJson = inject("lsdevJson");
    const diskInfo = inject("diskInfo");
    const zfsInfo = inject("zfsInfo");
    const enableZfsAnimations = inject("enableZfsAnimations");
    watch(lsdevJson, () => {
      diskInfoObj.value = lsdevJson;
      assets$i.loadingFlag = false;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$i.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$i[index2].occupied = slot.occupied;
        diskLocations$i[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$i[index2].HDD);
      });
      assets$i.loadingFlag = false;
    }, { immediate: false, deep: true });
    watch(diskInfo, () => {
      diskInfoObj.value = diskInfo;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$i.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$i[index2].occupied = slot.occupied;
        diskLocations$i[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$i[index2].HDD);
      });
    }, { immediate: true, deep: true });
    watch(enableZfsAnimations, () => {
    }, { immediate: true, deep: true });
    function getDiskImage(occupied, modelName, modelFamily, diskType, slotHdd) {
      if (!occupied) {
        return slotHdd ? null : assets$i.disks.ssd.empty.image;
      }
      if (assets$i.loadingFlag && diskType === "SSD" && slotHdd)
        return assets$i.disks.caddy.loading.image;
      if (assets$i.loadingFlag && diskType === "SSD" && !slotHdd)
        return assets$i.disks.ssd.loading.image;
      if (assets$i.loadingFlag && diskType === "HDD" && !slotHdd)
        return assets$i.disks.ssd.loading.image;
      if (assets$i.loadingFlag && diskType === "HDD")
        return assets$i.disks.hdd.loading.image;
      if (diskType === "SSD" && slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$i.disks.caddy.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$i.disks.caddy.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$i.disks.caddy.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$i.disks.caddy.micron5300.image;
        }
        return assets$i.disks.caddy.default.image;
      }
      if (diskType === "SSD" && !slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$i.disks.ssd.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$i.disks.ssd.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$i.disks.ssd.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$i.disks.ssd.micron5300.image;
        } else if (/NVMe Micron/.test(modelName)) {
          return assets$i.disks.ssd.micronNvme.image;
        } else if (/NVMe XP/.test(modelName)) {
          return assets$i.disks.ssd.seagateNvme.image;
        }
        return assets$i.disks.ssd.default.image;
      }
      if (diskType === "HDD" && slotHdd) {
        if (/ST18000|ST16000|ST20000|ST14000|ST12000/.test(modelName)) {
          return assets$i.disks.hdd.seagateSt.image;
        } else if (/Seagate Enterprise/.test(modelFamily)) {
          return assets$i.disks.hdd.seagate.image;
        } else if (/TOSHIBA/.test(modelName)) {
          return assets$i.disks.hdd.toshiba.image;
        } else {
          return assets$i.disks.hdd.default.image;
        }
      }
      if (diskType === "HDD" && !slotHdd) {
        return assets$i.disks.ssd.hdd25.image;
      }
    }
    const p5Script = function(p5) {
      loadingAnimation(p5);
      zfsAnimation(p5);
      p5.preload = (_) => {
        assets$i.loadingFlag = true;
        assets$i.chassis.image = p5.loadImage(assets$i.chassis.path);
        Object.entries(assets$i.disks.caddy).forEach(([dsk, val]) => {
          assets$i.disks.caddy[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$i.disks.ssd).forEach(([dsk, val]) => {
          assets$i.disks.ssd[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$i.disks.hdd).forEach(([dsk, val]) => {
          assets$i.disks.hdd[dsk].image = p5.loadImage(val.path);
        });
        diskInfoObj.value.rows.flat().forEach((slot) => {
          const index2 = diskLocations$i.findIndex((loc) => loc.BAY === slot["bay-id"]);
          diskLocations$i[index2].occupied = slot.occupied;
          diskLocations$i[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$i[index2].HDD);
        });
      };
      p5.setup = (_) => {
        const canvas = p5.createCanvas(assets$i.chassis.image.width, assets$i.chassis.image.height);
        canvas.parent("p5-stornadof2");
        p5.frameRate(24);
        resizeHook(p5, canvas.id(), assets$i.chassis.image.width);
      };
      p5.draw = (_) => {
        if (assets$i.loadingFlag) {
          p5.frameRate(10);
          p5.loadingAnimationIndex = p5.int((p5.loadingAnimationIndex + 1) % p5.loadingAnimationSteps);
        } else {
          p5.frameRate(24);
        }
        p5.image(assets$i.chassis.image, 0, 0);
        diskLocations$i.forEach((loc) => {
          if (loc.occupied && loc.image) {
            p5.image(loc.image, loc.x, loc.y);
            if (assets$i.loadingFlag) {
              p5.animateLoading(loc.x, loc.y, loc.image.width, loc.image.height - 14);
            }
          }
        });
        if (currentDisk.value) {
          let idx = diskLocations$i.findIndex((loc) => loc.BAY === currentDisk.value);
          if (diskLocations$i[idx].image) {
            if (enableZfsAnimations.flag) {
              p5.showZfs(currentDisk.value, zfsInfo, diskLocations$i, -14);
            }
            p5.fill(255, 255, 255, 50);
            p5.stroke(206, 242, 212);
            p5.strokeWeight(2);
            p5.rect(diskLocations$i[idx].x, diskLocations$i[idx].y, diskLocations$i[idx].image.width, diskLocations$i[idx].image.height - 14);
          }
        }
      };
      p5.mouseClicked = (_) => {
        let mx = p5.mouseX;
        let my = p5.mouseY;
        diskLocations$i.forEach((loc) => {
          if (loc.image && mx > loc.x && mx < loc.x + loc.image.width && my > loc.y && my < loc.y + loc.image.height) {
            currentDisk.value = loc.BAY;
          }
        });
      };
    };
    onMounted(() => {
      new P5(p5Script);
    });
    return {
      diskInfoObj,
      currentDisk,
      lsdevJson,
      diskInfo,
      enableZfsAnimations
    };
  }
};
const _hoisted_1$l = {
  id: "p5-stornadof2",
  class: "self-stretch m-2 flex justify-center"
};
function _sfc_render$l(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1$l);
}
var P5StornadoF2 = /* @__PURE__ */ _export_sfc(_sfc_main$l, [["render", _sfc_render$l]]);
const assets$h = {
  chassis: {
    path: "img/chassis/f8x1-storinator.png",
    image: null
  },
  fade: {
    path: "img/chassis/chassis-fade.png",
    image: null
  },
  disks: {
    caddy: {
      default: {
        path: "img/disks/caddy-generic.png",
        image: null
      },
      micron5200: {
        path: "img/disks/caddy-micron.png",
        image: null
      },
      micron5300: {
        path: "img/disks/caddy-micron-5300.png",
        image: null
      },
      seagate: {
        path: "img/disks/caddy-seagate.png",
        image: null
      },
      seagateSas: {
        path: "img/disks/caddy-seagate-sas.png",
        image: null
      },
      loading: {
        path: "img/disks/caddy-loading.png",
        image: null
      }
    },
    ssd: {
      micron5200: {
        path: "img/disks/ssd-micron-270.png",
        image: null
      },
      micron5300: {
        path: "img/disks/ssd-micron-5300-270.png",
        image: null
      },
      seagate: {
        path: "img/disks/ssd-seagate-270.png",
        image: null
      },
      seagateSas: {
        path: "img/disks/ssd-seagate-sas-270.png",
        image: null
      },
      default: {
        path: "img/disks/ssd-generic-270.png",
        image: null
      },
      loading: {
        path: "img/disks/ssd-loading-270.png",
        image: null
      },
      hdd25: {
        path: "img/disks/hdd-25-270.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-ssd-270.png",
        image: null
      }
    },
    hdd: {
      default: {
        path: "img/disks/hdd-generic.png",
        image: null
      },
      seagateSt: {
        path: "img/disks/hdd-seagate-st.png",
        image: null
      },
      seagate: {
        path: "img/disks/hdd-seagate.png",
        image: null
      },
      toshiba: {
        path: "img/disks/hdd-toshiba.png",
        image: null
      },
      loading: {
        path: "img/disks/hdd-loading.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-hdd.png",
        image: null
      }
    }
  },
  loadingFlag: true
};
const diskLocations$h = [
  {
    x: 17,
    y: 36,
    BAY: "1-1",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 47,
    BAY: "1-2",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 72,
    BAY: "1-3",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 83,
    BAY: "1-4",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 94,
    BAY: "1-5",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 105,
    BAY: "1-6",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 129,
    BAY: "1-7",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 140,
    BAY: "1-8",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 107,
    y: 33,
    BAY: "1-9",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 139,
    y: 33,
    BAY: "1-10",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 171,
    y: 33,
    BAY: "1-11",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 203,
    y: 33,
    BAY: "1-12",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 235,
    y: 33,
    BAY: "1-13",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 267,
    y: 33,
    BAY: "1-14",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 299,
    y: 33,
    BAY: "1-15",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 331,
    y: 33,
    BAY: "1-16",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 363,
    y: 33,
    BAY: "1-17",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 395,
    y: 33,
    BAY: "1-18",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 428,
    y: 33,
    BAY: "1-19",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 460,
    y: 33,
    BAY: "1-20",
    HDD: true,
    occupied: false,
    image: null
  }
];
const _sfc_main$k = {
  name: "P5F8X1",
  setup() {
    const diskInfoObj = ref({});
    const currentDisk = inject("currentDisk");
    const lsdevJson = inject("lsdevJson");
    const diskInfo = inject("diskInfo");
    const zfsInfo = inject("zfsInfo");
    const enableZfsAnimations = inject("enableZfsAnimations");
    watch(diskInfo, () => {
      diskInfoObj.value = diskInfo;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$h.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$h[index2].occupied = slot.occupied;
        diskLocations$h[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$h[index2].HDD);
      });
    }, { immediate: true, deep: true });
    watch(lsdevJson, () => {
      diskInfoObj.value = lsdevJson;
      assets$h.loadingFlag = false;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$h.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$h[index2].occupied = slot.occupied;
        diskLocations$h[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$h[index2].HDD);
      });
    }, { immediate: false, deep: true });
    function getDiskImage(occupied, modelName, modelFamily, diskType, slotHdd) {
      if (!occupied) {
        return slotHdd ? assets$h.disks.hdd.empty.image : assets$h.disks.ssd.empty.image;
      }
      if (assets$h.loadingFlag && diskType === "SSD" && slotHdd)
        return assets$h.disks.caddy.loading.image;
      if (assets$h.loadingFlag && diskType === "SSD" && !slotHdd)
        return assets$h.disks.ssd.loading.image;
      if (assets$h.loadingFlag && diskType === "HDD" && !slotHdd)
        return assets$h.disks.ssd.loading.image;
      if (assets$h.loadingFlag && diskType === "HDD")
        return assets$h.disks.hdd.loading.image;
      if (diskType === "SSD" && slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$h.disks.caddy.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$h.disks.caddy.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$h.disks.caddy.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$h.disks.caddy.micron5300.image;
        }
        return assets$h.disks.caddy.default.image;
      }
      if (diskType === "SSD" && !slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$h.disks.ssd.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$h.disks.ssd.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$h.disks.ssd.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$h.disks.ssd.micron5300.image;
        }
        return assets$h.disks.ssd.default.image;
      }
      if (diskType === "HDD" && slotHdd) {
        if (/ST18000|ST16000|ST20000|ST14000|ST12000/.test(modelName)) {
          return assets$h.disks.hdd.seagateSt.image;
        } else if (/Seagate Enterprise/.test(modelFamily)) {
          return assets$h.disks.hdd.seagate.image;
        } else if (/TOSHIBA/.test(modelName)) {
          return assets$h.disks.hdd.toshiba.image;
        } else {
          return assets$h.disks.hdd.default.image;
        }
      }
      if (diskType === "HDD" && !slotHdd) {
        return assets$h.disks.ssd.hdd25.image;
      }
    }
    const p5Script = function(p5) {
      loadingAnimation(p5);
      zfsAnimation(p5);
      p5.preload = (_) => {
        assets$h.chassis.image = p5.loadImage(assets$h.chassis.path);
        assets$h.fade.image = p5.loadImage(assets$h.fade.path);
        Object.entries(assets$h.disks.caddy).forEach(([dsk, val]) => {
          assets$h.disks.caddy[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$h.disks.ssd).forEach(([dsk, val]) => {
          assets$h.disks.ssd[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$h.disks.hdd).forEach(([dsk, val]) => {
          assets$h.disks.hdd[dsk].image = p5.loadImage(val.path);
        });
        diskInfoObj.value.rows.flat().forEach((slot) => {
          const index2 = diskLocations$h.findIndex((loc) => loc.BAY === slot["bay-id"]);
          if (index2 === -1)
            return;
          diskLocations$h[index2].occupied = slot.occupied;
          diskLocations$h[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$h[index2].HDD);
        });
      };
      p5.setup = (_) => {
        const canvas = p5.createCanvas(assets$h.chassis.image.width, assets$h.chassis.image.height + assets$h.fade.image.height);
        canvas.parent("p5-f8x1-storinator");
        p5.image(assets$h.fade.image, 0, 0);
        diskLocations$h.forEach((loc) => {
          loc.y += assets$h.fade.image.height;
        });
        resizeHook(p5, canvas.id(), assets$h.chassis.image.width);
      };
      p5.draw = (_) => {
        if (assets$h.loadingFlag) {
          p5.frameRate(10);
          p5.loadingAnimationIndex = p5.int((p5.loadingAnimationIndex + 1) % p5.loadingAnimationSteps);
        } else {
          p5.frameRate(24);
        }
        p5.image(assets$h.chassis.image, 0, assets$h.fade.image.height);
        diskLocations$h.forEach((loc) => {
          if (loc.occupied && loc.image) {
            p5.image(loc.image, loc.x, loc.y);
            if (assets$h.loadingFlag) {
              p5.animateLoading(loc.x, loc.y, loc.image.width, loc.image.height, p5.animationSteps, p5.animationLoadingIndex);
            }
          }
        });
        if (currentDisk.value) {
          let idx = diskLocations$h.findIndex((loc) => loc.BAY === currentDisk.value);
          if (diskLocations$h[idx].image) {
            if (enableZfsAnimations.flag) {
              p5.showZfs(currentDisk.value, zfsInfo, diskLocations$h);
            }
            p5.fill(255, 255, 255, 50);
            p5.stroke(206, 242, 212);
            p5.strokeWeight(2);
            p5.rect(diskLocations$h[idx].x, diskLocations$h[idx].y, diskLocations$h[idx].image.width, diskLocations$h[idx].image.height);
          }
        }
      };
      p5.mouseClicked = (_) => {
        let mx = p5.mouseX;
        let my = p5.mouseY;
        diskLocations$h.forEach((loc) => {
          if (loc.image && mx > loc.x && mx < loc.x + loc.image.width && my > loc.y && my < loc.y + loc.image.height) {
            currentDisk.value = loc.BAY;
          }
        });
      };
    };
    onMounted(() => {
      new P5(p5Script);
    });
    return {
      diskInfoObj,
      currentDisk,
      lsdevJson,
      diskInfo,
      enableZfsAnimations
    };
  }
};
const _hoisted_1$k = {
  id: "p5-f8x1-storinator",
  class: "self-stretch m-2 flex justify-center"
};
function _sfc_render$k(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1$k);
}
var P5F8X1 = /* @__PURE__ */ _export_sfc(_sfc_main$k, [["render", _sfc_render$k]]);
const assets$g = {
  chassis: {
    path: "img/chassis/f8x2-storinator.png",
    image: null
  },
  fade: {
    path: "img/chassis/chassis-fade.png",
    image: null
  },
  disks: {
    caddy: {
      default: {
        path: "img/disks/caddy-generic.png",
        image: null
      },
      micron5200: {
        path: "img/disks/caddy-micron.png",
        image: null
      },
      micron5300: {
        path: "img/disks/caddy-micron-5300.png",
        image: null
      },
      seagate: {
        path: "img/disks/caddy-seagate.png",
        image: null
      },
      seagateSas: {
        path: "img/disks/caddy-seagate-sas.png",
        image: null
      },
      loading: {
        path: "img/disks/caddy-loading.png",
        image: null
      }
    },
    ssd: {
      micron5200: {
        path: "img/disks/ssd-micron-270.png",
        image: null
      },
      micron5300: {
        path: "img/disks/ssd-micron-5300-270.png",
        image: null
      },
      seagate: {
        path: "img/disks/ssd-seagate-270.png",
        image: null
      },
      seagateSas: {
        path: "img/disks/ssd-seagate-sas-270.png",
        image: null
      },
      default: {
        path: "img/disks/ssd-generic-270.png",
        image: null
      },
      loading: {
        path: "img/disks/ssd-loading-270.png",
        image: null
      },
      hdd25: {
        path: "img/disks/hdd-25-270.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-ssd-270.png",
        image: null
      }
    },
    hdd: {
      default: {
        path: "img/disks/hdd-generic.png",
        image: null
      },
      seagateSt: {
        path: "img/disks/hdd-seagate-st.png",
        image: null
      },
      seagate: {
        path: "img/disks/hdd-seagate.png",
        image: null
      },
      toshiba: {
        path: "img/disks/hdd-toshiba.png",
        image: null
      },
      loading: {
        path: "img/disks/hdd-loading.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-hdd.png",
        image: null
      }
    }
  },
  loadingFlag: true
};
const diskLocations$g = [
  {
    x: 17,
    y: 36,
    BAY: "2-1",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 47,
    BAY: "2-2",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 72,
    BAY: "2-3",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 83,
    BAY: "2-4",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 94,
    BAY: "2-5",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 105,
    BAY: "2-6",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 129,
    BAY: "2-7",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 140,
    BAY: "2-8",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 107,
    y: 33,
    BAY: "2-9",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 139,
    y: 33,
    BAY: "2-10",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 171,
    y: 33,
    BAY: "2-11",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 203,
    y: 33,
    BAY: "2-12",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 235,
    y: 33,
    BAY: "2-13",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 267,
    y: 33,
    BAY: "2-14",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 299,
    y: 33,
    BAY: "2-15",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 331,
    y: 33,
    BAY: "2-16",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 363,
    y: 33,
    BAY: "2-17",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 395,
    y: 33,
    BAY: "2-18",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 428,
    y: 33,
    BAY: "2-19",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 460,
    y: 33,
    BAY: "2-20",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 200,
    BAY: "1-1",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 211,
    BAY: "1-2",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 236,
    BAY: "1-3",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 247,
    BAY: "1-4",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 258,
    BAY: "1-5",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 269,
    BAY: "1-6",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 293,
    BAY: "1-7",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 304,
    BAY: "1-8",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 107,
    y: 197,
    BAY: "1-9",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 139,
    y: 197,
    BAY: "1-10",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 171,
    y: 197,
    BAY: "1-11",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 203,
    y: 197,
    BAY: "1-12",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 235,
    y: 197,
    BAY: "1-13",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 267,
    y: 197,
    BAY: "1-14",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 299,
    y: 197,
    BAY: "1-15",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 331,
    y: 197,
    BAY: "1-16",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 363,
    y: 197,
    BAY: "1-17",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 395,
    y: 197,
    BAY: "1-18",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 428,
    y: 197,
    BAY: "1-19",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 460,
    y: 197,
    BAY: "1-20",
    HDD: true,
    occupied: false,
    image: null
  }
];
const _sfc_main$j = {
  name: "P5F8X2",
  setup() {
    const diskInfoObj = ref({});
    const currentDisk = inject("currentDisk");
    const lsdevJson = inject("lsdevJson");
    const diskInfo = inject("diskInfo");
    const zfsInfo = inject("zfsInfo");
    const enableZfsAnimations = inject("enableZfsAnimations");
    watch(diskInfo, () => {
      diskInfoObj.value = diskInfo;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$g.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$g[index2].occupied = slot.occupied;
        diskLocations$g[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$g[index2].HDD);
      });
    }, { immediate: true, deep: true });
    watch(lsdevJson, () => {
      diskInfoObj.value = lsdevJson;
      assets$g.loadingFlag = false;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$g.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$g[index2].occupied = slot.occupied;
        diskLocations$g[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$g[index2].HDD);
      });
    }, { immediate: false, deep: true });
    function getDiskImage(occupied, modelName, modelFamily, diskType, slotHdd) {
      if (!occupied) {
        return slotHdd ? assets$g.disks.hdd.empty.image : assets$g.disks.ssd.empty.image;
      }
      if (assets$g.loadingFlag && diskType === "SSD" && slotHdd)
        return assets$g.disks.caddy.loading.image;
      if (assets$g.loadingFlag && diskType === "SSD" && !slotHdd)
        return assets$g.disks.ssd.loading.image;
      if (assets$g.loadingFlag && diskType === "HDD" && !slotHdd)
        return assets$g.disks.ssd.loading.image;
      if (assets$g.loadingFlag && diskType === "HDD")
        return assets$g.disks.hdd.loading.image;
      if (diskType === "SSD" && slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$g.disks.caddy.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$g.disks.caddy.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$g.disks.caddy.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$g.disks.caddy.micron5300.image;
        }
        return assets$g.disks.caddy.default.image;
      }
      if (diskType === "SSD" && !slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$g.disks.ssd.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$g.disks.ssd.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$g.disks.ssd.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$g.disks.ssd.micron5300.image;
        }
        return assets$g.disks.ssd.default.image;
      }
      if (diskType === "HDD" && slotHdd) {
        if (/ST18000|ST16000|ST20000|ST14000|ST12000/.test(modelName)) {
          return assets$g.disks.hdd.seagateSt.image;
        } else if (/Seagate Enterprise/.test(modelFamily)) {
          return assets$g.disks.hdd.seagate.image;
        } else if (/TOSHIBA/.test(modelName)) {
          return assets$g.disks.hdd.toshiba.image;
        } else {
          return assets$g.disks.hdd.default.image;
        }
      }
      if (diskType === "HDD" && !slotHdd) {
        return assets$g.disks.ssd.hdd25.image;
      }
    }
    const p5Script = function(p5) {
      loadingAnimation(p5);
      zfsAnimation(p5);
      p5.preload = (_) => {
        assets$g.chassis.image = p5.loadImage(assets$g.chassis.path);
        assets$g.fade.image = p5.loadImage(assets$g.fade.path);
        Object.entries(assets$g.disks.caddy).forEach(([dsk, val]) => {
          assets$g.disks.caddy[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$g.disks.ssd).forEach(([dsk, val]) => {
          assets$g.disks.ssd[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$g.disks.hdd).forEach(([dsk, val]) => {
          assets$g.disks.hdd[dsk].image = p5.loadImage(val.path);
        });
        diskInfoObj.value.rows.flat().forEach((slot) => {
          const index2 = diskLocations$g.findIndex((loc) => loc.BAY === slot["bay-id"]);
          if (index2 === -1)
            return;
          diskLocations$g[index2].occupied = slot.occupied;
          diskLocations$g[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$g[index2].HDD);
        });
      };
      p5.setup = (_) => {
        const canvas = p5.createCanvas(assets$g.chassis.image.width, assets$g.chassis.image.height + assets$g.fade.image.height);
        canvas.parent("p5-f8x2-storinator");
        p5.image(assets$g.fade.image, 0, 0);
        diskLocations$g.forEach((loc) => {
          loc.y += assets$g.fade.image.height;
        });
        resizeHook(p5, canvas.id(), assets$g.chassis.image.width);
      };
      p5.draw = (_) => {
        if (assets$g.loadingFlag) {
          p5.frameRate(10);
          p5.loadingAnimationIndex = p5.int((p5.loadingAnimationIndex + 1) % p5.loadingAnimationSteps);
        } else {
          p5.frameRate(24);
        }
        p5.image(assets$g.chassis.image, 0, assets$g.fade.image.height);
        diskLocations$g.forEach((loc) => {
          if (loc.occupied && loc.image) {
            p5.image(loc.image, loc.x, loc.y);
            if (assets$g.loadingFlag) {
              p5.animateLoading(loc.x, loc.y, loc.image.width, loc.image.height, p5.animationSteps, p5.animationLoadingIndex);
            }
          }
        });
        if (currentDisk.value) {
          let idx = diskLocations$g.findIndex((loc) => loc.BAY === currentDisk.value);
          if (diskLocations$g[idx].image) {
            if (enableZfsAnimations.flag) {
              p5.showZfs(currentDisk.value, zfsInfo, diskLocations$g);
            }
            p5.fill(255, 255, 255, 50);
            p5.stroke(206, 242, 212);
            p5.strokeWeight(2);
            p5.rect(diskLocations$g[idx].x, diskLocations$g[idx].y, diskLocations$g[idx].image.width, diskLocations$g[idx].image.height);
          }
        }
      };
      p5.mouseClicked = (_) => {
        let mx = p5.mouseX;
        let my = p5.mouseY;
        diskLocations$g.forEach((loc) => {
          if (loc.image && mx > loc.x && mx < loc.x + loc.image.width && my > loc.y && my < loc.y + loc.image.height) {
            currentDisk.value = loc.BAY;
          }
        });
      };
    };
    onMounted(() => {
      new P5(p5Script);
    });
    return {
      diskInfoObj,
      currentDisk,
      lsdevJson,
      diskInfo,
      enableZfsAnimations
    };
  }
};
const _hoisted_1$j = {
  id: "p5-f8x2-storinator",
  class: "self-stretch m-2 flex justify-center"
};
function _sfc_render$j(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1$j);
}
var P5F8X2 = /* @__PURE__ */ _export_sfc(_sfc_main$j, [["render", _sfc_render$j]]);
const assets$f = {
  chassis: {
    path: "img/chassis/f8x3-storinator.png",
    image: null
  },
  fade: {
    path: "img/chassis/chassis-fade.png",
    image: null
  },
  disks: {
    caddy: {
      default: {
        path: "img/disks/caddy-generic.png",
        image: null
      },
      micron5200: {
        path: "img/disks/caddy-micron.png",
        image: null
      },
      micron5300: {
        path: "img/disks/caddy-micron-5300.png",
        image: null
      },
      seagate: {
        path: "img/disks/caddy-seagate.png",
        image: null
      },
      seagateSas: {
        path: "img/disks/caddy-seagate-sas.png",
        image: null
      },
      loading: {
        path: "img/disks/caddy-loading.png",
        image: null
      }
    },
    ssd: {
      micron5200: {
        path: "img/disks/ssd-micron-270.png",
        image: null
      },
      micron5300: {
        path: "img/disks/ssd-micron-5300-270.png",
        image: null
      },
      seagate: {
        path: "img/disks/ssd-seagate-270.png",
        image: null
      },
      seagateSas: {
        path: "img/disks/ssd-seagate-sas-270.png",
        image: null
      },
      default: {
        path: "img/disks/ssd-generic-270.png",
        image: null
      },
      loading: {
        path: "img/disks/ssd-loading-270.png",
        image: null
      },
      hdd25: {
        path: "img/disks/hdd-25-270.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-ssd-270.png",
        image: null
      }
    },
    hdd: {
      default: {
        path: "img/disks/hdd-generic.png",
        image: null
      },
      seagateSt: {
        path: "img/disks/hdd-seagate-st.png",
        image: null
      },
      seagate: {
        path: "img/disks/hdd-seagate.png",
        image: null
      },
      toshiba: {
        path: "img/disks/hdd-toshiba.png",
        image: null
      },
      loading: {
        path: "img/disks/hdd-loading.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-hdd.png",
        image: null
      }
    }
  },
  loadingFlag: true
};
const diskLocations$f = [
  {
    x: 17,
    y: 36,
    BAY: "3-1",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 47,
    BAY: "3-2",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 72,
    BAY: "3-3",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 83,
    BAY: "3-4",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 94,
    BAY: "3-5",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 105,
    BAY: "3-6",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 129,
    BAY: "3-7",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 140,
    BAY: "3-8",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 107,
    y: 33,
    BAY: "3-9",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 139,
    y: 33,
    BAY: "3-10",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 171,
    y: 33,
    BAY: "3-11",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 203,
    y: 33,
    BAY: "3-12",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 235,
    y: 33,
    BAY: "3-13",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 267,
    y: 33,
    BAY: "3-14",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 299,
    y: 33,
    BAY: "3-15",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 331,
    y: 33,
    BAY: "3-16",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 363,
    y: 33,
    BAY: "3-17",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 395,
    y: 33,
    BAY: "3-18",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 428,
    y: 33,
    BAY: "3-19",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 460,
    y: 33,
    BAY: "3-20",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 200,
    BAY: "2-1",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 211,
    BAY: "2-2",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 236,
    BAY: "2-3",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 247,
    BAY: "2-4",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 258,
    BAY: "2-5",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 269,
    BAY: "2-6",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 293,
    BAY: "2-7",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 304,
    BAY: "2-8",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 107,
    y: 197,
    BAY: "2-9",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 139,
    y: 197,
    BAY: "2-10",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 171,
    y: 197,
    BAY: "2-11",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 203,
    y: 197,
    BAY: "2-12",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 235,
    y: 197,
    BAY: "2-13",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 267,
    y: 197,
    BAY: "2-14",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 299,
    y: 197,
    BAY: "2-15",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 331,
    y: 197,
    BAY: "2-16",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 363,
    y: 197,
    BAY: "2-17",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 395,
    y: 197,
    BAY: "2-18",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 428,
    y: 197,
    BAY: "2-19",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 460,
    y: 197,
    BAY: "2-20",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 364,
    BAY: "1-1",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 375,
    BAY: "1-2",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 400,
    BAY: "1-3",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 411,
    BAY: "1-4",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 422,
    BAY: "1-5",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 433,
    BAY: "1-6",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 457,
    BAY: "1-7",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 17,
    y: 468,
    BAY: "1-8",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 107,
    y: 361,
    BAY: "1-9",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 139,
    y: 361,
    BAY: "1-10",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 171,
    y: 361,
    BAY: "1-11",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 203,
    y: 361,
    BAY: "1-12",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 235,
    y: 361,
    BAY: "1-13",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 267,
    y: 361,
    BAY: "1-14",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 299,
    y: 361,
    BAY: "1-15",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 331,
    y: 361,
    BAY: "1-16",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 363,
    y: 361,
    BAY: "1-17",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 395,
    y: 361,
    BAY: "1-18",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 428,
    y: 361,
    BAY: "1-19",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 460,
    y: 361,
    BAY: "1-20",
    HDD: true,
    occupied: false,
    image: null
  }
];
const _sfc_main$i = {
  name: "P5F8X3",
  setup() {
    const diskInfoObj = ref({});
    const currentDisk = inject("currentDisk");
    const lsdevJson = inject("lsdevJson");
    const diskInfo = inject("diskInfo");
    const zfsInfo = inject("zfsInfo");
    const enableZfsAnimations = inject("enableZfsAnimations");
    watch(diskInfo, () => {
      diskInfoObj.value = diskInfo;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$f.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$f[index2].occupied = slot.occupied;
        diskLocations$f[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$f[index2].HDD);
      });
    }, { immediate: true, deep: true });
    watch(lsdevJson, () => {
      diskInfoObj.value = lsdevJson;
      assets$f.loadingFlag = false;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$f.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$f[index2].occupied = slot.occupied;
        diskLocations$f[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$f[index2].HDD);
      });
    }, { immediate: false, deep: true });
    function getDiskImage(occupied, modelName, modelFamily, diskType, slotHdd) {
      if (!occupied) {
        return slotHdd ? assets$f.disks.hdd.empty.image : assets$f.disks.ssd.empty.image;
      }
      if (assets$f.loadingFlag && diskType === "SSD" && slotHdd)
        return assets$f.disks.caddy.loading.image;
      if (assets$f.loadingFlag && diskType === "SSD" && !slotHdd)
        return assets$f.disks.ssd.loading.image;
      if (assets$f.loadingFlag && diskType === "HDD" && !slotHdd)
        return assets$f.disks.ssd.loading.image;
      if (assets$f.loadingFlag && diskType === "HDD")
        return assets$f.disks.hdd.loading.image;
      if (diskType === "SSD" && slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$f.disks.caddy.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$f.disks.caddy.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$f.disks.caddy.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$f.disks.caddy.micron5300.image;
        }
        return assets$f.disks.caddy.default.image;
      }
      if (diskType === "SSD" && !slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$f.disks.ssd.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$f.disks.ssd.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$f.disks.ssd.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$f.disks.ssd.micron5300.image;
        }
        return assets$f.disks.ssd.default.image;
      }
      if (diskType === "HDD" && slotHdd) {
        if (/ST18000|ST16000|ST20000|ST14000|ST12000/.test(modelName)) {
          return assets$f.disks.hdd.seagateSt.image;
        } else if (/Seagate Enterprise/.test(modelFamily)) {
          return assets$f.disks.hdd.seagate.image;
        } else if (/TOSHIBA/.test(modelName)) {
          return assets$f.disks.hdd.toshiba.image;
        } else {
          return assets$f.disks.hdd.default.image;
        }
      }
      if (diskType === "HDD" && !slotHdd) {
        return assets$f.disks.ssd.hdd25.image;
      }
    }
    const p5Script = function(p5) {
      loadingAnimation(p5);
      zfsAnimation(p5);
      p5.preload = (_) => {
        assets$f.chassis.image = p5.loadImage(assets$f.chassis.path);
        assets$f.fade.image = p5.loadImage(assets$f.fade.path);
        Object.entries(assets$f.disks.caddy).forEach(([dsk, val]) => {
          assets$f.disks.caddy[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$f.disks.ssd).forEach(([dsk, val]) => {
          assets$f.disks.ssd[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$f.disks.hdd).forEach(([dsk, val]) => {
          assets$f.disks.hdd[dsk].image = p5.loadImage(val.path);
        });
        diskInfoObj.value.rows.flat().forEach((slot) => {
          const index2 = diskLocations$f.findIndex((loc) => loc.BAY === slot["bay-id"]);
          if (index2 === -1)
            return;
          diskLocations$f[index2].occupied = slot.occupied;
          diskLocations$f[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$f[index2].HDD);
        });
      };
      p5.setup = (_) => {
        const canvas = p5.createCanvas(assets$f.chassis.image.width, assets$f.chassis.image.height + assets$f.fade.image.height);
        canvas.parent("p5-f8x3-storinator");
        p5.image(assets$f.fade.image, 0, 0);
        diskLocations$f.forEach((loc) => {
          loc.y += assets$f.fade.image.height;
        });
        resizeHook(p5, canvas.id(), assets$f.chassis.image.width);
      };
      p5.draw = (_) => {
        if (assets$f.loadingFlag) {
          p5.frameRate(10);
          p5.loadingAnimationIndex = p5.int((p5.loadingAnimationIndex + 1) % p5.loadingAnimationSteps);
        } else {
          p5.frameRate(24);
        }
        p5.image(assets$f.chassis.image, 0, assets$f.fade.image.height);
        diskLocations$f.forEach((loc) => {
          if (loc.occupied && loc.image) {
            p5.image(loc.image, loc.x, loc.y);
            if (assets$f.loadingFlag) {
              p5.animateLoading(loc.x, loc.y, loc.image.width, loc.image.height, p5.animationSteps, p5.animationLoadingIndex);
            }
          }
        });
        if (currentDisk.value) {
          let idx = diskLocations$f.findIndex((loc) => loc.BAY === currentDisk.value);
          if (diskLocations$f[idx].image) {
            if (enableZfsAnimations.flag) {
              p5.showZfs(currentDisk.value, zfsInfo, diskLocations$f);
            }
            p5.fill(255, 255, 255, 50);
            p5.stroke(206, 242, 212);
            p5.strokeWeight(2);
            p5.rect(diskLocations$f[idx].x, diskLocations$f[idx].y, diskLocations$f[idx].image.width, diskLocations$f[idx].image.height);
          }
        }
      };
      p5.mouseClicked = (_) => {
        let mx = p5.mouseX;
        let my = p5.mouseY;
        diskLocations$f.forEach((loc) => {
          if (loc.image && mx > loc.x && mx < loc.x + loc.image.width && my > loc.y && my < loc.y + loc.image.height) {
            currentDisk.value = loc.BAY;
          }
        });
      };
    };
    onMounted(() => {
      new P5(p5Script);
    });
    return {
      diskInfoObj,
      currentDisk,
      lsdevJson,
      diskInfo,
      enableZfsAnimations
    };
  }
};
const _hoisted_1$i = {
  id: "p5-f8x3-storinator",
  class: "self-stretch m-2 flex justify-center"
};
function _sfc_render$i(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1$i);
}
var P5F8X3 = /* @__PURE__ */ _export_sfc(_sfc_main$i, [["render", _sfc_render$i]]);
const assets$e = {
  chassis: {
    path: "img/chassis/2u-stornado-chassis.png",
    image: null
  },
  disks: {
    caddy: {
      loading: {
        path: "img/disks/ssd-loading-2u.png",
        image: null
      },
      default: {
        path: "img/disks/ssd-loading-2u.png",
        image: null
      }
    },
    ssd: {
      default: {
        path: "img/disks/ssd-generic-2u.png",
        image: null
      },
      micron5200: {
        path: "img/disks/ssd-micron-2u.png",
        image: null
      },
      micron5300: {
        path: "img/disks/ssd-micron-5300-2u.png",
        image: null
      },
      seagate: {
        path: "img/disks/ssd-seagate-2u.png",
        image: null
      },
      seagateSas: {
        path: "img/disks/ssd-seagate-sas-2u.png",
        image: null
      },
      loading: {
        path: "img/disks/ssd-loading-2u.png",
        image: null
      },
      hdd25: {
        path: "img/disks/hdd-25-2u.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-2u.png",
        image: null
      }
    },
    hdd: {
      loading: {
        path: "img/disks/ssd-loading-2u.png",
        image: null
      },
      default: {
        path: "img/disks/ssd-loading-2u.png",
        image: null
      }
    }
  },
  loadingFlag: true
};
const diskLocations$e = [
  {
    x: 101,
    y: 30,
    BAY: "1-1",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 123,
    y: 30,
    BAY: "1-2",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 177,
    y: 30,
    BAY: "1-3",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 200,
    y: 30,
    BAY: "1-4",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 223,
    y: 30,
    BAY: "1-5",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 246,
    y: 30,
    BAY: "1-6",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 299,
    y: 30,
    BAY: "1-7",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 322,
    y: 30,
    BAY: "1-8",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 347,
    y: 30,
    BAY: "1-9",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 369,
    y: 30,
    BAY: "1-10",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 423,
    y: 30,
    BAY: "1-11",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 446,
    y: 30,
    BAY: "1-12",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 468,
    y: 30,
    BAY: "1-13",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 491,
    y: 30,
    BAY: "1-14",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 545,
    y: 30,
    BAY: "1-15",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 568,
    y: 30,
    BAY: "1-16",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 592,
    y: 30,
    BAY: "2-1",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 615,
    y: 30,
    BAY: "2-2",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 669,
    y: 30,
    BAY: "2-3",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 692,
    y: 30,
    BAY: "2-4",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 714,
    y: 30,
    BAY: "2-5",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 737,
    y: 30,
    BAY: "2-6",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 791,
    y: 30,
    BAY: "2-7",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 814,
    y: 30,
    BAY: "2-8",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 839,
    y: 30,
    BAY: "2-9",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 861,
    y: 30,
    BAY: "2-10",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 915,
    y: 30,
    BAY: "2-11",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 938,
    y: 30,
    BAY: "2-12",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 961,
    y: 30,
    BAY: "2-13",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 984,
    y: 30,
    BAY: "2-14",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 1037,
    y: 30,
    BAY: "2-15",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 1060,
    y: 30,
    BAY: "2-16",
    HDD: false,
    occupied: false,
    image: null
  }
];
const _sfc_main$h = {
  name: "P5Stornado2U",
  setup() {
    const diskInfoObj = ref({});
    const currentDisk = inject("currentDisk");
    const lsdevJson = inject("lsdevJson");
    const diskInfo = inject("diskInfo");
    const zfsInfo = inject("zfsInfo");
    const enableZfsAnimations = inject("enableZfsAnimations");
    watch(lsdevJson, () => {
      diskInfoObj.value = lsdevJson;
      assets$e.loadingFlag = false;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$e.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$e[index2].occupied = slot.occupied;
        diskLocations$e[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$e[index2].HDD);
      });
      assets$e.loadingFlag = false;
    }, { immediate: false, deep: true });
    watch(diskInfo, () => {
      diskInfoObj.value = diskInfo;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$e.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$e[index2].occupied = slot.occupied;
        diskLocations$e[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$e[index2].HDD);
      });
    }, { immediate: true, deep: true });
    watch(enableZfsAnimations, () => {
    }, { immediate: true, deep: true });
    function getDiskImage(occupied, modelName, modelFamily, diskType, slotHdd) {
      if (!occupied) {
        return slotHdd ? null : assets$e.disks.ssd.empty.image;
      }
      if (assets$e.loadingFlag && diskType === "SSD" && slotHdd)
        return assets$e.disks.caddy.loading.image;
      if (assets$e.loadingFlag && diskType === "SSD" && !slotHdd)
        return assets$e.disks.ssd.loading.image;
      if (assets$e.loadingFlag && diskType === "HDD" && !slotHdd)
        return assets$e.disks.ssd.loading.image;
      if (assets$e.loadingFlag && diskType === "HDD")
        return assets$e.disks.hdd.loading.image;
      if (diskType === "SSD" && slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$e.disks.caddy.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$e.disks.caddy.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$e.disks.caddy.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$e.disks.caddy.micron5300.image;
        }
        return assets$e.disks.caddy.default.image;
      }
      if (diskType === "SSD" && !slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$e.disks.ssd.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$e.disks.ssd.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$e.disks.ssd.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$e.disks.ssd.micron5300.image;
        }
        return assets$e.disks.ssd.default.image;
      }
      if (diskType === "HDD" && slotHdd) {
        if (/ST18000|ST16000|ST20000|ST14000|ST12000/.test(modelName)) {
          return assets$e.disks.hdd.seagateSt.image;
        } else if (/Seagate Enterprise/.test(modelFamily)) {
          return assets$e.disks.hdd.seagate.image;
        } else if (/TOSHIBA/.test(modelName)) {
          return assets$e.disks.hdd.toshiba.image;
        } else {
          return assets$e.disks.hdd.default.image;
        }
      }
      if (diskType === "HDD" && !slotHdd) {
        return assets$e.disks.ssd.hdd25.image;
      }
    }
    const p5Script = function(p5) {
      loadingAnimation(p5);
      zfsAnimation(p5);
      p5.preload = (_) => {
        assets$e.loadingFlag = true;
        assets$e.chassis.image = p5.loadImage(assets$e.chassis.path);
        Object.entries(assets$e.disks.caddy).forEach(([dsk, val]) => {
          assets$e.disks.caddy[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$e.disks.ssd).forEach(([dsk, val]) => {
          assets$e.disks.ssd[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$e.disks.hdd).forEach(([dsk, val]) => {
          assets$e.disks.hdd[dsk].image = p5.loadImage(val.path);
        });
        diskInfoObj.value.rows.flat().forEach((slot) => {
          const index2 = diskLocations$e.findIndex((loc) => loc.BAY === slot["bay-id"]);
          diskLocations$e[index2].occupied = slot.occupied;
          diskLocations$e[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$e[index2].HDD);
        });
      };
      p5.setup = (_) => {
        const canvas = p5.createCanvas(assets$e.chassis.image.width, assets$e.chassis.image.height);
        canvas.parent("p5-stornado2u");
        p5.frameRate(24);
        resizeHook(p5, canvas.id(), assets$e.chassis.image.width);
      };
      p5.draw = (_) => {
        if (assets$e.loadingFlag) {
          p5.frameRate(10);
          p5.loadingAnimationIndex = p5.int((p5.loadingAnimationIndex + 1) % p5.loadingAnimationSteps);
        } else {
          p5.frameRate(24);
        }
        p5.image(assets$e.chassis.image, 0, 0);
        diskLocations$e.forEach((loc) => {
          if (loc.occupied && loc.image) {
            p5.image(loc.image, loc.x, loc.y);
            if (assets$e.loadingFlag) {
              p5.animateLoading(loc.x, loc.y, loc.image.width, loc.image.height - 14);
            }
          }
        });
        if (currentDisk.value) {
          let idx = diskLocations$e.findIndex((loc) => loc.BAY === currentDisk.value);
          if (diskLocations$e[idx].image) {
            if (enableZfsAnimations.flag) {
              p5.showZfs(currentDisk.value, zfsInfo, diskLocations$e, -14);
            }
            p5.fill(255, 255, 255, 50);
            p5.stroke(206, 242, 212);
            p5.strokeWeight(2);
            p5.rect(diskLocations$e[idx].x, diskLocations$e[idx].y, diskLocations$e[idx].image.width, diskLocations$e[idx].image.height - 14);
          }
        }
      };
      p5.mouseClicked = (_) => {
        let mx = p5.mouseX;
        let my = p5.mouseY;
        diskLocations$e.forEach((loc) => {
          if (loc.image && mx > loc.x && mx < loc.x + loc.image.width && my > loc.y && my < loc.y + loc.image.height) {
            currentDisk.value = loc.BAY;
          }
        });
      };
    };
    onMounted(() => {
      new P5(p5Script);
    });
    return {
      diskInfoObj,
      currentDisk,
      lsdevJson,
      diskInfo,
      enableZfsAnimations
    };
  }
};
const _hoisted_1$h = {
  id: "p5-stornado2u",
  class: "self-stretch m-2 flex justify-center"
};
function _sfc_render$h(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1$h);
}
var P5Stornado2U = /* @__PURE__ */ _export_sfc(_sfc_main$h, [["render", _sfc_render$h]]);
const assets$d = {
  chassis: {
    path: "img/chassis/q30-storinator.png",
    image: null
  },
  fade: {
    path: "img/chassis/chassis-fade.png",
    image: null
  },
  disks: {
    caddy: {
      default: {
        path: "img/disks/caddy-generic.png",
        image: null
      },
      micron5200: {
        path: "img/disks/caddy-micron.png",
        image: null
      },
      micron5300: {
        path: "img/disks/caddy-micron-5300.png",
        image: null
      },
      seagate: {
        path: "img/disks/caddy-seagate.png",
        image: null
      },
      seagateSas: {
        path: "img/disks/caddy-seagate-sas.png",
        image: null
      },
      loading: {
        path: "img/disks/caddy-loading.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-caddy.png",
        image: null
      }
    },
    ssd: {
      loading: {
        path: "img/disks/ssd-loading.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-ssd.png",
        image: null
      }
    },
    hdd: {
      default: {
        path: "img/disks/hdd-generic.png",
        image: null
      },
      seagateSt: {
        path: "img/disks/hdd-seagate-st.png",
        image: null
      },
      seagate: {
        path: "img/disks/hdd-seagate.png",
        image: null
      },
      toshiba: {
        path: "img/disks/hdd-toshiba.png",
        image: null
      },
      loading: {
        path: "img/disks/hdd-loading.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-hdd.png",
        image: null
      }
    }
  },
  loadingFlag: true
};
const diskLocations$d = [
  {
    x: 459,
    y: 197,
    BAY: "1-1",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 427,
    y: 197,
    BAY: "1-2",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 394,
    y: 197,
    BAY: "1-3",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 362,
    y: 197,
    BAY: "1-4",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 330,
    y: 197,
    BAY: "1-5",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 298,
    y: 197,
    BAY: "1-6",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 266,
    y: 197,
    BAY: "1-7",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 234,
    y: 197,
    BAY: "1-8",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 202,
    y: 197,
    BAY: "1-9",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 170,
    y: 197,
    BAY: "1-10",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 138,
    y: 197,
    BAY: "1-11",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 106,
    y: 197,
    BAY: "1-12",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 74,
    y: 197,
    BAY: "1-13",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 42,
    y: 197,
    BAY: "1-14",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 10,
    y: 197,
    BAY: "1-15",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 459,
    y: 33,
    BAY: "2-1",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 427,
    y: 33,
    BAY: "2-2",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 394,
    y: 33,
    BAY: "2-3",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 362,
    y: 33,
    BAY: "2-4",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 330,
    y: 33,
    BAY: "2-5",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 298,
    y: 33,
    BAY: "2-6",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 266,
    y: 33,
    BAY: "2-7",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 234,
    y: 33,
    BAY: "2-8",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 202,
    y: 33,
    BAY: "2-9",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 170,
    y: 33,
    BAY: "2-10",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 138,
    y: 33,
    BAY: "2-11",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 106,
    y: 33,
    BAY: "2-12",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 74,
    y: 33,
    BAY: "2-13",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 42,
    y: 33,
    BAY: "2-14",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 10,
    y: 33,
    BAY: "2-15",
    HDD: true,
    occupied: false,
    image: null
  }
];
const _sfc_main$g = {
  name: "P5StorinatorQ30",
  setup() {
    const diskInfoObj = ref({});
    const currentDisk = inject("currentDisk");
    const lsdevJson = inject("lsdevJson");
    const diskInfo = inject("diskInfo");
    const zfsInfo = inject("zfsInfo");
    const enableZfsAnimations = inject("enableZfsAnimations");
    const getDiskImage = (occupied, modelName, modelFamily, diskType, slotHdd) => {
      if (!occupied) {
        return slotHdd ? assets$d.disks.hdd.empty.image : assets$d.disks.ssd.empty.image;
      }
      if (assets$d.loadingFlag && diskType === "SSD" && slotHdd)
        return assets$d.disks.caddy.loading.image;
      if (assets$d.loadingFlag && diskType === "SSD" && !slotHdd)
        return assets$d.disks.caddy.loading.image;
      if (assets$d.loadingFlag && diskType === "HDD")
        return assets$d.disks.hdd.loading.image;
      if (diskType === "SSD" && slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$d.disks.caddy.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$d.disks.caddy.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$d.disks.caddy.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$d.disks.caddy.micron5300.image;
        }
        return assets$d.disks.caddy.default.image;
      }
      if (diskType === "SSD" && !slotHdd) {
        return assets$d.disks.caddy.default.image;
      }
      if (diskType === "HDD") {
        if (/ST18000|ST16000|ST20000|ST14000|ST12000/.test(modelName)) {
          return assets$d.disks.hdd.seagateSt.image;
        } else if (/Seagate Enterprise/.test(modelFamily)) {
          return assets$d.disks.hdd.seagate.image;
        } else if (/TOSHIBA/.test(modelName)) {
          return assets$d.disks.hdd.toshiba.image;
        } else {
          return assets$d.disks.hdd.default.image;
        }
      }
    };
    watch(lsdevJson, () => {
      diskInfoObj.value = lsdevJson;
      assets$d.loadingFlag = false;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$d.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$d[index2].occupied = slot.occupied;
        diskLocations$d[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$d[index2].HDD);
      });
    }, { immediate: false, deep: true });
    watch(diskInfo, () => {
      diskInfoObj.value = diskInfo;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$d.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$d[index2].occupied = slot.occupied;
        diskLocations$d[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$d[index2].HDD);
      });
    }, { immediate: true, deep: true });
    const p5Script = function(p5) {
      loadingAnimation(p5);
      zfsAnimation(p5);
      p5.preload = (_) => {
        assets$d.loadingFlag = true;
        assets$d.chassis.image = p5.loadImage(assets$d.chassis.path);
        assets$d.fade.image = p5.loadImage(assets$d.fade.path);
        Object.entries(assets$d.disks.caddy).forEach(([dsk, val]) => {
          assets$d.disks.caddy[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$d.disks.ssd).forEach(([dsk, val]) => {
          assets$d.disks.ssd[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$d.disks.hdd).forEach(([dsk, val]) => {
          assets$d.disks.hdd[dsk].image = p5.loadImage(val.path);
        });
        diskInfoObj.value.rows.flat().forEach((slot) => {
          const index2 = diskLocations$d.findIndex((loc) => loc.BAY === slot["bay-id"]);
          if (index2 === -1)
            return;
          diskLocations$d[index2].occupied = slot.occupied;
          diskLocations$d[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$d[index2].HDD);
        });
      };
      p5.setup = (_) => {
        const canvas = p5.createCanvas(assets$d.chassis.image.width, assets$d.chassis.image.height + assets$d.fade.image.height);
        canvas.parent("p5-q30-storinator");
        p5.image(assets$d.fade.image, 0, 0);
        diskLocations$d.forEach((loc) => {
          loc.y += assets$d.fade.image.height;
        });
        resizeHook(p5, canvas.id(), assets$d.chassis.image.width);
      };
      p5.draw = (_) => {
        if (assets$d.loadingFlag) {
          p5.frameRate(10);
          p5.loadingAnimationIndex = p5.int((p5.loadingAnimationIndex + 1) % p5.loadingAnimationSteps);
        } else {
          p5.frameRate(24);
        }
        p5.image(assets$d.chassis.image, 0, assets$d.fade.image.height);
        diskLocations$d.forEach((loc) => {
          if (loc.occupied && loc.image) {
            p5.image(loc.image, loc.x, loc.y);
            if (assets$d.loadingFlag) {
              p5.animateLoading(loc.x, loc.y, loc.image.width, loc.image.height, p5.animationSteps, p5.animationLoadingIndex);
            }
          }
        });
        if (currentDisk.value) {
          let idx = diskLocations$d.findIndex((loc) => loc.BAY === currentDisk.value);
          if (diskLocations$d[idx].image) {
            if (enableZfsAnimations.flag) {
              p5.showZfs(currentDisk.value, zfsInfo, diskLocations$d);
            }
            p5.fill(255, 255, 255, 50);
            p5.stroke(206, 242, 212);
            p5.strokeWeight(2);
            p5.rect(diskLocations$d[idx].x, diskLocations$d[idx].y, diskLocations$d[idx].image.width, diskLocations$d[idx].image.height);
          }
        }
      };
      p5.mouseClicked = (_) => {
        let mx = p5.mouseX;
        let my = p5.mouseY;
        diskLocations$d.forEach((loc) => {
          if (loc.image && mx > loc.x && mx < loc.x + loc.image.width && my > loc.y && my < loc.y + loc.image.height) {
            currentDisk.value = loc.BAY;
          }
        });
      };
    };
    onMounted(() => {
      new P5(p5Script);
    });
    return {
      diskInfoObj,
      currentDisk,
      lsdevJson,
      diskInfo,
      getDiskImage,
      enableZfsAnimations
    };
  }
};
const _hoisted_1$g = {
  id: "p5-q30-storinator",
  class: "self-stretch m-2 flex justify-center"
};
function _sfc_render$g(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1$g);
}
var P5StorinatorQ30 = /* @__PURE__ */ _export_sfc(_sfc_main$g, [["render", _sfc_render$g]]);
const assets$c = {
  chassis: {
    path: "img/chassis/stornado.png",
    image: null
  },
  fade: {
    path: "img/chassis/chassis-fade.png",
    image: null
  },
  disks: {
    caddy: {
      loading: {
        path: "img/disks/ssd-loading.png",
        image: null
      },
      default: {
        path: "img/disks/ssd-loading.png",
        image: null
      }
    },
    ssd: {
      default: {
        path: "img/disks/ssd-generic.png",
        image: null
      },
      micron5200: {
        path: "img/disks/ssd-micron.png",
        image: null
      },
      micron5300: {
        path: "img/disks/ssd-micron-5300.png",
        image: null
      },
      seagate: {
        path: "img/disks/ssd-seagate.png",
        image: null
      },
      seagateSas: {
        path: "img/disks/ssd-seagate-sas.png",
        image: null
      },
      loading: {
        path: "img/disks/ssd-loading.png",
        image: null
      },
      hdd25: {
        path: "img/disks/hdd-25.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-ssd.png",
        image: null
      }
    },
    hdd: {
      loading: {
        path: "img/disks/ssd-loading.png",
        image: null
      },
      default: {
        path: "img/disks/ssd-loading.png",
        image: null
      }
    }
  },
  loadingFlag: true
};
const diskLocations$c = [
  {
    x: 476,
    y: 46,
    BAY: "1-1",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 464,
    y: 46,
    BAY: "1-2",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 439,
    y: 46,
    BAY: "1-3",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 428,
    y: 46,
    BAY: "1-4",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 417,
    y: 46,
    BAY: "1-5",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 406,
    y: 46,
    BAY: "1-6",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 382,
    y: 46,
    BAY: "1-7",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 371,
    y: 46,
    BAY: "1-8",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 358,
    y: 46,
    BAY: "1-9",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 347,
    y: 46,
    BAY: "1-10",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 322,
    y: 46,
    BAY: "1-11",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 311,
    y: 46,
    BAY: "1-12",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 300,
    y: 46,
    BAY: "1-13",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 289,
    y: 46,
    BAY: "1-14",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 265,
    y: 46,
    BAY: "1-15",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 254,
    y: 46,
    BAY: "1-16",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 238,
    y: 46,
    BAY: "2-1",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 227,
    y: 46,
    BAY: "2-2",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 202,
    y: 46,
    BAY: "2-3",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 191,
    y: 46,
    BAY: "2-4",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 180,
    y: 46,
    BAY: "2-5",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 169,
    y: 46,
    BAY: "2-6",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 145,
    y: 46,
    BAY: "2-7",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 134,
    y: 46,
    BAY: "2-8",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 121,
    y: 46,
    BAY: "2-9",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 110,
    y: 46,
    BAY: "2-10",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 85,
    y: 46,
    BAY: "2-11",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 74,
    y: 46,
    BAY: "2-12",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 63,
    y: 46,
    BAY: "2-13",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 52,
    y: 46,
    BAY: "2-14",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 27,
    y: 46,
    BAY: "2-15",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 16,
    y: 46,
    BAY: "2-16",
    HDD: false,
    occupied: false,
    image: null
  }
];
const _sfc_main$f = {
  name: "P5Stornado",
  setup() {
    const diskInfoObj = ref({});
    const currentDisk = inject("currentDisk");
    const lsdevJson = inject("lsdevJson");
    const diskInfo = inject("diskInfo");
    const zfsInfo = inject("zfsInfo");
    const enableZfsAnimations = inject("enableZfsAnimations");
    function getDiskImage(occupied, modelName, modelFamily, diskType, slotHdd) {
      if (!occupied) {
        return slotHdd ? null : assets$c.disks.ssd.empty.image;
      }
      if (assets$c.loadingFlag && diskType === "SSD" && slotHdd)
        return assets$c.disks.caddy.loading.image;
      if (assets$c.loadingFlag && diskType === "SSD" && !slotHdd)
        return assets$c.disks.ssd.loading.image;
      if (assets$c.loadingFlag && diskType === "HDD" && !slotHdd)
        return assets$c.disks.ssd.loading.image;
      if (assets$c.loadingFlag && diskType === "HDD")
        return assets$c.disks.hdd.loading.image;
      if (diskType === "SSD" && slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$c.disks.caddy.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$c.disks.caddy.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$c.disks.caddy.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$c.disks.caddy.micron5300.image;
        }
        return assets$c.disks.caddy.default.image;
      }
      if (diskType === "SSD" && !slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$c.disks.ssd.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$c.disks.ssd.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$c.disks.ssd.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$c.disks.ssd.micron5300.image;
        }
        return assets$c.disks.ssd.default.image;
      }
      if (diskType === "HDD" && slotHdd) {
        if (/ST18000|ST16000|ST20000|ST14000|ST12000/.test(modelName)) {
          return assets$c.disks.hdd.seagateSt.image;
        } else if (/Seagate Enterprise/.test(modelFamily)) {
          return assets$c.disks.hdd.seagate.image;
        } else if (/TOSHIBA/.test(modelName)) {
          return assets$c.disks.hdd.toshiba.image;
        } else {
          return assets$c.disks.hdd.default.image;
        }
      }
      if (diskType === "HDD" && !slotHdd) {
        return assets$c.disks.ssd.hdd25.image;
      }
    }
    watch(lsdevJson, () => {
      diskInfoObj.value = lsdevJson;
      assets$c.loadingFlag = false;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$c.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$c[index2].occupied = slot.occupied;
        diskLocations$c[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$c[index2].HDD);
      });
    }, { immediate: false, deep: true });
    watch(diskInfo, () => {
      diskInfoObj.value = diskInfo;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$c.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$c[index2].occupied = slot.occupied;
        diskLocations$c[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$c[index2].HDD);
      });
    }, { immediate: true, deep: true });
    const p5Script = function(p5) {
      loadingAnimation(p5);
      zfsAnimation(p5);
      p5.preload = (_) => {
        assets$c.chassis.image = p5.loadImage(assets$c.chassis.path);
        assets$c.fade.image = p5.loadImage(assets$c.fade.path);
        Object.entries(assets$c.disks.caddy).forEach(([dsk, val]) => {
          assets$c.disks.caddy[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$c.disks.ssd).forEach(([dsk, val]) => {
          assets$c.disks.ssd[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$c.disks.hdd).forEach(([dsk, val]) => {
          assets$c.disks.hdd[dsk].image = p5.loadImage(val.path);
        });
        diskInfoObj.value.rows.flat().forEach((slot) => {
          const index2 = diskLocations$c.findIndex((loc) => loc.BAY === slot["bay-id"]);
          if (index2 == -1)
            return;
          diskLocations$c[index2].occupied = slot.occupied;
          diskLocations$c[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$c[index2].HDD);
        });
      };
      p5.setup = (_) => {
        const canvas = p5.createCanvas(assets$c.chassis.image.width, assets$c.chassis.image.height + assets$c.fade.image.height);
        canvas.parent("p5-av15-stornado");
        p5.image(assets$c.fade.image, 0, 0);
        diskLocations$c.forEach((loc) => {
          loc.y += assets$c.fade.image.height;
        });
        resizeHook(p5, canvas.id(), assets$c.chassis.image.width);
      };
      p5.draw = (_) => {
        if (assets$c.loadingFlag) {
          p5.frameRate(10);
          p5.loadingAnimationIndex = p5.int((p5.loadingAnimationIndex + 1) % p5.loadingAnimationSteps);
        } else {
          p5.frameRate(24);
        }
        p5.image(assets$c.chassis.image, 0, assets$c.fade.image.height);
        diskLocations$c.forEach((loc) => {
          if (loc.occupied && loc.image) {
            p5.image(loc.image, loc.x, loc.y);
            if (assets$c.loadingFlag) {
              p5.animateLoading(loc.x, loc.y, loc.image.width, loc.image.height, p5.animationSteps, p5.loadingAnimationIndex);
            }
          }
        });
        if (currentDisk.value) {
          let idx = diskLocations$c.findIndex((loc) => loc.BAY === currentDisk.value);
          if (diskLocations$c[idx].image) {
            if (enableZfsAnimations.flag) {
              p5.showZfs(currentDisk.value, zfsInfo, diskLocations$c);
            }
            p5.fill(255, 255, 255, 50);
            p5.stroke(206, 242, 212);
            p5.strokeWeight(2);
            p5.rect(diskLocations$c[idx].x, diskLocations$c[idx].y, diskLocations$c[idx].image.width, diskLocations$c[idx].image.height);
          }
        }
      };
      p5.mouseClicked = (_) => {
        let mx = p5.mouseX;
        let my = p5.mouseY;
        diskLocations$c.forEach((loc) => {
          if (loc.image && mx > loc.x && mx < loc.x + loc.image.width && my > loc.y && my < loc.y + loc.image.height) {
            currentDisk.value = loc.BAY;
          }
        });
      };
    };
    onMounted(() => {
      new P5(p5Script);
    });
    return {
      diskInfoObj,
      currentDisk,
      lsdevJson,
      diskInfo,
      enableZfsAnimations
    };
  }
};
const _hoisted_1$f = {
  id: "p5-av15-stornado",
  class: "self-stretch m-2 flex justify-center"
};
function _sfc_render$f(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1$f);
}
var P5Stornado = /* @__PURE__ */ _export_sfc(_sfc_main$f, [["render", _sfc_render$f]]);
const assets$b = {
  chassis: {
    path: "img/chassis/xl60-h16-storinator.png",
    image: null
  },
  fade: {
    path: "img/chassis/chassis-fade-90.png",
    image: null
  },
  disks: {
    caddy: {
      default: {
        path: "img/disks/caddy-generic-90.png",
        image: null
      },
      micron5200: {
        path: "img/disks/caddy-micron-90.png",
        image: null
      },
      micron5300: {
        path: "img/disks/caddy-micron-5300-90.png",
        image: null
      },
      seagate: {
        path: "img/disks/caddy-seagate-90.png",
        image: null
      },
      seagateSas: {
        path: "img/disks/caddy-seagate-sas-90.png",
        image: null
      },
      loading: {
        path: "img/disks/caddy-loading-90.png",
        image: null
      }
    },
    ssd: {
      micron5200: {
        path: "img/disks/ssd-micron-90.png",
        image: null
      },
      micron5300: {
        path: "img/disks/ssd-micron-5300-90.png",
        image: null
      },
      seagate: {
        path: "img/disks/ssd-seagate-90.png",
        image: null
      },
      seagateSas: {
        path: "img/disks/ssd-seagate-sas-90.png",
        image: null
      },
      default: {
        path: "img/disks/ssd-generic-90.png",
        image: null
      },
      loading: {
        path: "img/disks/ssd-loading-90.png",
        image: null
      },
      hdd25: {
        path: "img/disks/hdd-25-90.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-ssd-90.png",
        image: null
      }
    },
    hdd: {
      default: {
        path: "img/disks/hdd-generic-90.png",
        image: null
      },
      seagateSt: {
        path: "img/disks/hdd-seagate-st-90.png",
        image: null
      },
      seagate: {
        path: "img/disks/hdd-seagate-90.png",
        image: null
      },
      toshiba: {
        path: "img/disks/hdd-toshiba-90.png",
        image: null
      },
      loading: {
        path: "img/disks/hdd-loading-90.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-hdd-90.png",
        image: null
      }
    }
  },
  loadingFlag: true
};
const diskLocations$b = [
  {
    x: 525,
    y: 10,
    BAY: "1-1",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 42,
    BAY: "1-2",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 74,
    BAY: "1-3",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 106,
    BAY: "1-4",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 138,
    BAY: "1-5",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 170,
    BAY: "1-6",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 202,
    BAY: "1-7",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 234,
    BAY: "1-8",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 266,
    BAY: "1-9",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 298,
    BAY: "1-10",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 330,
    BAY: "1-11",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 362,
    BAY: "1-12",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 394,
    BAY: "1-13",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 426,
    BAY: "1-14",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 458,
    BAY: "1-15",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 10,
    BAY: "2-1",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 42,
    BAY: "2-2",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 74,
    BAY: "2-3",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 106,
    BAY: "2-4",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 138,
    BAY: "2-5",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 170,
    BAY: "2-6",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 202,
    BAY: "2-7",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 234,
    BAY: "2-8",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 266,
    BAY: "2-9",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 298,
    BAY: "2-10",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 330,
    BAY: "2-11",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 362,
    BAY: "2-12",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 394,
    BAY: "2-13",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 426,
    BAY: "2-14",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 458,
    BAY: "2-15",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 10,
    BAY: "3-1",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 42,
    BAY: "3-2",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 74,
    BAY: "3-3",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 106,
    BAY: "3-4",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 138,
    BAY: "3-5",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 170,
    BAY: "3-6",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 202,
    BAY: "3-7",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 234,
    BAY: "3-8",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 266,
    BAY: "3-9",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 298,
    BAY: "3-10",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 330,
    BAY: "3-11",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 362,
    BAY: "3-12",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 394,
    BAY: "3-13",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 426,
    BAY: "3-14",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 458,
    BAY: "3-15",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 40,
    y: 20,
    BAY: "4-1",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 40,
    y: 31,
    BAY: "4-2",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 40,
    y: 56,
    BAY: "4-3",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 40,
    y: 67,
    BAY: "4-4",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 40,
    y: 78,
    BAY: "4-5",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 40,
    y: 89,
    BAY: "4-6",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 40,
    y: 114,
    BAY: "4-7",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 40,
    y: 125,
    BAY: "4-8",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 40,
    y: 136,
    BAY: "4-9",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 40,
    y: 147,
    BAY: "4-10",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 40,
    y: 174,
    BAY: "4-11",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 40,
    y: 185,
    BAY: "4-12",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 40,
    y: 196,
    BAY: "4-13",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 40,
    y: 207,
    BAY: "4-14",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 40,
    y: 231,
    BAY: "4-15",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 40,
    y: 242,
    BAY: "4-16",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 33,
    y: 266,
    BAY: "4-17",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 33,
    y: 298,
    BAY: "4-18",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 33,
    y: 330,
    BAY: "4-19",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 33,
    y: 362,
    BAY: "4-20",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 33,
    y: 394,
    BAY: "4-21",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 33,
    y: 426,
    BAY: "4-22",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 33,
    y: 458,
    BAY: "4-23",
    HDD: true,
    occupied: false,
    image: null
  }
];
const _sfc_main$e = {
  name: "P5StorinatorXL60H16",
  setup() {
    const diskInfoObj = ref({});
    const currentDisk = inject("currentDisk");
    const lsdevJson = inject("lsdevJson");
    const diskInfo = inject("diskInfo");
    const zfsInfo = inject("zfsInfo");
    const enableZfsAnimations = inject("enableZfsAnimations");
    watch(lsdevJson, () => {
      diskInfoObj.value = lsdevJson;
      assets$b.loadingFlag = false;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$b.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$b[index2].occupied = slot.occupied;
        diskLocations$b[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$b[index2].HDD);
      });
    }, { immediate: false, deep: true });
    watch(diskInfo, () => {
      diskInfoObj.value = diskInfo;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$b.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$b[index2].occupied = slot.occupied;
        diskLocations$b[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$b[index2].HDD);
      });
    }, { immediate: true, deep: true });
    function getDiskImage(occupied, modelName, modelFamily, diskType, slotHdd) {
      if (!occupied) {
        return slotHdd ? assets$b.disks.hdd.empty.image : assets$b.disks.ssd.empty.image;
      }
      if (assets$b.loadingFlag && diskType === "SSD" && slotHdd)
        return assets$b.disks.caddy.loading.image;
      if (assets$b.loadingFlag && diskType === "SSD" && !slotHdd)
        return assets$b.disks.ssd.loading.image;
      if (assets$b.loadingFlag && diskType === "HDD" && !slotHdd)
        return assets$b.disks.ssd.loading.image;
      if (assets$b.loadingFlag && diskType === "HDD")
        return assets$b.disks.hdd.loading.image;
      if (diskType === "SSD" && slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$b.disks.caddy.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$b.disks.caddy.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$b.disks.caddy.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$b.disks.caddy.micron5300.image;
        }
        return assets$b.disks.caddy.default.image;
      }
      if (diskType === "SSD" && !slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$b.disks.ssd.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$b.disks.ssd.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$b.disks.ssd.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$b.disks.ssd.micron5300.image;
        }
        return assets$b.disks.ssd.default.image;
      }
      if (diskType === "HDD" && slotHdd) {
        if (/ST18000|ST16000|ST20000|ST14000|ST12000/.test(modelName)) {
          return assets$b.disks.hdd.seagateSt.image;
        } else if (/Seagate Enterprise/.test(modelFamily)) {
          return assets$b.disks.hdd.seagate.image;
        } else if (/TOSHIBA/.test(modelName)) {
          return assets$b.disks.hdd.toshiba.image;
        } else {
          return assets$b.disks.hdd.default.image;
        }
      }
      if (diskType === "HDD" && !slotHdd) {
        return assets$b.disks.ssd.hdd25.image;
      }
    }
    const p5Script = function(p5) {
      loadingAnimation(p5);
      zfsAnimation(p5);
      p5.preload = (_) => {
        assets$b.chassis.image = p5.loadImage(assets$b.chassis.path);
        assets$b.fade.image = p5.loadImage(assets$b.fade.path);
        Object.entries(assets$b.disks.caddy).forEach(([dsk, val]) => {
          assets$b.disks.caddy[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$b.disks.ssd).forEach(([dsk, val]) => {
          assets$b.disks.ssd[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$b.disks.hdd).forEach(([dsk, val]) => {
          assets$b.disks.hdd[dsk].image = p5.loadImage(val.path);
        });
        diskInfoObj.value.rows.flat().forEach((slot) => {
          const index2 = diskLocations$b.findIndex((loc) => loc.BAY === slot["bay-id"]);
          if (index2 === -1)
            return;
          diskLocations$b[index2].occupied = slot.occupied;
          diskLocations$b[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$b[index2].HDD);
        });
      };
      p5.setup = (_) => {
        const canvas = p5.createCanvas(assets$b.chassis.image.width + assets$b.fade.image.width, assets$b.chassis.image.height);
        canvas.parent("p5-xl60-h16-storinator");
        p5.image(assets$b.fade.image, 0, 0);
        diskLocations$b.forEach((loc) => {
          loc.x += assets$b.fade.image.width;
        });
        resizeHook(p5, canvas.id(), assets$b.chassis.image.width + assets$b.fade.image.width);
      };
      p5.draw = (_) => {
        if (assets$b.loadingFlag) {
          p5.frameRate(10);
          p5.loadingAnimationIndex = p5.int((p5.loadingAnimationIndex + 1) % p5.loadingAnimationSteps);
        } else {
          p5.frameRate(24);
        }
        p5.image(assets$b.chassis.image, assets$b.fade.image.width, 0);
        diskLocations$b.forEach((loc) => {
          if (loc.occupied && loc.image) {
            p5.image(loc.image, loc.x, loc.y);
            if (assets$b.loadingFlag) {
              p5.animateLoading(loc.x, loc.y, loc.image.width, loc.image.height, p5.animationSteps, p5.animationLoadingIndex);
            }
          }
        });
        if (currentDisk.value) {
          let idx = diskLocations$b.findIndex((loc) => loc.BAY === currentDisk.value);
          if (diskLocations$b[idx].image) {
            if (enableZfsAnimations.flag) {
              p5.showZfs(currentDisk.value, zfsInfo, diskLocations$b);
            }
            p5.fill(255, 255, 255, 50);
            p5.stroke(206, 242, 212);
            p5.strokeWeight(2);
            p5.rect(diskLocations$b[idx].x, diskLocations$b[idx].y, diskLocations$b[idx].image.width, diskLocations$b[idx].image.height);
          }
        }
      };
      p5.mouseClicked = (_) => {
        let mx = p5.mouseX;
        let my = p5.mouseY;
        diskLocations$b.forEach((loc) => {
          if (loc.image && mx > loc.x && mx < loc.x + loc.image.width && my > loc.y && my < loc.y + loc.image.height) {
            currentDisk.value = loc.BAY;
          }
        });
      };
    };
    onMounted(() => {
      new P5(p5Script);
    });
    return {
      diskInfoObj,
      currentDisk,
      lsdevJson,
      diskInfo,
      enableZfsAnimations
    };
  }
};
const _hoisted_1$e = {
  id: "p5-xl60-h16-storinator",
  class: "self-stretch m-2 flex justify-center"
};
function _sfc_render$e(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1$e);
}
var P5StorinatorXL60H16 = /* @__PURE__ */ _export_sfc(_sfc_main$e, [["render", _sfc_render$e]]);
const assets$a = {
  chassis: {
    path: "img/chassis/s45-storinator.png",
    image: null
  },
  fade: {
    path: "img/chassis/chassis-fade.png",
    image: null
  },
  disks: {
    caddy: {
      default: {
        path: "img/disks/caddy-generic.png",
        image: null
      },
      micron5200: {
        path: "img/disks/caddy-micron.png",
        image: null
      },
      micron5300: {
        path: "img/disks/caddy-micron-5300.png",
        image: null
      },
      seagate: {
        path: "img/disks/caddy-seagate.png",
        image: null
      },
      seagateSas: {
        path: "img/disks/caddy-seagate-sas.png",
        image: null
      },
      loading: {
        path: "img/disks/caddy-loading.png",
        image: null
      }
    },
    ssd: {
      micron5200: {
        path: "img/disks/ssd-micron.png",
        image: null
      },
      micron5300: {
        path: "img/disks/ssd-micron-5300.png",
        image: null
      },
      seagate: {
        path: "img/disks/ssd-seagate.png",
        image: null
      },
      seagateSas: {
        path: "img/disks/ssd-seagate-sas.png",
        image: null
      },
      default: {
        path: "img/disks/ssd-generic.png",
        image: null
      },
      loading: {
        path: "img/disks/ssd-loading.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-ssd.png",
        image: null
      }
    },
    hdd: {
      default: {
        path: "img/disks/hdd-generic.png",
        image: null
      },
      seagateSt: {
        path: "img/disks/hdd-seagate-st.png",
        image: null
      },
      seagate: {
        path: "img/disks/hdd-seagate.png",
        image: null
      },
      toshiba: {
        path: "img/disks/hdd-toshiba.png",
        image: null
      },
      loading: {
        path: "img/disks/hdd-loading.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-hdd.png",
        image: null
      }
    }
  },
  loadingFlag: true
};
const diskLocations$a = [
  {
    x: 460,
    y: 361,
    BAY: "1-1",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 428,
    y: 361,
    BAY: "1-2",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 396,
    y: 361,
    BAY: "1-3",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 364,
    y: 361,
    BAY: "1-4",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 332,
    y: 361,
    BAY: "1-5",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 300,
    y: 361,
    BAY: "1-6",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 268,
    y: 361,
    BAY: "1-7",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 236,
    y: 361,
    BAY: "1-8",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 204,
    y: 361,
    BAY: "1-9",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 172,
    y: 361,
    BAY: "1-10",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 140,
    y: 361,
    BAY: "1-11",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 108,
    y: 361,
    BAY: "1-12",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 76,
    y: 361,
    BAY: "1-13",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 44,
    y: 361,
    BAY: "1-14",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 12,
    y: 361,
    BAY: "1-15",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 460,
    y: 197,
    BAY: "2-1",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 428,
    y: 197,
    BAY: "2-2",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 396,
    y: 197,
    BAY: "2-3",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 364,
    y: 197,
    BAY: "2-4",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 332,
    y: 197,
    BAY: "2-5",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 300,
    y: 197,
    BAY: "2-6",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 268,
    y: 197,
    BAY: "2-7",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 236,
    y: 197,
    BAY: "2-8",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 204,
    y: 197,
    BAY: "2-9",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 172,
    y: 197,
    BAY: "2-10",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 140,
    y: 197,
    BAY: "2-11",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 108,
    y: 197,
    BAY: "2-12",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 76,
    y: 197,
    BAY: "2-13",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 44,
    y: 197,
    BAY: "2-14",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 12,
    y: 197,
    BAY: "2-15",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 460,
    y: 33,
    BAY: "3-1",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 428,
    y: 33,
    BAY: "3-2",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 396,
    y: 33,
    BAY: "3-3",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 364,
    y: 33,
    BAY: "3-4",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 332,
    y: 33,
    BAY: "3-5",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 300,
    y: 33,
    BAY: "3-6",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 268,
    y: 33,
    BAY: "3-7",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 236,
    y: 33,
    BAY: "3-8",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 204,
    y: 33,
    BAY: "3-9",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 172,
    y: 33,
    BAY: "3-10",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 140,
    y: 33,
    BAY: "3-11",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 108,
    y: 33,
    BAY: "3-12",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 76,
    y: 33,
    BAY: "3-13",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 44,
    y: 33,
    BAY: "3-14",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 12,
    y: 33,
    BAY: "3-15",
    HDD: true,
    occupied: false,
    image: null
  }
];
const _sfc_main$d = {
  name: "P5StorinatorS45",
  setup() {
    const diskInfoObj = ref({});
    const currentDisk = inject("currentDisk");
    const lsdevJson = inject("lsdevJson");
    const diskInfo = inject("diskInfo");
    const zfsInfo = inject("zfsInfo");
    const enableZfsAnimations = inject("enableZfsAnimations");
    watch(lsdevJson, () => {
      diskInfoObj.value = lsdevJson;
      assets$a.loadingFlag = false;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$a.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$a[index2].occupied = slot.occupied;
        diskLocations$a[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$a[index2].HDD);
      });
    }, { immediate: false, deep: true });
    watch(diskInfo, () => {
      diskInfoObj.value = diskInfo;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$a.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$a[index2].occupied = slot.occupied;
        diskLocations$a[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$a[index2].HDD);
      });
    }, { immediate: true, deep: true });
    function getDiskImage(occupied, modelName, modelFamily, diskType, slotHdd) {
      if (!occupied) {
        return slotHdd ? assets$a.disks.hdd.empty.image : assets$a.disks.ssd.empty.image;
      }
      if (assets$a.loadingFlag && diskType === "SSD" && slotHdd)
        return assets$a.disks.caddy.loading.image;
      if (assets$a.loadingFlag && diskType === "SSD" && !slotHdd)
        return assets$a.disks.ssd.loading.image;
      if (assets$a.loadingFlag && diskType === "HDD")
        return assets$a.disks.hdd.loading.image;
      if (diskType === "SSD" && slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$a.disks.caddy.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$a.disks.caddy.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$a.disks.caddy.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$a.disks.caddy.micron5300.image;
        }
        return assets$a.disks.caddy.default.image;
      }
      if (diskType === "SSD" && !slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$a.disks.ssd.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$a.disks.ssd.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$a.disks.ssd.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$a.disks.ssd.micron5300.image;
        }
        return assets$a.disks.ssd.default.image;
      }
      if (diskType === "HDD") {
        if (/ST18000|ST16000|ST20000|ST14000|ST12000/.test(modelName)) {
          return assets$a.disks.hdd.seagateSt.image;
        } else if (/Seagate Enterprise/.test(modelFamily)) {
          return assets$a.disks.hdd.seagate.image;
        } else if (/TOSHIBA/.test(modelName)) {
          return assets$a.disks.hdd.toshiba.image;
        } else {
          return assets$a.disks.hdd.default.image;
        }
      }
    }
    const p5Script = function(p5) {
      loadingAnimation(p5);
      zfsAnimation(p5);
      p5.preload = (_) => {
        assets$a.chassis.image = p5.loadImage(assets$a.chassis.path);
        assets$a.fade.image = p5.loadImage(assets$a.fade.path);
        Object.entries(assets$a.disks.caddy).forEach(([dsk, val]) => {
          assets$a.disks.caddy[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$a.disks.ssd).forEach(([dsk, val]) => {
          assets$a.disks.ssd[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$a.disks.hdd).forEach(([dsk, val]) => {
          assets$a.disks.hdd[dsk].image = p5.loadImage(val.path);
        });
        diskInfoObj.value.rows.flat().forEach((slot) => {
          const index2 = diskLocations$a.findIndex((loc) => loc.BAY === slot["bay-id"]);
          if (index2 === -1)
            return;
          diskLocations$a[index2].occupied = slot.occupied;
          diskLocations$a[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$a[index2].HDD);
        });
      };
      p5.setup = (_) => {
        const canvas = p5.createCanvas(assets$a.chassis.image.width, assets$a.chassis.image.height + assets$a.fade.image.height);
        canvas.parent("p5-s45-storinator");
        p5.image(assets$a.fade.image, 0, 0);
        diskLocations$a.forEach((loc) => {
          loc.y += assets$a.fade.image.height;
        });
        resizeHook(p5, canvas.id(), assets$a.chassis.image.width);
      };
      p5.draw = (_) => {
        if (assets$a.loadingFlag) {
          p5.frameRate(10);
          p5.loadingAnimationIndex = p5.int((p5.loadingAnimationIndex + 1) % p5.loadingAnimationSteps);
        } else {
          p5.frameRate(24);
        }
        p5.image(assets$a.chassis.image, 0, assets$a.fade.image.height);
        diskLocations$a.forEach((loc) => {
          if (loc.occupied && loc.image) {
            p5.image(loc.image, loc.x, loc.y);
            if (assets$a.loadingFlag) {
              p5.animateLoading(loc.x, loc.y, loc.image.width, loc.image.height, p5.animationSteps, p5.animationLoadingIndex);
            }
          }
        });
        if (currentDisk.value) {
          let idx = diskLocations$a.findIndex((loc) => loc.BAY === currentDisk.value);
          if (diskLocations$a[idx].image) {
            if (enableZfsAnimations.flag) {
              p5.showZfs(currentDisk.value, zfsInfo, diskLocations$a);
            }
            p5.fill(255, 255, 255, 50);
            p5.stroke(206, 242, 212);
            p5.strokeWeight(2);
            p5.rect(diskLocations$a[idx].x, diskLocations$a[idx].y, diskLocations$a[idx].image.width, diskLocations$a[idx].image.height);
          }
        }
      };
      p5.mouseClicked = (_) => {
        let mx = p5.mouseX;
        let my = p5.mouseY;
        diskLocations$a.forEach((loc) => {
          if (loc.image && mx > loc.x && mx < loc.x + loc.image.width && my > loc.y && my < loc.y + loc.image.height) {
            currentDisk.value = loc.BAY;
          }
        });
      };
    };
    onMounted(() => {
      new P5(p5Script);
    });
    return {
      diskInfoObj,
      currentDisk,
      lsdevJson,
      diskInfo,
      enableZfsAnimations
    };
  }
};
const _hoisted_1$d = {
  id: "p5-s45-storinator",
  class: "self-stretch m-2 flex justify-center"
};
function _sfc_render$d(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1$d);
}
var P5StorinatorS45 = /* @__PURE__ */ _export_sfc(_sfc_main$d, [["render", _sfc_render$d]]);
const assets$9 = {
  chassis: {
    path: "img/chassis/s45-h16-storinator.png",
    image: null
  },
  fade: {
    path: "img/chassis/chassis-fade.png",
    image: null
  },
  disks: {
    caddy: {
      default: {
        path: "img/disks/caddy-generic.png",
        image: null
      },
      micron5200: {
        path: "img/disks/caddy-micron.png",
        image: null
      },
      micron5300: {
        path: "img/disks/caddy-micron-5300.png",
        image: null
      },
      seagate: {
        path: "img/disks/caddy-seagate.png",
        image: null
      },
      seagateSas: {
        path: "img/disks/caddy-seagate-sas.png",
        image: null
      },
      loading: {
        path: "img/disks/caddy-loading.png",
        image: null
      }
    },
    ssd: {
      micron5200: {
        path: "img/disks/ssd-micron.png",
        image: null
      },
      micron5300: {
        path: "img/disks/ssd-micron-5300.png",
        image: null
      },
      seagate: {
        path: "img/disks/ssd-seagate.png",
        image: null
      },
      seagateSas: {
        path: "img/disks/ssd-seagate-sas.png",
        image: null
      },
      default: {
        path: "img/disks/ssd-generic.png",
        image: null
      },
      loading: {
        path: "img/disks/ssd-loading.png",
        image: null
      },
      hdd25: {
        path: "img/disks/hdd-25.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-ssd.png",
        image: null
      }
    },
    hdd: {
      default: {
        path: "img/disks/hdd-generic.png",
        image: null
      },
      seagateSt: {
        path: "img/disks/hdd-seagate-st.png",
        image: null
      },
      seagate: {
        path: "img/disks/hdd-seagate.png",
        image: null
      },
      toshiba: {
        path: "img/disks/hdd-toshiba.png",
        image: null
      },
      loading: {
        path: "img/disks/hdd-loading.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-hdd.png",
        image: null
      }
    }
  },
  loadingFlag: true
};
const diskLocations$9 = [
  {
    x: 460,
    y: 361,
    BAY: "1-1",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 428,
    y: 361,
    BAY: "1-2",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 396,
    y: 361,
    BAY: "1-3",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 364,
    y: 361,
    BAY: "1-4",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 332,
    y: 361,
    BAY: "1-5",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 300,
    y: 361,
    BAY: "1-6",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 268,
    y: 361,
    BAY: "1-7",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 236,
    y: 361,
    BAY: "1-8",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 204,
    y: 361,
    BAY: "1-9",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 172,
    y: 361,
    BAY: "1-10",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 140,
    y: 361,
    BAY: "1-11",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 108,
    y: 361,
    BAY: "1-12",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 76,
    y: 361,
    BAY: "1-13",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 44,
    y: 361,
    BAY: "1-14",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 12,
    y: 361,
    BAY: "1-15",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 460,
    y: 197,
    BAY: "2-1",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 428,
    y: 197,
    BAY: "2-2",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 396,
    y: 197,
    BAY: "2-3",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 364,
    y: 197,
    BAY: "2-4",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 332,
    y: 197,
    BAY: "2-5",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 300,
    y: 197,
    BAY: "2-6",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 268,
    y: 197,
    BAY: "2-7",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 236,
    y: 197,
    BAY: "2-8",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 204,
    y: 197,
    BAY: "2-9",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 172,
    y: 197,
    BAY: "2-10",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 140,
    y: 197,
    BAY: "2-11",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 108,
    y: 197,
    BAY: "2-12",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 76,
    y: 197,
    BAY: "2-13",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 44,
    y: 197,
    BAY: "2-14",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 12,
    y: 197,
    BAY: "2-15",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 471,
    y: 40,
    BAY: "3-1",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 460,
    y: 40,
    BAY: "3-2",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 435,
    y: 40,
    BAY: "3-3",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 424,
    y: 40,
    BAY: "3-4",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 413,
    y: 40,
    BAY: "3-5",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 402,
    y: 40,
    BAY: "3-6",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 377,
    y: 40,
    BAY: "3-7",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 366,
    y: 40,
    BAY: "3-8",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 354,
    y: 40,
    BAY: "3-9",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 343,
    y: 40,
    BAY: "3-10",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 317,
    y: 40,
    BAY: "3-11",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 306,
    y: 40,
    BAY: "3-12",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 295,
    y: 40,
    BAY: "3-13",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 284,
    y: 40,
    BAY: "3-14",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 259,
    y: 40,
    BAY: "3-15",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 248,
    y: 40,
    BAY: "3-16",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 204,
    y: 33,
    BAY: "3-17",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 172,
    y: 33,
    BAY: "3-18",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 140,
    y: 33,
    BAY: "3-19",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 108,
    y: 33,
    BAY: "3-20",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 76,
    y: 33,
    BAY: "3-21",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 44,
    y: 33,
    BAY: "3-22",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 12,
    y: 33,
    BAY: "3-23",
    HDD: true,
    occupied: false,
    image: null
  }
];
const _sfc_main$c = {
  name: "P5StorinatorS45H16",
  setup() {
    const diskInfoObj = ref({});
    const currentDisk = inject("currentDisk");
    const lsdevJson = inject("lsdevJson");
    const diskInfo = inject("diskInfo");
    const zfsInfo = inject("zfsInfo");
    const enableZfsAnimations = inject("enableZfsAnimations");
    watch(diskInfo, () => {
      diskInfoObj.value = diskInfo;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$9.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$9[index2].occupied = slot.occupied;
        diskLocations$9[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$9[index2].HDD);
      });
    }, { immediate: true, deep: true });
    watch(lsdevJson, () => {
      diskInfoObj.value = lsdevJson;
      assets$9.loadingFlag = false;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$9.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$9[index2].occupied = slot.occupied;
        diskLocations$9[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$9[index2].HDD);
      });
    }, { immediate: false, deep: true });
    function getDiskImage(occupied, modelName, modelFamily, diskType, slotHdd) {
      if (!occupied) {
        return slotHdd ? assets$9.disks.hdd.empty.image : assets$9.disks.ssd.empty.image;
      }
      if (assets$9.loadingFlag && diskType === "SSD" && slotHdd)
        return assets$9.disks.caddy.loading.image;
      if (assets$9.loadingFlag && diskType === "SSD" && !slotHdd)
        return assets$9.disks.ssd.loading.image;
      if (assets$9.loadingFlag && diskType === "HDD" && !slotHdd)
        return assets$9.disks.ssd.loading.image;
      if (assets$9.loadingFlag && diskType === "HDD")
        return assets$9.disks.hdd.loading.image;
      if (diskType === "SSD" && slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$9.disks.caddy.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$9.disks.caddy.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$9.disks.caddy.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$9.disks.caddy.micron5300.image;
        }
        return assets$9.disks.caddy.default.image;
      }
      if (diskType === "SSD" && !slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$9.disks.ssd.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$9.disks.ssd.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$9.disks.ssd.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$9.disks.ssd.micron5300.image;
        }
        return assets$9.disks.ssd.default.image;
      }
      if (diskType === "HDD" && slotHdd) {
        if (/ST18000|ST16000|ST20000|ST14000|ST12000/.test(modelName)) {
          return assets$9.disks.hdd.seagateSt.image;
        } else if (/Seagate Enterprise/.test(modelFamily)) {
          return assets$9.disks.hdd.seagate.image;
        } else if (/TOSHIBA/.test(modelName)) {
          return assets$9.disks.hdd.toshiba.image;
        } else {
          return assets$9.disks.hdd.default.image;
        }
      }
      if (diskType === "HDD" && !slotHdd) {
        return assets$9.disks.ssd.hdd25.image;
      }
    }
    const p5Script = function(p5) {
      loadingAnimation(p5);
      zfsAnimation(p5);
      p5.preload = (_) => {
        assets$9.chassis.image = p5.loadImage(assets$9.chassis.path);
        assets$9.fade.image = p5.loadImage(assets$9.fade.path);
        Object.entries(assets$9.disks.caddy).forEach(([dsk, val]) => {
          assets$9.disks.caddy[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$9.disks.ssd).forEach(([dsk, val]) => {
          assets$9.disks.ssd[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$9.disks.hdd).forEach(([dsk, val]) => {
          assets$9.disks.hdd[dsk].image = p5.loadImage(val.path);
        });
        diskInfoObj.value.rows.flat().forEach((slot) => {
          const index2 = diskLocations$9.findIndex((loc) => loc.BAY === slot["bay-id"]);
          if (index2 === -1)
            return;
          diskLocations$9[index2].occupied = slot.occupied;
          diskLocations$9[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$9[index2].HDD);
        });
      };
      p5.setup = (_) => {
        const canvas = p5.createCanvas(assets$9.chassis.image.width, assets$9.chassis.image.height + assets$9.fade.image.height);
        canvas.parent("p5-s45-h16-storinator");
        p5.image(assets$9.fade.image, 0, 0);
        diskLocations$9.forEach((loc) => {
          loc.y += assets$9.fade.image.height;
        });
        resizeHook(p5, canvas.id(), assets$9.chassis.image.width);
      };
      p5.draw = (_) => {
        if (assets$9.loadingFlag) {
          p5.frameRate(10);
          p5.loadingAnimationIndex = p5.int((p5.loadingAnimationIndex + 1) % p5.loadingAnimationSteps);
        } else {
          p5.frameRate(24);
        }
        p5.image(assets$9.chassis.image, 0, assets$9.fade.image.height);
        diskLocations$9.forEach((loc) => {
          if (loc.occupied && loc.image) {
            p5.image(loc.image, loc.x, loc.y);
            if (assets$9.loadingFlag) {
              p5.animateLoading(loc.x, loc.y, loc.image.width, loc.image.height, p5.animationSteps, p5.animationLoadingIndex);
            }
          }
        });
        if (currentDisk.value) {
          let idx = diskLocations$9.findIndex((loc) => loc.BAY === currentDisk.value);
          if (diskLocations$9[idx].image) {
            if (enableZfsAnimations.flag) {
              p5.showZfs(currentDisk.value, zfsInfo, diskLocations$9);
            }
            p5.fill(255, 255, 255, 50);
            p5.stroke(206, 242, 212);
            p5.strokeWeight(2);
            p5.rect(diskLocations$9[idx].x, diskLocations$9[idx].y, diskLocations$9[idx].image.width, diskLocations$9[idx].image.height);
          }
        }
      };
      p5.mouseClicked = (_) => {
        let mx = p5.mouseX;
        let my = p5.mouseY;
        diskLocations$9.forEach((loc) => {
          if (loc.image && mx > loc.x && mx < loc.x + loc.image.width && my > loc.y && my < loc.y + loc.image.height) {
            currentDisk.value = loc.BAY;
          }
        });
      };
    };
    onMounted(() => {
      new P5(p5Script);
    });
    return {
      diskInfoObj,
      currentDisk,
      lsdevJson,
      diskInfo,
      enableZfsAnimations
    };
  }
};
const _hoisted_1$c = {
  id: "p5-s45-h16-storinator",
  class: "self-stretch m-2 flex justify-center"
};
function _sfc_render$c(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1$c);
}
var P5StorinatorS45H16 = /* @__PURE__ */ _export_sfc(_sfc_main$c, [["render", _sfc_render$c]]);
const assets$8 = {
  chassis: {
    path: "img/chassis/s45-h32-storinator.png",
    image: null
  },
  fade: {
    path: "img/chassis/chassis-fade.png",
    image: null
  },
  disks: {
    caddy: {
      default: {
        path: "img/disks/caddy-generic.png",
        image: null
      },
      micron5200: {
        path: "img/disks/caddy-micron.png",
        image: null
      },
      micron5300: {
        path: "img/disks/caddy-micron-5300.png",
        image: null
      },
      seagate: {
        path: "img/disks/caddy-seagate.png",
        image: null
      },
      seagateSas: {
        path: "img/disks/caddy-seagate-sas.png",
        image: null
      },
      loading: {
        path: "img/disks/caddy-loading.png",
        image: null
      }
    },
    ssd: {
      micron5200: {
        path: "img/disks/ssd-micron.png",
        image: null
      },
      micron5300: {
        path: "img/disks/ssd-micron-5300.png",
        image: null
      },
      seagate: {
        path: "img/disks/ssd-seagate.png",
        image: null
      },
      seagateSas: {
        path: "img/disks/ssd-seagate-sas.png",
        image: null
      },
      default: {
        path: "img/disks/ssd-generic.png",
        image: null
      },
      loading: {
        path: "img/disks/ssd-loading.png",
        image: null
      },
      hdd25: {
        path: "img/disks/hdd-25.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-ssd.png",
        image: null
      }
    },
    hdd: {
      default: {
        path: "img/disks/hdd-generic.png",
        image: null
      },
      seagateSt: {
        path: "img/disks/hdd-seagate-st.png",
        image: null
      },
      seagate: {
        path: "img/disks/hdd-seagate.png",
        image: null
      },
      toshiba: {
        path: "img/disks/hdd-toshiba.png",
        image: null
      },
      loading: {
        path: "img/disks/hdd-loading.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-hdd.png",
        image: null
      }
    }
  },
  loadingFlag: true
};
const diskLocations$8 = [
  {
    x: 460,
    y: 361,
    BAY: "1-1",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 428,
    y: 361,
    BAY: "1-2",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 396,
    y: 361,
    BAY: "1-3",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 364,
    y: 361,
    BAY: "1-4",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 332,
    y: 361,
    BAY: "1-5",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 300,
    y: 361,
    BAY: "1-6",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 268,
    y: 361,
    BAY: "1-7",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 236,
    y: 361,
    BAY: "1-8",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 204,
    y: 361,
    BAY: "1-9",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 172,
    y: 361,
    BAY: "1-10",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 140,
    y: 361,
    BAY: "1-11",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 108,
    y: 361,
    BAY: "1-12",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 76,
    y: 361,
    BAY: "1-13",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 44,
    y: 361,
    BAY: "1-14",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 12,
    y: 361,
    BAY: "1-15",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 460,
    y: 197,
    BAY: "2-1",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 428,
    y: 197,
    BAY: "2-2",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 396,
    y: 197,
    BAY: "2-3",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 364,
    y: 197,
    BAY: "2-4",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 332,
    y: 197,
    BAY: "2-5",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 300,
    y: 197,
    BAY: "2-6",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 268,
    y: 197,
    BAY: "2-7",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 236,
    y: 197,
    BAY: "2-8",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 204,
    y: 197,
    BAY: "2-9",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 172,
    y: 197,
    BAY: "2-10",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 140,
    y: 197,
    BAY: "2-11",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 108,
    y: 197,
    BAY: "2-12",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 76,
    y: 197,
    BAY: "2-13",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 44,
    y: 197,
    BAY: "2-14",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 12,
    y: 197,
    BAY: "2-15",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 476,
    y: 46,
    BAY: "2-16",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 464,
    y: 46,
    BAY: "2-17",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 439,
    y: 46,
    BAY: "2-18",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 428,
    y: 46,
    BAY: "2-19",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 417,
    y: 46,
    BAY: "2-20",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 406,
    y: 46,
    BAY: "2-21",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 382,
    y: 46,
    BAY: "2-22",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 371,
    y: 46,
    BAY: "2-23",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 358,
    y: 46,
    BAY: "3-1",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 347,
    y: 46,
    BAY: "3-2",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 322,
    y: 46,
    BAY: "3-3",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 311,
    y: 46,
    BAY: "3-4",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 300,
    y: 46,
    BAY: "3-5",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 289,
    y: 46,
    BAY: "3-6",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 265,
    y: 46,
    BAY: "3-7",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 254,
    y: 46,
    BAY: "3-8",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 238,
    y: 46,
    BAY: "3-9",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 227,
    y: 46,
    BAY: "3-10",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 202,
    y: 46,
    BAY: "3-11",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 191,
    y: 46,
    BAY: "3-12",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 180,
    y: 46,
    BAY: "3-13",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 169,
    y: 46,
    BAY: "3-14",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 145,
    y: 46,
    BAY: "3-15",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 134,
    y: 46,
    BAY: "3-16",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 121,
    y: 46,
    BAY: "3-17",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 110,
    y: 46,
    BAY: "3-18",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 85,
    y: 46,
    BAY: "3-19",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 74,
    y: 46,
    BAY: "3-20",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 63,
    y: 46,
    BAY: "3-21",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 52,
    y: 46,
    BAY: "3-22",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 27,
    y: 46,
    BAY: "3-23",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 16,
    y: 46,
    BAY: "3-24",
    HDD: false,
    occupied: false,
    image: null
  }
];
const _sfc_main$b = {
  name: "P5StorinatorQ30H32",
  setup() {
    const diskInfoObj = ref({});
    const currentDisk = inject("currentDisk");
    const lsdevJson = inject("lsdevJson");
    const diskInfo = inject("diskInfo");
    const zfsInfo = inject("zfsInfo");
    const enableZfsAnimations = inject("enableZfsAnimations");
    watch(diskInfo, () => {
      diskInfoObj.value = diskInfo;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$8.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 === -1)
          return;
        diskLocations$8[index2].occupied = slot.occupied;
        diskLocations$8[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$8[index2].HDD);
      });
    }, { immediate: true, deep: true });
    watch(lsdevJson, () => {
      diskInfoObj.value = lsdevJson;
      assets$8.loadingFlag = false;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$8.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 === -1)
          return;
        diskLocations$8[index2].occupied = slot.occupied;
        diskLocations$8[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$8[index2].HDD);
      });
    }, { immediate: false, deep: true });
    function getDiskImage(occupied, modelName, modelFamily, diskType, slotHdd) {
      if (!occupied) {
        return slotHdd ? assets$8.disks.hdd.empty.image : assets$8.disks.ssd.empty.image;
      }
      if (assets$8.loadingFlag && diskType === "SSD" && slotHdd)
        return assets$8.disks.caddy.loading.image;
      if (assets$8.loadingFlag && diskType === "SSD" && !slotHdd)
        return assets$8.disks.ssd.loading.image;
      if (assets$8.loadingFlag && diskType === "HDD" && !slotHdd)
        return assets$8.disks.ssd.loading.image;
      if (assets$8.loadingFlag && diskType === "HDD")
        return assets$8.disks.hdd.loading.image;
      if (diskType === "SSD" && slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$8.disks.caddy.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$8.disks.caddy.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$8.disks.caddy.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$8.disks.caddy.micron5300.image;
        }
        return assets$8.disks.caddy.default.image;
      }
      if (diskType === "SSD" && !slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$8.disks.ssd.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$8.disks.ssd.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$8.disks.ssd.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$8.disks.ssd.micron5300.image;
        }
        return assets$8.disks.ssd.default.image;
      }
      if (diskType === "HDD" && slotHdd) {
        if (/ST18000|ST16000|ST20000|ST14000|ST12000/.test(modelName)) {
          return assets$8.disks.hdd.seagateSt.image;
        } else if (/Seagate Enterprise/.test(modelFamily)) {
          return assets$8.disks.hdd.seagate.image;
        } else if (/TOSHIBA/.test(modelName)) {
          return assets$8.disks.hdd.toshiba.image;
        } else {
          return assets$8.disks.hdd.default.image;
        }
      }
      if (diskType === "HDD" && !slotHdd) {
        return assets$8.disks.ssd.hdd25.image;
      }
    }
    const p5Script = function(p5) {
      loadingAnimation(p5);
      zfsAnimation(p5);
      p5.preload = (_) => {
        assets$8.chassis.image = p5.loadImage(assets$8.chassis.path);
        assets$8.fade.image = p5.loadImage(assets$8.fade.path);
        Object.entries(assets$8.disks.caddy).forEach(([dsk, val]) => {
          assets$8.disks.caddy[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$8.disks.ssd).forEach(([dsk, val]) => {
          assets$8.disks.ssd[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$8.disks.hdd).forEach(([dsk, val]) => {
          assets$8.disks.hdd[dsk].image = p5.loadImage(val.path);
        });
        diskInfoObj.value.rows.flat().forEach((slot) => {
          const index2 = diskLocations$8.findIndex((loc) => loc.BAY === slot["bay-id"]);
          if (index2 === -1)
            return;
          diskLocations$8[index2].occupied = slot.occupied;
          diskLocations$8[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$8[index2].HDD);
        });
      };
      p5.setup = (_) => {
        const canvas = p5.createCanvas(assets$8.chassis.image.width, assets$8.chassis.image.height + assets$8.fade.image.height);
        canvas.parent("p5-s45-h32-storinator");
        p5.image(assets$8.fade.image, 0, 0);
        diskLocations$8.forEach((loc) => {
          loc.y += assets$8.fade.image.height;
        });
        resizeHook(p5, canvas.id(), assets$8.chassis.image.width);
      };
      p5.draw = (_) => {
        if (assets$8.loadingFlag) {
          p5.frameRate(10);
          p5.loadingAnimationIndex = p5.int((p5.loadingAnimationIndex + 1) % p5.loadingAnimationSteps);
        } else {
          p5.frameRate(24);
        }
        p5.image(assets$8.chassis.image, 0, assets$8.fade.image.height);
        diskLocations$8.forEach((loc) => {
          if (loc.occupied && loc.image) {
            p5.image(loc.image, loc.x, loc.y);
            if (assets$8.loadingFlag) {
              p5.animateLoading(loc.x, loc.y, loc.image.width, loc.image.height, p5.animationSteps, p5.animationLoadingIndex);
            }
          }
        });
        if (currentDisk.value) {
          let idx = diskLocations$8.findIndex((loc) => loc.BAY === currentDisk.value);
          if (diskLocations$8[idx].image) {
            if (enableZfsAnimations.flag) {
              p5.showZfs(currentDisk.value, zfsInfo, diskLocations$8);
            }
            p5.fill(255, 255, 255, 50);
            p5.stroke(206, 242, 212);
            p5.strokeWeight(2);
            p5.rect(diskLocations$8[idx].x, diskLocations$8[idx].y, diskLocations$8[idx].image.width, diskLocations$8[idx].image.height);
          }
        }
      };
      p5.mouseClicked = (_) => {
        let mx = p5.mouseX;
        let my = p5.mouseY;
        diskLocations$8.forEach((loc) => {
          if (loc.image && mx > loc.x && mx < loc.x + loc.image.width && my > loc.y && my < loc.y + loc.image.height) {
            currentDisk.value = loc.BAY;
          }
        });
      };
    };
    onMounted(() => {
      new P5(p5Script);
    });
    return {
      diskInfoObj,
      currentDisk,
      lsdevJson,
      diskInfo,
      enableZfsAnimations
    };
  }
};
const _hoisted_1$b = {
  id: "p5-s45-h32-storinator",
  class: "self-stretch m-2 flex justify-center"
};
function _sfc_render$b(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1$b);
}
var P5StorinatorS45H32 = /* @__PURE__ */ _export_sfc(_sfc_main$b, [["render", _sfc_render$b]]);
const assets$7 = {
  chassis: {
    path: "img/chassis/q30-h16-storinator.png",
    image: null
  },
  fade: {
    path: "img/chassis/chassis-fade.png",
    image: null
  },
  disks: {
    caddy: {
      default: {
        path: "img/disks/caddy-generic.png",
        image: null
      },
      micron5200: {
        path: "img/disks/caddy-micron.png",
        image: null
      },
      micron5300: {
        path: "img/disks/caddy-micron-5300.png",
        image: null
      },
      seagate: {
        path: "img/disks/caddy-seagate.png",
        image: null
      },
      seagateSas: {
        path: "img/disks/caddy-seagate-sas.png",
        image: null
      },
      loading: {
        path: "img/disks/caddy-loading.png",
        image: null
      }
    },
    ssd: {
      micron5200: {
        path: "img/disks/ssd-micron.png",
        image: null
      },
      micron5300: {
        path: "img/disks/ssd-micron-5300.png",
        image: null
      },
      seagate: {
        path: "img/disks/ssd-seagate.png",
        image: null
      },
      seagateSas: {
        path: "img/disks/ssd-seagate-sas.png",
        image: null
      },
      default: {
        path: "img/disks/ssd-generic.png",
        image: null
      },
      loading: {
        path: "img/disks/ssd-loading.png",
        image: null
      },
      hdd25: {
        path: "img/disks/hdd-25.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-ssd.png",
        image: null
      }
    },
    hdd: {
      default: {
        path: "img/disks/hdd-generic.png",
        image: null
      },
      seagateSt: {
        path: "img/disks/hdd-seagate-st.png",
        image: null
      },
      seagate: {
        path: "img/disks/hdd-seagate.png",
        image: null
      },
      toshiba: {
        path: "img/disks/hdd-toshiba.png",
        image: null
      },
      loading: {
        path: "img/disks/hdd-loading.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-hdd.png",
        image: null
      }
    }
  },
  loadingFlag: true
};
const diskLocations$7 = [
  {
    x: 460,
    y: 197,
    BAY: "1-1",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 428,
    y: 197,
    BAY: "1-2",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 396,
    y: 197,
    BAY: "1-3",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 364,
    y: 197,
    BAY: "1-4",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 332,
    y: 197,
    BAY: "1-5",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 300,
    y: 197,
    BAY: "1-6",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 268,
    y: 197,
    BAY: "1-7",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 236,
    y: 197,
    BAY: "1-8",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 204,
    y: 197,
    BAY: "1-9",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 172,
    y: 197,
    BAY: "1-10",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 140,
    y: 197,
    BAY: "1-11",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 108,
    y: 197,
    BAY: "1-12",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 76,
    y: 197,
    BAY: "1-13",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 44,
    y: 197,
    BAY: "1-14",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 12,
    y: 197,
    BAY: "1-15",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 471,
    y: 40,
    BAY: "2-1",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 460,
    y: 40,
    BAY: "2-2",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 435,
    y: 40,
    BAY: "2-3",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 424,
    y: 40,
    BAY: "2-4",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 413,
    y: 40,
    BAY: "2-5",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 402,
    y: 40,
    BAY: "2-6",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 377,
    y: 40,
    BAY: "2-7",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 366,
    y: 40,
    BAY: "2-8",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 354,
    y: 40,
    BAY: "2-9",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 343,
    y: 40,
    BAY: "2-10",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 317,
    y: 40,
    BAY: "2-11",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 306,
    y: 40,
    BAY: "2-12",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 295,
    y: 40,
    BAY: "2-13",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 284,
    y: 40,
    BAY: "2-14",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 259,
    y: 40,
    BAY: "2-15",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 248,
    y: 40,
    BAY: "2-16",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 204,
    y: 33,
    BAY: "2-17",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 172,
    y: 33,
    BAY: "2-18",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 140,
    y: 33,
    BAY: "2-19",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 108,
    y: 33,
    BAY: "2-20",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 76,
    y: 33,
    BAY: "2-21",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 44,
    y: 33,
    BAY: "2-22",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 12,
    y: 33,
    BAY: "2-23",
    HDD: true,
    occupied: false,
    image: null
  }
];
const _sfc_main$a = {
  name: "P5StorinatorQ30H16",
  setup() {
    const diskInfoObj = ref({});
    const currentDisk = inject("currentDisk");
    const lsdevJson = inject("lsdevJson");
    const diskInfo = inject("diskInfo");
    const zfsInfo = inject("zfsInfo");
    const enableZfsAnimations = inject("enableZfsAnimations");
    watch(diskInfo, () => {
      diskInfoObj.value = diskInfo;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$7.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$7[index2].occupied = slot.occupied;
        diskLocations$7[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$7[index2].HDD);
      });
    }, { immediate: true, deep: true });
    watch(lsdevJson, () => {
      diskInfoObj.value = lsdevJson;
      assets$7.loadingFlag = false;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$7.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$7[index2].occupied = slot.occupied;
        diskLocations$7[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$7[index2].HDD);
      });
    }, { immediate: false, deep: true });
    function getDiskImage(occupied, modelName, modelFamily, diskType, slotHdd) {
      if (!occupied) {
        return slotHdd ? assets$7.disks.hdd.empty.image : assets$7.disks.ssd.empty.image;
      }
      if (assets$7.loadingFlag && diskType === "SSD" && slotHdd)
        return assets$7.disks.caddy.loading.image;
      if (assets$7.loadingFlag && diskType === "SSD" && !slotHdd)
        return assets$7.disks.ssd.loading.image;
      if (assets$7.loadingFlag && diskType === "HDD" && !slotHdd)
        return assets$7.disks.ssd.loading.image;
      if (assets$7.loadingFlag && diskType === "HDD")
        return assets$7.disks.hdd.loading.image;
      if (diskType === "SSD" && slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$7.disks.caddy.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$7.disks.caddy.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$7.disks.caddy.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$7.disks.caddy.micron5300.image;
        }
        return assets$7.disks.caddy.default.image;
      }
      if (diskType === "SSD" && !slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$7.disks.ssd.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$7.disks.ssd.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$7.disks.ssd.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$7.disks.ssd.micron5300.image;
        }
        return assets$7.disks.ssd.default.image;
      }
      if (diskType === "HDD" && slotHdd) {
        if (/ST18000|ST16000|ST20000|ST14000|ST12000/.test(modelName)) {
          return assets$7.disks.hdd.seagateSt.image;
        } else if (/Seagate Enterprise/.test(modelFamily)) {
          return assets$7.disks.hdd.seagate.image;
        } else if (/TOSHIBA/.test(modelName)) {
          return assets$7.disks.hdd.toshiba.image;
        } else {
          return assets$7.disks.hdd.default.image;
        }
      }
      if (diskType === "HDD" && !slotHdd) {
        return assets$7.disks.ssd.hdd25.image;
      }
    }
    const p5Script = function(p5) {
      loadingAnimation(p5);
      zfsAnimation(p5);
      p5.preload = (_) => {
        assets$7.chassis.image = p5.loadImage(assets$7.chassis.path);
        assets$7.fade.image = p5.loadImage(assets$7.fade.path);
        Object.entries(assets$7.disks.caddy).forEach(([dsk, val]) => {
          assets$7.disks.caddy[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$7.disks.ssd).forEach(([dsk, val]) => {
          assets$7.disks.ssd[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$7.disks.hdd).forEach(([dsk, val]) => {
          assets$7.disks.hdd[dsk].image = p5.loadImage(val.path);
        });
        diskInfoObj.value.rows.flat().forEach((slot) => {
          const index2 = diskLocations$7.findIndex((loc) => loc.BAY === slot["bay-id"]);
          if (index2 === -1)
            return;
          diskLocations$7[index2].occupied = slot.occupied;
          diskLocations$7[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$7[index2].HDD);
        });
      };
      p5.setup = (_) => {
        const canvas = p5.createCanvas(assets$7.chassis.image.width, assets$7.chassis.image.height + assets$7.fade.image.height);
        canvas.parent("p5-q30-h16-storinator");
        p5.image(assets$7.fade.image, 0, 0);
        diskLocations$7.forEach((loc) => {
          loc.y += assets$7.fade.image.height;
        });
        resizeHook(p5, canvas.id(), assets$7.chassis.image.width);
      };
      p5.draw = (_) => {
        if (assets$7.loadingFlag) {
          p5.frameRate(10);
          p5.loadingAnimationIndex = p5.int((p5.loadingAnimationIndex + 1) % p5.loadingAnimationSteps);
        } else {
          p5.frameRate(24);
        }
        p5.image(assets$7.chassis.image, 0, assets$7.fade.image.height);
        diskLocations$7.forEach((loc) => {
          if (loc.occupied && loc.image) {
            p5.image(loc.image, loc.x, loc.y);
            if (assets$7.loadingFlag) {
              p5.animateLoading(loc.x, loc.y, loc.image.width, loc.image.height, p5.animationSteps, p5.animationLoadingIndex);
            }
          }
        });
        if (currentDisk.value) {
          let idx = diskLocations$7.findIndex((loc) => loc.BAY === currentDisk.value);
          if (diskLocations$7[idx].image) {
            if (enableZfsAnimations.flag) {
              p5.showZfs(currentDisk.value, zfsInfo, diskLocations$7);
            }
            p5.fill(255, 255, 255, 50);
            p5.stroke(206, 242, 212);
            p5.strokeWeight(2);
            p5.rect(diskLocations$7[idx].x, diskLocations$7[idx].y, diskLocations$7[idx].image.width, diskLocations$7[idx].image.height);
          }
        }
      };
      p5.mouseClicked = (_) => {
        let mx = p5.mouseX;
        let my = p5.mouseY;
        diskLocations$7.forEach((loc) => {
          if (loc.image && mx > loc.x && mx < loc.x + loc.image.width && my > loc.y && my < loc.y + loc.image.height) {
            currentDisk.value = loc.BAY;
          }
        });
      };
    };
    onMounted(() => {
      new P5(p5Script);
    });
    return {
      diskInfoObj,
      currentDisk,
      lsdevJson,
      diskInfo,
      enableZfsAnimations
    };
  }
};
const _hoisted_1$a = {
  id: "p5-q30-h16-storinator",
  class: "self-stretch m-2 flex justify-center"
};
function _sfc_render$a(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1$a);
}
var P5StorinatorQ30H16 = /* @__PURE__ */ _export_sfc(_sfc_main$a, [["render", _sfc_render$a]]);
const assets$6 = {
  chassis: {
    path: "img/chassis/av15-storinator.png",
    image: null
  },
  fade: {
    path: "img/chassis/chassis-fade.png",
    image: null
  },
  disks: {
    caddy: {
      default: {
        path: "img/disks/caddy-generic.png",
        image: null
      },
      micron5200: {
        path: "img/disks/caddy-micron.png",
        image: null
      },
      micron5300: {
        path: "img/disks/caddy-micron-5300.png",
        image: null
      },
      seagate: {
        path: "img/disks/caddy-seagate.png",
        image: null
      },
      seagateSas: {
        path: "img/disks/caddy-seagate-sas.png",
        image: null
      },
      loading: {
        path: "img/disks/caddy-loading.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-caddy.png",
        image: null
      }
    },
    ssd: {
      loading: {
        path: "img/disks/ssd-loading.png",
        image: null
      },
      default: {
        path: "img/disks/ssd-generic.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-ssd.png",
        image: null
      }
    },
    hdd: {
      default: {
        path: "img/disks/hdd-generic.png",
        image: null
      },
      seagateSt: {
        path: "img/disks/hdd-seagate-st.png",
        image: null
      },
      seagate: {
        path: "img/disks/hdd-seagate.png",
        image: null
      },
      toshiba: {
        path: "img/disks/hdd-toshiba.png",
        image: null
      },
      loading: {
        path: "img/disks/hdd-loading.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-hdd.png",
        image: null
      }
    }
  },
  loadingFlag: true
};
const diskLocations$6 = [
  {
    x: 459,
    y: 33,
    BAY: "1-1",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 427,
    y: 33,
    BAY: "1-2",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 394,
    y: 33,
    BAY: "1-3",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 362,
    y: 33,
    BAY: "1-4",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 330,
    y: 33,
    BAY: "1-5",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 298,
    y: 33,
    BAY: "1-6",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 266,
    y: 33,
    BAY: "1-7",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 234,
    y: 33,
    BAY: "1-8",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 202,
    y: 33,
    BAY: "1-9",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 170,
    y: 33,
    BAY: "1-10",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 138,
    y: 33,
    BAY: "1-11",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 106,
    y: 33,
    BAY: "1-12",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 74,
    y: 33,
    BAY: "1-13",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 42,
    y: 33,
    BAY: "1-14",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 10,
    y: 33,
    BAY: "1-15",
    HDD: true,
    occupied: false,
    image: null
  }
];
const _sfc_main$9 = {
  name: "P5StorinatorAV15",
  setup() {
    const diskInfoObj = ref({});
    const currentDisk = inject("currentDisk");
    const lsdevJson = inject("lsdevJson");
    const diskInfo = inject("diskInfo");
    const zfsInfo = inject("zfsInfo");
    const enableZfsAnimations = inject("enableZfsAnimations");
    watch(diskInfo, () => {
      diskInfoObj.value = diskInfo;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$6.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$6[index2].occupied = slot.occupied;
        diskLocations$6[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$6[index2].HDD);
      });
    }, { immediate: true, deep: true });
    watch(lsdevJson, () => {
      diskInfoObj.value = lsdevJson;
      assets$6.loadingFlag = false;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$6.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$6[index2].occupied = slot.occupied;
        diskLocations$6[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$6[index2].HDD);
      });
    }, { immediate: false, deep: true });
    function getDiskImage(occupied, modelName, modelFamily, diskType, slotHdd) {
      if (!occupied) {
        return slotHdd ? assets$6.disks.hdd.empty.image : assets$6.disks.ssd.empty.image;
      }
      if (assets$6.loadingFlag && diskType === "SSD" && slotHdd)
        return assets$6.disks.caddy.loading.image;
      if (assets$6.loadingFlag && diskType === "SSD" && !slotHdd)
        return assets$6.disks.ssd.loading.image;
      if (assets$6.loadingFlag && diskType === "HDD")
        return assets$6.disks.hdd.loading.image;
      if (diskType === "SSD" && slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$6.disks.caddy.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$6.disks.caddy.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$6.disks.caddy.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$6.disks.caddy.micron5300.image;
        }
        return assets$6.disks.caddy.default.image;
      }
      if (diskType === "SSD" && !slotHdd) {
        return assets$6.disks.caddy.default.image;
      }
      if (diskType === "HDD") {
        if (/ST18000|ST16000|ST20000|ST14000|ST12000/.test(modelName)) {
          return assets$6.disks.hdd.seagateSt.image;
        } else if (/Seagate Enterprise/.test(modelFamily)) {
          return assets$6.disks.hdd.seagate.image;
        } else if (/TOSHIBA/.test(modelName)) {
          return assets$6.disks.hdd.toshiba.image;
        } else {
          return assets$6.disks.hdd.default.image;
        }
      }
    }
    const p5Script = function(p5) {
      loadingAnimation(p5);
      zfsAnimation(p5);
      p5.preload = (_) => {
        assets$6.chassis.image = p5.loadImage(assets$6.chassis.path);
        assets$6.fade.image = p5.loadImage(assets$6.fade.path);
        Object.entries(assets$6.disks.caddy).forEach(([dsk, val]) => {
          assets$6.disks.caddy[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$6.disks.ssd).forEach(([dsk, val]) => {
          assets$6.disks.ssd[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$6.disks.hdd).forEach(([dsk, val]) => {
          assets$6.disks.hdd[dsk].image = p5.loadImage(val.path);
        });
        diskInfoObj.value.rows.flat().forEach((slot) => {
          const index2 = diskLocations$6.findIndex((loc) => loc.BAY === slot["bay-id"]);
          if (index2 === -1)
            return;
          diskLocations$6[index2].occupied = slot.occupied;
          diskLocations$6[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$6[index2].HDD);
        });
      };
      p5.setup = (_) => {
        const canvas = p5.createCanvas(assets$6.chassis.image.width, assets$6.chassis.image.height + assets$6.fade.image.height);
        canvas.parent("p5-av15-storinator");
        p5.image(assets$6.fade.image, 0, 0);
        diskLocations$6.forEach((loc) => {
          loc.y += assets$6.fade.image.height;
        });
        resizeHook(p5, canvas.id(), assets$6.chassis.image.width);
      };
      p5.draw = (_) => {
        if (assets$6.loadingFlag) {
          p5.frameRate(10);
          p5.loadingAnimationIndex = p5.int((p5.loadingAnimationIndex + 1) % p5.loadingAnimationSteps);
        } else {
          p5.frameRate(24);
        }
        p5.image(assets$6.chassis.image, 0, assets$6.fade.image.height);
        diskLocations$6.forEach((loc) => {
          if (loc.occupied && loc.image) {
            p5.image(loc.image, loc.x, loc.y);
            if (assets$6.loadingFlag) {
              p5.animateLoading(loc.x, loc.y, loc.image.width, loc.image.height, p5.animationSteps, p5.animationLoadingIndex);
            }
          }
        });
        if (currentDisk.value) {
          let idx = diskLocations$6.findIndex((loc) => loc.BAY === currentDisk.value);
          if (diskLocations$6[idx].image) {
            if (enableZfsAnimations.flag) {
              p5.showZfs(currentDisk.value, zfsInfo, diskLocations$6);
            }
            p5.fill(255, 255, 255, 50);
            p5.stroke(206, 242, 212);
            p5.strokeWeight(2);
            p5.rect(diskLocations$6[idx].x, diskLocations$6[idx].y, diskLocations$6[idx].image.width, diskLocations$6[idx].image.height);
          }
        }
      };
      p5.mouseClicked = (_) => {
        let mx = p5.mouseX;
        let my = p5.mouseY;
        diskLocations$6.forEach((loc) => {
          if (loc.image && mx > loc.x && mx < loc.x + loc.image.width && my > loc.y && my < loc.y + loc.image.height) {
            currentDisk.value = loc.BAY;
          }
        });
      };
    };
    onMounted(() => {
      new P5(p5Script);
    });
    return {
      diskInfoObj,
      currentDisk,
      lsdevJson,
      diskInfo,
      enableZfsAnimations
    };
  }
};
const _hoisted_1$9 = {
  id: "p5-av15-storinator",
  class: "self-stretch m-2 flex justify-center"
};
function _sfc_render$9(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1$9);
}
var P5StorinatorAV15 = /* @__PURE__ */ _export_sfc(_sfc_main$9, [["render", _sfc_render$9]]);
const assets$5 = {
  chassis: {
    path: "img/chassis/hl15-homelab.png",
    image: null
  },
  fade: {
    path: "img/chassis/hl15-chassis-fade.png",
    image: null
  },
  disks: {
    caddy: {
      default: {
        path: "img/disks/caddy-generic.png",
        image: null
      },
      micron5200: {
        path: "img/disks/caddy-micron.png",
        image: null
      },
      micron5300: {
        path: "img/disks/caddy-micron-5300.png",
        image: null
      },
      seagate: {
        path: "img/disks/caddy-seagate.png",
        image: null
      },
      seagateSas: {
        path: "img/disks/caddy-seagate-sas.png",
        image: null
      },
      loading: {
        path: "img/disks/caddy-loading.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-caddy.png",
        image: null
      }
    },
    ssd: {
      loading: {
        path: "img/disks/ssd-loading.png",
        image: null
      },
      default: {
        path: "img/disks/ssd-generic.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-ssd.png",
        image: null
      }
    },
    hdd: {
      default: {
        path: "img/disks/hdd-generic.png",
        image: null
      },
      seagateSt: {
        path: "img/disks/hdd-seagate-st.png",
        image: null
      },
      seagate: {
        path: "img/disks/hdd-seagate.png",
        image: null
      },
      toshiba: {
        path: "img/disks/hdd-toshiba.png",
        image: null
      },
      loading: {
        path: "img/disks/hdd-loading.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-hdd.png",
        image: null
      }
    }
  },
  loadingFlag: true
};
const diskLocations$5 = [
  {
    x: 459,
    y: 33,
    BAY: "1-1",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 427,
    y: 33,
    BAY: "1-2",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 394,
    y: 33,
    BAY: "1-3",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 362,
    y: 33,
    BAY: "1-4",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 330,
    y: 33,
    BAY: "1-5",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 298,
    y: 33,
    BAY: "1-6",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 266,
    y: 33,
    BAY: "1-7",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 234,
    y: 33,
    BAY: "1-8",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 202,
    y: 33,
    BAY: "1-9",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 170,
    y: 33,
    BAY: "1-10",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 138,
    y: 33,
    BAY: "1-11",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 106,
    y: 33,
    BAY: "1-12",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 74,
    y: 33,
    BAY: "1-13",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 42,
    y: 33,
    BAY: "1-14",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 10,
    y: 33,
    BAY: "1-15",
    HDD: true,
    occupied: false,
    image: null
  }
];
const _sfc_main$8 = {
  name: "P5HomeLabHL15",
  setup() {
    const diskInfoObj = ref({});
    const currentDisk = inject("currentDisk");
    const lsdevJson = inject("lsdevJson");
    const diskInfo = inject("diskInfo");
    const zfsInfo = inject("zfsInfo");
    const enableZfsAnimations = inject("enableZfsAnimations");
    watch(diskInfo, () => {
      diskInfoObj.value = diskInfo;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$5.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$5[index2].occupied = slot.occupied;
        diskLocations$5[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$5[index2].HDD);
      });
    }, { immediate: true, deep: true });
    watch(lsdevJson, () => {
      diskInfoObj.value = lsdevJson;
      assets$5.loadingFlag = false;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$5.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$5[index2].occupied = slot.occupied;
        diskLocations$5[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$5[index2].HDD);
      });
    }, { immediate: false, deep: true });
    function getDiskImage(occupied, modelName, modelFamily, diskType, slotHdd) {
      if (!occupied) {
        return slotHdd ? assets$5.disks.hdd.empty.image : assets$5.disks.ssd.empty.image;
      }
      if (assets$5.loadingFlag && diskType === "SSD" && slotHdd)
        return assets$5.disks.caddy.loading.image;
      if (assets$5.loadingFlag && diskType === "SSD" && !slotHdd)
        return assets$5.disks.ssd.loading.image;
      if (assets$5.loadingFlag && diskType === "HDD")
        return assets$5.disks.hdd.loading.image;
      if (diskType === "SSD" && slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$5.disks.caddy.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$5.disks.caddy.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$5.disks.caddy.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$5.disks.caddy.micron5300.image;
        }
        return assets$5.disks.caddy.default.image;
      }
      if (diskType === "SSD" && !slotHdd) {
        return assets$5.disks.caddy.default.image;
      }
      if (diskType === "HDD") {
        if (/ST18000|ST16000|ST20000|ST14000|ST12000/.test(modelName)) {
          return assets$5.disks.hdd.seagateSt.image;
        } else if (/Seagate Enterprise/.test(modelFamily)) {
          return assets$5.disks.hdd.seagate.image;
        } else if (/TOSHIBA/.test(modelName)) {
          return assets$5.disks.hdd.toshiba.image;
        } else {
          return assets$5.disks.hdd.default.image;
        }
      }
    }
    const p5Script = function(p5) {
      loadingAnimation(p5);
      zfsAnimation(p5);
      p5.preload = (_) => {
        assets$5.chassis.image = p5.loadImage(assets$5.chassis.path);
        assets$5.fade.image = p5.loadImage(assets$5.fade.path);
        Object.entries(assets$5.disks.caddy).forEach(([dsk, val]) => {
          assets$5.disks.caddy[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$5.disks.ssd).forEach(([dsk, val]) => {
          assets$5.disks.ssd[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$5.disks.hdd).forEach(([dsk, val]) => {
          assets$5.disks.hdd[dsk].image = p5.loadImage(val.path);
        });
        diskInfoObj.value.rows.flat().forEach((slot) => {
          const index2 = diskLocations$5.findIndex((loc) => loc.BAY === slot["bay-id"]);
          if (index2 === -1)
            return;
          diskLocations$5[index2].occupied = slot.occupied;
          diskLocations$5[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$5[index2].HDD);
        });
      };
      p5.setup = (_) => {
        const canvas = p5.createCanvas(assets$5.chassis.image.width, assets$5.chassis.image.height + assets$5.fade.image.height);
        canvas.parent("p5-hl15-homelab");
        p5.image(assets$5.fade.image, 0, 0);
        diskLocations$5.forEach((loc) => {
          loc.y += assets$5.fade.image.height;
        });
        resizeHook(p5, canvas.id(), assets$5.chassis.image.width);
      };
      p5.draw = (_) => {
        if (assets$5.loadingFlag) {
          p5.frameRate(10);
          p5.loadingAnimationIndex = p5.int((p5.loadingAnimationIndex + 1) % p5.loadingAnimationSteps);
        } else {
          p5.frameRate(24);
        }
        p5.image(assets$5.chassis.image, 0, assets$5.fade.image.height);
        diskLocations$5.forEach((loc) => {
          if (loc.occupied && loc.image) {
            p5.image(loc.image, loc.x, loc.y);
            if (assets$5.loadingFlag) {
              p5.animateLoading(loc.x, loc.y, loc.image.width, loc.image.height, p5.animationSteps, p5.animationLoadingIndex);
            }
          }
        });
        if (currentDisk.value) {
          let idx = diskLocations$5.findIndex((loc) => loc.BAY === currentDisk.value);
          if (diskLocations$5[idx].image) {
            if (enableZfsAnimations.flag) {
              p5.showZfs(currentDisk.value, zfsInfo, diskLocations$5);
            }
            p5.fill(255, 255, 255, 50);
            p5.stroke(206, 242, 212);
            p5.strokeWeight(2);
            p5.rect(diskLocations$5[idx].x, diskLocations$5[idx].y, diskLocations$5[idx].image.width, diskLocations$5[idx].image.height);
          }
        }
      };
      p5.mouseClicked = (_) => {
        let mx = p5.mouseX;
        let my = p5.mouseY;
        diskLocations$5.forEach((loc) => {
          if (loc.image && mx > loc.x && mx < loc.x + loc.image.width && my > loc.y && my < loc.y + loc.image.height) {
            currentDisk.value = loc.BAY;
          }
        });
      };
    };
    onMounted(() => {
      new P5(p5Script);
    });
    return {
      diskInfoObj,
      currentDisk,
      lsdevJson,
      diskInfo,
      enableZfsAnimations
    };
  }
};
const _hoisted_1$8 = {
  id: "p5-hl15-homelab",
  class: "self-stretch m-2 flex justify-center"
};
function _sfc_render$8(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1$8);
}
var P5HomeLabHL15 = /* @__PURE__ */ _export_sfc(_sfc_main$8, [["render", _sfc_render$8]]);
const assets$4 = {
  chassis: {
    path: "img/chassis/q30-h32-storinator.png",
    image: null
  },
  fade: {
    path: "img/chassis/chassis-fade.png",
    image: null
  },
  disks: {
    caddy: {
      default: {
        path: "img/disks/caddy-generic.png",
        image: null
      },
      micron5200: {
        path: "img/disks/caddy-micron.png",
        image: null
      },
      micron5300: {
        path: "img/disks/caddy-micron-5300.png",
        image: null
      },
      seagate: {
        path: "img/disks/caddy-seagate.png",
        image: null
      },
      seagateSas: {
        path: "img/disks/caddy-seagate-sas.png",
        image: null
      },
      loading: {
        path: "img/disks/caddy-loading.png",
        image: null
      }
    },
    ssd: {
      micron5200: {
        path: "img/disks/ssd-micron.png",
        image: null
      },
      micron5300: {
        path: "img/disks/ssd-micron-5300.png",
        image: null
      },
      seagate: {
        path: "img/disks/ssd-seagate.png",
        image: null
      },
      seagateSas: {
        path: "img/disks/ssd-seagate-sas.png",
        image: null
      },
      default: {
        path: "img/disks/ssd-generic.png",
        image: null
      },
      loading: {
        path: "img/disks/ssd-loading.png",
        image: null
      },
      hdd25: {
        path: "img/disks/hdd-25.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-ssd.png",
        image: null
      }
    },
    hdd: {
      default: {
        path: "img/disks/hdd-generic.png",
        image: null
      },
      seagateSt: {
        path: "img/disks/hdd-seagate-st.png",
        image: null
      },
      seagate: {
        path: "img/disks/hdd-seagate.png",
        image: null
      },
      toshiba: {
        path: "img/disks/hdd-toshiba.png",
        image: null
      },
      loading: {
        path: "img/disks/hdd-loading.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-hdd.png",
        image: null
      }
    }
  },
  loadingFlag: true
};
const diskLocations$4 = [
  {
    x: 460,
    y: 197,
    BAY: "1-1",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 428,
    y: 197,
    BAY: "1-2",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 396,
    y: 197,
    BAY: "1-3",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 364,
    y: 197,
    BAY: "1-4",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 332,
    y: 197,
    BAY: "1-5",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 300,
    y: 197,
    BAY: "1-6",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 268,
    y: 197,
    BAY: "1-7",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 236,
    y: 197,
    BAY: "1-8",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 204,
    y: 197,
    BAY: "1-9",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 172,
    y: 197,
    BAY: "1-10",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 140,
    y: 197,
    BAY: "1-11",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 108,
    y: 197,
    BAY: "1-12",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 76,
    y: 197,
    BAY: "1-13",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 44,
    y: 197,
    BAY: "1-14",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 12,
    y: 197,
    BAY: "1-15",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 476,
    y: 46,
    BAY: "1-16",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 464,
    y: 46,
    BAY: "1-17",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 439,
    y: 46,
    BAY: "1-18",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 428,
    y: 46,
    BAY: "1-19",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 417,
    y: 46,
    BAY: "1-20",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 406,
    y: 46,
    BAY: "1-21",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 382,
    y: 46,
    BAY: "1-22",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 371,
    y: 46,
    BAY: "1-23",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 358,
    y: 46,
    BAY: "2-1",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 347,
    y: 46,
    BAY: "2-2",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 322,
    y: 46,
    BAY: "2-3",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 311,
    y: 46,
    BAY: "2-4",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 300,
    y: 46,
    BAY: "2-5",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 289,
    y: 46,
    BAY: "2-6",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 265,
    y: 46,
    BAY: "2-7",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 254,
    y: 46,
    BAY: "2-8",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 238,
    y: 46,
    BAY: "2-9",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 227,
    y: 46,
    BAY: "2-10",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 202,
    y: 46,
    BAY: "2-11",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 191,
    y: 46,
    BAY: "2-12",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 180,
    y: 46,
    BAY: "2-13",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 169,
    y: 46,
    BAY: "2-14",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 145,
    y: 46,
    BAY: "2-15",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 134,
    y: 46,
    BAY: "2-16",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 121,
    y: 46,
    BAY: "2-17",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 110,
    y: 46,
    BAY: "2-18",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 85,
    y: 46,
    BAY: "2-19",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 74,
    y: 46,
    BAY: "2-20",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 63,
    y: 46,
    BAY: "2-21",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 52,
    y: 46,
    BAY: "2-22",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 27,
    y: 46,
    BAY: "2-23",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 16,
    y: 46,
    BAY: "2-24",
    HDD: false,
    occupied: false,
    image: null
  }
];
const _sfc_main$7 = {
  name: "P5StorinatorQ30H32",
  setup() {
    const diskInfoObj = ref({});
    const currentDisk = inject("currentDisk");
    const lsdevJson = inject("lsdevJson");
    const diskInfo = inject("diskInfo");
    const zfsInfo = inject("zfsInfo");
    const enableZfsAnimations = inject("enableZfsAnimations");
    watch(diskInfo, () => {
      diskInfoObj.value = diskInfo;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$4.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 === -1)
          return;
        diskLocations$4[index2].occupied = slot.occupied;
        diskLocations$4[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$4[index2].HDD);
      });
    }, { immediate: true, deep: true });
    watch(lsdevJson, () => {
      diskInfoObj.value = lsdevJson;
      assets$4.loadingFlag = false;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$4.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 === -1)
          return;
        diskLocations$4[index2].occupied = slot.occupied;
        diskLocations$4[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$4[index2].HDD);
      });
    }, { immediate: false, deep: true });
    function getDiskImage(occupied, modelName, modelFamily, diskType, slotHdd) {
      if (!occupied) {
        return slotHdd ? assets$4.disks.hdd.empty.image : assets$4.disks.ssd.empty.image;
      }
      if (assets$4.loadingFlag && diskType === "SSD" && slotHdd)
        return assets$4.disks.caddy.loading.image;
      if (assets$4.loadingFlag && diskType === "SSD" && !slotHdd)
        return assets$4.disks.ssd.loading.image;
      if (assets$4.loadingFlag && diskType === "HDD" && !slotHdd)
        return assets$4.disks.ssd.loading.image;
      if (assets$4.loadingFlag && diskType === "HDD")
        return assets$4.disks.hdd.loading.image;
      if (diskType === "SSD" && slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$4.disks.caddy.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$4.disks.caddy.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$4.disks.caddy.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$4.disks.caddy.micron5300.image;
        }
        return assets$4.disks.caddy.default.image;
      }
      if (diskType === "SSD" && !slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$4.disks.ssd.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$4.disks.ssd.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$4.disks.ssd.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$4.disks.ssd.micron5300.image;
        }
        return assets$4.disks.ssd.default.image;
      }
      if (diskType === "HDD" && slotHdd) {
        if (/ST18000|ST16000|ST20000|ST14000|ST12000/.test(modelName)) {
          return assets$4.disks.hdd.seagateSt.image;
        } else if (/Seagate Enterprise/.test(modelFamily)) {
          return assets$4.disks.hdd.seagate.image;
        } else if (/TOSHIBA/.test(modelName)) {
          return assets$4.disks.hdd.toshiba.image;
        } else {
          return assets$4.disks.hdd.default.image;
        }
      }
      if (diskType === "HDD" && !slotHdd) {
        return assets$4.disks.ssd.hdd25.image;
      }
    }
    const p5Script = function(p5) {
      loadingAnimation(p5);
      zfsAnimation(p5);
      p5.preload = (_) => {
        assets$4.chassis.image = p5.loadImage(assets$4.chassis.path);
        assets$4.fade.image = p5.loadImage(assets$4.fade.path);
        Object.entries(assets$4.disks.caddy).forEach(([dsk, val]) => {
          assets$4.disks.caddy[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$4.disks.ssd).forEach(([dsk, val]) => {
          assets$4.disks.ssd[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$4.disks.hdd).forEach(([dsk, val]) => {
          assets$4.disks.hdd[dsk].image = p5.loadImage(val.path);
        });
        diskInfoObj.value.rows.flat().forEach((slot) => {
          const index2 = diskLocations$4.findIndex((loc) => loc.BAY === slot["bay-id"]);
          if (index2 === -1)
            return;
          diskLocations$4[index2].occupied = slot.occupied;
          diskLocations$4[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$4[index2].HDD);
        });
      };
      p5.setup = (_) => {
        const canvas = p5.createCanvas(assets$4.chassis.image.width, assets$4.chassis.image.height + assets$4.fade.image.height);
        canvas.parent("p5-q30-h32-storinator");
        p5.image(assets$4.fade.image, 0, 0);
        diskLocations$4.forEach((loc) => {
          loc.y += assets$4.fade.image.height;
        });
        resizeHook(p5, canvas.id(), assets$4.chassis.image.width);
      };
      p5.draw = (_) => {
        if (assets$4.loadingFlag) {
          p5.frameRate(10);
          p5.loadingAnimationIndex = p5.int((p5.loadingAnimationIndex + 1) % p5.loadingAnimationSteps);
        } else {
          p5.frameRate(24);
        }
        p5.image(assets$4.chassis.image, 0, assets$4.fade.image.height);
        diskLocations$4.forEach((loc) => {
          if (loc.occupied && loc.image) {
            p5.image(loc.image, loc.x, loc.y);
            if (assets$4.loadingFlag) {
              p5.animateLoading(loc.x, loc.y, loc.image.width, loc.image.height, p5.animationSteps, p5.animationLoadingIndex);
            }
          }
        });
        if (currentDisk.value) {
          let idx = diskLocations$4.findIndex((loc) => loc.BAY === currentDisk.value);
          if (diskLocations$4[idx].image) {
            if (enableZfsAnimations.flag) {
              p5.showZfs(currentDisk.value, zfsInfo, diskLocations$4);
            }
            p5.fill(255, 255, 255, 50);
            p5.stroke(206, 242, 212);
            p5.strokeWeight(2);
            p5.rect(diskLocations$4[idx].x, diskLocations$4[idx].y, diskLocations$4[idx].image.width, diskLocations$4[idx].image.height);
          }
        }
      };
      p5.mouseClicked = (_) => {
        let mx = p5.mouseX;
        let my = p5.mouseY;
        diskLocations$4.forEach((loc) => {
          if (loc.image && mx > loc.x && mx < loc.x + loc.image.width && my > loc.y && my < loc.y + loc.image.height) {
            currentDisk.value = loc.BAY;
          }
        });
      };
    };
    onMounted(() => {
      new P5(p5Script);
    });
    return {
      diskInfoObj,
      currentDisk,
      lsdevJson,
      diskInfo,
      enableZfsAnimations
    };
  }
};
const _hoisted_1$7 = {
  id: "p5-q30-h32-storinator",
  class: "self-stretch m-2 flex justify-center"
};
function _sfc_render$7(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1$7);
}
var P5StorinatorQ30H32 = /* @__PURE__ */ _export_sfc(_sfc_main$7, [["render", _sfc_render$7]]);
const assets$3 = {
  chassis: {
    path: "img/chassis/xl60-h32-storinator.png",
    image: null
  },
  fade: {
    path: "img/chassis/chassis-fade-90.png",
    image: null
  },
  disks: {
    caddy: {
      default: {
        path: "img/disks/caddy-generic-90.png",
        image: null
      },
      micron5200: {
        path: "img/disks/caddy-micron-90.png",
        image: null
      },
      micron5300: {
        path: "img/disks/caddy-micron-5300-90.png",
        image: null
      },
      seagate: {
        path: "img/disks/caddy-seagate-90.png",
        image: null
      },
      seagateSas: {
        path: "img/disks/caddy-seagate-sas-90.png",
        image: null
      },
      loading: {
        path: "img/disks/caddy-loading-90.png",
        image: null
      }
    },
    ssd: {
      micron5200: {
        path: "img/disks/ssd-micron-90.png",
        image: null
      },
      micron5300: {
        path: "img/disks/ssd-micron-5300-90.png",
        image: null
      },
      seagate: {
        path: "img/disks/ssd-seagate-90.png",
        image: null
      },
      seagateSas: {
        path: "img/disks/ssd-seagate-sas-90.png",
        image: null
      },
      default: {
        path: "img/disks/ssd-generic-90.png",
        image: null
      },
      loading: {
        path: "img/disks/ssd-loading-90.png",
        image: null
      },
      hdd25: {
        path: "img/disks/hdd-25-90.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-ssd-90.png",
        image: null
      }
    },
    hdd: {
      default: {
        path: "img/disks/hdd-generic-90.png",
        image: null
      },
      seagateSt: {
        path: "img/disks/hdd-seagate-st-90.png",
        image: null
      },
      seagate: {
        path: "img/disks/hdd-seagate-90.png",
        image: null
      },
      toshiba: {
        path: "img/disks/hdd-toshiba-90.png",
        image: null
      },
      loading: {
        path: "img/disks/hdd-loading-90.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-hdd-90.png",
        image: null
      }
    }
  },
  loadingFlag: true
};
const diskLocations$3 = [
  {
    x: 525,
    y: 10,
    BAY: "1-1",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 42,
    BAY: "1-2",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 74,
    BAY: "1-3",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 106,
    BAY: "1-4",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 138,
    BAY: "1-5",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 170,
    BAY: "1-6",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 202,
    BAY: "1-7",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 234,
    BAY: "1-8",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 266,
    BAY: "1-9",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 298,
    BAY: "1-10",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 330,
    BAY: "1-11",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 362,
    BAY: "1-12",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 394,
    BAY: "1-13",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 426,
    BAY: "1-14",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 458,
    BAY: "1-15",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 10,
    BAY: "2-1",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 42,
    BAY: "2-2",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 74,
    BAY: "2-3",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 106,
    BAY: "2-4",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 138,
    BAY: "2-5",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 170,
    BAY: "2-6",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 202,
    BAY: "2-7",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 234,
    BAY: "2-8",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 266,
    BAY: "2-9",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 298,
    BAY: "2-10",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 330,
    BAY: "2-11",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 362,
    BAY: "2-12",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 394,
    BAY: "2-13",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 426,
    BAY: "2-14",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 458,
    BAY: "2-15",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 10,
    BAY: "3-1",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 42,
    BAY: "3-2",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 74,
    BAY: "3-3",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 106,
    BAY: "3-4",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 138,
    BAY: "3-5",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 170,
    BAY: "3-6",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 202,
    BAY: "3-7",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 234,
    BAY: "3-8",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 266,
    BAY: "3-9",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 298,
    BAY: "3-10",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 330,
    BAY: "3-11",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 362,
    BAY: "3-12",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 394,
    BAY: "3-13",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 426,
    BAY: "3-14",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 458,
    BAY: "3-15",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 16,
    BAY: "3-16",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 27,
    BAY: "3-17",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 53,
    BAY: "3-18",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 64,
    BAY: "3-19",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 75,
    BAY: "3-20",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 86,
    BAY: "3-21",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 110,
    BAY: "3-22",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 121,
    BAY: "3-23",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 134,
    BAY: "4-1",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 145,
    BAY: "4-2",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 170,
    BAY: "4-3",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 181,
    BAY: "4-4",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 192,
    BAY: "4-5",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 203,
    BAY: "4-6",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 228,
    BAY: "4-7",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 239,
    BAY: "4-8",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 254,
    BAY: "4-9",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 265,
    BAY: "4-10",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 290,
    BAY: "4-11",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 301,
    BAY: "4-12",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 312,
    BAY: "4-13",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 323,
    BAY: "4-14",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 347,
    BAY: "4-15",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 358,
    BAY: "4-16",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 371,
    BAY: "4-17",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 382,
    BAY: "4-18",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 407,
    BAY: "4-19",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 418,
    BAY: "4-20",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 429,
    BAY: "4-21",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 439,
    BAY: "4-22",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 465,
    BAY: "4-23",
    HDD: false,
    occupied: false,
    image: null
  },
  {
    x: 46,
    y: 476,
    BAY: "4-24",
    HDD: false,
    occupied: false,
    image: null
  }
];
const _sfc_main$6 = {
  name: "P5StorinatorXL60H16",
  setup() {
    const diskInfoObj = ref({});
    const currentDisk = inject("currentDisk");
    const lsdevJson = inject("lsdevJson");
    const diskInfo = inject("diskInfo");
    const zfsInfo = inject("zfsInfo");
    const enableZfsAnimations = inject("enableZfsAnimations");
    watch(diskInfo, () => {
      diskInfoObj.value = diskInfo;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$3.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$3[index2].occupied = slot.occupied;
        diskLocations$3[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$3[index2].HDD);
      });
    }, { immediate: true, deep: true });
    watch(lsdevJson, () => {
      diskInfoObj.value = lsdevJson;
      assets$3.loadingFlag = false;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$3.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 === -1)
          return;
        diskLocations$3[index2].occupied = slot.occupied;
        diskLocations$3[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$3[index2].HDD);
      });
    }, { immediate: false, deep: true });
    function getDiskImage(occupied, modelName, modelFamily, diskType, slotHdd) {
      if (!occupied) {
        return slotHdd ? assets$3.disks.hdd.empty.image : assets$3.disks.ssd.empty.image;
      }
      if (assets$3.loadingFlag && diskType === "SSD" && slotHdd)
        return assets$3.disks.caddy.loading.image;
      if (assets$3.loadingFlag && diskType === "SSD" && !slotHdd)
        return assets$3.disks.ssd.loading.image;
      if (assets$3.loadingFlag && diskType === "HDD" && !slotHdd)
        return assets$3.disks.ssd.loading.image;
      if (assets$3.loadingFlag && diskType === "HDD")
        return assets$3.disks.hdd.loading.image;
      if (diskType === "SSD" && slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$3.disks.caddy.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$3.disks.caddy.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$3.disks.caddy.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$3.disks.caddy.micron5300.image;
        }
        return assets$3.disks.caddy.default.image;
      }
      if (diskType === "SSD" && !slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$3.disks.ssd.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$3.disks.ssd.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$3.disks.ssd.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$3.disks.ssd.micron5300.image;
        }
        return assets$3.disks.ssd.default.image;
      }
      if (diskType === "HDD" && slotHdd) {
        if (/ST18000|ST16000|ST20000|ST14000|ST12000/.test(modelName)) {
          return assets$3.disks.hdd.seagateSt.image;
        } else if (/Seagate Enterprise/.test(modelFamily)) {
          return assets$3.disks.hdd.seagate.image;
        } else if (/TOSHIBA/.test(modelName)) {
          return assets$3.disks.hdd.toshiba.image;
        } else {
          return assets$3.disks.hdd.default.image;
        }
      }
      if (diskType === "HDD" && !slotHdd) {
        return assets$3.disks.ssd.hdd25.image;
      }
    }
    const p5Script = function(p5) {
      loadingAnimation(p5);
      zfsAnimation(p5);
      p5.preload = (_) => {
        assets$3.chassis.image = p5.loadImage(assets$3.chassis.path);
        assets$3.fade.image = p5.loadImage(assets$3.fade.path);
        Object.entries(assets$3.disks.caddy).forEach(([dsk, val]) => {
          assets$3.disks.caddy[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$3.disks.ssd).forEach(([dsk, val]) => {
          assets$3.disks.ssd[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$3.disks.hdd).forEach(([dsk, val]) => {
          assets$3.disks.hdd[dsk].image = p5.loadImage(val.path);
        });
        diskInfoObj.value.rows.flat().forEach((slot) => {
          const index2 = diskLocations$3.findIndex((loc) => loc.BAY === slot["bay-id"]);
          if (index2 === -1)
            return;
          diskLocations$3[index2].occupied = slot.occupied;
          diskLocations$3[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$3[index2].HDD);
        });
      };
      p5.setup = (_) => {
        const canvas = p5.createCanvas(assets$3.chassis.image.width + assets$3.fade.image.width, assets$3.chassis.image.height);
        canvas.parent("p5-xl60-h32-storinator");
        p5.image(assets$3.fade.image, 0, 0);
        diskLocations$3.forEach((loc) => {
          loc.x += assets$3.fade.image.width;
        });
        resizeHook(p5, canvas.id(), assets$3.chassis.image.width + assets$3.fade.image.width);
      };
      p5.draw = (_) => {
        if (assets$3.loadingFlag) {
          p5.frameRate(10);
          p5.loadingAnimationIndex = p5.int((p5.loadingAnimationIndex + 1) % p5.loadingAnimationSteps);
        } else {
          p5.frameRate(24);
        }
        p5.image(assets$3.chassis.image, assets$3.fade.image.width, 0);
        diskLocations$3.forEach((loc) => {
          if (loc.occupied && loc.image) {
            p5.image(loc.image, loc.x, loc.y);
            if (assets$3.loadingFlag) {
              p5.animateLoading(loc.x, loc.y, loc.image.width, loc.image.height, p5.animationSteps, p5.animationLoadingIndex);
            }
          }
        });
        if (currentDisk.value) {
          let idx = diskLocations$3.findIndex((loc) => loc.BAY === currentDisk.value);
          if (diskLocations$3[idx].image) {
            if (enableZfsAnimations.flag) {
              p5.showZfs(currentDisk.value, zfsInfo, diskLocations$3);
            }
            p5.fill(255, 255, 255, 50);
            p5.stroke(206, 242, 212);
            p5.strokeWeight(2);
            p5.rect(diskLocations$3[idx].x, diskLocations$3[idx].y, diskLocations$3[idx].image.width, diskLocations$3[idx].image.height);
          }
        }
      };
      p5.mouseClicked = (_) => {
        let mx = p5.mouseX;
        let my = p5.mouseY;
        diskLocations$3.forEach((loc) => {
          if (loc.image && mx > loc.x && mx < loc.x + loc.image.width && my > loc.y && my < loc.y + loc.image.height) {
            currentDisk.value = loc.BAY;
          }
        });
      };
    };
    onMounted(() => {
      new P5(p5Script);
    });
    return {
      diskInfoObj,
      currentDisk,
      lsdevJson,
      diskInfo,
      enableZfsAnimations
    };
  }
};
const _hoisted_1$6 = {
  id: "p5-xl60-h32-storinator",
  class: "self-stretch m-2 flex justify-center"
};
function _sfc_render$6(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1$6);
}
var P5StorinatorXL60H32 = /* @__PURE__ */ _export_sfc(_sfc_main$6, [["render", _sfc_render$6]]);
const assets$2 = {
  chassis: {
    path: "img/chassis/xl60-storinator.png",
    image: null
  },
  fade: {
    path: "img/chassis/chassis-fade-90.png",
    image: null
  },
  disks: {
    caddy: {
      default: {
        path: "img/disks/caddy-generic-90.png",
        image: null
      },
      micron5200: {
        path: "img/disks/caddy-micron-90.png",
        image: null
      },
      micron5300: {
        path: "img/disks/caddy-micron-5300-90.png",
        image: null
      },
      seagate: {
        path: "img/disks/caddy-seagate-90.png",
        image: null
      },
      seagateSas: {
        path: "img/disks/caddy-seagate-sas-90.png",
        image: null
      },
      loading: {
        path: "img/disks/caddy-loading-90.png",
        image: null
      }
    },
    ssd: {
      micron5200: {
        path: "img/disks/ssd-micron-90.png",
        image: null
      },
      micron5300: {
        path: "img/disks/ssd-micron-5300-90.png",
        image: null
      },
      seagate: {
        path: "img/disks/ssd-seagate-90.png",
        image: null
      },
      seagateSas: {
        path: "img/disks/ssd-seagate-sas-90.png",
        image: null
      },
      default: {
        path: "img/disks/ssd-generic-90.png",
        image: null
      },
      loading: {
        path: "img/disks/ssd-loading-90.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-ssd-90.png",
        image: null
      }
    },
    hdd: {
      default: {
        path: "img/disks/hdd-generic-90.png",
        image: null
      },
      seagateSt: {
        path: "img/disks/hdd-seagate-st-90.png",
        image: null
      },
      seagate: {
        path: "img/disks/hdd-seagate-90.png",
        image: null
      },
      toshiba: {
        path: "img/disks/hdd-toshiba-90.png",
        image: null
      },
      loading: {
        path: "img/disks/hdd-loading-90.png",
        image: null
      },
      empty: {
        path: "img/disks/empty-hdd-90.png",
        image: null
      }
    }
  },
  loadingFlag: true
};
const diskLocations$2 = [
  {
    x: 525,
    y: 10,
    BAY: "1-1",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 42,
    BAY: "1-2",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 74,
    BAY: "1-3",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 106,
    BAY: "1-4",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 138,
    BAY: "1-5",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 170,
    BAY: "1-6",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 202,
    BAY: "1-7",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 234,
    BAY: "1-8",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 266,
    BAY: "1-9",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 298,
    BAY: "1-10",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 330,
    BAY: "1-11",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 362,
    BAY: "1-12",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 394,
    BAY: "1-13",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 426,
    BAY: "1-14",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 525,
    y: 458,
    BAY: "1-15",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 10,
    BAY: "2-1",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 42,
    BAY: "2-2",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 74,
    BAY: "2-3",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 106,
    BAY: "2-4",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 138,
    BAY: "2-5",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 170,
    BAY: "2-6",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 202,
    BAY: "2-7",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 234,
    BAY: "2-8",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 266,
    BAY: "2-9",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 298,
    BAY: "2-10",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 330,
    BAY: "2-11",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 362,
    BAY: "2-12",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 394,
    BAY: "2-13",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 426,
    BAY: "2-14",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 361,
    y: 458,
    BAY: "2-15",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 10,
    BAY: "3-1",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 42,
    BAY: "3-2",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 74,
    BAY: "3-3",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 106,
    BAY: "3-4",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 138,
    BAY: "3-5",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 170,
    BAY: "3-6",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 202,
    BAY: "3-7",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 234,
    BAY: "3-8",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 266,
    BAY: "3-9",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 298,
    BAY: "3-10",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 330,
    BAY: "3-11",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 362,
    BAY: "3-12",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 394,
    BAY: "3-13",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 426,
    BAY: "3-14",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 197,
    y: 458,
    BAY: "3-15",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 33,
    y: 10,
    BAY: "4-1",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 33,
    y: 42,
    BAY: "4-2",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 33,
    y: 74,
    BAY: "4-3",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 33,
    y: 106,
    BAY: "4-4",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 33,
    y: 138,
    BAY: "4-5",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 33,
    y: 170,
    BAY: "4-6",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 33,
    y: 202,
    BAY: "4-7",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 33,
    y: 234,
    BAY: "4-8",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 33,
    y: 266,
    BAY: "4-9",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 33,
    y: 298,
    BAY: "4-10",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 33,
    y: 330,
    BAY: "4-11",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 33,
    y: 362,
    BAY: "4-12",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 33,
    y: 394,
    BAY: "4-13",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 33,
    y: 426,
    BAY: "4-14",
    HDD: true,
    occupied: false,
    image: null
  },
  {
    x: 33,
    y: 458,
    BAY: "4-15",
    HDD: true,
    occupied: false,
    image: null
  }
];
const _sfc_main$5 = {
  name: "P5StorinatorXL60",
  setup() {
    const diskInfoObj = ref({});
    const currentDisk = inject("currentDisk");
    const lsdevJson = inject("lsdevJson");
    const diskInfo = inject("diskInfo");
    const zfsInfo = inject("zfsInfo");
    const enableZfsAnimations = inject("enableZfsAnimations");
    watch(diskInfo, () => {
      diskInfoObj.value = diskInfo;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$2.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$2[index2].occupied = slot.occupied;
        diskLocations$2[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$2[index2].HDD);
      });
    }, { immediate: true, deep: true });
    watch(lsdevJson, () => {
      diskInfoObj.value = lsdevJson;
      assets$2.loadingFlag = false;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$2.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$2[index2].occupied = slot.occupied;
        diskLocations$2[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$2[index2].HDD);
      });
    }, { immediate: false, deep: true });
    function getDiskImage(occupied, modelName, modelFamily, diskType, slotHdd) {
      if (!occupied) {
        return slotHdd ? assets$2.disks.hdd.empty.image : assets$2.disks.ssd.empty.image;
      }
      if (assets$2.loadingFlag && diskType === "SSD" && slotHdd)
        return assets$2.disks.caddy.loading.image;
      if (assets$2.loadingFlag && diskType === "SSD" && !slotHdd)
        return assets$2.disks.ssd.loading.image;
      if (assets$2.loadingFlag && diskType === "HDD")
        return assets$2.disks.hdd.loading.image;
      if (diskType === "SSD" && slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$2.disks.caddy.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$2.disks.caddy.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$2.disks.caddy.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$2.disks.caddy.micron5300.image;
        }
        return assets$2.disks.caddy.default.image;
      }
      if (diskType === "SSD" && !slotHdd) {
        if (/Seagate Nytro/.test(modelFamily)) {
          return assets$2.disks.ssd.seagate.image;
        } else if (/SEAGATE XS400LE10003/.test(modelName)) {
          return assets$2.disks.ssd.seagateSas.image;
        } else if (/Micron_5100_|Micron_5200_/.test(modelName)) {
          return assets$2.disks.ssd.micron5200.image;
        } else if (/Micron_5300_/.test(modelName)) {
          return assets$2.disks.ssd.micron5300.image;
        }
        return assets$2.disks.ssd.default.image;
      }
      if (diskType === "HDD") {
        if (/ST18000|ST16000|ST20000|ST14000|ST12000/.test(modelName)) {
          return assets$2.disks.hdd.seagateSt.image;
        } else if (/Seagate Enterprise/.test(modelFamily)) {
          return assets$2.disks.hdd.seagate.image;
        } else if (/TOSHIBA/.test(modelName)) {
          return assets$2.disks.hdd.toshiba.image;
        } else {
          return assets$2.disks.hdd.default.image;
        }
      }
    }
    const p5Script = function(p5) {
      loadingAnimation(p5);
      zfsAnimation(p5);
      p5.preload = (_) => {
        assets$2.chassis.image = p5.loadImage(assets$2.chassis.path);
        assets$2.fade.image = p5.loadImage(assets$2.fade.path);
        Object.entries(assets$2.disks.caddy).forEach(([dsk, val]) => {
          assets$2.disks.caddy[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$2.disks.ssd).forEach(([dsk, val]) => {
          assets$2.disks.ssd[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$2.disks.hdd).forEach(([dsk, val]) => {
          assets$2.disks.hdd[dsk].image = p5.loadImage(val.path);
        });
        diskInfoObj.value.rows.flat().forEach((slot) => {
          const index2 = diskLocations$2.findIndex((loc) => loc.BAY === slot["bay-id"]);
          if (index2 === -1)
            return;
          diskLocations$2[index2].occupied = slot.occupied;
          diskLocations$2[index2].image = getDiskImage(slot.occupied, slot["model-name"], slot["model-family"], slot["disk_type"], diskLocations$2[index2].HDD);
        });
      };
      p5.setup = (_) => {
        const canvas = p5.createCanvas(assets$2.chassis.image.width + assets$2.fade.image.width, assets$2.chassis.image.height);
        canvas.parent("p5-xl60-storinator");
        p5.image(assets$2.fade.image, 0, 0);
        diskLocations$2.forEach((loc) => {
          loc.x += assets$2.fade.image.width;
        });
        resizeHook(p5, canvas.id(), assets$2.chassis.image.width + assets$2.fade.image.width);
      };
      p5.draw = (_) => {
        if (assets$2.loadingFlag) {
          p5.frameRate(10);
          p5.loadingAnimationIndex = p5.int((p5.loadingAnimationIndex + 1) % p5.loadingAnimationSteps);
        } else {
          p5.frameRate(24);
        }
        p5.image(assets$2.chassis.image, assets$2.fade.image.width, 0);
        diskLocations$2.forEach((loc) => {
          if (loc.occupied && loc.image) {
            p5.image(loc.image, loc.x, loc.y);
            if (assets$2.loadingFlag) {
              p5.animateLoading(loc.x, loc.y, loc.image.width, loc.image.height, p5.animationSteps, p5.animationLoadingIndex);
            }
          }
        });
        if (currentDisk.value) {
          let idx = diskLocations$2.findIndex((loc) => loc.BAY === currentDisk.value);
          if (diskLocations$2[idx].image) {
            if (enableZfsAnimations.flag) {
              p5.showZfs(currentDisk.value, zfsInfo, diskLocations$2);
            }
            p5.fill(255, 255, 255, 50);
            p5.stroke(206, 242, 212);
            p5.strokeWeight(2);
            p5.rect(diskLocations$2[idx].x, diskLocations$2[idx].y, diskLocations$2[idx].image.width, diskLocations$2[idx].image.height);
          }
        }
      };
      p5.mouseClicked = (_) => {
        let mx = p5.mouseX;
        let my = p5.mouseY;
        diskLocations$2.forEach((loc) => {
          if (loc.image && mx > loc.x && mx < loc.x + loc.image.width && my > loc.y && my < loc.y + loc.image.height) {
            currentDisk.value = loc.BAY;
          }
        });
      };
    };
    onMounted(() => {
      new P5(p5Script);
    });
    return {
      diskInfoObj,
      currentDisk,
      lsdevJson,
      diskInfo,
      enableZfsAnimations
    };
  }
};
const _hoisted_1$5 = {
  id: "p5-xl60-storinator",
  class: "self-stretch m-2 flex justify-center"
};
function _sfc_render$5(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1$5);
}
var P5StorinatorXL60 = /* @__PURE__ */ _export_sfc(_sfc_main$5, [["render", _sfc_render$5]]);
const assets$1 = {
  chassis: {
    path: "img/chassis/c8-storinator.png",
    image: null
  },
  disks: {
    caddy: {
      default: {
        path: "img/disks/caddy-c8-mi4.png",
        image: null
      },
      loading: {
        path: "img/disks/caddy-c8-mi4.png",
        image: null
      },
      empty: {
        path: "img/disks/caddy-c8-mi4.png",
        image: null
      }
    },
    ssd: {},
    hdd: {}
  },
  loadingFlag: true
};
const diskLocations$1 = [
  {
    x: 50,
    y: 80,
    BAY: "1-1",
    occupied: false,
    image: null
  },
  {
    x: 312,
    y: 80,
    BAY: "1-2",
    occupied: false,
    image: null
  },
  {
    x: 573,
    y: 80,
    BAY: "1-3",
    occupied: false,
    image: null
  },
  {
    x: 834,
    y: 80,
    BAY: "1-4",
    occupied: false,
    image: null
  },
  {
    x: 50,
    y: 150,
    BAY: "2-1",
    occupied: false,
    image: null
  },
  {
    x: 312,
    y: 150,
    BAY: "2-2",
    occupied: false,
    image: null
  },
  {
    x: 573,
    y: 150,
    BAY: "2-3",
    occupied: false,
    image: null
  },
  {
    x: 834,
    y: 150,
    BAY: "2-4",
    occupied: false,
    image: null
  }
];
const _sfc_main$4 = {
  name: "P5StorinatorC8",
  setup() {
    const diskInfoObj = ref({});
    const currentDisk = inject("currentDisk");
    const lsdevJson = inject("lsdevJson");
    const diskInfo = inject("diskInfo");
    const zfsInfo = inject("zfsInfo");
    const enableZfsAnimations = inject("enableZfsAnimations");
    watch(diskInfo, () => {
      diskInfoObj.value = diskInfo;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$1.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$1[index2].occupied = slot.occupied;
        diskLocations$1[index2].image = getDiskImage(slot.occupied);
      });
    }, { immediate: true, deep: true });
    watch(lsdevJson, () => {
      diskInfoObj.value = lsdevJson;
      assets$1.loadingFlag = false;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations$1.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations$1[index2].occupied = slot.occupied;
        diskLocations$1[index2].image = getDiskImage(slot.occupied);
      });
    }, { immediate: false, deep: true });
    function getDiskImage(occupied) {
      if (!occupied)
        return assets$1.disks.caddy.empty.image;
      if (assets$1.loadingFlag)
        return assets$1.disks.caddy.loading.image;
      return assets$1.disks.caddy.default.image;
    }
    const p5Script = function(p5) {
      loadingAnimation(p5);
      zfsAnimation(p5);
      p5.preload = (_) => {
        assets$1.chassis.image = p5.loadImage(assets$1.chassis.path);
        Object.entries(assets$1.disks.caddy).forEach(([dsk, val]) => {
          assets$1.disks.caddy[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$1.disks.ssd).forEach(([dsk, val]) => {
          assets$1.disks.ssd[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets$1.disks.hdd).forEach(([dsk, val]) => {
          assets$1.disks.hdd[dsk].image = p5.loadImage(val.path);
        });
        diskInfoObj.value.rows.flat().forEach((slot) => {
          const index2 = diskLocations$1.findIndex((loc) => loc.BAY === slot["bay-id"]);
          if (index2 === -1)
            return;
          diskLocations$1[index2].occupied = slot.occupied;
          diskLocations$1[index2].image = getDiskImage(slot.occupied);
        });
      };
      p5.setup = (_) => {
        const canvas = p5.createCanvas(assets$1.chassis.image.width, assets$1.chassis.image.height);
        canvas.parent("p5-c8-storinator");
        resizeHook(p5, canvas.id(), assets$1.chassis.image.width);
      };
      p5.draw = (_) => {
        if (assets$1.loadingFlag) {
          p5.frameRate(10);
          p5.loadingAnimationIndex = p5.int((p5.loadingAnimationIndex + 1) % p5.loadingAnimationSteps);
        } else {
          p5.frameRate(24);
        }
        p5.image(assets$1.chassis.image, 0, 0);
        diskLocations$1.forEach((loc) => {
          if (loc.occupied && loc.image) {
            p5.image(loc.image, loc.x, loc.y);
            if (assets$1.loadingFlag) {
              p5.animateLoading(loc.x, loc.y, loc.image.width, loc.image.height, p5.animationSteps, p5.animationLoadingIndex);
            }
          }
        });
        if (currentDisk.value) {
          let idx = diskLocations$1.findIndex((loc) => loc.BAY === currentDisk.value);
          if (diskLocations$1[idx].image) {
            if (enableZfsAnimations.flag) {
              p5.showZfs(currentDisk.value, zfsInfo, diskLocations$1);
            }
            p5.fill(255, 255, 255, 50);
            p5.stroke(206, 242, 212);
            p5.strokeWeight(2);
            p5.rect(diskLocations$1[idx].x, diskLocations$1[idx].y, diskLocations$1[idx].image.width, diskLocations$1[idx].image.height);
          }
        }
      };
      p5.mouseClicked = (_) => {
        let mx = p5.mouseX;
        let my = p5.mouseY;
        diskLocations$1.forEach((loc) => {
          if (loc.image && mx > loc.x && mx < loc.x + loc.image.width && my > loc.y && my < loc.y + loc.image.height) {
            currentDisk.value = loc.BAY;
          }
        });
      };
    };
    onMounted(() => {
      new P5(p5Script);
    });
    return {
      diskInfoObj,
      currentDisk,
      lsdevJson,
      diskInfo,
      enableZfsAnimations
    };
  }
};
const _hoisted_1$4 = {
  id: "p5-c8-storinator",
  class: "self-stretch m-2 flex justify-center"
};
function _sfc_render$4(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1$4);
}
var P5StorinatorC8 = /* @__PURE__ */ _export_sfc(_sfc_main$4, [["render", _sfc_render$4]]);
const assets = {
  chassis: {
    path: "img/chassis/mi4-storinator.png",
    image: null
  },
  disks: {
    caddy: {
      default: {
        path: "img/disks/caddy-c8-mi4.png",
        image: null
      },
      loading: {
        path: "img/disks/caddy-c8-mi4.png",
        image: null
      },
      empty: {
        path: "img/disks/caddy-c8-mi4.png",
        image: null
      }
    },
    ssd: {},
    hdd: {}
  },
  loadingFlag: true
};
const diskLocations = [
  {
    x: 50,
    y: 56,
    BAY: "1-1",
    occupied: false,
    image: null
  },
  {
    x: 312,
    y: 56,
    BAY: "1-2",
    occupied: false,
    image: null
  },
  {
    x: 573,
    y: 56,
    BAY: "1-3",
    occupied: false,
    image: null
  },
  {
    x: 834,
    y: 56,
    BAY: "1-4",
    occupied: false,
    image: null
  }
];
const _sfc_main$3 = {
  name: "P5StorinatorMI4",
  setup() {
    const diskInfoObj = ref({});
    const currentDisk = inject("currentDisk");
    const lsdevJson = inject("lsdevJson");
    const diskInfo = inject("diskInfo");
    const zfsInfo = inject("zfsInfo");
    const enableZfsAnimations = inject("enableZfsAnimations");
    watch(lsdevJson, () => {
      Object.assign(diskInfoObj.value, diskInfo);
      assets.loadingFlag = false;
      diskInfoObj.value.rows.flat().forEach((slot) => {
        const index2 = diskLocations.findIndex((loc) => loc.BAY === slot["bay-id"]);
        if (index2 == -1)
          return;
        diskLocations[index2].occupied = slot.occupied;
        diskLocations[index2].image = getDiskImage(slot.occupied);
      });
    }, { immediate: false, deep: true });
    watch(diskInfo, () => {
      if (assets.loadingFlag) {
        Object.assign(diskInfoObj.value, diskInfo);
        diskInfoObj.value.rows.flat().forEach((slot) => {
          const index2 = diskLocations.findIndex((loc) => loc.BAY === slot["bay-id"]);
          diskLocations[index2].occupied = slot.occupied;
          diskLocations[index2].image = getDiskImage(slot.occupied);
        });
      }
    }, { immediate: true, deep: true });
    function getDiskImage(occupied) {
      if (!occupied)
        return assets.disks.caddy.empty.image;
      if (assets.loadingFlag)
        return assets.disks.caddy.loading.image;
      return assets.disks.caddy.default.image;
    }
    const p5Script = function(p5) {
      loadingAnimation(p5);
      zfsAnimation(p5);
      p5.preload = (_) => {
        assets.chassis.image = p5.loadImage(assets.chassis.path);
        Object.entries(assets.disks.caddy).forEach(([dsk, val]) => {
          assets.disks.caddy[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets.disks.ssd).forEach(([dsk, val]) => {
          assets.disks.ssd[dsk].image = p5.loadImage(val.path);
        });
        Object.entries(assets.disks.hdd).forEach(([dsk, val]) => {
          assets.disks.hdd[dsk].image = p5.loadImage(val.path);
        });
        diskInfoObj.value.rows.flat().forEach((slot) => {
          const index2 = diskLocations.findIndex((loc) => loc.BAY === slot["bay-id"]);
          if (index2 === -1)
            return;
          diskLocations[index2].occupied = slot.occupied;
          diskLocations[index2].image = getDiskImage(slot.occupied);
        });
      };
      p5.setup = (_) => {
        const canvas = p5.createCanvas(assets.chassis.image.width, assets.chassis.image.height);
        canvas.parent("p5-mi4-storinator");
        resizeHook(p5, canvas.id(), assets.chassis.image.width);
      };
      p5.draw = (_) => {
        if (assets.loadingFlag) {
          p5.frameRate(10);
          p5.loadingAnimationIndex = p5.int((p5.loadingAnimationIndex + 1) % p5.loadingAnimationSteps);
        } else {
          p5.frameRate(24);
        }
        p5.image(assets.chassis.image, 0, 0);
        diskLocations.forEach((loc) => {
          if (loc.occupied && loc.image) {
            p5.image(loc.image, loc.x, loc.y);
            if (assets.loadingFlag) {
              p5.animateLoading(loc.x, loc.y, loc.image.width, loc.image.height, p5.animationSteps, p5.animationLoadingIndex);
            }
          }
        });
        if (currentDisk.value) {
          let idx = diskLocations.findIndex((loc) => loc.BAY === currentDisk.value);
          if (diskLocations[idx].image) {
            if (enableZfsAnimations.flag) {
              p5.showZfs(currentDisk.value, zfsInfo, diskLocations);
            }
            p5.fill(255, 255, 255, 50);
            p5.stroke(206, 242, 212);
            p5.strokeWeight(2);
            p5.rect(diskLocations[idx].x, diskLocations[idx].y, diskLocations[idx].image.width, diskLocations[idx].image.height);
          }
        }
      };
      p5.mouseClicked = (_) => {
        let mx = p5.mouseX;
        let my = p5.mouseY;
        diskLocations.forEach((loc) => {
          if (loc.image && mx > loc.x && mx < loc.x + loc.image.width && my > loc.y && my < loc.y + loc.image.height) {
            currentDisk.value = loc.BAY;
          }
        });
      };
    };
    onMounted(() => {
      new P5(p5Script);
    });
    return {
      diskInfoObj,
      currentDisk,
      lsdevJson,
      diskInfo,
      enableZfsAnimations
    };
  }
};
const _hoisted_1$3 = {
  id: "p5-mi4-storinator",
  class: "self-stretch m-2 flex justify-center"
};
function _sfc_render$3(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1$3);
}
var P5StorinatorMI4 = /* @__PURE__ */ _export_sfc(_sfc_main$3, [["render", _sfc_render$3]]);
function u$2(r2, n2, ...a2) {
  if (r2 in n2) {
    let e2 = n2[r2];
    return typeof e2 == "function" ? e2(...a2) : e2;
  }
  let t2 = new Error(`Tried to handle "${r2}" but there is no handler defined. Only defined handlers are: ${Object.keys(n2).map((e2) => `"${e2}"`).join(", ")}.`);
  throw Error.captureStackTrace && Error.captureStackTrace(t2, u$2), t2;
}
var m = ((t2) => (t2[t2.None = 0] = "None", t2[t2.RenderStrategy = 1] = "RenderStrategy", t2[t2.Static = 2] = "Static", t2))(m || {}), h$1 = ((e2) => (e2[e2.Unmount = 0] = "Unmount", e2[e2.Hidden = 1] = "Hidden", e2))(h$1 || {});
function k(_a) {
  var _b = _a, { visible: n2 = true, features: r2 = 0 } = _b, e2 = __objRest(_b, ["visible", "features"]);
  var t2;
  if (n2 || r2 & 2 && e2.props.static)
    return a$1(e2);
  if (r2 & 1) {
    let i = (t2 = e2.props.unmount) == null || t2 ? 0 : 1;
    return u$2(i, { [0]() {
      return null;
    }, [1]() {
      return a$1(__spreadProps(__spreadValues({}, e2), { props: __spreadProps(__spreadValues({}, e2.props), { hidden: true, style: { display: "none" } }) }));
    } });
  }
  return a$1(e2);
}
function a$1({ props: n2, attrs: r2, slots: e2, slot: t2, name: i }) {
  var u2;
  let _a = R(n2, ["unmount", "static"]), { as: p2 } = _a, s = __objRest(_a, ["as"]), o2 = (u2 = e2.default) == null ? void 0 : u2.call(e2, t2);
  if (p2 === "template") {
    if (Object.keys(s).length > 0 || Object.keys(r2).length > 0) {
      let [d, ...c] = o2 != null ? o2 : [];
      if (!b$2(d) || c.length > 0)
        throw new Error(['Passing props on "template"!', "", `The current component <${i} /> is rendering a "template".`, "However we need to passthrough the following props:", Object.keys(s).concat(Object.keys(r2)).map((l2) => `  - ${l2}`).join(`
`), "", "You can apply a few solutions:", ['Add an `as="..."` prop, to ensure that we render an actual element instead of a "template".', "Render a single element as the child so that we can forward the props onto that element."].map((l2) => `  - ${l2}`).join(`
`)].join(`
`));
      return cloneVNode(d, s);
    }
    return Array.isArray(o2) && o2.length === 1 ? o2[0] : o2;
  }
  return h$2(p2, s, o2);
}
function O(n2) {
  let r2 = Object.assign({}, n2);
  for (let e2 in r2)
    r2[e2] === void 0 && delete r2[e2];
  return r2;
}
function R(n2, r2 = []) {
  let e2 = Object.assign({}, n2);
  for (let t2 of r2)
    t2 in e2 && delete e2[t2];
  return e2;
}
function b$2(n2) {
  return n2 == null ? false : typeof n2.type == "string" || typeof n2.type == "object" || typeof n2.type == "function";
}
let e = 0;
function n() {
  return ++e;
}
function t$1() {
  return n();
}
var o = ((r2) => (r2.Space = " ", r2.Enter = "Enter", r2.Escape = "Escape", r2.Backspace = "Backspace", r2.Delete = "Delete", r2.ArrowLeft = "ArrowLeft", r2.ArrowUp = "ArrowUp", r2.ArrowRight = "ArrowRight", r2.ArrowDown = "ArrowDown", r2.Home = "Home", r2.End = "End", r2.PageUp = "PageUp", r2.PageDown = "PageDown", r2.Tab = "Tab", r2))(o || {});
function t(l2) {
  return l2 == null || l2.value == null ? null : "$el" in l2.value ? l2.value.$el : l2.value;
}
function r(t2, e2) {
  if (t2)
    return t2;
  let n2 = e2 != null ? e2 : "button";
  if (typeof n2 == "string" && n2.toLowerCase() === "button")
    return "button";
}
function b$1(t$12, e2) {
  let n2 = ref(r(t$12.value.type, t$12.value.as));
  return onMounted(() => {
    n2.value = r(t$12.value.type, t$12.value.as);
  }), watchEffect(() => {
    var o2;
    n2.value || !t(e2) || t(e2) instanceof HTMLButtonElement && !((o2 = t(e2)) != null && o2.hasAttribute("type")) && (n2.value = "button");
  }), n2;
}
let l = defineComponent({ name: "VisuallyHidden", props: { as: { type: [Object, String], default: "div" } }, setup(e2, { slots: r2, attrs: i }) {
  return () => k({ props: __spreadValues(__spreadValues({}, e2), { style: { position: "absolute", width: 1, height: 1, padding: 0, margin: -1, overflow: "hidden", clip: "rect(0, 0, 0, 0)", whiteSpace: "nowrap", borderWidth: "0", display: "none" } }), slot: {}, attrs: i, slots: r2, name: "VisuallyHidden" });
} });
function p(n2) {
  var t2;
  let r2 = (t2 = n2 == null ? void 0 : n2.form) != null ? t2 : n2.closest("form");
  if (!!r2) {
    for (let i of r2.elements)
      if (i.tagName === "INPUT" && i.type === "submit" || i.tagName === "BUTTON" && i.type === "submit" || i.nodeName === "INPUT" && i.type === "image") {
        i.click();
        return;
      }
  }
}
let u$1 = Symbol("DescriptionContext");
function h() {
  let n2 = inject(u$1, null);
  if (n2 === null)
    throw new Error("Missing parent");
  return n2;
}
function P({ slot: n2 = ref({}), name: o2 = "Description", props: s = {} } = {}) {
  let e2 = ref([]);
  function t2(r2) {
    return e2.value.push(r2), () => {
      let i = e2.value.indexOf(r2);
      i !== -1 && e2.value.splice(i, 1);
    };
  }
  return provide(u$1, { register: t2, slot: n2, name: o2, props: s }), computed(() => e2.value.length > 0 ? e2.value.join(" ") : void 0);
}
let S = defineComponent({ name: "Description", props: { as: { type: [Object, String], default: "p" } }, setup(n2, { attrs: o2, slots: s }) {
  let e2 = h(), t2 = `headlessui-description-${t$1()}`;
  return onMounted(() => onUnmounted(e2.register(t2))), () => {
    let { name: r2 = "Description", slot: i = ref({}), props: c = {} } = e2, l2 = n2, d = __spreadProps(__spreadValues({}, Object.entries(c).reduce((f, [a2, g]) => Object.assign(f, { [a2]: unref(g) }), {})), { id: t2 });
    return k({ props: __spreadValues(__spreadValues({}, l2), d), slot: i.value, attrs: o2, slots: s, name: r2 });
  };
} });
let u = Symbol("LabelContext");
function a() {
  let t2 = inject(u, null);
  if (t2 === null) {
    let n2 = new Error("You used a <Label /> component, but it is not inside a parent.");
    throw Error.captureStackTrace && Error.captureStackTrace(n2, a), n2;
  }
  return t2;
}
function K({ slot: t2 = {}, name: n2 = "Label", props: i = {} } = {}) {
  let e2 = ref([]);
  function r2(o2) {
    return e2.value.push(o2), () => {
      let l2 = e2.value.indexOf(o2);
      l2 !== -1 && e2.value.splice(l2, 1);
    };
  }
  return provide(u, { register: r2, slot: t2, name: n2, props: i }), computed(() => e2.value.length > 0 ? e2.value.join(" ") : void 0);
}
let T = defineComponent({ name: "Label", props: { as: { type: [Object, String], default: "label" }, passive: { type: [Boolean], default: false } }, setup(t2, { slots: n2, attrs: i }) {
  let e2 = a(), r2 = `headlessui-label-${t$1()}`;
  return onMounted(() => onUnmounted(e2.register(r2))), () => {
    let { name: o2 = "Label", slot: l2 = {}, props: p2 = {} } = e2, _a = t2, { passive: d } = _a, c = __objRest(_a, ["passive"]), f = __spreadProps(__spreadValues({}, Object.entries(p2).reduce((m2, [b2, g]) => Object.assign(m2, { [b2]: unref(g) }), {})), { id: r2 }), s = __spreadValues(__spreadValues({}, c), f);
    return d && delete s.onClick, k({ props: s, slot: l2, attrs: i, slots: n2, name: o2 });
  };
} });
let b = Symbol("GroupContext"), W = defineComponent({ name: "SwitchGroup", props: { as: { type: [Object, String], default: "template" } }, setup(l2, { slots: a2, attrs: i }) {
  let n2 = ref(null), u2 = K({ name: "SwitchLabel", props: { onClick() {
    !n2.value || (n2.value.click(), n2.value.focus({ preventScroll: true }));
  } } }), t2 = P({ name: "SwitchDescription" });
  return provide(b, { switchRef: n2, labelledby: u2, describedby: t2 }), () => k({ props: l2, slot: {}, slots: a2, attrs: i, name: "SwitchGroup" });
} }), X = defineComponent({ name: "Switch", emits: { "update:modelValue": (l2) => true }, props: { as: { type: [Object, String], default: "button" }, modelValue: { type: Boolean, default: false }, name: { type: String, optional: true }, value: { type: String, optional: true } }, inheritAttrs: false, setup(l$1, { emit: a2, attrs: i, slots: n2, expose: u2 }) {
  let t2 = inject(b, null), p$12 = `headlessui-switch-${t$1()}`;
  function c() {
    a2("update:modelValue", !l$1.modelValue);
  }
  let h2 = ref(null), o$1 = t2 === null ? h2 : t2.switchRef, S2 = b$1(computed(() => ({ as: l$1.as, type: i.type })), o$1);
  u2({ el: o$1, $el: o$1 });
  function w(e2) {
    e2.preventDefault(), c();
  }
  function v(e2) {
    e2.key === o.Space ? (e2.preventDefault(), c()) : e2.key === o.Enter && p(e2.currentTarget);
  }
  function g(e2) {
    e2.preventDefault();
  }
  return () => {
    let _a = l$1, { name: e2, value: R2, modelValue: r2 } = _a, k$1 = __objRest(_a, ["name", "value", "modelValue"]), D = { checked: r2 }, K2 = { id: p$12, ref: o$1, role: "switch", type: S2.value, tabIndex: 0, "aria-checked": r2, "aria-labelledby": t2 == null ? void 0 : t2.labelledby.value, "aria-describedby": t2 == null ? void 0 : t2.describedby.value, onClick: w, onKeyup: v, onKeypress: g };
    return h$2(Fragment, [e2 != null && r2 != null ? h$2(l, O({ as: "input", type: "checkbox", hidden: true, readOnly: true, checked: r2, name: e2, value: R2 })) : null, k({ props: __spreadValues(__spreadValues(__spreadValues({}, i), k$1), K2), slot: D, attrs: i, slots: n2, name: "Switch" })]);
  };
} }), Y = T;
S;
const _sfc_main$2 = {
  components: {
    P5StornadoF2,
    P5F8X1,
    P5F8X2,
    P5F8X3,
    P5Stornado2U,
    P5StorinatorQ30,
    P5Stornado,
    P5StorinatorXL60H16,
    P5StorinatorS45,
    P5StorinatorS45H16,
    P5StorinatorQ30H16,
    P5StorinatorAV15,
    P5HomeLabHL15,
    P5StorinatorQ30H32,
    P5StorinatorS45H32,
    P5StorinatorXL60H32,
    P5StorinatorXL60,
    P5StorinatorC8,
    P5StorinatorMI4,
    Switch: X,
    SwitchGroup: W,
    SwitchLabel: Y
  },
  props: {
    serverInfo: Object
  },
  setup(props) {
    const serverModel = ref(props.serverInfo.Model);
    const enableZfsAnimations = inject("enableZfsAnimations");
    const zfsInfo = inject("zfsInfo");
    const enableSketch = (modelString) => {
      let testString = /(Storinator|Stornado|HomeLab)-(H8)?(H16|H32)?-?(HL15|AV15|Q30|S45|XL60|F2|2U|MI4|C8|F8X1|F8X2|F8X3)/m.exec(modelString);
      let enableString = testString ? testString[1] + testString[4] + (testString[3] ? testString[3] : "") : "";
      return enableString;
    };
    const canvasCardBody = ref();
    const activeSketchStr = enableSketch(serverModel.value);
    watch(enableZfsAnimations, () => {
    });
    return {
      serverModel,
      canvasCardBody,
      activeSketchStr,
      zfsInfo,
      enableZfsAnimations
    };
  }
};
const _hoisted_1$2 = {
  id: "canvas-card",
  class: "card inline-flex flex-col flex-auto"
};
const _hoisted_2$2 = { class: "card-header flex flex-row items-center" };
const _hoisted_3$2 = /* @__PURE__ */ createBaseVNode("h3", { class: "text-header text-default" }, "Disk Viewer", -1);
const _hoisted_4$2 = /* @__PURE__ */ createBaseVNode("div", { class: "grow" }, null, -1);
const _hoisted_5$2 = /* @__PURE__ */ createBaseVNode("span", { class: "text-sm font-medium text-default" }, "Show ZFS Animations", -1);
const _hoisted_6$2 = {
  key: 0,
  ref: "canvasCardBody",
  class: "card-body flex-auto flex flex-col items-center content-center p-0 overflow-visible"
};
const _hoisted_7$2 = {
  key: 1,
  class: "grow flex justify-center items-center"
};
const _hoisted_8$2 = { class: "p-5 bg-accent rounded-lg text-muted" };
function _sfc_render$2(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_Switch = resolveComponent("Switch");
  const _component_SwitchLabel = resolveComponent("SwitchLabel");
  const _component_SwitchGroup = resolveComponent("SwitchGroup");
  const _component_P5StornadoF2 = resolveComponent("P5StornadoF2");
  const _component_P5F8X1 = resolveComponent("P5F8X1");
  const _component_P5F8X2 = resolveComponent("P5F8X2");
  const _component_P5F8X3 = resolveComponent("P5F8X3");
  const _component_P5Stornado2U = resolveComponent("P5Stornado2U");
  const _component_P5StorinatorQ30 = resolveComponent("P5StorinatorQ30");
  const _component_P5Stornado = resolveComponent("P5Stornado");
  const _component_P5StorinatorXL60H16 = resolveComponent("P5StorinatorXL60H16");
  const _component_P5StorinatorS45 = resolveComponent("P5StorinatorS45");
  const _component_P5StorinatorS45H16 = resolveComponent("P5StorinatorS45H16");
  const _component_P5StorinatorQ30H16 = resolveComponent("P5StorinatorQ30H16");
  const _component_P5StorinatorAV15 = resolveComponent("P5StorinatorAV15");
  const _component_P5HomeLabHL15 = resolveComponent("P5HomeLabHL15");
  const _component_P5StorinatorQ30H32 = resolveComponent("P5StorinatorQ30H32");
  const _component_P5StorinatorS45H32 = resolveComponent("P5StorinatorS45H32");
  const _component_P5StorinatorXL60H32 = resolveComponent("P5StorinatorXL60H32");
  const _component_P5StorinatorXL60 = resolveComponent("P5StorinatorXL60");
  const _component_P5StorinatorC8 = resolveComponent("P5StorinatorC8");
  const _component_P5StorinatorMI4 = resolveComponent("P5StorinatorMI4");
  return openBlock(), createElementBlock("div", _hoisted_1$2, [
    createBaseVNode("div", _hoisted_2$2, [
      _hoisted_3$2,
      _hoisted_4$2,
      $setup.zfsInfo.zfs_installed ? (openBlock(), createBlock(_component_SwitchGroup, {
        key: 0,
        as: "div",
        class: "flex items-center"
      }, {
        default: withCtx(() => [
          createVNode(_component_Switch, {
            modelValue: $setup.enableZfsAnimations.flag,
            "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => $setup.enableZfsAnimations.flag = $event),
            class: normalizeClass([
              $setup.enableZfsAnimations.flag ? "!bg-red-700 dark:!bg-red-800" : "!bg-neutral-200 dark:!bg-neutral-900",
              "relative inline-flex flex-shrink-0 h-6 w-11 border-2 border-transparent rounded-full cursor-pointer transition-colors ease-in-out duration-200 focus:outline-none"
            ])
          }, {
            default: withCtx(() => [
              createBaseVNode("span", {
                "aria-hidden": "true",
                class: normalizeClass([
                  $setup.enableZfsAnimations.flag ? "translate-x-5" : "translate-x-0",
                  "pointer-events-none inline-block h-5 w-5 rounded-full shadow bg-default transform ring-0 transition ease-in-out duration-200"
                ])
              }, null, 2)
            ]),
            _: 1
          }, 8, ["modelValue", "class"]),
          createVNode(_component_SwitchLabel, {
            as: "span",
            class: "ml-3"
          }, {
            default: withCtx(() => [
              _hoisted_5$2
            ]),
            _: 1
          })
        ]),
        _: 1
      })) : createCommentVNode("", true)
    ]),
    $setup.activeSketchStr ? (openBlock(), createElementBlock("div", _hoisted_6$2, [
      $setup.activeSketchStr === "StornadoF2" ? (openBlock(), createBlock(_component_P5StornadoF2, { key: 0 })) : createCommentVNode("", true),
      $setup.activeSketchStr === "StorinatorF8X1" ? (openBlock(), createBlock(_component_P5F8X1, { key: 1 })) : createCommentVNode("", true),
      $setup.activeSketchStr === "StorinatorF8X2" ? (openBlock(), createBlock(_component_P5F8X2, { key: 2 })) : createCommentVNode("", true),
      $setup.activeSketchStr === "StorinatorF8X3" ? (openBlock(), createBlock(_component_P5F8X3, { key: 3 })) : createCommentVNode("", true),
      $setup.activeSketchStr === "Stornado2U" ? (openBlock(), createBlock(_component_P5Stornado2U, { key: 4 })) : $setup.activeSketchStr === "StorinatorQ30" ? (openBlock(), createBlock(_component_P5StorinatorQ30, { key: 5 })) : $setup.activeSketchStr === "StornadoAV15" ? (openBlock(), createBlock(_component_P5Stornado, { key: 6 })) : $setup.activeSketchStr === "StorinatorXL60H16" ? (openBlock(), createBlock(_component_P5StorinatorXL60H16, { key: 7 })) : $setup.activeSketchStr === "StorinatorS45" ? (openBlock(), createBlock(_component_P5StorinatorS45, { key: 8 })) : $setup.activeSketchStr === "StorinatorS45H16" ? (openBlock(), createBlock(_component_P5StorinatorS45H16, { key: 9 })) : $setup.activeSketchStr === "StorinatorQ30H16" ? (openBlock(), createBlock(_component_P5StorinatorQ30H16, { key: 10 })) : $setup.activeSketchStr === "StorinatorAV15" ? (openBlock(), createBlock(_component_P5StorinatorAV15, { key: 11 })) : $setup.activeSketchStr === "HomeLabHL15" ? (openBlock(), createBlock(_component_P5HomeLabHL15, { key: 12 })) : $setup.activeSketchStr === "StorinatorQ30H32" ? (openBlock(), createBlock(_component_P5StorinatorQ30H32, { key: 13 })) : $setup.activeSketchStr === "StorinatorS45H32" ? (openBlock(), createBlock(_component_P5StorinatorS45H32, { key: 14 })) : $setup.activeSketchStr === "StorinatorXL60H32" ? (openBlock(), createBlock(_component_P5StorinatorXL60H32, { key: 15 })) : $setup.activeSketchStr === "StorinatorXL60" ? (openBlock(), createBlock(_component_P5StorinatorXL60, { key: 16 })) : $setup.activeSketchStr === "StorinatorC8" ? (openBlock(), createBlock(_component_P5StorinatorC8, { key: 17 })) : $setup.activeSketchStr === "StorinatorMI4" ? (openBlock(), createBlock(_component_P5StorinatorMI4, { key: 18 })) : createCommentVNode("", true)
    ], 512)) : (openBlock(), createElementBlock("div", _hoisted_7$2, [
      createBaseVNode("div", _hoisted_8$2, " Unknown/Unsupported server model encountered '" + toDisplayString($setup.serverModel) + "' ", 1)
    ]))
  ]);
}
var CanvasSection = /* @__PURE__ */ _export_sfc(_sfc_main$2, [["render", _sfc_render$2]]);
const _sfc_main$1 = {
  setup() {
    const currentDisk = inject("currentDisk");
    const zfsInfo = inject("zfsInfo");
    const updateZfs = () => {
    };
    watch(currentDisk, updateZfs);
    return {
      zfsInfo,
      currentDisk
    };
  }
};
const _hoisted_1$1 = {
  id: "zfsCard",
  class: "card grow flex flex-col"
};
const _hoisted_2$1 = /* @__PURE__ */ createBaseVNode("div", { class: "card-header" }, [
  /* @__PURE__ */ createBaseVNode("h3", { class: "text-header text-default" }, "ZFS Information")
], -1);
const _hoisted_3$1 = {
  key: 0,
  class: "card-body overflow-y-auto grow-0 flex flex-wrap gap-12"
};
const _hoisted_4$1 = { class: "grow-0 2xl:grow grid grid-cols-3 items-stretch gap-y-3 gap-x-5" };
const _hoisted_5$1 = /* @__PURE__ */ createBaseVNode("div", { class: "text-label text-default col-span-3 border-b-[1px] shrink-0 border-neutral-200 dark:border-neutral-700" }, " Zpools ", -1);
const _hoisted_6$1 = { class: "grid grid-cols-1" };
const _hoisted_7$1 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, "zpool name", -1);
const _hoisted_8$1 = { class: "text-sm" };
const _hoisted_9$1 = { class: "grid grid-cols-1" };
const _hoisted_10$1 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, "health", -1);
const _hoisted_11$1 = { class: "grid grid-cols-1" };
const _hoisted_12$1 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, "state", -1);
const _hoisted_13$1 = { class: "grid grid-cols-1" };
const _hoisted_14$1 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, "mountpoint", -1);
const _hoisted_15 = { class: "text-sm" };
const _hoisted_16 = { class: "grid grid-cols-1" };
const _hoisted_17 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, "available", -1);
const _hoisted_18 = { class: "text-sm" };
const _hoisted_19 = { class: "grid grid-cols-1" };
const _hoisted_20 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, "used", -1);
const _hoisted_21 = { class: "text-sm" };
const _hoisted_22 = { class: "grid grid-cols-1" };
const _hoisted_23 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, "size (raw)", -1);
const _hoisted_24 = { class: "text-sm" };
const _hoisted_25 = { class: "grid grid-cols-1" };
const _hoisted_26 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, "alloc (raw)", -1);
const _hoisted_27 = { class: "text-sm" };
const _hoisted_28 = { class: "grid grid-cols-1" };
const _hoisted_29 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, "free (raw)", -1);
const _hoisted_30 = { class: "text-sm" };
const _hoisted_31 = { class: "grow-0 2xl:grow grid grid-cols-3 items-stretch gap-y-3 gap-x-5" };
const _hoisted_32 = /* @__PURE__ */ createBaseVNode("div", { class: "text-label text-default col-span-3 border-b-[1px] shrink-0 border-neutral-200 dark:border-neutral-700" }, " Vdevs ", -1);
const _hoisted_33 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, "vdev name", -1);
const _hoisted_34 = { class: "text-sm" };
const _hoisted_35 = { key: 0 };
const _hoisted_36 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, "state", -1);
const _hoisted_37 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, "alloc (raw)", -1);
const _hoisted_38 = { class: "text-sm" };
const _hoisted_39 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, "free (raw)", -1);
const _hoisted_40 = { class: "text-sm" };
const _hoisted_41 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, "read errors", -1);
const _hoisted_42 = { class: "text-sm" };
const _hoisted_43 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, "write errors", -1);
const _hoisted_44 = { class: "text-sm" };
const _hoisted_45 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, "checksum errors", -1);
const _hoisted_46 = { class: "text-sm" };
const _hoisted_47 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, "vdev type", -1);
const _hoisted_48 = { class: "text-sm" };
const _hoisted_49 = { key: 0 };
const _hoisted_50 = { key: 1 };
const _hoisted_51 = { class: "grow-0 2xl:grow grid grid-cols-3 items-stretch gap-y-3 gap-x-5 h-fit" };
const _hoisted_52 = /* @__PURE__ */ createBaseVNode("div", { class: "text-label text-default col-span-3 border-b-[1px] self-start border-neutral-200 dark:border-neutral-700" }, " Devices ", -1);
const _hoisted_53 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, "device name", -1);
const _hoisted_54 = { class: "text-sm" };
const _hoisted_55 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, "state", -1);
const _hoisted_56 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, "read errors", -1);
const _hoisted_57 = { class: "text-sm" };
const _hoisted_58 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, "write errors", -1);
const _hoisted_59 = { class: "text-sm" };
const _hoisted_60 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, "checksum errors", -1);
const _hoisted_61 = { class: "text-sm" };
const _hoisted_62 = /* @__PURE__ */ createBaseVNode("div", { class: "text-sm text-muted" }, "device type", -1);
const _hoisted_63 = { class: "text-sm" };
const _hoisted_64 = { key: 0 };
const _hoisted_65 = { key: 1 };
const _hoisted_66 = {
  key: 1,
  class: "card-body grow flex justify-center items-center"
};
const _hoisted_67 = { class: "p-5 bg-accent rounded-lg" };
const _hoisted_68 = { class: "text-muted" };
const _hoisted_69 = {
  key: 2,
  class: "card-body grow flex justify-center items-center"
};
const _hoisted_70 = /* @__PURE__ */ createBaseVNode("div", { class: "p-5 bg-accent rounded-lg" }, [
  /* @__PURE__ */ createBaseVNode("span", { class: "text-muted" }, "Click on a disk for more detail.")
], -1);
const _hoisted_71 = [
  _hoisted_70
];
function _sfc_render$1(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1$1, [
    _hoisted_2$1,
    $setup.currentDisk != "" && $setup.zfsInfo.zfs_disks.hasOwnProperty($setup.currentDisk) ? (openBlock(), createElementBlock("div", _hoisted_3$1, [
      createBaseVNode("div", _hoisted_4$1, [
        _hoisted_5$1,
        createBaseVNode("div", _hoisted_6$1, [
          _hoisted_7$1,
          createBaseVNode("div", _hoisted_8$1, toDisplayString($setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_name), 1)
        ]),
        createBaseVNode("div", _hoisted_9$1, [
          _hoisted_10$1,
          createBaseVNode("div", {
            class: normalizeClass([
              $setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].health === "ONLINE" ? "text-success" : "",
              $setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].health === "OFFLINE" ? "text-warning" : "",
              $setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].health === "DEGRADED" ? "text-warning" : "",
              $setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].health === "SUSPENDED" ? "text-danger" : "",
              "text-sm"
            ])
          }, toDisplayString($setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].health), 3)
        ]),
        createBaseVNode("div", _hoisted_11$1, [
          _hoisted_12$1,
          createBaseVNode("div", {
            class: normalizeClass([
              $setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].state === "ONLINE" ? "text-success" : "",
              $setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].state === "OFFLINE" ? "text-warning" : "",
              $setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].state === "DEGRADED" ? "text-warning" : "",
              $setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].state === "SUSPENDED" ? "text-danger" : "",
              "text-sm"
            ])
          }, toDisplayString($setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].state), 3)
        ]),
        createBaseVNode("div", _hoisted_13$1, [
          _hoisted_14$1,
          createBaseVNode("div", _hoisted_15, toDisplayString($setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].mountpoint), 1)
        ]),
        createBaseVNode("div", _hoisted_16, [
          _hoisted_17,
          createBaseVNode("div", _hoisted_18, toDisplayString($setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].avail), 1)
        ]),
        createBaseVNode("div", _hoisted_19, [
          _hoisted_20,
          createBaseVNode("div", _hoisted_21, toDisplayString($setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].used), 1)
        ]),
        createBaseVNode("div", _hoisted_22, [
          _hoisted_23,
          createBaseVNode("div", _hoisted_24, toDisplayString($setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].raw_size), 1)
        ]),
        createBaseVNode("div", _hoisted_25, [
          _hoisted_26,
          createBaseVNode("div", _hoisted_27, toDisplayString($setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].raw_alloc), 1)
        ]),
        createBaseVNode("div", _hoisted_28, [
          _hoisted_29,
          createBaseVNode("div", _hoisted_30, toDisplayString($setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].raw_alloc), 1)
        ])
      ]),
      createBaseVNode("div", _hoisted_31, [
        _hoisted_32,
        createBaseVNode("div", null, [
          _hoisted_33,
          createBaseVNode("div", _hoisted_34, [
            createTextVNode(toDisplayString($setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].vdevs[$setup.zfsInfo.zfs_disks[$setup.currentDisk].vdev_idx].name) + " ", 1),
            $setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].vdevs[$setup.zfsInfo.zfs_disks[$setup.currentDisk].vdev_idx].tag != $setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_name ? (openBlock(), createElementBlock("span", _hoisted_35, " (" + toDisplayString($setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].vdevs[$setup.zfsInfo.zfs_disks[$setup.currentDisk].vdev_idx].tag) + ")", 1)) : createCommentVNode("", true)
          ])
        ]),
        createBaseVNode("div", null, [
          _hoisted_36,
          createBaseVNode("div", {
            class: normalizeClass([
              $setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].vdevs[$setup.zfsInfo.zfs_disks[$setup.currentDisk].vdev_idx].state === "ONLINE" ? "text-success" : "",
              $setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].vdevs[$setup.zfsInfo.zfs_disks[$setup.currentDisk].vdev_idx].state === "OFFLINE" ? "text-warning" : "",
              $setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].vdevs[$setup.zfsInfo.zfs_disks[$setup.currentDisk].vdev_idx].state === "DEGRADED" ? "text-warning" : "",
              $setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].vdevs[$setup.zfsInfo.zfs_disks[$setup.currentDisk].vdev_idx].state === "UNAVAIL" ? "text-danger" : "",
              $setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].vdevs[$setup.zfsInfo.zfs_disks[$setup.currentDisk].vdev_idx].state === "FAULTED" ? "text-danger" : "",
              "text-sm"
            ])
          }, toDisplayString($setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].vdevs[$setup.zfsInfo.zfs_disks[$setup.currentDisk].vdev_idx].state), 3)
        ]),
        createBaseVNode("div", null, [
          _hoisted_37,
          createBaseVNode("div", _hoisted_38, toDisplayString($setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].vdevs[$setup.zfsInfo.zfs_disks[$setup.currentDisk].vdev_idx].alloc), 1)
        ]),
        createBaseVNode("div", null, [
          _hoisted_39,
          createBaseVNode("div", _hoisted_40, toDisplayString($setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].vdevs[$setup.zfsInfo.zfs_disks[$setup.currentDisk].vdev_idx].free), 1)
        ]),
        createBaseVNode("div", null, [
          _hoisted_41,
          createBaseVNode("div", _hoisted_42, toDisplayString($setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].vdevs[$setup.zfsInfo.zfs_disks[$setup.currentDisk].vdev_idx].read_errors), 1)
        ]),
        createBaseVNode("div", null, [
          _hoisted_43,
          createBaseVNode("div", _hoisted_44, toDisplayString($setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].vdevs[$setup.zfsInfo.zfs_disks[$setup.currentDisk].vdev_idx].write_errors), 1)
        ]),
        createBaseVNode("div", null, [
          _hoisted_45,
          createBaseVNode("div", _hoisted_46, toDisplayString($setup.zfsInfo.zpools[$setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_idx].vdevs[$setup.zfsInfo.zfs_disks[$setup.currentDisk].vdev_idx].checksum_errors), 1)
        ]),
        createBaseVNode("div", null, [
          _hoisted_47,
          createBaseVNode("div", _hoisted_48, [
            $setup.zfsInfo.zfs_disks[$setup.currentDisk].tag != $setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_name ? (openBlock(), createElementBlock("span", _hoisted_49, toDisplayString($setup.zfsInfo.zfs_disks[$setup.currentDisk].tag), 1)) : (openBlock(), createElementBlock("span", _hoisted_50, "storage"))
          ])
        ])
      ]),
      createBaseVNode("div", _hoisted_51, [
        _hoisted_52,
        createBaseVNode("div", null, [
          _hoisted_53,
          createBaseVNode("div", _hoisted_54, toDisplayString($setup.zfsInfo.zfs_disks[$setup.currentDisk].name), 1)
        ]),
        createBaseVNode("div", null, [
          _hoisted_55,
          createBaseVNode("div", {
            class: normalizeClass([
              $setup.zfsInfo.zfs_disks[$setup.currentDisk].state === "ONLINE" ? "text-success" : "",
              $setup.zfsInfo.zfs_disks[$setup.currentDisk].state === "OFFLINE" ? "text-warning" : "",
              $setup.zfsInfo.zfs_disks[$setup.currentDisk].state === "REMOVED" ? "text-danger" : "",
              $setup.zfsInfo.zfs_disks[$setup.currentDisk].state === "UNAVAIL" ? "text-danger" : "",
              "text-sm"
            ])
          }, toDisplayString($setup.zfsInfo.zfs_disks[$setup.currentDisk].state), 3)
        ]),
        createBaseVNode("div", null, [
          _hoisted_56,
          createBaseVNode("div", _hoisted_57, toDisplayString($setup.zfsInfo.zfs_disks[$setup.currentDisk].read_errors), 1)
        ]),
        createBaseVNode("div", null, [
          _hoisted_58,
          createBaseVNode("div", _hoisted_59, toDisplayString($setup.zfsInfo.zfs_disks[$setup.currentDisk].write_errors), 1)
        ]),
        createBaseVNode("div", null, [
          _hoisted_60,
          createBaseVNode("div", _hoisted_61, toDisplayString($setup.zfsInfo.zfs_disks[$setup.currentDisk].checksum_errors), 1)
        ]),
        createBaseVNode("div", null, [
          _hoisted_62,
          createBaseVNode("div", _hoisted_63, [
            $setup.zfsInfo.zfs_disks[$setup.currentDisk].tag != $setup.zfsInfo.zfs_disks[$setup.currentDisk].zpool_name ? (openBlock(), createElementBlock("span", _hoisted_64, toDisplayString($setup.zfsInfo.zfs_disks[$setup.currentDisk].tag), 1)) : (openBlock(), createElementBlock("span", _hoisted_65, "storage"))
          ])
        ])
      ])
    ])) : $setup.currentDisk != "" ? (openBlock(), createElementBlock("div", _hoisted_66, [
      createBaseVNode("div", _hoisted_67, [
        createBaseVNode("span", _hoisted_68, "Disk '" + toDisplayString($setup.currentDisk) + "' is not a member of a zpool. ", 1)
      ])
    ])) : (openBlock(), createElementBlock("div", _hoisted_69, _hoisted_71))
  ]);
}
var ZfsSection = /* @__PURE__ */ _export_sfc(_sfc_main$1, [["render", _sfc_render$1]]);
var App_vue_vue_type_style_index_0_lang = "";
const _sfc_main = {
  name: "App",
  components: {
    FfdHeader,
    DebugBox,
    ServerSection,
    DiskSection,
    CanvasSection,
    ErrorMessage,
    ZfsSection,
    Notifications
  },
  props: { notificationFIFO: FIFO },
  setup(props) {
    const currentDisk = ref("");
    provide("currentDisk", currentDisk);
    const lsdevState = ref("");
    provide("lsdevState", lsdevState);
    const lsdevJson = reactive({ lsdevDuration: 5 });
    provide("lsdevJson", lsdevJson);
    const diskInfo = reactive({ lsdevDuration: 5 });
    provide("diskInfo", diskInfo);
    const zfsInfo = reactive({});
    provide("zfsInfo", zfsInfo);
    const enableZfsAnimations = reactive({ flag: true });
    provide("enableZfsAnimations", enableZfsAnimations);
    const pageLayout = ref("AZ");
    provide("pageLayout", pageLayout);
    const notifications = ref();
    provide("Notifications", notifications);
    const delay = (s) => new Promise((res) => setTimeout(res, s * 1e3));
    let watchInitiated = false;
    const adminFlag = ref(false);
    const adminCheck = ref(false);
    const preloadChecks = reactive({
      serverInfo: {
        content: reactive({}),
        finished: false,
        failed: false
      },
      lsdev: {
        content: reactive({}),
        finished: false,
        failed: false
      },
      diskInfo: {
        content: reactive({}),
        finished: false,
        failed: false
      },
      zfs: {
        content: reactive({}),
        finished: false,
        failed: false
      },
      pageStatus: {
        ready: false
      }
    });
    const runDmap = async () => {
      preloadChecks.serverInfo.finished = false;
      preloadChecks.diskInfo.finished = false;
      try {
        const state = await useSpawn(["/opt/45drives/tools/dmap"], {
          err: "out",
          superuser: "require"
        }).promise();
        init();
      } catch (error) {
        preloadChecks.serverInfo.finished = true;
        preloadChecks.diskInfo.finished = true;
        notifications.value.constructNotification("Error running dmap", errorStringHTML(error.stdout), "error", 0);
        return false;
      }
    };
    const runServerIdentifier = async () => {
      try {
        const state = await useSpawn(["/opt/45drives/tools/server_identifier"], {
          err: "out",
          superuser: "require"
        }).promise();
        return await runServerInfo();
      } catch (error) {
        console.log(error);
        notifications.value.constructNotification("Error running server_identifier", errorStringHTML(error.stdout), "error", 0);
        return false;
      }
    };
    const setPageLayout = () => {
      if (preloadChecks.zfs.finished && preloadChecks.zfs.failed) {
        if (!preloadChecks.serverInfo.failed) {
          switch (preloadChecks.serverInfo.content["Chassis Size"]) {
            case "F8X1":
              pageLayout.value = "B";
              break;
            case "F8X2":
              pageLayout.value = "B";
              break;
            case "F8X3":
              pageLayout.value = "B";
              break;
            case "2U":
              pageLayout.value = "A";
              break;
            case "F2":
              pageLayout.value = "A";
              break;
            case "AV15":
              pageLayout.value = "B";
              break;
            case "HL15":
              pageLayout.value = "B";
              break;
            case "C8":
              pageLayout.value = "A";
              break;
            case "MI4":
              pageLayout.value = "A";
              break;
            case "Q30":
              pageLayout.value = "B";
              break;
            case "S45":
              pageLayout.value = "B";
              break;
            case "XL60":
              pageLayout.value = "C";
              break;
            default:
              console.log("UNKNOWN CHASSIS SIZE");
          }
        }
        preloadChecks.pageStatus.ready = true;
      } else {
        if (preloadChecks.zfs.finished && !preloadChecks.serverInfo.failed) {
          switch (preloadChecks.serverInfo.content["Chassis Size"]) {
            case "F8X1":
              pageLayout.value = "BZ";
              break;
            case "F8X2":
              pageLayout.value = "BZ";
              break;
            case "F8X3":
              pageLayout.value = "BZ";
              break;
            case "2U":
              pageLayout.value = "AZ";
              break;
            case "F2":
              pageLayout.value = "AZ";
              break;
            case "AV15":
              pageLayout.value = "BZ";
              break;
            case "HL15":
              pageLayout.value = "BZ";
              break;
            case "C8":
              pageLayout.value = "AZ";
              break;
            case "MI4":
              pageLayout.value = "AZ";
              break;
            case "Q30":
              pageLayout.value = "BZ";
              break;
            case "S45":
              pageLayout.value = "BZ";
              break;
            case "XL60":
              pageLayout.value = "CZ";
              break;
            default:
              console.log("UNKNOWN CHASSIS SIZE");
          }
        }
        preloadChecks.pageStatus.ready = true;
      }
    };
    let serverInfoFailNotification = null;
    const runServerInfo = async () => {
      preloadChecks.serverInfo.finished = false;
      try {
        const state = await useSpawn(["/usr/share/cockpit/45drives-disks/scripts/server_info"], {
          err: "out",
          superuser: "require"
        }).promise();
        let result = JSON.parse(state.stdout);
        preloadChecks.serverInfo.content = result;
        preloadChecks.serverInfo.finished = true;
        preloadChecks.serverInfo.failed = false;
      } catch (error) {
        console.log(error);
        preloadChecks.serverInfo.content = null;
        preloadChecks.serverInfo.finished = true;
        preloadChecks.serverInfo.failed = true;
        if (error.stdout && error.stdout.includes("/etc/45drives/server_info/server_info.json not found.")) {
          serverInfoFailNotification = notifications.value.constructNotification("Error obtaining server model information", errorStringHTML(error.stdout), "error", 3e4).addAction("fix", () => runServerIdentifier());
        }
      }
    };
    const runLsdev = async () => {
      try {
        const state = await useSpawn(["/opt/45drives/tools/lsdev", "--json"], {
          err: "out",
          superuser: "require"
        }).promise();
        let result = JSON.parse(state.stdout);
        if (!lsdevJson["rows"] || result.rows.flat().filter((slot) => slot.occupied).length != lsdevJson.rows.flat().filter((slot) => slot.occupied).length) {
          Object.assign(lsdevJson, result);
          preloadChecks.lsdev.content = lsdevJson;
          preloadChecks.lsdev.finished = true;
          preloadChecks.lsdev.failed = false;
          return true;
        } else {
          return false;
        }
      } catch (error) {
        console.log(error);
        preloadChecks.lsdev.content = null;
        preloadChecks.lsdev.finished = true;
        preloadChecks.lsdev.failed = true;
        notifications.value.constructNotification("Error obtaining disk information", errorStringHTML(error.stdout), "error", 0);
        return false;
      }
    };
    const runDiskInfo = async () => {
      preloadChecks.lsdev.finished = false;
      preloadChecks.diskInfo.finished = false;
      try {
        const state = await useSpawn(["/usr/share/cockpit/45drives-disks/scripts/disk_info"], {
          err: "out",
          superuser: "require"
        }).promise();
        let result = JSON.parse(state.stdout);
        Object.assign(diskInfo, result);
        preloadChecks.lsdev.content = result;
        preloadChecks.lsdev.finished = true;
        preloadChecks.lsdev.failed = false;
        preloadChecks.diskInfo.content = result;
        preloadChecks.diskInfo.finished = true;
        preloadChecks.diskInfo.failed = false;
        return true;
      } catch (error) {
        console.log(error);
        preloadChecks.diskInfo.content = null;
        preloadChecks.diskInfo.failed = true;
        preloadChecks.diskInfo.finished = true;
        if (error.stdout && error.stdout.includes("Error opening /etc/vdev_id.conf. Run `dmap`.")) {
          notifications.value.constructNotification("Error obtaining disk information", errorStringHTML(error.stdout), "error", 0).addAction("fix", () => {
            if (serverInfoFailNotification)
              serverInfoFailNotification.show = false;
            runDmap();
          });
        } else {
          notifications.value.constructNotification("Error obtaining disk information", errorStringHTML(error.stdout), "error");
          return false;
        }
      }
    };
    const runZfsInfo = async () => {
      try {
        const state = await useSpawn(["/usr/share/cockpit/45drives-disks/scripts/zfs_info"], {
          err: "out",
          superuser: "require"
        }).promise();
        let result = JSON.parse(state.stdout);
        Object.assign(zfsInfo, result);
        if (result.warnings && result.warnings.length > 0) {
          notifications.value.constructNotification("Warning:", errorStringHTML(result.warnings.join("")), "warning", 0);
        }
        preloadChecks.zfs.content = result;
        preloadChecks.zfs.finished = true;
        preloadChecks.zfs.failed = !(result == null ? void 0 : result.zfs_installed);
      } catch (error) {
        console.log(error);
        preloadChecks.zfs.content = null;
        preloadChecks.zfs.finished = true;
        preloadChecks.zfs.failed = true;
        notifications.value.constructNotification("Unable to gather zfs information", errorStringHTML(error.stdout), "warning", 0);
        return false;
      }
    };
    const init = async () => {
      await runServerInfo();
      await runDiskInfo();
      await runZfsInfo();
      if (!preloadChecks.diskInfo.failed && !preloadChecks.serverInfo.failed && preloadChecks.zfs.finished) {
        setPageLayout();
        runLsdev();
      }
    };
    const retryLsdev = async (duration) => {
      await delay(duration);
      while (await runLsdev()) {
        await delay(duration);
      }
      await runZfsInfo();
    };
    const rootCheck = async () => {
      let root_check = cockpit.permission({ admin: true });
      root_check.addEventListener("changed", () => {
        if (root_check.allowed) {
          adminCheck.value = true;
          adminFlag.value = true;
          init();
        } else {
          adminCheck.value = true;
          adminFlag.value = false;
        }
      });
    };
    const setupWatches = () => {
      cockpit.file("/usr/share/cockpit/45drives-disks/udev/state").watch(async (content) => {
        var _a, _b;
        if (watchInitiated) {
          lsdevState.value = content;
          if (await runLsdev()) {
            retryLsdev(((_b = (_a = lsdevJson.lsdevDuration) == null ? void 0 : _a.toFixed(2)) != null ? _b : 5) * 2);
          }
        } else {
          watchInitiated = true;
        }
      });
    };
    onMounted(() => {
      setupWatches();
      rootCheck();
    });
    return {
      adminCheck,
      adminFlag,
      preloadChecks,
      runServerInfo,
      runLsdev,
      lsdevJson,
      retryLsdev,
      diskInfo,
      zfsInfo,
      enableZfsAnimations,
      pageLayout,
      notifications
    };
  }
};
const _hoisted_1 = {
  id: "App",
  class: "flex flex-col h-full"
};
const _hoisted_2 = {
  key: 0,
  class: "grow flex flex-col well overflow-y-auto p-4"
};
const _hoisted_3 = { class: "gap-well grid grid-cols-6" };
const _hoisted_4 = { class: "flex flex-col gap-well grow flex-wrap" };
const _hoisted_5 = { class: "flex grow flex-col items-stretch gap-well col-span-6" };
const _hoisted_6 = {
  key: 1,
  class: "flex-auto flex flex-col items-center justify-evenly well"
};
const _hoisted_7 = { key: 0 };
const _hoisted_8 = {
  key: 1,
  class: "well flex flex-col items-center h-full"
};
const _hoisted_9 = /* @__PURE__ */ createStaticVNode('<div class="card"><div class="card-header"><h3 class="text-header text-default"> 45Drives Disks - Unable to proceed </h3></div><div class="card-body flex flex-col gap-4"><h3>This module is designed to work with 45Drives servers which feature dedicated storage bays.</h3><div>Consult any notifications for potential fixes.</div><div> If you are still experiencing issues, contact 45Drives Support or let us know by submitting an issue on our github. </div><div class="bg-accent rounded-md p-5 flex flex-col items-center gap-4"><a href="https://github.com/45Drives/cockpit-hardware/issues" class="text-blue-500" target="_blank"> Submit a github issue </a></div></div></div>', 1);
const _hoisted_10 = [
  _hoisted_9
];
const _hoisted_11 = {
  key: 2,
  class: "grow flex flex-col well overflow-y-auto p-4 justify-center items-center"
};
const _hoisted_12 = /* @__PURE__ */ createStaticVNode('<div class="card"><div class="card-header"><h3 class="text-header text-default"> Administrative Access Required </h3></div><div class="card-body flex flex-col gap-4"><div class="bg-accent rounded-md p-5 flex flex-col items-center gap-4"> 45Drives Disks requires administrative access to proceed. </div></div></div>', 1);
const _hoisted_13 = [
  _hoisted_12
];
const _hoisted_14 = {
  key: 3,
  class: "grow flex flex-col well overflow-y-auto p-4 justify-center items-center"
};
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_Notifications = resolveComponent("Notifications");
  const _component_FfdHeader = resolveComponent("FfdHeader");
  const _component_CanvasSection = resolveComponent("CanvasSection");
  const _component_DiskSection = resolveComponent("DiskSection");
  const _component_ZfsSection = resolveComponent("ZfsSection");
  const _component_ServerSection = resolveComponent("ServerSection");
  return openBlock(), createElementBlock(Fragment, null, [
    createVNode(_component_Notifications, {
      notificationFIFO: $props.notificationFIFO,
      ref: "notifications"
    }, null, 8, ["notificationFIFO"]),
    createBaseVNode("div", _hoisted_1, [
      createVNode(_component_FfdHeader, {
        moduleName: "Disks",
        centerName: ""
      }),
      $setup.adminCheck && $setup.adminFlag && $setup.preloadChecks.serverInfo.finished && $setup.preloadChecks.diskInfo.finished && !$setup.preloadChecks.serverInfo.failed && !$setup.preloadChecks.diskInfo.failed && $setup.preloadChecks.zfs.finished && $setup.preloadChecks.pageStatus.ready ? (openBlock(), createElementBlock("div", _hoisted_2, [
        createBaseVNode("div", _hoisted_3, [
          createBaseVNode("div", {
            class: normalizeClass([
              $setup.pageLayout === "AZ" ? "lg:col-span-6" : "",
              $setup.pageLayout === "BZ" ? "xl:col-span-3 2xl:col-span-2" : "",
              $setup.pageLayout === "CZ" ? "xl:col-span-4 2xl:col-span-3" : "",
              $setup.pageLayout === "A" ? "lg:col-span-6" : "",
              $setup.pageLayout === "B" ? "xl:col-span-3 2xl:col-span-2" : "",
              $setup.pageLayout === "C" ? "xl:col-span-4 2xl:col-span-3" : "",
              "grow grid gap-well col-span-6"
            ])
          }, [
            createBaseVNode("div", _hoisted_4, [
              $setup.preloadChecks.serverInfo.finished && $setup.preloadChecks.diskInfo.finished && !$setup.preloadChecks.serverInfo.failed && !$setup.preloadChecks.diskInfo.failed && $setup.preloadChecks.zfs.finished && $setup.preloadChecks.pageStatus.ready ? (openBlock(), createBlock(_component_CanvasSection, {
                key: 0,
                serverInfo: $setup.preloadChecks.serverInfo.content
              }, null, 8, ["serverInfo"])) : createCommentVNode("", true)
            ])
          ], 2),
          $setup.preloadChecks.serverInfo.finished && $setup.preloadChecks.diskInfo.finished && !$setup.preloadChecks.serverInfo.failed && !$setup.preloadChecks.diskInfo.failed && $setup.preloadChecks.zfs.finished && $setup.preloadChecks.pageStatus.ready ? (openBlock(), createElementBlock("div", {
            key: 0,
            class: normalizeClass([
              $setup.pageLayout === "AZ" ? "lg:col-span-3" : "",
              $setup.pageLayout === "BZ" ? "xl:col-span-3 2xl:col-span-4" : "",
              $setup.pageLayout === "CZ" ? "xl:col-span-2 2xl:col-span-3" : "",
              $setup.pageLayout === "A" ? "lg:col-span-6" : "",
              $setup.pageLayout === "B" ? "xl:col-span-3 2xl:col-span-4" : "",
              $setup.pageLayout === "C" ? "xl:col-span-2 2xl:col-span-3" : "",
              "grow grid gap-well col-span-6"
            ])
          }, [
            $setup.preloadChecks.serverInfo.finished && $setup.preloadChecks.diskInfo.finished && !$setup.preloadChecks.serverInfo.failed && !$setup.preloadChecks.diskInfo.failed && $setup.preloadChecks.pageStatus.ready ? (openBlock(), createBlock(_component_DiskSection, { key: 0 })) : createCommentVNode("", true)
          ], 2)) : createCommentVNode("", true),
          $setup.preloadChecks.zfs.finished && !$setup.preloadChecks.zfs.failed && !$setup.preloadChecks.serverInfo.failed && !$setup.preloadChecks.diskInfo.failed && $setup.preloadChecks.pageStatus.ready ? (openBlock(), createElementBlock("div", {
            key: 1,
            class: normalizeClass([
              $setup.pageLayout === "AZ" ? "lg:col-span-3" : "",
              $setup.pageLayout === "BZ" ? "lg:col-span-6" : "",
              $setup.pageLayout === "CZ" ? "lg:col-span-6" : "",
              "grow grid gap-well col-span-6"
            ])
          }, [
            $setup.preloadChecks.zfs.finished && !$setup.preloadChecks.zfs.failed ? (openBlock(), createBlock(_component_ZfsSection, { key: 0 })) : createCommentVNode("", true)
          ], 2)) : createCommentVNode("", true),
          createBaseVNode("div", _hoisted_5, [
            $setup.preloadChecks.serverInfo.finished && $setup.preloadChecks.lsdev.finished ? (openBlock(), createBlock(_component_ServerSection, {
              key: 0,
              serverInfo: $setup.preloadChecks.serverInfo.content
            }, null, 8, ["serverInfo"])) : createCommentVNode("", true)
          ])
        ])
      ])) : $setup.adminCheck && $setup.adminFlag ? (openBlock(), createElementBlock("div", _hoisted_6, [
        !$setup.preloadChecks.serverInfo.finished || !$setup.preloadChecks.diskInfo.finished || !$setup.preloadChecks.zfs.finished ? (openBlock(), createElementBlock("div", _hoisted_7, " Gathering disk information. Please wait... ")) : createCommentVNode("", true),
        $setup.preloadChecks.serverInfo.finished && $setup.preloadChecks.serverInfo.failed || $setup.preloadChecks.diskInfo.finished && $setup.preloadChecks.diskInfo.failed ? (openBlock(), createElementBlock("div", _hoisted_8, _hoisted_10)) : createCommentVNode("", true)
      ])) : $setup.adminCheck && !$setup.adminFlag ? (openBlock(), createElementBlock("div", _hoisted_11, _hoisted_13)) : (openBlock(), createElementBlock("div", _hoisted_14, " Loading ... "))
    ])
  ], 64);
}
var App = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
var index = "";
const notificationFIFO = reactive(new FIFO());
const errorHandler = (error) => {
  console.error(error);
  const notificationObj = {
    title: "System Error",
    body: "",
    show: true,
    timeout: 1e4,
    actions: [],
    level: "error"
  };
  if (error instanceof Error && (error == null ? void 0 : error.message)) {
    notificationObj.body = error.message;
  } else if (typeof error === "string") {
    notificationObj.body = error;
  } else if (error == null ? void 0 : error.stderr) {
    notificationObj.body = error.stderr;
  } else {
    notificationObj.body = "An error occured, check the system console (CTRL+SHIFT+J) for more information.";
  }
  if (notificationFIFO.getLen() < 10)
    notificationFIFO.push(notificationObj);
  else
    throw error;
};
const app = createApp(App, { notificationFIFO });
app.config.errorHandler = (error) => errorHandler(error);
window.onerror = (...args) => {
  var _a;
  return errorHandler((_a = args[4]) != null ? _a : args[0]);
};
app.mount("#app");
